# PHPGraphLib Graphing Library

PHPGraphLib is a lightweight PHP-based graphing library that creates slick PHP
graphs for incorporation into a website or application.

PHPGraphLib has powerful customization features, allowing you to generate the
perfect bar, line, stacked bar, or pie graph for any application. Used with
dynamic data, PHPGraphLib allows easy visual interpretation of sophisticated
data sets. Simply feed PHPGraphLib an array of data points, and it will generate
a .png chart of your data dynamically for browser display or saved to your
filesystem.

## History

The first version PHPGraphLib was written in 2007 by Elliott Brueggeman to
deliver PHP generated graphs quickly and easily to PHP4 applications. It has
grown in both features and maturity since its inception. PHPGraphLib now
requires PHP5+. Originally available only for paid commercial use, PHPGraphLib
was open-sourced in 2013 under the MIT License. Please visit
[http://www.ebrueggeman.com/phpgraphlib](http://www.ebrueggeman.com/phpgraphlib)
for more information.

## Documentation

Documentation is available at
[http://www.ebrueggeman.com/phpgraphlib](http://www.ebrueggeman.com/phpgraphlib)

[href="http://www.ebrueggeman.com/phpgraphlib](http://www.ebrueggeman.com/phpgraphlib).
I'll begin porting over documentation soon where it makes sense.

## Examples

Within the [Examples](/examples) directory are examples of PHPGraphLib usage.
Git clone this repo to a directory on your localhost or server to see these
examples in action.

![PHPGraphLib Graph
Example](http://www.ebrueggeman.com/sites/www.ebrueggeman.com/files/images/phpgraphlib_example_graph.png)

![Graph
Example](http://www.ebrueggeman.com/sites/www.ebrueggeman.com/files/images/alaska_temp_graph.png)

![Two Dataset
Example](http://www.ebrueggeman.com/sites/www.ebrueggeman.com/files/images/company_production_graph.png)

![Pie Chart
Example](http://www.ebrueggeman.com/sites/www.ebrueggeman.com/files/images/example_graph_6_pie.png)

![Stacked Graph
Example](http://www.ebrueggeman.com/sites/www.ebrueggeman.com/files/images/stacked-graph-example-2.png)
