--
-- Table structure for table `mac_track_approved_macs`
--

CREATE TABLE `mac_track_approved_macs` (
  `mac_prefix` varchar(20) NOT NULL,
  `vendor` varchar(50) NOT NULL,
  `description` varchar(255) NOT NULL,
  PRIMARY KEY  (`mac_prefix`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_device_types`
--

CREATE TABLE `mac_track_device_types` (
  `device_type_id` int(10) unsigned NOT NULL auto_increment,
  `description` varchar(100) NOT NULL default '',
  `vendor` varchar(40) NOT NULL default '',
  `device_type` varchar(10) NOT NULL default '0',
  `sysDescr_match` varchar(20) NOT NULL default '',
  `sysObjectID_match` varchar(40) NOT NULL default '',
  `scanning_function` varchar(100) NOT NULL default '',
  `ip_scanning_function` varchar(100) NOT NULL,
  `serial_number_oid` varchar(100) default '',
  `lowPort` int(10) unsigned NOT NULL default '0',
  `highPort` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`sysDescr_match`,`sysObjectID_match`,`device_type`),
  KEY `device_type` (`device_type`),
  KEY `device_type_id` (`device_type_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_devices`
--

CREATE TABLE `mac_track_devices` (
			`site_id` int(10) unsigned NOT NULL default '0',
			`device_id` int(10) unsigned NOT NULL auto_increment,
			`host_id` INTEGER UNSIGNED NOT NULL default '0',
			`device_name` varchar(100) default '',
			`device_type_id` int(10) unsigned default '0',
			`hostname` varchar(40) NOT NULL default '',
			`notes` text,
			`disabled` char(2) default '',
			`ignorePorts` varchar(255) default NULL,
			`ips_total` int(10) unsigned NOT NULL default '0',
			`vlans_total` int(10) unsigned NOT NULL default '0',
			`ports_total` int(10) unsigned NOT NULL default '0',
			`ports_active` int(10) unsigned NOT NULL default '0',
			`ports_trunk` int(10) unsigned NOT NULL default '0',
			`macs_active` int(10) unsigned NOT NULL default '0',
			`scan_type` tinyint(11) NOT NULL default '1',
			`term_type` tinyint(11) NOT NULL default '1',
			`user_name` varchar(40) default NULL,
			`user_password` varchar(40) default NULL,
			`private_key_path` varchar(128) default '',
			`snmp_options` int(10) unsigned NOT NULL default '0',
			`snmp_readstring` varchar(100) NOT NULL,
			`snmp_readstrings` varchar(255) default NULL,
			`snmp_version` varchar(100) NOT NULL default '',
			`snmp_port` int(10) NOT NULL default '161',
			`snmp_timeout` int(10) unsigned NOT NULL default '500',
			`snmp_retries` tinyint(11) unsigned NOT NULL default '3',
			`snmp_sysName` varchar(100) default '',
			`snmp_sysLocation` varchar(100) default '',
			`snmp_sysContact` varchar(100) default '',
			`snmp_sysObjectID` varchar(100) default NULL,
			`snmp_sysDescr` varchar(100) default NULL,
			`snmp_sysUptime` varchar(100) default NULL,
			`snmp_status` int(10) unsigned NOT NULL default '0',
			`snmp_username` varchar(50) default NULL,
			`snmp_password` varchar(50) default NULL,
			`snmp_auth_protocol` char(5) default '',
			`snmp_priv_passphrase` varchar(200) default '',
			`snmp_priv_protocol` char(6) default '',
			`snmp_context` varchar(64) default '',
			`max_oids` int(12) unsigned default '10',
			`last_runmessage` varchar(100) default '',
			`last_rundate` datetime NOT NULL default '0000-00-00 00:00:00',
			`last_runduration` decimal(10,5) NOT NULL default '0.00000',
			PRIMARY KEY  (`hostname`,`snmp_port`,`site_id`),
			KEY `site_id` (`site_id`),
			KEY `host_id`(`host_id`),
			KEY `device_id` (`device_id`),
			KEY `snmp_sysDescr` (`snmp_sysDescr`),
			KEY `snmp_sysObjectID` (`snmp_sysObjectID`),
			KEY `device_type_id` (`device_type_id`),
			KEY `device_name` (`device_name`))
			ENGINE=MyISAM COMMENT='Devices to be scanned for MAC addresses';

--
-- Table structure for table `mac_track_interfaces`
--

CREATE TABLE `mac_track_interfaces` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `ifIndex` int(10) unsigned NOT NULL default '0',
  `ifName` varchar(128) NOT NULL,
  `ifAlias` varchar(255) NOT NULL,
  `ifDescr` varchar(128) NOT NULL,
  `ifType` int(10) unsigned NOT NULL default '0',
  `ifMtu` int(10) unsigned NOT NULL default '0',
  `ifSpeed` int(10) unsigned NOT NULL default '0',
  `ifPhysAddress` varchar(20) NOT NULL,
  `ifAdminStatus` int(10) unsigned NOT NULL default '0',
  `ifOperStatus` int(10) unsigned NOT NULL default '0',
  `ifLastChange` int(10) unsigned NOT NULL default '0',
  `linkPort` tinyint(3) unsigned NOT NULL default '0',
  `vlan_id` int(10) unsigned NOT NULL,
  `vlan_name` varchar(128) NOT NULL,
  `vlan_trunk` tinyint(3) unsigned NOT NULL,
  `vlan_trunk_status` int(10) unsigned NOT NULL,
  `ifInDiscards` int(10) unsigned NOT NULL default '0',
  `ifInErrors` int(10) unsigned NOT NULL default '0',
  `ifInUnknownProtos` int(10) unsigned NOT NULL default '0',
  `ifOutDiscards` int(10) unsigned default '0',
  `ifOutErrors` int(10) unsigned default '0',
  `last_up_time` timestamp NOT NULL default '0000-00-00 00:00:00',
  `last_down_time` timestamp NOT NULL default '0000-00-00 00:00:00',
  `stateChanges` int(10) unsigned NOT NULL default '0',
  `int_discards_present` tinyint(3) unsigned NOT NULL default '0',
  `int_errors_present` tinyint(3) unsigned NOT NULL default '0',
  `present` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`site_id`,`device_id`,`ifIndex`),
  KEY `ifDescr` (`ifDescr`),
  KEY `ifType` (`ifType`),
  KEY `ifSpeed` (`ifSpeed`),
  KEY `ifMTU` (`ifMtu`),
  KEY `ifAdminStatus` (`ifAdminStatus`),
  KEY `ifOperStatus` (`ifOperStatus`),
  KEY `ifInDiscards` USING BTREE (`ifInUnknownProtos`),
  KEY `ifInErrors` USING BTREE (`ifInUnknownProtos`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_ip_ranges`
--

CREATE TABLE `mac_track_ip_ranges` (
  `ip_range` varchar(20) NOT NULL default '',
  `site_id` int(10) unsigned NOT NULL default '0',
  `ips_max` int(10) unsigned NOT NULL default '0',
  `ips_current` int(10) unsigned NOT NULL default '0',
  `ips_max_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `ips_current_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ip_range`,`site_id`),
  KEY `site_id` (`site_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_ips`
--

CREATE TABLE `mac_track_ips` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `hostname` varchar(40) NOT NULL default '',
  `device_name` varchar(100) NOT NULL default '',
  `port_number` varchar(10) NOT NULL default '',
  `mac_address` varchar(20) NOT NULL default '',
  `ip_address` varchar(20) NOT NULL default '',
  `dns_hostname` varchar(200) default '',
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`scan_date`,`ip_address`,`mac_address`,`site_id`),
  KEY `ip` (`ip_address`),
  KEY `port_number` (`port_number`),
  KEY `mac` (`mac_address`),
  KEY `device_id` (`device_id`),
  KEY `site_id` (`site_id`),
  KEY `hostname` (`hostname`),
  KEY `scan_date` (`scan_date`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_macauth`
--

CREATE TABLE `mac_track_macauth` (
  `mac_address` varchar(20) NOT NULL,
  `mac_id` int(10) unsigned NOT NULL auto_increment,
  `description` varchar(100) NOT NULL,
  `added_date` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `added_by` varchar(20) NOT NULL,
  PRIMARY KEY  (`mac_address`),
  KEY `mac_id` (`mac_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_macwatch`
--

CREATE TABLE `mac_track_macwatch` (
  `mac_address` varchar(20) NOT NULL,
  `mac_id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(45) NOT NULL,
  `description` varchar(255) NOT NULL,
  `ticket_number` varchar(45) NOT NULL,
  `notify_schedule` tinyint(3) unsigned NOT NULL,
  `email_addresses` varchar(255) NOT NULL default '',
  `discovered` tinyint(3) unsigned NOT NULL,
  `date_first_seen` timestamp NOT NULL default '0000-00-00 00:00:00',
  `date_last_seen` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`mac_address`),
  KEY `mac_id` (`mac_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_oui_database`
--

CREATE TABLE `mac_track_oui_database` (
  `vendor_mac` varchar(8) NOT NULL,
  `vendor_name` varchar(100) NOT NULL,
  `vendor_address` text NOT NULL,
  `present` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`vendor_mac`),
  KEY `vendor_name` (`vendor_name`)
) ENGINE=MyISAM;

--
-- Dumping data for table `mac_track_oui_database`
--

LOCK TABLES `mac_track_oui_database` WRITE;
/*!40000 ALTER TABLE `mac_track_oui_database` DISABLE KEYS */;
INSERT INTO `mac_track_oui_database` VALUES ('00:00:00','Xerox Corporation','Xerox CorporationM/s 105-50c800 Phillips RoadWebster Ny 14580United States',1),('00:00:01','Xerox Corporation','Xerox CorporationZerox Systems InstituteM/s 105-50c 800 Phillips RoadWebster Ny 14580United States',1),('00:00:02','Xerox Corporation','Xerox CorporationXerox Systems InstituteM/s 105-50c 800 Phillips RoadWebster Ny 14580United States',1),('00:00:03','Xerox Corporation','Xerox CorporationZerox Systems InstituteM/s 105-50cew Avenue 800 Phillips RoadWebster Ny 14580United States',1),('00:00:04','Xerox Corporation','Xerox CorporationOffice Systems DivisionM/s 105-50c 800 Phillips Road4Webster Ny 14580United States',1),('00:00:05','Xerox Corporation','Xerox CorporationOffice Systems DivisionM/s 105-50c 800 Phillips RoadWebster Ny 14580United States',1),('00:00:06','Xerox Corporation','Xerox CorporationOffice Systems DivisionM/s 105-50c 800 Phillips Road4Webster Ny 14580United States',1),('00:00:07','Xerox Corporation','Xerox CorporationOffice Systems DivisionM/s 105-50c 800 Phillips RoadWebster Ny 14580United States',1),('00:00:08','Xerox Corporation','Xerox CorporationOffice Systems DivisionM/s/ 105-50c 800 Phillips RoadWebster Ny 14580United States',1),('00:00:09','Xerox Corporation','Xerox Corporation1350 Jefferson RoadRochester Ny 14623United States',1),('00:00:0A','Omron Tateisi Electronics Co.','Omron Tateisi Electronics Co.Section Nff, System R&d Labs.Research & Tech. Assessmnt Div ShimokaiiKyoto 617 JapanJapan',1),('00:00:0B','Matrix Corporation','Matrix Corporation1203 New Hope RoadRaleigh North Carolina  276United States',1),('00:00:0C','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134-1706United States',1),('00:00:0D','Fibronics Ltd.','Fibronics Ltd.Matam Technology CenterHaifa 31905IsraelIsrael',1),('00:00:0E','Fujitsu Limited','Fujitsu LimitedMusashi-kosugi Tower Place Bldg.,Kosugi-cho 1-chome,nakahara-kuKawasaki 211 KanagawaJapan',1),('00:00:0F','Next, Inc.','Next, Inc.3475 Deer Creek RoadPalo Alto Ca 94304United States',1),('00:00:10','Sytek Inc.','Sytek Inc.1225 Charleston RoadMountain View Ca 94043United States',1),('00:00:11','Normerel Systemes','Normerel Systemes58 Rue Pottier78150 Le ChesnayFranceFrance',1),('00:00:12','Information Technology Limited','Information Technology LimitedMaylands Ave. Hemel HempsteadHerts EnglandUnited Kingdom',1),('00:00:13','Camex','Camex75 Kneeland StreetBoston Ma 02111United States',1),('00:00:14','Netronix','Netronix1372 Mcdowell Blvd.Petulama Ca 94952United States',1),('00:00:15','Datapoint Corporation','Datapoint Corporation9725 Datapoint DriveMs S-37San Antonio Tx 78284United States',1),('00:00:16','Du Pont Pixel Systems     .','Du Pont Pixel Systems     .Meadlake PlaceThorpe Lea Road Egham, Surrey Tw20 8heEnglandUnited Kingdom',1),('00:00:17','Tekelec','Tekelec26540 Agoura RoadCalabasas Ca 91302United States',1),('00:00:18','Webster Computer Corporation','Webster Computer Corporation16040 Redwood Lodge RoadLos Gatos Ca 95033-9260United States',1),('00:00:19','Applied Dynamics International','Applied Dynamics International3800 Stone School RoadAnn Arbor Mi 48104-2499United States',1),('00:00:1A','Advanced Micro Devices','Advanced Micro DevicesP.o. Box 3453M/s 26Sunnyvale Ca 94088United States',1),('00:00:1B','Novell Inc.','Novell Inc.122 East 1700 SouthM/s: E-12-1Provo Ut 84606United States',1),('00:00:1C','Bell Technologies','Bell Technologies330 Warren AvenueFremont Ca 94539United States',1),('00:00:1D','Cabletron Systems, Inc.','Cabletron Systems, Inc.35 Industrial WayP.o. Box 5005Rochester Nh 03867United States',1),('00:00:1E','Telsist Industria Electronica','Telsist Industria ElectronicaRua Vilhena De Moraes, 380Barra Da Tijuca Rio De Janeiro, Rj Cep 2BrazilBrazil',1),('00:00:1F','Telco Systems, Inc.','Telco Systems, Inc.63 Nathan StreetNorwood Ma 02072United States',1),('00:00:20','Dataindustrier Diab Ab','Dataindustrier Diab AbBox 2029S-183 02 TabySwedenSweden',1),('00:00:21','Sureman Comp. & Commun. Corp.','Sureman Comp. & Commun. Corp.10f-5 No. 7,  Sec. 3Hsin Sheng N. Rd.,Taipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:00:22','Visual Technology Inc.','Visual Technology Inc.1703 Middlesex StreetLowell Ma 01851United States',1),('00:00:23','Abb Industrial Systems Ab','Abb Industrial Systems AbDept. Seisy/lksbS-721 67 VasterasSwedenSweden',1),('00:00:24','Connect As','Connect AsHoerkaer 7-9Dk 2730 HerlevDenmarkDenmark',1),('00:00:25','Ramtek Corp.','Ramtek Corp.810 W. Maude AvenueSunnyvale Ca 94086United States',1),('00:00:26','Sha-ken Co., Ltd.','Sha-ken Co., Ltd.Minami-otsuka2-26-13, Toshima-kuTokyo JapanJapan',1),('00:00:27','Japan Radio Company','Japan Radio CompanyLaboratory5-1-1 Shimorenjaku Mitaka-shi, TokyoJapanJapan',1),('00:00:28','Prodigy Systems Corporation','Prodigy Systems Corporation2601 Casey DriveMountain View Ca 94043United States',1),('00:00:29','Imc Networks Corp.','Imc Networks Corp.16931 Milliken Ave.Irvine Ca 92714-5013United States',1),('00:00:2A','Trw - Sedd/inp','Trw - Sedd/inp1800 Glenn Curtiss StreetM/s Dh6/2826Carson Ca 90746United States',1),('00:00:2B','Crisp Automation, Inc','Crisp Automation, Inc5160 Blazer ParkwayDublin Oh 43017United States',1),('00:00:2C','Autotote Limited','Autotote Limited100 Bellevue RoadNewark Delaware 19714United States',1),('00:00:2D','Chromatics Inc','Chromatics Inc2558 Mountain Industrial BlvdTucker Ga 30084United States',1),('00:00:2E','Societe Evira','Societe EviraZone Portuaire De Bregaillon83500 La Seyne Sur MerFranceFrance',1),('00:00:2F','Timeplex Inc.','Timeplex Inc.530 Chestnut Ridge RoadWoodcliff Lake Nj 07675United States',1),('00:00:30','Vg Laboratory Systems Ltd','Vg Laboratory Systems LtdTribune AvenueAltrincham, Manchester, Wa14 5tpEnglandUnited Kingdom',1),('00:00:31','Qpsx Communications Pty Ltd','Qpsx Communications Pty Ltd33 Richardson StreetWest Perth 6005Western AustraliaAustralia',1),('00:00:32','Marconi Plc','Marconi Plc28 Elstree Way, BorehamwoodHertfordshire Wd6 1rxUnited KingdomUnited Kingdom',1),('00:00:33','Egan Machinery Company','Egan Machinery CompanySouth Adamsville RoadSommerville Nj 08876United States',1),('00:00:34','Network Resources Corporation','Network Resources Corporation61 East Daggett DriveSan Jose Ca 95134United States',1),('00:00:35','Spectragraphics Corporation','Spectragraphics CorporationOrLan Manufacturing Engineer 9707 Waples SSan Diego Ca 92121United States',1),('00:00:36','Atari Corporation','Atari Corporation1196 Borregas AvenueSunnyvale Ca 94086United States',1),('00:00:37','Oxford Metrics Limited','Oxford Metrics LimitedUnit 8, 7 West Way,Botley,oxford, Ox2 OjbUnited KingdomUnited Kingdom',1),('00:00:38','Css Labs','Css Labs2134 South RipcheySanta Ana Ca 92705United States',1),('00:00:39','Toshiba Corporation','Toshiba CorporationComputer Division1-1-1 Shibaura, Minato-kuTokyo 105 JapanJapan',1),('00:00:3A','Chyron Corporation','Chyron Corporation265 Spagnoli RoadMelville Ny 11747United States',1),('00:00:3B','I Controls, Inc.','I Controls, Inc.12f Doonsan Building, 105-7Nonhyun-dong, Gangnam-gu SeoulKorea 135-714Korea, Republic Of',1),('00:00:3C','Auspex Systems Inc.','Auspex Systems Inc.5200 Great America PkwySanta Clara Ca 95054United States',1),('00:00:3D','Unisys','UnisysMs8-010P.o. Box 6685San Jose Ca 95150-6685United States',1),('00:00:3E','Simpact','Simpact9210 Sky Park CourtSan Diego Ca 92123United States',1),('00:00:3F','Syntrex, Inc.','Syntrex, Inc.246 Industrial Way WestEatontown Nj 07724United States',1),('00:00:40','Applicon, Inc.','Applicon, Inc.4251 Plymouth Rd 48015Po Box 986Ann Arbor Mi 48106-0986United States',1),('00:00:41','Ice Corporation','Ice Corporation17945 Skypark CircleSuite EIrvine Ca 92714United States',1),('00:00:42','Metier Management Systems Ltd.','Metier Management Systems Ltd.3 Foundation StreetIpswich  Suffolk  Ip4 1bgEnglandUnited Kingdom',1),('00:00:43','Micro Technology','Micro Technology4905 East LapalmaAnaheim Ca 92807United States',1),('00:00:44','Castelle Corporation','Castelle Corporation3255-3 Scott BoulevardSanta Clara Ca 95054United States',1),('00:00:45','Ford Aerospace & Comm. Corp.','Ford Aerospace & Comm. Corp.Colorado Springs Operation10440 State Highway 83Colorado Springs Co 80908United States',1),('00:00:46','Olivetti North America','Olivetti North AmericaE 22425 ApplewayLiberty Lake Wa 99019United States',1),('00:00:47','Nicolet Instruments Corp.','Nicolet Instruments Corp.5225 Verona RoadMadison Wi 53711United States',1),('00:00:48','Seiko Epson Corporation','Seiko Epson Corporation80 Hirooka Shiojiri-cityNagano-kenJapan 399-07Japan',1),('00:00:49','Apricot Computers, Ltd','Apricot Computers, Ltd90 Vincent DriveEdgbaston, Birmingham B152spEnglandUnited Kingdom',1),('00:00:4A','Adc Codenoll Technology Corp.','Adc Codenoll Technology Corp.200 Corporate Blvd. So.Yonkers Ny 10701United States',1),('00:00:4B','Icl Data Oy','Icl Data OyKutomotie 16-1800380 Helsinki  P.o. Box 458 Sf-00101 HeFinlandFinland',1),('00:00:4C','Nec Corporation','Nec Corporation7-1 Shiba  5-chomeMinato-kuTokyo 108-01  JapanJapan',1),('00:00:4D','Dci Corporation','Dci Corporation64j Princeton-hightstown Rd#121Princeton Junction Nj 08550United States',1),('00:00:4E','Ampex Corporation','Ampex Corporation581 Conference PlaceGolden Co 80401United States',1),('00:00:4F','Logicraft, Inc.','Logicraft, Inc.22 Cotton RoadNashua Nh 03063United States',1),('00:00:50','Radisys Corporation','Radisys Corporation15025 S.w. Koll ParkwayBeaverton Or 97006-6056United States',1),('00:00:51','Hob Electronic Gmbh & Co. Kg','Hob Electronic Gmbh & Co. KgBrandsstatter-str.2-10D-8502 ZirndorfGermanyGermany',1),('00:00:52','Intrusion.com, Inc.','Intrusion.com, Inc.1101 E. Arapaho RoadRichardson Tx 75081',1),('00:00:53','Compucorp','Compucorp2211 Michigan AvenueSanta Monica Ca 90404United States',1),('00:00:54','Modicon, Inc.','Modicon, Inc.One High StreetNorth Andover Ma 01845-2699United States',1),('00:00:55','Commissariat A L`energie Atom.','Commissariat A L`energie Atom.31, Rue De La FederationParis 75015FranceFrance',1),('00:00:56','Dr. B. Struck','Dr. B. StruckPob 1147 Baeckerbarg 6D-2000 Tangstedt/hamburgW-germanyGermany',1),('00:00:57','Scitex Corporation Ltd.','Scitex Corporation Ltd.P.o. Box 33046103 Herzlia BIsraelIsrael',1),('00:00:58','Racore Computer Products Inc.','Racore Computer Products Inc.2355 South 1070 WestSalt Lake City Ut 84119United States',1),('00:00:59','Hellige Gmbh','Hellige GmbhE-swHeinrich-von-stefan-str.4 D-7800 FreiburWest GermanyGermany',1),('00:00:5A','Syskonnect Gmbh','Syskonnect GmbhSiemensstrasse 2376275 EttlingenGermanyGermany',1),('00:00:5B','Eltec Elektronik Ag','Eltec Elektronik AgGalileo-galilei-strasse 11Pob 42 13 63 D-55071 MainzGermanyGermany',1),('00:00:5C','Telematics International Inc.','Telematics International Inc.1201 Cypress Creek RdFt. Lauderdale Fl 33309United States',1),('00:00:5D','Cs Telecom','Cs Telecom4-16 Avenue Du General LeclercBp 74 - 92263 Fontenay Aux RosesFranceFrance',1),('00:00:5E','Usc Information Sciences Inst','Usc Information Sciences InstInternet Assned Nos.authority4676 Admiralty WayMarina Del Rey Ca 90292-6695United States',1),('00:00:5F','Sumitomo Electric Ind., Ltd.','Sumitomo Electric Ind., Ltd.1-1-3, ShimayaKonohana-ku Osaka554 JapanJapan',1),('00:00:60','Kontron Elektronik Gmbh','Kontron Elektronik GmbhOskar-von-miller-str. 1D-85385 EchingGermanyGermany',1),('00:00:61','Gateway Communications','Gateway Communications2941 Alton AvenueIrvine Ca 92714United States',1),('00:00:62','Bull Hn Information Systems','Bull Hn Information Systems300 Concord Road M/s 864aBillerica Ma 01821United States',1),('00:00:63','Barco Control Rooms Gmbh','Barco Control Rooms GmbhAn Der Rossweid 5Karlsruhe  D-76229Germany',1),('00:00:64','Yokogawa Digital Computer Corp','Yokogawa Digital Computer CorpSi Headquarters DivisionNo. 25 Kowa Bldg 8-7 Sanbancho Chiyoda-kJapanJapan',1),('00:00:65','Network General Corporation','Network General Corporation178 E Tsaman DrSan Jose Ca 95134United States',1),('00:00:66','Talaris Systems, Inc.','Talaris Systems, Inc.11339 Sorrento Valley RoadSan Diego Ca 92121United States',1),('00:00:67','Soft * Rite, Inc.','Soft * Rite, Inc.15392 Assembly Lane, Unit AHuntington Beach Ca 92649United States',1),('00:00:68','Rosemount Controls','Rosemount Controls1300 E. Lambert RoadLa Habra Ca 90632United States',1),('00:00:69','Concord Communications Inc','Concord Communications Inc753 Forest StreetMarlborough Ma 01752United States',1),('00:00:6A','Computer Consoles Inc.','Computer Consoles Inc.Computer Products Division9801 Muirlands Blvd.Irvine Ca 92718United States',1),('00:00:6B','Silicon Graphics Inc./mips','Silicon Graphics Inc./mips2011 North Shoreline Blvd.P.o. Box 7311 -  Bldg. #10Mountain View Ca 94039-7311United States',1),('00:00:6C','Private','',1),('00:00:6D','Cray Communications, Ltd.','Cray Communications, Ltd.P.o. Box 254, Caxton WayWatford Business Park Watford Herts  Wd1United KingdomUnited Kingdom',1),('00:00:6E','Artisoft, Inc.','Artisoft, Inc.691 East River RoadTucson Az 85704United States',1),('00:00:6F','Madge Ltd.','Madge Ltd.Madge HousePriors WayMaindenhead Berkshire Sl6 2hpUnited Kingdom',1),('00:00:70','Hcl Limited','Hcl LimitedResearch & Development Unit72, Luz Church Road Madrsa-600 004IndiaIndia',1),('00:00:71','Adra Systems Inc.','Adra Systems Inc.59 Technology DriveLowell Ma 01851United States',1),('00:00:72','Miniware Technology','Miniware TechnologyBeemdenstraat 385004 Ct Weert (l)The NetherlandsNetherlands',1),('00:00:73','Siecor Corporation','Siecor CorporationP.o. Box 13625Research Triangle Pk Nc 27709United States',1),('00:00:74','Ricoh Company Ltd.','Ricoh Company Ltd.2446 Toda, Atsugi CityKanagawa Pref.,243 JapanJapan',1),('00:00:75','Nortel Networks','Nortel NetworksGlobal Operations EngineeringDep 6800 Program Manager 8200 Dixie RoadBrampton On L6t 5p6 CanaCanada',1),('00:00:76','Abekas Video System','Abekas Video System101 Galveston DriveRedwood City Ca 94063United States',1),('00:00:77','Interphase Corporation','Interphase Corporation13800 SenlacDallas Tx 75234United States',1),('00:00:78','Labtam Limited','Labtam Limited43 Malcolm Road   P.o. Box297Braeside, Victoria 3195AustraliaAustralia',1),('00:00:79','Networth Incorporated','Networth Incorporated8404 Esters BoulevardIrving Tx 75063United States',1),('00:00:7A','Dana Computer Inc.','Dana Computer Inc.550 Del Rey AvenueSunnyvale Ca 94086United States',1),('00:00:7B','Research Machines','Research MachinesP.o. Box 75Mill Street Oxford  Ox2 0bwEnglandUnited Kingdom',1),('00:00:7C','Ampere Incorporated','Ampere IncorporatedShinjuku Asahi Bldg.5-20  7-chome Nishi-shinjuku  Shinjuku-kTokyo JapanJapan',1),('00:00:7D','Sun Microsystems, Inc.','Sun Microsystems, Inc.4200 Network CircleSanta Clara Ca 95054United States',1),('00:00:7E','Clustrix Corporation','Clustrix Corporation960 Hamlin CourtSunnyvale Ca 94089United States',1),('00:00:7F','Linotype-hell Ag','Linotype-hell AgPostfach 56 60Mergenthaler Allee 55-75 6236 Eschborn BGermanyGermany',1),('00:00:80','Cray Communications A/s','Cray Communications A/sSmedeholm 12-142730 HerlevDenmarkDenmark',1),('00:00:81','Bay Networks','Bay Networks4401 Great American ParkwayPo Box 58185 M/s Sc01-05Santa Clara Ca 95052-8185United States',1),('00:00:82','Lectra Systemes Sa','Lectra Systemes SaChemin De MarticotResearch Department 33610 CestasFranceFrance',1),('00:00:83','Tadpole Technology Plc','Tadpole Technology Plc137 Ditton WalkCambridge Cb5 8fnEnglandUnited Kingdom',1),('00:00:84','Supernet','Supernet846 Del Rey AvenueSunnyvale Ca 94086United States',1),('00:00:85','Canon Inc.','Canon Inc.Dvtech. Dev. Center Dept.123-30-2, Shimomaruko, Ohta-ku Tokyo 146JapanJapan',1),('00:00:86','Megahertz Corporation','Megahertz Corporation605 North--5600 WestSalt Lake City Ut 84116-3738United States',1),('00:00:87','Hitachi, Ltd.','Hitachi, Ltd.Network Engineering Div.Hitachi Omori 2nd Bldg., 27-18 Minami OiTokyo 140Japan',1),('00:00:88','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology Dr.San Jose Ca 95110United States',1),('00:00:89','Cayman Systems Inc.','Cayman Systems Inc.26 Lansdowne StreetCambridge Ma 02139United States',1),('00:00:8A','Datahouse Information Systems','Datahouse Information SystemsDirector Of OperationsMeon House, East Tisted Nr. Alton, HampsGu34 3qw EnglandUnited Kingdom',1),('00:00:8B','Infotron','Infotron9 North OlneyCherry Hill Nj 08003United States',1),('00:00:8C','Alloy Computer Products (australia) Pty Ltd','Alloy Computer Products (australia) Pty LtdUnit 4/585 Blackburn RoadNotting Hill Victoria 3168Australia',1),('00:00:8D','Cryptek Inc.','Cryptek Inc.1501 Moran RoadSterling Va 20166United States',1),('00:00:8E','Solbourne Computer, Inc.','Solbourne Computer, Inc.1900 Pike RoadLongmont Colorado 80501United States',1),('00:00:8F','Raytheon','RaytheonM/s 1-1-11191001 Boston Post RdMarlboro Ma 01752United States',1),('00:00:90','Microcom','Microcom500 River Ridge DriveNorwood Ma 02062-5028United States',1),('00:00:91','Anritsu Corporation','Anritsu Corporation1800, OnnaAtugi-shi Kanagawa-ken 243JapanJapan',1),('00:00:92','Cogent Data Technologies','Cogent Data Technologies640 Mullis StreetFriday Harbor Wa 98250United States',1),('00:00:93','Proteon Inc.','Proteon Inc.4 Tech CircleNatick Ma 01760United States',1),('00:00:94','Asante Technologies','Asante Technologies821 Fox LaneSan Jose Ca 95131United States',1),('00:00:95','Sony Tektronix Corp.','Sony Tektronix Corp.P.o. Box 5209 Tokyo IntlTokyo 100-31JapanJapan',1),('00:00:96','Marconi Electronics Ltd.','Marconi Electronics Ltd.Browns Lane, The AirportPortsmouth -- Hampshire P03 5phUnited KingdomUnited Kingdom',1),('00:00:97','Emc Corporation','Emc Corporation176 South StreetHopkinton Ma 01748United States',1),('00:00:98','Crosscomm Corporation','Crosscomm Corporation450 Donald Lynch BoulevardMarlborough Ma 01752United States',1),('00:00:99','Mtx, Inc.','Mtx, Inc.3301 Terminal DriveRaleigh Nc 27604United States',1),('00:00:9A','Rc Computer A/s','Rc Computer A/sLautrupbjerg 1Dk-2750 BallerupDenmarkDenmark',1),('00:00:9B','Information International, Inc','Information International, Inc5f., The 7th Industry Bldg.1-20-14 Jinnan Shibuya-ku TokyoJapan 150Japan',1),('00:00:9C','Rolm Mil-spec Computers','Rolm Mil-spec Computers3151 Zanker RoadSan Jose Ca 95148United States',1),('00:00:9D','Locus Computing Corporation','Locus Computing Corporation9800 La CienegaInglewood Ca 90301United States',1),('00:00:9E','Marli S.a.','Marli S.a.Chemin Taverney 31218 GenevaSwitzerlandSwitzerland',1),('00:00:9F','Ameristar Technologies Inc.','Ameristar Technologies Inc.47 Whittier Ave.Medford Ny 11763United States',1),('00:00:A0','Sanyo Electric Co., Ltd.','Sanyo Electric Co., Ltd.5-5, Keihan-hondori 2-chome,Moriguchi City Osaka 570-8677Japan',1),('00:00:A1','Marquette Electric Co.','Marquette Electric Co.8200 West Tower AvenueMilwaukee Wi 53223United States',1),('00:00:A2','Bay Networks','Bay Networks4401 Great American PkwyM/s:sc01-05Santa Clara Ca 95052-8185United States',1),('00:00:A3','Network Application Technology','Network Application Technology1686 Dell AvenueCampbell Ca 95008United States',1),('00:00:A4','Acorn Computers Limited','Acorn Computers LimitedFulbourn Road, Cherry HintonCambridge Cb1 4jn,EnglandUnited Kingdom',1),('00:00:A5','Compatible Systems Corp.','Compatible Systems Corp.P.o. Box 17220Boulder Co 80308-7220United States',1),('00:00:A6','Network General Corporation','Network General Corporation1296 B Lawrence Station RoadSunnyvale Ca 94089United States',1),('00:00:A7','Network Computing Devices Inc.','Network Computing Devices Inc.350 North BernardoMountain View Ca 94043United States',1),('00:00:A8','Stratus Computer Inc.','Stratus Computer Inc.111 Powdermill RoadMaynard Ma 01754United States',1),('00:00:A9','Network Systems Corp.','Network Systems Corp.7600 Boone Avenue NorthMinneapolis Mn 55428-1099United States',1),('00:00:AA','Xerox Corporation','Xerox CorporationOffice Systems DivisionM/s 105-50c 800 Phillips RoadWebster Ny 14580United States',1),('00:00:AB','Logic Modeling Corporation','Logic Modeling Corporation1520 Mccandless DriveMilpitas Ca 95035United States',1),('00:00:AC','Conware Computer Consulting','Conware Computer ConsultingKillisfeldstrasse 6476227 KarlsruheGermanyGermany',1),('00:00:AD','Bruker Instruments Inc.','Bruker Instruments Inc.Manning ParkBillerica Ma 01821United States',1),('00:00:AE','Dassault Electronique','Dassault Electronique55, Quai Marcel Dassault92214 St CloudFranceFrance',1),('00:00:AF','Nuclear Data Instrumentation','Nuclear Data InstrumentationGolf & Meacham RoadsSchaumberg Il 60196United States',1),('00:00:B0','Rnd-rad Network Devices','Rnd-rad Network DevicesAtidim Technolcl Bldg. 1Tel Aviv  61131IsraelIsrael',1),('00:00:B1','Alpha Microsystems Inc.','Alpha Microsystems Inc.3501 SunflowerSanta Ana Ca 92704United States',1),('00:00:B2','Televideo Systems, Inc.','Televideo Systems, Inc.550 E. Brokaw RoadSan Jose Ca 95161-9048United States',1),('00:00:B3','Cimlinc Incorporated','Cimlinc Incorporated1957 Crooks RoadTroy Mi 48084United States',1),('00:00:B4','Edimax Computer Company','Edimax Computer CompanyNo. 3, Wu-chuan 3rd Road,Wu-ku Industrial ParkTaipei Hsien  248Taiwan, Republic Of China',1),('00:00:B5','Datability Software Sys. Inc.','Datability Software Sys. Inc.One Palmer TerraceCarlstadt Nj 07072United States',1),('00:00:B6','Micro-matic Research','Micro-matic ResearchAmbachtenlaan  21 B5B - 3030  HeverleeBelgiumBelgium',1),('00:00:B7','Dove Computer Corporation','Dove Computer Corporation1200 North 23rd StreetWilmington Nc 28405United States',1),('00:00:B8','Seikosha Co., Ltd.','Seikosha Co., Ltd.System Equipment Division4-1-1 Taihei Sumida-ku Tokyo 130JapanJapan',1),('00:00:B9','Mcdonnell Douglas Computer Sys','Mcdonnell Douglas Computer SysDiv Mcdonnell Douglas Inf SysBoundary Way Hemel Hempstead HertsEnglandUnited Kingdom',1),('00:00:BA','Siig, Inc.','Siig, Inc.6078 Stewart AvenueFremont Ca 94538United States',1),('00:00:BB','Tri-data','Tri-data505 East Middlefield RoadMountain View Ca 94043-4082United States',1),('00:00:BC','Rockwell Automation','Rockwell Automation1 Allen-bradley Dr.Mayfield Heights Oh 44124-6118United States',1),('00:00:BD','Mitsubishi Cable Company','Mitsubishi Cable Company520 Madison AvenueNew York Ny 10022United States',1),('00:00:BE','The Nti Group','The Nti Group4701 Patrick Henry DriveSuite 24Santa Clara Ca 95054United States',1),('00:00:BF','Symmetric Computer Systems','Symmetric Computer Systems1620 Oakland Road  Suite D-200San Jose Ca 95131United States',1),('00:00:C0','Western Digital Corporation','Western Digital Corporation8105 Irvine Center DriveIrvine Ca 92718United States',1),('00:00:C1','Madge Ltd.','Madge Ltd.Madge HousePriors WayMaindenhead Berkshire Sl6 2hpUnited Kingdom',1),('00:00:C2','Information Presentation Tech.','Information Presentation Tech.23801 Calabasas RoadSuite 2011Calabasas Ca 91302United States',1),('00:00:C3','Harris Corp Computer Sys Div','Harris Corp Computer Sys DivM/s 751025 W. Nasa Blvd.l 33309Melbourne Fl 32919United States',1),('00:00:C4','Waters Div. Of Millipore','Waters Div. Of Millipore34 Maple StreetMilford Ma 01757United States',1),('00:00:C5','Farallon Computing/netopia','Farallon Computing/netopia2470 Mariner Square LoopAlameda Ca 94501United States',1),('00:00:C6','Eon Systems','Eon Systems10601 South Deanza Blvd.Suite 303Cupertino Ca 95014United States',1),('00:00:C7','Arix Corporation','Arix CorporationEngineering Mail Stop1152 Morse AvenueSunnyvale Ca 94089United States',1),('00:00:C8','Altos Computer Systems','Altos Computer Systems2641 Orchard ParkwaySan Jose Ca 95134United States',1),('00:00:C9','Emulex Corporation','Emulex Corporation3333 Susan StreetCosta Mesa Ca 92626United States',1),('00:00:CA','Arris International','Arris International3871 Lakefield Drive, Suite 300Suwanee Ga 30024United States',1),('00:00:CB','Compu-shack Electronic Gmbh','Compu-shack Electronic GmbhRingstr. 56 - 58, 5450 NeuwiedWest GermanyGermany',1),('00:00:CC','Densan Co., Ltd.','Densan Co., Ltd.1-23-11, KamitakaidoSuginami-ku, Tokyo 168JapanJapan',1),('00:00:CD','Allied Telesis Labs Ltd','Allied Telesis Labs Ltd27 Nazareth AvenueMiddleton Christchurch 8024New Zealand',1),('00:00:CE','Megadata Corp.','Megadata Corp.35 Orville DriveBohemia Ny 11716United States',1),('00:00:CF','Hayes Microcomputer Products','Hayes Microcomputer Products(canada) Ltd.295 Phillip Street Waterloo, Ontario N2lCanadaCanada',1),('00:00:D0','Develcon Electronics Ltd.','Develcon Electronics Ltd.856-51st Street EastSaskatoon Saskatchewan S7k 5c7CanadaCanada',1),('00:00:D1','Adaptec Incorporated','Adaptec IncorporatedM/s 180691 South Milpitas Blvd.Milpitas Ca 95035United States',1),('00:00:D2','Sbe, Inc.','Sbe, Inc.4550 North Canyon RoadSan Ramon Ca 94583United States',1),('00:00:D3','Wang Laboratories Inc.','Wang Laboratories Inc.',1),('00:00:D4','Pure Data Ltd.','Pure Data Ltd.200 West Beaver Creek RoadRichmond Hill  OntarioL4b 1b4 CanadaCanada',1),('00:00:D5','Micrognosis International','Micrognosis International63 Queen Victoria StreetLondon Ec4n 4udUnited KingdomUnited Kingdom',1),('00:00:D6','Punch Line Holding','Punch Line HoldingP.o. Box 391708Bramley 2018South AfricaSouth Africa',1),('00:00:D7','Dartmouth College','Dartmouth CollegeKiewit Computer CenterHanover Nh 03755United States',1),('00:00:D8','Novell, Inc.','Novell, Inc.122 East 1700 South M/s:e-12-1P.o. Box 5900Provo Ut 84601United States',1),('00:00:D9','Nippon Telegraph & Telephone','Nippon Telegraph & TelephoneCorporation (ntt)Teishin Bldg. 3-1 Ootemachi 2 Chome, ChiTokyo 100-8116 JapanJapan',1),('00:00:DA','Atex','Atex15 Crosby DriveBedford Ma 01730United States',1),('00:00:DB','British Telecommunications Plc','British Telecommunications Plc81 Newgate StreetLondon, Ec1a 7ajEnglandUnited Kingdom',1),('00:00:DC','Hayes Microcomputer Products','Hayes Microcomputer ProductsP.o. Box 105203Atlanta Ga 30348United States',1),('00:00:DD','Tcl Incorporated','Tcl Incorporated41829 Albrae StreetFremont Ca 94538United States',1),('00:00:DE','Cetia','Cetia150 Rue BerthelotZi Toulon Est 83088 Toulon CedexFranceFrance',1),('00:00:DF','Bell & Howell Pub Sys Div','Bell & Howell Pub Sys DivOld Mansfield RoadWooster Oh 44691-9050United States',1),('00:00:E0','Quadram Corp.','Quadram Corp.One Quad WayNorcross Ga 30093United States',1),('00:00:E1','Grid Systems','Grid Systems47211 Lakeview BoulevardP.o. Box 5003Fremont Ca 94537-5003United States',1),('00:00:E2','Acer Technologies Corp.','Acer Technologies Corp.401 Charcot Ave.San Jose Ca 95131United States',1),('00:00:E3','Integrated Micro Products Ltd','Integrated Micro Products LtdImp, No. 1 Industrial EstateConsett, Co DukhamEngland England Dh86tjUnited Kingdom',1),('00:00:E4','In2 Groupe Intertechnique','In2 Groupe IntertechniqueIn2 - B.p.6378373 Plaisir CedexFranceFrance',1),('00:00:E5','Sigmex Ltd.','Sigmex Ltd.Sigma HouseNorth Heath Lane Horsham, West SussexRh12 4uz EnglandUnited Kingdom',1),('00:00:E6','Aptor Produits De Comm Indust','Aptor Produits De Comm Indust61, Chemin Du Vieux-cheneZirst-bp 177 38244 Meylan CedexFranceFrance',1),('00:00:E7','Star Gate Technologies','Star Gate Technologies29300 Aurora RoadSolon Oh 44139United States',1),('00:00:E8','Accton Technology Corp.','Accton Technology Corp.46750 Fremont Blvd. #104Fremont Ca 94538United States',1),('00:00:E9','Isicad, Inc.','Isicad, Inc.1920 West Corporate WayAnaheim Ca 92803-6122United States',1),('00:00:EA','Upnod Ab','Upnod AbBox 23051S-750 23 UppsalaSwedenSweden',1),('00:00:EB','Matsushita Comm. Ind. Co. Ltd.','Matsushita Comm. Ind. Co. Ltd.3-1  4-chomeTsunashima-higashi Kohoku-ku  YokohamaJapanJapan',1),('00:00:EC','Microprocess','Microprocess97 Bis, Rue De ColombesB.p. 87 92400 CourbevoieFranceFrance',1),('00:00:ED','April','April60, Rue De CartaleBp 38 38170 Seyssinet-parisetFranceFrance',1),('00:00:EE','Network Designers, Ltd.','Network Designers, Ltd.Unit 1a, Hornbeam ParkHookstone Road Harrogate, North YorkshirUnited Kingdom Hg2 8qtUnited Kingdom',1),('00:00:EF','Kti','Kti2157 Otoole AvenueSuite HSan Jose Ca 95131United States',1),('00:00:F0','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.416, Maetan-3dong, Paldal-guSuwon City, Kyungki-do442-742Korea, Republic Of',1),('00:00:F1','Magna Computer Corporation','Magna Computer Corporation22 Keewaydin DriveSalem Nh 03079United States',1),('00:00:F2','Spider Communications','Spider Communications7491 Briar RoadMontreal,  Quebec H4w 1k4CanadaCanada',1),('00:00:F3','Gandalf Data Limited','Gandalf Data Limited130 Colonnade Road SouthNepean  Ontario  K2e 7m4CanadaCanada',1),('00:00:F4','Allied Telesyn International','Allied Telesyn InternationalCorporation950 Kifer RoadSunnyvale Ca 94086United States',1),('00:00:F5','Diamond Sales Limited','Diamond Sales Limited17, Charterhouse StreetLondon, Ecin 6raUnited KingdomUnited Kingdom',1),('00:00:F6','Applied Microsystems Corp.','Applied Microsystems Corp.5020 148 Avenue, N.e.P.o. Box 97002Redmond Wa 98073-9702United States',1),('00:00:F7','Youth Keep Enterprise Co Ltd','Youth Keep Enterprise Co Ltd3/f No. 712 Mintsu E. RoadTaipei, TaiwanRocTaiwan, Republic Of China',1),('00:00:F8','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King Street Littleton  Ma  01460-12801460United States',1),('00:00:F9','Quotron Systems Inc.','Quotron Systems Inc.5454 Beethoven St.Los Angeles Ca 90066United States',1),('00:00:FA','Microsage Computer Systems Inc','Microsage Computer Systems Inc680 South Rock BlvdReno Ne 89502United States',1),('00:00:FB','Rechner Zur Kommunikation','Rechner Zur KommunikationBitzenstr. 11F-5464 AsbachGermanyGermany',1),('00:00:FC','Meiko','Meiko650 Aztec WestBristol Bs12 4sdUnited KingdomUnited Kingdom',1),('00:00:FD','High Level Hardware','High Level HardwarePo Box 170 Windmill RoadHeadington Oxford Ox3 7bnEnglandUnited Kingdom',1),('00:00:FE','Annapolis Micro Systems','Annapolis Micro Systems190 Admiral Cochrane DriveSuite 130Annapolis Md 21401United States',1),('00:00:FF','Camtec Electronics Ltd.','Camtec Electronics Ltd.101 Vaughan WayLeicester Le1 4saEnglandUnited Kingdom',1),('00:01:00','Equiptrans','Equiptrans31 Rue Paul CezanneLa Rochette  77000France',1),('00:01:01','Private','',1),('00:01:02','3com Corporation','3com Corporation5400 Bayfront Plaza  - Ms: 4220Santa Clara Ca 95052United States',1),('00:01:03','3com Corporation','3com Corporation5400 Bayfront Plaza - Ms: 4220Santa Clara Ca 95052United States',1),('00:01:04','Dvico Co., Ltd.','Dvico Co., Ltd.Kookmin Card B/d 6f 267-2Seohyun-dong Boondang-guSungnam-si Kyungki-do 463-050Korea, Republic Of',1),('00:01:05','Beckhoff Automation Gmbh','Beckhoff Automation GmbhEiserstr. 533415 VerlGermany',1),('00:01:06','Tews Datentechnik Gmbh','Tews Datentechnik GmbhAm Bahnhof 725469 HalstenbekGermany',1),('00:01:07','Leiser Gmbh','Leiser GmbhIlmstr. 785579 NeubibergGermany',1),('00:01:08','Avlab Technology, Inc.','Avlab Technology, Inc.3f-1, No. 134, Sec. 3Chung Shin RoadHsin Tien, TaipeiTaiwan, Republic Of China',1),('00:01:09','Nagano Japan Radio Co., Ltd.','Nagano Japan Radio Co., Ltd.Shimohigano 1163, Inasato-machiNagano 381-2288Japan',1),('00:01:0A','Cis Technology Inc.','Cis Technology Inc.16f, No. 75 Hsin Tai Wu RoadSec. 1, Hsi ChihTaipei Hsien 221Taiwan, Republic Of China',1),('00:01:0B','Space Cyberlink, Inc.','Space Cyberlink, Inc.5th Fl. Guppyung Town B203 Nonhnyun-dong, Kangham-guSeoulKorea, Republic Of',1),('00:01:0C','System Talks Inc.','System Talks Inc.4f, Primenihonbashi Bld.3-35-6, Nihonbashi Hama-choChuo-ku TokyoJapan',1),('00:01:0D','Coreco, Inc.','Coreco, Inc.6969 Route TranscanadianneVille St. Laurent H4t 1v8 QuebecCanada',1),('00:01:0E','Bri-link Technologies Co., Ltd','Bri-link Technologies Co., Ltd2f, No. 63, Chow-tze StreetTaipei 114Taiwan, Republic Of China',1),('00:01:0F','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology Dr.San Jose Ca 95110United States',1),('00:01:10','Gotham Networks','Gotham Networks15 Discovery WayActon Ma 01720United States',1),('00:01:11','Idigm Inc.','Idigm Inc.7fl Sindo B/d 1604-22 Seocho-dongSeocho-guSeoul 137-070Korea, Republic Of',1),('00:01:12','Shark Multimedia Inc.','Shark Multimedia Inc.48890 Milmont Drive  #101-dFremont Ca 94538United States',1),('00:01:13','Olympus Corporation','Olympus Corporation2-3 Kuboyama-cho, Hachioji-shiTokyo 192-8512Japan',1),('00:01:14','Kanda Tsushin Kogyo Co., Ltd.','Kanda Tsushin Kogyo Co., Ltd.23-2, Nishi-gotanda 2-chome,Shinagawa-kuTokyo 141-8533Japan',1),('00:01:15','Extratech Corporation','Extratech Corporation760 Thornton St., Unit 2Post Falls Id 83854United States',1),('00:01:16','Netspect Technologies, Inc.','Netspect Technologies, Inc.3945 Freedom Circle - Ste. #360Santa Clara Ca 95054United States',1),('00:01:17','Canal +','Canal +23 Rue LeblancLe Ponant C75906 Paris Cedex 15France',1),('00:01:18','Ez Digital Co., Ltd.','Ez Digital Co., Ltd.Bitville Bldg. Room 703#1327 Seocho-dong Seocho-guSeoulKorea, Republic Of',1),('00:01:19','Rtunet (australia)','Rtunet (australia)8/3-5 Gilda CourtMulgrave Vic 3170Australia',1),('00:01:1A','Eeh Datalink Gmbh','Eeh Datalink GmbhNiederberger Str. 75D-53909 ZuelpichGermany',1),('00:01:1B','Unizone Technologies, Inc.','Unizone Technologies, Inc.5floor Haesung Bldg.67-2-yangjae-dongSeocho-ku SeoulKorea, Republic Of',1),('00:01:1C','Universal Talkware Corporation','Universal Talkware Corporation10 Second St. NeSuite #400Minneapolis Mn 55413United States',1),('00:01:1D','Centillium Communications','Centillium Communications47211 Lakeview Blvd.Fremont Ca 94538United States',1),('00:01:1E','Precidia Technologies, Inc.','Precidia Technologies, Inc.10a Hearst WayKanata Ontario K2m-2c4Canada',1),('00:01:1F','Rc Networks, Inc.','Rc Networks, Inc.6727 Flanders Drive - Ste. #212San Diego Ca 92121United States',1),('00:01:20','Oscilloquartz S.a.','Oscilloquartz S.a.Rue Des Brevards 162002 NeuchatelSwitzerland',1),('00:01:21','Watchguard Technologies, Inc.','Watchguard Technologies, Inc.605 Fifth Ave. SSuite 500Seattle Wa 98104-3892United States',1),('00:01:22','Trend Communications, Ltd.','Trend Communications, Ltd.Knaves Beech EstateLoudwater, High WycombeBucks, Hp10 9qz EnglandUnited Kingdom',1),('00:01:23','Digital Electronics Corp.','Digital Electronics Corp.8-2-52 Nanko Higashi, Suminoe-kuOsaka, 559-0031Japan',1),('00:01:24','Acer Incorporated','Acer Incorporated21f, 88, Sec.1Hsin Tai Wu Road, HsichihTaipei Hsien 221Taiwan, Republic Of China',1),('00:01:25','Yaesu Musen Co., Ltd.','Yaesu Musen Co., Ltd.4-8-8, NakameguroMeguro-ku,Tokyo, 153-8644Japan',1),('00:01:26','Pac Labs','Pac Labs3079 Kilgore RoadRancho Cordova Ca 95670United States',1),('00:01:27','Open Networks Pty Ltd','Open Networks Pty LtdLevel 5, 342 Flinders StreetMelbourne  Vic 3000Australia',1),('00:01:28','Enjoyweb, Inc.','Enjoyweb, Inc.3000 Scott Blvd. #107Santa Clara Ca 95054United States',1),('00:01:29','Dfi Inc.','Dfi Inc.100, Huan-ho StreetHsi-chih City Taipei HsienTaiwan, Republic Of China',1),('00:01:2A','Telematica Sistems Inteligente','Telematica Sistems InteligenteRua Miguel Casagrande, 200Sao PauloBrazil',1),('00:01:2B','Telenet Co., Ltd.','Telenet Co., Ltd.',1),('00:01:2C','Aravox Technologies, Inc.','Aravox Technologies, Inc.16725 40th Place NorthPlymouth Mn 55446United States',1),('00:01:2D','Komodo Technology','Komodo Technology170 Knowles DriveLos Gatos Ca 95032United States',1),('00:01:2E','Pc Partner Ltd.','Pc Partner Ltd.Rm 1901-1908, 19/f, Shatin Galleria18-24 Shan  Mei Street, Fo Tan Shatin, HChinaChina',1),('00:01:2F','Twinhead International Corp','Twinhead International Corp2fl, 2, Lane 235, Bao-chiao RoadHsin-tienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:30','Extreme Networks','Extreme Networks3585 Monroe StreetSanta Clara Ca 95051United States',1),('00:01:31','Detection Systems, Inc.','Detection Systems, Inc.130 Perinton ParkwayFairport Ny 14450United States',1),('00:01:32','Dranetz - Bmi','Dranetz - Bmi1000 New Durham RoadEdison Nj 08817United States',1),('00:01:33','Kyowa Electronic Instruments C','Kyowa Electronic Instruments C3-5-1, CyofugaokaCyofu TokyoJapan',1),('00:01:34','Selectron Systems Ag','Selectron Systems AgBernstreasse 70Ch-3250 LyssSwitzerland',1),('00:01:35','Kdc Corp.','Kdc Corp.200-11 Anyang 7 DongManan-gu Anyane-si Kyunggi-doKoreaKorea, Republic Of',1),('00:01:36','Cybertan Technology, Inc.','Cybertan Technology, Inc.626, Bldg.53, 195-56 Sec.4Chung Hsing Rd Chutung, HsinchuTaiwan R.o.c.Taiwan, Republic Of China',1),('00:01:37','It Farm Corporation','It Farm CorporationAsashiseimei Fuchu Bldg. 11f1-14-1 Fuchu-cho, Fuchu-shi Tokyo183-0055 JapanJapan',1),('00:01:38','Xavi Technologies Corp.','Xavi Technologies Corp.9f, No. 129, Hsing Te Rd,Sanchung City  Taipei Hsien241 Taiwan 241 Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:39','Point Multimedia Systems','Point Multimedia Systems4ra 507, Shihwa Industrial Complex669-8 Sungkog-dong, Ansan-city, Kyunggi-Korea 425-110Korea, Republic Of',1),('00:01:3A','Shelcad Communications, Ltd.','Shelcad Communications, Ltd.P.o. Box 8513New Industrial Zone Netanya 42504IsraelIsrael',1),('00:01:3B','Bna Systems','Bna Systems1637 S. Main StreetMilpitas Ca 95035United States',1),('00:01:3C','Tiw Systems','Tiw Systems2211 Lawson LaneSanta Clara Ca 95054United States',1),('00:01:3D','Riscstation Ltd.','Riscstation Ltd.168 Elliott StreetTyldesley M29 805United KingdomUnited Kingdom',1),('00:01:3E','Ascom Tateco Ab','Ascom Tateco AbBox 878340276 GoteborgSweden',1),('00:01:3F','Neighbor World Co., Ltd.','Neighbor World Co., Ltd.114a Yerc, 134, Shinchon_dongSeodaemun_ku Seoul120-749 120-749 KoreaKorea, Republic Of',1),('00:01:40','Sendtek Corporation','Sendtek Corporation12f-3, 333, Sec.1Kuang-fu Road HsinchuTaiwanTaiwan, Republic Of China',1),('00:01:41','Cable Print','Cable PrintJozef Cardynstraat 16B  - 9420 Erpe-mereBelgiumBelgium',1),('00:01:42','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:01:43','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:01:44','Emc Corporation','Emc Corporation228 South St.Hopkinton Ma 01748United States',1),('00:01:45','Winsystems, Inc.','Winsystems, Inc.715 Stadium DriveArlington Tx 76011United States',1),('00:01:46','Tesco Controls, Inc.','Tesco Controls, Inc.P.o. Box 239012Sacramento Ca 95823-9012United States',1),('00:01:47','Zhone Technologies','Zhone Technologies7001 Oakport StreetOakland Ca 94621United States',1),('00:01:48','X-traweb Inc.','X-traweb Inc.6750 West 93rd Street - Ste. #210Overland Park Ks 66212United States',1),('00:01:49','T.d.t. Transfer Data Test Gmbh','T.d.t. Transfer Data Test GmbhSiemensstrasse 1884051 EssenbachGermanyGermany',1),('00:01:4A','Sony Corporation','Sony CorporationEngineering Standardization Office:mono-zukuri Technology Div.Gotenyama Tec 5-1-2 Kitashinagawa,Tokyo Shinagawa-ku 141-0001Japan',1),('00:01:4B','Ennovate Networks, Inc.','Ennovate Networks, Inc.60 Codman Hill RoadBoxborough Ma 01719United States',1),('00:01:4C','Berkeley Process Control','Berkeley Process Control4124 Lakeside DrRichmond Ca 94806United States',1),('00:01:4D','Shin Kin Enterprises Co., Ltd','Shin Kin Enterprises Co., Ltd7, Fu Hsing St. Tue Cheng Ind.Dist. TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:4E','Win Enterprises, Inc.','Win Enterprises, Inc.300 Willow Street SouthNorth Andover Ma 01845United States',1),('00:01:4F','Adtran Inc','Adtran Inc901 Explorer Blvd.Huntsville Al 35806-2807United States',1),('00:01:50','Gilat Communications, Ltd.','Gilat Communications, Ltd.21/d Yegia Kapayim StreetPetach-tikva 49130IsraelIsrael',1),('00:01:51','Ensemble Communications','Ensemble Communications6256 Greenman Drive - Ste. #400San Diego Ca 92122United States',1),('00:01:52','Chromatek Inc.','Chromatek Inc.6-10, Miyazaki 2-chomeMiyamae-ku, Kawasaki-shi Kanagawa, 216-0JapanJapan',1),('00:01:53','Archtek Telecom Corporation','Archtek Telecom Corporation4f, No.9 Lane 130, Min-chyuan Rd.Hsin-tien Taipei231 TaiwanTaiwan, Republic Of China',1),('00:01:54','G3m Corporation','G3m Corporation4320 Stevens Creek Blvd. - Ste. #275San Jose Ca 95129United States',1),('00:01:55','Promise Technology, Inc.','Promise Technology, Inc.4f, 1, Prosperity 1st RoadScience-based Industrial Park Hsin-chuTaiwanTaiwan, Republic Of China',1),('00:01:56','Firewiredirect.com, Inc.','Firewiredirect.com, Inc.4132 Spicewood Springs Rd - #i-4Austin Tx 78759United States',1),('00:01:57','Syswave Co., Ltd','Syswave Co., LtdDongho B/d 5f, 221-2Nonhyun-dong, Kangnam-gu SeoulKorea 135-010Korea, Republic Of',1),('00:01:58','Electro Industries/gauge Tech','Electro Industries/gauge Tech1800 Shames DriveWestbury Ny 11590United States',1),('00:01:59','S1 Corporation','S1 CorporationR&d Center, S1 Bldg.59-8, Nonhyun-dong Kangnam-ku SeoulKorea 135-010Korea, Republic Of',1),('00:01:5A','Digital Video Broadcasting','Digital Video BroadcastingDvb, % European Broadcasting Union17a Ancienne Route Ch-1218 Grand SaconneSwitzerlandSwitzerland',1),('00:01:5B','Italtel S.p.a/rf-up-i','Italtel S.p.a/rf-up-i20019 Cast.settimo M.se (mi)ItalyItaly',1),('00:01:5C','Cadant Inc.','Cadant Inc.4343 Commerce Court - Ste. #207Lisle Il 60532United States',1),('00:01:5D','Sun Microsystems, Inc','Sun Microsystems, Inc4200 Network CircleSanta Clara Ca 95054United States',1),('00:01:5E','Best Technology Co., Ltd.','Best Technology Co., Ltd.7f, Haesung B/d115-12 Nonhyun-dong Kangnam-ku Seoul, 13KoreaKorea, Republic Of',1),('00:01:5F','Digital Design Gmbh','Digital Design GmbhAlt-moabit 96aBerlin D-10559Germany',1),('00:01:60','Elmex Co., Ltd.','Elmex Co., Ltd.16-30 KimachiAobaku Sendai-shi Miyagi-kenJapanJapan',1),('00:01:61','Meta Machine Technology','Meta Machine Technology400 Silver Cedar Court - Ste. #220Chapel Hill Nc 27514United States',1),('00:01:62','Cygnet Technologies, Inc.','Cygnet Technologies, Inc.1411 Lemay Drive #301Carrollton Tx 75007United States',1),('00:01:63','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:01:64','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:01:65','Airswitch Corporation','Airswitch Corporation37east 200southSpringville Ut 84663United States',1),('00:01:66','Tc Group A/s','Tc Group A/sSindalsvej 34Risskov  Dk-8240Denmark',1),('00:01:67','Hioki E.e. Corporation','Hioki E.e. Corporation81 Koizumi, Ueda, Nagano386-1192 386-1192 JapanJapan',1),('00:01:68','Vitana Corporation','Vitana Corporation2500 Don Reid DriveOttawa, OntarioK1h 1e1 K1h 1e1 CanadaCanada',1),('00:01:69','Celestix Networks Pte Ltd.','Celestix Networks Pte Ltd.18 Tannery Lane #05-03Lian Tong BuildingSingapore 347780Singapore',1),('00:01:6A','Alitec','AlitecLaval Technopole B.p. 10253001 Laval CedexFranceFrance',1),('00:01:6B','Lightchip, Inc.','Lightchip, Inc.5 Industrial WaySalem Nh 03079United States',1),('00:01:6C','Foxconn','Foxconn6125 Phyllis DriveCypress Ca 90630United States',1),('00:01:6D','Carriercomm Inc.','Carriercomm Inc.539 Encintas Blvd.Encintas Ca 92024United States',1),('00:01:6E','Conklin Corporation','Conklin Corporation6141 Crooked Creek RoadNorcross Ga 30092-3193United States',1),('00:01:6F','Inkel Corp.','Inkel Corp.Cheongcheon-dong, Bupyeong-gu,Incheon-siKorea, Republic Of',1),('00:01:70','Ese Embedded System Engineerg','Ese Embedded System EngineergMuehlbachstr. 2078351 Bodman-ludwigshafenGermanyGermany',1),('00:01:71','Allied Data Technologies','Allied Data TechnologiesPascalweg 1,3208 Kl SpijkenisseThe NetherlandsNetherlands',1),('00:01:72','Technoland Co., Ltd.','Technoland Co., Ltd.3-17-11 Akebono-choFukuyama-city Hiroshima 721-0925JapanJapan',1),('00:01:73','Amcc','Amcc6290 Sequence DriveSan Diego Ca 92121United States',1),('00:01:74','Cyberoptics Corporation','Cyberoptics Corporation5900 Golden Hills DriveGolden Valley Mn 55416United States',1),('00:01:75','Radiant Communications Corp.','Radiant Communications Corp.5001 Hadley RoadSouth Plainfield Nj 07080United States',1),('00:01:76','Orient Silver Enterprises','Orient Silver Enterprises8740 White Oak AvenueRancho Cucamonga Ca 91730United States',1),('00:01:77','Edsl','EdslHabarzel 1 StRamat Ahayal Tel-avivIsrael 69710Israel',1),('00:01:78','Margi Systems, Inc.','Margi Systems, Inc.3155 Kearney Street. - Ste.#200Fremont Ca 94538United States',1),('00:01:79','Wireless Technology, Inc.','Wireless Technology, Inc.Anam Bldg. 2fl, 154-17Samsung-dong, Kangnam-ku Seoul, 135-090KoreaKorea, Republic Of',1),('00:01:7A','Chengdu Maipu Electric Industrial Co., Ltd.','Chengdu Maipu Electric Industrial Co., Ltd.Nanyi Building, Consulate Rd.,ChengduP.r. ChinaChina',1),('00:01:7B','Heidelberger Druckmaschinen Ag','Heidelberger Druckmaschinen AgKurfuerstenanlage 52-6069115 HeidelbergGermanyGermany',1),('00:01:7C','Ag-e Gmbh','Ag-e GmbhDennewartstr. 2752068 AachenGermanyGermany',1),('00:01:7D','Thermoquest','Thermoquest355 River Oaks ParkwaySan Jose Ca 95134United States',1),('00:01:7E','Adtek System Science Co., Ltd.','Adtek System Science Co., Ltd.Ybp West Tower134 Gohdo-cho,Hodogaya YokohamaJapan',1),('00:01:7F','Experience Music Project','Experience Music Project110 -110th Avenue Ne - Ste. #400Bellevue Wa 98004United States',1),('00:01:80','Aopen, Inc.','Aopen, Inc.6f, 88, Sec.1, Hsin TaiWu Road, Hsichih Taipei Hsien 221Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:81','Nortel Networks','Nortel Networks1100 Technology Park DriveBillerica Ma 01821United States',1),('00:01:82','Dica Technologies Ag','Dica Technologies AgRotherstr, 19D-10245 BerlinGermanyGermany',1),('00:01:83','Anite Telecoms','Anite Telecoms127 Fleet Road, FleetHampshire, Gub 8pdUnited KingdomUnited Kingdom',1),('00:01:84','Sieb & Meyer Ag','Sieb & Meyer AgAuf Dem Schmaarkamp 21D-21339 LuneburgGermanyGermany',1),('00:01:85','Aloka Co., Ltd.','Aloka Co., Ltd.3-7-19, Imai Ome-cityTokyo198-8577 JapanJapan',1),('00:01:86','Uwe Disch','Uwe DischEichenhainstrasse 1491207 Lauf A.d. PegnitzGermany',1),('00:01:87','I2se Gmbh','I2se GmbhCarl-zeiss - Str. 4647445 MoersGermanyGermany',1),('00:01:88','Lxco Technologies Ag','Lxco Technologies AgGimmerstr. 69D-10117 BerlinGermanyGermany',1),('00:01:89','Refraction Technology, Inc.','Refraction Technology, Inc.2626 Lombardy Lane - Ste. #105Dallas Tx 75220United States',1),('00:01:8A','Roi Computer Ag','Roi Computer AgWerner-von-siemens-str. 193426 RodingGermanyGermany',1),('00:01:8B','Netlinks Co., Ltd.','Netlinks Co., Ltd.3f Dscom Bldg., 238-3Poi-dong, Kangnam-ku SeoulKoreaKorea, Republic Of',1),('00:01:8C','Mega Vision','Mega Vision5765 Thornwood DriveGoleta Ca 93117United States',1),('00:01:8D','Audesi Technologies','Audesi TechnologiesSuite 180, 68158th Street N.e. CalgaryAb CanadaCanada',1),('00:01:8E','Logitec Corporation','Logitec Corporation8268 Rokudouhara, MisuzuIna, NaganoJapanJapan',1),('00:01:8F','Kenetec, Inc.','Kenetec, Inc.115 Hurley RoadOxford Ct 06748United States',1),('00:01:90','Smk-m','Smk-m1055 Tierra Del ReyChula Vista Ca 91910United States',1),('00:01:91','Syred Data Systems','Syred Data Systems272 Lanes Mill RoadHowell Nj 07731United States',1),('00:01:92','Texas Digital Systems','Texas Digital Systems400 Technology ParkwayCollege Station Tx 77845United States',1),('00:01:93','Hanbyul Telecom Co., Ltd.','Hanbyul Telecom Co., Ltd.5th Fl. Oksan Bldg.157-33 Samsung-dong Kangnam-ku SeoulKoreaKorea, Republic Of',1),('00:01:94','Capital Equipment Corporation','Capital Equipment Corporation900 Middlesex Turnpike - Bldg. 2Billerica Ma 01821United States',1),('00:01:95','Sena Technologies, Inc.','Sena Technologies, Inc.116-23 Shinlim-dongOnsung Bldg. 8th Floor Kwanak-ku SeoulKoreaKorea, Republic Of',1),('00:01:96','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:01:97','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:01:98','Darim Vision','Darim VisionTaejon Expo Venture Town3-1 Doryong-dong, Yusung-gu TaejonKoreaKorea, Republic Of',1),('00:01:99','Heisei Electronics','Heisei Electronics5/7 Alley 8, Lane 45Poaltsin Road Hsintien CityTaiwanTaiwan, Republic Of China',1),('00:01:9A','Leunig Gmbh','Leunig GmbhWilhelm-ostwald-str. 1753721 SiegburgGermanyGermany',1),('00:01:9B','Kyoto Microcomputer Co., Ltd.','Kyoto Microcomputer Co., Ltd.2-27 HachijogaokaNagaokakyo-city KyotoJapanJapan',1),('00:01:9C','Jds Uniphase Inc.','Jds Uniphase Inc.570 West Hunt Club RoadNapeon, On K1r 7t7CanadaCanada',1),('00:01:9D','E-control Systems, Inc.','E-control Systems, Inc.9420 Lurline Ave., UniteChatsworth Ca 91311United States',1),('00:01:9E','Ess Technology, Inc.','Ess Technology, Inc.48401 Fremont Blvd.Fremont Ca 94538United States',1),('00:01:9F','Phonex Broadband','Phonex Broadband6952 High Tech DriveMidvale Ut 84047United States',1),('00:01:A0','Infinilink Corporation','Infinilink Corporation1740 E. Garry Ave. - Ste. #206Santa Ana Ca 92705United States',1),('00:01:A1','Mag-tek, Inc.','Mag-tek, Inc.20725 South Annalee Ave.Carson Ca 90746United States',1),('00:01:A2','Logical Co., Ltd.','Logical Co., Ltd.4598 Murakushi-choHamamatsu-shi, Shizuoka-ken431-1207 JapanJapan',1),('00:01:A3','Genesys Logic, Inc.','Genesys Logic, Inc.10f, No. 11, Ln.3.,Tsao Ti Wei, Shenkeng TaipeiTaiwan, Republic Of China',1),('00:01:A4','Microlink Corporation','Microlink Corporation11110 Ohio Ave., - Ste. #108Los Angeles Ca 90034United States',1),('00:01:A5','Nextcomm, Inc.','Nextcomm, Inc.12413 Willows Road Ne - Ste. #210Kirkland Wa 98034United States',1),('00:01:A6','Scientific-atlanta Arcodan A/s','Scientific-atlanta Arcodan A/sAvgustenborg Landevej 7Dk-6400 SonderborgDenmarkDenmark',1),('00:01:A7','Unex Technology Corporation','Unex Technology Corporation8f-5, No. 130 Sze Wei RoadHsinchuTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:A8','Welltech Computer Co., Ltd.','Welltech Computer Co., Ltd.13f-4, No. 150, Jian Yi RoadChung-ho 235,  TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:A9','Bmw Ag','Bmw AgBmw Ag Dept. Fz-320Knorrstr.11980788 MunichGermany',1),('00:01:AA','Airspan Communications, Ltd.','Airspan Communications, Ltd.Cambridge House, Oxford Rd.,Uxbridge, Middlesex Ub1un,United KingdomUnited Kingdom',1),('00:01:AB','Main Street Networks','Main Street Networks4030 Moorpark Ave.Suite 200San Jose Ca 95117-1849United States',1),('00:01:AC','Sitara Networks, Inc.','Sitara Networks, Inc.60 Hickory DriveWaltham Ma 02451United States',1),('00:01:AD','Coach Master International  D.b.a. Cmi Worldwide, Inc.','Coach Master International  D.b.a. Cmi Worldwide, Inc.600 Stewart StreetSuite 700Seattle Wa 98101United States',1),('00:01:AE','Trex Enterprises','Trex Enterprises590 Lipoa ParkwaySuite 222Kihei Hi 96753United States',1),('00:01:AF','Emerson Network Power','Emerson Network Power2900 S. Diablo WaySuite 190Tempe Arizona 85282United States',1),('00:01:B0','Fulltek Technology Co., Ltd.','Fulltek Technology Co., Ltd.3f No. 8, Lane 130, Min Chuan Rd., HsintCity, Taipei Hsein 231,Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:B1','General Bandwidth','General Bandwidth12303-b Technology Blvd.Austin Tx 78727United States',1),('00:01:B2','Digital Processing Systems, Inc.','Digital Processing Systems, Inc.70 Valleywood DriveMarkham, Ontario CanadaL3r 4t5Canada',1),('00:01:B3','Precision Electronic Manufacturing','Precision Electronic ManufacturingP0187, P.o. 527948Miami Fl 33152-7948United States',1),('00:01:B4','Wayport, Inc.','Wayport, Inc.1609 Shoal Creek Blvd.Suite 301Austin Tx 78701United States',1),('00:01:B5','Turin Networks, Inc.','Turin Networks, Inc.1415 North Mcdowell Blvd.Petaluma Ca 94954United States',1),('00:01:B6','Saejin T&m Co., Ltd.','Saejin T&m Co., Ltd.2nd Fl., Saejin Bldg., 689Ilwon-dong, Kangnam-gu. Seoul, 135-230KoreaKorea, Republic Of',1),('00:01:B7','Centos, Inc.','Centos, Inc.6f-1, No. 15, Lane 360Nei-hu Rd., Sect. 1, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:B8','Netsensity, Inc.','Netsensity, Inc.15301 Dallas ParkwaySuite 760Addison Tx 75001United States',1),('00:01:B9','Skf Condition Monitoring','Skf Condition Monitoring4141 Ruffin RoadSan Diego Ca 92123United States',1),('00:01:BA','Ic-net, Inc.','Ic-net, Inc.5 Fl. Seasung Bldg., 311-27 Noryangjin-dDongjak-gu Seoul,KoreaKorea, Republic Of',1),('00:01:BB','Frequentis','FrequentisSpittelbreitengasse 34A-1120 ViennaAustriaAustria',1),('00:01:BC','Brains Corporation','Brains Corporation2-27-8-4fl TamagawaSetagaya-ku, Tokyo 158-0094JapanJapan',1),('00:01:BD','Peterson Electro-musical Products, Inc.','Peterson Electro-musical Products, Inc.11601 S. Mayfield AvenueAlsip Il 60803-2476United States',1),('00:01:BE','Gigalink Co., Ltd.','Gigalink Co., Ltd.6th F/l Diplomatic Center 1376-1Seocho-dong Seocho-ku SeoulKoreaKorea, Republic Of',1),('00:01:BF','Teleforce Co., Ltd.','Teleforce Co., Ltd.721 Yoshioka-cho Kanonji-cityKagawa-prf. 768-0021JapanJapan',1),('00:01:C0','Compulab, Ltd.','Compulab, Ltd.P.o. Box 66Nesher 36770IsraelIsrael',1),('00:01:C1','Vitesse Semiconductor Corporation','Vitesse Semiconductor CorporationHoerkaer 18Dk-2730 HerlevDenmark',1),('00:01:C2','Ark Research Corp.','Ark Research Corp.1198 Saratoga Ave. #11dSan Jose Ca 95129United States',1),('00:01:C3','Acromag, Inc.','Acromag, Inc.30765 S. Wixom RoadWixom Mi 48393United States',1),('00:01:C4','Neowave, Inc.','Neowave, Inc.10th Krihs Bldg. 1591-6Kwan Yang-dong, Dong An-gu, Anyong-si, KSouth KoreaKorea, Republic Of',1),('00:01:C5','Simpler Networks','Simpler Networks555 Dr Frederick PhilipsSuite 210 St. Laurent, Quebec CanadaH4m 2x4Canada',1),('00:01:C6','Quarry Technologies','Quarry Technologies8 New England Executive ParkBurlington Ma 01803United States',1),('00:01:C7','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:01:C8','Conrad Corp.','Conrad Corp.',1),('00:01:C9','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:01:CA','Geocast Network Systems, Inc.','Geocast Network Systems, Inc.190 Independence DriveMenlo Park Ca 94025United States',1),('00:01:CB','Evr','Evr12 Raul Wallenberg St.Tel Aviv  69719Israel',1),('00:01:CC','Japan Total Design Communication Co., Ltd.','Japan Total Design Communication Co., Ltd.Enesta Suginamihigashi Build., 3f,3-7-1, Asagayaminami Suginami-ku, TokyoJapanJapan',1),('00:01:CD','Artem','ArtemOlgastrasse 152D-89073 UlmGermanyGermany',1),('00:01:CE','Custom Micro Products, Ltd.','Custom Micro Products, Ltd.450 Blandford RoadHamworthy Poole Dorset Bhil 5bnUnited KingdomUnited Kingdom',1),('00:01:CF','Alpha Data Parallel Systems, Ltd.','Alpha Data Parallel Systems, Ltd.58 Timber BushEdinburgh Eh6 6qh ScotlandUnited KingdomUnited Kingdom',1),('00:01:D0','Vitalpoint, Inc.','Vitalpoint, Inc.15770 Hopper RoadPeyton Co 80831United States',1),('00:01:D1','Conet Communications, Inc.','Conet Communications, Inc.25 Mauchly, #320Irvine Ca 92618United States',1),('00:01:D2','Macpower Peripherals, Ltd.','Macpower Peripherals, Ltd.3fl, No.3, Alley 9, Lane 45,Baohsing Rd. Hsintien City, Taipei CountTaiwanTaiwan, Republic Of China',1),('00:01:D3','Paxcomm, Inc.','Paxcomm, Inc.7th F The Corp. CenterChungnam National University 220 Kung-doKoreaKorea, Republic Of',1),('00:01:D4','Leisure Time, Inc.','Leisure Time, Inc.4258 Communications DriveNorcross Ga 30093United States',1),('00:01:D5','Haedong Info & Comm Co., Ltd','Haedong Info & Comm Co., Ltd#801 The Corporation Center For Universi220 Kung-dong, Yuseong-gu,Taejeon Republic Of Korea 305Korea, Republic Of',1),('00:01:D6','Manroland Ag','Manroland AgStadtbachstrasse 186219 AugsburgGermany',1),('00:01:D7','F5 Networks, Inc.','F5 Networks, Inc.1322 N. Whitman LaneLiberty Lake Wa 99019United States',1),('00:01:D8','Teltronics, Inc.','Teltronics, Inc.4125 Keller Springs RoadSuite 166Addison Tx 25001United States',1),('00:01:D9','Sigma, Inc.','Sigma, Inc.32-3 Seijyo 9 ChomeSetagaya-ku Tokyo 157-0066JapanJapan',1),('00:01:DA','Wincomm Corporation','Wincomm Corporation2f, No. 3, Prosperity Road 1,Science-based Industrial Park, Hsinchu,Hsinchu TaiwanTaiwan, Republic Of China',1),('00:01:DB','Freecom Technologies Gmbh','Freecom Technologies GmbhObentrautstr. 72D-10963, Berlin,Germany',1),('00:01:DC','Activetelco','Activetelco43222 Christy StreetFremont Ca 94538United States',1),('00:01:DD','Avail Networks','Avail Networks305 E. Eisenhower ParkwayAnn Arbor Mi 48108United States',1),('00:01:DE','Trango Systems, Inc.','Trango Systems, Inc.9939 V/a PasarSan Diego Ca 92126United States',1),('00:01:DF','Isdn Communications, Ltd.','Isdn Communications, Ltd.The Stable Block, RonansChavey Down Road, Winkfield Row BerkshirEnglandUnited Kingdom',1),('00:01:E0','Fast Systems, Inc.','Fast Systems, Inc.87-9 Yang-jae, Seo-cho,Seoul,KoreaKorea, Republic Of',1),('00:01:E1','Kinpo Electronics, Inc.','Kinpo Electronics, Inc.Tsac Ti Wei, Wan Shun Tsun,Shen Keng Hsiang, Taipei Hsien Taiwan (2ChinaTaiwan, Republic Of China',1),('00:01:E2','Ando Electric Corporation','Ando Electric Corporation19-7, Kamata 4-chrome, Ota-kuTokyo, 144-0052JapanJapan',1),('00:01:E3','Siemens Ag','Siemens AgSchlavenhorst 8846395 BocholtGermanyGermany',1),('00:01:E4','Sitera, Inc.','Sitera, Inc.1820 Lefthand CircleLongmont Co 80501United States',1),('00:01:E5','Supernet, Inc.','Supernet, Inc.135-080 Daemeong Bldg.2nd Floor, 650-2, Yeoksam-dong Kangnam-kKoreaKorea, Republic Of',1),('00:01:E6','Hewlett-packard Company','Hewlett-packard Company11000 Wolfe Road, Mailstop 42leCupertino Ca 95014United States',1),('00:01:E7','Hewlett-packard Company','Hewlett-packard Company11000 Wolfe Road, Mailstop 42leCupertino Ca 95014United States',1),('00:01:E8','Force10 Networks, Inc.','Force10 Networks, Inc.1440 Mccarthy Blvd.Milpitas Ca 95035United States',1),('00:01:E9','Litton Marine Systems B.v.','Litton Marine Systems B.v.118 Burlington RoadNew Malden, SurreyEngland Kt3 4nrUnited Kingdom',1),('00:01:EA','Cirilium Corp.','Cirilium Corp.1615 S. 52nd StreetTempe Az 85281United States',1),('00:01:EB','C-com Corporation','C-com Corporation3f, No. 48, Park Ave. Ii SbipHsinchu Taiwan Hsinchu Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:EC','Ericsson Group','Ericsson GroupTelefonaktiebolagetLm Ericsson Corp. 126 25 StockholmSwedenSweden',1),('00:01:ED','Seta Corp.','Seta Corp.Ariake Frontier Bldg. BAriake, Koutou Ku Tokyo,Japan 135-0063Japan',1),('00:01:EE','Comtrol Europe, Ltd.','Comtrol Europe, Ltd.The Courtyard StudioGrange Farm, Station Road Launton Oxon OU.k.United Kingdom',1),('00:01:EF','Camtel Technology Corp.','Camtel Technology Corp.No. 2, Wu-kung 5 Rd., Wu-kuInd. Park, Hsinchuang, Taipei ShienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:01:F0','Tridium, Inc.','Tridium, Inc.3951 Westerre ParkwaySuite 350Richmond Va 23233United States',1),('00:01:F1','Innovative Concepts, Inc.','Innovative Concepts, Inc.8200 Greensboro DriveSuite 801Mclean Va 22102United States',1),('00:01:F2','Mark Of The Unicorn, Inc.','Mark Of The Unicorn, Inc.1280 Massachusetts Ave.Cambridge Ma 02138United States',1),('00:01:F3','Qps, Inc.','Qps, Inc.8015 E. Crystal DriveAnaheim Ca 92807United States',1),('00:01:F4','Enterasys Networks','Enterasys Networks35 Industrial WayRochester Nh 03867United States',1),('00:01:F5','Erim S.a.','Erim S.a.11 Av Republique69692 Venissieux CedexFranceFrance',1),('00:01:F6','Association Of Musical Electronics Industry','Association Of Musical Electronics IndustryIto Bldg. 4th Floor 2-16-9 Misaki-cho,Chiyoda-ku, Tokyo, 101-0061JapanJapan',1),('00:01:F7','Image Display Systems, Inc.','Image Display Systems, Inc.46560 Fremont Blvd.Suite #406Fremont Ca 94538United States',1),('00:01:F8','Adherent Systems, Ltd.','Adherent Systems, Ltd.Endeavour House, Vision ParkHiston Cambridge Cb4 4zrUnited KingdomUnited Kingdom',1),('00:01:F9','Teraglobal Communications Corp.','Teraglobal Communications Corp.9171 Towne Centre DriveSuite #600San Diego Ca 92122United States',1),('00:01:FA','Horoscas','Horoscas26, Louis Blanc69006 LyonFranceFrance',1),('00:01:FB','Dotop Technology, Inc.','Dotop Technology, Inc.10f, No. 100, Min-chyuan RoadHsin-tien, TaipeiTaiwanTaiwan, Republic Of China',1),('00:01:FC','Keyence Corporation','Keyence Corporation1-3-14, Higashi-nakajima,Higashi-yodogawa-ku Osaka 533-8555JapanJapan',1),('00:01:FD','Digital Voice Systems, Inc.','Digital Voice Systems, Inc.234 Littleton RoadWestford Ma 01886United States',1),('00:01:FE','Digital Equipment Corporation','Digital Equipment CorporationM/s Cx01-2/n26301 Rockrimmon Blvd., SColorado Springs Co 80919United States',1),('00:01:FF','Data Direct Networks, Inc.','Data Direct Networks, Inc.9320 Lurline AvenueChatsworth Ca 91311United States',1),('00:02:00','Net & Sys Co., Ltd.','Net & Sys Co., Ltd.Kuro Hitech Industrial Complex 304,402-3, Shindorim-dong, Kuro-gu Seoul,KoreaKorea, Republic Of',1),('00:02:01','Ifm Electronic Gmbh','Ifm Electronic GmbhBechlingen 34D-88069 TettnangGermanyGermany',1),('00:02:02','Amino Communications, Ltd.','Amino Communications, Ltd.Times HouseFen End Willingham, CambridgeUk Cb4 5lhUnited Kingdom',1),('00:02:03','Woonsang Telecom, Inc.','Woonsang Telecom, Inc.104-9, Munji-dong, Yusong-guTaejon, 305-380,KoreaKorea, Republic Of',1),('00:02:04','Bodmann Industries Elektronik Gmbh','Bodmann Industries Elektronik GmbhMesserschmittring 33D-86343 KonigsbrunnGermanyGermany',1),('00:02:05','Hitachi Denshi, Ltd.','Hitachi Denshi, Ltd.32 Miyaki-cho Kodaira-shiToyko,Japan 187-8511Japan',1),('00:02:06','Telital R&d Denmark A/s','Telital R&d Denmark A/s9530 StouringDenmarkDenmark',1),('00:02:07','Visionglobal Network Corp.','Visionglobal Network Corp.826 E. Stale RoadSuite 200American Fork Ut 84003United States',1),('00:02:08','Unify Networks, Inc.','Unify Networks, Inc.3160 De La Cruz Blvd.#201Santa Clara Ca 95054United States',1),('00:02:09','Shenzhen Sed Information Technology Co., Ltd.','Shenzhen Sed Information Technology Co., Ltd.4/f., West Block, Block 414, Zhenhua Rd.Futian Shenzhen, 518031 P.r.ChinaChina',1),('00:02:0A','Gefran Spa','Gefran SpaVia Sebina, 74Provaglio Diseo 25050 BresciaItalyItaly',1),('00:02:0B','Native Networks, Inc.','Native Networks, Inc.P.o. Box 7165Petah Tikva 49170IsraelIsrael',1),('00:02:0C','Metro-optix','Metro-optix2201 Avenue KPlano Tx 75074United States',1),('00:02:0D','Micronpc.com','Micronpc.com900 E. Karcher Rd.Nampa Ia 83687United States',1),('00:02:0E','Eci Telecom, Ltd., Nsd-us','Eci Telecom, Ltd., Nsd-us1300 Omega Dr.Pittsburgh Pa 15205United States',1),('00:02:0F','Aatr','Aatr306 Chemin Des Miroirs13330 PelissanneFranceFrance',1),('00:02:10','Fenecom','Fenecom7/f Kon-kuk University AlumniAssociation Building No:  227-336 JayangSeoul Seoul KoreaKorea, Republic Of',1),('00:02:11','Nature Worldwide Technology Corp.','Nature Worldwide Technology Corp.No. 1, Min-chuan StreetTu-cheng Industrial Park Taipei Hsien,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:12','Sierracom','Sierracom99 South StreetHopkinton Ma 01748United States',1),('00:02:13','S.d.e.l.','S.d.e.l.Aeropole D2aRue Nungerrer Et Coli 44860 St Aignan DeFranceFrance',1),('00:02:14','Dtvro','Dtvro813 Daegong Bldg.,823-21 Yeoksam-dong, Kangnam-gu, Seoul,Korea Korea 135-080Korea, Republic Of',1),('00:02:15','Cotas Computer Technology A/b','Cotas Computer Technology A/bPaludan-mullers Vej 82Dk-8200 Aarhus NDenmarkDenmark',1),('00:02:16','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:02:17','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:02:18','Advanced Scientific Corp','Advanced Scientific Corp1 Fl., No. 26, Industry East 9th RoadScience-based Industrial Park Hsin-chuTaiwanTaiwan, Republic Of China',1),('00:02:19','Paralon Technologies','Paralon Technologies700 Fifth Ave, Suite 6101Seattle Wa 98104United States',1),('00:02:1A','Zuma Networks','Zuma Networks8403 Fallbrook Ave.West Hills Ca 91304United States',1),('00:02:1B','Kollmorgen-servotronix','Kollmorgen-servotronixPob 3919, Petach Tikya49130 IsraelIsrael',1),('00:02:1C','Network Elements, Inc.','Network Elements, Inc.9782 Sw Nimbus AvenueBeaverton Or 97008United States',1),('00:02:1D','Data General Communication Ltd.','Data General Communication Ltd.Rm. 18c, Bldg. C, Ceiec TowerNo. 2070, Rd. Shennanzhong Shenzhen CityChinaChina',1),('00:02:1E','Simtel S.r.l.','Simtel S.r.l.Via Bonifacio Lupi, 2550129 FirenzeItalyItaly',1),('00:02:1F','Aculab Plc','Aculab PlcLakeside, Bramley RoadMount Farm Milton Keynes Bulks Mk1 1ptUkUnited Kingdom',1),('00:02:20','Canon Aptex, Inc.','Canon Aptex, Inc.5-15, Shimomaruko 2-chrome, Ota-kuTokyo 156-0092JapanJapan',1),('00:02:21','Dsp Application, Ltd.','Dsp Application, Ltd.12f-12, No. 79, Sec. 1 Hsin Tai Wu Rd.Hsichi, Taipei CountyTaiwanTaiwan, Republic Of China',1),('00:02:22','Chromisys, Inc.','Chromisys, Inc.1012 Stewart DriveSunnyvale Ca 94086United States',1),('00:02:23','Clicktv','ClicktvKemong Bldg., 4th Fl.,772 Yoksam-dong Kangnam-kuSeoul Korea 135-010Korea, Republic Of',1),('00:02:24','C-cor','C-cor15 Sterling DriveWallingford Ct 06492United States',1),('00:02:25','One Stop Systems','One Stop Systems2235 Enterprise StreetSuite 110Escondido Ca 92029United States',1),('00:02:26','Xesystems, Inc.','Xesystems, Inc.317 Main StreetEast Rochester Ny 14445United States',1),('00:02:27','Esd Electronic System Design Gmbh','Esd Electronic System Design GmbhVahrenwalder Str. 20730 165 Hannover GermanyGermany',1),('00:02:28','Necsom, Ltd.','Necsom, Ltd.Necsom Ltd. C/o KoirstoSaunamaentie 4 A 1 Fin-02770 Esp00FinlandFinland',1),('00:02:29','Adtec Corporation','Adtec Corporation3f Megurohigashiyama Blg1 4 4 Higashiyama, Meguro Ku Tokyo 153 0JapanJapan',1),('00:02:2A','Asound Electronic','Asound ElectronicXianxi Industries Zone Changan TownDong Guon City, Guong Dong ProvidenceChinaChina',1),('00:02:2B','Saxa, Inc.','Saxa, Inc.13f Nbf Platinum Tower 17-3Shirogane 1-chomeMinato-ku TokyoJapan',1),('00:02:2C','Abb Bomem, Inc.','Abb Bomem, Inc.585, Boul. Charest EstSuite 300 Quebec City, PqCanada G1k 9h4Canada',1),('00:02:2D','Agere Systems','Agere SystemsP.o. Box 7553430 At NieuwegeinNetherlands',1),('00:02:2E','Teac Corp. R& D','Teac Corp. R& D857 Koyata, IrumaSaitamaJapanJapan',1),('00:02:2F','P-cube, Ltd.','P-cube, Ltd.P.o. Box 12331Herzlia 46766IsraelIsrael',1),('00:02:30','Intersoft Electronics','Intersoft ElectronicsLammerdries 27B2250 OlenBelgiumBelgium',1),('00:02:31','Ingersoll-rand','Ingersoll-rand1467 Route 31 SouthP.o. Box 970Annandale Nj 08801United States',1),('00:02:32','Avision, Inc.','Avision, Inc.No. 20, Creation Rd. 1,Science-based Industrial Park,Hsinchu Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:02:33','Mantra Communications, Inc.','Mantra Communications, Inc.12850 Middlebrook RoadSuite 1Germantown Md 20874United States',1),('00:02:34','Imperial Technology, Inc.','Imperial Technology, Inc.2305 Utah AvenueEl Segundo Ca 90245United States',1),('00:02:35','Paragon Networks International','Paragon Networks International61 Commerce DriveBrookfield Ct 06804United States',1),('00:02:36','Init Gmbh','Init GmbhKaeppelestr. 6D-76131 KarlsruheGermanyGermany',1),('00:02:37','Cosmo Research Corp.','Cosmo Research Corp.Cosmo Bldg, 3-148-5Miyaharacho, Omiya Saitama 330-0038JapanJapan',1),('00:02:38','Serome Technology, Inc.','Serome Technology, Inc.555-14, Baekang B/d 7fShinsa-dong, Kangnam-guSeoul Korea 135-120Korea, Republic Of',1),('00:02:39','Visicom','Visicom10052 Mesa Ridge Ct.San Diego Ca 92121United States',1),('00:02:3A','Zsk Stickmaschinen Gmbh','Zsk Stickmaschinen GmbhMagdeburger Strasse 38-4047800 KrefeldGermanyGermany',1),('00:02:3B','Redback Networks','Redback Networks1195 Borregas AvenueSunnyvale Ca 94089United States',1),('00:02:3C','Creative Technology, Ltd.','Creative Technology, Ltd.31 International Business ParkSingapore 609921Republic Of SingaporeSingapore',1),('00:02:3D','Nuspeed, Inc.','Nuspeed, Inc.7767 Elm Creek Blvd., Ste 300Maple Grove Mn 55369United States',1),('00:02:3E','Selta Telematica S.p.a','Selta Telematica S.p.aVia Nazionale Km 404.564019 Tortoreto Lido TeItalyItaly',1),('00:02:3F','Compal Electronics, Inc.','Compal Electronics, Inc.581, Juikuang Rd.,Neihu, Taipei, (114)Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:40','Seedek Co., Ltd.','Seedek Co., Ltd.#709, 1638-32, SammoShinrimbon-dong, Kwanak-gu, SeoulKoreaKorea, Republic Of',1),('00:02:41','Amer.com','Amer.com7259 Bryan Dairy RoadLargo Fl 33777United States',1),('00:02:42','Videoframe Systems','Videoframe Systems101 Providence Mine RoadSuite 103Nevada City Ca 95959United States',1),('00:02:43','Raysis Co., Ltd.','Raysis Co., Ltd.997-10, Daechi-dong, Kangnam-ku,Seoul 135-280, South KoreaKorea, Republic Of',1),('00:02:44','Surecom Technology Co.','Surecom Technology Co.6f, No. 125, Sec. 2, Datung Rd.Shijr, Taipei County, 221Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:45','Lampus Co, Ltd.','Lampus Co, Ltd.6th Bldg., Samgong,58-7 Ranpo 4dong Scoch-go, Seoul,Korea Korea 137-044Korea, Republic Of',1),('00:02:46','All-win Tech Co., Ltd.','All-win Tech Co., Ltd.11f, No. 111-7, Hsing De Rd.,San Chung City,Taipei Hsien Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:02:47','Great Dragon Information Technology (group) Co., Ltd.','Great Dragon Information Technology (group) Co., Ltd.169 Beiyuan Rd.,Chaoyang DistrictBeijing 100101, ChinaChina',1),('00:02:48','Pilz Gmbh & Co.','Pilz Gmbh & Co.Felix-wankel-strasse 2D-73760 OstfildernGermanyGermany',1),('00:02:49','Aviv Infocom Co, Ltd.','Aviv Infocom Co, Ltd.962-5, Kwanyang-dong, Dongan-gu,Anyang-city, Kyungki-do, 431-060Korea (rok)Korea, Republic Of',1),('00:02:4A','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:4B','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:4C','Sibyte, Inc.','Sibyte, Inc.2805 Bowers AvenueSanta Clara Ca 95051-0917United States',1),('00:02:4D','Mannesman Dematic Colby Pty. Ltd.','Mannesman Dematic Colby Pty. Ltd.24 Narabang WayBelrose, Nsw 2085AustraliaAustralia',1),('00:02:4E','Datacard Group','Datacard Group11111 Bren Road WestMs 210Minnetonka Mn 55343United States',1),('00:02:4F','Ipm Datacom S.r.l.','Ipm Datacom S.r.l.Via Roma, 23180027 FrattamaggioreNaples ItalyItaly',1),('00:02:50','Geyser Networks, Inc.','Geyser Networks, Inc.535 Del Rey AvenueSunnyvale Ca 94086United States',1),('00:02:51','Soma Networks, Inc.','Soma Networks, Inc.185 Berry StreetSuite 2000San Francisco Ca 94107United States',1),('00:02:52','Carrier Corporation','Carrier CorporationOne Carrier PlaceFarmington Ct 06034-4015United States',1),('00:02:53','Televideo, Inc.','Televideo, Inc.2345 Harris WaySan Jose Ca 95131United States',1),('00:02:54','Worldgate','Worldgate3190 Tremont AvenueTrevose Pa 19053United States',1),('00:02:55','Ibm Corporation','Ibm Corporation3039 Cornwallis Road, Ibm Raleigh (rtp)P.o. Box 12195Raleigh (rtp) Nc 27709-2195United States',1),('00:02:56','Alpha Processor, Inc.','Alpha Processor, Inc.130 C Baker Ave. Ext.Concord Ma 01742United States',1),('00:02:57','Microcom Corp.','Microcom Corp.8333a Green Meadows Dr. N.Westerville Oh 43081United States',1),('00:02:58','Flying Packets Communications','Flying Packets Communications388 Market StreetSuite 380San Francisco Ca 94111United States',1),('00:02:59','Tsann Kuen China (shanghai)enterprise Co., Ltd. It Group','Tsann Kuen China (shanghai)enterprise Co., Ltd. It Group8f, #99, Huaihai Rd, East,Shanghai,China 200021China',1),('00:02:5A','Catena Networks','Catena Networks307 Legget DriveKanata OntarioCanada K2k 3c8Canada',1),('00:02:5B','Cambridge Silicon Radio','Cambridge Silicon RadioUnit 400, Science Park,Milton Road, Cambridge,cb4 OxlUnited KingdomUnited Kingdom',1),('00:02:5C','Sci Systems (kunshan) Co., Ltd.','Sci Systems (kunshan) Co., Ltd.312 Qing Yang RoadKunshan, Jiangsu ProviccChina China 215300China',1),('00:02:5D','Calix Networks','Calix Networks1035 North Mcdowell Blvd.Petaluma Ca 94954United States',1),('00:02:5E','High Technology Ltd','High Technology LtdChongqing JinghongA2-10-3 California Garden Yubei DistrictPeoples Republic Of ChinaChina',1),('00:02:5F','Nortel Networks','Nortel Networks9300 Trans-canada HighwaySt. Laurenet, QuebecH4s 1ks CanadaCanada',1),('00:02:60','Accordion Networks, Inc.','Accordion Networks, Inc.39899 Balentine Drive, #335Newark Ca 94560United States',1),('00:02:61','Tilgin Ab','Tilgin AbFinlandsgatan 40Se-164 74 KistaSweden',1),('00:02:62','Soyo Group Soyo Com Tech Co., Ltd','Soyo Group Soyo Com Tech Co., Ltd5h. No. 21 Wu-gong 5 Rd,Hsing Chuang,Taipei Hsien Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:63','Ups Manufacturing Srl','Ups Manufacturing SrlVia Giordano, 5437050 Vallese Di OppeanoVerona ItalyItaly',1),('00:02:64','Audioramp.com','Audioramp.com15941 Red Hill Suite 205Tustin Ca 92780United States',1),('00:02:65','Virditech Co. Ltd.','Virditech Co. Ltd.Hyundai Topics Blgd., 11th Fl44-3 Pangi-dong, Songpa-guSeoul Seoul KoreaKorea, Republic Of',1),('00:02:66','Thermalogic Corporation','Thermalogic Corporation22 Kane Industrial DriveHudson Ma 01749United States',1),('00:02:67','Node Runner, Inc.','Node Runner, Inc.2202 N. Forbes Blvd.Tucson Az 85745United States',1),('00:02:68','Harris Government Communications','Harris Government CommunicationsSystems DivisionP.o. Box 37 Ms: 1-5856Melbourne Fl 32902United States',1),('00:02:69','Nadatel Co., Ltd','Nadatel Co., Ltd9f Cowell Bldg, 66-1 Banpo-dongSeocho-gu, Seoul,Korea 137-040Korea, Republic Of',1),('00:02:6A','Cocess Telecom Co., Ltd.','Cocess Telecom Co., Ltd.Research & Development Dept.43, Yoido-dong, Youngdeungpo-kuSeoul Seoul KoreaKorea, Republic Of',1),('00:02:6B','Bcm Computers Co., Ltd.','Bcm Computers Co., Ltd.4f-1, No. 66, Sec 2,Nan Kan Rd., Lu-chu Hsing, Tao YuanTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:6C','Philips Cft','Philips CftBuilding San 6P.o. Box 218 5600 Md EindhovenThe NetherlandsNetherlands',1),('00:02:6D','Adept Telecom','Adept TelecomAvenue De LeuropeBp 161 F-71204 Le Creusot CedexFranceFrance',1),('00:02:6E','Negen Access, Inc.','Negen Access, Inc.33 Boston Post Rd. WestSuite 360Marlborough Ma 01752United States',1),('00:02:6F','Senao International Co., Ltd.','Senao International Co., Ltd.2f, No. 531, Chung-cheng Rd.,Hsin-tien City, Taipei County,TaiwanTaiwan, Republic Of China',1),('00:02:70','Crewave Co., Ltd.','Crewave Co., Ltd.F7, Pureun Bldg., 28-1Jamwon-dong, Seocho-guSeoul Korea 137-030Korea, Republic Of',1),('00:02:71','Vpacket Communications','Vpacket Communications1390 Mccarthy Blvd.Milpitas Ca 95035United States',1),('00:02:72','Cc&c Technologies, Inc.','Cc&c Technologies, Inc.8f, 150, Chien I Rd., Chung Ho City,Taipei County 235 Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:73','Coriolis Networks','Coriolis Networks330 Codmanhill RoadBoxborough Ma 01719United States',1),('00:02:74','Tommy Technologies Corp.','Tommy Technologies Corp.#407 Heehoon Bld110-1 Kuro-dong, Kuro-kuSeoul Seoul KoreaKorea, Republic Of',1),('00:02:75','Smart Technologies, Inc.','Smart Technologies, Inc.#600, 1177 11 Ave. S.w.Calgary, AlbertaCanada T2r 1k9Canada',1),('00:02:76','Primax Electronics Ltd.','Primax Electronics Ltd.No. 669, Ruey Kuang Road, NeihuTaipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:02:77','Cash Systemes Industrie','Cash Systemes IndustrieTechnoparc EpsilonRd 100 83700 St RaphaelFranceFrance',1),('00:02:78','Samsung Electro-mechanics Co., Ltd.','Samsung Electro-mechanics Co., Ltd.314, Mae-tan-dong,Pai-dal-gu, Kyoung-gi-do,Suwon Suwon KoreaKorea, Republic Of',1),('00:02:79','Control Applications, Ltd.','Control Applications, Ltd.3 Tevuot Haarets St.Tel-aviv 69546IsraelIsrael',1),('00:02:7A','Ioi Technology Corporation','Ioi Technology Corporation4f-3 No. 125 Lane 235,Pao Chiao Road Hsin Tien City,Taipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:02:7B','Amplify Net, Inc.','Amplify Net, Inc.47381 Bayside ParkwayFremont Ca 94538United States',1),('00:02:7C','Trilithic, Inc.','Trilithic, Inc.9202 E. 33rd StreetIndianapolis In 46235United States',1),('00:02:7D','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:7E','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:7F','Ask-technologies.com','Ask-technologies.com36 Wellington Business ParkDukes Ride, Crowthorne Berkshire Rg45 6lUnited Kingdom',1),('00:02:80','Mu Net, Inc.','Mu Net, Inc.442 Marrett RoadSuite 9Lexington Ma 02421United States',1),('00:02:81','Madge Ltd.','Madge Ltd.Madge HousePriors WayMaindenhead Berkshire Sl6 2hpUnited Kingdom',1),('00:02:82','Viaclix, Inc.','Viaclix, Inc.1400 Dell Ave., Suite BCampbell Ca 95008United States',1),('00:02:83','Spectrum Controls, Inc.','Spectrum Controls, Inc.Po Box 5533Bellevue Wa 98006United States',1),('00:02:84','Areva T&d','Areva T&dAvenue De Figuieres Bp 7534975 Lattes CedexFrance',1),('00:02:85','Riverstone Networks','Riverstone Networks5200 Great America ParkwaySanta Clara Ca 95054United States',1),('00:02:86','Occam Networks','Occam Networks4183 State StreetSanta Barbara Ca 93110United States',1),('00:02:87','Adapcom','Adapcom172-a Component DriveSan Jose Ca 95131United States',1),('00:02:88','Global Village Communication','Global Village Communication1144 East Arques Ave.Sunnyvale Ca 94086United States',1),('00:02:89','Dne Technologies','Dne Technologies50 Barnes Park NWallingford Ct 06492United States',1),('00:02:8A','Ambit Microsystems Corporation','Ambit Microsystems Corporation5f-1, 5 Hsin-an Road Hsinchu,Science Based Industrial Park,TaiwanTaiwan, Republic Of China',1),('00:02:8B','Vdsl Systems Oy','Vdsl Systems OyTekniikantie 1202 150 EspooFinlandFinland',1),('00:02:8C','Micrel-synergy Semiconductor','Micrel-synergy Semiconductor3250 Scott BoulevardSanta Clara Ca 95054United States',1),('00:02:8D','Movita Technologies, Inc.','Movita Technologies, Inc.No. 26 Wu-chuan 7th Road,Wu-ku Industrial ParkTaipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:02:8E','Rapid 5 Networks, Inc.','Rapid 5 Networks, Inc.180 Baytech DriveSan Jose Ca 95134-2302United States',1),('00:02:8F','Globetek, Inc.','Globetek, Inc.1607 Akron Peninsula Rd.Suite 103Akron Oh 44313-5190United States',1),('00:02:90','Woorigisool, Inc.','Woorigisool, Inc.Yoopoong Bldg.1595-1, Bongchum-7dong,Seoul Seoul KoreaKorea, Republic Of',1),('00:02:91','Open Network Co., Ltd.','Open Network Co., Ltd.Seishin Bldg., 2-5-10 ShinjukuShinjuku-ku, TokyoJapan 160-0022Japan',1),('00:02:92','Logic Innovations, Inc.','Logic Innovations, Inc.6205 Lusk Blvd.San Diego Ca 92121-2731United States',1),('00:02:93','Solid Data Systems','Solid Data Systems2945 Oakmead Village CourtSanta Clara Ca 95051United States',1),('00:02:94','Tokyo Sokushin Co., Ltd.','Tokyo Sokushin Co., Ltd.5-16-12 Nishi-nipporiArakawa-ku, Tokyo 116-0013JapanJapan',1),('00:02:95','Ip.access Limited','Ip.access LimitedMelbourn Science ParkCambridge Road, Melbourn Royston, HartfoSg8 6ee Sg8 6ee U.k.United Kingdom',1),('00:02:96','Lectron Co,. Ltd.','Lectron Co,. Ltd.9f, No.171, Sec. 2, Tatung Rd.,Hsichih City, Taipei Hsien 221,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:97','C-cor.net','C-cor.net60 Decibel RoadBms EngineeringState College Pa 16801United States',1),('00:02:98','Broadframe Corporation','Broadframe Corporation5828 Moonstone Ave.Suite 220Alta Loma Ca 91701United States',1),('00:02:99','Apex, Inc.','Apex, Inc.9911 Willows Rd. N.e.Redmond Wa 95052United States',1),('00:02:9A','Storage Apps','Storage Apps3 Princess RoadLawrenceville Nj 08648United States',1),('00:02:9B','Kreatel Communications Ab','Kreatel Communications AbTeknikringen 4cSe-58330 LinkopingSwedenSweden',1),('00:02:9C','3com','3com405 Spring Hill RoadSharon Nh 03458United States',1),('00:02:9D','Merix Corp.','Merix Corp.Jin-su Building, 49-16Machum-dong, Song-pa-kuSeoul Seoul KoreaKorea, Republic Of',1),('00:02:9E','Information Equipment Co., Ltd.','Information Equipment Co., Ltd.740-1 Eaho Bldg., Yeok Sam-dongKangnam-kuSeoul Korea #135-080Korea, Republic Of',1),('00:02:9F','L-3 Communication Aviation Recorders','L-3 Communication Aviation RecordersP.o. Box 3041Sarasota Fl 34230United States',1),('00:02:A0','Flatstack Ltd.','Flatstack Ltd.1112 BudapestPeterhegyi Ut 98HungaryHungary',1),('00:02:A1','World Wide Packets','World Wide PacketsPo Box 14645Spokane Wa 99214United States',1),('00:02:A2','Hilscher Gmbh','Hilscher GmbhRheinstrae 1565795 HattersheimGermanyGermany',1),('00:02:A3','Abb Power Automation','Abb Power AutomationBahnhofstrasseCh-5300 TurgiSwitzerland',1),('00:02:A4','Addpac Technology Co., Ltd.','Addpac Technology Co., Ltd.3f Jeoung Am Bldg., 769-12Yeoksam-dong, Kangnam-gu,Seoul Seoul KoreaKorea, Republic Of',1),('00:02:A5','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:02:A6','Effinet Systems Co., Ltd.','Effinet Systems Co., Ltd.Yugong Bldg. 5021144-1, Sanbon-dong Kunpo-shi, Kyonggi-dKoreaKorea, Republic Of',1),('00:02:A7','Vivace Networks','Vivace Networks2730 Orchard ParkwaySan Jose Ca 95134United States',1),('00:02:A8','Air Link Technology','Air Link TechnologyBethel Bldg. 303324-1 Yangjee-dong, Seocho-guSeoul Korea 137-130Korea, Republic Of',1),('00:02:A9','Racom, S.r.o.','Racom, S.r.o.Mirova 1283, Nove Mesto Na Morave592 31 Czech RepublicCzech Republic',1),('00:02:AA','Plcom Co., Ltd.','Plcom Co., Ltd.Hosung B/d, #1083-1, Hogye-dongDongan-ku, Anyang-citySouth KoreaKorea, Republic Of',1),('00:02:AB','Ctc Union Technologies Co., Ltd.','Ctc Union Technologies Co., Ltd.8f No. 60 Zhouzi St.Neihu Taipei 114Taiwan, Republic Of China',1),('00:02:AC','3par Data','3par Data4209 Technology DriveFremont Ca 94538United States',1),('00:02:AD','Hoya Corporation','Hoya Corporation2-7-5 Naka-ochiai, Shinjuku-ku,Tokyo 161-8525Japan',1),('00:02:AE','Scannex Electronics Ltd.','Scannex Electronics Ltd.Unit 8 English Business ParkEnglish CloseHove  Bn3 7etUnited Kingdom',1),('00:02:AF','Telecruz Technology, Inc.','Telecruz Technology, Inc.2391 Qume Dr.San Jose Ca 95131United States',1),('00:02:B0','Hokubu Communication & Industrial Co., Ltd.','Hokubu Communication & Industrial Co., Ltd.Fushiogami-aza-oki 27-1Fukushima  960-8514Japan',1),('00:02:B1','Anritsu, Ltd.','Anritsu, Ltd.Rutherford CloseStevenage, Herts England, Sg12efUnited KingdomUnited Kingdom',1),('00:02:B2','Cablevision','Cablevision420 Crossways Park Drive WestWoodbury Ny 11787United States',1),('00:02:B3','Intel Corporation','Intel CorporationM/s:  Jf3-4202111 N.e. 25th Ave.Hillsboro Or 97124United States',1),('00:02:B4','Daphne','Daphne101 Chaussee De Binche7000 HonsBelgiumBelgium',1),('00:02:B5','Avnet, Inc.','Avnet, Inc.2211 S. 47th StreetPhoenix Az 85034United States',1),('00:02:B6','Acrosser Technology Co., Ltd.','Acrosser Technology Co., Ltd.No. 116-2 Guang-fu Rd.Sea 1, San Chung,Taipei Taipei R.o.c.Taiwan, Republic Of China',1),('00:02:B7','Watanabe Electric Industry Co., Ltd.','Watanabe Electric Industry Co., Ltd.6-16-19, Jingumae, Shibuya-kuTokyo 150-0001,JapanJapan',1),('00:02:B8','Whi Konsult Ab','Whi Konsult AbScheelegatan 1112040 ArstaStockholm Se-112 28Sweden',1),('00:02:B9','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:BA','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:BB','Continuous Computing Corp','Continuous Computing Corp9380 Carroll Park DriveSan Diego Ca 92121United States',1),('00:02:BC','Lvl 7 Systems, Inc.','Lvl 7 Systems, Inc.13000 Weston PkwySuite 105Cary Nc 27513United States',1),('00:02:BD','Bionet Co., Ltd.','Bionet Co., Ltd.3f, Medison Venture Tower,997-4, Daechi-dong, Kangnam-gu, Seoul,KoreaKorea, Republic Of',1),('00:02:BE','Totsu Engineering, Inc.','Totsu Engineering, Inc.5-16-20 Roppongi Minato-kuZip:  106-0032Tokyo  106-8551Japan',1),('00:02:BF','Dotrocket, Inc.','Dotrocket, Inc.1901 S. Bascom, Suite 300Campbell Ca 95008United States',1),('00:02:C0','Bencent Tzeng Industry Co., Ltd.','Bencent Tzeng Industry Co., Ltd.3rd Fl., No. 3 Ruey Kuang Rd.,Nei Hu Dist., Taipei 114Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:02:C1','Innovative Electronic Designs, Inc.','Innovative Electronic Designs, Inc.9701 Taylorsville Rd.Louisville Ky 40299United States',1),('00:02:C2','Net Vision Telecom','Net Vision Telecom#206 Software Support Center48 Jang-dong Yusong-gu, Taejon305-343 Rep. Of KoreaKorea, Republic Of',1),('00:02:C3','Arelnet Ltd.','Arelnet Ltd.3 Hayarden St.Yavne 70600IsraelIsrael',1),('00:02:C4','Vector International Bvba','Vector International BvbaTechnologielaan 4B-3001 Leuven HeverleeBelgium',1),('00:02:C5','Evertz Microsystems Ltd.','Evertz Microsystems Ltd.5288 John Lucas DriveBurlingtonOntario L7l 5z9Canada',1),('00:02:C6','Data Track Technology Plc','Data Track Technology Plc153 Somerford RoadChristchurch, Dorset Bh23 3ty,United KingdomUnited Kingdom',1),('00:02:C7','Alps Electric Co., Ltd.','Alps Electric Co., Ltd.1-2-1, Okinouchi, Sama-city,Fukushima-pref, 976-8501,JapanJapan',1),('00:02:C8','Technocom Communications Technology (pte) Ltd','Technocom Communications Technology (pte) Ltd189 Kaki Buckit Avenue 1#03-03 Shun Li Industrial ParkSingapore 416029Singapore',1),('00:02:C9','Mellanox Technologies','Mellanox Technologies2900 Stender WaySanta Clara Ca 95054United States',1),('00:02:CA','Endpoints, Inc.','Endpoints, Inc.4 Preston CourtBedford Ma 01730United States',1),('00:02:CB','Tristate Ltd.','Tristate Ltd.Shinonaga Blg. 4-11-19 Hokko-choTomakomai-shi, Hokkaido053-0852 053-0852 JapanJapan',1),('00:02:CC','M.c.c.i','M.c.c.i3520 Krums Corners Rd.Ithaca Ny 14850United States',1),('00:02:CD','Teledream, Inc.','Teledream, Inc.Shinhwa Bldg., 940-10 Daechi-dongKangnam-ku, Seoul 135-280Korea, Republic Of',1),('00:02:CE','Foxjet, Inc.','Foxjet, Inc.2016 E. Randal Mill Rd. #409Arlington Tx 76011-8223United States',1),('00:02:CF','Zygate Communications, Inc.','Zygate Communications, Inc.2f, No.48, Lung-chin RoadLung-tan, Tanyuan,Taiwan, Republic Of China',1),('00:02:D0','Comdial Corporation','Comdial Corporation1180 Seminole TrailCharlottesville Va 22901United States',1),('00:02:D1','Vivotek, Inc.','Vivotek, Inc.5f-1, 168-1, Lien-chen Rd,Chung-ho, Taipei County,Taiwan, Republic Of China',1),('00:02:D2','Workstation Ag','Workstation AgSchaffhauserstr. 55Ch-8152 GlattbruggSwitzerland',1),('00:02:D3','Netbotz, Inc.','Netbotz, Inc.110044 Research Blvd.Suite C-100Austin Tx 78759United States',1),('00:02:D4','Pda Peripherals, Inc.','Pda Peripherals, Inc.205 Orange St.Third FloorNew Haven Ct 06510United States',1),('00:02:D5','Acr','AcrCardoulines B21360 Rte Dolinis 06560 ValbonneFrance',1),('00:02:D6','Nice Systems','Nice Systems8 Hapnina St., Pob 690Raanana 43107Israel',1),('00:02:D7','Empeg Ltd','Empeg Ltd1 Signet CourtSwanns Road Cambridge, UkCb5 8laUnited Kingdom',1),('00:02:D8','Brecis Communications Corporation','Brecis Communications Corporation2025 Gateway Place, Suite 132San Jose Ca 95110United States',1),('00:02:D9','Reliable Controls','Reliable Controls120 Hallowell RoadVictoria,  B.c. V9a 7k2Canada',1),('00:02:DA','Exio Communications, Inc.','Exio Communications, Inc.2362 Qume DriveSuite CSan Jose Ca 95131United States',1),('00:02:DB','Netsec','Netsec13505 Dulles Technology DriveSuite 1Hernandon Va 20171United States',1),('00:02:DC','Fujitsu General Limited','Fujitsu General Limited1116, Suenaga, Takatsu-ku,Kawasaki-city, Kanagawa-pref.,213-8502Japan',1),('00:02:DD','Bromax Communications, Ltd.','Bromax Communications, Ltd.No. 20 Kuang Fu Road,Hsin Chu Industrial Park, Hu Kou,Hsin Chu 303Taiwan, Republic Of China',1),('00:02:DE','Astrodesign, Inc.','Astrodesign, Inc.2-22-12 Kamikodana KaNakaharaku, Kawasai-cityKanagawaJapan',1),('00:02:DF','Net Com Systems, Inc.','Net Com Systems, Inc.15-3, Yoido-dong,Yeoungdongpo-ku,SeoulKorea, Republic Of',1),('00:02:E0','Etas Gmbh','Etas GmbhBorsigstrasse 10D70469 StuttgartGermany',1),('00:02:E1','Integrated Network Corporation','Integrated Network Corporation757 Route 202/206Bridgewater Nj 08807United States',1),('00:02:E2','Ndc Infared Engineering','Ndc Infared Engineering5314 N. Irwindale Ave.Irwindale Ca 91706United States',1),('00:02:E3','Lite-on Communications, Inc.','Lite-on Communications, Inc.736 S. Hillview DriveMilpitas Ca 95035United States',1),('00:02:E4','Jc Hyun Systems, Inc.','Jc Hyun Systems, Inc.Shinbong Bldg, 736-6,Yoksam-dong, Kangnam-ku,Seoul  (135-080)Korea, Republic Of',1),('00:02:E5','Timeware Ltd.','Timeware Ltd.Brookfield Grange79 Falinge Rd, RockdaleLancs  042 GlbUnited Kingdom',1),('00:02:E6','Gould Instrument Systems, Inc.','Gould Instrument Systems, Inc.8333 Rockside RoadValley View Oh 44125United States',1),('00:02:E7','Cab Gmbh & Co Kg','Cab Gmbh & Co KgWilhelm-schickard-str 1476131 KarlsruheGermany',1),('00:02:E8','E.d.&a.','E.d.&a.Energielaan 16Iz Bosduin 2950 KapellenBelgium',1),('00:02:E9','Cs Systemes De Securite - C3s','Cs Systemes De Securite - C3s23, Rue De Schwobsheim67600 BaldenheimFrance',1),('00:02:EA','Focus Enhancements','Focus Enhancements1370 Dell Ave.Campbell Ca 95008United States',1),('00:02:EB','Pico Communications','Pico Communications20085 Stevens Creek Blvd.Suite #100Cupertino Ca 95014United States',1),('00:02:EC','Maschoff Design Engineering','Maschoff Design Engineering4454 Cedar Lake Rd. #8St. Louis Park Mn 55416United States',1),('00:02:ED','Dxo Telecom Co., Ltd.','Dxo Telecom Co., Ltd.8f, 300-11, Yumgok-dong,Seocho-ku, Seoul 137-789Korea, Republic Of',1),('00:02:EE','Nokia Danmark A/s','Nokia Danmark A/sFrederikskaj, Copenhagen VDk-1790Denmark',1),('00:02:EF','Ccc Network Systems Group Ltd.','Ccc Network Systems Group Ltd.13 Farnborough Business CentreEelmoor Road, Farnborough, Hants, Gu14 7EnglandUnited Kingdom',1),('00:02:F0','Ame Optimedia Technology Co., Ltd.','Ame Optimedia Technology Co., Ltd.17f-2, 79 Hsin Tai Wu Road, Sec. 1,Hsi-chih, Taipei HsienTaiwan, Republic Of China',1),('00:02:F1','Pinetron Co., Ltd.','Pinetron Co., Ltd.Bldg. #1599-11,Seocho-dong, Seocho-ku,Seoul  137-073Korea, Republic Of',1),('00:02:F2','Edevice, Inc.','Edevice, Inc.420 Lexington AvenueSuite 2300New York Ny 10170United States',1),('00:02:F3','Media Serve Co., Ltd.','Media Serve Co., Ltd.Dongsung Bldg. #17-8, Youido-dong,Youngdeoungpo-ku,SeoulKorea, Republic Of',1),('00:02:F4','Pctel, Inc.','Pctel, Inc.1331 California CircleMilpitas Ca 95035United States',1),('00:02:F5','Vive Synergies, Inc.','Vive Synergies, Inc.30 West Beaver Creek Road, Unit 101Richmond Hill, OntarioL4b 3k1Canada',1),('00:02:F6','Equipe Communications','Equipe Communications100 Nagog ParkActon Ma 01720United States',1),('00:02:F7','Arm','Arm110, Fulbourn RoadCherry Hinton CambridgeCb1 9njUnited Kingdom',1),('00:02:F8','Seakr Engineering, Inc.','Seakr Engineering, Inc.12847 E. Peakview Ave.Englewood Co 80111United States',1),('00:02:F9','Mimos Semiconductor Sdn Bhd','Mimos Semiconductor Sdn BhdTaman Teknologi MalaysiaBukit Jalil 57000 Kuala Lumpur,Malaysia',1),('00:02:FA','Dx Antenna Co., Ltd.','Dx Antenna Co., Ltd.2-15 Hamazaki-dori,Hyogo-ku, KobeJapan',1),('00:02:FB','Baumuller Aulugen-systemtechnik Gmbh','Baumuller Aulugen-systemtechnik GmbhOstendsts. 84D-90482 NurubergGermany',1),('00:02:FC','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:FD','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:02:FE','Viditec, Inc.','Viditec, Inc.520 Central Parkway E.Suite 115Plano Tx 75074United States',1),('00:02:FF','Handan Broadinfocom','Handan Broadinfocom5th Fl. Shinsung Plaza #697-11Yeogsam-dong, Kangnam-guSeoulKorea, Republic Of',1),('00:03:00','Netcontinuum, Inc.','Netcontinuum, Inc.1705 Wyatt DriveSanta Clara Ca 95054United States',1),('00:03:01','Avantas Networks Corporation','Avantas Networks Corporation9900 Cavendish Blvd., Suite #310St-laurent, QuebecH4m 2v2Canada',1),('00:03:02','Charles Industries, Ltd.','Charles Industries, Ltd.5600 Apollo DriveRolling Meadows Il 60008United States',1),('00:03:03','Jama Electronics Co., Ltd.','Jama Electronics Co., Ltd.10f, No. 222-1, Sec. 3Ta-tung Rd., Hsi-chihTaipei HsienTaiwan, Republic Of China',1),('00:03:04','Pacific Broadband Communications','Pacific Broadband Communications3103 North First St.San Jose Ca 95134United States',1),('00:03:05','Smart Network Devices Gmbh','Smart Network Devices GmbhKarl Heinz Beckurts-str. 1352428 JulichGermany',1),('00:03:06','Fusion In Tech Co., Ltd.','Fusion In Tech Co., Ltd.6fl, Daeyoon Bldg. 1688-5, Seocho-dongSeocho-ku,Seoul,Korea, Republic Of',1),('00:03:07','Secure Works, Inc.','Secure Works, Inc.11 Executive DriveSuite 200Atlanta Ga 30329United States',1),('00:03:08','Am Communications, Inc.','Am Communications, Inc.100 Commerce Blvd.Quakertown Pa 18951United States',1),('00:03:09','Texcel Technology Plc','Texcel Technology PlcThames RoadCrayford Kent Da1 4sbEnglandUnited Kingdom',1),('00:03:0A','Argus Technologies','Argus Technologies8f, No. 183, Kang Chien Rd.114Taiwan, Republic Of China',1),('00:03:0B','Hunter Technology, Inc.','Hunter Technology, Inc.Hanbang Bldg., 3f. 418-4,Dokok-dong, Kangnam-gu,Seoul  135-270Korea, Republic Of',1),('00:03:0C','Telesoft Technologies Ltd.','Telesoft Technologies Ltd.Observatory House, Stour Park,Blandforum, Dorset, Dt11 9lq,United Kingdom',1),('00:03:0D','Uniwill Computer Corp.','Uniwill Computer Corp.No. 24, Pei Yuan Rd., ChungLi Industrial Park, ChungLi CityTaiwan, Republic Of China',1),('00:03:0E','Core Communications Co., Ltd.','Core Communications Co., Ltd.3f Shopping Center Bd. OfSsang Young Hwang-geum Apt, #253 Mapo-doSeoul (121-050)  (121-050)Korea, Republic Of',1),('00:03:0F','Digital China (shanghai) Networks Ltd.','Digital China (shanghai) Networks Ltd.602-23, Haitai Building, 351 Guo ShoujinPudong New District,ShanghaiChina',1),('00:03:10','Itx E-globaledge Corporation','Itx E-globaledge CorporationNakameguro Gt Tower 7f 2-1-1 KamimeguroMeguro-kuTokyo  153-0051Japan',1),('00:03:11','Micro Technology Co., Ltd.','Micro Technology Co., Ltd.Suehiro Bldg.1-2, Soto Kanda 5 Chome Chiyoda-ku, Toky101-0021Japan',1),('00:03:12','Tr-systemtechnik Gmbh','Tr-systemtechnik GmbhEglishalde 6D-78647 TrossingenGermany',1),('00:03:13','Access Media Spa','Access Media SpaVia Delle Industrie, 4/g24035 Lallio (bg)Italy',1),('00:03:14','Teleware Network Systems','Teleware Network Systems#7806 7th Dongil Technotown,Kinanyang Dong 823, Dongahn Gu, Anyang C431-062Korea, Republic Of',1),('00:03:15','Cidco Incorporated','Cidco Incorporated220 Cochrane CircleMorgan Hill Ca 95037United States',1),('00:03:16','Nobell Communications, Inc.','Nobell Communications, Inc.3410 Far West Blvd., Suite 240Austin Tx 78731United States',1),('00:03:17','Merlin Systems, Inc.','Merlin Systems, Inc.3900 New Park Mall Rd.3rd FloorNewark Ca 94560United States',1),('00:03:18','Cyras Systems, Inc.','Cyras Systems, Inc.47100 Bayside ParkwayFremont Ca 94538United States',1),('00:03:19','Infineon Ag','Infineon AgP.o. Box 800949D-81609 MunichGermany',1),('00:03:1A','Beijing Broad Telecom Ltd., China','Beijing Broad Telecom Ltd., ChinaP.o. Box #147Beijing University Of Posts  And TelecomBeijing  100876China',1),('00:03:1B','Cellvision Systems, Inc.','Cellvision Systems, Inc.3f-1, 75, Hsin Taiwu Road, Sec. 1Hsichih, Taipei,Taiwan, Republic Of China',1),('00:03:1C','Svenska Hardvarufabriken Ab','Svenska Hardvarufabriken AbOle Romersvag 16, IdeonSe-223 70 LundSweden',1),('00:03:1D','Taiwan Commate Computer, Inc.','Taiwan Commate Computer, Inc.8f, No. 94, Sec 1,Shin Tai Wu Rd. Hsi Chih, Taipei Hsien,Taiwan, Republic Of China',1),('00:03:1E','Optranet, Inc.','Optranet, Inc.7041 Koll Center PkwySuite 135Pleasanton Ca 94566United States',1),('00:03:1F','Condev Ltd.','Condev Ltd.200-1626 West 2nd Ave.Vancouver, B.c. V6j 1h4Canada',1),('00:03:20','Xpeed, Inc.','Xpeed, Inc.99 W. Tasman DriveSuite 110San Jose Ca 95134United States',1),('00:03:21','Reco Research Co., Ltd.','Reco Research Co., Ltd.No. 47-1, Sec. 2,Kuang Fu Rd.,san Chung City, Taipei,Taiwan, Republic Of China',1),('00:03:22','Idis Co., Ltd.','Idis Co., Ltd.7th Floor, 646-7 Yuksam-dong,Kangnam-gu, Seoul 135-280,Korea, Republic Of',1),('00:03:23','Cornet Technology, Inc.','Cornet Technology, Inc.6800 Versar Center, Suite 216Springfield Va 22151-4147United States',1),('00:03:24','Sanyo Multimedia Tottori Co., Ltd.','Sanyo Multimedia Tottori Co., Ltd.7-101 Tachikawa-choTottori City  680-8634Japan',1),('00:03:25','Arima Computer Corp.','Arima Computer Corp.6th Fl., No. 327,Sung-lung Rd., Taipei City,Taiwan, Republic Of China',1),('00:03:26','Iwasaki Information Systems Co., Ltd.','Iwasaki Information Systems Co., Ltd.3361 OshiFukiage-machi, Saitama 369-0113Japan',1),('00:03:27','Actl','ActlAvenue De Artisanat 10a1924 Braine LallardBelgium',1),('00:03:28','Mace Group, Inc.','Mace Group, Inc.5101 Commerce Dr.Baldwin Park Ca 91706United States',1),('00:03:29','F3, Inc.','F3, Inc.2f, No. 7, Industry E. Rd. 9,Science Based Industrial Park,HsinchuTaiwan, Republic Of China',1),('00:03:2A','Unidata Communication Systems, Inc.','Unidata Communication Systems, Inc.2f, Ohsung-bldg, 82-15,Nonhyun-dong, Gangnam-gu,  Seoul,135-101Korea, Republic Of',1),('00:03:2B','Gai Datenfunksysteme Gmbh','Gai Datenfunksysteme GmbhRiedleparkstrasse 28D-88045 FriedrichshafenGermany',1),('00:03:2C','Abb Switzerland Ltd','Abb Switzerland LtdDept. AtptCh-5300 TurgiAustrasseSwitzerland',1),('00:03:2D','Ibase Technology, Inc.','Ibase Technology, Inc.5f, No. 221,Chung Yang Rd.TaipeiTaiwan, Republic Of China',1),('00:03:2E','Scope Information Management, Ltd.','Scope Information Management, Ltd.2f Chanwoo B/o 736 Youksang-dong,Kangnam-gu,Seoul  135-080Korea, Republic Of',1),('00:03:2F','Global Sun Technology, Inc.','Global Sun Technology, Inc.No. 13, Tung Yuan Rd.,Jung Li Industrial Park Jung Li CityTaiwan, Republic Of China',1),('00:03:30','Imagenics, Co., Ltd.','Imagenics, Co., Ltd.1-31-5 Kokuryo-choChofu-city Tokyo182-0022Japan',1),('00:03:31','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:32','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:33','Digitel Co., Ltd.','Digitel Co., Ltd.835-6, Yoksam-dongKangnam-gu, 135-080, Seoul,Korea, Republic Of',1),('00:03:34','Newport Electronics','Newport Electronics2229 So. Yale St.Santa Ana Ca 92704United States',1),('00:03:35','Mirae Technology','Mirae Technology211-15, Hon Hyun-dong,Kangnam-ku 135-010SeoulKorea, Republic Of',1),('00:03:36','Zetes Technologies','Zetes Technologies3 Rue De Stras Bourg1130 BrusselsBelgium',1),('00:03:37','Vaone, Inc.','Vaone, Inc.6f Kyemong Art Center,772 Yuksan2-dong Kang Hamgu, Seoul,135-082Korea, Republic Of',1),('00:03:38','Oak Technology','Oak Technology139 Kifer CourtSunnyvale Ca 94086-5160United States',1),('00:03:39','Eurologic Systems, Ltd.','Eurologic Systems, Ltd.Clonshaugh Industrial EstateClonshaugh Dublin 17Ireland',1),('00:03:3A','Silicon Wave, Inc.','Silicon Wave, Inc.6256 Greenwich DriveSuite 300San Diego Ca 92122United States',1),('00:03:3B','Tami Tech Co., Ltd.','Tami Tech Co., Ltd.4f, Chungdo Bencher Town606 Tanbang-dong, Seo-guTaejonKorea, Republic Of',1),('00:03:3C','Daiden Co., Ltd.','Daiden Co., Ltd.2100-19 Tutumi, Kamimine-machiMiyaki-gun, Saga-kenJapan',1),('00:03:3D','Ilshin Lab','Ilshin LabKcs B/d 228-13 Young Dap-dongSung Dong-gu,SeoulKorea, Republic Of',1),('00:03:3E','Tateyama System Laboratory Co., Ltd.','Tateyama System Laboratory Co., Ltd.30 Shimonoban Oyama-choKaminikawa-gun Toyama Prof.930-1305Japan',1),('00:03:3F','Bigband Networks, Ltd.','Bigband Networks, Ltd.3 Azrieli TowersTel-aviv 67023Israel',1),('00:03:40','Floware Wireless Systems, Ltd.','Floware Wireless Systems, Ltd.28 Hacharoshet SteetP.o.b. 812 Or-yehuda60250Israel',1),('00:03:41','Axon Digital Design','Axon Digital DesignP.o. Box 1115070 Ac UdenhoutNetherlands',1),('00:03:42','Nortel Networks','Nortel Networks8200 Dixie Road - Ste #100Dept. 6800 Brampton  On  L6t 5p6Canada',1),('00:03:43','Martin Professional A/s','Martin Professional A/sOlof Palmes Alle 18Dk-8200 AarhusnDenmark',1),('00:03:44','Tietech.co., Ltd.','Tietech.co., Ltd.2-13-1 Chikamatoori MinamikuNagoya,Japan',1),('00:03:45','Routrek Networks Corporation','Routrek Networks CorporationNilssei Shin Mizonokuchi Bldg. 1f3-5-7 Hisamoto, Takatsu-ku Kawasaki-shi,23-0011Japan',1),('00:03:46','Hitachi Kokusai Electric, Inc.','Hitachi Kokusai Electric, Inc.1-6-10 UchikandaChiyoda-ku Tokyo L101Japan',1),('00:03:47','Intel Corporation','Intel CorporationMs:  Lf3-4202111 N.e. 25th AvenueHillsboro Or 97124United States',1),('00:03:48','Norscan Instruments, Ltd.','Norscan Instruments, Ltd.7 Terracon PlaceWinnipeg, Manitoba,R2j 4b3Canada',1),('00:03:49','Vidicode Datacommunicatie B.v.','Vidicode Datacommunicatie B.v.Postbus 71642701 Ad ZoetermeerNetherlands',1),('00:03:4A','Rias Corporation','Rias Corporation46600 Fremont Blvd.Fremont Ca 94538United States',1),('00:03:4B','Nortel Networks','Nortel Networks8200 Dixie Road Suite 100Dept. 6800 Brampton On L6t 5 P6Canada',1),('00:03:4C','Shanghai Digivision Technology Co., Ltd.','Shanghai Digivision Technology Co., Ltd.11f, Heng TongInternational Building, 865 Chang Ning RShanghai 200050China',1),('00:03:4D','Chiaro Networks, Ltd.','Chiaro Networks, Ltd.P.o. Box 832427Richardson Tx 75083-2427United States',1),('00:03:4E','Pos Data Company, Ltd.','Pos Data Company, Ltd.276-2, Seo-hyun Dong,Bun-dang Gu, Sung-nam City, Kyoung-gi PrKorea, Republic Of',1),('00:03:4F','Sur-gard Security','Sur-gard Security401 Magnetic DriveUnits 24-28, DownsviewOntario  M3j 3h9Canada',1),('00:03:50','Bticino Spa','Bticino SpaVia L. Manara, 422036 Erba (co)Italy',1),('00:03:51','Diebold, Inc.','Diebold, Inc.5995 Mayfair RoadNorth Canton Oh 44720United States',1),('00:03:52','Colubris Networks','Colubris Networks440 Armand-frappierLaval (quebec)H7v 4b4Canada',1),('00:03:53','Mitac, Inc.','Mitac, Inc.No. 2, Chung-hsiao StreetChitu Keelung,Taiwan, Republic Of China',1),('00:03:54','Fiber Logic Communications','Fiber Logic Communications5f-3, No. 9, Prosperity Road One,Science-based Industrial Park,HsinchuTaiwan, Republic Of China',1),('00:03:55','Terabeam Internet Systems','Terabeam Internet Systems14833 Ne 87th St., Bldg. CRedmond Wa 98052United States',1),('00:03:56','Wincor Nixdorf International Gmbh','Wincor Nixdorf International GmbhHeinz-nixdorf Ring 1D-33106 PaderbornGermany',1),('00:03:57','Intervoice-brite, Inc.','Intervoice-brite, Inc.17811 Waterview Pkwy.Dallas Tx 75252United States',1),('00:03:58','Hanyang Digitech Co., Ltd.','Hanyang Digitech Co., Ltd.13f, Acetwintower2, 212-30, Guro-dongGuro-guSeoulKorea, Republic Of',1),('00:03:59','Digitalsis','DigitalsisB-1405 Samho Bldg.275-6 YangjaeSeocho Seoul,Korea, Republic Of',1),('00:03:5A','Photron Limited','Photron LimitedShibuya 1-9-8Shibuya-ku, Tokyo150-0002Japan',1),('00:03:5B','Bridgewave Communications','Bridgewave Communications3350 Thomad RoadSanta Clara Ca 95054United States',1),('00:03:5C','Saint Song Corp.','Saint Song Corp.4f, No. 12, Lane 94, Tsao Ti WziShen Keng Hsiang, Taipei Hsien222Taiwan, Republic Of China',1),('00:03:5D','Bosung Hi-net Co., Ltd.','Bosung Hi-net Co., Ltd.Youngil B/o 2f,Yangjae-dong 12-7, Seocho-gu, Seoul137-130Korea, Republic Of',1),('00:03:5E','Metropolitan Area Networks, Inc.','Metropolitan Area Networks, Inc.1299 Pennsylvania Avenue, NwNinth FloorWashington Dc 20004United States',1),('00:03:5F','Prueftechnik Condition Monitoring Gmbh & Co. Kg','Prueftechnik Condition Monitoring Gmbh & Co. KgFranz-bayer-str. 14D-88213 RavensburgGermany',1),('00:03:60','Pac Interactive Technology, Inc.','Pac Interactive Technology, Inc.6f, No. 30, Alley 18, Lane 478Jai Guang Road, Nei-huTaipeiTaiwan, Republic Of China',1),('00:03:61','Widcomm, Inc.','Widcomm, Inc.9645 Scranton RoadSuite 205San Diego Ca 92121United States',1),('00:03:62','Vodtel Communications, Inc.','Vodtel Communications, Inc.12f, No 166 Chien-yi RoadChung-ho City, Taipei County235Taiwan, Republic Of China',1),('00:03:63','Miraesys Co., Ltd.','Miraesys Co., Ltd.650-2 4 Fl. Daemyung Bldg.Yuksam, Kangnam, Seoul,135-080Korea, Republic Of',1),('00:03:64','Scenix Semiconductor, Inc.','Scenix Semiconductor, Inc.1330 Charleston Rd.Mountainview Ca 94043United States',1),('00:03:65','Kira Information & Communications, Ltd.','Kira Information & Communications, Ltd.6th Fl. Anam Tower,702-10 Yeoksam-dong, Kangnam-ku, SeoulKorea, Republic Of',1),('00:03:66','Asm Pacific Technology','Asm Pacific Technology12/f Watson Centre16 Kung Yip St.Kwai ChungHong Kong',1),('00:03:67','Jasmine Networks, Inc.','Jasmine Networks, Inc.1940 Zanker RoadSan Jose Ca 95112United States',1),('00:03:68','Embedone Co., Ltd.','Embedone Co., Ltd.Fl. 9 Annex Samhwan B/d. 17-26Yeoido-dong, Youngdeungpo-ku,Seoul  150-01Korea, Republic Of',1),('00:03:69','Nippon Antenna Co., Ltd.','Nippon Antenna Co., Ltd.No. 49-8, Nishiogu,7-chome Arakawa-ku,Tokyo  116-8561Japan',1),('00:03:6A','Mainnet, Ltd.','Mainnet, Ltd.P.o. Box 2324Kfar Saba 44641Israel',1),('00:03:6B','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:6C','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:6D','Runtop, Inc.','Runtop, Inc.1, Lane 21, Hsin Hua Road, KueishanIndustrial Park, Taoyuan City,Taiwan, Republic Of China',1),('00:03:6E','Nicon Systems (pty) Limited','Nicon Systems (pty) Limited11 Termo StreetTechnopark Stellenbosch, 7600South Africa',1),('00:03:6F','Telsey Spa','Telsey SpaViale Dell Industria, 131 055 QuintoDitreviso-Italy',1),('00:03:70','Nxtv, Inc.','Nxtv, Inc.5955 De Soto Ave, #160Woodland Hills Ca 91367United States',1),('00:03:71','Acomz Networks Corp.','Acomz Networks Corp.7th Fl., Wooseok Bldg., 1007-37Sadang1-dong, Dongjak-gu,Seoul  156-09Korea, Republic Of',1),('00:03:72','Ulan','Ulan5f-3, No. 31-1, Lane 169,Kang Ning St., Hsi-chin City, Taipei HsiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:73','Aselsan A.s','Aselsan A.sMehmet Akif Ersoy Mah.16 Cad. No. 16 Macunkoy/ankaraTurkeyTurkey',1),('00:03:74','Control Microsystems','Control Microsystems48 Steacie DriveOttawa Ontario K2k 2a9Canada',1),('00:03:75','Netmedia, Inc.','Netmedia, Inc.10940 N. Stallard PlaceTuscon Az 85737United States',1),('00:03:76','Graphtec Technology, Inc.','Graphtec Technology, Inc.45 Parker, Suite AIrvine Ca 92618United States',1),('00:03:77','Gigabit Wireless','Gigabit Wireless3099 N. First StreetSan Jose Ca 95134United States',1),('00:03:78','Humax Co., Ltd.','Humax Co., Ltd.271-2, Suh-hyun-dong,Bundang-gu, Sungnam-city, Kyonggi-do, 46Korea, Republic Of',1),('00:03:79','Proscend Communications, Inc.','Proscend Communications, Inc.2f, No.36, Industry E. Rd. Iv,Science-based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:03:7A','Taiyo Yuden Co., Ltd.','Taiyo Yuden Co., Ltd.8-1 Sakae-choTakasaki-shi Gunma 370-8522JapanJapan',1),('00:03:7B','Idec Izumi Corporation','Idec Izumi Corporation7-31, Nishimiyahara1-chome Yodogawa-ku. Osaka 532-8550JapanJapan',1),('00:03:7C','Coax Media','Coax Media1220 Oak Industrial LaneSuite BCumming Ga 30041United States',1),('00:03:7D','Stellcom','Stellcom10525 Vista Sorrento ParkwaySuite 100San Diego Ca 92121United States',1),('00:03:7E','Portech Communications, Inc.','Portech Communications, Inc.150, Shiang-shung N. Rd.,Taichung Taiwan 403, R.o.c.Taiwan, Republic Of China',1),('00:03:7F','Atheros Communications, Inc.','Atheros Communications, Inc.5480 Great America ParkwaySanta Clara Ca 95054United States',1),('00:03:80','Ssh Communications Security Corp.','Ssh Communications Security Corp.Fredrikinkatu 42Fin 0100 HelsinkiFinlandFinland',1),('00:03:81','Ingenico International','Ingenico International1/9 Apollo StreetWarriewood Nsw 2102AustraliaAustralia',1),('00:03:82','A-one Co., Ltd.','A-one Co., Ltd.6-9-20, Shimoichiba-cho,Kasugai-shi, Aichi-ken, 486-0852JapanJapan',1),('00:03:83','Metera Networks, Inc.','Metera Networks, Inc.1202 Richardson Dr.Suite 100Richardson Tx 75080United States',1),('00:03:84','Aeta','AetaKepler 618-22 Avenue Edouard HerriotLe Plessis Robinson  92350France',1),('00:03:85','Actelis Networks, Inc.','Actelis Networks, Inc.1 Bazel St., P.o.b. 10173Petah - Tikva 49103IsraelIsrael',1),('00:03:86','Ho Net, Inc.','Ho Net, Inc.Venture Company CenterSan 94-6 Yiui-dong, Paldal-gu, Suwon-si,Korea 442-760Korea, Republic Of',1),('00:03:87','Blaze Network Products','Blaze Network Products5180 Hacienda DriveDublin Ca 94568United States',1),('00:03:88','Fastfame Technology Co., Ltd.','Fastfame Technology Co., Ltd.7f, No. 111, Hsing De Rd.,Sanchung, Taipei,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:89','Plantronics','Plantronics345 Encinal St.Santa Cruz Ca 95060United States',1),('00:03:8A','America Online, Inc.','America Online, Inc.44900 Prentice DriveDulles Va 20166United States',1),('00:03:8B','Plus-one I&t, Inc.','Plus-one I&t, Inc.7f, A-san Venture Tower,Yangjae-dong, Seocho-ku, Seoul,KoreaKorea, Republic Of',1),('00:03:8C','Total Impact','Total Impact295 Willis Ave.Suite ECamarillo Ca 93010United States',1),('00:03:8D','Pcs Revenue Control Systems, Inc.','Pcs Revenue Control Systems, Inc.560 Sylvan Ave.Englewood Cliffs Nj 07632United States',1),('00:03:8E','Atoga Systems, Inc.','Atoga Systems, Inc.49026 Milmont DriveFremont Ca 94538United States',1),('00:03:8F','Weinschel Corporation','Weinschel Corporation5305 Spectrum DriveFrederick Md 21703United States',1),('00:03:90','Digital Video Communications, Inc.','Digital Video Communications, Inc.500 W. Cummings ParkSuite 2000Woburn Ma 07801United States',1),('00:03:91','Advanced Digital Broadcast, Ltd.','Advanced Digital Broadcast, Ltd.8f, 145 Chung Shan N. Rd. Sec. 2,Taipei, 104,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:92','Hyundai Teletek Co., Ltd.','Hyundai Teletek Co., Ltd.B-501, Techno Park, 148 Yatap-dong,Boondang-gu, Sungnam-si, Kyunggi-do, 463Korea RepublicKorea, Republic Of',1),('00:03:93','Apple Computer, Inc.','Apple Computer, Inc.20650 Valley Green Dr.Cupertino Ca 95014United States',1),('00:03:94','Connect One','Connect One2 Hanagar StreetKfar Saba 44425IsraelIsrael',1),('00:03:95','California Amplifier','California Amplifier460 Calle San PabloCamarillo Ca 93012United States',1),('00:03:96','Ez Cast Co., Ltd.','Ez Cast Co., Ltd.6th Floor, Jungang Building,99-1, Nonhyun-dong (135-010) Kangnam-ku,KoreaKorea, Republic Of',1),('00:03:97','Watchfront Limited','Watchfront Limited3 Victoria WalkWokingham  Rg40 5ylUnited Kingdom',1),('00:03:98','Wisi','WisiWilhelm-sihn-str. 5-7D-75223 Niefern-oeschelbronnGermany',1),('00:03:99','Dongju Informations & Communications Co., Ltd.','Dongju Informations & Communications Co., Ltd.#305, Eunsuk Bldg. Samsung-dongKangnam-gu SeoulRepublic Of KoreaKorea, Republic Of',1),('00:03:9A','Siconnect','SiconnectDelta 100Welton RoadSwindon  Sn5 7xpUnited Kingdom',1),('00:03:9B','Netchip Technology, Inc.','Netchip Technology, Inc.335 Pioneer WayMountain View Ca 94041United States',1),('00:03:9C','Optimight Communications, Inc.','Optimight Communications, Inc.980 Linda Vista AvenueMountain View Ca 94043United States',1),('00:03:9D','Qisda Corporation','Qisda Corporation157 Shan Ying RoadGueishan Taoyuan 333Taiwan, Republic Of China',1),('00:03:9E','Tera System Co., Ltd.','Tera System Co., Ltd.Doosung B/f Rm 302766-1 Shinchungdong Shihung City KyungkiRepublic Of KoreaKorea, Republic Of',1),('00:03:9F','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:A0','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:A1','Hiper Information & Communication, Inc.','Hiper Information & Communication, Inc.1675-7, Sinil-dong,Taeduk-gu, Taejon,306-230 South KoreaKorea, Republic Of',1),('00:03:A2','Catapult Communications','Catapult Communications160 S. Whisman Rd.Mountain View Ca 94041United States',1),('00:03:A3','Mavix, Ltd.','Mavix, Ltd.Pob 217, Yokneam Illit,20692Israel',1),('00:03:A4','Imation Corp.','Imation Corp.1 Imation PlaceDiscovery 2b-50Oakdale Mn 55128-3414United States',1),('00:03:A5','Medea Corporation','Medea Corporation5701 Lindero Canyon Rd.Bldg. 3-100Wetlake Village Ca 91362United States',1),('00:03:A6','Traxit Technology, Inc.','Traxit Technology, Inc.256 Great Road,Suite 16Littleton Ma 01461United States',1),('00:03:A7','Unixtar Technology, Inc.','Unixtar Technology, Inc.13f No. 100 Ming Chuan RoadHsin Tien, Taipei,TaiwanTaiwan, Republic Of China',1),('00:03:A8','Idot Computers, Inc.','Idot Computers, Inc.3f., No. 137, Lane 235Pao-chiao Road, Hsin-tien Taipei CountryTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:A9','Axcent Media Ag','Axcent Media AgTechnologiepark 1333100 PaderbornGermanyGermany',1),('00:03:AA','Watlow','Watlow1241 Bundy Blvd.Winona Mn 55987United States',1),('00:03:AB','Bridge Information Systems','Bridge Information Systems717 Office ParkwaySt. Louis Mo 63141United States',1),('00:03:AC','Fronius Schweissmaschinen','Fronius SchweissmaschinenGuenter Fronius Str. 1A-4600 Weis-thalheimAustriaAustria',1),('00:03:AD','Emerson Energy Systems Ab','Emerson Energy Systems AbSe-141 82 StockholmSweden',1),('00:03:AE','Allied Advanced Manufacturing Pte, Ltd.','Allied Advanced Manufacturing Pte, Ltd.7 International Business Park#02-00Singapore 609919Singapore',1),('00:03:AF','Paragea Communications','Paragea Communications207 Perry ParkwayGaithersburg Md 20877United States',1),('00:03:B0','Xsense Technology Corp.','Xsense Technology Corp.11 F, 232, Sec. 3, Chengteh Rd.Taipei Taiwan, 103Taiwan, Republic Of China',1),('00:03:B1','Hospira Inc.','Hospira Inc.755 Jarvis DriveMorgan Hill Ca 95037United States',1),('00:03:B2','Radware','Radware8 Hamrpe HochvimJerusalemIsraelIsrael',1),('00:03:B3','Ia Link Systems Co., Ltd.','Ia Link Systems Co., Ltd.6f-4, No. 81 Hsin TaiWu Rd., Sec. 1 Hsih-chih, Taipei Hsien,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:B4','Macrotek International Corp.','Macrotek International Corp.2f, No. 28, Lane 46Kwang Fu 6 Road,Taipei Taipei TaiwanTaiwan, Republic Of China',1),('00:03:B5','Entra Technology Co.','Entra Technology Co.Fl. 3, No. 5, Alley 2,Su-wei Lane, Chung-cheng Rd., Hsin-dien,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:B6','Qsi Corporation','Qsi Corporation2212 South West Temple #50Salt Lake City Ut 84115United States',1),('00:03:B7','Zaccess Systems','Zaccess Systems275 Shoreline Drive, #110Redwood City Ca 94065United States',1),('00:03:B8','Netkit Solutions, Llc','Netkit Solutions, Llc1125-a Business Center CircleThousand Oaks Ca 91320United States',1),('00:03:B9','Hualong Telecom Co., Ltd.','Hualong Telecom Co., Ltd.9 Guanghua St.Changzhou, Jiangsu, 213003P.r. ChinaChina',1),('00:03:BA','Sun Microsystems Inc.','Sun Microsystems Inc.4200 Network CircleSanta Clara Ca 95054United States',1),('00:03:BB','Signal Communications Limited','Signal Communications LimitedUnit 217, 2/f, Hkitc,72 Tat Chee Avenue, Kln.,Hong KongHong Kong',1),('00:03:BC','Cot Gmbh','Cot GmbhGueterstrasse 564807 DieburgGermanyGermany',1),('00:03:BD','Omnicluster Technologies, Inc.','Omnicluster Technologies, Inc.4950 Blue Lake DriveSuite 900Boca Raton Fl 33431United States',1),('00:03:BE','Netility','Netility298 South Sunnyvale Ave.Suie 102Sunnyvale Ca 94086United States',1),('00:03:BF','Centerpoint Broadband Technologies, Inc.','Centerpoint Broadband Technologies, Inc.1741 Technology Drive,Suite 400San Jose Ca 95110-1310United States',1),('00:03:C0','Rftnc Co., Ltd.','Rftnc Co., Ltd.3f, 1624-24, Bongchen-dongKionak-gu, SeoulSouth KoreaKorea, Republic Of',1),('00:03:C1','Packet Dynamics Ltd','Packet Dynamics Ltd2 Buckstane ParkEdinburgh, ScotlandUk Eh10 GpaUnited Kingdom',1),('00:03:C2','Solphone K.k.','Solphone K.k.2-11-1 Kandatsukasa-choChiyada, Tokyo101-0048 JapanJapan',1),('00:03:C3','Micronik Multimedia','Micronik MultimediaBrueckenstr. 2D-51379 LeverkusenGermanyGermany',1),('00:03:C4','Tomra Systems Asa','Tomra Systems AsaDrengsrudhagen 2Box 278 N-1371 AskerNorwayNorway',1),('00:03:C5','Mobotix Ag','Mobotix AgWingertsweilerhof 6D-67724 HoringenGermanyGermany',1),('00:03:C6','Icue Systems, Inc.','Icue Systems, Inc.17489 Gale AvenueCity Of Industry Ca 91748United States',1),('00:03:C7','Hopf Elektronik Gmbh','Hopf Elektronik GmbhNottebohmstrasse 4158511 LuedenscheidGermany',1),('00:03:C8','Cml Emergency Services','Cml Emergency Services75 Boulevard La TechnologiesHull, Quebec Je23g4CanadaCanada',1),('00:03:C9','Tecom Co., Ltd.','Tecom Co., Ltd.23, R&d Road 2Science-based Industrial ParkHsin-chuTaiwan, Republic Of China',1),('00:03:CA','Mts Systems Corp.','Mts Systems Corp.16050 Stetson RoadLos Gatos Ca 95033United States',1),('00:03:CB','Nippon Systems Development Co., Ltd.','Nippon Systems Development Co., Ltd.30-12, Komyo-cho,Takarabuka-city, Hyogo,665-0045 JapanJapan',1),('00:03:CC','Momentum Computer, Inc.','Momentum Computer, Inc.1815 Aston AvenueSuite 107Carlsbad Ca 92008-7310United States',1),('00:03:CD','Clovertech, Inc.','Clovertech, Inc.3-1-5 Naka-cho Musashino-shiTokyo 180-0006 JapanJapan',1),('00:03:CE','Eten Technologies, Inc.','Eten Technologies, Inc.2f, No. 9, Lane 235, Pao-chiao Rd.,Hsien Tien City, Taipei Hsien 231Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:03:CF','Muxcom, Inc.','Muxcom, Inc.D 602, Bundang Technopark #151Yatap Dong, Bundag Gu, Sungnam Si,Kyungki Do Korea 463-070Korea, Republic Of',1),('00:03:D0','Koankeiso Co., Ltd.','Koankeiso Co., Ltd.Zip Code 791-80422798 36minamiyoshida-mati Matuyama-cityJapanJapan',1),('00:03:D1','Takaya Corporation','Takaya CorporationDevelopment Division661-1, Ibara-cho Ibara-city Okayama, 715JapanJapan',1),('00:03:D2','Crossbeam Systems, Inc.','Crossbeam Systems, Inc.80 Central StreetBoxborough Ma 01719United States',1),('00:03:D3','Internet Energy Systems, Inc.','Internet Energy Systems, Inc.4218 Trumbo Ct.Fairfax Va 22033United States',1),('00:03:D4','Alloptic, Inc.','Alloptic, Inc.6960 Koll Center ParkwaySuite 300Pleasanton Ca 94566United States',1),('00:03:D5','Advanced Communications Co., Ltd.','Advanced Communications Co., Ltd.16-16 Takashima-honcho,Numazu Shizuoka,4100055 JapanJapan',1),('00:03:D6','Radvision, Ltd.','Radvision, Ltd.24 Raul Wallenberg St.Tel-aviv 69719IsraelIsrael',1),('00:03:D7','Nextnet Wireless, Inc.','Nextnet Wireless, Inc.9555 James Ave. So.Suite 270Bloomington Mn 55431United States',1),('00:03:D8','Impath Networks, Inc.','Impath Networks, Inc.1431 Merivale Rd.Nepean, Ontario,Canada K2e 1b9Canada',1),('00:03:D9','Secheron Sa','Secheron SaUntermattweg 8Ch-3027 BernSwitzerlandSwitzerland',1),('00:03:DA','Takamisawa Cybernetics Co., Ltd.','Takamisawa Cybernetics Co., Ltd.Nakano Heiwa Bldg.48 5-2-chome Chuo, Nakano-ku Tokyo 164-0JapanJapan',1),('00:03:DB','Apogee Electronics Corp.','Apogee Electronics Corp.3145 Donald Douglas Loop SouthSanta Monica Ca 90405-3210United States',1),('00:03:DC','Lexar Media, Inc.','Lexar Media, Inc.47421 Bayside ParkwayFremont Ca 94538United States',1),('00:03:DD','Comark Corp.','Comark Corp.93 West St.Medfield Ma 02052United States',1),('00:03:DE','Otc Wireless','Otc Wireless602 Charlot Ave.San Jose Ca 95131United States',1),('00:03:DF','Desana Systems','Desana Systems1805 Mccandless Ave.Milpitas Ca 95035United States',1),('00:03:E0','Radioframe Networks, Inc.','Radioframe Networks, Inc.18650 Ne 67th CourtSuite 110Redmond Wa 98052United States',1),('00:03:E1','Winmate Communication, Inc.','Winmate Communication, Inc.9f,no.111-6,shing-de RdSan-chung,Taipei   241Taiwan, Republic Of China',1),('00:03:E2','Comspace Corporation','Comspace Corporation955 Freeport PkwySuite 100Coppell Tx 75019United States',1),('00:03:E3','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:E4','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:E5','Hermstedt Sg','Hermstedt SgCarl-reuther - Str. 3D-68305 MannheimGermanyGermany',1),('00:03:E6','Entone, Inc.','Entone, Inc.2755 Campus Dr Ste 235San Mateo Ca  94403United States',1),('00:03:E7','Logostek Co. Ltd.','Logostek Co. Ltd.19th 15 Sunusu-academy Tower277-17 Sungsu-2ga, Sungdong-guSeoul Korea 133-123Korea, Republic Of',1),('00:03:E8','Wavelength Digital Limited','Wavelength Digital Limited12 Vincent AvenueCrownhill Business Park Milton Keynes, BMk8 0ab Mk8 0ab EnglandUnited Kingdom',1),('00:03:E9','Akara Canada, Inc.','Akara Canada, Inc.150 Katimavik RoadKanata OntarioCanada K2l 2n2Canada',1),('00:03:EA','Mega System Technologies, Inc.','Mega System Technologies, Inc.2f, No. 41, Lane 76,Rui Kuang Rd., Nei Hu 114Taipei Taipei TaiwanTaiwan, Republic Of China',1),('00:03:EB','Atrica','Atrica5 Shenkar St. P.o.b. 12231Hezelia Industrial Area46733 46733 IsraelIsrael',1),('00:03:EC','Icg Research, Inc.','Icg Research, Inc.775 B The Queens WayToronto, OntarioM8z 1n1 CanadaCanada',1),('00:03:ED','Shinkawa Electric Co., Ltd.','Shinkawa Electric Co., Ltd.3-2-24 3 ChomeKonan Nakaku Hiroshima, 730-0825,JapanJapan',1),('00:03:EE','Mknet Corporation','Mknet Corporation711-b Charcot Ave.San Jose Ca 95131United States',1),('00:03:EF','Oneline Ag','Oneline AgSteinfeldstr. 339179 BarlebenGermanyGermany',1),('00:03:F0','Redfern Broadband Networks','Redfern Broadband NetworksLevel 1, 1 Central Ave.,Australian Technology Park Eveleigh, NswAustraliaAustralia',1),('00:03:F1','Cicada Semiconductor, Inc.','Cicada Semiconductor, Inc.811 Barton Springs Rd.Suite 550Austin Tx 78704United States',1),('00:03:F2','Seneca Networks','Seneca Networks30 West Gude Dr.Suite 200Rockville Md 20850United States',1),('00:03:F3','Dazzle Multimedia, Inc.','Dazzle Multimedia, Inc.47211 Bayside ParkwayFremont Ca 94538United States',1),('00:03:F4','Netburner','Netburner11324 Legacy Canyon Pl.San Diego Ca 92131United States',1),('00:03:F5','Chip2chip','Chip2chip2249 Zanker Rd.San Jose Ca 95131United States',1),('00:03:F6','Allegro Networks, Inc.','Allegro Networks, Inc.6399 San Ignacio AvenueSan Jose Ca 95119United States',1),('00:03:F7','Plast-control Gmbh','Plast-control GmbhWalter-freitag-str. 1542899 RemscheidGermanyGermany',1),('00:03:F8','Sancastle Technologies, Inc.','Sancastle Technologies, Inc.2107 North First StreetSuite 500San Jose Ca 95131United States',1),('00:03:F9','Pleiades Communications, Inc.','Pleiades Communications, Inc.2830 Market Loop #104South Lake Tx 76092United States',1),('00:03:FA','Timetra Networks','Timetra Networks500 Ellis St.Mountain View Ca 94043United States',1),('00:03:FB','Enegate Co.,ltd.','Enegate Co.,ltd.3-14-40 Senrioka,Settsu-city Osaka 566-8686Japan',1),('00:03:FC','Intertex Data Ab','Intertex Data AbRissneleden 45174 44 SundbybergSwedenSweden',1),('00:03:FD','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:FE','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:03:FF','Microsoft Corporation','Microsoft Corporation1 Microsoft WayRedmond Wa 98052United States',1),('00:04:00','Lexmark International, Inc.','Lexmark International, Inc.740 New Circle Rd - Bldg. #035Lexington Ky 40550United States',1),('00:04:01','Osaki Electric Co., Ltd.','Osaki Electric Co., Ltd.1131, Fujikubo, Miyoshimachi,Iruma-gun, Saitama 354-8501,JapanJapan',1),('00:04:02','Nexsan Technologies, Ltd.','Nexsan Technologies, Ltd.Parker CentreMansfield RdDerby  De21 4szUnited Kingdom',1),('00:04:03','Nexsi Corporation','Nexsi Corporation1959 Concourse DriveSan Jose Ca 95131United States',1),('00:04:04','Makino Milling Machine Co., Ltd.','Makino Milling Machine Co., Ltd.4023 Nakatsu, Aikawa-machi,Aiko-gun Kanagawa 243-0303Japan',1),('00:04:05','Acn Technologies','Acn Technologies9f, Heykang B/d, 157-36Sansung-dong, Kangnamgu,Seoul Korea #135-090Korea, Republic Of',1),('00:04:06','Fa. Metabox Ag','Fa. Metabox AgDaimlerring 37,D-31135 Hildsheim,GermanyGermany',1),('00:04:07','Topcon Positioning Systems, Inc.','Topcon Positioning Systems, Inc.5758 W. Las Positas Blvd.Pleasanton Ca 94588United States',1),('00:04:08','Sanko Electronics Co., Ltd.','Sanko Electronics Co., Ltd.3-802 Ueda Tenpaku-kuNagoya JapanJapan',1),('00:04:09','Cratos Networks','Cratos Networks313 Littleton RoadSuite 20Chelmsford Ma 01824United States',1),('00:04:0A','Sage Systems','Sage Systems1420 Harbor Bay ParkwaySuite 160Alameda Ca 94502United States',1),('00:04:0B','3com Europe Ltd.','3com Europe Ltd.3com CentreBoundary Way, Hemel Hempstead HertfordshHp2 7yu UkUnited Kingdom',1),('00:04:0C','Kanno Works Ltd.','Kanno Works Ltd.1-5-25 Kamitomino,Kokurakita-ku, Kitakyusyu-city, Fukuoka-JapanJapan',1),('00:04:0D','Avaya, Inc.','Avaya, Inc.Office 1a325307 Middletown Lincroft RoadLincroft Nj 07738-1526United States',1),('00:04:0E','Avm Gmbh','Avm GmbhAlt-moabit 9510559 BerlinGermany',1),('00:04:0F','Asus Network Technologies, Inc.','Asus Network Technologies, Inc.11-1, No. 675, Sec. 1, King-kuo Rd.,Hsinchu,Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:04:10','Spinnaker Networks, Inc.','Spinnaker Networks, Inc.107 Gamma DrivePittsburgh Pa 15238United States',1),('00:04:11','Inkra Networks, Inc.','Inkra Networks, Inc.40971 Encyclopedia CircleFremont Ca 94538United States',1),('00:04:12','Wavesmith Networks, Inc.','Wavesmith Networks, Inc.40 Nagog ParkActon Ma 01720-3425United States',1),('00:04:13','Snom Technology Ag','Snom Technology AgHelmholtzstrasse 2-9D-10587 BerlinGermanyGermany',1),('00:04:14','Umezawa Musen Denki Co., Ltd.','Umezawa Musen Denki Co., Ltd.14-3, Minami 1, Nishi 8,Chuo-ku, Sapporo,Hokkaido Japan 060-0061Japan',1),('00:04:15','Rasteme Systems Co., Ltd.','Rasteme Systems Co., Ltd.886-2 Nihongi Nakagou-muraNakakubiki-gun NiigataJapanJapan',1),('00:04:16','Parks S/a Comunicacoes Digitais','Parks S/a Comunicacoes DigitaisAv. Pernambuco, 1001Porto-alegre-rs Cep 90240-004BrazilBrazil',1),('00:04:17','Elau Ag','Elau AgDillberg 1297828 MarktheidenfeldGermanyGermany',1),('00:04:18','Teltronic S.a.u.','Teltronic S.a.u.Poligono De MalpicaCalle F Oeste 50057 ZaragozaSpainSpain',1),('00:04:19','Fibercycle Networks, Inc.','Fibercycle Networks, Inc.20 South Santa Cruz Ave.Suite 112Los Gatos Ca 95030United States',1),('00:04:1A','Ines Test And Measurement Gmbh & Cokg','Ines Test And Measurement Gmbh & CokgAn Der Muehlenaue 5Bad Nenndorf 31542Germany',1),('00:04:1B','Bridgeworks Ltd.','Bridgeworks Ltd.135 Somerford RoadChristchurch Dorset Bh23 3pyUnited Kingdom',1),('00:04:1C','Ipdialog, Inc.','Ipdialog, Inc.1762 Technology DriveSuite 124San Jose Ca 95110United States',1),('00:04:1D','Corega Of America','Corega Of AmericaP.o. Box 159Bothell Wa 98041-0159United States',1),('00:04:1E','Shikoku Instrumentation Co., Ltd.','Shikoku Instrumentation Co., Ltd.777, Oosachou, Zentsuujishi,Kagawa, 765-0052,JapanJapan',1),('00:04:1F','Sony Computer Entertainment, Inc.','Sony Computer Entertainment, Inc.2-6-21 Minami-aoyamaMinato-ku Tokyo 107-0062Japan',1),('00:04:20','Slim Devices, Inc.','Slim Devices, Inc.12 South First St.Suite 103San Jose Ca 95113United States',1),('00:04:21','Ocular Networks','Ocular Networks12700, Fair Lakes CircleSuite 100Fairfax Va 22033United States',1),('00:04:22','Gordon Kapes, Inc.','Gordon Kapes, Inc.5520 W. Touhy Ave.Skokie Il 60077United States',1),('00:04:23','Intel Corporation','Intel CorporationMs:  Jf3-4202111 Ne 25th AvenueHillsboro Or 97124United States',1),('00:04:24','Tmc S.r.l.','Tmc S.r.l.202 Via A. Costa40134 - BolognaItalyItaly',1),('00:04:25','Atmel Corporation','Atmel CorporationMultimedia & Communications Group2200 Gateway Centre, Suite 201Morrisville Nc 27560United States',1),('00:04:26','Autosys','Autosys202 Ilsinpastel,721-2 Mok3-dong Yang Cheon-ku,Seoul Seoul KoreaKorea, Republic Of',1),('00:04:27','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:28','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:29','Pixord Corporation','Pixord CorporationRoom 3, 1f, No. 1396,Chung Cheng Rd. Taoyuan City, Taoyuan HsTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:04:2A','Wireless Networks, Inc.','Wireless Networks, Inc.2322 El Camino RealSan Mateo Ca 94403United States',1),('00:04:2B','It Access Co., Ltd.','It Access Co., Ltd.3-17-6, Shinyokohama, Kouhoku-kuYokohama-shi, Kanagawa 222-8545JapanJapan',1),('00:04:2C','Minet, Inc.','Minet, Inc.3f Se-a Venture Tower946-12 Daechi-dong, Gangnam-gu, SeoulKoreaKorea, Republic Of',1),('00:04:2D','Sarian Systems, Ltd.','Sarian Systems, Ltd.Beacon HouseRiverside Business Park  Leeds Road, IlkWest Yorkshire England Ls29 8jzUnited Kingdom',1),('00:04:2E','Netous Technologies, Ltd.','Netous Technologies, Ltd.1006, Block A,Goodview Industrial Building, Kin Fat StHong KongHong Kong',1),('00:04:2F','International Communications Products, Inc.','International Communications Products, Inc.4325 Woodland Park DriveSuite 101West Melbourne Fl 32904United States',1),('00:04:30','Netgem','Netgem27 Rue Dorleans92 200 Neuillt S/seineFranceFrance',1),('00:04:31','Globalstreams, Inc.','Globalstreams, Inc.2882 Prospect Park DriveSuite 350Rancho Cordova Ca 95670United States',1),('00:04:32','Voyetra Turtle Beach, Inc.','Voyetra Turtle Beach, Inc.5 Odell PlazaYonkers Ny 10701United States',1),('00:04:33','Cyberboard A/s','Cyberboard A/sKloevermarken 120Dk-7190 BillundDenmarkDenmark',1),('00:04:34','Accelent Systems, Inc.','Accelent Systems, Inc.2620 Ridgewood Rd.,Suite 300Akron Oh 44313United States',1),('00:04:35','Comptek International, Inc.','Comptek International, Inc.11 Beacon St.Boston Ma 02108United States',1),('00:04:36','Elansat Technologies, Inc.','Elansat Technologies, Inc.No. 11, Lane 19, Pateh Road,Hsinchu Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:04:37','Powin Information Technology, Inc.','Powin Information Technology, Inc.8f, No. 70, Zhou-z St.114 Nei-hu TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:04:38','Nortel Networks','Nortel NetworksDepartment 68008200 Dixie Road, Suite 100 Brampton, OnCanadaCanada',1),('00:04:39','Rosco Entertainment Technology, Inc.','Rosco Entertainment Technology, Inc.2181 Nw Front Ave.Portland Or 97209United States',1),('00:04:3A','Intelligent Telecommunications, Inc.','Intelligent Telecommunications, Inc.1687-2, Sinil-dongDaedok-gu, TaejonSouth Korea 306-230Korea, Republic Of',1),('00:04:3B','Lava Computer Mfg., Inc.','Lava Computer Mfg., Inc.2 Vulcan St.Etobicoke, OntarioCanada M9w-1l2Canada',1),('00:04:3C','Sonos Co., Ltd.','Sonos Co., Ltd.#725 Pungsan Apt. Factory1141-2 Baikseok, Ilsan, Goyang, GyeonggiRep. Of Korea Zip Code: 411-815Korea, Republic Of',1),('00:04:3D','Indel Ag','Indel AgTufiwis 26Ch-8332 RussikonSwitzerlandSwitzerland',1),('00:04:3E','Telencomm','Telencomm2551 Walsh AvenueSanta Clara Ca 95051United States',1),('00:04:3F','Electronic Systems Technology, Inc.','Electronic Systems Technology, Inc.415 N. Quay St., Suite 4Kennewick Wa 99336United States',1),('00:04:40','Cyberpixie, Inc.','Cyberpixie, Inc.68 E. Wacker Place,Suite 600Chicago Il 60601United States',1),('00:04:41','Half Dome Systems, Inc.','Half Dome Systems, Inc.155 B-1 Moffet Park DriveSunnyvale Ca 94089United States',1),('00:04:42','Nact','Nact191 W. 5200 N.Provo Ut 84604United States',1),('00:04:43','Agilent Technologies, Inc.','Agilent Technologies, Inc.5301 Stevens Creek BoulevardMailstop 54l-sqSanta Clara Ca 95051United States',1),('00:04:44','Western Multiplex Corporation','Western Multiplex Corporation1196 Borregas AvenueSuite 500Sunnyvale Ca 94089United States',1),('00:04:45','Lms Skalar Instruments Gmbh','Lms Skalar Instruments GmbhWilli-eichler-str 11D-37079 GoettingenGermanyGermany',1),('00:04:46','Cyzentech Co., Ltd.','Cyzentech Co., Ltd.601 Eunkyeong B/d 141-31,Samsung-dong, Gangnam-gu, Seoul,135-876 KoreaKorea, Republic Of',1),('00:04:47','Acrowave Systems Co., Ltd.','Acrowave Systems Co., Ltd.Maru B/d 86-6, Nonhyun-dongGangnam-gu, SeoulKorea Zip: 135-818Korea, Republic Of',1),('00:04:48','Polaroid Corporation','Polaroid Corporation300 Baker AvenueConcord Ma 01742United States',1),('00:04:49','Mapletree Networks','Mapletree Networks315 Norwood Park SouthNorwood Ma 02062United States',1),('00:04:4A','Ipolicy Networks, Inc.','Ipolicy Networks, Inc.47467 Fremont Blvd.Fremont Ca 94538United States',1),('00:04:4B','Nvidia','Nvidia3535 Monroe St.Santa Clara Ca 95051United States',1),('00:04:4C','Jenoptik','JenoptikLaser, Optik, Systeme GmbhEinkauf, Prussingstr. 41 D-07745 JenaGermanyGermany',1),('00:04:4D','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:4E','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:4F','Leukhardt Systemelektronik Gmbh','Leukhardt Systemelektronik GmbhRudolf-diesel-str. 1778532 TuttlingenGermanyGermany',1),('00:04:50','Dmd Computers Srl','Dmd Computers SrlVia Monviso, 1410090 Villarbasse (to)ItalyItaly',1),('00:04:51','Medrad, Inc.','Medrad, Inc.One Medrad DriveIndianola Pa 15051United States',1),('00:04:52','Rocketlogix, Inc.','Rocketlogix, Inc.6504 International ParkwaySuite 1200Plano Tx 75093United States',1),('00:04:53','Yottayotta, Inc.','Yottayotta, Inc.6020- 104 StreetEdmonton, Ab  T6h 5s4Canada',1),('00:04:54','Quadriga Uk','Quadriga UkBaird HouseArlington Business Park Theale Reading REnglandUnited Kingdom',1),('00:04:55','Antara.net','Antara.net747 Camden Ave.Suite ACampbell Ca 95008United States',1),('00:04:56','Motorola Ptp Inc','Motorola Ptp IncUnit 1a, Linhay Business Park,Eastern Road,Ashburton Devon Tq13 7upUnited Kingdom',1),('00:04:57','Universal Access Technology, Inc.','Universal Access Technology, Inc.2 Fl., No. 5, Alley 22,Lane 513, Jui Kuang Road,Nei Hu Taipei, Taiwan 114Taiwan, Republic Of China',1),('00:04:58','Fusion X Co., Ltd.','Fusion X Co., Ltd.#905 Hansol Techno Town16-1 Dang-jung Dong Kun-po Kyung-ki Do KZip 435-030Korea, Republic Of',1),('00:04:59','Veristar Corporation','Veristar Corporation727 Allston WayBerkeley Ca 94710United States',1),('00:04:5A','The Linksys Group, Inc.','The Linksys Group, Inc.17401 Armstrong Ave.Irvine Ca 92614United States',1),('00:04:5B','Techsan Electronics Co., Ltd.','Techsan Electronics Co., Ltd.North Wing43 High Street Fareham, Hants P016 7bqUnited KingdomUnited Kingdom',1),('00:04:5C','Mobiwave Pte Ltd','Mobiwave Pte LtdBlk 16, Kallang Place#07-01/04339156Singapore',1),('00:04:5D','Beka Elektronik','Beka ElektronikSiemenstrasse 29Erftstadt 50374Germany',1),('00:04:5E','Polytrax Information Technology Ag','Polytrax Information Technology AgMartin-kollar - Str. 5D-81829 MunchenGermanyGermany',1),('00:04:5F','Evalue Technology, Inc.','Evalue Technology, Inc.5f-7, No. 130, Chien Kang Road,Chung Ho City, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:04:60','Knilink Technology, Inc.','Knilink Technology, Inc.10f, #96, Hsin Tai Wu Rd.,Sec. 1, Hsi Chih, Taipei Hsien,TaiwanTaiwan, Republic Of China',1),('00:04:61','Epox Computer Co., Ltd.','Epox Computer Co., Ltd.11f, #346, Chung San Rd.Sec. 2, Chung Ho City, Taipei Hsien 235Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:04:62','Dakos Data & Communication Co., Ltd.','Dakos Data & Communication Co., Ltd.2nd Floor Bethel Building 324-1Yangjae-dong Seocho-gu Seoul R.o.k.Zip Code: 137-130Taiwan, Republic Of China',1),('00:04:63','Bosch Security Systems','Bosch Security Systems850 Greenfield RoadLancaster Pa 17601-5874United States',1),('00:04:64','Fantasma Networks, Inc.','Fantasma Networks, Inc.3250 Ash StreetPalo Alto Ca 94306United States',1),('00:04:65','I.s.t Isdn-support Technik Gmbh','I.s.t Isdn-support Technik GmbhRhein Strasse 7e14513 TeltowGermanyGermany',1),('00:04:66','Armitel Co.','Armitel Co.F5, Doman Plaza 353-4,Yatap-dong, Pudang-ku, Seong-name Si, KyRepublic Of KoreaKorea, Republic Of',1),('00:04:67','Wuhan Research Institute Of Mii','Wuhan Research Institute Of Mii88 Youkeyuan Road,Hangshan District,wuhan, Hubei Province,430074 430074 P.r.chinaChina',1),('00:04:68','Vivity, Inc.','Vivity, Inc.3360 Mitchell LaneBoulder Co 80301United States',1),('00:04:69','Innocom, Inc.','Innocom, Inc.655-2 Naebalsan-dongKangseo-gu, Seoul157-280 157-280 KoreaKorea, Republic Of',1),('00:04:6A','Navini Networks','Navini Networks3605 E. Plano Pkwy,Suite 400,Plano Tx 75074United States',1),('00:04:6B','Palm Wireless, Inc.','Palm Wireless, Inc.48933 Warm Springs Blvd.Fremont Ca 94539United States',1),('00:04:6C','Cyber Technology Co., Ltd.','Cyber Technology Co., Ltd.1-45 Yeo Wol-dongOh Jung-em, Bu Cheon City,Kyeong Gi-do Kyeong Gi-do KoreaKorea, Republic Of',1),('00:04:6D','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:6E','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:6F','Digitel S/a Industria Eletronica','Digitel S/a Industria EletronicaR. Doutor Joao Ignacio, 1165Porto Alegre, Rs. BrazilZip: 90230.181Brazil',1),('00:04:70','Ipunplugged Ab','Ipunplugged AbBox 10160Se 121 28 Stockholm-globsenSwedenSweden',1),('00:04:71','Iprad','Iprad24 Raoul Wallenberg St.Tel-aviv 69719IsraelIsrael',1),('00:04:72','Telelynx, Inc.','Telelynx, Inc.3f-1, 66 Nankan Rd.,Sec. 2 Lu Chu, Tao-yuanTaiwanTaiwan, Republic Of China',1),('00:04:73','Photonex Corporation','Photonex Corporation8c Preston CourtBedford Ma 01730United States',1),('00:04:74','Legrand','Legrand145 Avenue De Lattre57045 LimogesFranceFrance',1),('00:04:75','3 Com Corporation','3 Com Corporation5400 Bayfront PlazaMs:  4220Santa Clara Ca 95052United States',1),('00:04:76','3 Com Corporation','3 Com Corporation5400 Bayfront PlazaMs:  4220Santa Clara Ca 95052United States',1),('00:04:77','Scalant Systems, Inc.','Scalant Systems, Inc.2040 Martin AvenueSanta Clara Ca 95050United States',1),('00:04:78','G. Star Technology Corporation','G. Star Technology Corporation4th Floor, No. 118, Sector 2Chung Hsiao East RoadTaipei City Taipei City TaiwanTaiwan, Republic Of China',1),('00:04:79','Radius Co., Ltd.','Radius Co., Ltd.1-48-11, ItabashiRoje Bldg., No. 3, 6f Itabashi-ku, TokyoJapanJapan',1),('00:04:7A','Axxessit Asa','Axxessit AsaAxxessit Asa HaldenBox 1053 1787 Berg I OstfoldNorwayNorway',1),('00:04:7B','Schlumberger','SchlumbergerSugar Land Product Center110 Schlumberger DriveSugar Land Tx 77478United States',1),('00:04:7C','Skidata Ag','Skidata AgT-697553 Untersbergstr. 40A-5083 GartenauAustriaAustria',1),('00:04:7D','Pelco','Pelco3500 Pelco WayClovis Ca 93612United States',1),('00:04:7E','Optelecom=nkf','Optelecom=nkfZuidelijk Halfrond 112801 Dd GoudaNetherlands',1),('00:04:7F','Chr. Mayr Gmbh & Co. Kg','Chr. Mayr Gmbh & Co. KgEichenstrasse 1D-87665 MauerstettenGermanyGermany',1),('00:04:80','Foundry Networks, Inc.','Foundry Networks, Inc.2100 Gold St.Po Box 649100San Jose Ca 95164-9100United States',1),('00:04:81','Econolite Control Products, Inc.','Econolite Control Products, Inc.3360 E. La Palma Ave.Anaheim Ca 92806United States',1),('00:04:82','Medialogic Corp.','Medialogic Corp.0-3, Toyamaken-sangyouKoudoka-center, 5, Office Park, Takaoka-JapanJapan',1),('00:04:83','Deltron Technology, Inc.','Deltron Technology, Inc.8f-3, No. 125, Lane 235Pao-chiao Rd., Hsintien,Taipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:04:84','Amann Gmbh','Amann GmbhUnteranger 6D-82041 OberhachingGermanyGermany',1),('00:04:85','Picolight','Picolight4665 Nautilus Court SouthBoulder Co 80301United States',1),('00:04:86','Ittc, University Of Kansas','Ittc, University Of Kansas2335 Irving Hill Rd.Lawrence Ks 66045United States',1),('00:04:87','Cogency Semiconductor, Inc.','Cogency Semiconductor, Inc.362 Terry Fox Drive, Suite 210Kanata, On, K2k 2p5CanadaCanada',1),('00:04:88','Eurotherm Controls','Eurotherm Controls741f Miller DriveLessburg Va 20175United States',1),('00:04:89','Yafo Networks, Inc.','Yafo Networks, Inc.1340f Charwood Rd.Hanover Md 21076United States',1),('00:04:8A','Temia Vertriebs Gmbh','Temia Vertriebs GmbhLandsbergerstr. 320D-80687 MunichGermanyUnited States',1),('00:04:8B','Poscon Corporation','Poscon Corporation#606 Ho-dong, Nam Gu,Pohang City, Kyungbuk,South KoreaKorea, Republic Of',1),('00:04:8C','Nayna Networks, Inc.','Nayna Networks, Inc.157 Topaz St.Milpitas Ca 95035United States',1),('00:04:8D','Tone Commander Systems, Inc.','Tone Commander Systems, Inc.11609 49th Place WestMukilteo Wa 98275United States',1),('00:04:8E','Ohm Tech Labs, Inc.','Ohm Tech Labs, Inc.141 Lanza Ave., B-12Garfield Nj 07026United States',1),('00:04:8F','Td Systems Corporation','Td Systems Corporation100 Bearfoot Rd.64 Ontario DriveHudson Ma 01749United States',1),('00:04:90','Optical Access','Optical AccessP.o. Box 114Yokneam, 20692IsraelIsrael',1),('00:04:91','Technovision, Inc.','Technovision, Inc.5155 Spectrum Way, Unit #31Mississauga, OntarioL4w 5a1 CanadaCanada',1),('00:04:92','Hive Internet, Ltd.','Hive Internet, Ltd.Unit 2, Church View Business CentreLouth RoadBinbrook Market Rasen, Lincolnshire Ln8 6byUnited Kingdom',1),('00:04:93','Tsinghua Unisplendour Co., Ltd.','Tsinghua Unisplendour Co., Ltd.Th-unis Building TsinghuaUniversity, Bejing 100084P.r. ChinaChina',1),('00:04:94','Breezecom, Ltd.','Breezecom, Ltd.Atidim Technology ParkBldg. 1, P.o.b. 13139 Tel-aviv 61131IsraelIsrael',1),('00:04:95','Tejas Networks','Tejas Networks1st Floor, Zone 2Khanija Bhavan 49, Race Course RoadBangalore - 560001 IndiaIndia',1),('00:04:96','Extreme Networks','Extreme Networks3585 Monroe St.Santa Clara Ca 95051United States',1),('00:04:97','Macrosystem Digital Video Ag','Macrosystem Digital Video AgSchoellinger Feld 2858300 Wetter, F.r.GermanyGermany',1),('00:04:98','Mahi Networks','Mahi Networks1039 N. Mcdowell Blvd.Petaluma Ca 94954United States',1),('00:04:99','Chino Corporation','Chino Corporation1 Mori, Fujioka City,Gunma Pref. JapanZip: 375-8505Japan',1),('00:04:9A','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:9B','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:9C','Surgient Networks, Inc.','Surgient Networks, Inc.3520 Executive Center DriveSuite 300Austin Tx 78731United States',1),('00:04:9D','Ipanema Technologies','Ipanema Technologies28, Rue De La Redoute92260 Fontenay Aux RosesFranceFrance',1),('00:04:9E','Wirelink Co., Ltd.','Wirelink Co., Ltd.11f, Geoseong B/d 541, Dowha-dong,Mapo-gu, Seoul, 121-701,KoreaKorea, Republic Of',1),('00:04:9F','Freescale Semiconductor','Freescale Semiconductor7700 West Parmer LaneMd Pl59Austin Tx 78729United States',1),('00:04:A0','Verity Instruments, Inc.','Verity Instruments, Inc.2901 Eisenhower St.Carrollton Tx 75007United States',1),('00:04:A1','Pathway Connectivity','Pathway Connectivity1439-17 Avenue SeCalgary Alberta T2g 1j9Canada',1),('00:04:A2','L.s.i. Japan Co., Ltd.','L.s.i. Japan Co., Ltd.1-8-14 Sendagaya Shibuya-kuTokyo 151-0051 JapanJapan',1),('00:04:A3','Microchip Technology, Inc.','Microchip Technology, Inc.2355 W. Chandler Blvd.Chandler Az 85224United States',1),('00:04:A4','Netenabled, Inc.','Netenabled, Inc.1275 Kinnear Rd.Columbus Oh 43212United States',1),('00:04:A5','Barco Projection Systems Nv','Barco Projection Systems NvNoordlaan 5B8520 KuurneBelgiumBelgium',1),('00:04:A6','Saf Tehnika Ltd.','Saf Tehnika Ltd.91 Dzirnavu Str.,Riga, Lv-1011,LatviaLatvia',1),('00:04:A7','Fabiatech Corporation','Fabiatech Corporation4f-3, No. 18, Lane 609Chung-hsin Rd., Sec. 5 San Chung City,Taipei Hsien, Taiwan R.o.cTaiwan, Republic Of China',1),('00:04:A8','Broadmax Technologies, Inc.','Broadmax Technologies, Inc.180, Wai Yip Street,Hwun Tong,Hong KongHong Kong',1),('00:04:A9','Sandstream Technologies, Inc.','Sandstream Technologies, Inc.1955 Lakeway Dr.Lewisville Tx 75057United States',1),('00:04:AA','Jetstream Communications','Jetstream Communications5400 Hellyer AvenueSan Jose Ca 95138-1005United States',1),('00:04:AB','Comverse Network Systems, Inc.','Comverse Network Systems, Inc.29 Habarzel Street.Tel-aviv 69710IsraelIsrael',1),('00:04:AC','Ibm Corp.','Ibm Corp.P.o. Box 12195Ce6a/664 3039 CornwallisRtp Nc 27709-2195United States',1),('00:04:AD','Malibu Networks','Malibu Networks26637 Agoura Rd.Calabasas Ca 91302United States',1),('00:04:AE','Sullair Corporation','Sullair Corporation3700 East Michigan BlvdMichigan City In 46360United States',1),('00:04:AF','Digital Fountain, Inc.','Digital Fountain, Inc.600 Alabama St.San Francisco Ca 94110United States',1),('00:04:B0','Elesign Co., Ltd.','Elesign Co., Ltd.9fl. Taekyoung Bldg.,42-42 Bongchun-dong Kwanak-gu, Seoul,R.o. KoreaKorea, Republic Of',1),('00:04:B1','Signal Technology, Inc.','Signal Technology, Inc.3rd. Fl. Dabo Bldg.37-2 Koyo SongpaSeoul Korea 138-110Korea, Republic Of',1),('00:04:B2','Essegi Srl','Essegi SrlVia Del Cavaratori, 1720092 Cinisello B. (m1)ItalyItaly',1),('00:04:B3','Videotek, Inc.','Videotek, Inc.243 Shoemaker Rd.Pottstown Pa 19464United States',1),('00:04:B4','Ciac','Ciac18 Rue Joseph Bara92130 Issy-les-molineauxFranceFrance',1),('00:04:B5','Equitrac Corporation','Equitrac Corporation1905 N.w. 82nd AvenueMiami Fl 33126United States',1),('00:04:B6','Stratex Networks, Inc.','Stratex Networks, Inc.64 White RoadRetreat,Cape Town  7945South Africa',1),('00:04:B7','Amb I.t. Holding','Amb I.t. HoldingZuiderhoutlaan 4Pj Haarlem 2012Netherlands',1),('00:04:B8','Kumahira Co., Ltd.','Kumahira Co., Ltd.4-34 Ujinahigashi 2-chomeMinamiku HiroshimaJapan 734-8567Japan',1),('00:04:B9','S.i. Soubou, Inc.','S.i. Soubou, Inc.Kubo Bldg., 703, 2-12,Nanpeidai-cho, Shibuya-ku,Tokyo Tokyo JapanJapan',1),('00:04:BA','Kdd Media Will Corporation','Kdd Media Will Corporation2-1-23 NakameguroMeguro-ku Tokyo153-0061 JapanJapan',1),('00:04:BB','Bardac Corporation','Bardac Corporation40 Log Canoe CircleStevensville Md 21666United States',1),('00:04:BC','Giantec, Inc.','Giantec, Inc.4f, No. 3, Lane 123,Pao Chung Rd., Hsien Tien City, TaipeiTaiwan 231 Taiwan 231 R.o.c.Taiwan, Republic Of China',1),('00:04:BD','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:04:BE','Optxcon, Inc.','Optxcon, Inc.P.o. Box 13449Research Triangle Park Nc 27709-3449United States',1),('00:04:BF','Versalogic Corp.','Versalogic Corp.3888 Stewart Rd.Eugene Or 97402United States',1),('00:04:C0','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:C1','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:C2','Magnipix, Inc.','Magnipix, Inc.3539 St-charles Blvd., Suite 212Kirkland (quebec)Canada H9h3c4Canada',1),('00:04:C3','Castor Informatique','Castor Informatique2, Rue Du KefirSenia 34394537 Orly Cedex FranceFrance',1),('00:04:C4','Allen & Heath Limited','Allen & Heath LimitedKernick Industrial Estate, PenrynCornwall England Tr10 9luUnited Kingdom',1),('00:04:C5','Ase Technologies, Usa','Ase Technologies, Usa6721 Baum Dr.Knoxville Tn 37919United States',1),('00:04:C6','Yamaha Motor Co., Ltd.','Yamaha Motor Co., Ltd.Information System Division2500 Shingai Iwata, ShizuokaJapan Zip: 438-8501Japan',1),('00:04:C7','Netmount','NetmountP.o.b. 2325Kadima 60920IsraelIsrael',1),('00:04:C8','Liba Maschinenfabrik Gmbh','Liba Maschinenfabrik GmbhPo Box 1120D95112 NailaGermanyGermany',1),('00:04:C9','Micro Electron Co., Ltd.','Micro Electron Co., Ltd.2f Ibanaki-tanaka Bldg.1-1-59 Nakahodumi Ibaraki-shi, Osaka 567JapanJapan',1),('00:04:CA','Freems Corp.','Freems Corp.Shinhan Bldg. 6f,45-11 Yoido-dong, Youngdeungpo-ku,Seoul 150-736 KoreaKorea, Republic Of',1),('00:04:CB','Tdsoft Communication, Ltd.','Tdsoft Communication, Ltd.60 Medinat Hayehudim St.Herzlia 46766IsraelIsrael',1),('00:04:CC','Peek Traffic B.v.','Peek Traffic B.v.Postbus 25423800 Gb AmersfootThe NetherlandsNetherlands',1),('00:04:CD','Informedia Research Group','Informedia Research Group390 St-vallier EastSuite 203Quebec Pq G1k 3p6 CanadaCanada',1),('00:04:CE','Patria Ailon','Patria AilonNaulakatu 3Fin-33100 TampereFinlandFinland',1),('00:04:CF','Seagate Technology','Seagate Technology1280 Disc DriveShakopee Mn 55379United States',1),('00:04:D0','Softlink S.r.o.','Softlink S.r.o.Tomkova 409Kralupy N. VltavouCzech RepublicCzech Republic',1),('00:04:D1','Drew Technologies, Inc.','Drew Technologies, Inc.3915 Research Park DrSuite A10Ann Arbor Mi 48108United States',1),('00:04:D2','Adcon Telemetry Gmbh','Adcon Telemetry GmbhInkustr. 24A-3400 KlosterneuburgAustria',1),('00:04:D3','Toyokeiki Co., Ltd.','Toyokeiki Co., Ltd.Wada 3967-10, Matsumoto-cityNagano 390-1298,JapanJapan',1),('00:04:D4','Proview Electronics Co., Ltd.','Proview Electronics Co., Ltd.6f, No. 1, Pau-sheng RoadYung Ho City, Taipei,TaiwanTaiwan, Republic Of China',1),('00:04:D5','Hitachi Information & Communication Engineering, Ltd.','Hitachi Information & Communication Engineering, Ltd.Queens Tower B21f, 2-3-3, Minatomirai,Nishi-ku, Yokohama, 220-6121Japan',1),('00:04:D6','Takagi Industrial Co., Ltd.','Takagi Industrial Co., Ltd.Electronic Instrument Div.3508, Kamiide-mikaeshi, Eujinomiya-shi,418-0103 418-0103 JapanJapan',1),('00:04:D7','Omitec Instrumentation Ltd.','Omitec Instrumentation Ltd.Hopton Industrial Est.London Rd., Devizes Wiltshire Sn10 2euEnglandUnited Kingdom',1),('00:04:D8','Ipwireless, Inc.','Ipwireless, Inc.4 Landsowne CourtBumpers Way Chippenham, Wiltshire,Sn14 Grz UkUnited Kingdom',1),('00:04:D9','Titan Electronics, Inc.','Titan Electronics, Inc.Rm 7, 11 Fl., No. 398,Huan-pei Road, Chung-li,Taoyuan Taoyuan TaiwanTaiwan, Republic Of China',1),('00:04:DA','Relax Technology, Inc.','Relax Technology, Inc.Dba/ Granite Digital3101 Whipple RoadUnion City Ca 94587United States',1),('00:04:DB','Tellus Group Corp.','Tellus Group Corp.4f, No. 15 Industry E. Rd., IxScience-based Industrial ParkHsinchu Hsinchu TaiwanTaiwan, Republic Of China',1),('00:04:DC','Nortel Networks','Nortel NetworksDepartment 68008200 Dixie Road, Suite 100 Brapton On L6CanadaCanada',1),('00:04:DD','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:DE','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:04:DF','Teracom Telematica Ltda.','Teracom Telematica Ltda.R. Felipe Neri, 246 Cj. 30190440-150 Porto Allegre RsBazilBrazil',1),('00:04:E0','Procket Networks','Procket Networks1100 Cadillac CourtMilpitas Ca 95035United States',1),('00:04:E1','Infinior Microsystems','Infinior Microsystems2f, Accufar Bldg, 234-10,Jamsil-dong, Songpa-guSeoul Korea 138-220Korea, Republic Of',1),('00:04:E2','Smc Networks, Inc.','Smc Networks, Inc.6 HughesIrvine Ca 92618United States',1),('00:04:E3','Accton Technology Corp.','Accton Technology Corp.No. 1 Creation Rd. Iii,SbipHsinchu Hsinchu TaiwanTaiwan, Republic Of China',1),('00:04:E4','Daeryung Ind., Inc.','Daeryung Ind., Inc.#219-6, Kasan Dong,Kumchun Ku,Seoul Seoul KoreaKorea, Republic Of',1),('00:04:E5','Glonet Systems, Inc.','Glonet Systems, Inc.11fl., Jeil Bldg., 94-46, 7kaYoungdungpo-dong Yongdungpo-ku Seoul, 15KoreaKorea, Republic Of',1),('00:04:E6','Banyan Network Private Limited','Banyan Network Private Limited443, 8th Floor, Guna ComplexAnnasalai, Chennai-600 018IndiaIndia',1),('00:04:E7','Lightpointe Communications, Inc','Lightpointe Communications, Inc10140 Barnes Canyon RoadSan Diego Ca 92121United States',1),('00:04:E8','Ier, Inc.','Ier, Inc.4501 So. General Bruce DrSuite 50Temple Tx 76502United States',1),('00:04:E9','Infiniswitch Corporation','Infiniswitch Corporation134 Flanders RoadWestborough Ma 01581United States',1),('00:04:EA','Hewlett-packard Company','Hewlett-packard Company11000 Wolfe Road, Mailstop 42leCupertino Ca 95014United States',1),('00:04:EB','Paxonet Communications, Inc.','Paxonet Communications, Inc.4046 Clipper CourtFremont Ca 94538United States',1),('00:04:EC','Memobox Sa','Memobox Sa1, Place Dame Suzanne91190 Saint AubinFranceFrance',1),('00:04:ED','Billion Electric Co., Ltd.','Billion Electric Co., Ltd.8f, No.192, Sec.2, Chung Hsing Rd.,Hsin Tien City, Taipei HsienTaiwan Taiwan RocTaiwan, Republic Of China',1),('00:04:EE','Lincoln Electric Company','Lincoln Electric Company22801 St. Clair AvenueCleveland Oh 44117-1199United States',1),('00:04:EF','Polestar Corp.','Polestar Corp.Rm #802 Seogeon B/d, 1480,Gwanyang-dong, Dongan-gu, Anyang City, 4Korea (rok)Korea, Republic Of',1),('00:04:F0','International Computers, Ltd','International Computers, Ltd1 Wenlock WayWest Gorton Manchester, M12 5drUkUnited Kingdom',1),('00:04:F1','Wherenet','Wherenet107 W. Mckinney AvenueRogersville Tn 37857United States',1),('00:04:F2','Polycom','Polycom1000 West 14th StreetNorth Vancouver, B.c.Canada V7p3p3Canada',1),('00:04:F3','Fs Forth-systeme Gmbh','Fs Forth-systeme GmbhKueferstr. 8D-79206 BreisachGermanyGermany',1),('00:04:F4','Infinite Electronics Inc.','Infinite Electronics Inc.No.478-1, Sec 2Ching Hai Road 407, Tai ChungTaiwan, Republic Of China',1),('00:04:F5','Snowshore Networks, Inc.','Snowshore Networks, Inc.285 Billerica RoadChelmsford Ma 01824United States',1),('00:04:F6','Amphus','Amphus2372 Qume Drive, #fSan Jose Ca 95131United States',1),('00:04:F7','Omega Band, Inc.','Omega Band, Inc.9020-i Capital Of Texas Hghwy NSuite #270Austin Tx 78759United States',1),('00:04:F8','Qualicable Tv Industria E Com., Ltda','Qualicable Tv Industria E Com., LtdaAv. Joao Paulo Ablas, 308Jardim Da Gloria - Cotia -sp Cep 06711-2Brazil',1),('00:04:F9','Xtera Communications, Inc.','Xtera Communications, Inc.500 W Bethany DriveAllen Tx 75013United States',1),('00:04:FA','Nbs Technologies Inc.','Nbs Technologies Inc.703 Evans Avenue, Suite 400TorontoOntario  M9c 5e9Canada',1),('00:04:FB','Commtech, Inc.','Commtech, Inc.9011 E. 37th StreetWichita Ks 67226-2006United States',1),('00:04:FC','Stratus Computer (de), Inc.','Stratus Computer (de), Inc.111 Powdermill RoadMaynard Ma 01754United States',1),('00:04:FD','Japan Control Engineering Co., Ltd.','Japan Control Engineering Co., Ltd.1-5-1, Higashiamagawa, Takatsuki-shiOsaka 569-0012Japan',1),('00:04:FE','Pelago Networks','Pelago Networks701 E. Plano Parkway - Ste. #205Plano Tx 75074United States',1),('00:04:FF','Acronet Co., Ltd.','Acronet Co., Ltd.Saman B/d 2fl811-15 Bangbae-dong Seocho-ku, Seoul137-064Korea, Republic Of',1),('00:05:00','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:01','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:02','Apple Computer','Apple Computer20650 Valley Green DriveCupertino Ca 95014United States',1),('00:05:03','Iconag','IconagAm Bahnhof 255765 BirkenfeldGermany',1),('00:05:04','Naray Information & Communication Enterprise','Naray Information & Communication Enterprise3f San Woo Bldg., 1543-11Seocho-dong, Seocho-ku,Seoul 137-070Korea, Republic Of',1),('00:05:05','Systems Integration Solutions, Inc.','Systems Integration Solutions, Inc.3922 Coconut Palm Drive,Suite 106Tampa Fl 33619United States',1),('00:05:06','Reddo Networks Ab','Reddo Networks AbLivdjursgatan 4Se 121 62 JohanneshovSweden',1),('00:05:07','Fine Appliance Corp.','Fine Appliance Corp.7fl., No. 499,Chung-cheng Rd., Hsintien, TaipeiTaiwan, Republic Of China',1),('00:05:08','Inetcam, Inc.','Inetcam, Inc.10171 Pacific Mesa Blvd.San Diego Ca 92121United States',1),('00:05:09','Avoc Nishimura Ltd.','Avoc Nishimura Ltd.Jogasaki 4-16-14Miyazaki-city, Miyazaki 880-0917,Japan',1),('00:05:0A','Ics Spa','Ics SpaVia Romano Al10010 Scarmagno (to)Italy',1),('00:05:0B','Sicom Systems, Inc.','Sicom Systems, Inc.4140 Skyron DriveDoylestown Pa 18901United States',1),('00:05:0C','Network Photonics, Inc.','Network Photonics, Inc.451 Aviation BoulevardSanta Rosa Ca 95403United States',1),('00:05:0D','Midstream Technologies, Inc.','Midstream Technologies, Inc.777 108th Ave. NeSuite 1700Bellevue Wa 98004-5140United States',1),('00:05:0E','3ware, Inc.','3ware, Inc.701 E. Middlefield Rd.Suite 300Mt. View Ca 94043United States',1),('00:05:0F','Tanaka S/s Ltd.','Tanaka S/s Ltd.1942 Nomura HirookaShiojiri-cityNagano 399-0702Japan',1),('00:05:10','Infinite Shanghai Communication Terminals Ltd.','Infinite Shanghai Communication Terminals Ltd.777 Chungiao Road, PudongShanghai 201206,China',1),('00:05:11','Complementary Technologies Ltd','Complementary Technologies LtdComtech House, 28 Manchester RoadWesthoughton BoltonBl5 3qjUnited Kingdom',1),('00:05:12','Meshnetworks, Inc.','Meshnetworks, Inc.485 Keller Rd., Suite 250Maitland Fl 32751-7535United States',1),('00:05:13','Vtlinx Multimedia Systems, Inc.','Vtlinx Multimedia Systems, Inc.8401 Colesville Road,Suite 750Silver Spring Md 20910United States',1),('00:05:14','Kdt Systems Co., Ltd.','Kdt Systems Co., Ltd.102-6, Chobu-li, Mohyun-myun,Yongin-city, Kyungki-do,Korea, Republic Of',1),('00:05:15','Nuark Co., Ltd.','Nuark Co., Ltd.12f, Anyang K Center, 1591-9, Burim-dongDongan-gu, Anyang-si,Gunggi-do 431-065Korea, Republic Of',1),('00:05:16','Smart Modular Technologies','Smart Modular Technologies4305 Cushing PkwyFremont Ca 94538United States',1),('00:05:17','Shellcomm, Inc.','Shellcomm, Inc.Rm #6122 Etri Tbi Center, 1,Eoeun-dong, Yusong-gu, Taejon, 305-333,Korea, Republic Of',1),('00:05:18','Jupiters Technology','Jupiters TechnologyPo Box 12693Elizabeth Street Brisbane Qld 4002Australia',1),('00:05:19','Siemens Building Technologies Ag,','Siemens Building Technologies Ag,Cerberus DivisionAlte Landstrasse 411 Ch-8708 MaennedorfSwitzerland',1),('00:05:1A','3com Europe Ltd.','3com Europe Ltd.3com Centre, Boundary Way,Hempstead, Herts, Hp2 7yuUnited Kingdom',1),('00:05:1B','Magic Control Technology Corporation','Magic Control Technology Corporation6f, No. 120-11 Chung Shan Rd.Sec 3, Chung Ho TaipeiTaiwan, Republic Of China',1),('00:05:1C','Xnet Technology Corp.','Xnet Technology Corp.9f-16, No. 12, Lane 609,Sec. 5, Chung Hsin Road, San Chung City,Taiwan, Republic Of China',1),('00:05:1D','Airocon, Inc.','Airocon, Inc.116 Houghton LaneBoxboro Ma 01719United States',1),('00:05:1E','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology DriveSan Jose Ca 95110United States',1),('00:05:1F','Taijin Media Co., Ltd.','Taijin Media Co., Ltd.640-8 Tungchon-dongKangseo-gu,Seoul  157-030Korea, Republic Of',1),('00:05:20','Smartronix, Inc.','Smartronix, Inc.22685 Three Notch Rd.California Md 20619United States',1),('00:05:21','Control Microsystems','Control Microsystems48 Steacie DriveOntario  K2k 2a9Canada',1),('00:05:22','Lea*d Corporation, Inc.','Lea*d Corporation, Inc.Advatech Bldg.Teradion Ind. Park D.n. Misgav, 20179Israel',1),('00:05:23','Avl List Gmbh','Avl List GmbhHans List Platz 1A-8020 GrazAustria',1),('00:05:24','Btl System (hk) Limited','Btl System (hk) Limited14/f., Blk. B, Vita Tower,29 Wong Chuk Hang Rd.,AberdeenHong Kong',1),('00:05:25','Puretek Industrial Co., Ltd.','Puretek Industrial Co., Ltd.No. 14, 4 Flr. Lane 235Pao Chiao Road Hsin Tien, Taipei HsienTaiwan, Republic Of China',1),('00:05:26','Ipas Gmbh','Ipas GmbhGrabenstr. 149a47057 DuisburgGermany',1),('00:05:27','Sj Tek Co. Ltd','Sj Tek Co. LtdHo Gae Dong 976-5, Dong An Ku,An Yang City, Kyung Kee Do,Korea, Republic Of',1),('00:05:28','New Focus, Inc.','New Focus, Inc.2630 Walsh Ave.Santa Clara Ca 95051United States',1),('00:05:29','Shanghai Broadan Communication Technology Co., Ltd','Shanghai Broadan Communication Technology Co., Ltd15f, Suntime International MansionNo. 450 Fushan Road, Pudong District, Sh200122China',1),('00:05:2A','Ikegami Tsushinki Co., Ltd.','Ikegami Tsushinki Co., Ltd.5-6-16 Ikegami Ohta-ku,Tokyo146-8567Japan',1),('00:05:2B','Horiba, Ltd.','Horiba, Ltd.2 Miyanohigashi, Kisshoin,Minami-ku, Kyoto601-8510Japan',1),('00:05:2C','Supreme Magic Corporation','Supreme Magic CorporationSun Towers Center Bldg., 13f2-11-22, Sangen-jaya, Setagaya-ku, Tokyo154-0024Japan',1),('00:05:2D','Zoltrix International Limited','Zoltrix International LimitedRoom 701 Po Hing Centre,18 Wan Chiu Road, Kowloon,Hong Kong',1),('00:05:2E','Cinta Networks','Cinta Networks3010 North First StreetSan Jose Ca 95134United States',1),('00:05:2F','Leviton Network Solutions','Leviton Network Solutions2222 222nd Street S.e.Bothell Wa 98021United States',1),('00:05:30','Andiamo Systems, Inc.','Andiamo Systems, Inc.14171 Teerlink WaySaratoga Ca 95070United States',1),('00:05:31','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:32','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:33','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology Dr.San Jose Ca 95110United States',1),('00:05:34','Northstar Engineering Ltd.','Northstar Engineering Ltd.P.o. Box 40Henley-on-thames Oxon Rg9 6aeUnited Kingdom',1),('00:05:35','Chip Pc Ltd.','Chip Pc Ltd.20 A.l. Motzkin St.Topaz House, Nahum Hat 5 , P.o. Box 4Tirat Carmel  39100Israel',1),('00:05:36','Danam Communications, Inc.','Danam Communications, Inc.900-3, Hokye-dong, Dongan-gu,Anyang, Kyungki-do, 431-082,Korea, Republic Of',1),('00:05:37','Nets Technology Co., Ltd.','Nets Technology Co., Ltd.#b1 Yungjun Bldg.154-10 Sansung-dong Kangnam-guSeoul 135-090  135-090Korea, Republic Of',1),('00:05:38','Merilus, Inc.','Merilus, Inc.#307-46165 Yale RoadChiliwack, BcV2p 2p2Canada',1),('00:05:39','A Brand New World In Sweden Ab','A Brand New World In Sweden AbBox 1223Se-164 28 KistaSweden',1),('00:05:3A','Willowglen Services Pte Ltd','Willowglen Services Pte Ltd151 Lorong Chuan,New Tech Park #05-07,556741Singapore',1),('00:05:3B','Harbour Networks Ltd., Co. Beijing','Harbour Networks Ltd., Co. Beijing13/f, Jiuling Building, No. 21,Xisanhuan North Rd., Beijing100089China',1),('00:05:3C','Xircom','Xircom2300 Corporate Center Dr.Thousand Oaks Ca 91320United States',1),('00:05:3D','Agere Systems','Agere Systems1371 Mccarthy Blvd.Milpitas Ca 95035United States',1),('00:05:3E','Kid Systeme Gmbh','Kid Systeme GmbhLuneburger Schanze 3021614 BuxtehudeGermany',1),('00:05:3F','Visiontek, Inc.','Visiontek, Inc.1175 Lakeside Dr.Gurnee Il 60031United States',1),('00:05:40','Fast Corporation','Fast Corporation2791-5 Shimo-tsurumaYamato Kanagawa242-0001Japan',1),('00:05:41','Advanced Systems Co., Ltd.','Advanced Systems Co., Ltd.2-9-7 Nishikicho,Tachikawa-shi, Tokyo190-0022Japan',1),('00:05:42','Otari, Inc.','Otari, Inc.4-33-3 Kokuryo-cho,Chofu-shi, Tokyo 182-0022,Japan',1),('00:05:43','Iq Wireless Gmbh','Iq Wireless GmbhCarl-scheele-str. 14D-12489 BerlinGermany',1),('00:05:44','Valley Technologies, Inc.','Valley Technologies, Inc.1006 West College Ave.Suite 200State College Pa 16801United States',1),('00:05:45','Internet Photonics','Internet Photonics1030 Broad St., 2nd FloorShrewsbury Nj 07702United States',1),('00:05:46','Kddi Network & Solultions Inc.','Kddi Network & Solultions Inc.2-3-1, Nishishinjunku-ku,Tokyo 163-0907Japan',1),('00:05:47','Starent Networks','Starent Networks30 International PlaceTewksbury Ma 01876United States',1),('00:05:48','Disco Corporation','Disco Corporation13-11 Omori-kita 2-chomeOta-ku Tokyo 143-8580Japan',1),('00:05:49','Salira Optical Network Systems','Salira Optical Network Systems2694 Orchard ParkwaySan Jose Ca 95134United States',1),('00:05:4A','Ario Data Networks, Inc.','Ario Data Networks, Inc.2890 Zanker Road, Suite 203San Jose Ca 95134United States',1),('00:05:4B','Micro Innovation Ag','Micro Innovation AgSpinnereistrasse 89008 St.gallenSwitzerland',1),('00:05:4C','Rf Innovations Pty Ltd','Rf Innovations Pty Ltd22 Boulder RoadMalaga Wa  6090Australia',1),('00:05:4D','Brans Technologies, Inc.','Brans Technologies, Inc.501 Boramae Academy Tower395-69 Shinaebang-dong Tongjak-gu SeoulKorea, Republic Of',1),('00:05:4E','Philips','Philips1000 West Maude AvenueSunnyvale Ca 94085-2810United States',1),('00:05:4F','Private','',1),('00:05:50','Vcomms Limited','Vcomms Limited75 The Esplanade, Level 3Po Box 38-920Wellington Mail Centre 5045 WellingtonNew Zealand',1),('00:05:51','F & S Elektronik Systeme Gmbh','F & S Elektronik Systeme GmbhUntere Waldplaetze 23D-70569 StuttgartGermany',1),('00:05:52','Xycotec Computer Gmbh','Xycotec Computer GmbhKarl-heinz-beckurts-str. 4D-52428 JulichGermany',1),('00:05:53','Dvc Company, Inc.','Dvc Company, Inc.10200 Hwy 290 W.Austin Tx 78236United States',1),('00:05:54','Rangestar Wireless','Rangestar Wireless9565 Soquel Drive, Suite 100Aptos Ca 95003United States',1),('00:05:55','Japan Cash Machine Co., Ltd.','Japan Cash Machine Co., Ltd.No. 3-15, 2-chome, Nishiwaki,Hirano-ku, Osaka547-0035Japan',1),('00:05:56','360 Systems','360 Systems31355 Agoura RoadWestlake Village Ca 91361United States',1),('00:05:57','Agile Tv Corporation','Agile Tv Corporation333 Ravenswood Ave.,Building 202Menlo Park Ca 94025United States',1),('00:05:58','Synchronous, Inc.','Synchronous, Inc.77 Las Colinas LaneSan Jose Ca 95119United States',1),('00:05:59','Intracom S.a.','Intracom S.a.19 5 Km Markopoulou Ave.19002 PeaniaAttikaGreece',1),('00:05:5A','Power Dsine Ltd.','Power Dsine Ltd.1 Hanagar St., P.o. Box 7220Neve Neeman Industrial Zone Hod HasharoIsrael',1),('00:05:5B','Charles Industries, Ltd.','Charles Industries, Ltd.5600 Apollo Dr.Rolling Meadows Il 60008United States',1),('00:05:5C','Kowa Company, Ltd.','Kowa Company, Ltd.Chofugaoka 3-3-1,Chofu-si, Tokyo,182-0021Japan',1),('00:05:5D','D-link Systems, Inc.','D-link Systems, Inc.53 Discovery Dr.Irvine Ca 92618United States',1),('00:05:5E','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:5F','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:60','Leader Comm.co., Ltd','Leader Comm.co., Ltd234, Komae-ri, Kiheung-eup,Youngsin-si, Kyungki-do,449-900Korea, Republic Of',1),('00:05:61','Nac Image Technology, Inc.','Nac Image Technology, Inc.8-7 Sanban-cho, Chiyoda-ku,Tokyo, 102-0075Japan',1),('00:05:62','Digital View Limited','Digital View Limited2201 Nan Yang Plaza,57 Hungto Road, Kwun Tong,KowloonHong Kong',1),('00:05:63','J-works, Inc.','J-works, Inc.12328 Gladstone St. #1Sylmor Ca 91342United States',1),('00:05:64','Tsinghua Bitway Co., Ltd.','Tsinghua Bitway Co., Ltd.12 Floor, Tower C, CorporateSquare, No. 35, Financial Street, XichenChina',1),('00:05:65','Tailyn Communication Company Ltd.','Tailyn Communication Company Ltd.No. 62, Lane 205, Nan-san Road,Sec. 2, Lu-chu Hsiang,Taoyuan HsienTaiwan, Republic Of China',1),('00:05:66','Secui.com Corporation','Secui.com Corporation17th Fl. Samsung Yeoksam Bldg.647-9, Yeoksam-dong, Kangnam-guSeoul  135-080Korea, Republic Of',1),('00:05:67','Etymonic Design, Inc.','Etymonic Design, Inc.41 Byron AvenueDorchester, Ontario,Nol 1goCanada',1),('00:05:68','Piltofish Networks Ab','Piltofish Networks AbStora Badhusgatan 18-20S-41121 GoteborgSweden',1),('00:05:69','Vmware, Inc.','Vmware, Inc.3145 Porter Dr., Bldg. FPalo Alto Ca 94304United States',1),('00:05:6A','Heuft Systemtechnik Gmbh','Heuft Systemtechnik GmbhBrohltalstr 31-3356659 BurgbrohlDeutschlandGermany',1),('00:05:6B','C.p. Technology Co., Ltd.','C.p. Technology Co., Ltd.12f, No. 86, Hsin Tai Wu Rd.,Sec. 1, Hsi-chih, Taipei Hsien,221Taiwan, Republic Of China',1),('00:05:6C','Hung Chang Co., Ltd.','Hung Chang Co., Ltd.1385-14, Juan-dong,Nam-ku, Inchom, 402-200Korea, Republic Of',1),('00:05:6D','Pacific Corporation','Pacific Corporation2-23-3 Ebisu-minami ShibuyaTokyo 150-0022Japan',1),('00:05:6E','National Enhance Technology, Inc.','National Enhance Technology, Inc.2f, No. 196-3, Tatung Rd., Sec. 3,Hsi Chih, Taipei Hsien,Taiwan, Republic Of China',1),('00:05:6F','Innomedia Technologies Pvt. Ltd.','Innomedia Technologies Pvt. Ltd.#3278, 12th Main RoadHal 2nd Stage Bangalore - 560 008India',1),('00:05:70','Baydel Ltd.','Baydel Ltd.Baydel HouseBrook Way Leatherhead, Surrey Kt22 7naUnited Kingdom',1),('00:05:71','Seiwa Electronics Co.','Seiwa Electronics Co.757 Amabouki, Kukizaki-machiInashiki-gun, Ibaraki-ken300-1253Japan',1),('00:05:72','Deonet Co., Ltd.','Deonet Co., Ltd.#127-5 Jinyoung B/d 3th F,Noniyun-dong, Kangnam-gu,SeoulKorea, Republic Of',1),('00:05:73','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:74','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:75','Cds-electronics Bv','Cds-electronics BvMozart Laan 3303144 Nh MaassluisNetherlands',1),('00:05:76','Nsm Technology Ltd.','Nsm Technology Ltd.22 Floor, Times Tower928 Cheung Sha Wan RoadKoloonHong Kong',1),('00:05:77','Sm Information & Communication','Sm Information & Communication330-1 YangjaedongSeoucho-gu, Seoul137-130Korea, Republic Of',1),('00:05:78','Private','',1),('00:05:79','Universal Control Solution Corp.','Universal Control Solution Corp.12843 Foothill Blvd.Unit #dSylmar Ca 91342United States',1),('00:05:7A','Hatteras Networks','Hatteras NetworksP.o. Box Box 110025Research Triangle Park Nc 27709-0025United States',1),('00:05:7B','Chung Nam Electronic Co., Ltd.','Chung Nam Electronic Co., Ltd.Unit 3, 1/f, Festigood CentreNo. 8 Lok Yip Road, On LokTsuen Fanling,Hong Kong',1),('00:05:7C','Rco Security Ab','Rco Security AbBox 705Se 176 27 JarfallaSweden',1),('00:05:7D','Sun Communications, Inc.','Sun Communications, Inc.Gloria Bldg 6th1-3 Ageba-cho Shinjuku-kuTokyo  162-082Japan',1),('00:05:7E','Eckelmann Steuerungstechnik Gmbh','Eckelmann Steuerungstechnik GmbhBerliner Strasse 16165205 WiesbadenGermany',1),('00:05:7F','Acqis Technology','Acqis Technology1621 West El Camino RealMt. View Ca 94040United States',1),('00:05:80','Fibrolan Ltd.','Fibrolan Ltd.6 Hayetzira StreetYokneam Illit 20692Israel',1),('00:05:81','Snell & Wilcox Ltd.','Snell & Wilcox Ltd.Southleigh Park HouseEastleigh Road, HavantHampshire  P09 2peUnited Kingdom',1),('00:05:82','Clearcube Technology','Clearcube Technology8834 Capital Of Texas Hwy,Suite 140Austin Tx 78759United States',1),('00:05:83','Imagecom Limited','Imagecom LimitedCedars Park, Cedars Road,Maidenhead, Berkshire,Sl6 1rzUnited Kingdom',1),('00:05:84','Absolutevalue Systems, Inc.','Absolutevalue Systems, Inc.715-d North Dr.Melbourne Fl 32934United States',1),('00:05:85','Juniper Networks, Inc.','Juniper Networks, Inc.1194 N. Mathilda AvenueSunnyvale Ca 94089United States',1),('00:05:86','Lucent Technologies','Lucent Technologies1701 Harbor Bay ParkwayAlameda Ca 94502United States',1),('00:05:87','Locus, Incorporated','Locus, Incorporated5540 Research Park DriveFitchburg CenterMadison Wi 53711United States',1),('00:05:88','Sensoria Corp.','Sensoria Corp.15950 Bernardo Ctr. Dr.Suite JSan Diego Ca 92127United States',1),('00:05:89','National Datacomputer','National Datacomputer900 Middlesex Tpk.Billerica Ma 01821United States',1),('00:05:8A','Netcom Co., Ltd.','Netcom Co., Ltd.1f, No. 7, Lane 242,Hu Liin StreetTaipeiTaiwan, Republic Of China',1),('00:05:8B','Ipmental, Inc.','Ipmental, Inc.8f-9, No. 35, Hsin Tai Rd.Juibei, HsinchuTaiwan, Republic Of China',1),('00:05:8C','Opentech Inc.','Opentech Inc.6f, Dongwon Bldg., 275Youngjae-dong, Seocho-gu,Seoul  137-130Korea, Republic Of',1),('00:05:8D','Lynx Photonic Networks, Inc.','Lynx Photonic Networks, Inc.13 Hamelaha St.Rosh-heaynIsrael',1),('00:05:8E','Flextronics International Gmbh & Co. Nfg. Kg','Flextronics International Gmbh & Co. Nfg. KgSchrackgasse 9-15Kindberg  8650Austria',1),('00:05:8F','Clcsoft Co.','Clcsoft Co.Dept. Of Electrical EngineeringKaist, 373-1 Kuseong-dong, Yuseong-gu, DKorea, Republic Of',1),('00:05:90','Swissvoice Ltd.','Swissvoice Ltd.Ziegelmattstrasse 14503 SolothurnSwitzerland',1),('00:05:91','Active Silicon Ltd.','Active Silicon Ltd.Brunnel Science ParkKingston Lane, Uxbridge,Middx  Ub8 3pqUnited Kingdom',1),('00:05:92','Pultek Corp.','Pultek Corp.74-1, Yamashita-cho,Naka-ku, Tokohama-city,231-0023Japan',1),('00:05:93','Grammar Engine Inc.','Grammar Engine Inc.921 Eastwind DriveSuite 122Westerville Oh 43081United States',1),('00:05:94','Ixxat Automation Gmbh','Ixxat Automation GmbhLeibnizstrasse 1588250 WeingartenGermany',1),('00:05:95','Alesis Corporation','Alesis Corporation1633 26th StreetSanta Monica Ca 90404United States',1),('00:05:96','Genotech Co., Ltd.','Genotech Co., Ltd.#308 Gunkook Bldg.,288-1 Doksan-dongGumchon-gu SeoulKorea, Republic Of',1),('00:05:97','Eagle Traffic Control Systems','Eagle Traffic Control Systems8004 Cameron RoadAustin Tx 78754United States',1),('00:05:98','Cronos S.r.l.','Cronos S.r.l.Via Cavour 58/a23900 Lecco (lc)Italy',1),('00:05:99','Drs Test And Energy Management Or Drs-tem','Drs Test And Energy Management Or Drs-tem110 Wynn DriveHuntsville Al 35805United States',1),('00:05:9A','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:05:9B','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:05:9C','Kleinknecht Gmbh, Ing. Buero','Kleinknecht Gmbh, Ing. BueroBachstrasse 30D-82541 MuensingGermany',1),('00:05:9D','Daniel Computing Systems, Inc.','Daniel Computing Systems, Inc.3208 8th Avenue Ne #118Calgary AlbertaT2a 7v8Canada',1),('00:05:9E','Zinwell Corporation','Zinwell Corporation7f, No.512, Yuan-shan RoadChang-ho City Taipei HsienTaiwan, Republic Of China',1),('00:05:9F','Yotta Networks, Inc.','Yotta Networks, Inc.2201 Avenue KPlano Tx 75074United States',1),('00:05:A0','Mobiline Kft.','Mobiline Kft.Lehel Utca 14BudapestH-1134Hungary',1),('00:05:A1','Zenocom','ZenocomNo.402, 4th Floor, Wongok Bldg.830-38, Yoksam-dong, Gangnam-guSeoulKorea, Republic Of',1),('00:05:A2','Celox Networks','Celox Networks940 West Port Plaza - Ste. #300St. Louis Mo 63146United States',1),('00:05:A3','Qei, Inc.','Qei, Inc.60 Fadem RoadSpringfield Nj 07081United States',1),('00:05:A4','Lucid Voice Ltd.','Lucid Voice Ltd.5 Jabotinski StreetRamat-gan, 52520Israel',1),('00:05:A5','Kott','KottSuite 305 Daeha B/d680 Yeoksam-dong, Kangnam-gu Seoul135-080Korea, Republic Of',1),('00:05:A6','Extron Electronics','Extron Electronics1230 S. LewisAnahiem Ca 92805United States',1),('00:05:A7','Hyperchip, Inc.','Hyperchip, Inc.180 Peel Street - Ste. #333Montreal, QuebecH3c 2g7Canada',1),('00:05:A8','Wyle Electronics','Wyle Electronics3000 Bowers AvenueSanta Clara Ca 95051-0919United States',1),('00:05:A9','Princeton Networks, Inc.','Princeton Networks, Inc.100 Century Center Ct. #100San Jose Ca 95112United States',1),('00:05:AA','Moore Industries International Inc.','Moore Industries International Inc.16650 Schoenborn St.North Hills Ca 91343United States',1),('00:05:AB','Cyber Fone, Inc.','Cyber Fone, Inc.989 Old Eagle School RoadSuite 800Wayne Pa 19087United States',1),('00:05:AC','Northern Digital, Inc.','Northern Digital, Inc.103 Randall DriveWaterloo  Ontario N2v 1c5Canada',1),('00:05:AD','Topspin Communications, Inc.','Topspin Communications, Inc.515 Ellis StreetMountain View Ca 94043United States',1),('00:05:AE','Mediaport Usa','Mediaport Usa17151 Newhope Ave. #202Fountain Valley Ca 92708United States',1),('00:05:AF','Innoscan Computing A/s','Innoscan Computing A/sSoren Frichsvej 42rDk-8230 AabyhojDenmark',1),('00:05:B0','Korea Computer Technology Co., Ltd.','Korea Computer Technology Co., Ltd.Kct Bldg, 111-3 Yangjae-dong,Seocho-gu, SeoulKorea, Republic Of',1),('00:05:B1','Asb Technology Bv','Asb Technology BvDe Ronde 15a5683 Cz BestNetherlands',1),('00:05:B2','Medison Co., Ltd.','Medison Co., Ltd.997-4, Saechi-dong,Kangnam-ku, Souel,135-280Korea, Republic Of',1),('00:05:B3','Asahi-engineering Co., Ltd.','Asahi-engineering Co., Ltd.3-6-12-2 Gakuenhigashi-choKodaira-shiTokyo  187-0043Japan',1),('00:05:B4','Aceex Corporation','Aceex Corporation2f, No. 2, Alley 1, Sze-wei LaneChung-cheng Rd., Hsintien, Taipei23138Taiwan, Republic Of China',1),('00:05:B5','Broadcom Technologies','Broadcom Technologies137-060858-31 Yujeong Bld, Bangbae-dongSecho-gu Seoul,Korea, Republic Of',1),('00:05:B6','Insys Microelectronics Gmbh','Insys Microelectronics GmbhWaffnergasse 893047 RegensburgGermany',1),('00:05:B7','Arbor Technology Corp.','Arbor Technology Corp.5f, No. 738, Zhong Zheng Rd.,Zhong Ho 235, Taipei,Taiwan, Republic Of China',1),('00:05:B8','Electronic Design Associates, Inc.','Electronic Design Associates, Inc.331 Arcado Rd. NwSuite C-1Lilburn Ga 30047-2841United States',1),('00:05:B9','Airvana, Inc.','Airvana, Inc.25 Industrial Ave.Chlemsford Ma 01824United States',1),('00:05:BA','Area Netwoeks, Inc.','Area Netwoeks, Inc.1148 Euclid Ave., Suite 400Cleveland Oh 4415United States',1),('00:05:BB','Myspace Ab','Myspace AbSveavagen 33Se-11134 StockholmSweden',1),('00:05:BC','Resorsys Ltd.','Resorsys Ltd.80 Johnsdone Avenue,Hilington, Glasgow,Scotland  G52 4ltUnited Kingdom',1),('00:05:BD','Roax Bv','Roax BvSterrenbergweg 29Nl-3769 Bs  SoesterbergNetherlands',1),('00:05:BE','Kongsberg Seatex As','Kongsberg Seatex AsPirsenteretN-7562 TrondheimNorway',1),('00:05:BF','Justezy Technology, Inc.','Justezy Technology, Inc.5f, No. 324, Sec. 1, Junghua Rd.HsinchuTaiwan, Republic Of China',1),('00:05:C0','Digital Network Alacarte Co., Ltd.','Digital Network Alacarte Co., Ltd.A104, Seoul Business Incubator647-26, Deungchun-dong, Kangseo-guSeoul  157-030,Korea, Republic Of',1),('00:05:C1','A-kyung Motion, Inc.','A-kyung Motion, Inc.54-10, Munjung-dongSongpa-ku,SeoulKorea, Republic Of',1),('00:05:C2','Soronti, Inc.','Soronti, Inc.12257 South Business Park Drive#160Draper Utah 84020United States',1),('00:05:C3','Pacific Instruments, Inc.','Pacific Instruments, Inc.4080 Pike LaneConcord Ca 94520United States',1),('00:05:C4','Telect, Inc.','Telect, Inc.2111 N. Molter RoadLiberty Lake Wa 99019United States',1),('00:05:C5','Flaga Hf','Flaga HfVesturhlid 7Is-105 ReykjavikIceland',1),('00:05:C6','Triz Communications','Triz CommunicationsAnwon Bldg. 7th Fl.14-15 Yoido-dong Youngdeungpo-guSeoul  150-010Korea, Republic Of',1),('00:05:C7','I/f-com A/s','I/f-com A/sEllegaardvej 366400 SoenderborgDenmark',1),('00:05:C8','Verytech','Verytech#402, Jang Young Shil Kwan,Venture Town, 1688-5 Shinil-dong, DaedeoKorea, Republic Of',1),('00:05:C9','Lg Innotek Co., Ltd.','Lg Innotek Co., Ltd.Lg Component R&d Center1271, Sa-dong, Sangrok-guAnsan-si Gyeonggi-do 426-791Korea, Republic Of',1),('00:05:CA','Hitron Technology, Inc.','Hitron Technology, Inc.Hsinchu Sbip SubsidiaryNo. 25 R&d 1st Rd. Science-based IndustrHsin-chuTaiwan, Republic Of China',1),('00:05:CB','Rois Technologies, Inc.','Rois Technologies, Inc.6th F Changhyun B/d, 960-1Hogye-dong Dongan-ku Anyang,431-080Korea, Republic Of',1),('00:05:CC','Sumtel Communications, Inc.','Sumtel Communications, Inc.1f, No. 173, Gung Yuan Road,Hsinchu City  30054Taiwan, Republic Of China',1),('00:05:CD','Denon, Ltd.','Denon, Ltd.35-1, Sagamiono 7-chome,Sagamihara-shiKanagawa  228-8505Japan',1),('00:05:CE','Prolink Microsystems Corporation','Prolink Microsystems Corporation6f, No. 349, Yang-kuang St.Nei-hu Taipei,Taiwan, Republic Of China',1),('00:05:CF','Thunder River Technologies, Inc.','Thunder River Technologies, Inc.23 Corporate Plaza, Suite 250Newport Beach Ca 92660United States',1),('00:05:D0','Solinet Systems','Solinet Systems1200-180 Elgin St.Ottawa OntarioK2p 2k3Canada',1),('00:05:D1','Metavector Technologies','Metavector TechnologiesSteenweg Op Gierle, 100B-2300 Turnhout,Belgium',1),('00:05:D2','Dap Technologies','Dap Technologies955 Fernand Dufour,Ville De Vanier, Quebec,G1m 3b2Canada',1),('00:05:D3','Eproduction Solutions, Inc.','Eproduction Solutions, Inc.22001 North Park DriveKingwood Tx 77339-3804United States',1),('00:05:D4','Futuresmart Networks, Inc.','Futuresmart Networks, Inc.6155 Almaden ExpresswaySuite 100San Jose Ca 95120United States',1),('00:05:D5','Speedcom Wireless','Speedcom Wireless7020 Professional Pkwy EastSarasota Fl 34240-8514United States',1),('00:05:D6','Titan Wireless','Titan Wireless3033 Science Park RoadSan Diego Ca 92121United States',1),('00:05:D7','Vista Imaging, Inc.','Vista Imaging, Inc.521 Taylor WaySan Carlos Ca 94070United States',1),('00:05:D8','Arescom, Inc.','Arescom, Inc.3541 Gateway Blvd.Fremont Ca 94538United States',1),('00:05:D9','Techno Valley, Inc.','Techno Valley, Inc.Asic Venture Town 5f,1330-3 Seocho2-dong, Seocho-ku,Seoul  135-072Korea, Republic Of',1),('00:05:DA','Apex Automationstechnik','Apex AutomationstechnikVossenkamp 4D-38104 BraunschweigGermany',1),('00:05:DB','Nentec Netzwerktechnologie Gmbh','Nentec Netzwerktechnologie GmbhGreschbachstrasse 12Karlsruhe  76229Germany',1),('00:05:DC','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:DD','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:05:DE','Gi Fone Korea, Inc.','Gi Fone Korea, Inc.Twin Bldg. 4th Fl,902-124 Togok-dong, Kangnam-gu,Seoul,Korea, Republic Of',1),('00:05:DF','Electronic Innovation, Inc.','Electronic Innovation, Inc.12731 Cannington Way SwCalgary, Ab T2w 1z7Canada',1),('00:05:E0','Empirix Corp.','Empirix Corp.205 Lowell St.Wilmington Ma 01887United States',1),('00:05:E1','Trellis Photonics, Ltd.','Trellis Photonics, Ltd.P.o.b. 36Yogneam Elite, 20692Israel',1),('00:05:E2','Creativ Network Technologies','Creativ Network Technologies1755 St. Regis Suite 240Dollard-des-ormeauxQuebec H9b-2m9Canada',1),('00:05:E3','Lightsand Communications, Inc.','Lightsand Communications, Inc.375 Los Coches St.Milpitas Ca 94539United States',1),('00:05:E4','Red Lion Controls Inc.','Red Lion Controls Inc.20 Willow Springs CircleYork Pa 17402United States',1),('00:05:E5','Renishaw Plc','Renishaw PlcNew Mills, Wotton-under-edgeGloucestershure, Gl12 8jrUnited Kingdom',1),('00:05:E6','Egenera, Inc.','Egenera, Inc.165 Forest St.Marlboro Ma 01752United States',1),('00:05:E7','Netrake An Audiocodes Company','Netrake An Audiocodes Company3000 Technology DriveSuite 100Plano Tx 75074United States',1),('00:05:E8','Turbowave, Inc.','Turbowave, Inc.555 South StateSuite 302Orem Ut 84058United States',1),('00:05:E9','Unicess Network, Inc.','Unicess Network, Inc.870 Dorothy Dr. #708Richardson Tx 75081United States',1),('00:05:EA','Rednix','Rednix502, Dong-a Resort Officetel538-8 Bongmyung-dong Yusung,Taejon  305-709Korea, Republic Of',1),('00:05:EB','Blue Ridge Networks, Inc.','Blue Ridge Networks, Inc.14120 Parke Long CourtSuite 201Chantilly Va 20151United States',1),('00:05:EC','Mosaic Systems Inc.','Mosaic Systems Inc.7 Campbell ParkSomerville Ma 02144United States',1),('00:05:ED','Technikum Joanneum Gmbh','Technikum Joanneum GmbhAlte Poststrae 1498020 GrazAustria',1),('00:05:EE','Bewator Group','Bewator GroupBewator Ab, Box 1275Se-17124 SolnanSweden',1),('00:05:EF','Adoir Digital Technology','Adoir Digital Technology28 Fl, Zhaofeng World Trade Bldg.369 Jiangsu Rd.Shanghai 200050,China',1),('00:05:F0','Satec','SatecP.o. Box 45022Jerusalem91450Israel',1),('00:05:F1','Vrcom, Inc.','Vrcom, Inc.401, Songam Bldg, 479-1,Bangbae 3-dong, Seocho-ku,SeoulKorea, Republic Of',1),('00:05:F2','Power R, Inc.','Power R, Inc.756 Aloha St.Seattle Wa 98109United States',1),('00:05:F3','Weboyn','Weboyn26 Rue Oes Gaudines78100 Saint-germainFrance',1),('00:05:F4','System Base Co., Ltd.','System Base Co., Ltd.475-22, Bangbae 2 Dong,Seocho Gu, Seoul,Korea, Republic Of',1),('00:05:F5','Oyo Geospace','Oyo Geospace7007 PinemontHouston Tx 77040United States',1),('00:05:F6','Young Chang Co. Ltd.','Young Chang Co. Ltd.1432 Main StreetWaltham Ma 02451United States',1),('00:05:F7','Analog Devices, Inc.','Analog Devices, Inc.804 Woburn St., Ms 111Wilmington Ma 01887United States',1),('00:05:F8','Real Time Access, Inc.','Real Time Access, Inc.455 N. Canyons Pkwy.Suite BLivermore Ca 94550United States',1),('00:05:F9','Toa Corporation','Toa Corporation2-1 Takamatsu-cho,Takarazuka-cityHyogo  665-0043Japan',1),('00:05:FA','Ipoptical, Inc.','Ipoptical, Inc.45940 Horseshoe DriveSuite 150Dulles Va 20166United States',1),('00:05:FB','Sharegate, Inc.','Sharegate, Inc.9805 Double R Blvd.Third FloorReno Nv 89511-5917United States',1),('00:05:FC','Schenck Pegasus Corp.','Schenck Pegasus Corp.2890 John R RoadTroy Mi 48083United States',1),('00:05:FD','Packetlight Networks Ltd.','Packetlight Networks Ltd.27 Habarzel St.Ramat HahayalTel-aviv  69710Israel',1),('00:05:FE','Traficon N.v.','Traficon N.v.Bissegemsestraat 45B-8501 HeuleBelgium',1),('00:05:FF','Sns Solutions, Inc.','Sns Solutions, Inc.2nd Fl. Hill House,99-2 Sohyun, Bundang, Sungnam, Kyunggi,Korea, Republic Of',1),('00:06:00','Toshiba Teli Corporation','Toshiba Teli Corporation4-7-1 Asahigaoka, Hino-shi,Tokyo 191-0065Japan',1),('00:06:01','Otanikeiki Co., Ltd.','Otanikeiki Co., Ltd.2-10-23 Hikari-machiHigashi-ku Hiroshima732-0052Japan',1),('00:06:02','Cirkitech Electronics Co.','Cirkitech Electronics Co.B1-2, No. 361, Fu-xing First RoadGuei-shan Hsiang,Tao-yuanTaiwan, Republic Of China',1),('00:06:03','Baker Hughes Inc.','Baker Hughes Inc.2001 Rankin Rd.Houston Tx 77073United States',1),('00:06:04','@track Communications, Inc.','@track Communications, Inc.1155 Kas Dr.Richardson Tx 75081United States',1),('00:06:05','Inncom International, Inc.','Inncom International, Inc.P.o. Box 106083 Halls RoadOld Lyme Ct 06371United States',1),('00:06:06','Rapidwan, Inc.','Rapidwan, Inc.2085 Hamilton Ave.Suite #220San Jose Ca 95125United States',1),('00:06:07','Omni Directional Control Technology Inc.','Omni Directional Control Technology Inc.8f-2, No. 94, Pao-chung Rd.Hsin-tien City,Taipei Hsien,Taiwan, Republic Of China',1),('00:06:08','At-sky Sas','At-sky SasZi Athelia 3, Voi Atlas13600- La CiotatFrance',1),('00:06:09','Crossport Systems','Crossport Systems10940 Ne 33rd Pl.Suite 101Bellevue Wa 98005United States',1),('00:06:0A','Blue2space','Blue2spaceArstaangsv. 9Se-11748 StockholmSweden',1),('00:06:0B','Paceline Systems Corporation','Paceline Systems Corporation50 Nagog ParkActon Ma 01720United States',1),('00:06:0C','Melco Industries, Inc.','Melco Industries, Inc.1575 W. 124th Ave.Denver Co 80234United States',1),('00:06:0D','Wave7 Optics','Wave7 Optics1075 Windward Ridge Pkwy.Suite 170Alpharetta Ga 30005United States',1),('00:06:0E','Igys Systems, Inc.','Igys Systems, Inc.7373 Lincoln WayGarden Grove Ca 92841United States',1),('00:06:0F','Narad Networks Inc','Narad Networks Inc515 Groton RoadWestford Ma 01886United States',1),('00:06:10','Abeona Networks Inc','Abeona Networks Inc46117 Landing ParkwayFremont Ca 94539United States',1),('00:06:11','Zeus Wireless, Inc.','Zeus Wireless, Inc.8325 Guilford RoadColumbia Md 21046United States',1),('00:06:12','Accusys, Inc.','Accusys, Inc.5f, No. 38, Taiyuan StJhubei CityHsinchu County  30265Taiwan, Republic Of China',1),('00:06:13','Kawasaki Microelectronics Incorporated','Kawasaki Microelectronics IncorporatedMtg B-5, 1-3, Nakase,Mihama-ku Chiba 261-8501Japan',1),('00:06:14','Prism Holdings','Prism HoldingsP.o. Box 901,Witkoppen, 2068,GautengSouth Africa',1),('00:06:15','Kimoto Electric Co., Ltd.','Kimoto Electric Co., Ltd.3-1 Funahashi-cho,Tennoji-ku, Osaka543-0024Japan',1),('00:06:16','Tel Net Co., Ltd.','Tel Net Co., Ltd.3f Bof Bldg 730-15 Goje SongYeonje Gu Pusam 611-073,Korea, Republic Of',1),('00:06:17','Redswitch Inc.','Redswitch Inc.1815 Mccandless DriveMilpitas Ca 95035-8046United States',1),('00:06:18','Digipower Manufacturing Inc.','Digipower Manufacturing Inc.No. 114, Floor 13, Sec. 1,Hsin Tai Wu Road, Shijr City,TaipeiTaiwan, Republic Of China',1),('00:06:19','Connection Technology Systems','Connection Technology Systems18f-6, No. 79, Sec. 1,Hsin Tai Wu Rd.Hsinchih Taipei,Taiwan, Republic Of China',1),('00:06:1A','Zetari Inc.','Zetari Inc.411 Waverly Oaks Rd.Suite 323Waltham Ma 02452-8401United States',1),('00:06:1B','Notebook Development Lab.  Lenovo Japan Ltd.','Notebook Development Lab.  Lenovo Japan Ltd.1623-14 ShimotsurumaYamato-shi Kanagawa-ken242-8502Japan',1),('00:06:1C','Hoshino Metal Industries, Ltd.','Hoshino Metal Industries, Ltd.645 Yamanokami, Yabutsuka,Nitta-gun, Gunma379-2302Japan',1),('00:06:1D','Mip Telecom, Inc.','Mip Telecom, Inc.3rd Floor, Sangil Bldg,948-16, Bongcheondong, Gwanakku,Seoul  151-069Korea, Republic Of',1),('00:06:1E','Maxan Systems','Maxan Systems1-84, Woulam-dongSalseo-gu, Daegu,Korea, Republic Of',1),('00:06:1F','Vision Components Gmbh','Vision Components GmbhOttostr. 2Ettlingen, 76275Germany',1),('00:06:20','Serial System Ltd.','Serial System Ltd.76 Playfair Road#04-03 Lhk2 Building367996Singapore',1),('00:06:21','Hinox, Co., Ltd.','Hinox, Co., Ltd.15-7 3-chome, Sennin-cho,Hachioji-city, Tokyo,193-0835Japan',1),('00:06:22','Chung Fu Chen Yeh Enterprise Corp.','Chung Fu Chen Yeh Enterprise Corp.2f No. 666 Jing Ping Road,Chung Ho City,Taipei HsienTaiwan, Republic Of China',1),('00:06:23','Mge Ups Systems France','Mge Ups Systems France140 Avenue Jean KuntzmannZirst Montbonnot St Martin 38334 St IsmiFrance',1),('00:06:24','Gentner Communications Corp.','Gentner Communications Corp.1825 Research WaySalt Lake City Ut 84119United States',1),('00:06:25','The Linksys Group, Inc.','The Linksys Group, Inc.17401 Armstrong Ave.Irvine Ca 92614United States',1),('00:06:26','Mwe Gmbh','Mwe GmbhOlbrichtstr. 21D-69469 WeinheimGermany',1),('00:06:27','Uniwide Technologies, Inc.','Uniwide Technologies, Inc.Korea Development Bank B/d 5th FlrDunsandong, Seogu,Taejon 302-122,Korea, Republic Of',1),('00:06:28','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:06:29','Ibm Corporation','Ibm CorporationCe6a/664P.o. Box 12195Research Triangle Park Nc 27709-2195United States',1),('00:06:2A','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:06:2B','Intraserver Technology','Intraserver TechnologySeven October Hill Rd.Holliston Ma 01746United States',1),('00:06:2C','Bivio Networks','Bivio Networks4457 Willow Road,Pleasanton Ca 94588United States',1),('00:06:2D','Touchstar Technologies, L.l.c.','Touchstar Technologies, L.l.c.5147 South Garnett RoadSuite ATulsa Ok 74146United States',1),('00:06:2E','Aristos Logic Corp.','Aristos Logic Corp.27051 Towne Centre Dr.Suite 290Foothill Ranch Ca 92610United States',1),('00:06:2F','Pivotech Systems Inc.','Pivotech Systems Inc.200 Centennial Ave.,Suite 222Piscataway Nj 08854United States',1),('00:06:30','Adtranz Sweden','Adtranz SwedenDept. Tcc/thOstraringvagen 2 72173 VasterasSweden',1),('00:06:31','Optical Solutions, Inc.','Optical Solutions, Inc.16305 36th Ave. N.Suite 300Plymouth Mn 55446-2698United States',1),('00:06:32','Mesco Engineering Gmbh','Mesco Engineering GmbhWiesentalstrasse 7479539 LorrachGermany',1),('00:06:33','Cross Match Technologies Gmbh','Cross Match Technologies GmbhUnstrutweg 4Jena 07743Germany',1),('00:06:34','Gte Airfone Inc.','Gte Airfone Inc.2809 ButterfieldOakbrook Il 60522United States',1),('00:06:35','Packetair Networks, Inc.','Packetair Networks, Inc.11545 W. Bernardo Ct.Suite 100San Diego Ca 92127United States',1),('00:06:36','Jedai Broadband Networks','Jedai Broadband Networks331 Newman Springs Rd.Building 1, 2nd FloorRed Bank Nj 07701United States',1),('00:06:37','Toptrend-meta Information (shenzhen) Inc.','Toptrend-meta Information (shenzhen) Inc.2/f, Bldg. 3, Section A, Nor-east ZoneEastern Industrial Area, Overseas City,China',1),('00:06:38','Sungjin C&c Co., Ltd.','Sungjin C&c Co., Ltd.1543-6, Seocho-dong, Seocho-gu,Seoul  137-073Korea, Republic Of',1),('00:06:39','Newtec','NewtecLaarstraat 5B-9100 Sint-niklaasBelgium',1),('00:06:3A','Dura Micro, Inc.','Dura Micro, Inc.13580 Fifth StreetChino Ca 91710United States',1),('00:06:3B','Arcturus Networks, Inc.','Arcturus Networks, Inc.701 Evans Ave. - Suite 300Toronto Ontario M9c 1a3Canada',1),('00:06:3C','Intrinsyc Europe Ltd','Intrinsyc Europe Ltd700 West Pender Street, 10th Floor,Vancouver, Bc, V6c 1g8Canada',1),('00:06:3D','Microwave Data Systems Inc.','Microwave Data Systems Inc.175 Science ParkwayRochester Ny 14620United States',1),('00:06:3E','Opthos Inc.','Opthos Inc.590 Taylor WaySan Carlos Ca 94070United States',1),('00:06:3F','Everex Communications Inc.','Everex Communications Inc.5020a Brandin Ct.Fremont Ca 94538United States',1),('00:06:40','White Rock Networks','White Rock NetworksSuite #90018111 Preston RoadDallas Tx 75252United States',1),('00:06:41','Itcn','Itcn8571 Gander Creek DriveMiamisburg Oh 45342United States',1),('00:06:42','Genetel Systems Inc.','Genetel Systems Inc.Mockwoo B/d, 912 Walpyoung-dongSeo-gu Taejon,302-852Korea, Republic Of',1),('00:06:43','Sono Computer Co., Ltd.','Sono Computer Co., Ltd.1f., No. 8, Alley 35, Lane 91,Sec. 1, Nei-hu Road,TaipeiTaiwan, Republic Of China',1),('00:06:44','Digital Technologies Corporation','Digital Technologies Corporation3-5-3-24, HigashisapporoShiroishi-kuSapporo Hokkaido 003-0003Japan',1),('00:06:45','Meisei Electric Co. Ltd.','Meisei Electric Co. Ltd.249-1, Moriya-kou, MoriyaKitasouma-gun, Ibaraki302-0192Japan',1),('00:06:46','Shenzhen Xunbao Network Technology Co Ltd','Shenzhen Xunbao Network Technology Co LtdF3, R2-a Building, South DistrictOf High-tech Industrial Park,Shen ZhenChina',1),('00:06:47','Etrali S.a.','Etrali S.a.221, Rue La Fontaine94132 Fontenay Sous Bois CedexFrance',1),('00:06:48','Seedsware, Inc.','Seedsware, Inc.3-7-16 Technostage,Izumi, Osaka 594-1144Japan',1),('00:06:49','3m Deutschland Gmbh','3m Deutschland GmbhCarl-schurz-str. 1D-42109 WuppertalNeuss  D-41453Germany',1),('00:06:4A','Honeywell Co., Ltd. (korea)','Honeywell Co., Ltd. (korea)56, Chaam-dong, Chonan-cityChoongcheongnam-do, 330-200,Korea, Republic Of',1),('00:06:4B','Alexon Co., Ltd.','Alexon Co., Ltd.3-207-1 Teramoto,Itami, Hyogo 664-0026Japan',1),('00:06:4C','Invicta Networks, Inc.','Invicta Networks, Inc.13873 Park Center RoadSuite 400Herndon Va 20171United States',1),('00:06:4D','Sencore','Sencore3200 Sencore Dr.Sioux Falls Sd 57107United States',1),('00:06:4E','Broad Net Technology Inc.','Broad Net Technology Inc.5f, No.58, Lane 188, Rui Kuang RoadNeihu District, Taipei 114,Taiwan, Republic Of China',1),('00:06:4F','Pro-nets Technology Corporation','Pro-nets Technology CorporationPao-chung Road,No. 92, 10f-1Hsin Tien Taipei,Taiwan, Republic Of China',1),('00:06:50','Tiburon Networks, Inc.','Tiburon Networks, Inc.200 Minuteman Rd.Suite 2bAndover Ma 01810United States',1),('00:06:51','Aspen Networks Inc.','Aspen Networks Inc.3777 Stevens Creek BlvdSuite 330Santa Clara Ca 95051United States',1),('00:06:52','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:06:53','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:06:54','Winpresa Building Automation Technologies Gmbh','Winpresa Building Automation Technologies GmbhVivenotgasse 53/2A-1120 ViennaAustria',1),('00:06:55','Yipee, Inc.','Yipee, Inc.555 International DriveSuite 800Williamsville Ny 14221United States',1),('00:06:56','Tactel Ab','Tactel AbNorra Vallgatan 64Se-211 22 MalmoSweden',1),('00:06:57','Market Central, Inc.','Market Central, Inc.500 Business Center DrivePittsburgh Pa 15205-1333United States',1),('00:06:58','Helmut Fischer Gmbh Institut Fr Elektronik Und Messtechnik','Helmut Fischer Gmbh Institut Fr Elektronik Und MesstechnikIndustriabe2171069 SindefingenGermany',1),('00:06:59','Eal (apeldoorn) B.v.','Eal (apeldoorn) B.v.Molenmakershoek 14Jk Apeldoorn  7328Netherlands',1),('00:06:5A','Strix Systems','Strix Systems310 N. Westlake Blvd.Suite 150Westlake Village Ca 91362United States',1),('00:06:5B','Dell Computer Corp.','Dell Computer Corp.One Dell WayRound Rock Tx 78682United States',1),('00:06:5C','Malachite Technologies, Inc.','Malachite Technologies, Inc.195 New Hampshire AvenueSuite 150Portsmouth Nh 03801United States',1),('00:06:5D','Heidelberg Web Systems','Heidelberg Web Systems121 Technology Dr.Durham Nh 03824United States',1),('00:06:5E','Photuris, Inc.','Photuris, Inc.20 Corporate Place SouthPiscataway Nj 08854United States',1),('00:06:5F','Eci Telecom - Ngts Ltd.','Eci Telecom - Ngts Ltd.30 Hasivim St.Petah-tikva 49130Israel',1),('00:06:60','Nadex Co., Ltd.','Nadex Co., Ltd.1 Omiyamae, Tokushige,Nishiharu-cyo, Nishikasugai-gun,Aichi  481-0038Japan',1),('00:06:61','Nia Home Technologies Corp.','Nia Home Technologies Corp.Innovation Incubator, Nthu,101, Sec. 2, Kuang Fu Road,Hsinchu 30013,Taiwan, Republic Of China',1),('00:06:62','Mbm Technology Ltd.','Mbm Technology Ltd.Victoria Rd.Portslade, Brighton Sussex Bn4l 1yhUnited Kingdom',1),('00:06:63','Human Technology Co., Ltd.','Human Technology Co., Ltd.3rd Fl, Hyungok Bldg.,836-25, Yuksam-dong,Kangnam-ku SeoulKorea, Republic Of',1),('00:06:64','Fostex Corporation','Fostex Corporation3-2-35, Musashino, Akishima,Tokyo  196-0021Japan',1),('00:06:65','Sunny Giken, Inc.','Sunny Giken, Inc.3-1-9 Nishidai Itami-shiHyogo-pref.  664-0858Japan',1),('00:06:66','Roving Networks','Roving Networks809 University AvenueLos Gatos Ca 95032United States',1),('00:06:67','Tripp Lite','Tripp Lite1111 W. 35th StreetChicago Il 60609United States',1),('00:06:68','Vicon Industries Inc.','Vicon Industries Inc.89 Arkay DriveHauppauge Ny 11788United States',1),('00:06:69','Datasound Laboratories Ltd','Datasound Laboratories Ltd5 Business Park West, Avenue OneLetchworth, Herts Sg6 24bEnglandUnited Kingdom',1),('00:06:6A','Infinicon Systems, Inc.','Infinicon Systems, Inc.700 American Ave.Suite 101King Of Prussia Pa 19406United States',1),('00:06:6B','Sysmex Corporation','Sysmex Corporation4-4-4 Takatsukadai,Nishi-ku, Kobe-city651-2271Japan',1),('00:06:6C','Robinson Corporation','Robinson Corporation12f, No. 278 Ho Ping E. Rd.,Sec. 3TaipeiTaiwan, Republic Of China',1),('00:06:6D','Compuprint S.p.a.','Compuprint S.p.a.Via Martiri Ditalia 2610014 Caluso (turin)Italy',1),('00:06:6E','Delta Electronics, Inc.','Delta Electronics, Inc.11f, 266 Wen-hwa 2nd Road,Sec. 1, Linkou, Taipei Hsien 244Taiwan, Republic Of China',1),('00:06:6F','Korea Data Systems','Korea Data Systems170, Gongdan-dong, Gumi-siKyungbuk  730-030Korea, Republic Of',1),('00:06:70','Upponetti Oy','Upponetti OyTykistokatu 4dFin-20520 TurkuFinland',1),('00:06:71','Softing Ag','Softing AgRichard-reitzner-allee 685540 HaarGermany',1),('00:06:72','Netezza','Netezza1671 Worcester RoadSuite 100Framingham Ma 01701United States',1),('00:06:73','Optelecom-nkf','Optelecom-nkf12920 Cloverleaf Center DriveGermantown Md 20874United States',1),('00:06:74','Spectrum Control, Inc.','Spectrum Control, Inc.8061 Avonia RoadFairview Pa 16415United States',1),('00:06:75','Banderacom, Inc.','Banderacom, Inc.9211 Waterford Centre Blvd.Suite 100Austin Tx 78758United States',1),('00:06:76','Novra Technologies Inc.','Novra Technologies Inc.900-330 St. Mary AvenueWinnipeg Manitoba R3c 3z5Canada',1),('00:06:77','Sick Ag','Sick AgErwin-sick Str.1D-79183 WaldkirchGermany',1),('00:06:78','Marantz Brand Company','Marantz Brand CompanyD&m Building, 2-1 Nisshin-choKawasaki-kuKawasaki-shi Kawagawa 210-8569Japan',1),('00:06:79','Konami Corporation','Konami Corporation11-14-5 Akasaka, Minato-ku,Tokyo 107-0052Japan',1),('00:06:7A','Jmp Systems','Jmp Systems3rd Fl. Shinwha Bldg.,1451-19, Seocho-dong,Seocho-ku Seoul,Korea, Republic Of',1),('00:06:7B','Toplink C&c Corporation','Toplink C&c Corporation6f-15, No. 12, Lane 609, Sec. 5Chung Hsin Rd., San Chung CityTaipei Hsien 241Taiwan, Republic Of China',1),('00:06:7C','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:06:7D','Takasago Ltd.','Takasago Ltd.1-24-16 Mizonokuchi Takatsu-kuKawasaki KanagawaJapan',1),('00:06:7E','Wincom Systems, Inc.','Wincom Systems, Inc.10900 World Trade Blvd.Suite 250Morrisville Nc 27560United States',1),('00:06:7F','Rearden Steel Technologies','Rearden Steel Technologies529 Bryant StreetPalo Alto Ca 94301United States',1),('00:06:80','Card Access, Inc.','Card Access, Inc.11778 S. Election RdSuite 260Salt Lake City Ut 80420United States',1),('00:06:81','Goepel Electronic Gmbh','Goepel Electronic GmbhGoeschwitzer Str. 58-6007745 JenaGermany',1),('00:06:82','Convedia','Convedia4190 Still Creek Dr.Vancouver B.c.V5c 6c6Canada',1),('00:06:83','Bravara Communications, Inc.','Bravara Communications, Inc.2650 East Bayshore RoadPalo Alto Ca 94303United States',1),('00:06:84','Biacore Ab','Biacore AbSoftware, Electronics And OpticsRapsgatan 7, 754 50 UppsalaSweden',1),('00:06:85','Netnearu Corporation','Netnearu Corporation2908 Finfeather RoadBryan Tx 77801United States',1),('00:06:86','Zardcom Co., Ltd.','Zardcom Co., Ltd.4f, 1548-1, Seocho Dong, Seocho-guSeoulKorea, Republic Of',1),('00:06:87','Omnitron Systems Technology, Inc.','Omnitron Systems Technology, Inc.140 TechnologySuite 500Irvine Ca 92618United States',1),('00:06:88','Telways Communication Co., Ltd.','Telways Communication Co., Ltd.3f, No. 53, Lane 258Zui-kuang Rd., Nei-huTaipei  114Taiwan, Republic Of China',1),('00:06:89','Ylez Technologies Pte Ltd','Ylez Technologies Pte LtdNo. 1, Tannery Road, Cencon 1,#09-03, 347719Singapore',1),('00:06:8A','Neuronnet Co. Ltd. R&d Center','Neuronnet Co. Ltd. R&d Center735-34 Dasung Bldg., Yuksam-dong,Kangnam-gu, SeoulKorea, Republic Of',1),('00:06:8B','Airrunner Technologies, Inc.','Airrunner Technologies, Inc.2401 Lupine TrailSouth Lake Tahoe Ca 96150United States',1),('00:06:8C','3com Corporation','3com Corporation5400 Bayfront PlazaMs:  5116Santa Clara Ca 95052United States',1),('00:06:8D','Sepaton, Inc.','Sepaton, Inc.400 Nickerson Rd.Marlborough Ma 01752United States',1),('00:06:8E','Hid Corporation','Hid Corporation9292 Jeronimo RoadIrvine Ca 92618-1905United States',1),('00:06:8F','Telemonitor, Inc.','Telemonitor, Inc.9055f Guilford RoadColumbia Md 21046United States',1),('00:06:90','Euracom Communication Gmbh','Euracom Communication GmbhFranklinstr. 14D-10587 BerlinGermany',1),('00:06:91','Pt Inovacao','Pt InovacaoRua Eng. Jose F. Pinto Basto3810 AveiroPortugal',1),('00:06:92','Intruvert Networks, Inc.','Intruvert Networks, Inc.Suite 1022290 North First StreetSan Jose Ca 95131United States',1),('00:06:93','Flexus Computer Technology, Inc.','Flexus Computer Technology, Inc.8f-2, No.5, Alley22, Lane 513,Ruei-guang Rd., Nei-hu Dist.,Taipei 114Taiwan, Republic Of China',1),('00:06:94','Mobillian Corporation','Mobillian Corporation11031 Via FronteraSuite CSan Diego Ca 92127United States',1),('00:06:95','Ensure Technologies, Inc.','Ensure Technologies, Inc.3526 West LibertySuite 100Ann Arbor Mi 48103United States',1),('00:06:96','Advent Networks','Advent Networks9600 Great Hills Tr.Suite 300eAustin Tx 78759United States',1),('00:06:97','R & D Center','R & D Center5f, Seungwon B/d, 810-9Bangbae-dong, Seocho-guSeoulKorea, Republic Of',1),('00:06:98','Egnite Software Gmbh','Egnite Software GmbhErinstr. 9Castrop-rauxel D-44575Germany',1),('00:06:99','Vida Design Co.','Vida Design Co.10f, No. 278 Ho Ping E. Rd.,Sec. 3, TaipeiTaiwan, Republic Of China',1),('00:06:9A','E & Tel','E & Tel100 Sejong-no Chongno-gu,Seoul 110-777,Korea, Republic Of',1),('00:06:9B','Avt Audio Video Technologies Gmbh','Avt Audio Video Technologies GmbhRathsbergstrasse 17D-90411 NuernbergGermany',1),('00:06:9C','Transmode Systems Ab','Transmode Systems AbJakobsdalsvgen 17Hgersten Se-126 53Sweden',1),('00:06:9D','Petards Mobile Intelligence','Petards Mobile IntelligenceThe Old Barn, Appleford RoadLong Wittenham, AbingdonOxford  Ox14 4rsUnited Kingdom',1),('00:06:9E','Uniqa, Inc.','Uniqa, Inc.477 Valley WayMilpitas Ca 95035United States',1),('00:06:9F','Kuokoa Networks','Kuokoa Networks2901 Tasman Dr.Suite 202Santa Clara Ca 95054United States',1),('00:06:A0','Mx Imaging','Mx Imaging2341 W. 205th StreetSuite 110Torrance Ca 90501United States',1),('00:06:A1','Celsian Technologies, Inc.','Celsian Technologies, Inc.3002 Dow Ave., Unit 138Tustin Ca 92780United States',1),('00:06:A2','Microtune, Inc.','Microtune, Inc.6440 Lusk Blvd., Suite D205San Diego Ca 92121United States',1),('00:06:A3','Bitran Corporation','Bitran Corporation2213 MochidaGyouda SaitamaJapan',1),('00:06:A4','Innowell Corp.','Innowell Corp.#717 Chonggu Bluevill11-1, Sunae-1 Dong, Bundang-gu, Sungnam-463-825Korea, Republic Of',1),('00:06:A5','Pinon Corp.','Pinon Corp.Dk Gotanda Bldg.7f7-13-5 Nishigotanda Shinagawa-kuTokyo  141-0031Japan',1),('00:06:A6','Artistic Licence (uk) Ltd','Artistic Licence (uk) Ltd24 Forward DriveChristchurch AvenueHarrow Middlesex Ha3 8ntUnited Kingdom',1),('00:06:A7','Primarion','Primarion3450 Torrance Blvd.Torrance Ca 90503United States',1),('00:06:A8','Kc Technology, Inc.','Kc Technology, Inc.1900 Mccarthy Blvd.Suite 300Milpitas Ca 95035United States',1),('00:06:A9','Universal Instruments Corp.','Universal Instruments Corp.Po Box 825Binghamton Ny 13902United States',1),('00:06:AA','Vt Miltope','Vt Miltope4900 Pearl East CircleSuite 106Boulder Co 80301United States',1),('00:06:AB','W-link Systems, Inc.','W-link Systems, Inc.No. 20, Park Ave. Ii,Science Based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:06:AC','Intersoft Co.','Intersoft Co.#1803 Sun-kyoung Officetel106-4 Bunzi, Guro5dong, Guro GuSeoulKorea, Republic Of',1),('00:06:AD','Kb Electronics Ltd.','Kb Electronics Ltd.150 Bluewater Rd.Bedford, Nova ScotiaB4b 1g9Canada',1),('00:06:AE','Himachal Futuristic Communications Ltd','Himachal Futuristic Communications Ltd8, Commercial ComplexMasjid Moth, Greater Kailash IiNew Dehli  110048India',1),('00:06:AF','Xalted Networks','Xalted Networks2901 Dallas ParkwaySuite 200Plano Tx 75093United States',1),('00:06:B0','Comtech Ef Data Corp.','Comtech Ef Data Corp.2114 W. 7th St.Tempe Az 85281United States',1),('00:06:B1','Sonicwall','Sonicwall1160 Bordeaux Dr.Sunnyvale Ca 94089United States',1),('00:06:B2','Linxtek Co.','Linxtek Co.2f Kum-a B/d 31-3 Karak-dong,Songpa-ku, Seoul,138-160Korea, Republic Of',1),('00:06:B3','Diagraph Corporation','Diagraph Corporation3401 Rider Trail SouthEarth City Mo 63045-1110United States',1),('00:06:B4','Vorne Industries, Inc.','Vorne Industries, Inc.1445 Industrial Dr.Itasca Il 60143-1849United States',1),('00:06:B5','Luminent, Inc.','Luminent, Inc.20550 Nordhoff St.Chatsworth Ca 91311United States',1),('00:06:B6','Nir-or Israel Ltd.','Nir-or Israel Ltd.11 Amal St.Rosh Haayin 48092Israel',1),('00:06:B7','Telem Gmbh','Telem GmbhLise-meitner-allee 31D 44801Germany',1),('00:06:B8','Bandspeed Pty Ltd','Bandspeed Pty LtdLevel 9, 5000 Collins StreetMelbourne Vic 3000Australia',1),('00:06:B9','A5tek Corp.','A5tek Corp.1233 Alderwood Ave.Sunnyvale Ca 94089United States',1),('00:06:BA','Westwave Communications','Westwave Communications463 Aviation Blvd.Santa Rosa Ca 95403United States',1),('00:06:BB','Ati Technologies Inc.','Ati Technologies Inc.75 Tiverton CourtUnionville, On L3r 953Canada',1),('00:06:BC','Macrolink, Inc.','Macrolink, Inc.1500 N Kellogg Dr.Anaheim Ca 92807United States',1),('00:06:BD','Bntechnology Co., Ltd.','Bntechnology Co., Ltd.602 Youngshin Bldg. 238-8Poi-dong Kangnam-guSeoulKorea, Republic Of',1),('00:06:BE','Baumer Optronic Gmbh','Baumer Optronic GmbhBadstrasse 30D-01454 RadebergGermany',1),('00:06:BF','Accella Technologies Co., Ltd.','Accella Technologies Co., Ltd.Rm 512 No. 680 Gui Ping Rd.Shanghai  200233China',1),('00:06:C0','United Internetworks, Inc.','United Internetworks, Inc.5072 North 300 West, Suite 2nProvo Ut 84604United States',1),('00:06:C1','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:06:C2','Smartmatic Corporation','Smartmatic Corporation6400 Congress Ave., Suite 1300Boca Raton Fl 33487United States',1),('00:06:C3','Schindler Elevator Ltd.','Schindler Elevator Ltd.Dept. R&d-coVia Della Pace 22Locarno Ch-6600Switzerland',1),('00:06:C4','Piolink Inc.','Piolink Inc.It Castle 1-401, 550-1 Gasan-dong,1656-2 Seocho-gu, SeoulSeoul Geumchon-gu 153-803Korea, Republic Of',1),('00:06:C5','Innovi Technologies Limited','Innovi Technologies Limited31st Floor, China Online Centre333 Lockhart RoadWanchaiHong Kong',1),('00:06:C6','Lesswire Ag','Lesswire AgIm Technologiepark 25Germany',1),('00:06:C7','Rfnet Technologies Pte Ltd (s)','Rfnet Technologies Pte Ltd (s)Unit 233 Innovation Centre Blk 218 Nanyang Drive637722Singapore',1),('00:06:C8','Sumitomo Metal Micro Devices, Inc.','Sumitomo Metal Micro Devices, Inc.1, Higashimukojima Higashino-choAmagasaki, Hyogo, 660-8660Japan',1),('00:06:C9','Technical Marketing Research, Inc.','Technical Marketing Research, Inc.Shin Nihon Gijutsu Bldg.1-1-32, Shibadaimon, Minato-kuTokyo 105-0012  105-0012Japan',1),('00:06:CA','American Computer & Digital Components, Inc. (acdc)','American Computer & Digital Components, Inc. (acdc)440 Cloverleaf DriveBaldwin Park Ca 91706United States',1),('00:06:CB','Jotron Electronics A/s','Jotron Electronics A/sPob 54N3280 TjodalyngNorway',1),('00:06:CC','Jmi Electronics Co., Ltd.','Jmi Electronics Co., Ltd.Nanyang B/d 3f, 25-4Yonmun-dong, Yongsan-guSeoul  140-080Korea, Republic Of',1),('00:06:CD','Kodak Il Ltd.','Kodak Il Ltd.7th Hatnufa StPetach-tikva  49002Israel',1),('00:06:CE','Dateno','DatenoRue Amiral BerengerZac Es Passants Ii Bp 90145, 35801 DinarFrance',1),('00:06:CF','Thales Avionics In-flight Systems, Llc','Thales Avionics In-flight Systems, Llc17481 Red Hill AvenueIrvine Ca 92614-5630United States',1),('00:06:D0','Elgar Electronics Corp.','Elgar Electronics Corp.9250 Brown Deer Rd.San Diego Ca 92121United States',1),('00:06:D1','Tahoe Networks, Inc.','Tahoe Networks, Inc.3052 Orchard DriveSan Jose Ca 95134United States',1),('00:06:D2','Tundra Semiconductor Corp.','Tundra Semiconductor Corp.603 March RoadKanata, Ont.K2k-2m5Canada',1),('00:06:D3','Alpha Telecom, Inc. U.s.a.','Alpha Telecom, Inc. U.s.a.1394 Borregor Ave.Sunnyvale Ca 94089United States',1),('00:06:D4','Interactive Objects, Inc.','Interactive Objects, Inc.12600 Se 38th St.Suite 150Bellevue Wa 98006United States',1),('00:06:D5','Diamond Systems Corp.','Diamond Systems Corp.8430-d Central Ave.Newark Ca 94560United States',1),('00:06:D6','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:06:D7','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:06:D8','Maple Optical Systems','Maple Optical Systems3200 North First St.San Jose Ca 95134United States',1),('00:06:D9','Ipm-net S.p.a.','Ipm-net S.p.a.Via Remo De Feo80022 Arzano (naples)Italy',1),('00:06:DA','Itran Communications Ltd.','Itran Communications Ltd.1 Azrieli Center,The Round BuildingTel Aviv 67021   67021Israel',1),('00:06:DB','Ichips Co., Ltd.','Ichips Co., Ltd.3f, Samjeon Bldg., 236-3Nonhyun-dong, Kangnam-kuSeoul-city  135-01Korea, Republic Of',1),('00:06:DC','Syabas Technology (amquest)','Syabas Technology (amquest)4727 Paseo Padre ParkwayFremont Ca 94555United States',1),('00:06:DD','At & T Laboratories - Cambridge Ltd','At & T Laboratories - Cambridge Ltd24a Trumpington StreetCambridge, Cb2 1qaEnglandUnited Kingdom',1),('00:06:DE','Flash Technology','Flash TechnologyP.o. Box 681509Franklin Tn 37068United States',1),('00:06:DF','Aidonic Corporation','Aidonic Corporation2-7-10 Otsuka, Bunkyo-ku,Tokyo, 112-0012Japan',1),('00:06:E0','Mat Co., Ltd.','Mat Co., Ltd.864-3 Kwanyang-dongDongan-gu, Anyang-siKyunggi-do  431-060Korea, Republic Of',1),('00:06:E1','Techno Trade S.a','Techno Trade S.a732a Chaussee De BruxellesB-1410 WaterlooBelgium',1),('00:06:E2','Ceemax Technology Co., Ltd.','Ceemax Technology Co., Ltd.5f-7, 736, Chung Cheng Rd.,Chung Ho Taipei Hsien,Taiwan, Republic Of China',1),('00:06:E3','Quantitative Imaging Corporation','Quantitative Imaging Corporation8081 Lougheed HighwayBurnaby, BcCanada',1),('00:06:E4','Citel Technologies Ltd.','Citel Technologies Ltd.Wheatcroft Business ParkLandmere Lane, EdwaltonNottigham  Ng12 4dgUnited Kingdom',1),('00:06:E5','Fujian Newland Computer Ltd. Co.','Fujian Newland Computer Ltd. Co.141f Sunshine Holiday HotelNo. 26 Gao Qiao Rd., Wuyi SquareFuzhou Fujian  350005China',1),('00:06:E6','Dongyang Telecom Co., Ltd.','Dongyang Telecom Co., Ltd.642-7 Deung Chon-dong, Kangseo-guSeoul 157-841Korea, Republic Of',1),('00:06:E7','Bit Blitz Communications Inc.','Bit Blitz Communications Inc.830 Hillview Ct., #290Milpitas Ca 95035United States',1),('00:06:E8','Optical Network Testing, Inc.','Optical Network Testing, Inc.55 Merchant St.28th FloorHonolulu Hi 96813United States',1),('00:06:E9','Intime Corp.','Intime Corp.324-4, Yangjae-dong, 2fSeocho-ku, Seoul, 137-130,Korea, Republic Of',1),('00:06:EA','Elzet80 Mikrocomputer Gmbh&co. Kg','Elzet80 Mikrocomputer Gmbh&co. KgTheaterplatz 9D-52062 AachenGermany',1),('00:06:EB','Global Data','Global Data2250 Obispo Ave #105Signal Hill Ca 90806United States',1),('00:06:EC','M/a Com Private Radio System Inc.','M/a Com Private Radio System Inc.3315 Old Forest RoadLynchburg Va 24501United States',1),('00:06:ED','Inara Networks','Inara Networks3031 Tisch Way,Suite 100San Jose Ca 95128United States',1),('00:06:EE','Shenyang Neu-era Information & Technology Stock Co., Ltd','Shenyang Neu-era Information & Technology Stock Co., Ltd8/f, The 21st Century Building,No. 1 Shiji Road, Hunnan Industrial DistDvlpmnt Zone Shenyang,China',1),('00:06:EF','Maxxan Systems, Inc.','Maxxan Systems, Inc.107 Bonaventura DriveSan Jose Ca 95134United States',1),('00:06:F0','Digeo, Inc.','Digeo, Inc.8815 122nd Ave., NeKirkland Wa 98033United States',1),('00:06:F1','Optillion','OptillionKronborgsgr.9Se-16487 KistaSweden',1),('00:06:F2','Platys Communications','Platys Communications3150a Coronado Dr.Santa Clara Ca 95054United States',1),('00:06:F3','Accelight Networks','Accelight Networks70 Abele Road, Building 1200Pittsburgh Pa 15017United States',1),('00:06:F4','Prime Electronics & Satellitics Inc.','Prime Electronics & Satellitics Inc.69, Tung-yuan Rd.,Chung-li City, TaoyuanTaiwan, Republic Of China',1),('00:06:F8','Cpu Technology, Inc.','Cpu Technology, Inc.5731 W. Las Positas Blvd.Pleasanton Ca 94588United States',1),('00:06:F9','Mitsui Zosen Systems Research Inc.','Mitsui Zosen Systems Research Inc.11-1, Uno 1-chomeTamano-shi, Okayama706-0011Japan',1),('00:06:FA','Ip Square Co, Ltd.','Ip Square Co, Ltd.1-9-11, Hakataekihigashi,Hakata-ku, Fukuoka-shi,Fukuoka  812-0013Japan',1),('00:06:FB','Hitachi Printing Solutions, Ltd.','Hitachi Printing Solutions, Ltd.1060, Takeda Hitachinaka-cityIbaraki-pref.312-8502Japan',1),('00:06:FC','Fnet Co., Ltd.','Fnet Co., Ltd.Kfsb Bldg. 10th F. 16-2Yoido-dong, Youngdeungpo-ku,SeoulKorea, Republic Of',1),('00:06:FD','Comjet Information Systems Corp.','Comjet Information Systems Corp.7fl., No. 103, Fen Liao StreetNei-hu, TaipeiTaiwan, Republic Of China',1),('00:06:FE','Celion Networks, Inc.','Celion Networks, Inc.3101 E. Pres. George Bush Frwy. #250Richardson Tx 75082United States',1),('00:06:FF','Sheba Systems Co., Ltd.','Sheba Systems Co., Ltd.5th Fl. Hyundai Jad B/d460-1 Seongnae-dong, Kangdong-ku,Seoul  134-030Korea, Republic Of',1),('00:07:00','Zettamedia Korea','Zettamedia KoreaSuite 1008, Kumkang Venturetel, 1108Bisandong, Dongangu, AnyangsiKyounggido,Korea, Republic Of',1),('00:07:01','Racal-datacom','Racal-datacomLan Internetworking Division155 Swanson RoadBoxborough Ma 01719United States',1),('00:07:02','Varian Medical Systems','Varian Medical Systems2599 Garcia AvenueMountain View Ca 94043United States',1),('00:07:03','Csee Transport','Csee Transport4, Avenue Du CanadaB.p. 243-91944 Les UlisFrance',1),('00:07:05','Endress & Hauser Gmbh & Co','Endress & Hauser Gmbh & CoHauptstrabe 1 - Postfach 1261D-79689 MaulbergGermany',1),('00:07:06','Sanritz Corporation','Sanritz Corporation199-1, Shimooibukuro,Kawagoe-city, Saitama350-0848Japan',1),('00:07:07','Interalia Inc.','Interalia Inc.4110-79th Street N.w.Calgary, AlbertaT3b 5c2Canada',1),('00:07:08','Bitrage Inc.','Bitrage Inc.100 Southpark Blvd.Suite 400Saint Augustine Fl 32086United States',1),('00:07:09','Westerstrand Urfabrik Ab','Westerstrand Urfabrik AbBox 133Se-545 23 TorebodaSweden',1),('00:07:0A','Unicom Automation Co., Ltd.','Unicom Automation Co., Ltd.Silk Bldg 3-31-11Honcho, Nakano-ku,Tokyo  164-0012Japan',1),('00:07:0B','Octal, Sa','Octal, SaAv. Do Forte, 6-piso 12790-072 CarnaxidePortugal',1),('00:07:0C','Sva-intrusion.com Co. Ltd.','Sva-intrusion.com Co. Ltd.The 4th Floor, No. 28 Building140 Tian Lin RoadShanghai  20233China',1),('00:07:0D','Cisco Systems Inc.','Cisco Systems Inc.Sj-m/1170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:0E','Cisco Systems Inc.','Cisco Systems Inc.Sj-m/1170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:0F','Fujant, Inc.','Fujant, Inc.6305 Carpinteria AvenueSuite 300Carpinteria Ca 93013-2901United States',1),('00:07:10','Adax, Inc.','Adax, Inc.614 Bancroft WayBerkeley Ca 94556United States',1),('00:07:11','Acterna','Acterna6620 Network WayIndianapolis In 46278United States',1),('00:07:12','Jal Information Technology','Jal Information TechnologyNetwork Solution Dep. Jal-tamachi Bldg.15-1, Shibura, 4-chome, Minato-ku,TokyoJapan',1),('00:07:13','Ip One, Inc.','Ip One, Inc.Sammi Bldg., 1004Daechi-dong Gangnam-gu,Seoul,  135-083Korea, Republic Of',1),('00:07:14','Brightcom','Brightcom6 Hanechoshet St.,Tel Aviv 69710Israel',1),('00:07:15','General Research Of Electronics, Inc.','General Research Of Electronics, Inc.3-12-17, Mita, Minato-kuTokyo  108-0073Japan',1),('00:07:16','J & S Marine Ltd.','J & S Marine Ltd.Pottington Business ParkBarnstapleDevon  Ex31 1lyUnited Kingdom',1),('00:07:17','Wieland Electric Gmbh','Wieland Electric GmbhBrennerstr. 10-14D-96052 BambergGermany',1),('00:07:18','Icantek Co., Ltd.','Icantek Co., Ltd.2nd Fl. Dk Plaza Ii, 376-5,Keumgok-dong, Bumdag-ku,Sungman-si, Kyonggi-do  463-805Korea, Republic Of',1),('00:07:19','Mobiis Co., Ltd.','Mobiis Co., Ltd.277-1, Shinhwa Bldg. 4fYangjae-dong, Seocho-gu,Seoul,Korea, Republic Of',1),('00:07:1A','Finedigital Inc.','Finedigital Inc.4th Fl. Bomi Bldg., 661 Deungchon 3 DongKangseo Ku,Seoul  157-033Korea, Republic Of',1),('00:07:1B','Cdv Americas Ltd','Cdv Americas Ltd1645-a Autoroute Laval WestLaval Quebec H7l 3w3Canada',1),('00:07:1C','At&t Fixed Wireless Services','At&t Fixed Wireless ServicesP.o. Box 90759Redmond Wa 98073-9759United States',1),('00:07:1D','Satelsa Sistemas Y Aplicaciones De Telecomunicaciones, S.a.','Satelsa Sistemas Y Aplicaciones De Telecomunicaciones, S.a.C/, Alejandro Moran, 5628025-madridSpain',1),('00:07:1E','Tri-m Engineering / Nupak Dev. Corp.','Tri-m Engineering / Nupak Dev. Corp.6-1301 Ketch CourtCoquitcaut BcV3k 6x7Canada',1),('00:07:1F','European Systems Integration','European Systems Integration455 Promenade Des AnglasF-06200 NiceFrance',1),('00:07:20','Trutzschler Gmbh & Co. Kg','Trutzschler Gmbh & Co. KgDuvenstr. 82-9241199 MonchengladbachGermany',1),('00:07:21','Formac Elektronik Gmbh','Formac Elektronik GmbhDofstr. 3315827 BlankenteldeGermany',1),('00:07:22','The Nielsen Company','The Nielsen Company501 Brooker Creek Blvd.Oldsmar Fl 34677United States',1),('00:07:23','Elcon Systemtechnik Gmbh','Elcon Systemtechnik GmbhObere Hauptstrasse 10D-09232 HartmannsdorfGermany',1),('00:07:24','Telemax Co., Ltd.','Telemax Co., Ltd.6th Fl. Sungwoo B/d, 1099-1Sanbon-dong, Kunpo-shiKyungki-do,  435-040Korea, Republic Of',1),('00:07:25','Bematech International Corp.','Bematech International Corp.5895 Shiloh RoadSuite 111Alpharetta Ga 30005United States',1),('00:07:27','Zi Corporation (hk) Ltd.','Zi Corporation (hk) Ltd.30/f, China Resources Building26 Harbour Road, Waichai,Hong Kong',1),('00:07:28','Neo Telecom','Neo TelecomEast Building 9f, 1tVenture Tower, 78 Garag-dongSongpa-gu, SeoulKorea, Republic Of',1),('00:07:29','Kistler Instrumente Ag','Kistler Instrumente AgEulachstrasse 22Ch-8408 WinterthurSwitzerland',1),('00:07:2A','Innovance Networks','Innovance Networks19 Fairmont AvenueOttawa, Ontario K1y 1x4Canada',1),('00:07:2B','Jung Myung Telecom Co., Ltd.','Jung Myung Telecom Co., Ltd.5fl Silla Technovil., 39-3 Dang-dongKoonpo-shi, Kyung Ki-doKorea, Republic Of',1),('00:07:2C','Fabricom','FabricomRue Gatti De Gamond 2541190 BruxellesBelgium',1),('00:07:2D','Cnsystems','CnsystemsBaumkircherstrasse 1A-8020 GrazAustria',1),('00:07:2E','North Node Ab','North Node AbSkeppsloron 421130 StockholmSweden',1),('00:07:2F','Intransa, Inc.','Intransa, Inc.2670 ZankerSuite 200San Jose Ca 95134United States',1),('00:07:30','Hutchison Optel Telecom Technology Co., Ltd.','Hutchison Optel Telecom Technology Co., Ltd.No. 28 Xinwai StreetBeijingChina',1),('00:07:31','Ophir-spiricon Inc','Ophir-spiricon Inc60 W 1000 NLogan Ut 84321United States',1),('00:07:32','Aaeon Technology Inc.','Aaeon Technology Inc.5f, #135, Lane 235, Pao Chiao RoadHsin-tien CityTaipeiTaiwan, Republic Of China',1),('00:07:33','Dancontrol Engineering','Dancontrol EngineeringItaliensvej 1-5Dk-8450 HammelDenmark',1),('00:07:34','Onstor, Inc.','Onstor, Inc.130-b Knowles DriveLos Gatos Ca 95032United States',1),('00:07:35','Flarion Technologies, Inc.','Flarion Technologies, Inc.135 Route 202/206 SouthBedminster Nj 07921United States',1),('00:07:36','Data Video Technologies Co., Ltd.','Data Video Technologies Co., Ltd.7f, No. 352, Sec. 2Chung-shan Rd., Chung-ho CityTaipei HsienTaiwan, Republic Of China',1),('00:07:37','Soriya Co. Ltd.','Soriya Co. Ltd.2, 8th Floor Hanshin B/o, 136-1,Hapo-dong, Mapo-gu,Seoul,Korea, Republic Of',1),('00:07:38','Young Technology Co., Ltd.','Young Technology Co., Ltd.D-604, Sigma-ii Officetel,#18, Gumi-dong, Bundgang-gu,Sungnam-si, Kyeonggi-do 763-741Korea, Republic Of',1),('00:07:39','Motion Media Technology Ltd.','Motion Media Technology Ltd.Severn Bridge, Aust,Bristol, Bs35 4blUnited Kingdom',1),('00:07:3A','Inventel Systemes','Inventel Systemes35, Rue Toumefort75005 ParisFrance',1),('00:07:3B','Tenovis Gmbh & Co Kg','Tenovis Gmbh & Co KgKleyerstrasse 9460326 FrankfurtGermany',1),('00:07:3C','Telecom Design','Telecom DesignVoie Romaine, Zone De Remora33170 GradignanFrance',1),('00:07:3D','Nanjing Postel Telecommunications Co., Ltd.','Nanjing Postel Telecommunications Co., Ltd.No. 187, Shengzhou Road,Nanjing City, Jiangsu210004China',1),('00:07:3E','China Great-wall Computer Shenzhen Co., Ltd.','China Great-wall Computer Shenzhen Co., Ltd.Research & Development Center, Kefa RoadScience Industry Park, Nanshan DisctrictShenzhen  518057China',1),('00:07:3F','Woojyun Systec Co., Ltd.','Woojyun Systec Co., Ltd.4f Han Yang B/d, Yoido-dongYoung Deong Po-kuSeoul  150-010Korea, Republic Of',1),('00:07:40','Melco Inc.','Melco Inc.Melco Hi-tech Center,Shibata Hondori 4-15 Minami-ku,Nagoya  457-8520Japan',1),('00:07:41','Sierra Automated Systems','Sierra Automated Systems2625 North San Fernando Blvd.Burbank Ca 91504United States',1),('00:07:42','Current Technologies, Llc','Current Technologies, Llc20420 Century BlvdGermantown Md 20874United States',1),('00:07:43','Chelsio Communications','Chelsio Communications170 S. Whismon Rd.Bldg. D, Ste AMountain View Ca 94041-1512United States',1),('00:07:44','Unico, Inc.','Unico, Inc.3725 Nicholson Rd.Franksville Wi 53126United States',1),('00:07:45','Radlan Computer Communications Ltd.','Radlan Computer Communications Ltd.Atidim Technology ParkBldg. 4Tel Aviv  61131Israel',1),('00:07:46','Turck, Inc.','Turck, Inc.3000 Campus DrivePlymouth Mn 55441United States',1),('00:07:47','Mecalc','MecalcPo Box 7958Centurion 0046South Africa',1),('00:07:48','The Imaging Source Europe','The Imaging Source EuropeSommerstrasse 34-3628215 BremanGermany',1),('00:07:49','Cenix Inc.','Cenix Inc.5141 California AvenueIrvine Ca 92612United States',1),('00:07:4A','Carl Valentin Gmbh','Carl Valentin GmbhNeckarstrabe 78-80D-78056 Vs-schwenningenGermany',1),('00:07:4B','Daihen Corporation','Daihen Corporation2-1-11 Tagawa Yodogawa-kuOsaka 532-8512Japan',1),('00:07:4C','Beicom Inc.','Beicom Inc.114 King StreetAlexandria Va 22314United States',1),('00:07:4D','Zebra Technologies Corp.','Zebra Technologies Corp.333 Corporate Woods ParkwayVernon Hills Il 60061United States',1),('00:07:4E','Naughty Boy Co., Ltd.','Naughty Boy Co., Ltd.Parl Bldg. 6f, 3-15-5 ShibuyaShibuya-ku, Tokyo150-0002Japan',1),('00:07:4F','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:50','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:51','Mut Ag','Mut AgMegerte Fr Medizin- Und UmwelttechnikAm Marienhof 2Wedel  22880Germany',1),('00:07:52','Rhythm Watch Co., Ltd.','Rhythm Watch Co., Ltd.321 Shinshukushinden, Showa-machi,Kitakatshika-gun, Saitama344-0196Japan',1),('00:07:53','Beijing Qxcomm Technology Co., Ltd.','Beijing Qxcomm Technology Co., Ltd.4f Tower B, Tongtai Building No. 33,Financial Street, Xicheng District,Beijing 100032China',1),('00:07:54','Xyterra Computing, Inc.','Xyterra Computing, Inc.14505 Hayden Rd.,Suite B340Scottsdale Az 85260-6953United States',1),('00:07:55','Lafon Sa','Lafon Sa44 Avenue Victor MeunierBassens  33530France',1),('00:07:56','Juyoung Telecom','Juyoung Telecom#201, Dunsan Building218-1 Walpyeng-dong, Seogu,Taejon  302-846Korea, Republic Of',1),('00:07:57','Topcall International Ag','Topcall International AgTalpagasse 11230 ViennaAustria',1),('00:07:58','Dragonwave','Dragonwave600-411 Leggett Drive,Suite 600Kanata, Ontario K2k 3c9Canada',1),('00:07:59','Boris Manufacturing Corp.','Boris Manufacturing Corp.Po Box 601Castle Point Ny 12511United States',1),('00:07:5A','Air Products And Chemicals, Inc.','Air Products And Chemicals, Inc.7201 Hamilton Blvd.Mail Stop C1307Allentown Pa 18195-1501United States',1),('00:07:5B','Gibson Guitars','Gibson Guitars309 Park Plus Blvd.Nashville Tn 37217United States',1),('00:07:5C','Eastman Kodak Company','Eastman Kodak Company343 State StreetRochester Ny 14650-0124United States',1),('00:07:5D','Celleritas Inc.','Celleritas Inc.C/o Celeritas Ltd.Bezalel 29, Ramat-ganIsrael',1),('00:07:5E','Ametek Power Instruments','Ametek Power Instruments4050 Nw 121 AvenueCoral Springs Fl 33065United States',1),('00:07:5F','Vcs Video Communication Systems Ag','Vcs Video Communication Systems AgForchheimer Str. 490425 NuernbergGermany',1),('00:07:60','Tomis Information & Telecom Corp.','Tomis Information & Telecom Corp.Youngdeungpo Telephone Office - ExtensioYoungdeungpodong 35-1, Youngdeungpo-guSeoulKorea, Republic Of',1),('00:07:61','Logitech Sa','Logitech SaZ.i. Moulin Du Choc DCh-1122 Romanel-sur-morgesSwitzerland',1),('00:07:62','Group Sense Limited','Group Sense Limited27/f, Wu Chung House,213 Queens Road East,WanchaiHong Kong',1),('00:07:63','Sunniwell Cyber Tech. Co., Ltd.','Sunniwell Cyber Tech. Co., Ltd.17th Floor Haitai Building #229Beisihuan Hong Road,Beijing  100083China',1),('00:07:64','Youngwoo Telecom Co. Ltd.','Youngwoo Telecom Co. Ltd.3f, Sehwa B/d, 355-1Yatap-dong, Bundag-kuSungnam-si Kyungki-doKorea, Republic Of',1),('00:07:65','Jade Quantum Technologies, Inc.','Jade Quantum Technologies, Inc.5f, No. 116, Hsien Fu Rd.,Taoyuan,Taiwan, Republic Of China',1),('00:07:66','Chou Chin Industrial Co., Ltd.','Chou Chin Industrial Co., Ltd.9f, #35, Chiau An St. Chung Ho City,Taipei HsienTaiwan, Republic Of China',1),('00:07:67','Yuxing Electronics Company Limited','Yuxing Electronics Company LimitedUnit 1808, 18/f Tower 3,Enterprise Square, 9 Sheung Yuet RoadKowloon Bay, KowloonHong Kong',1),('00:07:68','Danfoss A/s','Danfoss A/sE16-n12, Dk-6430 NordborgDenmark',1),('00:07:69','Italiana Macchi Spa','Italiana Macchi SpaVia Matteotti 121040 Oggiona S. Stefano (va)Italy',1),('00:07:6A','Nexteye Co., Ltd.','Nexteye Co., Ltd.Shinsegi Plaza 4f, 900-9,Pyungchon, Dongan, Anyang,Kyunggi  431-070Korea, Republic Of',1),('00:07:6B','Stralfors Ab','Stralfors AbLanggatan 21S-341 84 LjungbySweden',1),('00:07:6C','Daehanet, Inc.','Daehanet, Inc.#8-2 Chung Jung Rd 2- GaSur Dae Moon,Seoul  120-012Korea, Republic Of',1),('00:07:6D','Flexlight Networks','Flexlight Networks15 Atir Yeda St.Kfar Saba 44643Israel',1),('00:07:6E','Sinetica Corporation Limited','Sinetica Corporation LimitedWillow HouseLlancayo CourtMonmouthshire Usk Np15 1hyUnited Kingdom',1),('00:07:6F','Synoptics Limited','Synoptics LimitedBeacon House, Nuffield Road,Cambridge Cb4 1tfUnited Kingdom',1),('00:07:70','Locusnetworks Corporation','Locusnetworks Corporation9th Fl. Chungjln53-5 Wonhyo-ro 3gaSeoul  140-719Korea, Republic Of',1),('00:07:71','Embedded System Corporation','Embedded System Corporation13-5, Takadanobaba 3-chome,Shinjuku-ku, Tokyo 169-0075Japan',1),('00:07:72','Alcatel Shanghai Bell Co., Ltd.','Alcatel Shanghai Bell Co., Ltd.No. 388, Ningqiao Road,Pudong Jinqiao, Shanghai201206China',1),('00:07:73','Ascom Powerline Communications Ltd.','Ascom Powerline Communications Ltd.Belpstr. 373000 Bern 14Switzerland',1),('00:07:74','Guangzhou Thinker Technology Co. Ltd.','Guangzhou Thinker Technology Co. Ltd.109 Zhongshan Ave., Tianhe DistrictGuangzhou510630China',1),('00:07:75','Valence Semiconductor, Inc.','Valence Semiconductor, Inc.41 DiscoveryIrvine Ca 92618United States',1),('00:07:76','Federal Apd','Federal Apd42775 Nine Mile Rd.Novi Mi 48375United States',1),('00:07:77','Motah Ltd.','Motah Ltd.4-4-5 KoishikawaBunkyo, Tokyo112-0002Japan',1),('00:07:78','Gerstel Gmbh & Co. Kg','Gerstel Gmbh & Co. KgEberhard-gerstel-platz 1D45473Mlheim An Der RuhrGermany',1),('00:07:79','Sungil Telecom Co., Ltd.','Sungil Telecom Co., Ltd.#321, Gongdan-dong,Gumi-city, Kyoung-buk730-030Korea, Republic Of',1),('00:07:7A','Infoware System Co., Ltd.','Infoware System Co., Ltd.Mizorogi Daiichi Bldg 4 F1-5-13 Shinjuku, Shinjuku-kuTokyoJapan',1),('00:07:7B','Millimetrix Broadband Networks','Millimetrix Broadband NetworksKibutz Givat Hashelosha 48800Israel',1),('00:07:7C','Westermo Teleindustri Ab','Westermo Teleindustri AbSe-640 40Stora SundbySweden',1),('00:07:7E','Elrest Gmbh','Elrest GmbhLeibnizstr. 10D-73230 KirchheimGermany',1),('00:07:7F','J Communications Co., Ltd.','J Communications Co., Ltd.124-4 Ojeon-dong, Ulwang-cityKyungki-doKorea, Republic Of',1),('00:07:80','Bluegiga Technologies Oy','Bluegiga Technologies OyP.o. Box 120Fin-02631 EspooFinland',1),('00:07:81','Itron Inc.','Itron Inc.2818 N. Sullivan RoadSpokane Wa 99216United States',1),('00:07:82','Sun Microsystems, Inc.','Sun Microsystems, Inc.4200 Network CircleSanta Clara Ma 95054United States',1),('00:07:83','Syncom Network, Inc.','Syncom Network, Inc.4f, No. 31, Hsintai Road, Chupei City,Hsinchu Hsien,Taiwan, Republic Of China',1),('00:07:84','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:85','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:86','Wireless Networks Inc.','Wireless Networks Inc.#300, 3016 Fifth Ave. NeCalgary, AlbertaT2a 6k4Canada',1),('00:07:87','Idea System Co., Ltd.','Idea System Co., Ltd.4-1-21 Shinmei-cho Okaya-shiNagano-ken 394-0004Japan',1),('00:07:88','Clipcomm, Inc.','Clipcomm, Inc.5th Fl, Ssangyang Bldg.935-1 Bongcheon-dong, Kwamak-gu,Seoul  151-827Korea, Republic Of',1),('00:07:89','Eastel Systems Corporation','Eastel Systems Corporation621-3, Bakdal-dongManan-gu, Anyang-siKyunggi-do  430-803Kuwait',1),('00:07:8A','Mentor Data System Inc.','Mentor Data System Inc.No. 24-1, Industry East 4 Rd.,Science Based Industrial Park,Hsin-chu,Taiwan, Republic Of China',1),('00:07:8B','Wegener Communications, Inc.','Wegener Communications, Inc.11350 Technology CircleDuluth Ga 30097United States',1),('00:07:8C','Elektronikspecialisten I Borlange Ab','Elektronikspecialisten I Borlange AbBox 5040 MockfjrdSe 780Sweden',1),('00:07:8D','Netengines Ltd.','Netengines Ltd.146 Walnut Tree CloseGuildford, SurreyGui 4ubUnited Kingdom',1),('00:07:8E','Garz & Friche Gmbh','Garz & Friche GmbhTempowerhving 4D-21079 HamburgGermany',1),('00:07:8F','Emkay Innovative Products','Emkay Innovative Products53, Pao Hsing Rd., Hsintien CityTaipeiTaiwan, Republic Of China',1),('00:07:90','Tri-m Technologies (s) Limited','Tri-m Technologies (s) LimitedBlk 25, Kallang Avenue #07-01/04Kallang Basin Ind. Est339416Singapore',1),('00:07:91','International Data Communications, Inc.','International Data Communications, Inc.47873 Fremont Blvd.Fremont Ca 04538United States',1),('00:07:92','Suetron Electronic Gmbh','Suetron Electronic GmbhKurze Strasse 2970794 FilderstadtGermany',1),('00:07:93','Shin Satellite Public Company Limited','Shin Satellite Public Company Limited41/103  Rattanathibet Road,Nonthaburi 11000,Thailand',1),('00:07:94','Simple Devices, Inc.','Simple Devices, Inc.111 Anza Blvd., Suite 120Burlingame Ca 94010United States',1),('00:07:95','Elitegroup Computer System Co. (ecs)','Elitegroup Computer System Co. (ecs)No. 22, Alley 38, Lane 91,Sec. 1, Nei Hu RoadTaipei  114Taiwan, Republic Of China',1),('00:07:96','Lsi Systems, Inc.','Lsi Systems, Inc.10-1 Minami-kurokawa,Asao-ku, Kawasaki,Kanagawa  215-0034Japan',1),('00:07:97','Netpower Co., Ltd.','Netpower Co., Ltd.Baekam Bldg., 6f123, Karak-dong, Song-pa GuSeoul  138-162Korea, Republic Of',1),('00:07:98','Selea Srl','Selea SrlVia A. Moro No. 6946015 - CicognaraItaly',1),('00:07:99','Tipping Point Technologies, Inc.','Tipping Point Technologies, Inc.7501 B N. Capital Of Tx Hwy.Austin Tx 78731United States',1),('00:07:9A','Verint Systems Inc','Verint Systems Inc1800 Berlier, Suite 440Laval,  Quebec H7l 4s4Canada',1),('00:07:9B','Aurora Networks','Aurora Networks2803 Mission College Blvd.Santa Clara Ca 95054United States',1),('00:07:9C','Golden Electronics Technology Co., Ltd.','Golden Electronics Technology Co., Ltd.No. 29, 21st Road,Taichung Industrial Park, TaichungTaiwan, Republic Of China',1),('00:07:9D','Musashi Co., Ltd.','Musashi Co., Ltd.3-21-1, Shimo-ochiai,Shinjuku-ku,Tokyo  161-0033Japan',1),('00:07:9E','Ilinx Co., Ltd.','Ilinx Co., Ltd.4th Floor Korea Telecom, Yangjae BranchDogok-dong, Kangnam-ku,SeoulKorea, Republic Of',1),('00:07:9F','Action Digital Inc.','Action Digital Inc.10650 Main St.Suite 102Fairfax Va 22030United States',1),('00:07:A0','E-watch Inc.','E-watch Inc.7800 Ih 10 WestSuite 700San Antonio Tx 78229United States',1),('00:07:A1','Viasys Healthcare Gmbh','Viasys Healthcare GmbhLeibnizstrasse 7Hoechberg Bavaria 97204Germany',1),('00:07:A2','Opteon Corporation','Opteon Corporation70 Hastings StreetWellesley Ma 02481United States',1),('00:07:A3','Ositis Software, Inc.','Ositis Software, Inc.6120 Stoneridge Mall RoadSuite 210Pleasanton Ca 94588United States',1),('00:07:A4','Gn Netcom Ltd.','Gn Netcom Ltd.12-13 Sedling Road, Wear Est., DistrictWashington, Tyne And WearEngland Ne38 9bzUnited Kingdom',1),('00:07:A5','Y.d.k Co. Ltd.','Y.d.k Co. Ltd.1705, Oshitate, Inagi-city,Tokyo,Japan',1),('00:07:A6','Home Automation, Inc.','Home Automation, Inc.4330 Michoud Blvd.New Orleans La 70129United States',1),('00:07:A7','A-z Inc.','A-z Inc.5-5-17 KamikoushienNishinomiya City, HyogoJapan',1),('00:07:A8','Haier Group Technologies Ltd.','Haier Group Technologies Ltd.No. 1 Haier Road, Hi-tech ZoneQingdao,China',1),('00:07:A9','Novasonics','Novasonics1390 Willow RoadMenlo Park Ca 94025United States',1),('00:07:AA','Quantum Data Inc.','Quantum Data Inc.2111 Big Timber Rd.Elgin Il 60123-1100United States',1),('00:07:AC','Eolring','Eolring10 Rue Alfred Kastler14000 CaenFrance',1),('00:07:AD','Pentacon Gmbh Foto-und Feinwerktechnik','Pentacon Gmbh Foto-und FeinwerktechnikEnderstrabe 9401277 DresdenGermany',1),('00:07:AE','Britestream Networks, Inc.','Britestream Networks, Inc.12401 Research Blvd.Building Two, Suite 275Austin Tx 78759United States',1),('00:07:AF','N-tron Corp.','N-tron Corp.820 S. University Blvd.Suite 4eMobile Al 36609United States',1),('00:07:B0','Office Details, Inc.','Office Details, Inc.25 Ottawa4th FloorGrand Rapids Mi 49503United States',1),('00:07:B1','Equator Technologies','Equator Technologies1300 White Oaks Rd.Campbell Ca 95008United States',1),('00:07:B2','Transaccess S.a.','Transaccess S.a.R. Galeno De Castro, 1445Turubatuba 04696-040Sao Paulo SpBrazil',1),('00:07:B3','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:B4','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:B5','Any One Wireless Ltd.','Any One Wireless Ltd.Namseoul Bd., 8f, 1304-3Seocho 4-dong, Seocho-guSeoulKorea, Republic Of',1),('00:07:B6','Telecom Technology Ltd.','Telecom Technology Ltd.Docklands Innovation Park128-130 East Wall RoadDublin 3Ireland',1),('00:07:B7','Samurai Ind. Prods Eletronicos Ltda','Samurai Ind. Prods Eletronicos LtdaR-nebraska, 443 S/2 2o AndarBrooklin Novo - Sao Paulo04560-011Brazil',1),('00:07:B8','American Predator Corp.','American Predator Corp.18630 Sutter Blvd.Morgan Hill Ca 95037United States',1),('00:07:B9','Ginganet Corporation','Ginganet CorporationKintetsu Shin Namba BuildingMinato Machi 1-4-38 NaniwakuOsaka Shi  1556-0017Japan',1),('00:07:BA','Utstarcom, Inc.','Utstarcom, Inc.1275 Barbor Bay PkwyAlameda Ca 94502United States',1),('00:07:BB','Candera Inc.','Candera Inc.673 South Milpitas Blvd.Milpitas Ca 95035United States',1),('00:07:BC','Identix Inc.','Identix Inc.6591 Sierra LaneDublin Ca 94568United States',1),('00:07:BD','Radionet Ltd.','Radionet Ltd.Keilaranta 602150 Esp00Finland',1),('00:07:BE','Datalogic Spa','Datalogic SpaVia Candini, 240012 Lippo Di Calderara Di RenoBolognaItaly',1),('00:07:BF','Armillaire Technologies, Inc.','Armillaire Technologies, Inc.10411 Motor City DriveBethesda Md 20817United States',1),('00:07:C0','Netzerver Inc.','Netzerver Inc.26 West Lone Cactus DrivePhoenix Az 85027United States',1),('00:07:C1','Overture Networks, Inc.','Overture Networks, Inc.507 Airport BlvdSuite 111Morrisville Nc 27560United States',1),('00:07:C2','Netsys Telecom','Netsys Telecom4f, Kyungnam B/d, 830-48, Yeoksam-dongKangnam-gu,Seoul  135-080Korea, Republic Of',1),('00:07:C3','Thomson','Thomson5-7, Rue Salomon De RothschildSuresnes92150France',1),('00:07:C4','Jean Co. Ltd.','Jean Co. Ltd.7f, 2, Rei Kuang Road,Nei Hu,TaipeiTaiwan, Republic Of China',1),('00:07:C5','Gcom, Inc.','Gcom, Inc.1800 Woodfield Dr.Savoy Il 61874United States',1),('00:07:C6','Vds Vosskuhler Gmbh','Vds Vosskuhler GmbhWeibe Breite 7D-49084 OsnabruckGermany',1),('00:07:C7','Synectics Systems Limited','Synectics Systems Limited3 Acorn Business ParkWooseats Close, SheffieldS8 OtbUnited Kingdom',1),('00:07:C8','Brain21, Inc.','Brain21, Inc.19f Mesa B/d, 204 Hoihyun-dongJoong-guSeoul  100-051Korea, Republic Of',1),('00:07:C9','Technol Seven Co., Ltd.','Technol Seven Co., Ltd.25-16 Tobehon-cho, Nisi-ku,Yokohama, 220-0041Japan',1),('00:07:CA','Creatix Polymedia Ges Fur Kommunikaitonssysteme','Creatix Polymedia Ges Fur KommunikaitonssystemeHeinrich-barth-str. 366115 SaarbrueckenGermany',1),('00:07:CB','Freebox Sa','Freebox Sa8 Rue De La Ville LevequeParis  75008France',1),('00:07:CC','Kaba Benzing Gmbh','Kaba Benzing GmbhAlbertistrabe 378056 Villigen-schwenningenGermany',1),('00:07:CD','Nmtel Co., Ltd.','Nmtel Co., Ltd.Suite 1303 1.b.c. 917-6Mok-1 Dong Tangcheon-kuSeoulKorea, Republic Of',1),('00:07:CE','Cabletime Limited','Cabletime Limited64 Greenham RoadNewbury, Berkshire,Rg14 7hxUnited Kingdom',1),('00:07:CF','Anoto Ab','Anoto AbSolvegatan 41Se-223 70 LundSweden',1),('00:07:D0','Automat Engenharia De Automaoa Ltda.','Automat Engenharia De Automaoa Ltda.Rua Santo Antonio, 917 - ReboucasCuritiba - Pr80230-120Brazil',1),('00:07:D1','Spectrum Signal Processing Inc.','Spectrum Signal Processing Inc.#200-2700 Production WayBurnaby, Bc V5a 4x1Canada',1),('00:07:D2','Logopak Systeme','Logopak SystemeDorfstrasse 40D-24628 HartenholmGermany',1),('00:07:D3','Stork Digital Imaging B.v.','Stork Digital Imaging B.v.Handelstraat 6P.o. Box 210Boxmeer  5830-aeNetherlands',1),('00:07:D4','Zhejiang Yutong Network Communication Co Ltd.','Zhejiang Yutong Network Communication Co Ltd.805 Huaxing Technical Building477# Wensan Road, HangzhouZhejiangChina',1),('00:07:D5','3e Technologies Int;., Inc.','3e Technologies Int;., Inc.15800 Crabbs Branch WaySuite 290Rockville Md 20855United States',1),('00:07:D6','Commil Ltd.','Commil Ltd.P.o. Box 10050Petah Tikva 49001Israel',1),('00:07:D7','Caporis Networks Ag','Caporis Networks AgSueggelstr. 31D-44532 LuenenGermany',1),('00:07:D8','Hitron Systems Inc.','Hitron Systems Inc.135-220 Hitron B/d 726-5Suso-dong, Kangnam GuSeoulKorea, Republic Of',1),('00:07:D9','Splicecom','SplicecomLittle Gillions, The GreenCroxley Green, RickmansworthHerts  Wd3 3hyUnited Kingdom',1),('00:07:DA','Neuro Telecom Co., Ltd.','Neuro Telecom Co., Ltd.2f Misung B/d, 938-7Hoge-dong, Dongan-guKyunggi-doKorea, Republic Of',1),('00:07:DB','Kirana Networks, Inc.','Kirana Networks, Inc.331 Newman Springs RoadBldg. 1 4th FloorRed Bank Nj 07701United States',1),('00:07:DC','Atek Co, Ltd.','Atek Co, Ltd.B Dong #205 Hanyang Venture Park685-20 Songsu1gadong Song Donggu,SeoulKorea, Republic Of',1),('00:07:DD','Cradle Technologies','Cradle Technologies3130 West Warren Ave.Fremont Ca 94538United States',1),('00:07:DE','Ecopilt Ab','Ecopilt AbVeddestavagen 24Se-175 62 JarfallaSweden',1),('00:07:DF','Vbrick Systems Inc.','Vbrick Systems Inc.12 Beaumont RoadWallingford Ct 06492United States',1),('00:07:E0','Palm Inc.','Palm Inc.950 West Maude AveSunnyvale Ca 94085-2801United States',1),('00:07:E1','Wis Communications Co. Ltd.','Wis Communications Co. Ltd.4/f Building 533Bugua Sixth RoadShenzhen Guangdong ProvidenceChina',1),('00:07:E2','Bitworks, Inc.','Bitworks, Inc.#1 Bitworks WayPrairie Grove Ar 72753United States',1),('00:07:E3','Navcom Technology, Inc.','Navcom Technology, Inc.123 West Torrance Blvd.,Suite 101Redondo Beach Ca 90277United States',1),('00:07:E4','Softradio Co., Ltd.','Softradio Co., Ltd.2f, Dong-bok B/d 645-18Yeoksam-dong, Kangnam-guSeoulKorea, Republic Of',1),('00:07:E5','Coup Corporation','Coup Corporation1-24-4 Marusen 2nd Bld. 4f,Higashi-ueno, Taito-kuTokyoJapan',1),('00:07:E6','Edgeflow Canada Inc.','Edgeflow Canada Inc.329 March RoadKanata, OntarioK2k 2e1Canada',1),('00:07:E7','Freewave Technologies','Freewave Technologies1880 S. Flaitron Ct.Ste. FBoulder Co 80301United States',1),('00:07:E8','St. Bernard Software','St. Bernard Software15015 Avenue Of ScienceSan Diego Ca 92128United States',1),('00:07:E9','Intel Corporation','Intel CorporationMs:  Jf3-4202111 Ne 25th Ave.Hillsboro Or 97124United States',1),('00:07:EA','Massana, Inc.','Massana, Inc.2901 Tasman DriveSuite 106Santa Clara Ca 95054United States',1),('00:07:EB','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:EC','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:07:ED','Altera Corporation','Altera Corporation101 Innovation DriveMs 2305San Jose Ca 95134United States',1),('00:07:EE','Telco Informationssysteme Gmbh','Telco Informationssysteme GmbhSchulstrasse 38D 0912 ChemnitzGermany',1),('00:07:EF','Lockheed Martin Tactical Systems','Lockheed Martin Tactical Systems3333 Pilot Knob RoadEagan Mn 55121United States',1),('00:07:F0','Beckett Logisync Llc','Beckett Logisync Llc1313 Lear Industrial ParkwayAvon Oh 44011United States',1),('00:07:F1','Teraburst Networks Inc.','Teraburst Networks Inc.985 Stewart DriveSunnyvale Ca 94086United States',1),('00:07:F2','Ioa Corporation','Ioa Corporation350 Potrero Ave.Sunnyvale Ca 94085United States',1),('00:07:F3','Thinkengine Networks','Thinkengine Networks100 Nickerson RoadMarlborough Ma 01752United States',1),('00:07:F4','Eletex Co., Ltd.','Eletex Co., Ltd.8-2-56 Nankou-higashi Suminoe-kuOsaka 559-0031Japan',1),('00:07:F5','Bridgeco Co Ag','Bridgeco Co AgRingstr. 14Ch 8600 DuebendorfSwitzerland',1),('00:07:F6','Qqest Software Systems','Qqest Software Systems860 East 4500 South #200Murray Ut 84107United States',1),('00:07:F7','Galtronics','Galtronics4645 East Cotton Center Blvd.Bldg. TwoPhoenix Az 85040United States',1),('00:07:F8','Itdevices, Inc.','Itdevices, Inc.606 110th Ave. NeBellevue Wa 98004United States',1),('00:07:F9','Phonetics, Inc.','Phonetics, Inc.901 Tryens RoadAston Pa 19014United States',1),('00:07:FA','Itt Co., Ltd.','Itt Co., Ltd.1-14-7, Mukohjyuku,Hamamatsu, Shizuoka 430Japan',1),('00:07:FB','Giga Stream Umts Technologies Gmbh','Giga Stream Umts Technologies GmbhKonrad-zuse-strabe 7D-66115 SaarbruckenGermany',1),('00:07:FC','Adept Systems Inc.','Adept Systems Inc.360 W. 920 N.Orem Ut 84057United States',1),('00:07:FD','Lanergy Ltd.','Lanergy Ltd.Imperial House, Imperial WayNewport, Gwent Np10 8uhUnited Kingdom',1),('00:07:FE','Rigaku Corporation','Rigaku Corporation3-9-12, Matsubara-choAkishima-shiTokyo  196-8666Japan',1),('00:07:FF','Gluon Networks','Gluon Networks5401 Old Redwood Hwy.Petaluma Ca 94954United States',1),('00:08:00','Multitech Systems, Inc.','Multitech Systems, Inc.2205 Woodale DriveMounds View Mn 55112United States',1),('00:08:01','Highspeed Surfing Inc.','Highspeed Surfing Inc.44790 S. Grimmer Blvd.Suite 100Fremont Ca 94538United States',1),('00:08:02','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:08:03','Cos Tron','Cos Tron3f Boolim B/d, 1431-22,Kwanyang-dong, Dongon-gu,Anyang  431-061Korea, Republic Of',1),('00:08:04','Ica Inc.','Ica Inc.542-1 NogukiKuki-shi, SaitamnJapan',1),('00:08:05','Techno-holon Corporation','Techno-holon Corporation3-19-2, Takamatsu-choTachikawa-shiTokyo  190-0011Japan',1),('00:08:06','Raonet Systems, Inc.','Raonet Systems, Inc.West Wing 14f, It Venture Tower 78Garakbon-dong, Songpa,Seoul  138-803Korea, Republic Of',1),('00:08:07','Access Devices Limited','Access Devices LimitedSixth Floor, 58 Oxbridge RoadEaling, London W5 2stUnited Kingdom',1),('00:08:08','Ppt Vision, Inc.','Ppt Vision, Inc.12988 Valley View Rd.Eden Prairie Mn 55344United States',1),('00:08:09','Systemonic Ag','Systemonic AgAm Waldschloesschen 1D-01099 DresdenGermany',1),('00:08:0A','Espera-werke Gmbh','Espera-werke GmbhMoltkestrasse 17- 3347058 DuisburgGermany',1),('00:08:0B','Birka Bpa Informationssystem Ab','Birka Bpa Informationssystem AbBox 20100161 02 BrommaSweden',1),('00:08:0C','Vda Elettronica Spa','Vda Elettronica SpaViale Lino Zanussi, 333170 PordenoneItaly',1),('00:08:0D','Toshiba','Toshiba2-9, Suehiro-cho,Ome-city,Tokyo  198-8710Japan',1),('00:08:0E','Motorola, Bcs','Motorola, Bcs6450 Sequence Dr.San Diego Ca 92121United States',1),('00:08:0F','Proximion Fiber Optics Ab','Proximion Fiber Optics AbIsafjordsgatan 9Se-16440 KistaSweden',1),('00:08:10','Key Technology, Inc.','Key Technology, Inc.150 Avery St.Walla Walla Wa 99362United States',1),('00:08:11','Voix Corporation','Voix Corporation1991-3 4th Floor Tops Venture TowerSeo Cho-dong, Seo Cho-guSeoul  138-090Korea, Republic Of',1),('00:08:12','Gm-2 Corporation','Gm-2 CorporationShiba-matushira-bldg.6f 3-3-12,shibaTokyo Minato-ku 105-0014Japan',1),('00:08:13','Diskbank, Inc.','Diskbank, Inc.3f Focus Building, 725-25Yeoksam-dong, Kangnam-guSeoul  135-080Korea, Republic Of',1),('00:08:14','Til Technologies','Til TechnologiesEuropark Depichaury, Bat 913856 Aix En ProvidenceFrance',1),('00:08:15','Cats Co., Ltd.','Cats Co., Ltd.751-2 Kachida-cho,Tsuzuki-ku, Yokohama224-0034Japan',1),('00:08:16','Bluetags A/s','Bluetags A/sNytorv 11, 4 Floor9000 AalborgDenmark',1),('00:08:17','Emergecore Networks Llc','Emergecore Networks Llc10542 S. Jordan GatewaySuite 150South Jordan Ut 84095United States',1),('00:08:18','Pixelworks, Inc.','Pixelworks, Inc.7700 Sw Mohawk StreetTualatin Or 97062United States',1),('00:08:19','Banksys','BanksysHaachtsesteenweg 14421130 BrusselBelgium',1),('00:08:1A','Sanrad Intelligence Storage Communications (2000) Ltd.','Sanrad Intelligence Storage Communications (2000) Ltd.32 Habarzel St., Entrace BTel-aviv 69710Israel',1),('00:08:1B','Windigo Systems','Windigo Systems2210 Otoole Ave. #200San Jose Ca 95131United States',1),('00:08:1C','@pos.com','@pos.com3051 North First StreetSan Jose Ca 95134United States',1),('00:08:1D','Ipsil, Incorporated','Ipsil, Incorporated7945 Macarthur Blvd.Suite 212Cabin John Md 20818United States',1),('00:08:1E','Repeatit Ab','Repeatit AbFarogatan 7Se16440 KistaSweden',1),('00:08:1F','Pou Yuen Tech Corp. Ltd.','Pou Yuen Tech Corp. Ltd.16f, No. 107, Sect. 3, Taichung Keng Rd.Taichung City 407,Taiwan, Republic Of China',1),('00:08:20','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:08:21','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:08:22','Inpro Comm','Inpro Comm11f, No. 93 Shuei-yuan StreetHsinchu, 300Taiwan, Republic Of China',1),('00:08:23','Texa Corp.','Texa Corp.Nara Bldg. 3f, 2-2-8 Shin-yokohama,Kohoku-ku, Yokohama222-0033Japan',1),('00:08:24','Copitrak Inc','Copitrak Inc8390 Mayrand StreetMontreal  Quebec H4p 2c9Canada',1),('00:08:25','Acme Packet','Acme Packet71 Third AvenueBurllingtonWoburn Ma 01803United States',1),('00:08:26','Colorado Med Tech','Colorado Med Tech6175 Longbow Dr.Boulder Co 80301United States',1),('00:08:27','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano 20126Italy',1),('00:08:28','Koei Engineering Ltd.','Koei Engineering Ltd.3-40, 5-chomeKire-nishi Hirano-kuOsaku  547-0026Japan',1),('00:08:29','Aval Nagasaki Corporation','Aval Nagasaki Corporation6-42 Tukuba IsahayaNagasaki854-0065Japan',1),('00:08:2A','Powerwallz Network Security','Powerwallz Network Security120-13160 Vanier Place,Richmond, Bc,V6v 2j2Canada',1),('00:08:2B','Wooksung Electronics, Inc.','Wooksung Electronics, Inc.Jaho-bldg. 6f, Tanbang-dong,Seo-gu, Taejon, 302-223Korea, Republic Of',1),('00:08:2C','Homag Ag','Homag AgAbt. Est., Homag Str. 3-5D-72296 SchopflochGermany',1),('00:08:2D','Indus Teqsite Private Limited','Indus Teqsite Private Limited#7, Arya Gowder Road,West Mambalam, Chennai,Tamil Nadu  600033India',1),('00:08:2E','Multitone Electronics Plc','Multitone Electronics PlcMultitone House, Beggarwood LaneBasingstoke Rg23 7llUnited Kingdom',1),('00:08:4E','Divergenet, Inc.','Divergenet, Inc.2142 Bering Dr.San Jose Ca 95131United States',1),('00:08:4F','Qualstar Corporation','Qualstar Corporation3990b Heritage Oak CourtSimi Valley Ca 93063United States',1),('00:08:50','Arizona Instrument Corp.','Arizona Instrument Corp.1912 W. 4th StreetTempe Az 85281United States',1),('00:08:51','Canadian Bank Note Company, Ltd.','Canadian Bank Note Company, Ltd.18 Auriga Dr.Nepean, Ont.K2e 7t9Canada',1),('00:08:52','Davolink Co. Inc.','Davolink Co. Inc.Room-604, Kumhwa Plaza,1142-5, Sanbon-dong, Kunpo-siKyunggi-do  435-040Korea, Republic Of',1),('00:08:53','Schleicher Gmbh & Co. Relaiswerke Kg','Schleicher Gmbh & Co. Relaiswerke KgPichelswerderstrasse 3-5D-13597 BerlinGermany',1),('00:08:54','Netronix, Inc.','Netronix, Inc.3f-1, No. 31, Hsin-tai Road,Chupei City, Hsinchu HsienTaiwan, Republic Of China',1),('00:08:55','Nasa-goddard Space Flight Center','Nasa-goddard Space Flight CenterCode 561Greenbelt Md 20771United States',1),('00:08:56','Gamatronic Electronic Industries Ltd.','Gamatronic Electronic Industries Ltd.Hartum Street 14Jerusalem 97774Israel',1),('00:08:57','Polaris Networks, Inc.','Polaris Networks, Inc.6810 Santa Teresa Blvd.San Jose Ca 95119United States',1),('00:08:58','Novatechnology Inc.','Novatechnology Inc.Nova Bldg. 4f 641 03Yuksam-dong Kangnam-kuSeoul  135-080Korea, Republic Of',1),('00:08:59','Shenzhen Unitone Electronics Co., Ltd.','Shenzhen Unitone Electronics Co., Ltd.2 Southern Floor 702 BuildingBagualing Industrial Zone ShenzhenChina',1),('00:08:5A','Intigate Inc.','Intigate Inc.309e It Venture Tower78, Garakbon-dong, Songpa-guSeoul  138-803Korea, Republic Of',1),('00:08:5B','Hanbit Electronics Co., Ltd.','Hanbit Electronics Co., Ltd.414-5, Woncheon-dong, Paldal-guSuwon-city, Kyoungki-do, 442-823Korea, Republic Of',1),('00:08:5C','Shanghai Dare Technologies Co. Ltd.','Shanghai Dare Technologies Co. Ltd.23f, China Merchants Tower,No. 161, East Lujiazui RoadPudong New Area, ShanghaiChina',1),('00:08:5D','Aastra','Aastra1160 Route 22 EastBridgewater Nj 08807United States',1),('00:08:5E','Pco Ag','Pco AgDonaupark 1193309 KelheimGermany',1),('00:08:5F','Picanol N.v.','Picanol N.v.Polenlaan 3-78900 IeperBelgium',1),('00:08:60','Lodgenet Entertainment Corp.','Lodgenet Entertainment Corp.3900 W. Innovation StreetSioux Falls Sd 57107United States',1),('00:08:61','Softenergy Co., Ltd.','Softenergy Co., Ltd.346 Sangwangsipli-dong,Sung Dong-gu, SeoulKorea, Republic Of',1),('00:08:62','Nec Eluminant Technologies, Inc.','Nec Eluminant Technologies, Inc.14700 Avion ParkwayChantilly Va 20151United States',1),('00:08:63','Entrisphere Inc.','Entrisphere Inc.1601 S. De Anza Blvd.Suite 250Cupertino Ca 95014United States',1),('00:08:64','Fasy S.p.a.','Fasy S.p.a.Via Tognasca 7Gallarate Varese 21013Italy',1),('00:08:65','Jascom Co., Ltd','Jascom Co., LtdJuan Industrial Complex 330, 17-1,Juan-dong Nam-gu Incheon 402-200Korea, Republic Of',1),('00:08:66','Dsx Access Systems, Inc.','Dsx Access Systems, Inc.10731 Rockwall Rd.Dallas Tx 75238United States',1),('00:08:67','Uptime Devices','Uptime Devices3160 Bee Caves RdSuite 204Austin Texas 78746United States',1),('00:08:68','Puroptix','Puroptix1945 Camino Vida RobleSuite CCarlsbad Ca 92008United States',1),('00:08:69','Command-e Technology Co.,ltd.','Command-e Technology Co.,ltd.Suite 709, Zhongsheng Mansion,No.2 Bei Fengwo Rd.Beijing  100038China',1),('00:08:6A','Industrie Technik Ips Gmbh','Industrie Technik Ips GmbhWamslerstr. 581829 MunchenDeutschlandGermany',1),('00:08:6B','Mipsys','Mipsys19c, Avenue Des IndesLes Ulis Cedex  Fr-91969France',1),('00:08:6C','Plasmon Lms','Plasmon Lms4425 Arrowswest DriveColorado Springs Co 80907United States',1),('00:08:6D','Missouri Freenet','Missouri FreenetPo Box 771026St. Louis Missouri 63177-1026United States',1),('00:08:6E','Hyglo Ab','Hyglo AbVastberga Alle 60Se-126 75 StockholmSweden',1),('00:08:6F','Resources Computer Network Ltd.','Resources Computer Network Ltd.Rm 324, Tech Centre, 72 Tat Chee Ave.,Kowloon Tong, KowloonHong Kong',1),('00:08:70','Rasvia Systems, Inc.','Rasvia Systems, Inc.3255-3 Scott Blvd.Suite 102Santa Clara Ca 95054United States',1),('00:08:71','Northdata Co., Ltd.','Northdata Co., Ltd.#302 Kayangtechno-town 1487Kayang3-dongKangseo-gu Seoul 157-810Korea, Republic Of',1),('00:08:72','Sorenson Technologies, Inc.','Sorenson Technologies, Inc.1011 West 400 NorthLogan Ut 84321United States',1),('00:08:73','Dap Design B.v.','Dap Design B.v.Hinmanweg 11bBe Oldenzaal  7575Netherlands',1),('00:08:74','Dell Computer Corp.','Dell Computer Corp.One Dell WayRound Rock Tx 78682United States',1),('00:08:75','Acorp Electronics Corp.','Acorp Electronics Corp.8f, No.111-6,shing Teh Rd,San Chung Taipei Hsien 241Taiwan, Republic Of China',1),('00:08:76','Sdsystem','Sdsystem613,hyundai I Valley,223-12,Sangdaiwon 1-dong,jungwon-guSeongnam Gyeonggi-do 462-807Korea, Republic Of',1),('00:08:77','Liebert-hiross Spa','Liebert-hiross SpaVia Leonardo Da Vinci 8Piove Di Sacco Z.i. Tognana 35020Italy',1),('00:08:78','Benchmark Storage Innovations','Benchmark Storage Innovations3122 Sterling CircleBoulder Co 80301United States',1),('00:08:79','Cem Corporation','Cem CorporationP.o. Box 200Matthews Nc 28106United States',1),('00:08:7A','Wipotec Gmbh','Wipotec GmbhAdam-hoffman Str. 26D-67657 KaiserslautermGermany',1),('00:08:7B','Rtx Telecom A/s','Rtx Telecom A/sStroemmen 6Dk 9400 NoerresundbyDenmark',1),('00:08:7C','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:08:7D','Cisco Systems Inc.','Cisco Systems Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:08:7E','Bon Electro-telecom Inc.','Bon Electro-telecom Inc.Gayang 1st Factory 701, 14-81Gayang-dong Gangso-guSeoul  157-808Korea, Republic Of',1),('00:08:7F','Spaun Electronic Gmbh & Co. Kg','Spaun Electronic Gmbh & Co. KgByk-gulden - Str. 2278224 SingenGermany',1),('00:08:80','Broadtel Canada Communications Inc.','Broadtel Canada Communications Inc.3700 Griffith, Suite 389Saint-laurent Quebec H4t 2b3Canada',1),('00:08:81','Digital Hands Co.,ltd.','Digital Hands Co.,ltd.Towns Square 503, Kakiya Building 2f2-7-17 Shinyokohama Kouhoku-kuYokohama Kanagawa 222-0033Japan',1),('00:08:82','Sigma Corporation','Sigma Corporation2-3-15 Iwato-minamiKomae-shi Tokyo 201-8630Japan',1),('00:08:83','Hewlett-packard Company','Hewlett-packard Company10955 Tantau Avenue, Mailstop 45sl-gCupertino Ca 95014United States',1),('00:08:84','Index Braille Ab','Index Braille AbBox 155S-95423 GammelstadSweden',1),('00:08:85','Ems Dr. Thomas Wuensche','Ems Dr. Thomas WuenscheSonnenhang 3D-85304 IlmmuensterGermany',1),('00:08:86','Hansung Teliann, Inc.','Hansung Teliann, Inc.195-1, Neungpyung-ri, Opo-eubKwangju-si, Kyoggi-do, 464-890Korea, Republic Of',1),('00:08:87','Maschinenfabrik Reinhausen Gmbh','Maschinenfabrik Reinhausen GmbhFalkensteinstr. 8Regensburg Bavaria 93059Germany',1),('00:08:88','Oullim Information Technology Inc,.','Oullim Information Technology Inc,.A-10th Fl,. It Venture Tower,78 Garak-dong, Songpa-kuSeoul  138-803Korea, Republic Of',1),('00:08:89','Echostar Technologies Corp','Echostar Technologies Corp94 Inverness CircleEnglewood Co 80112United States',1),('00:08:8A','Minds@work','Minds@work15550 Rockfield Blvd. Suite CIrvine Ca 92618United States',1),('00:08:8B','Tropic Networks Inc.','Tropic Networks Inc.135 Micheal Cowpland DriveOttawa Ontario K2m2e9Canada',1),('00:08:8C','Quanta Network Systems Inc.','Quanta Network Systems Inc.13, 13f, Sec. 2, Pei-tou RdTaipei  112Taiwan, Republic Of China',1),('00:08:8D','Sigma-links Inc.','Sigma-links Inc.550-1 Higashiasakawa-cho,Hachioji-shi,Tokyo  193-8550Japan',1),('00:08:8E','Nihon Computer Co., Ltd.','Nihon Computer Co., Ltd.36-8 HigashitamachiHamamatsu Shizuoka 430-0915Japan',1),('00:08:8F','Advanced Digital Technology','Advanced Digital TechnologyAdt Bldg.,3-3, Yangjae-dong,Seocho-gu,SeoulKorea, Republic Of',1),('00:08:90','Avilinks Sa','Avilinks SaEtic Center - Cs 77 7299 Rue Des CharmillesCesson Sevigne Cedex France 35577France',1),('00:08:91','Lyan Inc.','Lyan Inc.5f-1, No.51, Sec.2, Keelung Rd.Taipei  110Taiwan, Republic Of China',1),('00:08:92','Em Solutions','Em Solutions101 Hyde RdYeronga Brisbane, Qld 4104Australia',1),('00:08:93','Le Information Communication Inc.','Le Information Communication Inc.Rm, 4501, Da-dong Chungang Circulation C1258 Kuro Bon-dong, Kuro-ku,Seoul  152-721Korea, Republic Of',1),('00:08:94','Innovision Multimedia Ltd.','Innovision Multimedia Ltd.Rm 608, 6/f Tins Enterprises Centre,777 Lai Chi Kok Road,Kowloon,Hong Kong',1),('00:08:95','Dirc Technologie Gmbh & Co.kg','Dirc Technologie Gmbh & Co.kgBorsigstr. 13Ratingen Nrw 40880Germany',1),('00:08:96','Printronix, Inc.','Printronix, Inc.14600 Myford Rd.P.o. Box 19559Irvine California 92623-9559United States',1),('00:08:97','Quake Technologies','Quake Technologies2880 Zanker RoadSuite 104San Jose Ca 95134United States',1),('00:08:98','Gigabit Optics Corporation','Gigabit Optics Corporation1156 Aster Ave.Sunnyvale Ca 94086-6810United States',1),('00:08:99','Netbind, Inc.','Netbind, Inc.5 Marine View PlazaHoboken Nj 07030United States',1),('00:08:9A','Alcatel Microelectronics','Alcatel MicroelectronicsExcelsiorlaan 44-46B-1930 ZavantemBelgium',1),('00:08:9B','Icp Electronics Inc.','Icp Electronics Inc.4f, No. 22, Chung-hsing Rd. Shi-chi CityTaipei Hsien, 221,Taipei  221Taiwan, Republic Of China',1),('00:08:9C','Elecs Industry Co., Ltd.','Elecs Industry Co., Ltd.1-22-23,shinsaku,takatsu-kuKawasaki Kanagawa 213-0014Japan',1),('00:08:9D','Uhd-elektronik','Uhd-elektronikZuercherstrasse 12Baden Ag 5400Switzerland',1),('00:08:9E','Beijing Enter-net Co.ltd','Beijing Enter-net Co.ltdNo 1 Courtyard,Shuangquanpu Jia 1,chaoyaBeijing  100085China',1),('00:08:9F','Efm Networks','Efm Networks403, 4th Floor Elegance 1 Bldg.25-2 Gumi-dong Pundang-guSungnam-si Kyunggi-do 463-808Korea, Republic Of',1),('00:08:A0','Stotz Feinmesstechnik Gmbh','Stotz Feinmesstechnik GmbhHermann-dreher Str. 6Gerlingen  70839Germany',1),('00:08:A1','Cnet Technology Inc.','Cnet Technology Inc.No.15, Park Avenue Ii, Science-based IndHsin-chu City,Hsin-chu  300Taiwan, Republic Of China',1),('00:08:A2','Adi Engineering, Inc.','Adi Engineering, Inc.1769a Worth ParkCharlottesville Va 22911United States',1),('00:08:A3','Cisco Systems','Cisco Systems170 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:08:A4','Cisco Systems','Cisco Systems170 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:08:A5','Peninsula Systems Inc.','Peninsula Systems Inc.6902 Verde Ridge Rd.Rancho Palos Verdes Ca 90275United States',1),('00:08:A6','Multiware & Image Co., Ltd.','Multiware & Image Co., Ltd.Saedong Bldg. 65-25,2ka, Namhang, YoungdoPusan  606-032Korea, Republic Of',1),('00:08:A7','Ilogic Inc.','Ilogic Inc.Rm#318, Technocomplex Bldg., 126-16, 5-gSeoul  136-701Korea, Republic Of',1),('00:08:A8','Systec Co., Ltd.','Systec Co., Ltd.19 Nochidori, NawaTokai Aichi 476-0002Japan',1),('00:08:A9','Sangsang Technology, Inc.','Sangsang Technology, Inc.64-8, Nogok-ri, Docheok-myun,Gwangju Kyonggi-do 464-882Korea, Republic Of',1),('00:08:AA','Karam','Karam98-3,  Hankangro 2-ka, YongsanSeoul  140-012Korea, Republic Of',1),('00:08:AB','Enerlinx.com, Inc.','Enerlinx.com, Inc.3965 South Woodhill LaneNew Berlin Wi 53151United States',1),('00:08:AC','Eltromat Gmbh','Eltromat GmbhHerforder Str. 249-251Leopoldshhe Nordrhein-westfalen 33818Germany',1),('00:08:AD','Toyo-linx Co., Ltd.','Toyo-linx Co., Ltd.Hirakawa-cho, Chiyada-ku,Tokyo  102-0093Japan',1),('00:08:AE','Packetfront Sweden Ab','Packetfront Sweden AbBox 1217Kista  16428Sweden',1),('00:08:AF','Novatec Corporation','Novatec Corporation2-19-2 Nishi-gotandaShinagawa-ku Tokyo 141-0031Japan',1),('00:08:B0','Bktel Communications Gmbh','Bktel Communications GmbhBenzstrasse 441836 Hueckelhoven-baal Nrw 41836Germany',1),('00:08:B1','Proquent Systems','Proquent Systems67 Forest StreetMarlboro Ma 01752United States',1),('00:08:B2','Shenzhen Compass Technology Development Co.,ltd','Shenzhen Compass Technology Development Co.,ltd4th Floor,building 205,tairan Industry&trade Park,futian District,shenzhenShenzhen Guangdong 518040China',1),('00:08:B3','Fastwel','FastwelProfsoyuznaya 108,Moscow  117313Russian Federation',1),('00:08:B4','Syspol','Syspol4th Fl,syspol B/d, Bangbae 4 Dong, SeochSeoul  137-064Korea, Republic Of',1),('00:08:B5','Tai Guen Enterprise Co., Ltd','Tai Guen Enterprise Co., LtdN0.400, 10f-7 Huanpei Rd.,Chung Li City Tw, Roc.Chung Li  320-61Taiwan, Republic Of China',1),('00:08:B6','Routefree, Inc.','Routefree, Inc.3400 Hillview Ave. Bldg. 5Palo Alto Ca 94306United States',1),('00:08:B7','Hit Incorporated','Hit Incorporated4f, 8, Lane 235, Pao-chiao Road,Shin Tien Taipei 231Taiwan, Republic Of China',1),('00:08:B8','E.f. Johnson','E.f. Johnson299 Johnson Ave.P.o. Box 1249Waseca Mn 56093United States',1),('00:08:B9','Kaon Media Co., Ltd.','Kaon Media Co., Ltd.#113 Imae 1-dong, Bundang-guSungnam-city Kyungki-do 463-829Korea, Republic Of',1),('00:08:BA','Erskine Systems Ltd','Erskine Systems LtdSalter RoadEastfield Industrial EstateScarborough North Yorkshire Yo11 3duUnited Kingdom',1),('00:08:BB','Netexcell','Netexcell15375 Barranca Pkwy, #e-106Irvine Ca 92679United States',1),('00:08:BC','Ilevo Ab','Ilevo AbBox 1561Karlstad Vrmland S-651 21Sweden',1),('00:08:BD','Tepg-us','Tepg-us100 Simplex DriveWestminster Ma 01441United States',1),('00:08:BE','Xenpak Msa Group','Xenpak Msa GroupCare Of: Agilent TechnologiesWhite House RoadIpswich Suffolk Ip1 5pbUnited Kingdom',1),('00:08:BF','Aptus Elektronik Ab','Aptus Elektronik AbFo Petersons G 6421 31 V. FrolundaSweden',1),('00:08:C0','Asa Systems','Asa SystemsS245 Korea Maritime University, 1 DongsaBusan Busan Metropolitan City 606-791Korea, Republic Of',1),('00:08:C1','Avistar Communications Corporation','Avistar Communications Corporation15851 Dallas Pkwy.Suite 600Addison Tx 75001United States',1),('00:08:C2','Cisco Systems','Cisco Systems80 West Tasman DrSan Jose Ca 95134United States',1),('00:08:C3','Contex A/s','Contex A/sSvanevang 2Allerod Dk 3450Denmark',1),('00:08:C4','Hikari Co.,ltd.','Hikari Co.,ltd.418-4 Minaminoda Chigenobu-choOnsen-gun Ehime 791-0297Japan',1),('00:08:C5','Liontech Co., Ltd.','Liontech Co., Ltd.306, Wooyoung Techno Center, 273-15,Sungsu2ga-3dong, Sungdong-ku,Seoul  133-831Korea, Republic Of',1),('00:08:C6','Philips Consumer Communications','Philips Consumer CommunicationsRoute Dangers72081 Le MansCedex 9France',1),('00:08:C7','Hewlett Packard','Hewlett Packard20555 State Highway 249Houston Tx 77070United States',1),('00:08:C8','Soneticom, Inc.','Soneticom, Inc.4325 Woodland Park Drive, Suite 102West Melbourne Florida 32904United States',1),('00:08:C9','Technisat Digital Gmbh','Technisat Digital GmbhGewerbepark Merbitz Nr. 5Dresden Saxony 01156Germany',1),('00:08:CA','Twinhan Technology Co.,ltd','Twinhan Technology Co.,ltd13f-6,no 79,sec 1,hsin Tai Wu Rd.,hsi-chTaipei Hsien  221Taiwan, Republic Of China',1),('00:08:CB','Zeta Broadband Inc.','Zeta Broadband Inc.660 Vista Way, Suite BMilpitas Ca 95035United States',1),('00:08:CC','Remotec, Inc.','Remotec, Inc.114 Union Valley RoadOak Ridge Tn 37830United States',1),('00:08:CD','With-net Inc','With-net Inc4fl B&b B/d 1403-4Kwangyang1-dong Dongan-kuAnyang Kyonggi 431-061Korea, Republic Of',1),('00:08:CE','Ipmobilenet Inc.','Ipmobilenet Inc.11909 E Telegraph Rd.Santa Fe Springs Ca 90670United States',1),('00:08:CF','Nippon Koei Power Systems Co., Ltd.','Nippon Koei Power Systems Co., Ltd.2940 Shinyoshida-choKohoku-ku Yokohama 223-8506Japan',1),('00:08:D0','Musashi Engineering Co., Ltd.','Musashi Engineering Co., Ltd.3-11-7, Nishi-shimbashiMinato-ku Tokyo 105-0003Japan',1),('00:08:D1','Karel Inc.','Karel Inc.Organize Sanayi BolgesiGazneliler Cad No:10  SincanAnkara  06935Turkey',1),('00:08:D2','Zoom Networks Inc.','Zoom Networks Inc.13f,xinludao Building,no.1175,nanshan RoShen Zhen Guangdong Province 518052China',1),('00:08:D3','Hercules Technologies S.a.','Hercules Technologies S.a.Place De LtoileCarentoir Bretagne 56910France',1),('00:08:D4','Ineoquest Technologies, Inc','Ineoquest Technologies, Inc1931 Washington StCanton Massachusetts 02021United States',1),('00:08:D5','Vanguard Managed Solutions','Vanguard Managed Solutions575 West StreetMansfield Ma. 02048United States',1),('00:08:D6','Hassnet Inc.','Hassnet Inc.2f Missy2000 B/d 725, Sooseo-dong,Kangnam-kuSeoul  135-757Korea, Republic Of',1),('00:08:D7','How Corporation','How Corporation1-11-17 ChiyodaSagamihara Kanagawa 229-0037Japan',1),('00:08:D8','Dowkey Microwave','Dowkey Microwave4822 Mcgrath StreetVentura Ca 93003United States',1),('00:08:D9','Mitadenshi Co.,ltd','Mitadenshi Co.,ltd1-8-6 Furuichi AsaminamikuHiroshima  731-0123Japan',1),('00:08:DA','Sofaware Technologies Ltd.','Sofaware Technologies Ltd.3 Hilazon St.Ramat-gan  52522Israel',1),('00:08:DB','Corrigent Systems','Corrigent Systems126 Yigal AlonTel Aviv  67443Israel',1),('00:08:DC','Wiznet','Wiznet5f Simmtech Bldg., 228-3,Nonyhun, KangnamSeoul  135-830Korea, Republic Of',1),('00:08:DD','Telena Communications, Inc.','Telena Communications, Inc.6725 Mesa Ridge RoadSuite 226San Diego Ca 92121United States',1),('00:08:DE','3up Systems','3up Systems6 Results WayCupertino Ca 95014United States',1),('00:08:DF','Alistel Inc.','Alistel Inc.Midori Bldg. 2f1-5-20 Nakagawa, Tsuzuki-kuYokohama Kanagawa 222-0001Japan',1),('00:08:E0','Ato Technology Ltd.','Ato Technology Ltd.Rm. 1314-1346, Block B1, Yau Tong Ind. CYau Tong, Kowloon,Hong KongHong Kong',1),('00:08:E1','Barix Ag','Barix AgWiesenstr. 17Zuerich Zh 8008Switzerland',1),('00:08:E2','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-bld M/1San Jose Ca 95134United States',1),('00:08:E3','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-bld M/1San Jose Ca 95134United States',1),('00:08:E4','Envenergy Inc','Envenergy Inc6307 Carpinteria AveCarpinteria Ca 93013United States',1),('00:08:E5','Idk Corporation','Idk Corporation6-7-10Chuo-rinkanYamato Kanagawa 242-0007Japan',1),('00:08:E6','Littlefeet','Littlefeet13000 Gregg StreetPoway California 92064United States',1),('00:08:E7','Shi Controlsystems,ltd.','Shi Controlsystems,ltd.19,natusimaYokosuka Kanagawa 237-8555Japan',1),('00:08:E8','Excel Master Ltd.','Excel Master Ltd.Room D, 3/f., Yeung Yiu Chung (no. 8) Ind. Bldg.20 Wang Hoi RoadKowloon BayHong Kong',1),('00:08:E9','Nextgig','Nextgig9820-b Towne Centre DriveSan Diego Ca 92121United States',1),('00:08:EA','Motion Control Engineering, Inc','Motion Control Engineering, Inc11380 White Rock RoadRancho Cordova Ca 95742United States',1),('00:08:EB','Romwin Co.,ltd.','Romwin Co.,ltd.406 Omiyaohtaka Bldg. 1-103Kishiki-choSaitama  330-0843Japan',1),('00:08:EC','Zonu, Inc.','Zonu, Inc.6005 Yolanda AvenueTarzana Ca 91356-1421United States',1),('00:08:ED','St&t Instrument Corp.','St&t Instrument Corp.16 Shing-gong Road, Yung-kung IndustrialYung-kung Tainan 710Taiwan, Republic Of China',1),('00:08:EE','Logic Product Development','Logic Product Development411 Washington Ave N. Suite 101Minneapolis Minnesota 55401United States',1),('00:08:EF','Dibal,s.a.','Dibal,s.a.Astintze Kalea 24Derio Vizcaya 48160Spain',1),('00:08:F0','Next Generation Systems, Inc.','Next Generation Systems, Inc.Po Box 31205Dayton Oh 45437-0205United States',1),('00:08:F1','Voltaire','Voltaire9 Hamenofim St.Herzelia  46725Israel',1),('00:08:F2','C&s Technology','C&s TechnologyC&s Venture Bldg., Nonhyun-dong,221-1, Gangnam-guSeoul  135-829Korea, Republic Of',1),('00:08:F3','Wany','WanyCeei Cap AlphaAvenue De Leurope, ClapiersMontpellier Herault 34940France',1),('00:08:F4','Bluetake Technology Co., Ltd.','Bluetake Technology Co., Ltd.6f, No. 33, Lane 155, Sec. 3, Pei Shen RSaen Keng Shiang, TaipeiTaipei Taiwan 222Taiwan, Republic Of China',1),('00:08:F5','Yestechnology Co.,ltd.','Yestechnology Co.,ltd.4th Fl Kyung-am B/d 157-27 Samsung-dong,Seoul 135-090Korea, Republic Of',1),('00:08:F6','Sumitomo Electric System Solutions Co.,ltd.','Sumitomo Electric System Solutions Co.,ltd.Shimaya 1-1-3, Konohana-kuOsaka City Osaka 112-0014Japan',1),('00:08:F7','Hitachi Ltd, Semiconductor &amp; Integrated Circuits Gr','Hitachi Ltd, Semiconductor &amp; Integrated Circuits Gr20-1 Josuihon-chou 5chomeKodaira-shi Tokyo 187-8588Japan',1),('00:08:F8','Guardall Ltd','Guardall LtdLochend Industrial Estate,NewbridgeEdinburgh Scotland Eh28 8plUnited Kingdom',1),('00:08:F9','Padcom, Inc.','Padcom, Inc.2005 City Line RoadBethlehem Pa 18017United States',1),('00:08:FA','Karl E.brinkmann Gmbh','Karl E.brinkmann GmbhFoersterweg 36-38Barntrup Nrw D-32683Germany',1),('00:08:FB','Sonosite, Inc.','Sonosite, Inc.21919 30th Drive SeBothell Wa 98021United States',1),('00:08:FC','Gigaphoton Inc.','Gigaphoton Inc.Yokokura Shinden400Oyama Totigi 323-8558Japan',1),('00:08:FD','Bluekorea Co., Ltd.','Bluekorea Co., Ltd.3f, Sejong Building, 379-15, Seokyo-dongMapo-ku,Seoul  121-839Korea, Republic Of',1),('00:08:FE','Unik C&c Co.,ltd.','Unik C&c Co.,ltd.706-13 Unik Bldg 17fYeok-sam Kang-nam GuSeoul  135-080Korea, Republic Of',1),('00:08:FF','Trilogy Communications Ltd','Trilogy Communications Ltd26 Focus WayWalworth EstateAndover Hampshire Sp10 5nyUnited Kingdom',1),('00:09:00','Tmt','Tmt11 Kiryat Mada, Pob 45199Jerusalem  91450Israel',1),('00:09:01','Shenzhen Shixuntong Information & Technoligy Co','Shenzhen Shixuntong Information & Technoligy CoRoom 403,617 Bldg;bagua 1 Road ,shenzhenShenzhen Guangdong 518029China',1),('00:09:02','Redline Communications Inc.','Redline Communications Inc.302 Town Centre BlvdSuite 100Markham On L3r 0e8Canada',1),('00:09:03','Panasas, Inc','Panasas, Inc15333 John F Kennedy Blvd, Suite 400Houston Tx 77032-2351United States',1),('00:09:04','Mondial Electronic','Mondial ElectronicEggelsberg 73Eggelsberg Oberoesterreich 5142Austria',1),('00:09:05','Itec Technologies Ltd.','Itec Technologies Ltd.160-1, Karak-dong, Songpa-guSeoul  138-809Korea, Republic Of',1),('00:09:06','Esteem Networks','Esteem Networks4f, No.900, Yishan RoadShanghai  200233China',1),('00:09:07','Chrysalis Development','Chrysalis Development8125 River Dr. Suite 100Morton Grove Il 60053United States',1),('00:09:08','Vtech Technology Corp.','Vtech Technology Corp.2f-2, No. 124, Chung Cheng Rd., ShihlinTaipei  11141Taiwan, Republic Of China',1),('00:09:09','Telenor Connect A/s','Telenor Connect A/sEllegaardvej 25lSnderborg Als 6400Denmark',1),('00:09:0A','Snedfar Technology Co., Ltd.','Snedfar Technology Co., Ltd.15fl., No.866-2, Jung Jeng Rd.,Junghe Taipei 235Taiwan, Republic Of China',1),('00:09:0B','Mtl  Instruments Plc','Mtl  Instruments PlcPower CourtLuton Bedfordshire Lu1 3jjUnited Kingdom',1),('00:09:0C','Mayekawa Mfg. Co. Ltd.','Mayekawa Mfg. Co. Ltd.16825 Ih 35 NorthSelma Texas 78154United States',1),('00:09:0D','Leader Electronics Corp.','Leader Electronics Corp.2-6-33, Tsunashima-higashiKohoku-ku Yokohama 223-8505Japan',1),('00:09:0E','Helix Technology Inc.','Helix Technology Inc.5f, No. 6, Sec 1, Jung-shing Rd., Wugu-sTaipei  248Taiwan, Republic Of China',1),('00:09:0F','Fortinet Inc.','Fortinet Inc.3333 Octavius DriveSanta Clara Ca 95054United States',1),('00:09:10','Simple Access Inc.','Simple Access Inc.600 Mccaffrey StreetSt-laurent Quebec H4t1n1Canada',1),('00:09:11','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:12','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:13','Systemk Corporation','Systemk Corporation238-9 Higashi 1, Kita 15, Higashi-kuSapporo Hokkaido 065-0015Japan',1),('00:09:14','Computrols Inc.','Computrols Inc.221 Bark DriveHarvey La 70058United States',1),('00:09:15','Cas Corp.','Cas Corp.#19, Ganap-riKwangguk-myunYangju-gun Kyunggi-do 482-841Korea, Republic Of',1),('00:09:16','Listman Home Technologies, Inc.','Listman Home Technologies, Inc.1100 Northmeadow ParkwaySuite 108Roswell Georgia 30076United States',1),('00:09:17','Wem Technology Inc','Wem Technology Inc8f-2, No 386, Sec 5 Nanjing East Road.Taipei  105Taiwan, Republic Of China',1),('00:09:18','Samsung Techwin Co.,ltd','Samsung Techwin Co.,ltd42SungjudongChangwon Kyongnam 641-716Korea, Republic Of',1),('00:09:19','Mds Gateways','Mds GatewaysClonshaugh Industrial EstateClonshaughDublin 17Ireland',1),('00:09:1A','Macat Optics & Electronics Co., Ltd.','Macat Optics & Electronics Co., Ltd.15/f., Macat Center, No. 63 Macat RoadHuizhou Guangdong 516001China',1),('00:09:1B','Digital Generation Inc.','Digital Generation Inc.5f, Ho-sam B/d, #30-3, Bongchun6-dongKwanak-ku, Seoul 151-089Korea, Republic Of',1),('00:09:1C','Cachevision, Inc','Cachevision, Inc1990 Concourse DriveSan Jose Ca 95131United States',1),('00:09:1D','Proteam Computer Corporation','Proteam Computer Corporation7f, No. 157. Section 2 Ta-tung RdHsi-chih Taipei Hsien 221Taiwan, Republic Of China',1),('00:09:1E','Firstech Technology Corp.','Firstech Technology Corp.8fl.,no.267,section 4,hsin-yi Rd. ,da-anTaipei  106Taiwan, Republic Of China',1),('00:09:1F','A&amp;d Co., Ltd.','A&amp;d Co., Ltd.1-243 AsahiKitamoto-shi Saitama 364-8585Japan',1),('00:09:20','Epox Computer Co.,ltd.','Epox Computer Co.,ltd.10th Floor, No.346,chung San Rd.,sec.2,Chung Ho City,taipei Hsien  235Taiwan, Republic Of China',1),('00:09:21','Planmeca Oy','Planmeca OyAsentajankatu 6Helsinki  00810 HelsinFinland',1),('00:09:22','Tst Biometrics Gmbh','Tst Biometrics GmbhMoehlstr. 3981675 MunichGermany',1),('00:09:23','Heaman System Co., Ltd','Heaman System Co., LtdBuilding M6,national Hi-tech & IndusChangsha Hunan Province 410013China',1),('00:09:24','Telebau Gmbh','Telebau GmbhAm Kraehenberg 1Waldeck-sachsenhausen Germany 34513Germany',1),('00:09:25','Vsn Systemen Bv','Vsn Systemen BvKeizersveld 83Venray Limburg 5803 ApNetherlands',1),('00:09:26','Yoda Communications, Inc.','Yoda Communications, Inc.2f, No.3-1, Industry East Road Ix,Hsinchu Science Based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:09:27','Toyokeiki Co.,ltd.','Toyokeiki Co.,ltd.17-10-3,shimosinjyoHigashiyodogawa-kuOsaka  533-0021Japan',1),('00:09:28','Telecore Inc','Telecore Inc1800 North GlenvilleSuite 116Richardson Tx 75081United States',1),('00:09:29','Sanyo Industries (uk) Limited','Sanyo Industries (uk) LimitedSchool RoadLowestoft Suffolk Nr33 9naUnited Kingdom',1),('00:09:2A','Mytecs Co.,ltd.','Mytecs Co.,ltd.1-12-39, TaishidouSetagaya-ku Tokyo 154-0004Japan',1),('00:09:2B','Iqstor Networks, Inc.','Iqstor Networks, Inc.2001 Corporate Center DriveNewbury Park Ca 91320United States',1),('00:09:2C','Hitpoint Inc.','Hitpoint Inc.No.7, Fenliao, 2nd Industrial Park, LinkTaipei  244Taiwan, Republic Of China',1),('00:09:2D','Htc Corporation','Htc CorporationNo 23, Hsin Hua Rd.Taoyuan City,330Taiwan, Republic Of China',1),('00:09:2E','B&tech System Inc.','B&tech System Inc.#601, Seo-jung B/d, 830-24, Youksam-dongSeoulKorea, Republic Of',1),('00:09:2F','Akom Technology Corporation','Akom Technology Corporation5f, No. 323, Yang-guang St.Taipei  114Taiwan, Republic Of China',1),('00:09:30','Aeroconcierge Inc.','Aeroconcierge Inc.10256 Yonge St.Richmond Hill Ont. L4c 3b7Canada',1),('00:09:31','Future Internet, Inc.','Future Internet, Inc.11th Floor Samhomoolsan Bldg, B/bldg, 2Yangjea Dong, Seocho KuSeoul Kyung-ki 137-130Korea, Republic Of',1),('00:09:32','Omnilux','Omnilux130 W. Union St.Pasadena Ca 91103United States',1),('00:09:33','Optovalley Co. Ltd.','Optovalley Co. Ltd.301ho, Jinjin Bldg. 1667-13Seocho-dong, Seocho-guSeoul  137-070Korea, Republic Of',1),('00:09:34','Dream-multimedia-tv Gmbh','Dream-multimedia-tv GmbhBrueckstr. 29Menden Sauerland 58706Germany',1),('00:09:35','Sandvine Incorporated','Sandvine Incorporated170 Columbia St. W.Waterloo On N2l 3l3Canada',1),('00:09:36','Ipetronik Gmbh & Co.kg','Ipetronik Gmbh & Co.kgJaegerweg 1Baden-baden Baden-wuerttemberg 76532Germany',1),('00:09:37','Inventec Appliance Corp','Inventec Appliance Corp113, Wugung 1 Rd., Wuku Industrial NparkWuku Shiang, Taipei Hsien 248, Taiwan ,TaipeiTaiwan, Republic Of China',1),('00:09:38','Allot Communications','Allot CommunicationsHanagar 22 StHod-hasharon  45800Israel',1),('00:09:39','Shibasoku Co.,ltd.','Shibasoku Co.,ltd.6-8 Shinbashi 4-chomeMinato-ku Tokyo 105-0004Japan',1),('00:09:3A','Molex Fiber Optics','Molex Fiber Optics5224 Katrine AvenueDowners Grove Il 60515United States',1),('00:09:3B','Hyundai Networks Inc.','Hyundai Networks Inc.San 136-1  Ami-ri  Bubal_eupIchon Kyungki-do 467-701Korea, Republic Of',1),('00:09:3C','Jacques Technologies P/l','Jacques Technologies P/l268 Montague RdWest End Queensland 4101Australia',1),('00:09:3D','Newisys,inc.','Newisys,inc.6200 Bridgepoint ParkwayBuiding Iv, Suite 100Austin Tx 78730United States',1),('00:09:3E','C&i Technologies','C&i Technologies#303 Kwanbo Plaza B/d, 1467-2Kwanyang-dong, Dongan-kuAnyang-shi Kyunggi-do 431-808Korea, Republic Of',1),('00:09:3F','Double-win Enterpirse Co., Ltd','Double-win Enterpirse Co., LtdNo.300, Sec 1, Chung Feng Rd.Ping Chen City Taoyuan Hsien 324Taiwan, Republic Of China',1),('00:09:40','Agfeo Gmbh & Co. Kg','Agfeo Gmbh & Co. KgPostfach 140107Bielefeld Rhine Westfalia 33621Germany',1),('00:09:41','Allied Telesis K.k.','Allied Telesis K.k.Technical Center/no.2 Toc Bldg.7-21-11 Nishi-gotandaShinagawa-ku Tokyo 141-0031Japan',1),('00:09:42','Cresco, Ltd.','Cresco, Ltd.Yamada Bldg 5f5-27-5 Shiba, Minato-kuTokyo  108-0014Japan',1),('00:09:43','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:44','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:45','Palmmicro Communications Inc','Palmmicro Communications Inc630 Alder DrMilpitas Ca 95035United States',1),('00:09:46','Cluster Labs Gmbh','Cluster Labs GmbhDauerwaldweg 114055 BerlinBerlin Berlin 14055Germany',1),('00:09:47','Aztek, Inc.','Aztek, Inc.23 Spectrum Pointe #209Lake Forest California 92630United States',1),('00:09:48','Vista Control Systems, Corp.','Vista Control Systems, Corp.2001 West Melinda LanePhoenix Az 85027United States',1),('00:09:49','Glyph Technologies Inc.','Glyph Technologies Inc.735 W. Clinton StreetIthaca Ny 14850United States',1),('00:09:4A','Homenet Communications','Homenet CommunicationsInnovation CentreNational Technological ParkLimerickIreland',1),('00:09:4B','Fillfactory Nv','Fillfactory NvSchalienhoevedreef 20bB-2800 MechelenBelgium',1),('00:09:4C','Communication Weaver Co.,ltd.','Communication Weaver Co.,ltd.1~3 Coweaver B/d 446-19,Seogyo-dong, Mapo-guSeoul  121-841Korea, Republic Of',1),('00:09:4D','Braintree Communications Pty Ltd','Braintree Communications Pty LtdLevel 1, 6 Cordelia StSouth Brisbane Qld 4101Australia',1),('00:09:4E','Bartech Systems International, Inc','Bartech Systems International, Inc251 Najoles Rd Suite AMillersville Maryland 21108United States',1),('00:09:4F','Elmegt Gmbh & Co. Kg','Elmegt Gmbh & Co. KgKommunikationstechnikVoehrumer Str. 30Peine Niedersachsen D-31228Germany',1),('00:09:50','Independent Storage Corporation','Independent Storage Corporation6273 Monarch Park PlaceNiwot Colorado 80503United States',1),('00:09:51','Apogee Instruments, Inc','Apogee Instruments, Inc11760 Atwood Road, Suite 4Auburn Ca 95603United States',1),('00:09:52','Auerswald Gmbh & Co. Kg','Auerswald Gmbh & Co. KgVor Den Grashoefen 22Cremlingen Niedersachsen 38162Germany',1),('00:09:53','Linkage System Integration Co.ltd.','Linkage System Integration Co.ltd.40 GongjianfangSouth Zhongshan RoadNanjing Jiangsu 210006China',1),('00:09:54','Amit Spol. S. R. O.','Amit Spol. S. R. O.Naskove 3150 00 Praha 5Czech Republic',1),('00:09:55','Young Generation International Corp.','Young Generation International Corp.4f.,no. 188, Minchuan Rd., Shindian CityShindian  231Taiwan, Republic Of China',1),('00:09:56','Network Systems Group, Ltd. (nsg)','Network Systems Group, Ltd. (nsg)39 Kirpichnaya St., Suite 1302Moscow  105187Russian Federation',1),('00:09:57','Supercaller, Inc.','Supercaller, Inc.101 Saginaw DriveRedwood City Ca 94063United States',1),('00:09:58','Intelnet S.a.','Intelnet S.a.Francisco Olivan Bayle, 4Zaragoza  50015Spain',1),('00:09:59','Sitecsoft','Sitecsoft7th Gugu Bd. 145-18 Samsung-dongKangnam-gu Seoul KoreaSeoul Seoul 135-090Korea, Republic Of',1),('00:09:5A','Racewood Technology','Racewood Technology5f-2,no.6,chung-hsing Rd.,sec.1,wu-guTaipei  248Taiwan, Republic Of China',1),('00:09:5B','Netgear, Inc.','Netgear, Inc.4500 Great America ParkwaySanta Clara Ca 95054United States',1),('00:09:5C','Philips Medical Systems - Cardiac And Monitoring Systems (cm','Philips Medical Systems - Cardiac And Monitoring Systems (cm3000 Minuteman RoadAndover Massachusetts 01810United States',1),('00:09:5D','Dialogue Technology Corp.','Dialogue Technology Corp.10f, No. 196, Sec. 2, Jungshing Rd.Shindian City Taipei 231Taiwan, Republic Of China',1),('00:09:5E','Masstech Group Inc.','Masstech Group Inc.2 East Beaver Creek Rd.Building 3Richmond Hill Ontario L4b 2n3Canada',1),('00:09:5F','Telebyte, Inc.','Telebyte, Inc.270 Pulaski RoadGreenlawn Ny 11740-1616United States',1),('00:09:60','Yozan Inc.','Yozan Inc.Yozan Bld.,3-5-18, KitazawaSetagaya-ku Tokyo 155-0031Japan',1),('00:09:61','Switchgear And Instrumentation Ltd','Switchgear And Instrumentation LtdRipley RoadBradford West Yorkshire Bd4 7ehUnited Kingdom',1),('00:09:62','Sonitor Technologies As','Sonitor Technologies AsForskningsveien 1bP.o. Box 124Oslo Blindern N-0134Norway',1),('00:09:63','Dominion Lasercom Inc.','Dominion Lasercom Inc.1716 Briarcrest Dr. Ste. 210Bryan Tx 77802United States',1),('00:09:64','Hi-techniques, Inc.','Hi-techniques, Inc.2515 Frazier Ave.Madison Wi 53713-1505United States',1),('00:09:65','Hyunju Computer Co., Ltd.','Hyunju Computer Co., Ltd.222-22, Hyunju B/d, Guro 3 Dong, GuroguSeoul  152-848Korea, Republic Of',1),('00:09:66','Thales Navigation','Thales Navigation471 El Camino RealSanta Clara Ca 95050United States',1),('00:09:67','Tachyon, Inc','Tachyon, Inc9339 Carroll Park DriveSuite 150San Diego Ca 92121United States',1),('00:09:68','Technoventure, Inc.','Technoventure, Inc.P. O. Box 5641Pasadena Texas 77508-5641United States',1),('00:09:69','Meret Optical Communications','Meret Optical Communications10070 Mesa Rim RoadSan Diego California 92121United States',1),('00:09:6A','Cloverleaf Communications Inc.','Cloverleaf Communications Inc.2 Willow St.Southborough Ma 01745-1027United States',1),('00:09:6B','Ibm Corporation','Ibm CorporationPo Box 12195Dept. V51a / Bldg. 660 / Office E103Research Triangle Park Nc 27709United States',1),('00:09:6C','Imedia Semiconductor Corp.','Imedia Semiconductor Corp.4988 Great America Pkwy.Santa Clara Ca 95054United States',1),('00:09:6D','Powernet Technologies Corp.','Powernet Technologies Corp.371-51, Gasan-dong Kumchon-gu,Seoul  153-803Korea, Republic Of',1),('00:09:6E','Giant Electronics Ltd.','Giant Electronics Ltd.7/f., Elite Industrial Building,135-137 Hoi Bun Road,Kwun Tong KowloonHong Kong',1),('00:09:6F','Beijing Zhongqing Elegant Tech. Corp.,limited','Beijing Zhongqing Elegant Tech. Corp.,limitedRm.508, A-building, Shangdi Digital ScieBeijing  100084China',1),('00:09:70','Vibration Research Corporation','Vibration Research Corporation2385 Wilshere DriveSuite AJenison Mi 49428United States',1),('00:09:71','Time Management, Inc.','Time Management, Inc.11 Lake Gatlin RoadOrlando Florida 32806United States',1),('00:09:72','Securebase,inc','Securebase,inc2nd Fl,seungseung-bldg,dokok 2-dong,kangSeoul  135-854Korea, Republic Of',1),('00:09:73','Lenten Technology Co., Ltd.','Lenten Technology Co., Ltd.16f, No.51, Sec.2, Gungyi Road,Taichung City  408Taiwan, Republic Of China',1),('00:09:74','Innopia Technologies, Inc.','Innopia Technologies, Inc.5f., Institute Of TechnologyHanyang University, 17 Haengdang-dongSeoul  133-791Korea, Republic Of',1),('00:09:75','Fsona Communications Corporation','Fsona Communications Corporation#140-11120 Horseshoe WayRichmond Bc V7a 5h7Canada',1),('00:09:76','Datasoft Isdn Systems Gmbh','Datasoft Isdn Systems GmbhSchillerplatz 3St. Poelten Lower Austria 3100Austria',1),('00:09:77','Brunner Elektronik Ag','Brunner Elektronik AgMllerwis 1Hittnau Zrich 8335Switzerland',1),('00:09:78','Aiji System Co., Ltd.','Aiji System Co., Ltd.#208 Samho-park-tower Bldg. 1122-10, IngSuwon Gyeonggi-do 442-835Korea, Republic Of',1),('00:09:79','Advanced Television Systems Committee, Inc.','Advanced Television Systems Committee, Inc.1750 K Street NwSuite 1200Washington Dc 20006United States',1),('00:09:7A','Louis Design Labs.','Louis Design Labs.2f,no 4, Lane 497, Chung-cheng Rd.,hsin-Hsin-tien Taipei Hsien 231Taiwan, Republic Of China',1),('00:09:7B','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:7C','Cisco Systems','Cisco Systems80 West Tasman DrSj-m/1San Jose Ca 95134United States',1),('00:09:7D','Secwell Networks Oy','Secwell Networks OyP.o.box 174Hmeenpuisto 21Tampere  33101Finland',1),('00:09:7E','Imi Technology Co., Ltd','Imi Technology Co., Ltd2nd Floor, Eun Seok Building, 729-1Yeoksam-dong,Gangnam-gu Seoul 135-080Korea, Republic Of',1),('00:09:7F','Vsecure 2000 Ltd.','Vsecure 2000 Ltd.11 Moshe Levi St.Rishon Lezion  75658Israel',1),('00:09:80','Power Zenith Inc.','Power Zenith Inc.Tsujido Nishikaigan 1-10-7Fujisawa Kanagawa 251-0046Japan',1),('00:09:81','Newport Networks','Newport NetworksEnterprise HouseStation RoadChepstow Monmouthshire Np16 5pbUnited Kingdom',1),('00:09:82','Loewe Opta Gmbh','Loewe Opta GmbhIndustriestrasse 11Kronach Bavaria 96317Germany',1),('00:09:83','Gvision Incorporated','Gvision Incorporated11f, No.166, Chien-i RoadChung Ho City, Taipei Hsien  235Taiwan, Republic Of China',1),('00:09:84','Mycasa Network Inc.','Mycasa Network Inc.200 Sheridan Ave #103Palo Alto Ca 94306United States',1),('00:09:85','Auto Telecom Company','Auto Telecom Company10f, No.3,lane 16, Sec.2, Sichuan Rd.Banqiao City Taipei County 22061Taiwan, Republic Of China',1),('00:09:86','Metalink Ltd.','Metalink Ltd.Yakum Business ParkYakum Hof Hasharon 60972Israel',1),('00:09:87','Nishi Nippon Electric Wire & Cable Co.,ltd.','Nishi Nippon Electric Wire & Cable Co.,ltd.KasugauraOita-city Oita 870-8632Japan',1),('00:09:88','Nudian Electron Co., Ltd.','Nudian Electron Co., Ltd.797-28 Bangbae-dong, Seocho-guSeoul  137-060Korea, Republic Of',1),('00:09:89','Vividlogic Inc.','Vividlogic Inc.40994 Encyclopedia CircleFremont Ca 94538United States',1),('00:09:8A','Equallogic Inc','Equallogic Inc9 Townsend WestNashua Nh 03062United States',1),('00:09:8B','Entropic Communications, Inc.','Entropic Communications, Inc.9276 Scranton Rd #200San Diego Ca 92121United States',1),('00:09:8C','Option Wireless Sweden','Option Wireless SwedenSturegatan 211th Fl.Sundbyberg Se-172 24Sweden',1),('00:09:8D','Velocity Semiconductor','Velocity SemiconductorSuite 32 Wey House15 Church StreetWeybridge Surrey Kt13 8naUnited Kingdom',1),('00:09:8E','Ipcas Gmbh','Ipcas GmbhWetterkreuz 17Erlangen Bavaria 91058Germany',1),('00:09:8F','Cetacean Networks','Cetacean Networks110 Corporate DriveBuilding 2Portsmouth Nh 03801United States',1),('00:09:90','Acksys Communications & Systems','Acksys Communications & SystemsZa Du Val Joyeux10 Rue Des EntrepreneursVillepreux  F-78450France',1),('00:09:91','Ge Fanuc Automation Manufacturing, Inc.','Ge Fanuc Automation Manufacturing, Inc.Route 606 & Route 29nPo Box 8106Charlottesville Virginia 22911United States',1),('00:09:92','Interepoch Technology,inc.','Interepoch Technology,inc.7f,no.3,alley 6,lane 235,pao-chiao RdHsin-tien Taipei Hsien 231Taiwan, Republic Of China',1),('00:09:93','Visteon Corporation','Visteon Corporation16630 Southfield RoadSt. 41e10Allen Park Michigan 48101United States',1),('00:09:94','Cronyx Engineering','Cronyx EngineeringMarshala Sokolovskogo Str. 4Moscow  123063Russian Federation',1),('00:09:95','Castle Technology Ltd','Castle Technology LtdOre Trading EstateWoodbridge RoadFramlingham Suffolk Ip13 9llUnited Kingdom',1),('00:09:96','Rdi','Rdi20406 Earl St.Torrance Ca 90503United States',1),('00:09:97','Nortel Networks','Nortel Networks8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:09:98','Capinfo Company Limited','Capinfo Company Limited7th Floor A Corporate Square, No. 35 FinBeijing  100032China',1),('00:09:99','Cp Georges Renault','Cp Georges Renault38 Rue Bobby Sands44800 Saint HerblainFrance',1),('00:09:9A','Elmo Company, Limited','Elmo Company, Limited6-14, Meizen-cho, Mizuho-kuNagoya Aichi-pref. 467-8567Japan',1),('00:09:9B','Western Telematic Inc.','Western Telematic Inc.5 SterlingIrvine Ca 92618United States',1),('00:09:9C','Naval Research Laboratory','Naval Research LaboratoryCode 55924555 Overlook AvenueWashington Dc 20375-5000United States',1),('00:09:9D','Haliplex Communications','Haliplex CommunicationsPo Box 147Mooroolbark Vic 3138Australia',1),('00:09:9E','Testech, Inc.','Testech, Inc.Bundang-technopark, C-dong, 702-ho, #145Yatap-dong, Bundang-gu,Sungnam-city Kyungki-do 463-070Korea, Republic Of',1),('00:09:9F','Videx Inc.','Videx Inc.1105 Ne Circle BlvdCorvallis Or 97330United States',1),('00:09:A0','Microtechno Corporation','Microtechno Corporation2-33-36 ShimoodanakaNakahara-kuKawasaki Kanagawa 211-0041Japan',1),('00:09:A1','Telewise Communications, Inc.','Telewise Communications, Inc.2050 Ringwood AvenueSan Jose Ca 95131United States',1),('00:09:A2','Interface Co., Ltd.','Interface Co., Ltd.2-5-12-201 KyonanchoMusashino-city Tokyo 180-0023Japan',1),('00:09:A3','Leadfly Techologies Corp. Ltd.','Leadfly Techologies Corp. Ltd.9fl, No.260, Bade Rd.,104, R.o.c.Taipei  104Taiwan, Republic Of China',1),('00:09:A4','Hartec Corporation','Hartec CorporationKouhokuku Shin-yokohama3-19-5Yokohama-shi Kanagawa-ken 222-0033Japan',1),('00:09:A5','Hansung Eletronic Industries Development Co., Ltd','Hansung Eletronic Industries Development Co., LtdHeungjin Bldg 3f, #217-3 Poi-dong, KangnSeoul  135-963Korea, Republic Of',1),('00:09:A6','Ignis Optics, Inc.','Ignis Optics, Inc.482 W. San CarlosSan Jose California 95110United States',1),('00:09:A7','Bang & Olufsen A/s','Bang & Olufsen A/sPeter Bangs Vej 15Struer  7600Denmark',1),('00:09:A8','Eastmode Pte Ltd','Eastmode Pte Ltd30 Loyang Way #07-06Loyang Industrial Estate508769Singapore',1),('00:09:A9','Ikanos Communications','Ikanos Communications47709 Fremont BlvdFremont Ca 94538United States',1),('00:09:AA','Data Comm For Business, Inc.','Data Comm For Business, Inc.2949 County Road 1000 EastDewey Il 61853United States',1),('00:09:AB','Netcontrol Oy','Netcontrol OyKarvaamokuja 3Helsinki  Fin 00380Finland',1),('00:09:AC','Lanvoice','Lanvoice1364-39 Seochodong, #201 Jihun BldgSeocho-guSeoul  137-072Korea, Republic Of',1),('00:09:AD','Hyundai Syscomm, Inc.','Hyundai Syscomm, Inc.San 136-1, Ami-ri, Bubal-eubIchon Kyoungki-do 467-701Korea, Republic Of',1),('00:09:AE','Okano Electric Co.,ltd','Okano Electric Co.,ltd2-8-18 Kanayama-choHigashikurume Tokyo 203-0003Japan',1),('00:09:AF','E-generis','E-generis13 Rue Du Chene GermainCesson Sevigne  35510France',1),('00:09:B0','Onkyo Corporation','Onkyo Corporation2-1 Nisshin-choNeyagawa Osaka 5728540Japan',1),('00:09:B1','Kanematsu Electronics, Ltd.','Kanematsu Electronics, Ltd.17-5, Kyobashi 2-chomeChuo-ku Tokyo 104-8338Japan',1),('00:09:B2','L&f Inc.','L&f Inc.4-2-9TokumaruItabashi-ku Tokyo 175-0083Japan',1),('00:09:B3','Mcm Systems Ltd','Mcm Systems LtdKolomban 9fAnkaran Slovenija 6280Slovenia',1),('00:09:B4','Kisan Telecom Co., Ltd.','Kisan Telecom Co., Ltd.9f, Teawon Bldg., 65 Bangyi-dongSongpa-gu Seoul 138-828Korea, Republic Of',1),('00:09:B5','3j Tech. Co., Ltd.','3j Tech. Co., Ltd.342 Fushing N. Rd., 2f, Taipei, TaiwanTaipei  104Taiwan, Republic Of China',1),('00:09:B6','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:B7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 94134United States',1),('00:09:B8','Entise Systems','Entise Systems10095 Judy AvenueCupertino Ca 95014United States',1),('00:09:B9','Action Imaging Solutions','Action Imaging SolutionsKings Hall, St Ives Business ParkSt IvesHuntingdon Cambridgeshire Pe27 4wyUnited Kingdom',1),('00:09:BA','Maku Informationstechik Gmbh','Maku Informationstechik GmbhGewerbehofstr. 7Essen Nrw 45145Germany',1),('00:09:BB','Mathstar, Inc.','Mathstar, Inc.5900 Green Oak DriveMinneapolis Mn 55343United States',1),('00:09:BC','Integrian, Inc.','Integrian, Inc.511 Davis Dr.Suite 300Morrisville Nc 27560United States',1),('00:09:BD','Epygi Technologies, Ltd.','Epygi Technologies, Ltd.5040 Addison CircleSuite 225Addison Texas 75001United States',1),('00:09:BE','Mamiya-op Co.,ltd.','Mamiya-op Co.,ltd.3-23-10, Negishi Minami-kuSaitama-shi Saitama 336-8581Japan',1),('00:09:BF','Nintendo Co.,ltd.','Nintendo Co.,ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:09:C0','6wind','6wind1, Place Charles De GaulleMontigny-le-bretonneux  78180France',1),('00:09:C1','Proces-data A/s','Proces-data A/sNavervej 8Silkeborg  Dk-8600Denmark',1),('00:09:C2','Private','',1),('00:09:C3','Netas','NetasAlemdag Cad. No 171UmraniyeIstanbul  81244Turkey',1),('00:09:C4','Medicore Co., Ltd','Medicore Co., Ltd72-3 5th Fl., Luna Bldg, Chungdam-dongKangnam-guSeoul  135-080Korea, Republic Of',1),('00:09:C5','Kingene Technology Corporation','Kingene Technology Corporation7f, No. 144, Minchuan E. Rd. Sec. 3Taipei  105Taiwan, Republic Of China',1),('00:09:C6','Visionics Corporation','Visionics Corporation5600 Rowland RoadSuite 205Minnetonka Mn 55343United States',1),('00:09:C7','Movistec','Movistec110-5 Maryoung -ri Seosu-myunKunsan Chonbuk 573-940Korea, Republic Of',1),('00:09:C8','Sinagawa Tsushin Keisou Service','Sinagawa Tsushin Keisou Service13-5 Fuke , Sumiyoshi , OnahamaIwaki City Fukushima Prefecture 971-8124Japan',1),('00:09:C9','Bluewinc Co., Ltd.','Bluewinc Co., Ltd.401 Korea Design Center344-1 Yatap1-dong, Bundang-guSeongnam City Kyonggido 463-828Korea, Republic Of',1),('00:09:CA','Imaxnetworks(shenzhen)limited.','Imaxnetworks(shenzhen)limited.4/b,south Bldg Of 29th,south District OfShenzhen Hi-tech Industrial Park, ShennaShenzhen Guangdong 518057China',1),('00:09:CB','Hbrain','Hbrain#705 Kwanglim Bldg 179 KumidongBundang GuSeongnam Gyeonggido 463-810Korea, Republic Of',1),('00:09:CC','Moog Gmbh','Moog GmbhHanns-klemm-str. 28Boeblingen  D-71034Germany',1),('00:09:CD','Hudson Soft Co.,ltd.','Hudson Soft Co.,ltd.C62,geijutsu-no-mori3-chome,minami-kuSapporo Hokkaido 005-0864Japan',1),('00:09:CE','Spacebridge Semiconductor Corp.','Spacebridge Semiconductor Corp.115 Rue ChamplainHull Quebec J8x3r1Canada',1),('00:09:CF','Iad Gmbh','Iad GmbhUnterschlauersbacher Hauptstrasse 10Grosshabersdorf Bavaria 90613Germany',1),('00:09:D0','Solacom Technologies Inc.','Solacom Technologies Inc.80 Jean-proulxGatineau Quebec J8z 1w1Canada',1),('00:09:D1','Seranoa Networks Inc','Seranoa Networks IncConcord Office Center2352 Main StConcord Ma 01742United States',1),('00:09:D2','Mai Logic Inc.','Mai Logic Inc.47697 Westinghouse Dr., Suite 200Fremont Ca 94539United States',1),('00:09:D3','Western Datacom Co., Inc.','Western Datacom Co., Inc.925-d Bassett Rd.Westlake Oh 44145United States',1),('00:09:D4','Transtech Networks','Transtech Networks100 Wood AvenueSuite 204Iselin Nj 08830United States',1),('00:09:D5','Signal Communication, Inc.','Signal Communication, Inc.100 Wood Ave SouthSuite 103Iselin Nj 08830United States',1),('00:09:D6','Knc One Gmbh','Knc One GmbhHohe Welle 10 BEvessen Niedersachsen 38173Germany',1),('00:09:D7','Dc Security Products','Dc Security ProductsOne Lindsay CircleSan Francisco California 94124United States',1),('00:09:D8','Flt Communications Ab','Flt Communications AbKylgrnd 6aSe 906 20 UmeSweden',1),('00:09:D9','Neoscale Systems, Inc','Neoscale Systems, Inc1500 Mc Candless DriveMilpitas Ca 95035United States',1),('00:09:DA','Control Module Inc.','Control Module Inc.227 Brainard RoadEnfield Ct 06082United States',1),('00:09:DB','Espace','Espace9623 Simsbury Ct.Twinsburg Oh 44087-3220United States',1),('00:09:DC','Galaxis Technology Ag','Galaxis Technology AgSteinmetzstrasse 7P.o. Box 3364Lbeck Schleswig-holstein 23556Germany',1),('00:09:DD','Mavin Technology Inc.','Mavin Technology Inc.Room 305, Bldg. 52 No. 195-28Sec. 4 Chung-hsing Rd.Chutung, Hsinchu  310Taiwan, Republic Of China',1),('00:09:DE','Samjin Information & Communications Co., Ltd.','Samjin Information & Communications Co., Ltd.Majangmyun Dukpyungri 235-2Ichon Kyonggi 467-812Korea, Republic Of',1),('00:09:DF','Vestel Komunikasyon Sanayi Ve Ticaret A.s.','Vestel Komunikasyon Sanayi Ve Ticaret A.s.Ege Serbest Bolgesi No:144/1GaziemirIzmir - 35410Turkey',1),('00:09:E0','Xemics S.a.','Xemics S.a.Rue De La Maladiere 71Ch-2007 Neuchatel Neuchatel 2007Switzerland',1),('00:09:E1','Gemtek Technology Co., Ltd.','Gemtek Technology Co., Ltd.No.1 Jen Ai RoadHukou Hsinchu 303Taiwan, Republic Of China',1),('00:09:E2','Sinbon Electronics Co., Ltd.','Sinbon Electronics Co., Ltd.4f-13, No. 79, Sec 1, Hsin Tai Wu Rd.Hsi-chih, Taipei  221Taiwan, Republic Of China',1),('00:09:E3','Angel Iglesias S.a.','Angel Iglesias S.a.Polgono 27 MartuteneSan Sebastin Guipzcoa 20014Spain',1),('00:09:E4','K Tech Infosystem Inc.','K Tech Infosystem Inc.B-405, Bundang Techno-park 148, Yatap-doSeongnam Kyonggi-do 464-070Korea, Republic Of',1),('00:09:E5','Hottinger Baldwin Messtechnik Gmbh','Hottinger Baldwin Messtechnik GmbhIm Tiefen See 45Darmstadt Hessen 64293Germany',1),('00:09:E6','Cyber Switching Inc.','Cyber Switching Inc.1800 De La Cruz Blvd.Santa Clara Ca 95050United States',1),('00:09:E7','Adc Techonology','Adc TechonologySakae Members Office Bld. 4-16-8, Sakae,Nagoya Aichi 4600008Japan',1),('00:09:E8','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:E9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:09:EA','Yem Inc.','Yem Inc.1-3-33OkataAtsugi-shi Kanagawa 243-0021Japan',1),('00:09:EB','Humandata Ltd.','Humandata Ltd.1-2-51NakahozumiIbaraki Osaka 567-0034Japan',1),('00:09:EC','Daktronics, Inc.','Daktronics, Inc.315 32nd AveBuilding #2Brookings Sd 57006United States',1),('00:09:ED','Cipheroptics','Cipheroptics701 Corporate Center DriveSuite 150Raleigh North Carolina 27607United States',1),('00:09:EE','Meikyo Electric Co.,ltd','Meikyo Electric Co.,ltd4-27-2 HigashioguArakawa-ku Tokyo 116-0012Japan',1),('00:09:EF','Vocera Communications','Vocera Communications20230 Stevens Creek BlvdSuite CCupertino California 95014United States',1),('00:09:F0','Shimizu Technology Inc.','Shimizu Technology Inc.15-6, No.107, Chung Shan Rd., Sec.1Hsin Chuan, Taipei 242Taiwan, Republic Of China',1),('00:09:F1','Yamaki Electric Corporation','Yamaki Electric Corporation3-7-22 ShimomeguroMeguro-ku Tokyo 153-0064Japan',1),('00:09:F2','Cohu, Inc., Electronics Division','Cohu, Inc., Electronics Division3912 Calle FortunadaSan Diego Ca 92123United States',1),('00:09:F3','Well Communication Corp.','Well Communication Corp.11f, No.778, Chung Cheng Rd., Chung Ho CChung Ho  235Taiwan, Republic Of China',1),('00:09:F4','Alcon Laboratories, Inc.','Alcon Laboratories, Inc.6201 South FreewayFort Worth Tx 76134United States',1),('00:09:F5','Emerson Network Power Co.,ltd','Emerson Network Power Co.,ltd1/f,3/f Electric Building Huawei Base,baLonggang,shenzhen Municipality,peoplesShenzhen Guangdong 518029China',1),('00:09:F6','Shenzhen Eastern Digital Tech Ltd.','Shenzhen Eastern Digital Tech Ltd.Shenzhen Futian Chegongmiao TairanTechnology Park 210 - 3cShenzhen Guangdong 518048China',1),('00:09:F7','Sed, A Division Of Calian','Sed, A Division Of Calian18 Innnovation BoulevardP.o. Box 1464Saskatoon Saskatchewan (sk) S7k 3p7Canada',1),('00:09:F8','Unimo Technology Co., Ltd.','Unimo Technology Co., Ltd.Bangbae Dong 479-12Seocho-gu,Seoul  137-820Korea, Republic Of',1),('00:09:F9','Art Japan Co., Ltd.','Art Japan Co., Ltd.322-7, Ichinotsubo,Nakahara-kuKawasaki Kanagawa 211-0016Japan',1),('00:09:FB','Philips Medizinsysteme Boeblingen Gmbh','Philips Medizinsysteme Boeblingen GmbhHewlett-packard-str.2Boeblingen  71034Germany',1),('00:09:FC','Ipflex Inc.','Ipflex Inc.Mowa-bldg 3f, 1-16-6Ebisu-nishiShibuya-ku Tokyo 150-0021Japan',1),('00:09:FD','Ubinetics Limited','Ubinetics LimitedCambridge Technology CentreMelbourn Hertfordshire Sg8 6dpUnited Kingdom',1),('00:09:FE','Daisy Technologies, Inc.','Daisy Technologies, Inc.1209 Orange StreetCounty Of New CastleCity Of Wilmington De 19801United States',1),('00:09:FF','X.net 2000 Gmbh','X.net 2000 GmbhKoenigsberger Str. 2cReinheim  64354Germany',1),('00:0A:00','Mediatek Corp.','Mediatek Corp.8f, No 69-5, Sec.2, Chung Cheng East Rd.Taipei  251Taiwan, Republic Of China',1),('00:0A:01','Sohoware, Inc.','Sohoware, Inc.3050 Coronado DriveSanta Clara Ca 95054United States',1),('00:0A:02','Annso Co., Ltd.','Annso Co., Ltd.5f, No. 100, Min-chuan Road, Shing-tienShing-tien City Taipei Hsien Taiwan 221Taiwan, Republic Of China',1),('00:0A:03','Endesa Servicios, S.l.','Endesa Servicios, S.l.Avgda Paral.lel, 51Barcelona  08004Spain',1),('00:0A:04','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:0A:05','Widax Corp.','Widax Corp.269 Stevens StreetHyannis Ma 02668United States',1),('00:0A:06','Teledex Llc','Teledex Llc6311 San Ignacio AvenueSan Jose Ca 95119United States',1),('00:0A:07','Webwayone Ltd','Webwayone Ltd11 Kingfisher Court,Hambridge RoadNewbury Berkshire Rg14 5sjUnited Kingdom',1),('00:0A:08','Alpine Electronics, Inc.','Alpine Electronics, Inc.20-1 Yoshima-kogyodanchiIwaki-city Fukushima 970-1192Japan',1),('00:0A:09','Taracom Integrated Products, Inc.','Taracom Integrated Products, Inc.830 Stewart Dr.Sunnyvale Ca 94085United States',1),('00:0A:0A','Sunix Co., Ltd.','Sunix Co., Ltd.3fl., No. 76, Baugau Rd.,Shindian Taipei 231Taiwan, Republic Of China',1),('00:0A:0B','Sealevel Systems, Inc.','Sealevel Systems, Inc.155 Technology PlaceLiberty Sc 29657United States',1),('00:0A:0C','Scientific Research Corporation','Scientific Research Corporation2300 Windy Ridge ParkwaySuite 400 SouthAtlanta Ga 30339United States',1),('00:0A:0D','Mergeoptics Gmbh','Mergeoptics GmbhAm Borsigturm 17Berlin  13507Germany',1),('00:0A:0E','Invivo Research Inc.','Invivo Research Inc.12601 Research ParkwayOrlando Florida 32826United States',1),('00:0A:0F','Ilryung Telesys, Inc','Ilryung Telesys, IncIlryung Bldg, 34-2, Cheonho-dongGangdong-guSeoul  134-861Korea, Republic Of',1),('00:0A:10','Fast Media Integrations Ag','Fast Media Integrations AgSchngrund 26Rotkreuz Canton Of Zug 6343Switzerland',1),('00:0A:11','Expet Technologies, Inc','Expet Technologies, Inc6f, Kyonggi Small Business Center#111-8, Iui-dong, Paldal-gu,Suwon, Kyonggi-do, 442-270  442-770Korea, Republic Of',1),('00:0A:12','Azylex Technology, Inc','Azylex Technology, Inc7-2fl., No. 738 Chung Cheng Road,Chung Ho City Taipei 235Taiwan, Republic Of China',1),('00:0A:13','Honeywell Video Systems','Honeywell Video Systems6554 176 StreetSurrey Bc V3s 4g5Canada',1),('00:0A:14','Teco A.s.','Teco A.s.Havlickova 260Kolin Cz 280 58Czech Republic',1),('00:0A:15','Silicon Data, Inc','Silicon Data, Inc4699 Old Ironsides Dr., #150Santa Clara Ca 95054United States',1),('00:0A:16','Lassen Research','Lassen Research31695 Forward RoadManton Ca 96059United States',1),('00:0A:17','Nestar Communications, Inc','Nestar Communications, IncNo.6,19 Lane Bade RoadHsinchu  300Taiwan, Republic Of China',1),('00:0A:18','Vichel Inc.','Vichel Inc.3f Jang Bldg. 92-6 Yangjae-dong, Secho-gSeoul  137-130Korea, Republic Of',1),('00:0A:19','Valere Power, Inc.','Valere Power, Inc.661 N. Plano Rd.Richardson Texas 75081United States',1),('00:0A:1A','Imerge Ltd','Imerge LtdUnit 6, Bar Hill Business ParkSaxon WayBar Hill Cambridge Cb3 8slUnited Kingdom',1),('00:0A:1B','Stream Labs','Stream LabsLeninskie Gori 1, Bild 77Moskow  119992Russian Federation',1),('00:0A:1C','Bridge Information Co., Ltd.','Bridge Information Co., Ltd.No.3, Lane 106, Wu-kung 2 Rd.,Wu-ku Ind. Park,Taipei  248Taiwan, Republic Of China',1),('00:0A:1D','Optical Communications Products Inc.','Optical Communications Products Inc.20961 Knapp St.Chatsworth Ca 91311United States',1),('00:0A:1E','Red-m Products Limited','Red-m Products LimitedNeptune HouseMercury Park, Wycombe LaneWooburn Green Buckinghamshire Hp10 0hhUnited Kingdom',1),('00:0A:1F','Art Ware Telecommunication Co., Ltd.','Art Ware Telecommunication Co., Ltd.806 Ace Techno Tower #1, 197-17Guro-dong, Guro-guSeoul  152-050Korea, Republic Of',1),('00:0A:20','Sva Networks, Inc.','Sva Networks, Inc.840 F Ave., Suite 104Plano Tx 75074United States',1),('00:0A:21','Integra Telecom Co. Ltd','Integra Telecom Co. Ltd7th Floor Hwayoung Bld. 112-2Karak-dong Sonpa-guSeoulKorea, Republic Of',1),('00:0A:22','Amperion Inc','Amperion Inc250 Apollo DriveChelmsford Ma 01824United States',1),('00:0A:23','Parama Networks Inc','Parama Networks Inc1955 The AlamedaSan Jose Ca 95126United States',1),('00:0A:24','Octave Communications','Octave Communications85 Northwest BoulevardNashua Nh 03063United States',1),('00:0A:25','Ceragon Networks','Ceragon Networks24 Rauel Wallenberg StreetTel-aviv  96719Israel',1),('00:0A:26','Ceia S.p.a.','Ceia S.p.a.Zona Industriale Di Viciomaggio 54Arezzo Ar 52040Italy',1),('00:0A:27','Apple Computer, Inc.','Apple Computer, Inc.20650 Valley Green DriveCupertino Ca 95014United States',1),('00:0A:28','Motorola','Motorola600 N. Us Hwy 45Libertyville Il 60048United States',1),('00:0A:29','Pan Dacom Networking Ag','Pan Dacom Networking AgDreieich Plaza 1bDreieich Hessen D-63303Germany',1),('00:0A:2A','Qsi Systems Inc.','Qsi Systems Inc.7 Raymond AvenueBuilding B, Unit 11Salem Nh 03079United States',1),('00:0A:2B','Etherstuff','Etherstuff6943 Whitaker StLake Balboa Ca 91406United States',1),('00:0A:2C','Active Tchnology Corporation','Active Tchnology Corporation16-23, Shibaura 2-chome,Minato-ku,Tokyo Tokyo 108-0023Japan',1),('00:0A:2D','Cabot Communications Limited','Cabot Communications LimitedVerona HouseFilwood RoadBristol Gloucestershire Bs16 3ryUnited Kingdom',1),('00:0A:2E','Maple Networks Co., Ltd','Maple Networks Co., Ltd602, Dongwha349-24, Shindaebang-dong, Dongjak-guSeoul  156-010Korea, Republic Of',1),('00:0A:2F','Artnix Inc.','Artnix Inc.Chungjin B/d, 475-22 Bangbae, SeochoSeoul  137-819Korea, Republic Of',1),('00:0A:30','Johnson Controls-asg','Johnson Controls-asg915 East 32nd StreetHolland Mi 49423United States',1),('00:0A:31','Hcv Wireless','Hcv WirelessLevel 1, 80 Jephson StToowong Qld 4066Australia',1),('00:0A:32','Xsido Corporation','Xsido Corporation3f,2-8-13,shiba-daimon,Minato-kuTokyo  105-0012Japan',1),('00:0A:33','Emulex Corporation','Emulex Corporation2021 Opportunity DriveSuite 1Roseville Ca 95678United States',1),('00:0A:34','Identicard Systems Incorporated','Identicard Systems Incorporated40 Citation LaneLancaster Pennsylvania 17606United States',1),('00:0A:35','Xilinx','Xilinx2100 Logic DriveSan Jose Ca 94110United States',1),('00:0A:36','Synelec Telecom Multimedia','Synelec Telecom MultimediaZone IndustrielleSaint Sernin Sur Rance Aveyron F-12380France',1),('00:0A:37','Procera Networks, Inc.','Procera Networks, Inc.1299 Orleans DriveSunnyvale Ca 94089United States',1),('00:0A:38','Apani Networks','Apani Networks1800 E. Imperial HwySuite 210Brea Ca 92821United States',1),('00:0A:39','Lopa Information Technology','Lopa Information Technology710-9, Dae Lim 3-dongYoung Deung Po-gu Seoul, Korea 150-814Korea, Republic Of',1),('00:0A:3A','J-three International Holding Co., Ltd.','J-three International Holding Co., Ltd.No. 1, Yu-3 Rd., Youth Industrial ParkYang-mei, Taoyuan Hsien  326Taiwan, Republic Of China',1),('00:0A:3B','Gct Semiconductor, Inc','Gct Semiconductor, Inc2121 Ringwood AvenueSan Jose Ca 95131United States',1),('00:0A:3C','Enerpoint Ltd.','Enerpoint Ltd.Kaivopuistontie 33Rauma  26100Finland',1),('00:0A:3D','Elo Sistemas Eletronicos S.a.','Elo Sistemas Eletronicos S.a.Rua Edu Chaves, 547Porto Alegre Rs 90.240-620Brazil',1),('00:0A:3E','Eads Telecom','Eads TelecomLandshuter Strasse 26Munich Bavaria 85716Germany',1),('00:0A:3F','Data East Corporation','Data East Corporation4-41-10 Minami-ogikuboSuginami-ku Tokyo 167-0052Japan',1),('00:0A:40','Crown Audio -- Harmanm International','Crown Audio -- Harmanm International1718 W. Mishawaka RdElkhart In 46517United States',1),('00:0A:41','Cisco Systems','Cisco Systems80 West Tasman Dr.San Jose Ca 95134United States',1),('00:0A:42','Cisco Systems','Cisco Systems80 West Tasman Dr.San Jose Ca 95134United States',1),('00:0A:43','Chunghwa Telecom Co., Ltd.','Chunghwa Telecom Co., Ltd.12, Lane 551, Min-tsu RoadSec. 5 Yang-mei,Taoyuan  326Taiwan, Republic Of China',1),('00:0A:44','Avery Dennison Deutschland Gmbh','Avery Dennison Deutschland GmbhOhmstr. 3Eching  85386Germany',1),('00:0A:45','Audio-technica Corp.','Audio-technica Corp.Naruse 1,348Machida Tokyo 194-8566Japan',1),('00:0A:46','Aro Controls Sas','Aro Controls SasZi De Mont Sur LoirChateau Du Loir Sarthe 72500France',1),('00:0A:47','Allied Vision Technologies','Allied Vision TechnologiesTaschenweg 2aStadtroda Thringen 07646Germany',1),('00:0A:48','Albatron Technology','Albatron Technology6f, No 716, Chung Cheng,Chung-ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:0A:49','F5 Networks, Inc.','F5 Networks, Inc.41 Wellman StLowell Ma 01851United States',1),('00:0A:4A','Targa Systems Ltd.','Targa Systems Ltd.1905 Grandtech Centre,8 On Ping St.  Siu Lek YuenShatin N.t.Hong Kong',1),('00:0A:4B','Datapower Technology, Inc.','Datapower Technology, Inc.One Alewife CenterCambridge Ma 02140United States',1),('00:0A:4C','Molecular Devices Corporation','Molecular Devices Corporation1311 Orleans DriveSunnyvale Ca 94089United States',1),('00:0A:4D','Noritz Corporation','Noritz Corporation5 Minami-futami,Futami-cho,Akashi-shi Hyogo 674-0093Japan',1),('00:0A:4E','Unitek Electronics Inc.','Unitek Electronics Inc.1-18-4Ohmori-kitaOhta-ku Tokyo 143-0016Japan',1),('00:0A:4F','Brain Boxes Limited','Brain Boxes LimitedUnit 3c, Wavertree Boulevard SouthWavertree Technology ParkLiverpool Merseyside L7 9pfUnited Kingdom',1),('00:0A:50','Remotek Corporation','Remotek Corporation6f-6, No 77, Sec 1, Hsin Tai Wu Road,Hsi-chih Taipei Hsien 221Taiwan, Republic Of China',1),('00:0A:51','Gyrosignal Technology Co., Ltd.','Gyrosignal Technology Co., Ltd.5f,no. 77,lide St.Zhonghe City Taipei County 23556Taiwan, Republic Of China',1),('00:0A:52','Asiarf Ltd.','Asiarf Ltd.4f., No.2, Lane 560Zhongzheng Rd.Xindian City Taipei 231Taiwan, Republic Of China',1),('00:0A:53','Intronics, Incorporated','Intronics, Incorporated2020 Lafayette Blvd.Fredericksburg Virginia 22401United States',1),('00:0A:54','Laguna Hills, Inc.','Laguna Hills, Inc.1-25-1 35f Fl., NishishinjukuShinjuku-ku Tokyo 1630635Japan',1),('00:0A:55','Markem Corporation','Markem Corporation150 Congress StreetKeene Nh 03431United States',1),('00:0A:56','Hitachi Maxell Ltd.','Hitachi Maxell Ltd.6-20-1 KinunodaiYawara-mura, Tsukuba-gun Ibaraki 300-2496Japan',1),('00:0A:57','Hewlett-packard Company - Standards','Hewlett-packard Company - Standards10955 Tantau AvenueMailstop 4138Cupertino Ca 95014United States',1),('00:0A:58','Ingenieur-buero Freyer & Siegel','Ingenieur-buero Freyer & SiegelNeuendorfstr. 18 BHennigsdorf Brandenburg 16761Germany',1),('00:0A:59','Hw Server','Hw ServerItalska 15Prague 2 Czech Republic 120 00Czech Republic',1),('00:0A:5A','Greennet Technologies Co.,ltd.','Greennet Technologies Co.,ltd.No.10, Qiongyu Road,sciences-based IndusNanshan DistrictShenzhen Guangdong 518057China',1),('00:0A:5B','Power-one As','Power-one AsP.o. Box 1543Drammen  3007Norway',1),('00:0A:5C','Carel S.p.a.','Carel S.p.a.Via Dell Industria, 11Brugine Padova 35020Italy',1),('00:0A:5D','Puc Founder (msc) Berhad','Puc Founder (msc) BerhadLot G-1 & G-2, Incubator 1Technology Park MalaysiaKuala Lumpur Wp 57000Malaysia',1),('00:0A:5E','3com Corporation','3com Corporation5400 Bayfront PlazaM/s 5119Santa Clara Ca 95052-8145United States',1),('00:0A:5F','Almedio Inc.','Almedio Inc.32-13, Sakae-cho 2 ChomeHigashimurayama-shi Tokyo 189-0013Japan',1),('00:0A:60','Autostar Technology Pte Ltd','Autostar Technology Pte LtdUnit 04-10 Techplace IiSingapore Singapore 569876Singapore',1),('00:0A:61','Cellinx Systems Inc.','Cellinx Systems Inc.408 Woosung Character199 Officetel467-24 Dogok-dong Kangnam-guSeoul  135-856Korea, Republic Of',1),('00:0A:62','Crinis Networks, Inc.','Crinis Networks, Inc.2099 N. Collins Blvd, Suite 200Richardson Tx 75080United States',1),('00:0A:63','Dhd Gmbh','Dhd GmbhHaferkornstrasse 5Leipzig Sachsen 04129Germany',1),('00:0A:64','Eracom Technologies','Eracom Technologies28 Greg Chappell DriveBurleigh Heads Qld 4220Australia',1),('00:0A:65','Gentechmedia.co.,ltd.','Gentechmedia.co.,ltd.Solvit Bldg 2f, 402-8, Yangjae-don,Seocho-gu, Seoul 137-899Korea, Republic Of',1),('00:0A:66','Mitsubishi Electric System & Service Co.,ltd.','Mitsubishi Electric System & Service Co.,ltd.1-4-13 Ooyodonaka,kita-kuOsaka  531-0076Japan',1),('00:0A:67','Ongcorp','Ongcorp481 Hackensack Ave.Hackensack Nj 07601United States',1),('00:0A:68','Solarflare Communications, Inc.','Solarflare Communications, Inc.9501 JeronimoSuite 100Irvine Ca 92618United States',1),('00:0A:69','Sunny Bell Technology Co., Ltd.','Sunny Bell Technology Co., Ltd.#502 Buwon B/d 107-45 Banpo-dongSeocho-kuSeoul  137-806Korea, Republic Of',1),('00:0A:6A','Svm Microwaves S.r.o.','Svm Microwaves S.r.o.U Mrazovky 5Praha 5  15000Czech Republic',1),('00:0A:6B','Tadiran Telecom Business Systems Ltd','Tadiran Telecom Business Systems Ltd18 Hasivim St.P.o.box 450Petach Tikva  49105Israel',1),('00:0A:6C','Walchem Corporation','Walchem Corporation5 Boynton RoadHolliston Ma 01746United States',1),('00:0A:6D','Eks Elektronikservice Gmbh','Eks Elektronikservice GmbhEnzstr. 9Kornwestheim Baden Wrtemberg 70806Germany',1),('00:0A:6E','Broadcast Technology Limited','Broadcast Technology Limited6 Sopwith Park, Royce CloseWest Portway Industrial EstateAndover Hampshire Sp10 3tbUnited Kingdom',1),('00:0A:6F','Zyflex Technologies Inc','Zyflex Technologies Inc2fl. No. 58 Park Ave. IiS.b.i.p., Hsinchu  30077Taiwan, Republic Of China',1),('00:0A:70','Mpls Forum','Mpls Forum39355 California StreetSuite 307Fremont Ca 94538United States',1),('00:0A:71','Avrio Technologies, Inc','Avrio Technologies, Inc2655 A Park Center DriveSimi Valley Ca 91356United States',1),('00:0A:72','Stec, Inc.','Stec, Inc.3001 Daimler StreetSanta Ana Ca 92705United States',1),('00:0A:73','Scientific Atlanta','Scientific Atlanta5030 Sugarloaf ParkwayMs 5.2425Lawrenceville Ga 30042United States',1),('00:0A:74','Manticom Networks Inc.','Manticom Networks Inc.14016-c Sullyfield CircleChantilly Va 20151United States',1),('00:0A:75','Caterpillar, Inc','Caterpillar, IncMailstop Location Ac6130Po Box 610Mossville Il 61552-0610United States',1),('00:0A:76','Beida Jade Bird Huaguang Technology Co.,ltd','Beida Jade Bird Huaguang Technology Co.,ltdNo.207 Chengfu Road, Haidian DistrictBeijing  100871China',1),('00:0A:77','Bluewire Technologies Llc','Bluewire Technologies Llc420 N. O St.Tulare Ca 93274United States',1),('00:0A:78','Olitec','OlitecB.p. 59287, Rue Mac MahonNancy Cedex  54009France',1),('00:0A:79','Corega K.k.','Corega K.k.1-19-20, ShinyokohamaKouhoku-kuYokohama-city Kanagawa-ken 222-0033Japan',1),('00:0A:7A','Kyoritsu Electric Co., Ltd.','Kyoritsu Electric Co., Ltd.2-3-17Iwato-minamiKomae-shi Tokyo 201-0005Japan',1),('00:0A:7B','Cornelius Consult','Cornelius ConsultAm Siepen 17Bochum Nrw 44803Germany',1),('00:0A:7C','Tecton Ltd','Tecton LtdFishers CourtFishers PondEastleigh Hampshire So50 7hgUnited Kingdom',1),('00:0A:7D','Valo, Inc.','Valo, Inc.1351 Redwood WayPetaluma Ca 94954United States',1),('00:0A:7E','The Advantage Group','The Advantage Group1610 Des Peres RoadSuite 370St. Louis Mo 63131United States',1),('00:0A:7F','Teradon Industries, Inc','Teradon Industries, Inc7500 2nd St NwAlbuquerque Nm 87120United States',1),('00:0A:80','Telkonet Inc.','Telkonet Inc.20374 Seneca Meadows PkwyGermantown Md 20786United States',1),('00:0A:81','Teima Audiotex S.l.','Teima Audiotex S.l.C/ Tirvia, 6, Local BMadrid  28040Spain',1),('00:0A:82','Tatsuta System Electronics Co.,ltd.','Tatsuta System Electronics Co.,ltd.Iwatatyou2-3-1Higashioosaka-shi Oosaka-fu 578-8585Japan',1),('00:0A:83','Salto Systems S.l.','Salto Systems S.l.Arkotz, 9Polgono Lanbarren Oiartzun 20180Spain',1),('00:0A:84','Rainsun Enterprise Co., Ltd.','Rainsun Enterprise Co., Ltd.No.14-3 , Lane 235, Ho-chen RoadBaociao RoadShindian City Taipei 231Taiwan, Republic Of China',1),('00:0A:85','Platc2,inc','Platc2,inc2-3-6 SotokandaChiyoda-ku Tokyo 101-0021Japan',1),('00:0A:86','Lenze','LenzePo Box 101352Hameln Lower Saxony 31763Germany',1),('00:0A:87','Integrated Micromachines Inc.','Integrated Micromachines Inc.1400 S. Shamrock Ave.Monrovia Ca 91016United States',1),('00:0A:88','Incypher S.a.','Incypher S.a.18 Rue De LeauLuxembourg  1449Luxembourg',1),('00:0A:89','Creval Systems, Inc.','Creval Systems, Inc.2f,24-4,sanwolgok-dong,sungbuk-ku,seoul,Seoul  136-120Korea, Republic Of',1),('00:0A:8A','Cisco Systems','Cisco Systems80 West Tasman Dr.San Jose Ca 95134United States',1),('00:0A:8B','Cisco Systems','Cisco Systems80 West Tasman Dr.San Jose Ca 95134United States',1),('00:0A:8C','Guardware Systems Ltd.','Guardware Systems Ltd.Ulloi Ut 102.Budapest  H-1089Hungary',1),('00:0A:8D','Eurotherm Limited','Eurotherm LimitedFaraday CloseDurringtonWorthing West Sussex Bn13 3plUnited Kingdom',1),('00:0A:8E','Invacom Ltd','Invacom LtdBusiness And Technology CentreBessemer DriveStevenage Hertfordshire Sg1 2dxUnited Kingdom',1),('00:0A:8F','Aska International Inc.','Aska International Inc.306 Riverseven4-18 Haregi-honmachiKochi  780-8088Japan',1),('00:0A:90','Bayside Interactive, Inc.','Bayside Interactive, Inc.330 Biscayne Blvd.Suite 801Miami Fl 33132United States',1),('00:0A:91','Hemocue Ab','Hemocue AbBox 1204ngelholm Skne 26223Sweden',1),('00:0A:92','Presonus Corporation','Presonus Corporation7257 Florida Blvd.Baton Rouge Louisiana 70806United States',1),('00:0A:93','W2 Networks, Inc.','W2 Networks, Inc.5808 Nw Lac Leman DriveIssaquah Washington 98027United States',1),('00:0A:94','Shanghai Cellink Co., Ltd','Shanghai Cellink Co., LtdC3 Meilong Zhongxin Industrial Park,no.1Shanghai  200237China',1),('00:0A:95','Apple Computer, Inc.','Apple Computer, Inc.1 Infinite LoopM/s 26-cCupertino Ca 95014United States',1),('00:0A:96','Mewtel Technology Inc.','Mewtel Technology Inc.E15fl. It Venture Tower78 Karak-dong, Songpa-guSeoul  138-803Korea, Republic Of',1),('00:0A:97','Sonicblue, Inc.','Sonicblue, Inc.2841 Mission College Blvd.Santa Clara Ca 95054United States',1),('00:0A:98','M+f Gwinner Gmbh & Co','M+f Gwinner Gmbh & CoWeidenbaumsweg 91 AHamburg  21029Germany',1),('00:0A:99','Dataradio Inc.','Dataradio Inc.5500 Royalmount Ave. ,Suite 200Town Of Mount-royal, Montreal Quebec H4p 1h7Canada',1),('00:0A:9A','Aiptek International Inc','Aiptek International IncNo 5-1 Innovation Rd 1Science-based Industrial ParkHsin-chu  300Taiwan, Republic Of China',1),('00:0A:9B','Towa Meccs Corporation','Towa Meccs Corporation35-1 KamitodaToda Saitama 335-0022Japan',1),('00:0A:9C','Server Technology, Inc.','Server Technology, Inc.1040 Sandhill Dr.Reno Nevada 89511United States',1),('00:0A:9D','King Young Technology Co. Ltd.','King Young Technology Co. Ltd.1fl., No. 9, Lane 26, Gangchi Rd., NeihuTaipei  114Taiwan, Republic Of China',1),('00:0A:9E','Broadweb Corportation','Broadweb Corportation3f, 24-1, Industry East Rd., Iv,Science Based, Industrial ParkHsin-chu 300Taiwan, Republic Of China',1),('00:0A:9F','Pannaway Technologies, Inc.','Pannaway Technologies, Inc.215 Commerce WayPortsmouth Nh 03801United States',1),('00:0A:A0','Cedar Point Communications','Cedar Point Communications16 Route 111, Bldg 3Derry Nh 03038United States',1),('00:0A:A1','V V S Limited','V V S LimitedHpic, 1. Ainslie Road ,HillingtonGlasgow Scotland G52 4ruUnited Kingdom',1),('00:0A:A2','Systek Inc.','Systek Inc.Jcom Building 402, Ojeon-dong 124-4,Uiwang-si Gyunggi-do 437-070Korea, Republic Of',1),('00:0A:A3','Shimafuji Electric Co.,ltd.','Shimafuji Electric Co.,ltd.Daihyaku-seimei Kamata Bldg.3f8-11-11 Nishikamata,ota-kuTokyo 144-0051Japan',1),('00:0A:A4','Shanghai Surveillance Technology Co,ltd','Shanghai Surveillance Technology Co,ltdFl.25a,no.8 Changyang RoadShanghai  200082China',1),('00:0A:A5','Maxlink Industries Limited','Maxlink Industries Limited29a Shenzhen Special ZonePress TowerShenzhen Guangdong 518009China',1),('00:0A:A6','Hochiki Corporation','Hochiki Corporation246, TsurumaMachida Tokyo 194-8577Japan',1),('00:0A:A7','Fei Electron Optics','Fei Electron OpticsAchtseweg Noord 5Aae 34Eindhoven  5651ggNetherlands',1),('00:0A:A8','Epipe Pty. Ltd.','Epipe Pty. Ltd.P.o. Box 1428ToowongBrisbane Queensland 4066Australia',1),('00:0A:A9','Brooks Automation Gmbh','Brooks Automation GmbhGoeschwitzer Strasse 25Jena Thuringia 07745Germany',1),('00:0A:AA','Altigen Communications Inc.','Altigen Communications Inc.47427 Fremont Blvd.Fremont Ca 94538United States',1),('00:0A:AB','Toyota Technical Development Corporation','Toyota Technical Development Corporation1-21, Imae, Hanamoto-choToyota Aichi 470-0334Japan',1),('00:0A:AC','Terratec Electronic Gmbh','Terratec Electronic GmbhHerrenpfad 38Nettetal Nrw 41334Germany',1),('00:0A:AD','Stargames Corporation','Stargames Corporation13 Sheridan CloseMilperra Nsw 2031Australia',1),('00:0A:AE','Rosemount Process Analytical','Rosemount Process Analytical6573a Cochran Rd.Solon Ohio 44139-3922United States',1),('00:0A:AF','Pipal Systems','Pipal Systems2903 Bunker Hill LaneSuite 210Santa Clara Ca 95054United States',1),('00:0A:B0','Loytec Electronics Gmbh','Loytec Electronics GmbhStolzenthalergasse 24/3Vienna Wien 1080Austria',1),('00:0A:B1','Genetec Corporation','Genetec CorporationNishikura-lk Bld.Tomihisa-chou 16-6Shinjuku-ku Tokyo 162-0067Japan',1),('00:0A:B2','Fresnel Wireless Systems','Fresnel Wireless Systems1333 Gateway DriveSuite 1007Melbourne Fl 32901United States',1),('00:0A:B3','Fa. Gira','Fa. GiraDahlienstraeRadevormwald Nordrhein-westfalen 42477Germany',1),('00:0A:B4','Etic Telecommunications','Etic Telecommunications13, Chemin Du Vieux-chene ZirstMeylan Isere 38240France',1),('00:0A:B5','Digital Electronic Network','Digital Electronic Network8 Rue Du Sacr CoeurSaint Laurent Sur Sevre Vendee 85290France',1),('00:0A:B6','Compunetix, Inc','Compunetix, Inc2420 Mosside Blvd.Monroeville Pa 15146United States',1),('00:0A:B7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0A:B8','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0A:B9','Astera Technologies Corp.','Astera Technologies Corp.2380 Waverley StreetPalo Alto Ca 94301United States',1),('00:0A:BA','Arcon Technology Limited','Arcon Technology LimitedRm. 3711-12, 37/f., Cable Tv Tower ,9 Hoi Shing Rd., Tsuen Wan , N.tHong KongChina',1),('00:0A:BB','Taiwan Secom Co,. Ltd','Taiwan Secom Co,. Ltd13f, 108, Sec1, Shin-tai 5th RoadHsi-chih Taipei County 221Taiwan, Republic Of China',1),('00:0A:BC','Seabridge Ltd.','Seabridge Ltd.3 Hanagar St.Neve-neeman BHod-hasharon Israel 45241Israel',1),('00:0A:BD','Rupprecht & Patashnick Co.','Rupprecht & Patashnick Co.25 Corporate CircleAlbany Ny 12203United States',1),('00:0A:BE','Opnet Technologies Co., Ltd.','Opnet Technologies Co., Ltd.3f, No.5, Industry E. Rd. Ix, Science-baHsinchu  300Taiwan, Republic Of China',1),('00:0A:BF','Hirota Ss','Hirota SsMatukawa-kougyoudanchiSuzaka-shi Nagano 382-0005Japan',1),('00:0A:C0','Fuyoh Video Industry Co., Ltd.','Fuyoh Video Industry Co., Ltd.7-25 Higashi KibogaokaAsahi-kuYokohama-shi Kanagawa-ken 246-0008Japan',1),('00:0A:C1','Futuretel','Futuretel21580 Stevens Creek Blvd, Suite 208Cupertino Ca 95014United States',1),('00:0A:C2','Fiberhome Telecommunication Technologies Co.,ltd','Fiberhome Telecommunication Technologies Co.,ltdNo.88 Youkeyuan Road,hongshan District,wWuhan Hubei 430074China',1),('00:0A:C3','Em Technics Co., Ltd.','Em Technics Co., Ltd.7f., It Venture Tower., 78,Garakbon-dong, Songpa-guSeoul  138-803Korea, Republic Of',1),('00:0A:C4','Daewoo Teletech Co., Ltd','Daewoo Teletech Co., Ltd265-3, Seohyeon, BundangSeongnam Gyeonggi 463-769Korea, Republic Of',1),('00:0A:C5','Color Kinetics','Color Kinetics10 Milk StreetSuite 1100Boston Masachusetts 02108United States',1),('00:0A:C6','Ceterus Networks, Inc.','Ceterus Networks, Inc.P.o. Box 250391Plano Tx 75025-0391United States',1),('00:0A:C7','Unication Group','Unication Group3f., No. 6, Wu-kung 5rd., Hsinchuang CitTaipei  242Taiwan, Republic Of China',1),('00:0A:C8','Zpsys Co.,ltd. (planning&management)','Zpsys Co.,ltd. (planning&management)106 Ace Techno Tower1197-17 Kuro-dongSeoul  152-050Korea, Republic Of',1),('00:0A:C9','Zambeel Inc','Zambeel Inc45700 Northport Loop EastFremont Ca 94538United States',1),('00:0A:CA','Yokoyama Shokai Co.,ltd.','Yokoyama Shokai Co.,ltd.6-96 MatsumuraKanazawa Ishikawa 920-0348Japan',1),('00:0A:CB','Xpak Msa Group','Xpak Msa GroupCare Of: Molex Fiber Optics5224 Katrine AvenueDowners Grove Il 60515United States',1),('00:0A:CC','Winnow Networks, Inc.','Winnow Networks, Inc.701 Emerson RoadSuite 244St. Louis Mo 63141United States',1),('00:0A:CD','Sunrich Technology Limited','Sunrich Technology LimitedUnit 1301, Eastern Centre, 1065 Kings RQuarry BayHong Kong',1),('00:0A:CE','Radiantech, Inc.','Radiantech, Inc.2-1, Industry East Rd. 1, Science-basedIndustrial ParkHsin Chu  300Taiwan, Republic Of China',1),('00:0A:CF','Provideo Multimedia Co. Ltd.','Provideo Multimedia Co. Ltd.5f, No.8, Alley 2, Tzu-wei Lane,Chung Cheng Rd.,Hsin Tien City Taipei Hsien, 231Taiwan, Republic Of China',1),('00:0A:D0','Niigata Develoment Center,  F.i.t. Co., Ltd.','Niigata Develoment Center,  F.i.t. Co., Ltd.Akane-niigata Building 2f1-6-7 AtagoNiigata Niigata Prefecture 950-0944Japan',1),('00:0A:D1','Mws','Mws12, Quai PapacinoNice  06300France',1),('00:0A:D2','Jepico Corporation','Jepico CorporationNishi-shinjyuku2-7-1Dai-ichi Seimei Bldg.Shinjyuku-ku Tokyo 163-0729Japan',1),('00:0A:D3','Initech Co., Ltd','Initech Co., Ltd3f, Initech Bldg, 559-5,Geoyo-dong, Songpa-guSeoul Songpa 138-816Korea, Republic Of',1),('00:0A:D4','Corebell Systems Inc.','Corebell Systems Inc.Htvc 2317 Kaist373-1 Guseong-dongYuseong-gu Daejeon 305-701Korea, Republic Of',1),('00:0A:D5','Brainchild Electronic Co., Ltd.','Brainchild Electronic Co., Ltd.No.209, Chung Yang Rd.,Nan Kang District,Taipei  115Taiwan, Republic Of China',1),('00:0A:D6','Beamreach Networks','Beamreach Networks755 North Mathilda AveSunnyvale California 94086United States',1),('00:0A:D7','Origin Electric Co.,ltd.','Origin Electric Co.,ltd.1-18-1TakadaToshima Ward Tokyo Met. 171-8555Japan',1),('00:0A:D8','Ipcserv Technology Corp.','Ipcserv Technology Corp.6f,no.107,pan-hsin RdPan-chiao Taipei 22046Taiwan, Republic Of China',1),('00:0A:D9','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:0A:DA','Vindicator Technologies','Vindicator Technologies5307 Industrial Oaks Blvd.Suite 130Austin Texas 78735United States',1),('00:0A:DB','Skypilot Network, Inc','Skypilot Network, Inc1301 Shoreway RoadBelmont Ca 94002United States',1),('00:0A:DC','Ruggedcom Inc.','Ruggedcom Inc.30 Whitmore RoadWoodbridge Ontario L4l 7z4Canada',1),('00:0A:DD','Allworx Corp.','Allworx Corp.300 Main StreetSuite 11East Rochester Ny 14445United States',1),('00:0A:DE','Happy Communication Co., Ltd.','Happy Communication Co., Ltd.42-11 Wonmi-dongWonmi-guBucheon-city Kyunggi-do 420-110Korea, Republic Of',1),('00:0A:DF','Gennum Corporation','Gennum CorporationP.o Box 489Station ABurlington Ontario L7r 3y3Canada',1),('00:0A:E0','Fujitsu Softek','Fujitsu Softek1250 East Arques AveMs 729Sunnyvale Ca 94085United States',1),('00:0A:E1','Eg Technology','Eg Technology250 15th StreetSuite 4007Atlanta Ga 30318United States',1),('00:0A:E2','Binatone Electronics International, Ltd','Binatone Electronics International, LtdFloor 23a, 9 Des Voeux Road WestHong Kong ChinaHong Kong',1),('00:0A:E3','Yang Mei Technology Co., Ltd','Yang Mei Technology Co., Ltd21, Alley 1, Lane 342Fude 1st Road, Shijr CityTaipei  114Taiwan, Republic Of China',1),('00:0A:E4','Wistron Corp.','Wistron Corp.21f, No. 88, Section 1, Hsin Tai  Wu Rd.HsichihTaipei  221Taiwan, Republic Of China',1),('00:0A:E5','Scottcare Corporation','Scottcare Corporation4791 West 150th StreetCleveland Ohio 44135United States',1),('00:0A:E6','Elitegroup Computer System Co. (ecs)','Elitegroup Computer System Co. (ecs)No.22, Alley 38, Lane 91, Sec. 1, Nei HuTaipei  114Taiwan, Republic Of China',1),('00:0A:E7','Eliop S.a.','Eliop S.a.Avenida De Manoteras, 30Madrid  E-28050Spain',1),('00:0A:E8','Cathay Roxus Information Technology Co. Ltd','Cathay Roxus Information Technology Co. LtdFuhua Mansion Building A/b 4fDongcheng DistrictBeijing  100027China',1),('00:0A:E9','Airvast Technology Inc.','Airvast Technology Inc.3f.-5, No.6, Lane 609, Sec. 5, Chongsin Rd.Sanchong City Taipei 241Taiwan, Republic Of China',1),('00:0A:EA','Adam Elektronik Ltd.sti.','Adam Elektronik Ltd.sti.Uzunayna Cad. Celenk Sok. No:1 akmak /Istanbul  81260Turkey',1),('00:0A:EB','Shenzhen Tp-link Technology Co; Ltd.','Shenzhen Tp-link Technology Co; Ltd.Hi-tech Park R1-b33/f, Bldg,  Shennan RoadShenzhen Guangdong 518057China',1),('00:0A:EC','Koatsu Gas Kogyo Co., Ltd.','Koatsu Gas Kogyo Co., Ltd.1-5, Doyama-cho, Kita-ku, OsakaOsaka  530-8411Japan',1),('00:0A:ED','Harting Systems Gmbh & Co Kg','Harting Systems Gmbh & Co KgWilhelm Harting Str.1Espelkamp Nrw/owl 32339Germany',1),('00:0A:EE','Gcd Hard- & Software Gmbh','Gcd Hard- & Software GmbhHenkestr. 79Erlangen Bayern 91052Germany',1),('00:0A:EF','Otrum Asa','Otrum AsaBrattekleivFrvik  N-4818Norway',1),('00:0A:F0','Shin-oh Electronics Co., Ltd. R&d','Shin-oh Electronics Co., Ltd. R&d#729-5, Bonoh-dong, Ansan-city, Kyunggi-Shin-oh Electronics Co., Ltd.Ansan-city Kyunggi-do 425-180Korea, Republic Of',1),('00:0A:F1','Clarity Design, Inc.','Clarity Design, Inc.13029 Danielson StreetSuite 100Poway Ca 92064-8810United States',1),('00:0A:F2','Neoaxiom Corp.','Neoaxiom Corp.1520 Montague ExpresswaySan Jose Ca 95131United States',1),('00:0A:F3','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0A:F4','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0A:F5','Airgo Networks, Inc.','Airgo Networks, Inc.900 Arastradero RdPalo Alto Ca 94304United States',1),('00:0A:F6','Emerson Climate Technologies Retail Solutions, Inc.','Emerson Climate Technologies Retail Solutions, Inc.1640 Airport RdSuite 104Kennesaw Ga 30144-7038United States',1),('00:0A:F7','Broadcom Corp.','Broadcom Corp.16215 Alton ParkwayIrvine Ca 92618United States',1),('00:0A:F8','American Telecare Inc.','American Telecare Inc.7640 Golden Triangle DriveEden Prairie Mn 55344United States',1),('00:0A:F9','Hiconnect, Inc.','Hiconnect, Inc.Rm #906, Haksan Cosmostel, 110Kwangjang-dong, Kwangjin-gu, Seoul, KoreKwangjin-gu Seoul 143-802Korea, Republic Of',1),('00:0A:FA','Traverse Technologies Australia','Traverse Technologies AustraliaUnit 6, 26-36 High StNorthcote Victoria 3070Australia',1),('00:0A:FB','Ambri Limited','Ambri Limited126 Greville StreetChatswood Nsw 2067Australia',1),('00:0A:FC','Core Tec Communications, Llc','Core Tec Communications, Llc49 Leavenworth StreetSuite 200Waterbury Ct 06702United States',1),('00:0A:FD','Viking Electronic Services','Viking Electronic Services620 Allendale RdSuite 175King Of Prussia Pa 19406United States',1),('00:0A:FE','Novapal Ltd','Novapal LtdFloor 658 Uxbridge RoadEaling London W5 2stUnited Kingdom',1),('00:0A:FF','Kilchherr Elektronik Ag','Kilchherr Elektronik AgAeschistrasse 25Muensingen Be 3110Switzerland',1),('00:0B:00','Fujian Start Computer Equipment Co.,ltd','Fujian Start Computer Equipment Co.,ltdHong Shan Yuan Road No.68 Hongshan,gulouFuzhou Fujian 350002China',1),('00:0B:01','Daiichi Electronics Co., Ltd.','Daiichi Electronics Co., Ltd.1-11-13Hitotsuya Adachi-ku Tokyo 121-8639Japan',1),('00:0B:02','Dallmeier Electronic','Dallmeier ElectronicWuerzburgerstr.5Regensburg Bavaria 93059Germany',1),('00:0B:03','Taekwang Industrial Co., Ltd','Taekwang Industrial Co., Ltd#191-1, Anyang-7dong, Manan-guAnyang-si South Korea 430-017Korea, Republic Of',1),('00:0B:04','Volktek Corporation','Volktek Corporation4f., No.192, Lian-chang Road, Chang-hoTaipei  235Taiwan, Republic Of China',1),('00:0B:05','Pacific Broadband Networks','Pacific Broadband Networks8-10 Keith Campbell CourtScoresby Vic 3179Australia',1),('00:0B:06','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:0B:07','Voxpath Networks','Voxpath Networks7600b Capital Of Texas Highway  - NorthSuite 220Austin Texas 78731United States',1),('00:0B:08','Pillar Data Systems','Pillar Data Systems1371 Mccarthy Blvd.Milpitas Ca 95035United States',1),('00:0B:09','Ifoundry Systems Singapore','Ifoundry Systems SingaporeBlock 1, Unit 101b, Innovation Centre, 1637722Singapore',1),('00:0B:0A','Dbm Optics','Dbm Optics300 S. Public RoadLafayette Colorado 80026United States',1),('00:0B:0B','Corrent Corporation','Corrent Corporation1711 W. Greentree Dr.Suite 201Tempe Az 85284-2717United States',1),('00:0B:0C','Agile Systems Inc.','Agile Systems Inc.575 Kumpf DriveWaterloo Ontario N2v 1k3Canada',1),('00:0B:0D','Air2u, Inc.','Air2u, Inc.No. 5-1 Innovation Rd 1, Science-based PHsin-chu Taiwan 300Taiwan, Republic Of China',1),('00:0B:0E','Trapeze Networks','Trapeze Networks5753 W. Las Positas BlvdPleasanton Ca 94588United States',1),('00:0B:0F','Nyquist Industrial Control Bv','Nyquist Industrial Control BvLuchthavenweg 20Eindhoven Noord Brabant Nl5657 EbNetherlands',1),('00:0B:10','11wave Technonlogy Co.,ltd','11wave Technonlogy Co.,ltd10f,no.285 Sec.2 ,ti-ding Ave,naihu.taipTaipei  114Taiwan, Republic Of China',1),('00:0B:11','Himeji Abc Trading Co.,ltd.','Himeji Abc Trading Co.,ltd.1-8-22JyouhokushinmachiHjmeji Hyogo 670-0883Japan',1),('00:0B:12','Nuri Telecom Co., Ltd.','Nuri Telecom Co., Ltd.Woolim Lions Valley Bldg-b 10th F#371-28 Kasan-dongKeum-cheun-gu Seoul 153-803Korea, Republic Of',1),('00:0B:13','Zetron Inc','Zetron IncPo Box 97004Redmond Wa 98073United States',1),('00:0B:14','Viewsonic Corporation','Viewsonic Corporation381 Brea Canyon RoadWalnut California 91789United States',1),('00:0B:15','Platypus Technology','Platypus Technology4/1 Atchison StSt Leonards Nsw 2065Australia',1),('00:0B:16','Communication Machinery Corporation','Communication Machinery Corporation402 E. Gutierrez St.Santa Barbara Ca 93101United States',1),('00:0B:17','Mks Instruments','Mks Instruments651 Lowell StreetMethuen Ma 01844United States',1),('00:0B:18','Private','',1),('00:0B:19','Vernier Networks, Inc.','Vernier Networks, Inc.490 E. Middlefield RoadMountain View Ca 94043United States',1),('00:0B:1A','Industrial Defender, Inc.','Industrial Defender, Inc.16 Chestnut StreetSuite 300Foxborough Ma 02035United States',1),('00:0B:1B','Systronix, Inc.','Systronix, Inc.939 Edison St.Salt Lake City Utah 84111United States',1),('00:0B:1C','Sibco Bv','Sibco BvSchoonhout 46Etten-leur Nb 4872 MeNetherlands',1),('00:0B:1D','Layerzero Power Systems, Inc.','Layerzero Power Systems, Inc.3559 Townley RoadShaker Heights Oh 44122-5156United States',1),('00:0B:1E','Kappa Opto-electronics Gmbh','Kappa Opto-electronics GmbhKleines Feld 637130Gleichen NiedersachsenGermany',1),('00:0B:1F','I Con Computer Co.','I Con Computer Co.3f, No. 142 , Hsin Ming RoadNeihu Taipei 114Taiwan, Republic Of China',1),('00:0B:20','Hirata Corporation','Hirata Corporation111 Hitotsugi, Ueki,Kamoto Kumamoto 861-0198Japan',1),('00:0B:21','G-star Communications Inc.','G-star Communications Inc.5f, 69-10, Sec. 2, Chung Cheng East RoadTaipei Hsien  251Taiwan, Republic Of China',1),('00:0B:22','Environmental Systems And Services','Environmental Systems And Services20 Council StreetHawthorn East Victoria 3123Australia',1),('00:0B:23','Siemens Subscriber Networks','Siemens Subscriber Networks4849 Alpha RoadDallas Texas 74244United States',1),('00:0B:24','Airlogic','Airlogic807-1, Bundangtechnopark D, 151,Yatap-dong, Bundang-kuSungnam-si Kyungki-do 463-760Korea, Republic Of',1),('00:0B:25','Aeluros','Aeluros201 San Antonio Circle #172Mountain View Ca 94040United States',1),('00:0B:26','Wetek Corporation','Wetek Corporation4f, No.17, Kuanfu N. RoadHsin Chu Industrial Park Hsin Chu 303Taiwan, Republic Of China',1),('00:0B:27','Scion Corporation','Scion Corporation82 Wormans Mill CourtSuite HFrederick Md 21701United States',1),('00:0B:28','Quatech Inc.','Quatech Inc.662 Wolf Ledges Pkwy.Akron Oh 44311United States',1),('00:0B:29','Ls(lg) Industrial Systems Co.,ltd','Ls(lg) Industrial Systems Co.,ltd533 Hogye-dong, Dongan-guAnyang-si Gyeonggi-doKorea, Republic Of',1),('00:0B:2A','Howtel Co., Ltd.','Howtel Co., Ltd.J-com Bd. 4f, 124-4 Ojeon-dongUiwang-shi Kyounggi-do 437-070Korea, Republic Of',1),('00:0B:2B','Hostnet Corporation','Hostnet Corporation10f-12,no. 12 Lane 609, Sec.5,chunghsinSanchung Taipei Hsien 241Taiwan, Republic Of China',1),('00:0B:2C','Eiki Industrial Co. Ltd.','Eiki Industrial Co. Ltd.4-12 Manzai-cho, Kita-kuOsaka  530Japan',1),('00:0B:2D','Danfoss Inc.','Danfoss Inc.7941 Corporate DrBaltimore Md 21236United States',1),('00:0B:2E','Cal-comp Electronics (thailand) Public Company Limited Taipe','Cal-comp Electronics (thailand) Public Company Limited Taipe9f, 99, Nan-king E Rd., Sec. 5.Taipei  105Taiwan, Republic Of China',1),('00:0B:2F','Bplan Gmbh','Bplan GmbhIndustriestrae 23Steinbach 61449Germany',1),('00:0B:30','Beijing Gongye Science & Technology Co.,ltd','Beijing Gongye Science & Technology Co.,ltdUnit D.17/e,shenlanhuating Mid Road No.6Beijing  100029China',1),('00:0B:31','Yantai Zhiyang Scientific And Technology Industry Co., Ltd','Yantai Zhiyang Scientific And Technology Industry Co., Ltd5f-4, No. 64, Gong-jian Rd.Hsi-chih City Taipei County 221Taiwan, Republic Of China',1),('00:0B:32','Vormetric, Inc.','Vormetric, Inc.2060 Corporate CtSan Jose Ca 95131United States',1),('00:0B:33','Vivato','Vivato12610 East Mirabeau ParkwaySpokane Wa 99216United States',1),('00:0B:34','Shanghai Broadband Technologies Co.ltd','Shanghai Broadband Technologies Co.ltd17f,no.122,huangxing RoadShanghai  200090China',1),('00:0B:35','Quad Bit System Co., Ltd.','Quad Bit System Co., Ltd.402 Gayang Technotown1487 Gayang 3 DongSeoul Kangseogu 157-810Korea, Republic Of',1),('00:0B:36','Productivity Systems, Inc.','Productivity Systems, Inc.1711 Analog DriveRichardson Tx 75081-1944United States',1),('00:0B:37','Manufacture Des Montres Rolex Sa','Manufacture Des Montres Rolex SaLa Haute-route 82Biel-bienne Be 2502Switzerland',1),('00:0B:38','Knuerr Ag','Knuerr AgMariakirchener Strasse 38Arnstorf Bavaria 94424Germany',1),('00:0B:39','Keisoku Giken Co.,ltd.','Keisoku Giken Co.,ltd.2-12-2 , Chigasaki-minamiTsuzuki-kuYokohama Kanagawa 224-0037Japan',1),('00:0B:3A','Qustream Corporation','Qustream Corporation3305 Breckinridge Blvd.Suite 118Duluth Georgia 30096United States',1),('00:0B:3B','Devolo Ag','Devolo AgSonnenweg 11Aachen Nrw 52070Germany',1),('00:0B:3C','Cygnal Integrated Products, Inc.','Cygnal Integrated Products, Inc.4301 Westbank DriveSuite B-100Austin Tx 78746United States',1),('00:0B:3D','Contal Ok Ltd.','Contal Ok Ltd.Frana Mraza 2/289P.o.box B-34Zilina  01124Slovakia',1),('00:0B:3E','Bittware, Inc','Bittware, Inc31 B South Main StConcord Nh 03301United States',1),('00:0B:3F','Anthology Solutions Inc.','Anthology Solutions Inc.1722 Ringwood Ave.Suite 250San Jose Ca 95131United States',1),('00:0B:40','Opnext Inc.','Opnext Inc.1 Christopher WayEatontown New Jersey 07724United States',1),('00:0B:41','Ing. Buero Dr. Beutlhauser','Ing. Buero Dr. BeutlhauserRoemerweg 4Grassau D-83224Germany',1),('00:0B:42','Commax Co., Ltd.','Commax Co., Ltd.513-11, Sangdaewon-dong, Jungwon-kuSungnam-city Kyunggi-do 462-120Korea, Republic Of',1),('00:0B:43','Microscan Systems, Inc.','Microscan Systems, Inc.1201 Sw 7th StreetRenton Wa 98055United States',1),('00:0B:44','Concord Idea Corp.','Concord Idea Corp.4118 14th Ave., Unit 4Markham Ontario L3r 0j3Canada',1),('00:0B:45','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:46','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:47','Advanced Energy','Advanced Energy1625 Sharp Point DriveFort Collins Colorado 80525United States',1),('00:0B:48','Sofrel','Sofrel2 Rue Du PlessisVern Sur Seiche Ille Et Vilaine 35770France',1),('00:0B:49','Rf-link System Inc.','Rf-link System Inc.No.6, Nan-ke 5th Rd., Hsin-shi,Tainan County  744Taiwan, Republic Of China',1),('00:0B:4A','Visimetrics (uk) Ltd','Visimetrics (uk) LtdSkye HouseSkye RoadPrestwick Ayrshire Ka9 2taUnited Kingdom',1),('00:0B:4B','Visiowave Sa','Visiowave SaRoute De La Pierre 22Victoria HouseEcublens Vaud Ch-1024Switzerland',1),('00:0B:4C','Clarion (m) Sdn Bhd','Clarion (m) Sdn BhdPhase 3FizBayan Lepas Penang 11900Malaysia',1),('00:0B:4D','Emuzed','Emuzed46750 Lakeview BoulevardFremont California 94538United States',1),('00:0B:4E','Vertexrsi, General Dynamics Satcom Technologies, Inc.','Vertexrsi, General Dynamics Satcom Technologies, Inc.1915 E. Harrison RoadLongview Tx 75604United States',1),('00:0B:4F','Verifone, Inc.','Verifone, Inc.2455 Augustine DriveSanta Clara California 95054United States',1),('00:0B:50','Oxygnet','Oxygnet402 E. Carrillo St.Suite CSanta Barbara Ca 93101United States',1),('00:0B:51','Micetek International Inc.','Micetek International Inc.7f-1, #237, Sec. 1, Wu Chuan W. Rd.Taichung  403Taiwan, Republic Of China',1),('00:0B:52','Joymax Electronics Corp.','Joymax Electronics Corp.No. 17, Lane 63, Hsin-jung Road, Ping-chTao-yuan  324Taiwan, Republic Of China',1),('00:0B:53','Initium Co., Ltd.','Initium Co., Ltd.8f. Gongduck Bldg. 272-6 Seohyun BundangSungnam Kyunggi 463-824Korea, Republic Of',1),('00:0B:54','Bitmicro Networks, Inc.','Bitmicro Networks, Inc.45550 Northport Loop EastFremont Ca 94538United States',1),('00:0B:55','Adinstruments','AdinstrumentsP. O. Box 587Dunedin Otago 9001New Zealand',1),('00:0B:56','Cybernetics','Cybernetics111 Cybernetics WayYorktown Va 23693United States',1),('00:0B:57','Silicon Laboratories','Silicon Laboratories7000 W. William Cannon Dr.Bldg.1, Suite 200Austin Tx 78735United States',1),('00:0B:58','Astronautics C.a  Ltd','Astronautics C.a  Ltd23 Hayarkon StreetBnei Brak  51261Israel',1),('00:0B:59','Scriptpro, Llc','Scriptpro, Llc5828 Reeds Rd.Mission Kansas 66202United States',1),('00:0B:5A','Hyperedge','Hyperedge333 Pierce Road Suite #200Itasca Il 60143United States',1),('00:0B:5B','Rincon Research Corporation','Rincon Research Corporation101 N. Wilmot Rd.Suite 101Tucson Az 85711United States',1),('00:0B:5C','Newtech Co.,ltd','Newtech Co.,ltdK-bldg 1-7-7 Shibadaimon Minato-kuTokyo  105-0012Japan',1),('00:0B:5D','Fujitsu Limited','Fujitsu LimitedMusashi-kosugi Tower Place Bldg., 403Kosugi-cho 1-chome,nakahara-kuKawasaki KanagawaJapan',1),('00:0B:5E','Audio Engineering Society Inc.','Audio Engineering Society Inc.60 East 42nd Street, Suite #2520New York Ny 10165-2520United States',1),('00:0B:5F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:60','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:61','Friedrich Ltze Gmbh &co.','Friedrich Ltze Gmbh &co.Bruckwiesenstrae 17-19Weinstadt-groheppach Bw 71384Germany',1),('00:0B:62','Ingenieurbuero Fuer Elektronikdesign Ingo Mohnen','Ingenieurbuero Fuer Elektronikdesign Ingo MohnenStich 30 D52249 EschweilerGermany',1),('00:0B:63','Kaleidescape','KaleidescapeOne First Street, Suite SixteenLos Altos Ca 94022United States',1),('00:0B:64','Kieback & Peter Gmbh & Co Kg','Kieback & Peter Gmbh & Co KgTempelhofer Weg 50Berlin  12347Germany',1),('00:0B:65','Sy.a.c. Srl','Sy.a.c. SrlVia Caboto 19/1Trieste  34147Italy',1),('00:0B:66','Teralink Communications','Teralink CommunicationsCapital Tower 15f,931 Doonsan-dong, Seo-guDaejeon  302120Korea, Republic Of',1),('00:0B:67','Topview Technology Corporation','Topview Technology CorporationNo. 8,wu-chuan Road,wu Ku Industrial ParWu Ku Hsiang,taipei Hsien,  248Taiwan, Republic Of China',1),('00:0B:68','Addvalue Communications Pte Ltd','Addvalue Communications Pte Ltd190 Changi Road , #02-02 Mdis BuildingSingapore  419974Singapore',1),('00:0B:69','Franke Finland Oy','Franke Finland OyVartiokuja 1Naarajarvi Naarajarvi Fin-76850Finland',1),('00:0B:6A','Asiarock Incorporation','Asiarock IncorporationP.o. Box957, Offshore Incorporations CenRoad Town TortolaVirgin Islands, British',1),('00:0B:6B','Wistron Neweb Corp.','Wistron Neweb Corp.No. 10-1, Li-hsin Road I, Science-basedHsinchu  300Taiwan, Republic Of China',1),('00:0B:6C','Sychip Inc.','Sychip Inc.2805 N. Dallas Parkway Suite 400Plano Texas 75093United States',1),('00:0B:6D','Solectron Japan Nakaniida','Solectron Japan Nakaniida325 GanbaraNakaniidamachiKamigun Miyagiken 981-4263Japan',1),('00:0B:6E','Neff Instrument Corp.','Neff Instrument Corp.700 South Myrtle Ave.Monrovia Ca 91016United States',1),('00:0B:6F','Media Streaming Networks Inc','Media Streaming Networks Inc1905 Anam Tower, 702-10, Yeoksam Dong, KSeoul  135-080Korea, Republic Of',1),('00:0B:70','Load Technology, Inc.','Load Technology, Inc.4225 Production CourtLas Vegas Nv 89115United States',1),('00:0B:71','Litchfield Communications Inc.','Litchfield Communications Inc.27 Princeton RoadWatertown Ct 06795United States',1),('00:0B:72','Lawo Ag','Lawo AgAm Oberwald 8Rastatt Baden-wrttemberg 76437Germany',1),('00:0B:73','Kodeos Communications','Kodeos Communications111 Corporate BlvdSuite ASouth Plainfield Nj 07080United States',1),('00:0B:74','Kingwave Technology Co., Ltd.','Kingwave Technology Co., Ltd.18f-3, No. 186, Jian-yi Rd.Chung-ho Taipei 235Taiwan, Republic Of China',1),('00:0B:75','Iosoft Ltd.','Iosoft Ltd.5 Woodlark RoadCambridge Cambs. Cb3 0htUnited Kingdom',1),('00:0B:76','Et&t Technology Co. Ltd.','Et&t Technology Co. Ltd.6f No.101, Songjiang Rd.Taipei  104Taiwan, Republic Of China',1),('00:0B:77','Cogent Systems, Inc.','Cogent Systems, Inc.209 Fair Oaks Ave.South Pasadena Ca 91030United States',1),('00:0B:78','Taifatech Inc.','Taifatech Inc.8f-1 No.289, Sec.2  Guangfu Rd.Hsinchu  300Taiwan, Republic Of China',1),('00:0B:79','X-com, Inc.','X-com, Inc.8809 Sudley RoadSuite 202Manassas Va 20110United States',1),('00:0B:7A','Wave Science Inc.','Wave Science Inc.7620 Omnitech PlaceVictor New York 14564United States',1),('00:0B:7B','Test-um Inc.','Test-um Inc.808 Calle PlanoCamarillo Ca 93012United States',1),('00:0B:7C','Telex Communications','Telex Communications8601 E. Cornhusker HwyLincoln Ne 68505United States',1),('00:0B:7D','Solomon Extreme International Ltd.','Solomon Extreme International Ltd.3f, No.20, Lane 165, Duenhua N. Rd., SunTaipeiTaiwan, Republic Of China',1),('00:0B:7E','Saginomiya Seisakusho Inc.','Saginomiya Seisakusho Inc.535 SasaiSayamashi Saitamaken 350-1395Japan',1),('00:0B:7F','Omniwerks','Omniwerks900 E Hamilton AvenueSuite 100Campbell Ca 95008United States',1),('00:0B:80','Lycium Networks','Lycium Networks9 Hamenofim St.P.o.box 12256Herzliya Israel 46733Israel',1),('00:0B:81','Kaparel Corporation','Kaparel Corporation97 Randall DriveWaterloo Ontario N2v-1c5Canada',1),('00:0B:82','Grandstream Networks, Inc.','Grandstream Networks, Inc.1297 Beacon Street2nd FloorBrookline Ma 02446United States',1),('00:0B:83','Datawatt B.v.','Datawatt B.v.Houtstraat 5P.o. Box 108Wolvega Friesland Nl-8471-zxNetherlands',1),('00:0B:84','Bodet','BodetRoute De La TourlandryTrementines France 49340France',1),('00:0B:85','Cisco Systems','Cisco Systems170 W. Tasman DriveMs Sjcm/1/1San Jose Ca 95134United States',1),('00:0B:86','Aruba Networks','Aruba Networks1322 Crossman AvenueSunnyvale Ca 94089United States',1),('00:0B:87','American Reliance Inc.','American Reliance Inc.11801 Goldring RdArcadia Ca 91006United States',1),('00:0B:88','Vidisco Ltd.','Vidisco Ltd.17 Yechiel DresnerPetach-tikva  49277Israel',1),('00:0B:89','Top Global Technology, Ltd.','Top Global Technology, Ltd.Room 3310, China World Tower No. 1Jian Guo Men Wai AvenueBeijing Beijing 100004China',1),('00:0B:8A','Miteq Inc.','Miteq Inc.100 Davids DriveHauppauge Ny 11788-2034United States',1),('00:0B:8B','Kerajet, S.a.','Kerajet, S.a.Ctra. Villarreal-onda, Km 2.5Villarreal Castellon E-12540Spain',1),('00:0B:8C','Flextronics','FlextronicsMigdal HaemekRamat Gavriel23108 Hataasia 1Israel',1),('00:0B:8D','Avvio Networks','Avvio Networks11 Donovan DrBedford Ma 01730United States',1),('00:0B:8E','Ascent Corporation','Ascent Corporation2-16-19, Kawaraya-machi, Chuo-ku,Osaka-city Osaka-pref 542-0066Japan',1),('00:0B:8F','Akita Electronics Systems Co.,ltd.','Akita Electronics Systems Co.,ltd.85,aza Ushirono,aikawa,yuwa-machiKawabe-gun Akita-ken 010-1231Japan',1),('00:0B:90','Adva Optical Networking Inc.','Adva Optical Networking Inc.Clifton Technology CentreClifton MoorYork Yo30 4guUnited Kingdom',1),('00:0B:91','Aglaia Gesellschaft Fr Bildverarbeitung Und Kommunikation M','Aglaia Gesellschaft Fr Bildverarbeitung Und Kommunikation MTiniusstr. 12-15Berlin  D-13089Germany',1),('00:0B:92','Ascom Danmark A/s','Ascom Danmark A/sFabriksparken 42Glostrup Denmark 2600Denmark',1),('00:0B:93','Ritter Elektronik','Ritter ElektronikLeverkuser Str 65P.o. Box 110240Remscheid Nrw 42897Germany',1),('00:0B:94','Digital Monitoring Products, Inc.','Digital Monitoring Products, Inc.2500 N. Partnership BoulevardSpringfield Missouri 65803United States',1),('00:0B:95','Ebet Gaming Systems Pty Ltd','Ebet Gaming Systems Pty LtdSuite D, 255 Rawson StreetAuburn Nsw 2144Australia',1),('00:0B:96','Innotrac Diagnostics Oy','Innotrac Diagnostics OyKalevantie 25Turku bo 20520Finland',1),('00:0B:97','Matsushita Electric Industrial Co.,ltd.','Matsushita Electric Industrial Co.,ltd.3-1-1 Yagumo-naka-machiMoriguchi City Osaka 570-8501Japan',1),('00:0B:98','Nicetechvision','NicetechvisionIntelzone 703Yongin  Gugal-ri  Ki Heung Kyoungkido 354-2Korea, Republic Of',1),('00:0B:99','Sensable Technologies, Inc.','Sensable Technologies, Inc.15 Constitution WayWoburn Ma 01801United States',1),('00:0B:9A','Shanghai Ulink Telecom Equipment Co. Ltd.','Shanghai Ulink Telecom Equipment Co. Ltd.6 Floor, Building 3230 West Jiangwan RoadShanghai  200083China',1),('00:0B:9B','Sirius System Co, Ltd.','Sirius System Co, Ltd.3-27 Funado-choAshiya Hyogo 659-0093Japan',1),('00:0B:9C','Tribeam Technologies, Inc.','Tribeam Technologies, Inc.116 W. Eastman St., Suite 208Arlington Heights Il 60004United States',1),('00:0B:9D','Twinmos Technologies Inc.','Twinmos Technologies Inc.303 No.3, Tzu Chiang Rd., Hu Kou Xiang,Hsin Chu  303Taiwan, Republic Of China',1),('00:0B:9E','Yasing Technology Corp.','Yasing Technology Corp.No. 50, Ta Hsueh Road, Hsinchu, TaiwanHsinchu  300Taiwan, Republic Of China',1),('00:0B:9F','Neue Elsa Gmbh','Neue Elsa GmbhSonnenweg 11Aachen  52070Germany',1),('00:0B:A0','T&l Information Inc.','T&l Information Inc.898-44 Hokye-dong, Dongan-guAnyang Kyungki-do 431-836Korea, Republic Of',1),('00:0B:A1','Syscom Ltd.','Syscom Ltd.4-10 Hakoda, Kumagaya-shiSaitama-ken 360-8515Japan',1),('00:0B:A2','Sumitomo Electric Networks, Inc','Sumitomo Electric Networks, Inc1-1-3, Shimaya, Konohana-kuOsaka  554-0024Japan',1),('00:0B:A3','Siemens Ag, I&s','Siemens Ag, I&sWerner-von-siemens-strae 65Erlangen Bavaria 91052Germany',1),('00:0B:A4','Shiron Satellite Communications Ltd. (1996)','Shiron Satellite Communications Ltd. (1996)23 Hasivim St.Petach Tikva  49170Israel',1),('00:0B:A5','Quasar Cipta Mandiri, Pt','Quasar Cipta Mandiri, PtJl. Palasari 9aBandung West Java 40262Indonesia',1),('00:0B:A6','Miyakawa Electric Works Ltd.','Miyakawa Electric Works Ltd.2-1-6,Kohhoku-kuYokohama Kanagawa 222-0001Japan',1),('00:0B:A7','Maranti Networks','Maranti Networks3061-b Zanker RoadSan Jose Ca 95134United States',1),('00:0B:A8','Hanback Electronics Co., Ltd.','Hanback Electronics Co., Ltd.306-7, Galma-dong, Seo-guDaejeon  302-171Korea, Republic Of',1),('00:0B:A9','Cloudshield Technologies, Inc.','Cloudshield Technologies, Inc.212 Gilbraltar DriveSunnyvale Ca 94089United States',1),('00:0B:AA','Aiphone Co.,ltd','Aiphone Co.,ltd2-18 Jinno-choAtsuta-kuNagoya Aichi-ken 456-8666Japan',1),('00:0B:AB','Advantech Technology (china) Co., Ltd.','Advantech Technology (china) Co., Ltd.No.666, Han-pu Rd. Yu-shanKun-shan Jiang Su 215316China',1),('00:0B:AC','3com Ltd','3com LtdPeoplebuilding 2, Peoplebuilding EstateMaylands AvenueHemel Hempstead Herts. Hp2 4nwUnited Kingdom',1),('00:0B:AD','Pc-pos Inc.','Pc-pos Inc.309 Commissioners Road WestLondon Ontario N6j 1y4Canada',1),('00:0B:AE','Vitals System Inc.','Vitals System Inc.Jooheung B/d 4fl. 1005-1, Youngtong-dongSuwon City Kyonggi-do 442-813Korea, Republic Of',1),('00:0B:AF','Wooju Communications Co,.ltd','Wooju Communications Co,.ltdB-713, Sk Twin Tech Tower, 345-9, Ga-sanSeoul  153-802Korea, Republic Of',1),('00:0B:B0','Sysnet Telematica Srl','Sysnet Telematica SrlViale Berbera, 49Milan  20162Italy',1),('00:0B:B1','Super Star Technology Co., Ltd.','Super Star Technology Co., Ltd.No. 7 Lane 306,sec. 2,tai-lin Rd.Tai-shan ShiangTaipei Hsien  243Taiwan, Republic Of China',1),('00:0B:B2','Smallbig Technology','Smallbig Technology3f Dongsung Bldg. 720-9 YoksamdongGangnamgu Seoul 135-080Korea, Republic Of',1),('00:0B:B3','Rit Technologies Ltd.','Rit Technologies Ltd.24 Raoul Walenberg  St.Tel Aviv  69719Israel',1),('00:0B:B4','Rdc Semiconductor Inc.,','Rdc Semiconductor Inc.,6f-1 , No.2-1, Lihsin Rd, Science-basedHsin Chu  300Taiwan, Republic Of China',1),('00:0B:B5','Nstor Technologies, Inc.','Nstor Technologies, Inc.100 Technology ParkSuite 175Lake Mary Fl 32746United States',1),('00:0B:B6','Mototech Inc.','Mototech Inc.9, Park Avenue Ii, Science-based IndustrHsinchu  300Taiwan, Republic Of China',1),('00:0B:B7','Micro Systems Co.,ltd.','Micro Systems Co.,ltd.2-15-34 NishikuboMusashino-city Tokyo 180-0013Japan',1),('00:0B:B8','Kihoku Electronic Co.','Kihoku Electronic Co.Marukatubiru 3f 4-9-6Nihonbashi Naniwa-kuOsakashi Osaka-hu 556-0005Japan',1),('00:0B:B9','Imsys Ab','Imsys AbJohanneslundsvagen 3Upplands Vasby  Se-19461Sweden',1),('00:0B:BA','Harmonic Broadband Access Networks','Harmonic Broadband Access Networks549 Baltic WaySunnyvale Ca 94089United States',1),('00:0B:BB','Etin Systems Co., Ltd','Etin Systems Co., Ltd12f, It Venture Tower,78 Garakbon-dong, Songpa-kuSeoul  138-803Korea, Republic Of',1),('00:0B:BC','En Garde Systems, Inc.','En Garde Systems, Inc.2101 White Cloud St. NeAlbuquerque Nm 87112United States',1),('00:0B:BD','Connexionz Limited','Connexionz Limited1 Show PlaceChristchurch Canterbury 8004New Zealand',1),('00:0B:BE','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:BF','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:C0','China Iwncomm Co., Ltd.','China Iwncomm Co., Ltd.4f.c Xietong Building,no.12 Gaoxin 2nd RHi-tech Industries Development ZoneXian Shaanxi 710075China',1),('00:0B:C1','Bay Microsystems, Inc.','Bay Microsystems, Inc.2700 Augustine DriveSuite 298Santa Clara Ca 95054United States',1),('00:0B:C2','Corinex Communication Corp.','Corinex Communication Corp.#308 1168 Hamilton StreetVancouver B.c. V6b 2s2Canada',1),('00:0B:C3','Multiplex, Inc.','Multiplex, Inc.5000 Hadley Rd.S. Plainfield Nj 07040United States',1),('00:0B:C4','Biotronik Gmbh & Co','Biotronik Gmbh & CoWoermannkehre 1Berlin  12359Germany',1),('00:0B:C5','Smc Networks, Inc.','Smc Networks, Inc.38 TeslaIrvine Ca 92618United States',1),('00:0B:C6','Isac, Inc.','Isac, Inc.Po Box 7682Auburn Ca 95604United States',1),('00:0B:C7','Icet S.p.a.','Icet S.p.a.Via Quarto Negroni, 63Cecchina Di Ariccia Roma 00040Italy',1),('00:0B:C8','Airflow Networks','Airflow Networks444 Castro StSuite 320Mountain View Ca 94041United States',1),('00:0B:C9','Electroline Equipment','Electroline Equipment8265 Boul. St-michelMontreal Quebec H1z 3e4Canada',1),('00:0B:CA','Datavan International Corporation','Datavan International Corporation4fl,#120-12,chung Shan Rd, Sec.3Chung Ho City, Taipei Hsien  235Taiwan, Republic Of China',1),('00:0B:CB','Fagor Automation , S. Coop','Fagor Automation , S. CoopSan Andres S/n20500 MondragonGuipuzcoa 20500Spain',1),('00:0B:CC','Jusan, S.a.','Jusan, S.a.Vivero, 5Madrid  28040Spain',1),('00:0B:CD','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs040801Houston Tx 77070United States',1),('00:0B:CE','Free2move Ab','Free2move AbSperlingsgatan 7Halmstad Halland 30248Sweden',1),('00:0B:CF','Agfa Ndt Inc.','Agfa Ndt Inc.50 Industrial Park RoadLewistown Pa 17044United States',1),('00:0B:D0','Ximeta Technology Americas Inc.','Ximeta Technology Americas Inc.54 Ray StreetNew Brunswick Nj 08901United States',1),('00:0B:D1','Aeronix, Inc.','Aeronix, Inc.1775 W. Hibiscus Blvd,Suite #304Melbourne Fl 32901United States',1),('00:0B:D2','Remopro Technology Inc.','Remopro Technology Inc.No. 443, Huannan Rd.,Pingjen City Taoyuan 324Taiwan, Republic Of China',1),('00:0B:D3','Cd3o','Cd3o402 W BroadwaySan Deigo Ca 92101United States',1),('00:0B:D4','Beijing Wise Technology & Science Development Co.ltd','Beijing Wise Technology & Science Development Co.ltd3rd Floor Caihong Building, No.2,1st WesMadian, Haidian DistrictBeijing  100088China',1),('00:0B:D5','Nvergence, Inc.','Nvergence, Inc.Jeil Bldg. 4th, Samsung-dong 168-26, KanSeoul  135-090Korea, Republic Of',1),('00:0B:D6','Paxton Access Ltd','Paxton Access LtdPaxton HouseHome Farm RoadBrighton East Sussex Bn1 9huUnited Kingdom',1),('00:0B:D7','Mbb Gelma Gmbh','Mbb Gelma GmbhMainzer Strae 36-52Bonn Nordrheinwestfalen 53179Germany',1),('00:0B:D8','Industrial Scientific Corp.','Industrial Scientific Corp.1001 Oakdale RoadOakdale Pa 15071United States',1),('00:0B:D9','General Hydrogen','General Hydrogen13120 Vanier PlaceRichmond British Columbia V6v 2j2Canada',1),('00:0B:DA','Eyecross Co.,inc.','Eyecross Co.,inc.3f  Iioka-buildingTokyo Ueno Taitoh-ku 3-4-1 110-0005Japan',1),('00:0B:DB','Dell Esg Pcba Test','Dell Esg Pcba TestOne Dell WayRound Rock Texas 78682United States',1),('00:0B:DC','Akcp','Akcp67/285  Muangake Village #8Moo 3 Vipawadee Road, Tambol LughookAmphur Muang Patomthanee 12000Thailand',1),('00:0B:DD','Tohoku Ricoh Co., Ltd.','Tohoku Ricoh Co., Ltd.3-1 ShinmeidoShibata Miyagi Pref. 989-1695Japan',1),('00:0B:DE','Teldix Gmbh','Teldix GmbhGrenzhoefer Weg 36Heidelberg  69123Germany',1),('00:0B:DF','Shenzhen Routerd Networks Limited','Shenzhen Routerd Networks Limited8/f, Building A, Tsinghua Hi-tech ParkNanshan DistrictShenzhenChina',1),('00:0B:E0','Serconet Ltd.','Serconet Ltd.16 Haharoshet St.P.o.b. 2009Raanana  43657Israel',1),('00:0B:E1','Nokia Net Product Operations','Nokia Net Product Operations313 Fairchild DriveMountain View California 94043United States',1),('00:0B:E2','Lumenera Corporation','Lumenera Corporation2520b St. Laurent Blvd.Ottawa Ontario K1b 4r8Canada',1),('00:0B:E3','Key Stream Co., Ltd.','Key Stream Co., Ltd.No. 2 Nagaoka Bldg. 4f,  2-8-5 HatchoborChuo-ku Tokyo 104-0032Japan',1),('00:0B:E4','Hosiden Corporation','Hosiden Corporation4-33Kitakyuhoji 1-chomeYao-city Osaka 581-0071Japan',1),('00:0B:E5','Hims Korea Co., Ltd.','Hims Korea Co., Ltd.5105, High Tech Venture Hall,53-3, Eoeun-dong, Yuseong-ku,Daejeon Daejeon 305-806Korea, Republic Of',1),('00:0B:E6','Datel Electronics','Datel ElectronicsStafford RoadStone Staffordshire St15 0dgUnited Kingdom',1),('00:0B:E7','Comflux Technology Inc.','Comflux Technology Inc.Room 131,bldg. 53,195-58,sec.4,Chung Hsing Rd.,chutung,Hsinchu  310Taiwan, Republic Of China',1),('00:0B:E8','Aoip','Aoip6 Rue Maryse BastieZi De St GuenaultCourcouronnes Idf 91080France',1),('00:0B:E9','Actel Corporation','Actel Corporation200 Valley RoadSuite 300Mt. Arlington Nj 07856United States',1),('00:0B:EA','Zultys Technologies','Zultys Technologies771 Vaqueros AvenueSunnyvale Ca 94085United States',1),('00:0B:EB','Systegra Ag','Systegra AgBurgunderstrasse 15Bellach So 4512Switzerland',1),('00:0B:EC','Nippon Electric Instrument, Inc.','Nippon Electric Instrument, Inc.3-56-21 HiradoTotsuka-ku Yokohama-shi 244-0802Japan',1),('00:0B:ED','Elm Inc.','Elm Inc.15248 KasedatakedaMinamisatsuma Kagoshima 897-0002Japan',1),('00:0B:EE','Inc.jet, Incorporated','Inc.jet, IncorporatedOne Winnenden RoadNorwich Ct 06360United States',1),('00:0B:EF','Code Corporation','Code Corporation11814 S. Election Rd., Ste 200Draper Utah 84020United States',1),('00:0B:F0','Motex Products Co., Ltd.','Motex Products Co., Ltd.C.p.o.box 6912Ye Kwan-dong 19-1Chong-gu Seoul 82Korea, Republic Of',1),('00:0B:F1','Lap Laser Applikations','Lap Laser ApplikationsZeppelinstrasse 23Lueneburg Niedersachsen 21337Germany',1),('00:0B:F2','Chih-kan Technology Co., Ltd.','Chih-kan Technology Co., Ltd.No. 24-1, Pei Shih Chou, Ming Ho Vill.Shan Sun Hsiang Tainan Hsien 180Taiwan, Republic Of China',1),('00:0B:F3','Bae Systems','Bae Systems6500 Tracor LaneAustin Texas 78725United States',1),('00:0B:F4','Private','',1),('00:0B:F5','Shanghai Sibo Telecom Technology Co.,ltd','Shanghai Sibo Telecom Technology Co.,ltdFloor 6 Building 18,300 Tianlin Rd.Shanghai  200233China',1),('00:0B:F6','Nitgen Co., Ltd','Nitgen Co., Ltd4th Fl. 1337-31 Seocho-dong, Seocho-kuSeoul  137-860Korea, Republic Of',1),('00:0B:F7','Nidek Co.,ltd','Nidek Co.,ltd34-14 MaehamaHiroishi-choGamagori Aich 443-0038Japan',1),('00:0B:F8','Infinera','Infinera1322 Bordeaux DriveSunnyvale Ca 94089United States',1),('00:0B:F9','Gemstone Communications, Inc.','Gemstone Communications, Inc.6fl., No. 102,  Hengyang Rd.Taipei  100Taiwan, Republic Of China',1),('00:0B:FA','Exemys Srl','Exemys SrlLoyola 680Capital Federal Bs As C1414Argentina',1),('00:0B:FB','D-net International Corporation','D-net International Corporation15, Wu-chuan 5th Road, Wu-ku IndustrialTaipei  Hsieh  248Taiwan, Republic Of China',1),('00:0B:FC','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:FD','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0B:FE','Castel Broadband Limited','Castel Broadband Limited9/f., Sui Ying Industrial Building.,Tokwawan Kowloon 150Hong Kong',1),('00:0B:FF','Berkeley Camera Engineering','Berkeley Camera Engineering127 National StreetSanta Cruz Ca 95060United States',1),('00:0C:00','Beb Industrie-elektronik Ag','Beb Industrie-elektronik AgProgressastrasse 31Oberburg Be 3414Switzerland',1),('00:0C:01','Abatron Ag','Abatron AgLettenstrasse 9Rotkreuz  Ch-6343Switzerland',1),('00:0C:02','Abb Oy','Abb OyP.o.box 89Turku  Fin-20521Finland',1),('00:0C:03','Hdmi Licensing, Llc','Hdmi Licensing, Llc1060 East Arques Ave.Suite 100Sunnyvale Ca 94085United States',1),('00:0C:04','Tecnova','Tecnova1486 St. Paul Ave.Gurnee Illinois 60031United States',1),('00:0C:05','Rpa Reserch Co., Ltd.','Rpa Reserch Co., Ltd.4f, 90-7, Yangjae-dong, Seocho-kuSeoul, KoreaSeoul  137-130Korea, Republic Of',1),('00:0C:06','Nixvue Systems  Pte Ltd','Nixvue Systems  Pte Ltd30 Loyang Way, #07-02Singapore Singapore S508769Singapore',1),('00:0C:07','Iftest Ag','Iftest AgSchwimmbadstrasse 43Wettingen Ag 5430Switzerland',1),('00:0C:08','Humex Technologies Corp.','Humex Technologies Corp.5f, No.5, Lane 44, Szu Wei Rd. Taan TaipTaipei  106Taiwan, Republic Of China',1),('00:0C:09','Hitachi Ie Systems Co., Ltd','Hitachi Ie Systems Co., LtdSaiwai-cho 120-1,inazawa-shiAichi 492-8622,japanInazawa-shi Aichi 492-8622Japan',1),('00:0C:0A','Guangdong Province Electronic Technology Research Institute','Guangdong Province Electronic Technology Research InstituteElectronic Technology Building,no.61-65,West Zhongshan Avenue,tianhe DistrictGuangzhou Guangdong 510630China',1),('00:0C:0B','Broadbus Technologies','Broadbus Technologies80 Central StreetBoxborough Massachusetts 01719United States',1),('00:0C:0C','Appro Technology Inc.','Appro Technology Inc.13f, No. 66 Chung-cheng Rd,Hsin-chuang Taipei 242Taiwan, Republic Of China',1),('00:0C:0D','Communications & Power Industries / Satcom Division','Communications & Power Industries / Satcom Division811 Hansen Way Ms S-600Palo Alto Ca 94303United States',1),('00:0C:0E','Xtremespectrum, Inc.','Xtremespectrum, Inc.8133 Leesburg PikeVienna Va 22182United States',1),('00:0C:0F','Techno-one Co., Ltd','Techno-one Co., Ltd9-17-1 Higashi SonodaAmagasaki Hyogo 661-0953Japan',1),('00:0C:10','Pni Corporation','Pni Corporation5464 Skylane Blvd #aSanta Rosa Ca 95403United States',1),('00:0C:11','Nippon Dempa Co.,ltd.','Nippon Dempa Co.,ltd.1-4-8KamenokouKakegawa City Shizuoka Pref. 436-0028Japan',1),('00:0C:12','Micro-optronic-messtechnik Gmbh','Micro-optronic-messtechnik GmbhLessingstrasse 14Langebrueck Saxony D-01465Germany',1),('00:0C:13','Mediaq','Mediaq2975 San Ysidro WaySanta Clara Ca 95051United States',1),('00:0C:14','Diagnostic Instruments, Inc.','Diagnostic Instruments, Inc.6540 BurroughsSterling Heights Mi 48314United States',1),('00:0C:15','Cyberpower Systems, Inc.','Cyberpower Systems, Inc.6f, No. 32, Sec. 1, Chenggong Rd.Nanhang DistrictTaipei  115Taiwan, Republic Of China',1),('00:0C:16','Concorde Microsystems Inc.','Concorde Microsystems Inc.10427 Cogdill Road, Suite 500Knoxville Tn 37932United States',1),('00:0C:17','Aja Video Systems Inc','Aja Video Systems Inc443 Crown Point CircleGrass Valley California 95945United States',1),('00:0C:18','Zenisu Keisoku Inc.','Zenisu Keisoku Inc.2-13-37HonmachiFuchu-shi Tokyo 183-0027Japan',1),('00:0C:19','Telio Communications Gmbh','Telio Communications GmbhElbchaussee 1Hamburg  22765Germany',1),('00:0C:1A','Quest Technical Solutions Inc.','Quest Technical Solutions Inc.4110 Mourning Dove Crt.Melbourne Fl 32934United States',1),('00:0C:1B','Oracom Co, Ltd.','Oracom Co, Ltd.3rd Fl, A-sung Bldg, 999-3Deachi-dong, Kangnam-guSeoul  135-280Korea, Republic Of',1),('00:0C:1C','Microweb Co., Ltd.','Microweb Co., Ltd.403 T/s/s/c, 23-14 Jang-dong, Yusong-gu,Daejeon Choongchungdo 305-343Korea, Republic Of',1),('00:0C:1D','Mettler & Fuchs Ag','Mettler & Fuchs AgQuerstrasse 17Ch-8951 FahrweidSwitzerland',1),('00:0C:1E','Global Cache','Global Cache160 East California StreetPob 1659Jacksonville Or 97530United States',1),('00:0C:1F','Glimmerglass Networks','Glimmerglass Networks26142 Eden Landing RoadHayward California 94545United States',1),('00:0C:20','Fi Win, Inc.','Fi Win, Inc.8f, No. 10, Prosperity Rd. 1,Science Based Industrial ParkHsin Chu  300Taiwan, Republic Of China',1),('00:0C:21','Faculty Of Science And Technology, Keio University','Faculty Of Science And Technology, Keio University3-14-1 Hiyoshi, Kohoku-kuYokohama Kanagawa 223-8522Japan',1),('00:0C:22','Double D Electronics Ltd','Double D Electronics LtdUnit 6, Robins WharfGrove RoadNorthfleet Kent Da11 9axUnited Kingdom',1),('00:0C:23','Beijing Lanchuan Tech. Co., Ltd.','Beijing Lanchuan Tech. Co., Ltd.Rm220,no.30 Shangyuancun,Gaoliangqiaolu,haidian DistrictBeijing  100044China',1),('00:0C:24','Anator','Anator44, Rue Destienne DorvesSartrouville Yvelines 78500France',1),('00:0C:25','Allied Telesyn Networks','Allied Telesyn NetworksSuite 450920 Main Campus DriveRaleigh Nc 27606United States',1),('00:0C:26','Weintek Labs. Inc.','Weintek Labs. Inc.3f, No.910, Chung Cheng Rd.Chung Ho City Taipei Hsien 236Taiwan, Republic Of China',1),('00:0C:27','Sammy Corporation','Sammy CorporationSun Shine60 45f,3-1-1,higashi-ikebukuroToshima-ku Tokyo 170-6045Japan',1),('00:0C:28','Rifatron','Rifatron9th Fl, Shintaeyang Bldg736-8, Banpo-dongSeoul Seocho-gu 137-041Korea, Republic Of',1),('00:0C:29','Vmware, Inc.','Vmware, Inc.3145 Porter Dr.Palo Alto Ca 94304United States',1),('00:0C:2A','Octtel Communication Co., Ltd.','Octtel Communication Co., Ltd.7f-1, No.300, Daduen 10th St.Taichung City  408Taiwan, Republic Of China',1),('00:0C:2B','Elias Technology, Inc.','Elias Technology, Inc.3f, 1015, Yung-an Road,Taoyuan City Taoyuan 330Taiwan, Republic Of China',1),('00:0C:2C','Enwiser Inc.','Enwiser Inc.4f, Cheongseok B/d135-11, Nonhyeon-dong, Kangnam-kuSeoul Seoul 135-010Korea, Republic Of',1),('00:0C:2D','Fullwave Technology Co., Ltd.','Fullwave Technology Co., Ltd.7f-6, No.26, Taiyuan St.,Jubei Hsin Chu 302Taiwan, Republic Of China',1),('00:0C:2E','Openet Information Technology(shenzhen) Co., Ltd.','Openet Information Technology(shenzhen) Co., Ltd.2/f,a Tower,international Tech-innovatioHigh-tech Industrial Park ,shenzhen, P.rShenzhen Guangdong 518057China',1),('00:0C:2F','Seorimtechnology Co.,ltd.','Seorimtechnology Co.,ltd.2f Diplomatic Center B/d 1376-1 Seocho2-Seoul  137-072Korea, Republic Of',1),('00:0C:30','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0C:31','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0C:32','Avionic Design Development Gmbh','Avionic Design Development GmbhSthamerstrasse 24aHamburg  22397Germany',1),('00:0C:33','Compucase Enterprise Co. Ltd.','Compucase Enterprise Co. Ltd.225 Lane 54, An Ho Road, Section 2nd.Tainan City  70942Taiwan, Republic Of China',1),('00:0C:34','Vixen Co., Ltd.','Vixen Co., Ltd.5-17-3 HigashitokorozawaTokorozawa Saitama 359-0021Japan',1),('00:0C:35','Kavo Dental Gmbh & Co. Kg','Kavo Dental Gmbh & Co. KgBismarkring 39Biberach/riss Baden-wuerttemberg 88400Germany',1),('00:0C:36','Sharp Takaya Electronics Industry Co.,ltd.','Sharp Takaya Electronics Industry Co.,ltd.3121-1 Satomi Satosho-choAsakuchi-gun Okayama 719-0301Japan',1),('00:0C:37','Geomation, Inc.','Geomation, Inc.25188 Genesee Trail RoadSuite 100Golden Co 80401United States',1),('00:0C:38','Telcobridges Inc.','Telcobridges Inc.586 Du ChenalRepentigny Quebec J6a 7c5Canada',1),('00:0C:39','Sentinel Wireless Inc.','Sentinel Wireless Inc.439 S. Union St.South Lawrence Ma 01843United States',1),('00:0C:3A','Oxance','Oxance75-85 Rue RichelieuLes Lucs Sur Boulogne  85170France',1),('00:0C:3B','Orion Electric Co., Ltd.','Orion Electric Co., Ltd.41-1, Iehisa-choTakefu-shi Fukui 915-8555Japan',1),('00:0C:3C','Mediachorus, Inc.','Mediachorus, Inc.#205, Etri Tbi 2 CenterUeun-dong, Yusong-guDaejon Dj 305-333Korea, Republic Of',1),('00:0C:3D','Glsystech Co., Ltd.','Glsystech Co., Ltd.Song Bo B/d 3f212-10, Kung-dong, Kuro GuSeoul  152-883Korea, Republic Of',1),('00:0C:3E','Crest Audio','Crest Audio16-00 Pollitt DriveFair Lawn Nj 07410United States',1),('00:0C:3F','Cogent Defence & Security Networks,','Cogent Defence & Security Networks,Meadows Road,Queensway Meadows Ind Estate,Newport, South Wales, Np19 4ssUnited Kingdom',1),('00:0C:40','Altech Controls','Altech Controls1545 Industial DriveMissouri City Texas 77489United States',1),('00:0C:41','Cisco-linksys','Cisco-linksys121 Theory Dr.Irvine Ca 92612United States',1),('00:0C:42','Routerboard.com','Routerboard.comPernavas 46Riga  Lv-1009Latvia',1),('00:0C:43','Ralink Technology, Corp.','Ralink Technology, Corp.4f, No.2, Technology 5th Road,Science-based Industrial Park,Hsin-chu  200Taiwan, Republic Of China',1),('00:0C:44','Automated Interfaces, Inc.','Automated Interfaces, Inc.120 Confederate LaneGreer South Carolina 29651United States',1),('00:0C:45','Animation Technologies Inc.','Animation Technologies Inc.8f,no.138,lane 235,paochiao Road,Hsin TienTaipei Hsien  231Taiwan, Republic Of China',1),('00:0C:46','Allied Telesyn Inc.','Allied Telesyn Inc.960 Stewart Drive, Suite BSunnyvale California 94085United States',1),('00:0C:47','Sk Teletech(r&d Planning Team)','Sk Teletech(r&d Planning Team)21th Fl Startower 737, Yeoksam-dongKangnam-kuSeoul  135-984Korea, Republic Of',1),('00:0C:48','Qostek Corporation','Qostek Corporation7f, 22, Taiyuen StreetChupei Hsinchu Hsien 302Taiwan, Republic Of China',1),('00:0C:49','Dangaard Telecom Rtc Division A/s','Dangaard Telecom Rtc Division A/sIndustrivej 1Dk 26154553Padborg  Dk-6330Denmark',1),('00:0C:4A','Cygnus Microsystems (p) Limited','Cygnus Microsystems (p) Limited93, Phase Ii,Ida, CherlapallyHyderabad Andhra Pradesh 500051India',1),('00:0C:4B','Cheops Elektronik','Cheops ElektronikJeschkenstrasse 32Geretsried Bayern 82538Germany',1),('00:0C:4C','Arcor Ag&co.','Arcor Ag&co.Alfred-herrhausen-allee 1Eschborn Hessen 65760Germany',1),('00:0C:4D','Acra Control','Acra ControlLandscape House,Landscape Road,Churchtown, Dublin 14Ireland',1),('00:0C:4E','Winbest Technology Co,lt','Winbest Technology Co,lt7f-5no.736 Chung Chengrd.,chunghoTaipei  235Taiwan, Republic Of China',1),('00:0C:4F','Udtech Japan Corporation','Udtech Japan CorporationHamacho Hanacho Bldg, 2f2-17-8 Nihonbashi-hamachoChuo-ku Tokyo 103-0007Japan',1),('00:0C:50','Seagate Technology','Seagate Technology1280 Disc DriveShakopee Mn 55379United States',1),('00:0C:51','Scientific Technologies Inc.','Scientific Technologies Inc.6550 Dumbarton CircleFremont Ca 94560United States',1),('00:0C:52','Roll Systems Inc.','Roll Systems Inc.53 Third AvenueBurlington Ma 01803United States',1),('00:0C:53','Private','',1),('00:0C:54','Pedestal Networks, Inc','Pedestal Networks, Inc6503 Dumbarton CircleFremont Ca 94555United States',1),('00:0C:55','Microlink Communications Inc.','Microlink Communications Inc.8f, 31, Hsintai RoadChupei CityHsinchu  302Taiwan, Republic Of China',1),('00:0C:56','Megatel Computer (1986) Corp.','Megatel Computer (1986) Corp.586 Main StreetGlen Williams Ontario L7g 3t6Canada',1),('00:0C:57','Mackie Engineering Services Belgium Bvba','Mackie Engineering Services Belgium BvbaIndustriepark Noord 10Sint Niklaas  B-9100Belgium',1),('00:0C:58','M&s Systems','M&s Systems2861 Congressman LaneDallas Tx 75220United States',1),('00:0C:59','Indyme Electronics, Inc.','Indyme Electronics, Inc.9085 Aero Dr.San Diego Ca 92123United States',1),('00:0C:5A','Ibsmm Industrieelektronik Multimedia','Ibsmm Industrieelektronik MultimediaAyinger Str. 1FaistenhaarBrunnthal Bavaria D-85649Germany',1),('00:0C:5B','Hanwang Technology Co.,ltd','Hanwang Technology Co.,ltd8f,automation Building,95 Zhongguancun,Haidian DistrictBeijing  100080China',1),('00:0C:5C','Gtn Systems B.v.','Gtn Systems B.v.Postbus 122361100 AeAmsterdamNetherlands',1),('00:0C:5D','Chic Technology (china) Corp.','Chic Technology (china) Corp.7th Building,shiao Ind.zone,longhua TowShenzhen Guangdong 518109China',1),('00:0C:5E','Calypso Medical','Calypso Medical2101 Fourth Avenue, Suite 1550Seattle Wa 98121United States',1),('00:0C:5F','Avtec, Inc.','Avtec, Inc.4335 Augusta HwyGilbert Sc 29054United States',1),('00:0C:60','Acm Systems','Acm Systems3034 Gold Canal DriveRancho Cordova Ca 95670United States',1),('00:0C:61','Ac Tech Corporation Dba Advanced Digital','Ac Tech Corporation Dba Advanced Digital1250-g Avenida AcasoCamarillo Ca 93010United States',1),('00:0C:62','Abb Automation Technology Products Ab, Control','Abb Automation Technology Products Ab, ControlMotorgrand 20Vasteras  721 61Sweden',1),('00:0C:63','Zenith Electronics Corporation','Zenith Electronics Corporation2000 Millbrook DriveLincolnshire Illinois 60069United States',1),('00:0C:64','X2 Msa Group','X2 Msa GroupCare Of: Agilent TechnologiesWhite House RoadIpswich, Suffolk Ip1 5pbUnited Kingdom',1),('00:0C:65','Sunin Telecom','Sunin Telecom1025-5 Dokok-ri, Wabu-eubNamyangju-city Kyunggi-do 472-900Korea, Republic Of',1),('00:0C:66','Pronto Networks Inc','Pronto Networks Inc4637 Chabot DrSuite 300Pleasanton Ca 94588United States',1),('00:0C:67','Oyo Electric Co.,ltd','Oyo Electric Co.,ltd63-1 Nakamichi OmoteHirakawaJoyo Kyoto 610-0101Japan',1),('00:0C:68','Sigmatel, Inc.','Sigmatel, Inc.201 Jones RoadWaltham Ma 02451United States',1),('00:0C:69','National Radio Astronomy Observatory','National Radio Astronomy ObservatoryP.o. Box OSocorro Nm 87801United States',1),('00:0C:6A','Mbari','Mbari7700 Sandholdt RoadMoss Landing Ca 95039United States',1),('00:0C:6B','Kurz Industrie-elektronik Gmbh','Kurz Industrie-elektronik GmbhFoehrenbachstrasse 3Remshalden Baden-wrttemberg 73630Germany',1),('00:0C:6C','Elgato Systems Llc','Elgato Systems Llc900 Kearny St #750San Francisco Ca 94133United States',1),('00:0C:6D','Edwards Ltd.','Edwards Ltd.Marshall RoadEastbourne East Sussex Bn22 9baUnited Kingdom',1),('00:0C:6E','Asustek Computer Inc.','Asustek Computer Inc.150, Li-te Rd., PeitouTaipei  112Taiwan, Republic Of China',1),('00:0C:6F','Amtek System Co.,ltd.','Amtek System Co.,ltd.14f-11,no.79,sec. 1 ,hsin Tai Wu Rd.,Hsi Chih CityTaipei  221Taiwan, Republic Of China',1),('00:0C:70','Acc Gmbh','Acc GmbhAm Sandfeld 15Karlsruhe Baden 76149Germany',1),('00:0C:71','Wybron, Inc','Wybron, Inc4830 List DrColorado Springs Colorado 80919United States',1),('00:0C:72','Tempearl Industrial Co., Ltd.','Tempearl Industrial Co., Ltd.3-1-42 OhzuMinami-kuHiroshima-shi Hiroshima 732-0802Japan',1),('00:0C:73','Telson Electronics Co., Ltd','Telson Electronics Co., LtdTelson Venture Tower., 949-3 Dogok-dongSeoul Kangnam-ku 135-739Korea, Republic Of',1),('00:0C:74','Rivertec Corporation','Rivertec Corporation882-5 MiyagasakiImabari Ehime 799-1537Japan',1),('00:0C:75','Oriental Integrated Electronics. Ltd','Oriental Integrated Electronics. Ltd281-34 Dondang-dong Wonmi-guBucheon Kyoungkido 420-808Korea, Republic Of',1),('00:0C:76','Micro-star International Co., Ltd.','Micro-star International Co., Ltd.No 69, Li-de Street, Jung-he City, TaipeTaipeiTaiwan, Republic Of China',1),('00:0C:77','Life Racing Ltd','Life Racing LtdUnit 6 Repton CloseBurnt Mills Ind EstBasildon Essex Ss13 1leUnited Kingdom',1),('00:0C:78','In-tech Electronics Limited','In-tech Electronics LimitedUnit A, 13th Floor., Wing Tai Centre12 Hing Yip StreetKwun Tong KowloonHong Kong',1),('00:0C:79','Extel Communications P/l','Extel Communications P/l399 Ferntree Gully RoadMt Waverley Victoria 3149Australia',1),('00:0C:7A','Datarius Technologies Gmbh','Datarius Technologies GmbhAnton Maria Schyrle Str. 7Reutte Tirol 6600Austria',1),('00:0C:7B','Alpha Project Co.,ltd.','Alpha Project Co.,ltd.4-4-24 KamijimaHamamatsu Shizuoka 433-8122Japan',1),('00:0C:7C','Internet Information Image Inc.','Internet Information Image Inc.Fl. 6, No. 1, Alley 20, Lane 26, RueiguaNeihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:0C:7D','Teikoku Electric Mfg. Co., Ltd','Teikoku Electric Mfg. Co., Ltd60, HiranoShingu-choIbo-gun Hyogo 679-4395Japan',1),('00:0C:7E','Tellium Incorporated','Tellium Incorporated2 Crescent PlaceOceanport New Jersey 07757United States',1),('00:0C:7F','Synertronixx Gmbh','Synertronixx GmbhVahrenwalder Strasse 7Hannover Niedersachsen 30165Germany',1),('00:0C:80','Opelcomm Inc.','Opelcomm Inc.46750 Fremont Blvd. Ste 210Fremont Ca 94538United States',1),('00:0C:81','Nulec Industries Pty Ltd','Nulec Industries Pty LtdPo Box 761, Edith St,Lytton Qld 4178Australia',1),('00:0C:82','Network Technologies Inc','Network Technologies Inc1275 Danner DriveAurora Oh 44202United States',1),('00:0C:83','Logical Solutions','Logical Solutions100t Washington StreetMilford Ct 06460United States',1),('00:0C:84','Eazix, Inc.','Eazix, Inc.Unit 301 Plaza Building B6530 Northgate Avenue, FilinvestMuntinlupa City Rizal 1770Philippines',1),('00:0C:85','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0C:86','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0C:87','Amd','Amd4555 Great America PkwySte 501Santa Clara Ca 95054United States',1),('00:0C:88','Apache Micro Peripherals, Inc.','Apache Micro Peripherals, Inc.17526 Von Karman AveIrvine Ca 92614United States',1),('00:0C:89','Ac Electric Vehicles, Ltd.','Ac Electric Vehicles, Ltd.Markkinakuja 3Jokela  05400Finland',1),('00:0C:8A','Bose Corporation','Bose CorporationAutomotive Systems Division (asd)688 Great Road (mailstop: 1w2)Stow Ma 01775-9102United States',1),('00:0C:8B','Connect Tech Inc','Connect Tech Inc42 Arrow RoadGuelph Ontario N1k 1s6Canada',1),('00:0C:8C','Kodicom Co.,ltd.','Kodicom Co.,ltd.A-dong 5fi.,sk Twin Tower 345-9,Gasan-dong, Guemchun-guSeoul  153-023Korea, Republic Of',1),('00:0C:8D','Matrix Vision Gmbh','Matrix Vision GmbhTalstrasse 16Oppenweiler Baden-wuerttemberg D-71570Germany',1),('00:0C:8E','Mentor Engineering Inc','Mentor Engineering Inc2891 Sunridge Way NeSuite 230Calgary Alberta T1y7k7Canada',1),('00:0C:8F','Nergal S.r.l.','Nergal S.r.l.Viale Bardanzellu,8Roma  00155Italy',1),('00:0C:90','Octasic Inc.','Octasic Inc.4101 Molson St.Suite 300Montreal Quebec H1y 3l1Canada',1),('00:0C:91','Riverhead Networks Inc.','Riverhead Networks Inc.20195 Stevens Creek Blvd. # 110Cupertino Ca 95014United States',1),('00:0C:92','Wolfvision Gmbh','Wolfvision GmbhOberes Ried 146833 KlausAustria',1),('00:0C:93','Xeline Co., Ltd.','Xeline Co., Ltd.7f. Chungjin Bldg., 475-22Bangbae 2 Dong, Seocho-guSeoul  137-819Korea, Republic Of',1),('00:0C:94','United Electronic Industries, Inc. (eui)','United Electronic Industries, Inc. (eui)27 Renmar AveWalpole Ma 02081United States',1),('00:0C:95','Primenet','PrimenetHongik University, 72-1, Sangsu-dong, MaSeoul  121-791Korea, Republic Of',1),('00:0C:96','Oqo, Inc.','Oqo, Inc.1800 Illinois StreetSan Francisco Ca 94124United States',1),('00:0C:97','Nv Adb Ttv Technologies Sa','Nv Adb Ttv Technologies SaLeuvensesteenweg,585Zaventem Vlaamse Brabant 1930Belgium',1),('00:0C:98','Letek Communications Inc.','Letek Communications Inc.Taeyang Bd. 2nd Floor, 2486Songnam-dong, Jungwon-kuSongnam Kyunggi-do 462-824Korea, Republic Of',1),('00:0C:99','Hitel Link Co.,ltd','Hitel Link Co.,ltdSamsung Omni Tower 4th Fl., 395-62Shindaebang-dong, Dongjac-ku,Seoul  156-010Korea, Republic Of',1),('00:0C:9A','Hitech Electronics Corp.','Hitech Electronics Corp.4f, No. 501-15 Chung-cheng Rd.Shin-tien Taipei Shien 231Taiwan, Republic Of China',1),('00:0C:9B','Ee Solutions, Inc','Ee Solutions, Inc8f, No. 9, Park Ii Ave., Science-based IHsin Chu  300Taiwan, Republic Of China',1),('00:0C:9C','Chongho Information & Communications','Chongho Information & CommunicationsChongho Bldg, #7-61 Yangjae-dong, SeochoSeoul  137-130Korea, Republic Of',1),('00:0C:9D','Airwalk Communications, Inc.','Airwalk Communications, Inc.1850 N. Greenville Ave., Suite 164Richardson Tx 75081United States',1),('00:0C:9E','Memorylink Corp.','Memorylink Corp.36 Jewelers Park DriveSuite 200Neenah Wisconsin 54957United States',1),('00:0C:9F','Nke Corporation','Nke Corporation27 Zusho BabaNagaokakyo-shi Kyoto 617-0828Japan',1),('00:0C:A0','Storcase Technology, Inc.','Storcase Technology, Inc.17600 Newhope St.Fountain Valley Ca 92708United States',1),('00:0C:A1','Sigmacom Co., Ltd.','Sigmacom Co., Ltd.Dacombldg 7f 200-12 Anyang-dongManan-ku, Anyang-city, Kyungki-do, Korea430-817Korea, Republic Of',1),('00:0C:A2','Scopus Network Technologies Ltd','Scopus Network Technologies Ltd10 Haamal St. Park AfekRosh Haayin  48092Israel',1),('00:0C:A3','Rancho Technology, Inc.','Rancho Technology, Inc.10783 Bell CourtRancho Cucamonga Ca 19730United States',1),('00:0C:A4','Prompttec Product Management Gmbh','Prompttec Product Management GmbhMariatrosterstr. 41Graz Austria A-8043Austria',1),('00:0C:A5','Naman Nz Ltd','Naman Nz Ltd13/17 Kawana StNorthcoteAucklandNew Zealand',1),('00:0C:A6','Mintera Corporation','Mintera Corporation847 Rogers StreetLowell Ma 01852United States',1),('00:0C:A7','Metro (suzhou) Technologies Co., Ltd.','Metro (suzhou) Technologies Co., Ltd.No.221 Xinghai Street, Suzhou Industrial ParkSuzhou Jiang Su Province 215021China',1),('00:0C:A8','Garuda Networks Corporation','Garuda Networks Corporation48499 Milmont DriveFremont Ca 94538United States',1),('00:0C:A9','Ebtron Inc.','Ebtron Inc.1663 Hwy 701 SouthLoris Sc 29569United States',1),('00:0C:AA','Cubic Transportation Systems Inc','Cubic Transportation Systems Inc1308 S. Washington StreetTullahoma Tn 37388United States',1),('00:0C:AB','Commend International','Commend InternationalHoelzlstrasse 561Wals Salzburg A-5071Austria',1),('00:0C:AC','Citizen Watch Co., Ltd.','Citizen Watch Co., Ltd.6-1-12, Tanashi-choNishi-tokyo-shi Tokyo 188-8511Japan',1),('00:0C:AD','Btu International','Btu International23 Esquire RdNorth Billerica Ma 01862United States',1),('00:0C:AE','Ailocom Oy','Ailocom OyHatanpaan Valtatie 24Dynamo Business ParkTampere Fin 33950Finland',1),('00:0C:AF','Tri Term Co.,ltd.','Tri Term Co.,ltd.21-5 Hiraide Kougiyo DanchiUtsunomiya-shiTochigi  321-0905Japan',1),('00:0C:B0','Star Semiconductor Corporation','Star Semiconductor Corporation6f, No.17, Li-hsin RdScience-based Industrial ParkHsinchu City  300Taiwan, Republic Of China',1),('00:0C:B1','Salland Engineering (europe) Bv','Salland Engineering (europe) BvBedrijvenpark BerkumSchrevenweg 12Zwolle Ov 8024 HaNetherlands',1),('00:0C:B2','Comstar Co., Ltd.','Comstar Co., Ltd.701 Masan Valley #1121-9Chung-ri, Naeseo-eupMasan Gyeongnam 630-724Korea, Republic Of',1),('00:0C:B3','Round Co.,ltd.','Round Co.,ltd.3-9 Gokashou-shibahigashiUji Kyoto 611-0011Japan',1),('00:0C:B4','Autocell Laboratories, Inc.','Autocell Laboratories, Inc.174 Concord StreetSuite 310Peterborough, New Hampshire 03458United States',1),('00:0C:B5','Premier Technolgies, Inc','Premier Technolgies, IncPo Box 159One Premier DrLong Lake Mn 55356United States',1),('00:0C:B6','Nanjing Seu Mobile & Internet Technology Co.,ltd','Nanjing Seu Mobile & Internet Technology Co.,ltd5th Floor,building 5,changjianghou Street No.6Nanjing Jiangsu 210018China',1),('00:0C:B7','Nanjing Huazhuo Electronics Co., Ltd.','Nanjing Huazhuo Electronics Co., Ltd.No.77 Gaohu RoadJiangning Economic & Technology DevelopmNanjing Jiangsu 211100China',1),('00:0C:B8','Medion Ag','Medion AgZ.h. Andreas ClausGnsemarkt 16-18Essen Nrw 45127Germany',1),('00:0C:B9','Lea','LeaBat La Fayette2 Place Des VosgesParis Rp 924051France',1),('00:0C:BA','Jamex','Jamex84 Sperry LaneLansing Ny 14882United States',1),('00:0C:BB','Iskraemeco','IskraemecoSavska Loka 4Kranj Gorenjska 4000Slovenia',1),('00:0C:BC','Iscutum','Iscutum#899-6 Ho-gye Dong, Dong-an GuAn-yang City Kyong-gi Do 431-080Korea, Republic Of',1),('00:0C:BD','Interface Masters, Inc','Interface Masters, Inc2381 Zanker Rd., Suite 130San Jose California 95131United States',1),('00:0C:BE','Innominate Security Technologies Ag','Innominate Security Technologies AgRudower Chaussee 1312489 BerlinGermany',1),('00:0C:BF','Holy Stone Ent. Co., Ltd.','Holy Stone Ent. Co., Ltd.1f, No.62, Sec.2, Huang Shan Rd.,Nei Hu Dist., Taipei, Taiwan, R.o.c.Taipei  114Taiwan, Republic Of China',1),('00:0C:C0','Genera Oy','Genera OyNiittylanpolku 16Box 16Helsinki  00621Finland',1),('00:0C:C1','Cooper Industries Inc.','Cooper Industries Inc.600 Travis, Suite 5800Houston Tx 77002United States',1),('00:0C:C2','Controlnet (india) Private Limited','Controlnet (india) Private LimitedL-44, Unit - IVerna Industrial EstateVerna, Salcete Goa 403 722India',1),('00:0C:C3','Bewan Systems','Bewan Systems16 Rue Du Moulin Des BruyresCourbevoie Hauts De Seine 92400France',1),('00:0C:C4','Tiptel Ag','Tiptel AgHalskestrasse 1Ratingen Nrw 40880Germany',1),('00:0C:C5','Nextlink Co., Ltd.','Nextlink Co., Ltd.C 605, Technopark #145 Yatop-dong,Seongnam-si Bundang-gu, Gyeonggi 463-760Korea, Republic Of',1),('00:0C:C6','Ka-ro Electronics Gmbh','Ka-ro Electronics GmbhPascalstrae 22Aachen Nw 52076Germany',1),('00:0C:C7','Intelligent Computer Solutions Inc.','Intelligent Computer Solutions Inc.9350 Eton St.Chatsworth Ca 91301United States',1),('00:0C:C8','Xytronix Research & Design, Inc.','Xytronix Research & Design, Inc.1488 East 2300 NorthNorth Logan Ut 84341-1627United States',1),('00:0C:C9','Ilwoo Data & Technology Co.,ltd','Ilwoo Data & Technology Co.,ltd1475-10,hwa Hyun Bld. 2nd Floor,Seocho-dong,seocho-gu,Seoul  137-071Korea, Republic Of',1),('00:0C:CA','Hitachi Global Storage Technologies','Hitachi Global Storage Technologies5600 Cottle Rd.San Jose Ca 95193United States',1),('00:0C:CB','Design Combus Ltd','Design Combus LtdHatanapaan Valtatie 34aTampere  Fin-33100Finland',1),('00:0C:CC','Aeroscout Ltd.','Aeroscout Ltd.3 Pekeris St.Park TamarRehovot  76701Israel',1),('00:0C:CD','Iec - Tc57','Iec - Tc573, Rue De VarembP.o. Box 131Geneva Ge 1211Switzerland',1),('00:0C:CE','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0C:CF','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0C:D0','Symetrix','Symetrix6408 216th St SwMountlake Terrace Wa 98043United States',1),('00:0C:D1','Sfom Technology Corp.','Sfom Technology Corp.No.18, Lane 32, Wufu 1st Rd., Luju ShianLuju Shiang Tauyuan County 338Taiwan, Republic Of China',1),('00:0C:D2','Schaffner Emv Ag','Schaffner Emv AgNordstrasse 1Luterbach  Ch-4542Switzerland',1),('00:0C:D3','Prettl Elektronik Radeberg Gmbh','Prettl Elektronik Radeberg GmbhRobert-bosch-str. 10Radeberg Saxony D-01454Germany',1),('00:0C:D4','Positron Public Safety Systems Inc.','Positron Public Safety Systems Inc.5101 BuchanMontreal Quebec H4p 2r9Canada',1),('00:0C:D5','Passave Inc.','Passave Inc.1557 Jasper Dr.Sunnyvale Ca 94087United States',1),('00:0C:D6','Partner Tech','Partner Tech10f, No.233-2,pao Chiao Road, Shin TienTaipei  231Taiwan, Republic Of China',1),('00:0C:D7','Nallatech Ltd','Nallatech LtdBoolean House1 Napier Park, CumbernauldGlasgow Scotland G68 0bhUnited Kingdom',1),('00:0C:D8','M. K. Juchheim Gmbh & Co','M. K. Juchheim Gmbh & CoMoltkestr. 13 - 31Fulda Hessen 36039Germany',1),('00:0C:D9','Itcare Co., Ltd','Itcare Co., Ltd408 Kt Seocho, 1001-1 Bangbae-dong,Seocho-kuSeoul  137-850Korea, Republic Of',1),('00:0C:DA','Freehand Systems, Inc.','Freehand Systems, Inc.95 First St.Suite 200Los Altos Ca 94022United States',1),('00:0C:DB','Foundry Networks','Foundry Networks2100 Gold StPo Box 649100San Jose Ca 95164-9100United States',1),('00:0C:DC','Becs Technology, Inc','Becs Technology, Inc9487 Dielman Rock Island Industrial DrivSt. Louis Mo 63132United States',1),('00:0C:DD','Aos Technologies Ag','Aos Technologies AgTaefernstrasse 20Baden - Daettwil Ag Ch-5405Switzerland',1),('00:0C:DE','Abb Stotz-kontakt Gmbh','Abb Stotz-kontakt GmbhEppelheimer Str. 82Heidelberg Baden-wrttemberg 69123Germany',1),('00:0C:DF','Pulnix America, Inc','Pulnix America, Inc1330 Orleans DriveSunnyvale Ca 94089United States',1),('00:0C:E0','Trek Diagnostics Inc.','Trek Diagnostics Inc.982 Keynote CircleSuite 6Cleveland Ohio 44131United States',1),('00:0C:E1','The Open Group','The Open GroupApex PlazaForbury RoadReading Berks Rg1 1axUnited Kingdom',1),('00:0C:E2','Rolls-royce','Rolls-royce105 N. Sandusky St.Mt. Vernon Ohio 43050United States',1),('00:0C:E3','Option International N.v.','Option International N.v.Kolonel Begaultlaan 45Leuven Brabant 3012Belgium',1),('00:0C:E4','Neurocom International, Inc.','Neurocom International, Inc.9570 Se Lawnfield RdClackamas Or 97015United States',1),('00:0C:E5','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:0C:E6','Meru Networks Inc','Meru Networks Inc1309 South Mary Avenue,Sunnyvale Ca 94087United States',1),('00:0C:E7','Mediatek Inc.','Mediatek Inc.1f, No. 13, Innovation Road 1,Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:0C:E8','Guangzhou Anjubao Co., Ltd','Guangzhou Anjubao Co., LtdHeiqiaotang Tangxia TianheGuangzhou Guangdong 510665China',1),('00:0C:E9','Bloomberg L.p.','Bloomberg L.p.731 Lexington AveNew York New York 10022United States',1),('00:0C:EA','Aphona Kommunikationssysteme','Aphona KommunikationssystemeEntwicklungs- Und VertriebsgmbhDeutschstrae 4Wien  1230Austria',1),('00:0C:EB','Cnmp Networks, Inc.','Cnmp Networks, Inc.1245 S. Winchester Blvd.Suite 208San Jose Ca 95128United States',1),('00:0C:EC','Spectracom Corp.','Spectracom Corp.95 Methodist Hill DriveSuite 500Rochester Ny 14623United States',1),('00:0C:ED','Real Digital Media','Real Digital Media485 North Keller RoadSuite 140Maitland Fl 32751United States',1),('00:0C:EE','Jp-embedded','Jp-embeddedBuen 21, Nr. DalbyBorup  4140Denmark',1),('00:0C:EF','Open Networks Engineering Ltd','Open Networks Engineering LtdClassic HouseRaynham RoadBishops Stortford Hertfordshire Cm23 5pdUnited Kingdom',1),('00:0C:F0','M & N Gmbh','M & N GmbhDieselstr 18Rosbach V.d.h. Hessen 61191Germany',1),('00:0C:F1','Intel Corporation','Intel CorporationMs: Jf3-4202111 Ne 25th AvenueHillsboro Or 97124United States',1),('00:0C:F2','Gamesa Elica','Gamesa ElicaPolgono Agustinos S/nPamplona Navarra 31013Spain',1),('00:0C:F3','Call Image Sa','Call Image Sa867 Route ImperialeBaillargues  34670France',1),('00:0C:F4','Akatsuki Electric Mfg.co.,ltd.','Akatsuki Electric Mfg.co.,ltd.593-1,aoji ChoKusatsu Shi Shiga 525-0041Japan',1),('00:0C:F5','Infoexpress','Infoexpress170 S. Whisman Road, Suite BMountain View Ca 94041United States',1),('00:0C:F6','Sitecom Europe Bv','Sitecom Europe BvSevillaweg 122Rotterdam Zh 3047 AlNetherlands',1),('00:0C:F7','Nortel Networks','Nortel Networks8200 Dixie Rd.Suite 100Brampton Ontario L6t 5p6Canada',1),('00:0C:F8','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100036 Cc 101Brampton Ontario L6t 5p6Canada',1),('00:0C:F9','Itt Flygt Ab','Itt Flygt AbPo Box 2058Industrigatan 50Kristianstad  291 02Sweden',1),('00:0C:FA','Digital Systems Corp','Digital Systems Corp3 North Main StreetPo Box 158Walkersville Maryland 21793United States',1),('00:0C:FB','Korea Network Systems','Korea Network Systems206  Jangyoungsil Bldg, 1688-5Shinil-dong, Taedeok-guTaejeon  306-230Korea, Republic Of',1),('00:0C:FC','S2io Technologies Corp','S2io Technologies Corp505 March RdSuite 120Ottawa Ontario K2k 2m5Canada',1),('00:0C:FD','Hyundai Imagequest Co.,ltd.','Hyundai Imagequest Co.,ltd.San 136-1, Ami-ri, Bubal-eubIchon-si Kyoung Ki-do 467-701Korea, Republic Of',1),('00:0C:FE','Grand Electronic Co., Ltd','Grand Electronic Co., LtdRoom 1710, Block B Lucky Tower, No.3 DonBeijing  100027China',1),('00:0C:FF','Mro-tek Limited','Mro-tek Limited14, 1st D Main Road,Ganga NagarBangalore Karnataka 560032India',1),('00:0D:00','Seaway Networks Inc.','Seaway Networks Inc.1 Chrysalis WayOttawa Ontario K2g 6p9Canada',1),('00:0D:01','P&e Microcomputer Systems, Inc.','P&e Microcomputer Systems, Inc.710 Commonwealth AveBoston Ma 02215United States',1),('00:0D:02','Nec Accesstechnica,ltd','Nec Accesstechnica,ltd800 ShimomataKakegawa Shizuoka 436-8501Japan',1),('00:0D:03','Matrics, Inc.','Matrics, Inc.8850 Stanford BlvdSuite 3000Columbia Md 21045United States',1),('00:0D:04','Foxboro Eckardt Development Gmbh','Foxboro Eckardt Development GmbhGlockenstrasse 52Stuttgart Baden-wrttemberg 70376Germany',1),('00:0D:05','Cybernet Manufacturing Inc.','Cybernet Manufacturing Inc.5001 Birch StreetNewport Beach Ca 92660United States',1),('00:0D:06','Compulogic Limited','Compulogic LimitedUnit W3, Mk Two Business CentreBarton RoadWater Eaton Milton Keynes Mk2 3huUnited Kingdom',1),('00:0D:07','Calrec Audio Ltd','Calrec Audio LtdNutclough MillHebden Bridge West Yorkshire Hx7 8ezUnited Kingdom',1),('00:0D:08','Abovecable, Inc.','Abovecable, Inc.8403 Colesville Road, #825Silver Spring Md 20910United States',1),('00:0D:09','Yuehua(zhuhai) Electronic Co. Ltd','Yuehua(zhuhai) Electronic Co. Ltd4rd Pingdong,nanping Science & TechnologZhuhai Guangdong 519070China',1),('00:0D:0A','Projectiondesign As','Projectiondesign AsHabornveien 53Gamle Fredrikstad N-1630Norway',1),('00:0D:0B','Buffalo Inc.','Buffalo Inc.Melco Hi-tech Center,Shibata Hondori 4-15 Minami-ku,Nagoya  457-8520Japan',1),('00:0D:0C','Mdi Security Systems','Mdi Security Systems9518 Ninth StreetRancho Cucamonga Ca 91730United States',1),('00:0D:0D','Itsupported, Llc','Itsupported, Llc4989 Peachtree ParkwaySte 200Norcross Ga 30092United States',1),('00:0D:0E','Inqnet Systems, Inc.','Inqnet Systems, Inc.321 Nkic Center48-84 Hongeun-dong, Seodaemun-kuSeoul  120-100Korea, Republic Of',1),('00:0D:0F','Finlux Ltd','Finlux LtdRadiomiehenkatu 3Turku  Fin-20321Finland',1),('00:0D:10','Embedtronics Oy','Embedtronics OyUnkarinpolku 20Kuopio  70820Finland',1),('00:0D:11','Dentsply - Gendex','Dentsply - Gendex901 West Oakton StreetDes Plaines Il 60018-1884United States',1),('00:0D:12','Axell Corporation','Axell CorporationAkihabara Udx South Wing 10f4-14-1 SotokandaChiyoda-ku Tokyo 101-8973Japan',1),('00:0D:13','Wilhelm Rutenbeck Gmbh&co.','Wilhelm Rutenbeck Gmbh&co.Niederworth 1-10Schalksmhle Nrw 58579Germany',1),('00:0D:14','Vtech Innovation Lp Dba Advanced American Telephones','Vtech Innovation Lp Dba Advanced American Telephones203-600 Parsippany RdParsippany Nj 07054United States',1),('00:0D:15','Voipac S.r.o.','Voipac S.r.o.Ul. Janka Krala 3Trencin  911 01Slovakia',1),('00:0D:16','Uhs Systems Pty Ltd','Uhs Systems Pty LtdPo Box 6264South Sydney Business HubAlexandria Nsw 2015Australia',1),('00:0D:17','Turbo Networks Co.ltd','Turbo Networks Co.ltd2f,no 1223, Chung Cheng Rd.Tao Yuan  330Taiwan, Republic Of China',1),('00:0D:18','Mega-trend Electronics Co., Ltd.','Mega-trend Electronics Co., Ltd.Tong Fu Yu Ind., Ku Keng Village, Guan LanShengzhen Guang Dong 518110China',1),('00:0D:19','Robe Show Lighting','Robe Show LightingHazovice 2090Roznov Pod Radhostem  756 61Czech Republic',1),('00:0D:1A','Mustek System Inc.','Mustek System Inc.No. 25, R&d Road, Science-based IndustriHsin-chu  300Taiwan, Republic Of China',1),('00:0D:1B','Kyoto Electronics Manufacturing Co., Ltd.','Kyoto Electronics Manufacturing Co., Ltd.56-2, Ninodan-cho, Shinden,Kisshoin, Minami-ku,Kyoto-city Kyoto Prefecture 601-8317Japan',1),('00:0D:1C','Amesys Defense','Amesys Defense1030 Av De La LauziereZac De Pichaury Ii Les Milles Bp 20 140Aix En Provence Cedex 03 13794France',1),('00:0D:1D','High-tek Harness Ent. Co., Ltd.','High-tek Harness Ent. Co., Ltd.4f-6, No18, Pu-ting Rd. Hsinchu, Taiwan4f, No16, Lane50, Sec3, Nan-kang Rd, NanHsinchu  300Taiwan, Republic Of China',1),('00:0D:1E','Control Techniques','Control TechniquesThe GroPool RoadNewtown Powys Sy16 3beUnited Kingdom',1),('00:0D:1F','Av Digital','Av DigitalPottendorfer Strasse 25-27/4/1/1Wien  1120Austria',1),('00:0D:20','Asahikasei Technosystem Co.,ltd.','Asahikasei Technosystem Co.,ltd.Kanda Jinbocho 1-10523-7,nishishinjuku 1-chomeChiyoda-ku Tokyo 101-8101Japan',1),('00:0D:21','Wiscore Inc.','Wiscore Inc.6f, No. 180, Sec. 2, Duenhua S. Rd,Taipei  106Taiwan, Republic Of China',1),('00:0D:22','Unitronics Ltd','Unitronics LtdUnitronics BuildingAirport City, P.o.b 300Ben Gurion Airport  70100Israel',1),('00:0D:23','Smart Solution, Inc','Smart Solution, Inc465 West Lawndale #bSalt Lake City Ut 84115United States',1),('00:0D:24','Sentec E&e Co., Ltd.','Sentec E&e Co., Ltd.No. 32. Gong5 Rd.Lungtan Taoyuan 325Taiwan, Republic Of China',1),('00:0D:25','Sanden Corporation','Sanden Corporation20 Kotobuki-choIsesaki-shi Gunma 372-8502Japan',1),('00:0D:26','Primagraphics Limited','Primagraphics LimitedCambridge House, No.2 Focus FourFourth AvenueLetchworth Garden City Hertfordshire Sg6 2tuUnited Kingdom',1),('00:0D:27','Microplex Printware Ag','Microplex Printware AgPanzerstrae 5Varel Niedersachsen 26316Germany',1),('00:0D:28','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:29','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:2A','Scanmatic As','Scanmatic AsKilsundStaub  4920Norway',1),('00:0D:2B','Racal Instruments','Racal Instruments4 Goodyear StreetIrvine Ca 92618United States',1),('00:0D:2C','Patapsco Designs Ltd','Patapsco Designs LtdThe Passfield OakPassfieldNr Liphook Hampshire Gu30 7rlUnited Kingdom',1),('00:0D:2D','Nct Deutschland Gmbh','Nct Deutschland GmbhWildenbruchstr. 15Jena Thringen 07745Germany',1),('00:0D:2E','Matsushita Avionics Systems Corporation','Matsushita Avionics Systems Corporation26200 Enterprise WayLake Forest Ca 92630United States',1),('00:0D:2F','Ain Comm.tech.co., Ltd','Ain Comm.tech.co., Ltd4f, No.76, Sec2 Mintzu RdJung-li City  320Taiwan, Republic Of China',1),('00:0D:30','Icefyre Semiconductor','Icefyre SemiconductorSuite 300411 Leggett DriveKanata Ontario K2k 3c9Canada',1),('00:0D:31','Compellent Technologies, Inc.','Compellent Technologies, Inc.7625 Smetana LaneEden Prairie Minnesota 55344United States',1),('00:0D:32','Dispensesource, Inc.','Dispensesource, Inc.29801 Santa Margarita ParkwayRancho Santa Margarita Ca 92688United States',1),('00:0D:33','Prediwave Corp.','Prediwave Corp.48431 Milmont DriveFremont Ca 94538United States',1),('00:0D:34','Shell International Exploration And Production, Inc.','Shell International Exploration And Production, Inc.Btc-gasmerPo Box 481Houston Tx 77001United States',1),('00:0D:35','Pac International Ltd','Pac International Ltd1 Park Gate CloseBredburyStockport Cheshire Sk6 2szUnited Kingdom',1),('00:0D:36','Wu Han Routon Electronic Co., Ltd','Wu Han Routon Electronic Co., LtdMiao Shan District, East Lake Hi-techDevelopment ParkWuhan Hubei 430223China',1),('00:0D:37','Wiplug','WiplugRua  Dr. Agostinho GoulaoBairro: CorreasPetropolis Rio Janeiro 25730050Brazil',1),('00:0D:38','Nissin Inc.','Nissin Inc.10-7 Kamei-choTakarazuka Hyogo 665-0047Japan',1),('00:0D:39','Network Electronics','Network ElectronicsBox 1020Sandefjord Sandefjord N3204Norway',1),('00:0D:3A','Microsoft Corp.','Microsoft Corp.One Microsoft WayRedmond Wa. 98052United States',1),('00:0D:3B','Microelectronics Technology Inc.','Microelectronics Technology Inc.No1, Innovation Road IiHsinchu Science-based Industrial Park300Taiwan, Republic Of China',1),('00:0D:3C','I.tech Dynamic Ltd','I.tech Dynamic LtdRoom 1112, Metroplaza Tower 2, 223 Hing852Hong Kong',1),('00:0D:3D','Hammerhead Systems, Inc.','Hammerhead Systems, Inc.640 Clyde CourtMountain View California 94043United States',1),('00:0D:3E','Aplux Communications Ltd.','Aplux Communications Ltd.10f, No. 166, Dah-yeh Rd., PeitouTaipei  112Taiwan, Republic Of China',1),('00:0D:3F','Vti Instruments Corporation','Vti Instruments Corporation5425 Warner Road, Suite 13Valley View Oh 44125United States',1),('00:0D:40','Verint Loronix Video Solutions','Verint Loronix Video Solutions12526 High Bluff Dr. #170San Diego Ca 92130United States',1),('00:0D:41','Siemens Ag Icm Mp Uc Rd It Klf1','Siemens Ag Icm Mp Uc Rd It Klf1Suedstrasse 9Kamp-lintfort Nrw 47475Germany',1),('00:0D:42','Newbest Development Limited','Newbest Development Limited3/f  Unit 311-312No.1 Science Park East AvenueShatin  NtHong Kong',1),('00:0D:43','Drs Tactical Systems Inc.','Drs Tactical Systems Inc.3520 U.s. Highway 1Palm Bay Fl 32905United States',1),('00:0D:44','Audio Bu - Logitech','Audio Bu - Logitech1499 Se Tech Center PlaceSuite 350Vancouver Wa 98683United States',1),('00:0D:45','Tottori Sanyo Electric Co., Ltd.','Tottori Sanyo Electric Co., Ltd.3-201, Minami YoshikataTottori City Tottori 680-8634Japan',1),('00:0D:46','Parker Ssd Drives','Parker Ssd Drives9225 Forsyth Park DriveCharlotte Nc 28273-3884United States',1),('00:0D:47','Collex','Collex13f-3,no.142,sec.1,huamei W,st.,shi ChiuTaichung  403Taiwan, Republic Of China',1),('00:0D:48','Aewin Technologies Co., Ltd.','Aewin Technologies Co., Ltd.7f, No. 2, Lane 47, Sec. 3, Nan-gang Rd.Taipei  115Taiwan, Republic Of China',1),('00:0D:49','Triton Systems Of Delaware, Inc.','Triton Systems Of Delaware, Inc.522 E. Railroad St.Long Beach Ms 39560United States',1),('00:0D:4A','Steag Eta-optik','Steag Eta-optikBorsigstrasse 78.-80Heinsberg  52525Germany',1),('00:0D:4B','Roku, Llc','Roku, Llc399 Sherman Ave. #12Palo Alto Ca 94306United States',1),('00:0D:4C','Outline Electronics Ltd.','Outline Electronics Ltd.7/f Benson Tower74 Hung To RoadKwun Tong KowloonHong Kong',1),('00:0D:4D','Ninelanes','Ninelanes#405 4f Diplomatic CenterSeocho-gu, Seocho-dongSeoul  1376-1Korea, Republic Of',1),('00:0D:4E','Ndr Co.,ltd.','Ndr Co.,ltd.Sumitomo Seimei Minatomachi Mt Bldg1-18-2 Minamihorie Nishi-kuOsak Kinki 550-0015Japan',1),('00:0D:4F','Kenwood Corporation','Kenwood Corporation2967-3, Ishikawa-machiHachioji-shi Tokyo 192-8525Japan',1),('00:0D:50','Galazar Networks','Galazar Networks35 Fitzgerald AveOttawa On K2h 1e6Canada',1),('00:0D:51','Divr Systems, Inc.','Divr Systems, Inc.2161 Saturn Ct.Bakersfield Ca 93308United States',1),('00:0D:52','Comart System','Comart SystemNo. 211, Ace Techno Tower Iii, 197-48Gu-ro Dong, Gu-ro Gu, Seoul, KoreaSeoul  152-050Korea, Republic Of',1),('00:0D:53','Beijing 5w Communication Corp.','Beijing 5w Communication Corp.No.4,zhong-guan-cun South 4 Street,Beijing  100080China',1),('00:0D:54','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:0D:55','Sanycom Technology Co.,ltd','Sanycom Technology Co.,ltd6f,beijing Capital Times Square,88# XichBeijing  100031China',1),('00:0D:56','Dell Pcba Test','Dell Pcba TestOne Dell WayRr5 Ms-8545Round Rock Texas 78682United States',1),('00:0D:57','Fujitsu I-network Systems Limited.','Fujitsu I-network Systems Limited.1-403 Kosugi-cho Nakahara-kuKawasaki Kanagawa 211-0063Japan',1),('00:0D:58','Private','',1),('00:0D:59','Amity Systems, Inc.','Amity Systems, Inc.888 Tasman DriveMilpitas Ca 95035United States',1),('00:0D:5A','Tiesse Spa','Tiesse SpaVia AstiZona Industrial San BernardoIvrea To 10015Italy',1),('00:0D:5B','Smart Empire Investments Limited','Smart Empire Investments LimitedSuite 2001-2006,level 20 Landmark NorthXin Jie Hong Kong 00852China',1),('00:0D:5C','Robert Bosch Gmbh, Vt-atmo','Robert Bosch Gmbh, Vt-atmoWernerstrasse 51Stuttgart Bw 70469Germany',1),('00:0D:5D','Raritan Computer, Inc','Raritan Computer, Inc400 Cottontail LaneSomerset Nj 08873United States',1),('00:0D:5E','Nec Customtechnica, Ltd.','Nec Customtechnica, Ltd.6-80, Shimohanazawa 2-chomeYonezawa-shi Yamagata 992-8520Japan',1),('00:0D:5F','Minds Inc','Minds Inc1919 Boul Lionel Bertrand#202Boisbriand Quebec J7h 1n8Canada',1),('00:0D:60','Ibm Corporation','Ibm Corporation3039 Cornwallis RoadDept Fcga, Bldg 660, Office F106Research Triangle Park Nc 27709United States',1),('00:0D:61','Giga-byte Technology Co., Ltd.','Giga-byte Technology Co., Ltd.No 6, Bau Chiang Road, Hsin-tienTaipei Hsien  9999Taiwan, Republic Of China',1),('00:0D:62','Funkwerk Dabendorf Gmbh','Funkwerk Dabendorf GmbhMaerkische StrasseDabendorf Brandenburg 15806Germany',1),('00:0D:63','Dent Instruments, Inc.','Dent Instruments, Inc.64 Nw Franklin AveBend Or 97701United States',1),('00:0D:64','Comag Handels Ag','Comag Handels AgZillenhardtstr.41Goeppingen Baden-wrttemberg 73037Germany',1),('00:0D:65','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:66','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:67','Belair Networks Inc.','Belair Networks Inc.603 March RoadKanata Ontario K2k 2m5Canada',1),('00:0D:68','Vinci Systems, Inc.','Vinci Systems, Inc.8330 Boone BoulevardSuite 500Vienna Va 22182United States',1),('00:0D:69','Tmt&d Corporation','Tmt&d Corporation2-24-1Harumi-choFuchu-si Tokyo 183-0057Japan',1),('00:0D:6A','Redwood Technologies Ltd','Redwood Technologies LtdAmber HouseMarket StreetBracknell Berkshire Rg12 1jbUnited Kingdom',1),('00:0D:6B','Mita-teknik A/s','Mita-teknik A/sHaandvaerkervej 1Roedkaersbro Dk Dk-8840Denmark',1),('00:0D:6C','M-audio','M-audio45 E St Joseph St.Arcadia Ca 91006United States',1),('00:0D:6D','K-tech Devices Corp.','K-tech Devices Corp.14016-30Nakaminowa Minowamachi Kamiina Nagano 399-4601Japan',1),('00:0D:6E','K-patents Oy','K-patents OyP.o. Box 77Elannontie 5Vantaa Fi 01511Finland',1),('00:0D:6F','Ember Corporation','Ember Corporation343 Congress St5th FloorBoston Ma 02210United States',1),('00:0D:70','Datamax Corporation','Datamax Corporation4501 Parkway Commerce BlvdOrlando Fl 32808United States',1),('00:0D:71','Boca Systems','Boca Systems1065 S. Rogers CircleBoca Raton Fl 33487United States',1),('00:0D:72','2wire, Inc','2wire, Inc1704 Automation ParkwaySan Jose Ca 95131United States',1),('00:0D:73','Technical Support, Inc.','Technical Support, Inc.11253 John Galt BlvdOmaha Nebraska 68137United States',1),('00:0D:74','Sand Network Systems, Inc.','Sand Network Systems, Inc.434 Payran StreetPetaluma Ca 94952United States',1),('00:0D:75','Kobian Pte Ltd - Taiwan Branch','Kobian Pte Ltd - Taiwan Branch2f, No.580, Rueikuang Rd.,nei Hu,taipei,Taipei Nei Hu 114Taiwan, Republic Of China',1),('00:0D:76','Hokuto Denshi Co,. Ltd.','Hokuto Denshi Co,. Ltd.3-7 Odori Nishi 16-chome ChuokuSapporo Hokkaido 060-0042Japan',1),('00:0D:77','Falconstor Software','Falconstor Software125 Baylis RdMelville Ny 11747United States',1),('00:0D:78','Engineering & Security','Engineering & SecurityMartiri Della Libert 32/4Genova  16155Italy',1),('00:0D:79','Dynamic Solutions Co,.ltd.','Dynamic Solutions Co,.ltd.17-8 Nihonbashi Hakozaki-choChuo-ku Tokyo 103-0015Japan',1),('00:0D:7A','Digatto Asia Pacific Pte Ltd','Digatto Asia Pacific Pte Ltd190 Mddle Road, #19-05 Fortune Center188979Singapore',1),('00:0D:7B','Consensys Computers Inc.','Consensys Computers Inc.215 Shields Ct.Markham On L3r 8v2Canada',1),('00:0D:7C','Codian Ltd','Codian Ltd14 Waterside DriveLangley Slough Sl3 6ezUnited Kingdom',1),('00:0D:7D','Afco Systems','Afco Systems200 Finn CourtFarmingdale Ny 11735United States',1),('00:0D:7E','Axiowave Networks, Inc.','Axiowave Networks, Inc.200 Nickerson RoadMarlborough Ma 01752United States',1),('00:0D:7F','Midas  Communication Technologies Pte Ltd ( Foreign Branch)','Midas  Communication Technologies Pte Ltd ( Foreign Branch)04-12, Phase Z.ro Technoprenuer Park#151, North Buona Vista RoadSingapore  139 347Singapore',1),('00:0D:80','Online Development Inc','Online Development Inc7209 Chapman HwyKnoxville Tn 37920United States',1),('00:0D:81','Pepperl+fuchs Gmbh','Pepperl+fuchs GmbhLilienthalstrae 200Mannheim  68307Germany',1),('00:0D:82','Phs Srl','Phs SrlVia Pal, 17Arcugnano Vicenza 36057Italy',1),('00:0D:83','Sanmina-sci Hungary  Ltd.','Sanmina-sci Hungary  Ltd.Kota Jozsef U. 2.Tatabanya Komarom-esztergom 2800Hungary',1),('00:0D:84','Makus Inc.','Makus Inc.4f Daedo Bldg., 748-14 Yeoksam-dongKangnam-gu Seoul 135-080Korea, Republic Of',1),('00:0D:85','Tapwave, Inc.','Tapwave, Inc.1901 Landings DriveBuilding GMountain View Ca 94043United States',1),('00:0D:86','Huber + Suhner Ag','Huber + Suhner AgDegersheimerstrasse 149100 HerisauSwitzerland',1),('00:0D:87','Elitegroup Computer System Co. (ecs)','Elitegroup Computer System Co. (ecs)No.22, Alley 38, Lane 91, Sec. 1, Nei HuTaipei  114Taiwan, Republic Of China',1),('00:0D:88','D-link Corporation','D-link CorporationNo.8, Li-hsing 7 Road, Science-based IndHsinchu  30077Taiwan, Republic Of China',1),('00:0D:89','Bils Technology Inc','Bils Technology Inc508 S River Oaks DriveIndialantic Fl 32903United States',1),('00:0D:8A','Winners Electronics Co., Ltd.','Winners Electronics Co., Ltd.#340-5,wonchun-dong,paldal-guSuwon-city Kyungki-do 442-823Korea, Republic Of',1),('00:0D:8B','T&d Corporation','T&d Corporation5652-169 SasagaMatsumoto Nagano 399-0033Japan',1),('00:0D:8C','Shanghai Wedone Digital Ltd. Co.','Shanghai Wedone Digital Ltd. Co.893-899 Huashan Road,Shanghai  200031China',1),('00:0D:8D','Prolinx Communication Gateways, Inc.','Prolinx Communication Gateways, Inc.1675 Chester Ave.Fourth FloorBakersfield Ca 93301United States',1),('00:0D:8E','Koden Electronics Co., Ltd.','Koden Electronics Co., Ltd.5278 UenoharaUenohara-shiYamanashi-ken 409-0112Japan',1),('00:0D:8F','King Tsushin Kogyo Co., Ltd.','King Tsushin Kogyo Co., Ltd.2-6-6 NogeSetagaya-ku Tokyo 158-0092Japan',1),('00:0D:90','Factum Electronics Ab','Factum Electronics AbTeknikringen 1hLinkping stergtland 583 30Sweden',1),('00:0D:91','Eclipse (hq Espana) S.l.','Eclipse (hq Espana) S.l.Cc De NegociosOfficina No. 46. C.n. 340, Km 175Puerto De Banus Marbella 29660Spain',1),('00:0D:92','Arima Communication Corporation','Arima Communication Corporation16, Lane 658, Ying-tao RoadYingko Taipei County 23943Taiwan, Republic Of China',1),('00:0D:93','Apple Computer','Apple Computer1 Infinite LoopCupertino Ca 95014United States',1),('00:0D:94','Afar Communications,inc','Afar Communications,inc81 David Love PlaceSuite ASanta Barbara Ca 93117United States',1),('00:0D:95','Opti-cell, Inc.','Opti-cell, Inc.100 High Tower Blvd.,  Suite 301Pittsburgh Pa 15205United States',1),('00:0D:96','Vtera Technology Inc.','Vtera Technology Inc.No 34, Industrial East. 4th Rd.Hsinchu  300Taiwan, Republic Of China',1),('00:0D:97','Tropos Networks, Inc.','Tropos Networks, Inc.1710 S. Amphlett Blvd,  Suite 304San Mateo Ca 94402United States',1),('00:0D:98','S.w.a.c. Schmitt-walter Automation Consult Gmbh','S.w.a.c. Schmitt-walter Automation Consult GmbhOedenpullach 1Oberhaching Bavaria 82041Germany',1),('00:0D:99','Orbital Sciences Corp.; Launch Systems Group','Orbital Sciences Corp.; Launch Systems Group3380 S. Price Rd.Chandler, Az 85248United States',1),('00:0D:9A','Infotec Ltd','Infotec LtdThe MaltingsTamworth RoadAshby-de-la-zouch Leicestershire Le65 2psUnited Kingdom',1),('00:0D:9B','Heraeus Electro-nite International N.v.','Heraeus Electro-nite International N.v.Centrum Zuid 1105Houthalen  3530Belgium',1),('00:0D:9C','Elan Gmbh & Co Kg','Elan Gmbh & Co KgIm Ostpark 2Wettenberg Hessen 35435Germany',1),('00:0D:9D','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMx070405Houston Tx 77070United States',1),('00:0D:9E','Tokuden Ohizumi Seisakusyo Co.,ltd.','Tokuden Ohizumi Seisakusyo Co.,ltd.Yoshida 1221Ouragun Ohizumi Gunma 370-0523Japan',1),('00:0D:9F','Rf Micro Devices','Rf Micro Devices2191 Zanker RoadSan Jose Ca 95131United States',1),('00:0D:A0','Nedap N.v.','Nedap N.v.P.o.box 103P.o.box 6Groenlo Gld 7141 AcNetherlands',1),('00:0D:A1','Mirae Its Co.,ltd.','Mirae Its Co.,ltd.7f, Changhyun B/d,960-1,hogye1dongAnyang Kyongigido 431-840Korea, Republic Of',1),('00:0D:A2','Infrant Technologies, Inc.','Infrant Technologies, Inc.48820 Kato RoadSte 110bFremont Ca 94538United States',1),('00:0D:A3','Emerging Technologies Limited','Emerging Technologies LimitedWongs Industrial Centre, 180 Wai Yip StKwun Tong, KowloonNilHong Kong',1),('00:0D:A4','Dosch & Amand Systems Ag','Dosch & Amand Systems AgScheinerstrasse 9Munich Bavaria 81679Germany',1),('00:0D:A5','Fabric7 Systems, Inc','Fabric7 Systems, Inc1300 Crittenden LaneSuite 302Mountain View Ca 94043United States',1),('00:0D:A6','Universal Switching Corporation','Universal Switching Corporation7145 Woodley AveVan Nuys Ca 91406United States',1),('00:0D:A7','Private','',1),('00:0D:A8','Teletronics Technology Corporation','Teletronics Technology Corporation2525 Pearl Buck RoadBristol Pennsylvania 19007United States',1),('00:0D:A9','T.e.a.m. S.l.','T.e.a.m. S.l.Parque Tecnologico Edificio 108Zamudio Bizkaia 48170Spain',1),('00:0D:AA','S.a.tehnology Co.,ltd.','S.a.tehnology Co.,ltd.80-12 Yangjae 1 DongSeocho GuSeoul South Korea 137-890Korea, Republic Of',1),('00:0D:AB','Parker Hannifin Gmbh Electromechanical Division Europe','Parker Hannifin Gmbh Electromechanical Division EuropeRobert-bosch-strasse 22Offenburg Baden Wrttemberg 77656Germany',1),('00:0D:AC','Japan Cbm Corporation','Japan Cbm Corporation5-68-10 Nakano,Nakano-ku Tokyo 164-0001Japan',1),('00:0D:AD','Dataprobe Inc','Dataprobe Inc1 Pearl Ct Unit BAllendale Nj 07401United States',1),('00:0D:AE','Samsung Heavy Industries Co., Ltd.','Samsung Heavy Industries Co., Ltd.493, Banweol-ri, Taean-eupHwaseong-city Kyeonggi-do 445-973Korea, Republic Of',1),('00:0D:AF','Plexus Corp (uk) Ltd','Plexus Corp (uk) LtdPinnacle HillKelso Roxburghshire Td5 8xxUnited Kingdom',1),('00:0D:B0','Olym-tech Co.,ltd.','Olym-tech Co.,ltd.Room 401/402,no.1,songling Road,hi-techShenzhen Guangdong 518031China',1),('00:0D:B1','Japan Network Service Co., Ltd.','Japan Network Service Co., Ltd.Matoba Bldg. 6f,3-7-7 IrifuneChuo-ku Tokyo 104-0042Japan',1),('00:0D:B2','Ammasso, Inc.','Ammasso, Inc.345 Summer StreetBoston Ma 02210United States',1),('00:0D:B3','Sdo Communication Corperation','Sdo Communication Corperation6f, No.112, Shin Min StreetChung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:0D:B4','Netasq','Netasq3 Rue ArchimedeVilleneuve Dascq Nord 59650France',1),('00:0D:B5','Globalsat Technology Corporation','Globalsat Technology CorporationFar East Century ParkChung Ho CityTaipei Hsien  235Taiwan, Republic Of China',1),('00:0D:B6','Teknovus, Inc.','Teknovus, Inc.1363 Redwood WayPetaluma Ca 94954United States',1),('00:0D:B7','Sanko Electric Co,.ltd','Sanko Electric Co,.ltd7-23 Tamanoi-cho Atsuta-kuNagoya-shi Aichi 456-0025Japan',1),('00:0D:B8','Schiller Ag','Schiller AgAltgasse 68Baar Zug 6300Switzerland',1),('00:0D:B9','Pc Engines Gmbh','Pc Engines GmbhGermaniastrasse 688006 ZurichSwitzerland',1),('00:0D:BA','Oc Document Technologies Gmbh','Oc Document Technologies GmbhMax-stromeyer-str. 116Konstanz  78467Germany',1),('00:0D:BB','Nippon Dentsu Co.,ltd.','Nippon Dentsu Co.,ltd.2-21-1,isojiMinato-kuOsaka  552-0003Japan',1),('00:0D:BC','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:BD','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:BE','Bel Fuse Europe Ltd.,uk','Bel Fuse Europe Ltd.,uk45/46 Riverside 2Medway City EstateRochester Kent Me2 4dpUnited Kingdom',1),('00:0D:BF','Tektone Sound & Signal Mfg., Inc.','Tektone Sound & Signal Mfg., Inc.277 Industrial Park Rd.Franklin Nc 28734United States',1),('00:0D:C0','Spagat As','Spagat AsTonne Hutifeldtpl. 2Halden Ostfold 1767Norway',1),('00:0D:C1','Safeweb Inc','Safeweb Inc2200 Powell St. Ste 590Emeryville Ca 94608United States',1),('00:0D:C2','Private','',1),('00:0D:C3','First Communication, Inc.','First Communication, Inc.1f, No.36, Industry E. Rd. Iv.,Science-based Industrial ParkHsinchuTaiwan, Republic Of China',1),('00:0D:C4','Emcore Corporation','Emcore Corporation1600 Eubank Blvd, SeAlbuquerque New Mexico 87123United States',1),('00:0D:C5','Echostar International Corporation','Echostar International CorporationSchuilenburglaan 5aAlmelo Overijssel 7604bjNetherlands',1),('00:0D:C6','Digirose Technology Co., Ltd.','Digirose Technology Co., Ltd.No. 1, Alley 20, Lane 26 Rueiguang Road,Taipei  114Taiwan, Republic Of China',1),('00:0D:C7','Cosmic Engineering Inc.','Cosmic Engineering Inc.1-3-5, NishihirayamaHino-shi Tokyo 191-0055Japan',1),('00:0D:C8','Airmagnet, Inc','Airmagnet, Inc830 E. Arques AvenueSunnyvale Ca 94085United States',1),('00:0D:C9','Thales Elektronik Systeme Gmbh','Thales Elektronik Systeme GmbhFritz-ludwig-str. 1Koblenz  56070Germany',1),('00:0D:CA','Tait Electronics','Tait Electronics535 Wairakei RdPo Box 1645Christchurch Canterbury 8005New Zealand',1),('00:0D:CB','Petcomkorea Co., Ltd.','Petcomkorea Co., Ltd.5f,689-47,geumjeong-dong,gunpo-si,kyunggKyunggi-do Gunpo-si 435-050Korea, Republic Of',1),('00:0D:CC','Neosmart Corp.','Neosmart Corp.Yoon-b/d 4f, 475-31, Bangbae 2-dongSeoul Seocho-gu 147-819Korea, Republic Of',1),('00:0D:CD','Groupe Txcom','Groupe TxcomZi Du Petit Clamart10 Avenue DescartesLe Plessis Robinson Hauts-de-seine 92350France',1),('00:0D:CE','Dynavac Technology Pte Ltd','Dynavac Technology Pte Ltd30 Tuas Avenue 9639183Singapore',1),('00:0D:CF','Cidra Corp.','Cidra Corp.50 Barns Park NorthWallingford Ct 06492United States',1),('00:0D:D0','Tetratec Instruments Gmbh','Tetratec Instruments GmbhGewerbestrasse 8Steinenbronn Bw 71144Germany',1),('00:0D:D1','Stryker Corporation','Stryker Corporation4100 E MilhamKalamazoo Mi 49001United States',1),('00:0D:D2','Simrad Optronics Asa','Simrad Optronics AsaEnsjveien 23bPo Box 6114 Etterstad No-0602 OsloNorway',1),('00:0D:D3','Samwoo Telecommunication Co.,ltd.','Samwoo Telecommunication Co.,ltd.',1),('00:0D:D4','Symantec Corporation','Symantec Corporation275 2nd AveWaltham Ma 02541United States',1),('00:0D:D5','Orite Technology Co.,ltd','Orite Technology Co.,ltd4f-8,no 80,guangfu Rd.sec 2,sanchungTaipei County  241Taiwan, Republic Of China',1),('00:0D:D6','Iti    Ltd','Iti    LtdR&d,iti Bangalore ComplexF-86 Bldg.Dooravani Nagar, Bangalore Karnataka State 560016India',1),('00:0D:D7','Bright','Bright1-12-44 AobadaiKashiwa-shi Chiba-ken 277-0055Japan',1),('00:0D:D8','Bbn','Bbn7f-3,no.186, Jian Yi Rd ., Chung Ho CityTaipei  235Taiwan, Republic Of China',1),('00:0D:D9','Anton Paar Gmbh','Anton Paar GmbhAnton-paar-strasse 20Graz  8054Austria',1),('00:0D:DA','Allied Telesis K.k.','Allied Telesis K.k.Piazza Tirana N. 24/4 BMilano  20147Italy',1),('00:0D:DB','Airwave Technologies Inc.','Airwave Technologies Inc.3f,no.9,industry E. 9th RoadScience-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:0D:DC','Vac','Vac20f, N0. 456, Sec. 4, Hsin Yi Rd.,Taipei  110Taiwan, Republic Of China',1),('00:0D:DD','Proflo Telra Elektronk Sanay Ve Tcaret A..','Proflo Telra Elektronk Sanay Ve Tcaret A..Cemal Sahr Sokak No:26-28Mecdyekystanbul Turkey 34255Turkey',1),('00:0D:DE','Joyteck Co., Ltd.','Joyteck Co., Ltd.19f, No.4, Sec. 3, Min Chuan East Rd.Taipei  105Taiwan, Republic Of China',1),('00:0D:DF','Japan Image & Network Inc.','Japan Image & Network Inc.5-29-12 ShibaMinato-ku Tokyo 108-0014Japan',1),('00:0D:E0','Icpdas Co.,ltd','Icpdas Co.,ltdNo. 111, Kuang-fu N. Rd., Hsin-chu InduHsinchu  303Taiwan, Republic Of China',1),('00:0D:E1','Control Products, Inc.','Control Products, Inc.1724 Lake Drive WestChanhassen Mn 55317United States',1),('00:0D:E2','Cmz Sistemi Elettronici','Cmz Sistemi ElettroniciVia Dellartiginato, 21Vascon Di Carbonera Treviso 31050Italy',1),('00:0D:E3','At Sweden Ab','At Sweden AbP.o. Box 1166Isafjordsgatan 30bKista Stockholm Se-164 26Sweden',1),('00:0D:E4','Diginics, Inc.','Diginics, Inc.178-7Poi-dongKangnam-gu Seoul 135-961Korea, Republic Of',1),('00:0D:E5','Samsung Thales','Samsung Thales259 Gongdan-dongGumi-city Gyeongsangbuk-do 730-904Korea, Republic Of',1),('00:0D:E6','Youngbo Engineering Co.,ltd','Youngbo Engineering Co.,ltdMt.22, Jaeunga-ri, Jigsan-eup,Cheonan-shi Chungcheongnam-do #330-810Korea, Republic Of',1),('00:0D:E7','Snap-on Oem Group','Snap-on Oem Group2333 East Walton Blvd.Auburn Hills Mi 48326United States',1),('00:0D:E8','Nasaco Electronics Pte. Ltd','Nasaco Electronics Pte. LtdLevel 4, Nasaco Tech Centre49, Changi South Avenue 2486056Singapore',1),('00:0D:E9','Napatech Aps','Napatech ApsRundofrbivej 271, 1Naerum  2850Denmark',1),('00:0D:EA','Kingtel Telecommunication Corp.','Kingtel Telecommunication Corp.147 Kang Ning St.Hsi Chih City Taipei Hsien 221Taiwan, Republic Of China',1),('00:0D:EB','Compxs Limited','Compxs LimitedRobert Denholm HouseNutfieldRedhill Surrey Rh1 4hwUnited Kingdom',1),('00:0D:EC','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:ED','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0D:EE','Andrew Rf Power Amplifier Group','Andrew Rf Power Amplifier Group40 Technology DriveWarren Nj 07059United States',1),('00:0D:EF','Soc. Coop. Bilanciai','Soc. Coop. BilanciaiVia S.ferrari 16Campogalliano Modena 41011Italy',1),('00:0D:F0','Qcom Technology Inc.','Qcom Technology Inc.7f., No 178, Ming Chuan E. Rd., Sec. 3,Taipei  105Taiwan, Republic Of China',1),('00:0D:F1','Ionix Inc.','Ionix Inc.Ssangyong It Twin Tower 604, 442-17, Sangdaewon-dong, Jungwon-gu,Seongnam-si Gyeonggi-do 462-120Korea, Republic Of',1),('00:0D:F2','Private','',1),('00:0D:F3','Asmax Solutions','Asmax SolutionsTatarska 5Cracow  30-103Poland',1),('00:0D:F4','Watertek Co.','Watertek Co.Room 1006,haitai Building,north Si HuanZhong Road,haidian DistrictBeijing  100083China',1),('00:0D:F5','Teletronics International Inc.','Teletronics International Inc.2 Choke Cherry RoadSuite #101Rockville Md 20850United States',1),('00:0D:F6','Technology Thesaurus Corp.','Technology Thesaurus Corp.No. 6, East 4th St. KepzKaohsiung  806Taiwan, Republic Of China',1),('00:0D:F7','Space Dynamics Lab','Space Dynamics Lab1695 N. Research Park WayNorth Logan Ut 84341United States',1),('00:0D:F8','Orga Kartensysteme Gmbh','Orga Kartensysteme GmbhKonrad-zuse-ring 1Flintbek Schleswig-holstein 24220Germany',1),('00:0D:F9','Nds Limited','Nds LimitedOne Heathrow Boulevard286 Bath RoadWest Drayton Middlesex Ub7 0dqUnited Kingdom',1),('00:0D:FA','Micro Control Systems Ltd.','Micro Control Systems Ltd.8-7 SakuraiSaku-shi Nagano 385-0056Japan',1),('00:0D:FB','Komax Ag','Komax AgIndustriestrasse 6Dierikon Lu 6036Switzerland',1),('00:0D:FC','Itfor Inc.','Itfor Inc.Ichibancho Tokyu Bidg.,21 Ichibanncyo,chiyoda-kuTokyo 102-0082Japan',1),('00:0D:FD','Huges Hi-tech Inc.,','Huges Hi-tech Inc.,7f, 188, Sec.2, Chung Hsing Road.Hsin Tien Taipei Hsien 231Taiwan, Republic Of China',1),('00:0D:FE','Hauppauge Computer Works, Inc.','Hauppauge Computer Works, Inc.91 Cabot CourtHauppauge New York 11788United States',1),('00:0D:FF','Chenming Mold Industry Corp.','Chenming Mold Industry Corp.2f No. 26, Lane 513, Rei Kuang Rd.Taipei  114Taiwan, Republic Of China',1),('00:0E:00','Atrie','Atrie10th Floor, 14, Lane 609, Sec. 5, Chung Hsin Rd., San Chung City,Taipei Hsien San Chung 241Taiwan, Republic Of China',1),('00:0E:01','Asip Technologies Inc.','Asip Technologies Inc.10f-2, No.322, Sec.1, Guangfu Rd.,Hsinchu  300Taiwan, Republic Of China',1),('00:0E:02','Advantech Amt Inc.','Advantech Amt Inc.657 Orly Ave.Dorval Quebec H9p 1g1Canada',1),('00:0E:03','Emulex','Emulex3333 Susan StreetCosta Mesa Ca 92626United States',1),('00:0E:04','Cma/microdialysis Ab','Cma/microdialysis AbDalvgen 10 / Box 2Solna  171 18Sweden',1),('00:0E:05','Wireless Matrix Corp.','Wireless Matrix Corp.Unit 1a-3751 North Fraser WayBurnaby Bc V5j 5g4Canada',1),('00:0E:06','Team Simoco Ltd','Team Simoco LtdField HouseUttoxeter Old RoadDerby Derbyshire De1 1nhUnited Kingdom',1),('00:0E:07','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88 LundSweden',1),('00:0E:08','Cisco Linksys Llc','Cisco Linksys Llc170 West Tasman Dr.San Jose Ca 95134United States',1),('00:0E:09','Shenzhen Coship Software Co.,ltd.','Shenzhen Coship Software Co.,ltd.7/f,block A,w2 Bldg,hi-tech Industrial Park,shenzhen,chinaShenzhen Guangdong 518057China',1),('00:0E:0A','Sakuma Design Office','Sakuma Design Office674-11Kuki-shi Saitama 346-0029Japan',1),('00:0E:0B','Netac Technology Co., Ltd.','Netac Technology Co., Ltd.6f, Incubator Building, China Academy Of Science &tech Development,No.1 High-tech South StreetShenzhen Guangdong 518057China',1),('00:0E:0C','Intel Corporation','Intel Corporation2111 Ne  25th AvenueMs:  Jf3-420Hillsboro Or 97124United States',1),('00:0E:0D','Hesch Schrder Gmbh','Hesch Schrder GmbhBoschstrasse 8Neustadt Niedersachsen 31535Germany',1),('00:0E:0E','Esa Elettronica S.p.a.','Esa Elettronica S.p.a.Via P. Masciadri 4/aMariano Comense Co 22066Italy',1),('00:0E:0F','Ermme','Ermme9 Rue LavoisierVert-le-petit  91710France',1),('00:0E:10','C-guys, Inc.','C-guys, Inc.Izumi Garden Wing 1f, 1-6-3Roppongi, Minato-kuTokyo  106-0032Japan',1),('00:0E:11','Bdt Bro- Und Datentechnik Gmbh & Co. Kg','Bdt Bro- Und Datentechnik Gmbh & Co. KgSaline 29Rottweil Baden-wrttemberg D-78628Germany',1),('00:0E:12','Adaptive Micro Systems Inc.','Adaptive Micro Systems Inc.7840 North 86th St.Milwaukee Wi 53224United States',1),('00:0E:13','Accu-sort Systems Inc.','Accu-sort Systems Inc.511 School House RoadTelford Pa 18969United States',1),('00:0E:14','Visionary Solutions, Inc.','Visionary Solutions, Inc.4193 Carpinteria AveSuite 11Carpinteria Ca 93013United States',1),('00:0E:15','Tadlys Ltd','Tadlys LtdIsraeli Shimon 3Rishon Lezyyon Israel 75654Israel',1),('00:0E:16','Southwing S.l.','Southwing S.l.C/avila, 48-503rd FloorBarcelona  08005Spain',1),('00:0E:17','Private','',1),('00:0E:18','Mya Technology','Mya Technology2100 Muirwood WaySan Jose Ca 95132United States',1),('00:0E:19','Logicacmg Pty Ltd','Logicacmg Pty Ltd17-19 Orion RoadLane Cove Nsw 2066Australia',1),('00:0E:1A','Jps Communications','Jps Communications5800 Departure DriveRaleigh Nc 27616United States',1),('00:0E:1B','Iav Gmbh','Iav GmbhCarnotstr. 1Berlin  10587Germany',1),('00:0E:1C','Hach Company','Hach Company5600 Lindbergh DriveLoveland Co 80538United States',1),('00:0E:1D','Arion Technology Inc.','Arion Technology Inc.1042-1, Hogye-dong, Arion Bldg.Dongan-guAn-yang City Gyeonggi-do 431-080Korea, Republic Of',1),('00:0E:1E','Netxen, Inc.','Netxen, Inc.3965 Freedom Circle, Fourth FloorSanta Clara Ca 95054United States',1),('00:0E:1F','Tcl Networks Equipment Co., Ltd.','Tcl Networks Equipment Co., Ltd.No.5 Industrial Road,shekouShenzhen Guangdong 518067China',1),('00:0E:20','Access Systems Americas, Inc.','Access Systems Americas, Inc.1188 East Arques AvenueSunnyvale Ca 94085United States',1),('00:0E:21','Mtu Friedrichshafen Gmbh','Mtu Friedrichshafen GmbhMaybachplatz 1Friedrichshafen Baden Wuertemberg 88040Germany',1),('00:0E:22','Private','',1),('00:0E:23','Incipient, Inc.','Incipient, Inc.230 Third Ave.4th FloorWaltham Ma 02451United States',1),('00:0E:24','Huwell Technology Inc.','Huwell Technology Inc.1f 82-21, Majin BuildingNonhyun-dong, Gangnam-guSeoul  135-010Korea, Republic Of',1),('00:0E:25','Hannae Technology Co., Ltd','Hannae Technology Co., Ltd4f, Hyunjin Bldg., #798-30, Yeoksam-dongKangnam-kuSeoul  135-080Korea, Republic Of',1),('00:0E:26','Gincom Technology Corp.','Gincom Technology Corp.15f., No. 284, Sec.3, Sanmin Rd., Taoyuan City,Taoyuan,  330Taiwan, Republic Of China',1),('00:0E:27','Crere Networks, Inc.','Crere Networks, Inc.Room 110 Etri Tbi, 52 Eoeun-dongYuseong-guDaejeon  305-333Korea, Republic Of',1),('00:0E:28','Dynamic Ratings P/l','Dynamic Ratings P/lC/o Wilson Transformer Co.Wilson Rd. (po Box 5)Glen Waverley Victoria 3150Australia',1),('00:0E:29','Shester Communications Inc','Shester Communications Inc159 S. LincolnSuite 221Spokane Wa 99201United States',1),('00:0E:2A','Private','',1),('00:0E:2B','Safari Technologies','Safari Technologies63855 M40 HwyLawton Mi 49065United States',1),('00:0E:2C','Netcodec Co.','Netcodec Co.401 Daeion S/w Center, 48 JangdongYusongguDaejon  305-715Korea, Republic Of',1),('00:0E:2D','Hyundai Digital Technology Co.,ltd.','Hyundai Digital Technology Co.,ltd.223-22, Sangdaewon-1dong, Jungwon-guSeongnam-si Kyoungki-do 462-807Korea, Republic Of',1),('00:0E:2E','Edimax Technology Co., Ltd.','Edimax Technology Co., Ltd.3, Wu-chuan 3rd Road,Wu-ku Industrial Park,Taipei Hsien,  248Taiwan, Republic Of China',1),('00:0E:2F','Disetronic Medical Systems Ag','Disetronic Medical Systems AgKirchbergstrasse 190Burgdorf Bern 3401Switzerland',1),('00:0E:30','Aeras Networks, Inc.','Aeras Networks, Inc.P.o. Box 7330Laguna Niguel Ca 92607-7330United States',1),('00:0E:31','Olympus Soft Imaging Solutions Gmbh','Olympus Soft Imaging Solutions GmbhJohann-krane-weg 39Mnster 48149Germany',1),('00:0E:32','Kontron Medical','Kontron MedicalReinacherstrasse 131Basel  4002Switzerland',1),('00:0E:33','Shuko Electronics Co.,ltd','Shuko Electronics Co.,ltdTohshin Higashi-ikebukuro Building 3f5-44-15,higashi-ikebukuro,toshima-kuTokyo Kantoh 170-0063Japan',1),('00:0E:34','Nexgen City, Lp','Nexgen City, Lp1680 GlenvilleSuite 100Richardson Texas 75081United States',1),('00:0E:35','Intel Corp','Intel Corp2111 Ne 25th AveJf3-420Hillsboro Or 97123United States',1),('00:0E:36','Heinesys, Inc.','Heinesys, Inc.3f, Sungkwang Bldg. 456-13, Sungnae-dongKangdong-guSeoul  134-848Korea, Republic Of',1),('00:0E:37','Harms & Wende Gmbh & Co.kg','Harms & Wende Gmbh & Co.kgGrossmoorkehre 9Hamburg  D-21079Germany',1),('00:0E:38','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0E:39','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0E:3A','Cirrus Logic','Cirrus Logic2901 Via FortunaAustin Tx 78746United States',1),('00:0E:3B','Hawking Technologies, Inc.','Hawking Technologies, Inc.15281a Barranca ParkwayIrvine Ca 92618United States',1),('00:0E:3C','Transact Technologies Inc','Transact Technologies Inc20 Bomax DriveIthaca New York 14850United States',1),('00:0E:3D','Televic N.v.','Televic N.v.Leo Bekaertlaan 1Izegem  8870Belgium',1),('00:0E:3E','Sun Optronics Inc','Sun Optronics Inc4-38-4 Fuchinobe-honchouSagamihara Kanagawa 229-0002Japan',1),('00:0E:3F','Soronti, Inc.','Soronti, Inc.12159 Business Park Dr, Suite 140Draper Utah 84020United States',1),('00:0E:40','Nortel Networks','Nortel Networks8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:0E:41','Nihon Mechatronics Co.,ltd.','Nihon Mechatronics Co.,ltd.9-6 Shiomidai, Miyamae-kuKawasaki-shi Kanagawa-ken 216-0013Japan',1),('00:0E:42','Motic Incoporation Ltd.','Motic Incoporation Ltd.Room 2907-8, Windsor  House311 Gloucester Road, Causeway BayHong KongChina',1),('00:0E:43','G-tek Electronics Sdn. Bhd.','G-tek Electronics Sdn. Bhd.2493 Mukim 1, Lorong Perusahaan LapanKawasan Perindustrian PeraiPerai Penang 13600Malaysia',1),('00:0E:44','Digital 5, Inc.','Digital 5, Inc.101 Grovers Mill Rd.Suite 200Lawrenceville Nj 08648United States',1),('00:0E:45','Beijing Newtry Electronic Technology Ltd','Beijing Newtry Electronic Technology LtdPo Box 95, No. 1 Bei Sha Tan,Chao Yang QuBeijing  10083China',1),('00:0E:46','Niigata Seimitsu Co.,ltd.','Niigata Seimitsu Co.,ltd.3335-2, Shimonaka, Sanwa-muraNakakubiki-gun Niigata 943-0222Japan',1),('00:0E:47','Nci System Co.,ltd.','Nci System Co.,ltd.#206, Kayang Techno-town, 1487, Kayang 3 Dong, Kangseo-ku, Seoul, KoreaSeoul  157-810Korea, Republic Of',1),('00:0E:48','Lipman Transaction Solutions','Lipman Transaction Solutions11 Haamal St.Rosh-haayin  48092Israel',1),('00:0E:49','Forsway Scandinavia Ab','Forsway Scandinavia AbKaplansgatan 16 B541 34 SkvdeSweden',1),('00:0E:4A','Changchun Huayu Webpad Co.,ltd','Changchun Huayu Webpad Co.,ltd4370 Gaoxin Road, High-techDevelopment AreaChangchun Jilin 130012China',1),('00:0E:4B','Atrium C And I','Atrium C And I124-4, Ojeon-dong,Uiwang-city Kyunggi-do 437-819Korea, Republic Of',1),('00:0E:4C','Bermai Inc.','Bermai Inc.410 Cambridge Ave2nd FloorPalo Alto Ca 94306United States',1),('00:0E:4D','Numesa Inc.','Numesa Inc.4444 Westgrove Suite 300Addison Tx 75001United States',1),('00:0E:4E','Waveplus Technology Co., Ltd.','Waveplus Technology Co., Ltd.347 Hsinhu 2nd Rd., NeihuTaipei  114Taiwan, Republic Of China',1),('00:0E:4F','Trajet Gmbh','Trajet GmbhRebenring 33Braunschweig Nds. 38106Germany',1),('00:0E:50','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47Edegem Antwerp B-2650Belgium',1),('00:0E:51','Tecna Elettronica Srl','Tecna Elettronica SrlVia Miglioli 30Castel San Pietro Terme Bologna 40024Italy',1),('00:0E:52','Optium Corporation','Optium Corporation500 Horizon DrSuite 505Chalfont Pa 18914United States',1),('00:0E:53','Av Tech Corporation','Av Tech Corporation10f,e Building,no.19-11 San Chung Rd.,nankangTaipei  115Taiwan, Republic Of China',1),('00:0E:54','Alphacell Wireless Ltd.','Alphacell Wireless Ltd.22 Zarhin StreetRaanana  43662Israel',1),('00:0E:55','Auvitran','Auvitran7c Chemin Des PrsMeylan  38410France',1),('00:0E:56','4g Systems Gmbh & Co. Kg','4g Systems Gmbh & Co. KgJarrestrasse 2-622303 HamburgGermany',1),('00:0E:57','Iworld Networking, Inc.','Iworld Networking, Inc.125 Hanju Bldg, Nonhyun-dongKang-nam GuSeoul  135010Korea, Republic Of',1),('00:0E:58','Sonos, Inc.','Sonos, Inc.223 E. De La Guerra St.Santa Barbara Ca 93101United States',1),('00:0E:59','Sagem Sa','Sagem Sa2, Rue Du Petit AlbiCergy Saint Christophe Val Doise 95800France',1),('00:0E:5A','Telefield Inc.','Telefield Inc.3f, Kumbo Bldg, 2-9, Seokchon-dongSongpa-guSeoul  138-190Korea, Republic Of',1),('00:0E:5B','Parkervision - Direct2data','Parkervision - Direct2data9432 Baymeadows WaySuite 150Jacksonville Fl 32246United States',1),('00:0E:5C','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:0E:5D','Triple Play Technologies A/s','Triple Play Technologies A/sHerstedvang 8Albertslund  Dk-2620Denmark',1),('00:0E:5E','Raisecom Technology','Raisecom Technology2 Floor, South Building Of Rainbow PlazaNo. 11 Shangdi Information RoadHaidian District Beijing 100085China',1),('00:0E:5F','Activ-net Gmbh & Co. Kg','Activ-net Gmbh & Co. KgKonrad-zuse-str. 4Bochum  44801Germany',1),('00:0E:60','360sun Digital Broadband Corporation','360sun Digital Broadband Corporation2f-2, No.2, Jianba Rd.,Chung Ho Taipei 235Taiwan, Republic Of China',1),('00:0E:61','Microtrol Limited','Microtrol Limited16 Elgar Business CentreMoseley RoadHallow Worcester Wr2 6njUnited Kingdom',1),('00:0E:62','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:0E:63','Lemke Diagnostics Gmbh','Lemke Diagnostics GmbhRadeburger Str. 47Volkersdorf Saxony 01468Germany',1),('00:0E:64','Elphel, Inc','Elphel, Inc3200 S. Elpmer St.Magna Ut 84044United States',1),('00:0E:65','Transcore','Transcore8600 Jefferson St NeAlbuquerque Nm 87113United States',1),('00:0E:66','Hitachi Advanced Digital, Inc.','Hitachi Advanced Digital, Inc.292, Yoshida-cho, Totsuka-kuYokohama Kanagawa 244-0817Japan',1),('00:0E:67','Eltis Microelectronics Ltd.','Eltis Microelectronics Ltd.Unit 902b, 9/f., Sunbeam Centre27, Shing Yip StreetKwun Tong KowloonHong Kong',1),('00:0E:68','E-top Network Technology Inc.','E-top Network Technology Inc.No. 7, Shin Shin Rd.,Tainan  702Taiwan, Republic Of China',1),('00:0E:69','China Electric Power Research Institute','China Electric Power Research InstituteNo.15 Xiaoying East Road,qinghe,beijing,chinaBeijing  100085China',1),('00:0E:6A','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:0E:6B','Janitza Electronics Gmbh','Janitza Electronics GmbhVor Dem Polstck 1Lahnau Hessen 35633Germany',1),('00:0E:6C','Device Drivers Limited','Device Drivers Limited1-5-1-103Wakamatsu-choFuchu-shi Tokyo 1830005Japan',1),('00:0E:6D','Murata Manufacturing Co., Ltd.','Murata Manufacturing Co., Ltd.2288, Oaza-ohshinohara, Yasu-cho,Yasu-gun Shiga 520-2393Japan',1),('00:0E:6E','Micrelec  Electronics S.a','Micrelec  Electronics S.a16 Isminis Str.Athens Aegaleo 12241Greece',1),('00:0E:6F','Iris Corporation Berhad','Iris Corporation BerhadIris Smart Technology ComplexTechnology Park Malaysia, Bukit JalilKuala Lumpur Wp 57000Malaysia',1),('00:0E:70','In2 Networks','In2 Networks320 W  200 SSuite #380Slc Ut 84101United States',1),('00:0E:71','Gemstar Technology Development Ltd.','Gemstar Technology Development Ltd.Unit 201, Stulex House, 698 Prince Edward Road East, San Po Kong, KolwoonHong Kong  852Hong Kong',1),('00:0E:72','Cts Electronics','Cts ElectronicsCorso Vercelli 332Ivrea Torino 10015Italy',1),('00:0E:73','Tpack A/s','Tpack A/sLautrupbjerg 7 - 11Dk 2750  Ballerup  Dk 2750Denmark',1),('00:0E:74','Solar Telecom. Tech','Solar Telecom. TechB B/d, 4f, Samho Venture Tower#275-6, Yangjae-dong, Secho-guSeoul  137-941Korea, Republic Of',1),('00:0E:75','New York Air Brake Corp.','New York Air Brake Corp.748 Starbuck Ave.Watertown Ny 13601United States',1),('00:0E:76','Gemsoc Innovision Inc.','Gemsoc Innovision Inc.9f,no.516,sec,1neihu Rd.,Taipei  114Taiwan, Republic Of China',1),('00:0E:77','Decru, Inc.','Decru, Inc.275 Shoreline DrSuite 450Redwood City Ca 94065United States',1),('00:0E:78','Amtelco','Amtelco4800 Curtin DriveMcfarland Wi 53558United States',1),('00:0E:79','Ample Communications Inc.','Ample Communications Inc.4034 Clipper Ct.Fremont Ca 94538United States',1),('00:0E:7A','Gemwon Communications Co., Ltd.','Gemwon Communications Co., Ltd.3fl.,no.32,lane 135,shianjeng 9th Rd.,jubei CityHsinchu  302Taiwan, Republic Of China',1),('00:0E:7B','Toshiba','Toshiba2-9, Suehiro-choOme Tokyo 1988710Japan',1),('00:0E:7C','Televes S.a.','Televes S.a.Rua Benefica Conxo 17Santiago De Compostela Corua 15706Spain',1),('00:0E:7D','Electronics Line 3000 Ltd.','Electronics Line 3000 Ltd.2 Granit St.Petah Tikva Kiryar Arie 449130Israel',1),('00:0E:7E','Ionsign Oy','Ionsign OyP.o.box  246Fi-26101RaumaFinland',1),('00:0E:7F','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:0E:80','Thomson Technology Inc','Thomson Technology Inc9087a 198th StSurrey Bc V1m-3b1Canada',1),('00:0E:81','Devicescape Software, Inc.','Devicescape Software, Inc.1000 Marina BlvdSuite 400Brisbane Ca 94005United States',1),('00:0E:82','Commtech Wireless','Commtech Wireless115/396 Scarborough Beach RdOsborne ParkPerth Wa 6017Australia',1),('00:0E:83','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0E:84','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0E:85','Catalyst Enterprises, Inc.','Catalyst Enterprises, Inc.3385 Scott BlvdSanta Clara Ca 95054United States',1),('00:0E:86','Alcatel North America','Alcatel North America2301 Sugar Bush RoadRaleigh Nc 27612United States',1),('00:0E:87','Adp Gauselmann Gmbh','Adp Gauselmann GmbhBoschstr. 8Luebbecke Nrw 32312Germany',1),('00:0E:88','Videotron Corp.','Videotron Corp.17-16,2-chomeHachioji Tokyo 193-0835Japan',1),('00:0E:89','Clematic','Clematic101 Rue Pierre SemardChatillon R.p. 92320France',1),('00:0E:8A','Avara Technologies Pty. Ltd.','Avara Technologies Pty. Ltd.9 Business Park DriveNotting Hill Victoria 3168Australia',1),('00:0E:8B','Astarte Technology Co, Ltd.','Astarte Technology Co, Ltd.11f, No. 166 Dah-yeh Rd.Peitou, Taipei  112Taiwan, Republic Of China',1),('00:0E:8C','Siemens Ag A&d Et','Siemens Ag A&d EtSiemensstrae 10Regensburg  93055Germany',1),('00:0E:8D','Systems In Progress Holding Gmbh','Systems In Progress Holding GmbhExerzierplatzstrasse 85Graz Styria 8051Austria',1),('00:0E:8E','Sparklan Communications, Inc.','Sparklan Communications, Inc.3fl . , No. 246, Sec. 1, Neihu Road., Neihu Chiu,Taipei  114Taiwan, Republic Of China',1),('00:0E:8F','Sercomm Corp.','Sercomm Corp.3f,no.81,yu-yih Rd.,chu-nan ChenMiao-lih Hsuan  350Taiwan, Republic Of China',1),('00:0E:90','Ponico Corp.','Ponico Corp.602, Ace Twin Tower 1, 212-1 Guro-dongGurogu Seoul 152-766Korea, Republic Of',1),('00:0E:91','Navico Auckland Ltd','Navico Auckland Ltd17-21 Kawana StNorthcote AucklandNew Zealand',1),('00:0E:92','Millinet Co., Ltd.','Millinet Co., Ltd.2f, West Building, It Venture Tower, 78, Garakbon-dongSongpa-gu Seoul 138-169Korea, Republic Of',1),('00:0E:93','Milnio 3 Sistemas Electrnicos, Lda.','Milnio 3 Sistemas Electrnicos, Lda.Edifcio Via Norte, R. Espido 164c S403Maia Minho 4470-177Portugal',1),('00:0E:94','Maas International Bv','Maas International BvScience Park Eindhoven 5051Son Noord Brabant Nl-5692 EbNetherlands',1),('00:0E:95','Fujiya Denki Seisakusho Co.,ltd.','Fujiya Denki Seisakusho Co.,ltd.8f Fukushima Bldg. 6-25-11,nishi-gotandaShinagawa-ku Tokyo 141-0031Japan',1),('00:0E:96','Cubic Defense Applications, Inc.','Cubic Defense Applications, Inc.P.o. Box 855879333 Balboa AvenueSan Diego Ca 92186-5587United States',1),('00:0E:97','Ultracker Technology Co., Inc','Ultracker Technology Co., Inc14f-1, No. 888, Jingguo Road, Taoyuan City,Taoyuan  330Taiwan, Republic Of China',1),('00:0E:98','Vitec Cc, Inc.','Vitec Cc, Inc.Dba Clearcom Communications850 Marina Village ParkwayAlameda California 94501United States',1),('00:0E:99','Spectrum Digital, Inc','Spectrum Digital, Inc12502 Exchange Drive, Suite 440Stafford Tx 77477United States',1),('00:0E:9A','Boe Technology Group Co.,ltd','Boe Technology Group Co.,ltdNo.10 Jiuxianqiao Road,chaoyang District,beijing,prcBeijing  100016China',1),('00:0E:9B','Ambit Microsystems Corporation','Ambit Microsystems Corporation5f-1, 5 Hsin-an Rd. Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:0E:9C','Pemstar','Pemstar3535 Technology DriveRochester Mn 55901United States',1),('00:0E:9D','Tiscali Uk Ltd','Tiscali Uk Ltd20 Broadwick StreetLondon  W1f 8htUnited Kingdom',1),('00:0E:9E','Topfield Co., Ltd','Topfield Co., Ltd4th Floor, Deoksan Bldg 260-4, Seohyun-dongSeongnam Bundang-ku 463-824Korea, Republic Of',1),('00:0E:9F','Temic Sds Gmbh','Temic Sds GmbhSoeflinger Strasse 100Ulm  89077Germany',1),('00:0E:A0','Netklass Technology Inc.','Netklass Technology Inc.2f-1, No.30,tai Yuen Street,Chupei City, Hsinchu, 302Taiwan, Republic Of China',1),('00:0E:A1','Formosa Teletek Corporation','Formosa Teletek Corporation358,huaya 2nd Rd.Gueishan ShiangTaoyuan  333Taiwan, Republic Of China',1),('00:0E:A2','Secure Computing Corporation','Secure Computing Corporation350 Sw 12th AvenueDeerfield Beach Fl 33442United States',1),('00:0E:A3','Cncr-it Co.,ltd,hangzhou P.r.china','Cncr-it Co.,ltd,hangzhou P.r.chinaXuantan Road No1.department Room504,Hangzhou Zhejiang 310003China',1),('00:0E:A4','Certance Inc.','Certance Inc.1650 Sunflower Ave.Costa Mesa Ca 92626-1513United States',1),('00:0E:A5','Blip Systems','Blip SystemsHaekken 2Vodskov Vester Hassing 9310Denmark',1),('00:0E:A6','Asustek Computer Inc.','Asustek Computer Inc.No. 150, Li-te Rd.,peitouTaipei  112Taiwan, Republic Of China',1),('00:0E:A7','Endace Technology','Endace Technology85 Alexandra StreetHamilton  3204New Zealand',1),('00:0E:A8','United Technologists Europe Limited','United Technologists Europe LimitedUtel Laboratories, Wolves Farm LaneIpswich RoadHadleigh Suffolk Ip7 6bhUnited Kingdom',1),('00:0E:A9','Shanghai Xun Shi Communications Equipment Ltd. Co.','Shanghai Xun Shi Communications Equipment Ltd. Co.Hi-tech King World, Unit C603#666 Beijing Road (e)Shanghai  200001China',1),('00:0E:AA','Scalent Systems, Inc.','Scalent Systems, Inc.490 S. California AvePalo Alto Ca 94306United States',1),('00:0E:AB','Cray Inc','Cray Inc411 First Ave S Suite 600Seattle Wa 98104Canada',1),('00:0E:AC','Mintron Enterprise Co., Ltd.','Mintron Enterprise Co., Ltd.No.3,wu-kung 5rd., Wu-ku Ind ParkTaipei County  248Taiwan, Republic Of China',1),('00:0E:AD','Metanoia Technologies, Inc.','Metanoia Technologies, Inc.5918 W. Courtyard Dr.Suite 330Austin Tx 78730United States',1),('00:0E:AE','Gawell Technologies Corp.','Gawell Technologies Corp.2f,no.102,sec.3,jung Shan Rd,Jung Ho City, Taipei Hsien 235Taiwan, Republic Of China',1),('00:0E:AF','Castel','CastelZi Saint Lambert Des LevesSaumur Maine Et Loire 49412France',1),('00:0E:B0','Solutions Radio Bv','Solutions Radio BvPrinsegracht 82The Hague Zh 2512 GcNetherlands',1),('00:0E:B1','Newcotech,ltd','Newcotech,ltdAnyang Megavally 715-3Kwanyang-dong, Dongan-gu,Anyang City Gueonggi-do 431-160Korea, Republic Of',1),('00:0E:B2','Micro-research Finland Oy','Micro-research Finland OyVlitalontie 83 CHelsinki  Fin-00660Finland',1),('00:0E:B3','Hewlett-packard','Hewlett-packard2580 55th StreetBoulder Co 80301United States',1),('00:0E:B4','Guangzhou Gaoke Communications Technology Co.ltd.','Guangzhou Gaoke Communications Technology Co.ltd.Ave. 398 ZhongshanGuangzhou Guangdong 510660China',1),('00:0E:B5','Ecastle Electronics Co., Ltd.','Ecastle Electronics Co., Ltd.#502, Namjang B/d, Bangbae-dong,Seocho-ku,Seoul  137-818Korea, Republic Of',1),('00:0E:B6','Riverbed Technology, Inc.','Riverbed Technology, Inc.501 Second StreetSuite 410San Francisco Ca 94107United States',1),('00:0E:B7','Knovative, Inc.','Knovative, Inc.11245 West Bernardo CourtSuite 100San Diego Ca 92127United States',1),('00:0E:B8','Iiga Co.,ltd','Iiga Co.,ltd3f Tkbldg. 3-5-2 SotokandaChiyoda-ku Tokyo 101-0021Japan',1),('00:0E:B9','Hashimoto Electronics Industry Co.,ltd.','Hashimoto Electronics Industry Co.,ltd.3866-12 Takasu-choMatsusaka Mie 515-0104Japan',1),('00:0E:BA','Hanmi Semiconductor Co., Ltd.','Hanmi Semiconductor Co., Ltd.#532-2, Gajwa-dong, Seo-ku,Incheon  404 250Korea, Republic Of',1),('00:0E:BB','Everbee Networks','Everbee Networks41, Boulevard Des CapucinesParis  75002France',1),('00:0E:BC','Paragon Fidelity Gmbh','Paragon Fidelity GmbhSchwadermhlstrasse 4aCadolzburg  90556Germany',1),('00:0E:BD','Burdick, A Quinton Compny','Burdick, A Quinton Compny500 Burdick ParkwayDeerfield Wi 53531United States',1),('00:0E:BE','B&b Electronics Manufacturing Co.','B&b Electronics Manufacturing Co.707 Dayton RoadP.o. Box 1040Ottawa Ilinois 61350United States',1),('00:0E:BF','Remsdaq Limited','Remsdaq LimitedParkwayDeeside Industrial ParkDeeside Flintshire Ch5 2nlUnited Kingdom',1),('00:0E:C0','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:0E:C1','Mynah Technologies','Mynah Technologies504 Trade Center BlvdChesterfield Mo 63005United States',1),('00:0E:C2','Lowrance Electronics, Inc.','Lowrance Electronics, Inc.12000 E. Skelly DriveTulsa Ok 74128United States',1),('00:0E:C3','Logic Controls, Inc.','Logic Controls, Inc.355 Denton AvenueNew Hyde Park Ny 11040United States',1),('00:0E:C4','Iskra Transmission D.d.','Iskra Transmission D.d.Stegne 11Ljubljana  1000Slovenia',1),('00:0E:C5','Digital Multitools Inc','Digital Multitools Inc9005 Leslie Street  Unit 205Richmond Hill Ontario L4b 1g7Canada',1),('00:0E:C6','Asix Electronics Corp.','Asix Electronics Corp.4f, No.8, Hsin Ann Rd.,Science-based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:0E:C7','Motorola Korea','Motorola KoreaHibrand B/d 17f Sw Team Motorola KoreaYangjaedong SeochoKorea, Republic Of',1),('00:0E:C8','Zoran Corporation','Zoran Corporation1390 Kifer Rd.Sunnyvale Ca 94086United States',1),('00:0E:C9','Yoko Technology Corp.','Yoko Technology Corp.6f, No.10, Lane16, Sec2, Sze-chuan Rd., Pan-Chiao City,Taipei  886Taiwan, Republic Of China',1),('00:0E:CA','Wtss Inc','Wtss Inc5999 Avenida EncinasSuite 150Carlsbad Ca 92008United States',1),('00:0E:CB','Vinesys Technology','Vinesys Technology3350 Scott Blvd. Building 15-03Santa Clara Ca 95054United States',1),('00:0E:CC','Tableau, Llc','Tableau, LlcN8 W22195 Johnson Drive, Suite 100Waukesha Wi 53186United States',1),('00:0E:CD','Skov A/s','Skov A/sHedelund 4GlyngoereRoslev  Dk-7870Denmark',1),('00:0E:CE','S.i.t.t.i. S.p.a.','S.i.t.t.i. S.p.a.Via Cadorna 69Vimodrone Milan I-20090Italy',1),('00:0E:CF','Profibus Nutzerorganisation E.v.','Profibus Nutzerorganisation E.v.Haid-und-neu-strasse 7Karlsruhe Baden-wrttemberg 76131Germany',1),('00:0E:D0','Privaris, Inc.','Privaris, Inc.650 Peter Jefferson Pkwy, Ste 330Charlottesville Virginia 22911United States',1),('00:0E:D1','Osaka Micro Computer.','Osaka Micro Computer.Isonokamicyo 3-11-7Kishiwada Osaka 5960001Japan',1),('00:0E:D2','Filtronic Plc','Filtronic PlcThe WaterfrontSalts Mill RdSaltaire W Yorks Bd18 3ttUnited Kingdom',1),('00:0E:D3','Epicenter, Inc.','Epicenter, Inc.211 B Calle PintorescoSan Clemente Ca 92672United States',1),('00:0E:D4','Cresitt Industrie','Cresitt Industrie12 Rue De BloisOrleans Bp 6744 45067  CedexFrance',1),('00:0E:D5','Copan Systems Inc.','Copan Systems Inc.2605 Trade Centre Ave.Suite DLongmont Co 80503United States',1),('00:0E:D6','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0E:D7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0E:D8','Aktino, Inc.','Aktino, Inc.18551 Von Karman AvenueSuite 201Irvine Ca 92612United States',1),('00:0E:D9','Aksys, Ltd.','Aksys, Ltd.2 Marriott DriveLincolnshire Il 60069United States',1),('00:0E:DA','C-tech United Corp.','C-tech United Corp.5f, No 665, Chung Chen Rd.Hsin Chuang Citt  Of Taipei Hsien  242Taiwan, Republic Of China',1),('00:0E:DB','Xincom Corp.','Xincom Corp.2840 Industrial Ave.Hubbard Or 97032United States',1),('00:0E:DC','Tellion Inc.','Tellion Inc.5th Fl. Bona Venture Town1586-1 Seocho 3-dong, Seocho-guSeoul Seocho-gu. 137-719Korea, Republic Of',1),('00:0E:DD','Shure Incorporated','Shure Incorporated5800 W. Touhy Ave.Niles Il 60714United States',1),('00:0E:DE','Remec, Inc.','Remec, Inc.2144 Franklin Drive NePalm Bay Florida 32905-4021United States',1),('00:0E:DF','Plx Technology','Plx Technology870 Maude Ave.,Sunnyvale Ca 94085United States',1),('00:0E:E0','Mcharge','MchargeFirstec Bldg,. 15-4 Youido-dongYoungdeungpo-gu,Seoul Youido 150-010Korea, Republic Of',1),('00:0E:E1','Extremespeed Inc.','Extremespeed Inc.Po Box 6004634-46th Street Suite 201Mannville Alberta T0b 2w0Canada',1),('00:0E:E2','Custom Engineering S.p.a.','Custom Engineering S.p.a.Via Beretttine 2/bFontevivo Parma 43010Italy',1),('00:0E:E3','Chiyu Technology Co.,ltd','Chiyu Technology Co.,ltdNo. 28, Renai Road, Chiayi, 600Chiayi  600Taiwan, Republic Of China',1),('00:0E:E4','Boe Technology Group Co.,ltd','Boe Technology Group Co.,ltdNo.10 Jiuxianqiao Road,chaoyang District,Beijing  100016China',1),('00:0E:E5','Bitwallet, Inc.','Bitwallet, Inc.Gate City Ohsaki West Tower 18f, 1-11-1 Osaki, Shinagawa-kuTokyo  1410032Japan',1),('00:0E:E6','Adimos Systems Ltd','Adimos Systems Ltd17 Atirey-yeda StreetKfar-saba  44643Israel',1),('00:0E:E7','Aac Electronics Corp.','Aac Electronics Corp.Floor 7,sixth Building Of Naianyou Tnan Industrial Area,nanshan DistrictShenzhen Province Guangdong 518054China',1),('00:0E:E8','Zioncom','ZioncomWest Wing 5/f ., Block 1, Gaoxin South Ring Rd/keji South Rd,Vision(shenzhen)business Park, Shenzhen Hi-tech Industrial Park,Shenzhen Guangdong 518057China',1),('00:0E:E9','Waytech Development, Inc.','Waytech Development, Inc.11floor, 253 Min-sheng RoadHsinchu  300Taiwan, Republic Of China',1),('00:0E:EA','Shadong Luneng Jicheng Electronics,co.,ltd','Shadong Luneng Jicheng Electronics,co.,ltdNo.188,east,huayuan RoadJinan Shandong 250100China',1),('00:0E:EB','Sandmartin(zhong Shan)electronics Co.,ltd','Sandmartin(zhong Shan)electronics Co.,ltd3st Industrial Area,tan Zhou,Zhongshan Guangdong 528467China',1),('00:0E:EC','Orban','Orban1525 Alvarado St.San Leandro Ca 94577United States',1),('00:0E:ED','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:0E:EE','Muco Industrie Bv','Muco Industrie BvPleimuiden 12eAmsterdam Nh 1046 AgNetherlands',1),('00:0E:EF','Private','',1),('00:0E:F0','Festo Ag & Co. Kg','Festo Ag & Co. KgRuiterstrae 82Esslingen  73734Germany',1),('00:0E:F1','Ezquest Inc.','Ezquest Inc.21133 E. La Palma Ave.Yorba Linda Ca 92887United States',1),('00:0E:F2','Infinico Corporation','Infinico Corporation4f, F-1 Bldg., 1-2-12,Hamamatsucho, Mitano-kuTokyo  105-0013Japan',1),('00:0E:F3','Smarthome','Smarthome16542 Millikan Ave.Irvine Ca 92606United States',1),('00:0E:F4','Kasda Digital Technology Co.,ltd','Kasda Digital Technology Co.,ltd2/f,building 2,bagua 2 Road,futian,Shenzhen Guangdong Province 518029China',1),('00:0E:F5','Ipac Technology Co., Ltd.','Ipac Technology Co., Ltd.6f, No. 30, Shingjung Road, NeihuTaipei  114Taiwan, Republic Of China',1),('00:0E:F6','E-ten Information Systems Co., Ltd.','E-ten Information Systems Co., Ltd.No. 256, Yangguang Street, Neihu ChiuTaipei  114Taiwan, Republic Of China',1),('00:0E:F7','Vulcan Portals Inc','Vulcan Portals Inc505 5th Ave South, Suite 900Seattle Wa 98104United States',1),('00:0E:F8','Sbc Asi','Sbc AsiNetwork & Infrastructure Technical Support1010 N Saint MarysSan Antonio Texas 78215United States',1),('00:0E:F9','Rea Elektronik Gmbh','Rea Elektronik GmbhTeichwiesenstr. 1Muehltal Hessen 64367Germany',1),('00:0E:FA','Optoway Technology Incorporation','Optoway Technology IncorporationNo. 38, Kuang Fu South RoadHsin Chu Industrial ParkHu Kou Hsin Chu 303Taiwan, Republic Of China',1),('00:0E:FB','Macey Enterprises','Macey EnterprisesP.o. Box 7267Tempe Az 85281United States',1),('00:0E:FC','Jtag Technologies B.v.','Jtag Technologies B.v.Boschdijk 50Eindhoven Nb 5612 AnNetherlands',1),('00:0E:FD','Fujinon Corporation','Fujinon Corporation1-324 Uetake, Kita-ku,Saitama City Saitama 331-9624Japan',1),('00:0E:FE','Endrun Technologies Llc','Endrun Technologies Llc2270 Northpoint ParkwaySanta Rosa Ca 95407United States',1),('00:0E:FF','Megasolution,inc.','Megasolution,inc.2-7-10 ShitayaTaito Tokyo 110-0004Japan',1),('00:0F:00','Legra Systems, Inc.','Legra Systems, Inc.3 Burlington Woods DriveBurlington Ma 01803United States',1),('00:0F:01','Digitalks Inc','Digitalks Inc14 Marshall LaneWeston Ct 06883United States',1),('00:0F:02','Digicube Technology Co., Ltd','Digicube Technology Co., Ltd8f,no. 51, Lane  35, Jihu Rd.,Taipei  114Taiwan, Republic Of China',1),('00:0F:03','Com&c Co., Ltd','Com&c Co., Ltd2f Woojin Bld 1445-2 Secho-dongSecho-guSeoul  137-070Korea, Republic Of',1),('00:0F:04','Cim-usa Inc','Cim-usa Inc10813 Nw 30th StreetMiami Florida 33172United States',1),('00:0F:05','3b System Inc.','3b System Inc.1727, Sankyuk2-dong, Buk-guDaegu  702-845Korea, Republic Of',1),('00:0F:06','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:0F:07','Mangrove Systems, Inc.','Mangrove Systems, Inc.10 Fairfield Blvd.Wallingford Ct 06492United States',1),('00:0F:08','Indagon Oy','Indagon OyNuijamiestentie 5 AHelsinki - 00400Finland',1),('00:0F:09','Private','',1),('00:0F:0A','Clear Edge Networks','Clear Edge Networks11250 El Camino RealSan Diego Ca 92130United States',1),('00:0F:0B','Kentima Technologies Ab','Kentima Technologies AbBox 174Kastanjevgen 2Staffanstorp Skne 245 44Sweden',1),('00:0F:0C','Synchronic Engineering','Synchronic Engineering25 Cap DarnetalDarnetal France 76160France',1),('00:0F:0D','Hunt Electronic Co., Ltd.','Hunt Electronic Co., Ltd.6fi, No. 57-59, Jiun H Sien Rd., Chi Tu DistrictKeelung Taiwan 206Taiwan, Republic Of China',1),('00:0F:0E','Wavesplitter Technologies, Inc.','Wavesplitter Technologies, Inc.2248 North First StreetSan Jose Ca 95131United States',1),('00:0F:0F','Real Id Technology Co., Ltd.','Real Id Technology Co., Ltd.9f Hanmi B/d 192-19Nonhyeon-dongGangnam-gu Seoul 135-010Korea, Republic Of',1),('00:0F:10','Rdm Corporation','Rdm Corporation608 Weber St. NWaterloo On N2v 1k4Canada',1),('00:0F:11','Prodrive B.v.','Prodrive B.v.P.o. 28030Eindhoven  5602 JaNetherlands',1),('00:0F:12','Panasonic Europe Ltd.','Panasonic Europe Ltd.Hesebergweg 49-51Peine  D-31228Germany',1),('00:0F:13','Nisca Corporation','Nisca Corporation430-1KobayashiMasuho-cho Yamanashi-ken 400-0593Japan',1),('00:0F:14','Mindray Co., Ltd.','Mindray Co., Ltd.Mindray Building, Keji 12th Road SouthHigh-tech Industrial Park, NanshanShenzhen Guangdong 518057China',1),('00:0F:15','Kjaerulff1 A/s','Kjaerulff1 A/sC.f. Tietgens Boulevard 19Odense S Fyn 5220Denmark',1),('00:0F:16','Jay How Technology Co.,','Jay How Technology Co.,No.486,sec. 1, Wan Shou Rd., KueiShan Hsiang, Taoyuan HsienTaoyuan Hsien  333Taiwan, Republic Of China',1),('00:0F:17','Insta Elektro Gmbh','Insta Elektro GmbhTalstrasse 104Luedenscheid Nrw D-58515Germany',1),('00:0F:18','Industrial Control Systems','Industrial Control SystemsHoutschelf 1Hardinxveld Zuid-holland Nl-3371 KbNetherlands',1),('00:0F:19','Boston Scientific','Boston Scientific4100 Hamline Ave N.St. Paul Mn 55112United States',1),('00:0F:1A','Gaming Support B.v.','Gaming Support B.v.Industrie Weg 29Rotterdam 3044 AsNetherlands',1),('00:0F:1B','Ego Systems Inc.','Ego Systems Inc.1206 Woolim E-biz Center Ii16 Yangpyongdong3ga, Youngdungpo-guSeoul  150-834Korea, Republic Of',1),('00:0F:1C','Digitall World Co., Ltd','Digitall World Co., LtdSejin Bld 2f, 689 Ilwon2-dong,Gangnam-gu Seoul 135-946Korea, Republic Of',1),('00:0F:1D','Cosmo Techs Co., Ltd.','Cosmo Techs Co., Ltd.2-6-1, MatsueAtsugi-shi Kanagawa-ken 243-0005Japan',1),('00:0F:1E','Chengdu Kt Electric Co.of High & New Technology','Chengdu Kt Electric Co.of High & New TechnologyNo.2 Gaopeng Dong Road,high & New Development Zone,No.9 Wuke East No.3 Road,wuhou Zone,Chengdu Sichuan 610041China',1),('00:0F:1F','Ww Pcba Test','Ww Pcba TestOne Dell WayRound Rock Texas 78682United States',1),('00:0F:20','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:0F:21','Scientific Atlanta, Inc','Scientific Atlanta, Inc5030 Sugarloaf ParkwayPo Box 465447Lawrenceville Ga 30042United States',1),('00:0F:22','Helius, Inc.','Helius, Inc.333 South 520 WestSuite 330Lindon Ut 84042United States',1),('00:0F:23','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:24','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:25','Aimvalley B.v.','Aimvalley B.v.Anton Philipsweg 1Hilversum Nh 1223 KzNetherlands',1),('00:0F:26','Worldaccxx  Llc','Worldaccxx  Llc4035 Tampa Rd.Suite 6000Oldsmar Fl 34667United States',1),('00:0F:27','Teal Electronics, Inc.','Teal Electronics, Inc.10350 Sorrento Valley RoadSan Diego California 92121United States',1),('00:0F:28','Itronix Corporation','Itronix CorporationSouth 801 Stevens StreetSpokane Wa 99204United States',1),('00:0F:29','Augmentix Corporation','Augmentix Corporation4030 W Braker LnBuilding 2, Suite 100Austin Texas 78759United States',1),('00:0F:2A','Cableware Electronics','Cableware Electronics1702 Western Ave.Suite GLas Vegas Nevada 89102United States',1),('00:0F:2B','Greenbell Systems','Greenbell Systems2th Floor, Doonam Bldg, 236-11 Nonhyun-dong, Kangnam-kuSeoul  135-010Korea, Republic Of',1),('00:0F:2C','Uplogix, Inc.','Uplogix, Inc.Bldg 1, Suite 2358601 Rr 2222Austin Tx 78730United States',1),('00:0F:2D','Chung-hsin Electric & Machinery Mfg.corp.','Chung-hsin Electric & Machinery Mfg.corp.No. 25, Wen-te Rd., Lo-shan VillageKwei Shan Hsiang Taoyuan Hsien 330Taiwan, Republic Of China',1),('00:0F:2E','Megapower International Corp.','Megapower International Corp.Rm. 403, No 24 , Wu-chuan 2nd Rd.,Hsin-chuangTaipei Hsien  242Taiwan, Republic Of China',1),('00:0F:2F','W-linx Technology Co., Ltd.','W-linx Technology Co., Ltd.2f,ellen L. Skelton Building,fisher Lane RoadTortolaVirgin Islands, British',1),('00:0F:30','Raza Microelectronics Inc','Raza Microelectronics Inc3080 North First Street5th FloorSan Jose Ca 95134United States',1),('00:0F:31','Prosilica','Prosilica101-3750 North Fraser WayBurnaby Bc V5j 5e9Canada',1),('00:0F:32','Lutong Electronic Technology Co.,ltd','Lutong Electronic Technology Co.,ltd106, Liangxi RoadWuxi Jiangsu 214063China',1),('00:0F:33','Duali Inc.','Duali Inc.#505 Samsung Techno Park Bldg 471Woncheon-dong, Youngtong-guSuwon Gyeonggi-do 442-824Korea, Republic Of',1),('00:0F:34','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:35','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:36','Accurate Techhnologies, Inc.','Accurate Techhnologies, Inc.47199 Cartier Dr.Wixom Michigan 48393United States',1),('00:0F:37','Xambala Incorporated','Xambala Incorporated2674 N. 1st StreetSuite 215San Jose Ca 95134United States',1),('00:0F:38','Netstar','Netstar3f,no.347, Yang-kuang St.,nei-hu Dis.,Taipei  114Taiwan, Republic Of China',1),('00:0F:39','Iris Sensors','Iris SensorsZa Les UfernetsToulaud Ardeche F07130France',1),('00:0F:3A','Hisharp','HisharpNo.673,chang Hsing Road Pate City,taoyuan,Taipei  334Taiwan, Republic Of China',1),('00:0F:3B','Fuji System Machines Co., Ltd.','Fuji System Machines Co., Ltd.5-8-10HibarigaokaZama-shi Kanagawa-ken 228-0003Japan',1),('00:0F:3C','Endeleo Limited','Endeleo Limited78 Cannon StreetLondon England Ec4n 6nqUnited Kingdom',1),('00:0F:3D','D-link Corporation','D-link CorporationNo.8,li-shing Seventh Road,science-based Industrial Park,hsimchu,Hsimchu  300Taiwan, Republic Of China',1),('00:0F:3E','Cardionet, Inc','Cardionet, Inc1010 Second AvenueSuite 700San Diego Ca 92101United States',1),('00:0F:3F','Big Bear Networks','Big Bear Networks345 Potrero AveSunny Vale California 94085United States',1),('00:0F:40','Optical Internetworking Forum','Optical Internetworking Forum48377 Fremont BlvdSte 117Fremont Ca 94538United States',1),('00:0F:41','Zipher Ltd','Zipher Ltd7 Faraday BuildingNottingham Science And Technology ParkNottingham Nottinghamshire Ng7 2qpUnited Kingdom',1),('00:0F:42','Xalyo Systems','Xalyo SystemsGrenier 9Commugny Vd 1291Switzerland',1),('00:0F:43','Wasabi Systems Inc.','Wasabi Systems Inc.500 E. Main StreetSuite 1520Norfolk Va 23510United States',1),('00:0F:44','Tivella Inc.','Tivella Inc.795 Main StreetHalf Moon Bay Ca 94019United States',1),('00:0F:45','Stretch, Inc.','Stretch, Inc.1322 Orleans DriveSunnyvale Ca 94089United States',1),('00:0F:46','Sinar Ag','Sinar AgStadtweg 24Feuerthalen Zh Ch-8245Switzerland',1),('00:0F:47','Robox Spa','Robox SpaVia Sempione 82Castelletto S.ticino No 28053Italy',1),('00:0F:48','Polypix Inc.','Polypix Inc.1fl, Sungdo Venture Tower, 165-2 Samsung-dong, Kangnam-kuSeoul  135-881Korea, Republic Of',1),('00:0F:49','Northover Solutions Limited','Northover Solutions LimitedHeath CottageIllington RoadLarling Norfolk Nr16 2rbUnited Kingdom',1),('00:0F:4A','Kyushu-kyohan Co.,ltd','Kyushu-kyohan Co.,ltd2-6-3,koganemachiKokurakita-kuKitakyushu-city Fukuoka 802-0071Japan',1),('00:0F:4B','Virtual Iron Software, Inc.','Virtual Iron Software, Inc.900 Chelmsford StreetTower 1 Floor 2Lowell Ma 01851United States',1),('00:0F:4C','Elextech Inc','Elextech Inc554-2, Gasan-dong, Gumcheon-guSeoul  153-023Korea, Republic Of',1),('00:0F:4D','Talkswitch','Talkswitch1545 Carling AveSuite 510Ottawa Ontario K1z 8p9Canada',1),('00:0F:4E','Cellink','CellinkCatherinalaan 37Rotselaar Vlaams Brabant B-3110Belgium',1),('00:0F:4F','Cadmus Technology Ltd','Cadmus Technology Ltd66 Hillside RdGlenfieldAuckland  1310New Zealand',1),('00:0F:50','Streamscale Limited','Streamscale LimitedThe Court, Alexandra ParkPrescot RoadSt Helens  Wa10 3tpUnited Kingdom',1),('00:0F:51','Azul Systems, Inc.','Azul Systems, Inc.1600 Plymouth StreetMountain View California 94043United States',1),('00:0F:52','York Refrigeration, Marine & Controls','York Refrigeration, Marine & ControlsJens Juulsvej 28Viby J Dk 8362Denmark',1),('00:0F:53','Solarflare Communications Inc','Solarflare Communications Inc9501 Jeronimo RoadSuite 250Irvine Ca 92618United States',1),('00:0F:54','Entrelogic Corporation','Entrelogic Corporation33 Boston Post Rd. West.Suite 160Marlborough Ma 01752United States',1),('00:0F:55','Datawire Communication Networks Inc.','Datawire Communication Networks Inc.10 Carlson Court, Suite 300Toronto Ontario M9w 6l2Canada',1),('00:0F:56','Continuum Photonics Inc','Continuum Photonics Inc5 Fortune DriveBillerica Ma 01821United States',1),('00:0F:57','Cablelogic Co., Ltd.','Cablelogic Co., Ltd.3f., Hwain Bldg., 1559-12 Seocho 3-dong,Secho-gu,Seoul  137-873Korea, Republic Of',1),('00:0F:58','Adder Technology Limited','Adder Technology LimitedTechnology HouseTrafalgar WayBar Hill Cambridgeshire Cb3 8sqUnited Kingdom',1),('00:0F:59','Phonak Communications Ag','Phonak Communications AgLnggasse 17Murten Fr 3280Switzerland',1),('00:0F:5A','Peribit Networks','Peribit Networks2855 Bowers AveSanta Clara Ca 95051United States',1),('00:0F:5B','Delta Information Systems, Inc.','Delta Information Systems, Inc.300 Welsh Road, Bldg. 3Horsham Pa 19044-2273United States',1),('00:0F:5C','Day One Digital Media Limited','Day One Digital Media Limited197 Archers RdGlenfieldAuckland North Island 1310New Zealand',1),('00:0F:5D','42networks Ab','42networks AbPo-1217Kistagangen 2, IvKista Stockholm Se-16428Sweden',1),('00:0F:5E','Veo','Veo910 Rincon CircleSan Jose Ca 95131United States',1),('00:0F:5F','Nicety Technologies Inc. (nts)','Nicety Technologies Inc. (nts)792-3 Tomioka Toyoda-choIwata-gun Shizuoka 438-0803Japan',1),('00:0F:60','Lifetron Co.,ltd','Lifetron Co.,ltd6-7,tenjinnishimachiKita-kuOsaka Osaka Prefecture 530-0045Japan',1),('00:0F:61','Hewlett Packard','Hewlett Packard20555 State Highway 249Houston Tx 77070United States',1),('00:0F:62','Alcatel Bell Space N.v.','Alcatel Bell Space N.v.Berkenrodelei 33Hoboken Antwerpen B-2660Belgium',1),('00:0F:63','Obzerv Technologies','Obzerv Technologies400 Jean LesageSuite 201Quebec Qc G1k8w1Canada',1),('00:0F:64','D&r Electronica Weesp Bv','D&r Electronica Weesp BvRijnkade 15bWeesp Nh 1382gsNetherlands',1),('00:0F:65','Icube Corp.','Icube Corp.Olympia Center 2f,828-10,yeoksam-dong,kangnam-kuSeoul South 135-935Korea, Republic Of',1),('00:0F:66','Cisco-linksys','Cisco-linksys121 Theory Dr.Irvine Ca 92612United States',1),('00:0F:67','West Instruments','West InstrumentsUnit 5, The Hyde, Lower BevendeanBrighton East Sussex Bn2 4juUnited Kingdom',1),('00:0F:68','Vavic Network Technology, Inc.','Vavic Network Technology, Inc.1st Floor, 15 Jiangong RoadTianhe  S&t ZoneGuangzhou Guangdong 510665China',1),('00:0F:69','Sew Eurodrive Gmbh & Co. Kg','Sew Eurodrive Gmbh & Co. KgErnst Blickle Str. 42Bruchsal  76646Germany',1),('00:0F:6A','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:0F:6B','Gateware Communications Gmbh','Gateware Communications GmbhAllersberger Strasse 185 FNuernberg Bavaria D-90461Germany',1),('00:0F:6C','Addi-data Gmbh','Addi-data GmbhDieselstrasse 3Ottersweier Bw 77833Germany',1),('00:0F:6D','Midas Engineering','Midas EngineeringAce Techno-tower V #906 197-22Kuro-dong, Kuro-guSeoul  152-848Korea, Republic Of',1),('00:0F:6E','Bbox','BboxEpitok U. 2-4Budaors  H-2040Hungary',1),('00:0F:6F','Fta Communication Technologies','Fta Communication Technologies11, Rue Pierre WernerBetzdorf  L-6832Luxembourg',1),('00:0F:70','Wintec Industries, Inc.','Wintec Industries, Inc.675 Sycamore DriveMilpitas, Ca 95035United States',1),('00:0F:71','Sanmei Electronics Co.,ltd','Sanmei Electronics Co.,ltd2-2-1,seikai,shimizuShizuoka  424-0924Japan',1),('00:0F:72','Sandburst','Sandburst600 Federal St2nd FloorAndover Ma 01810United States',1),('00:0F:73','Rockwell  Automation Korea','Rockwell  Automation Korea447-6, Gongse-dong , Giheung-guYoungin-city Gyeonggi-do 449-902Korea, Republic Of',1),('00:0F:74','Qamcom Technology Ab','Qamcom Technology AbGruvgatan 8Se-421 30Vastra FrolundaSweden',1),('00:0F:75','First Silicon Solutions','First Silicon Solutions13939 Forest LaneLarkspur Co 80118United States',1),('00:0F:76','Digital Keystone, Inc.','Digital Keystone, Inc.1975 El Camino Real#306Mountain View Ca 94040United States',1),('00:0F:77','Dentum Co.,ltd','Dentum Co.,ltdWookyung B/d 602 #678-6Deungchon-dong ,kangseo-guSeoul  157-030Korea, Republic Of',1),('00:0F:78','Datacap Systems Inc','Datacap Systems Inc100 New Britain BlvdChalfont Pa 18914United States',1),('00:0F:79','Bluetooth Interest Group Inc.','Bluetooth Interest Group Inc.4f, No. 9, Alley 2, Lane 35, Ji-hu Rd.Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:0F:7A','Beijing Nuqx Technology Co.,ltd','Beijing Nuqx Technology Co.,ltdRoom 812,8f Tower B,yinwang Center, No.113,zhi Chun Road,Haidian DistrictBeijing  100086China',1),('00:0F:7B','Arce Sistemas, S.a.','Arce Sistemas, S.a.C/padre Larramendi, 3 - 2Bilbao Vizcaya 48012Spain',1),('00:0F:7C','Acti Corporation','Acti Corporation7f., No. 1, Alley 20, Lane 407, Sec. 2, Tiding Blvd.,Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:0F:7D','Xirrus','Xirrus310 North Westlake Blvd.Westlake Village Ca 91362United States',1),('00:0F:7E','Ablerex Electronics Co., Ltd','Ablerex Electronics Co., Ltd1f, No.3 Lane 7, Paokao Rd.Hsintien Taipei Hsien 23114Taiwan, Republic Of China',1),('00:0F:7F','Ubstorage Co.,ltd.','Ubstorage Co.,ltd.#a-108, Seoul_sanup_jiwon_center647-26, Deungchong-dongGanseo-gu Seoul 157-840Korea, Republic Of',1),('00:0F:80','Trinity Security Systems,inc.','Trinity Security Systems,inc.Alte Building Higashi Kanda 8f1-7-8 HigashikandaChiyoda-ku Tokyo 101-0031Japan',1),('00:0F:81','Secure Info Imaging','Secure Info Imaging1848 Commercenter EastSan Bernardino Ca 92408United States',1),('00:0F:82','Mortara Instrument, Inc.','Mortara Instrument, Inc.7865 N. 86th St.Milwaukee Wi 53224United States',1),('00:0F:83','Brainium Technologies Inc.','Brainium Technologies Inc.#201 - 11491 Kingston StreetMaple Ridge Bc V2x 0y6Canada',1),('00:0F:84','Astute Networks, Inc.','Astute Networks, Inc.16516 Via Esprillo#200San Diego Ca 92127United States',1),('00:0F:85','Addo-japan Corporation','Addo-japan CorporationShin Edobashi Bldg. 4f, 8-6 Nihombashi Kobuna-choChuo-ku Tokyo 103-0024Japan',1),('00:0F:86','Research In Motion Limited','Research In Motion Limited295 Phillip StreetWaterloo Ontario N2l 3w8Canada',1),('00:0F:87','Maxcess International','Maxcess International222 W. Memorial RoadOklahoma City Ok 73114United States',1),('00:0F:88','Ametek, Inc.','Ametek, Inc.150 Freeport RoadPittsburgh Pa 15238United States',1),('00:0F:89','Winnertec System Co., Ltd.','Winnertec System Co., Ltd.#405, 4th Floor. Ace-techno Tower Iii, 197-48,Kuro 3-dong, Kuro-ku.Seoul  152-766Korea, Republic Of',1),('00:0F:8A','Wideview','WideviewF. 6, No. 8, Wu-chuan 2 Rd, Hsin-chuang CityTaipei Country  242Taiwan, Republic Of China',1),('00:0F:8B','Orion Multisystems Inc','Orion Multisystems Inc3375 Scott Blvd Suite 338Santa Clara Ca 95054United States',1),('00:0F:8C','Gigawavetech Pte Ltd','Gigawavetech Pte Ltd1 Jalan Kilang Timor#07-02 Pacific Tech Centre159303Singapore',1),('00:0F:8D','Fast Tv-server Ag','Fast Tv-server AgRuedesheimerstr. 11-13Munich Germany 80686Germany',1),('00:0F:8E','Dongyang Telecom Co.,ltd.','Dongyang Telecom Co.,ltd.642-7, Deungchon-dong, Kangseo-guSeoul Kangse-gu 157-841Korea, Republic Of',1),('00:0F:8F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:90','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:91','Aerotelecom Co.,ltd.','Aerotelecom Co.,ltd.195-58 Anyang 7 DongAnyang Kyunggi 430-817Korea, Republic Of',1),('00:0F:92','Microhard Systems Inc.','Microhard Systems Inc.#17, 2135-32ave NeCalgary Ab T2e6z3Canada',1),('00:0F:93','Landis+gyr Ltd.','Landis+gyr Ltd.Feldstrasse 1Zug  Ch-6301Switzerland',1),('00:0F:94','Genexis','GenexisLodewijkstraat 1aEindhoven  5646hpNetherlands',1),('00:0F:95','Elecom Co.,ltd Laneed Division','Elecom Co.,ltd Laneed Division8f Kanda-muromachi Bldg.1 Kanda-ogawamachi 1 Chome,Chiyoda-ku, Tokyo.  101-0052Japan',1),('00:0F:96','Critical Telecom Corp.','Critical Telecom Corp.340 March Road, Suite 500Ottawa On K2k 2e4Canada',1),('00:0F:97','Avanex Corporation','Avanex Corporation40919 Encyclopedia CircleFremont Ca 94538United States',1),('00:0F:98','Avamax Co. Ltd.','Avamax Co. Ltd.B1, No. 51, Section 2, Chongqing S. Rd.Taipei  100Taiwan, Republic Of China',1),('00:0F:99','Apac Opto Electronics Inc.','Apac Opto Electronics Inc.7 San-min Road, Hsinchu Industrial ParkHukow, Hsinchu Hsien  303Taiwan, Republic Of China',1),('00:0F:9A','Synchrony, Inc.','Synchrony, Inc.6410 Commonwealth DriveRoanoke Va 24018United States',1),('00:0F:9B','Ross Video Limited','Ross Video Limited8 John StreetPo Box 220Iroquois Ontario K0e 1k0Canada',1),('00:0F:9C','Panduit Corp','Panduit Corp17301 Ridgeland AveTinley Park Illinois 60477United States',1),('00:0F:9D','Displaylink (uk) Ltd','Displaylink (uk) LtdMount Pleasant HouseMount PleasantCambridge Cambridgeshire Cb3 0rnUnited Kingdom',1),('00:0F:9E','Murrelektronik Gmbh','Murrelektronik GmbhFalkenstrasse 3Oppenweiler Baden Wrttemberg 71570Germany',1),('00:0F:9F','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:0F:A0','Canon Korea Business Solutions Inc.','Canon Korea Business Solutions Inc.736 Wonsi-dongAnsan-si Kyunggi-do 425-090Korea, Republic Of',1),('00:0F:A1','Gigabit Systems Inc.','Gigabit Systems Inc.Fuyoh Video Building 3f7-25 Higashi-kibougaoka, Asahi-kuYokohama Kanagawa 241-0826Japan',1),('00:0F:A2','Digital Path Networks','Digital Path Networks275 Airpark BlvdSuite 500Chico Ca 95973United States',1),('00:0F:A3','Alpha Networks Inc.','Alpha Networks Inc.No.8 Li-shing 7th Rd.,science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:0F:A4','Sprecher Automation Gmbh','Sprecher Automation GmbhFranckstrasse 51Linz Obersterreich 4018Austria',1),('00:0F:A5','Smp / Bwa Technology Gmbh','Smp / Bwa Technology GmbhFrankfurter Ring 193aMunich  D-80807Germany',1),('00:0F:A6','S2 Security Corporation','S2 Security Corporation6 Abbott RoadWellesley Ma 02481United States',1),('00:0F:A7','Raptor Networks Technology','Raptor Networks Technology65 Enterprise RoadAliso Viejo Ca 92656United States',1),('00:0F:A8','Photometrics, Inc.','Photometrics, Inc.3440 E Britannia DriveTucson Az 85706-5006United States',1),('00:0F:A9','Pc Fabrik','Pc FabrikBuchenstrasse 13-15Dresden Sachsen 01097Germany',1),('00:0F:AA','Nexus Technologies','Nexus Technologies10 National Ave.Fletcher Nc 28732United States',1),('00:0F:AB','Kyushu Electronics Systems Inc.','Kyushu Electronics Systems Inc.3-3, Kongo 2-chome, Yahatanishi WardKitakyushu City Fukuoka Pref. 807-1263Japan',1),('00:0F:AC','Ieee 802.11','Ieee 802.114125 Highlander ParkwayRichfield Ohio 44286United States',1),('00:0F:AD','Fmn Communications Gmbh','Fmn Communications GmbhGrimmelallee 4Nordhausen Thringen 99734Germany',1),('00:0F:AE','E2o Communications','E2o Communications52 Serangoon North Ave 4#06-02 Ever Tech Building555853Singapore',1),('00:0F:AF','Dialog Inc.','Dialog Inc.1-47-9HigashiikebukuroToshima-ku Tokyo 1700013Japan',1),('00:0F:B0','Compal Electronics,inc.','Compal Electronics,inc.581 Juikuang Road,neihu,Taipei  114Taiwan, Republic Of China',1),('00:0F:B1','Cognio Inc.','Cognio Inc.101 Orchard Ridge DriveSuite 350Gaithersburg Md 20878United States',1),('00:0F:B2','Broadband Pacenet (india) Pvt. Ltd.','Broadband Pacenet (india) Pvt. Ltd.7-b, Shah Industrial Estate, Off Veera Desai RoadAndheri WestMumbai Maharashtra 400 053India',1),('00:0F:B3','Actiontec Electronics, Inc','Actiontec Electronics, Inc760 North Mary AveSunnyvale Ca 94086United States',1),('00:0F:B4','Timespace Technology','Timespace TechnologyBlackstone RoadHuntingdon Cambridgeshire Pe29 6ttUnited Kingdom',1),('00:0F:B5','Netgear Inc','Netgear Inc4500 Great America ParkwaySanta Clara Ca 95054United States',1),('00:0F:B6','Europlex Technologies','Europlex TechnologiesClonshaugh Business & Tech. ParkClonshaugh  Dublin 17Ireland',1),('00:0F:B7','Cavium Networks','Cavium Networks2610 Augustine DriveSanta Clara California 95054United States',1),('00:0F:B8','Callurl Inc.','Callurl Inc.3f-11, No. 508 Sec.  5, Chung-hsiao E. Rd.Taipei  110Taiwan, Republic Of China',1),('00:0F:B9','Adaptive Instruments','Adaptive Instruments577 Main StreetHudson Ma 01749United States',1),('00:0F:BA','Tevebox Ab','Tevebox AbBerglinds Vag 13Warmdo  S-13900Sweden',1),('00:0F:BB','Nokia Siemens Networks Gmbh & Co. Kg','Nokia Siemens Networks Gmbh & Co. KgWerner-von-siemens Str. 2-6Bruchsal Baden-wrtemberg 76646Germany',1),('00:0F:BC','Onkey Technologies, Inc.','Onkey Technologies, Inc.780 Montague Expressway, Inc.Suite #306San Jose Ca 95131United States',1),('00:0F:BD','Mrv Communications (networks) Ltd','Mrv Communications (networks) LtdP.o Box 614Yokneam  20692Israel',1),('00:0F:BE','E-w/you Inc.','E-w/you Inc.3f Fine Bldg. 6-17-17Minamiooi,Shinagawa-ku, Tokyo 140-0013Japan',1),('00:0F:BF','Dgt Sp. Z O.o.','Dgt Sp. Z O.o.Ul. Jaskowa Dolina 15Gdansk  80-252Poland',1),('00:0F:C0','Delcomp','DelcompTechnologielaan 3Leuven  B-3000Belgium',1),('00:0F:C1','Wave Corporation','Wave Corporation3-25-5 ChidoriOhta-ku Tokyo 146-0083Japan',1),('00:0F:C2','Uniwell Corporation','Uniwell Corporation5-25, 3-chome, Tenma, Kita-kuOsaka  530-0043Japan',1),('00:0F:C3','Palmpalm Technology, Inc.','Palmpalm Technology, Inc.Samsung-dong 156-3, Gangnam-guSeoul  135-091Korea, Republic Of',1),('00:0F:C4','Nst Co.,ltd.','Nst Co.,ltd.4-3-1 ShinmiyakodaHamamatsu Shizuoka 431-2103Japan',1),('00:0F:C5','Keymed Ltd','Keymed LtdKeymed HouseStock RoadSouthend On Sea Essex Ss2 5qhUnited Kingdom',1),('00:0F:C6','Eurocom Industries A/s','Eurocom Industries A/sPorsvej 2Aalborg Nv Dk-9200Denmark',1),('00:0F:C7','Dionica R&d Ltd.','Dionica R&d Ltd.Bologna Centre, F11Mosta TechnoparkMosta  Mst13Malta',1),('00:0F:C8','Chantry Networks','Chantry Networks1900 Minnesota CourtSuite 125Mississauga Ontario L5n 3c9Canada',1),('00:0F:C9','Allnet Gmbh','Allnet GmbhMaistr. 2Germering Bavaria 82110Germany',1),('00:0F:CA','A-jin Techline Co, Ltd','A-jin Techline Co, Ltd327-35Kasan-dongKumchun-ku Seoul 153-802Korea, Republic Of',1),('00:0F:CB','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:0F:CC','Netopia, Inc.','Netopia, Inc.6001 Shellmound Street4th FloorEmeryville Ca 94608United States',1),('00:0F:CD','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:0F:CE','Kikusui Electronics Corp.','Kikusui Electronics Corp.1-1-3,higashi YamataTsuzuki-kuYokohama Kanagawa 224-0023Japan',1),('00:0F:CF','Datawind Research','Datawind Research555 Rene-levesque WestSuite 1130Montreal Quebec H2z 1b1Canada',1),('00:0F:D0','Astri','Astri18/f Tower 6, Gateway, 9 Canton RdTst, KowloonHong Kong',1),('00:0F:D1','Applied Wireless Identifications Group, Inc.','Applied Wireless Identifications Group, Inc.382 Route 59, Section 292Monsey New York 10952United States',1),('00:0F:D2','Ewa Technologies, Inc.','Ewa Technologies, Inc.13873 Park Center RoadHerndon Va 20171United States',1),('00:0F:D3','Digium','Digium445 Jan Davis Drive NwSuite 100Huntsville Al 35806United States',1),('00:0F:D4','Soundcraft','SoundcraftCranborne HouseCranborne RoadPotters Bar Hertfordshire En6 3jnUnited Kingdom',1),('00:0F:D5','Schwechat - Rise','Schwechat - RiseAm Concorde Park 2aSchwechat  2320Austria',1),('00:0F:D6','Sarotech Co., Ltd','Sarotech Co., LtdHangang Bldg, 1549-7, Seocho-dong,Seocho-ku,Seoul  137-070Korea, Republic Of',1),('00:0F:D7','Harman Music Group','Harman Music Group8760 Sandy ParkwaySandy Utah 84070United States',1),('00:0F:D8','Force, Inc.','Force, Inc.825 Park StreetChristiansburg Va 24073United States',1),('00:0F:D9','Flexdsl Telecommunications Ag','Flexdsl Telecommunications AgHaus Zum EngelAltendorf Schwyz 8852Switzerland',1),('00:0F:DA','Yazaki Corporation','Yazaki Corporation1500 MishukuSusono-city Shizuoka-pref 410-1194Japan',1),('00:0F:DB','Westell Technologies','Westell Technologies750 N. Commons Dr.Aurora Il 60504United States',1),('00:0F:DC','Ueda Japan  Radio Co., Ltd.','Ueda Japan  Radio Co., Ltd.Fumiiri 2-10-19Ueda City Nagano Prefecture 386-8608Japan',1),('00:0F:DD','Sordin Ab','Sordin AbRorlaggarvagen 8Varnamo Smaland S-331 34Sweden',1),('00:0F:DE','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:0F:DF','Solomon Technology Corp.','Solomon Technology Corp.No.42,sing Zhong Rd.,nei Hu Dist.,Taipei  114Taiwan, Republic Of China',1),('00:0F:E0','Ncomputing Co.,ltd.','Ncomputing Co.,ltd.6th Fl, Jei-platz B/d1423-6, Gwanyang1-dong, Dongan-guSeoul Gasan-dong Geumcheon-gu 459-11Korea, Republic Of',1),('00:0F:E1','Id Digital Corporation','Id Digital Corporation6th Fl., Mirae Bldg., 271-1, Seohyun-dong, Bundang-ku, Sungnam-si, Keongki-do, South KoreaSungnam-si Keongki-do 463-050Korea, Republic Of',1),('00:0F:E2','Hangzhou H3c Technologies Co., Ltd.','Hangzhou H3c Technologies Co., Ltd.Oriental Electronic Bld., No.2,chuangye RoadShang-di Informaiton Industry Base,Hai-dian District Beijing 100085China',1),('00:0F:E3','Damm Cellular Systems A/s','Damm Cellular Systems A/sMoellegade 68Soenderborg  Dk-6400Denmark',1),('00:0F:E4','Pantech Co.,ltd','Pantech Co.,ltdShinsong B/d 3f, 25-12,Yeouido-dong,Youngdeungpo-gu Seoul 150-711Korea, Republic Of',1),('00:0F:E5','Mercury Security Corporation','Mercury Security Corporation2355 Mira Mar Ave.Long Beach Ca 90815United States',1),('00:0F:E6','Mbtech Systems, Inc.','Mbtech Systems, Inc.412 1st Ave SeSuite 100Cullman Alabama 35055United States',1),('00:0F:E7','Lutron Electronics Co., Inc.','Lutron Electronics Co., Inc.7200 Suter Rd.Coopersburg Pa 18036-1299United States',1),('00:0F:E8','Lobos, Inc.','Lobos, Inc.U&t Bldg 3f, 1-2-3 Sarugaku-cho, Chiyoda-ku,Tokyo  101-0064Japan',1),('00:0F:E9','Gw Technologies Co.,ltd.','Gw Technologies Co.,ltd.No.38 Shangdi Xilu,haidian DistrictBeijing  100085China',1),('00:0F:EA','Giga-byte Technology Co.,ltd.','Giga-byte Technology Co.,ltd.No.215,nan-ping Road,ping-jen City,Ping-jen Taoyuan 324Taiwan, Republic Of China',1),('00:0F:EB','Cylon Controls','Cylon ControlsClonshaugh Industrial EstateClonshaughDublin 17Ireland',1),('00:0F:EC','Arkus Inc.','Arkus Inc.3-8 Chuo-choOkayama  700-0836Japan',1),('00:0F:ED','Anam Electronics Co., Ltd','Anam Electronics Co., Ltd645 Sungkok-dongDanwon-guAnsan-city Kyungki-do 425-834Korea, Republic Of',1),('00:0F:EE','Xtec, Incorporated','Xtec, Incorporated5775 Blue Lagoon DriveSuite 280Miami Florida 33126United States',1),('00:0F:EF','Thales E-transactions Gmbh','Thales E-transactions GmbhKonrad-zuse-strae 19-21Bad Hersfeld Hessen 36251Germany',1),('00:0F:F0','Sunray Co. Ltd.','Sunray Co. Ltd.Osawa2-5-5 MitakaTokyo 181-0015Japan',1),('00:0F:F1','Nex-g Systems Pte.ltd','Nex-g Systems Pte.ltd25 Kallang Ave#07-05339416Singapore',1),('00:0F:F2','Loud Technologies Inc.','Loud Technologies Inc.16220 Wood-red Rd. NeWoodinville Wa 98072United States',1),('00:0F:F3','Jung Myoung Communications&technology','Jung Myoung Communications&technology1th Fl., Dong Il Bldg.107 Yangjae-dongSeocho-ku Seoul 137-130Korea, Republic Of',1),('00:0F:F4','Guntermann & Drunck Gmbh','Guntermann & Drunck GmbhDortmunder Str. 4aWilnsdorf Nrw 57234Germany',1),('00:0F:F5','Gn&s Company','Gn&s Company301 Ansan S/w Center, 643-7 Wongok-dongAnsan City Gyeonggi-do 425-130Korea, Republic Of',1),('00:0F:F6','Darfon Electronics Corp.','Darfon Electronics Corp.31, Lane17, Zihciang N. RoadGueishanTaoyuan  333Taiwan, Republic Of China',1),('00:0F:F7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:F8','Cisco  Systems','Cisco  Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:0F:F9','Valcretec, Inc.','Valcretec, Inc.Byucksan Digital Valley Ii 15f481-10, Gasan-dong, Geumcheon-guSeoul  153-803Korea, Republic Of',1),('00:0F:FA','Optinel Systems, Inc.','Optinel Systems, Inc.6835 Deerpath Rd.Elkridge Md 21075United States',1),('00:0F:FB','Nippon Denso Industry Co., Ltd.','Nippon Denso Industry Co., Ltd.3-14-19Shibaura, Minato-ku Tokyo, 108-8560Japan',1),('00:0F:FC','Merit Li-lin Ent.','Merit Li-lin Ent.No. 20 Wu-long 6 Rd.Wu-ku Taipei 242Taiwan, Republic Of China',1),('00:0F:FD','Glorytek Network Inc.','Glorytek Network Inc.5f.-3, No.16, Sec. 1, Dongda Rd.,Hsinchu  300Taiwan, Republic Of China',1),('00:0F:FE','G-pro Computer','G-pro ComputerFirst Arrange C Yinghu Industrial Estate Qingxi Country Dongguan CityDongguan Guangdong 523648China',1),('00:0F:FF','Control4','Control411734 S. Election DriveDraper Ut 84020United States',1),('00:10:00','Cable Television Laboratories, Inc.','Cable Television Laboratories, Inc.858 Coal Creek CircleLouisville Co 80027United States',1),('00:10:01','Citel','CitelLoughborough Innovation CentreEpinal WayLoughborough  Le11 3ehUnited Kingdom',1),('00:10:02','Actia','Actia25 Chemin De Pouvourville31432 Toulouse,  Cedex 04France',1),('00:10:03','Imatron, Inc.','Imatron, Inc.389 Oyster Point Blvd.So. San Francisco Ca 94080United States',1),('00:10:04','The Brantley Coile Company,inc','The Brantley Coile Company,inc545 Research DriveAthens Ga 30605United States',1),('00:10:05','Uec Commercial','Uec CommercialP.o. Box 54,Mt. Edgecombe4300 DurbanSouth Africa',1),('00:10:06','Thales Contact Solutions Ltd.','Thales Contact Solutions Ltd.Tolbar WaySouthampton, So30 2zpUnited Kingdom',1),('00:10:07','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive   Sja-2San Jose Ca 95134-1706United States',1),('00:10:08','Vienna Systems Corporation','Vienna Systems Corporation6651 Fraserwood PlaceSuite #250Richmond, B.c. V6w 1j3Canada',1),('00:10:09','Horo Quartz','Horo QuartzZ.i. Route De Niort85200 - Fontenay Le ComteFrench Guiana',1),('00:10:0A','Williams Communications Group','Williams Communications GroupAdvanced Technologies111 East FirstTulsa Ok 74103United States',1),('00:10:0B','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive  Sja-2San Jose Ca 95134-1706United States',1),('00:10:0C','Ito Co., Ltd.','Ito Co., Ltd.8-2 Miyanoshita-choHirakata-city, OsakaJapan',1),('00:10:0D','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr.-sja-2San Jose Ca 95134-1706United States',1),('00:10:0E','Micro Linear Coporation','Micro Linear Coporation2092 Concourse DriveSan Jose Ca 95131United States',1),('00:10:0F','Industrial Cpu Systems','Industrial Cpu Systems111-d W. Dyer RoadSanta Ana Ca 92707United States',1),('00:10:10','Initio Corporation','Initio Corporation2188 B Del Franco StreetSan Jose Ca 95118United States',1),('00:10:11','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:10:12','Processor Systems (i) Pvt Ltd','Processor Systems (i) Pvt Ltd24 Richmond RoadBangalore 560 025India',1),('00:10:13','Kontron','Kontron6260 Sequence DriveSan Diego Ca 92121United States',1),('00:10:14','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:10:15','Oomon Inc.','Oomon Inc.Po Box 8241Coburg Or 97408United States',1),('00:10:16','T.sqware','T.sqware6, Parc ArianeImmeuble Mercure78284 Guyancourt CedexFrance',1),('00:10:17','Micos Gmbh','Micos GmbhSt.-jobser Str. 31D-52146 Wurselen (deutschland)Germany',1),('00:10:18','Broadcom Corporation','Broadcom Corporation16215 Alton ParkwayP.o. Box 57013Irvine Ca 92619-7013United States',1),('00:10:19','Sirona Dental Systems Gmbh & Co. Kg','Sirona Dental Systems Gmbh & Co. KgFabrikstrasse 3164625 BensheimGermany',1),('00:10:1A','Picturetel Corp.','Picturetel Corp.100 Minuteman Road, Ms641Andover Ma 01810United States',1),('00:10:1B','Cornet Technology, Inc.','Cornet Technology, Inc.7f-4, No. 46 Chung Shan N.roadSec. 2, TaipeiTajikistan',1),('00:10:1C','Ohm Technologies Intl, Llc','Ohm Technologies Intl, Llc4 Executive Circle, Suite 185Irvine Ca 92614United States',1),('00:10:1D','Winbond Electronics Corp.','Winbond Electronics Corp.No. 4, Creation Rd. IiiScience-based Industrial ParkHsin ChuTaiwan, Republic Of China',1),('00:10:1E','Matsushita Electronic Instruments Corp.','Matsushita Electronic Instruments Corp.23-9 Kiyohara Industrial ParkUtsunomiya Tochigi 321-32Japan',1),('00:10:1F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr.San Jose Ca 95134-1706United States',1),('00:10:20','Hand Held Products Inc','Hand Held Products Inc700 Visions DriveSkaneateles Falls Ny 13153-0208United States',1),('00:10:21','Encanto Networks, Inc.','Encanto Networks, Inc.2953 Bunker Hill LaneSuite #400Santa Clara Ca 95054United States',1),('00:10:22','Satcom Media Corporation','Satcom Media Corporation3255-7 Scott Blvd.Santa Clara Ca 95054United States',1),('00:10:23','Network Equipment Technologies','Network Equipment Technologies6900 Paseo Padre ParkwayFreemont Ca 94555-3660United States',1),('00:10:24','Nagoya Electric Works Co., Ltd','Nagoya Electric Works Co., Ltd29-1 Shinoda, Miwa-choAma-gun, Aichi 490-12Japan',1),('00:10:25','Grayhill, Inc','Grayhill, Inc561 Hillgrove AveLagrange Il 60525United States',1),('00:10:26','Accelerated Networks, Inc.','Accelerated Networks, Inc.31238 Via Colinas, UnitWestlake Village Ca 91362United States',1),('00:10:27','L-3 Communications East','L-3 Communications EastOne Federal Street - A&e-3esCamden Nj 08102United States',1),('00:10:28','Computer Technica, Inc.','Computer Technica, Inc.3-5-19 Higashinaka Hakata-kuFukuoka-siFukuoka  816Japan',1),('00:10:29','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:10:2A','Zf Microsystems, Inc.','Zf Microsystems, Inc.1052 Elwell CourtPalo Alto Ca 94303-4307United States',1),('00:10:2B','Umax Data Systems, Inc.','Umax Data Systems, Inc.No. 1-1, R&d Road 2Science-based Industrial ParkHsinchuTaiwan, Republic Of China',1),('00:10:2C','Lasat Networks A/s','Lasat Networks A/sSkalhuse 13Sk-9240 NibeDenmark',1),('00:10:2D','Hitachi Software Engineering','Hitachi Software Engineering5-79, Onoecho, Naka-kuYokohama 231Japan',1),('00:10:2E','Network Systems & Technologies Pvt. Ltd.','Network Systems & Technologies Pvt. Ltd.Plot No. 2, Cochin Export Processing  ZoKakkanad, Cochin 682 030India',1),('00:10:2F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr.San Jose Ca 95134-1706United States',1),('00:10:30','Eion Inc.','Eion Inc.320 March RoadSuite 500Ottawa On K2k 2e3Canada',1),('00:10:31','Objective Communications, Inc.','Objective Communications, Inc.75 Rochester Ave.Unit 1Portsmouth Nh 03801United States',1),('00:10:32','Alta Technology','Alta Technology9500 South 500 West - Ste #212Sandy Ut 84070United States',1),('00:10:33','Accesslan Communications, Inc.','Accesslan Communications, Inc.44 Airport ParkwaySan Jose Ca 95110United States',1),('00:10:34','Gnp Computers','Gnp Computers555 E.huntington DriveMonrovia Ca 91016United States',1),('00:10:35','Elitegroup Computer Systems Co., Ltd','Elitegroup Computer Systems Co., Ltd6f, No. 88, Sec. 6Chung Shan N. Rd.Shih Lin TaipeiTaiwan, Republic Of China',1),('00:10:36','Inter-tel Integrated Systems','Inter-tel Integrated Systems7300 W. Boston StreetChandler Az 85226United States',1),('00:10:37','Cyqve Technology Co., Ltd.','Cyqve Technology Co., Ltd.Cosmo Bldg. 10f, No.1-7Shinjuku 1-chomeShinjuku-ku,  Tokyo 160Japan',1),('00:10:38','Micro Research Institute, Inc.','Micro Research Institute, Inc.2f, 2l-2-5 Minami ShinagawaShinagawa-kuTokyoJapan',1),('00:10:39','Vectron Systems Ag','Vectron Systems AgWilly-brandt-weg 4148155 MuensterGermany',1),('00:10:3A','Diamond Network Tech','Diamond Network TechP.o. Box 84525Greenside 2034South Africa',1),('00:10:3B','Hippi Networking Forum','Hippi Networking ForumPo Box 10173Albuquerque Nm 87184-0173United States',1),('00:10:3C','Ic Ensemble, Inc.','Ic Ensemble, Inc.3255-2 Scott Blvd.--ste.#105Santa Clara Ca 95054United States',1),('00:10:3D','Phasecom, Ltd.','Phasecom, Ltd.P.o. Box 45017Jerusalem 91450Israel',1),('00:10:3E','Netschools Corporation','Netschools Corporation2003 Landings DriveMountain View Ca 94043United States',1),('00:10:3F','Tollgrade Communications, Inc.','Tollgrade Communications, Inc.493 Nixon RoadCheswick Pa 15024United States',1),('00:10:40','Intermec Corporation','Intermec Corporation6001 36th Ave WestP.o. Box 4280Everett Wa 98203-9280United States',1),('00:10:41','Bristol Babcock, Inc.','Bristol Babcock, Inc.1100 Buckingham StreetWatertown Ct 06795United States',1),('00:10:42','Alacritech, Inc.','Alacritech, Inc.1995 N. First StreetSuite 200San Jose Ca 95112United States',1),('00:10:43','A2 Corporation','A2 Corporation6-14-11 Yutaka-choShinagawa-kuTokyoJapan',1),('00:10:44','Innolabs Corporation','Innolabs Corporation2f-4, No. 16, Lane 609, Chung-hsin Rd.Sec. 5 San-chung CityTaipei HsienTaiwan, Republic Of China',1),('00:10:45','Nortel Networks','Nortel NetworksOptera Solutions Division340 Terry Fox DriveKanata Ontario K2k-2x3Canada',1),('00:10:46','Alcorn Mcbride Inc.','Alcorn Mcbride Inc.3300 S. Hiawassee  #105Orlando Fl 32835United States',1),('00:10:47','Echo Eletric Co. Ltd.','Echo Eletric Co. Ltd.No.1800 Ichigao ChoMidori WardYokohama City  225Japan',1),('00:10:48','Htrc Automation, Inc.','Htrc Automation, Inc.285 Laval StreetBromptonvilleQuebec J0b 1h0Canada',1),('00:10:49','Shoretel, Inc','Shoretel, Inc960 Stewart DriveSunnyvale Ca 94085United States',1),('00:10:4A','The Parvuc Corporation','The Parvuc Corporation396 W. Ironwood DriveSalt Lake City Ut 84115United States',1),('00:10:4B','3com Corporation','3com Corporation5400 Bayfront PlazaMailstop: 4220Santa Clara Ca 95052United States',1),('00:10:4C','Lecroy Corporation','Lecroy Corporation3385 Scott Blvd.Santa Clara Ca 95054United States',1),('00:10:4D','Surtec Industries, Inc.','Surtec Industries, Inc.No.11, Alley 16, Lane 337Ta-tung Road Sec.1, Shi-chihTaipeiTaiwan, Republic Of China',1),('00:10:4E','Ceologic','CeologicZa De PissaloopRue Edouard Branly78192 TrappesFrance',1),('00:10:4F','Sun Microsystems, Inc.','Sun Microsystems, Inc.4200 Network CircleSanta Clara Co 95054United States',1),('00:10:50','Rion Co., Ltd.','Rion Co., Ltd.3-20-41 HigashimotomachiKokubunji, Tokyo 185Japan',1),('00:10:51','Cmicro Corporation','Cmicro Corporation17-20-2 Kamino-choTakamatsu-shi, Kagawa 761Japan',1),('00:10:52','Mettler-toledo (albstadt) Gmbh','Mettler-toledo (albstadt) GmbhP.o. Box 2 50D-72423 AlbstadtGermany',1),('00:10:53','Computer Technology Corp.','Computer Technology Corp.50 W. Technecenter DriveMilford Oh 45150United States',1),('00:10:54','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:10:55','Fujitsu Microelectronics, Inc.','Fujitsu Microelectronics, Inc.3545 North First StreetSan Jose Ca 95134-1806United States',1),('00:10:56','Sodick Co., Ltd.','Sodick Co., Ltd.3-12-1 NakamachidaiTsuzuki-ku, Yokohama Kanagawa 224Japan',1),('00:10:57','Rebel.com, Inc.','Rebel.com, Inc.150 Isabella Street--ste. 1000Ottawa, Ontario K1s 1v7Canada',1),('00:10:58','Arrowpoint Communications','Arrowpoint Communications235 Littleton RoadWestford Ma 01886United States',1),('00:10:59','Diablo Research Co. Llc','Diablo Research Co. Llc825 Stewart DriveSunnyvale Ca 94086United States',1),('00:10:5A','3com Corporation','3com Corporation5400 Bayfront PlazaMailstop:  4220Santa Clara Ca 95052United States',1),('00:10:5B','Net Insight Ab','Net Insight AbVstberga All 9Se-1260 30 HgerstenSweden',1),('00:10:5C','Quantum Designs (h.k.) Ltd.','Quantum Designs (h.k.) Ltd.5/f., Somerset House, Taikoo Place979 Kings Road,Quarry BayHong Kong',1),('00:10:5D','Draeger Medical','Draeger MedicalMoislinger Allee 53-55Luebeck  D-23542Germany',1),('00:10:5E','Hekimian Laboratories, Inc.','Hekimian Laboratories, Inc.15200 Omega DriveRockville Md 20850-3240United States',1),('00:10:5F','In-snec','In-snec2 Rue De Caen14740 Bretteville LorgueilleuseFrance',1),('00:10:60','Billionton Systems, Inc.','Billionton Systems, Inc.3f-1, No. 8, Lane 99Pu-ding Rd.Hsin-chuTaiwan, Republic Of China',1),('00:10:61','Hostlink Corp.','Hostlink Corp.10f-1, No. 181Sec.1, Ta-tung Rd.Hsi-chih, TaipeiTaiwan, Republic Of China',1),('00:10:62','Nx Server, Ilnc.','Nx Server, Ilnc.5401 E. La Palma Ave.Anaheim Ca 92807United States',1),('00:10:63','Starguide Digital Networks','Starguide Digital Networks5754 Pacific Center Blvd.San Diego Ca 92121United States',1),('00:10:64','Dnpg, Llc','Dnpg, Llc20 North Wentworth AvenueLondonderry Nh 03053United States',1),('00:10:65','Radyne Corporation','Radyne Corporation5225 S. 37th StreetPhoenix Az 85040United States',1),('00:10:66','Advanced Control Systems, Inc.','Advanced Control Systems, Inc.2755 Northwoods ParkwayNorcross Ga 30071United States',1),('00:10:67','Redback Networks, Inc.','Redback Networks, Inc.2570 North 1st StreetSuite #410San Jose Ca 95131United States',1),('00:10:68','Comos Telecom','Comos TelecomSaehan B/d/, 27-1 Supyo-dongChung-gu, Seoul 100-230Korea, Republic Of',1),('00:10:69','Helioss Communications, Inc.','Helioss Communications, Inc.391 Tottem Pond Rd.- Ste#303Waltham Ma 02154United States',1),('00:10:6A','Digital Microwave Corporation','Digital Microwave Corporation170 Rose Orchard WaySan Jose Ca 95134United States',1),('00:10:6B','Sonus Networks, Inc.','Sonus Networks, Inc.5 Carlisle RoadWestford Ma 01886United States',1),('00:10:6C','Infratec Ag','Infratec AgWerner-von-siemens-str. 764625 BensheimGermany',1),('00:10:6D','Axxcelera Broadband Wireless','Axxcelera Broadband Wireless1600 East Parham RoadRichmond Va 23228United States',1),('00:10:6E','Tadiran Com. Ltd.','Tadiran Com. Ltd.26 Hashoftim St.Holon  58102Israel',1),('00:10:6F','Trenton Technology Inc.','Trenton Technology Inc.2350 Centennial DriveGainesville Ga 30504United States',1),('00:10:70','Caradon Trend Ltd.','Caradon Trend Ltd.P.o. Box 34, HorshamWest Sussex, Rh12 2yf EnglandUnited Kingdom',1),('00:10:71','Advanet Inc.','Advanet Inc.3-20-8 NodaOkayami 700Japan',1),('00:10:72','Gvn Technologies, Inc.','Gvn Technologies, Inc.8200 Bryan Dairy RoadSuite #100Largo Fl 33777United States',1),('00:10:73','Technobox, Inc.','Technobox, Inc.140 Mount Holly BypassUnit 1Lumberton Nj 08048United States',1),('00:10:74','Aten International Co., Ltd.','Aten International Co., Ltd.12f, No.101, Sung Chiang Rd.Taipei, 10428Taiwan, Republic Of China',1),('00:10:75','Maxtor Corporation','Maxtor Corporation2452 Clover Basin Dr.Logmont Co 80503United States',1),('00:10:76','Eurem Gmbh','Eurem GmbhJulicher Str. 338bD-52070 AachenGermany',1),('00:10:77','Saf Drive Systems, Ltd.','Saf Drive Systems, Ltd.88 Ardelt Ave.Kitchener, Ontario N2c 2c9Canada',1),('00:10:78','Nuera Communications, Inc.','Nuera Communications, Inc.10445 Pacific Center CourtSan Diego Ca 92121United States',1),('00:10:79','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr.San Jose Ca 95134-1706United States',1),('00:10:7A','Ambicom, Inc.','Ambicom, Inc.2450 Scott Blvd., #305Santa Clara Ca 95050United States',1),('00:10:7B','Cisco Systems, Inc.','Cisco Systems, Inc.170 W.tasman Dr.-sja-2San Jose Ca 95134-1706United States',1),('00:10:7C','P-com, Inc.','P-com, Inc.3175 S. Winchester Blvd.Campbell Ca 95008United States',1),('00:10:7D','Aurora Communications, Ltd.','Aurora Communications, Ltd.P.o. Box 1942Macquarie Centre, North RydeNsw 2113Australia',1),('00:10:7E','Bachmann Electronic Gmbh','Bachmann Electronic GmbhKreuzaeckerweg 33A 6806 FeldkirchAustria',1),('00:10:7F','Crestron Electronics, Inc.','Crestron Electronics, Inc.101 BroadwayCresskill Nj 07626United States',1),('00:10:80','Metawave Communications','Metawave Communications8700 148th Avenue N.e.Redmond Wa 98052United States',1),('00:10:81','Dps, Inc.','Dps, Inc.4922 East Yale AvenueFresno Ca 93727United States',1),('00:10:82','Jna Telecommunications Limited','Jna Telecommunications Limited16 Smith St, ChatswoodNsw 2067Australia',1),('00:10:83','Hewlett-packard Company','Hewlett-packard CompanyMail Stop 42le110000 Wolfe RoadCupertino Ca 95014United States',1),('00:10:84','K-bot Communications','K-bot CommunicationsP.o. Box 410Norton Ma 02766United States',1),('00:10:85','Polaris Communications, Inc.','Polaris Communications, Inc.10200 Sw Allen Blvd.Beaverton Or 97005United States',1),('00:10:86','Atto Technology, Inc.','Atto Technology, Inc.155 Crosspoint Pkwy.Amherst Ny 14068United States',1),('00:10:87','Xstreamis Plc','Xstreamis PlcOxford Science ParkG10.  2 Magdalen Centre Robert RobinsonOxford 0x4 4ga EnglandUnited States',1),('00:10:88','American Networks Inc.','American Networks Inc.6800 Orangethorpe Ave. #aBuena Park Ca 90620United States',1),('00:10:89','Websonic','Websonic3466 Edward Ave.Santa Clara Ca 95054United States',1),('00:10:8A','Teralogic, Inc.','Teralogic, Inc.707 California StreetMountain View Ca 94041United States',1),('00:10:8B','Laseranimation Sollinger Gmbh','Laseranimation Sollinger GmbhCrellestr. 19/20D 10827 BerlinGermany',1),('00:10:8C','Fujitsu Telecommunications Europe, Ltd.','Fujitsu Telecommunications Europe, Ltd.Solihull ParkwayBirmingham Business ParkBirmingham B37 7yu EnglandUnited Kingdom',1),('00:10:8D','Johnson Controls, Inc.','Johnson Controls, Inc.507 E. Michigan St.P.o. Box 423 / M73Milwaukee Wi 53201United States',1),('00:10:8E','Hugh Symons Concept Technologies Ltd.','Hugh Symons Concept Technologies Ltd.Alder Hills Park16 Alder HillsPoole, Dorset Bm12 4arUnited Kingdom',1),('00:10:8F','Raptor Systems','Raptor Systems69 Hickory Ave.Waltham Ma 02154United States',1),('00:10:90','Cimetrics, Inc.','Cimetrics, Inc.55 Temple PlaceBoston Ma 02111United States',1),('00:10:91','No Wires Needed Bv','No Wires Needed BvP.o. Box 3433720 Ah BilthovenNetherlands',1),('00:10:92','Netcore Inc.','Netcore Inc.12f-2, 537, Sec.2Kuang-fu Road,HsinchuTaiwan, Republic Of China',1),('00:10:93','Cms Computers, Ltd.','Cms Computers, Ltd.201 ArcadiaNariman PointMumbai 400 0021India',1),('00:10:94','Performance Analysis Broadband, Spirent Plc','Performance Analysis Broadband, Spirent Plc27349 Agoura RoadCalabasas Hills Ca 91301United States',1),('00:10:95','Thomson Inc.','Thomson Inc.101 West 103rd StreetIndianapolis In 46290-1102United States',1),('00:10:96','Tracewell Systems, Inc.','Tracewell Systems, Inc.567 Enterprise DriveWesterville Oh 43081United States',1),('00:10:97','Winnet Metropolitan Communications Systems, Inc.','Winnet Metropolitan Communications Systems, Inc.661 East Arques Ave.Sunnyvale Ca 94086United States',1),('00:10:98','Starnet Technologies, Inc.','Starnet Technologies, Inc.2210 Otoole Ave.San Jose Ca 95131United States',1),('00:10:99','Innomedia, Inc.','Innomedia, Inc.4800 Great America ParkwaySuite #400Santa Clara Ca 95054United States',1),('00:10:9A','Netline','Netline7, Rue De Bievres92140 ClamartFrance',1),('00:10:9B','Emulex Corporation','Emulex Corporation3333 Susan StreetCosta Mesa Ca 92626United States',1),('00:10:9C','M-system Co., Ltd.','M-system Co., Ltd.1-1-25 Shin Urashima ChouKanagawa-kuYokohama 221Japan',1),('00:10:9D','Clarinet Systems, Inc.','Clarinet Systems, Inc.1415 Koll Circle #101San Jose Ca 95112United States',1),('00:10:9E','Aware, Inc.','Aware, Inc.One Oak ParkBedford Ma 01730United States',1),('00:10:9F','Pavo, Inc.','Pavo, Inc.95 Yesler WaySeattle Wa 98104United States',1),('00:10:A0','Innovex Technologies, Inc.','Innovex Technologies, Inc.Keystone Commons526 Braddock Ave.Turtle Creek Pa 15145United States',1),('00:10:A1','Kendin Semiconductor, Inc.','Kendin Semiconductor, Inc.1550 S. Bascom Ave., Ste. #250Campbell Ca 95008United States',1),('00:10:A2','Tns','Tns800 Third Street, Suite B100Herndon Va 20170United States',1),('00:10:A3','Omnitronix, Inc.','Omnitronix, Inc.760 Harrison StreetSeattle Wa 98109United States',1),('00:10:A4','Xircom','Xircom2300 Corporate Center Dr.Thousand Oaks Ca 91320United States',1),('00:10:A5','Oxford Instruments','Oxford InstrumentsIndustrial Analysis Group19/20 Nuffield WayAbingdon, Oxon Ox14 1txUnited Kingdom',1),('00:10:A6','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:10:A7','Unex Technology Corporation','Unex Technology Corporation8f-5, #130, Sze Wei Rd.,HsinchuTaiwan, Republic Of China',1),('00:10:A8','Reliance Computer Corp.','Reliance Computer Corp.3032 Bunker Hill LaneSuite 201Santa Clara Ca 95054United States',1),('00:10:A9','Adhoc Technologies','Adhoc Technologies1150 First StreetSan Jose Ca 95112United States',1),('00:10:AA','Media4, Inc.','Media4, Inc.250 14th St. Nw - Ste #4002Atlanta Ga 30318United States',1),('00:10:AB','Koito Industries, Ltd.','Koito Industries, Ltd.100 Maeda-cho, Totsuka-kuYokohama 244Japan',1),('00:10:AC','Imci Technologies','Imci Technologies8401 Old Court Hkouse RdSuite #200Vienna Va 22182United States',1),('00:10:AD','Softronics Usb, Inc.','Softronics Usb, Inc.5085 List DriveColorado Springs Co 80919United States',1),('00:10:AE','Shinko Electric Industries Co.','Shinko Electric Industries Co.80 Oshimada-machiNagano-shi 381-22Japan',1),('00:10:AF','Tac Systems, Inc.','Tac Systems, Inc.1035 Putman Drive--ste.Huntsville Al 35816-2271United States',1),('00:10:B0','Meridian Technology Corp.','Meridian Technology Corp.11 Mcbride Corp. Center Dr.Chesterfield Md 63005United States',1),('00:10:B1','For-a Co., Ltd.','For-a Co., Ltd.2-3-3 OosakuSakura City,Chiba Pref. 285Japan',1),('00:10:B2','Coactive Aesthetics','Coactive Aesthetics4000 Bridgeway - Ste. #303Sausalita Ca 94965United States',1),('00:10:B3','Nokia Multimedia Terminals','Nokia Multimedia TerminalsNokia Home CommunicationsDiskettgatan 11Se-583 35 LinkopingSweden',1),('00:10:B4','Atmosphere Networks','Atmosphere Networks10460 Bandley DriveCupertino Ca 95014United States',1),('00:10:B5','Accton Technology Corporation','Accton Technology CorporationNo.1, Creation Rd. IiiScience-based Industrial ParkHsinchu 300Taiwan, Republic Of China',1),('00:10:B6','Entrata Communications Corp.','Entrata Communications Corp.574 Heritage Rd.Southbury Ct 06488United States',1),('00:10:B7','Coyote Technologies, Llc','Coyote Technologies, Llc4360 Park Terrace DriveWestlake Village Ca 91361United States',1),('00:10:B8','Ishigaki Computer System Co.','Ishigaki Computer System Co.1-1-1, Kyobashi,Chuo-kuTokyoJapan',1),('00:10:B9','Maxtor Corp.','Maxtor Corp.2190 Miller DriveLongmont Co 80501-6744United States',1),('00:10:BA','Martinho-davis Systems, Inc.','Martinho-davis Systems, Inc.1260 Old Innes RoadOttawa, Ontario K1b 3v3Canada',1),('00:10:BB','Data & Information Technology','Data & Information TechnologyTechnology House1 Normanton LaneBottesford, Nottingham Ng13 OelUnited Kingdom',1),('00:10:BC','Aastra Telecom','Aastra Telecom8 Federal StreetBillerica Ma 01821-3570United States',1),('00:10:BD','The Telecommunication Technology Committee','The Telecommunication Technology Committee1-2-11, Hamamatsu-choMinato-ku, Tokyo 105Japan',1),('00:10:BE','Telexis Corp.','Telexis Corp.2427 Holly LaneOttawa, Ontario K1v 7p2  7p2Canada',1),('00:10:BF','Interair Wireless','Interair Wireless485 Cayuga RoadBuffalo Ny 14225-0222United States',1),('00:10:C0','Arma, Inc.','Arma, Inc.6255 Ferris SquareSan Diego Ca 92121United States',1),('00:10:C1','Oi Electric Co., Ltd.','Oi Electric Co., Ltd.7-3-16 KikunaKohoku-kuYokohama  222Japan',1),('00:10:C2','Willnet, Inc.','Willnet, Inc.Jowa-takanawa  Bldg. 8fTakanawa 1-5-4, Minato-ku,TokyoJapan',1),('00:10:C3','Csi-control Systems','Csi-control SystemsInternationalPob 59469Dallas Tx 75229United States',1),('00:10:C4','Media Links Co., Ltd.','Media Links Co., Ltd.Ksp East Bldg. 604, Sakado 3-2-1,Takatsu-ku Kawasaki-shi,Kanagawa-ken 214Japan',1),('00:10:C5','Protocol Technologies, Inc.','Protocol Technologies, Inc.4 First StreetBridgewater Ma 02324United States',1),('00:10:C6','Usi','Usi141, Lane 351, Taiping Rd.Sec.1,Tsao Tuen, Nan-tou 542Taiwan, Republic Of China',1),('00:10:C7','Data Transmission Network','Data Transmission Network9110 W. Dodge Rd. - Ste.#200Omaha Ne 68114United States',1),('00:10:C8','Communications Electronics Security Group','Communications Electronics Security Group10/4w22 Fiddlers Green LaneBenhall, Cheltenham Glouster Gl52 5ajUnited Kingdom',1),('00:10:C9','Mitsubishi Electronics Logistic Support Co.','Mitsubishi Electronics Logistic Support Co.',1),('00:10:CA','Integral Access','Integral Access2021 Midwest Road,  Ste #203Oakbrook Il 60521United States',1),('00:10:CB','Facit K.k.','Facit K.k.Himei Nihombashi Bldg. 3f12-3-nihombashi-kobunachoChuo-ku, Tokyo 103Japan',1),('00:10:CC','Clp Computer Logistik Planung Gmbh','Clp Computer Logistik Planung GmbhBassermannstr. 21D-81245 MuenchenGermany',1),('00:10:CD','Interface Concept','Interface Concept3 Venelle De Kergos29000 QuimperFrance',1),('00:10:CE','Volamp, Ltd.','Volamp, Ltd.Unit 3 Riverside Business ParkDogflud Way,Farnham, Surrey EnglandUnited Kingdom',1),('00:10:CF','Fiberlane Communications','Fiberlane Communications1318 Redwood Way, #200Petaluma Ca 94954United States',1),('00:10:D0','Witcom, Ltd.','Witcom, Ltd.P.o.b. 2250Haifa  31021Israel',1),('00:10:D1','Top Layer Networks, Inc.','Top Layer Networks, Inc.4 Mechanic St.- Ste#212Natick Ma 01760United States',1),('00:10:D2','Nitto Tsushinki Co., Ltd','Nitto Tsushinki Co., Ltd7-27-11, Todoroki, Setagaya-kuTokyo 151Japan',1),('00:10:D3','Grips Electronic Gmbh','Grips Electronic GmbhNiesenbergergasse 37A-8020 GrazAustria',1),('00:10:D4','Storage Computer Corporation','Storage Computer Corporation11 Riverside StreetNashua Nh 03062United States',1),('00:10:D5','Imasde Canarias, S.a.','Imasde Canarias, S.a.Urb. El CebadalC/dr. Juan Dguez.perez, 39-235008 Las Palmas G.c.Spain',1),('00:10:D6','Itt - A/cd','Itt - A/cdDept. 8521100 Kingsland RoadClifton Nj 07014United States',1),('00:10:D7','Argosy Research Inc.','Argosy Research Inc.No. 44, Lane 411, Chung Hua RdSec.4, HsinchuTaiwan, Republic Of China',1),('00:10:D8','Calista','Calista98 High Street, ThameOxfordshire Ox9 3eh EnglandUnited Kingdom',1),('00:10:D9','Ibm Japan, Fujisawa Mt+d','Ibm Japan, Fujisawa Mt+dKirihara-cho 1, Fujisawa CityKanagawa 252Japan',1),('00:10:DA','Motion Engineering, Inc.','Motion Engineering, Inc.33 S.la Patera LnSanta Barbara Ca 93117United States',1),('00:10:DB','Juniper Networks, Inc.','Juniper Networks, Inc.1194 N. Mathilda AvenueSunnyvale Ca 94010United States',1),('00:10:DC','Micro-star International Co., Ltd.','Micro-star International Co., Ltd.No. 69, Li-de St., Jung-he CityTaipei HsienTaiwan, Republic Of China',1),('00:10:DD','Enable Semiconductor, Inc.','Enable Semiconductor, Inc.1740 Technology DriveSuite #110San Jose Ca 95110United States',1),('00:10:DE','International Datacasting Corporation','International Datacasting Corporation2680 Queensview DriveOttawa, Ontario K2b 8h6Canada',1),('00:10:DF','Rise Computer Inc.','Rise Computer Inc.9f, No. 306-3, Tatung Rd.Sec. 1, Hsi Chih,Taipei HsienTaiwan, Republic Of China',1),('00:10:E0','Sun Microsystems, Inc.','Sun Microsystems, Inc.4200 Network CircleSanta Clara Ca 95054United States',1),('00:10:E1','S.i. Tech, Inc.','S.i. Tech, Inc.P.o. Box 609Geneva Il 60134United States',1),('00:10:E2','Arraycomm, Inc.','Arraycomm, Inc.3141 Zanker RoadSan Jose Ca 95134United States',1),('00:10:E3','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:10:E4','Nsi Corporation','Nsi CorporationP.o. Box 635Wilsonville Or 97070United States',1),('00:10:E5','Solectron Texas','Solectron Texas12455 Research Blvd. M/s 2205Austin Tx 78759United States',1),('00:10:E6','Applied Intelligent Systems, Inc.','Applied Intelligent Systems, Inc.3923 Ranchero DriveAnn Arbor Mi 48108United States',1),('00:10:E7','Breezecom','BreezecomPo Box 13139Atidim Technological Park, Bldg. 1Tel-avivIsrael',1),('00:10:E8','Telocity, Incorporated','Telocity, Incorporated992 South De Anza BlvdSan Jose Ca 95129United States',1),('00:10:E9','Raidtec Ltd.','Raidtec Ltd.Castle RoadLittle Island Industrial EstateLittle Island County CorkIreland',1),('00:10:EA','Adept Technology','Adept Technology150 Rose Orchard WaySan Jose Ca 95134United States',1),('00:10:EB','Selsius Systems, Inc.','Selsius Systems, Inc.5057 Keller Springs Rd.Dallas Tx 75248United States',1),('00:10:EC','Rpcg, Llc','Rpcg, Llc749 Miner RoadHighland Hts Oh 44143-2117United States',1),('00:10:ED','Sundance Technology, Inc.','Sundance Technology, Inc.20111 Stevens Creek Blvd.Suite #138Cupertino Ca 95014United States',1),('00:10:EE','Cti Products, Inc.','Cti Products, Inc.1211 W. Sharon Rd.Cincinnati Oh 45240United States',1),('00:10:EF','Dbtel Incorporated','Dbtel IncorporatedNo.29 Tzu-chiang St.,Tu-cheng TaipeiTaiwan, Republic Of China',1),('00:10:F1','I-o Corporation','I-o Corporation2256 South 3600 WestSalt Lake City Ut 84119United States',1),('00:10:F2','Antec','Antec4920 Avalon Ridge PkwySuite #600Norcross Ga 30071United States',1),('00:10:F3','Nexcom International Co., Ltd.','Nexcom International Co., Ltd.18f, No. 716, Chung-cheng Road,Chung Ho,Taipei Hsien 235,Taiwan, Republic Of China',1),('00:10:F4','Vertical Communications','Vertical Communications3979 Freedom Circle #400Santa Clara Ca 95054-1247United States',1),('00:10:F5','Amherst Systems, Inc.','Amherst Systems, Inc.30 Wilson RoadBuffalo Ny 14221United States',1),('00:10:F6','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:10:F7','Iriichi Technologies Inc.','Iriichi Technologies Inc.1-26-7 Chuo, Nakana-kuTokyo 164Japan',1),('00:10:F8','Texio Corporation','Texio Corporation1850-1 Tsuruma, Machida-shiTokyo  194-0004Japan',1),('00:10:F9','Unique Systems, Inc.','Unique Systems, Inc.181 Don Park RdMarkham, Ontario L3r 1c2Canada',1),('00:10:FA','Apple Inc','Apple Inc1 Infinite LoopMs 35-gpoCupertino Ca 95014United States',1),('00:10:FB','Zida Technologies Limited','Zida Technologies Limited8/f Block A  Goodview Industrial BuildinKin Fat Str Tmtl 213Tuen Mun NtHong Kong',1),('00:10:FC','Broadband Networks, Inc.','Broadband Networks, Inc.37 Stevenson RoadWinnipeg, Manitoba R3h 0h9Canada',1),('00:10:FD','Cocom A/s','Cocom A/sTeletonvej 8Dk 2860 SoborgDenmark',1),('00:10:FE','Digital Equipment Corporation','Digital Equipment Corporation301 Rockrimmon Blvd, SouthM/s Cxo1-2/n26Colorado Springs Co 80919United States',1),('00:10:FF','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:11:00','Schneider Electric','Schneider Electric5460 Pottsville PikeLeesport Pa 19533United States',1),('00:11:01','Cet Technologies Pte Ltd','Cet Technologies Pte Ltd100 Jurong East Street 21Singapore Technologies Building609602Singapore',1),('00:11:02','Aurora Multimedia Corp.','Aurora Multimedia Corp.205 Commercial CourtMorganville New Jersey 07751-1070United States',1),('00:11:03','Kawamura Electric Inc.','Kawamura Electric Inc.3-86 Akatsuki-choSeto Aichi 489-0071Japan',1),('00:11:04','Telexy','Telexy1116, Hyundai 41 Tower, 917-9Mok-dong, Yangchun-ku,Seoul  158-723Korea, Republic Of',1),('00:11:05','Sunplus Technology Co., Ltd.','Sunplus Technology Co., Ltd.19, Innovation First Road, Hsinchu Science ParkHsinchu  300Taiwan, Republic Of China',1),('00:11:06','Siemens Nv (belgium)','Siemens Nv (belgium)Atealaan 34Herentals Antwerp 2200Belgium',1),('00:11:07','Rgb Networks Inc.','Rgb Networks Inc.2929 Campus DriveSuite 165San Mateo Ca 94403United States',1),('00:11:08','Orbital Data Corporation','Orbital Data Corporation1900 S. Norfolk St. Ste 320San Mateo Ca 94403United States',1),('00:11:09','Micro-star International','Micro-star InternationalNo 69, Li-de Street, Jung-he City,TaipeiTaiwan, Republic Of China',1),('00:11:0A','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms070405Houston Tx 77070United States',1),('00:11:0B','Franklin Technology Systems','Franklin Technology Systems20406 Earl StTorrance Ca 90503United States',1),('00:11:0C','Atmark Techno, Inc.','Atmark Techno, Inc.2f Sd Bldg, 2-2-3-14 Atsubetsu-nishi, Atsubetsu-kuSapporo Hokkaido 004-0062Japan',1),('00:11:0D','Sanblaze Technology, Inc.','Sanblaze Technology, Inc.2 Clock Tower PlaceMaynard Ma 01748United States',1),('00:11:0E','Tsurusaki Sealand Transportation Co. Ltd.','Tsurusaki Sealand Transportation Co. Ltd.1000 MisaOita  8700196Japan',1),('00:11:0F','Netplat,inc.','Netplat,inc.2f Olympia Center, 828-10, Yeoksam-dong, Gangnam-guSeoul  135-935Korea, Republic Of',1),('00:11:10','Maxanna Technology Co., Ltd.','Maxanna Technology Co., Ltd.Room201, No.42-3, Luyuan RoadGuangzhou  510095China',1),('00:11:11','Intel Corporation','Intel Corporation2111 Ne 25th AvenueHillsboro Or 97123United States',1),('00:11:12','Honeywell Cmss','Honeywell Cmss8323 Lindbergh CtSarasota Fl 34243United States',1),('00:11:13','Fraunhofer Fokus','Fraunhofer FokusKaiserin-augusta-allee 31Berlin  10589Germany',1),('00:11:14','Everfocus Electronics Corp.','Everfocus Electronics Corp.12f, No. 79, Sec. 1, Shin-tai Wu Rd.Hsi-chi Taipei Hsien 221Taiwan, Republic Of China',1),('00:11:15','Epin Technologies, Inc.','Epin Technologies, Inc.Acorn Campus6th Result Way, Suite 248Cupertino Ca 95014United States',1),('00:11:16','Coteau Vert Co., Ltd.','Coteau Vert Co., Ltd.3-3-19 KachidokiChuo-ku Tokyo 104-0054Japan',1),('00:11:17','Cesnet','CesnetZikova 4Praha 6  160 00Czech Republic',1),('00:11:18','Blx Ic Design Corp., Ltd.','Blx Ic Design Corp., Ltd.Rm 1006, Quantum PlazaNo.27, Zhichun Rd, HaidanBeijing  100083China',1),('00:11:19','Solteras, Inc.','Solteras, Inc.900 W. Santa Anita StreetSan Gabriel Ca 91776United States',1),('00:11:1A','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:11:1B','Targa Systems Div L-3 Communications Canada','Targa Systems Div L-3 Communications Canada2081 Merivale RdSuite 200Ottawa Ont K2g 1g9Canada',1),('00:11:1C','Pleora Technologies Inc.','Pleora Technologies Inc.359 Terry Fox Drive, Suite 230Kanata On K2k 2e7Canada',1),('00:11:1D','Hectrix Limited','Hectrix LimitedUnit 906-911, 9/f, Stanhope Hosue,734-738 Kings Road,North Point Hong KongChina',1),('00:11:1E','Epsg (ethernet Powerlink Standardization Group)','Epsg (ethernet Powerlink Standardization Group)C/o University Of Applied SciencesPo Box 805Winterthur Zh Ch-8401Switzerland',1),('00:11:1F','Doremi Labs, Inc.','Doremi Labs, Inc.306 E. Alameda Ave.Burbank Ca 91502United States',1),('00:11:20','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:21','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:22','Cimsys Inc','Cimsys Inc#301,sinsung-clean Bldg,140, Nongseo-ri,kiheung-eupYongin-city Kyunggi-do 449-711Korea, Republic Of',1),('00:11:23','Appointech, Inc.','Appointech, Inc.6f-2 No.192 Tung-kuan Rd.Hsinchu  300Taiwan, Republic Of China',1),('00:11:24','Apple Computer','Apple Computer1 Inifinite LoopCupertino Ca 95014United States',1),('00:11:25','Ibm Corporation','Ibm Corporation3039 E Cornwallis RdP.o. Box 12195Research Triangle Park Nc 27709-2195United States',1),('00:11:26','Venstar Inc.','Venstar Inc.9250 Owensmouth Ave.Chatsworth Ca 91311United States',1),('00:11:27','Tasi, Inc','Tasi, Inc5551 Dry Fork RoadCleves Oh 45002United States',1),('00:11:28','Streamit','StreamitFlight Forum 3543Eindhoven 5657 DwNetherlands',1),('00:11:29','Paradise Datacom Ltd.','Paradise Datacom Ltd.1 Wheaton RoadWitham Essex Uk Cm8 1ujUnited Kingdom',1),('00:11:2A','Niko Nv','Niko NvIndustriepark West 40Sint-niklaas O/v 9100Belgium',1),('00:11:2B','Netmodule','NetmoduleMeriedweg 11Niederwangen Ch 3172Switzerland',1),('00:11:2C','Izt Gmbh','Izt GmbhAm Weichselgarten 5Erlangen Bavaria 91058Germany',1),('00:11:2D','Ipulse Systems','Ipulse Systems1st Floor Novell House, Morningside Wedge Office Park255 Rivonia RoadMorningside Johannesburg 2128South Africa',1),('00:11:2E','Ceicom','Ceicom17 Rue Gaston EvrardToulouse Cedex 1 Haute-garonne 31094France',1),('00:11:2F','Asustek Computer Inc.','Asustek Computer Inc.No.150, Li-te Rd., PeitouTaipei  112Taiwan, Republic Of China',1),('00:11:30','Allied Telesis (hong Kong) Ltd.','Allied Telesis (hong Kong) Ltd.Room F, 3/f, Yeung Yiu Chong (no. 8) Industrial Building,20 Wang Hoi Road, Kowloon Bay,Hong Kong',1),('00:11:31','Unatech. Co.,ltd','Unatech. Co.,ltdA-727 ,geopyung Town,203-1Nonhyung-dongKangnam-gu Seoul 135-010Korea, Republic Of',1),('00:11:32','Synology Incorporated','Synology Incorporated6f-2, No.106, Chang An W. Rd.,Taipei  103Taiwan, Republic Of China',1),('00:11:33','Siemens Austria Simea','Siemens Austria SimeaSiemensstrasse 90-92Vienna  1210Austria',1),('00:11:34','Mediacell, Inc.','Mediacell, Inc.600 17th StSuite 2800 SouthDenver Co 80202United States',1),('00:11:35','Grandeye Ltd','Grandeye Ltd6 Huxley RoadSurrey Research ParkGuildford Surrey Gu2 7reUnited Kingdom',1),('00:11:36','Goodrich Sensor Systems','Goodrich Sensor Systems14300 Judicial RoadBurnsville Minnesota 55306-4898United States',1),('00:11:37','Aichi Electric Co., Ltd.','Aichi Electric Co., Ltd.1Aichi-choKasugai City Aichi Pref. 486-8666Japan',1),('00:11:38','Taishin Co., Ltd.','Taishin Co., Ltd.200-7 NakanoNakano Nagano 383-0013Japan',1),('00:11:39','Stoeber Antriebstechnik Gmbh + Co. Kg.','Stoeber Antriebstechnik Gmbh + Co. Kg.Kieselbronner Str. 12Pforzheim  75177Germany',1),('00:11:3A','Shinboram','Shinboram4f Dahnworld Building, 154-11 Samsung-dongKangnam-gu,Seoul  135-879Korea, Republic Of',1),('00:11:3B','Micronet Communications Inc.','Micronet Communications Inc.12f-1, No. 100, Min-chuan RoadHsin-tien Taipei 231Taiwan, Republic Of China',1),('00:11:3C','Micronas Gmbh','Micronas GmbhHans-bunte-strasse 19Freiburg Bw D-79108Germany',1),('00:11:3D','Kn Soltec Co.,ltd.','Kn Soltec Co.,ltd.98b-5l Namdong Industrial Complex #662-4 Gojan-dongNamdong-gu Incheon 405-818Korea, Republic Of',1),('00:11:3E','Jl Corporation','Jl Corporation4-4-17 SugeTama-kuKawasaki-city Kanagawa-ken 214-0001Japan',1),('00:11:3F','Alcatel Di','Alcatel DiZi LavoisierEu Normandie 76260France',1),('00:11:40','Nanometrics Inc.','Nanometrics Inc.250 Herzberg Rd.Kanata Ontario K2k 2a1Canada',1),('00:11:41','Goodman Corporation','Goodman Corporation2f, No.572, Sec.1, Ming-sheng N Road, Kwei-shan HsiangTaoyuan Hsien  33300Taiwan, Republic Of China',1),('00:11:42','E-smartcom  Inc.','E-smartcom  Inc.3f, 216, Imok-dongJangan-kuSuwon Kyoungki-do 440-310Korea, Republic Of',1),('00:11:43','Dell Inc.','Dell Inc.One Dell WayRr5 Ms-8545Round Rock Texas 78682United States',1),('00:11:44','Assurance Technology Corp','Assurance Technology Corp6304 Potomac AvenueAlexandria Virginia 22307United States',1),('00:11:45','Valuepoint Networks','Valuepoint Networks350 Townsend St Ste 320San Francisco, Ca 94107United States',1),('00:11:46','Telecard-pribor Ltd','Telecard-pribor LtdLustdorfskaya Doroga, 162Odessa  65115Ukraine',1),('00:11:47','Secom-industry Co.ltd.','Secom-industry Co.ltd.Fukuo Kakuramoto Ichihonki 3-3Shiroishi Miyagi 989-0295Japan',1),('00:11:48','Prolon Control Systems','Prolon Control SystemsHerstedvesterstraede 56Albertslund  Dk-2620Denmark',1),('00:11:49','Proliphix Inc.','Proliphix Inc.66 Tadmuck Rd.Westford Ma 01886United States',1),('00:11:4A','Kayaba Industry Co,.ltd.','Kayaba Industry Co,.ltd.World Trade Center Bldg., 4-1Hamamatsu-cho 2-chome,Minato-ku, Tokyo Meto. 105-6111Japan',1),('00:11:4B','Francotyp-postalia Ag & Co. Kg','Francotyp-postalia Ag & Co. KgTriftweg 21-26Birkenwerder Brandenburg 16547Germany',1),('00:11:4C','Caffeina Applied Research Ltd.','Caffeina Applied Research Ltd.125 Baird AveCochrane Alberta T4c 1c7Canada',1),('00:11:4D','Atsumi Electric Co.,ltd.','Atsumi Electric Co.,ltd.4-2-2 Shin-miyakoda, Kita-kuHamamatsu Shizuoka 431-2103Japan',1),('00:11:4E','690885 Ontario Inc.','690885 Ontario Inc.205 Annagem Blvd.Mississauga Ontario L5t 2v1Canada',1),('00:11:4F','Us Digital Television, Inc','Us Digital Television, Inc5807 N. Andrews WayFort Lauderdale Fl 33309United States',1),('00:11:50','Belkin Corporation','Belkin Corporation501 West Walnut StreetCompton Ca 90220-5221United States',1),('00:11:51','Mykotronx','Mykotronx359 Van Ness WayTorrance Ca 90501United States',1),('00:11:52','Eidsvoll Electronics As','Eidsvoll Electronics AsNedre Vilberg Vei 8Eidsvoll  N-2080Norway',1),('00:11:53','Trident Tek, Inc.','Trident Tek, Inc.8041 Cessna Ave #200Gaithersburg Md 20879United States',1),('00:11:54','Webpro Technologies Inc.','Webpro Technologies Inc.2f-1, No.81, Sec. 4, Chungching N. Rd.,Shrlin ChiuTaipei  111Taiwan, Republic Of China',1),('00:11:55','Sevis Systems','Sevis Systems2805 N Dallas Parkway, Ste 530Plano Texas 75093United States',1),('00:11:56','Pharos Systems Nz','Pharos Systems NzLevel 3, 123 Carlton Gore RoadGraftonAuckland Nz 1001New Zealand',1),('00:11:57','Of Networks Co., Ltd.','Of Networks Co., Ltd.1-3-cb4 Nakase, Mihama-kuChiba City Chiba 261-8501Japan',1),('00:11:58','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:11:59','Matisse Networks Inc','Matisse Networks Inc339 N Bernardo AveMountain View Ca 94043United States',1),('00:11:5A','Ivoclar Vivadent Ag','Ivoclar Vivadent AgBendererstrasse 2Schaan  9494Liechtenstein',1),('00:11:5B','Elitegroup Computer System Co. (ecs)','Elitegroup Computer System Co. (ecs)No.22, Alley 38, Lane 91, Sec. 1, Nei Hu Road,Taipei  114Taiwan, Republic Of China',1),('00:11:5C','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:5D','Cisco','Cisco80 West Tasman Dr.Sj-m/2San Jose Ca 95134United States',1),('00:11:5E','Prominent Dosiertechnik Gmbh','Prominent Dosiertechnik GmbhIm Schumachergewann 5-11Heidelberg Bw 69123Germany',1),('00:11:5F','Itx Security Co., Ltd.','Itx Security Co., Ltd.9f Kolon Digital Tower Aston Bldg. 505-14Gasan-dong Geumcheon-gu Seoul 153-803Korea, Republic Of',1),('00:11:60','Artdio Company Co., Ltd','Artdio Company Co., Ltd7th Fl.., No.476, Min-hu Rd., Hsin-chu,Hsinchu  300Taiwan, Republic Of China',1),('00:11:61','Netstreams, Llc','Netstreams, Llc3600 W. Parmer LaneSuite 100Austin Tx 78727United States',1),('00:11:62','Star Micronics Co.,ltd.','Star Micronics Co.,ltd.536 ShimizunanatsushinyaShizuoka  424-0066Japan',1),('00:11:63','System Spa Dept. Electronics','System Spa Dept. ElectronicsVia Ghiarola Vecchia 73Fiorano Modenese Modena I-41042Italy',1),('00:11:64','Acard Technology Corp.','Acard Technology Corp.6f No.78 Sec1 Kwang Fu Road, Sanchung,Taipei Hsien  241Taiwan, Republic Of China',1),('00:11:65','Znyx Networks','Znyx Networks48421 Milmont DriveFremont Ca 94538United States',1),('00:11:66','Taelim Electronics Co., Ltd.','Taelim Electronics Co., Ltd.196-5, Anyang7-dong Manan-guAnyang-si Kyuggi-do 430-817Korea, Republic Of',1),('00:11:67','Integrated System Solution Corp.','Integrated System Solution Corp.3f, No. 2-1, Industry East Rd., IScience-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:11:68','Homelogic Llc','Homelogic Llc100 Hoods LaneMarblehead Ma 01945United States',1),('00:11:69','Ems Satcom','Ems SatcomGreen LaneAshchurchTewkesbury Gloucestershire Gl20 8hdUnited Kingdom',1),('00:11:6A','Domo Ltd','Domo LtdWessex HouseUpper Market StreetEastleigh Hampshire So50 9fdUnited Kingdom',1),('00:11:6B','Digital Data Communications Asia Co.,ltd','Digital Data Communications Asia Co.,ltd8f,no.41,lane 221,kang-chien Rd.,nei-hu Dis.,Taipei City  114Taiwan, Republic Of China',1),('00:11:6C','Nanwang Multimedia Inc.,ltd','Nanwang Multimedia Inc.,ltdFloor 12,tianyuan Bldg,wensan Rd#508Hangzhou Zhejiang 310013China',1),('00:11:6D','American Time And Signal','American Time And Signal140 Third St. SouthDassel Mn 55325United States',1),('00:11:6E','Peplink Ltd.','Peplink Ltd.17/f., Park Building476 Castle Peak RoadCheung Sha Wan KowloonHong Kong',1),('00:11:6F','Netforyou Co., Ltd.','Netforyou Co., Ltd.1121-4 3f,  Kwanyang-dong, Dongan-guAnyang-si Kyunggi-do 431-804Korea, Republic Of',1),('00:11:70','Gsc Srl','Gsc SrlVia Per VimercateUsmate Velate Milano 20040Italy',1),('00:11:71','Dexter Communications, Inc.','Dexter Communications, Inc.2f Shinsung B/d 404-1Backhyun-dong, Bundang-guSungnam Gyunggi 463-420Korea, Republic Of',1),('00:11:72','Cotron Corporation','Cotron Corporation12fl,no.150,sec.4,cheng-de RdShihlin DistrictTaipei City  111Taiwan, Republic Of China',1),('00:11:73','Adtron Corporation','Adtron Corporation4415 E Cotton Center BlvdSuite 100Phoenix Az 85040United States',1),('00:11:74','Wibhu Technologies, Inc.','Wibhu Technologies, Inc.1561 Blackhawk DriveSunnyvale Ca 94087United States',1),('00:11:75','Pathscale, Inc.','Pathscale, Inc.477 N. Mathilda Ave.Sunnyvale Ca 94085United States',1),('00:11:76','Intellambda Systems, Inc.','Intellambda Systems, Inc.48501 Warm Springs Blvd, #107Fremont California 94539United States',1),('00:11:77','Coaxial Networks, Inc.','Coaxial Networks, Inc.4633 Old Ironsides DrSanta Clara Ca 95054United States',1),('00:11:78','Chiron Technology Ltd','Chiron Technology LtdWyvols CourtSwallowfieldReading Berkshire Rg7 1wyUnited Kingdom',1),('00:11:79','Singular Technology Co. Ltd.','Singular Technology Co. Ltd.21f, No.37, Sec.2, San Min Rd.,Pan Chiao City, Taipei CountyTaipei  220Taiwan, Republic Of China',1),('00:11:7A','Singim International Corp.','Singim International Corp.6f-2, No. 190, Sec. 2 Chung Hsin Road,Hsin Tien City  231Taiwan, Republic Of China',1),('00:11:7B','Bchi Labortechnik Ag','Bchi Labortechnik AgMeierseggstrasse 40Flawil 9230 SgSwitzerland',1),('00:11:7C','E-zy.net','E-zy.netSmirnis 14Veria Imathia 59100Greece',1),('00:11:7D','Zmd America, Inc.','Zmd America, Inc.15373 Innovation DriveSuite 115San Dieo Ca 92128United States',1),('00:11:7E','Progeny Inc.','Progeny Inc.1407 Barclay BoulevardBuffalo Grove Il 60089United States',1),('00:11:7F','Neotune Information Technology Corporation,.ltd','Neotune Information Technology Corporation,.ltd1703#  No.737  North Of Caoxi Rd.Shanghai  200030China',1),('00:11:80','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:11:81','Interenergy Co.ltd,','Interenergy Co.ltd,4f Shinyokohama Bosei Bldg.3-20-13 Shinyokohama Kohhoku-kuYokohama City Kanagawa 222-0033Japan',1),('00:11:82','Imi Norgren Ltd','Imi Norgren LtdPo Box 22Eastern AvenueLichfield Staffordshire Ws13 6sbUnited Kingdom',1),('00:11:83','Psc Scanning, Inc','Psc Scanning, Inc959 Terry StEugene Or 97402United States',1),('00:11:84','Humo Laboratory,ltd.','Humo Laboratory,ltd.Nishiogi-kita 5-19-11Suginami-ku Tokyo 167-0042Japan',1),('00:11:85','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:11:86','Prime Systems, Inc.','Prime Systems, Inc.16267-333Suwa-gun Hara-mura Nagano 391-0100Japan',1),('00:11:87','Category Solutions, Inc','Category Solutions, Inc1021 W. Adams StChicago Il 60607United States',1),('00:11:88','Enterasys','Enterasys35 Industrial WayRochester Nh 03867United States',1),('00:11:89','Aerotech Inc','Aerotech Inc101 Zeta DrivePittsburgh Pa 15238United States',1),('00:11:8A','Viewtran Technology Limited','Viewtran Technology Limited3/f, R2-a Builiding, High Tech Industrial Park,Nanshan District,Shenzhen Guangdong 518057China',1),('00:11:8B','Alcatel-lucent, Enterprise Business Group','Alcatel-lucent, Enterprise Business Group26801 West Agoura RoadCalabasas Ca 91301United States',1),('00:11:8C','Missouri Department Of Transportation','Missouri Department Of TransportationP.o. Box 270Jefferson City Missouri 65102United States',1),('00:11:8D','Hanchang System Corp.','Hanchang System Corp.715-11 Boeun-town, E-dong, Sangrok-gu,Ansan-shi Kyungki-do 425-857Korea, Republic Of',1),('00:11:8E','Halytech Mace','Halytech MaceUnit 11, 22 Lexington DriveNorwest Business ParkBaulkham Hills Nsw 2153Australia',1),('00:11:8F','Eutech Instruments Pte. Ltd.','Eutech Instruments Pte. Ltd.Blk 55,ayer Rajah Crescent, #04-16/24.139949Singapore',1),('00:11:90','Digital Design Corporation','Digital Design Corporation3820 Ventura DriveArlington Heights Il 60004United States',1),('00:11:91','Cts-clima Temperatur Systeme Gmbh','Cts-clima Temperatur Systeme GmbhLotzencker 21Hechingen Badenwrttemberg 72379Germany',1),('00:11:92','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:93','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:94','Chi Mei Communication Systems, Inc.','Chi Mei Communication Systems, Inc.11f, No.39, Chung Hua Rd. Sec 1Taipei  100Taiwan, Republic Of China',1),('00:11:95','D-link Corporation','D-link Corporation2f No. 233-2, Pao-chiao RoadHsin-tienTaipei TaiwanTaiwan, Republic Of China',1),('00:11:96','Actuality Systems, Inc.','Actuality Systems, Inc.25 Corporate DriveSuite 300Burlington Ma 01803United States',1),('00:11:97','Monitoring Technologies Limited','Monitoring Technologies Limited14 Attenburys Park EstateAttenburys LaneTimperley Cheshire Wa14 5qeUnited Kingdom',1),('00:11:98','Prism Media Products Limited','Prism Media Products LimitedWilliam James HouseCowley RoadCambridge Cambridgeshire Cb4 0wxUnited Kingdom',1),('00:11:99','2wcom Gmbh','2wcom GmbhSchleswiger Strasse 85Flensburg  24941Germany',1),('00:11:9A','Alkeria Srl','Alkeria Srl25 Via GiuntiniNavacchio (pi)  I-56023Italy',1),('00:11:9B','Telesynergy Research Inc.','Telesynergy Research Inc.4f, No. 49, Tung Hsin Rd.,Taipei  110Taiwan, Republic Of China',1),('00:11:9C','Ep&t Energy','Ep&t Energy358 Eastern Valley WayChatswoodSydney Nsw 2067Australia',1),('00:11:9D','Diginfo Technology Corporation','Diginfo Technology Corporation10fl., No.82, Fu Hsing North RoadTaipei  106Taiwan, Republic Of China',1),('00:11:9E','Solectron Brazil','Solectron BrazilRod. Campinas Mogi MirimBairro RoseiraJaguariuna Sp 13820-000Brazil',1),('00:11:9F','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:11:A0','Vtech Engineering Canada Ltd','Vtech Engineering Canada Ltd200-7671 Alderbridge WayRichmond Bc V6x 1z9Canada',1),('00:11:A1','Vision Netware Co.,ltd','Vision Netware Co.,ltdAce Twin Tower (2), #709212-30, Guro-dongSeoul Guro-gu 152-050Korea, Republic Of',1),('00:11:A2','Manufacturing Technology Inc','Manufacturing Technology Inc70 Ready Ave NwFort Walton Beach Fl 32548United States',1),('00:11:A3','Lanready Technologies Inc.','Lanready Technologies Inc.4f, No. 337, Sinhu 2nd Road., Neihu DistrictTaipei 114Taiwan, Republic Of China',1),('00:11:A4','Jstream Technologies Inc.','Jstream Technologies Inc.Bldg.53, R405, 195 Sec.4, Chung Hsing Rd.Chutung,  Hsinchu 310Taiwan, Republic Of China',1),('00:11:A5','Fortuna Electronic Corp.','Fortuna Electronic Corp.3f, No.9, Sec.1, Changan East Rd.,Taipei  104Taiwan, Republic Of China',1),('00:11:A6','Sypixx Networks','Sypixx Networks108 Bank StreetWaterbury Ct 06702United States',1),('00:11:A7','Infilco Degremont Inc.','Infilco Degremont Inc.8007 Discovery Dr.Po Box 71390Richmond Virginia 23255-1390United States',1),('00:11:A8','Quest Technologies','Quest Technologies1060 Corporate Center DriveOconomowoc Wisconsin 53066United States',1),('00:11:A9','Moimstone Co., Ltd','Moimstone Co., Ltd7th Floor Joongpyung Building 64-1Woomyun-dong, Seocho-guSeoul  137-900Korea, Republic Of',1),('00:11:AA','Uniclass Technology, Co., Ltd','Uniclass Technology, Co., Ltd4f, No. 98, Ming Chuan RdHsintien City Taipei Hsien 231Taiwan, Republic Of China',1),('00:11:AB','Trustable Technology Co.,ltd.','Trustable Technology Co.,ltd.12fl.-1,no.167,fu-shing N.rd.,sung-shan AreaTaipei  105Taiwan, Republic Of China',1),('00:11:AC','Simtec Electronics','Simtec ElectronicsAvondale DriveTarleton Lancashire Pr4 6axUnited Kingdom',1),('00:11:AD','Shanghai Ruijie Technology','Shanghai Ruijie Technology27f, 420 Jiangning Rd.Shanghai  200041China',1),('00:11:AE','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:11:AF','Medialink-i,inc','Medialink-i,inc1-9-10 Hamamatsu-choBelieve A HamamatsuchoMinato-ku Tokyo 105-0013Japan',1),('00:11:B0','Fortelink Inc.','Fortelink Inc.42501 Albrae Street Suite 202Fremont Ca 94538United States',1),('00:11:B1','Blueexpert Technology Corp.','Blueexpert Technology Corp.8f,no.16,lane 77,xing-ai Rd,nei-hu DistrictTaipei  11494Taiwan, Republic Of China',1),('00:11:B2','2001 Technology Inc.','2001 Technology Inc.7f-10, 79 Hsin Tai 5th. Rd. Sec.1Hsi Chih Taipei County 221Taiwan, Republic Of China',1),('00:11:B3','Yoshimiya Co.,ltd.','Yoshimiya Co.,ltd.2-3-24 BainanNishinari-kuOsaka Osaka-pref 557-0033Japan',1),('00:11:B4','Westermo Teleindustri Ab','Westermo Teleindustri AbStora SundbySe-640 40Sweden',1),('00:11:B5','Shenzhen Powercom Co.,ltd','Shenzhen Powercom Co.,ltdFloor 16,tower B,zhongyin Building,north Caitian Road,futian District,shenzhen,p.r.chinaShenzhen Guangdong Province 518028China',1),('00:11:B6','Open Systems International','Open Systems International3600 Holly Lane NorthSuite 40Minneapolis Mn 55447United States',1),('00:11:B7','Onroerend Groen B.v.','Onroerend Groen B.v.Molensteijn 60De Meern  Nl-3454 PtNetherlands',1),('00:11:B8','Liebherr - Elektronik Gmbh','Liebherr - Elektronik GmbhPeter - Dornier - Strasse 11Lindau (bodensee) Bavaria 88131Germany',1),('00:11:B9','Inner Range Pty. Ltd.','Inner Range Pty. Ltd.1 Millenium CourtKnoxfield Victoria 3180Australia',1),('00:11:BA','Elexol Pty Ltd','Elexol Pty LtdLevel 2 / 146 Bundall RoadBundall Queensland 4217Australia',1),('00:11:BB','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:BC','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:11:BD','Bombardier Transportation','Bombardier Transportation1501 Lebanon Church RoadPittsburgh Pa 15236United States',1),('00:11:BE','Agp Telecom Co. Ltd','Agp Telecom Co. Ltd9f, 134 Chung-hsiao E. RdSec. 4Taipei  106Taiwan, Republic Of China',1),('00:11:BF','Aesys S.p.a.','Aesys S.p.a.Via Artigiani, 41Brusaporto Bergamo 24060Italy',1),('00:11:C0','Aday Technology Inc','Aday Technology Inc9f.-3, No. 247, Sec. 1, Taichung Port Rd.,Taichung City Taiw 403Taiwan, Republic Of China',1),('00:11:C1','4p Mobile Data Processing','4p Mobile Data ProcessingViale Regione Veneto 26Padova Pd 35127Italy',1),('00:11:C2','United Fiber Optic Communication','United Fiber Optic Communication13-1,no.700,jungjeng Rd,junghe CityJunghe City Taipei 235Taiwan, Republic Of China',1),('00:11:C3','Transceiving System Technology Corporation','Transceiving System Technology CorporationNo.85,sec.2,gongdaowu Rd.,Hsinchu  300Taiwan, Republic Of China',1),('00:11:C4','Terminales De Telecomunicacion Terrestre, S.l.','Terminales De Telecomunicacion Terrestre, S.l.Poligono Europolis, Calle C 26Las Rozas Madrid 28230Spain',1),('00:11:C5','Ten Technology','Ten Technology555 East Ocean Blvd.9th FloorLong Beach Ca 90802United States',1),('00:11:C6','Seagate Technology Llc','Seagate Technology Llc1280 Disc DriveShakopee Mn 55379United States',1),('00:11:C7','Raymarine Uk Ltd','Raymarine Uk LtdQuay PointNortharbour RoadPortsmouth Hampshire Po6 3tdUnited Kingdom',1),('00:11:C8','Powercom Co., Ltd.','Powercom Co., Ltd.8f, No. 246, Lien Chen Rd.Chung Ho Taipei 235Taiwan, Republic Of China',1),('00:11:C9','Mtt Corporation','Mtt Corporation2-7-12MurotaniNishi-ku Kobe 651-2241Japan',1),('00:11:CA','Long Range Systems, Inc.','Long Range Systems, Inc.9855 Chartwell Dr.Dallas Texas 75243United States',1),('00:11:CB','Jacobsons Ab','Jacobsons AbNedralid S 32Motala  591 97Sweden',1),('00:11:CC','Guangzhou Jinpeng Group Co.,ltd.','Guangzhou Jinpeng Group Co.,ltd.No.9 Shenzhou Road,guangzhou Science CityGuangzhou Guangdong 510663China',1),('00:11:CD','Axsun Technologies','Axsun Technologies1 Fortune DriveBillerica Ma 02460United States',1),('00:11:CE','Ubisense Limited','Ubisense LimitedSt. Andrews HouseSt. Andrews RoadChesterton Cambridge Cb4 1dlUnited Kingdom',1),('00:11:CF','Thrane & Thrane A/s','Thrane & Thrane A/sLundtoftegaardsvej 93dLyngby Kbenhavn 2800Denmark',1),('00:11:D0','Tandberg Data Asa','Tandberg Data AsaKjelssveien 161Oslo  0411Norway',1),('00:11:D1','Soft Imaging System Gmbh','Soft Imaging System GmbhJohann-krane-weg 39Muenster  48149Germany',1),('00:11:D2','Perception Digital Ltd','Perception Digital LtdFlat A, 8/f, Shaw HouseRm AClear Water Bay NtHong Kong',1),('00:11:D3','Nextgentel Holding Asa','Nextgentel Holding AsaSandslimarka 31SandsliBergen Hordaland 5861Norway',1),('00:11:D4','Netenrich, Inc','Netenrich, Inc890 Hillview Ct.Suite 150Milpitas Ca 95035United States',1),('00:11:D5','Hangzhou Sunyard System Engineering Co.,ltd.','Hangzhou Sunyard System Engineering Co.,ltd.Sunyard Science & Technology Building Hi-tech Software Park(second Land Consolidation)Hangzhou Hi-tech Industrial Development Zone(binjiang District)Hangzhou Zhejiang 310053China',1),('00:11:D6','Handera, Inc.','Handera, Inc.2859 104th St.Des Moines Ia 50322United States',1),('00:11:D7','Ewerks Inc','Ewerks Inc411-2025 Guelph LineBurlington Ontario L7p 4x4Canada',1),('00:11:D8','Asustek Computer Inc.','Asustek Computer Inc.No. 15, Li-te Rd., PeitouTaipei  112Taiwan, Republic Of China',1),('00:11:D9','Tivo','Tivo2160 Gold AveAlviso Ca 95002-2160United States',1),('00:11:DA','Vivaas Technology Inc.','Vivaas Technology Inc.15f, No. 10, Sec 1, Pei-hsin Rd.,Hsin-tien City Taipei Hsien, 231Taiwan, Republic Of China',1),('00:11:DB','Land-cellular Corporation','Land-cellular Corporation12054 Miramar ParkwayMiramar Fl 33025United States',1),('00:11:DC','Glunz & Jensen','Glunz & JensenHaslevvej 13Ringsted  4100Denmark',1),('00:11:DD','Fromus Tec. Co., Ltd.','Fromus Tec. Co., Ltd.2f 896-8 Hogye2-dong Dongan-guAnyang-city, Gyeonggi-do,431-836Korea, Republic Of',1),('00:11:DE','Eurilogic','EurilogicCentrale Parc Bt 7Avenue Sully PrudhommeChatenay Malabry  92298France',1),('00:11:DF','Arecont Systems','Arecont Systems177 N Church Ave Suite 1010Tucson Arizona 85701United States',1),('00:11:E0','U-media Communications, Inc.','U-media Communications, Inc.9f, No.1 Jin-shan St.Hsinchu  300Taiwan, Republic Of China',1),('00:11:E1','Beko Electronics Co.','Beko Electronics Co.Beylikduzu Mevkii BuyukcekmeceIstanbul  34901Turkey',1),('00:11:E2','Hua Jung Components Co., Ltd.','Hua Jung Components Co., Ltd.5f, No.13, Lane 120, Sec.1, Nei Hu RoadTaipei  114Taiwan, Republic Of China',1),('00:11:E3','Thomson, Inc.','Thomson, Inc.101 West 103rd StreetIndianapolis In 46290United States',1),('00:11:E4','Danelec Electronics A/s','Danelec Electronics A/sBlokken 44Birkeroed Copenhagen 3460Denmark',1),('00:11:E5','Kcodes Corporation','Kcodes CorporationFloor 2, Number 501, Section 2Tiding BoulevardNeihu District Taipei City 114Taiwan, Republic Of China',1),('00:11:E6','Scientific Atlanta','Scientific Atlanta5030 Sugarloaf ParkwayMail Stop 5.2.428Lawrenceville Ga 30042United States',1),('00:11:E7','Worldsat - Texas De France','Worldsat - Texas De France220, Rue Gustave EiffelCedex 3Aix En Provence Bouches Du Rhone 13854France',1),('00:11:E8','Tixi.com','Tixi.comKarmeliterweg 114Berlin  13465Germany',1),('00:11:E9','Starnex Co., Ltd.','Starnex Co., Ltd.4th Floor, C&c Bldg, 228-2Guui-dongKwangjin-gu Seoul 143-200Korea, Republic Of',1),('00:11:EA','Iwics Inc.','Iwics Inc.19125 North Creek ParkwaySuite 120Bothell Wa 98011United States',1),('00:11:EB','Innovative Integration','Innovative Integration2390a Ward AvenueSimi Valley Ca 93065United States',1),('00:11:EC','Avix Inc.','Avix Inc.1-1, Fukuura, Kanazawa-kuYokohama-shi Kanagawa 236-0004Japan',1),('00:11:ED','802 Global','802 GlobalStudio 11,intec 2,wade RoadBasingstoke,Hampshire  Rg24 BneUnited Kingdom',1),('00:11:EE','Estari, Inc.','Estari, Inc.1800 Paxton StHarrisburg Pa 17104United States',1),('00:11:EF','Conitec Datensysteme Gmbh','Conitec Datensysteme GmbhDieselstr. 11cDieburg Hessen 64807Germany',1),('00:11:F0','Wideful Limited','Wideful Limited3b, Speedy Ind. Bldg., 114 How Ming StreetKwun TongHong Kong 852Hong Kong',1),('00:11:F1','Qinetiq Ltd','Qinetiq LtdRoom E601St. Andrews RoadMalvern Worcestershire Wr14 3psUnited Kingdom',1),('00:11:F2','Institute Of Network Technologies','Institute Of Network Technologies17-th Line Vasilevsky Ostrov, 54-1St.petersburg  199178Russian Federation',1),('00:11:F3','Gavitec Ag- Mobile Digit','Gavitec Ag- Mobile DigitJens-otto-krag-str. 11Wrselen Nordrhein-westfalen 52146Germany',1),('00:11:F4','Woori-net','Woori-net#508, Hankook Moolyu, 853-1 Dongchun-dongYongin-si Kyungki-do 449-843Korea, Republic Of',1),('00:11:F5','Askey Computer Corp.','Askey Computer Corp.10f, No.119, Chienkang  Rd.,Chung-ho, Taipei  235Taiwan, Republic Of China',1),('00:11:F6','Asia Pacific Microsystems , Inc.','Asia Pacific Microsystems , Inc.No.2,r&d Road 6 ,science-based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:11:F7','Shenzhen Forward Industry Co., Ltd','Shenzhen Forward Industry Co., Ltd4b1 F5.8, Tian An Cyber Park, Chengongmiao,Shenzhen Guangdong 518040China',1),('00:11:F8','Airaya Corp','Airaya Corp637 Adair CourtMorgan Hill Ca 95037United States',1),('00:11:F9','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:11:FA','Rane Corporation','Rane Corporation10802 47th Avenue WestMukilteo Wa 98275-5098United States',1),('00:11:FB','Heidelberg Engineering Gmbh','Heidelberg Engineering GmbhTiergartenstr. 15Heidelberg Baden-wuerttemberg 69121Germany',1),('00:11:FC','Harting Electric Gmbh & Co.kg','Harting Electric Gmbh & Co.kgWilhelm Harting Str. 1Espelkamp Nordrhein Westfalen D-32339Germany',1),('00:11:FD','Korg Inc.','Korg Inc.1-15-12 ShimotakaidoSuginami-ku Tokyo 168-0073Japan',1),('00:11:FE','Keiyo System Research, Inc.','Keiyo System Research, Inc.Hamada Park Bldg. 6f17-3 Shinmachi Chuou-kuChiba-city Chiba-pref 260-0028Japan',1),('00:11:FF','Digitro Tecnologia Ltda','Digitro Tecnologia LtdaRua: Professora Sofia Quint De Souza, 167Bairro: CapoeirasFlorianpolis Santa Catarina 88085-040Brazil',1),('00:12:00','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:01','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:02','Decrane Aerospace - Audio International Inc.','Decrane Aerospace - Audio International Inc.7300 Industry DriveNorth Little Rock Ar 72117United States',1),('00:12:03','Activ Networks','Activ NetworksBat L - 1 Rue De Terre NeuveBp127Courtaboeuf N/a 91944France',1),('00:12:04','U10 Networks, Inc.','U10 Networks, Inc.2-2-14 KakinokizakaMeguro Tokyo 152-0022Japan',1),('00:12:05','Terrasat Communications, Inc.','Terrasat Communications, Inc.235 Vineyard Court, Suite 100Morgan Hill California 95037United States',1),('00:12:06','Iquest (nz) Ltd','Iquest (nz) LtdP.o.box 15169DinsdaleHamilton Waikato 2031New Zealand',1),('00:12:07','Head Strong International Limited','Head Strong International LimitedUnit 9, 20/f, Metropole Square,2 On Yiu Street, ShatinGuangdongHong Kong',1),('00:12:08','Gantner Electronic Gmbh','Gantner Electronic GmbhMontafonerstrasse 8Schruns Vorarlberg 6780Austria',1),('00:12:09','Fastrax Ltd','Fastrax LtdValimotie 7Vantaa Fi 01510Finland',1),('00:12:0A','Emerson Electric Gmbh & Co. Ohg','Emerson Electric Gmbh & Co. OhgHeerstrasse 111Waiblingen Bw 71332Germany',1),('00:12:0B','Chinasys Technologies Limited','Chinasys Technologies Limited10/f,cagw Building,no.30 Haidian South RoadBeijing  100080China',1),('00:12:0C','Ce-infosys Pte Ltd','Ce-infosys Pte Ltd390 Havelock Road#08-02 Kings Centre169662Singapore',1),('00:12:0D','Advanced Telecommunication Technologies, Inc.','Advanced Telecommunication Technologies, Inc.10390 Wilshire BoulevardSuite 1803Los Angeles California 90024United States',1),('00:12:0E','Abocom','Abocom1f , No. 21, Yanfa 2nd Rd., SbipHsinchu City  300Taiwan, Republic Of China',1),('00:12:0F','Ieee 802.3','Ieee 802.3',1),('00:12:10','Wideray Corp','Wideray Corp25 Kearny Street6th FloorSan Francisco Ca 94108United States',1),('00:12:11','Protechna Herbst Gmbh & Co. Kg','Protechna Herbst Gmbh & Co. KgOtto Hahn Str. 26Ottobrunn Germany/bavaria 85521Germany',1),('00:12:12','Plus Vision Corporation','Plus Vision Corporation1033-1, Oshitate, Inagi-shi,Tokyo Saitama 206-0811Japan',1),('00:12:13','Metrohm Ag','Metrohm AgOberdorfstrasse 68Herisau Ar 9101Switzerland',1),('00:12:14','Koenig & Bauer Ag','Koenig & Bauer AgFriedrich-koenig-str. 4Wuerzburg Bavaria 97080Germany',1),('00:12:15','Istor Networks, Inc.','Istor Networks, Inc.7585 Irvine Center DriveSuite 250Irvine Ca 92618United States',1),('00:12:16','Icp Internet Communication Payment Ag','Icp Internet Communication Payment AgWilhelm-stein-weg 24Hamburg  D-22339Germany',1),('00:12:17','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory Dr.Irvine Ca 92612United States',1),('00:12:18','Aruze Corporation','Aruze CorporationAriake Frontier Building A3-1-25 AriakeKohtoh-ku Tokyo 135-0063Japan',1),('00:12:19','Ahead Communication Systems Inc','Ahead Communication Systems Inc199 Park Road ExtPo Box 929Middlebury Ct 06762United States',1),('00:12:1A','Techno Soft Systemnics Inc.','Techno Soft Systemnics Inc.2-5-17, Ebisu-nishi, Naniwa-ku,Osaka  556-0003Japan',1),('00:12:1B','Sound Devices, Llc','Sound Devices, Llc300 Wengel DriveReedsburg Wi 53959United States',1),('00:12:1C','Parrot S.a.','Parrot S.a.174, Quai De JemmapesParis  75010France',1),('00:12:1D','Netfabric Corporation','Netfabric Corporation67 Federal RoadSuite 300Brookfield Ct 06804United States',1),('00:12:1E','Juniper Networks, Inc.','Juniper Networks, Inc.1194 N. Mathilda AvenueSunnyvale Ca 94010United States',1),('00:12:1F','Harding Intruments','Harding Intruments9431-41aveEdmonton Ab T6e 5x7Canada',1),('00:12:20','Cadco Systems','Cadco Systems2363 Merritt DrGarland Texas 75041United States',1),('00:12:21','B.braun Melsungen Ag','B.braun Melsungen AgSchwarzenberger Weg 73-79Melsungen Hessen 34212Germany',1),('00:12:22','Skardin (uk) Ltd','Skardin (uk) LtdNo. 5 Greenway (ro24)Harlow Business ParkHarlow Essex Cm19 5qbUnited Kingdom',1),('00:12:23','Pixim','Pixim915 Linda Vista Ave.Mountain View Ca 94043United States',1),('00:12:24','Nexql Corporation','Nexql Corporation12250 Inwood Road #6Dallas Tx 75244United States',1),('00:12:25','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:12:26','Japan Direx Corporation','Japan Direx CorporationKyocera Harajuku Bldg.6-27-8, JingumaeShibuya-ku Tokyo 150-0001Japan',1),('00:12:27','Franklin Electric Co., Inc.','Franklin Electric Co., Inc.400 E. Spring StreetBluffton Indiana 46714United States',1),('00:12:28','Data Ltd.','Data Ltd.J. Hagaru 9P.o. Box 7Bratislava  830 05Slovakia',1),('00:12:29','Broadeasy Technologies Co.,ltd','Broadeasy Technologies Co.,ltd24th Floor,tower A,jinshan Mansion,No.8 Shanxi Road,nanjing,p.r.c.Nanjing Jiangsu 210009China',1),('00:12:2A','Vtech Telecommunications Ltd.','Vtech Telecommunications Ltd.23/f, Tai Ping Industrial Centre, Block 157 Ting Kok Road, Tai PoHong Kong',1),('00:12:2B','Virbiage Pty Ltd','Virbiage Pty LtdLevel 48 Market StreetMelbourne Victoria 3000Australia',1),('00:12:2C','Soenen Controls N.v.','Soenen Controls N.v.Wijnedalestraat 190Roeselare W-vl 8800Belgium',1),('00:12:2D','Sinett Corporation','Sinett Corporation640 W. California AvenueSunnyvale Ca 94086United States',1),('00:12:2E','Signal Technology - Aisd','Signal Technology - Aisd1820 Preston Park Blvd.Suite 2800Plano Tx 75093United States',1),('00:12:2F','Sanei Electric Inc.','Sanei Electric Inc.5f Taisou-ikebukuro Bldg.2-61-1 IkebukuroToshima-ku Tokyo 171-0014Japan',1),('00:12:30','Picaso Infocommunication Co., Ltd.','Picaso Infocommunication Co., Ltd.3f, Suntechcity, Sangdaewon 1-dong,513-15, Jungwon-guSungnam-city Kyunggi-do 462-725Korea, Republic Of',1),('00:12:31','Motion Control Systems, Inc.','Motion Control Systems, Inc.Po Box 1156701 Viscoe RoadNew River Va 24129United States',1),('00:12:32','Lewiz Communications Inc.','Lewiz Communications Inc.1376 N. 4th St. #300San Jose Ca 95112United States',1),('00:12:33','Jrc Tokki Co.,ltd.','Jrc Tokki Co.,ltd.3-2-1 Shinyoshidahigashi Kohoku-kuYokohama Kanagawa 223-8572Japan',1),('00:12:34','Camille Bauer','Camille BauerAargauerstr. 7Wohlen Ag 5610Switzerland',1),('00:12:35','Andrew Corporation','Andrew Corporation2601 Telecom PkwyRichardson Tx 75082United States',1),('00:12:36','Consentry Networks','Consentry Networks1690 Mccandless DrMilipitas Ca 95035United States',1),('00:12:37','Texas Instruments','Texas Instruments12500 Ti Boulevard,Ms 8723Dallas Texas 75243United States',1),('00:12:38','Setabox Technology Co., Ltd.','Setabox Technology Co., Ltd.9f-1, No. 293-3, Sec2, Fu-hsing S. Rd.Taipei  106Taiwan, Republic Of China',1),('00:12:39','S Net Systems Inc.','S Net Systems Inc.10f Sungwon Bldg. Samsung-dongGangnam-guSeoul  135-090Korea, Republic Of',1),('00:12:3A','Posystech Inc., Co.','Posystech Inc., Co.Room 407, Daeryung Techno Town 6,493-6, Gasan-dong, Geumcheon-gu,Seoul  153-771Korea, Republic Of',1),('00:12:3B','Kero Systems Aps','Kero Systems ApsAllikevej 3Hrsholm  2970Denmark',1),('00:12:3C','Second Rule Llc','Second Rule Llc4119 Walnut StreetSuite 200Philadelphia Pa 19104United States',1),('00:12:3D','Ges','GesRoom 5403, Dongseoul College, 423, Bokjeong-dong, Sujeong-gu, Seongnam-si, Gyeonggi-do,Gyeonggi-do Seongnam-si 461-714Korea, Republic Of',1),('00:12:3E','Erune Technology Co., Ltd.','Erune Technology Co., Ltd.No. 429, Chin-san 2nd Street,Yang-meiTao Yuan  326Taiwan, Republic Of China',1),('00:12:3F','Dell Inc','Dell IncOne Dell WayRound Rock  Texas 78682United States',1),('00:12:40','Amoi Electronics Co.,ltd','Amoi Electronics Co.,ltd295 Lane,zuchongzhi Road,zhang Jiang,Shanghai  201203China',1),('00:12:41','A2i Marketing Center','A2i Marketing Center1024-4  Duksan Bldg Bangbaedong Seochogu Seoul KoreaSeoul  137-060Korea, Republic Of',1),('00:12:42','Millennial Net','Millennial Net2 4th AvenueBurlington Ma 01803United States',1),('00:12:43','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:44','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:45','Zellweger Analytics, Inc.','Zellweger Analytics, Inc.405 Barclay Blvd.Lincolnshire Illinois 60069United States',1),('00:12:46','T.o.m Technology Inc..','T.o.m Technology Inc..906 Woolim E-biz Center 2,Guro-3dongSeoul Guro-gu 184-1Korea, Republic Of',1),('00:12:47','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1, Imsoo-dongGumi-city Gyeong-buk 730-350Korea, Republic Of',1),('00:12:48','Emc Corporation (kashya)','Emc Corporation (kashya)176 South StreetHopkinton Ma 01748United States',1),('00:12:49','Delta Elettronica S.p.a.','Delta Elettronica S.p.a.Via Astico 41Varese  21100Italy',1),('00:12:4A','Dedicated Devices, Inc.','Dedicated Devices, Inc.5680 E. FranklinSuite 250Nampa Idaho 83687United States',1),('00:12:4B','Texas Instruments','Texas InstrumentsGaustadalleen 21Texas Instruments Norway AsOslo  N-0349Norway',1),('00:12:4C','Bbwm Corporation','Bbwm Corporation6f, No. 578, Rui Guang Road, Nei HuTaipei  114Taiwan, Republic Of China',1),('00:12:4D','Inducon Bv','Inducon BvKerklaan 26Leimuiden Zh 2541 CgNetherlands',1),('00:12:4E','Xac Automation Corp.','Xac Automation Corp.4f, 30 Industry E. Road IxScience ParkHsin-chu  300Taiwan, Republic Of China',1),('00:12:4F','Tyco Thermal Controls Llc.','Tyco Thermal Controls Llc.11004 - 174 St.Edmonton Alberta T5s 2p3Canada',1),('00:12:50','Tokyo Aircaft Instrument Co., Ltd.','Tokyo Aircaft Instrument Co., Ltd.1-35-1, Izumi-honchoKomae-shi Tokyo 201-8555Japan',1),('00:12:51','Silink','Silink13 Rue PomeysLe Taillan  33320France',1),('00:12:52','Citronix, Llc','Citronix, Llc3030 Se Loop 820Fort Worth Texas 76140United States',1),('00:12:53','Audiodev Ab','Audiodev AbKabingatan 9Malm  Se-212 39Sweden',1),('00:12:54','Spectra Technologies Holdings Company Ltd','Spectra Technologies Holdings Company LtdUnit 1301-09, Tower IiPacific Century Place, Mongkok852Hong Kong',1),('00:12:55','Neteffect Incorporated','Neteffect Incorporated9211 Waterford Centre BlvdSuite 100Austin Texas 78758United States',1),('00:12:56','Lg Information & Comm.','Lg Information & Comm.459-9,kasan-dong,kumchon-gu,Seoul  153-023Korea, Republic Of',1),('00:12:57','Leapcomm Communication Technologies Inc.','Leapcomm Communication Technologies Inc.Rm1804-05 South Tower Hong Kong Plaza, No.283 Huaihai Zhong RoadShanghai  200021China',1),('00:12:58','Activis Polska','Activis PolskaSwierzawska 5Poznan Wielkopolska 60-321Poland',1),('00:12:59','Thermo Electron Karlsruhe','Thermo Electron KarlsruheDieselstrasse 4Karlsruhe Baden Wrtemberg 76227Germany',1),('00:12:5A','Microsoft Corporation','Microsoft CorporationOne Microsoft WayRedmond Washington 98052-6399United States',1),('00:12:5B','Kaimei Electroni','Kaimei Electroni14-3f, No.81,sec. 1,hsin-tai-wu Road,hsichih,Taipei Hsien Hsichih 221Taiwan, Republic Of China',1),('00:12:5C','Green Hills Software, Inc.','Green Hills Software, Inc.30 West Sola StreetSanta Barbara Ca 93101United States',1),('00:12:5D','Cybernet Inc.','Cybernet Inc.#205, Lotte Suntech City, 513-15Sangdaewon-dong, Chungwon-guSungnam Kyunggi 462-806Korea, Republic Of',1),('00:12:5E','Caen','CaenVia Vetraia, 11Viareggio Lucca 55049Italy',1),('00:12:5F','Awind Inc.','Awind Inc.17f., No. 886-5, Jungjeng RdJunghe CityTaipei County  235Taiwan, Republic Of China',1),('00:12:60','Stanton Magnetics,inc.','Stanton Magnetics,inc.3000 Sw 42nd StreetHollywood Fl 33312United States',1),('00:12:61','Adaptix, Inc','Adaptix, Inc1407 116th Ave. NeSuite E210Bellevue Wa 98004United States',1),('00:12:62','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:12:63','Data Voice Technologies Gmbh','Data Voice Technologies GmbhStockholmer Allee 32bDortmund Nrw D-44269Germany',1),('00:12:64','Daum Electronic Gmbh','Daum Electronic GmbhFlugplatzstr. 100Fuerth Bavaria 90768Germany',1),('00:12:65','Enerdyne Technologies, Inc.','Enerdyne Technologies, Inc.1935 Cordell CourtEl Cajon Ca 92020United States',1),('00:12:66','Swisscom Hospitality Services Sa','Swisscom Hospitality Services SaChemin De Letang 651211 GenevaSwitzerland',1),('00:12:67','Matsushita Electronic Components Co., Ltd.','Matsushita Electronic Components Co., Ltd.1006 KadomaKadoma-city Osaka 571-8506Japan',1),('00:12:68','Ips D.o.o.','Ips D.o.o.C. Ljubljanske Brigade 17Ljubljana  Si-1000Slovenia',1),('00:12:69','Value Electronics','Value ElectronicsDong-kwan B/d, 5f, 1566-2Seocho-dong, Seocho-guSeoul  137-874Korea, Republic Of',1),('00:12:6A','Optoelectronics Co., Ltd.','Optoelectronics Co., Ltd.3-1kamiaokinishi 1-chomeKawaguchi Saitama Pref. 333-0845Japan',1),('00:12:6B','Ascalade Communications Limited','Ascalade Communications LimitedUnit 10-11, 35/f, Cable Tv Tower,No.9 Hoi Shing Road, Tsuen WanHong Kong',1),('00:12:6C','Visonic Ltd.','Visonic Ltd.24 Habarzel St.Tel Aviv  69710Israel',1),('00:12:6D','University Of California, Berkeley','University Of California, BerkeleyEecs DepartmentBerkeley Ca 94720-1776United States',1),('00:12:6E','Seidel Elektronik Gmbh Nfg.kg','Seidel Elektronik Gmbh Nfg.kgFrauentalerstrasse 100Deutschlandsberg Steiermark 8530Austria',1),('00:12:6F','Rayson Technology Co., Ltd.','Rayson Technology Co., Ltd.1f No.9 R&d Rd.ii, Science-based Industrial ParkHsin-chu  300Taiwan, Republic Of China',1),('00:12:70','Nges Denro Systems','Nges Denro Systems9318 Gaither RoadGaithersburg Md 20877United States',1),('00:12:71','Measurement Computing Corp','Measurement Computing Corp16 Commerce BlvdMiddleboro Ma 02346United States',1),('00:12:72','Redux Communications Ltd.','Redux Communications Ltd.Pob 101Modiin  71700Israel',1),('00:12:73','Stoke Inc','Stoke Inc2189 Leghorn StreetMountain View Ca 94043United States',1),('00:12:74','Nit Lab','Nit LabSkoriny Str., 65-3Minsk Minskaya Obl. 220013Belarus',1),('00:12:75','Sentilla Corporation','Sentilla Corporation201 Marshall StreetRedwood City Ca 94063United States',1),('00:12:76','Microsol Holdings Ltd.','Microsol Holdings Ltd.Unit 28, Trinity Enterprise Complex,Pearse St.,Dublin  D2Ireland',1),('00:12:77','Korenix Technologies Co., Ltd.','Korenix Technologies Co., Ltd.11f-1, No. 108, Minquan Rd.Xindian City Taipei 231Taiwan, Republic Of China',1),('00:12:78','International Bar Code','International Bar Code160 Oak StreetGlastonbury Ct 06033United States',1),('00:12:79','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:12:7A','Sanyu Industry Co.,ltd.','Sanyu Industry Co.,ltd.Midori-ku Hakusan1-11-11Yokohama-shi Kanagawa-ken 226-0006Japan',1),('00:12:7B','Via Networking Technologies, Inc.','Via Networking Technologies, Inc.8f,533, Chung-cheng Road, Hsin-tienTaipei  231Taiwan, Republic Of China',1),('00:12:7C','Swegon Ab','Swegon AbBox 300Kvnum Vstra Gtaland Se 535 23Sweden',1),('00:12:7D','Mobilearia','Mobilearia800 W El Camino Real #240Mountain View Ca 94040United States',1),('00:12:7E','Digital Lifestyles Group, Inc.','Digital Lifestyles Group, Inc.801 South Sentous Ave.City Of Industry Ca 91748United States',1),('00:12:7F','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:80','Cisco','Cisco80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:81','Cieffe Srl','Cieffe SrlVia Ugo Foscolo, 13Carate Brianza Milano 20048Italy',1),('00:12:82','Qovia','Qovia7470 New Technology WaySuite EFrederick Md 21703United States',1),('00:12:83','Nortel Networks','Nortel Networks8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:12:84','Lab33 Srl','Lab33 SrlC.so F. Perrone 24Genoa Ge 16152Italy',1),('00:12:85','Gizmondo Europe Ltd','Gizmondo Europe Ltd1 Meadow Gate AvenueFarnborough Business ParkFarnborough Hampshire Gu14 6fgUnited Kingdom',1),('00:12:86','Endevco Corp','Endevco Corp30700 Rancho Viejo RoadSan Juan Capistrano Ca 92675United States',1),('00:12:87','Digital Everywhere Unterhaltungselektronik Gmbh','Digital Everywhere Unterhaltungselektronik GmbhMaria Gailer Strasse 16Villach Krnten 9500Austria',1),('00:12:88','2wire, Inc','2wire, Inc1704 Automation ParkwaySan Jose Ca 94538United States',1),('00:12:89','Advance Sterilization Products','Advance Sterilization Products33 Technology DriveIrvine California 92618United States',1),('00:12:8A','Motorola Pcs','Motorola Pcs645 N. Us Hwy 45Room No. Mw-113Libertyville Il 60048United States',1),('00:12:8B','Sensory Networks Inc','Sensory Networks IncLevel 6, 140 William StEast Sydney Nsw 2011Australia',1),('00:12:8C','Woodward Governor','Woodward Governor1000 E. Drake RoadFt. Collins Co 80525United States',1),('00:12:8D','Stb Datenservice Gmbh','Stb Datenservice GmbhWeinsbergstrasse 190Kln Nrw 50825Germany',1),('00:12:8E','Q-free Asa','Q-free AsaTh. Owesensgt. 35cTrondheim St 7443Norway',1),('00:12:8F','Montilio','Montilio1 Maskit St.Hertzelia  46763Israel',1),('00:12:90','Kyowa Electric & Machinery Corp.','Kyowa Electric & Machinery Corp.4-8-16,masuizumiKanazawa Ishikawa 921-8025Japan',1),('00:12:91','Kws Computersysteme Gmbh','Kws Computersysteme GmbhCarl Zeiss Str. 1Ettlingen Bw 76275Germany',1),('00:12:92','Griffin Technology','Griffin Technology1619c Elm Hill PikeNashville Tn 37210United States',1),('00:12:93','Ge Energy','Ge Energy1501 Roanoke Blvd.Room 283Salem Va 24153United States',1),('00:12:94','Eudyna Devices Inc.','Eudyna Devices Inc.1000 Kamisukiawara,showa-choNakakoma-gun Yamanashi 409-3883Japan',1),('00:12:95','Aiware Inc.','Aiware Inc.J-tower 2f1-1 NikkochoFuchu-shi Tokyo 183-0044Japan',1),('00:12:96','Addlogix','Addlogix43 Tesla WayIrvine Ca 92618United States',1),('00:12:97','O2micro, Inc.','O2micro, Inc.3118 Patrick Henry DriveSanta Clara Ca 95054United States',1),('00:12:98','Mico Electric(shenzhen) Limited','Mico Electric(shenzhen) Limited21/f Block A, Hailrun Complex, 6021 Shennan Blvd., Shenzhen, Pr China.Shenzhen Guangdong 518040China',1),('00:12:99','Ktech Telecommunications Inc','Ktech Telecommunications Inc21540 Prairie Street Unit BChatsworth Ca 91311United States',1),('00:12:9A','Irt Electronics Pty Ltd','Irt Electronics Pty Ltd26 Hotham ParadeArtarmon Nsw 2064Australia',1),('00:12:9B','E2s Electronic Engineering Solutions, S.l.','E2s Electronic Engineering Solutions, S.l.Sant Ferran 10Barcelona  08031Spain',1),('00:12:9C','Yulinet','Yulinet11f, Samhomoolsan B/d 275-6, Yangjae-dongSeocho Seoul 137-941Korea, Republic Of',1),('00:12:9D','First International Computer Do Brasil','First International Computer Do BrasilRodovia Br 459Km 121 - Distrito IndustrialSanta Rita Do Sapuca Minas GeraisBrazil',1),('00:12:9E','Surf Communications Inc.','Surf Communications Inc.Room 313, 3f, Bldg.52, No. 195, Chung Hsing Rd., Sec 4, Chutung, Hsinchu, TaiwanHsinchu  310Taiwan, Republic Of China',1),('00:12:9F','Rae Systems, Inc.','Rae Systems, Inc.1339 Moffett Park DriveSunnyvale California 94089United States',1),('00:12:A0','Neomeridian Sdn Bhd','Neomeridian Sdn Bhd3a-1, Perdana The PlaceJalan Pju 8/5gBandar Damansara Perdana Selangor 47820Malaysia',1),('00:12:A1','Bluepacket Communications Co., Ltd.','Bluepacket Communications Co., Ltd.10f-1, No. 420, Sec. 1, Keelung Rd., 110,Taipei  110Taiwan, Republic Of China',1),('00:12:A2','Vita','VitaPo Box 19658Fountain Hills Az 85269United States',1),('00:12:A3','Trust International B.v.','Trust International B.v.Laan Van Barcelona 600Dordrecht Zuid Holland 3317 DdNetherlands',1),('00:12:A4','Thingmagic, Llc','Thingmagic, LlcOne Broadway14th FloorCambridge Ma 02142United States',1),('00:12:A5','Stargen, Inc.','Stargen, Inc.225 Cedar Hill StreetMarlborough Ma 01752United States',1),('00:12:A6','Dolby Australia','Dolby AustraliaLevel 6136 Chalmers StreetSurry Hills Nsw 2010Australia',1),('00:12:A7','Isr Technologies Inc','Isr Technologies Inc1100, Rue Notre-dame OuestMontreal Quebec H3c 1k3Canada',1),('00:12:A8','Intec Gmbh','Intec GmbhRahmedestr. 90Luedenscheid Nrw 58507Germany',1),('00:12:A9','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:12:AA','Iee, Inc.','Iee, Inc.7740 Lemona AvenueVan Nuys, Ca 91405United States',1),('00:12:AB','Wilife, Inc.','Wilife, Inc.132 E. 13065 S., Suite 150Draper Ut 84020United States',1),('00:12:AC','Ontimetek Inc.','Ontimetek Inc.9fl.,owners Tower16-5, Sunae-dong, Bundang-guSungnam-si Kyunggi-do 463-825Korea, Republic Of',1),('00:12:AD','Ids Gmbh','Ids GmbhNobelstr, 18Ettlingen Baden-wrttemberg 76275Germany',1),('00:12:AE','Hls Hard-line Solutions Inc.','Hls Hard-line Solutions Inc.53 Main StreetDowling Ontario P0m 1r0Canada',1),('00:12:AF','Elpro Technologies','Elpro Technologies9 / 12 Billabong St.Stafford Queensland 4053Australia',1),('00:12:B0','Efore Oyj   (plc)','Efore Oyj   (plc)P.o.box 260(linnoitustie 4 A)Espoo  Fi - 02601Finland',1),('00:12:B1','Dai Nippon Printing Co., Ltd','Dai Nippon Printing Co., Ltd2-8-21,akabane-minamiKita-ku Tokyo 115-0044Japan',1),('00:12:B2','Avolites Ltd.','Avolites Ltd.184 Park AvenueLondon  Nw10 7xlUnited Kingdom',1),('00:12:B3','Advance Wireless Technology Corp.','Advance Wireless Technology Corp.12f No. 27-6, Sec. 2, Chung Cheng East RoadTamshui  251Taiwan, Republic Of China',1),('00:12:B4','Work Microwave Gmbh','Work Microwave GmbhRaiffeisenstrasse 12Holzkirchen  83607Germany',1),('00:12:B5','Vialta, Inc.','Vialta, Inc.48461 Fremont Blvd.Fremont Ca 94538United States',1),('00:12:B6','Santa Barbara Infrared, Inc.','Santa Barbara Infrared, Inc.30 S. Calle Cesar ChavezSuite DSanta Barbara Ca 93103United States',1),('00:12:B7','Ptw Freiburg','Ptw FreiburgLoerracher Strasse 7Freiburg  79115Germany',1),('00:12:B8','G2 Microsystems','G2 Microsystems408 Euclid AveOakland Ca 94610United States',1),('00:12:B9','Fusion Digital Technology','Fusion Digital TechnologyVictoria Mews, 23 Millfield RoadCottingley Business ParkBingley West Yorkshire Bd16 1pyUnited Kingdom',1),('00:12:BA','Fsi Systems, Inc.','Fsi Systems, Inc.5847 County Road 41Farmington Ny 14425United States',1),('00:12:BB','Telecommunications Industry Association Tr-41 Committee','Telecommunications Industry Association Tr-41 Committee2500 Wilson Blvd., Suite 300Arlington Va 22201United States',1),('00:12:BC','Echolab Llc','Echolab Llc267 Boston RoadSuite 11Billerica Ma 01862United States',1),('00:12:BD','Avantec Manufacturing Limited','Avantec Manufacturing LimitedUnit L, 7/f, Camelpaint Bldg, Block 360 Hoi Yuen Road, Kwun Tong, Kowloon852Hong Kong',1),('00:12:BE','Astek Corporation','Astek Corporation4250 Buckingham Drive, Suite 500Colorado Springs Colorado 80907United States',1),('00:12:BF','Arcadyan Technology Corporation','Arcadyan Technology Corporation4f, No. 9, Park Avenue IiScience-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:12:C0','Hotlava Systems, Inc.','Hotlava Systems, Inc.6329 Chelton DriveOakland Ca 94611United States',1),('00:12:C1','Check Point Software Technologies','Check Point Software Technologies5 Hasolelim St.Tel Aviv  67897Israel',1),('00:12:C2','Apex Electronics Factory','Apex Electronics FactoryNo.3 Industrial Zone, No.4 Block,Fuyong Town, Baoan DistrictShen Zhen Guang Dong 518103China',1),('00:12:C3','Wit S.a.','Wit S.a.138 Avenue Lon BrengerSaint Laurent Du Var Paca 06700France',1),('00:12:C4','Viseon, Inc.','Viseon, Inc.8445 Freeport ParkwaySuite 245Irving Texas 75063United States',1),('00:12:C5','V-show  Technology (china) Co.,ltd','V-show  Technology (china) Co.,ltd7f, Tengda Plaza, No.168Xizhimen Wai Street,Haidian District, Beijing 100089China',1),('00:12:C6','Tgc America, Inc','Tgc America, Inc2901 Tasman Drive, Suite 111Santa Clara Ca 95054United States',1),('00:12:C7','Securay Technologies Ltd.co.','Securay Technologies Ltd.co.Tianjin Haitai Industrial Base Erwei RoadNo. 6 Block F 8-401Tianjin  300384China',1),('00:12:C8','Perfect Tech','Perfect Tech3f,no.9,lane175,nankan Rd.,Lujhu Taoyuan 338Taiwan, Republic Of China',1),('00:12:C9','Motorola Bcs','Motorola Bcs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:12:CA','Mechatronic Brick Aps','Mechatronic Brick ApsAlsion 26400 SonderborgDenmark',1),('00:12:CB','Css Inc.','Css Inc.151 Superior Blvd.Unit 13 & 14Mississauga Ontario L5t2l1Canada',1),('00:12:CC','Bitatek Co., Ltd','Bitatek Co., Ltd6f-1,190,ta-tung Road,sec. 3,Hsichih Taipei County 221Taiwan, Republic Of China',1),('00:12:CD','Asem Spa','Asem SpaVia Buia, 4Artegna Udine I-33011Italy',1),('00:12:CE','Advanced Cybernetics Group','Advanced Cybernetics Group2953 Bunker Hill LaneSuite 400Santa Clara Ca 95054United States',1),('00:12:CF','Accton Technology Corporation','Accton Technology CorporationNo. 1 Creation Rd. Iii, Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:12:D0','Gossen-metrawatt-gmbh','Gossen-metrawatt-gmbhThomas-mann-str. 16-20Nrnberg Bavaria 90471Germany',1),('00:12:D1','Texas Instruments Inc','Texas Instruments Inc12500 Ti Boulevard,Ms 8723Dallas Texas 75243United States',1),('00:12:D2','Texas Instruments','Texas Instruments12500 Ti BoulevardMs 8723Dallas Texas 75243United States',1),('00:12:D3','Zetta Systems, Inc.','Zetta Systems, Inc.17311 135th Ave NeSuite B900Woodinville Wa 98072United States',1),('00:12:D4','Princeton Technology, Ltd','Princeton Technology, LtdK.a.i. Bldg. 3f3-9-5 Iwamoto-choChiyodaku Tokyo 101-0032Japan',1),('00:12:D5','Motion Reality Inc.','Motion Reality Inc.200 North Cobb ParkwaySuite 140Marietta Ga 30062United States',1),('00:12:D6','Jiangsu Yitong High-tech Co.,ltd','Jiangsu Yitong High-tech Co.,ltdNo 216 Huanghe RoadChangshu Jiangsu 215500China',1),('00:12:D7','Invento Networks, Inc.','Invento Networks, Inc.377 Simarano DriveMarlborough Ma 01752United States',1),('00:12:D8','International Games System Co., Ltd.','International Games System Co., Ltd.No.130, Wu-gung Rd., Wu-gu Industrial Park,Taipei  248Taiwan, Republic Of China',1),('00:12:D9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:DA','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:12:DB','Ziehl Industrie-elektronik Gmbh + Co Kg','Ziehl Industrie-elektronik Gmbh + Co KgDaimlerstr. 13Schwaebisch Hall  74523Germany',1),('00:12:DC','Suncorp Industrial Limited','Suncorp Industrial LimitedNo.68 Guowei Road,Liantang Industrial District, Shenzhen,China',1),('00:12:DD','Shengqu Information Technology (shanghai) Co., Ltd.','Shengqu Information Technology (shanghai) Co., Ltd.No.1 Building,no. 690 Bibo Road,pudong New AreaShanghai  201203China',1),('00:12:DE','Radio Components Sweden Ab','Radio Components Sweden AbViderogatan 3bKista Stockholm 16422Sweden',1),('00:12:DF','Novomatic Ag','Novomatic AgWiener Strasse 158Gumpoldskirchen Niedersterreich A-2352Austria',1),('00:12:E0','Codan Limited','Codan Limited81 Graves StreetNewton South 5074Australia',1),('00:12:E1','Alliant Networks, Inc','Alliant Networks, Inc1259 Birchwood Dr.Sunnyvale Ca 94089United States',1),('00:12:E2','Alaxala Networks Corporation','Alaxala Networks Corporation890 Kashimada, Saiwai-kuKawasaki-shi Kanagawa-ken 212-0058Japan',1),('00:12:E3','Agat-rt, Ltd.','Agat-rt, Ltd.101 Pr. Mira #1220,Moscow  129085Russian Federation',1),('00:12:E4','Ziehl Industrie-electronik Gmbh + Co Kg','Ziehl Industrie-electronik Gmbh + Co KgDaimlerstr. 13Schwaebisch Hall  74523Germany',1),('00:12:E5','Time America, Inc.','Time America, Inc.51 W. 3rd Street #310Tempe Az 85281United States',1),('00:12:E6','Spectec Computer Co., Ltd.','Spectec Computer Co., Ltd.6f., No. 92, Nanking E. Rd. Sec. 5,Taipei  105Taiwan, Republic Of China',1),('00:12:E7','Projectek Networking Electronics Corp.','Projectek Networking Electronics Corp.5f-9, No. 16, Lane 609, Sec. 5, Chungshin Rd.,Sanchung, Taipei  241Taiwan, Republic Of China',1),('00:12:E8','Fraunhofer Ims','Fraunhofer ImsFinkenstrasse 61Duisburg Nrw 47057Germany',1),('00:12:E9','Abbey Systems Ltd','Abbey Systems LtdLevel 4, 220 Willis StPo Box 27-497Wellington  6030New Zealand',1),('00:12:EA','Trane','Trane4833 White Bear ParkwaySt. Paul Mn 55110United States',1),('00:12:EB','R2di, Llc','R2di, Llc2575 Ne Kathryn St.Suite 14Hillsboro Or 97124United States',1),('00:12:EC','Movacolor B.v.','Movacolor B.v.Koperslagersstraat 31Sneek Friesland 8601 WlNetherlands',1),('00:12:ED','Avg Advanced Technologies','Avg Advanced Technologies4140 Utica Ridge RoadBettendorf Ia 52722United States',1),('00:12:EE','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:12:EF','Oneaccess Sa','Oneaccess Sa28 Rue De La RedouteFontenay Aux Roses  92260France',1),('00:12:F0','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:12:F1','Ifotec','IfotecZac ChampfeuilletBp247Voiron  38507France',1),('00:12:F2','Foundry Networks','Foundry Networks2100 Gold StreetPo Box 649100San Jose Ca 95164United States',1),('00:12:F3','Connectblue Ab','Connectblue AbNorra Vallgatan 64Malmoe  Se-211 22Sweden',1),('00:12:F4','Belco International Co.,ltd.','Belco International Co.,ltd.212, Yeokok-dong, Wonmi-guPuchun-si Kyongki-do 420-100Korea, Republic Of',1),('00:12:F5','Prolificx Ltd','Prolificx LtdPo Box 76204Manukau City  1702New Zealand',1),('00:12:F6','Mdk Co.,ltd.','Mdk Co.,ltd.2-6-27 IbarameKashiwazaki City Niigata 9451341Japan',1),('00:12:F7','Xiamen Xinglian Electronics Co., Ltd.','Xiamen Xinglian Electronics Co., Ltd.Xinglian Electronics (xingtel) Building,chuangxin Road,Torch Hi-tech Industrial District,Xiamen Fujian 361006China',1),('00:12:F8','Wni Resources, Llc','Wni Resources, Llc2146 Bering DriveSan Jose California 95131-2013United States',1),('00:12:F9','Uryu Seisaku, Ltd.','Uryu Seisaku, Ltd.1-2-11Fukae-minamiHigashinari-ku Osaka 537-0002Japan',1),('00:12:FA','Thx Ltd','Thx Ltd5201 Great America ParkwaySuite 320Santa Clara Ca 95054United States',1),('00:12:FB','Samsung Electronics','Samsung Electronics416, Maetan-3dong, Yeongtong-guSuwon-city Gyeonggi-do 443-742Korea, Republic Of',1),('00:12:FC','Planet System Co.,ltd','Planet System Co.,ltd4th Floor, Daehan B/d, 873-29,Bangbae4-dong, Seocho-ku,Seoul  137-064Korea, Republic Of',1),('00:12:FD','Optimus Ic S.a.','Optimus Ic S.a.Nawojowska 118Nowy Sacz Malopolska 33-300Poland',1),('00:12:FE','Lenovo Mobile Communication Technology Ltd.','Lenovo Mobile Communication Technology Ltd.Xiamen Overseas Chinese Electronic Science Park,huoju High Technology Development ZoneXia Men Fu Jian 361009China',1),('00:12:FF','Lely Industries N.v.','Lely Industries N.v.Weverskade 110Maassluis Zuid-holland 3147paNetherlands',1),('00:13:00','It-factory, Inc.','It-factory, Inc.1-16-26 Takagi Minami-kuFukuoka-shi Fukuoka-ken 815-0004Japan',1),('00:13:01','Irongate S.l.','Irongate S.l.Calcala 268, Primera PlantaMadrid  28027Spain',1),('00:13:02','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:13:03','Gateconnect Technologies Gmbh','Gateconnect Technologies GmbhAgastrasse 24 R212489 Berlin  12489Germany',1),('00:13:04','Flaircomm Technologies Co. Ltd','Flaircomm Technologies Co. Ltd2088 Huashan RoadSouth Huiyin Bldg. #2306Shanghai  200030China',1),('00:13:05','Epicom, Inc.','Epicom, Inc.Po Box 16130Oakland Ca 94610United States',1),('00:13:06','Always On Wireless','Always On Wireless3701 Kirby DrSuite 1090Houston Tx 77098United States',1),('00:13:07','Paravirtual Corporation','Paravirtual Corporation2953 Bunker Hill LaneSuite 406Santa Clara Ca 95054United States',1),('00:13:08','Nuvera Fuel Cells','Nuvera Fuel Cells129 Concord Road, #1Billerica Ma 01821United States',1),('00:13:09','Ocean Broadband Networks','Ocean Broadband Networks2078 Walsh Ave, Suite BSanta Clara California 95050United States',1),('00:13:0A','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:13:0B','Mextal B.v.','Mextal B.v.De Tienden 48Nuenen Noord Brabant 5674tbNetherlands',1),('00:13:0C','Hf System Corporation','Hf System Corporation1520-1 AyukaiShirataka-machiNishiokitama-gun Yamagata-ken 992-0771Japan',1),('00:13:0D','Galileo Avionica','Galileo AvionicaViale EuropaNerviano Milano 20014Italy',1),('00:13:0E','Focusrite Audio Engineering Limited','Focusrite Audio Engineering Limited19 Lincoln RoadCressex Business ParkHigh Wycombe Bucks Hp12 3fxUnited Kingdom',1),('00:13:0F','Egemen Bilgisayar Muh San Ve Tic Ltd Sti','Egemen Bilgisayar Muh San Ve Tic Ltd StiFevzi Cakmak 2 Sok 31/aKizilayAnkara Cankaya 06440Turkey',1),('00:13:10','Cisco-linksys, Llc','Cisco-linksys, Llc121 TheoryIrvine Ca 92612United States',1),('00:13:11','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:13:12','Amedia Networks Inc.','Amedia Networks Inc.101 Crawfords Corner RdHolmdel Nj 07733United States',1),('00:13:13','Guangzhou Post & Telecom Equipment Ltd','Guangzhou Post & Telecom Equipment Ltd139# Zhongshan AveGuangzhou Guangdong 510630China',1),('00:13:14','Asiamajor Inc.','Asiamajor Inc.6f-9, No. 268, Lian-cheng Rd., Junghe City,Taipei  235Taiwan, Republic Of China',1),('00:13:15','Sony Computer Entertainment Inc,','Sony Computer Entertainment Inc,6-21,2chomeMinami-aoyamaMinato-ku Tokyo 107-0062Japan',1),('00:13:16','L-s-b Gmbh','L-s-b GmbhGustav-stresemann-str. 8Bingen Rheinland-pfalz 55411Germany',1),('00:13:17','Gn Netcom As','Gn Netcom AsMetalbuen 66P.o.box 201Ballerup Skovlunde Dk-2750Denmark',1),('00:13:18','Dgstation Co., Ltd.','Dgstation Co., Ltd.Rm.401, Bldg.a, Bundang Techno Park 150, Yatap-dong, Bundang-gu, Sungnam-si, Gyunggi-do, 463-760, KoreaSungnam Gyunggi 463-760Korea, Republic Of',1),('00:13:19','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:1A','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:1B','Becell Innovations Corp.','Becell Innovations Corp.12f-9, No. 79, Shin-tai 5th Rd Sec 1,Shih-chih, Taipei 221Taiwan, Republic Of China',1),('00:13:1C','Litetouch, Inc.','Litetouch, Inc.3400 South West TempleSalt Lake City Ut 84115United States',1),('00:13:1D','Scanvaegt International A/s','Scanvaegt International A/sP.o.pedersens Vej 18Aarhus Jylland 8200 NDenmark',1),('00:13:1E','Peiker Acustic Gmbh & Co. Kg','Peiker Acustic Gmbh & Co. KgMax-planck-strae 32Friedrichsdorf Hessen 61381Germany',1),('00:13:1F','Nxtphase T&d, Corp.','Nxtphase T&d, Corp.3040 E. BroadwayVancouver Bc V5m 1z4Canada',1),('00:13:20','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:13:21','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms070405Houston Tx 77070United States',1),('00:13:22','Daq Electronics, Inc.','Daq Electronics, Inc.262b Old New Brunswick RoadPiscataway Nj 08854United States',1),('00:13:23','Cap Co., Ltd.','Cap Co., Ltd.11f,684-2,deungchon 3-dong,gangseo-guSeoul  157-754Korea, Republic Of',1),('00:13:24','Schneider Electric Ultra Terminal','Schneider Electric Ultra TerminalIndustriparken 32Copenhagen  2750Denmark',1),('00:13:25','Cortina Systems Inc','Cortina Systems Inc840 W California Ave, Suite 100Sunnyvale Ca 94086United States',1),('00:13:26','Ecm Systems Ltd','Ecm Systems LtdEllifoot ParkBurstwickHull East Yorkshire Hu12 9dzUnited Kingdom',1),('00:13:27','Data Acquisitions Limited','Data Acquisitions Limited84 Gasson StreetChristchurchNew Zealand',1),('00:13:28','Westech Korea Inc.,','Westech Korea Inc.,548-9, Gajwa3-dong,seo-ku,Incheon  404-817Korea, Republic Of',1),('00:13:29','Vsst Co., Ltd','Vsst Co., LtdSuit 3202, Korea World Trade Center 159-1Samsung-dong, Kangnam-guSeoul  135-729Korea, Republic Of',1),('00:13:2A','Sitronics Telecom Solutions','Sitronics Telecom SolutionsMichelska 60Prague Prague 4 - Michle 140 00Czech Republic',1),('00:13:2B','Phoenix Digital','Phoenix Digital7650 East Evans Rd. Bldg. AScottsdale Az 85260United States',1),('00:13:2C','Maz Brandenburg Gmbh','Maz Brandenburg GmbhMielestrae 2Werder Brandenburg 14542Germany',1),('00:13:2D','Iwise Communications','Iwise CommunicationsUnit 3c, Arden GroveRacecourse Rd,montagu GardensCape Town  7441South Africa',1),('00:13:2E','Itian Coporation','Itian Coporation4f Youngho Bd.1605-1 Seocho-dongSeocho-guSeoul  137-070Korea, Republic Of',1),('00:13:2F','Interactek','InteractekSigmal 2 Bldg #c-319, 18 Kumi-dongPundang-kuSeongnam Kyung-gi 463-741Korea, Republic Of',1),('00:13:30','Euro Protection Surveillance','Euro Protection Surveillance30 Rue Du DoubsStrasbourg  67100France',1),('00:13:31','Cellpoint Connect','Cellpoint ConnectBilledvej 4Copenhagen  2100Denmark',1),('00:13:32','Beijing Topsec Network Security Technology Co., Ltd.','Beijing Topsec Network Security Technology Co., Ltd.4th Floor, Huakong TowerNo. 1 Shangdi East RoadHaidian District Beijing 100080China',1),('00:13:33','Baud Technology Inc.','Baud Technology Inc.12f, No.181, Sec.  1. Tatung Rd.,Hsichih Taipei Hsien 221Taiwan, Republic Of China',1),('00:13:34','Arkados, Inc.','Arkados, Inc.948 Us Hwy 22North Plainfield Nj 07060United States',1),('00:13:35','Vs Industry Berhad','Vs Industry BerhadPlo 47, Senai Ind. Est. Ii,Senai Johor 81400Malaysia',1),('00:13:36','Tianjin 712 Communication Broadcasting Co., Ltd.','Tianjin 712 Communication Broadcasting Co., Ltd.No.185, Xinda Road, Hebei DistrictTianjin  300140China',1),('00:13:37','Orient Power Home Network Ltd.','Orient Power Home Network Ltd.307 Harbour Centre, Tower 1,1 Hok Cheung Street, Hung HomHong Kong',1),('00:13:38','Fresenius-vial','Fresenius-vialLe Grand CheminBrezins  38590France',1),('00:13:39','El-me Ag','El-me AgGewerbering 1Au I. D. Hallertau Bayern 84072Germany',1),('00:13:3A','Vadatech Inc.','Vadatech Inc.11540 S. Eastern AvenueHenderson Nevada 89052United States',1),('00:13:3B','Speed Dragon Multimedia Limited','Speed Dragon Multimedia LimitedRoom 1312, Vanta Industrial Centre,33 Tai Lin Pai Road,Kwai Chung N.t.Hong Kong',1),('00:13:3C','Quintron Systems Inc.','Quintron Systems Inc.2105 So. Blosser RoadSanta Maria California 93458United States',1),('00:13:3D','Micro Memory Llc','Micro Memory Llc9540 Vassar AvenueChatsworth Ca 91311United States',1),('00:13:3E','Metaswitch','Metaswitch1411 Harbor Bay ParkwaySuite 1003Alameda Ca 94502United States',1),('00:13:3F','Eppendorf Instrumente Gmbh','Eppendorf Instrumente GmbhBarkhausenweg 1Abtl. Ih-feHamburg De 22339Germany',1),('00:13:40','Ad.el S.r.l.','Ad.el S.r.l.Via S. Pertini,5Martellago Venezia 30030Italy',1),('00:13:41','Shandong New Beiyang Information Technology Co.,ltd','Shandong New Beiyang Information Technology Co.,ltdNo.11 Xinwei RoadWeihai City Shandong 264200China',1),('00:13:42','Vision Research, Inc.','Vision Research, Inc.100 Dey RoadWayne Nj 07470United States',1),('00:13:43','Matsushita Electronic Components (europe) Gmbh','Matsushita Electronic Components (europe) GmbhZeppelinstrae 19Lueneburg Niedersachsen 21337Germany',1),('00:13:44','Fargo Electronics Inc.','Fargo Electronics Inc.6533 Flying Cloud DriveEden Prairie Mn 55344United States',1),('00:13:45','Eaton Corporation','Eaton Corporation4201 North 27th StreetMilwaukee Wisconsin 53216United States',1),('00:13:46','D-link Corporation','D-link Corporation2f, No.233-2, Pao-chiao RoadHsin-tien, Taipei 231Taiwan, Republic Of China',1),('00:13:47','Bluetree Wireless Data Inc.','Bluetree Wireless Data Inc.2425 46e AvenueLachine Quebec H8t 3c9Canada',1),('00:13:48','Artila Electronics Co., Ltd.','Artila Electronics Co., Ltd.2f., No.1, Alley 8, Siwei Lane, Zhongzheng Rd.,Xindian City Taipei County 231Taiwan, Republic Of China',1),('00:13:49','Zyxel Communications Corporation','Zyxel Communications CorporationNo. 6, Innovation Road Ii Science ParkHsin-chu  300Taiwan, Republic Of China',1),('00:13:4A','Engim, Inc.','Engim, Inc.40 Nagog ParkActon Ma 01720United States',1),('00:13:4B','Togoldennet Technology Inc.','Togoldennet Technology Inc.5f-1 No.25,pu-ding.,Hsin-chu  300Taiwan, Republic Of China',1),('00:13:4C','Ydt Technology International','Ydt Technology International2f., No.218, Rueiguang Rd.,Neihu DistrictTaipei,  114Taiwan, Republic Of China',1),('00:13:4D','Ipc Systems','Ipc SystemsNoordeinde 72Leimuiden Noordholland 2451 AhNetherlands',1),('00:13:4E','Valox Systems, Inc.','Valox Systems, Inc.#704, Ace Twin Tower 2, 212-30, Guro-3dong, Guro-guSeoul  152-779Korea, Republic Of',1),('00:13:4F','Tranzeo Wireless Technologies Inc.','Tranzeo Wireless Technologies Inc.20155 Stewart Cres.Maple Ridge British Columbia V2x 0t6Canada',1),('00:13:50','Silver Spring Networks, Inc','Silver Spring Networks, Inc575 Broadway StreetRedwood City Ca 94063United States',1),('00:13:51','Niles Audio Corporation','Niles Audio Corporation12331 Sw 130th StreetMiami Fl 33186United States',1),('00:13:52','Naztec, Inc.','Naztec, Inc.820 Park Two Dr.Sugar Land Tx 77478United States',1),('00:13:53','Hydac Filtertechnik Gmbh','Hydac Filtertechnik GmbhIndustriegebietSulzbach/saar Saarland 66280Germany',1),('00:13:54','Zcomax Technologies, Inc.','Zcomax Technologies, Inc.98 Ford RoadSuite 3-fDenville Nj 07834United States',1),('00:13:55','Tomen Cyber-business Solutions, Inc.','Tomen Cyber-business Solutions, Inc.2-11-19 KohnanMinatoku-kuTokyo  108-0075Japan',1),('00:13:56','Target Systemelectronic Gmbh','Target Systemelectronic GmbhKoelner Strae 99Solingen Nrw 42651Germany',1),('00:13:57','Soyal Technology Co., Ltd.','Soyal Technology Co., Ltd.10f, No. 27, Lane 169, Kangning St., Shijr City,2f, No. 27, Lane 169, Kangning St., Shijr City,Taipei  221Taiwan, Republic Of China',1),('00:13:58','Realm Systems, Inc.','Realm Systems, Inc.9350 South 535 East9th FloorSandy Utah 84070United States',1),('00:13:59','Protelevision Technologies A/s','Protelevision Technologies A/sMarielundvej 16,2Herlev Copenhagen 2730Denmark',1),('00:13:5A','Project T&e Limited','Project T&e LimitedRoom 3c, 2/f. Wah Shing Center,11 Shing Yip Street,Kwun Tong, Kowloon, 852Hong Kong',1),('00:13:5B','Panellink Cinema, Llc','Panellink Cinema, Llc1070 E Arques AveSunnyvale Ca 94085United States',1),('00:13:5C','Onsite Systems, Inc.','Onsite Systems, Inc.3900 Freedom CircleSuite 102Santa Clara Ca 95054-1222United States',1),('00:13:5D','Nttpc Communications, Inc.','Nttpc Communications, Inc.3-25 Kanda Jinbo-choChiyoda-ku Tokyo 101-0051Japan',1),('00:13:5E','Eab/rwi/k','Eab/rwi/kFrgatan 6Stockholm Kista 164 80Sweden',1),('00:13:5F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:60','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:61','Biospace Co., Ltd.','Biospace Co., Ltd.10th Floor, Poonglim Bldg, 823 Yeoksam 1-dongGangnam-gu Seoul 135-784Korea, Republic Of',1),('00:13:62','Shinheung Precision Co., Ltd.','Shinheung Precision Co., Ltd.Daeha Bldg. 401101-7 ShingildongYoungdungpogu Seoul 150-050Korea, Republic Of',1),('00:13:63','Verascape, Inc.','Verascape, Inc.1101 31st St., Suite #190Downers Grove Il 60515United States',1),('00:13:64','Paradigm Technology Inc..','Paradigm Technology Inc..3f, No. 285, Sec.2, Ti-ding Blvd Nei-hu,Taipei  114Taiwan, Republic Of China',1),('00:13:65','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:13:66','Neturity Technologies Inc.','Neturity Technologies Inc.830 Stewart DriveSunnyvale Ca 94085United States',1),('00:13:67','Narayon. Co., Ltd.','Narayon. Co., Ltd.#502 Hyochang T/w 181-3Jamsil-dong, Songpa-guSeoul  138-220Korea, Republic Of',1),('00:13:68','Maersk Data Defence','Maersk Data DefenceEllegaardvej 25Soenderborg Dk 6400Denmark',1),('00:13:69','Honda Electron Co., Led.','Honda Electron Co., Led.2-14-1, KyobashiChuo-ku Tokyo 104-0031Japan',1),('00:13:6A','Hach Ultra Analytics','Hach Ultra Analytics6, Route De CompoisCp 212Vesenaz Geneva 1222Switzerland',1),('00:13:6B','E-tec','E-tec2-17-14-503 HakataekimaeHakataku FukuokashiFukuoka Fukuokaken 812-0011Japan',1),('00:13:6C','Tomtom','TomtomOosterdoksstraat 1141011 Dk AmsterdamNetherlands',1),('00:13:6D','Tentaculus Ab','Tentaculus AbStudiegangen 3Ostersund Jamtland Se - 831 40Sweden',1),('00:13:6E','Techmetro Corp.','Techmetro Corp.4f. Dongam B/d., 264-5, Yangjae-dongSeocho-kuSeoul  137-130Korea, Republic Of',1),('00:13:6F','Packetmotion, Inc.','Packetmotion, Inc.2121 El Camino Real10th FloorSan Mateo Ca 94403United States',1),('00:13:70','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:13:71','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:13:72','Dell Inc.','Dell Inc.One Dell WayRound Rock Texas 78682United States',1),('00:13:73','Blwave Electronics Co., Ltd','Blwave Electronics Co., Ltd23fgh, Block A,zhenye Building , Baoan Nan Road , Luohu , Shenzhen , ChinaShenzhen Guangdong 518000China',1),('00:13:74','Atheros Communications, Inc.','Atheros Communications, Inc.5480 Great America ParkwaySanta Clara Ca 95054United States',1),('00:13:75','American Security Products Co.','American Security Products Co.11925 Pacific Ave.Fontana Ca 92335United States',1),('00:13:76','Tabor Electronics Ltd.','Tabor Electronics Ltd.9 Hatatsia St.Tel Hanan  20302Israel',1),('00:13:77','Samsung Electronics Co., Ltd','Samsung Electronics Co., Ltd416, Maetan 3dong, Yeongtong-guSuwon City, Geyonggi Do, KoreaSuwon Geyonggi 443742Korea, Republic Of',1),('00:13:78','Qsan Technology, Inc.','Qsan Technology, Inc.2f., No.31, Lane 583, Rueiguang Rd., Neihu Dist.Taipei  114Taiwan, Republic Of China',1),('00:13:79','Ponder Information Industries Ltd.','Ponder Information Industries Ltd.14f,no.77,lane700, Chung-cheng RoadHsin-tien City Taipei Hsien 231Taiwan, Republic Of China',1),('00:13:7A','Netvox Technology Co., Ltd.','Netvox Technology Co., Ltd.No.21-1 Sec. 1 Chung Hua West RoadTainan  702Taiwan, Republic Of China',1),('00:13:7B','Movon Corporation','Movon Corporation5th, Hyunjuk B/d140-28, Samsung-dong, Kangnam-kuSeoul  135-092Korea, Republic Of',1),('00:13:7C','Kaicom Co., Ltd.','Kaicom Co., Ltd.#109, Gayang Techno Town 1487, Gayang-dong,kangso-guSeoul  157-810Korea, Republic Of',1),('00:13:7D','Dynalab, Inc.','Dynalab, Inc.555 Lancaster Ave.Reynoldsburg Oh 43068United States',1),('00:13:7E','Coredge Networks, Inc.','Coredge Networks, Inc.7600 Boone Ave NSuite 1Brooklyn Park Mn 55428United States',1),('00:13:7F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:80','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:81','Chips & Systems, Inc.','Chips & Systems, Inc.4750 Patrick Henry DriveSanta Clara California 95054United States',1),('00:13:82','Cetacea Networks Corporation','Cetacea Networks Corporation3708 West 36th AvenueVancouver British Columbia V6n 2s4Canada',1),('00:13:83','Application Technologies And Engineering Research Laboratory','Application Technologies And Engineering Research LaboratoryShinjuku 1-chome Bldg.1-10-4, ShinjukuShinjuku-ku Tokyo 160-0022Japan',1),('00:13:84','Advanced Motion Controls','Advanced Motion Controls3805 Calle TecateCamarillo California 93012United States',1),('00:13:85','Add-on Technology Co., Ltd.','Add-on Technology Co., Ltd.1f, No.11, Lane 206, Da-an Road Sec. 1,Taipei  106Taiwan, Republic Of China',1),('00:13:86','Abb Inc./totalflow','Abb Inc./totalflow7051 Industrial Blvd.Bartlesville Ok 74006United States',1),('00:13:87','27m Technologies Ab','27m Technologies AbDiskettgatan 11Linkping  S-583 35Sweden',1),('00:13:88','Wimedia Alliance','Wimedia Alliance2400 Camino RamonSuite 375San Ramon Ca 94583United States',1),('00:13:89','Redes De Telefona Mvil S.a.','Redes De Telefona Mvil S.a.C/puerto De La Morcuera 14 B4Legans Madrid 28918Spain',1),('00:13:8A','Qingdao Goertek Electronics Co.,ltd.','Qingdao Goertek Electronics Co.,ltd.Room 605,innovation Building,hi-tech Industrial Park,Qingdao Shandong 266061China',1),('00:13:8B','Phantom Technologies Llc','Phantom Technologies Llc7825 Fay Avenue, Suite 200La Jolla Ca 92037United States',1),('00:13:8C','Kumyoung.co.ltd','Kumyoung.co.ltdSeoul Ky Building, 40-17 Hangang Ro, 3ga, Youngsan-guSeoul  140-880Korea, Republic Of',1),('00:13:8D','Kinghold','Kinghold11f, No. 965, Jungjeng Rd.Junghe Taipei 235Taiwan, Republic Of China',1),('00:13:8E','Foab Elektronik Ab','Foab Elektronik AbSankt Jorgens Vag 8Gothenburg  422 49Sweden',1),('00:13:8F','Asiarock Incorporation','Asiarock IncorporationP.o. Box957, Offshore Incorporations CentreRoad Town TortolaVirgin Islands, British',1),('00:13:90','Termtek Computer Co., Ltd','Termtek Computer Co., Ltd2f, No. 100, Li De St.,Chung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:13:91','Ouen Co.,ltd.','Ouen Co.,ltd.Gotanda Nt Bldg.7f,5-2 Higashi Gotanda 4-chomeShinagawa-ku Tokyo 141-0022Japan',1),('00:13:92','Ruckus Wireless','Ruckus Wireless880 West Maude AvenueSuite 101Sunnyvale Ca 94045United States',1),('00:13:93','Panta Systems, Inc.','Panta Systems, Inc.20450 Stevens Creek Blvd.Suite 400Cupertino California 95014United States',1),('00:13:94','Infohand Co.,ltd','Infohand Co.,ltdKranz-techno #1207, 5442-1, Sangdaewon-dong, Jungwon-guSeongnam-si Gyeonggi-do 462-819Korea, Republic Of',1),('00:13:95','Congatec Ag','Congatec AgAuwiesenstrasse 5Deggendorf  94469Germany',1),('00:13:96','Acbel Polytech Inc.','Acbel Polytech Inc.No.159,sec.3, Tam-king Rd.,Tamsui Taipei 251Taiwan, Republic Of China',1),('00:13:97','Xsigo Systems, Inc.','Xsigo Systems, Inc.940 Stewart DriveSunnyvale Ca 94085United States',1),('00:13:98','Trafficsim Co.,ltd','Trafficsim Co.,ltd23-9 Mita-biru 2f, Chiyoda 3-chomeNaka-ku, NagoyaAichi Non 460-0012Japan',1),('00:13:99','Stac Corporation.','Stac Corporation.2-16-37,fujimiSayama-shi Saitama 350-1306Japan',1),('00:13:9A','K-ubique Id Corp.','K-ubique Id Corp.Yamasan Bldg.8f,Nihonbashi Honcho2-6-13Chuo-ku Tokyo 103-0023Japan',1),('00:13:9B','Ioimage Ltd.','Ioimage Ltd.3 Maskit StreetHerzliya Pituach Il 46733Israel',1),('00:13:9C','Exavera Technologies, Inc.','Exavera Technologies, Inc.195 New Hampshire AvenueSuite 155Portsmouth Nh 03801United States',1),('00:13:9D','Design Of Systems On Silicon S.a.','Design Of Systems On Silicon S.a.C/ Charles Robert Darwin, 2Paterna Valencia 46980Spain',1),('00:13:9E','Ciara Technologies Inc.','Ciara Technologies Inc.9300 Trans Canada HighwaySaint-laurent Quebec H4s 1k5Canada',1),('00:13:9F','Electronics Design Services, Co., Ltd.','Electronics Design Services, Co., Ltd.5-10-20 TokumaruItabashi-ku Tokyo 175-0083Japan',1),('00:13:A0','Algosystem Co., Ltd.','Algosystem Co., Ltd.656 Kobirao Mihara-choSakai Osaka 587-0021Japan',1),('00:13:A1','Crow Electronic Engeneering','Crow Electronic Engeneering12 Kinneret St.Airport CityIsrael',1),('00:13:A2','Maxstream, Inc','Maxstream, Inc355 South 520 West Suite 180Lindon Ut 84042United States',1),('00:13:A3','Siemens Com Cpe Devices','Siemens Com Cpe Devices4849 Alpha RoadDallas Texas 75244United States',1),('00:13:A4','Keyeye Communications','Keyeye Communications9785 GoetheSacramento Ca 95827United States',1),('00:13:A5','General Solutions, Ltd.','General Solutions, Ltd.5902 Sovereign DriveHouston Texas 77036United States',1),('00:13:A6','Extricom Ltd','Extricom LtdGlil YamHerzlia  46905Israel',1),('00:13:A7','Battelle Memorial Institute','Battelle Memorial Institute505 King AveColumbus Ohio 43201United States',1),('00:13:A8','Tanisys Technology','Tanisys Technology12201 Technology Blvd.Suite 125Austin Tx 78727-6601United States',1),('00:13:A9','Sony Corporation','Sony CorporationEngineering Standardization Office:mono-zukuri Technology Div.Gotenyama Tec 5-1-2 Kitashinagawa,Shinagawa-ku Tokyo 141-0001Japan',1),('00:13:AA','Als  & Tec Ltd.','Als  & Tec Ltd.6 B. Kazachya Str.Saratov Saratov Region 410600Russian Federation',1),('00:13:AB','Telemotive Ag','Telemotive AgBreitwiesenMuehlhausen Baden Wuerttemberg 73347Germany',1),('00:13:AC','Sunmyung Electronics Co., Ltd','Sunmyung Electronics Co., LtdLargo-plaza 8f, Janghang-dong857-1, Ilsan-kuKoyang Kyungki 411-837Korea, Republic Of',1),('00:13:AD','Sendo Ltd','Sendo LtdHatchford BrookHatchford WayBirmingham West Midlands B26 3rzUnited Kingdom',1),('00:13:AE','Radiance Technologies, Inc.','Radiance Technologies, Inc.350 Wynn Dr.Huntsville Alabama 35805United States',1),('00:13:AF','Numa Technology,inc.','Numa Technology,inc.4f,no778,sec 4,patch Rd.Taipei  115Taiwan, Republic Of China',1),('00:13:B0','Jablotron','JablotronPod Skalkou 33Jablonec Nad Nisou  46601Czech Republic',1),('00:13:B1','Intelligent Control Systems (asia) Pte Ltd','Intelligent Control Systems (asia) Pte Ltd70 Ubi Crescent #01-12Ubi Tech Park408570Singapore',1),('00:13:B2','Carallon Limited','Carallon LimitedStudio G20 Shepherds BuildingRockley RoadLondon W14 0daUnited Kingdom',1),('00:13:B3','Ecom Communications Technology Co., Ltd.','Ecom Communications Technology Co., Ltd.Floor 7, Machinery Industry Building, No.22,Baiwanzhuang Street, Xicheng DistrictBeijingChina',1),('00:13:B4','Appear Tv','Appear TvLilleakerveien 6dP.o. Box 8 LilleakerNo-0216 OsloNorway',1),('00:13:B5','Wavesat','Wavesat1375, Trans-canada HighwaySuite 300Dorval Quebec H9p 2w8Canada',1),('00:13:B6','Sling Media, Inc.','Sling Media, Inc.1840 Gateway Center2nd FloorSan Mateo Ca 94404United States',1),('00:13:B7','Scantech Id','Scantech IdAmersfoortsestraat 124Soesterberg Utrecht 3769 AnNetherlands',1),('00:13:B8','Ryco Electronic Systems Limited','Ryco Electronic Systems LimitedUnit E, Cartel Business EstateEdinburgh WayHarlow Essex Cm20 2ttUnited Kingdom',1),('00:13:B9','Bm Spa','Bm SpaVia Milano 54/56Rozzano  20089Italy',1),('00:13:BA','Readylinks Inc','Readylinks Inc6595 Edenvale BoulevardSuite 180Eden Prairie Mn 55346United States',1),('00:13:BB','Smartvue Corporation','Smartvue Corporation102 Woodmont BoulevardSuite 200Nashville Tn 37205United States',1),('00:13:BC','Artimi Ltd','Artimi LtdBetjeman House104 Hills RoadCambridge Cambridgeshire Cb2 1lqUnited Kingdom',1),('00:13:BD','Hymatom Sa','Hymatom SaZone Industrielle175 Rue De MassacanVendargues Herault 34740France',1),('00:13:BE','Virtual Conexions','Virtual Conexions410 Rue St-nicolas, Suite 600Montral Qubec H2y 2p5Canada',1),('00:13:BF','Media System Planning Corp.','Media System Planning Corp.4f Velco-kuromon Bldg.3-14-5 Ueno,Taito-ku, Tokyo 110-0005Japan',1),('00:13:C0','Trix Tecnologia Ltda.','Trix Tecnologia Ltda.Rua Da Paz, 1957 - Chcara Santo AntnioSo Paulo  04713-002Brazil',1),('00:13:C1','Asoka Usa Corporation','Asoka Usa Corporation558 Pilgrim DriveUnit HFoster City Ca 94404United States',1),('00:13:C2','Wacom Co.,ltd','Wacom Co.,ltd2-510-1 Toyonodai Otone-machiKitasaitama-gun Saitama 349-1148Japan',1),('00:13:C3','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:C4','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:13:C5','Lightron Fiber-optic Devices Inc.','Lightron Fiber-optic Devices Inc.51-1 Moonpyung-dong, Taeduck-guTaejon 306-220Korea, Republic Of',1),('00:13:C6','Opengear, Inc','Opengear, Inc7984 South Welby Park #101Salt Lake City Utah 84088United States',1),('00:13:C7','Ionos Co.,ltd.','Ionos Co.,ltd.1-36-18 MiyasakaSetagaya-ku Tokyo 156-0051Japan',1),('00:13:C8','Pirelli Broadband Solutions S.p.a.','Pirelli Broadband Solutions S.p.a.Viale Sarca 222Milano  20126Italy',1),('00:13:C9','Beyond Achieve Enterprises Ltd.','Beyond Achieve Enterprises Ltd.',1),('00:13:CA','X-digital Systems, Inc.','X-digital Systems, Inc.9727 Pacific Heights BlvdSuite 200San Diego Ca 92121United States',1),('00:13:CB','Zenitel Norway As','Zenitel Norway AsSandaker V 24 CPo Box 4498Oslo 0403Norway',1),('00:13:CC','Tall Maple Systems','Tall Maple Systems85 Saratoga Ave Suite 139Santa Clara Ca 95051United States',1),('00:13:CD','Mti Co. Ltd','Mti Co. Ltd166-10 Karak-dongR&d Group 3Songpa-ku Seoul 138-810Korea, Republic Of',1),('00:13:CE','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKedah 09000Malaysia',1),('00:13:CF','4access Communications','4access Communications1 N. Lasalle St.Suite 2015Chicago Il 60602United States',1),('00:13:D0','T+ Medical Ltd','T+ Medical Ltd174e Milton ParkAbingdon  Ox14 4seUnited Kingdom',1),('00:13:D1','Kirk Telecom A/s','Kirk Telecom A/sLangmarksvej 34Horsens  8700Denmark',1),('00:13:D2','Page Iberica, S.a.','Page Iberica, S.a.Av. De La Industria, 24Tres Cantos Madrid 28760Spain',1),('00:13:D3','Micro-star International Co., Ltd.','Micro-star International Co., Ltd.No. 69, Li-de St.Jung-he City Taipei Hsien 235Taiwan, Republic Of China',1),('00:13:D4','Asustek Computer Inc.','Asustek Computer Inc.No.5 Shing Yeh StreetKwei Shan HsiangTao Yuan Hsien  333Taiwan, Republic Of China',1),('00:13:D5','Winetworks Ltd','Winetworks Ltd32 Maskit St.Herzeliya  46733Israel',1),('00:13:D6','Tii Network Technologies, Inc.','Tii Network Technologies, Inc.1385 Akron StreetCopiague Ny 11726United States',1),('00:13:D7','Spidcom Technologies Sa','Spidcom Technologies Sa137 Avenue Du General LeclercBourg La Reine  92340France',1),('00:13:D8','Princeton Instruments','Princeton Instruments3660 Quakerbridge RoadTrenton Nj 08619United States',1),('00:13:D9','Matrix Product Development, Inc.','Matrix Product Development, Inc.13 North Bird StreetSun Prairie Wi 53590United States',1),('00:13:DA','Diskware Co., Ltd','Diskware Co., Ltd1-4-12 KibaNakojikiba Bldg.5fKoto-ku Tokyo 135-0042Japan',1),('00:13:DB','Shoei Electric Co.,ltd','Shoei Electric Co.,ltd1-29-2,wakabayashiSetagaya-ku Tokyo 154-0023Japan',1),('00:13:DC','Ibtek Inc.','Ibtek Inc.16f, 30, Pei-ping East Rd.,Taipei  100Taiwan, Republic Of China',1),('00:13:DD','Abbott Diagnostics','Abbott Diagnostics5440 Patrick Henry DriveSanta Clara Ca 95054United States',1),('00:13:DE','Adapt4, Llc','Adapt4, Llc1050 W Nasa Blvd,Suite 134Melbourne Fl 32901United States',1),('00:13:DF','Ryvor Corp.','Ryvor Corp.15145 Red Hill Ave.Suite BTustin Ca 92780United States',1),('00:13:E0','Murata Manufacturing Co., Ltd.','Murata Manufacturing Co., Ltd.2288, Oshinohara,Yasu-shi Shiga 520-2393Japan',1),('00:13:E1','Iprobe Ab','Iprobe AbFinlandsgatan 12Kista Se-16474Sweden',1),('00:13:E2','Geovision Inc.','Geovision Inc.12f.,no.316,sec.1,Neihu Rd,neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:13:E3','Covi Technologies, Inc.','Covi Technologies, Inc.6300 Bridgepoint ParkwaySuite 300, Bldg. IiAustin Texas 78730United States',1),('00:13:E4','Yangjae Systems Corp.','Yangjae Systems Corp.1202. Hanshin It Tower Guro-3dong,Guro-guSeoul 152-848Korea, Republic Of',1),('00:13:E5','Tenosys, Inc.','Tenosys, Inc.Seojin B/d, 1564-1, Seocho-dong,Seocho-guSeoul 137-070Korea, Republic Of',1),('00:13:E6','Technolution','TechnolutionZuidelijkhalfrond 1Gouda Zh 2801 DdNetherlands',1),('00:13:E7','Halcro','HalcroSuite 1, Level 18 Greenhill RdWayville South Australia 5034Australia',1),('00:13:E8','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKedah 09000Malaysia',1),('00:13:E9','Veriwave, Inc.','Veriwave, Inc.9600 Sw Oak St.Portland Or 97223United States',1),('00:13:EA','Kamstrup A/s','Kamstrup A/sIndustrivej 28Stilling  8660Denmark',1),('00:13:EB','Sysmaster Corporation','Sysmaster Corporation5801 Christie Ave.Suite 400Emeryville Ca 94608United States',1),('00:13:EC','Sunbay Software Ag','Sunbay Software AgSeestrasse 78Rueschlikon Zh 8803Switzerland',1),('00:13:ED','Psia','Psia517-13 Induspis 5thSangdaewondong JungwonguSungnam KyunggiKorea, Republic Of',1),('00:13:EE','Jbx Designs Inc.','Jbx Designs Inc.Po Box 970158Boca Raton Fl 33497United States',1),('00:13:EF','Kingjon Digital Technology Co.,ltd','Kingjon Digital Technology Co.,ltdRoom 827,huanan Dianli Bulding,no.2050Shenzhen Guangdong 518031China',1),('00:13:F0','Wavefront Semiconductor','Wavefront Semiconductor4746 44th Ave SwSuite 201Seattle Wa 98116United States',1),('00:13:F1','Amod Technology Co., Ltd.','Amod Technology Co., Ltd.2f., No. 16, Prosperity Road IiScience-based Industrial Park,Hsinchu,  30078Taiwan, Republic Of China',1),('00:13:F2','Klas Ltd','Klas LtdBracetown Business ParkClonee Co MeathIreland',1),('00:13:F3','Giga-byte Communications Inc.','Giga-byte Communications Inc.8f, No.43, Fu-hsin Road. Hsin-tienTaipei Hsien  231Taiwan, Republic Of China',1),('00:13:F4','Psitek (pty) Ltd','Psitek (pty) LtdThe Vineyards Office Estate99 Jip De Jager DriveTyger Valley Cape Town 7530South Africa',1),('00:13:F5','Akimbi Systems','Akimbi Systems1400 Fashion Island BlvdSuite 900San Mateo Ca 94404United States',1),('00:13:F6','Cintech','Cintech21a Route De La WantzenauHoenheim  67800France',1),('00:13:F7','Smc Networks, Inc.','Smc Networks, Inc.38 TeslaIrvine Ca 92618United States',1),('00:13:F8','Dex Security Solutions','Dex Security Solutions10 Junction Road Parktown2nd Floor Bp HouseJohannesburg Guteng 2000South Africa',1),('00:13:F9','Cavera Systems','Cavera Systems2355 Oakland Rd, Suite#33San Jose Ca 95131United States',1),('00:13:FA','Lifesize Communications, Inc','Lifesize Communications, Inc901 S. MopacBldg 3, Suite 300Austin Tx 78746United States',1),('00:13:FB','Rkc Instrument Inc.','Rkc Instrument Inc.16-6, Kugahara 5-chome,Ohta-ku Tokyo 146-8515Japan',1),('00:13:FC','Sicortex, Inc','Sicortex, Inc3 Clocktower PlaceSuite 210Maynard Ma 01754United States',1),('00:13:FD','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:13:FE','Grandtec Electronic Corp.','Grandtec Electronic Corp.8f,no.268,lian Cheng Rd.,chung Ho City,Hsien 235Taipei  235Taiwan, Republic Of China',1),('00:13:FF','Dage-mti Of Mc, Inc.','Dage-mti Of Mc, Inc.701 N. Roeske Ave.Michigan City In 46360United States',1),('00:14:00','Minerva Korea Co., Ltd','Minerva Korea Co., Ltd#203, Sh Sienne, Seohyeon-dongBundang-guSeongnam-si Gyeonggi-do 463-821Korea, Republic Of',1),('00:14:01','Rivertree Networks Corp.','Rivertree Networks Corp.R#304, K-center, 1591-9Burim-dong, Dongahn-guAnyang-si Kyunggi-do 431-815Korea, Republic Of',1),('00:14:02','Kk-electronic A/s','Kk-electronic A/sCypresvej 6Herning  7400Denmark',1),('00:14:03','Renasis, Llc','Renasis, Llc1530 N. State St.Suite ELehi Ut 84043United States',1),('00:14:04','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:14:05','Openib, Inc.','Openib, Inc.Openfabrics, Inc., C/o Qlogic Corporation2071 Stierlin Court, Suite 200Mountain View Ca 94043-4655United States',1),('00:14:06','Go Networks','Go Networks126 Yigal Alon St.Tel Aviv  67443Israel',1),('00:14:07','Sperian Protection Instrumentation','Sperian Protection Instrumentation651 South Main StreetMiddletown Ct 06457United States',1),('00:14:08','Eka Systems Inc.','Eka Systems Inc.20251 Century BlvdSuite 120Germantown Md 20874United States',1),('00:14:09','Magneti Marelli   S.e. S.p.a.','Magneti Marelli   S.e. S.p.a.Viale Aldo Borletti, 61/63Corbetta Milano 20011Italy',1),('00:14:0A','Wepio Co., Ltd.','Wepio Co., Ltd.#1125, Opus1, Gurodongcomplex Building611-26,guro-dong,guro-gu,Seoul  152-050Korea, Republic Of',1),('00:14:0B','First International Computer, Inc.','First International Computer, Inc.Fic Building, No.300, Yang Guang St.,NeihuTaipei County 114Taiwan, Republic Of China',1),('00:14:0C','Gkb Cctv Co., Ltd.','Gkb Cctv Co., Ltd.7f, No. 1, Lane 641,Shen Ling South Rd.,Ta Ya Hsiang, Taichung 428Taiwan, Republic Of China',1),('00:14:0D','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:14:0E','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:14:0F','Federal State Unitary Enterprise Leningrad R&d Institute Of','Federal State Unitary Enterprise Leningrad R&d Institute Of11 Warshawskaya St.St. Petersburg 196128Russian Federation',1),('00:14:10','Suzhou Keda Technology Co.,ltd','Suzhou Keda Technology Co.,ltd131,jinshan RoadSuzhou Jiangsu 215011China',1),('00:14:11','Deutschmann Automation Gmbh & Co. Kg','Deutschmann Automation Gmbh & Co. KgCarl-zeiss-str. 8Bad Camberg  D - 65520Germany',1),('00:14:12','S-tec Electronics Ag','S-tec Electronics AgIndustriestrasse 49Zug 6300Switzerland',1),('00:14:13','Trebing & Himstedt Prozessautomation Gmbh & Co. Kg','Trebing & Himstedt Prozessautomation Gmbh & Co. KgWilhelm-hennemann-str. 13Schwerin Mecklenburg-vorpommern 19061Germany',1),('00:14:14','Jumpnode Systems Llc.','Jumpnode Systems Llc.800 Washington Ave N.Suite 309Minneapolis Mn 55041United States',1),('00:14:15','Intec Automation Inc.','Intec Automation Inc.2751 Arbutus Rd.Victoria British Columbia V8n 5x7Canada',1),('00:14:16','Scosche Industries, Inc.','Scosche Industries, Inc.Po Box 2901Oxnard Ca 93034United States',1),('00:14:17','Rse Informations Technologie Gmbh','Rse Informations Technologie GmbhSilberbergstrasse 9Wolfsberg Krnten 9400Austria',1),('00:14:18','C4line','C4line1001 Hyundai Parisian,907-10 Mok5-dongYangchun-gu Seoul 158-050Korea, Republic Of',1),('00:14:19','Sidsa','SidsaPtm - Torres Quevedo 1Tres Cantos Madrid 28760Spain',1),('00:14:1A','Deicy Corporation','Deicy Corporation3-3-6,sakae-cho,hamura-shi,Tokyo 205-0002Japan',1),('00:14:1B','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:1C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:1D','Lust Antriebstechnik Gmbh','Lust Antriebstechnik GmbhGewerbestrasse 5-9Lahnau Hessen 35633Germany',1),('00:14:1E','P.a. Semi, Inc.','P.a. Semi, Inc.3965 Freedom Circle, Fl 8Santa Clara Ca 95054United States',1),('00:14:1F','Sunkwang Electronics Co., Ltd','Sunkwang Electronics Co., Ltd#365(techno-park, 301 Dong, 901 Ho,) Samjung-dong, Ohjung-ku,Bucheon-shi Kyunggi-do 421-809Korea, Republic Of',1),('00:14:20','G-links Networking Company','G-links Networking Company1fl. No.15-49, Ming Der Second Road,Chi Du District,Keelung  206Taiwan, Republic Of China',1),('00:14:21','Total Wireless Technologies Pte. Ltd.','Total Wireless Technologies Pte. Ltd.Blk 1003, Bukit Merah Central, #04-18Technopreneur Centre159836Singapore',1),('00:14:22','Dell Inc.','Dell Inc.One Dell WayRound Rock Texas 78682United States',1),('00:14:23','J-s Co. Neurocom','J-s Co. NeurocomEnergeticheskii Proezd, 6Moscow  111250Russian Federation',1),('00:14:24','Merry Electrics Co., Ltd.','Merry Electrics Co., Ltd.No.22,23rd RoadPark Taichung,Taichung City  40850Taiwan, Republic Of China',1),('00:14:25','Galactic Computing Corp.','Galactic Computing Corp.1/f12 Lee Chung StreetChai Wan DistrictHong Kong',1),('00:14:26','Nl Technology','Nl Technology800 Turnpike StreetSte 100North Andover Ma 01845United States',1),('00:14:27','Jazzmutant','Jazzmutant2 Allee Du Doyen Georges BrusPessac  33600France',1),('00:14:28','Vocollect, Inc','Vocollect, Inc703 Rodi RoadPittsburgh Pa 15235United States',1),('00:14:29','V Center Technologies Co., Ltd.','V Center Technologies Co., Ltd.7f-7, No.35, Hsintai Rd.Jubei City Hsinchu 302Taiwan, Republic Of China',1),('00:14:2A','Elitegroup Computer System Co., Ltd','Elitegroup Computer System Co., LtdNo.22, Alley 38, Lane 91, Sec. 1,Nei Hu RoadTaipei  114Taiwan, Republic Of China',1),('00:14:2B','Edata Communication Inc.','Edata Communication Inc.2f-1, No. 872, Chung-cheng RdChung-ho CityTaipei Hsien 235Taiwan, Republic Of China',1),('00:14:2C','Koncept International, Inc.','Koncept International, Inc.2500 E Foothill Blvd. #407Pasadena Ca 91107United States',1),('00:14:2D','Toradex Ag','Toradex AgAltsagenstrasse 5Horw Lu 6048Switzerland',1),('00:14:2E','77 Elektronika Kft.','77 Elektronika Kft.Fehervari Ut 98.Budapest H-1163Hungary',1),('00:14:2F','Wildpackets','Wildpackets1340 Treat BoulevardSuite 500Walnut Creek Ca 94597United States',1),('00:14:30','Vipower, Inc','Vipower, Inc9f., No.205-3, Sec. 3, Beisin RdSindian Taipei County 231Taiwan, Republic Of China',1),('00:14:31','Pdl Electronics Ltd','Pdl Electronics Ltd81 Austin StreetNapier Hawkes Bay 4015New Zealand',1),('00:14:32','Tarallax Wireless, Inc.','Tarallax Wireless, Inc.10 West 100 South,Suite 600Salt Lake City Ut 84101United States',1),('00:14:33','Empower Technologies(canada) Inc.','Empower Technologies(canada) Inc.Unit 120 - 13551 Verdun PlaceRichmond British Columbia V6v 1w5Canada',1),('00:14:34','Keri Systems, Inc','Keri Systems, IncSuite 1001530 Oakland RdSan Jose Ca 95112United States',1),('00:14:35','Citycom Corp.','Citycom Corp.3f., No.532, Sec. 2,Jhongshan Rd.Jhonghe City Taipei Hsien 23557Taiwan, Republic Of China',1),('00:14:36','Qwerty Elektronik Ab','Qwerty Elektronik AbBlinge KlockargrdTystberga  610 60Sweden',1),('00:14:37','Gsteletech Co.,ltd.','Gsteletech Co.,ltd.1385-14, Juan-dong, Nam-guIncheon 402-200Korea, Republic Of',1),('00:14:38','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:14:39','Blonder Tongue Laboratories, Inc.','Blonder Tongue Laboratories, Inc.One Jake Brown RoadOld Bridge New Jersey 08857United States',1),('00:14:3A','Raytalk International Srl','Raytalk International SrlSt. Marecchia 79Verucchio (rn) 47826Italy',1),('00:14:3B','Sensovation Ag','Sensovation AgLudwigshafener Str. 29Stockach Baden-wuerttemberg 78333Germany',1),('00:14:3C','Rheinmetall Canada Inc.','Rheinmetall Canada Inc.225 Boul Du Seminaire SudSt-jean-sur-richelieu Quebec J3b 8e9Canada',1),('00:14:3D','Aevoe Inc.','Aevoe Inc.11f, No 23, Keelung RoadTaipei Hsinyi District 110Taiwan, Republic Of China',1),('00:14:3E','Airlink Communications, Inc.','Airlink Communications, Inc.3159 Corporate PlaceHayward Ca 94545United States',1),('00:14:3F','Hotway Technology Corporation','Hotway Technology CorporationNo. 81, Hsin Tai 5th Road Section 111f-3Shijr Taipei 221Taiwan, Republic Of China',1),('00:14:40','Atomic Corporation','Atomic CorporationMampo Bldg1-3-11,asakusabashiTaito-ku Tokyo 111-0053Japan',1),('00:14:41','Innovation Sound Technology Co., Ltd.','Innovation Sound Technology Co., Ltd.Building 2th.,cuihai Industrial Area,Huaide, Fuyong TownShenzhen Guangdong 518103China',1),('00:14:42','Atto Corporation','Atto Corporation1-25-23 Hongo,Bunkyo-ku,Tokyo 113-8425Japan',1),('00:14:43','Consultronics Europe Ltd','Consultronics Europe LtdElectron WayChandlers Ford Hants So53 4seUnited Kingdom',1),('00:14:44','Grundfos Electronics','Grundfos ElectronicsBirkevaenget 2-10Bjerringbro  Dk8850Denmark',1),('00:14:45','Telefon-gradnja D.o.o.','Telefon-gradnja D.o.o.Plesivicka 3Sveta Nedelja Zupanija Zagrebacka 10431Croatia',1),('00:14:46','Supervision Solutions Llc','Supervision Solutions Llc762 Industrial Dr.Elmhurst Il 60126United States',1),('00:14:47','Boaz Inc.','Boaz Inc.282 Pukok-ri Songsan-myon Dangzin-gun Chungcheongnam-do,  343-834#301, 1429-7 Seocho-dongSeoul Seocho-gu 137-070Korea, Republic Of',1),('00:14:48','Inventec Multimedia & Telecom Corporation','Inventec Multimedia & Telecom Corporation5f,no.396,sec.1 Nei-hu RoadTaipei  114Taiwan, Republic Of China',1),('00:14:49','Sichuan Changhong Electric Ltd.','Sichuan Changhong Electric Ltd.No.35,east Mianxin RoadMianyang Sichuan Prc 621000China',1),('00:14:4A','Taiwan Thick-film Ind. Corp.','Taiwan Thick-film Ind. Corp.No.126,wuu Gong 2nd Rd,Wuu Guu Industrial ZoneTaipei Hsien  248Taiwan, Republic Of China',1),('00:14:4B','Hifn, Inc.','Hifn, Inc.750 University AveSuite 200Los Gatos Ca 95032United States',1),('00:14:4C','General Meters Corp.','General Meters Corp.1935 Dominion WayColorado Springs Colorado 80918United States',1),('00:14:4D','Intelligent Systems','Intelligent Systems11101 Johns Hopkins RoadLaurel Md 20723United States',1),('00:14:4E','Srisa','Srisa36/1, Nakhimovskiy Pr-tMoscow 117218Russian Federation',1),('00:14:4F','Sun Microsystems, Inc.','Sun Microsystems, Inc.4200 Network CircleSanta Clara Ca 95054United States',1),('00:14:50','Heim Systems Gmbh','Heim Systems GmbhFriedrich Ebert StrasseTechnologieparkBergisch Gladbach Nrw 51429Germany',1),('00:14:51','Apple Computer Inc.','Apple Computer Inc.1 Infinite LoopMs:35gpoCupertino Ca 95014United States',1),('00:14:52','Calculex,inc.','Calculex,inc.132 W. Las Cruces Ave.Las Cruces New Mexico 88001United States',1),('00:14:53','Advantech Technologies Co.,ltd','Advantech Technologies Co.,ltd#1202 Ace Techno Tower, 684-1Deungchon-3dong, Kangseo-kuSeoul 157-721Korea, Republic Of',1),('00:14:54','Symwave','Symwave10251 Vista Sorrento ParkwaySuite 100San Diego Ca 92121United States',1),('00:14:55','Coder Electronics Corporation','Coder Electronics CorporationTakeda Bldg, 1-30-6 Shirasagi,Nakano-ku Tokyo 165-0035Japan',1),('00:14:56','Edge Products','Edge Products1080 South Depot DriveOgden Utah 84404United States',1),('00:14:57','T-vips As','T-vips AsOstensjoveien 18Oslo No-0661Norway',1),('00:14:58','Hs Automatic Aps','Hs Automatic ApsBjerringbrovej 70Rodovre  2610Denmark',1),('00:14:59','Moram Co., Ltd.','Moram Co., Ltd.3f, Manwol Bldg., 1022-4Youngtong-dong, Youngtong-guSuwon-shi Gyounggi-do 443-813Korea, Republic Of',1),('00:14:5A','Neratec Ag','Neratec AgRosswiesstrasse 29Ch-8608 Bubikon ZhSwitzerland',1),('00:14:5B','Seekernet Inc.','Seekernet Inc.300 Satellite Blvd.Suwanee Georgia 30024United States',1),('00:14:5C','Intronics B.v.','Intronics B.v.Hermesweg 22Barneveld Gelderland 3771 NdNetherlands',1),('00:14:5D','Wj Communications, Inc.','Wj Communications, Inc.401 River Oaks ParkwaySan Jose Ca 95134United States',1),('00:14:5E','Ibm','Ibm3039 Cornwallis RdBld 660-2f202Raleigh Nc 27709United States',1),('00:14:5F','Aditec Co. Ltd','Aditec Co. Ltd4f Hyowon B/d, 99-5,Karak-dong,songpa-guSeoul 138-805Korea, Republic Of',1),('00:14:60','Kyocera Wireless Corp.','Kyocera Wireless Corp.10300 Campus Point DriveSan Diego Ca 92121United States',1),('00:14:61','Corona Corporation','Corona Corporation7-7, Higashi-shinboSanjo-shi Niigata 955-8510Japan',1),('00:14:62','Digiwell Technology, Inc','Digiwell Technology, Inc4f, No.1, Prosperity 1st RoadHsinchu Science Park 300Taiwan, Republic Of China',1),('00:14:63','Idcs N.v.','Idcs N.v.Hellebeemden 9Hasselt Limburg 3500Belgium',1),('00:14:64','Cryptosoft','CryptosoftLermontova Str, 3Penza Region 440026Russian Federation',1),('00:14:65','Novo Nordisk A/s','Novo Nordisk A/sNovo AlleBagsvaerd  2880Denmark',1),('00:14:66','Kleinhenz Elektronik Gmbh','Kleinhenz Elektronik GmbhGreinerberg 14Munich  81371Germany',1),('00:14:67','Arrowspan Inc.','Arrowspan Inc.4699 Old Ironsides Dr. Suite 100Santa Clara Ca 95054United States',1),('00:14:68','Celplan International, Inc.','Celplan International, Inc.1835 Alexander Bell DriveSuite 200Reston Va 20191United States',1),('00:14:69','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:6A','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:6B','Anagran, Inc.','Anagran, Inc.580 North Pastoria AvSunnyvale Ca 94085United States',1),('00:14:6C','Netgear Inc.','Netgear Inc.4500 Great America ParkwaySanta Clara Ca 95054United States',1),('00:14:6D','Rf Technologies','Rf Technologies3125 N 126th StreetBrookfield Wi 53005United States',1),('00:14:6E','H. Stoll Gmbh & Co. Kg','H. Stoll Gmbh & Co. KgStollwegReutlingen Deutschland 72760Germany',1),('00:14:6F','Kohler Co','Kohler Co444 Highland DriveMs 072Kohler Wi 53044United States',1),('00:14:70','Prokom Software Sa','Prokom Software SaAl. Jerozolimskie 65/79Warszawa Mazowieckie 00-697Poland',1),('00:14:71','Eastern Asia Technology Limited','Eastern Asia Technology Limited5611, North Bridge Road,#22-03, Eng Cheong Tower198782Singapore',1),('00:14:72','China Broadband Wireless Ip Standard Group','China Broadband Wireless Ip Standard GroupP.o.box 88,west High-techDevelopment Center,Xian Shaan Xi 710075China',1),('00:14:73','Bookham Inc','Bookham Inc10 Brewer Hunt WayKanata On K2k 2b5Canada',1),('00:14:74','K40 Electronics','K40 Electronics600 Tollgate Rd. Unit AElgin Il 60123United States',1),('00:14:75','Wiline Networks, Inc.','Wiline Networks, Inc.741 Alexander RdPrinceton Nj 08540United States',1),('00:14:76','Multicom Industries Limited','Multicom Industries LimitedRoom 1206-7, Manhattan Center,8 Kwai Cheong Rd.Kwai Chung, N.t.Hong Kong',1),('00:14:77','Nertec  Inc.','Nertec  Inc.950 Cowie St.Granby Quebec J2j 1p2Canada',1),('00:14:78','Shenzhen Tp-link Technologies Co., Ltd.','Shenzhen Tp-link Technologies Co., Ltd.3/f,bldg.r1-b,hi-tech Industrial Park,Shennan Rd.Shenzhen Guangdong 518057China',1),('00:14:79','Nec Magnus Communications,ltd.','Nec Magnus Communications,ltd.4-28Mita 1-chomeMinato-ku Tokyo 108-0073Japan',1),('00:14:7A','Eubus Gmbh','Eubus GmbhGollierstr. 70  Aufgang E  4.stockMunich Bavaria 80339Germany',1),('00:14:7B','Iteris, Inc.','Iteris, Inc.1515 S. Manchester Ave.Anaheim Ca 92802United States',1),('00:14:7C','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:14:7D','Aeon Digital International','Aeon Digital International31-6, The Bund Center222 Yan An E. RdShanghai Sh 200002China',1),('00:14:7E','Innerwireless','Innerwireless1155 Kas Drive, Suite 200Richardson Tx 75081United States',1),('00:14:7F','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47Edegem Antwerp B-2650Belgium',1),('00:14:80','Hitachi-lg Data Storage Korea, Inc','Hitachi-lg Data Storage Korea, Inc19-1,cheongho-riJinwuy-myunPyungtaik Kyunggi-do 451-713Korea, Republic Of',1),('00:14:81','Multilink Inc','Multilink Inc580 Ternes AveElyria Oh 44035United States',1),('00:14:82','Gobacktv, Inc','Gobacktv, Inc937 Hamilton AvenueMenlo Park Ca 94025United States',1),('00:14:83','Exs Inc.','Exs Inc.1900 Alameda De Las PulgasSuite 103San Mateo Ca 94403United States',1),('00:14:84','Cermate Technologies Inc.','Cermate Technologies Inc.7f-1, No 168 Lien-chen Rd.Chung-ho City Taipei CountyTaiwan, Republic Of China',1),('00:14:85','Giga-byte','Giga-byteNo.215,nan-ping Road,Pin-jen Taoyuan 326Taiwan, Republic Of China',1),('00:14:86','Echo Digital Audio Corporation','Echo Digital Audio Corporation6450 Via Real #1Carpinteria Ca 93013United States',1),('00:14:87','American Technology Integrators','American Technology Integrators1358 Rosalia AveSan Jose Ca 95130United States',1),('00:14:88','Akorri','Akorri305 Foster StreetLittleton Ma 01460United States',1),('00:14:89','B15402100 - Jandei, S.l.','B15402100 - Jandei, S.l.Pol. Ind. Pocomaco, E-28La Corua  15190Spain',1),('00:14:8A','Elin Ebg Traction Gmbh','Elin Ebg Traction GmbhCumberlandstrasse 32Vienna  1140Austria',1),('00:14:8B','Globo Electronic Gmbh & Co. Kg','Globo Electronic Gmbh & Co. KgIndustriestrasse 4aNiederlauer Bayern 97618Germany',1),('00:14:8C','Fortress Technologies','Fortress Technologies2 Technology Park DriveWestford Ma 01886United States',1),('00:14:8D','Cubic Defense Simulation Systems','Cubic Defense Simulation Systems2001 W. Oakridge RoadOrlando Fl 32809United States',1),('00:14:8E','Tele Power Inc.','Tele Power Inc.1-46-15#b1fAsahigaokaNerima-ku Tokyo 176-0005Japan',1),('00:14:8F','Protronic (far East) Ltd.','Protronic (far East) Ltd.Rm. 2504, Nanyang Plaza,57 Hung To RoadKwun Tong Kowloon 852Hong Kong',1),('00:14:90','Asp Corporation','Asp Corporation465 Industrial Park RoadHartwell Ga 30643United States',1),('00:14:91','Daniels Electronics Ltd.','Daniels Electronics Ltd.43 Erie StVictoria Bc V8v 1p8Canada',1),('00:14:92','Liteon, Mobile Media Solution Sbu','Liteon, Mobile Media Solution Sbu4f, 3, Lane 768, Sec. 4,Pateh Road,Taipei  115Taiwan, Republic Of China',1),('00:14:93','Systimax Solutions','Systimax Solutions1300 E Lookout DriveRichardson Texas 75082United States',1),('00:14:94','Esu Ag','Esu AgLukasstrasse 29St. Gallen  9008Switzerland',1),('00:14:95','2wire, Inc.','2wire, Inc.1704 Automation ParkwaySan Jose Ca 95131United States',1),('00:14:96','Phonic Corp.','Phonic Corp.12thfl, 59 Tung Hsing RdTaipei  110Taiwan, Republic Of China',1),('00:14:97','Zhiyuan Eletronics Co.,ltd.','Zhiyuan Eletronics Co.,ltd.2 Floor, No.3 Building, Huangzhou Industrial Estate, Chebei Road,TianheGuangzhou Guangdong 510660China',1),('00:14:98','Viking Design Technology','Viking Design Technology2f, No.2, Lane 42,Hou-gang Street, Shih-lin DistrictTaipei  111Taiwan, Republic Of China',1),('00:14:99','Helicomm Inc','Helicomm Inc1947 Camino Vida RobleSuite 109Carlsbad Ca 92008United States',1),('00:14:9A','Motorola Mobile Devices Business','Motorola Mobile Devices Business600 N Us Hwy 45Rm Mw113Libertyville Il 60048United States',1),('00:14:9B','Nokota Communications, Llc','Nokota Communications, Llc200 Galleria ParkwaySuite 1820Atlanta Georgia 30339United States',1),('00:14:9C','Hf Company','Hf CompanyNode Park TouraineBp1 Tauxigny  37310France',1),('00:14:9D','Sound Id Inc.','Sound Id Inc.3430 West Bayshore RoadPalo Alto California 94303United States',1),('00:14:9E','Ubone Co., Ltd','Ubone Co., LtdShinyoung B.d. 602, Seohyeon2-dongBundang-guSeongnam-si Gyeongg-do 463-824Korea, Republic Of',1),('00:14:9F','System And Chips, Inc.','System And Chips, Inc.4f,no. 1, Lane 50, Nankang Road, Section 3,Taipei  115Taiwan, Republic Of China',1),('00:14:A0','Accsense, Inc.','Accsense, Inc.460 Ward DriveSuite E2Santa Barbara California 93111United States',1),('00:14:A1','Synchronous Communication Corp','Synchronous Communication Corp9 Floor, No168, Rueiguang Road, Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:14:A2','Core Micro Systems Inc.','Core Micro Systems Inc.Wajun Bldg. 6f, 2-22-2, KoishikawaBunkyo-ku Tokyo 112-0002Japan',1),('00:14:A3','Vitelec Bv','Vitelec BvKapittelweg 18P.o.box 6543Breda Nb Nl 4827 HgNetherlands',1),('00:14:A4','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.5f-1, 5 Hsin-an RoadScience-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:14:A5','Gemtek Technology Co., Ltd.','Gemtek Technology Co., Ltd.No. 1 Jen Ai RoadHsinchu Industrial ParkHukou, Hsinchu  303Taiwan, Republic Of China',1),('00:14:A6','Teranetics, Inc.','Teranetics, Inc.3965 Freedom CircleSixth FloorSanta Clara Ca 95054United States',1),('00:14:A7','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  1790vDenmark',1),('00:14:A8','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:A9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:AA','Ashly Audio, Inc.','Ashly Audio, Inc.847 Holt RoadWebster Ny 14580United States',1),('00:14:AB','Senhai Electronic Technology Co., Ltd.','Senhai Electronic Technology Co., Ltd.Rm.10a. 28/f.segplaza Huaqiangbei RoadShengzhen Guangdong 518031China',1),('00:14:AC','Bountiful Wifi','Bountiful Wifi707 West 700 SouthWoods Cross Utah 84087United States',1),('00:14:AD','Gassner Wiege- U. Metechnik Gmbh','Gassner Wiege- U. Metechnik GmbhRobinigstr. 26aSalzburg  A-5020Austria',1),('00:14:AE','Wizlogics Co., Ltd.','Wizlogics Co., Ltd.4th Floor, Brother Bldg., 233-8Yongdap-dong, Sungdong-guSeoul  133-850Korea, Republic Of',1),('00:14:AF','Datasym Inc.','Datasym Inc.435 Elgin StreetBrantford Ontario N3s7p5Canada',1),('00:14:B0','Naeil Community','Naeil Community#506 Acetwin Tower 1, Guro-dongSeoul Guro-gu 152779Korea, Republic Of',1),('00:14:B1','Avitec Ab','Avitec AbBox 7139Sundbyberg  Se-174 07Sweden',1),('00:14:B2','Mcubelogics Corporation','Mcubelogics Corporation4f, Unibooks B/d, 514-1, Dogok-dong, KangnamSeoul  135-270Korea, Republic Of',1),('00:14:B3','Corestar International Corp','Corestar International Corp1044 Sandy Hill RdIrwin Pa 15642United States',1),('00:14:B4','General Dynamics United Kingdom Ltd','General Dynamics United Kingdom LtdCastleham RoadSt Leonards On Sea East Sussex Tn38 9njUnited Kingdom',1),('00:14:B5','Physiometrix,inc','Physiometrix,inc101 Billerica Ave #5N. Billerica Ma 01862United States',1),('00:14:B6','Enswer Technology Inc.','Enswer Technology Inc.1f No.70 Sec.2 Chung Shun St.Taipei  116Taiwan, Republic Of China',1),('00:14:B7','Ar Infotek Inc.','Ar Infotek Inc.9f, No.185, Gangqian RoadNeihu Technology Park,Taipei  11494Taiwan, Republic Of China',1),('00:14:B8','Hill-rom','Hill-rom1125 E. Pearl StreetBatesville In 47006United States',1),('00:14:B9','Mstar Semiconductor','Mstar Semiconductor11-13 Rue Ren JacquesIssy Les Moulineaux  92130France',1),('00:14:BA','Carvers Sa De Cv','Carvers Sa De CvAlvarez Del Castillo 1550Chapultepec CountryGuadalajara Jalisco 44620Mexico',1),('00:14:BB','Open Interface North America','Open Interface North America506 2nd Avenue, Suite 420Seattle Wa 98104United States',1),('00:14:BC','Synectic Telecom Exports Pvt. Ltd.','Synectic Telecom Exports Pvt. Ltd.196, 1st Main, 3rd Stage, 4th BlockBasaveshwar NagarBangalore  560079India',1),('00:14:BD','Incnetworks, Inc','Incnetworks, Inc198 Brighton AveLong Branch Nj 07740United States',1),('00:14:BE','Wink Communication Technology Co.ltd','Wink Communication Technology Co.ltdHuijiang Ind Blding Dashi TownPanyu DistrictGuang Zhou Guang Dong 511430China',1),('00:14:BF','Cisco-linksys Llc','Cisco-linksys Llc121 Theory Dr.Irvine Ca 92612United States',1),('00:14:C0','Symstream Technology Group Ltd','Symstream Technology Group LtdLevel 1, 3 Chester StreetOakleigh Victoria 3166Australia',1),('00:14:C1','U.s. Robotics Corporation','U.s. Robotics Corporation935 National ParkwaySchaumburg Il 60173-5157United States',1),('00:14:C2','Hewlett Packard','Hewlett Packard20555 Tomball ParkwayMs070405Houston Tx 77070United States',1),('00:14:C3','Seagate Technology Llc','Seagate Technology Llc1280 Disc DriveShakopee Mn 55379United States',1),('00:14:C4','Vitelcom Mobile Technology','Vitelcom Mobile TechnologyPta, Avda, Juan Lpez Pealver, N 729590, CampanillasCampanillas. Malaga.Spain',1),('00:14:C5','Alive Technologies Pty Ltd','Alive Technologies Pty Ltd11 Technology DriveArundel Queensland 4214Australia',1),('00:14:C6','Quixant Ltd','Quixant LtdCounty House221-241 Beckenham RdBeckenham Kent Br3 4ufUnited Kingdom',1),('00:14:C7','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:14:C8','Contemporary Research Corp','Contemporary Research Corp17630 Davenport RdSte 113Dallas Tx 75252United States',1),('00:14:C9','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology Dr.San Jose Ca 95110United States',1),('00:14:CA','Key Radio Systems Limited','Key Radio Systems LimitedVenus HouseCalleva ParkAldermaston Berkshire Rg7 8daUnited Kingdom',1),('00:14:CB','Lifesync Corporation','Lifesync Corporation1 E Broward Boulevard, Suite 1701Fort Lauderdale Florida 33301United States',1),('00:14:CC','Zetec, Inc.','Zetec, Inc.8226 Bracken Place SeSnoqualmie Wa 98065United States',1),('00:14:CD','Digitalzone Co., Ltd.','Digitalzone Co., Ltd.No. 1001 E&c Venturedreamtower2197-10 Guro-dong, Guro-guSeoul  152-848Korea, Republic Of',1),('00:14:CE','Nf Corporation','Nf Corporation6-3-20, Tsunashima-higashiKohoku-kuYokohama Kanagawa 223-8508Japan',1),('00:14:CF','Nextlink.to A/s','Nextlink.to A/sSandtoften 10Gentofte  2820Denmark',1),('00:14:D0','Bti Systems Inc.','Bti Systems Inc.50 Northside RoadOttawa Ontario K2h 5z6Canada',1),('00:14:D1','Trendware International, Inc.','Trendware International, Inc.20675 Manhattan PlaceTorrance Ca 90501United States',1),('00:14:D2','Kyuki Corporation','Kyuki Corporation4-19-18 Shimizu,minami-kuFukuoka  815-0031Japan',1),('00:14:D3','Sepsa','SepsaCalle Albatros, 7 Y 9Pol. Ind. La EstacinPinto Madrid 28320Spain',1),('00:14:D4','K Technology Corporation','K Technology Corporation325 GanbaraKami-machiKami-gun Miyagi-ken 981-4263Japan',1),('00:14:D5','Datang Telecom Technology Co. , Lcd,optical Communication Br','Datang Telecom Technology Co. , Lcd,optical Communication Br3rd Floor,building 8,hi-tech Incubation Park,Nanyanxian,tianfu Ave,chengdu Hi-tech Zone,Chengdu Sichuan 610041China',1),('00:14:D6','Jeongmin Electronics Co.,ltd.','Jeongmin Electronics Co.,ltd.#710, Byuksan Digital Valley 2,Kasan-dong, Keumcheon-gu,Seoul  153 783Korea, Republic Of',1),('00:14:D7','Datastore Technology Corp','Datastore Technology Corp9f, No.10, Sec.1, Chung Hsing Rd., Wu-kuTaipei Hsien,  248Taiwan, Republic Of China',1),('00:14:D8','Bio-logic Sa','Bio-logic Sa1, Rue De LeuropeClaix  38640France',1),('00:14:D9','Ip Fabrics, Inc.','Ip Fabrics, Inc.14964 Nw Greenbrier ParkwayBeaverton Oregon 97006United States',1),('00:14:DA','Huntleigh Healthcare','Huntleigh HealthcareHuntleigh Healthcare - Diagnostic Products Division35 Portmanmoor RoadCardiff  Cf24 5hnUnited Kingdom',1),('00:14:DB','Elma Trenew Electronic Gmbh','Elma Trenew Electronic GmbhStuttgarter Strasse 11Pforzheim Bw 75179Germany',1),('00:14:DC','Communication System Design & Manufacturing (csdm)','Communication System Design & Manufacturing (csdm)Postbus 181Bussum Nh 1400 AdNetherlands',1),('00:14:DD','Covergence Inc.','Covergence Inc.One Clock Tower Place, Suite 200Maynard Ma 01754United States',1),('00:14:DE','Sage Instruments Inc.','Sage Instruments Inc.240 Airport Blvd.Freedom Ca 95019United States',1),('00:14:DF','Hi-p Tech Corporation','Hi-p Tech Corporation1-27-23 HigashitokorozawaTokorozawa Saitama 359-0021Japan',1),('00:14:E0','Lets Corporation','Lets CorporationBancho Bldg. 4f, 2-18-20 Marunouchi, NakaNagoya Aichi 460-0002Japan',1),('00:14:E1','Data Display Ag','Data Display AgIndustriestrae 1Germering Bayern 82110Germany',1),('00:14:E2','Datacom Systems Inc.','Datacom Systems Inc.9 Adler DriveEast Syracuse N.y. 13057United States',1),('00:14:E3','Mm-lab Gmbh','Mm-lab GmbhStammheimer Strasse 10D-70806KornwestheimGermany',1),('00:14:E4','Integral Technologies','Integral Technologies9855 Crosspoint BlvdSte 126Indianapolis In 46256United States',1),('00:14:E5','Alticast','Alticast16th Floor, Nara Bldg, 1328-3Seocho-dong, Seocho-gu,Seoul 137-070Korea, Republic Of',1),('00:14:E6','Aim Infrarotmodule Gmbh','Aim Infrarotmodule GmbhSoeflingerstr. 100Ulm Bw 89077Germany',1),('00:14:E7','Stolinx,. Inc','Stolinx,. Inc3f Ohchang Bldg., 61 Yangjae-dongSeocho-guSeoul  137-889Korea, Republic Of',1),('00:14:E8','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:14:E9','Nortech International','Nortech International32a Wiganthorpe RoadWillowton HubPietermartizburg Kwazulu Natal 3201South Africa',1),('00:14:EA','S Digm Inc. (safe Paradigm Inc.)','S Digm Inc. (safe Paradigm Inc.)5f, Shin-an Bldg. 89-8,Moonjung-dongSongpa-gu Seoul 138-201Korea, Republic Of',1),('00:14:EB','Awarepoint Corporation','Awarepoint Corporation8899 University Center LaneSan Diego Ca 92122United States',1),('00:14:EC','Acro Telecom','Acro Telecom714 Woolim E-biz Center 170-5 Guro-dongGuro-gu Seoul 152-769Korea, Republic Of',1),('00:14:ED','Airak, Inc.','Airak, Inc.21641 Beaumeade CircleSuite 300Ashburn Virginia 20147United States',1),('00:14:EE','Western Digital Technologies, Inc.','Western Digital Technologies, Inc.20511 Lake Forest Dr.Lake Forest Ca 92630United States',1),('00:14:EF','Tzero Technologies, Inc.','Tzero Technologies, Inc.455 W. Maude AvenueSunnyvale Ca 94085United States',1),('00:14:F0','Business Security Ol Ab','Business Security Ol AbBox 110 65Stora Raby Byavag 88Lund  220 11Sweden',1),('00:14:F1','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:F2','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:14:F3','Vixs Systems Inc','Vixs Systems Inc2235 Sheppard Ave EastSuite1705Toronto Ontario M2j 5b5Canada',1),('00:14:F4','Dektec Digital Video B.v.','Dektec Digital Video B.v.Van Riebeeckweg 43aHilversum Nh 1212aeNetherlands',1),('00:14:F5','Osi Security Devices','Osi Security Devices1580 Jayken WayChula Vista California 91911United States',1),('00:14:F6','Juniper Networks, Inc.','Juniper Networks, Inc.1194 N. Mathilda AvenueSunnyvale Ca 94089United States',1),('00:14:F7','Crevis','CrevisD-11f, Digital Empire Bldg., 980-3YoungtongSuwonKorea, Republic Of',1),('00:14:F8','Scientific Atlanta','Scientific Atlanta5030 Sugarloaf ParkwayMs 5.2.428Lawrenceville Ga 30042United States',1),('00:14:F9','Vantage Controls','Vantage Controls1061 South 800 EastOrem Ut 84097United States',1),('00:14:FA','Asga S.a.','Asga S.a.Rod Roberto Moreira Km 04Paulinia Sao Paulo 13140-000Brazil',1),('00:14:FB','Technical Solutions Inc.','Technical Solutions Inc.1-7157 Honeyman StreetDelta Bc V4g 1e2Canada',1),('00:14:FC','Extandon, Inc.','Extandon, Inc.39350 Civic Center Drive Ste. 160Fremont Ca 94538United States',1),('00:14:FD','Thecus Technology Corp.','Thecus Technology Corp.15f.,no. 79,sec. 1,sintai 5th Rd.,Sijhih City Taipei County 221Taiwan, Republic Of China',1),('00:14:FE','Artech Electronics','Artech Electronics#301, Yangjae Bldg., 276-2Yangjae-dong, Seocho-kuSeoul  137-895Korea, Republic Of',1),('00:14:FF','Precise Automation, Inc.','Precise Automation, Inc.1402 Alexandra BlvdCrystal Lake Il 60014United States',1),('00:15:00','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:15:01','Lexbox','Lexbox3, Avenue Didier DauratToulouse  31400France',1),('00:15:02','Beta Tech','Beta Tech15 Rue DapolloLunion  31240France',1),('00:15:03','Proficomms S.r.o.','Proficomms S.r.o.Turgenevova 5Brno Eu/europe 618 00Czech Republic',1),('00:15:04','Game Plus Co., Ltd.','Game Plus Co., Ltd.164-57, Yeonghwa-dong, Jangan-guSuwon Gyeonggi-do 440-818Korea, Republic Of',1),('00:15:05','Actiontec Electronics, Inc','Actiontec Electronics, Inc760 North Mary AveSunnyvale Ca 94086United States',1),('00:15:06','Neo Photonics','Neo Photonics910 E. California St.Sunnyvale Ca 94085United States',1),('00:15:07','Renaissance Learning Inc','Renaissance Learning Inc2911 Peach StreetPo Box 8036Wisconsin Rapids Wisconsin 54494United States',1),('00:15:08','Global Target Enterprise Inc','Global Target Enterprise Inc5f, No. 186, Sec. 2, Chung-hsing Rd.,Hsin Tien, Taipei County 231Taiwan, Republic Of China',1),('00:15:09','Plus Technology Co., Ltd','Plus Technology Co., LtdOffice #205,  Gayang Techno-town,Gayang 3- Dong, Gangseo-kuSeoul 157-810Korea, Republic Of',1),('00:15:0A','Sonoa Systems, Inc','Sonoa Systems, Inc3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:15:0B','Sage Infotech Ltd.','Sage Infotech Ltd.3f, No30, Industry E. 9th Rd.,science-basedIndustrial ParkHsin-chu Taiwan 300Taiwan, Republic Of China',1),('00:15:0C','Avm Gmbh','Avm GmbhAlt-moabit 95Berlin  10559Germany',1),('00:15:0D','Hoana Medical, Inc.','Hoana Medical, Inc.828 Fort Street MallSuite 620Honolulu Hi 96813United States',1),('00:15:0E','Openbrain Technologies Co., Ltd.','Openbrain Technologies Co., Ltd.#804,anyang K-center,1591-9 , Burim-dong,dongan-gu,Anyang Kyunggi-do 431-815Korea, Republic Of',1),('00:15:0F','Mingjong','Mingjong8f,no.1,lane 16,sze Chuan Road,sec.2,panchiao City.Taipei  220Taiwan, Republic Of China',1),('00:15:10','Techsphere Co., Ltd','Techsphere Co., Ltd4f, Wonil Bldg., 980-54, Bangbae-dong, Seocho-guSeoul 137-060Korea, Republic Of',1),('00:15:11','Data Center Systems','Data Center Systems14802 Venture DriveDallas Tx 75234United States',1),('00:15:12','Zurich University Of Applied Sciences','Zurich University Of Applied SciencesTechnikumstrasse 9Winterthur Zh Ch-8401Switzerland',1),('00:15:13','Efs Sas','Efs SasBp 34Millery  F-69390France',1),('00:15:14','Hu Zhou Nava Networks&electronics Ltd.','Hu Zhou Nava Networks&electronics Ltd.3/f,no.328-4,guang Yuan Rd.Hu Zhou Zhe Jiang 313000China',1),('00:15:15','Leipold+co.gmbh','Leipold+co.gmbhKreuzwiese 12Rockenhausen Rlp D-67806Germany',1),('00:15:16','Uriel Systems Inc.','Uriel Systems Inc.#204 Byucksan Digitalvalley 1st, 212-16, Guro-dong, Guro-guSeoul  152-050Korea, Republic Of',1),('00:15:17','Intel Corporate','Intel CorporateLot 8, Jln Hi-tech  2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:15:18','Shenzhen 10moons Technology Development Co.,ltd','Shenzhen 10moons Technology Development Co.,ltdAdd:3f,huaxing Building, Qiaoxiang Road,Shenzhen Guangdong 518053China',1),('00:15:19','Storeage Networking Technologies','Storeage Networking Technologies63 Bar-yehuda St.Nesher  36651Israel',1),('00:15:1A','Hunter Engineering Company','Hunter Engineering Company11250 Hunter DriveBridgeton Missouri 63044United States',1),('00:15:1B','Isilon Systems Inc.','Isilon Systems Inc.3101 Western AvenueSeattle Wa 98121United States',1),('00:15:1C','Leneco','Leneco6th.,dong Moon Good Morning Tower1323 Beakseok-dong Ilsan-guKyeong Ki-do Goyang-si 411-817Korea, Republic Of',1),('00:15:1D','M2i Corporation','M2i CorporationKyonggi Venture Anyang Technical Center, 13th Floor, 572-5, Anyang 8-dong, Manan-guAnyang-shi Kyonggi-do 430-731Korea, Republic Of',1),('00:15:1E','Ethernet Powerlink Standardization Group (epsg)','Ethernet Powerlink Standardization Group (epsg)C/o Zurich University Of Applied SciencesTechnikumstrasse 9Ch-8401 WinterthurSwitzerland',1),('00:15:1F','Multivision Intelligent Surveillance (hong Kong) Ltd','Multivision Intelligent Surveillance (hong Kong) Ltd26/f, Aitken Vanson Centre,61 Hoi Yuen Road, Kwun Tong, Kowloon,Hong Kong',1),('00:15:20','Radiocrafts As','Radiocrafts AsSandakerveien 64Oslo 0484Norway',1),('00:15:21','Horoquartz','HoroquartzBp 251Fontenay Le Comte Vendee 85205France',1),('00:15:22','Dea Security','Dea SecurityVia Magenta 9Massa Ms 54100Italy',1),('00:15:23','Meteor Communications Corporation','Meteor Communications Corporation22614 66th Avenue SouthKent Wa 98032United States',1),('00:15:24','Numatics, Inc.','Numatics, Inc.1450 North Milford RoadHighland Michigan 48357United States',1),('00:15:25','Chamberlain Access Solutions','Chamberlain Access Solutions9160 E. Bahia Dr.Scottsdale Az 85260United States',1),('00:15:26','Remote Technologies Inc','Remote Technologies Inc7651 Anagram DriveEden Prairie Mn 55344United States',1),('00:15:27','Balboa Instruments','Balboa Instruments1382 Bell AveTustin Ca 92780United States',1),('00:15:28','Beacon Medical Products Llc D.b.a. Beaconmedaes','Beacon Medical Products Llc D.b.a. Beaconmedaes14408 W 105th StLenexa Ks 66215United States',1),('00:15:29','N3 Corporation','N3 Corporation#402 Gwangmyeong Techno Town626-3 Clulsan 1-dong, Gwangmyeong-cityGyeonggi-do  423-031Korea, Republic Of',1),('00:15:2A','Nokia Gmbh','Nokia GmbhRensingstr. 15Bochum Nrw 44807Germany',1),('00:15:2B','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:2C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:2D','Tenx Networks, Llc','Tenx Networks, Llc4855 Wiley Post WaySalt Lake City Ut 84116United States',1),('00:15:2E','Packethop, Inc.','Packethop, Inc.1301 Shoreway RoadSuite 200Belmont California 94002United States',1),('00:15:2F','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:15:30','Bus-tech, Inc.','Bus-tech, Inc.129 Middlesex TurnpikeBurlington Ma 01803United States',1),('00:15:31','Kocom','Kocom5f, Kocom Bldg., 260-7Yumchang-dong, Kangseo-guSeoul  157-040Korea, Republic Of',1),('00:15:32','Consumer Technologies Group, Llc','Consumer Technologies Group, Llc3500 Jordan Oaks Dr.Efland Nc 27243United States',1),('00:15:33','Nadam.co.,ltd','Nadam.co.,ltd#91-3 Wangrim-liBongdam-eupHwaseong Gyeonggi 445-895Korea, Republic Of',1),('00:15:34','A Beltrnica, Companhia De Comunicaes, Lda','A Beltrnica, Companhia De Comunicaes, LdaR. Dr. Jos Baptista De Sousa, 27Lisbon  1549-002 LisPortugal',1),('00:15:35','Ote Spa','Ote SpaVia Barsanti 8Florence Fi 50127Italy',1),('00:15:36','Powertech Co.,ltd','Powertech Co.,ltd#705, Dongyoung Venturestel, 199-32Anyang7-dong, Manan-guAnyang City Kyoungki-do 430-010Korea, Republic Of',1),('00:15:37','Ventus Networks','Ventus Networks800 Connecticut Ave1st Floor WestNorwalk Ct 06854United States',1),('00:15:38','Rfid, Inc.','Rfid, Inc.14100 East Jewell Ave.Suite 12Aurora Co 80012United States',1),('00:15:39','Technodrive Srl','Technodrive SrlVia Leonardo Da Vinci 162Trezzano Sul Naviglio Milano 20090Italy',1),('00:15:3A','Shenzhen Syscan Technology Co.,ltd.','Shenzhen Syscan Technology Co.,ltd.13f, Olympic Plaza,Shang Bao Road, Futian District,Shenzhen Guangdong 518034China',1),('00:15:3B','Emh Elektrizittszhler Gmbh & Cokg','Emh Elektrizittszhler Gmbh & CokgSuedring 5Wittenburg Mecklenburg-vorpommern 19243Germany',1),('00:15:3C','Kprotech Co., Ltd.','Kprotech Co., Ltd.2nd Floor, # 202, Myoung-ji E-space Ii218, An-yang 7 Dong, Man-an Gu,An-yang City Gyeong-gi Do 430-817Korea, Republic Of',1),('00:15:3D','Elim Product Co.','Elim Product Co.602-2 Gayang Techno Town, Gayang, 3-dongKangseo-gu Seoul KoreaSeoul 157-793Korea, Republic Of',1),('00:15:3E','Q-matic Sweden Ab','Q-matic Sweden AbNeongatan 8Molndal  431 53Sweden',1),('00:15:3F','Alcatel Alenia Space Italia','Alcatel Alenia Space ItaliaStrada Padana Superiore 290Vimodrone Mi 20090Italy',1),('00:15:40','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:15:41','Stratalight Communications, Inc.','Stratalight Communications, Inc.2105 S. Bascom AvenueSuite 300Campbell Ca 95008United States',1),('00:15:42','Microhard S.r.l.','Microhard S.r.l.Via Primo Maggio 36San Vittore Olona Milano 20028Italy',1),('00:15:43','Aberdeen Test Center','Aberdeen Test Center400 Colleran RoadBldg. 350Aberdeen Proving Grounds Md 21005-5059United States',1),('00:15:44','Com.s.a.t. Ag','Com.s.a.t. AgBesselstr. 3Mannheim  D-68219Germany',1),('00:15:45','Seecode Co., Ltd.','Seecode Co., Ltd.4th Floor, Amin Bldg., 110-1, Yangjaedong, SeochoguSeoul  137-891Korea, Republic Of',1),('00:15:46','Itg Worldwide Sdn Bhd','Itg Worldwide Sdn Bhd2, Jalan Astakau8/83Seksyen U8, Bukit JelutongShah Alam Selangor Darul Ehsan 40150Malaysia',1),('00:15:47','Aizen Solutions Inc.','Aizen Solutions Inc.10f-1, No.29, Puding Rd.Hsinchu Hsinchu County 300Taiwan, Republic Of China',1),('00:15:48','Cube Technologies','Cube Technologies10, Rue Des RosiristesChampagne Au Mont Dor France 69410France',1),('00:15:49','Dixtal Biomedica Ind. Com. Ltda','Dixtal Biomedica Ind. Com. LtdaR. Eng. Francisco Pitta Brito, 703Sao Paulo Sp 04753-080Brazil',1),('00:15:4A','Wanshih Electronic Co., Ltd','Wanshih Electronic Co., Ltd3f 72, Wu Kong 6th Rd.,Wu Ku Industrial District,Taipei Hsien Taiwan 248Taiwan, Republic Of China',1),('00:15:4B','Wonde Proud Technology Co., Ltd','Wonde Proud Technology Co., Ltd21f., No.100, Sec.1, Shintai 5th RdSijhih City Taipei County 221Taiwan, Republic Of China',1),('00:15:4C','Saunders Electronics','Saunders Electronics82 Industrial Park RdSaco Me 04072United States',1),('00:15:4D','Netronome Systems, Inc.','Netronome Systems, Inc.144 Emeryville DriveSuite 230Cranberry Twp. Pa 16066United States',1),('00:15:4E','Iec','Iec3, Rue De VarembP.o. Box 131Ch - 1211 Geneva 20Germany',1),('00:15:4F','One Rf Technology','One Rf Technology1360 Route Des DolinesBat B4 Les CardoulinesValbonne Sophia-antipolis Paca 06560France',1),('00:15:50','Nits Technology Inc','Nits Technology Inc2fl. No. 8 Alley 16, Lane 235, Bauchiau Rd.,Shindian City Taipei Hsien 231Taiwan, Republic Of China',1),('00:15:51','Radiopulse Inc.','Radiopulse Inc.2nd Fl. Hans B/d, 111-55Seongnae-dong, Gangdong-guSeoul  134-883Korea, Republic Of',1),('00:15:52','Wi-gear Inc.','Wi-gear Inc.340 Church StreetSuite 10San Francisco Ca 94114United States',1),('00:15:53','Cytyc Corporation','Cytyc Corporation250 Campus DiveMarlborough Ma 01752United States',1),('00:15:54','Atalum Wireless S.a.','Atalum Wireless S.a.C/ Orellana 5, 1 IMadrid  28004Spain',1),('00:15:55','Dfm Gmbh','Dfm GmbhLahrer Strasse 6Lahr Baden-wuerttemberg 77933Germany',1),('00:15:56','Sagem Communication','Sagem CommunicationLe Ponnant De Paris27 Rue LeblancCedex Paris 75512France',1),('00:15:57','Olivetti','OlivettiVia Jervis 77Ivrea Torino 10015Italy',1),('00:15:58','Foxconn','FoxconnNo.2,2nd Donghuan Road,10th YousongIndustrial District,longhua Street,baoan,Shenzhen Guangdong 518109China',1),('00:15:59','Securaplane Technologies, Inc.','Securaplane Technologies, Inc.10800 N. Mavinee Dr.Tucson Az 85737United States',1),('00:15:5A','Dainippon Pharmaceutical Co., Ltd.','Dainippon Pharmaceutical Co., Ltd.2-6-8, Doshomachi, Chuo-kuOsaka City Osaka Pref. 541-8524Japan',1),('00:15:5B','Sampo Corporation','Sampo Corporation216 Chung Shan Road,Sec. 1, Panchiao CityTaipei Hsien 220Taiwan, Republic Of China',1),('00:15:5C','Dresser Wayne','Dresser Wayne3814 Jarrett WayAustin Texas 78728United States',1),('00:15:5D','Microsoft Corporation','Microsoft CorporationOne Microsoft WayRedmond Wa 98052-8300United States',1),('00:15:5E','Morgan Stanley','Morgan Stanley750 7th AvenueNew York Ny 10019United States',1),('00:15:5F','Greenpeak Technologies','Greenpeak TechnologiesLindestraat 19Zele  9240Belgium',1),('00:15:60','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:15:61','Jjplus Corporation','Jjplus Corporation678 Massachusetts AveSuite 503Cambridge Ma 02139United States',1),('00:15:62','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:63','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:64','Behringer Spezielle Studiotechnik Gmbh','Behringer Spezielle Studiotechnik GmbhHanns-martin-schleyer-str. 36-38WillichGermany',1),('00:15:65','Xiamen Yealink Network Technology Co.,ltd','Xiamen Yealink Network Technology Co.,ltd7f Hualian Electronic Bldg.580 Jiahe Road,xiamen ChinaXiamen Fujian 361006China',1),('00:15:66','A-first Technology Co., Ltd.','A-first Technology Co., Ltd.5f, No. 111-2, Shin-teh Rd.,San-chung City Taipei Shien 241Taiwan, Republic Of China',1),('00:15:67','Radwin Inc.','Radwin Inc.900 Corporate DriveMahwah Nj 07430United States',1),('00:15:68','Dilithium Networks','Dilithium Networks5401 Old Redwood HwyPetaluma Ca 94954United States',1),('00:15:69','Peco Ii, Inc.','Peco Ii, Inc.7060 Huntley RoadColumbus Oh 43229United States',1),('00:15:6A','Dg2l Technologies Pvt. Ltd.','Dg2l Technologies Pvt. Ltd.Aml Center 1, Gnd. Floor, 8 Mahal Indl. Est.Off. Mahakali Caves Road, Andheri EMumbai Maharashtra 400093India',1),('00:15:6B','Perfisans Networks Corp.','Perfisans Networks Corp.4118 14th AvenueUnit 4Markham Ontario L3r 0j3Canada',1),('00:15:6C','Sane System Co., Ltd','Sane System Co., LtdPika-building 4f #894 Hogye-dong Dongan-guAnyang-si Kyunggi-do 431-836Korea, Republic Of',1),('00:15:6D','Ubiquiti Networks Inc.','Ubiquiti Networks Inc.495 Montague Expwy.Milpitas Ca 95035United States',1),('00:15:6E','A. W. Communication Systems Ltd','A. W. Communication Systems LtdCrook BarnThe Crook, RoweltownCarlisle Cumbria Ca6 6lhUnited Kingdom',1),('00:15:6F','Xiranet Communications Gmbh','Xiranet Communications GmbhBertolt-brecht-allee 24Dresden Saxony 01309Germany',1),('00:15:70','Symbol Technologieswholly Owned Subsidiary Of Motorola','Symbol Technologieswholly Owned Subsidiary Of MotorolaOne Motorola PlazaHoltsville Ny 11742United States',1),('00:15:71','Nolan Systems','Nolan Systems1595 Cleo Springs Dr.San Jose Ca. 95131United States',1),('00:15:72','Red-lemon','Red-lemonUnit 4, 9/f, Paramount BuildingNo. 12, Ka Yip StreetChai WanHong Kong',1),('00:15:73','Newsoft  Technology Corporation','Newsoft  Technology Corporation3f, 19-3, Sanchong Rd, Nankang,Taipei  115Taiwan, Republic Of China',1),('00:15:74','Horizon Semiconductors Ltd.','Horizon Semiconductors Ltd.9 Hamenofim St.Pob 2192Herzliya  46120Israel',1),('00:15:75','Nevis Networks Inc.','Nevis Networks Inc.3945 Freedom CircleSuite 720Santa Clara Ca 95054United States',1),('00:15:76','Scil Animal Care Company Gmbh','Scil Animal Care Company GmbhDina-weissmann-allee 6Viernheim Hessen 68519Germany',1),('00:15:77','Allied Telesyn, Inc.','Allied Telesyn, Inc.3200 North First StreetSan Jose California 95134United States',1),('00:15:78','Audio / Video Innovations','Audio / Video InnovationsA3-3375 North Service RoadBurlington On L7n 3g2Canada',1),('00:15:79','Lunatone Industrielle Elektronik Gmbh','Lunatone Industrielle Elektronik GmbhRennbahnweg 55Wien  1220Austria',1),('00:15:7A','Telefin S.p.a.','Telefin S.p.a.Via Albere 87/aVerona Vr 37138Italy',1),('00:15:7B','Leuze Electronic Gmbh + Co. Kg','Leuze Electronic Gmbh + Co. KgIn Der Braike 1Owen Baden-wrttemberg 73277Germany',1),('00:15:7C','Dave Networks, Inc.','Dave Networks, Inc.2151 Otool AvenueSuite HSan Jose Ca 95131United States',1),('00:15:7D','Posdata Co., Ltd.','Posdata Co., Ltd.276-2,seohyeon-dong,bundang-gu,Seongnam-city Kyeonggi-do 463-775Korea, Republic Of',1),('00:15:7E','Heyfra Electronic Gmbh','Heyfra Electronic GmbhHerner Str. 5Eisleben Sachsen/anhalt 06295Germany',1),('00:15:7F','Chuang International Holding Co.,ltd.','Chuang International Holding Co.,ltd.1f, No.12, Alley 1, Lane 125, Guolian Street 4lirn, Wuhan VillageTaoyuan Longtan 325Taiwan, Republic Of China',1),('00:15:80','U-way Corporation','U-way Corporation3f-2, No. 125, Lane 235, Pao-chiaoHsintien City Taipei Hsien 231Taiwan, Republic Of China',1),('00:15:81','Makus Inc.','Makus Inc.4f Daedo Bldg. 748-14 Yeoksam-dong, Kangnam-guSeoul 135-080Korea, Republic Of',1),('00:15:82','Tvonics Ltd','Tvonics LtdPenoced Technology ParkPencoed Mid Glam Cf35 5hzUnited Kingdom',1),('00:15:83','Ivt Corporation','Ivt CorporationShangdi Xinxi Road, Haidian DistrictBeijing  100085China',1),('00:15:84','Schenck Process Gmbh','Schenck Process GmbhPallaswiesenstr. 100Darmstadt Hessen 64293Germany',1),('00:15:85','Aonvision Technolopy Corp.','Aonvision Technolopy Corp.2f, No. 58, Park 2nd Ave. Science-based Industrial Park,Hsinchu 300Taiwan, Republic Of China',1),('00:15:86','Xiamen Overseas Chinese Electronic Co., Ltd.','Xiamen Overseas Chinese Electronic Co., Ltd.No. 22, Huli Street,Huli Industrial DistrictXiamen Fujian 361006China',1),('00:15:87','Takenaka Seisakusho Co.,ltd','Takenaka Seisakusho Co.,ltd178 HishieHigashi-osaka City Osaka 578-0984Japan',1),('00:15:88','Balda-thong Fook Solutions Sdn. Bhd.','Balda-thong Fook Solutions Sdn. Bhd.3 Jalan Zarib 6Kawasan Perindustrian ZaribLahat, Ipoh Perak 31500Malaysia',1),('00:15:89','D-max Technology Co.,ltd','D-max Technology Co.,ltd7f-6,no.26,lian Cheng Rd.,chung-ho CityTaipei Hsien  235Taiwan, Republic Of China',1),('00:15:8A','Surecom Technology Corp.','Surecom Technology Corp.6f, No. 125, Sec. 2, Datung Rd.Shijr City, Taipei County  221Taiwan, Republic Of China',1),('00:15:8B','Park Air Systems Ltd','Park Air Systems LtdNorthfieldsMarket DeepingPeterborough  Pe6 8ueUnited Kingdom',1),('00:15:8C','Liab Aps','Liab ApsOestre Alle 6Stoevring  Dk-9530Denmark',1),('00:15:8D','Jennic Ltd','Jennic LtdFurnival StreetSheffield Yorkshire S1 4qtUnited Kingdom',1),('00:15:8E','Plustek.inc','Plustek.inc13f-1,no3(building F) Yuan Qu StreetTaipei Yuan Qu 115Taiwan, Republic Of China',1),('00:15:8F','Ntt Advanced Technology Corporation','Ntt Advanced Technology CorporationShinjuku Mitsui Bldg. 2-1-1, Nishi-shinjukuShinjuku-ku Tokyo 163-0431Japan',1),('00:15:90','Hectronic Gmbh','Hectronic GmbhAllmendstrasse 15Bonndorf Baden-wrttemberg 79848Germany',1),('00:15:91','Rlw Inc.','Rlw Inc.2029 Cato Ave.State College Pa 16801United States',1),('00:15:92','Facom Uk Ltd (melksham)','Facom Uk Ltd (melksham)Lancaster HouseBowerhill Industrial EstateMelksham Wiltshire Sn104fbUnited Kingdom',1),('00:15:93','U4ea Technologies Inc.','U4ea Technologies Inc.48860 Milmont DriveSuite107cFremont Ca 94538United States',1),('00:15:94','Bixolon Co.,ltd','Bixolon Co.,ltd502-508,digital Empire Bldg.980-3 Yeongtong-dongYeongtong-gu,suwon Gyeonggi-do 443-813Korea, Republic Of',1),('00:15:95','Quester Tangent Corporation','Quester Tangent Corporation201 - 9865 West Saanich RoadSidney Bc V8l 5y8Canada',1),('00:15:96','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:97','Aeta Audio Systems','Aeta Audio Systems18-22, Avenue Edouard HerriotKepler 4Le Plessis Robinson  92350France',1),('00:15:98','Kolektor Group','Kolektor GroupVojkova 10Idrija  5280Slovenia',1),('00:15:99','Samsung Electronics Co., Ltd','Samsung Electronics Co., Ltd416, Maetan-3dong, Yeongtong-guSuwon Gyeonggi 443-742Korea, Republic Of',1),('00:15:9A','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:15:9B','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:15:9C','B-kyung System Co.,ltd.','B-kyung System Co.,ltd.#812,woolim E-biz Center,170-5Guro-dong Guro-gu 152-847Korea, Republic Of',1),('00:15:9D','Minicom Advanced Systems Ltd','Minicom Advanced Systems Ltd16, Hartom St.Har-hotzvimJerusalem  91450Israel',1),('00:15:9E','Mad Catz Interactive Inc','Mad Catz Interactive IncUnits 3+4 West Point RowGreat Park Rd, AlmondsburyBristol South Gloucestershire Bs32 4qgUnited Kingdom',1),('00:15:9F','Terascala, Inc.','Terascala, Inc.145 Bodwell StreetAvon Ma 02322United States',1),('00:15:A0','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:15:A1','Eca-sinters','Eca-sinters5, Rue Paul MesplToulouse Cedex 01 31106France',1),('00:15:A2','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:A3','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:A4','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:A5','Dci Co., Ltd.','Dci Co., Ltd.4th Fl. Susung B/d, 893-4Jijok-dongYuseong-gu Daejeon 305-330Korea, Republic Of',1),('00:15:A6','Digital Electronics Products Ltd.','Digital Electronics Products Ltd.Room 301, 3 Rd Floor, Tsun Yip Centre41 Tsun Yip StreetKwun Tong  852Hong Kong',1),('00:15:A7','Robatech Ag','Robatech AgPilatusring 10Muri Ag 5630Switzerland',1),('00:15:A8','Motorola Mobile Devices','Motorola Mobile Devices600 N Us Hwy 45Rm Mw113Libertyville Il 60048United States',1),('00:15:A9','Kwang Woo I&c Co.,ltd','Kwang Woo I&c Co.,ltd898-23, Hogye-dong,dongan-guAnyang-si,gyeonggi-do431-080Korea, Republic Of',1),('00:15:AA','Rextechnik International Co.,','Rextechnik International Co.,Room 5-3, No.51, Section 2, Keelung RoadTaipei  110Taiwan, Republic Of China',1),('00:15:AB','Pro Co Sound Inc','Pro Co Sound Inc225 Parsons StreetKalamazoo Michigan 49008United States',1),('00:15:AC','Capelon Ab','Capelon AbJgerhorns Vg 1Kungens Kurva Stockholm S-141 75Sweden',1),('00:15:AD','Accedian Networks','Accedian Networks4878 Levy, Suite 202Suite 202St-laurent Quebec H9p 2v4Canada',1),('00:15:AE','Kyung Il','Kyung IlWoar Rong-myn Yougate-ri 101-2Paju-city Gyeong Gi 413-813Korea, Republic Of',1),('00:15:AF','Azurewave Technologies, Inc.','Azurewave Technologies, Inc.8f., No.94, Baozhong Rd., XindianTaipei  231Taiwan, Republic Of China',1),('00:15:B0','Autotelenet Co.,ltd','Autotelenet Co.,ltd2f, 898-24, Hogye2-dong, Dongan-guAnyang-city Kyunggi-do 431-836Korea, Republic Of',1),('00:15:B1','Ambient Corporation','Ambient Corporation79 Chapel St.Newton Ma 02458United States',1),('00:15:B2','Advanced Industrial Computer, Inc.','Advanced Industrial Computer, Inc.17970 E. Ajax CircleCity Of Industry Ca 91748United States',1),('00:15:B3','Caretech Ab','Caretech AbNyborgsvgen 197Kalix  95291Sweden',1),('00:15:B4','Polymap  Wireless Llc','Polymap  Wireless Llc310 S. Williams Blvd. Ste. 350Tucson Az 85711United States',1),('00:15:B5','Ci Network Corp.','Ci Network Corp.2f Daini Inoue Bldg1-6-6 Akasaka Minato-kuTokyo  107-0052Japan',1),('00:15:B6','Shinmaywa Industries, Ltd.','Shinmaywa Industries, Ltd.1-1 Shinmeiwa-choTakarazuka Hyogo 665-8550Japan',1),('00:15:B7','Toshiba','Toshiba2-9,suehiro-choOme Tokyo 1988710Japan',1),('00:15:B8','Tahoe','TahoeUl. Uniwersytecka 1Wroclaw  50951Poland',1),('00:15:B9','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1Imsoo-dongGumi-city Gyeong-buk 730-350Korea, Republic Of',1),('00:15:BA','Iba Ag','Iba AgKoenigswarterstrasse 44Fuerth Bavaria 90762Germany',1),('00:15:BB','Sma Solar Technology Ag','Sma Solar Technology AgSonnenallee 1Niestetal Hessen 34266Germany',1),('00:15:BC','Develco','DevelcoOlof Palmes All 40Aarhus N  8200Denmark',1),('00:15:BD','Group 4 Technology Ltd','Group 4 Technology LtdChallenge HouseInternational DriveTewkesbury Gloucestershire Gl20 8uqUnited Kingdom',1),('00:15:BE','Iqua Ltd.','Iqua Ltd.Hyvoninkatu 1Salo Varsinais-suomi 24240Finland',1),('00:15:BF','Technicob','Technicob4 Rue Camille Saint-saensLanester Morbihan 56602France',1),('00:15:C0','Digital Telemedia Co.,ltd.','Digital Telemedia Co.,ltd.17th Floor, China Yuse Building,No 6013 Shennan Road,futian DistrictShenzhen Guangdong 518040China',1),('00:15:C1','Sony Computer Entertainment Inc,','Sony Computer Entertainment Inc,6-21,2chomeMinami-aoyamaMinato-ku Tokyo 107-0062Japan',1),('00:15:C2','3m Germany','3m GermanyCarl Schurz Str. 1Neuss Nrw 41453Germany',1),('00:15:C3','Ruf Telematik Ag','Ruf Telematik AgRuetistrasse 13Schlieren Zh 8952Switzerland',1),('00:15:C4','Flovel Co., Ltd.','Flovel Co., Ltd.The Tachihi Building No,3 Hall, 6-1, Sakae-cho,Tachikawa-shiTokyo  190-0003Japan',1),('00:15:C5','Dell Inc','Dell IncOne Dell WayRound Rock Texas 78682United States',1),('00:15:C6','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:C7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:C8','Flexipanel Ltd','Flexipanel Ltd7 Bis Rue LaloParis 75016France',1),('00:15:C9','Gumstix, Inc','Gumstix, Inc3130 Alpine RoadSuite 288-606Portola Valley Ca 94028United States',1),('00:15:CA','Terarecon, Inc.','Terarecon, Inc.2955 Campus Drive, Suite 325San Mateo Ca 94403United States',1),('00:15:CB','Surf Communication Solutions Ltd.','Surf Communication Solutions Ltd.P.o. Box 343Soltam Industrial ZoneYokneam  20164Israel',1),('00:15:CC','Tepco Uquest, Ltd.','Tepco Uquest, Ltd.Sannomiya Intes Bldg. 8f7-1-8 Isogami-dori, Chuo-kuKobe Hyogo 651-0086Japan',1),('00:15:CD','Exartech International Corp.','Exartech International Corp.3/f, No.62, Lane 188, Ruei Guang Rd., NeihuTaipei  114Taiwan, Republic Of China',1),('00:15:CE','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:CF','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:D0','Arris International','Arris International3871 Lakefield DriveSuite 300Suwanee Ga 30024United States',1),('00:15:D1','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:15:D2','Xantech Corporation','Xantech Corporation13100 Telfair AvenueSecond FloorSylmar Ca 91342-3573United States',1),('00:15:D3','Pantech&curitel Communications, Inc.','Pantech&curitel Communications, Inc.1451-34, Seocho-dong, Seocho-guSeoul  137-070Korea, Republic Of',1),('00:15:D4','Emitor Ab','Emitor AbSjviksbacken 14Stockholm  117 43Sweden',1),('00:15:D5','Nicevt','NicevtWarshawskoe Shosse 125Moscow  117405Russian Federation',1),('00:15:D6','Oslink Sp. Z O.o.','Oslink Sp. Z O.o.Ul. Marsa 27Gdansk  80299Poland',1),('00:15:D7','Reti Corporation','Reti Corporation6f,no 13, Lane 120, Sec 1, Neihu Rd.,Taipei City  114Taiwan, Republic Of China',1),('00:15:D8','Interlink Electronics','Interlink Electronics546 Flynn RoadCamarillo Ca 93012United States',1),('00:15:D9','Pkc Electronics Oy','Pkc Electronics OyPajuniityntie 43Raahe  92120Finland',1),('00:15:DA','Iritel A.d.','Iritel A.d.Batajnicki Put 23Beograd Serbia 11080Yugoslavia',1),('00:15:DB','Canesta Inc.','Canesta Inc.965 West Maude AvenueSunnyvale California 94085United States',1),('00:15:DC','Kt&c Co., Ltd.','Kt&c Co., Ltd.487-4, Kt&c Bldg.Banghwa-dongGangseo-ku Seoul 157-849Korea, Republic Of',1),('00:15:DD','Ip Control Systems Ltd.','Ip Control Systems Ltd.Unit 15, Hi-tech Village,Witney Way, Boldon Business Park,Boldon Tyne & Wear Ne35 9peUnited Kingdom',1),('00:15:DE','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790 VDenmark',1),('00:15:DF','Clivet S.p.a.','Clivet S.p.a.Via Camp Lonc 25Feltre Belluno 32030Italy',1),('00:15:E0','Ericsson Mobile Platforms','Ericsson Mobile PlatformsNya VattentornetLund  Se-221 83Sweden',1),('00:15:E1','Picochip Designs Ltd','Picochip Designs LtdRiverside Buildings108 Walcot StreetBath Somerset Ba1 5bgUnited Kingdom',1),('00:15:E2','Dr.ing. Herbert Knauer Gmbh','Dr.ing. Herbert Knauer GmbhHegauer Weg 38Berlin  14163Germany',1),('00:15:E3','Dream Technologies Corporation','Dream Technologies CorporationEbisu Prime Square, 1-1-39 HirooShibuya-ku Tokyo 150-0012Japan',1),('00:15:E4','Zimmer Elektromedizin','Zimmer ElektromedizinJunkersstrasse 9Neu-ulm Bayern 89231Germany',1),('00:15:E5','Cheertek Inc.','Cheertek Inc.No.2, Du-sing First Road, Science-based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:15:E6','Mobile Technika Inc.','Mobile Technika Inc.Sotobori Sky Bld. 5th Floor2-11 Ichigaya Honmura-cho,Shinjuku-ku Tokyo 162-0845Japan',1),('00:15:E7','Quantec Proaudio','Quantec ProaudioLeopoldstrasse 18Mnchen  D-80802Germany',1),('00:15:E8','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:15:E9','D-link Corporation','D-link Corporation2f, No.233-2, Pao-chiao RoadHsin-tien, Taipei 231Taiwan, Republic Of China',1),('00:15:EA','Tellumat (pty) Ltd','Tellumat (pty) Ltd64/74 White RoadRetreatCape Town Western Province 7945South Africa',1),('00:15:EB','Zte Corporation','Zte Corporation5/f,a Wing,zte Plaza,keji Road South,hi-tech Industrial Park,nanshan DistrictShenzhen Guangdong 518057China',1),('00:15:EC','Boca Devices Llc','Boca Devices Llc6353 W. Rogers Circle #4Boca Raton Florida 33487United States',1),('00:15:ED','Fulcrum Microsystems, Inc.','Fulcrum Microsystems, Inc.26630 Agoura RoadCalabasas Ca 91302United States',1),('00:15:EE','Omnex Control Systems','Omnex Control Systems#74 - 1833 Coast Meridian Rd.Port Coquitlam Bc V3c 6g5Canada',1),('00:15:EF','Nec Tokin Corporation','Nec Tokin Corporation1120, ShimokuzawaSagamihara Kanagawa 229-1198Japan',1),('00:15:F0','Ego Bv','Ego BvParade 15s-hertogenbosch Noord-brabant 5211klNetherlands',1),('00:15:F1','Kylink Communications Corp.','Kylink Communications Corp.8f-8, No. 351, Sec. 2, Zhongshan Rd., Zhonghe CityTaipei County23504Taiwan, Republic Of China',1),('00:15:F2','Asustek Computer Inc.','Asustek Computer Inc.No.5 Shing Yeh Street,kwei Shan Hsiang,taoyuanTaipei  333Taiwan, Republic Of China',1),('00:15:F3','Peltor Ab','Peltor AbBox 2341Se-331 02  Vrnamo  Se-331 02Sweden',1),('00:15:F4','Eventide','Eventide1 Alsan WayLittle Ferry Nj 07643United States',1),('00:15:F5','Sustainable Energy Systems','Sustainable Energy Systems#500, 609 14th Street NwCalgary Ab T2t 1p3Canada',1),('00:15:F6','Science And Engineering Services, Inc.','Science And Engineering Services, Inc.4015 Pulaski Pike NwHuntsville Al 35810United States',1),('00:15:F7','Wintecronics Ltd.','Wintecronics Ltd.No. 716, 11f-3, Jung Jeng Rd.Chung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:15:F8','Kingtronics Industrial Co. Ltd.','Kingtronics Industrial Co. Ltd.Penthouse, Century Centre,44-46 Hung To Road, Kwun TongKowloonHong Kong',1),('00:15:F9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:FA','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:15:FB','Setex Schermuly Textile Computer Gmbh','Setex Schermuly Textile Computer GmbhHauptstrasse 25Mengerskirchen Hessen 35794Germany',1),('00:15:FC','Startco Engineering Ltd.','Startco Engineering Ltd.406 Jessop AveSaskatoon Sk S7n2s5Canada',1),('00:15:FD','Complete Media Systems','Complete Media SystemsGrove PlaceCuckfield LaneWarninglid West Sussex Rh17 5snUnited Kingdom',1),('00:15:FE','Schilling Robotics Llc','Schilling Robotics Llc201 Cousteau PlDavis Ca 95616United States',1),('00:15:FF','Novatel Wireless, Inc.','Novatel Wireless, Inc.9645 Scranton RoadSuite 205San Diego California 92121United States',1),('00:16:00','Cellebrite Mobile Synchronization','Cellebrite Mobile Synchronization25 Basel St.Pob 7565Petach Tikva  49170Israel',1),('00:16:01','Buffalo Inc.','Buffalo Inc.4-15 Shibata HondoriNagoya Minami-ku, Aichi 457-8520Japan',1),('00:16:02','Ceyon Technology Co.,ltd.','Ceyon Technology Co.,ltd.13f Samsung Insurance B/d. #942-9Ingye-dong,paldal-guSuwon-city Gyeonggi-do 442-832Korea, Republic Of',1),('00:16:03','Coolksky Co., Ltd','Coolksky Co., LtdShingsung Offcetel A511, 1588-1Secho Seoul 137-070Korea, Republic Of',1),('00:16:04','Sigpro','Sigpro655 W Evelyn StSuite 2Mountain View Ca 94041United States',1),('00:16:05','Yorkville Sound Inc.','Yorkville Sound Inc.4625 Witmer Industrial EstateNiagara Falls Ny 14305United States',1),('00:16:06','Ideal Industries','Ideal Industries9145 Balboa AveSan Diego Ca 92123United States',1),('00:16:07','Curves International Inc.','Curves International Inc.100 Ritchie RoadWaco Texas 76712United States',1),('00:16:08','Sequans Communications','Sequans Communications19 Le Parvis De La DfenseBtiment CiticenterParis La Defense Cedex 92073France',1),('00:16:09','Unitech Electronics Co., Ltd.','Unitech Electronics Co., Ltd.5f,no.136,lane 235 ,pao-chiao Rd.,Hsin-tien City Taipei Hsien 231Taiwan, Republic Of China',1),('00:16:0A','Sweex Europe Bv','Sweex Europe BvAmpereweg 3Delft Zuid-holland 2627 BgNetherlands',1),('00:16:0B','Tvworks Llc','Tvworks LlcTwo Belvedere Place, #200Mill Valley Ca 94941United States',1),('00:16:0C','Lpl  Development S.a. De C.v','Lpl  Development S.a. De C.vLago Ginebra 380 P3Col. Francisco I MaderoD.f. 11480Mexico',1),('00:16:0D','Be Here Corporation','Be Here Corporation39300 Civic Center Dr., Suite 180Fremont Ca 94538United States',1),('00:16:0E','Optica Technologies Inc.','Optica Technologies Inc.2051 Dogwood StreetSuite 210Louisville Co 80027United States',1),('00:16:0F','Badger Meter Inc','Badger Meter Inc4545 W Brown Deer RdMilwaukee Wi 53223United States',1),('00:16:10','Carina Technology','Carina Technology690a Discovery DriveHuntsville Al 35806United States',1),('00:16:11','Altecon Srl','Altecon SrlVia F.lli Cairoli, 17Lissone Milano 20035Italy',1),('00:16:12','Otsuka Electronics Co., Ltd.','Otsuka Electronics Co., Ltd.1-10 Sasagaoka, MinakuchiKouka Shiga 528-0061Japan',1),('00:16:13','Librestream Technologies Inc.','Librestream Technologies Inc.895 Waverley StreetSuite 110Winnipeg Manitoba R3t 5p4Canada',1),('00:16:14','Picosecond Pulse Labs','Picosecond Pulse Labs2500 55th StreetBoulder Co 80301United States',1),('00:16:15','Nittan Company, Limited','Nittan Company, Limited11-6, 1-chome, HatagayaShibuya-ku Tokyo 151-8535Japan',1),('00:16:16','Browan Communication Inc.','Browan Communication Inc.No.1 Jen-ai Road, Hsinchu Industrial Park,Hukou Hsiang Hsinchu Hsien 303Taiwan, Republic Of China',1),('00:16:17','Msi','MsiNo.69, Li-de St, Jung-ho CityTaipei Hsien  235Taiwan, Republic Of China',1),('00:16:18','Hivion Co., Ltd.','Hivion Co., Ltd.2f., Akyung Bldg., 54-10, Munjeong-dong,Songpa-gu SeoulKorea, Republic Of',1),('00:16:19','La Factora De Comunicaciones Aplicadas,s.l.','La Factora De Comunicaciones Aplicadas,s.l.C/agricultura,111Terrassa Barcelona 08223Spain',1),('00:16:1A','Dametric Ab','Dametric AbBox 120Skarholmen Stockholm Se-12723Sweden',1),('00:16:1B','Micronet Corporation','Micronet Corporation1788-388 Nomura HirookaShiojiri-shi Nagano-ken 399-0702Japan',1),('00:16:1C','E:cue','E:cueFriedrich-list-strasse 23Paderborn  33100Germany',1),('00:16:1D','Innovative Wireless Technologies, Inc.','Innovative Wireless Technologies, Inc.1047 Vista Park Dr.Suite AForest Va 24551United States',1),('00:16:1E','Woojinnet','Woojinnet292 Osan DongtanHwaseong Kyonggi 445-813Korea, Republic Of',1),('00:16:1F','Sunwavetec Co., Ltd.','Sunwavetec Co., Ltd.#823, Kwanyang-dong, Dongan-kuAnyang-si Kyungki-do 431-060Korea, Republic Of',1),('00:16:20','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:16:21','Colorado Vnet','Colorado Vnet255 E. 6th St.Loveland Co 80537United States',1),('00:16:22','Bbh Systems Gmbh','Bbh Systems GmbhBttgerstrasse 40Weiden I.d.opf. Bayern 92637Germany',1),('00:16:23','Interval Media','Interval Media3200 Ash StreetPalo Alto Ca 94306United States',1),('00:16:24','Teneros, Inc.','Teneros, Inc.215 Castro St.3rd FloorMt. View Ca 94041United States',1),('00:16:25','Impinj, Inc.','Impinj, Inc.701 N. 34th StreetSuite 300Seattle Wa 98103United States',1),('00:16:26','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:16:27','Embedded-logic Design And More Gmbh','Embedded-logic Design And More GmbhHansestrasse 24Muenster Nrw 48153Germany',1),('00:16:28','Ultra Electronics Manufacturing And Card Systems','Ultra Electronics Manufacturing And Card SystemsHampshire RoadGranby EstateWeymouth Dorset Dt4 9xdUnited Kingdom',1),('00:16:29','Nivus Gmbh','Nivus GmbhIm Tle 2Eppingen Baden-wuerttemberg 75031Germany',1),('00:16:2A','Antik Computers & Communications S.r.o.','Antik Computers & Communications S.r.o.Razusova 2Kosice Sk Sk-04001Slovakia',1),('00:16:2B','Togami Electric Mfg.co.,ltd.','Togami Electric Mfg.co.,ltd.1-1 Ohtakara-kitamachiSaga.prf 840-0802Japan',1),('00:16:2C','Xanboo','Xanboo115 West 30th, 6th FlNew York Ny 10001United States',1),('00:16:2D','Stnet Co., Ltd.','Stnet Co., Ltd.Shin-wha Building 4f, 954-25Kwanyang-dong, Dongan-guAnyang-si Kyungki-do  431-060Korea, Republic Of',1),('00:16:2E','Space Shuttle Hi-tech Co., Ltd.','Space Shuttle Hi-tech Co., Ltd.No. 226, Wu-ho St., Wu-lung Village,Chiung-lin Hsiang,Hsinchu Hsien  307Taiwan, Republic Of China',1),('00:16:2F','Geutebrck Gmbh','Geutebrck GmbhIm Nassen 7-9Windhagen  53578Germany',1),('00:16:30','Vativ Technologies','Vativ Technologies9339 Genesee AvenueSuite 130San Diego Ca 92121United States',1),('00:16:31','Xteam','XteamRoom 801, No.102 International Science & Techology ParkNo.2 Shangdi Info Road, Haidian DistrictBeijing 8610China',1),('00:16:32','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.416, Metan-3dong,Youngtong-guSuwon Kyungki-do 442-742Korea, Republic Of',1),('00:16:33','Oxford Diagnostics Ltd.','Oxford Diagnostics Ltd.SandybraeWhitebarn Dr, Boars HillOxford Oxon. Ox1 5hjUnited Kingdom',1),('00:16:34','Mathtech, Inc.','Mathtech, Inc.6402 Arlington Blvd.,Suite 1200Falls Church Virginia 22042-2356United States',1),('00:16:35','Hewlett Packard','Hewlett Packard20555 State Highway 249 SouthMs070405Houston Tx 77070United States',1),('00:16:36','Quanta Computer Inc.','Quanta Computer Inc.No. 211, Wen Hwa 2rd., Kuei Shan HsiangTao Yuan ShienTaiwan, Republic Of China',1),('00:16:37','Citel Srl','Citel SrlVia L. G. Columella, 36Milan Mi 20128Italy',1),('00:16:38','Tecom Co., Ltd.','Tecom Co., Ltd.23 R&d Road 2 Science Based Industrial ParkHsin-chu  300Taiwan, Republic Of China',1),('00:16:39','Ubiquam Co.,ltd','Ubiquam Co.,ltdTechnovill 4f,272-3 Yatap3BundangSeongnam Kyeonggi 463-836Korea, Republic Of',1),('00:16:3A','Yves Technology Co., Ltd.','Yves Technology Co., Ltd.No.74, Fusing 2nd Rd.Gueishan Taoyuan 33377Taiwan, Republic Of China',1),('00:16:3B','Vertexrsi/general Dynamics','Vertexrsi/general Dynamics2120 Old Gatesburg Rd.State College Pa 16803United States',1),('00:16:3C','Rebox B.v.','Rebox B.v.Hendrik Figeeweg 1xHaarlem Noord-holland 2031 BjNetherlands',1),('00:16:3D','Tsinghua Tongfang Legend Silicon Tech. Co., Ltd.','Tsinghua Tongfang Legend Silicon Tech. Co., Ltd.26f Tsinghua Tongfang Hi-tech PlazaBeijing  100083China',1),('00:16:3E','Xensource, Inc.','Xensource, Inc.2300 Geng Rd.Suite 250Palo Alto Ca 94303United States',1),('00:16:3F','Crete Systems Inc.','Crete Systems Inc.7f,no.250,sec.3,pei Shen Rd.,shen Keng HsiangTaipei County  22204Taiwan, Republic Of China',1),('00:16:40','Asmobile Communication Inc.','Asmobile Communication Inc.No.11 Lane 120, Li-te Rd., Peitou 112, Taipei, Taiwan, R.o.cTaipei  112Taiwan, Republic Of China',1),('00:16:41','Usi','Usi141, Lane 351, Taiping Rd. Sec.1,Tsao-tuen Nan-tou 542Taiwan, Republic Of China',1),('00:16:42','Pangolin','Pangolin9501 Satellite Boulevard, Suite 109Orlando Fl 32837United States',1),('00:16:43','Sunhillo Corporation','Sunhillo Corporation444 Kelley DriveWest Berlin New Jersey 08091United States',1),('00:16:44','Lite-on Technology Corp.','Lite-on Technology Corp.18f, No.392, Ruey Kuang Road, Niehu,Taipei  114Taiwan, Republic Of China',1),('00:16:45','Power Distribution, Inc.','Power Distribution, Inc.4200 Oakleys Ct.Richmond Va 23223United States',1),('00:16:46','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:16:47','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:16:48','Ssd Company Limited','Ssd Company Limited3-3-4 HigashiyaguraKusatsu-city Shiga 525-0054Japan',1),('00:16:49','Setone Gmbh','Setone GmbhHegenheimer Str. 2Weil Am Rhein Baden Wuertemberg D-79576Germany',1),('00:16:4A','Vibration Technology Limited','Vibration Technology LimitedVibtech House, Central BoulevardCentral ParkLarbert Scotland Fk5 4ruUnited Kingdom',1),('00:16:4B','Quorion Data Systems Gmbh','Quorion Data Systems GmbhAn Der Klinge 6Erfurt Thuringia 99195Germany',1),('00:16:4C','Planet Int Co., Ltd','Planet Int Co., Ltd8th Floor, Saeum B/d, 1361-5Seocho-dong, Seocho-kuSeoul  137-070Korea, Republic Of',1),('00:16:4D','Alcatel North America Ip Division','Alcatel North America Ip Division701 E. Middlefield Rd.Mountain View Ca 94043United States',1),('00:16:4E','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:16:4F','World Ethnic Broadcastin Inc.','World Ethnic Broadcastin Inc.50 California Street, Suite 1500San Francisco California 94111United States',1),('00:16:50','Eyal Microwave','Eyal MicrowaveKibbutz EyalD.n. Hasharon Hatichon45840Israel',1),('00:16:51','Exeo Systems','Exeo Systems1650, Rue Michelin, Suite 201Laval Qubec H7l 4r3Canada',1),('00:16:52','Hoatech Technologies, Inc.','Hoatech Technologies, Inc.1f., No.224, Guosheng St.Zhubei Hsinchu Hsien 30244Taiwan, Republic Of China',1),('00:16:53','Lego System A/s Ie Electronics Division','Lego System A/s Ie Electronics DivisionAastvej 1Billund Kommune 7190Denmark',1),('00:16:54','Flex-p Industries Sdn. Bhd.','Flex-p Industries Sdn. Bhd.No.128-12-2, Menara Umno,Jalan Macalister,Georgetown Penang 10400Malaysia',1),('00:16:55','Fuho Technology Co., Ltd','Fuho Technology Co., LtdNo. 30, Lane 726, Jinma Rd, Sec. 3Chang Hua Taiwa 500Taiwan, Republic Of China',1),('00:16:56','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:16:57','Aegate Ltd','Aegate LtdTechnology CentreMelbourn Hertfordshire Sg8 6dpUnited Kingdom',1),('00:16:58','Fusiontech Technologies Inc.','Fusiontech Technologies Inc.6f, No.78, Cheng Kung Rd., Sec. 1,Nan KangTaipei  115Taiwan, Republic Of China',1),('00:16:59','Z.m.p. Radwag','Z.m.p. RadwagBracka 28 StreetRadom Mazowieckie 26-600Poland',1),('00:16:5A','Harman Specialty Group','Harman Specialty Group3 Oak Park DriveBedford Ma 01730United States',1),('00:16:5B','Grip Audio','Grip Audio6345 W. Louise DriveGlendale Arizona 85310-4243United States',1),('00:16:5C','Trackflow Ltd','Trackflow Ltd167-169 Kensington High StreetLondon England W86shUnited Kingdom',1),('00:16:5D','Airdefense, Inc.','Airdefense, Inc.4800 North Point PkwySte 100Alpharetta Ga 30022United States',1),('00:16:5E','Precision I/o','Precision I/o4005 Miranda Ave., Suite 210Palo Alto Ca 94304-1232United States',1),('00:16:5F','Fairmount Automation','Fairmount Automation4621 West Chester PikeNewtown Square Pa 19073United States',1),('00:16:60','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:16:61','Novatium Solutions (p) Ltd','Novatium Solutions (p) Ltd3rd Floor, Temple Towers, #672Anna Salai, Nandanam,Chennai Tamil Nadu 600035India',1),('00:16:62','Liyuh Technology Ltd.','Liyuh Technology Ltd.7f-1, No. 92, Sec. 1, Hei Hu Rd.Taipei  114Taiwan, Republic Of China',1),('00:16:63','Kbt Mobile','Kbt Mobile4f, Polaris I, 15-3, Jeongja-dong, Bundang-guSeongnam-si, Gyeonggi-do 463-811Korea, Republic Of',1),('00:16:64','Prod-el Spa','Prod-el SpaVia Palmanova 185Milano Mi 20132Italy',1),('00:16:65','Cellon France','Cellon FranceRoute Dangers Le Mans Cedex 9Le Mans Sarthe 72081France',1),('00:16:66','Quantier Communication Inc.','Quantier Communication Inc.1f, No. 36, Industry E. Rd Iv,Science-based Industrial ParkHsin-chu  300Taiwan, Republic Of China',1),('00:16:67','A-tec Subsystem Inc.','A-tec Subsystem Inc.4f, No. 86, Chung-hsing Road, Shijr City,Taipei County221Taiwan, Republic Of China',1),('00:16:68','Eishin Electronics','Eishin ElectronicsNishiku Miyashita 1-19Kobe City Hyogo Prefecture 651-2146Japan',1),('00:16:69','Mrv Communication (networks) Ltd','Mrv Communication (networks) LtdP.o Box 614Yokneam  20692Israel',1),('00:16:6A','Tps','Tps145 Quai De StalingradIssy Les Moulineaux Ile De France 92137France',1),('00:16:6B','Samsung Electronics','Samsung Electronics416,maetan-3dong,yeongtong-guSuwon-city Kyeonggi-do 443-742Korea, Republic Of',1),('00:16:6C','Samsung Electonics Digital Video System Division','Samsung Electonics Digital Video System Division416, Maetan-3dong,yeongtong-guSuwon Gyeonggi-do 443-742Korea, Republic Of',1),('00:16:6D','Yulong Computer Telecommunication Scientific(shenzhen)co.,lt','Yulong Computer Telecommunication Scientific(shenzhen)co.,lt8/f.high Tech Plaza,tianan Cyberpark,chegongmiaoShenzhen Guangdong 518040China',1),('00:16:6E','Arbitron Inc.','Arbitron Inc.9705 Patuxent Woods DriveColumbia Md 21046United States',1),('00:16:6F','Intel Corporation','Intel CorporationLot 8, Jln Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:16:70','Sknet Corporation','Sknet CorporationFontana ShinyokohamaShinyokohama 2,17,2 Kohoku-kuYokohama Kanagawa 222-0033Japan',1),('00:16:71','Symphox Information Co.','Symphox Information Co.15f, No. 51, Sec. 3, Minsheng E. RoadTaipei City  104Taiwan, Republic Of China',1),('00:16:72','Zenway Enterprise Ltd','Zenway Enterprise Ltd6f., No.20, Lane 150, Jhongsing Rd., Sijhih CityTaipei  886Taiwan, Republic Of China',1),('00:16:73','Bury Gmbh & Co. Kg','Bury Gmbh & Co. KgRobert-koch-str. 1-7Loehne Germany 32584Germany',1),('00:16:74','Eurocb (phils.), Inc.','Eurocb (phils.), Inc.Sfb No.2Mactan Economic Zone - ILapulapu City Cebu 6015Philippines',1),('00:16:75','Motorola Mdb','Motorola Mdb600 N Us Hwy 45Libertyville Illinois 60048United States',1),('00:16:76','Intel Corporation','Intel CorporationLot 8, Jln Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:16:77','Bihl+wiedemann Gmbh','Bihl+wiedemann GmbhFlosswoerthstr. 41Mannheim Baden Wrtemberg 68199Germany',1),('00:16:78','Shenzhen Baoan Gaoke Electronics Co., Ltd','Shenzhen Baoan Gaoke Electronics Co., LtdGaoke Industrial Park, No.8 Tangkeng Road, Shiyan TownShenzhen Guangdong 518108China',1),('00:16:79','Eon Communications','Eon Communications4105 Royal Drive, Suite 100Kennesaw Georgia 30144United States',1),('00:16:7A','Skyworth Overseas Dvelopment Ltd.','Skyworth Overseas Dvelopment Ltd.Room 1505-06,westlands Centre20 Westlands Road, Quarry Bay,Hong Kong',1),('00:16:7B','Haver&boecker','Haver&boeckerCarl-haver-platz 3Oelde Nrw 59302Germany',1),('00:16:7C','Irex Technologies Bv','Irex Technologies BvHightech CampusBuilding 46, Room P-005Eindhoven Brabant 5656aeNetherlands',1),('00:16:7D','Sky-line Information Co., Ltd.','Sky-line Information Co., Ltd.8f.,no.38,sihyuan Rd.,Sinihuang Taipei 242Taiwan, Republic Of China',1),('00:16:7E','Diboss.co.,ltd','Diboss.co.,ltd126-1, Gongdan-dongGumi Gyeongbuk 730-902Korea, Republic Of',1),('00:16:7F','Bluebird Soft Inc.','Bluebird Soft Inc.562-21 Gangnam-gu,Seoul  135-890Korea, Republic Of',1),('00:16:80','Bally Gaming + Systems','Bally Gaming + Systems950 Sandhill RoadReno Nv 89521United States',1),('00:16:81','Vector Informatik Gmbh','Vector Informatik GmbhIngersheimer Str. 24Stuttgart Baden-wuerttemberg 70499Germany',1),('00:16:82','Pro Dex, Inc','Pro Dex, Inc1800 Nw 169th PlaceC100Beaverton Oregon 97006United States',1),('00:16:83','Webio International Co.,.ltd.','Webio International Co.,.ltd.21f.,no.171 Songde Rd.,sinyi DistrictTaipei  11085Taiwan, Republic Of China',1),('00:16:84','Donjin Co.,ltd.','Donjin Co.,ltd.21f,cangsong Building,tairan,futianShenzhen Guangdong 518040China',1),('00:16:85','Elisa Oyj','Elisa OyjElektroniikkatie 490570 OuluFinland',1),('00:16:86','Karl Storz Imaging','Karl Storz Imaging175 Cremona Dr.Goleta Ca 93117United States',1),('00:16:87','Chubb Csc-vendor Ap','Chubb Csc-vendor ApOttawa StnP.o. Box 9832Ottawa  K1g 6w6Canada',1),('00:16:88','Serverengines Llc','Serverengines Llc209 N. Fair Oaks AvenueSunnyvale Ca 94085United States',1),('00:16:89','Pilkor Electronics Co., Ltd','Pilkor Electronics Co., Ltd381,wonchun-dong,yeoungtong-guSuwon Kyung Ki-do 442-380Korea, Republic Of',1),('00:16:8A','Id-confirm Inc','Id-confirm Inc1800 Boulder StSuite 400Denver Co 80211United States',1),('00:16:8B','Paralan Corporation','Paralan Corporation4655 Ruffner St.San Diego Ca 92111United States',1),('00:16:8C','Dsl Partner As','Dsl Partner AsHavreveien 49Oslo  0680Norway',1),('00:16:8D','Korwin Co., Ltd.','Korwin Co., Ltd.3rd Floor, Hana Bldg, 123-7 Nonhyun-dongKangnam-guSeoul  135-010Korea, Republic Of',1),('00:16:8E','Vimicro Corporation','Vimicro Corporation15/f,shining Tower,no.35,xueyuanRoad,haidian DistrictBeijing  100083China',1),('00:16:8F','Gn Netcom As','Gn Netcom AsMetalbuen 66P.o.box 201Ballerup Skovlunde Dk - 2750Denmark',1),('00:16:90','J-tek Incorporation','J-tek Incorporation2f-1, No. 83, Sec. 2, Gongdaowu Rd.,Hsinchu City  30070Taiwan, Republic Of China',1),('00:16:91','Moser-baer Ag','Moser-baer AgSpitalstrasse 7Sumiswald Be 3454Switzerland',1),('00:16:92','Scientific-atlanta, Inc.','Scientific-atlanta, Inc.5030 Sugarloaf PkwyAtl 1.3.473Lawrenceville Ga 30044United States',1),('00:16:93','Powerlink Technology Inc.','Powerlink Technology Inc.N0. 18, Alley 1, Lane 151, Sec. 1, Jhongsing Rd., Wugu TownshipTaipei Hsien  248Taiwan, Republic Of China',1),('00:16:94','Sennheiser Communications A/s','Sennheiser Communications A/sLangager 6Solrd Strand Copenhagen 2680Denmark',1),('00:16:95','Avc Technology Limited','Avc Technology Limited6/f Enterprise Square Iii39 Wang Chiu RoadKowloon BayHong Kong',1),('00:16:96','Qdi Technology (h.k.) Limited','Qdi Technology (h.k.) Limited16/f, Standard Chartered Bank Building 4-4aDes Voeux Road CentralHong KongChina',1),('00:16:97','Nec Corporation','Nec Corporation7-1, Shiba 5-chome Minato-ku,Tokyo 108-8001Japan',1),('00:16:98','T&a Mobile Phones','T&a Mobile Phones4/f, South Building,no.2966, Jinke RoadZhangjiang High-teck ParkPudong Shanghai 201203China',1),('00:16:99','Tonic Dvb Marketing Ltd','Tonic Dvb Marketing LtdUnit B, 10/f, Summit Building,30 Man Yue Street,Hung Hom KowloonHong Kong',1),('00:16:9A','Quadrics Ltd','Quadrics Ltd1 Bridewell StreetBristol  Bs1 2aaUnited Kingdom',1),('00:16:9B','Alstom Transport','Alstom Transport11, 13 Avenue De Bel AirVilleurbanne Rhone 69100France',1),('00:16:9C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:16:9D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:16:9E','Tv One Ltd','Tv One LtdUnit V Continental ApproachWestwood Industrial EstateMargate Kent Ct9 4jgUnited Kingdom',1),('00:16:9F','Vimtron Electronics Co., Ltd.','Vimtron Electronics Co., Ltd.7f., No.9, Alley 2, Lane 35Jihu Rd.Neihu District Taipei City 11492Taiwan, Republic Of China',1),('00:16:A0','Auto-maskin','Auto-maskinSophie Radichs Vei 7Lillestrom Akershus 2003Norway',1),('00:16:A1','3leaf Networks','3leaf Networks3255-1 Scott BlvdSanta Clara Ca 95054United States',1),('00:16:A2','Centralite Systems, Inc.','Centralite Systems, Inc.6420 Wall StreetMobile Al 36695United States',1),('00:16:A3','Ingeteam Transmission&distribution, S.a.','Ingeteam Transmission&distribution, S.a.C/ Usausuaga, 7Pol. ArtunduagaBasauri Bizkaia 48970Spain',1),('00:16:A4','Ezurio Ltd','Ezurio LtdUnit 2126 Colindale AvenueLondon  Nw9 5hdUnited Kingdom',1),('00:16:A5','Tandberg Storage Asa','Tandberg Storage AsaPostboks 1911325 LysakerNorway',1),('00:16:A6','Dovado Fz-llc','Dovado Fz-llcAl-thuraya Tower 1, Office 504P.o. Box 500422DubaiUnited Arab Emirates',1),('00:16:A7','Aweta G&p','Aweta G&pBurg. Winkellaan 3Nootdorp  2631 HgNetherlands',1),('00:16:A8','Cwt Co., Ltd.','Cwt Co., Ltd.10f No. 74 Sec. 1 Chung-hua Rd.Taipei  108Taiwan, Republic Of China',1),('00:16:A9','2ei','2eiRua Dos Rubis, 77 - AssumpcaoAguas De Lindoia Sao Paulo 13940-000Brazil',1),('00:16:AA','Kei Communication Technology Inc.','Kei Communication Technology Inc.8-ban ChuouKobe Hyogo 650-0024Japan',1),('00:16:AB','Pbi-dansensor A/s','Pbi-dansensor A/sRoennedevej 18Ringsted  Dk-4100Denmark',1),('00:16:AC','Toho Technology Corp.','Toho Technology Corp.Higashi 5-1OrizushimomachiInazawa-city Aichi 492-8501Japan',1),('00:16:AD','Bt-links Company Limited','Bt-links Company LimitedRm 802, Nan Fung Centre, 264-298 Castle Peak RdTsuen WanHong Kong',1),('00:16:AE','Inventel','Inventel35 Rue TournefortParis  75005France',1),('00:16:AF','Shenzhen Union Networks Equipment Co.,ltd.','Shenzhen Union Networks Equipment Co.,ltd.Yihai Square East Building 2307, Chuangye Road, Nanshan DistrictShenzhen Guangdong 518054China',1),('00:16:B0','Vk Corporation','Vk CorporationVk B/d, 548-6, Anyang 8dong, Manan-guAnyang Kyounggi 430-8903Korea, Republic Of',1),('00:16:B1','Kbs','Kbs88 Rue Pierre SmardBp 55Moissy Cedex Ile De France 77552France',1),('00:16:B2','Drivecam Inc','Drivecam Inc3954 Murphy Canyon RoadSuite D205San Diego Ca 92123United States',1),('00:16:B3','Photonicbridges (china) Co., Ltd.','Photonicbridges (china) Co., Ltd.No. 900, Yishan Road,Shanghai  200233China',1),('00:16:B4','Private','',1),('00:16:B5','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:16:B6','Cisco-linksys','Cisco-linksys121 TheoryIrvine Ca 92612United States',1),('00:16:B7','Seoul Commtech','Seoul Commtech448-11, Seongnae 3dong. Gangdong Gu,Seoul  134033Korea, Republic Of',1),('00:16:B8','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:16:B9','Procurve Networking','Procurve Networking8000 Foothills BlvdMs 5662Roseville Ca 95747United States',1),('00:16:BA','Weathernews Inc.','Weathernews Inc.Nakase 1-3 MtgChiba  262-0032Japan',1),('00:16:BB','Law-chain Computer Technology Co Ltd','Law-chain Computer Technology Co Ltd7f-2, 286-4, Hsin Ya Road, Chien Chen DistrictKaohsiung  80673Taiwan, Republic Of China',1),('00:16:BC','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:16:BD','Ati Industrial Automation','Ati Industrial Automation1031 Goodworth DriveApex North Carolina 27539-3869United States',1),('00:16:BE','Infranet, Inc.','Infranet, Inc.8th Floor, Cowell B/d, 66-1Banpo-dong, Seocho-guSeoul  137-040Korea, Republic Of',1),('00:16:BF','Palodex Group Oy','Palodex Group OyP.o. Box 64Nahkelantie 160Tuusula  04301Finland',1),('00:16:C0','Semtech Corporation','Semtech Corporation200 Flynn RdCamarillo California 93012United States',1),('00:16:C1','Eleksen Ltd','Eleksen LtdPinewood StudiosIver HeathIver Bucks Sl0 0nhUnited Kingdom',1),('00:16:C2','Avtec Systems Inc','Avtec Systems Inc14432 Albemarle Point PlaceChantilly Virginia 20151United States',1),('00:16:C3','Ba Systems Inc','Ba Systems Inc6895 Via Del OroSan Jose Ca 95119United States',1),('00:16:C4','Sirf Technology, Inc.','Sirf Technology, Inc.217 Devcon Dr.San Jose Ca 95112United States',1),('00:16:C5','Shenzhen Xing Feng Industry Co.,ltd','Shenzhen Xing Feng Industry Co.,ltdFloor 1 - 4, Block 25, Hongtian Jinyuan Industrial,Hongtian Road Huangpu, Shajin, Baoan,Shenzhen Guangdong 86China',1),('00:16:C6','North Atlantic Industries','North Atlantic Industries170 Wilbur PlaceBohemia Ny 11716United States',1),('00:16:C7','Cisco Systems','Cisco Systems80 West Tasman Dr.San Jose Ca 95134United States',1),('00:16:C8','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:16:C9','Nat Seattle, Inc.','Nat Seattle, Inc.22125 17th Ave SeBothell Wa 98021United States',1),('00:16:CA','Nortel','Nortel8200 Dixie Road, Suite 100Brampton Ontario L6t 5p6Canada',1),('00:16:CB','Apple Computer','Apple Computer1 Infinite Loop Ms:35gpoCupertino Ca 95014United States',1),('00:16:CC','Xcute Mobile Corp.','Xcute Mobile Corp.3f. No.25, Ally15, Lane 120, Sec.1, Neihu Rd.Taipei  114Taiwan, Republic Of China',1),('00:16:CD','Hiji High-tech Co., Ltd.','Hiji High-tech Co., Ltd.Ohga 8133HijiHayami Oita 879-1504Japan',1),('00:16:CE','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd. Tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:16:CF','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd. Tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:16:D0','Atech Elektronika D.o.o.','Atech Elektronika D.o.o.Bac Pri Materiji 30Materija Si 6242Slovenia',1),('00:16:D1','Zat A.s.','Zat A.s.K Podlesi 541Pribram Vi  26180Czech Republic',1),('00:16:D2','Caspian','Caspian170 Baytech DriveSan Jose Ca 95134United States',1),('00:16:D3','Wistron Corporation','Wistron Corporation21f, 88, Sec.1, Hsin Tai Wu Rd., Hsichih,Taipei Hsien  221Taiwan, Republic Of China',1),('00:16:D4','Compal Communications, Inc.','Compal Communications, Inc.7th, Fl, No. 319, Sec. 4, Pa-teh Rd.Taipei  886Taiwan, Republic Of China',1),('00:16:D5','Synccom Co., Ltd','Synccom Co., Ltd#306 Myungi E-space  218-20Anyang7-dong Manan-guAnyang-si Kyungki-do 430-817Korea, Republic Of',1),('00:16:D6','Tda Tech Pty Ltd','Tda Tech Pty Ltd210 / 54 Currie StreetAdelaide South Australia 5000Australia',1),('00:16:D7','Sunways Ag','Sunways AgMacairestr.3-5Konstanz Baden Wrttemberg 78467Germany',1),('00:16:D8','Senea Ab','Senea AbFretagsallen 12kersberga  18484Sweden',1),('00:16:D9','Ningbo Bird Co.,ltd.','Ningbo Bird Co.,ltd.No.999 Dacheng East RoadFenghua Zhejiang 315500China',1),('00:16:DA','Futronic Technology Co. Ltd.','Futronic Technology Co. Ltd.Room 1016a, 10/f., Profit Ind. Bldg.,1-15 Kwai Fung Crescent,Kwai Chung  00000Hong Kong',1),('00:16:DB','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1, Imsoo-dongGumi-city Gyeong-buk 730-350Korea, Republic Of',1),('00:16:DC','Archos','Archos12 Rue AmpereIgny Essonnes 91430France',1),('00:16:DD','Gigabeam Corporation','Gigabeam Corporation407 Springpark PlaceSte 900Herndon Va 20170United States',1),('00:16:DE','Fast Inc','Fast Inc905 Honeyspot RdStratford Ct 06615United States',1),('00:16:DF','Lundinova Ab','Lundinova AbDalbyvagen 1Lund Skaane Se-224 60Sweden',1),('00:16:E0','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:16:E1','Siliconstor, Inc.','Siliconstor, Inc.48430 Lakeview Blvd.Fremont Ca 94538United States',1),('00:16:E2','American Fibertek, Inc.','American Fibertek, Inc.120 Belmont DriveSomerset New Jersey 08873-1204United States',1),('00:16:E3','Askey Computer Corp.','Askey Computer Corp.10f, No.119, Chienkang Rd.,Chung-ho, Taipei  235Taiwan, Republic Of China',1),('00:16:E4','Vanguard Security Engineering Corp.','Vanguard Security Engineering Corp.3, Lane 32, Kso Ching Rd.Yangmei Taoyuan 326Taiwan, Republic Of China',1),('00:16:E5','Fordley Development Limited','Fordley Development LimitedRoom 706, 7th Floor, Yu Sung Boon Building, 107-111 Des Voeux Road, Central,Hong Kong',1),('00:16:E6','Giga-byte Technology Co.,ltd.','Giga-byte Technology Co.,ltd.Pin-jen City, Taoyuan324Taiwan, Republic Of China',1),('00:16:E7','Dynamix Promotions Limited','Dynamix Promotions Limited788-790, Finchley RoadLondon  Nw11 7tjUnited Kingdom',1),('00:16:E8','Sigma Designs, Inc.','Sigma Designs, Inc.1778 Mccarthy Blvd.Milpitas Ca 95035United States',1),('00:16:E9','Tiba Medical Inc','Tiba Medical Inc5024 Lakewood DrivePlano Tx 75093United States',1),('00:16:EA','Intel Corporation','Intel CorporationLot 8, Jalan Hi-tech Park 2/3Kulim Hi-tech Park Kulim 09000Malaysia',1),('00:16:EB','Intel Corporation','Intel CorporationLot 8, Jalan Hi-tech 2/3Kulim Hi-tech Park Kedah 09000Malaysia',1),('00:16:EC','Elitegroup Computer Systems Co., Ltd.','Elitegroup Computer Systems Co., Ltd.No. 22, Alley 38, Lane 91, Sec. 1, Nei Hu Road,Taipei  11441Taiwan, Republic Of China',1),('00:16:ED','Integrian, Inc.','Integrian, Inc.511 Davis DriveSuite 300Morrisville Nc 27560United States',1),('00:16:EE','Royaldigital Inc.','Royaldigital Inc.8f., No.308, Sec.1, Neihu Rd.Neihu District,Taipei City  114Taiwan, Republic Of China',1),('00:16:EF','Koko Fitness, Inc.','Koko Fitness, Inc.136 Longwater DriveNorwell Ma 02061United States',1),('00:16:F0','Dell','Dell909 Hermosa CtSunnyvale Ca 94085United States',1),('00:16:F1','Omnisense, Llc','Omnisense, Llc2 Robin DriveLadys Island Sc 29907United States',1),('00:16:F2','Dmobile System Co., Ltd.','Dmobile System Co., Ltd.2f, No.13-20, Sec.6, Mincyuan E.rd,Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:16:F3','Cast Information Co., Ltd','Cast Information Co., Ltd5f Msa Bldg. 891-43 Dacchi-dong,Gangnam-guSeoul  135-280Korea, Republic Of',1),('00:16:F4','Eidicom Co., Ltd.','Eidicom Co., Ltd.Polychem B/d 4th Floor, 900-1Kwanyang-dong, Dongan-kuAnyang-si Kyeonggi-do 431-060Korea, Republic Of',1),('00:16:F5','Dalian Golden Hualu Digital Technology Co.,ltd','Dalian Golden Hualu Digital Technology Co.,ltdNo.1 Hua Road,qixianlingDalian Liaoning 116023China',1),('00:16:F6','Video Products Group','Video Products Group1600 Emerson AvenueOxnard California 93033United States',1),('00:16:F7','L-3 Communications, Electrodynamics, Inc.','L-3 Communications, Electrodynamics, Inc.1200 Hicks Rd.Rolling Meadows Il 60008United States',1),('00:16:F8','Aviqtech Technology Co., Ltd.','Aviqtech Technology Co., Ltd.6f 12, Li-hsin Road, SbipHsin-chu  300Taiwan, Republic Of China',1),('00:16:F9','Cetrta Pot, D.o.o., Kranj','Cetrta Pot, D.o.o., KranjPlanina 3Kranj Si 4000Slovenia',1),('00:16:FA','Eci Telecom Ltd.','Eci Telecom Ltd.30 Hasivim St.Petah Tikva  49133Israel',1),('00:16:FB','Shenzhen Mtc Co.,ltd.','Shenzhen Mtc Co.,ltd.5/f Benyuan Bldg,6015 Shennan RoadShenzhen Guangdong 518040China',1),('00:16:FC','Tohken Co.,ltd.','Tohken Co.,ltd.2-16-20 TamagawaChofu Tokyo 182-0025Japan',1),('00:16:FD','Jaty Electronics','Jaty ElectronicsJaty Bldg 10f, 1659-5 Bongchun11-dongKwanak-kuSeoul  151-832Korea, Republic Of',1),('00:16:FE','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, Okinouchi,Soma-city, Fukushima-pref., 976-8501Japan',1),('00:16:FF','Wamin Optocomm Mfg Corp','Wamin Optocomm Mfg CorpNo. 239 Qiaohe RoadZhonghe City Taipei County 235Taiwan, Republic Of China',1),('00:17:00','Motorola Mdb','Motorola Mdb600 N. Us Hwy 45Libertyville Il 60048United States',1),('00:17:01','Kde, Inc.','Kde, Inc.Kde Town, 42-7, Mangwol-dongHanam Gyeonggi-do 465-150Korea, Republic Of',1),('00:17:02','Osung Midicom Co., Ltd','Osung Midicom Co., Ltd231-18, Dorim2-dong,Seoul, Youngdeungpo-gu 150-832Korea, Republic Of',1),('00:17:03','Mosdan Internation Co.,ltd','Mosdan Internation Co.,ltdNo.74 Cheggung Shintsuen,shanhua Jen,Tainan  741Taiwan, Republic Of China',1),('00:17:04','Shinco Electronics Group Co.,ltd','Shinco Electronics Group Co.,ltdNo.5 Waihuan RoadChangzhou Jiangsu 213022China',1),('00:17:05','Methode Electronics','Methode Electronics7401 W. WilsonChicago Il 60706United States',1),('00:17:06','Techfaith Wireless Communication Technology Limited.','Techfaith Wireless Communication Technology Limited.2/f M8 West No.1 Jiu Xian Qiao Dong Road,Chao Yang DistrictBeijing  100016China',1),('00:17:07','Ingrid, Inc','Ingrid, Inc920 Cassatt RdSuite 220Berwyn Pa 19312United States',1),('00:17:08','Hewlett Packard','Hewlett Packard20555 State Highway 249Houston Tx 77070United States',1),('00:17:09','Exalt Communications','Exalt Communications580 Division StreetCampbell Ca 95008United States',1),('00:17:0A','Inew Digital Company','Inew Digital CompanySupply Bureau 3th Floor Kt&g 203-1,Pyong Chon-dong, DaedeogDaejeon  306-712Korea, Republic Of',1),('00:17:0B','Contela, Inc.','Contela, Inc.6-8 Soonae-dong, Bundang-gu,5th Floor, Korea First Bldg.,Sungnam Kyunggi-do 463-825Korea, Republic Of',1),('00:17:0C','Geosentric Oyj','Geosentric OyjP.o.box 84Fi-24101 SaloFinland',1),('00:17:0D','Dust Networks Inc.','Dust Networks Inc.30695 Huntwood Ave.Hayward Ca. 94544United States',1),('00:17:0E','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:0F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:10','Casa Systems Inc.','Casa Systems Inc.10, New England Business Center Dr.Suite 110Andover Ma 01810United States',1),('00:17:11','Ge Healthcare Bio-sciences Ab','Ge Healthcare Bio-sciences AbBjrkgatan 30Uppsala Se 75184Sweden',1),('00:17:12','Isco International','Isco International1001 Cambridge DriveElk Grove Village Il 60007United States',1),('00:17:13','Tiger Netcom','Tiger NetcomJ-15 Mudan Cun, Yijing Huayuan,Aiguo Road, Luohu District,Shenzhen Guangdong 518003China',1),('00:17:14','Br Controls Nederland Bv','Br Controls Nederland BvBranderweg 1Zwolle Overijssel 8042 PdNetherlands',1),('00:17:15','Qstik','QstikCartel Business EstateEdinburgh WayHarlow Essex Cm20 2ttUnited Kingdom',1),('00:17:16','Qno Technology Inc.','Qno Technology Inc.6f-2, No.25, Puding RoadHsinchu Taiwan 300Taiwan, Republic Of China',1),('00:17:17','Leica Geosystems Ag','Leica Geosystems AgHeinrich Wild StrasseHeerbrugg St. Gallen Ch-9435Switzerland',1),('00:17:18','Vansco Electronics Oy','Vansco Electronics OyTiilenlyojankatu 5Forssa  30101Finland',1),('00:17:19','Audiocodes Usa, Inc','Audiocodes Usa, Inc27 Worlds Fair DriveSomerset Nj 08873United States',1),('00:17:1A','Winegard Company','Winegard Company3000 Kirkwood StreetBurlington Ia 52601United States',1),('00:17:1B','Innovation Lab Corp.','Innovation Lab Corp.12fl., No. 285, Sec. 2, Tiding Blvd.,Taipei  11493Taiwan, Republic Of China',1),('00:17:1C','Nt Microsystems, Inc.','Nt Microsystems, Inc.1-5-3-2f TamagawadaiSetagaya Tokyo 158-0096Japan',1),('00:17:1D','Digit','DigitVia Pasteur , 1/3S.pietro Mosezzo Novara 28060Italy',1),('00:17:1E','Theo Benning Gmbh & Co. Kg','Theo Benning Gmbh & Co. KgMuensterstrae 135-137Bocholt Nrw 46397Germany',1),('00:17:1F','Imv Corporation','Imv Corporation2-6-10 TakejimaNishiyodogawa-kuOsaka  555-0011Japan',1),('00:17:20','Image Sensing Systems, Inc.','Image Sensing Systems, Inc.1600 University Ave. W.Suite 500St. Paul Mn 55104United States',1),('00:17:21','Fitre S.p.a.','Fitre S.p.a.Via Valsolda, 15Milan Milano 20142Italy',1),('00:17:22','Hanazeder Electronic Gmbh','Hanazeder Electronic GmbhJ.m. Dimmelstr 10Ried I. I. Obersterreich 4910Austria',1),('00:17:23','Summit Data Communications','Summit Data Communications526 South Main StreetSuite 805Akron Ohio 44311United States',1),('00:17:24','Studer Professional Audio Gmbh','Studer Professional Audio GmbhAlthardstrasse 30Regensdorf Zrich Ch-8105Switzerland',1),('00:17:25','Liquid Computing','Liquid Computing340 Terry Fox DriveSuite 300Ottawa Ontario K2k 3a2Canada',1),('00:17:26','M2c Electronic Technology Ltd.','M2c Electronic Technology Ltd.2403, 24/f, Nanyang Plaza57 Hung To RoadKwuntong Hong Kong 999 999China',1),('00:17:27','Thermo Ramsey Italia S.r.l.','Thermo Ramsey Italia S.r.l.Strada Rivoltana Km 6/7Rodano Milano 20090Italy',1),('00:17:28','Selex Communications','Selex CommunicationsVia Pieragostini 80Genova  16151Italy',1),('00:17:29','Ubicod Co.ltd','Ubicod Co.ltd7f Chun-gin Bldg, 53-5 Wonhyo-roYongsan-guSeoul  140-719Korea, Republic Of',1),('00:17:2A','Proware Technology Corp.','Proware Technology Corp.6fl., No. 4, Alley 1, Lane 235, Paochao Rd.Hsin Tien City Taipei Hsien 231Taiwan, Republic Of China',1),('00:17:2B','Global Technologies Inc.','Global Technologies Inc.4/f Kicox Bldg.,188-5,guro-dong,guro-gu,Seoul 152-848Korea, Republic Of',1),('00:17:2C','Taejin Infotech','Taejin Infotech6f Woolim E-biz Center, 170-5Guro-dong, Guro-gu,Seoul  152-769Korea, Republic Of',1),('00:17:2D','Axcen Photonics Corporation','Axcen Photonics Corporation6f, No. 119, Baujung Rd.,Shindian City, Taipei  231Taiwan, Republic Of China',1),('00:17:2E','Fxc Inc.','Fxc Inc.10-16 6f, Nihonbashi Tomizawa-chou, Chuo-kuTokyo  103-0006Japan',1),('00:17:2F','Neulion Incorporated','Neulion Incorporated1600 Old Country RoadPlainview Ny 11803United States',1),('00:17:30','Automation Electronics','Automation Electronics111 Big Horn Rd.Casper Wy 82601United States',1),('00:17:31','Asustek Computer Inc.','Asustek Computer Inc.No.5 Shing Yeh Street,kwei Shan Hsiang,taoyuanTaipei  333Taiwan, Republic Of China',1),('00:17:32','Science-technical Center rissa','Science-technical Center rissaSt. Abramtsevskaja, H.9Moscow  128572Russian Federation',1),('00:17:33','Neuf Cegetel','Neuf Cegetel40-42 Quai Du Point Du JourBoulogne Billancourt Hauts De Seine 92659France',1),('00:17:34','Lgc Wireless Inc.','Lgc Wireless Inc.2540 Junction Ave.San Jose California 95134-1902United States',1),('00:17:35','Private','',1),('00:17:36','Iitron Inc.','Iitron Inc.88 Mercy St.Mountain View Ca 94041United States',1),('00:17:37','Industrie Dial Face S.p.a.','Industrie Dial Face S.p.a.Via Canzo, 4Peschiera Borromeo Milano 20068Italy',1),('00:17:38','International Business Machines','International Business Machines1 Azrieli CenterTel Aviv  67021Israel',1),('00:17:39','Bright Headphone Electronics Company','Bright Headphone Electronics Company8f, 109, Li De StreetChung Ho City Taipei County 235Taiwan, Republic Of China',1),('00:17:3A','Reach Systems Inc.','Reach Systems Inc.1330 BroadwaySuite 1201Oakland Ca 94612United States',1),('00:17:3B','Arched Rock Corporation','Arched Rock Corporation657 Mission St. Ste 600San Francisco Ca 94105-4120United States',1),('00:17:3C','Extreme Engineering Solutions','Extreme Engineering Solutions3225 Deming WaySuite 120Middleton Wi 53562United States',1),('00:17:3D','Neology','Neology13000 Gregg Street Suite APoway Ca 92064United States',1),('00:17:3E','Leucotronequipamentos Ltda.','Leucotronequipamentos Ltda.Rua Jorge Dionisio Barbosa, 312Santa Rita Do Sapucai Minas Gerais 37.540-000Brazil',1),('00:17:3F','Belkin Corporation','Belkin Corporation501 W. Walnut StreetCompton Ca 90220-5221United States',1),('00:17:40','Technologies Labtronix','Technologies Labtronix2125, Rue Letendre Suite 420Drummondville Qubec J2c 7g1Canada',1),('00:17:41','Defidev','Defidev27 Avenue De VerdunVanves  92170France',1),('00:17:42','Fujitsu Limited','Fujitsu LimitedMusashi-kosugi Tower Place Bldg.,403Kosugi-cho 1-chome,nakahara-kuKawasaki Kanagawa 211-8588Japan',1),('00:17:43','Deck Srl','Deck SrlVia Fabio Filzi 2Milan  20124Italy',1),('00:17:44','Araneo Ltd.','Araneo Ltd.103 Medinat HayehudimHerzliya  46733Israel',1),('00:17:45','Innotz Co., Ltd','Innotz Co., Ltd14f, Prime Center 546-4 Guui-dong Kwanggin-guSeoul Seoul 143-200Korea, Republic Of',1),('00:17:46','Freedom9 Inc.','Freedom9 Inc.4140b Sladeview Cre.,Unit 4,Mississauga, Ontario L5l6a1Canada',1),('00:17:47','Trimble','Trimble345 Sw Avery AveCorvallis Or 97333United States',1),('00:17:48','Neokoros Brasil Ltda','Neokoros Brasil LtdaRua 86, Numero 501, Setor SulGoiania Goias 74083-330Brazil',1),('00:17:49','Hyundae Yong-o-sa Co.,ltd','Hyundae Yong-o-sa Co.,ltd448-10, Hyuckjae B/d Seongnae, Kangdong-guSeoul  134-847Korea, Republic Of',1),('00:17:4A','Socomec','SocomecRue De WesthouseBenfeld Cedex  67235France',1),('00:17:4B','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:17:4C','Millipore','Millipore1, Rue Jacques MonodRond-point Des SangliersGuyancourt  78280France',1),('00:17:4D','Dynamic Network Factory, Inc.','Dynamic Network Factory, Inc.26250 Eden Landing Rd.Hayward Ca 94545United States',1),('00:17:4E','Parama-tech Co.,ltd.','Parama-tech Co.,ltd.2-19-8, Sharyo, Higashi-kuFukuoka  812-0068Japan',1),('00:17:4F','Icatch Inc.','Icatch Inc.10f-2, No. 109, Sec. 6, Mincyuan E. Rd.,Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:17:50','Gsi Group, Microe Systems','Gsi Group, Microe Systems8 Erie DriveNatick Ma 01760United States',1),('00:17:51','Online Corporation','Online Corporation22f-3, No. 398, Huan Pei Road,Chung Li Taoyuan 320Taiwan, Republic Of China',1),('00:17:52','Dags, Inc','Dags, IncC-510, Woolim Lions Valley, 371-28, Gasan Dong, Geumcheon KuSeoul  153-786Korea, Republic Of',1),('00:17:53','Nfore Technology Inc.','Nfore Technology Inc.10f, 41 Dong Xing Rd,Taipei Taipei 110Taiwan, Republic Of China',1),('00:17:54','Arkino Corporation., Ltd','Arkino Corporation., LtdNo.213, Industrial South Rd.,Ping Chen Industrial Zone,Ping Chen Tao Yuan HsienTaiwan, Republic Of China',1),('00:17:55','Ge Security','Ge Security12345 Sw Leveton DriveTualatin Or 97062United States',1),('00:17:56','Vinci Labs Oy','Vinci Labs OyFinlaysoninkuja 21 ATampere Lnsi-suomi 33210Finland',1),('00:17:57','Rix Technology Limited','Rix Technology Limited17 Dai Wang StreetTai Po Industrial EstateTai Po New TerritoriesHong Kong',1),('00:17:58','Thruvision Ltd','Thruvision LtdCentral 127, No.18Milton ParkAbingdon Oxfordshire Ox14 4saUnited Kingdom',1),('00:17:59','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:5A','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:5B','Acs Solutions Switzerland Ltd.','Acs Solutions Switzerland Ltd.Frankenstrasse 70Bern- Buempliz  3018Switzerland',1),('00:17:5C','Sharp Corporation','Sharp Corporation22-22, Nagaike-cho,Abeno-kuOsaka  545-8522Japan',1),('00:17:5D','Dongseo System.','Dongseo System.974-21 Mansu-dong Namdong-guIncheon In-cheon 405-865Korea, Republic Of',1),('00:17:5E','Zed-3','Zed-3501 Valley WayMilpitas Ca 95035United States',1),('00:17:5F','Xenolink Communications Co., Ltd.','Xenolink Communications Co., Ltd.2nd Fl., Jungyou B/d 797-22Yeoksam-dong Gangnam-guSeoul  135-930Korea, Republic Of',1),('00:17:60','Naito Densei Machida Mfg.co.,ltd','Naito Densei Machida Mfg.co.,ltd2-17-28 FuchinobeSagamihara Kanagawa 229-0006Japan',1),('00:17:61','Zksoftware Inc.','Zksoftware Inc.Xinweizai, Bantian, Longgang District,shenzhen China 518129China',1),('00:17:62','Solar Technology, Inc.','Solar Technology, Inc.7620 Cetronia RoadAllentown Pa 18106United States',1),('00:17:63','Essentia S.p.a.','Essentia S.p.a.Via G.b. Vico, 29Cella (re) Reggio Emilia 42040Italy',1),('00:17:64','Atmedia Gmbh','Atmedia GmbhStuhlsatzenhausweg 69Saarbruecken Saarland 66123Germany',1),('00:17:65','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:17:66','Accense Technology, Inc.','Accense Technology, Inc.35 TansumachiShinjyuku-ku Tokyo 1620833Japan',1),('00:17:67','Earforce As','Earforce AsP.o.box 4Bryne  4349Norway',1),('00:17:68','Zinwave Ltd','Zinwave LtdZinwave Ltd, Harston MillHarstonCambridge Cambridgeshire Cb2 5ggUnited Kingdom',1),('00:17:69','Cymphonix Corp','Cymphonix Corp8871 S. Sandy Parkway, Suite 150Sandy Ut 84070United States',1),('00:17:6A','Avago Technologies','Avago Technologies350 West Trimble RdSan Jose Ca 95131United States',1),('00:17:6B','Kiyon, Inc.','Kiyon, Inc.9381 Judicial DriveSuite 160San Diego Ca 92121United States',1),('00:17:6C','Pivot3, Inc.','Pivot3, Inc.6605 Cypresswood Drive, Ste 350Spring Tx 77379-7741United States',1),('00:17:6D','Core Corporation','Core Corporation1-22-3, Sangenjaya,Setagaya-ku Tokyo-to 154-8552Japan',1),('00:17:6E','Ducati Sistemi','Ducati SistemiVia Marco Emilio Lepido, 182Bologna  40132Italy',1),('00:17:6F','Pax Computer Technology(shenzhen) Ltd.','Pax Computer Technology(shenzhen) Ltd.4/f, No.3 Building, Software Park, Second Central Science-tech Road, High-techIndustrial ParkShenzhen Guangdong 518057China',1),('00:17:70','Arti Industrial Electronics Ltd.','Arti Industrial Electronics Ltd.Ger-san Sitesi, 657. SokakNo: 80, ErgaziAnkara Tr 06370Turkey',1),('00:17:71','Apd Communications Ltd','Apd Communications LtdNewlands CentreInglemire LaneHull East Yorkshire Hu6 7tqUnited Kingdom',1),('00:17:72','Astro Strobel Kommunikationssysteme Gmbh','Astro Strobel Kommunikationssysteme GmbhOlefant 1-3Bergisch Gladbach Nrw 51427Germany',1),('00:17:73','Laketune Technologies Co. Ltd','Laketune Technologies Co. LtdNo. 38 Zijinghua Rd. Westlake DistrictGudang Industrial Zone Building 11, 5fHangzhou Zhejiang 310013China',1),('00:17:74','Elesta Gmbh','Elesta GmbhGottlieb Daimler Strasse 1Konstanz  78467Germany',1),('00:17:75','Tte Germany Gmbh','Tte Germany GmbhHermann-schwer-str. 3Villingen-schwenningen Baden-wrttemberg 78048Germany',1),('00:17:76','Meso Scale Diagnostics, Llc','Meso Scale Diagnostics, Llc9238 Gaither Rd.Gaithersburg Md 20877United States',1),('00:17:77','Obsidian Research Corporation','Obsidian Research CorporationEdmonton Research ParkSuite 106   9650-20 AveEdmonton Alberta T6n1g1Canada',1),('00:17:78','Central Music Co.','Central Music Co.0711-0712 Tower D, Soho New TownNo. 88 Jianguo Road, Chaoyang DistrictBeijing  100022China',1),('00:17:79','Quicktel','QuicktelCornishe El-nile, MaasaraCairo  11743Egypt',1),('00:17:7A','Assa Abloy Ab','Assa Abloy AbTheres Svenssons Gata 1541755 GoteborgGoteborg  41755Sweden',1),('00:17:7B','Azalea Networks Inc','Azalea Networks Inc673 S Milpitas BlvdSuite 105Milpitas Ca 95035United States',1),('00:17:7C','D-link India Ltd','D-link India LtdL-7, Verna Electronic CityVernaNagoa Goa 403 722India',1),('00:17:7D','Idt International Limited','Idt International LimitedBlock C, 9/f, Kaiser Estate, Phase I41 Man Yue Street, Hunghom, KowloonHong Kong',1),('00:17:7E','Meshcom Technologies Inc.','Meshcom Technologies Inc.Meritullinkatu 1 CHelsinki  00170Finland',1),('00:17:7F','Worldsmart Retech','Worldsmart Retech23 Hi-tech CourtEight Mile Plains Qld 4113Australia',1),('00:17:80','Applera Holding B.v. Singapore Operations','Applera Holding B.v. Singapore OperationsBlk 33, Marsiling Industrial Estate Road 3,#05-03739256Singapore',1),('00:17:81','Greystone Data System, Inc.','Greystone Data System, Inc.40800 Encycopedia CircleFremont Ca 94538United States',1),('00:17:82','Lobenn Inc.','Lobenn Inc.150 Katimavik RoadSuite 202Ottawa Ontario K2l 2n2Canada',1),('00:17:83','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:84','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:17:85','Sparr Electronics Ltd','Sparr Electronics LtdSparr Electronics Ltd43 Hmt Main Road MathikereBangalore Karnataka 560054India',1),('00:17:86','Wisembed','Wisembed808, Hansin It Tower, 235 Guro3-dong, Guro-guSeoul  152-768Korea, Republic Of',1),('00:17:87','Brother, Brother & Sons Aps','Brother, Brother & Sons ApsVed Amagerbanen 9Copenhagen S  Dk-2300Denmark',1),('00:17:88','Philips Lighting Bv','Philips Lighting BvMathildelaan 1Eindhoven Noord Brabant 5611 BdNetherlands',1),('00:17:89','Zenitron Corporation','Zenitron CorporationNo. 8, Lane 250, Sinhu 2nd Rd., Neihu District,Taipei  11494Taiwan, Republic Of China',1),('00:17:8A','Darts Technologies Corp.','Darts Technologies Corp.2f,no.119,chien Kang Rd.,Chung-ho Taipei Hsien 235Taiwan, Republic Of China',1),('00:17:8B','Teledyne Technologies Incorporated','Teledyne Technologies Incorporated12333 West Olympic BlvdLos Angeles Ca 90064United States',1),('00:17:8C','Independent Witness, Inc','Independent Witness, Inc1515 West 2200 SouthSuite ESalt Lake City Ut 84119United States',1),('00:17:8D','Checkpoint Systems, Inc.','Checkpoint Systems, Inc.101 Wolf DriveThorofare Nj 08086United States',1),('00:17:8E','Gunnebo Cash Automation Ab','Gunnebo Cash Automation AbFabriksgatan 10Gteborg  402 27Sweden',1),('00:17:8F','Ningbo Yidong Electronic Co.,ltd.','Ningbo Yidong Electronic Co.,ltd.No.65 Siming East RdYuyao City, Zhejiang Province Zhejiang Province China P.c 315400China',1),('00:17:90','Hyundai Digitech Co, Ltd.','Hyundai Digitech Co, Ltd.13th Fl, Choung-jin Bldg, 53-5Wonhyo-ro 3ga, Yongsan-guSeoul  140-719Korea, Republic Of',1),('00:17:91','Lintech Gmbh','Lintech GmbhFriedrich-engels-str. 35Berlin  13156Germany',1),('00:17:92','Falcom Wireless Comunications Gmbh','Falcom Wireless Comunications GmbhGewerbering 6Langewiesen Thuringia 98704Germany',1),('00:17:93','Tigi Corporation','Tigi Corporation2070 Chain Bridge RoadSuite G-100Vienna Va 22182United States',1),('00:17:94','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:95','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:96','Rittmeyer Ag','Rittmeyer AgInwilerriedstrasse 57Postfach 464Baar Zg Ch-6341Switzerland',1),('00:17:97','Telsy Elettronica S.p.a.','Telsy Elettronica S.p.a.Corso Svizzera 185Torino  10149Italy',1),('00:17:98','Azonic Technology Co., Ltd','Azonic Technology Co., Ltd15f-3, No. 163, Sec., 1 Keelung Rd.Taipei  110Taiwan, Republic Of China',1),('00:17:99','Smartire Systems Inc.','Smartire Systems Inc.Suite 15013151 Vanier PlaceRichmond Bc V6v 2j1Canada',1),('00:17:9A','D-link Corporation','D-link CorporationNo. 289, Sinhu 3rd Rd., Neihu District,Taipei  114Taiwan, Republic Of China',1),('00:17:9B','Chant Sincere Co., Ltd.','Chant Sincere Co., Ltd.7f-2,no.188,sec 3,ta Tung Rood,Hsi Chih City Taipei Hsien 221Taiwan, Republic Of China',1),('00:17:9C','Deprag Schulz Gmbh U. Co.','Deprag Schulz Gmbh U. Co.Kurfrstenring 12.18Amberg Bayern 92224Germany',1),('00:17:9D','Kelman Limited','Kelman LimitedRathdown CloseLissue East Industrial EstateLisburn Co. Antrim Bt28 2rbUnited Kingdom',1),('00:17:9E','Sirit Inc','Sirit Inc2525 Meridian ParkwaySuite 60Durham Nc 27713United States',1),('00:17:9F','Apricorn','Apricorn12191 Kirkham RdPoway California 92064United States',1),('00:17:A0','Robotech Srl','Robotech SrlVia Mazzini 82Sarzana (sp)  I-19038Italy',1),('00:17:A1','3soft Inc.','3soft Inc.Shinyoung Bldg 4f, Chungdam-dong, Gangnam-guSeoul  135-100Korea, Republic Of',1),('00:17:A2','Camrivox Ltd.','Camrivox Ltd.The Jeffreys BuildingCowley RoadCambridge Cambridgeshire Cb4 0wsUnited Kingdom',1),('00:17:A3','Mix S.r.l.','Mix S.r.l.Via Caldera, 21Milan  I-20153Italy',1),('00:17:A4','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:17:A5','Trendchip Technologies Corp.','Trendchip Technologies Corp.Suite 215, Bldg 53. 195-61 Sec.4, Chung Hsing Rd,Chutung Hsinchu 310Taiwan, Republic Of China',1),('00:17:A6','Yosin Electronics Co., Ltd.','Yosin Electronics Co., Ltd.6f-2, No.17, Lan 174, Shin-ming RoadTaipei  114Taiwan, Republic Of China',1),('00:17:A7','Mobile Computing Promotion Consortium','Mobile Computing Promotion Consortium3-5-12 Shiba-koenMinato-kuTokyo  105-0011Japan',1),('00:17:A8','Edm Corporation','Edm Corporation3-5-2 ItabashiItabashi-ku Tokyo 173-0004Japan',1),('00:17:A9','Sentivision','SentivisionMarynarska 19aWarsaw Mazowieckie 02-674Poland',1),('00:17:AA','Elab-experience Inc.','Elab-experience Inc.104 AnotsupiaAnotsudai 4-6-1Tsu-shi Mie Prefecture 514-0131Japan',1),('00:17:AB','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:17:AC','Oneil Product Development Inc.','Oneil Product Development Inc.8 MasonIrvine Ca 92618United States',1),('00:17:AD','Acenet Corporation','Acenet Corporation7f-4, No.146, Wen-shin RoadGueishan TaoyuanTaiwan, Republic Of China',1),('00:17:AE','Gai-tronics','Gai-tronicsBrunel DriveStretton ParkBurton Upon Trent Staffordshire De13 0bzUnited Kingdom',1),('00:17:AF','Enermet','EnermetSalvesenintieJysk  Fin-40420Finland',1),('00:17:B0','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:17:B1','Acist Medical Systems, Inc.','Acist Medical Systems, Inc.7450 Flying Cloud DriveSuite 150Eden Prairie Mn 55344United States',1),('00:17:B2','Sk Telesys','Sk Telesys4f, Kyungdong Bldg, 4-4, Sunae-dong, Pundang-guSungnam-city Kunggi-do 463-825Korea, Republic Of',1),('00:17:B3','Aftek Infosys Limited','Aftek Infosys LimitedPawan ComplexSheela Vihar ColonyPune Maharashtra 411 038India',1),('00:17:B4','Remote Security Systems, Llc','Remote Security Systems, Llc4806 Upper Brandon PlaceMarietta Georgia 30068United States',1),('00:17:B5','Peerless Systems Corporation','Peerless Systems Corporation2381 Rosecrans Avenue, Suite 400El Segundo Ca 90245United States',1),('00:17:B6','Aquantia','Aquantia700 Tasman Dr.Milpitas Ca 95035United States',1),('00:17:B7','Tonze Technology Co.','Tonze Technology Co.5f-10, No.6, Lane 180,Sec 6, Mincyuan East RoadTaipei  11490Taiwan, Republic Of China',1),('00:17:B8','Novatron Co., Ltd.','Novatron Co., Ltd.#601 Polaris Bldg., 15-3 Jeongja-dong, Bundang-guSeong Nam Gyeonggi Do 463-811Korea, Republic Of',1),('00:17:B9','Gambro Lundia Ab','Gambro Lundia AbBox 10101Lund Skne 22010Sweden',1),('00:17:BA','Sedo Co., Ltd.','Sedo Co., Ltd.302, Kt Bldg, 1annex, 35-1Yeongdeungpo-dong 8ga, Yeongdeungpo-guSeoul  150-038Korea, Republic Of',1),('00:17:BB','Syrinx Industrial Electronics','Syrinx Industrial ElectronicsDe Factorij 13Zwaag Noord Holland 1689 AkNetherlands',1),('00:17:BC','Touchtunes Music Corporation','Touchtunes Music Corporation3 Place Du Commerce4th FloorMontral Qubec H3e 1h7Canada',1),('00:17:BD','Tibetsystem','Tibetsystem6f It Castle Ii 550-1 Gasan-dongSeoul Geumcheon-gu 153-803Korea, Republic Of',1),('00:17:BE','Tratec Telecom B.v.','Tratec Telecom B.v.De Smalle Zijde 12Veenendaal  Nl0-3903 LpNetherlands',1),('00:17:BF','Coherent Research Limited','Coherent Research Limited8 Princess MewsHorace RoadKingston Upon Thames Surrey Kt1 2szUnited Kingdom',1),('00:17:C0','Puretech Systems, Inc.','Puretech Systems, Inc.2075 W Pinnacle Peak Road #120Phoenix Az 85027United States',1),('00:17:C1','Cm Precision Technology Ltd.','Cm Precision Technology Ltd.2 Fl, No. 177, Chien-e Road, Chung-ho CityTaipei Hsien  235Taiwan, Republic Of China',1),('00:17:C2','Pirelli Broadband Solutions','Pirelli Broadband SolutionsV.sarca 222Milano  20126Italy',1),('00:17:C3','Ktf Technologies Inc.','Ktf Technologies Inc.4th Fl., Central Tower, 265-3, Seohyun-dongBundnag-guSungnam-city Kyunggi-do 463-769Korea, Republic Of',1),('00:17:C4','Quanta Microsystems, Inc.','Quanta Microsystems, Inc.188 Wenhwa 2nd Rd., Kueishan HsiangTaoyuan Shien  333Taiwan, Republic Of China',1),('00:17:C5','Sonicwall','Sonicwall1143 Borregas AveSunnyvale Ca 95126United States',1),('00:17:C6','Cross Match Technologies Inc','Cross Match Technologies Inc400, Boul. Jean-lesageHall Ouest, Suite 30Qubec, Qc  G1k 8w1Canada',1),('00:17:C7','Mara Systems Consulting Ab','Mara Systems Consulting AbInstrumentvgen 45Stockholm  126 53Sweden',1),('00:17:C8','Kyocera Mita Corporation','Kyocera Mita Corporation2-14-9, TamagawadaiSetagaya-wardTokyo  158-8610Japan',1),('00:17:C9','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.416, Maetan-3dong, Yeongtong-guSuwon Geyonggi-do 443-742Korea, Republic Of',1),('00:17:CA','Qisda Corporation','Qisda Corporation157 Shan Ying Road,Gueishan Taoyuan, 333Taiwan, Republic Of China',1),('00:17:CB','Juniper Networks','Juniper Networks1194 North Mathilda AvenueSunnyvale California 94089-1206United States',1),('00:17:CC','Alcatel-lucent','Alcatel-lucent601 Data Dr.M/s 320Plano Tx 75075United States',1),('00:17:CD','Cec Wireless R&d Ltd.','Cec Wireless R&d Ltd.West M5 Building,no.1 East RoadJiuxianqiao Chao Yang DistrictBeijing  100016China',1),('00:17:CE','Mb International Telecom Labs Srl','Mb International Telecom Labs SrlVia Milano 255Baranzate Di Bollate Milano 20021Italy',1),('00:17:CF','Imca-gmbh','Imca-gmbhDorfstrasse 28bItzehoe Schleswig-holstein 25524Germany',1),('00:17:D0','Opticom Communications, Llc','Opticom Communications, Llc1050 Connecticut Avenue, NwSuite 1000Washington Dc 20036United States',1),('00:17:D1','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:17:D2','Thinlinx Pty Ltd','Thinlinx Pty Ltd31 Carwoola CrescentMooloolaba Queensland 4557Australia',1),('00:17:D3','Etymotic Research, Inc.','Etymotic Research, Inc.61 Martin LaneElk Grove Village Il 60061United States',1),('00:17:D4','Monsoon Multimedia, Inc','Monsoon Multimedia, Inc1730 South Amphlett Blvd. Suite 101San Mateo Ca 94402United States',1),('00:17:D5','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1, Imsoo-dongGumi-city Gyeong-buk 730-350Korea, Republic Of',1),('00:17:D6','Bluechips Microhouse Co.,ltd.','Bluechips Microhouse Co.,ltd.212/2 M.10 Tambol UmongAmphur MuangLamphun  51150Thailand',1),('00:17:D7','Ion Geophysical Corporation Inc.','Ion Geophysical Corporation Inc.850 DorothySuite 510Richardson Texas 75081United States',1),('00:17:D8','Magnum Semiconductor, Inc.','Magnum Semiconductor, Inc.591 Yosemite DriveMilpitas Ca 95035United States',1),('00:17:D9','Aai Corporation','Aai CorporationP.o. Box 126Hunt Valley Maryland 21030United States',1),('00:17:DA','Spans Logic','Spans Logic201 San Antonio Circle#280Mountain View Ca 94040United States',1),('00:17:DB','Canko Technologies Inc.','Canko Technologies Inc.5 Fl. Dong Sung Bldg. 17-8Yoido-dong, Yeongdeungpo-kuSeoul  150-874Korea, Republic Of',1),('00:17:DC','Daemyung Zero1','Daemyung Zero1#809,hyosung Intellian1594-1 Gwanyang-dong,dongan-guAnyang-si Gyeonggi-do 431-060Korea, Republic Of',1),('00:17:DD','Clipsal Australia','Clipsal AustraliaPo Box 103HindmarshAdelaide South Australia 5007Australia',1),('00:17:DE','Advantage Six Ltd','Advantage Six Ltd208 George StShawOldham Lancs Ol2 8drUnited Kingdom',1),('00:17:DF','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:E0','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:17:E1','Dacos Technologies Co., Ltd.','Dacos Technologies Co., Ltd.104 Daeryung-technotown Iii 448Gasan-dongSeoul Keumcheon-gu 153-772Korea, Republic Of',1),('00:17:E2','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:17:E3','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:E4','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:E5','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:E6','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:E7','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:E8','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:E9','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:EA','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:EB','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:EC','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:17:ED','Woojooit Ltd.','Woojooit Ltd.Hankooktire B/d 4th Floor, 501-19,Sinwol2 -dong,Yangcheon-gu, Seoul 158-839Korea, Republic Of',1),('00:17:EE','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92129United States',1),('00:17:EF','Blade Network Technologies, Inc.','Blade Network Technologies, Inc.2350 Mission College BlvdSuite 600Santa Clara Ca 95054United States',1),('00:17:F0','Szcom Broadband Network Technology Co.,ltd','Szcom Broadband Network Technology Co.,ltdRoom 602 No.8 Building ,shenzhen Software Park,Hi-tech C.zone ,nanshan AreaShenzhen Guangdong 518057China',1),('00:17:F1','Renu Electronics Pvt Ltd','Renu Electronics Pvt LtdSr No 2/6, Baner Road,Baner,Pune Maharashtra 411045India',1),('00:17:F2','Apple Computer','Apple Computer1 Infinite Loop Ms:35gpoCupertino Ca 95014United States',1),('00:17:F3','M/a-com Wireless Systems','M/a-com Wireless Systems12860 E. Lynchburg-salem TurnpikeForest  24551United States',1),('00:17:F4','Zeron Alliance','Zeron Alliance3f Doori Build. 244-14 Bunji, Poi-dong, Gangnam-guSeoul  135-965Korea, Republic Of',1),('00:17:F5','Lig Neoptek','Lig Neoptek926 Gosaek-dongGwonseon-guSuwon-si Gyeonggi-do 441-813Korea, Republic Of',1),('00:17:F6','Pyramid Meriden Inc.','Pyramid Meriden Inc.45 Gracey Ave.Meriden Ct 06451United States',1),('00:17:F7','Cem Solutions Pvt Ltd','Cem Solutions Pvt Ltd49,kanija BhavanRace Course RoadBangalore Karnataka 560 001India',1),('00:17:F8','Motech Industries Inc.','Motech Industries Inc.6f, No. 248, Sec. 3, Pei-shen Rd.,Shen-keng HsiangTaipei Hsien  222Taiwan, Republic Of China',1),('00:17:F9','Forcom Sp. Z O.o.','Forcom Sp. Z O.o.Gajowa 6Poznan Wlkp 60-815Poland',1),('00:17:FA','Microsoft Corporation','Microsoft CorporationOne Microsoft WayRed-b/1072Redmond Washington 98052-6399United States',1),('00:17:FB','Fa','Fa628-7, Dungchon-dongSeoul Kangseo-ku 157-838Korea, Republic Of',1),('00:17:FC','Suprema Inc.','Suprema Inc.16f Parkview Office Tower,Jeongja-dong, Bundang-gu,Seongnam Gyeonggi 463-863Korea, Republic Of',1),('00:17:FD','Amulet Hotkey','Amulet HotkeyCavalier RoadHeathfield Industrial EstateHeathfield Devon Tq12 6tqUnited Kingdom',1),('00:17:FE','Talos System Inc.','Talos System Inc.6191 Cornerstone Ct. Ste #109San Diego Ca 92121United States',1),('00:17:FF','Playline Co.,ltd.','Playline Co.,ltd.1-4-21 MotoakasakaMinatokuTokyo  107-0051Japan',1),('00:18:00','Unigrand Ltd','Unigrand Ltd7f-2, No.45, Jingde St., Jhonghe City,Taipei County235Taiwan, Republic Of China',1),('00:18:01','Actiontec Electronics, Inc','Actiontec Electronics, Inc760 North Mary AveSunnyvale Ca 94086United States',1),('00:18:02','Alpha Networks Inc.','Alpha Networks Inc.No.8 Li-shing Seventh Road,science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:18:03','Arcsoft Shanghai Co. Ltd','Arcsoft Shanghai Co. Ltd20th Floor, Suite (east) 2008, China Merchants Plaza, 333Shanghai  200041China',1),('00:18:04','E-tek Digital Technology Limited','E-tek Digital Technology LimitedUnit1520,15/f.,tower 2,grand Century Place,193 Prince Edward Road West,kowloon,Hong Kong',1),('00:18:05','Beijing Inhand Networking Technology Co.,ltd.','Beijing Inhand Networking Technology Co.,ltd.3/f,building A,gem TechchenterNo,9 3rd Street Of ShangdiBeijing  100085China',1),('00:18:06','Hokkei Industries Co., Ltd.','Hokkei Industries Co., Ltd.Imahira 432Hakusan Ishikawa 924-0827Japan',1),('00:18:07','Fanstel Corp.','Fanstel Corp.7466 E. Monte Cristo Ave.Scottsdale Arizona 85260United States',1),('00:18:08','Sightlogix, Inc.','Sightlogix, Inc.745 Alexander RoadPrinceton Nj 08540United States',1),('00:18:09','Cresyn','Cresyn8-22,jamwon-dongSeoul Seocho-gu #137-902Korea, Republic Of',1),('00:18:0A','Meraki, Inc.','Meraki, Inc.99 Rhode Island St.San Francisco, Ca 94103United States',1),('00:18:0B','Brilliant Telecommunications','Brilliant Telecommunications307 Orchard City Dr.Suite 102Campbell Ca 95008United States',1),('00:18:0C','Optelian Access Networks','Optelian Access Networks22a-1051 Baxter RoadOttawa Ontario K2c 3p2Canada',1),('00:18:0D','Terabytes Server Storage Tech Corp','Terabytes Server Storage Tech Corp14257 E Don Julian RdCity Of Industry Ca 91746United States',1),('00:18:0E','Avega Systems','Avega Systems59 Victoria StreetMcmahons Point Nsw 2060Australia',1),('00:18:0F','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V Denmark 1790vDenmark',1),('00:18:10','Iptrade S.a.','Iptrade S.a.Parc ScientifiqueAvenue Des Chasseurs Ardennais, 4Sart-tilman Wallonie 4031Belgium',1),('00:18:11','Neuros Technology International, Llc.','Neuros Technology International, Llc.650 W Lake StSuite 330Chicago Il 60661United States',1),('00:18:12','Beijing Xinwei Telecom Technology Co., Ltd.','Beijing Xinwei Telecom Technology Co., Ltd.Xinwei Bldg., No. 7 Zhongguancun Software Park,No. 8 Dongbeiwang West RoadHaidian District Beijing 100094China',1),('00:18:13','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:18:14','Mitutoyo Corporation','Mitutoyo Corporation20-1, Sakado 1-chome, Takatsu-ku,Kawasaki-shi  213-8533Japan',1),('00:18:15','Gz Technologies, Inc.','Gz Technologies, Inc.Room 1, 5f., No.94, Baojhong Rd.Sindian CityTaipei  231Taiwan, Republic Of China',1),('00:18:16','Ubixon Co., Ltd.','Ubixon Co., Ltd.Cheongdong Building 2f1344-29 Seocho Dong Seocho KuSeoul  137-070Korea, Republic Of',1),('00:18:17','D. E. Shaw Research, Llc','D. E. Shaw Research, Llc120 W. 45th St., 33rd FloorNew York Ny 10036United States',1),('00:18:18','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:18:19','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:18:1A','Avermedia Information Inc.','Avermedia Information Inc.7f, No. 137, Jian Yi Rd.,Chung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:18:1B','Taijin Metal Co., Ltd.','Taijin Metal Co., Ltd.#95-9, Hangdong7-ga, Joong-guIn Cheon  400-037Korea, Republic Of',1),('00:18:1C','Exterity Limited','Exterity LimitedRidge Way, Hillend Industrial EstateDalgety BayDunfermline Fife Ky11 9jdUnited Kingdom',1),('00:18:1D','Asia Electronics Co.,ltd','Asia Electronics Co.,ltd620-3 Docheon-dongGwangsan-guGwangju  506-301Korea, Republic Of',1),('00:18:1E','Gdx Technologies Ltd.','Gdx Technologies Ltd.61-63 Back Sneddon StreetPaisley Renfrewshire Pa3 2ddUnited Kingdom',1),('00:18:1F','Palmmicro Communications','Palmmicro CommunicationsRoom 0611, Bldg.b Tsinghua Tongfang Technology Plaza1 Wangzhuang RoadBeijing  100083China',1),('00:18:20','W5networks','W5networks48389 Fremont BlvdSuite 106Fremont Ca 94538United States',1),('00:18:21','Sindoricoh','Sindoricoh277-22, 2ga, Sungsu-dong, Sungdong-gu,Seoul  133-120Korea, Republic Of',1),('00:18:22','Cec Telecom Co.,ltd.','Cec Telecom Co.,ltd.10thfl.cec Building,6 Zhongguancun South StreetBeijing  100086China',1),('00:18:23','Delta Electronics, Inc.','Delta Electronics, Inc.186 Ruey Kuang Road, Neihu,Taipei  114Taiwan, Republic Of China',1),('00:18:24','Kimaldi Electronics, S.l.','Kimaldi Electronics, S.l.Ctra. De Rub, 292 BPol. Ind. Can GuitardTerrassa Barcelona 08228Spain',1),('00:18:25','Wavion Ltd','Wavion Ltd6 Hayetsira StreetPo Box 580Yoqneam-illit  20692Israel',1),('00:18:26','Cale Access Ab','Cale Access AbBox 1307Solna  Se-171 25Sweden',1),('00:18:27','Nec Philips Unified Solutions Nederland Bv','Nec Philips Unified Solutions Nederland BvAnton Philipsweg 1Hilversum Nh 1223kzNetherlands',1),('00:18:28','E2v Technologies (uk) Ltd.','E2v Technologies (uk) Ltd.106 Waterhouse LaneChelmsford Essex Cm1 2quUnited Kingdom',1),('00:18:29','Gatsometer','GatsometerClaes Tillyweg 2Haarlem Noord-holland 2031 CwNetherlands',1),('00:18:2A','Taiwan Video & Monitor','Taiwan Video & Monitor3f, 141 Jen Ai Rd Sec. 3Taipei City  106Taiwan, Republic Of China',1),('00:18:2B','Softier','SoftierTidhar 3Millenium Bldg Floor 11Raanana None 43665Israel',1),('00:18:2C','Ascend Networks, Inc.','Ascend Networks, Inc.No. 4 - 4, Lane 413, Chungchan Road,Benquao City Taipei 220Taiwan, Republic Of China',1),('00:18:2D','Artec Group O','Artec Group OTri 10cTallinn Harjumaa 11313Estonia',1),('00:18:2E','Xstreamhd, Llc','Xstreamhd, Llc7900b Westpark DriveSuite 200tMclean Va 22102United States',1),('00:18:2F','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:18:30','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:18:31','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:18:32','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:18:33','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:18:34','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:18:35','Thoratec / Itc','Thoratec / Itc2656 Patton RoadRoseville Mn 55113United States',1),('00:18:36','Reliance Electric Limited','Reliance Electric Limited2-3-2 Fukuura, Kanazawa-kuYokohama Kanagawa 236-8641Japan',1),('00:18:37','Universal Abit Co., Ltd.','Universal Abit Co., Ltd.7f, No. 323 Yangguang St.,Neihu Taipei 114Taiwan, Republic Of China',1),('00:18:38','Panaccess Communications,inc.','Panaccess Communications,inc.Floor 8,tower B,global Trade Center,36 Beisanhuandonglu,dongcheng DistrictBeijing 100013China',1),('00:18:39','Cisco-linksys Llc','Cisco-linksys Llc121 TheoryIrvine Ca 92612United States',1),('00:18:3A','Westell Technologies','Westell Technologies750 N. Commons Dr.Aurora Il 60504United States',1),('00:18:3B','Cenits Co., Ltd.','Cenits Co., Ltd.3f, Yangjae Bldg., 264-3Yangjae-dong, Seocho-guSeoul  137-130Korea, Republic Of',1),('00:18:3C','Encore Software Limited','Encore Software Limited6f Leo Complex44 Residency Cross RoadBangalore Karnataka 560025India',1),('00:18:3D','Vertex Link Corporation','Vertex Link CorporationMeitetsu Fudosan Takebashi Bldg 6f3-15 Kanda NishikichoChiyoda-ku Tokyo 101-0054Japan',1),('00:18:3E','Digilent, Inc','Digilent, Inc215 E. Main St.Suite DPullman Wa 99163United States',1),('00:18:3F','2wire, Inc','2wire, Inc1704 Automation ParkwaySan Jose Ca 95131United States',1),('00:18:40','3 Phoenix, Inc.','3 Phoenix, Inc.13135 Lee Jackson HwySuite 330Fairfax Virginia 22033United States',1),('00:18:41','High Tech Computer Corp','High Tech Computer Corp23 Hsin Hua Rd.Taoyuan  330Taiwan, Republic Of China',1),('00:18:42','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790 VDenmark',1),('00:18:43','Dawevision Ltd','Dawevision Ltd197 High StreetCottenham Cambridge Cb4 8rxUnited Kingdom',1),('00:18:44','Heads Up Technologies, Inc.','Heads Up Technologies, Inc.2033 Chennault Drive, Suite 100Carrollton Texas 75006-5119United States',1),('00:18:45','Npl Pulsar Ltd.','Npl Pulsar Ltd.Zaharova, 18aPenza  440044Russian Federation',1),('00:18:46','Crypto S.a.','Crypto S.a.V. Ipirou 45Marousi Athens 15125Greece',1),('00:18:47','Acenet Technology Inc.','Acenet Technology Inc.133 Vienna Dr.Milpitas Ca 95035United States',1),('00:18:48','Vecima Networks Inc.','Vecima Networks Inc.150 Cardinal PlaceSaskatoon Sk S7l 6h7Canada',1),('00:18:49','Pigeon Point Systems','Pigeon Point SystemsPo Box 66989Scotts Valley Ca 95067United States',1),('00:18:4A','Catcher, Inc.','Catcher, Inc.5864 Owens Ave.Suite 101Carlsbad Ca 92008United States',1),('00:18:4B','Las Vegas Gaming, Inc.','Las Vegas Gaming, Inc.4000 West Ali Baba Lane, Suite DLas Vegas Nevada 89118United States',1),('00:18:4C','Bogen Communications','Bogen Communications50 Spring St.Ramsey Nj 07446United States',1),('00:18:4D','Netgear Inc.','Netgear Inc.4500 Great America ParkwaySanta Clara Ca 95054United States',1),('00:18:4E','Lianhe Technologies, Inc.','Lianhe Technologies, Inc.3f, #119, Dahu Shanzhuang St.Neihu District Taipei City 114Taiwan, Republic Of China',1),('00:18:4F','8 Ways Technology Corp.','8 Ways Technology Corp.2f-1, No. 216, Sec. 3, Roosevelt Rd.Taipei 231Taiwan, Republic Of China',1),('00:18:50','Secfone Kft','Secfone Kft51 Bercsenyi StrJaszbereny  5100Hungary',1),('00:18:51','Swsoft','Swsoft13755 Sunrise Valley Drive, Suite 600Herndon Va 20171United States',1),('00:18:52','Storlink Semiconductors, Inc.','Storlink Semiconductors, Inc.1804 N. Shoreline BoulevardSuite 240Mountain View Ca 94043United States',1),('00:18:53','Atera Networks Ltd.','Atera Networks Ltd.31, Habarzel St.Ramat HachayalTel-aviv  69710Israel',1),('00:18:54','Argard Co., Ltd','Argard Co., Ltd2571 Lardprao Rd.Wangthonglang Bangkok 10310Thailand',1),('00:18:55','Aeromaritime Systembau Gmbh','Aeromaritime Systembau GmbhLudwig-erhard-str. 16D-85375 NeufahrnGermany',1),('00:18:56','Eyefi, Inc','Eyefi, Inc149 Commonwealth DriveMenlo Park Ca 94025United States',1),('00:18:57','Unilever R&d','Unilever R&dBldg. 50SharnbrookBedford Bedfordshire Mk44 1lqUnited Kingdom',1),('00:18:58','Tagmaster Ab','Tagmaster AbKronborgsgrnd 1Kista Stockholm S-16487Sweden',1),('00:18:59','Strawberry Linux Co.,ltd.','Strawberry Linux Co.,ltd.1-28-8-204 HigashiayaseAdachiku Tokyo 120-0004Japan',1),('00:18:5A','Ucontrol, Inc.','Ucontrol, Inc.5914 W. Courtyard DriveSuite 210Austin Tx 78730United States',1),('00:18:5B','Network Chemistry, Inc','Network Chemistry, Inc1804 Embarcadero RdPalo Alto Ca 94303United States',1),('00:18:5C','Eds Lab Pte Ltd','Eds Lab Pte Ltd20 Ayer Rajah Crescent#08-26139964Singapore',1),('00:18:5D','Taiguen Technology (shen-zhen) Co., Ltd.','Taiguen Technology (shen-zhen) Co., Ltd.No. 23, The Third Industrial Park Of Xia Village,Gongming, Baoan District,Shenzhen City, Guangdong, 815106China',1),('00:18:5E','Nexterm Inc.','Nexterm Inc.1-12-3, Shibaura, Minato-ku,Tokyo  105-0023Japan',1),('00:18:5F','Tac Inc.','Tac Inc.66 Nishiishigatsubocho Nishinanajyo ShimogyokuKyoto  600-8896Japan',1),('00:18:60','Sim Technology Group Shanghai Simcom Ltd.,','Sim Technology Group Shanghai Simcom Ltd.,Sim Technology Building,700 Yishan Rd, Shanghai 200233Shanghai  200233China',1),('00:18:61','Ooma, Inc.','Ooma, Inc.555 University AvenuePalo Alto Ca 94301United States',1),('00:18:62','Seagate Technology','Seagate Technology1280 Disc DriveShakopee Mn 55379United States',1),('00:18:63','Veritech Electronics Limited','Veritech Electronics Limited8f, 67, Sec. 1, Zhongshan Road, Xinzhuang,Taipei  242Taiwan, Republic Of China',1),('00:18:64','Cybectec Inc.','Cybectec Inc.730, Rue CommercialeSuite 200St-jean-chrysostome Qc G6z 2c5Canada',1),('00:18:65','Siemens Healthcare Diagnostics Manufacturing Ltd','Siemens Healthcare Diagnostics Manufacturing LtdNorthern RoadChilton Industrial EstateSudbury Suffolk C010 2xqUnited Kingdom',1),('00:18:66','Leutron Vision','Leutron VisionIndustriestrasse 57Glattbrugg Zh 8152Switzerland',1),('00:18:67','Evolution Robotics Retail','Evolution Robotics Retail433 N. Fair Oaks AvePasadena Ca 91103United States',1),('00:18:68','Scientific Atlanta, A Cisco Company','Scientific Atlanta, A Cisco Company5030 Sugarloaf ParkwayLawrenceville Ga 30044United States',1),('00:18:69','Kingjim','KingjimNo.10-18,2-chomeHigashi-kandaChiyoda-ku Tokyo 101-0031Japan',1),('00:18:6A','Global Link Digital Technology Co,.ltd','Global Link Digital Technology Co,.ltdQibaoyiding Ind.areaLiuchongwei Wanjiang TownDongguan Guangdong 523051China',1),('00:18:6B','Sambu Communics Co., Ltd.','Sambu Communics Co., Ltd.38b-1l Namdong Industrial Complex626 Namchon-dong, Namdong-guIncheon  405-100Korea, Republic Of',1),('00:18:6C','Neonode Ab','Neonode AbBiblioteksgatan 11, 1st FloorStockholm  S-111 46Sweden',1),('00:18:6D','Zhenjiang Sapphire Electronic Industry Co.','Zhenjiang Sapphire Electronic Industry Co.Wei San Road,dingmao Develop AreaZhenjiang Jiangsu 212009China',1),('00:18:6E','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts. Hp2 4nwUnited Kingdom',1),('00:18:6F','Setha Industria Eletronica Ltda','Setha Industria Eletronica LtdaRua Alvaro De Macedo 134Parada De LucasRio De Janeiro Rj 21.250-620Brazil',1),('00:18:70','E28 Shanghai Limited','E28 Shanghai Limited2/f Eastern Tower689 Beijing Road (east)Shanghai  200001China',1),('00:18:71','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:18:72','Expertise Engineering','Expertise Engineering4186 Sorrento Valley Blvd Suite -jSan Diego Ca 92121United States',1),('00:18:73','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:18:74','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:18:75','Anacise Testnology Pte Ltd','Anacise Testnology Pte Ltd3 Bishan Place #02-06Cpf Bishan Building579838Singapore',1),('00:18:76','Wowwee Ltd.','Wowwee Ltd.92 Granville Rd. Suite 301a-cEnergy PlazaT.s.t. East KowloonHong Kong',1),('00:18:77','Amplex A/s','Amplex A/sSilkeborgvej 2Aarhus C  8000Denmark',1),('00:18:78','Mackware Gmbh','Mackware GmbhSchnzle 13Waiblingen Baden-wrttemberg 71332Germany',1),('00:18:79','Dsys','DsysSoeflinger Str. 100Ulm Bw 89077Germany',1),('00:18:7A','Wiremold','Wiremold60 Woodlawn St.West Hartford Ct 06110United States',1),('00:18:7B','4nsys Co. Ltd.','4nsys Co. Ltd.3f, Hana Bldg118-2, Oryu-dongGuro-gu Seoul 152-100Korea, Republic Of',1),('00:18:7C','Intercross, Llc','Intercross, LlcNovoselov Str., 58/7Ryazan  390049Russian Federation',1),('00:18:7D','Armorlink Shanghai Co. Ltd','Armorlink Shanghai Co. LtdNo 515, Shengfu RoadShanghai  201108China',1),('00:18:7E','Rgb Spectrum','Rgb Spectrum950 Marina Village PkwyAlameda Ca 94501United States',1),('00:18:7F','Zodianet','Zodianet23, Rue Des FraisettesPalaiseau Essonne 91120France',1),('00:18:80','Maxim Integrated Circuits','Maxim Integrated Circuits2900 Lakeside DriveSuite 100Santa Clara Ca 95054United States',1),('00:18:81','Buyang Electronics Industrial Co., Ltd','Buyang Electronics Industrial Co., Ltd434-140, Oryu-dongSeo-kuIncheon  404-300Korea, Republic Of',1),('00:18:82','Huawei Technologies Co., Ltd.','Huawei Technologies Co., Ltd.F1-20,section F,huawei Base,bantian, Longgang DistrictShenzhen Guangdong 518129China',1),('00:18:83','Formosa21 Inc.','Formosa21 Inc.8f-6, No.351, Chung Shan Rd., Sec.2Chung Ho CityTaipei  235Taiwan, Republic Of China',1),('00:18:84','Fon','FonAvda. Bruselas, N. 7, Planta 3, AlcobendasMadrid 28100Spain',1),('00:18:85','Avigilon Corporation','Avigilon CorporationBox 378, 101 - 1001 West BroadwayVancouver Bc V6h 4e4Canada',1),('00:18:86','El-tech, Inc.','El-tech, Inc.A-711, Woolim Lions Valley, 371-28Gasan-dong, Geumcheon-gu,Seoul  150-834Korea, Republic Of',1),('00:18:87','Metasystem Spa','Metasystem SpaVia Oberdan 16Reggio Emilia Re 42100Italy',1),('00:18:88','Gotive A.s.','Gotive A.s.Zmock 34Bratislava  81101Slovakia',1),('00:18:89','Winnet Solutions Limited','Winnet Solutions LimitedRm804, Kornhill Metro Tower, Quarry BayHk 852Hong Kong',1),('00:18:8A','Infinova Llc','Infinova Llc51 Stouts Lane, Unit 1 & 2Monmouth Junction New Jersey 08852United States',1),('00:18:8B','Dell','DellOne Dell WayRound Rock Texas 78682United States',1),('00:18:8C','Mobile Action Technology Inc.','Mobile Action Technology Inc.5f, No. 205-3, Sec. 3, Beishin Rd.Shindian City, Taipei  231Taiwan, Republic Of China',1),('00:18:8D','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  1790Denmark',1),('00:18:8E','Ekahau, Inc.','Ekahau, Inc.Tallberginkatu 2Helsinki Uusimaa 00180Finland',1),('00:18:8F','Montgomery Technology, Inc.','Montgomery Technology, Inc.800 East Commerce StreetGreenville Al 36037United States',1),('00:18:90','Radiocom, S.r.o.','Radiocom, S.r.o.Misikova 22Bratislava  811 06Slovakia',1),('00:18:91','Zhongshan General K-mate Electronics Co., Ltd','Zhongshan General K-mate Electronics Co., Ltd3/f B1 Building, Fuwan Ind. Zone Sun Wen East RoadZhongshan Guangdong 528403China',1),('00:18:92','Ads-tec Gmbh','Ads-tec GmbhRaiffeisenstrasse 14Leinfelden-echterdingen Baden-wrttemberg 70771Germany',1),('00:18:93','Shenzhen Photon Broadband Technology Co.,ltd','Shenzhen Photon Broadband Technology Co.,ltd2/f Hivac Bld,2th Langshan Rd,north Hi-tech IndustrialShenzhen Guangdong 518057China',1),('00:18:94','Zimocom','Zimocom3~5f, Bongui Bldg, 76-1, Munjeong-dongSongpaguSeoul  138-200Korea, Republic Of',1),('00:18:95','Hansun Technologies Inc.','Hansun Technologies Inc.Room 301, Building 103, Wangjingkejiyuan, Chaoyang DistrictBeijing  100102China',1),('00:18:96','Great Well Electronic Ltd','Great Well Electronic LtdThe Third Industrial  AreaGuanlan TownShenzhen Guangdong 518110China',1),('00:18:97','Jess-link Products Co., Ltd','Jess-link Products Co., Ltd9f, No. 176, Jian-yi Rd., Chung Ho CityTaipei County  235Taiwan, Republic Of China',1),('00:18:98','Kingstate Electronics Corporation','Kingstate Electronics Corporation10f, No.69-11, Sec.2, Chung Cheng E. Rd.,Tamshui TownTaipei County  251Taiwan, Republic Of China',1),('00:18:99','Shenzhen Jieshun Science&technology Industry Co,ltd.','Shenzhen Jieshun Science&technology Industry Co,ltd.China Guangdong State Shenzhen City Futian Section No17. Meilin RoadShenzhen Guangdong 518049China',1),('00:18:9A','Hana Micron Inc.','Hana Micron Inc.#95-1 Wonnam-li, Umbong-myeonChung-nam, South Korea.Asan-city Chung-nam 336-864Korea, Republic Of',1),('00:18:9B','Thomson Inc.','Thomson Inc.101 West 103rd StreetIndianapolis In 46290-1102United States',1),('00:18:9C','Weldex Corporation','Weldex Corporation6751 Katella AvenueCypress Ca 90630United States',1),('00:18:9D','Navcast Inc.','Navcast Inc.Suite 612, 6711 Mississauga RoadMississauga On M2r 1a3Canada',1),('00:18:9E','Omnikey Gmbh.','Omnikey Gmbh.Ferihumerstrasse 13Linz Upperaustria 4040Austria',1),('00:18:9F','Lenntek Corporation','Lenntek Corporation4f, 125 Guangming 3rd. RoadJhu Bei Hsin Chu 302Taiwan, Republic Of China',1),('00:18:A0','Cierma Ascenseurs','Cierma Ascenseurs17 Avenue Guiglionda De Saint AgatheNice Paca 06300France',1),('00:18:A1','Tiqit Computers, Inc.','Tiqit Computers, Inc.2215 Old Page Mill RdPalo Alto Ca 94304United States',1),('00:18:A2','Xip Technology Ab','Xip Technology AbPo Box 437Jnkping Sweden Se- 551 16Sweden',1),('00:18:A3','Zippy Technology Corp.','Zippy Technology Corp.10f, No. 50, Mincyuan Rd., Sindian CityTaipei  231Taiwan, Republic Of China',1),('00:18:A4','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:18:A5','Adigit Technologies Corp.','Adigit Technologies Corp.Rm D302e,no.185 3f-2,kur-wong Road,Lung-tang,Tao-yuan,  325Taiwan, Republic Of China',1),('00:18:A6','Persistent Systems, Llc','Persistent Systems, Llc118 N. Howard St. #72Baltimore Md 21201United States',1),('00:18:A7','Yoggie Security Systems Ltd.','Yoggie Security Systems Ltd.P.p.box 156Beth Halevy  42870Israel',1),('00:18:A8','Anneal Technology Inc.','Anneal Technology Inc.No.30-11, Wunhua Rd., MinsyongChiayi  621Taiwan, Republic Of China',1),('00:18:A9','Ethernet Direct Corporation','Ethernet Direct Corporation19f,no.345 Chung Ho Road, Yung Ho CityTaipei  234Taiwan, Republic Of China',1),('00:18:AA','Protec Fire Detection Plc','Protec Fire Detection PlcProtec HouseChurchill WayNelson Lancashire Bb9 6rtUnited Kingdom',1),('00:18:AB','Beijing Lhwt Microelectronics Inc.','Beijing Lhwt Microelectronics Inc.18/f,quantum Plaza,no.27 Zhi Chun Rd.,hai Dian District,beijingChina',1),('00:18:AC','Shanghai Jiao Da Hisys Technology Co. Ltd.','Shanghai Jiao Da Hisys Technology Co. Ltd.7f Haoran Hitech Bldg., No.1954 Huashan RoadShanghai Xuhui 200030China',1),('00:18:AD','Nidec Sankyo Corporation','Nidec Sankyo Corporation5329, Shimosuwa-machi, Suwa-gunNagano 393-8511Japan',1),('00:18:AE','Tvt Co.,ltd','Tvt Co.,ltd5/f,north Block,ce Lighting HouseHi-tech Park, Nanshan District,Shenzhen Guangdong 518026China',1),('00:18:AF','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1, Imsoo-dongGumi-city Gyeong-buk 730-350Korea, Republic Of',1),('00:18:B0','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:18:B1','Blade Network Technologies','Blade Network Technologies2350 Mission College Blvd. Suite 600Santa Clara Ca 95054United States',1),('00:18:B2','Adeunis Rf','Adeunis Rf283 Rue NeelCrolles Isere 38920France',1),('00:18:B3','Tec Wizhome Co., Ltd.','Tec Wizhome Co., Ltd.18fl., In-song Bldg., 194-15,Heohyun-dong, 1ga, Jung-guSeoul  100-952Korea, Republic Of',1),('00:18:B4','Dawon Media Inc.','Dawon Media Inc.Rm503. Woolim E-biz Center 170-5, Guro3dong Gurogu,Seoul  152-769Korea, Republic Of',1),('00:18:B5','Magna Carta','Magna CartaNaritaweg 126Amsterdam Noord Holland 1043 CaNetherlands',1),('00:18:B6','S3c, Inc.','S3c, Inc.1010 Stewart Dr.Sunnyvale California 94085United States',1),('00:18:B7','D3 Led, Llc','D3 Led, Llc380 Mountain RdSuite 1412Union City Nj 07087United States',1),('00:18:B8','New Voice International Ag','New Voice International AgSt. Gallerstrasse 8Lachen Sz 8853Switzerland',1),('00:18:B9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:18:BA','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:18:BB','Eliwell Controls Srl','Eliwell Controls SrlVia Dellindustria, 15Pieve Dalpago Belluno 32010Italy',1),('00:18:BC','Zao Nvp Bolid','Zao Nvp BolidPionerskaya Str., 4Korolyov Moscow Region 141070Russian Federation',1),('00:18:BD','Shenzhen Dvbworld Technology Co., Ltd.','Shenzhen Dvbworld Technology Co., Ltd.2nd Floor, Building A, Qinghu Xinqiao Industry Area,Longhua, Bao An DistrictShenzhen Guangdong 518000China',1),('00:18:BE','Ansa Corporation','Ansa Corporation17f., No.738, Chung Cheng Rd.Chung Ho City, Taipei County  235Taiwan, Republic Of China',1),('00:18:BF','Essence Technology Solution, Inc.','Essence Technology Solution, Inc.B1, No. 207, Beisin Rd., Sec. 3Sindian, Taipei County  231Taiwan, Republic Of China',1),('00:18:C0','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92129United States',1),('00:18:C1','Almitec Informtica E Comrcio Ltda.','Almitec Informtica E Comrcio Ltda.461, Francisco De Morais St.So Paulo  04714-010Brazil',1),('00:18:C2','Firetide, Inc','Firetide, Inc16795 Lark Av, Suite 200Los Gatos Ca 95032United States',1),('00:18:C3','C&s Microwave','C&s MicrowaveSuntech City 8th Floor, Sang Dae Won-dong, Jung Won-guSungnam Gyunggi-do 82Korea, Republic Of',1),('00:18:C4','Raba Technologies Llc','Raba Technologies Llc8830 Stanford Blvd Suite 205Columbia Maryland 21045United States',1),('00:18:C5','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  1790Denmark',1),('00:18:C6','Opw Fuel Management Systems','Opw Fuel Management Systems6900 Santa Fe DriveHodgkins Illinois 60525United States',1),('00:18:C7','Real Time Automation','Real Time Automation2825 N Mayfair Rd Ste 11Wauwatosa Wi 53222United States',1),('00:18:C8','Isonas Inc.','Isonas Inc.6325 Gunpark DriveSuite 101Boulder Co 80301United States',1),('00:18:C9','Eops Technology Limited','Eops Technology LimitedRoom 2001, Fairmont House,8 Cotton Tree Drive, Central,Hong KongHong Kong',1),('00:18:CA','Viprinet Gmbh','Viprinet GmbhBasilikastrasse 3Bingen Am Rhein  55411Germany',1),('00:18:CB','Tecobest Technology Limited','Tecobest Technology Limited53/f.,block A,united Plaza,No.5022,bin He RoadShenzhen Guangdong 518026China',1),('00:18:CC','Axiohm Sas','Axiohm Sas1 Rue DarcueilMontrouge  92120France',1),('00:18:CD','Erae Electronics Industry Co., Ltd','Erae Electronics Industry Co., Ltd#371-51, Gasan-dongGeumchen-gu Seoul 153-803Korea, Republic Of',1),('00:18:CE','Dreamtech Co., Ltd','Dreamtech Co., Ltd#340-5, Yang-dang Ri, Jik-san MyeonCheon-an Si Chung-nam 330810Korea, Republic Of',1),('00:18:CF','Baldor Electric Company','Baldor Electric Company600 S. Zero St.Fort Smith Ar 72901United States',1),('00:18:D0','Atroad,  A Trimble Company','Atroad,  A Trimble Company47071 Bayside ParkwayFremont California 94538United States',1),('00:18:D1','Siemens Home & Office Comm. Devices','Siemens Home & Office Comm. Devices4849 Alpha Rd.Dallas Texas 75244United States',1),('00:18:D2','High-gain Antennas Llc','High-gain Antennas Llc11679 S. Cormorant CircleParker Co 80134United States',1),('00:18:D3','Teamcast','TeamcastCentre Espace PerformanceSaint Gregoire  35769France',1),('00:18:D4','Unified Display Interface Sig','Unified Display Interface Sig15201 Sw Greenbrier ParkwayBeaverton Oregon 97006United States',1),('00:18:D5','Reigncom','Reigncom14f Kamco Yanjae Tower, 949-3Dogok 1-dongm, Gangnam-guSeoul  135-739Korea, Republic Of',1),('00:18:D6','Swirlnet A/s','Swirlnet A/sDiplomvej 381Lyngby  Dk-2800Denmark',1),('00:18:D7','Javad Navigation Systems Inc.','Javad Navigation Systems Inc.1731 Technology Drive, Suite 680San Jose Ca 95110United States',1),('00:18:D8','Arch Meter Corporation','Arch Meter Corporation4f, No.3-2, Industry E. Rd.9,hsinchu Science ParkHsinchuTaiwan, Republic Of China',1),('00:18:D9','Santosha Internatonal, Inc','Santosha Internatonal, Inc3843 S. Bristol St. #242Santa Ana Ca 92704United States',1),('00:18:DA','Amber Wireless Gmbh','Amber Wireless GmbhAlbin-koebis-str. 18Koeln  51147Germany',1),('00:18:DB','Epl Technology Ltd','Epl Technology LtdLongdong,longgang DistrictShenzhen Guangdong 518116China',1),('00:18:DC','Prostar Co., Ltd.','Prostar Co., Ltd.A-703 Technotown, 250-3 Hagye-dong, Nowon-guSeoul  139-230Korea, Republic Of',1),('00:18:DD','Silicondust Engineering Ltd','Silicondust Engineering LtdPo Box 74-299Market RdAucklandNew Zealand',1),('00:18:DE','Intel Corporation','Intel CorporationLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:18:DF','The Morey Corporation','The Morey Corporation100 Morey DriveWoodridge Il 60517United States',1),('00:18:E0','Anaveo','AnaveoLes Carrs Du Parc10 Rue Des RosiristesChampagne Au Mont Dor Rhne F-69410France',1),('00:18:E1','Verkerk Service Systemen','Verkerk Service SystemenMolenvliet 1Zwijndrecht Zuid-holland Nl-3335lhNetherlands',1),('00:18:E2','Topdata Sistemas De Automacao Ltda','Topdata Sistemas De Automacao LtdaRua Dr Carvalho Chaves, 662Curitiba Pr 80.220-010Brazil',1),('00:18:E3','Visualgate Systems, Inc.','Visualgate Systems, Inc.64 Bakersfield StreetToronto Ontario M3j 2w7Canada',1),('00:18:E4','Yiguang','Yiguang3/fl.industry Zone,fuxinlin,hangcheng,xixiang,baoanShenzhen Guangdong 518126China',1),('00:18:E5','Adhoco Ag','Adhoco AgTechnoparkJgerstr. 2Winterthur Zh Ch-8406 WintSwitzerland',1),('00:18:E6','Computer Hardware Design Sia','Computer Hardware Design SiaDzelzavas 120iRiga  Lv-1021Latvia',1),('00:18:E7','Cameo Communications, Inc.','Cameo Communications, Inc.No.42, Sec. 6, Mincyuan E. Rd.Taipei  114Taiwan, Republic Of China',1),('00:18:E8','Hacetron Corporation','Hacetron CorporationNo. 542,Sec.1, Yang-hu Rd,Yang-mei, Tao-yuan, 326Taiwan, Republic Of China',1),('00:18:E9','Numata Corporation','Numata Corporation8-2-39 Nanko-higashiSuminoe-kuOsaka-shi Osaka-fu 559-0031Japan',1),('00:18:EA','Alltec Gmbh','Alltec GmbhAn Der Trave 27-31Selmsdorf Mecklenburg-vorpommern 23923Germany',1),('00:18:EB','Brovis Wireless Networks','Brovis Wireless Networks19925 Stevens Creek BlvdCupertino Ca 95014United States',1),('00:18:EC','Welding Technology Corporation','Welding Technology Corporation24775 Crestview CourtFarmington Hills Mi 48335United States',1),('00:18:ED','Accutech Ultrasystems Co., Ltd.','Accutech Ultrasystems Co., Ltd.11f-4, No. 150,Chien-yi Road,Chung-ho City, Taipei Hsien, 235Taiwan, Republic Of China',1),('00:18:EE','Videology Imaging Solutions, Inc.','Videology Imaging Solutions, Inc.37 M Lark Industrial ParkwayGreenville Ri 02828-3001United States',1),('00:18:EF','Escape Communications, Inc.','Escape Communications, Inc.2615 Pacific Coast HwySte 329Hermosa Beach Ca 90254United States',1),('00:18:F0','Joytoto Co., Ltd.','Joytoto Co., Ltd.3f Sungwoo Bldg. 717-3, Sooseo-dongKangnam-guSeoul  135-220Korea, Republic Of',1),('00:18:F1','Chunichi Denshi Co.,ltd.','Chunichi Denshi Co.,ltd.1 DenjiyamaNarumi Cho Midori KuNagoya Aichi 458-8525Japan',1),('00:18:F2','Beijing Tianyu Communication Equipment Co., Ltd','Beijing Tianyu Communication Equipment Co., Ltd27th Floor, Tengda PlazaXizhimengwai Street, Haidian DistrictBeijing  100044China',1),('00:18:F3','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitouTaipei  112Taiwan, Republic Of China',1),('00:18:F4','Eo Technics Co., Ltd.','Eo Technics Co., Ltd.864-4, Kwanyang 2-dongDongan-guAnyang Kyeonggi-do 431-062Korea, Republic Of',1),('00:18:F5','Shenzhen Streaming Video Technology Company Limited','Shenzhen Streaming Video Technology Company Limited5/f, Block 3, Software Part No.1, Keji Middle 2 Road,Shenzhen Hi-tech Industrial ParkShenzhen Gaungdong 518057China',1),('00:18:F6','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47Edegem Antwerp B-2650Belgium',1),('00:18:F7','Kameleon Technologies','Kameleon Technologies217, Rue St HonorParis  75001France',1),('00:18:F8','Cisco-linksys Llc','Cisco-linksys Llc121 Theory DriveIrvine Ca 92612United States',1),('00:18:F9','Vvond, Inc.','Vvond, Inc.3000 Bridge ParkwaySuite 102Redwood City Ca 94065United States',1),('00:18:FA','Yushin Precision Equipment Co.,ltd.','Yushin Precision Equipment Co.,ltd.11-260 KogahonmachiFushimi-kuKyoto  612-8492 JapJapan',1),('00:18:FB','Compro Technology','Compro Technology3/f No 12, Alley 6, Lane 45, Pao Shin RdHsintien  231Taiwan, Republic Of China',1),('00:18:FC','Altec Electronic Ag','Altec Electronic AgLenggenbachstrasse 3Fahrweid Zrich Ch-8951Switzerland',1),('00:18:FD','Optimal Technologies International Inc.','Optimal Technologies International Inc.12 Spanish Main DrivePo Box F-42409/359Freeport GbiBahamas',1),('00:18:FE','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms060308Houston Tx 77070United States',1),('00:18:FF','Powerquattro Co.','Powerquattro Co.Jnos U. 175.Budapest  H-1161Hungary',1),('00:19:00','Intelliverese - Dba Voicecom','Intelliverese - Dba Voicecom5900 Windward ParkwaySuite 500Alpharetta Georgia 30005United States',1),('00:19:01','F1media','F1media610, Keumkang Hightech , 138-1 Sangdaewon-dong, Jungwon-guSeongnam-si Gyeonggi-do 462-707Korea, Republic Of',1),('00:19:02','Cambridge Consultants Ltd','Cambridge Consultants LtdScience ParkMilton RoadCambridge Cambs Cb4 0dwUnited Kingdom',1),('00:19:03','Bigfoot Networks Inc','Bigfoot Networks Inc3925 West Braker LaneAustin Tx 78759United States',1),('00:19:04','Wb Electronics Sp. Z O.o.','Wb Electronics Sp. Z O.o.Ul. Poznanska 129/133Ozarow Mazowiecki Mazowieckie 05-850Poland',1),('00:19:05','Schrack Seconet Ag','Schrack Seconet AgEibesbrunnergasse 18Wien sterreich 1122Austria',1),('00:19:06','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:07','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:08','Duaxes Corporation','Duaxes Corporation2-5, Kasumigaseki 3-chome, Chiyoda-ku.Tokyo Foreign 100-6014Japan',1),('00:19:09','Devi A/s','Devi A/sUlvehavevej 61Vejle  7100Denmark',1),('00:19:0A','Hasware Inc.','Hasware Inc.4-12-3 HigashiKunitachi Tokyo 186-0002Japan',1),('00:19:0B','Southern Vision Systems, Inc.','Southern Vision Systems, Inc.8215 Madison Blvd, Suite 150Madison Al 35758United States',1),('00:19:0C','Encore Electronics, Inc.','Encore Electronics, Inc.16483 Old Valley Blvd.La Puente Ca 91744United States',1),('00:19:0D','Ieee 1394c','Ieee 1394cC/o 1394 Trade Association1560 East Southlake Blvd., Suite 220Southlake Tx 76092United States',1),('00:19:0E','Atech Technology Co., Ltd.','Atech Technology Co., Ltd.4 Fl., No. 103, Sec 2, Jiuzong Rd.Taipei  114Taiwan, Republic Of China',1),('00:19:0F','Advansus Corp.','Advansus Corp.No.5 Shing Yeh Street, Kwei HsiangTaoyuan  333Taiwan, Republic Of China',1),('00:19:10','Knick Elektronische Messgeraete Gmbh & Co. Kg','Knick Elektronische Messgeraete Gmbh & Co. KgBeuckestr. 22Berlin  14163Germany',1),('00:19:11','Just In Mobile Information Technologies (shanghai) Co., Ltd.','Just In Mobile Information Technologies (shanghai) Co., Ltd.5th Floor, 2nd Area, Haiwangxing Building, 62 Xingguang Ave., N.high-tech ParkChongqing  401121China',1),('00:19:12','Welcat Inc','Welcat IncEast Tower 6f, Shinagawa Seaside, 4-12-8, Higashi Shinagawa, Shinagawa SectionTokyo  140-0002Japan',1),('00:19:13','Chuang-yi Network Equipment Co.ltd.','Chuang-yi Network Equipment Co.ltd.238 Tianmushan Rd., West Lake DistrictHangzhou Zhejiang 310000China',1),('00:19:14','Winix Co., Ltd','Winix Co., Ltd363 Angade Bldg., Yangjae-dongSeocho-guSeoul  137-898Korea, Republic Of',1),('00:19:15','Tecom Co., Ltd.','Tecom Co., Ltd.23 R&d Road 2 Science Based Industrial ParkHsin-chu  300Taiwan, Republic Of China',1),('00:19:16','Paytec Ag','Paytec AgRosengartenstrasse 3Zollikerberg Zh 8125Switzerland',1),('00:19:17','Posiflex Inc.','Posiflex Inc.6, Wu-chuan RoadWu KuTaipei Hsien  248Taiwan, Republic Of China',1),('00:19:18','Interactive Wear Ag','Interactive Wear AgPetersbrunner Str. 3Starnberg Bavaria 82319Germany',1),('00:19:19','Astel Inc.','Astel Inc.59-7 Jang-dong Yusung-guDaejeon Chungnam 305-343Korea, Republic Of',1),('00:19:1A','Irlink','IrlinkHanyoung B/d 6f, 4-6Munjeong-dong, Sonpa-kuSeoul  138-824Korea, Republic Of',1),('00:19:1B','Sputnik Engineering Ag','Sputnik Engineering AgHheweg 85Biel-bienne Be  2502Switzerland',1),('00:19:1C','Sensicast Systems','Sensicast Systems200 Reservoir StSuite 100Needham Ma 02494United States',1),('00:19:1D','Nintendo Co.,ltd.','Nintendo Co.,ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:19:1E','Beyondwiz Co., Ltd.','Beyondwiz Co., Ltd.3f, Daechang Bldg.,8-2, Soonae-dong, Bundang-guSungnam Kyungki-do 463-825Korea, Republic Of',1),('00:19:1F','Microlink Communications Inc.','Microlink Communications Inc.8f , 31 , Hsintai Road , Chupei City , HsinchuChupei Taiwan 302Taiwan, Republic Of China',1),('00:19:20','Kume Electric Co.,ltd.','Kume Electric Co.,ltd.4-2-24 KitakawaraItami-city HyougoJapan',1),('00:19:21','Elitegroup Computer System Co.','Elitegroup Computer System Co.No.22,alley 38,lane 91, Sec. 1,nei Hu Road.Taipei  114Taiwan, Republic Of China',1),('00:19:22','Cm Comandos Lineares','Cm Comandos LinearesAv Eng Alberto De Zagottis, 760JurubatubaSao Paulo Sp 04675-085Brazil',1),('00:19:23','Phonex Korea Co., Ltd.','Phonex Korea Co., Ltd.33-3, Geoyeo-dongSeoul Songpa-gu 138-814Korea, Republic Of',1),('00:19:24','Lbnl  Engineering','Lbnl  Engineering1 Cyclotron Rd.Ms46r0125Berkeley Ca 94720United States',1),('00:19:25','Intelicis Corporation','Intelicis Corporation4633 Old Ironsides Drive, Suite 150Santa Clara Ca 95054United States',1),('00:19:26','Bitsgen Co., Ltd.','Bitsgen Co., Ltd.#502, Owners Tower, #16-5, Sunea-dongBundang-gu Seongnam-si 463-825Korea, Republic Of',1),('00:19:27','Imcosys Ltd','Imcosys LtdBundesstrasse 5Zug Zg 6300Switzerland',1),('00:19:28','Siemens Ag, Transportation Systems','Siemens Ag, Transportation SystemsWerner-von-siemens-strae 67Erlangen  91052Germany',1),('00:19:29','2m2b Montadora De Maquinas Bahia Brasil Ltda','2m2b Montadora De Maquinas Bahia Brasil LtdaRua Djalma Dutra, 668, Sete PortasSalvador Bahia 40240080Brazil',1),('00:19:2A','Antiope Associates','Antiope Associates18 Clay StreetFair Haven New Jersey 07704United States',1),('00:19:2B','Aclara Rf Systems Inc.','Aclara Rf Systems Inc.23905 Mercantile RdBeachwood Oh 44122United States',1),('00:19:2C','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:19:2D','Nokia Corporation','Nokia CorporationRensingstr. 15Bochum Nrw 44807Germany',1),('00:19:2E','Spectral Instruments, Inc.','Spectral Instruments, Inc.420 N Bonita AveTucson Az 85745United States',1),('00:19:2F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:30','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:31','Balluff Gmbh','Balluff GmbhSchurwaldstr. 9Neuhausen Bw 73765Germany',1),('00:19:32','Gude Analog- Und Digialsysteme Gmbh','Gude Analog- Und Digialsysteme GmbhEintrachstrasse 113Cologne Nrw 50668Germany',1),('00:19:33','Strix Systems, Inc.','Strix Systems, Inc.26610 Agoura RoadCalabasas Ca 91302United States',1),('00:19:34','Trendon Touch Technology Corp.','Trendon Touch Technology Corp.2f No.5, Alley 22, Lane 513, Rueiguang Rd., NeihuTaipei City  114Taiwan, Republic Of China',1),('00:19:35','Duerr Dental Gmbh & Co. Kg','Duerr Dental Gmbh & Co. KgHoepfigheimer Strasse 17Bietigheim-bissingen Baden-wuerttemberg 74321Germany',1),('00:19:36','Sterlite Optical Technologies Limited','Sterlite Optical Technologies LimitedE-1,e-2,&e-3Midc , WalujAurangabad Maharastra 431136India',1),('00:19:37','Commerceguard Ab','Commerceguard AbGustavslundsv 151aBromma  16714Sweden',1),('00:19:38','Umb Communications Co., Ltd.','Umb Communications Co., Ltd.1010, 5, Ace Techno Tower, 197-22, Guro-dong, Guro-guSeoul  151-766Korea, Republic Of',1),('00:19:39','Gigamips','Gigamips5th Floor, Yangjae Building, 261, Yangjae-dongSeocho-gu Seoul 137-130Korea, Republic Of',1),('00:19:3A','Oesolutions','OesolutionsTechnopark, 958-3 Daechon-dong, Buk-guGwangju Buk-gu 500-706Korea, Republic Of',1),('00:19:3B','Wilibox Deliberant Group Llc','Wilibox Deliberant Group Llc1440 Dutch Valley PlaceSuite 1155Atlanta Ga 30324United States',1),('00:19:3C','Highpoint Technologies Incorporated','Highpoint Technologies Incorporated1161 Cadillac CourtMilpitas Ca 95035United States',1),('00:19:3D','Gmc Guardian Mobility Corp.','Gmc Guardian Mobility Corp.Suite 20043 Auriga Dr.Ottawa On K2e 7y8Canada',1),('00:19:3E','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano  20126Italy',1),('00:19:3F','Rdi Technology(shenzhen) Co.,ltd','Rdi Technology(shenzhen) Co.,ltdBuilding C1&c2,  Xin Tang Industrial Zone,east Baishixia Village, Fuyong Town, Baoan DistrictShenzhen Guangdong Province 518103China',1),('00:19:40','Rackable Systems','Rackable Systems1933 Milmont DriveMilpitas Ca 95035United States',1),('00:19:41','Pitney Bowes, Inc','Pitney Bowes, Inc35 Waterview DriveMsc 26-21Shelton Ct 06484United States',1),('00:19:42','On Software International Limited','On Software International Limited9f, No. 17, Sec. 1, Cheng-te Rd.Taipei  103Taiwan, Republic Of China',1),('00:19:43','Belden','Belden793 Fort Mill HighwayFort Mill South Carolina 29715United States',1),('00:19:44','Fossil Partners, L.p.','Fossil Partners, L.p.2280 N. Greenville Ave.Richardson Tx 75082United States',1),('00:19:45','Ten-tec Inc.','Ten-tec Inc.1185 Dolly Parton PkwySevierville Tn 37862United States',1),('00:19:46','Cianet Industria E Comercio S/a','Cianet Industria E Comercio S/aRod Sc401, Km01 Tecnopolis/alfama 4o. AndarFlorianopolis Santa Catarina 88030-902Brazil',1),('00:19:47','Scientific Atlanta, A Cisco Company','Scientific Atlanta, A Cisco Company5030 Sugarloaf ParkwayAtl 1.3.473Lawrenceville Ga 30044United States',1),('00:19:48','Airespider Networks','Airespider Networks1171 Montague Express WayMilpitas Ca 95035United States',1),('00:19:49','Tentel  Comtech Co., Ltd.','Tentel  Comtech Co., Ltd.3/f., No. 42, Lane 80, Sec. 3, Nan-kang Rd.,Taipei  115Taiwan, Republic Of China',1),('00:19:4A','Testo Ag','Testo AgTesto Strasse 1Lenzkirch Baden-wrtemberg 79853Germany',1),('00:19:4B','Sagem Communication','Sagem Communication27 Rue LeblancParis  75512France',1),('00:19:4C','Fujian Stelcom Information & Technology Co.,ltd','Fujian Stelcom Information & Technology Co.,ltd4f,building A,start Science Park, No.68,hongshanyuan RdFuzhou Fujian 350002China',1),('00:19:4D','Avago Technologies Sdn Bhd','Avago Technologies Sdn BhdBayan Lepas Free Industrial ZoneBayan Lepas Penang 11900Malaysia',1),('00:19:4E','Ultra Electronics - Tcs (tactical Communication Systems)','Ultra Electronics - Tcs (tactical Communication Systems)5990 Cote De LiesseTmr Quebec H4t 1v7Canada',1),('00:19:4F','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:19:50','Harman Multimedia','Harman Multimedia8400 Balboa Blvd.Northridge Ca 91329United States',1),('00:19:51','Netcons, S.r.o.','Netcons, S.r.o.Stara Vajnorska 37Bratislava Slovakia 831 04Slovakia',1),('00:19:52','Acogito Co., Ltd','Acogito Co., Ltd#501 Shinyoung Palace Tower, 246-2, SeohyunSungnam Kyunggi 463-824Korea, Republic Of',1),('00:19:53','Chainleader Communications Corp.','Chainleader Communications Corp.5f, No. 400, Sec. 2 Bade Rd.,Taipei  105Taiwan, Republic Of China',1),('00:19:54','Leaf Corporation.','Leaf Corporation.Amuze 1fHigashi Naruse 35-10Isehara City Kanagawa-pref. 259-1117Japan',1),('00:19:55','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:56','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:57','Saafnet Canada Inc.','Saafnet Canada Inc.107-1089 East Kent Ave (n)Vancouver Bc V5x 4v9Canada',1),('00:19:58','Bluetooth Sig, Inc.','Bluetooth Sig, Inc.500 108th Avenue NeSuite 250Bellevue Wa 98004United States',1),('00:19:59','Staccato Communications Inc.','Staccato Communications Inc.6195 Lusk Blvd.San Diego Ca 92121United States',1),('00:19:5A','Jenaer Antriebstechnik Gmbh','Jenaer Antriebstechnik GmbhBuchaer Strasse 1Jena Thueringen 07745Germany',1),('00:19:5B','D-link Corporation','D-link CorporationNo.289, Sinhu 3rd Rd.,Neihu District, Taipei City 114Taiwan, Republic Of China',1),('00:19:5C','Innotech Corporation','Innotech Corporation3-17-6Shin-yokohama, Kohoku-kuYokohama Kanagawa 222-8580Japan',1),('00:19:5D','Shenzhen Xinhuatong Opto Electronics Co.,ltd','Shenzhen Xinhuatong Opto Electronics Co.,ltd5f,baodazhou,shancheng Industrial Zone,baoan DistrictShenzhen Guangdong 518108China',1),('00:19:5E','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:19:5F','Valemount Networks Corporation','Valemount Networks Corporation1201- 5th AvePo Box 687Valemount Bc V0e2z0Canada',1),('00:19:60','Docomo Systems, Inc.','Docomo Systems, Inc.Meguro Techno Bldg. 2nd Floor4-31-18 Nishi-gotandaShinagawa-ku Tokyo 141-0031Japan',1),('00:19:61','Blaupunkt Gmbh','Blaupunkt GmbhRobert-bosch-strasse 200Hildesheim Hessen 31139Germany',1),('00:19:62','Commerciant, Lp','Commerciant, Lp2901 WilcrestSuite 250Houston Texas 77042United States',1),('00:19:63','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Skne 221 88Sweden',1),('00:19:64','Doorking Inc.','Doorking Inc.120 Glasgow St.Inglewood Ca. 90301United States',1),('00:19:65','Yuhua Teltech (shanghai) Co., Ltd.','Yuhua Teltech (shanghai) Co., Ltd.Yuhua R&d Building,27 Xin Jin Qiao Road,Pudong,Shanghai  201206China',1),('00:19:66','Asiarock Technology Limited','Asiarock Technology LimitedP.o. Box957, Offshore Incorporations CentreRoad Town TortolaVirgin Islands, British',1),('00:19:67','Teldat Sp.j.','Teldat Sp.j.Kijowska 44Nip 554 19 26 042Bydgoszcz Woj. Kujawsko-pomorskie 85-703Poland',1),('00:19:68','Digital Video Networks(shanghai) Co. Ltd.','Digital Video Networks(shanghai) Co. Ltd.9th Floor,hechuan Building, No.1026 Yishan RdShanghai  201103China',1),('00:19:69','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:19:6A','Mikrom Gmbh','Mikrom GmbhDovestr. 1Berlin  10587Germany',1),('00:19:6B','Danpex Corporation','Danpex Corporation2114 Ringwood AvenueSan Jose California 95131United States',1),('00:19:6C','Etrovision Technology','Etrovision Technology2f, 19-5 San Chung Rd.,Block C, Nan Kang Software Park, Nan Kang District,Taipei  115Taiwan, Republic Of China',1),('00:19:6D','Raybit Systems Korea, Inc','Raybit Systems Korea, IncDream Tower 1221923-14, Mokdong, YangchunkuSeoul  158-718Korea, Republic Of',1),('00:19:6E','Metacom (pty) Ltd.','Metacom (pty) Ltd.6 Ndabeni Business ParkInyoni Str, NdabeniCape Town Western Cape 7405South Africa',1),('00:19:6F','Sensopart Gmbh','Sensopart GmbhAm Wiedenbach 1Wieden Baden-wuerttemberg D-79695Germany',1),('00:19:70','Z-com, Inc.','Z-com, Inc.7f-2, No.9, Prosperity 1st Rd.Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:19:71','Guangzhou Unicomp Technology Co.,ltd','Guangzhou Unicomp Technology Co.,ltd7/f,north Tower,jinshan Building.no.248Rd Wushan, Tianhe DistrictGuangzhou Guangdong 510630China',1),('00:19:72','Plexus (xiamen) Co.,ltd','Plexus (xiamen) Co.,ltdNo.6 Xiangxing 2 RoadXiangyu Free Trade ZoneXiamen Fujian 361006China',1),('00:19:73','Zeugma Systems','Zeugma SystemsSuite 25013571 Commerce ParkwayRichmond Bc V6v 2r2Canada',1),('00:19:74','Abocom Systems, Inc.','Abocom Systems, Inc.1f , No. 21, Yanfa 2nd Rd., SbipHsinchu City Hsinchu 300Taiwan, Republic Of China',1),('00:19:75','Beijing Huisen Networks Technology Inc','Beijing Huisen Networks Technology IncJia#2 Of Xili Of Baiyun Road,xicheng DistrictBeijing  100045China',1),('00:19:76','Xipher Technologies, Llc','Xipher Technologies, Llc156 River RoadWillington Ct 06279United States',1),('00:19:77','Aerohive Networks, Inc.','Aerohive Networks, Inc.3150-c Coronado DriveSanta Clara Ca 95054United States',1),('00:19:78','Datum Systems, Inc.','Datum Systems, Inc.3666 Tiffani Ct.Santa Cruz Ca 95065United States',1),('00:19:79','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:19:7A','Mazet Gmbh','Mazet GmbhGoeschwitzer Str. 32Jena  D-07745Germany',1),('00:19:7B','Picotest Corp.','Picotest Corp.8f-1, 286-9, Hsin-ya Rd., 80673Kaohsiung  80673Taiwan, Republic Of China',1),('00:19:7C','Riedel Communications Gmbh','Riedel Communications GmbhUellendahler Str. 353Wuppertal Nrw 42109Germany',1),('00:19:7D','Hon Hai Precision Ind. Co., Ltd','Hon Hai Precision Ind. Co., Ltd66, Chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:19:7E','Hon Hai Precision Ind. Co., Ltd','Hon Hai Precision Ind. Co., Ltd66, Chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:19:7F','Plantronics, Inc.','Plantronics, Inc.345 Encinal StreetSanta Cruz California 95060United States',1),('00:19:80','Gridpoint Systems','Gridpoint Systems4043 Carling Avenue, Suite 200Ottawa Ontario K2k 2a3Canada',1),('00:19:81','Vivox Inc','Vivox Inc40 Speen StreetSuite 402Framingham Ma 01701United States',1),('00:19:82','Smardtv','Smardtv531 Avenue Du SerpoletZe Athlia 2La Ciotat France 13 704France',1),('00:19:83','Cct R&d Limited','Cct R&d Limited18/f Cct Telecom Building11 Wo Shing StreetFotan, Shatin N.t. 0000Hong Kong',1),('00:19:84','Estic Corporation','Estic Corporation2-5-9 Hashibahigashino-choMoriguchi Osaka 570-0031Japan',1),('00:19:85','It Watchdogs, Inc','It Watchdogs, Inc12885 Research, Suite 210bAustin Tx 78750United States',1),('00:19:86','Cheng Hongjian','Cheng HongjianRm.2305b.sege Plaza,huaqiang North Rd.,FutianShenzhen Guangdong 518057China',1),('00:19:87','Panasonic Mobile Communications Co., Ltd.','Panasonic Mobile Communications Co., Ltd.600 Saedo-cho, Tsuzuki-ku,Yokohama City Kanagawa Prefecture 224-8539Japan',1),('00:19:88','Wi2wi, Inc','Wi2wi, Inc2107 N. 1st StreetSuite 540San Jose Ca 95131United States',1),('00:19:89','Sonitrol Corporation','Sonitrol Corporation1707 Orlando Central Pkwy.Suite 500Orlando Fl 32809United States',1),('00:19:8A','Northrop Grumman Systems Corp.','Northrop Grumman Systems Corp.7055 Troy Hill DriveElkridge Maryland 21075United States',1),('00:19:8B','Novera Optics Korea, Inc.','Novera Optics Korea, Inc.463-1 Jeon Min Dong Yuseong GuDeajeon  305-811Korea, Republic Of',1),('00:19:8C','Ixsea','Ixsea55 Av Auguste RenoirMarly Le Roi  78160France',1),('00:19:8D','Ocean Optics, Inc.','Ocean Optics, Inc.830 Douglas AveDunedin Fl 34698United States',1),('00:19:8E','Oticon A/s','Oticon A/sKongebakken 9Smrum  2765Denmark',1),('00:19:8F','Alcatel Bell N.v.','Alcatel Bell N.v.Copernicuslaan 50Antwerp  B-2018Belgium',1),('00:19:90','Elm Data Co., Ltd.','Elm Data Co., Ltd.2-15 Techno-park 1-chomeShimonopporo, Atsubetsu-kuSapporo Hokkaido 004-0015Japan',1),('00:19:91','Avinfo','AvinfoJiahuiyuan 703,huaao Center,31# Zizhuyuan Road,Haidian DistrictBeijing  100089China',1),('00:19:92','Bluesocket, Inc','Bluesocket, Inc10 North AveBurlington Ma 01803United States',1),('00:19:93','Changshu Switchgear Mfg. Co.,ltd. (former Changshu Switchgea','Changshu Switchgear Mfg. Co.,ltd. (former Changshu SwitchgeaNo. 8 Jianye RoadChangshu Jiangsu 215500China',1),('00:19:94','Jorjin Technologies Inc.','Jorjin Technologies Inc.5f, No.28, Lane141, Sing-ai Rd.Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:19:95','Jurong Hi-tech (suzhou)co.ltd','Jurong Hi-tech (suzhou)co.ltd275,xing Long Streetsuzhou Indudtrial ParkSuzhou Jiang Su 215021China',1),('00:19:96','Turbochef Technologies Inc.','Turbochef Technologies Inc.4240 International ParkwaySuite 105Carrollton Texas 75007United States',1),('00:19:97','Soft Device Sdn Bhd','Soft Device Sdn Bhd67-2 Jalan 2/27fKlsc Wangsa MajuKuala Lumpur Wp 53300Malaysia',1),('00:19:98','Sato Corporation','Sato Corporation1-207,onari-cho,Omiya-kuSaitama-shi Saitama 330-0852Japan',1),('00:19:99','Fujitsu Siemens Computers','Fujitsu Siemens ComputersBuergermeister-ulrich-strasse 100Augsburg  86199Germany',1),('00:19:9A','Edo-evi','Edo-evi7065 Columbia Gateway Dr.Columbia Md 21046United States',1),('00:19:9B','Diversified Technical Systems, Inc.','Diversified Technical Systems, Inc.909 Electric AvenueSuite 206Seal Beach California 90740United States',1),('00:19:9C','Ctring','Ctring#514, World Meridian Venture Center IiGasna-dongKeumcheon-gu Seoul 153-803Korea, Republic Of',1),('00:19:9D','Vizio, Inc.','Vizio, Inc.39 TeslaIrvine Ca 92618United States',1),('00:19:9E','Showadenshi Electronics,inc.','Showadenshi Electronics,inc.1978 Hirooka-nomuraShiojiri-city Nagano-pref. 399-0702Japan',1),('00:19:9F','Dkt A/s','Dkt A/sFanoevej 6Kr. Saaby  Dk-4060Denmark',1),('00:19:A0','Nihon Data Systens, Inc.','Nihon Data Systens, Inc.6-9, Koyo-cho NakaHigashinada-kuKobe-shi Hyogo 658-0032Japan',1),('00:19:A1','Lg Information & Comm.','Lg Information & Comm.60-39,kasan-dong,kumchon-kuSeoul  153-023Korea, Republic Of',1),('00:19:A2','Orion Tele-equipments Pvt Ltd','Orion Tele-equipments Pvt Ltd# 355/65/3, Sarjapura Main RoadAgaraBangalore - 560 034 Karnatana 560 034India',1),('00:19:A3','Asteel Electronique Atlantique','Asteel Electronique AtlantiqueZa De La Lande De Saint JeanBp 90111Sainte Marie De Redon  35600France',1),('00:19:A4','Austar Technology (hang Zhou) Co.,ltd','Austar Technology (hang Zhou) Co.,ltd19-c,bld A,paradise Software ParkNo.3,xi Doumen Rd.Hang Zhou Zhe Jiang 310012China',1),('00:19:A5','Radarfind Corporation','Radarfind Corporation2 Davis DriveResearch Triangle Park Nc 27709United States',1),('00:19:A6','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:19:A7','Itu-t','Itu-tPlace Des NationsGeneva 20  Ch-1211Switzerland',1),('00:19:A8','Wiquest Communications','Wiquest Communications915 Enterprise Blvd.Suite 200Allen Texas 75013United States',1),('00:19:A9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:AA','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:AB','Raycom Co ., Ltd','Raycom Co ., LtdA,3-4/fl, Building 1,27 Chuangxin Road,Changping Science ParkBeijing  102200China',1),('00:19:AC','Gsp Systems Inc.','Gsp Systems Inc.13fl, 101 Dong, Chunui Techno Park 1,200-1, Chunui-dong, Wonmi-gu,Bucheon-city Gyeonggi-do 420-857Korea, Republic Of',1),('00:19:AD','Bobst Sa','Bobst SaRte Des Flumeaux 50Case Postale 1001 LausannePrilly Vd 1008Switzerland',1),('00:19:AE','Hopling Technologies B.v.','Hopling Technologies B.v.Camerastraat 10Almere Flevoland 1322 BcNetherlands',1),('00:19:AF','Rigol Technologies, Inc.','Rigol Technologies, Inc.No. 156 Cai He Village, Sha He TownChang Ping DistrictBeijing  102206China',1),('00:19:B0','Hanyang System','Hanyang System701ho, Kofomo Techno Center Ii, 1289-5Jungwang-dongShihung-shi Kyunggi-do 429-850Korea, Republic Of',1),('00:19:B1','Arrow7 Corporation','Arrow7 CorporationKamijima 3-27-7Hamamatsu Shizuoka 433-8122Japan',1),('00:19:B2','Xynetsoft Co.,ltd','Xynetsoft Co.,ltdNo.158zhenyu Street High Industries Development AreaChangchun Jilin 130000China',1),('00:19:B3','Stanford Research Systems','Stanford Research Systems1290-d Reamwood AveSunnyvale Ca 94089United States',1),('00:19:B4','Videocast Ltd.','Videocast Ltd.Gyarmat U. 99/bBudapest  1147Hungary',1),('00:19:B5','Famar Fueguina S.a.','Famar Fueguina S.a.Rodney 70Buenos Aires  1427Argentina',1),('00:19:B6','Euro Emme S.r.l.','Euro Emme S.r.l.Via Belvedere, 24Galliate Lombardo Varese 21020Italy',1),('00:19:B7','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:19:B8','Boundary Devices','Boundary Devices7200 W. OaklandChandler Az 85226United States',1),('00:19:B9','Dell Inc.','Dell Inc.One Dell WayMs 8545Round Rock Tx 78682United States',1),('00:19:BA','Paradox Security Systems Ltd','Paradox Security Systems Ltd780 Industrial BlvdSt-eustache Quebec J7r 5v3Canada',1),('00:19:BB','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms060308Houston Tx 77070United States',1),('00:19:BC','Electro Chance Srl','Electro Chance SrlCarhue 3179Av. Eva Peron 7049Capital Federal Buenos Aires 1440Argentina',1),('00:19:BD','New Media Life','New Media LifeHea Ju Bild, 5f, 837-7, Yeoksam-dongKangnam-gu Seoul 135-080Korea, Republic Of',1),('00:19:BE','Altai Technologies Limited','Altai Technologies LimitedUnit 103b And 105, 1/f, Block 9,Hong Kong Science ParkShatin New TerritoriesHong Kong',1),('00:19:BF','Citiway Technology Co.,ltd','Citiway Technology Co.,ltdNo.2 Building,jia 32,beiheyan Avenue,east CityPeijing  100006China',1),('00:19:C0','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:19:C1','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, Okinouchi,Soma-city Fukushima-pref. 976-8501Japan',1),('00:19:C2','Equustek Solutions, Inc.','Equustek Solutions, Inc.#286 - 5489 Byrne Road,Burnaby Bc V5j 3j1Canada',1),('00:19:C3','Qualitrol','QualitrolWildflower WayApollo RoadBelfast Co. Antrim Bt12 6taUnited Kingdom',1),('00:19:C4','Infocrypt Inc.','Infocrypt Inc.711, Byucksan Digital Valley 1 212-16,Guro-guSeoul  152-050Korea, Republic Of',1),('00:19:C5','Sony Computer Entertainment Inc,','Sony Computer Entertainment Inc,6-21,2chomeMinami-aoyamaMinato-ku Tokyo 107-0062Japan',1),('00:19:C6','Zte Corporation','Zte CorporationTechnology Management Department, Zte Corporation12/f., Zte R&d Building, Kejinan RoadShenzhen Guangdong 518057China',1),('00:19:C7','Cambridge Industries(group) Co.,ltd.','Cambridge Industries(group) Co.,ltd.Room 309,333 Hong Qiao RoadShanghai  200030China',1),('00:19:C8','Anydata Corporation','Anydata Corporation18902 Bardeen Ave.Irvine Ca 91612United States',1),('00:19:C9','S&c Electric Company','S&c Electric Company1135 Atlantic AveAlameda Ca 94501United States',1),('00:19:CA','Broadata Communications, Inc','Broadata Communications, Inc2545 W 237th St Ste KTorrance Ca 90505United States',1),('00:19:CB','Zyxel Communications Corporation','Zyxel Communications CorporationNo. 6, Innovation Road IiHsinchu Science Park, Hsinchu 300Hsinchu  300Taiwan, Republic Of China',1),('00:19:CC','Rcg (hk) Ltd','Rcg (hk) Ltd9/f., Core C, Cyberport 3100 Cyberport RdHong Kong',1),('00:19:CD','Chengdu Ethercom Information Technology Ltd.','Chengdu Ethercom Information Technology Ltd.South Extension Of Tianfu Wide Road No.7 Department Room 201Chengdu Sichuan 610041China',1),('00:19:CE','Progressive Gaming International','Progressive Gaming International920 Pilot RoadLas Vegas Nv 89119United States',1),('00:19:CF','Salicru, S.a.','Salicru, S.a.Av. Serra , 100Sta.ma.palautordera Barcelona 08460Spain',1),('00:19:D0','Cathexis','CathexisPo Box 1091Umhlanga RocksDurban Kwazulu Natal 4320South Africa',1),('00:19:D1','Intel Corporation','Intel CorporationLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:19:D2','Intel Corporation','Intel CorporationLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:19:D3','Trak Microwave','Trak Microwave4726 Eisenhower BlvdTampa Fl 33634United States',1),('00:19:D4','Icx Technologies','Icx Technologies3440 Francis-hughesSuite 120Laval Quebec H7l 5a9Canada',1),('00:19:D5','Ip Innovations, Inc.','Ip Innovations, Inc.1517 146th AveDorr Mi 49323United States',1),('00:19:D6','Ls Cable Ltd.','Ls Cable Ltd.12f Ls Tower, 1026-6, Hogey-dongAnyang-si Gyeonggi-do 431-080Korea, Republic Of',1),('00:19:D7','Fortunetek Co., Ltd','Fortunetek Co., Ltd12f, No. 75, Sec 1, Chongqing S. Rd.,Zhongzheng DistrictTaipei  100Taiwan, Republic Of China',1),('00:19:D8','Maxfor','Maxfor#e 809, Bundang, Techno-parkYatap-dong, Bungdang-guSeongnam-city Gyeonggi-do 463-760Korea, Republic Of',1),('00:19:D9','Zeutschel Gmbh','Zeutschel GmbhHeerweg 2Tbingen-hirschau Bw D-72070Germany',1),('00:19:DA','Welltrans O&e Technology Co. , Ltd.','Welltrans O&e Technology Co. , Ltd.The 3rd Floor, Building C-d, Hi-tech Digital Harbor, Guandong Industrial ParkWuhan Hubei 430074China',1),('00:19:DB','Micro-star International Co., Ltd.','Micro-star International Co., Ltd.No. 69, Li-de St., Jung-he CityTaipei Hsien  235Tuvalu',1),('00:19:DC','Enensys Technologies','Enensys TechnologiesLe Germanium80 Avenue Des Buttes De CosmesRennes Brittany 35700France',1),('00:19:DD','Fei-zyfer, Inc.','Fei-zyfer, Inc.1515 S. ManchesterAnaheim Ca 92802United States',1),('00:19:DE','Mobitek','Mobitek5f,no.60,lane 321,yang-kwang StreetTaipei  114Taiwan, Republic Of China',1),('00:19:DF','Thomson Inc.','Thomson Inc.101 West 103rd StreetIndianapolis In 46290-1102United States',1),('00:19:E0','Tp-link Technologies Co., Ltd.','Tp-link Technologies Co., Ltd.South Building, No.5 Keyuan RoadCentral Zone, Science & Technology ParkNanshan Shenzhen 518057China',1),('00:19:E1','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:19:E2','Juniper Networks','Juniper Networks1194 N. Mathilda Ave.Sunnyvale Ca 94089United States',1),('00:19:E3','Apple Computer Inc.','Apple Computer Inc.1 Infinite LoopCupertino California 95014United States',1),('00:19:E4','2wire, Inc','2wire, Inc1704 Automation ParkwaySan Jose Ca 95131United States',1),('00:19:E5','Lynx Studio Technology, Inc.','Lynx Studio Technology, Inc.1540 Barton Rd # 268Redlands Ca 92373United States',1),('00:19:E6','Toyo Medic Co.,ltd.','Toyo Medic Co.,ltd.1-17-22 Kitahorie, Nishi-kuOsaka  550-0014Japan',1),('00:19:E7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:E8','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:19:E9','S-information Technolgy, Co., Ltd.','S-information Technolgy, Co., Ltd.Sungwoo Bldg, 717-3 Suseo-dong,Gangnam-gu,Seoul  135-884Korea, Republic Of',1),('00:19:EA','Teramage Technologies Co., Ltd.','Teramage Technologies Co., Ltd.Golden Land Building Suite 90732 Liang Ma Bridge RoadBeijing  100016China',1),('00:19:EB','Pyronix Ltd','Pyronix LtdBraithwell WayHellabyRotherham South Yorkshire S66 8qyUnited Kingdom',1),('00:19:EC','Sagamore Systems, Inc.','Sagamore Systems, Inc.55 Middlesex StreetSuite 217North Chelmsford Ma 01863United States',1),('00:19:ED','Axesstel Inc.','Axesstel Inc.6815 Flanders Sr.Ste 210San Diego Ca 92121United States',1),('00:19:EE','Carlo Gavazzi Controls Spa-controls Division','Carlo Gavazzi Controls Spa-controls DivisionVia Safforze 8Belluno Bl I-32100Italy',1),('00:19:EF','Shenzhen Linnking Electronics Co.,ltd','Shenzhen Linnking Electronics Co.,ltdRoom 901,b Block,qinghua Information Center Hi-tec Park North District,nanshan District,shenzhenShenzhen Guangdong 518057China',1),('00:19:F0','Unionman Technology Co.,ltd','Unionman Technology Co.,ltd18f, Huayang Tower,yandayi RoadHuizhou Guangdong 516007China',1),('00:19:F1','Star Communication Network Technology Co.,ltd','Star Communication Network Technology Co.,ltd10/f,tower B,soho New Town,no.88 Jianguoroad,chaoyang DistrictBeijing  100022China',1),('00:19:F2','Teradyne K.k.','Teradyne K.k.272-13, Heisei, TakaonoOzu-machiKikuchi-gun Kumamoto 869-1232Japan',1),('00:19:F3','Telematrix, Inc','Telematrix, Inc5025 Galley RdColorado Springs Co 80915United States',1),('00:19:F4','Convergens Oy Ltd','Convergens Oy LtdWestendintie 99 BEspoo Uusimaa Fin-02160Finland',1),('00:19:F5','Imagination Technologies Ltd','Imagination Technologies Ltd23 The CallsLeeds West Yorkshire Ls2 7ehUnited Kingdom',1),('00:19:F6','Acconet (pte) Ltd','Acconet (pte) LtdNo. 16 Ayer Rajah Crescent# 03-03Singapore  139965Singapore',1),('00:19:F7','Onset Computer Corporation','Onset Computer CorporationP.o. Box 3450Pocasset Ma 02559United States',1),('00:19:F8','Embedded Systems Design, Inc.','Embedded Systems Design, Inc.6810 Deerpath RoadSuite 300Elkridge Md 21075United States',1),('00:19:F9','Tdk-lambda','Tdk-lambda405 Essex RoadNeptune Nj 07753United States',1),('00:19:FA','Cable Vision Electronics Co., Ltd.','Cable Vision Electronics Co., Ltd.12f-3, No.16, Chien Pa Rd.Chung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:19:FB','Amstrad Plc','Amstrad Plc169 Kings RoadBrentwood Essex Cm14 4efUnited Kingdom',1),('00:19:FC','Pt. Ufoakses Sukses Luarbiasa','Pt. Ufoakses Sukses LuarbiasaJl. Sultan Hasanudin No. 41Kebayoran BaruJakarta Selatan Dki Jakarta 12160Indonesia',1),('00:19:FD','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:19:FE','Shenzhen Seecomm Technology Co.,ltd.','Shenzhen Seecomm Technology Co.,ltd.Room 609,404yannan RoadShenzhen Guangdong 518031China',1),('00:19:FF','Finnzymes','Finnzymes800 West Cummings ParkSuite 5550Woburn Ma 01801United States',1),('00:1A:00','Matrix Inc.','Matrix Inc.As Bld.3-13-20Nishi-temma Kita-kuOsaka  530-0047Japan',1),('00:1A:01','Smiths Medical','Smiths Medical4350 Rivergreen ParkwaySuite 200Duluth Ga 30096United States',1),('00:1A:02','Secure Care Products, Inc','Secure Care Products, Inc39 Chenell DriveConcord Nh 03301United States',1),('00:1A:03','Angel Electronics Co., Ltd.','Angel Electronics Co., Ltd.17, Lane 134, Shou Shan Road, Tai Shan,Taipei  243Taiwan, Republic Of China',1),('00:1A:04','Interay Solutions Bv','Interay Solutions BvMr. W.m. Oppedijk Van Veenweg 8Burgum Friesland 9251 GaNetherlands',1),('00:1A:05','Optibase Ltd','Optibase Ltd7 Shankar St.Herzliya Israel 46120Israel',1),('00:1A:06','Opvista, Inc.','Opvista, Inc.870 North Mccarthy Blvd.Milpitas California 95035United States',1),('00:1A:07','Arecont Vision','Arecont Vision2400 N. Lincoln AveAltadena Ca 91001United States',1),('00:1A:08','Dalman Technical Services','Dalman Technical Services36 Duke CloseWest WayAndover Hampshire Sp10 5apUnited Kingdom',1),('00:1A:09','Wayfarer Transit Systems Ltd','Wayfarer Transit Systems Ltd10 Willis WayFleets Insdustrial EstPoole Dorset Bh15 3ssUnited Kingdom',1),('00:1A:0A','Adaptive Micro-ware Inc.','Adaptive Micro-ware Inc.6917 Innovation BlvdFort Wayne In 46818United States',1),('00:1A:0B','Bona Technology Inc.','Bona Technology Inc.4f, E-place Bldg., 719-24Yeoksam-dong, Gangnam-gu,Seoul  135-080Korea, Republic Of',1),('00:1A:0C','Swe-dish Satellite Systems Ab','Swe-dish Satellite Systems AbTorggatan 15Solna Stockholm Se-171 06Sweden',1),('00:1A:0D','Handheld Entertainment, Inc.','Handheld Entertainment, Inc.539 Bryant Street, Suite 403San Francisco Ca 94103United States',1),('00:1A:0E','Cheng Uei Precision Industry Co.,ltd','Cheng Uei Precision Industry Co.,ltdJunda Industry District, Dongkeng Town,dongguan CityDongguan Guang Dong 523455China',1),('00:1A:0F','Sistemas Avanzados De Control, S.a.','Sistemas Avanzados De Control, S.a.Calle Colquide 6Las Rozas Madrid 28230Spain',1),('00:1A:10','Lucent Trans Electronics Co.,ltd','Lucent Trans Electronics Co.,ltd9f-1,no.16,chien Pah Rd.Chung Ho Taipei 235Taiwan, Republic Of China',1),('00:1A:11','Google Inc.','Google Inc.1600 Amphitheater ParkwayMountain View Ca 94043United States',1),('00:1A:12','Essilor','Essilor64 Bis Avenue Aubert94300 VincennesFrance',1),('00:1A:13','Wanlida Group Co., Ltd','Wanlida Group Co., LtdJiahe Road No.618Xiamen Fujian 361006China',1),('00:1A:14','Xin Hua Control Engineering Co.,ltd.','Xin Hua Control Engineering Co.,ltd.160 Wenjing Rd., MinhangShanghai  2000245China',1),('00:1A:15','Gemalto E-payment','Gemalto E-payment6 Rue De La VerrerieMeudon  92197France',1),('00:1A:16','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1A:17','Teak Technologies, Inc.','Teak Technologies, Inc.2901 Tasman Dr., Ste. #210Santa Clara Ca 95054United States',1),('00:1A:18','Advanced Simulation Technology Inc.','Advanced Simulation Technology Inc.500a Huntmar Park DriveHerndon Va 20170United States',1),('00:1A:19','Computer Engineering Limited','Computer Engineering LimitedPo Box 26-25EpsomAuckland Ak 1344New Zealand',1),('00:1A:1A','Gentex Corporation/electro-acoustic Products','Gentex Corporation/electro-acoustic Products2456 Brown AvenueManchester Nh 03103United States',1),('00:1A:1B','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:1A:1C','Gt&t Engineering Pte Ltd','Gt&t Engineering Pte Ltd2 Ang Mo Kio St.64, Econ Building, #04-00Singapore 569084Singapore',1),('00:1A:1D','Pchome Online Inc.','Pchome Online Inc.11f, 105, Sec. 2, Tun-hwa S. Rd.Taipei 106Taiwan, Republic Of China',1),('00:1A:1E','Aruba Networks','Aruba Networks1322 Crossman AvSunnyvale Ca 94089United States',1),('00:1A:1F','Coastal Environmental Systems','Coastal Environmental Systems820 First Avenue SouthSeattle Wa 98134United States',1),('00:1A:20','Cmotech Co. Ltd.','Cmotech Co. Ltd.5f Etronix Bldg. 17-10Yoido-dongYoungdungpo-gu Seoul 150-874Korea, Republic Of',1),('00:1A:21','Indac B.v.','Indac B.v.Institutenweg 15aEnschede Overijssel 7521 PhNetherlands',1),('00:1A:22','Eq-3 Gmbh','Eq-3 GmbhMaiburger Str. 32-36Leer Niedersachsen D-26789Germany',1),('00:1A:23','Ice Qube, Inc','Ice Qube, Inc141 Wilson AveGreensburg Pa 15601United States',1),('00:1A:24','Galaxy Telecom Technologies Ltd','Galaxy Telecom Technologies LtdNo.25, The 1st Gaoxin RoadXian City Shannxi 710075China',1),('00:1A:25','Delta Dore','Delta DoreBonnemainCombourg Bretagne 35 35270France',1),('00:1A:26','Deltanode Solutions Ab','Deltanode Solutions AbBox 92 184Stockholm  120 09Sweden',1),('00:1A:27','Ubistar','Ubistar8f, Seongdo Building, 587-23Sinsa-dong, Gangnam-guSeoul  135-747Korea, Republic Of',1),('00:1A:28','Aswt Co., Ltd. Taiwan Branch H.k.','Aswt Co., Ltd. Taiwan Branch H.k.7f., No.3 Lane 91, Dongmei Rd.Hsinchu  30070Taiwan, Republic Of China',1),('00:1A:29','Techsonic Industries D/b/a Humminbird','Techsonic Industries D/b/a Humminbird1220 Old Alpharetta RdSuite 340Alpharetta Ga 30041United States',1),('00:1A:2A','Arcadyan Technology Corporation','Arcadyan Technology Corporation4f., No. 9 , Park Avenue Ii,Science-based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:1A:2B','Ayecom Technology Co., Ltd.','Ayecom Technology Co., Ltd.No. 25, R&d Road 2, Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:1A:2C','Satec Co.,ltd','Satec Co.,ltd358-4, Palgok2-dong, Sangnok-guAnsan-si Kyungki-do 426-190Korea, Republic Of',1),('00:1A:2D','The Navvo Group','The Navvo Group4400 Baker RoadMinnetonka Mn 55343United States',1),('00:1A:2E','Ziova Coporation','Ziova CoporationUnit 3, 7-9 Sherriffs RoadLonsdale S.a. 5160Australia',1),('00:1A:2F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:30','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:31','Scan Coin Industries Ab','Scan Coin Industries AbJagershillgatan 26Malmoe Skane 21375Sweden',1),('00:1A:32','Activa Multimedia','Activa MultimediaSicp CseSant Joan Despi Barcelona 08970Spain',1),('00:1A:33','Asi Communications, Inc.','Asi Communications, Inc.1042 E Guadalupe RdTempe Az 85283United States',1),('00:1A:34','Konka Group Co., Ltd.','Konka Group Co., Ltd.Oversea Chinese Town,nanshan,Shenzhen Guangdong 518053China',1),('00:1A:35','Bartec Gmbh','Bartec GmbhSchulstr. 30Gotteszell Bavaria 94239Germany',1),('00:1A:36','Aipermon Gmbh & Co. Kg','Aipermon Gmbh & Co. KgZamdorfer Str. 100MunchenMunich Bavaria D-81677Germany',1),('00:1A:37','Lear Corporation','Lear CorporationIndustriestrasse 48Kronach Bayern 96317Germany',1),('00:1A:38','Sanmina-sci','Sanmina-sci13000 South Memorial ParkwayHuntsville Al 35803United States',1),('00:1A:39','Merten Gmbh&cokg','Merten Gmbh&cokgFritz-kotz-str. 8Wiehl Nrw 51674Germany',1),('00:1A:3A','Dongahelecomm','Dongahelecomm678-3,jeil-ri,yanggi-myun,cheoin-guYongin-si Gyeonggi-do 449-821Korea, Republic Of',1),('00:1A:3B','Doah Elecom Inc.','Doah Elecom Inc.8th Fl. Century Plaza, 277-40Sungsu-2ga 3dongSeoul  133-123Korea, Republic Of',1),('00:1A:3C','Technowave Ltd.','Technowave Ltd.Sakurai Bldg.1f,1-35-6 NakachoMusashino-shi Tokyo 180-0006Japan',1),('00:1A:3D','Ajin Vision Co.,ltd','Ajin Vision Co.,ltd1404, Mario-tower, 222-12Guro-dong, Guro-guSeoul  152-050Korea, Republic Of',1),('00:1A:3E','Faster Technology Llc','Faster Technology Llc1812 Avenue DSuite 202Katy Texas 77493United States',1),('00:1A:3F','Intelbras','IntelbrasRodovia Br 101 Km 210IntelbrasSao Jose Sc 88104800Brazil',1),('00:1A:40','A-four Tech Co., Ltd.','A-four Tech Co., Ltd.6f, No. 108, Min-chuan Rd.,Hsin-tien Taipei 23141Taiwan, Republic Of China',1),('00:1A:41','Inocova Co.,ltd','Inocova Co.,ltd5f Seoul Bd.736-17Yeoksam-dong, Kangnam-ku Seoul 135-924Korea, Republic Of',1),('00:1A:42','Techcity Technology Co., Ltd.','Techcity Technology Co., Ltd.4f, No. 4, Alley 1, Szu Wei Lane, Chung Cheng Rd.,Hsin Tein City Taipei Hsien 231Taiwan, Republic Of China',1),('00:1A:43','Logical Link Communications','Logical Link Communications1909 Central Drive Suite 205Bedford Tx 76021United States',1),('00:1A:44','Jwtrading Co., Ltd','Jwtrading Co., Ltd1590 Kwanyang-dong, Dongan-kuAhnyang Kyungki - Do 431-060Korea, Republic Of',1),('00:1A:45','Gn Netcom As','Gn Netcom AsMetalbuen 66P.o.box 201Ballerup Skovlunde Dk - 2750Denmark',1),('00:1A:46','Digital Multimedia Technology Co., Ltd','Digital Multimedia Technology Co., LtdDoorim Bldg, 3rd Fl, 164-21 Poi-dong,Seoul Kangnam-gu 135-960Korea, Republic Of',1),('00:1A:47','Agami Systems, Inc.','Agami Systems, Inc.1269 Innsbruck DriveSunnyvale California 94089United States',1),('00:1A:48','Takacom Corporation','Takacom Corporation304-709 Aza-nishiyanmaOroshi-choToki-shi Gifu-ken 509-5202Japan',1),('00:1A:49','Micro Vision Co.,ltd','Micro Vision Co.,ltd1-9-15Kandouji MinamiNiigata-city Niigata-ken 950-0986Japan',1),('00:1A:4A','Qumranet Inc.','Qumranet Inc.530 Lakeside DriveSuite 220Sunnyvale California 94085United States',1),('00:1A:4B','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms060308Houston Tx 77070United States',1),('00:1A:4C','Crossbow Technology, Inc','Crossbow Technology, Inc4145 N. First StreetSan Jose Ca 95134United States',1),('00:1A:4D','Giga-byte Technology Co.,ltd.','Giga-byte Technology Co.,ltd.',1),('00:1A:4E','Nti Ag / Linmot','Nti Ag / LinmotHaerdlistrasse 15Spreitenbach Ag 8957Switzerland',1),('00:1A:4F','Avm Gmbh','Avm GmbhAlt-moabit 95Berlin  10559Germany',1),('00:1A:50','Pheenet Technology Corp.','Pheenet Technology Corp.Rm. 3, 20f, No. 79, Sec. 1 Hsin Tai Wu Rd.Hsi-chih Taipei 221Taiwan, Republic Of China',1),('00:1A:51','Alfred Mann Foundation','Alfred Mann FoundationP.o. Box 905Santa Clarita Ca 91380-9005United States',1),('00:1A:52','Meshlinx Wireless Inc.','Meshlinx Wireless Inc.1410 G Avenue, Suite TPlano Texas 75074United States',1),('00:1A:53','Zylaya','Zylaya444 N. Frederick Ave.Suite 318Gaithersburg Md 20877United States',1),('00:1A:54','Hip Shing Electronics Ltd.','Hip Shing Electronics Ltd.Unit 1/2/3, 20/f, New Treasure Center10 Ng Fong Street, San Po Kong, KowloonHong Kong',1),('00:1A:55','Aca-digital Corporation','Aca-digital Corporation17 F, No. 866-7, Chung Cheng Rd.,Chung Ho City Taipei County 23586Taiwan, Republic Of China',1),('00:1A:56','Viewtel Co,. Ltd.','Viewtel Co,. Ltd.#b-502,bundang Techno Park 148Yatap-dongBundang-ku, Seongnam-si Gyeonggi-do 463-760Korea, Republic Of',1),('00:1A:57','Matrix Design Group, Llc','Matrix Design Group, Llc5741 Prospect Dr.Newburgh In 47630United States',1),('00:1A:58','Celectronic Gmbh','Celectronic GmbhNordlichtstrasse 63Berlin  D-13405Germany',1),('00:1A:59','Ircona','IrconaUnit 4b-1, Corporate ParkBlanchardstown Dublin 15Ireland',1),('00:1A:5A','Korea Electric Power Data Network  (kdn) Co., Ltd','Korea Electric Power Data Network  (kdn) Co., Ltd665 Naeson-dong,Gyeonggi-do Uiwang-si, Naeson-dong 437-082Korea, Republic Of',1),('00:1A:5B','Netcare Service Co., Ltd.','Netcare Service Co., Ltd.5-13-16 Shimizu, Asahi-kuOsaka  535-0021Japan',1),('00:1A:5C','Euchner Gmbh+co. Kg','Euchner Gmbh+co. KgKohlhammerstr. 16Leinfelden-echterdingen Bw 70771Germany',1),('00:1A:5D','Mobinnova Corp.','Mobinnova Corp.11f, 845, Chung Shan RdTaoyuan  33059Taiwan, Republic Of China',1),('00:1A:5E','Thincom Technology Co.,ltd','Thincom Technology Co.,ltd17f-3, No.398, Huanbei Rd.,Zhongli City Taoyuan Contry 320Taiwan, Republic Of China',1),('00:1A:5F','Kitworks.fi Ltd.','Kitworks.fi Ltd.SnowpolisVuokatti Kainuu 88610Finland',1),('00:1A:60','Wave Electronics Co.,ltd.','Wave Electronics Co.,ltd.3th Fl.,daesan Plaza B/d,guun-dong, 12-1,gwonseon-guSuwon-si Kyeonggi-do 441-814Korea, Republic Of',1),('00:1A:61','Pacstar Corp.','Pacstar Corp.15055 Sw Sequoia Pkwy, Suite 100Portland Or 97006United States',1),('00:1A:62','Data Robotics, Incorporated','Data Robotics, Incorporated1881 Landings DrMountain View Ca 94043United States',1),('00:1A:63','Elster Electricity, Llc','Elster Electricity, Llc208 South Rogers LaneRaleigh Nc 27610United States',1),('00:1A:64','Ibm Corp.','Ibm Corp.3039 E Cornwallis RdP.o. Box 12195Research Triangle Park Nc 27709-2195United States',1),('00:1A:65','Seluxit','SeluxitNyhavnsgade 9, 2.salAalborg Nord Jylland 9000Denmark',1),('00:1A:66','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1A:67','Infinite Ql Sdn Bhd','Infinite Ql Sdn BhdG.02, Block A, Dataran HamodalNo.4, Jalan 13/4, Sect. 13,Petaling Jaya Selangor Darul Ehsan 46300Malaysia',1),('00:1A:68','Weltec Enterprise Co., Ltd.','Weltec Enterprise Co., Ltd.2f, No. 351 Yung Ho Rd.Taipei HsienChung Ho  235Taiwan, Republic Of China',1),('00:1A:69','Wuhan Yangtze Optical Technology Co.,ltd.','Wuhan Yangtze Optical Technology Co.,ltd.4#,guanshan 2 RoadWuhan Hubei 430073China',1),('00:1A:6A','Tranzas, Inc.','Tranzas, Inc.Queens Tower C17Minatomirai 2-3-5 Nishi-kuYokohama Kanagawa-ken 220-6217Japan',1),('00:1A:6B','Usi','Usi141, Lane 351, Taiping Rd.Sec.1, Tsao Tuen,Nan-tou  542Taiwan, Republic Of China',1),('00:1A:6C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:6D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:6E','Impro Technologies','Impro Technologies47b Gillits RdPinetown Kwazulu-natal 3610South Africa',1),('00:1A:6F','Mi.tel S.r.l.','Mi.tel S.r.l.Via Guido Rossa, 22Cornate Dadda Milano 20040Italy',1),('00:1A:70','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92612United States',1),('00:1A:71','Diostech Co., Ltd.','Diostech Co., Ltd.151-21, Buk-ri, Namsa-myeon,Cheoin-guYongin-city Gyeonggi-do 449 884Korea, Republic Of',1),('00:1A:72','Mosart Semiconductor Corp.','Mosart Semiconductor Corp.23f., No.33, Sec.1,Min Sheng Rd., Panchiao CityTaipei  220Taiwan, Republic Of China',1),('00:1A:73','Gemtek Technology Co., Ltd.','Gemtek Technology Co., Ltd.No. 1 Jen Ai Road, Hsinchu Industrial Park, Hukou,Hsinchu  303Taiwan, Republic Of China',1),('00:1A:74','Procare International Co','Procare International Co5f, No.88, Jhouzih Street, Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:1A:75','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:1A:76','Sdt Information Technology Co.,ltd.','Sdt Information Technology Co.,ltd.Samil B/b 2f, 5-63 Hyochang-dongYongsan-ku,Seoul  140-896Korea, Republic Of',1),('00:1A:77','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:1A:78','Ubtos','UbtosRn.213, Woolim Lions Valley , #680Seoul Gasan-dong 153-803Korea, Republic Of',1),('00:1A:79','Telecomunication Technologies Ltd.','Telecomunication Technologies Ltd.4d Zhukova Blv.Odessa  65121Ukraine',1),('00:1A:7A','Lismore Instruments Limited','Lismore Instruments LimitedUnit 2 Tristar Centre, Star RoadPartridge GreenHorsham West Sussex Rh13 8raUnited Kingdom',1),('00:1A:7B','Teleco, Inc.','Teleco, Inc.430 Woodruff Rd.Suite 300Greenville Sc 29607United States',1),('00:1A:7C','Hirschmann Automation And Control B.v.','Hirschmann Automation And Control B.v.Pampuslaan 170Weesp Noord-holland 1382 JsNetherlands',1),('00:1A:7D','Cyber-blue(hk)ltd','Cyber-blue(hk)ltdRoom 1408 Block C Stars Plaza Hongliroad,futian DistrictShenzhen Guangdong 518028China',1),('00:1A:7E','Ln Srithai Comm Ltd.','Ln Srithai Comm Ltd.71/12 M.5, Bangna-trad Rd, Km.52, ThakamBangpakong Chachoengsao 24130Thailand',1),('00:1A:7F','Gci Science&technology Co.,ltd.','Gci Science&technology Co.,ltd.No.381, Xingangzhong Road,Guangzhou Guangdong 510310China',1),('00:1A:80','Sony Corporation','Sony CorporationEngineering Standardization Office:mono-zukuri Technology DivGotenyama Tec 5-1-2 KitashinagawaShinagawa-ku Tokyo 141-0001Japan',1),('00:1A:81','Zelax','Zelax2nd Buid., 1b, Zavodskaya St.,Moscow  124681Russian Federation',1),('00:1A:82','Proba Building Automation Co.,ltd','Proba Building Automation Co.,ltdPenghuan Building 501, Shangdi East Road #1, Haidian District,Beijing  100085China',1),('00:1A:83','Pegasus Technologies Inc.','Pegasus Technologies Inc.108 Pawnook Farm Rd.Lenoir City Tn 37771United States',1),('00:1A:84','V One Multimedia Pte Ltd','V One Multimedia Pte LtdBlk 54, Kallang Bahru#02-04339336Singapore',1),('00:1A:85','Nv Michel Van De Wiele','Nv Michel Van De WieleM. Vandewielestraat 7Marke West-vlaanderen 8510Belgium',1),('00:1A:86','Advancedio Systems Inc','Advancedio Systems Inc595 Howe Street, Suite 502Vancouver Bc V6c 2t5Canada',1),('00:1A:87','Canhold International Limited','Canhold International LimitedFlat 4, 13/f., Block 4, Tai Ping Industrial Centre51a Ting Kok Road, Tai Po, N.t.,00852Hong Kong',1),('00:1A:88','Venergy,co,ltd','Venergy,co,ltdWest 6th Floor,m-8 Building Maqueling Zone,Shenzhen High-tech Park, Nanshan District,Shenzhen Guangdong 518000China',1),('00:1A:89','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1A:8A','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1, Imsoo-dongGumi-city Gyeong-buk 730-350Korea, Republic Of',1),('00:1A:8B','Chunil Electric Ind., Co.','Chunil Electric Ind., Co.308,byucksan Digital Valley,132-7,gamjeon-dong,sasang-guBusan Gyeongsangnamdo 617-800Korea, Republic Of',1),('00:1A:8C','Astaro Ag','Astaro AgAmalienbadstr. 36Bau 33aKarlsruhe Bw 76227Germany',1),('00:1A:8D','Avecs Bergen Gmbh','Avecs Bergen GmbhBillrothstr. 11 ABergen Auf Rgen M/v 18528Germany',1),('00:1A:8E','3way Networks Ltd','3way Networks Ltd7200 Cambridge Research ParkWaterbeachCambridge Cambridgeshire Cb5 9tlUnited Kingdom',1),('00:1A:8F','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1A:90','Trpico Sistemas E Telecomunicaes Da Amaznia Ltda.','Trpico Sistemas E Telecomunicaes Da Amaznia Ltda.Rod.  Campinas-mogi-mirim (sp 340)  Km 118,5Polis De Tecnologia (cpqd)-prdio 9aCampinas So Paulo 13.086-902Brazil',1),('00:1A:91','Fusiondynamic Ltd.','Fusiondynamic Ltd.1 B.s.r. Towers, 4-th Floor2 Ben Gurion StreetRamat Gan  52573Israel',1),('00:1A:92','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitouTaipei  112Taiwan, Republic Of China',1),('00:1A:93','Erco Leuchten Gmbh','Erco Leuchten GmbhBrockhauser Weg 80-82Ldenscheid Nrw D-58507Germany',1),('00:1A:94','Votronic Gmbh','Votronic GmbhSaarbruecker Str. 8St. Ingbert Saarland 66386Germany',1),('00:1A:95','Hisense Mobile Communications Technoligy Co.,ltd.','Hisense Mobile Communications Technoligy Co.,ltd.11,jiangxi Road,Qingdao Shandong 266071China',1),('00:1A:96','Ecler S.a.','Ecler S.a.Motors 166-168Barcelona  08038Spain',1),('00:1A:97','Fitivision Technology Inc.','Fitivision Technology Inc.8f, No. 356, Sec. 1, Neihu RdNeihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:1A:98','Asotel Communication Limited Taiwan Branch','Asotel Communication Limited Taiwan Branch3g17, No5, Hsin Yi Road, Sec. 5Taipei  110Taiwan, Republic Of China',1),('00:1A:99','Smarty (hz) Information Electronics Co., Ltd','Smarty (hz) Information Electronics Co., LtdYonghua Industrial District,huishen Road,zhenlong TownHuizhou Guangdong 516227China',1),('00:1A:9A','Skyworth Digital Technology(shenzhen)co.ltd.','Skyworth Digital Technology(shenzhen)co.ltd.13f,block A,skyworth Building,gaoxin Ave.1.s,Nanshan District,Shenzhen Guangdong 518057China',1),('00:1A:9B','Adec & Parter Ag','Adec & Parter AgStaldenbachstrasse 30Pfaeffikon Zh 8808Switzerland',1),('00:1A:9C','Righthand Technologies, Inc.','Righthand Technologies, Inc.6545 N Olmsted AvenueChicago Il 60631-1414United States',1),('00:1A:9D','Skipper Wireless, Inc.','Skipper Wireless, Inc.Shinjuku-sumitomo Bldg. 20f2-6-1 Nishi-shinjukuShinjuku Tokyo 163-0220Japan',1),('00:1A:9E','Icon Digital International Limited','Icon Digital International LimitedSuite2209, 22/f., Skyline Tower,39 Wang Kwong Road, Kowloon BayChina',1),('00:1A:9F','A-link Europe Ltd','A-link Europe LtdP.o.box 3Espoo  Fi-02941Finland',1),('00:1A:A0','Dell Inc','Dell IncOne Dell Way,  Ms Rr5-45Round Rock Texas 78682United States',1),('00:1A:A1','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:A2','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:A3','Delorme','Delorme2 Delorme DriveYarmouth Maine 04096United States',1),('00:1A:A4','Future University-hakodate','Future University-hakodate116-2 Kamedanakano-choHakodate Hokkaido 041-8655Japan',1),('00:1A:A5','Brn Phoenix','Brn Phoenix2500 Augustine Drive, Suite 200Santa Clara Ca 95054United States',1),('00:1A:A6','Telefunken Radio Communication Systems Gmbh &co.kg','Telefunken Radio Communication Systems Gmbh &co.kgEberhard-finckh-strasse 55Ulm Baden-wrttemberg 89075Germany',1),('00:1A:A7','Torian Wireless','Torian Wireless204 Johnston StreetCollingwood Victoria 3066Australia',1),('00:1A:A8','Mamiya Digital Imaging Co., Ltd.','Mamiya Digital Imaging Co., Ltd.2-14-22 UenoTaito-ku Tokyo 110-0005Japan',1),('00:1A:A9','Fujian Star-net Communication Co.,ltd','Fujian Star-net Communication Co.,ltd19-22# Building, Star-net Science Plaza, Juyuanzhou,618 Jinshan Road,Fuzhou Fujian 350002China',1),('00:1A:AA','Analogic Corp.','Analogic Corp.8 Centennial DrivePeabody Ma 01960United States',1),('00:1A:AB','Ewings S.r.l.','Ewings S.r.l.Via S. Quasimodo 46Castel Maggiore Bologna 40013Italy',1),('00:1A:AC','Corelatus Ab','Corelatus AbTegnergatan 37Stockholm  11161Sweden',1),('00:1A:AD','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1A:AE','Savant Systems Llc','Savant Systems Llc770a Main StOsterville Massachusetts 02655United States',1),('00:1A:AF','Blusens Technology','Blusens TechnologyEdificio Cnl,- Av.Fernando Casas Novoa ,n 37b 215707 - Santiago De Compostela A CoruaSpain',1),('00:1A:B0','Signal Networks Pvt. Ltd.,','Signal Networks Pvt. Ltd.,No.12, Kalpataru Apartments,Race Course Cross Road, Madhavnagar,Bangalore Karnataka 560001India',1),('00:1A:B1','Asia Pacific Satellite Industries Co., Ltd.','Asia Pacific Satellite Industries Co., Ltd.9th Fl, It Castle 2-dong, #550-1, Gasan-dong, Geumcheon-gu,Seoul  153-768Korea, Republic Of',1),('00:1A:B2','Cyber Solutions Inc.','Cyber Solutions Inc.6-6-3, Minami YoshinariAoba-kuSendai Miyagi-ken 989-3204Japan',1),('00:1A:B3','Visionite Inc.','Visionite Inc.#707 Daeryung Technotown-2 569-21Gasan-dong Geumcheon-guSeoul  153-771Korea, Republic Of',1),('00:1A:B4','Ffei Ltd.','Ffei Ltd.Block 2,  Eaton CourtEaton RoadHemel Hempstead Hertfordshire Hp2 7drUnited Kingdom',1),('00:1A:B5','Home Network System','Home Network System107, Hyundai I-vallySangdaewon 1(il)-dong, Jungwon-guSeongnam-si Gyeonggi-do 462-714Korea, Republic Of',1),('00:1A:B6','Luminary Micro Inc','Luminary Micro Inc108 Wild Basin Ste 350Austin Tx 78746United States',1),('00:1A:B7','Ethos Networks Ltd.','Ethos Networks Ltd.2 Maskit St.Building D, Pobox 4090Herzlia  46766Israel',1),('00:1A:B8','Anseri Corporation','Anseri Corporation35e Industrial WaySuite 101Rochester Nh 03867United States',1),('00:1A:B9','Pmc','Pmc56, Avenue RaspailSaint Maur Val De Marne 94100France',1),('00:1A:BA','Caton Overseas Limited','Caton Overseas LimitedRoom 102, No. 101, Lane 91E-shan Road, Pudong DistrictShanghai  200127China',1),('00:1A:BB','Fontal Technology Incorporation','Fontal Technology IncorporationRm.522, Bldg. 52, 195, Sec. 4, Chunghsing Rd., ChutungHsinchu  310Taiwan, Republic Of China',1),('00:1A:BC','U4ea Technologies Ltd','U4ea Technologies LtdCity PointTemple GateBristol  Bs1 6plUnited Kingdom',1),('00:1A:BD','Impatica Inc.','Impatica Inc.205-1725 St. Laurent Blvd.Ottawa On K1g 3v4Canada',1),('00:1A:BE','Computer Hi-tech Inc.','Computer Hi-tech Inc.Higashiueno3-18-7Taitoku Tokyo 110-0015Japan',1),('00:1A:BF','Trumpf Laser Marking Systems Ag','Trumpf Laser Marking Systems AgAusserfeldGruesch Gr 7214Switzerland',1),('00:1A:C0','Joybien Technologies Co., Ltd.','Joybien Technologies Co., Ltd.18f-1, No.700, Zhongzheng Rd.,Zhonghe City  235Taiwan, Republic Of China',1),('00:1A:C1','3com Ltd','3com LtdPeoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:1A:C2','Yec Co.,ltd.','Yec Co.,ltd.543-9 TsurumaMachida Tokyo 194-0004Japan',1),('00:1A:C3','Scientific-atlanta, Inc','Scientific-atlanta, Inc5030 Sugarloaf PkwyAtl 1.3.473Lawrenceville Ga 30044United States',1),('00:1A:C4','2wire, Inc','2wire, Inc1704 Automation ParkwaySan Jose Ca 95131United States',1),('00:1A:C5','Breakingpoint Systems, Inc.','Breakingpoint Systems, Inc.10535 Boyer Blvd.Suite 300Austin Tx 78758United States',1),('00:1A:C6','Micro Control Designs','Micro Control Designs17490 Caribou DrMonument Co. 80132United States',1),('00:1A:C7','Unipoint','Unipoint7f Gwangsung Bld 831-47 Yeoksam-dongKangnam-gu Seoul 135-936Korea, Republic Of',1),('00:1A:C8','Isl (instrumentation Scientifique De Laboratoire)','Isl (instrumentation Scientifique De Laboratoire)Impasse Des 4 VentsParc Dactivit De La MesnillireVerson Calvados 14790France',1),('00:1A:C9','Suzuken Co.,ltd','Suzuken Co.,ltdSuzuken Tomei Bldg.26 Himewaka-cho Meito-kuNagoya-si Aichi-ken 465-0045Japan',1),('00:1A:CA','Tilera Corporation','Tilera Corporation1900 West Park DriveSuite 290Westborough Ma 01581United States',1),('00:1A:CB','Autocom Products Ltd','Autocom Products LtdUnit 4 Tachbrook Link, Tachbrook Park DriveWarwick Warwickshire Cv34 6rhUnited Kingdom',1),('00:1A:CC','Celestial Semiconductor, Ltd','Celestial Semiconductor, LtdUgland House, South Church Street,Cayman IslandsGeorge Town,  Cayman Islands 00000Cayman Islands',1),('00:1A:CD','Tidel Engineering Lp','Tidel Engineering Lp2025 W Belt Line Road Suite 114Carrollton Tx 75019United States',1),('00:1A:CE','Yupiteru Corporation','Yupiteru Corporation3, Dannoue, Iwazu-cho, Okazaki-city, AichiOkazaki Aichi 444-2144Japan',1),('00:1A:CF','C.t. Elettronica','C.t. ElettronicaVia Caduti Di Nassiriya 5 BBarberino Val Delsa (fi)  50021Italy',1),('00:1A:D0','Albis Technologies Ag','Albis Technologies AgAlbisriederstrasse 199Ch 8047 ZuerichSwitzerland',1),('00:1A:D1','Fargo Co., Ltd.','Fargo Co., Ltd.4f. Kyemyung B/d165-4 Samsung-dong, Kangnam-kuSeoul  135 885Korea, Republic Of',1),('00:1A:D2','Eletronica Nitron Ltda','Eletronica Nitron LtdaRua Dr. Ulisses Escobar 415Jardim Vista AlegreCamanducaia Minas Gerais 37650-000Brazil',1),('00:1A:D3','Vamp Ltd.','Vamp Ltd.Po Box 810Vaasa  65101Finland',1),('00:1A:D4','Ipox Technology Co., Ltd.','Ipox Technology Co., Ltd.15f-1, No.186, Jian-yi Rd., Chung-ho City,Taipei  235Taiwan, Republic Of China',1),('00:1A:D5','Kmc Chain Industrial Co., Ltd.','Kmc Chain Industrial Co., Ltd.7f-8, No. 81, Sui-lih Rd., HsinchuHsinchu  300Taiwan, Republic Of China',1),('00:1A:D6','Jiagnsu Aetna Electric Co.,ltd','Jiagnsu Aetna Electric Co.,ltdNo.571 Qianhu Road,qianqiao Industry Park,wuxi,jiangsu,chinaWuxi Jiangsu 214151China',1),('00:1A:D7','Christie Digital Systems, Inc.','Christie Digital Systems, Inc.809 Wellington Street NorthKitchener Ontario N2g 4y7Canada',1),('00:1A:D8','Alsteraero Gmbh','Alsteraero GmbhLbecker Strae 1Hamburg  22087Germany',1),('00:1A:D9','International Broadband Electric Communications, Inc.','International Broadband Electric Communications, Inc.285 Dunlop Blvd. SwSuite KHuntsville Al 35824United States',1),('00:1A:DA','Biz-2-me Inc.','Biz-2-me Inc.1301 West Eau Gallie BlvdSuite 106Melbourne Fl 32935United States',1),('00:1A:DB','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:1A:DC','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1A:DD','Pepwave Ltd','Pepwave Ltd17/f., Park Building,476 Castle Peak RoadCheung Sha Wan KowloonHong Kong',1),('00:1A:DE','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1A:DF','Interactivetv Pty Limited','Interactivetv Pty LimitedSuite 10 Level 356 Bowman StreetPyrmont, Sydney Nsw 2009Australia',1),('00:1A:E0','Mythology Tech Express Inc.','Mythology Tech Express Inc.2f, No.10, Lane 235, Bao Chiao Road,Hsin-tien.Taipei  231Taiwan, Republic Of China',1),('00:1A:E1','Edge Access Inc','Edge Access Inc5440 Beaumont Center BlvdSuite 490Tampa Fl 33634United States',1),('00:1A:E2','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:E3','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1A:E4','Liposonix Inc,','Liposonix Inc,11818 North Creek Parkway N.Bothell Wa 98011United States',1),('00:1A:E5','Mvox Technologies Inc.','Mvox Technologies Inc.19050 Pruneridge AveSte. 128Cupertino Ca 95014United States',1),('00:1A:E6','Atlanta Advanced Communications Holdings Limited','Atlanta Advanced Communications Holdings Limited1900 West Oak Circle, MariettaAtlanta Georgia 30062United States',1),('00:1A:E7','Aztek Networks, Inc.','Aztek Networks, Inc.2477 55th St. #202Boulder Co 80301United States',1),('00:1A:E8','Siemens Enterprise Communications Gmbh & Co. Kg','Siemens Enterprise Communications Gmbh & Co. KgSen Esy Scm 53Brauckstrasse 14Witten Nrw 58454Germany',1),('00:1A:E9','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:1A:EA','Radio Terminal Systems Pty Ltd','Radio Terminal Systems Pty Ltd1st Floor108 Dohertys RoadLaverton North Victoria 3026Australia',1),('00:1A:EB','Allied Telesis K.k.','Allied Telesis K.k.No.2 Toc Bldg.7-21-11 Nishi-gotandaShinagawa-ku Tokyo 141-0031Japan',1),('00:1A:EC','Keumbee Electronics Co.,ltd.','Keumbee Electronics Co.,ltd.3-26, Jangsang-dong, Sangrok-guAnsan-si Kyungki-do 426-410Korea, Republic Of',1),('00:1A:ED','Incotec Gmbh','Incotec GmbhBlomestrasse 25 - 27Bielefeld Nrw 33609Germany',1),('00:1A:EE','Shenztech Ltd','Shenztech Ltd813, 8f, Hollywood Plaza, 610 Nathan Road,Kowloon  852Hong Kong',1),('00:1A:EF','Loopcomm Technology, Inc.','Loopcomm Technology, Inc.18f-1, No. 150, Jian Yi Rd.,Chung-ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:1A:F0','Alcatel - Ipd','Alcatel - Ipd701 E. Middlefield Rd.Mountain View Ca 94043United States',1),('00:1A:F1','Embedded Artists Ab','Embedded Artists AbFriisgatan 33, 4vMalmoe  21421Sweden',1),('00:1A:F2','Dynavisions Schweiz Ag','Dynavisions Schweiz AgFreisinger Landstrasse 21D-80939 MuenchenGermany',1),('00:1A:F3','Samyoung Electronics','Samyoung Electronics146-1, Sangdaewon-dong, Joongwon-guSungnam-shi Gyunggi-do 462-807Korea, Republic Of',1),('00:1A:F4','Handreamnet','Handreamnet#1209 Mariotower, 222-12Guro-dong, Guro-guSeoul  152-848Korea, Republic Of',1),('00:1A:F5','Pentaone. Co., Ltd.','Pentaone. Co., Ltd.Hyo Chang Bldg, 3f, 1013-6, Inkye-dong Paldal-gu,Suwon City Gyunggi-do 422-833Korea, Republic Of',1),('00:1A:F6','Woven Systems, Inc.','Woven Systems, Inc.2455 Augustine DriveSuite 211Santa Clara Ca 95054United States',1),('00:1A:F7','Dataschalt E+a Gmbh','Dataschalt E+a GmbhAn Der Hlshorst 7-9Lbeck  23568Germany',1),('00:1A:F8','Copley Controls Corporation','Copley Controls Corporation20 Dan RoadCanton Ma 02021United States',1),('00:1A:F9','Aerovironment (av Inc)','Aerovironment (av Inc)4685 Industrial StPo A18271Simi Valley Ca 93063United States',1),('00:1A:FA','Welch Allyn, Inc.','Welch Allyn, Inc.4619 Jordan RoadPo Box 187Skaneateles Falls Ny 13153-0187United States',1),('00:1A:FB','Joby Inc.','Joby Inc.1535 Mission St.Floor 2San Francisco Ca 94103United States',1),('00:1A:FC','Moduslink Corporation','Moduslink Corporation2905 Prestonwood DrivePlano Texas 75093United States',1),('00:1A:FD','Evolis','Evolis29 Avenue De La FontaineZi Angers BeaucouzeBeaucouze  49070France',1),('00:1A:FE','Sofacreal','Sofacreal149 Avenue Du MaineParis Region Parisienne 75014France',1),('00:1A:FF','Wizyoung Tech.','Wizyoung Tech.9f, No. 25, Sec. 1, Nanjing E. Rd.Taipei  104Taiwan, Republic Of China',1),('00:1B:00','Neopost Technologies','Neopost Technologies113 Rue Jean-marin NaudinBagneux  92220France',1),('00:1B:01','Applied Radio Technologies','Applied Radio Technologies1124 South Service Road WestOakville Ontario L6l 5t7Canada',1),('00:1B:02','Ed Co.ltd','Ed Co.ltd517-15 Sangdaewon-dongSeongnam-city Gyeonggi-do 462-806Korea, Republic Of',1),('00:1B:03','Action Technology (sz) Co., Ltd','Action Technology (sz) Co., LtdAction Technology Building Baoyuan Road, Xixiang, Baoan DistrictShenzhen Guangdong 518102China',1),('00:1B:04','Affinity International S.p.a','Affinity International S.p.aC.so Savona 51Villastellone Torino I10029Italy',1),('00:1B:05','Young Media Concepts Gmbh','Young Media Concepts GmbhSonnenstrasse 4Kreuzlingen Thurgau 8280Switzerland',1),('00:1B:06','Ateliers R. Laumonier','Ateliers R. Laumonier11, Rue Du ChenivalBp 1Nesles La Valle Val Doise 95690France',1),('00:1B:07','Mendocino Software','Mendocino Software47001 Benecia St.Fremont Ca 94538United States',1),('00:1B:08','Danfoss Drives A/s','Danfoss Drives A/sUlsnaes 1Graasten 6300Denmark',1),('00:1B:09','Matrix Telecom Pvt. Ltd.','Matrix Telecom Pvt. Ltd.394, Gidc, Makarpura,Vadodara Gujarat 390010India',1),('00:1B:0A','Intelligent Distributed Controls Ltd','Intelligent Distributed Controls LtdKeynes House, Chester ParkAlfreton RoadDerby Derbyshire De21 4asUnited Kingdom',1),('00:1B:0B','Phidgets Inc.','Phidgets Inc.2715a 16a Street N.w.Calgary Alberta T2m 3r7Canada',1),('00:1B:0C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:0D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:0E','Inotec Gmbh Organisationssysteme','Inotec Gmbh OrganisationssystemeBiedrichstrasse 11Woelfersheim Hessen D-61200Germany',1),('00:1B:0F','Petratec','PetratecDerech Ha-sharon 12Kfar Saba Sharon 44271Israel',1),('00:1B:10','Shenzhen Kang Hui Technology Co.,ltd','Shenzhen Kang Hui Technology Co.,ltdChina  GuangdongTwo S,floor Baoan District LonghuaShenzhen Guangdong 518109China',1),('00:1B:11','D-link Corporation','D-link CorporationNo.289, Sinhu 3rd Rd.,Neihu District, Taipei City 114Taiwan, Republic Of China',1),('00:1B:12','Apprion','ApprionNasa Ames Rerearch CenterP.o. Box 95 Building 19 Suite 1000Moffett Field California 94035United States',1),('00:1B:13','Icron Technologies Corporation','Icron Technologies Corporation221 - 4664 Lougheed HighwayBurnaby Bc V5c 5t5Canada',1),('00:1B:14','Carex Lighting Equipment Factory','Carex Lighting Equipment Factory50 Chang Tang Rd., Yan Tian District,Fungkong, DongguanGuangdong ProvinceChina',1),('00:1B:15','Voxtel, Inc.','Voxtel, Inc.12725 Sw Millikan WaySuite 230Beaverton Or 97005United States',1),('00:1B:16','Celtro Ltd.','Celtro Ltd.Azorim Business Park94 Em Hmoshavot Road.Petach Tikva  49527Israel',1),('00:1B:17','Palo Alto Networks','Palo Alto Networks2130 Gold Street Suite 200Alviso Ca 95022United States',1),('00:1B:18','Tsuken Electric Ind. Co.,ltd','Tsuken Electric Ind. Co.,ltd3-9 Akedouri Izumi-kuSendai City Miyagi 981-3206Japan',1),('00:1B:19','Ieee 1588 Standard','Ieee 1588 Standard5301 Stevens Creek Boulevard, Ms: 54u-smSanta Clara Ca 95051-7201United States',1),('00:1B:1A','E-trees Japan, Inc.','E-trees Japan, Inc.Toranomon 4-1-21Fukide Bldg. No.2 501Minato-ku Tokyo 150-0001Japan',1),('00:1B:1B','Siemens Ag,','Siemens Ag,I Ia Sc Ewk Pu1, Oestliche Rheinbrueckenstrasse 5076181, Karlsruhe Baden WuerttembergGermany',1),('00:1B:1C','Coherent','Coherent1280 Blues Hills Ave.Bloomfield Ct 06002United States',1),('00:1B:1D','Phoenix International Co., Ltd','Phoenix International Co., Ltd11f. No.42-1, Sec.1, Zhongyang N. Rd. BeitouTaipei  112Taiwan, Republic Of China',1),('00:1B:1E','Hart Communication Foundation','Hart Communication FoundationSte 1-3509390 Research BlvdAustin Tx 78759United States',1),('00:1B:1F','Delta - Danish Electronics, Light & Acoustics','Delta - Danish Electronics, Light & AcousticsVenlighedsvej 4Hrsholm  Dk-2970Denmark',1),('00:1B:20','Tpine Technology','Tpine Technology3f, No.1, An-i Rd,Keelung  111Taiwan, Republic Of China',1),('00:1B:21','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1B:22','Palit Microsystems ( H.k.) Ltd.','Palit Microsystems ( H.k.) Ltd.Room 4-6,11f,nan Fung Commercial Center19 Lam Lok Road,kowloon BayKowloon  111Hong Kong',1),('00:1B:23','Simplecomtools','Simplecomtools598 Indian Trail Rd S.Suite #102Indian Trail Nc 28079United States',1),('00:1B:24','Quanta Computer Inc.','Quanta Computer Inc.No. 211, Wen Hwa 2nd Rd.,Kuei Shan Hsiang Tao Yuan Shien 333Taiwan, Republic Of China',1),('00:1B:25','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1B:26','Ron-telecom Zao','Ron-telecom Zao15 A, Zarechnaya St.Trehgorny Chelyabinsk Region 456080Russian Federation',1),('00:1B:27','Merlin Csi','Merlin Csi12625 Danielson CourtSuite 109Poway Ca 92064United States',1),('00:1B:28','Polygon, Jsc','Polygon, Jsc37/1, Karl Marx Str., Floor 5Ufa Bashkortostan 450077Russian Federation',1),('00:1B:29','Avantis.co.,ltd','Avantis.co.,ltd502 Seoil Bldg.1543-8 Seocho-dong, Seocho-guSeoul  132-872Korea, Republic Of',1),('00:1B:2A','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:2B','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:2C','Atron Electronic Gmbh','Atron Electronic GmbhAm Ziegelstadel 12 + 14Markt Schwaben  85570Germany',1),('00:1B:2D','Med-eng Systems Inc.','Med-eng Systems Inc.2400 St. Laurent Blvd.Ottawa Ontario K1g 6c4Canada',1),('00:1B:2E','Sinkyo Electron Inc','Sinkyo Electron Inc3-3-21 AsahigaokaHino-city Tokyo 191-0065Japan',1),('00:1B:2F','Netgear Inc.','Netgear Inc.4500 Great America ParkwaySanta Clara Ca 95054United States',1),('00:1B:30','Solitech Inc.','Solitech Inc.1838 Main StreetStevensville Md 21666United States',1),('00:1B:31','Neural Image. Co. Ltd.','Neural Image. Co. Ltd.A307, Casi, Osaka Univ.2-1, Yamada-okaSuita City Osaka 565-0871Japan',1),('00:1B:32','Qlogic Corporation','Qlogic Corporation26650 Aliso Viejo ParkwayAliso Viejo California 92656United States',1),('00:1B:33','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1B:34','Focus System Inc.','Focus System Inc.19f-1, No. 266 Wen Hwa 2nd Rd., Sec. 1Linkou Taipei CountyTaiwan, Republic Of China',1),('00:1B:35','Chongqing Jinou Science & Technology Development Co.,ltd','Chongqing Jinou Science & Technology Development Co.,ltdChuangyeyuan 208# Keyuan 3rd Road 106#Hi-tech Development ZoneChongqing  400030China',1),('00:1B:36','Tsubata Engineering Co.,ltd. (head Office)','Tsubata Engineering Co.,ltd. (head Office)Koyanagi 1-2Senju Bld.Ibaraki Osaka 567-0852Japan',1),('00:1B:37','Computec Oy','Computec OyJuholankatu 8Pl 66Kouvola Kymi 45200Finland',1),('00:1B:38','Compal Information (kunshan) Co., Ltd.','Compal Information (kunshan) Co., Ltd.No. 25, The 3rd AvenueKunshan Export Processing ZoneKunshan City Suzhou Province 215300China',1),('00:1B:39','Proxicast','Proxicast312 Sunnyfield DriveSuite 200Glenshaw Pa 15116United States',1),('00:1B:3A','Sims Corp.','Sims Corp.Raon Bldg, 9f, 92-8, Wonhyoro-2ga, Yongsan-guSeoul  140-847Korea, Republic Of',1),('00:1B:3B','Yi-qing Co., Ltd','Yi-qing Co., Ltd310 Room,12fNo.5-1 Heng Yang Rd.Taipei  100Taiwan, Republic Of China',1),('00:1B:3C','Software Technologies Group,inc.','Software Technologies Group,inc.10330 W. Roosevelt RoadSuite 310Weschester Il 60154United States',1),('00:1B:3D','Eurotel Spa','Eurotel SpaViale Martiri Della Liberta,4Lissone Milan 20035Italy',1),('00:1B:3E','Curtis, Inc.','Curtis, Inc.2405 Annapolis LaneSuite 220Minneapolis Mn 55441United States',1),('00:1B:3F','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills Blvd.Roseville California 95747United States',1),('00:1B:40','Network Automation Mxc Ab','Network Automation Mxc AbBox 7294Stockholm  10390Sweden',1),('00:1B:41','General Infinity Co.,ltd.','General Infinity Co.,ltd.3f,no.169, Xing-ai Rd,Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:1B:42','Wise & Blue','Wise & Blue#715-3 Anyang Megavalley799 Gwanyang-dong, Dongan-guAnyang-si Gyunggi-do 431-767Korea, Republic Of',1),('00:1B:43','Beijing Dg Telecommunications Equipment Co.,ltd','Beijing Dg Telecommunications Equipment Co.,ltdNo.5 Jiangtai Road, Chaoyang DistrictBeijing  100016China',1),('00:1B:44','Sandisk Corporation','Sandisk Corporation601 Mccarthy BoulevardMilpitas Ca 95035United States',1),('00:1B:45','Abb As, Division Automation Products','Abb As, Division Automation ProductsBergerveien 12Pob 90Billingstad  No-1375Norway',1),('00:1B:46','Blueone Technology Co.,ltd','Blueone Technology Co.,ltdRoom 309,3 Floor, 404 Building, Shangbu IndustrialShenzhen Guangdong 518028China',1),('00:1B:47','Futarque A/s','Futarque A/sAagade 15bAalborg  9000Denmark',1),('00:1B:48','Shenzhen Lantech Electronics Co., Ltd.','Shenzhen Lantech Electronics Co., Ltd.306 Room, Nanshan Water Building,Nanhai Road, NanshanShenzhen Guangdong 518052China',1),('00:1B:49','Roberts Radio Limited','Roberts Radio LimitedSwinton WorksTalbot RoadMexborough South Yorkshire S64 8ajUnited Kingdom',1),('00:1B:4A','W&w Communications, Inc.','W&w Communications, Inc.2903 Bunker Hill LaneSuite 107Santa Clara Ca 95054United States',1),('00:1B:4B','Sanion Co., Ltd.','Sanion Co., Ltd.#208 Acetechno Tower, 55-7, Mullae-dong 3ga,Yeongdeungpo-gu Seoul 150-992Korea, Republic Of',1),('00:1B:4C','Signtech','Signtech609 Seonil Technopia 609Sangdaewon 1dong Jungwon GuSungnamsi Kyunggido 462-120Korea, Republic Of',1),('00:1B:4D','Areca Technology Corporation','Areca Technology Corporation8f., No. 22, Lane 35, Ji-hu Rd.Taipei  114Taiwan, Republic Of China',1),('00:1B:4E','Navman New Zealand','Navman New Zealand7-21 Kawana StreetNorthcoteAuckland  0627New Zealand',1),('00:1B:4F','Avaya Inc.','Avaya Inc.Room 1a 309307 Middletown Lincroft RdLincroft Nj 07738United States',1),('00:1B:50','Nizhny Novgorod Factory Named After M.frunze, Fsue (nzif)','Nizhny Novgorod Factory Named After M.frunze, Fsue (nzif)174, Gagarina AvenueNizhny Novgorod  603950Russian Federation',1),('00:1B:51','Vector Technology Corp.','Vector Technology Corp.No.7, Lane12, Yajou Road.Tucheng Taipei 236Taiwan, Republic Of China',1),('00:1B:52','Motorola Mobile Devices','Motorola Mobile Devices600 N. Hwy 45Libertyville Il 60048United States',1),('00:1B:53','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:54','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:55','Hurco Automation Ltd.','Hurco Automation Ltd.6f, No. 31, Shintai Rd.Jubei City, Hsinchu Hsien 30244Taiwan, Republic Of China',1),('00:1B:56','Tehuti Networks Ltd.','Tehuti Networks Ltd.1, Shenkar St.Hertzliya  46105Israel',1),('00:1B:57','Semindia Systems Private Limited','Semindia Systems Private Limited#1106/9,a.m.industrial Estate,garvebhai Palya,7th Mile, Hosur Road,Bangalore Karnataka 560068India',1),('00:1B:58','Ace Cad Enterprise Co., Ltd.','Ace Cad Enterprise Co., Ltd.2f, No. 94, Bao Chung Road,Hsin Tien City, Taipei Hsien 23144Taiwan, Republic Of China',1),('00:1B:59','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:1B:5A','Apollo Imaging Technologies, Inc.','Apollo Imaging Technologies, Inc.18545 Rangeland RdRamona Ca 92065United States',1),('00:1B:5B','2wire, Inc.','2wire, Inc.1704 Automation ParkwaySan Jose Ca 95131United States',1),('00:1B:5C','Azuretec Co., Ltd.','Azuretec Co., Ltd.3f, No.8, Alley 8, Lane 45, Baoxing Rd.,Xindian City Taipei County 231Taiwan, Republic Of China',1),('00:1B:5D','Vololink Pty Ltd','Vololink Pty LtdLevel 2, 541 Blackburn RoadMount Waverley Victoria 3149Australia',1),('00:1B:5E','Bpl Limited','Bpl LimitedBpl Towers13, Kasturba RoadBangalore Karnataka 560001India',1),('00:1B:5F','Alien Technology','Alien Technology18220 Butterfield Blvd.Morgan Hill Ca 95037United States',1),('00:1B:60','Navigon Ag','Navigon AgBerliner Platz 11Wuerzburg Bavaria 97080Germany',1),('00:1B:61','Digital Acoustics, Llc','Digital Acoustics, Llc37 Sherwood TerraceLake Bluff Il 60044United States',1),('00:1B:62','Jht Optoelectronics Co.,ltd.','Jht Optoelectronics Co.,ltd.Hetian Industrial Park 2rd,houjie Town, Donguan,Dongguan Guangdong 523945China',1),('00:1B:63','Apple Computer Inc.','Apple Computer Inc.1 Infinite LoopCupertino California 95014United States',1),('00:1B:64','Isaaclandkorea Co., Ltd,','Isaaclandkorea Co., Ltd,Rm 608, Hangang-hyundai-hyel Bldg. 2-36,Hangangno 2-ga, Yongsan-gu,Seoul  140-871Korea, Republic Of',1),('00:1B:65','China Gridcom Co., Ltd','China Gridcom Co., Ltd21/f, Huaneng Building, No. 2068 Shennan Main RoadShenzhen Guangdong 0086China',1),('00:1B:66','Sennheiser Electronic Gmbh & Co. Kg','Sennheiser Electronic Gmbh & Co. KgAm Labor 1Wedemark Niedersachsen 30900Germany',1),('00:1B:67','Ubiquisys Ltd','Ubiquisys LtdThe Stella BuildingWindmill Hill Business ParkSwindon Wiltshire Sn5 6nxUnited Kingdom',1),('00:1B:68','Modnnet Co., Ltd','Modnnet Co., Ltd2139 Daemyung-dong Dip Main B/d Room#505, NamguDaegu Kyungsang Bookdo 705-701Korea, Republic Of',1),('00:1B:69','Equaline Corporation','Equaline Corporation9f, No. 234, Section 4, Cheng-de Road,Taipei Hsien 25162Taiwan, Republic Of China',1),('00:1B:6A','Powerwave Technologies Sweden Ab','Powerwave Technologies Sweden Ab164 26KistaKnarrarnsgatan 7, KistaSweden',1),('00:1B:6B','Swyx Solutions Ag','Swyx Solutions AgJoseph-von-fraunhofer-str.13aDortmund Nrw 44227Germany',1),('00:1B:6C','Lookx Digital Media Bv','Lookx Digital Media BvRoekenveldweg 1Brunssum Limburg 6446dkNetherlands',1),('00:1B:6D','Midtronics, Inc.','Midtronics, Inc.7000 Monroe St.Willowbrook Il 60527United States',1),('00:1B:6E','Anue Systems, Inc.','Anue Systems, Inc.9111 Jollyville RoadSuite 100Austin Tx 78759United States',1),('00:1B:6F','Teletrak Ltd','Teletrak Ltd214 Kepa RoadMission BayAuckland  1071New Zealand',1),('00:1B:70','Iri Ubiteq, Inc.','Iri Ubiteq, Inc.Shinjuku-nomura Bldg. 47f,1-26-2 Nishi-shinjuku,Shinjuku-ku Tokyo 163-0547Japan',1),('00:1B:71','Telular Corp.','Telular Corp.311 South Wacker DriveSuite 4300Chicago Il 60606United States',1),('00:1B:72','Sicep S.p.a.','Sicep S.p.a.Via Calabria, 14Certaldo  50052Italy',1),('00:1B:73','Dtl Broadcast Ltd','Dtl Broadcast LtdJohnsons EstateSilverdale RoadHayes Middlesex Ub3 3baUnited Kingdom',1),('00:1B:74','Miralink Corporation','Miralink Corporation111 Sw 5th Ave.Ste. 1000Portland Or 97204United States',1),('00:1B:75','Hypermedia Systems','Hypermedia Systems2b Bergman St.Rabbin Industrial ParkRehovot  76705Israel',1),('00:1B:76','Ripcode, Inc.','Ripcode, Inc.1130 E. Arapaho RoadSuite 435Richardson Tx 75081United States',1),('00:1B:77','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1B:78','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:1B:79','Faiveley Transport','Faiveley TransportZi Du Bois De PlanteRue Amelia EarhartLa Ville Aux Dames  37700France',1),('00:1B:7A','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:1B:7B','The Tintometer Ltd','The Tintometer LtdSolar WaySolstice ParkAmesbury Wiltshire Sp4 7szUnited Kingdom',1),('00:1B:7C','A & R Cambridge','A & R CambridgePembroke AvenueWaterbeachCambridge Cambs Cb25 9qrUnited Kingdom',1),('00:1B:7D','Cxr Anderson Jacobson','Cxr Anderson JacobsonRue De LornetteAbondant  28410France',1),('00:1B:7E','Beckmann Gmbh','Beckmann GmbhBrandtstr. 1Hoevelhof Nrw 33161Germany',1),('00:1B:7F','Tmn Technologies Telecomunicacoes Ltda','Tmn Technologies Telecomunicacoes LtdaRua Nilza, 422Sao Paulo Sp 03651-120Brazil',1),('00:1B:80','Lord Corporation','Lord Corporation2000 West Grandview BlvdErie Pa 16509United States',1),('00:1B:81','Dataq Instruments, Inc.','Dataq Instruments, Inc.241 Springside DriveAkron Ohio 44333United States',1),('00:1B:82','Taiwan Semiconductor Co., Ltd.','Taiwan Semiconductor Co., Ltd.11f, No. 205, Sec. 3, Beishin Rd,Shindian Taipei 231Taiwan, Republic Of China',1),('00:1B:83','Finsoft Ltd','Finsoft Ltd16-18 Hatton GardenLondon  Ec1n 8atUnited Kingdom',1),('00:1B:84','Scan Engineering Telecom','Scan Engineering TelecomSvobody Str. 75Voronezh  394030Russian Federation',1),('00:1B:85','Man Diesel Se','Man Diesel SeTeglholmsgade 41Copenhagen  2450Denmark',1),('00:1B:86','Bosch Access Systems Gmbh','Bosch Access Systems GmbhAdenauer Str 20Wuerselen Nordrhein-westfalen D-52146Germany',1),('00:1B:87','Deepsound Tech. Co., Ltd','Deepsound Tech. Co., Ltd3f No. 576 Sec. 1, Minsheng N. Rd., Gueishan Township,Taoyuan  333Taiwan, Republic Of China',1),('00:1B:88','Divinet Access Technologies Ltd','Divinet Access Technologies Ltd4th Floor, Media Center,Sakaal Nagar, Baner RoadPune Maharashtra 411007India',1),('00:1B:89','Emza Visual Sense Ltd.','Emza Visual Sense Ltd.20 Hataas St., Beith HapamonSuite 391Kfar Saba  44425Israel',1),('00:1B:8A','2m Electronic A/s','2m Electronic A/sMalervej 10Taastrup  2630Denmark',1),('00:1B:8B','Nec Accesstechnica,ltd.','Nec Accesstechnica,ltd.800 ShimomataKakegawa Shizuoka 436-8501Japan',1),('00:1B:8C','Jmicron Technology Corp.','Jmicron Technology Corp.1f, No. 13, Innovation Road 1, Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:1B:8D','Electronic Computer Systems, Inc.','Electronic Computer Systems, Inc.418 Donegal DriveTowson Md 21286United States',1),('00:1B:8E','Hulu Sweden Ab','Hulu Sweden AbBox 12328, 10228Kista Stockholm 164 40Sweden',1),('00:1B:8F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:90','Cisco Systems','Cisco Systems80 West Tasman Dr.Sj-m/1San Jose Ca 95134United States',1),('00:1B:91','Efkon Ag','Efkon AgAndritzer Reichsstrasse 66Graz Styria 8045Austria',1),('00:1B:92','L-acoustics','L-acousticsParc De La Fontaine De JouvenceMarcoussis Essonne 91462France',1),('00:1B:93','Jc Decaux Sa Dnt','Jc Decaux Sa Dnt21 Rue Claude BernardMaurepas  78310France',1),('00:1B:94','T.e.m.a. S.p.a.','T.e.m.a. S.p.a.Via Della Scienza 21 A/cCastelnuovo Rangone Modena 41051Italy',1),('00:1B:95','Video Systems Srl','Video Systems SrlLoc. Gorizzo, 1633030Camino Al Tagliamento UdItaly',1),('00:1B:96','Snif Labs, Inc.','Snif Labs, Inc.108 Lincoln St.Boston Ma 02111United States',1),('00:1B:97','Violin Technologies','Violin Technologies33 Wood Ave SouthIselin Nj 08830United States',1),('00:1B:98','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.#94-1, Imsoo-dongGumi Gyeong-buk 730-350Korea, Republic Of',1),('00:1B:99','Ks System Gmbh','Ks System GmbhAlexanderstr. 37Muelheim Nrw 45472Germany',1),('00:1B:9A','Apollo Fire Detectors Ltd','Apollo Fire Detectors Ltd36 Brookside RoadHavant Hampshire P09 1jrUnited Kingdom',1),('00:1B:9B','Hose-mccann Communications','Hose-mccann Communications1241 West Newport Center DriveDeerfield Beach Fl 33442United States',1),('00:1B:9C','Satel Sp. Z O.o.','Satel Sp. Z O.o.Schuberta 79Gdansk Pomorskie 80-172Poland',1),('00:1B:9D','Novus Security Sp. Z O.o.','Novus Security Sp. Z O.o.Ul. Puawska 431Warsaw Woj. Mazowieckie 02-801Poland',1),('00:1B:9E','Askey  Computer  Corp','Askey  Computer  Corp10f,no.119,chienkang Rd,Chung-ho,tpipei  235Taiwan, Republic Of China',1),('00:1B:9F','Calyptech Pty Ltd','Calyptech Pty Ltd5/486 Lower Heidelberg RoadHeidelberg Victoria 3084Australia',1),('00:1B:A0','Awox','Awox93, Place Pierre Duhem,Les Centuries34000 MontpellierFrance',1),('00:1B:A1','mic Ab','mic AbUppsala Science ParkDag Hammrskjlds Vg 52 BUppsala  75183Sweden',1),('00:1B:A2','Ids Imaging Development Systems Gmbh','Ids Imaging Development Systems GmbhDimbacher Str. 6Obersulm Bw 74182Germany',1),('00:1B:A3','Flexit Group Gmbh','Flexit Group GmbhBruhausstrae 14Salzburg Salzburg 5020Austria',1),('00:1B:A4','S.a.e Afikim','S.a.e AfikimKibutz AfikimKibutz Afikim  15148Israel',1),('00:1B:A5','Myungmin Systems, Inc.','Myungmin Systems, Inc.#410,doosan Venture Dime 2-cha,1307-37Kwanyang-dong,Kyungki-do  431-060Korea, Republic Of',1),('00:1B:A6','Intotech Inc.','Intotech Inc.13f Dmc R&d Center E3-2 Building Land Development District Sangam-dongMapogu Seoul 121-270Korea, Republic Of',1),('00:1B:A7','Lorica Solutions','Lorica Solutions275 Northpointe ParkwayAmherst Ny 14228United States',1),('00:1B:A8','Ubi&mobi,.inc','Ubi&mobi,.inc3f, Duido Bldg, #288-5, Yangjae-dongSeocho-gu Seoul 137-130Korea, Republic Of',1),('00:1B:A9','Brother Industries, Ltd.','Brother Industries, Ltd.Printing & Solutions Company, Development Management Dept.15-1 Naeshiro-cho, Mizuho-kuNagoya Aichi 467-8561Japan',1),('00:1B:AA','Xenics Nv','Xenics NvAmbachtenlaan 44Leuven Vlaams-brabant B-3001Belgium',1),('00:1B:AB','Telchemy, Incorporated','Telchemy, Incorporated2905 Premiere ParkwaySuite 280Duluth Ga 30097United States',1),('00:1B:AC','Curtiss Wright Controls Embedded Computing','Curtiss Wright Controls Embedded Computing10201 Wateridge CircleSuite 300San Diego Ca 92121United States',1),('00:1B:AD','Icontrol Incorporated','Icontrol Incorporated3235 Kifer RoadSuite 260Santa Clara California 95051United States',1),('00:1B:AE','Micro Control Systems, Inc','Micro Control Systems, Inc5877 Enterprise ParkwayFort Myers Florida 33905United States',1),('00:1B:AF','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1B:B0','Bharat Electronics','Bharat ElectronicsJalahalli PostBangalore Karnataka 560013India',1),('00:1B:B1','Wistron Neweb Corp.','Wistron Neweb Corp.No. 10-1, Li-hsin Road I, Hsinchu Science Park,Hsinchu  300Taiwan, Republic Of China',1),('00:1B:B2','Intellect International Nv','Intellect International NvKleine Kloosterstraat 23Zaventem Vlaamse Brabant 1932Belgium',1),('00:1B:B3','Condalo Gmbh','Condalo GmbhKohlstatt 3Lichtenau Bavaria 86706Germany',1),('00:1B:B4','Airvod Limited','Airvod LimitedHeather HouseHeather RoadSandyford Ind Est Dublin 18 D18Ireland',1),('00:1B:B5','Cherry Gmbh','Cherry GmbhCherrystrasse 1Auerbach I. D. Opf. Bayern D-91275Germany',1),('00:1B:B6','Bird Electronic Corp.','Bird Electronic Corp.30303 Aurora RoadSolon Ohio 44139United States',1),('00:1B:B7','Alta Heights Technology Corp.','Alta Heights Technology Corp.108 Alta Heights CourtLos Gatos California 95030United States',1),('00:1B:B8','Blueway Electronic Co;ltd','Blueway Electronic Co;ltdWorkshop B,dong Feng Village,Front Baiyun,gu Tang AoHuizhou Guangdong 516008China',1),('00:1B:B9','Elitegroup Computer System Co.','Elitegroup Computer System Co.No.22, Alley 38, Lane 91 , Sec. 1 , Nei Hu RoadTaipei  114Taiwan, Republic Of China',1),('00:1B:BA','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1B:BB','Rftech Co.,ltd','Rftech Co.,ltd339-17 Jwahang-ri,wonsam-myun,Cheoin-guYongin-si Kyungki-do 449-871Korea, Republic Of',1),('00:1B:BC','Silver Peak Systems, Inc.','Silver Peak Systems, Inc.471 El Camino RealSanta Clara Ca 95050United States',1),('00:1B:BD','Fmc Kongsberg Subsea As','Fmc Kongsberg Subsea AsKirkegaardsveien 45Kongsberg Buskerud 3601Norway',1),('00:1B:BE','Icop Digital','Icop Digital16801 W. 116th St.Lenexa Ks 66219United States',1),('00:1B:BF','Sagem Communication','Sagem Communication14 Rue Paul DautierVlizy  78457France',1),('00:1B:C0','Juniper Networks','Juniper Networks1194 N Mathilda AvenueSunnyvale Ca 94089United States',1),('00:1B:C1','Holux Technology, Inc.','Holux Technology, Inc.1f, No. 30, R&d Rd. Ii,Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:1B:C2','Integrated Control Technology Limitied','Integrated Control Technology Limitied6c Ascension PlaceMairangi BayAuckland Auckland 0735New Zealand',1),('00:1B:C3','Mobisolution Co.,ltd','Mobisolution Co.,ltd848-16Guyeong-dongGumi Gyeongbuk 730-300Korea, Republic Of',1),('00:1B:C4','Ultratec, Inc.','Ultratec, Inc.450 Science DriveMadison Wi 53711United States',1),('00:1B:C5','Ieee Registration Authority','Ieee Registration Authority445 Hoes LanePiscataway Nj 08854United States',1),('00:1B:C6','Strato Rechenzentrum Ag','Strato Rechenzentrum AgPascalstrasse 10D-10587 BerlinGermany',1),('00:1B:C7','Starvedia Technology Inc.','Starvedia Technology Inc.3f, No. 247, Done Sec. 1, Guangming 6th Rd.Jhubei Hsin-chu County 302Taiwan, Republic Of China',1),('00:1B:C8','Miura Co.,ltd','Miura Co.,ltd864-1,hojyotsujiMatsuyama Ehime 799-2430Japan',1),('00:1B:C9','Fsn Display Inc','Fsn Display IncBaeksuk-dong 1141-1, Ilsan Techno Town 1009Koyang-si, Ilsan-gu, Kyeonggi-do, Republic Of KoreaKoyang-si Kyeonggi-do 410722Korea, Republic Of',1),('00:1B:CA','Beijing Run Technology Ltd. Company','Beijing Run Technology Ltd. Company4/f, Hangtian Technology BuildingBeijing 100037China',1),('00:1B:CB','Pempek Systems Pty Ltd','Pempek Systems Pty LtdUnit 3 / 13 Hoyle AvenueCastle Hill Nsw 2154Australia',1),('00:1B:CC','Kingtek Cctv Alliance Co., Ltd.','Kingtek Cctv Alliance Co., Ltd.5f-3, No. 106, Sec. 3, Hsin Yi RoadTaipei  106Taiwan, Republic Of China',1),('00:1B:CD','Daviscomms (s) Pte Ltd','Daviscomms (s) Pte LtdBlk 70 Ubi Crescent #01-07Ubi Techpark408570Singapore',1),('00:1B:CE','Measurement Devices Ltd','Measurement Devices LtdSilverburn CrescentBridge Of DonAberdeen Aberdeenshire Ab23 8ewUnited Kingdom',1),('00:1B:CF','Dataupia Corporation','Dataupia CorporationOne Alewife CenterCambridge Ma 02140United States',1),('00:1B:D0','Identec Solutions','Identec SolutionsHertzstr. 10Weinheim  69469Germany',1),('00:1B:D1','Sogestmatic','Sogestmatic409 Route De La GareChateauneuf De Gadagne Paca 84470France',1),('00:1B:D2','Ultra-x Asia Pacific Inc.','Ultra-x Asia Pacific Inc.5-1-15 SotokandaTokyo Chiyoda-ku 101-0021Japan',1),('00:1B:D3','Matsushita Electric Panasonic Avc','Matsushita Electric Panasonic Avc1-15 Matsuo-cho678-518Kadoma Osaka 571-8504Japan',1),('00:1B:D4','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1B:D5','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1B:D6','Kelvin Hughes Ltd','Kelvin Hughes LtdNew North RoadHainaultIlford Essex Ig6 2urUnited Kingdom',1),('00:1B:D7','Scientific Atlanta, A Cisco Company','Scientific Atlanta, A Cisco Company5030 Sugarloaf ParkwayAtl 1.3.473Lawrenceville Ga 30044United States',1),('00:1B:D8','Dvtel Ltd','Dvtel Ltd5 Sapir46852 HerzeliaIsrael',1),('00:1B:D9','Edgewater Computer Systems','Edgewater Computer Systems1125 Innovation DriveOttawa Ontario K2k-3g6Canada',1),('00:1B:DA','Utstarcom Inc','Utstarcom Inc1275 Harbor Bay PkwyAlameda Ca 94502United States',1),('00:1B:DB','Valeo Vecs','Valeo Vecs2 Avenue Fernand PouillonEuroparcCreteil Ile De France 94042France',1),('00:1B:DC','Vencer Co., Ltd.','Vencer Co., Ltd.20f-1, No.77, Sec.1, Hsin Tai Wu Rd.,Hsi Chih Taipei 221Taiwan, Republic Of China',1),('00:1B:DD','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1B:DE','Renkus-heinz, Inc.','Renkus-heinz, Inc.19201 Cook St.Foothill Ranch Ca 92610United States',1),('00:1B:DF','Iskra Mis','Iskra MisLjubljanska Cesta 24aKranj Slovenia 4000Slovenia',1),('00:1B:E0','Telenot Electronic Gmbh','Telenot Electronic GmbhWiesentalstrae 42Aalen Baden-wrttemberg 73434Germany',1),('00:1B:E1','Vialogy','Vialogy2400 Lincoln AveAltadena Ca 91001United States',1),('00:1B:E2','Ahnlab,inc.','Ahnlab,inc.6th Fl, Ccmm Bldg, 12 Yeouido-dongSeoul  150869Korea, Republic Of',1),('00:1B:E3','Health Hero Network, Inc.','Health Hero Network, Inc.2000 Seaport Blvd.Suite 400Redwood City Ca 94063United States',1),('00:1B:E4','Townet Srl','Townet SrlVia Dante Alighieri, 3/bAcqualagna Pu 61041Italy',1),('00:1B:E5','802automation Limited','802automation Limited18 First AvenueWorthing West Sussex Bn14 9njUnited Kingdom',1),('00:1B:E6','Vr Ag','Vr AgRtistrasse 18Schlieren  Ch-8952Switzerland',1),('00:1B:E7','Postek Electronics Co., Ltd.','Postek Electronics Co., Ltd.Suite 510, Shanghang BuildingHongli RoadShen Zhen Guang Dong 518028China',1),('00:1B:E8','Ultratronik Gmbh','Ultratronik GmbhGewerbestr. 52Herrsching Bavaria D-82211Germany',1),('00:1B:E9','Broadcom Corporation','Broadcom Corporation16215 Alton ParkwayIrvine Ca 92618United States',1),('00:1B:EA','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:1B:EB','Dmp Electronics Inc.','Dmp Electronics Inc.8f., No.12, Wucyuan 7th Rd.Wugu TownshipTaipei County  248Taiwan, Republic Of China',1),('00:1B:EC','Netio Technologies Co., Ltd','Netio Technologies Co., Ltd4f-1, No. 582, Rueiguang Rd., Neihu DistrictTaipei  11492Taiwan, Republic Of China',1),('00:1B:ED','Foundry Networks','Foundry Networks2100 Gold StreetPo Box 649100San Jose Ca 95164United States',1),('00:1B:EE','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1B:EF','Blossoms Digital Technology Co.,ltd.','Blossoms Digital Technology Co.,ltd.Blk25,hengfeng Ind.city,hezhouXixiang TownShenzhen Guangdong 518126China',1),('00:1B:F0','Value Platforms Limited','Value Platforms LimitedRm 712-713, Building 9, 5, Science Park West Ave.,Hong Kong Science Park,Shatin,Hong Kong',1),('00:1B:F1','Nanjing Silvernet Software Co., Ltd.','Nanjing Silvernet Software Co., Ltd.3/f, 10 Building, Nanjing World Window Technology & Software Park12 Dinghuaimen, Gulou District, NanjingNanjing Jiangsu 210013China',1),('00:1B:F2','Kworld Computer Co., Ltd','Kworld Computer Co., LtdNo. 113, Jian 2nd Rd.,Jhonghe Taipei County 235Taiwan, Republic Of China',1),('00:1B:F3','Transradio Sendersysteme Berlin Ag','Transradio Sendersysteme Berlin AgMertensstrasse 63Berlin 13587Germany',1),('00:1B:F4','Kenwin Industrial(hk) Ltd.','Kenwin Industrial(hk) Ltd.Rm.1512 15/f Shatin Galleria18-24 Shan Mei St, FotanHong Kong',1),('00:1B:F5','Tellink Sistemas De Telecomunicacin S.l.','Tellink Sistemas De Telecomunicacin S.l.C/ Mara Tubau N 5 Bajo BMadrid  28050Spain',1),('00:1B:F6','Conwise Technology Corporation Ltd.','Conwise Technology Corporation Ltd.2f No.44, Park Ave. 2, Hsinchu Science ParkHsinchu City  30075Taiwan, Republic Of China',1),('00:1B:F7','Lund Ip Products Ab','Lund Ip Products AbDalbyv. 1Lund Skane 224 60Sweden',1),('00:1B:F8','Digitrax Inc.','Digitrax Inc.450 Cemetery StSuite 206Norcross Ga 30071United States',1),('00:1B:F9','Intellitect Water Ltd','Intellitect Water LtdSuite 19, Basepoint Business CentreAviation Park WestChristchurch Dorset Bh23 ^nwUnited Kingdom',1),('00:1B:FA','G.i.n. Mbh','G.i.n. MbhRaiffeisenstr. 15Griesheim Hessen 64347Germany',1),('00:1B:FB','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, OkinouchiSoma-city Fukushima--pref 976-8501Japan',1),('00:1B:FC','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitouTaipei  112Taiwan, Republic Of China',1),('00:1B:FD','Dignsys Inc.','Dignsys Inc.14f, Digital Empire Bldg., B-1408Yeongtong-gu,Suwon Gyeonggi-do 443-813Korea, Republic Of',1),('00:1B:FE','Zavio Inc.','Zavio Inc.No.1,lising 1st Rd. Science Based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:1B:FF','Millennia Media Inc.','Millennia Media Inc.4200 Day Spring CtPlacerville Ca 95667United States',1),('00:1C:00','Entry Point, Llc','Entry Point, LlcP.o. Box 3354930 East Lincoln RoadIdaho Falls Idaho 83403-3354United States',1),('00:1C:01','Abb Oy Drives','Abb Oy DrivesHiomotie 13Helsinki  Fi-00380Finland',1),('00:1C:02','Atto Devices, Inc','Atto Devices, Inc1350 Willow RdSuite 201Menlo Park Ca 94025United States',1),('00:1C:03','Betty Tv Technology Ag','Betty Tv Technology AgHardturmstrasse 2Zurich  80005Switzerland',1),('00:1C:04','Airgain, Inc.','Airgain, Inc.1930 Palomar Point WaySuite 107Carlsbad Ca 92008United States',1),('00:1C:05','Nonin Medical Inc.','Nonin Medical Inc.13700 1st Avenue NorthPlymouth Mn 55441United States',1),('00:1C:06','Siemens Numerical Control Ltd., Nanjing','Siemens Numerical Control Ltd., NanjingNo. 18 Siemens Road, Jiangning Development ZoneNanjing Jiangsu 211100China',1),('00:1C:07','Cwlinux Limited','Cwlinux LimitedUnit 138, 13/f, Weswick Commercial Building,147-151 Queens Road East,Wan ChaiHong Kong',1),('00:1C:08','Anystream, Inc.','Anystream, Inc.21335 Signal Hill PlazaSterling Va 20164United States',1),('00:1C:09','Sae Electronic Co.,ltd.','Sae Electronic Co.,ltd.23/f,ying Long Zhan Ye Building,No.6025, Shen Nan Road,futian DistrictShenzhen Guang Dong 518040China',1),('00:1C:0A','Shenzhen Aee Technology Co.,ltd.','Shenzhen Aee Technology Co.,ltd.1st Floor B Building, Shenzhen,Tsinghua Hi-tech Park, Nanshan Hi-tech Park North,Shenzhen Guangdong 518057China',1),('00:1C:0B','Smartant Telecom','Smartant Telecom2f, No. 669, Sec. 4, Chung Hsing Rd., ChutungHsinchu  310Taiwan, Republic Of China',1),('00:1C:0C','Tanita Corporation','Tanita Corporation1-14-2,maeno-choItabashi-kuTokyo  174-8630Japan',1),('00:1C:0D','G-technology, Inc.','G-technology, Inc.1653 Stanford StreetSanta Monica Ca 90404United States',1),('00:1C:0E','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:0F','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:10','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92612United States',1),('00:1C:11','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1C:12','Motorola Mobile Devices','Motorola Mobile Devices600 N. Us 45Libertyville Illinois 60048United States',1),('00:1C:13','Optsys Technology Co., Ltd.','Optsys Technology Co., Ltd.Suite B-802 Bundang Techno ParkYatap-dong, Bundang-kuSeongnam-si Gyeonggi-do 463-760Korea, Republic Of',1),('00:1C:14','Vmware, Inc','Vmware, Inc3145 Porter DrivePalo Alto Ca 94304United States',1),('00:1C:15','Txp Corporation','Txp Corporation1299 Commerce Dr.Richardson Texas 75081United States',1),('00:1C:16','Thyssenkrupp Elevator','Thyssenkrupp Elevator9280 Crestwyn Hills DriveMemphis Tn 38125United States',1),('00:1C:17','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1C:18','Sicert S.r.l.','Sicert S.r.l.Via Bernardino Alimena, 128Rome  00173Italy',1),('00:1C:19','Secunet Security Networks Ag','Secunet Security Networks AgKronprinzenstrae 30Essen Nrw 45128Germany',1),('00:1C:1A','Thomas Instrumentation, Inc','Thomas Instrumentation, Inc133 Landing RdCape May Court House Nj 08210United States',1),('00:1C:1B','Hyperstone Gmbh','Hyperstone GmbhLine-eid-str. 3Konstanz Baden-wrttemberg 78467Germany',1),('00:1C:1C','Center Communication Systems Gmbh','Center Communication Systems GmbhIgnaz-koeck-strasse 19Vienna  A-1210Austria',1),('00:1C:1D','Chenzhou Gospell Digital Technology Co.,ltd','Chenzhou Gospell Digital Technology Co.,ltdBailutang,suxian District,Chenzhou Hunan 423025China',1),('00:1C:1E','Emtrion Gmbh','Emtrion GmbhGreschbachstrasse 12Karlsruhe Baden Wuerttemberg 76229Germany',1),('00:1C:1F','Quest Retail Technology Pty Ltd','Quest Retail Technology Pty Ltd37-39 Walsh StreetThebarton Sa 5031Australia',1),('00:1C:20','Clb Benelux','Clb BeneluxRamgatseweg 17Raamsdonksveer Nbr 4941 VnNetherlands',1),('00:1C:21','Nucsafe Inc.','Nucsafe Inc.601 Oak Ridge TurnpikeOak Ridge Tennessee 37830United States',1),('00:1C:22','Aeris Elettronica S.r.l.','Aeris Elettronica S.r.l.Zona Ind.le VallecupaColonnella Teramo 64010Italy',1),('00:1C:23','Dell Inc','Dell IncOne Dell Way,  Ms Rr5-45Round Rock Texas 78682United States',1),('00:1C:24','Formosa Wireless Systems Corp.','Formosa Wireless Systems Corp.No. 408, Guandong Rd.,Hsinchu City  300Taiwan, Republic Of China',1),('00:1C:25','Hon Hai Precision Ind. Co.,ltd.','Hon Hai Precision Ind. Co.,ltd.66,chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:1C:26','Hon Hai Precision Ind. Co.,ltd.','Hon Hai Precision Ind. Co.,ltd.66,chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:1C:27','Sunell Electronics Co.','Sunell Electronics Co.3rd Floor,bldg.514,bagua RdFutian DistrictShenzhen Guangdong 518029China',1),('00:1C:28','Sphairon Access Systems Gmbh','Sphairon Access Systems GmbhManfred-von-ardenne-ring 20Dresden Saxony 01099Germany',1),('00:1C:29','Core Digital Electronics Co., Ltd','Core Digital Electronics Co., Ltd1006# 102 Chunuitechnopark 200-1Chunui-dong, Wonmi-guBucheon-city Gyunggi-do 420-857Korea, Republic Of',1),('00:1C:2A','Envisacor Technologies Inc.','Envisacor Technologies Inc.14845-6 Yonge Street, Suite 310Aurora On L4g 6h8Canada',1),('00:1C:2B','Alertme.com Limited','Alertme.com Limited27-28 Bridge StreetCambridge Cambridgeshire Cb2 1ujUnited Kingdom',1),('00:1C:2C','Synapse','Synapse132 Export CircleHuntsville Al 35806United States',1),('00:1C:2D','Flexradio Systems','Flexradio Systems8900 Marybank Dr.Austin Tx 78750United States',1),('00:1C:2E','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville Ca 95747United States',1),('00:1C:2F','Pfister Gmbh','Pfister GmbhSttzlinger Strae 70Augsburg Bavaria 86165Germany',1),('00:1C:30','Mode Lighting (uk ) Ltd.','Mode Lighting (uk ) Ltd.The Maltings63 High StreetWare Hertfordshire Sg12 9adUnited Kingdom',1),('00:1C:31','Mobile Xp Technology Co., Ltd','Mobile Xp Technology Co., LtdRoom No.2506,tri-tower C Building,no.66zhongguancun East Road,haidian DistrictBeijing  100080China',1),('00:1C:32','Telian Corporation','Telian Corporation4fl. Namjeon Bldg. 53-3 HaandongKwangmyungsi Kyoungkido 423060Korea, Republic Of',1),('00:1C:33','Sutron','Sutron21300 Ridgetop CirSterling Va 20166United States',1),('00:1C:34','Huey Chiao International Co., Ltd.','Huey Chiao International Co., Ltd.5f, No. 649-1,Chung Cheng Rd.,Hsin Chuang City Taipei 242Taiwan, Republic Of China',1),('00:1C:35','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790vDenmark',1),('00:1C:36','Inewit Nv','Inewit NvSchalinhoevedreef 20dMechelen Antwerp 2800Belgium',1),('00:1C:37','Callpod, Inc.','Callpod, Inc.850 W. JacksonSuite 260Chicago Il 60607United States',1),('00:1C:38','Bio-rad Laboratories, Inc.','Bio-rad Laboratories, Inc.245 Winter St.Suite 100Waltham Ma 02451United States',1),('00:1C:39','S Netsystems Inc.','S Netsystems Inc.10f Sungwon Bldg., 141 Samsung-dongKangnam-kuSeoul  135-716Korea, Republic Of',1),('00:1C:3A','Element Labs, Inc.','Element Labs, Inc.3350 Scott BoulevardBuilding #2Santa Clara Ca 95054United States',1),('00:1C:3B','Amroad Technology Inc.','Amroad Technology Inc.18f-3 No. 150 , Chien I RdChung Ho Taipei Hsien 23511Taiwan, Republic Of China',1),('00:1C:3C','Seon Design Inc.','Seon Design Inc.111-3b Burbidge StreetCoquitlam Bc V3k 7b2Canada',1),('00:1C:3D','Wavestorm','Wavestorm40 Rue Doradour-sur-glaneParis le-de-france 75015France',1),('00:1C:3E','Eckey Limited','Eckey LimitedPo Box 128 057RemueraAuckland  1050New Zealand',1),('00:1C:3F','International Police Technologies, Inc.','International Police Technologies, Inc.4150 S. 87th E. AvenueTulsa Ok 74145United States',1),('00:1C:40','Vdg-security Bv','Vdg-security BvRadonstraat 10-14Zoetermeer Zh 2718 TaNetherlands',1),('00:1C:41','Scemtec Transponder Technology Gmbh','Scemtec Transponder Technology GmbhGewerbeparkstr. 20Reichshof Nrw 51580Germany',1),('00:1C:42','Parallels, Inc.','Parallels, Inc.660 Sw 39h StreetSuite 205Renton Wa 98057United States',1),('00:1C:43','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1C:44','Bosch Security Systems Bv','Bosch Security Systems BvKapittelweg 104827 Hg  Breda Brabant 4827Netherlands',1),('00:1C:45','Chenbro Micom Co., Ltd.','Chenbro Micom Co., Ltd.15fl., No. 150, Jian Yi RoadChung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:1C:46','Qtum','Qtum#507 Byucksan/kyungin Digital Valley 2 481-10Gasan-dong Geumcheon-guSeoul  153-783Korea, Republic Of',1),('00:1C:47','Hangzhou Hollysys Automation Co., Ltd','Hangzhou Hollysys Automation Co., LtdNo.10 Middle Road, Jiancaicheng, Haidian District,Beijing  100096China',1),('00:1C:48','Widefi, Inc.','Widefi, Inc.1333 Gateway BlvdSuite 1012Melbourne Fl 32901United States',1),('00:1C:49','Zoltan Technology Inc.','Zoltan Technology Inc.4f, No.30, Wunsi St.Jhubei Hsinchu 302Taiwan, Republic Of China',1),('00:1C:4A','Avm Gmbh','Avm GmbhAlt-moabit 95Berlin  10559Germany',1),('00:1C:4B','Gener8, Inc.','Gener8, Inc.897 Independence AveMountain View Ca 94043United States',1),('00:1C:4C','Petrotest Instruments','Petrotest InstrumentsLudwig-erhard-ring 13Dahlewitz Bbg 15827Germany',1),('00:1C:4D','Zeetoo, Inc.','Zeetoo, Inc.128 Great RoadBedford Ma 01730United States',1),('00:1C:4E','Tasa International Limited','Tasa International Limited5fbuilding2no.1295 ,xin Jinqiao Road,Shanghai  201206China',1),('00:1C:4F','Macab Ab','Macab AbVannhgsgatan 7Trelleborg  23166Sweden',1),('00:1C:50','Tcl Technoly Electronics(huizhou)co.,ltd','Tcl Technoly Electronics(huizhou)co.,ltd10/f, Block A , Tcl Tower1 Gaoxin Nan Road, Nanshan DistrictShenzhen Guangdong 518057China',1),('00:1C:51','Celeno Communications','Celeno Communications22 Zarhin StreetRaanana  43665Israel',1),('00:1C:52','Visionee Srl','Visionee SrlViale Della Repubblica, 22Villorba Treviso 31050Italy',1),('00:1C:53','Synergy Lighting Controls','Synergy Lighting ControlsOne Lithonia WayConyers Ga 30012United States',1),('00:1C:54','Hillstone Networks Inc','Hillstone Networks IncA-1905 E-wing CenterZhichun Road, HaidianBeijing  100086China',1),('00:1C:55','Shenzhen Kaifa Technology Co.','Shenzhen Kaifa Technology Co.7006 Caitian Road, Futian District,Shenzhen Guangdong 518035China',1),('00:1C:56','Pado Systems, Inc.','Pado Systems, Inc.#706 Loadland Ez Tower 153Gumi-dong, Bundang-guSungnam Gyung Gi-do 463-810Korea, Republic Of',1),('00:1C:57','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:58','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:59','Devon It','Devon It1100 First AvenueSuite 100King Of Prussia Pa 19406United States',1),('00:1C:5A','Advanced Relay Corporation','Advanced Relay Corporation1896 Columbia StEugene Or 97403United States',1),('00:1C:5B','Chubb Electronic Security Systems Ltd','Chubb Electronic Security Systems LtdShadsworth RoadBlackburn Lancashire Bb1 2prUnited Kingdom',1),('00:1C:5C','Integrated Medical Systems, Inc.','Integrated Medical Systems, Inc.1984 Obispo AvenueSignal Hill Ca 90755United States',1),('00:1C:5D','Leica Microsystems','Leica MicrosystemsPobox 80515 Coldhams LaneCambridge  Cb1 3yzUnited Kingdom',1),('00:1C:5E','Aston France','Aston France151 Avenue GallieniBagnolet Ile De France 93177France',1),('00:1C:5F','Winland Electronics, Inc.','Winland Electronics, Inc.1950 Excel DriveMankato Mn 56001United States',1),('00:1C:60','Csp Frontier Technologies,inc.','Csp Frontier Technologies,inc.3-2-3,sasazukaShibuya-ku Tokyo 151-0073Japan',1),('00:1C:61','Galaxy Technology (hk) Ltd.','Galaxy Technology (hk) Ltd.Unit 802, 8/f, Shui Hing Centre, 13 Sheung Yuet Road,Kowloon Bay  Kln.,Hong Kong',1),('00:1C:62','Lg Electronics Inc','Lg Electronics Inc60-39, Gasan-dongKumchon-guSeoul  153-023Korea, Republic Of',1),('00:1C:63','Truen','Truen4f Samwon Bldg., 451-7Bangbae-dong, Seocho-guSeoul  137-818Korea, Republic Of',1),('00:1C:64','Cellnet+hunt','Cellnet+hunt6436 County Road 11Pequot Lakes Minnesota 56472United States',1),('00:1C:65','Joescan, Inc.','Joescan, Inc.119 E 8th St.Vancouver Wa 98660United States',1),('00:1C:66','Ucamp Co.,ltd','Ucamp Co.,ltd#1015, Kolon Science Valley Seoul Guro-dong,guro-gu, 152-848Korea, Republic Of',1),('00:1C:67','Pumpkin Networks, Inc.','Pumpkin Networks, Inc.3fl Jungho Bldg, 108-4 Sangdo-dong, Dongjak-guSeoul  156-030Korea, Republic Of',1),('00:1C:68','Anhui Sun Create Electronics Co., Ltd','Anhui Sun Create Electronics Co., LtdNo.199 Xiangzhang RoadHefei Anhui 230088China',1),('00:1C:69','Packet Vision Ltd','Packet Vision LtdSc HouseVanwall RoadMaidenhead Berks Sl6 4ubUnited Kingdom',1),('00:1C:6A','Weiss Engineering Ltd.','Weiss Engineering Ltd.Florastrasse 42Uster Zh 8610Switzerland',1),('00:1C:6B','Covax  Co. Ltd','Covax  Co. Ltd3-27-22 Kitahanada-cho KitakuSakai-shi Oosaka 591-8002Japan',1),('00:1C:6C','Jabil Circuit (guangzhou) Limited','Jabil Circuit (guangzhou) Limited128, Jun Cheng Road,uangzhou Economic And Technological Development DistrictGuangdong ProvinceGuangzhou Guangdong 510530China',1),('00:1C:6D','Kyohritsu Electronic Industry Co., Ltd.','Kyohritsu Electronic Industry Co., Ltd.2-5-1, Nipponbashi-nishi,Naniwa-kuOsaka  556-0004Japan',1),('00:1C:6E','Newbury Networks, Inc.','Newbury Networks, Inc.419 Boylston StreetBoston Ma 02116United States',1),('00:1C:6F','Emfit Ltd','Emfit LtdKonttisentie 8 BVaajakoski  40800Finland',1),('00:1C:70','Novacomm Ltda','Novacomm LtdaRua Beijui, 70Santo AmaroSao Paulo  04689-000Brazil',1),('00:1C:71','Emergent Electronics','Emergent ElectronicsBldg 2 Level 3 Suite 3052591 Wexford-bayne RoadSewickley Pa 15143United States',1),('00:1C:72','Mayer & Cie Gmbh & Co Kg','Mayer & Cie Gmbh & Co KgEmil Mayer Strasse 10Albstadt Baden Wrttemberg 72461Germany',1),('00:1C:73','Arista Networks, Inc.','Arista Networks, Inc.275 Middlefield Road, Ste 50Menlo Park California 94025United States',1),('00:1C:74','Syswan Technologies Inc.','Syswan Technologies Inc.2050 Beavercreek RoadSuite 101 #388Oregon City Oregon 97045United States',1),('00:1C:75','Rf Systems Gmbh','Rf Systems GmbhEinsteinstrae 11Viernheim Hessen D 68519Germany',1),('00:1C:76','The Wandsworth Group Ltd','The Wandsworth Group LtdAlbert DriveSheerwaterWoking Surrey Gu21 5seUnited Kingdom',1),('00:1C:77','Prodys','ProdysC/trigo 54 Pol. Ind. PolvorancaLeganes Madrid 28914Spain',1),('00:1C:78','Wyplay Sas','Wyplay Sas200 Avenue De ProvenceAllauch Bdr 13190France',1),('00:1C:79','Cohesive Financial Technologies Llc','Cohesive Financial Technologies Llc200 South Wacker Dr.Suite 1500Chicago Il 60606United States',1),('00:1C:7A','Perfectone Netware Company Ltd','Perfectone Netware Company LtdUnit 815, Sun Fung Centre,Kwok Shui Rd,Kwai ChungHong Kong',1),('00:1C:7B','Castlenet Technology Inc.','Castlenet Technology Inc.No.64, Chung-shan Rd.Tu-cheng City Taipei 236Taiwan, Republic Of China',1),('00:1C:7C','Perq Systems Corporation','Perq Systems Corporation2600 Liberety AvenueP.o. Box 2600Pittsburgh Pa 15230United States',1),('00:1C:7D','Excelpoint Manufacturing Pte Ltd','Excelpoint Manufacturing Pte Ltd15, Changi Business ParkCentral 1, 5th Level486057Singapore',1),('00:1C:7E','Toshiba','Toshiba2-9,suehiro-choOme Tokyo 1988710Japan',1),('00:1C:7F','Check Point Software Technologies','Check Point Software Technologies3a Jabotinsky St.Diamond TowerRamat Gan  52520Israel',1),('00:1C:80','New Business Division/rhea-information Co., Ltd.','New Business Division/rhea-information Co., Ltd.4f 594 Yeong Pung Bldg, Gueui-dongSeoul Gwangjin-gu 143-200Korea, Republic Of',1),('00:1C:81','Nextgen Venturi Ltd','Nextgen Venturi LtdTechnium 2Kings RoadSwansea West Glamorgan Sa18pjUnited Kingdom',1),('00:1C:82','Genew Technologies','Genew Technologies3a3 Building B1, Cyber-tech Zone,Gaoxin Ave. 7s, Hi-tech Industrial Park,Shenzhen Guangdong 518057China',1),('00:1C:83','New Level Telecom Co., Ltd.','New Level Telecom Co., Ltd.4floor, 342-15, Shindaebang2-dong,Dongjak-guSeoul  156-847Korea, Republic Of',1),('00:1C:84','Stl Solution Co.,ltd.','Stl Solution Co.,ltd.#710, World Meridian Venture Center I60-24, Gasan-dong, Geumcheon-guSeoul  152781Korea, Republic Of',1),('00:1C:85','Eunicorn','Eunicorn226-16 Unbo B/d Suckchon-dong Songpa-guSeoul  138845Korea, Republic Of',1),('00:1C:86','Cranite Systems, Inc.','Cranite Systems, Inc.121 Albright WayLos Gatos Ca 95032United States',1),('00:1C:87','Uriver Inc.','Uriver Inc.3rd., Fl., Bogwang Bldg., Poi-dong, 238-7 Gangnam-gu,Seoul  135-964Korea, Republic Of',1),('00:1C:88','Transystem Inc.','Transystem Inc.No. 1-2, Li-hsin Rd 1, Science-based Industrial ParkHsinchu  300Taiwan, Republic Of China',1),('00:1C:89','Force Communications, Inc.','Force Communications, Inc.Po Box 250286Plano Tx 75025United States',1),('00:1C:8A','Verari Systems Inc','Verari Systems Inc9449 Carroll Park DriveSan Diego Ca 92121United States',1),('00:1C:8B','Mj Innovations Ltd.','Mj Innovations Ltd.333 Wyecroft RoadUnit 3Oakville Ontario L6k 2h2Canada',1),('00:1C:8C','Dial Technology Ltd.','Dial Technology Ltd.6f-4, No.18, Lane.609, Sec.5, Chongsin Rd.,Sanchong City Taipei County 241Taiwan, Republic Of China',1),('00:1C:8D','Mesa Imaging','Mesa ImagingBadenerstrasse 569Zrich Zh 8048Switzerland',1),('00:1C:8E','Alcatel-lucent Ipd','Alcatel-lucent Ipd701 E. Middlefield Rd.Mountain View Ca 94043United States',1),('00:1C:8F','Advanced Electronic Design, Inc.','Advanced Electronic Design, Inc.344 John L Dietsch Blvd., Unit #2North Attleboro Ma 02763United States',1),('00:1C:90','Empacket Corporation','Empacket CorporationOsaki Ki Bldg.1-19-10 OsakiShinagawa Tokyo 141-0032Japan',1),('00:1C:91','Gefen Inc.','Gefen Inc.6265 Variel Ave.Woodland Hills Ca 91367United States',1),('00:1C:92','Tervela','Tervela43 Nagog ParkSuite 201Acton Ma 01720United States',1),('00:1C:93','Exadigm Inc','Exadigm Inc2871 Pullman StSanta Ana Ca 92705United States',1),('00:1C:94','Li-cor Biosciences','Li-cor Biosciences4647 Superior StreetLincoln Ne 68504United States',1),('00:1C:95','Opticomm Corporation','Opticomm Corporation6827 Nancy Ridge DrSan Diego Ca 92121United States',1),('00:1C:96','Linkwise Technology Pte Ltd','Linkwise Technology Pte LtdBlk 3, Ang Mo Kio Industrial Park 2a#06-03. Amk Tech I568050Singapore',1),('00:1C:97','Enzytek Technology Inc.,','Enzytek Technology Inc.,7f, No.35, Hsueh Fu Rd.,Hsinchu  300,Taiwan, Republic Of China',1),('00:1C:98','Lucky Technology (hk) Company Limited','Lucky Technology (hk) Company LimitedFlat/rm 1503 15/f Island Beverley No 1 Great George Street Causeway Bay999077Hong Kong',1),('00:1C:99','Shunra Software Ltd.','Shunra Software Ltd.20 Hataas St.Kefar-saba  44425Israel',1),('00:1C:9A','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1C:9B','Feig Electronic Gmbh','Feig Electronic GmbhLange Strae 4Weilburg Hessen 35781Germany',1),('00:1C:9C','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1C:9D','Liecthi Ag','Liecthi Ag10 Unterholz StreetKriegstetten Solothurn 4566Switzerland',1),('00:1C:9E','Dualtech It Ab','Dualtech It AbBanehagsgatan 1fGothenburg Vstra Gtaland 41451Sweden',1),('00:1C:9F','Razorstream, Llc','Razorstream, Llc2381-c Renaissance DriveLas Vegas Nv 89119United States',1),('00:1C:A0','Production Resource Group, Llc','Production Resource Group, Llc539 Temple Hill RoadNew Windsor Ny 12553United States',1),('00:1C:A1','Akamai Technologies, Inc.','Akamai Technologies, Inc.8 Cambridge CenterCambridge Ma 02142United States',1),('00:1C:A2','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano  20126Italy',1),('00:1C:A3','Terra','TerraDraugystes Str. 22Kaunas  Lt-51256Lithuania',1),('00:1C:A4','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:1C:A5','Zygo Corporation','Zygo Corporation21 Laurel Brook Rd.Middlefield Ct 06455United States',1),('00:1C:A6','Win4net','Win4net1301 Kolon Digital Tower,222-7 Kuro-dongKuro-gu Seoul 152-848Korea, Republic Of',1),('00:1C:A7','International Quartz Limited','International Quartz Limited2nd Floor, 2, Dai Wang Street,Tai Po Industrial Estate, Tai Po, N.t.Hong Kong 852China',1),('00:1C:A8','Airties Wireless Networks','Airties Wireless NetworksBuyukdere Cad No 103 Kat 5Mecidiyekoy, Istanbul 34460Turkey',1),('00:1C:A9','Audiomatica Srl','Audiomatica SrlVia Manfredi 12Florence Italy 50136Italy',1),('00:1C:AA','Bellon Pty Ltd','Bellon Pty LtdUnit 12/12-18 Victoria St EastLidcombe Nsw 2000Australia',1),('00:1C:AB','Meyer Sound Laboratories, Inc.','Meyer Sound Laboratories, Inc.2832 San Pablo Ave.Berkeley Ca 94702United States',1),('00:1C:AC','Qniq Technology Corp.','Qniq Technology Corp.5f, No.133, Sec.4, Minsheng E. Rd.,Songshan District,Taipei  105Taiwan, Republic Of China',1),('00:1C:AD','Wuhan Telecommunication Devices Co.,ltd','Wuhan Telecommunication Devices Co.,ltd88 Youkeyuan Road,hongshan DistrictWuhan Hubei 430074China',1),('00:1C:AE','Wichorus, Inc.','Wichorus, Inc.3590 N 1st Street, Suite 300San Jose Ca 95134United States',1),('00:1C:AF','Plato Networks Inc.','Plato Networks Inc.2855 Kifer RoadSuite 204Santa Clara Ca 95051United States',1),('00:1C:B0','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:B1','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:B2','Bpt Spa','Bpt SpaVia Stazione,48Sesto Al Reghena Pordenone 33079Italy',1),('00:1C:B3','Apple, Inc','Apple, Inc1 Infinite LoopCupertino California 95014United States',1),('00:1C:B4','Iridium Satellite Llc','Iridium Satellite Llc8440 S. River ParkwayTempe Az 85284United States',1),('00:1C:B5','Neihua Network Technology Co.,ltd.(nhn)','Neihua Network Technology Co.,ltd.(nhn)Plot Xinmei Road 102-q,new DistrictWuxi Jiangsu 214028China',1),('00:1C:B6','Duzon Cnt Co., Ltd.','Duzon Cnt Co., Ltd.14th Floor, Ire Building 2Yangpyung-dong 4ga, Youngdungpo-guSeoul  150-967Korea, Republic Of',1),('00:1C:B7','Usc Digiark Corporation','Usc Digiark Corporation6f Tennoz Central Tower 2-2-24 HigashishinagawaTokyo Shinagawa-ku 140-0002Japan',1),('00:1C:B8','Cbc Co., Ltd','Cbc Co., Ltd2-15-13, Tsukishima, Chuo-kuTokyo  104-0052Japan',1),('00:1C:B9','Kwang Sung Electronics Co., Ltd.','Kwang Sung Electronics Co., Ltd.201, World Venture Town 60-24, Gasan-dong Geumchun-gu,Seoul  153-801Korea, Republic Of',1),('00:1C:BA','Verscient, Inc.','Verscient, Inc.7700 Equitable DriveSuite 100Eden Prairie Mn 55344United States',1),('00:1C:BB','Musicianlink','Musicianlink2401 Cory Ave.San Jose Ca 95128United States',1),('00:1C:BC','Castgrabber, Llc','Castgrabber, Llc6507 Wilkins AvenuePittsburgh Pa 15217United States',1),('00:1C:BD','Ezze Mobile Tech., Inc.','Ezze Mobile Tech., Inc.3f, Bubmusa Bldg., 151-31Nonhyun-dong, Kangnam-kuSeoul 135-824Korea, Republic Of',1),('00:1C:BE','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:1C:BF','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1C:C0','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1C:C1','Motorola Mobile Devices','Motorola Mobile Devices600 N. Us 45Libertyville Illinois 60048United States',1),('00:1C:C2','Part Ii Research, Inc.','Part Ii Research, Inc.4601 E. Airport Dr.Ontario Ca 91761United States',1),('00:1C:C3','Pace Micro Technology Plc','Pace Micro Technology PlcSalts MillVictoria RoadBradford West Yorkshire Bd18 3lfUnited Kingdom',1),('00:1C:C4','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:1C:C5','3com Ltd','3com Ltd3com Europe Ltd, Peoplebuilding 2Peoplebuilding Estate, Maylands AvenueHemel Hempstead Herts Hp2 4nwUnited Kingdom',1),('00:1C:C6','Prostor Systems','Prostor Systems5555 Central AvenueSuite 100Boulder Colorado 80301United States',1),('00:1C:C7','Rembrandt Technologies, Llc D/b/a Remstream','Rembrandt Technologies, Llc D/b/a Remstream140 South Beverly DriveSuite 203Beverly Hills Ca 90212United States',1),('00:1C:C8','Industronic Industrie-electronic Gmbh & Co. Kg','Industronic Industrie-electronic Gmbh & Co. KgCarl-jacob-kolb-weg 1Wertheim Baden-wuerttemberg 97877Germany',1),('00:1C:C9','Kaise Electronic Technology Co., Ltd.','Kaise Electronic Technology Co., Ltd.No.678, Wunsyue Rd., Zuoying District,Kaohsiung  813Taiwan, Republic Of China',1),('00:1C:CA','Shanghai Gaozhi Science & Technology Development Co.','Shanghai Gaozhi Science & Technology Development Co.No.283 Qin Jiang Rd. Shanghai,chinaShanghai  200233China',1),('00:1C:CB','Forth Corporation Public Company Limited','Forth Corporation Public Company Limited226/12,13,16 Paholyothin RoadSamsennai, PayathaiBangkok  10400Thailand',1),('00:1C:CC','Research In Motion Limited','Research In Motion Limited305 Phillip StreetWaterloo Ontario N2l 3w8Canada',1),('00:1C:CD','Alektrona Corporation','Alektrona Corporation95 Hathaway Street, Suite 10Providence Ri 02907United States',1),('00:1C:CE','By Techdesign','By TechdesignC/ Marques De Ahumada 11Madrid  28028Spain',1),('00:1C:CF','Limetek','Limetek#213-1, Byucksan Digital Valley Ii, 480-10, Gasan-dong,Geumchen-guSeoul  153-783Korea, Republic Of',1),('00:1C:D0','Circleone Co.,ltd.','Circleone Co.,ltd.860-1,nodaBeppu-shi Ooita-ken 874-0016Japan',1),('00:1C:D1','Waves Audio Ltd','Waves Audio LtdAzrilei Center 3, Triangle Tower32nd FloorTel Aviv Central 67023Israel',1),('00:1C:D2','King Champion (hong Kong) Limited','King Champion (hong Kong) LimitedUnit 1520, 15/f, Phase 1, Metro Centre,32 Lam Hing Street, Kowloon Bay,KowloonHong Kong',1),('00:1C:D3','Zp Engineering Sel','Zp Engineering SelVia Ardito Desio, 60Tecnopolo TiburtinoRome  00131Italy',1),('00:1C:D4','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1C:D5','Zeevee, Inc.','Zeevee, Inc.1 Monarch DriveSuite 200Littleton Ma 01460United States',1),('00:1C:D6','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1C:D7','Harman/becker Automotive Systems Gmbh','Harman/becker Automotive Systems GmbhBecker-gring-str. 16Karlsbad Baden - Wrttemberg 76307Germany',1),('00:1C:D8','Blueant Wireless','Blueant Wireless245 St.kilda Rd, St KildaMelbourne Victoria 3182Australia',1),('00:1C:D9','Globaltop Technology Inc.','Globaltop Technology Inc.16 Nan-ke 9th Rd. Science-base Industrial Park,Shanhua Tainan County 741Taiwan, Republic Of China',1),('00:1C:DA','Exegin Technologies Limited','Exegin Technologies Limited204 - 2071 Kingsway AvenuePort Coquitlam Bc V3c 6n2Canada',1),('00:1C:DB','Carpoint Co.,ltd','Carpoint Co.,ltd1340-6, Namgang Bld 7f, Seocho-dongSeocho-ku,Seoul  137-070Korea, Republic Of',1),('00:1C:DC','Custom Computer Services, Inc.','Custom Computer Services, Inc.1020 Spring City DriveWaukesha Wi 53186United States',1),('00:1C:DD','Cowbell Engineering Co., Ltd.','Cowbell Engineering Co., Ltd.1739-1 NagatoroSaku Nagano 385-0021Japan',1),('00:1C:DE','Interactive Multimedia Exchange Inc.','Interactive Multimedia Exchange Inc.No. 165 Wenlin Road.Taipei Taiwan 111Taiwan, Republic Of China',1),('00:1C:DF','Belkin International Inc.','Belkin International Inc.501 W. Walnut St.Compton Ca 90220United States',1),('00:1C:E0','Dasan Tps','Dasan TpsHumax Village 6f, 11-4 Sunae-dong, Bundang-guSeongnam-si Gyeonggi-do 463-825Korea, Republic Of',1),('00:1C:E1','Indra Sistemas, S.a.','Indra Sistemas, S.a.Ctra. De Loeches, N. 9Torrejn De Ardoz Madrid 28850Spain',1),('00:1C:E2','Attero Tech, Llc.','Attero Tech, Llc.1315 Directors Row - Suite 107Fort Wayne Indiana 46808United States',1),('00:1C:E3','Optimedical Systems','Optimedical Systems235 Hembree Park DriveRoswell Ga 30076United States',1),('00:1C:E4','Elesy Jsc','Elesy JscAltayskaya Street, 161aTomsk Oblast 634021Russian Federation',1),('00:1C:E5','Mbs Electronic Systems Gmbh','Mbs Electronic Systems GmbhRingstrasse 382319 Starnberg Bavaria 82319Germany',1),('00:1C:E6','Innes','Innes80 Avenue Des Buttes De CosmesRennes  35700France',1),('00:1C:E7','Rocon Plc Research Centre','Rocon Plc Research Centre21 Vek 56a Str.Sofia  1700Bulgaria',1),('00:1C:E8','Cummins Inc','Cummins Inc1400 73rd Ave NeFridley Mn 55432United States',1),('00:1C:E9','Galaxy Technology Limited','Galaxy Technology Limited9/f Win Full Commerical Building, 172-176 Wing Lok Street,Sheung Wan,Hong Kong',1),('00:1C:EA','Scientific-atlanta, Inc','Scientific-atlanta, Inc5030 Sugarloaf PkwyAtl 2.t.603Lawrenceville Ga 30044United States',1),('00:1C:EB','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1C:EC','Mobilesoft (aust.) Pty Ltd','Mobilesoft (aust.) Pty LtdSuite 2, 27-35 Grosvenor StreetNeutral BaySydney Nsw 2089Australia',1),('00:1C:ED','Environnement Sa','Environnement Sa111 Bd. RobespierrePoissy Yvelines 78300France',1),('00:1C:EE','Sharp Corporation','Sharp Corporation22-22,nagaike-cho,abeno-kuOsaka  545-8522Japan',1),('00:1C:EF','Primax Electronics Ltd','Primax Electronics Ltd669, Ruey Kuang Road, NeihuTaipei  114Taiwan, Republic Of China',1),('00:1C:F0','D-link Corporation','D-link CorporationNo.289, Sinhu 3rd Rd.,Neihu District, Taipei City 114Taiwan, Republic Of China',1),('00:1C:F1','Supox Technology Co. , Ltd.','Supox Technology Co. , Ltd.7f, 419 , Chung San Rd. , Sec 2Chung Ho Taipei Hsien 235Taiwan, Republic Of China',1),('00:1C:F2','Tenlon Technology Co.,ltd.','Tenlon Technology Co.,ltd.4/f.,shenhua Bldg,no.3155,binhe Road,futian DistrictShenzhen Guangdong 518033China',1),('00:1C:F3','Evs Broadcast Equipment','Evs Broadcast EquipmentLiege Science ParkRue Bois St Jean 16Ougree Liege 4102Belgium',1),('00:1C:F4','Media Technology Systems Inc','Media Technology Systems Inc766 Lakefield RoadUnit FWestlake Village Ca 91377United States',1),('00:1C:F5','Wiseblue Technology Limited','Wiseblue Technology LimitedRm G5, 5/f, Kingsford Industrial Building Phase Ii, 26-32 Kwai Hei Street,Kwai Chung N.t.Hong Kong',1),('00:1C:F6','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:F7','Audioscience','Audioscience729 West 16th StSuite C2Costa Mesa California 92627United States',1),('00:1C:F8','Parade Technologies, Ltd.','Parade Technologies, Ltd.C/o Parade Technologies, Inc.530 Lakeside Dr. Suite 230Sunnyvale Ca 94085United States',1),('00:1C:F9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1C:FA','Alarm.com','Alarm.com1861 International DriveMclean Va 22102United States',1),('00:1C:FB','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1C:FC','Suminet Communication Technologies (shanghai) Co., Ltd.','Suminet Communication Technologies (shanghai) Co., Ltd.4f, 3bld. 647 Long, Songtao Road, Zhangjiang Hi-tech ParkShanghai  201203China',1),('00:1C:FD','Universal Electronics','Universal Electronics6101 Gateway DriveCypress California 90630United States',1),('00:1C:FE','Quartics Inc','Quartics Inc15241 Laguna Canyon RoadSte 200Irvine Ca 92618United States',1),('00:1C:FF','Napera Networks Inc','Napera Networks Inc7683 Se 27thSuite 120Mercer Island Wa 98040United States',1),('00:1D:00','Brivo Systems, Llc','Brivo Systems, Llc4330 East West HighwaySuite 250Bethesda Md 20814United States',1),('00:1D:01','Neptune Digital','Neptune DigitalMednarodni Mejni Prehod 6Vrtojba Nova Gorica 5290Slovenia',1),('00:1D:02','Cybertech Telecom Development','Cybertech Telecom DevelopmentHazenkoog 25Alkmaar Noord Holland 1822 BsNetherlands',1),('00:1D:03','Design Solutions Inc.','Design Solutions Inc.81 David Love PlaceGoleta Ca 93117United States',1),('00:1D:04','Zipit Wireless, Inc.','Zipit Wireless, Inc.49 Salters Road.Suite 6Greenville Sc 29607United States',1),('00:1D:05','Ilight','IlightUnit 4 Enterprise CentreRogues HillPenshurst Kent Tn11 8bgUnited Kingdom',1),('00:1D:06','Hm Electronics, Inc.','Hm Electronics, Inc.14110 Stowe DrivePoway Ca 92064United States',1),('00:1D:07','Shenzhen Sang Fei Consumer Communications Co.,ltd','Shenzhen Sang Fei Consumer Communications Co.,ltd11 Science And Technology Road,Science And Technology Industrial Park Nanshan District,Shenzhen Guangdong 518057China',1),('00:1D:08','Jiangsu Yinhe Electronics Co., Ltd','Jiangsu Yinhe Electronics Co., Ltd188 Nanhuan RoadTangqiaoZhangjiagang Jiangsu 215611China',1),('00:1D:09','Dell Inc','Dell IncOne Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:1D:0A','Davis Instruments, Inc.','Davis Instruments, Inc.3465 Diablo Ave.Hayward Ca 94545United States',1),('00:1D:0B','Power Standards Lab','Power Standards Lab1201 Marina Village Parkway #101Alameda Ca 94501United States',1),('00:1D:0C','Mobilecompia','MobilecompiaDongwon Bldg, 725-30, Yeoksam-dong, Gangnam-gu,Seoul  135-080Korea, Republic Of',1),('00:1D:0D','Sony Computer Entertainment Inc.','Sony Computer Entertainment Inc.6-21,2chomeMinami-aoyamaMinato-ku Tokyo 107-0062Japan',1),('00:1D:0E','Agapha Technology Co., Ltd.','Agapha Technology Co., Ltd.9f No.121, Shingde Rd.,Sanchung City Taipei County 241Taiwan, Republic Of China',1),('00:1D:0F','Tp-link Technologies Co., Ltd.','Tp-link Technologies Co., Ltd.3/f, Bldg. R1-b,Hi-tech Industrial Park, Shennan Rd.,Shenzhen Guangdong 518057China',1),('00:1D:10','Lighthaus Logic, Inc.','Lighthaus Logic, Inc.126-1020 Mainland StreetVancouver Bc V6b 2t4Canada',1),('00:1D:11','Analogue & Micro Ltd','Analogue & Micro LtdLakeside HouseLakesideLlantarnam Industrial Park Cwmbran Np44 3xsUnited Kingdom',1),('00:1D:12','Rohm Co., Ltd.','Rohm Co., Ltd.21 Saiin-mizosaki-cho,Ukyo-ku,Kyoto-shi Kyoto 615-8585Japan',1),('00:1D:13','Nextgtv','Nextgtv13f Byucksan/kyungin Digital Valley LlGasan-dong, Geumcheon-guSeoul  153-803Korea, Republic Of',1),('00:1D:14','Speradtone Information Technology Limited','Speradtone Information Technology LimitedRoom 1001 No.418 Gui Ping Road,Shanghai  200233China',1),('00:1D:15','Shenzhen Dolphin Electronic Co., Ltd','Shenzhen Dolphin Electronic Co., LtdBuilding21,baoyuan, No.1 Industrial Zone,Xixiang, Baoan District,Shenzhen Guangdong 518103China',1),('00:1D:16','Efixo','Efixo5 Avenue De Saint MenetImmeuble Axiome, Bt BMarseille Paca 13011France',1),('00:1D:17','Digital Sky Corporation','Digital Sky Corporation5-5-15 Sotokanda,Chiyoda-ku Tokyo 101-0021Japan',1),('00:1D:18','Power Innovation Gmbh','Power Innovation GmbhRehland 2Achim Niedersachsen 28832Germany',1),('00:1D:19','Arcadyan Technology Corporation','Arcadyan Technology Corporation4f., No. 9 , Park Avenue Ii,Science-based Industrial Park,Hsinchu  300Taiwan, Republic Of China',1),('00:1D:1A','Ovislink S.a.','Ovislink S.a.C/andres Obispo, 37. Pl. 4.Madrid  28043Spain',1),('00:1D:1B','Sangean Electronics Inc.','Sangean Electronics Inc.No. 18, Lane 7, Li-de StreetChung Ho City Taipei Hsien 235Taiwan, Republic Of China',1),('00:1D:1C','Gennet S.a.','Gennet S.a.2 Mesogeion Ave.Pirgos AthinonAthens Attiki 11527Greece',1),('00:1D:1D','Inter-m Corporation','Inter-m Corporation653-5 Banghak-dong, Dobong-kuSeoul  132-846Korea, Republic Of',1),('00:1D:1E','Kyushu Ten Co.,ltd','Kyushu Ten Co.,ltd2360 YunokimotomachiSasebo-city Nagasaki Prefecture 857-0115Japan',1),('00:1D:1F','Siauliu Tauro Televizoriai, Jsc','Siauliu Tauro Televizoriai, JscPramones,15Siauliai  Lt-57318Lithuania',1),('00:1D:20','Comtrend Co.','Comtrend Co.3f-1 10 Lane 609 Chung Hsin Road, Sec 5, San Chung City, Taipei Taiwan 241Taipei  241Taiwan, Republic Of China',1),('00:1D:21','Alcad Sl','Alcad SlPol. Ind. Arreche-ugalde, 1Irn Guipzcoa E-20305Spain',1),('00:1D:22','Foss Analytical A/s','Foss Analytical A/sSlangerupgade 69Hillerd Seeland 3400Denmark',1),('00:1D:23','Sensus Metering Systems','Sensus Metering Systems44 Castilian DriveGoleta California 93117United States',1),('00:1D:24','Aclara Power-line Systems Inc.','Aclara Power-line Systems Inc.945 Hornet DriveHazelwood Mo 63042United States',1),('00:1D:25','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1D:26','Rockridgesound Technology Co.','Rockridgesound Technology Co.Fumin Industrial Park, Houjie TownDong Guan Guang Dong 523956China',1),('00:1D:27','Nac-intercom','Nac-intercomC. Quintela, 27 Portal 4 LocalVigo Pontevedra 36209Spain',1),('00:1D:28','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:1D:29','Doro Ab','Doro AbMagistratsvgen 10Lund  226 43Sweden',1),('00:1D:2A','Tideway Electronic Ltd','Tideway Electronic LtdZhiji Industrial  Area ,jinye RoadB4 Dong. Kuiyong TownShengzhen Longgang Guangdong 518119China',1),('00:1D:2B','Wuhan Pont Technology Co. , Ltd','Wuhan Pont Technology Co. , LtdBuilding E, Guandong Science And Technology Industry  Park,East Lake High Technology Development Zone,Wuhan Hubei 430074China',1),('00:1D:2C','Wavetrend Technologies (pty) Limited','Wavetrend Technologies (pty) LimitedWavetrend House, Building 816/3Hammets Crossing Office Park,selbourne Road, FourwaysGauteng  2021South Africa',1),('00:1D:2D','Pylone, Inc.','Pylone, Inc.4f Nakano Bldg. 4-30-8 Kita-shinjukuShinjuku-ku, Tokyo 169-0074Japan',1),('00:1D:2E','Ruckus Wireless','Ruckus Wireless880 West Maude Ave.Suite 101Sunnyvale Ca 94085United States',1),('00:1D:2F','Quantumvision Corporation','Quantumvision Corporation335 Plantation WayRoswell Ga 30075United States',1),('00:1D:30','Yx Wireless S.a.','Yx Wireless S.a.Av. Vicua Mackenna #4860Edificio 512, Piso 3. MaculSantiago  8580710Chile',1),('00:1D:31','Highpro International R&d Co,.ltd.','Highpro International R&d Co,.ltd.3f,no.295,ruiguang Rd,nei Hu,Taipei  114Taiwan, Republic Of China',1),('00:1D:32','Longkay Communication & Technology (shanghai) Co. Ltd','Longkay Communication & Technology (shanghai) Co. LtdNo.5 Building, Unit 2, Lane 299 Bisheng Rd,Shanghai  201204China',1),('00:1D:33','Maverick Systems Inc.','Maverick Systems Inc.908, Daerungposttower 2-cha, 182-13Guro-dong, Guro-guSeoul  152-790Korea, Republic Of',1),('00:1D:34','Syris Technology Corp','Syris Technology Corp21 F-2,  No. 12,  Sec. 1,  Taijunggang Rd.Taichung  403Taiwan, Republic Of China',1),('00:1D:35','Viconics Electronics Inc.','Viconics Electronics Inc.9245 LangelierSaint Leonard Quebec H1p3k9Canada',1),('00:1D:36','Electronics Corporation Of India Limited','Electronics Corporation Of India LimitedControl And Automation Division-3Ecil PostHyderabad Andhra Pradesh 500 062India',1),('00:1D:37','Thales-panda Transportation System','Thales-panda Transportation System6th Floor, Huijie Plaza, 268 Zhongshan Rd.Nanjing Jiangsu 210008China',1),('00:1D:38','Seagate Technology','Seagate Technology1280 Disc DriveShakopee Mn 55379United States',1),('00:1D:39','Moohadigital Co., Ltd','Moohadigital Co., LtdSeoul Hightech Venture Center C-307 647-26Deungchon-dong Gangseo-guSeoul  157-030Korea, Republic Of',1),('00:1D:3A','Mh Acoustics Llc','Mh Acoustics Llc25a Summit AveSummit Nj 07901United States',1),('00:1D:3B','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1D:3C','Muscle Corporation','Muscle Corporation2-5-35, Kikawa-higashiOsaka  532-0012Japan',1),('00:1D:3D','Avidyne Corporation','Avidyne Corporation202 West DrMelbourne Fl 32904United States',1),('00:1D:3E','Saka Techno Science Co.,ltd','Saka Techno Science Co.,ltdNishi 105-1Kitazuka-machiKanazawa Ishikawa 920-0367Japan',1),('00:1D:3F','Mitron Pty Ltd','Mitron Pty LtdUnit 1112-18 Clarendon StreetArtarmon Nsw 2065Australia',1),('00:1D:40','Living Independently Group, Inc.','Living Independently Group, Inc.767 Third Ave, 14th FloorNew York Ny 10017United States',1),('00:1D:41','Hardy Instruments','Hardy Instruments3860 Calle FortunadaSan Diego Ca 92123United States',1),('00:1D:42','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1D:43','Shenzhen G-link Digital Technology Co., Ltd.','Shenzhen G-link Digital Technology Co., Ltd.4f, E Building,huachuang Da Technology Zone ,hangcheng Highway,gushu,xixiang ,Shenzhen Guangdong 518126China',1),('00:1D:44','Krohne','KrohneKerkeplaat 12Dordrecht Zh 3313 LcNetherlands',1),('00:1D:45','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:46','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:47','Covote Gmbh & Co Kg','Covote Gmbh & Co KgRitterhufen 30Berlin  14165Germany',1),('00:1D:48','Sensor-technik Wiedemann Gmbh','Sensor-technik Wiedemann GmbhAm Brenwald 6Kaufbeuren Bayern 87600Germany',1),('00:1D:49','Innovation Wireless Inc.','Innovation Wireless Inc.4f-1, No.81, Shueili Rd.Hsinchu  30059Taiwan, Republic Of China',1),('00:1D:4A','Carestream Health, Inc.','Carestream Health, Inc.150 Verona StreetRochestser Ny 14608United States',1),('00:1D:4B','Grid Connect Inc.','Grid Connect Inc.1630 W. Diehl RdNaperville Il 60563United States',1),('00:1D:4C','Alcatel-lucent','Alcatel-lucent601 Data DriveM/s 320Plano Tx 75075United States',1),('00:1D:4D','Adaptive Recognition Hungary, Inc','Adaptive Recognition Hungary, IncKiralyhago Ter 8-9Budapest Europe 1126Hungary',1),('00:1D:4E','Tcm Mobile Llc','Tcm Mobile Llc9218 Metcalf,Suite #293Overland Park Kansas 66212United States',1),('00:1D:4F','Apple Computer Inc.','Apple Computer Inc.1 Infinite LoopCupertino California 95014United States',1),('00:1D:50','Spinetix Sa','Spinetix SaParc Scientifique De Lepfl, Btiment CLausanne Vd 1015Switzerland',1),('00:1D:51','Ge Energy','Ge Energy11864 Canon Blvd, Suite 105Newport News Va 23606United States',1),('00:1D:52','Defzone B.v.','Defzone B.v.Transportcentrum 10Enschede Overijssel 7547 RwNetherlands',1),('00:1D:53','S&o Electronics (malaysia) Sdn. Bhd.','S&o Electronics (malaysia) Sdn. Bhd.Lot 202, Bakar ArangIndustrial Estate08000 Sungai Petani KedahMalaysia',1),('00:1D:54','Sunnic Technology & Merchandise Inc.','Sunnic Technology & Merchandise Inc.6f, No.74,zhou-z St.,Taipei  114Taiwan, Republic Of China',1),('00:1D:55','Zantaz, Inc','Zantaz, Inc5758 W. Las Positas AvenuePleasanton Ca 94588United States',1),('00:1D:56','Kramer Electronics Ltd.','Kramer Electronics Ltd.3 Am Veolamo StreetJerusalem  95463Israel',1),('00:1D:57','Caetec Messtechnik','Caetec MesstechnikSchlossstrasse 95aOlching Bayern 82140Germany',1),('00:1D:58','Cq Inc','Cq Inc5f, No. 43, Lane 76, Rui Guang RoadTaipei  114Taiwan, Republic Of China',1),('00:1D:59','Mitra Energy & Infrastructure','Mitra Energy & InfrastructureBoulevard De Leurope 1311301 WavreBelgium',1),('00:1D:5A','2wire Inc.','2wire Inc.1704 Automation ParkwaySan  Jose California 95131United States',1),('00:1D:5B','Tecvan Informatica Ltda','Tecvan Informatica LtdaRua Guaicurus, 145Vila ConceicoDiadema So Paulo 09911-630Brazil',1),('00:1D:5C','Tom Communication Industrial Co.,ltd.','Tom Communication Industrial Co.,ltd.1173 Nippa-choh Kohoku-kuYokohama Kanagawa 223-0057Japan',1),('00:1D:5D','Control Dynamics Pty. Ltd.','Control Dynamics Pty. Ltd.Po Box 636Morley Western Australia 6943Australia',1),('00:1D:5E','Coming Media Corp.','Coming Media Corp.Bona Bld. 4th Fl., 548-18Dogok-1dong, Kangnam-ku,Seoul  135-158Korea, Republic Of',1),('00:1D:5F','Overspeed Sarl','Overspeed Sarl15, Allee Du Bois CailleyLe Thuit-signol Normandie 27370France',1),('00:1D:60','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitouTaipei  112Taiwan, Republic Of China',1),('00:1D:61','Bij Corporation','Bij Corporation7f Takamizawa Building,2-7-10,Kitasaiwai,nishiYokohama Kanagawa 220-0004Japan',1),('00:1D:62','Inphase Technologies','Inphase Technologies2000 Pike RoadLongmont Colorado 80501United States',1),('00:1D:63','Miele & Cie. Kg','Miele & Cie. KgCarl-miele-str. 29Gtersloh  33332Germany',1),('00:1D:64','Adam Communications Systems Int Ltd','Adam Communications Systems Int LtdThe MissionWellington StreetStockport Cheshire Sk1 3ahUnited Kingdom',1),('00:1D:65','Microwave Radio Communications','Microwave Radio Communications101 Billerica Avemue, Bldg 6N. Billerica Ma 01862United States',1),('00:1D:66','Hyundai Telecom','Hyundai TelecomHyundai Telecom Bldg., 4273-12, Shingil-dong, Youngdungpo-gu,Seoul  150-859Korea, Republic Of',1),('00:1D:67','Amec','Amec9f,no.360,ruel Guang Rd,neihuTaipei  114Taiwan, Republic Of China',1),('00:1D:68','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47 BEdegem Antwerp B-2650Belgium',1),('00:1D:69','Knorr-bremse Ag','Knorr-bremse AgMoosacher Str. 80Muenchen By 80809Germany',1),('00:1D:6A','Alpha Networks Inc.','Alpha Networks Inc.No.8 Li-shing Seventh Road,science-basedHsinchu  300Taiwan, Republic Of China',1),('00:1D:6B','Motorola (formerly Netopia, Inc','Motorola (formerly Netopia, Inc6001 Shellmound St4th FloorEmeryville Ca 94608United States',1),('00:1D:6C','Clariphy Communications, Inc.','Clariphy Communications, Inc.16 Technology Dr., Suite 165Irvine Ca 92618United States',1),('00:1D:6D','Confidant International Llc','Confidant International Llc2530 Meridian PkwyDurham North Carolina 27713United States',1),('00:1D:6E','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V Dk-1790Denmark',1),('00:1D:6F','Chainzone Technology Co., Ltd','Chainzone Technology Co., LtdChainzone Tech. Ind Park, Nanxin 1st Rd.Guicheng NanhaiFoshan Guangdong 528200China',1),('00:1D:70','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:71','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:72','Wistron Corporation','Wistron Corporation21f, 88, Sec.1, Hsin Tai Wu Rd., Hsichih,Taipei Hsien 221Taiwan, Republic Of China',1),('00:1D:73','Buffalo Inc.','Buffalo Inc.15,shibata Hondori 4-chome,Minami-kuNagoya Aichi Pref. 457-8520Japan',1),('00:1D:74','Tianjin China-silicon Microelectronics Co., Ltd.','Tianjin China-silicon Microelectronics Co., Ltd.301,3f Building 211,no.214 Hongqi Road, Nankai District, Tianjin ChinaTianjin  300190China',1),('00:1D:75','Radioscape Plc','Radioscape Plc1 Albany TerraceRegents Park London Nw1 4dsUnited Kingdom',1),('00:1D:76','Eyeheight Ltd.','Eyeheight Ltd.Unit 34, Park House15-19 Greenhill CrescentWatford Herts Wd18 8phUnited Kingdom',1),('00:1D:77','Nsgate','NsgateRm 1304, 39 Kirpichnaya StreetMoscow  105187Russian Federation',1),('00:1D:78','Invengo Information Technology Co.,ltd','Invengo Information Technology Co.,ltd3/f,no.t2-b,high-tech Industrial Park SouthShenzhen Guangdong 518057China',1),('00:1D:79','Signamax Llc','Signamax Llc1090 Vermont AvenueWashington Washington D.c. 20005United States',1),('00:1D:7A','Wideband Semiconductor, Inc.','Wideband Semiconductor, Inc.1350 Pear AveSuite CMountain View Ca 94043United States',1),('00:1D:7B','Ice Energy, Inc.','Ice Energy, Inc.9351 Eastman Park DriveSuite BWindsor Colorado 80550United States',1),('00:1D:7C','Abe Elettronica S.p.a.','Abe Elettronica S.p.a.Via Leonardo Da Vinci, 92Caravaggio Bg 24043Italy',1),('00:1D:7D','Giga-byte Technology Co.,ltd.','Giga-byte Technology Co.,ltd.Pin-jen City, Taoyuan,Pin-jen Taoyuan 324Taiwan, Republic Of China',1),('00:1D:7E','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92612United States',1),('00:1D:7F','Tekron International Ltd','Tekron International Ltd409 Cuba Street, AlicetownPo Box 31-285Lower Hutt Wellington 5010New Zealand',1),('00:1D:80','Beijing Huahuan Eletronics Co.,ltd','Beijing Huahuan Eletronics Co.,ltdNo.26,shangdi 6th St.haidian District,Beijing  100085China',1),('00:1D:81','Guangzhou Gateway Electronics Co., Ltd','Guangzhou Gateway Electronics Co., LtdB20#,4f,no.9 Jiangong Road,tianhe Software Park,tianhe District,Guangzhou Guangdong 510665China',1),('00:1D:82','Gn A/s (gn Netcom A/s)','Gn A/s (gn Netcom A/s)Lautrupbjerg 7P.o.box 99Ballerup  Dk - 2750Denmark',1),('00:1D:83','Emitech Corporation','Emitech Corporation2f,no.7-1,industry E,rd.9Science-based Industrial Park,Hsinchu  308Taiwan, Republic Of China',1),('00:1D:84','Gateway, Inc.','Gateway, Inc.610 Gateway DriveP.o. Box 2000North Sioux City South Dakota 57049United States',1),('00:1D:85','Call Direct Cellular Solutions','Call Direct Cellular SolutionsSuite 145, National Innovation CentreAustralian Technology ParkEveleigh Nsw 1430Australia',1),('00:1D:86','Shinwa Industries(china) Ltd.','Shinwa Industries(china) Ltd.8 Pingnanzhong Road, Pingnan Industrial Park, Zhongkai No.4 Road,Huizhou City Guangdong Province 516006China',1),('00:1D:87','Vigtech Labs Sdn Bhd','Vigtech Labs Sdn Bhd45-11 The Boulevard Mid Valley CityLingkaran Syed PutraKuala Lumpur Selangor 59200Malaysia',1),('00:1D:88','Clearwire','Clearwire4400 Carillon PointKirkland Washington 98033United States',1),('00:1D:89','Vaultstor Corporation','Vaultstor Corporation1010 Brioso DriveCosta Mesa Ca 92627United States',1),('00:1D:8A','Techtrex Inc','Techtrex Inc6221 Highway 7, Unit 12Woodbridge Ontalio L4h 0k8Canada',1),('00:1D:8B','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano  20126Italy',1),('00:1D:8C','La Crosse Technology Ltd','La Crosse Technology Ltd2809 Losey Blvd. So.La Crosse Wi 54601United States',1),('00:1D:8D','Raytek Gmbh','Raytek GmbhBlankenburger Str. 135Berlin  13127Germany',1),('00:1D:8E','Alereon, Inc.','Alereon, Inc.7600 N. Capital Of Texas HwyBldg C, #200Austin Tx 78731United States',1),('00:1D:8F','Purewave Networks','Purewave Networks2660-c Marine WayMountain View Ca 94043United States',1),('00:1D:90','Emco Flow Systems','Emco Flow Systems2150 Miller DriveLongmont Co 80501United States',1),('00:1D:91','Digitize, Inc','Digitize, Inc158 Edison RoadLake Hopatcong New Jersey 07849United States',1),('00:1D:92','Micro-star Intl Co.,ltd.','Micro-star Intl Co.,ltd.No.69,li-de St,jung-ho CityTaipei Hsien 235Taiwan, Republic Of China',1),('00:1D:93','Modacom','ModacomJinsuk Building 1536-7Seocho-dong, Seocho-guSeoul  137-073Korea, Republic Of',1),('00:1D:94','Climax Technology Co., Ltd','Climax Technology Co., LtdNo. 258, Hsin Hu 2nd RoadNeihu DistrictTaipei City Taipei 114Taiwan, Republic Of China',1),('00:1D:95','Flash, Inc.','Flash, Inc.3703 N. 200th St.Elkhorn Ne 68022-2922United States',1),('00:1D:96','Watchguard Video','Watchguard Video3001 Summit Ave.Plano Tx 75074United States',1),('00:1D:97','Alertus Technologies Llc','Alertus Technologies Llc11785 Beltsville DriveSuite 1325Beltsville Md 20705United States',1),('00:1D:98','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1D:99','Cyan Optic, Inc.','Cyan Optic, Inc.1390 N. Mcdowell BlvdSuite G-327Petaluma Ca 94954United States',1),('00:1D:9A','Godex International Co., Ltd','Godex International Co., Ltd4f. No.168, Lian-cheng Road Chung-ho City,Taipei Hsien 235Taiwan, Republic Of China',1),('00:1D:9B','Hokuyo Automatic Co., Ltd.','Hokuyo Automatic Co., Ltd.Niitaka 1-10-9Yodogawa-kuOsaka  532-0033Japan',1),('00:1D:9C','Rockwell Automation','Rockwell Automation1 Allen-bradley DriveCs-c239Mayfield Heights Ohio 44124United States',1),('00:1D:9D','Artjoy International Limited','Artjoy International LimitedRoom 1601,no.239 Zhongxing Road,luohu DistrictShenzhen Guangdong 518001China',1),('00:1D:9E','Axion Technologies','Axion Technologies151 Rue Parc InnovationLa Pocatiere Quebec G0r1z0Canada',1),('00:1D:9F','Matt   R.p.traczynscy Sp.j.','Matt   R.p.traczynscy Sp.j.Polnocna 44Koscian Wielkopolskie Pl-64000Poland',1),('00:1D:A0','Heng Yu Electronic Manufacturing Company Limited','Heng Yu Electronic Manufacturing Company LimitedRoom 1004, Hsh Mongkok Plaza,794-802 Nathan Road,KowloonHong Kong',1),('00:1D:A1','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:A2','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:A3','Sabioso','Sabioso189 S State Suite #250Clearfield Utah 84015United States',1),('00:1D:A4','Hangzhou System Technology Co., Ltd','Hangzhou System Technology Co., LtdRoom A1505 Huaxing Times Plaza,no 478 Wensan RoadHangzhou Zhejiang 310012China',1),('00:1D:A5','Wb Electronics','Wb ElectronicsLangelandsvej 1aHerning Herning 7400Denmark',1),('00:1D:A6','Media Numerics Limited','Media Numerics LimitedRodenbacher Chaussee 6Hanau Hessen 63457Germany',1),('00:1D:A7','Seamless Internet','Seamless Internet2050 Russett Way Suite 338Carson City Nevada 89703United States',1),('00:1D:A8','Takahata Electronics Co.,ltd','Takahata Electronics Co.,ltd1188,kubota,kubota-machiYonezawa-shi Yamagata-pref. 992-0003Japan',1),('00:1D:A9','Castles Technology, Co., Ltd','Castles Technology, Co., Ltd2f, No.205, Sec 3 Beishin Rd.,Hsin-tien City Taipei 231Taiwan, Republic Of China',1),('00:1D:AA','Draytek Corp.','Draytek Corp.No. 26, Fu-shing RoadHukou County, Hsin-chu Industrial ParkHsin-chu  303Taiwan, Republic Of China',1),('00:1D:AB','Swissqual License Ag','Swissqual License AgBaarerstrasse 78Zug Postfach 117Switzerland',1),('00:1D:AC','Gigamon Systems Llc','Gigamon Systems Llc736 S. Hillview DriveMilpitas Ca 95035-5455United States',1),('00:1D:AD','Sinotech Engineering Consultants, Inc.  Geotechnical Enginee','Sinotech Engineering Consultants, Inc.  Geotechnical EngineeBasement No.7 Lane 26, Yat-sen Rd.Taipei  110Taiwan, Republic Of China',1),('00:1D:AE','Chang Tseng Technology Co., Ltd','Chang Tseng Technology Co., Ltd2f No.160 Back Building, Len Cheng Rd., Chung Ho CityTaipei Hsien 235Taiwan, Republic Of China',1),('00:1D:AF','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1D:B0','Fujian Hengtong Information Technology Co.,ltd','Fujian Hengtong Information Technology Co.,ltdNo.14-804,building 2,jinxiufucheng,no.338,hualin RoadFuzhou City Fujian Province 350001China',1),('00:1D:B1','Crescendo Networks','Crescendo Networks6 Yoni Netanyahu St.Or-yehuda  60376Israel',1),('00:1D:B2','Hokkaido Electric Engineering Co.,ltd.','Hokkaido Electric Engineering Co.,ltd.South15-west23Nanporo-cho Hokkaido 069-0215Japan',1),('00:1D:B3','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville Ca 95747United States',1),('00:1D:B4','Kumho Eng Co.,ltd','Kumho Eng Co.,ltd498-13, Hyundai B/d 5fPyeongri 3-dong, Seo-guDaegu  703-835Korea, Republic Of',1),('00:1D:B5','Juniper Networks','Juniper Networks1194 N Mathilda Ave.Sunnyvale Ca 94089United States',1),('00:1D:B6','Bestcomm Networks, Inc.','Bestcomm Networks, Inc.4400 E. Broadway Blvd.Suite 201Tucson Az 85711United States',1),('00:1D:B7','Tendril Networks, Inc.','Tendril Networks, Inc.5700-d Flatiron ParkwaySuite 5700-dBoulder Co 80301United States',1),('00:1D:B8','Intoto Inc.','Intoto Inc.3100 De La Cruz Blvd.  #300Santa Clara Ca 95054United States',1),('00:1D:B9','Wellspring Wireless','Wellspring Wireless107 Magella CourtNorth Wales Pa 19454United States',1),('00:1D:BA','Sony Corporation','Sony CorporationEngineering Standardization Office:mono-zukuri Technology Div.Gotenyama Tec. 5-1-12 Kitashinagawa Shinagawa-kuTokyo  141-0001Japan',1),('00:1D:BB','Dynamic System Electronics Corp.','Dynamic System Electronics Corp.5f,no,9,lane 130,sec 1,kuangg Fu Rd.san Chung City,Taipei Hsien 24158Taiwan, Republic Of China',1),('00:1D:BC','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:1D:BD','Versamed Inc.','Versamed Inc.2 Blue Hill PlazaPearl River Ny 10965United States',1),('00:1D:BE','Motorola Mobile Devices','Motorola Mobile Devices600 N. Us 45Libertyville Illinois 60048United States',1),('00:1D:BF','Radiient Technologies, Inc.','Radiient Technologies, Inc.2084-a Walsh AveSanta Clara Ca 95050United States',1),('00:1D:C0','Enphase Energy','Enphase Energy201 1st Street, Suite 111Petaluma Ca 94952United States',1),('00:1D:C1','Audinate','AudinateLevel 4, 223 Anzac PdeKensington Nsw 2052Australia',1),('00:1D:C2','Xortec Oy','Xortec OyHytmntie 6Lempl Pirkanmaa 33880Finland',1),('00:1D:C3','Rikor Tv, Ltd','Rikor Tv, LtdKostomarovsky Per.,3Moscow  105120Russian Federation',1),('00:1D:C4','Aioi Systems Co., Ltd.','Aioi Systems Co., Ltd.Kdx Omori, Bldg. 8f1-6-8 Omori Kita, Ota-kuTokyo  143-0016Japan',1),('00:1D:C5','Beijing Jiaxun Feihong Electricial Co., Ltd.','Beijing Jiaxun Feihong Electricial Co., Ltd.Electrical Building,no. 31 Jiaoda East Road,Beijing Haidian District, 100044China',1),('00:1D:C6','Snr Inc.','Snr Inc.Vbic T223ho, Icu, 103-6 Munji-dong, Youseong-guDaejeon  305-732Korea, Republic Of',1),('00:1D:C7','L-3 Communications Geneva Aerospace','L-3 Communications Geneva Aerospace4240 International ParkwaySuite 100Carrollton Texas 75007United States',1),('00:1D:C8','Scadametrcs, Llc.','Scadametrcs, Llc.595 Vista Hills CourtEureka Missouri 63025United States',1),('00:1D:C9','Gainspan Corp.','Gainspan Corp.P.o. Box 223580Carmel Ca 93922United States',1),('00:1D:CA','Pav Electronics Limited','Pav Electronics Limited7 Laverock RoadStirling Road Industrial EstateAirdrie Lanarkshire Ml6 7udUnited Kingdom',1),('00:1D:CB','Exns Development Oy','Exns Development OyKauppakatu 36Kajaani Kainuu 87100Finland',1),('00:1D:CC','Hetra Secure Solutions','Hetra Secure Solutions2350 Commerce Park Dr.Palm Bay Fl 32905United States',1),('00:1D:CD','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:CE','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:CF','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D0','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D1','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D2','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D3','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D4','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D5','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D6','Arris Group, Inc.','Arris Group, Inc.3871 Lakefield DriveSuwanee Ga 30024United States',1),('00:1D:D7','Algolith','Algolith400 IsabeySaint-laurent Qc H4t 1v3Canada',1),('00:1D:D8','Microsoft Corporation','Microsoft CorporationOne Microsoft WayRedmond Washington 98052-6399United States',1),('00:1D:D9','Hon Hai Precision Ind.co.,ltd.','Hon Hai Precision Ind.co.,ltd.66,chung Shan Rd.tu-chengTaipei Hsien 236Taiwan, Republic Of China',1),('00:1D:DA','Mikroelektronika Spol. S R. O.','Mikroelektronika Spol. S R. O.Drby 849Vysok Mto Cz 566 01Czech Republic',1),('00:1D:DB','C-bel Corporation','C-bel CorporationFutabacho 35-126f Okada BildgItabashi-ku Tokyo 173-0011Japan',1),('00:1D:DC','Hangzhou Dechanglong Tech&info Co.,ltd','Hangzhou Dechanglong Tech&info Co.,ltdRoom 1102,keji Mansion,East Software Park,90 Wensan Road.Hangzhou Zhejiang 310012China',1),('00:1D:DD','Dat H.k. Limited','Dat H.k. LimitedSuite 1405 14/f., City Plaza 4, Tai Koo Wan Rd,Tai Koo Shing Hong Kong Island 064828Hong Kong',1),('00:1D:DE','Zhejiang Broadcast&television Technology Co.,ltd.','Zhejiang Broadcast&television Technology Co.,ltd.Building No.16,xidoumen Industry Park,wenyi Road,Hangzhou Zhejiang 310012China',1),('00:1D:DF','Sunitec Enterprise Co., Ltd.','Sunitec Enterprise Co., Ltd.3f., No. 98-1, Mincyuan Rd.Sindian City Taipei County 231Taiwan, Republic Of China',1),('00:1D:E0','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1D:E1','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1D:E2','Radionor Communications','Radionor CommunicationsIngvald Ystgaards Veg 23Trondheim Trd 7046Norway',1),('00:1D:E3','Intuicom','Intuicom1880 S. Flatiron Ct.Suite RBoulder Co 80301United States',1),('00:1D:E4','Visioneered Image Systems','Visioneered Image Systems10561 Garden Grove BlvdGarden Grove California 92843United States',1),('00:1D:E5','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:E6','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1D:E7','Marine Sonic Technology, Ltd.','Marine Sonic Technology, Ltd.5508 George Washington Memorial HighwayP.o. Box 730White Marsh Virginia 23183United States',1),('00:1D:E8','Nikko Denki Tsushin Company(ndtc)','Nikko Denki Tsushin Company(ndtc)440 Kamoshida-town, Aoba-kuYokohama  227-0033Japan',1),('00:1D:E9','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1D:EA','Commtest Instruments Ltd','Commtest Instruments LtdLevel 2, 22 Moorhouse AveChristchurch Canterbury 8243New Zealand',1),('00:1D:EB','Dinec International','Dinec InternationalRue De La Gare, 30Braine Lalleud Brabant Wallon 1420Belgium',1),('00:1D:EC','Marusys','MarusysEunsung Bldg. 5f53-8 Chungdam-dong Kangnam-kuSeoul  135-763Korea, Republic Of',1),('00:1D:ED','Grid Net, Inc.','Grid Net, Inc.340 Brannan StreetSuite 501San Francisco Ca 94107United States',1),('00:1D:EE','Nextvision Sistemas Digitais De Televiso Ltda.','Nextvision Sistemas Digitais De Televiso Ltda.Alameda Rio Negro, 1030 - 19o. Andar Conj. 1904Barueri So Paulo 06454-000Brazil',1),('00:1D:EF','Trimm, Inc.','Trimm, Inc.407 Railroad StreetButner Nc 27509United States',1),('00:1D:F0','Vidient Systems, Inc.','Vidient Systems, Inc.4000 Burton DriveSanta Clara Ca 94054United States',1),('00:1D:F1','Intego Systems, Inc.','Intego Systems, Inc.5343 Bowden RoadJacksonville Fl 32216United States',1),('00:1D:F2','Netflix, Inc.','Netflix, Inc.100 Winchester CircleLos Gatos Ca 95032United States',1),('00:1D:F3','Sbs Science & Technology Co., Ltd','Sbs Science & Technology Co., LtdW2-b5/6 High-tech Industrial ParkShenzhen Guangdong 518057China',1),('00:1D:F4','Magellan Technology Pty Limited','Magellan Technology Pty Limited65 Johnston StreetAnnandale Nsw 2000Australia',1),('00:1D:F5','Sunshine Co,ltd','Sunshine Co,ltd1-3-5 KojimachiChiyoda-kuTokyo Kanto Region 102-0083Japan',1),('00:1D:F6','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1D:F7','R. Stahl Schaltgerte Gmbh','R. Stahl Schaltgerte GmbhAm Bahnhof 30Waldenburg Baden Wrttemberg 74638Germany',1),('00:1D:F8','Webpro Vision Technology Corporation','Webpro Vision Technology Corporation4f., No.573, Cingping Rd.Anping District  708Taiwan, Republic Of China',1),('00:1D:F9','Cybiotronics (far East) Limited','Cybiotronics (far East) LimitedUnit 1906, Eastern Centre,1065 Kings Road,Quarry BayHong Kong',1),('00:1D:FA','Fujian Landi Commercial Equipment Co.,ltd','Fujian Landi Commercial Equipment Co.,ltdBuilding 23,the 1st Section,software GardenNo.89 Software Road,Fuzhou Fujian 350003China',1),('00:1D:FB','Netcleus Systems Corporation','Netcleus Systems Corporation9f,yokohama Aioicho Bldg.6-104,aioi-cho,naka-kuYokohama-shi Kanagawa-ken 231-0012Japan',1),('00:1D:FC','Ksic','Ksic#6f, Korea Federation Of Teachers Associations, 114-1, Taebong-ro,Seoul Seocho-ku 137-715Korea, Republic Of',1),('00:1D:FD','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1D:FE','Palm, Inc','Palm, Inc950 West Maude AveSunnyvale Ca 94085United States',1),('00:1D:FF','Network Critical Solutions Ltd','Network Critical Solutions Ltd12b Southview ParkReading Berkshire Rg45afUnited Kingdom',1),('00:1E:00','Shantou Institute Of Ultrasonic Instruments','Shantou Institute Of Ultrasonic InstrumentsNo.77, Jinsha Road,Shantou Guangdong 515041China',1),('00:1E:01','Renesas Technology Sales Co., Ltd.','Renesas Technology Sales Co., Ltd.2-6-2OtemachiChiyoda-ku Tokyo 100-0004Japan',1),('00:1E:02','Sougou Keikaku Kougyou Co.,ltd.','Sougou Keikaku Kougyou Co.,ltd.Hk2 Bld. 2-21-10NishiogiminamiSuginamiku Tokyo 167-0053Japan',1),('00:1E:03','Licomm Co., Ltd.','Licomm Co., Ltd.908-1 Seo-ri, Idong-myeonYongin-si Gyeonggi-do 449-834Korea, Republic Of',1),('00:1E:04','Hanson Research Corporation','Hanson Research Corporation9810 Variel Ave.Chatsworth Ca 91311United States',1),('00:1E:05','Xseed Technologies & Computing','Xseed Technologies & ComputingTopaz House, Matam5 Nahum Hat St.Haifa  39100Israel',1),('00:1E:06','Wibrain','Wibrain306 Jei Plats B/d 459-11 Gasan-dong, Geumcheon-guSeoul  153-803Korea, Republic Of',1),('00:1E:07','Winy Technology Co., Ltd.','Winy Technology Co., Ltd.305-303, Bucheon Techno-park, #365Samjeong-dong, Ojeong-guBucheon Gyeonggi-do 421-741Korea, Republic Of',1),('00:1E:08','Centec Networks Inc','Centec Networks IncScience Plaza 10f , 328 Airport RdSuzhou Industrial ParkSuzhou Jiangsu 215021China',1),('00:1E:09','Zefatek Co.,ltd','Zefatek Co.,ltd326-4 Gasandong, GeumcheonguSeoul  153-802Korea, Republic Of',1),('00:1E:0A','Syba Tech Limited','Syba Tech LimitedRm1301, Vanta Industrial Centre,21-33 Tai Lin Pai Rd.Kwai ChungHong Kong',1),('00:1E:0B','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:1E:0C','Sherwood Information Partners, Inc.','Sherwood Information Partners, Inc.1120 W, 122nd Ave, Ste 300Westminster Co 80234United States',1),('00:1E:0D','Micran Ltd.','Micran Ltd.Vershinina St. 47Tomsk Tomsk Region 634034Russian Federation',1),('00:1E:0E','Maxi View Holdings Limited','Maxi View Holdings LimitedSuite 2302,23/f Great Eagle Centre, 23 Harbour Road, WanchaiHong KongChina',1),('00:1E:0F','Briot International','Briot International2 Rue Roger BonnetPont De Larche Eure 27340France',1),('00:1E:10','Shenzhen Huawei Communication Technologies Co.,ltd.','Shenzhen Huawei Communication Technologies Co.,ltd.Huawei Industrial Pk Bantian, Longgang Dist ShenzhenShenzhen Guangdong 518077China',1),('00:1E:11','Elelux International Ltd','Elelux International Ltd3f., No.103 Chow Tze StreetNei-hu District (114)Taipei  114Taiwan, Republic Of China',1),('00:1E:12','Ecolab','Ecolab655 Lone Oak DriveResearch Center Dock -- F4416Eagan Mn 55121United States',1),('00:1E:13','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:14','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:15','Beech Hill Electronics','Beech Hill ElectronicsBeechcroft, Beech Hill RoadBeech HillReading Berkshire Rg7 2auUnited Kingdom',1),('00:1E:16','Keytronix','KeytronixUngargasse 64-66/1/109Vienna  1030Austria',1),('00:1E:17','Stn Bv','Stn BvAmerikaweg 4Hulst Zeeland 4561 PbNetherlands',1),('00:1E:18','Radio Activity Srl','Radio Activity SrlVia Ponte Nuovo 8Milano Mi 20128Italy',1),('00:1E:19','Gtri','GtriM/s 0821Atlanta Ga 30332United States',1),('00:1E:1A','Best Source Taiwan Inc.','Best Source Taiwan Inc.2f, No.16, Lane 56, Jhongjheng W. Rd.,Jhubei City, Hsinchu County 302Taiwan, Republic Of China',1),('00:1E:1B','Digital Stream Technology, Inc.','Digital Stream Technology, Inc.4,5,6th Fl., Taechang B/d, 451-1Sungnae-dong, Gangdong-kuSeoul  134-030Korea, Republic Of',1),('00:1E:1C','Sws Australia Pty Limited','Sws Australia Pty Limited23 Scanlon DriveEpping Victoria 3076Australia',1),('00:1E:1D','East Coast Datacom, Inc.','East Coast Datacom, Inc.245 Gus Hipp Blvd., Ste 3Rockledge Fl 32955United States',1),('00:1E:1E','Honeywell Life Safety','Honeywell Life Safety12 Clintonville RoadNorthford Ct 0422United States',1),('00:1E:1F','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1E:20','Intertain Inc.','Intertain Inc.Suite 608 Lg Eclat-2, 245-4 Seohyun-dong, Bundang-guSungngm-shi Kyunggi-do 463-824Korea, Republic Of',1),('00:1E:21','Qisda Co.','Qisda Co.157 Shan-ying Road, GueishanTaoyuan  333Taiwan, Republic Of China',1),('00:1E:22','Arvoo Imaging Products Bv','Arvoo Imaging Products BvPo Box 439Woerden Ut 3440 AkNetherlands',1),('00:1E:23','Electronic Educational Devices, Inc','Electronic Educational Devices, Inc1903 S Grant StDenver Co 80210United States',1),('00:1E:24','Zhejiang Bell Technology Co.,ltd','Zhejiang Bell Technology Co.,ltd6 Xidoumen Rd. West Lake DistrictHangzhou Zhejiang 310012China',1),('00:1E:25','Intek Digital Inc','Intek Digital Inc1101, 11th Fl., Anyang K-center Building, 1591-9Gwanyang-dong, Dongan-guAnyang Gyeonggi-do 431-815Korea, Republic Of',1),('00:1E:26','Digifriends Co. Ltd','Digifriends Co. LtdJoyang B/d 6th Floor113 Samsung-dong, Kangnam-guSeoul  135-090Korea, Republic Of',1),('00:1E:27','Sbn Tech Co.,ltd.','Sbn Tech Co.,ltd.#706 Industrial Academic Center, Konkuk University, Hwayang-dong, Gwangjin-guSeoul  143-701Korea, Republic Of',1),('00:1E:28','Lumexis Corporation','Lumexis Corporation3184 Airway Ave Bldg DCosta Mesa Ca 92626United States',1),('00:1E:29','Hypertherm Inc','Hypertherm Inc15 Great Hollow RdPo Box 5010Hanover Nh 03755United States',1),('00:1E:2A','Netgear Inc.','Netgear Inc.4500 Great America ParkwaySanta Clara Ca 95054United States',1),('00:1E:2B','Radio Systems Design, Inc.','Radio Systems Design, Inc.601 Heron DriveLogan Twp New Jersey 08085United States',1),('00:1E:2C','Cyverse Corporation','Cyverse CorporationShoutou Roukubankan Bldg. 4f1-28-4, ShoutouShibuya-ku Tokyo 150-0046Japan',1),('00:1E:2D','Stim','StimZac Les Coustelliers6 Rue De LabrivadoCastries Herault 34160France',1),('00:1E:2E','Sirti S.p.a.','Sirti S.p.a.Via Stamira Dancona 9Milan  20127Italy',1),('00:1E:2F','Dimoto Pty Ltd','Dimoto Pty Ltd7 Meljaren PlaceBuderim Queensland 4556Australia',1),('00:1E:30','Shireen Inc','Shireen Inc8531 Ziggy LaneGaithersburg Md 20877United States',1),('00:1E:31','Infomark Co.,ltd.','Infomark Co.,ltd.5f.,geown Bldg.,1360-53Seoul Seocho-dong,seocho-gu 137-863Korea, Republic Of',1),('00:1E:32','Zensys','ZensysEmdrupvej 26Copenhagen O  Dk-2100Denmark',1),('00:1E:33','Inventec Corporation','Inventec CorporationInventec Building, 66 Hou-kang StreetShin-lin DistrictTaipei  111Taiwan, Republic Of China',1),('00:1E:34','Cryptometrics','Cryptometrics160 Michael Cowpland DrOttawa Ontario K2m 1p6Canada',1),('00:1E:35','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:1E:36','Ipte','IpteGeleenlaan 5Genk Limburg 3600Belgium',1),('00:1E:37','Usi','Usi141, Lane 351, Taiping Rd.Sec.1, Tsao TuenNan-tou 542Taiwan, Republic Of China',1),('00:1E:38','Bluecard Software Technology Co., Ltd.','Bluecard Software Technology Co., Ltd.D-801 Shangdi Science BuildingNo.8 Shangdi West RoadBeijing  100085China',1),('00:1E:39','Comsys Communication Ltd.','Comsys Communication Ltd.9 Hamenofim St.Herzelia  46725Israel',1),('00:1E:3A','Nokia Danmark A/s','Nokia Danmark A/sFrederiskajCopenhagen V  Dk-1790Denmark',1),('00:1E:3B','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1E:3C','Lyngbox Media Ab','Lyngbox Media AbDiskettgatan 11bLinkoping  Se-58335Sweden',1),('00:1E:3D','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, OkinouchiSoma City Fukushim-pref 976-8501Japan',1),('00:1E:3E','Kmw Inc.','Kmw Inc.65 Youngchun-ri, Dongtan-myunHwasung-si Kyungki-do 445-813Korea, Republic Of',1),('00:1E:3F','Private','',1),('00:1E:40','Shanghai Dareglobal Technologies  Co.,ltd.','Shanghai Dareglobal Technologies  Co.,ltd.22f, Lnfo Tech Building, No.1555 Kongjiang Road,Shanghai  200092China',1),('00:1E:41','Microwave Communication & Component, Inc.','Microwave Communication & Component, Inc.#204, Woolim Lion`s Valley 2, 680Gasan-dong, Geumchon-guSeoul  150-787Korea, Republic Of',1),('00:1E:42','Teltonika','TeltonikaZirmunu 27Vilnius  Lt - 09105Lithuania',1),('00:1E:43','Aisin Aw Co.,ltd.','Aisin Aw Co.,ltd.6-18 HarayamaOka-choOkazaki Aichi 444-8564Japan',1),('00:1E:44','Santec','SantecAn Der Strusbek 31Ahrensburg Schleswig Holstein 22926Germany',1),('00:1E:45','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:1E:46','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1E:47','Pt. Hariff Daya Tunggal Engineering','Pt. Hariff Daya Tunggal EngineeringJl. Soekarno Hatta No. 450Bandung Jawa Barat 40266Indonesia',1),('00:1E:48','Wi-links','Wi-links332 Ayiou StreetLimassol  3725Cyprus',1),('00:1E:49','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:4A','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:4B','City Theatrical','City Theatrical475 Barell AveCarlstadt New Jersey 07072United States',1),('00:1E:4C','Hon Hai Precision Ind.co., Ltd.','Hon Hai Precision Ind.co., Ltd.66,chung Shan Rd.tu-chengTaipei Hsien 236Taiwan, Republic Of China',1),('00:1E:4D','Welkin Sciences, Llc','Welkin Sciences, Llc102 S. Tejon St, Suite 200Colorado Springs Co 80903United States',1),('00:1E:4E','Dako Edv-ingenieur- Und Systemhaus Gmbh','Dako Edv-ingenieur- Und Systemhaus GmbhErnst-haeckel-platz 5/6Jena Thuringia 07745Germany',1),('00:1E:4F','Dell Inc.','Dell Inc.One Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:1E:50','Battistoni Research','Battistoni ResearchParco Donica 56Fisciano Salerno 84084Italy',1),('00:1E:51','Converter Industry Srl','Converter Industry SrlVia Euclide, 12Forli Fc 47100Italy',1),('00:1E:52','Apple Computer Inc','Apple Computer Inc1 Infinite LoopCupertino California 95014United States',1),('00:1E:53','Further Tech Co., Ltd','Further Tech Co., Ltd8f,no 421, Sungshan Rd.,taipei, Taiwn,r.o.c.Taipei  110Taiwan, Republic Of China',1),('00:1E:54','Toyo Electric Corporation','Toyo Electric Corporation1-39 HikisawaKagiya-choKasugai Aichi 480-0393Japan',1),('00:1E:55','Cowon Systems,inc.','Cowon Systems,inc.6th Fl. Cowon Tower,689-3,Yeoksam-dong,gangnam-gu,Seoul  135-080Korea, Republic Of',1),('00:1E:56','Bally Wulff Entertainment Gmbh','Bally Wulff Entertainment GmbhMaybachufer 48-51Berlin  12045Germany',1),('00:1E:57','Alcoma, Spol. S R.o.','Alcoma, Spol. S R.o.Klukovice 313, Praha - 5Praha  152 00Czech Republic',1),('00:1E:58','D-link Corporation','D-link CorporationNo.289, Sinhu 3rd Rd.,Neihu District, Taipei City 114Taiwan, Republic Of China',1),('00:1E:59','Silicon Turnkey Express, Llc','Silicon Turnkey Express, Llc749 Miner RoadHighland Heights Ohio 44143United States',1),('00:1E:5A','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1E:5B','Unitron Company, Inc.','Unitron Company, Inc.10925 Miller RoadDallas Tx 75238United States',1),('00:1E:5C','Rb Generalekonomik','Rb GeneralekonomikBulevar Despota Stefana 59aBeograd Serbia 11000Yugoslavia',1),('00:1E:5D','Holosys D.o.o.','Holosys D.o.o.Matije Gupca 7Oroslavje  49243Croatia',1),('00:1E:5E','Computime Ltd.','Computime Ltd.17/f Great Eagle Centre23 Harbour RoadWanchaiHong Kong',1),('00:1E:5F','Kwikbyte, Llc','Kwikbyte, Llc2430 W. 12th StreetTempe Az 85281United States',1),('00:1E:60','Digital Lighting Systems, Inc','Digital Lighting Systems, Inc12302 Sw 128th Ct,   #105Miami Fl 33186United States',1),('00:1E:61','Itec Gmbh','Itec GmbhLassnitzthal 300A-8200  GleisdorfAustria',1),('00:1E:62','Siemon','Siemon27 Siemon Company DriveWatertown Ct 06795United States',1),('00:1E:63','Vibro-meter Sa','Vibro-meter SaRoute De Moncor 4Fribourg  Ch-1701Switzerland',1),('00:1E:64','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1E:65','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1E:66','Resol Elektronische Regelungen Gmbh','Resol Elektronische Regelungen GmbhHeiskampstr. 10Hattingen Nrw 45527Germany',1),('00:1E:67','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1E:68','Quanta Computer','Quanta ComputerNo. 211, Wen Hwa 2rd., Kuei Shan HsiangTaipei Tao Yuan Shien 333Taiwan, Republic Of China',1),('00:1E:69','Thomson Inc.','Thomson Inc.101 West. 103rd StreetIndianapolis In 46290United States',1),('00:1E:6A','Beijing Bluexon Technology Co.,ltd','Beijing Bluexon Technology Co.,ltdJinqiuzhichun 7-301,zhichun Rd.,Haidian DistrictBeijing  100088China',1),('00:1E:6B','Scientific Atlanta, A Cisco Company','Scientific Atlanta, A Cisco Company5030 Sugarloaf ParkwayLawrenceville Ga 30044United States',1),('00:1E:6C','Spliced Networks Llc','Spliced Networks Llc4820 Fisher RoadAthens Oh 45701United States',1),('00:1E:6D','It R&d Center','It R&d Center461-25, Jeonmin-dong,yuseong-guDaejeon  305-811Korea, Republic Of',1),('00:1E:6E','Shenzhen First Mile Communications Ltd','Shenzhen First Mile Communications Ltd5th Floor, Block R3-aHigh-tech Industrial ParkShenzhen Guangdong 518057China',1),('00:1E:6F','Magna-power Electronics, Inc.','Magna-power Electronics, Inc.39 Royal RoadFlemington Nj 08822United States',1),('00:1E:70','Cobham Defence Communications Ltd','Cobham Defence Communications LtdHaslingden RoadBlackburn Lancashire Bb12eeUnited Kingdom',1),('00:1E:71','Igeacare Systems Inc.','Igeacare Systems Inc.91 Granton DriveRichmond Hill Ontario L4b 2n5Canada',1),('00:1E:72','Pcs','PcsRue Saint ExuperyBp70322Lescar Pyrenees Atlantiques 64230France',1),('00:1E:73','Zte Corporation','Zte Corporation12/f Zte Plaza,keji Road South,hi-tech Industrial Park,nanshan District,Shenzhen Guangdong 518057China',1),('00:1E:74','Sagem Communication','Sagem Communication14 Rue Paul DautierVelizy  78457France',1),('00:1E:75','Lg Electronics','Lg Electronics60-39,kasan-dong,kumchon-kuSeoul  153-801Korea, Republic Of',1),('00:1E:76','Thermo Fisher Scientific','Thermo Fisher Scientific2215 Grand Avenue ParkwayAustin Texas 78728United States',1),('00:1E:77','Air2app','Air2app50 Old Forge RdHanover Ma 02339United States',1),('00:1E:78','Owitek Technology Ltd.,','Owitek Technology Ltd.,No.2, Lane 78, Cingshan 6th St.,Yangmei Township,Taoyuan County  32657Taiwan, Republic Of China',1),('00:1E:79','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:7A','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:7B','R.i.co. S.r.l.','R.i.co. S.r.l.Via Adriatica, 17Castelfidardo An 60022Italy',1),('00:1E:7C','Taiwick Limited','Taiwick Limited5/f., Block E, Hing Yip Factory Bldg.,31 Hing Yip Street., Kwun Tong, Kln., Hk.China 852Hong Kong',1),('00:1E:7D','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1E:7E','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1E:7F','Cbm Of America','Cbm Of America1455 West Newport Center DriveDeerfield Beach Florida 33442United States',1),('00:1E:80','Last Mile Ltd.','Last Mile Ltd.12/f Vip Commercial Centre120 Canton RoadTsimshatsuiHong Kong',1),('00:1E:81','Cnb Technology Inc.','Cnb Technology Inc.#701 Star Valley, 60-11 Gasan-dong,Geumcheon-guSeoul  153777Korea, Republic Of',1),('00:1E:82','Pliant Technology, Inc.','Pliant Technology, Inc.630 Alder Drive,Suite 202Milpitas Ca 95035United States',1),('00:1E:83','Lan/man Standards Association (lmsc)','Lan/man Standards Association (lmsc)C/o Ieee Standards Association445 Hoes Lane,Piscataway Nj 08855United States',1),('00:1E:84','Pika Technologies Inc.','Pika Technologies Inc.535 Legget DriveSuite 400Ottawa Ontario K2k 3b8Canada',1),('00:1E:85','Lagotek Corporation','Lagotek Corporation11661 Se 1st St. #208Bellevue Wa 98005United States',1),('00:1E:86','Mel Co.,ltd.','Mel Co.,ltd.Tsukagoshi 5-5-1,warabi-shi,saitama,japnaWarabi Saitama 335-0002Japan',1),('00:1E:87','Realease Limited','Realease Limited15/f, Morrison Commercial Building31 Morrison Hill RoadWan ChaiHong Kong',1),('00:1E:88','Andor System Support Co., Ltd.','Andor System Support Co., Ltd.Minami-shinagawa 2-15-8Sinagawa Tokyo 140-0004Japan',1),('00:1E:89','Crfs Limited','Crfs LimitedBuilding 7200Cambridge Research ParkWaterbeach Cambridgeshire Cb25 9tlUnited Kingdom',1),('00:1E:8A','Ecopy, Inc','Ecopy, Inc1 Oracle DrNashua Nh 03062United States',1),('00:1E:8B','Infra Access Korea Co., Ltd.','Infra Access Korea Co., Ltd.9f Daeyang B/d,735-11 Bongchun 1dong,Kwanak-gu, Seoul 151-830Korea, Republic Of',1),('00:1E:8C','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitouTaipei  112Taiwan, Republic Of China',1),('00:1E:8D','Motorola Mobile Devices','Motorola Mobile Devices600 N. Us 45Libertyville Illinois 60048United States',1),('00:1E:8E','Hunkeler Ag','Hunkeler AgBahnhofstrasse 31Wikon Lucerne 4806Switzerland',1),('00:1E:8F','Canon Inc.','Canon Inc.3-30-2ShimomarukoOhta-ku Tokyo 146-8501Japan',1),('00:1E:90','Elitegroup Computer Systems Co','Elitegroup Computer Systems CoNo.239, Sec. 2, Ti Ding BlvdTaipei  11493Taiwan, Republic Of China',1),('00:1E:91','Kimin Electronic Co., Ltd.','Kimin Electronic Co., Ltd.293-4, Dongdan-dongGumi-city Gyeongbuk 730-906Korea, Republic Of',1),('00:1E:92','Jeulin S.a.','Jeulin S.a.Zi N1Rue Jacques MonodEvreux  F27019France',1),('00:1E:93','Ciritech Systems Inc','Ciritech Systems Inc920 Hillview Ct#170Milpitas Ca 95035United States',1),('00:1E:94','Supercom Technology Corporation','Supercom Technology Corporation8f, No 100-1, Ming-chuan Rd.Shing Tien Taipei 231Taiwan, Republic Of China',1),('00:1E:95','Sigmalink','SigmalinkDoosan Venturedigm 1028,126-1 Pyungchon-dong, Dongan-kuAnyang-city Kyunggi-do 431-070Korea, Republic Of',1),('00:1E:96','Sepura Plc','Sepura PlcRadio HouseSt Andrews RoadCambridge Cambridgeshire Cb4 1grUnited Kingdom',1),('00:1E:97','Medium Link System Technology Co., Ltd,','Medium Link System Technology Co., Ltd,11f.-2, No.7, Alley 92, Lane 77, Sec. 4, Sinhai Rd.,Wunshan District, Taipei 11693Taiwan, Republic Of China',1),('00:1E:98','Greenline Communications','Greenline CommunicationsAlrabiah, Alrabeea StreetBuilding 8, P.o. Box 921Amman Central Region 11953Jordan',1),('00:1E:99','Vantanol Industrial Corporation','Vantanol Industrial Corporation9f, No 31 . Shin-tai RoadJubei City Shinchu 302Taiwan, Republic Of China',1),('00:1E:9A','Hamilton Bonaduz Ag','Hamilton Bonaduz AgVia Crusch 8Bonaduz Graubuenden 7402Switzerland',1),('00:1E:9B','San-eisha, Ltd.','San-eisha, Ltd.2-1 Ebara 5-chomeShinagawa-ku Tokyo 142-8611Japan',1),('00:1E:9C','Fidustron Inc','Fidustron IncNo.770-6, Jhongiheng Rd.Jhonghe City Taipei County 235Taiwan, Republic Of China',1),('00:1E:9D','Recall Technologies, Inc.','Recall Technologies, Inc.130 Enterprise Ave.Suite FPalm Bay Fl 32909United States',1),('00:1E:9E','Ddm Hopt + Schuler Gmbh + Co. Kg','Ddm Hopt + Schuler Gmbh + Co. KgKoenigsberger Strasse 12Rottweil Baden-wuerttemberg 78626Germany',1),('00:1E:9F','Visioneering Systems, Inc.','Visioneering Systems, Inc.5931 Sea Lion PlaceSuite 109Carlsbad California 92010United States',1),('00:1E:A0','Xln-t','Xln-tHoogstraat 52Putte Antwerp B2580Belgium',1),('00:1E:A1','Brunata A/s','Brunata A/sVesterlundvej 14Herlev  2730Denmark',1),('00:1E:A2','Symx Systems, Inc.','Symx Systems, Inc.6320 Nw 84th AvenueMiami Florida 33166United States',1),('00:1E:A3','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1E:A4','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1E:A5','Robotous, Inc.','Robotous, Inc.Nex Center-201(lab.), Sk N TechnoparkSangdaewon-dong, Jungwon-guSeongnam-si Gyeonggi-do 462-120Korea, Republic Of',1),('00:1E:A6','Best It World (india) Pvt. Ltd.','Best It World (india) Pvt. Ltd.87/70/93 Mistry Industrial Complex,Midc Cross Road a, Andheri (east)Mumbai Maharashtra 400093India',1),('00:1E:A7','Actiontec Electronics, Inc','Actiontec Electronics, Inc760 North Mary AveSunnyvale Ca 94086United States',1),('00:1E:A8','Datang Mobile Communications Equipment Co.,ltd','Datang Mobile Communications Equipment Co.,ltdNo.29,xueyuan Rd.,haidian District,beijing,100083 P.r.chinaBeijing  100083China',1),('00:1E:A9','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:1E:AA','E-senza Technologies Gmbh','E-senza Technologies GmbhBlarerstrasse 56Konstanz Bw 78462Germany',1),('00:1E:AB','Telewell Oy','Telewell OyAlahotie 14 BJarvenpaa Uusimaa 04430Finland',1),('00:1E:AC','Armadeus Systems','Armadeus SystemsTechnopole -  40, Rue Marc SeguinBp 2118Mulhouse Cedex Haut-rhin 68060France',1),('00:1E:AD','Wingtech Group Limited','Wingtech Group Limited6th Floor, Unit G, No.668, East Beijing Road,Shanghai  200001China',1),('00:1E:AE','Continental Automotive Systems','Continental Automotive Systems21440 West Lake Cook RoadDeer Park Il 60010United States',1),('00:1E:AF','Ophir Optronics Ltd','Ophir Optronics LtdPob 45021Jerusalem  91450Israel',1),('00:1E:B0','Imesd Electronica S.l.','Imesd Electronica S.l.Entena 81Barcelona  08015Spain',1),('00:1E:B1','Cryptsoft Pty Ltd','Cryptsoft Pty LtdP.o. Box 6389Fairfield Gardens Queensland 4103Australia',1),('00:1E:B2','Lg Innotek','Lg InnotekHanyang Univ. 1271, Sa-dong, Sangrok-guAnsan-si Gyeonggi-do 426-791Korea, Republic Of',1),('00:1E:B3','Primex Wireless','Primex Wireless965 Wells StreetLake Geneva Wi 53147United States',1),('00:1E:B4','Unifat Technology Ltd.','Unifat Technology Ltd.7/floor Sui Hong Ind. Bldg.,547-549 Castle Peak RoadKwai Chung, N.t.Hong Kong',1),('00:1E:B5','Ever Sparkle Technologies Ltd','Ever Sparkle Technologies LtdUnit 403, Nan Fung Commercial Centre19, Lam Lok St.Kowloon Bay KowloonHong Kong',1),('00:1E:B6','Tag Heuer Sa','Tag Heuer SaRue Louis-joseph Chevrolet 6aLa Chaux-de-fonds Ne 2300Switzerland',1),('00:1E:B7','Tbtech, Co., Ltd.','Tbtech, Co., Ltd.1109, Hyundai Krim, 1330-18, Seocho-dong,Seocho-gu,Seoul  137-070Korea, Republic Of',1),('00:1E:B8','Fortis, Inc.','Fortis, Inc.#502 Techno Plaza, 149-10 Yatap-dong,Bundang-gu,Seongnam-si, Gyeonggi-do, 463-816Korea, Republic Of',1),('00:1E:B9','Sing Fai Technology Limited','Sing Fai Technology LimitedNo.700, Kaohsiung University Rd., Nan-tzu Dist.Nuk Advanced Business Incubation CenterKaohsiung  811Taiwan, Republic Of China',1),('00:1E:BA','High Density Devices As','High Density Devices AsVestre Strandgate 26Kristiansand  4611Norway',1),('00:1E:BB','Bluelight Technology Inc.','Bluelight Technology Inc.6472 Camden Ave., Suite 102bSan Jose Ca 95120United States',1),('00:1E:BC','Wintech Automation Co.,ltd.','Wintech Automation Co.,ltd.#1115, Taekwang Blvd.Youngrong-dong, Youngtong-guSuwon-si Kyunggi 443-816Korea, Republic Of',1),('00:1E:BD','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:BE','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:BF','Haas Automation Inc.','Haas Automation Inc.2800 Sturgis RdOxnard Ca 93030United States',1),('00:1E:C0','Zerog Wireless Inc.','Zerog Wireless Inc.990 Almanor Ave.Suite 250Sunnyvale California 94085United States',1),('00:1E:C1','3com Europe Ltd','3com Europe LtdPeoplebuilding 2Maylands AvenueHemel Hempstead Herts. Hp2 4nwUnited Kingdom',1),('00:1E:C2','Apple, Inc','Apple, Inc1 Inifinte LoopCupertino Ca 95014United States',1),('00:1E:C3','Kozio, Inc.','Kozio, Inc.2400 Trade Centre AveLongmont Co 80503United States',1),('00:1E:C4','Celio Corp','Celio Corp265 E 100 S  # 280Salt Lake City Ut 84111United States',1),('00:1E:C5','Middle Atlantic Products Inc','Middle Atlantic Products Inc300 Fairfield RoadFairfield Nj 07004United States',1),('00:1E:C6','Obvius Holdings Llc','Obvius Holdings Llc20811 Nw Cornell RoadSuite 700Hillsboro Or 97124United States',1),('00:1E:C7','2wire','2wire1704 Automation PrkwySan Jose Ca 95131United States',1),('00:1E:C8','Rapid Mobile (pty) Ltd','Rapid Mobile (pty) LtdBuilding C,d,e Apex Corporate ParkQuintin Brand Street, Persequor TechnoparkPretoria Gauteng 0020South Africa',1),('00:1E:C9','Dell Inc','Dell IncOne Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:1E:CA','Nortel','Nortel8200 Dixie RoadSuite 100Brampton Ontario L6t 5p6Canada',1),('00:1E:CB','rpc energoautomatika Ltd','rpc energoautomatika LtdKrasnokazarmennaya St., 13/1Moscow  111250Russian Federation',1),('00:1E:CC','Cdvi','Cdvi31 Avenue Du Gnral LeclercPantin Ile De France 93500France',1),('00:1E:CD','Kyland','KylandNo95 Building,Southeast Corner Of Xisanqi Bridge,Haidian Beijing 100096China',1),('00:1E:CE','Bisa Technologies (hong Kong) Limited','Bisa Technologies (hong Kong) Limited1102, Trans Asia Centre,18 Kin Hong Street,Kwai ChungHong Kong',1),('00:1E:CF','Philips Electronics Uk Ltd','Philips Electronics Uk LtdPhilips CentreGuildford Business ParkGuildford Surrey Gu2 8xhUnited Kingdom',1),('00:1E:D0','Connexium','Connexium39 LalbaredeAuzielle  31650France',1),('00:1E:D1','Keyprocessor B.v.','Keyprocessor B.v.Paasheuvelweg 20Amsterdam Nh 1105 BjNetherlands',1),('00:1E:D2','Ray Shine Video Technology Inc','Ray Shine Video Technology Inc6f,no.98,sec.1,xintai 5th Rd.Xizhi City Taipei County 221Taiwan, Republic Of China',1),('00:1E:D3','Dot Technology Intl Co., Ltd.','Dot Technology Intl Co., Ltd.Unit 1001, Fourseas Building 208-212, Nathan RoadKowloonHong Kong',1),('00:1E:D4','Doble Engineering','Doble Engineering85 Walnut StreetWatertown Massachusetts 02472United States',1),('00:1E:D5','Tekon-automatics','Tekon-automaticsZelenograd, 512-29Moscow  124482Russian Federation',1),('00:1E:D6','Alentec & Orion Ab','Alentec & Orion AbBox 108132 23 Saltsj-booSweden',1),('00:1E:D7','H-stream Wireless, Inc.','H-stream Wireless, Inc.2595 East Bayshore RoadSuite 100Palo Alto Ca 94303United States',1),('00:1E:D8','Digital United Inc.','Digital United Inc.9f, No.220, Gangcian Rd.Taipei  11444Taiwan, Republic Of China',1),('00:1E:D9','Mitsubishi Precision Co.,ltd.','Mitsubishi Precision Co.,ltd.345 KamimachiyaKamakura-city Kanagawa-prefecture 247-8505Japan',1),('00:1E:DA','Wesemann Elektrotechniek B.v.','Wesemann Elektrotechniek B.v.Droogbloem 31Rotterdam Zuid-holland 3068 AwNetherlands',1),('00:1E:DB','Giken Trastem Co., Ltd.','Giken Trastem Co., Ltd.4-1 Takeda Dankawaracho FushimikuKyoto  612-8414Japan',1),('00:1E:DC','Sony Ericsson Mobile Communications Ab','Sony Ericsson Mobile Communications AbNya VattentornetLund Se 221 88Sweden',1),('00:1E:DD','Wasko S.a.','Wasko S.a.Berbeckiego 6Gliwice Silesia 44-100Poland',1),('00:1E:DE','Byd Company Limited','Byd Company LimitedNo.1,baoping Road,baolong Industrial Town,longgangShen Zhen Guangdong 518116China',1),('00:1E:DF','Master Industrialization Center Kista','Master Industrialization Center KistaTorshamnsgatan 36KistaStockholm  Se-164 80Sweden',1),('00:1E:E0','Urmet Domus Spa','Urmet Domus SpaVia Bologna 188/cTorino To I-10154Italy',1),('00:1E:E1','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1E:E2','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1E:E3','T&w Electronics (shenzhen) Co.,ltd','T&w Electronics (shenzhen) Co.,ltd2f Baiying Building, No.19, Nanhaird., Nanshan DistShenzhen Guangdong 518052China',1),('00:1E:E4','Acs Solutions France','Acs Solutions FranceRue Claude ChappeGuilherand Granges Ardeche 07503France',1),('00:1E:E5','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92612United States',1),('00:1E:E6','Shenzhen Advanced Video Info-tech Co., Ltd.','Shenzhen Advanced Video Info-tech Co., Ltd.Tianxiang 11a,  Tianan Cyber Park , FutianShenzhen Guangdong 518048China',1),('00:1E:E7','Epic Systems Inc','Epic Systems Inc390 S. Abbott AveMilpitas Ca 95035United States',1),('00:1E:E8','Mytek','Mytek151 Lafayette Str 3 FlNew York Ny 10013United States',1),('00:1E:E9','Stoneridge Electronics Ab','Stoneridge Electronics AbGrdsfogdevgen 18aBromma Stockholm 168 66Sweden',1),('00:1E:EA','Sensor Switch, Inc.','Sensor Switch, Inc.900 Northrop RoadWallingford Ct 06492United States',1),('00:1E:EB','Talk-a-phone Co.','Talk-a-phone Co.5013 N. Kedzie Ave.Chicago Il 60625United States',1),('00:1E:EC','Compal Information (kunshan) Co., Ltd.','Compal Information (kunshan) Co., Ltd.No. 25, The 3rd StreetKunshan Export Processing ZoneKunshan City Suzhou Province 215300China',1),('00:1E:ED','Adventiq Ltd.','Adventiq Ltd.Technology HouseTrafalgar WayBar Hill Cambs. Cb3 8sqUnited Kingdom',1),('00:1E:EE','Etl Systems Ltd','Etl Systems LtdColdwell Radio StationMadleyHereford Herefordshire Hr2 9neUnited Kingdom',1),('00:1E:EF','Cantronic International Limited','Cantronic International LimitedUnit 515-516, Building 15, East Wing, No 8 Science Park West Avenue, Hong Kong Science Park Phase IiShatin New Territories 852Hong Kong',1),('00:1E:F0','Gigafin Networks','Gigafin Networks19050 PruneridgeSuite 200Cupertino Ca 95014United States',1),('00:1E:F1','Servimat','ServimatZaet Les HaiesRue Benoit FrachonSt Maximin Oise 60740France',1),('00:1E:F2','Micro Motion Inc','Micro Motion Inc7070 Winchester CircleBoulder Co 80301United States',1),('00:1E:F3','From2','From22f, Mester Inc1687-3, Sinil-dongDaejeon  306-230Korea, Republic Of',1),('00:1E:F4','L-3 Communications Display Systems','L-3 Communications Display Systems1355 Bluegrass Lakes ParkwayAlpharetta Ga 30004-8458United States',1),('00:1E:F5','Hitek Automated Inc.','Hitek Automated Inc.Room C3-901, No.383, Huamen ShijiaWensanlu Road,Hangzhou  310012China',1),('00:1E:F6','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:F7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1E:F8','Emfinity Inc.','Emfinity Inc.111 Elm StreetSuite 201Sudbury Ontario P3c1t3Canada',1),('00:1E:F9','Pascom Kommunikations Systeme Gmbh.','Pascom Kommunikations Systeme Gmbh.Technologiestr. 4Arbing Upper Austria 4332Austria',1),('00:1E:FA','Protei Ltd.','Protei Ltd.60a B.sampsonievsky,  Business CenterSt.petersburg Ru 194044Russian Federation',1),('00:1E:FB','Trio Motion Technology Ltd','Trio Motion Technology LtdShannon WayTewkesbury Gloucestershire Gl20 8ndUnited Kingdom',1),('00:1E:FC','Jsc massa-k','Jsc massa-k15, A, Pirogovskaya Nab.Saint-petersburg Leningradskiy Reg. 194044Russian Federation',1),('00:1E:FD','Microbit 2.0 Ab','Microbit 2.0 AbNystaden 1Kalix  95261Sweden',1),('00:1E:FE','Level S.r.o.','Level S.r.o.Plhovsk 1997Nchod  547 01Czech Republic',1),('00:1E:FF','Mueller-elektronik Gmbh & Co. Kg','Mueller-elektronik Gmbh & Co. KgFranz-kleine-str. 18Salzkotten Nrw 33154Germany',1),('00:1F:00','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790vDenmark',1),('00:1F:01','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790vDenmark',1),('00:1F:02','Pixelmetrix Corporation Pte Ltd','Pixelmetrix Corporation Pte Ltd31 Kaki Bukit Road 3#07-03, Techlink417818Singapore',1),('00:1F:03','Num Ag','Num AgBattenhusstrasse 16Teufen Ar 9053Switzerland',1),('00:1F:04','Granch Ltd.','Granch Ltd.40 Koroleva Str.53 Pisareva Str.Novosibirsk Nso 630015Russian Federation',1),('00:1F:05','Itas Technology Corp.','Itas Technology Corp.No. 75, Shuiyuan St.Hsinchu City  30069Taiwan, Republic Of China',1),('00:1F:06','Integrated Dispatch Solutions','Integrated Dispatch Solutions645 Mountain AveWyckoff Nj 07481United States',1),('00:1F:07','Azteq Mobile','Azteq MobileSuite 210, 525 University AvePalo Alto Ca 94301United States',1),('00:1F:08','Risco Ltd','Risco Ltd32 Hacharoshet StKiriat Malachi  83101Israel',1),('00:1F:09','Jastec Co., Ltd.','Jastec Co., Ltd.Jastec B/d, 92-7Kum-gok Dong, Boon-dang GuSeong-nam Si  Kyung-gi Do 463-804Korea, Republic Of',1),('00:1F:0A','Nortel','Nortel1830 Matheson BoulevardSuite 1Mississauga Ontario L4w 0b3Canada',1),('00:1F:0B','Federal State Unitary Enterprise Industrial Unionelectropribor','Federal State Unitary Enterprise Industrial Unionelectropribor',1),('00:1F:0C','Intelligent Digital Services Gmbh','Intelligent Digital Services GmbhGrevesmuehlener Strasse 8Mallentin Mecklenburg-vorpommern 23639Germany',1),('00:1F:0D','L3 Communications - Telemetry West','L3 Communications - Telemetry West9020 Balboa AveSan Diego Ca 92123United States',1),('00:1F:0E','Japan Kyastem Co., Ltd','Japan Kyastem Co., Ltd1-4-4Nishiki-choTachikawa Tokyo 190-0022Japan',1),('00:1F:0F','Select Engineered Systems','Select Engineered Systems7991 W. 26 AveHialeah Florida 33016United States',1),('00:1F:10','Toledo Do Brasil Industria De Balancas  Ltda','Toledo Do Brasil Industria De Balancas  LtdaRua Manoel Cremonesi, 1Estrada Samuel Aizemberg, 345Sao Bernardo Do Campo Sp 09851-900Brazil',1),('00:1F:11','Openmoko, Inc.','Openmoko, Inc.7f, No 300, Yang Guang StreetNeihuTaipei  11491Taiwan, Republic Of China',1),('00:1F:12','Juniper Networks','Juniper Networks1194 N Mathilda AvenueSunnyvale Ca 94089United States',1),('00:1F:13','S.& A.s. Ltd.','S.& A.s. Ltd.Boutros Bldg. 1st BsmtGhabi StreetBeirut  2067 7808Lebanon',1),('00:1F:14','Nexg','Nexg5f Seoul Academy Bldg, Daechi-dong, Gangnam-gu,Seoul  135-280Korea, Republic Of',1),('00:1F:15','Bioscrypt Inc','Bioscrypt Inc505 Cochrane DriveMarkham Ontario L3r 8e3Canada',1),('00:1F:16','Wistron Corporation','Wistron Corporation21f, 88, Sec.1,hsin Tai Wu Rd., Hsichih,Taipei Hsien 221Taiwan, Republic Of China',1),('00:1F:17','Idx Company, Ltd.','Idx Company, Ltd.6-28-11 Shukugawara, Tana-kuKawasaki-shi Kanagawa-ken 2140021Japan',1),('00:1F:18','Hakusan.mfg.co,.ltd','Hakusan.mfg.co,.ltdTomin-kougyou-ikebukuro Bld.5f2-26-5  Minami-ikebukuroTosima Ward Tokyo-met. 171-0022Japan',1),('00:1F:19','Ben-ri Electronica S.a.','Ben-ri Electronica S.a.Pol. Ind. Ventorro Del CanoC/. Lozoya 8Alcorcon Madrid 28925Spain',1),('00:1F:1A','Prominvest','Prominvest7, Bobruiskaya UlicaSaint-petersburg North-west Federal District 195009Russian Federation',1),('00:1F:1B','Royaltek Company Ltd.','Royaltek Company Ltd.Suite 9f-1, No. 1071, Chung Cheng Rd.Taoyuan Shien Taoyuan 330Taiwan, Republic Of China',1),('00:1F:1C','Kobishi Electric Co.,ltd.','Kobishi Electric Co.,ltd.1805-1KamiyaKounosu-shi Saitama-ken 365-0027Japan',1),('00:1F:1D','Atlas Material Testing Technology Llc','Atlas Material Testing Technology Llc4114 N. Ravenswood Ave.Chicago Il 60613United States',1),('00:1F:1E','Astec Technology Co., Ltd','Astec Technology Co., Ltd12f, No.2, Jian Ba Rd.Chung Ho Taipei Hsien 235Taiwan, Republic Of China',1),('00:1F:1F','Edimax Technology Co. Ltd.','Edimax Technology Co. Ltd.No. 3, Wu-chuan 3rd Road, Wu-ku Industrial Park,Taipei Hsien 248Taiwan, Republic Of China',1),('00:1F:20','Logitech Europe Sa','Logitech Europe SaMoulin Du Choc DRomanel Sur Morges Ch 1122Switzerland',1),('00:1F:21','Inner Mongolia Yin An Science & Technology Development Co.,l','Inner Mongolia Yin An Science & Technology Development Co.,lYinan Building Yiwei Road.ruyiDevelopment Zone,hohhotBeijing  010010China',1),('00:1F:22','Fiberxon, Inc.','Fiberxon, Inc.5201 Great America ParkwaySuite 340Santa Clara Ca 95054United States',1),('00:1F:23','Interacoustics','InteracousticsDrejervaenget 8Assens Dk 5610Denmark',1),('00:1F:24','Digitview Technology Co., Ltd.','Digitview Technology Co., Ltd.No. 14-22, Tian-fu ,Sansia Township,Taipei County  237Taiwan, Republic Of China',1),('00:1F:25','Mbs Gmbh','Mbs GmbhRmerstrae 15Krefeld Nordrhein-westfalen 47809Germany',1),('00:1F:26','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:27','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:28','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville Ca 95747United States',1),('00:1F:29','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040802Houston Tx 77070United States',1),('00:1F:2A','Accm','AccmObour Industrial City, Industrial Zone A, Lot14, Block 12006.CairoEgypt',1),('00:1F:2B','Orange Logic','Orange Logic#706 Acetechnotower 10-cha,470-5Gasan-dong Geumcheon-guSeoul  153-789Korea, Republic Of',1),('00:1F:2C','Starbridge Networks','Starbridge Networks3265 Meridian ParkwaySuite 134Weston Fl 33331United States',1),('00:1F:2D','Electro-optical Imaging, Inc.','Electro-optical Imaging, Inc.4300 Fortune Place, Suite CWest Melbourne Fl 32904United States',1),('00:1F:2E','Triangle Research Intl Pte Ltd','Triangle Research Intl Pte Ltd10 Ubi Crescent #05-83Ubi Techpark Sg 408664Singapore',1),('00:1F:2F','Berker Gmbh & Co. Kg','Berker Gmbh & Co. KgKlagebach 38Schalksmuehle Nrw 58579Germany',1),('00:1F:30','Travelping','Travelping',1),('00:1F:31','Radiocomp','RadiocompKrakesvej 17Hilleroed Copenhagen 3400Denmark',1),('00:1F:32','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:1F:33','Netgear Inc.','Netgear Inc.4500 Great America PkwySanta Clara Ca 95054United States',1),('00:1F:34','Lung Hwa Electronics Co., Ltd.','Lung Hwa Electronics Co., Ltd.3f, 248, Pei Sheng Rd. Sec. 3,Sheng KengTaipei Hsien 222Taiwan, Republic Of China',1),('00:1F:35','Air802 Llc','Air802 Llc1169 Banyon CourtNaperville Il 60540United States',1),('00:1F:36','Bellwin Information Co. Ltd.,','Bellwin Information Co. Ltd.,17f-1,no.128,chung De Rd.Taichung  404Taiwan, Republic Of China',1),('00:1F:37','Genesis I&c','Genesis I&c#515 Lisantekeunotaun1141-1 Baekseok-dong, Lisandong-guGoyang Gyeonggi 410-722Korea, Republic Of',1),('00:1F:38','Positron','PositronEstrada Telebras-unicamp, Km0,97 - Cj.01Bairro: Cidade UniversitariaCampinas Sao Paulo 13084-971Brazil',1),('00:1F:39','Construcciones Y Auxiliar De Ferrocarriles, S.a.','Construcciones Y Auxiliar De Ferrocarriles, S.a.C/ J.m. Iturrioz, 26Beasain Guipzcoa E-20200Spain',1),('00:1F:3A','Hon Hai Precision Ind.co., Ltd.','Hon Hai Precision Ind.co., Ltd.66, Chung Shan Rd.tu-chengTaipei Hsien 236Taiwan, Republic Of China',1),('00:1F:3B','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1F:3C','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:1F:3D','Qbit Gmbh','Qbit GmbhZeiloch 3Bruchsal Germany 76646Germany',1),('00:1F:3E','Rp-technik E.k.','Rp-technik E.k.Hermann-staudinger-str. 10-16Rodgau Hessen 63110Germany',1),('00:1F:3F','Avm Gmbh','Avm GmbhAlt-moabit 95Berlin  10559Germany',1),('00:1F:40','Speakercraft Inc.','Speakercraft Inc.940 Columbia Ave.,Riverside Ca 92507United States',1),('00:1F:41','Ruckus Wireless','Ruckus Wireless880 West Maude Ave.Sunnyvale Ca 94085United States',1),('00:1F:42','Etherstack Pty Ltd','Etherstack Pty Ltd201 National Innovation CentreAustralian Technology Park Nsw 2234Australia',1),('00:1F:43','Entes Elektronik','Entes ElektronikY. Dudullu Org. San. Bol. And Sanayi Sit. No.6UmraniyeIstanbul Dudullu 34775Turkey',1),('00:1F:44','Ge Transportation Systems','Ge Transportation Systems2901 East Lake RoadErie Pa 16501United States',1),('00:1F:45','Enterasys','Enterasys50 Minuteman RoadAndover Ma 01810United States',1),('00:1F:46','Nortel','Nortel2221 Lakeside BlvdRichardson Texas 75082United States',1),('00:1F:47','Mcs Logic Inc.','Mcs Logic Inc.6f. Samho Center B Bldg., 275-6Yangjae-dong, Secho-kuSeoul  137-941Korea, Republic Of',1),('00:1F:48','Mojix Inc.','Mojix Inc.11075 Santa Monica Blvd.Suite 350Los Angeles Ca 90025United States',1),('00:1F:49','Eurosat Distribution Ltd','Eurosat Distribution Ltd5 Oxgate CentreOxgate LaneLondon  Nw2 7jaUnited Kingdom',1),('00:1F:4A','Albentia Systems S.a.','Albentia Systems S.a.Albala 13Madrid  28037Spain',1),('00:1F:4B','Lineage Power','Lineage Power3000 Skyline Dr.Mesquite Tx 75149United States',1),('00:1F:4C','Roseman Engineering Ltd','Roseman Engineering Ltd65 Weizman StreetGivataim Israel 53468Israel',1),('00:1F:4D','Segnetics Llc','Segnetics LlcShkiperski Protok 14Saint-petersburg  199106Russian Federation',1),('00:1F:4E','Conmed Linvatec','Conmed Linvatec11311 Concept Blvd.Largo Fl 33773United States',1),('00:1F:4F','Thinkware Co. Ltd.','Thinkware Co. Ltd.15fl, Hanmi Tower, 45,Bangi-dong, Songpa-guSeoul  138-724Korea, Republic Of',1),('00:1F:50','Swissdis Ag','Swissdis AgGrasweg 7Schwarzhaeusern Be 4911Switzerland',1),('00:1F:51','Hd Communications Corp','Hd Communications Corp2180 Fifth AveRonkonkoma Ny 11779United States',1),('00:1F:52','Uvt Unternehmensberatung Fr Verkehr Und Technik Gmbh','Uvt Unternehmensberatung Fr Verkehr Und Technik GmbhJosefsstr.54-56Mainz Rlp 55118Germany',1),('00:1F:53','Gemac Gesellschaft Fr Mikroelektronikanwendung Chemnitz Mbh','Gemac Gesellschaft Fr Mikroelektronikanwendung Chemnitz MbhZwickauer Str. 227Chemnitz Sachsen 09116Germany',1),('00:1F:54','Lorex Technology Inc.','Lorex Technology Inc.300 Alden RoadMarkham Ontario L3r4c1Canada',1),('00:1F:55','Honeywell Security (china) Co., Ltd.','Honeywell Security (china) Co., Ltd.Block 28, Section 2, Huai  De Cui Gang Industrial  Estate, Fu Yong, Bao An, Shenzhen, P.r. ChinaShenzhen Guangdong 518103China',1),('00:1F:56','Digital Forecast','Digital Forecast5th Fl., 507, E&c Venture Dream Tower Iii, 197-33Guro 3-dong, Guro-guSeoul Gyunggi-do 152-719Korea, Republic Of',1),('00:1F:57','Phonik Innovation Co.,ltd','Phonik Innovation Co.,ltd29/167 Moo2, 345 Rd, Lampo,BangbuathongNonthaburi  11110Thailand',1),('00:1F:58','Emh Energiemesstechnik Gmbh','Emh Energiemesstechnik GmbhVor Dem Hassel 2Brackel Niedersachsen 21438Germany',1),('00:1F:59','Kronback Tracers','Kronback TracersC/o Ihk, M146Lautrupvang 15Ballerup Copenhagen 2750Denmark',1),('00:1F:5A','Beckwith Electric Co.','Beckwith Electric Co.6190 118th Ave NoLargo Florida 33773United States',1),('00:1F:5B','Apple, Inc.','Apple, Inc.1 Infinite LoopMs 35-gpoCupertino Ca 95014United States',1),('00:1F:5C','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1F:5D','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1F:5E','Dyna Technology Co.,ltd.','Dyna Technology Co.,ltd.Haohai Building 1f,no.7,5th Street,shangdi,Haidian DistrictBeijing  100085China',1),('00:1F:5F','Blatand Gmbh','Blatand GmbhLichtenbergstrae 8Garching Bavaria 85748Germany',1),('00:1F:60','Compass Systems Corp.','Compass Systems Corp.6f, No. 413, Sec. 2, Ti-ding Blvd.,Taipei Neihudist 114Taiwan, Republic Of China',1),('00:1F:61','Talent Communication Networks Inc.','Talent Communication Networks Inc.Rm. 910 R&f Plaza, #76, Huangpu Ave. West,Guangzhou (canton) Guangdong Province 510360China',1),('00:1F:62','Jsc stilsoft','Jsc stilsoftMayakovskogo 15Stavropol  355000Russian Federation',1),('00:1F:63','Jsc Goodwin-europa','Jsc Goodwin-europa20/5 Marksistskaya St.Moscow  109147Russian Federation',1),('00:1F:64','Beijing Autelan Technology Inc.','Beijing Autelan Technology Inc.Room B-12b01, Keshi Plaza, Xinxi Road,Shangdi Park,haidian,Beijing  100085China',1),('00:1F:65','Korea Electric Terminal Co., Ltd.','Korea Electric Terminal Co., Ltd.#7-38 Songdo-dongYeonsu-gu Incheon 406-840Korea, Republic Of',1),('00:1F:66','Planar Llc','Planar Llc32, Elkina StrChelyabinsk Su 454091Russian Federation',1),('00:1F:67','Hitachi,ltd.','Hitachi,ltd.Minamioi 6-27-18, Shinagawa-kuTokyo 140-8572Japan',1),('00:1F:68','Martinsson Elektronik Ab','Martinsson Elektronik AbBox 9060Hgersten Stockholm 126 09Sweden',1),('00:1F:69','Pingood Technology Co., Ltd.','Pingood Technology Co., Ltd.Rm1917, South Block, Cangsong Bldg., Tairan Industrial Zone, Futian DistrictShenzhen Guangdong 518040China',1),('00:1F:6A','Packetflux Technologies, Inc.','Packetflux Technologies, Inc.50 11th AvenueHelena Mt 59601United States',1),('00:1F:6B','Lg Electronics','Lg Electronics60-39,kasan-dong,kumchon-kuSeoul  153-023Korea, Republic Of',1),('00:1F:6C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:6D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:6E','Vtech Engineering Corporation','Vtech Engineering Corporation20 New England Business CenterAndover Ma 01810United States',1),('00:1F:6F','Fujian Sunnada Communication Co.,ltd.','Fujian Sunnada Communication Co.,ltd.7/fmain Buildingfujian Torch Hi-tech Innovation Park#611 Industrial Road Fuzhouprc 3500027# Building B District, Software Park, Tongpan Road Fuzhou, Prc 350003Fuzhou Fujian 350002China',1),('00:1F:70','Botik Technologies Ltd','Botik Technologies LtdTrudovaya, 1Pereslavl-zalessky Yaroslavskaya 152020Russian Federation',1),('00:1F:71','Xg Technology, Inc.','Xg Technology, Inc.240 S. Pineapple AvenueSuite 701Sarasota Fl 34236United States',1),('00:1F:72','Qingdao Hiphone Technology Co,.ltd','Qingdao Hiphone Technology Co,.ltdNo.106,jiangxi RoadQingdao Shandong 266071China',1),('00:1F:73','Teraview Technology Co., Ltd.','Teraview Technology Co., Ltd.23f, No. 29-5, Sec. 2, Jhongjheng E. Road,Danshui Township,Taipei County  251Taiwan, Republic Of China',1),('00:1F:74','Eigen Development','Eigen Development1807 W10th AveVancouver Bc V6j 2a9Canada',1),('00:1F:75','Gibahn Media','Gibahn Media1816 Rosedale Suseo-dongKangnam-guSeoul  135-885Korea, Republic Of',1),('00:1F:76','Airlogic Systems Inc.','Airlogic Systems Inc.3022 Peleke St.suite 1Lihue Hi 96766United States',1),('00:1F:77','Heol Design','Heol Design1 Bd DarmorLannion Bretagne 22300France',1),('00:1F:78','Blue Fox Porini Textile','Blue Fox Porini Textile1208 Pointe Centre DriveSte 200Chattanooga Tn 37421United States',1),('00:1F:79','Lodam Electronics A/s','Lodam Electronics A/sKrvej 77Snderborg Als Dk-6400Denmark',1),('00:1F:7A','Wiwide Inc.','Wiwide Inc.10b10, Hua Jie Plaza#13 Da Zhong Si, HaidianBeijing  100089China',1),('00:1F:7B','Technexion Ltd.','Technexion Ltd.3f, No. 716, Chung Chen Road,Chung Ho City Taipei 235Taiwan, Republic Of China',1),('00:1F:7C','Witelcom As','Witelcom AsVerftsgt 10Moss Ostfold 1511Norway',1),('00:1F:7D','Embedded Wireless Gmbh','Embedded Wireless GmbhSflinger Str. 100Ulm Bw 89077Germany',1),('00:1F:7E','Motorola Mobile Devices','Motorola Mobile Devices600 N. Us 45Libertyville Illinois 60048United States',1),('00:1F:7F','Phabrix Limited','Phabrix LimitedBlindmans Gate CottageWoolton HillNewbury Hampshire Rg20 9xbUnited Kingdom',1),('00:1F:80','Lucas Holding Bv','Lucas Holding BvDomein 28Gemert Nb 5421arNetherlands',1),('00:1F:81','Accel Semiconductor Corp','Accel Semiconductor Corp1f,mainbldg,149 Chun Xiao Road,Shanghai  201203China',1),('00:1F:82','Cal-comp Electronics & Communications Co., Ltd','Cal-comp Electronics & Communications Co., Ltd3f, #205, Sec.3 Peihsin Rd.Hsintein Taipei County 231Taiwan, Republic Of China',1),('00:1F:83','Teleplan Technology Services Sdn Bhd','Teleplan Technology Services Sdn Bhd2580, Tingkat Perusahaan 4bZon Perdagangan Bebas DuaPerai Penang 13600Malaysia',1),('00:1F:84','Gigle Semiconductor','Gigle SemiconductorBarcelona Activa - Vivero GloriasLlacuna 162Barcelona  08018Spain',1),('00:1F:85','Apriva Iss, Llc','Apriva Iss, Llc6900 E Camelback RdSuite 700Scottsdale Az 85251United States',1),('00:1F:86','Digecor','Digecor1625 N. 1100 W.Springville Ut 84663United States',1),('00:1F:87','Skydigital Inc.','Skydigital Inc.#28-9 Wonhyoro1-ga, Yongsan-gu,Seoul  140-846Korea, Republic Of',1),('00:1F:88','Fms Force Measuring Systems Ag','Fms Force Measuring Systems AgAspstrasse 6Oberglatt Zurich 8154Switzerland',1),('00:1F:89','Signalion Gmbh','Signalion GmbhSudhausweg 5Dresden Saxony 01099Germany',1),('00:1F:8A','Ellion Digital Inc.','Ellion Digital Inc.Suite 809, Sicox Tower, 513-14, Sangdaewon-dong, Jungwon-guSungnam-city Kyonggi-do 426-726Korea, Republic Of',1),('00:1F:8B','Storspeed, Inc.','Storspeed, Inc.8601 Rr 2222Building Iii, Suite 410Austin Texas 78730United States',1),('00:1F:8C','Ccs Inc.','Ccs Inc.Shimodachiuri-agaruKarasuma-dori, Kamigyo-kuKyoto Kyoto 602-8011Japan',1),('00:1F:8D','Ingenieurbuero Stark Gmbh Und Ko. Kg','Ingenieurbuero Stark Gmbh Und Ko. KgRudolf-diesel-strasse 44Laichingen Bw 89150Germany',1),('00:1F:8E','Metris Usa Inc.','Metris Usa Inc.12701 Grand RiverBrighton Mi 48116United States',1),('00:1F:8F','Shanghai Bellmann Digital Source Co.,ltd.','Shanghai Bellmann Digital Source Co.,ltd.404-408 Main Bd, Fdusp, No.11 Guotai Rd.Shanghai  200433China',1),('00:1F:90','Actiontec Electronics, Inc','Actiontec Electronics, Inc760 North Mary AveSunnyvale Ca 94085United States',1),('00:1F:91','Dbs Lodging Technologies, Llc','Dbs Lodging Technologies, Llc21196 LimberMission Viejo Ca 92692United States',1),('00:1F:92','Videoiq, Inc.','Videoiq, Inc.213 Burlington RoadSuite 104Bedford Ma 01730United States',1),('00:1F:93','Xiotech Corporation','Xiotech Corporation6455 Flying Cloud DriveEden Prairie Mn 55344United States',1),('00:1F:94','Lascar Electronics Ltd','Lascar Electronics LtdModule HouseWhiteparishNr Salisbury Wiltshire Sp5 2sjUnited Kingdom',1),('00:1F:95','Sagem Communication','Sagem Communication14 Rue Paul DautierVelizy  78457France',1),('00:1F:96','Aprotech Co.ltd','Aprotech Co.ltdKolondigital Tower Aston 201, 505-14Gasan-dong,kumchon-guSeoul  Ksxx 0022Korea, Republic Of',1),('00:1F:97','Bertana Srl','Bertana SrlViale Galileo Ferraris 27Bruino Torino 10090Italy',1),('00:1F:98','Daiichi-dentsu Ltd.','Daiichi-dentsu Ltd.Oomori 690-1Kani Gifu 509-0238Japan',1),('00:1F:99','Seronics Co.ltd','Seronics Co.ltd#401 Technopolis,711hosan-dong, Dalseo-guDaegu Gyeong-buk 704-230Korea, Republic Of',1),('00:1F:9A','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75082-4399United States',1),('00:1F:9B','Posbro','PosbroShinyounggtower 6f, 271-1Seohyun-dong, Bundang-guSeongnam-si Kyunggi-do 463-824Korea, Republic Of',1),('00:1F:9C','Ledco','Ledco47801 W Anchor CourtPlymouth Mi 48170United States',1),('00:1F:9D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:9E','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:9F','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47Edegem Antwerp B-2650Belgium',1),('00:1F:A0','A10 Networks','A10 Networks2309 Bering DriveSan Jose Ca 95131United States',1),('00:1F:A1','Gtran Inc','Gtran Inc2651 Lavery CourtNewbury Park Ca 91320United States',1),('00:1F:A2','Datron World Communications, Inc.','Datron World Communications, Inc.3030 Enterprise CourtVista California 92081United States',1),('00:1F:A3','T&w Electronics(shenzhen)co.,ltd.','T&w Electronics(shenzhen)co.,ltd.2f,baiying Building, No.1019,Shenzhen Guangdong 518067China',1),('00:1F:A4','Shenzhen Gongjin Electronics Co.,ltd','Shenzhen Gongjin Electronics Co.,ltd4f,baiying Building, No.1019,nanhai Rd,shekou,Shenzhen Guangdong 518067China',1),('00:1F:A5','Blue-white Industries','Blue-white Industries5300 Business DriveHuntington Beach Ca 92649United States',1),('00:1F:A6','Stilo Srl','Stilo SrlVia Besana, 420122 MilanoItaly',1),('00:1F:A7','Sony Computer Entertainment Inc.','Sony Computer Entertainment Inc.2-6-21 Minami-aoyama,Minato-ku Tokyo 107-0062Japan',1),('00:1F:A8','Ani Technologies Corp.','Ani Technologies Corp.3044 Bloor St. W. #302Etobicoke Ontario M8x 2y8Canada',1),('00:1F:A9','Atlanta Dth, Inc.','Atlanta Dth, Inc.5388 New Peachtree RdChamblee Ga 30341United States',1),('00:1F:AA','Taseon, Inc.','Taseon, Inc.3099 N. First StreetSan Jose Ca 95134United States',1),('00:1F:AB','I.s High Tech.inc','I.s High Tech.inc603-1,sungbon-ri,daeso-myunEumsung-gun Chungcheongbuk-do 369-823Korea, Republic Of',1),('00:1F:AC','Goodmill Systems Ltd','Goodmill Systems LtdSinikalliontie 10Espoo Uusimaa 02630Finland',1),('00:1F:AD','Brown Innovations, Inc','Brown Innovations, Inc369 Congress StreetFourth FloorBoston Ma 02210United States',1),('00:1F:AE','Blick South Africa (pty) Ltd','Blick South Africa (pty) LtdPo Box 1908RivoniaJohannesburg Gauteng 2108South Africa',1),('00:1F:AF','Nextio, Inc.','Nextio, Inc.12401 Research Blvd.Bldg. 2 Suite 200Austin Tx 78759United States',1),('00:1F:B0','Timeips, Inc.','Timeips, Inc.3522 N Comotara StWichita Ks 67226United States',1),('00:1F:B1','Cybertech Inc.','Cybertech Inc.935 Horsham RdUnit IHorsham Pa 19044United States',1),('00:1F:B2','Sontheim Industrie Elektronik Gmbh','Sontheim Industrie Elektronik GmbhDieselstrasse 7Kempten Allgaeu Bavaria D-87437Germany',1),('00:1F:B3','2wire','2wire1764 Automation ParkwaySan Jose Ca 95131United States',1),('00:1F:B4','Smartshare Systems','Smartshare SystemsTobaksvejen 25, 1. Th.Soeborg  Dk-2860Denmark',1),('00:1F:B5','I/o Interconnect Inc.','I/o Interconnect Inc.1202 E Wakeham AveSanta Ana Ca 92708United States',1),('00:1F:B6','Chi Lin Technology Co., Ltd.','Chi Lin Technology Co., Ltd.No.18, Sheng Li 1st St., Jen Te Hsiang,Tainan Taiwan 71758China',1),('00:1F:B7','Wimate Technologies Corp.','Wimate Technologies Corp.14a Building 2, Guimiao Garden, Nanguanglu, Nanshan DistrictShenzhen Guangdong 518054China',1),('00:1F:B8','Universal Remote Control, Inc.','Universal Remote Control, Inc.500 Mamaroneck AvenueSuite 502Harrison Ny 10528United States',1),('00:1F:B9','Paltronics','Paltronics1145 Paltronics CtCrystal Lake Il 60014United States',1),('00:1F:BA','Boyoung Tech. & Marketing, Inc.','Boyoung Tech. & Marketing, Inc.Youngdeungpo-gu Munrae3ga 84-2Dongguk Mertian 602Seoul  150-093Korea, Republic Of',1),('00:1F:BB','Xenatech Co.,ltd','Xenatech Co.,ltd514-2 Ya Tab-dong Bun Dang GuSeong Namsi Gyong Gi-do 463-839Korea, Republic Of',1),('00:1F:BC','Evga Corporation','Evga Corporation2900 Saturn St.Suite BBrea Ca 92821United States',1),('00:1F:BD','Kyocera Wireless Corp.','Kyocera Wireless Corp.10300 Campus Point DriveSan Diego Ca 92121United States',1),('00:1F:BE','Shenzhen Mopnet Industrial Co.,ltd','Shenzhen Mopnet Industrial Co.,ltdF 3.no.3 Keyuan Rd.Shenzhen Nanshan Science&industry ParkShenzhen Guangdong 518057China',1),('00:1F:BF','Fulhua Microelectronics Corp. Taiwan Branch','Fulhua Microelectronics Corp. Taiwan Branch1f, No.12, R&d Road,Science-based Ind. Park,Hsin-chu, 300  886Taiwan, Republic Of China',1),('00:1F:C0','Control Express Finland Oy','Control Express Finland OyLaitaatsillantie 3Savonlinna  57170Finland',1),('00:1F:C1','Hanlong Technology Co.,ltd','Hanlong Technology Co.,ltdRm.2220,block B,new Century Plaza,1 Tai Ping Nan Road,Nanjing Jiangsu 210002China',1),('00:1F:C2','Jow Tong Technology Co Ltd','Jow Tong Technology Co Ltd46 Lane 337 Chung Cheng RdYung Kang City Tainan County 71066Taiwan, Republic Of China',1),('00:1F:C3','Smartsynch, Inc','Smartsynch, Inc4400 Old Canton RdSuite 300Jackson Ms 39211United States',1),('00:1F:C4','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:1F:C5','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:1F:C6','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitou,taipei 112Taipei  112Taiwan, Republic Of China',1),('00:1F:C7','Casio Hitachi Mobile Comunications Co., Ltd.','Casio Hitachi Mobile Comunications Co., Ltd.2-229-1, SakuragaokaHigashiyamato-shi Tokyo 207-8501Japan',1),('00:1F:C8','Up-today Industrial Co., Ltd.','Up-today Industrial Co., Ltd.7/f., Unify Commercial & Industrial Building31 Tai Yip Street, Kwun Tong,KowloonHong Kong',1),('00:1F:C9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:CA','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:1F:CB','Niw Solutions','Niw SolutionsP.o. Box 62One Tree Hill South Australia 5114Australia',1),('00:1F:CC','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1F:CD','Samsung Electronics','Samsung Electronics#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:1F:CE','Qtech Llc','Qtech LlcNovozavodskaya St. 18 Build. 1Moscow Moscow Region 121309Russian Federation',1),('00:1F:CF','Msi Technology Gmbh','Msi Technology GmbhHanauer Landstrae 328-330Frankfurt Am Main Hessen 60314Germany',1),('00:1F:D0','Giga-byte Technology Co.,ltd.','Giga-byte Technology Co.,ltd.No.215,nan-ping Road,Pin-jen Taoyuan 324Taiwan, Republic Of China',1),('00:1F:D1','Optex Co.,ltd.','Optex Co.,ltd.5-8-12OgotoOtsu Shiga 520-0101Japan',1),('00:1F:D2','Commtech Technology Macao Commercial Offshore Ltd.','Commtech Technology Macao Commercial Offshore Ltd.31,tai Yip Street, 7/f Kwun Tong,Kowloon, HongkongChina',1),('00:1F:D3','Riva Networks Inc.','Riva Networks Inc.555 Riva AveEast Brunswick Nj 08816United States',1),('00:1F:D4','4ipnet, Inc.','4ipnet, Inc.38129 Cambridge CourtFremont Ca 94536United States',1),('00:1F:D5','Microrisc S.r.o.','Microrisc S.r.o.Delnicka 222Jicin Kralovehradecky Kraj 50601Czech Republic',1),('00:1F:D6','Shenzhen Allywll','Shenzhen AllywllKejiyuan NanshanShenzhen Guangdong 518057China',1),('00:1F:D7','Telerad Sa','Telerad Sa2, Avenue De La Butte Aux CaillesAnglet  64600France',1),('00:1F:D8','A-trust Computer Corporation','A-trust Computer Corporation3f., No.361, Fusing 1st Rd., Gueishan Township,Taoyuan  33375Taiwan, Republic Of China',1),('00:1F:D9','Rsd Communications Ltd','Rsd Communications Ltd8 Borrowmeadow RoadSpringkerse Industrial EstateStirling Scotland Fk7 7uwUnited Kingdom',1),('00:1F:DA','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75081United States',1),('00:1F:DB','Network Supply Corp.,','Network Supply Corp.,1938 Nakadaira KanaeIida Nagano 395-0801Japan',1),('00:1F:DC','Mobile Safe Track Ltd','Mobile Safe Track LtdNiemenkatu 7315149 LahtiFinland',1),('00:1F:DD','Gdi Llc','Gdi LlcOne Midamerica PlazaSuite 1010Oakbrook Terrace Il 60181United States',1),('00:1F:DE','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1F:DF','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:1F:E0','Edgevelocity Corp','Edgevelocity Corp3 Bourbon StreetPeabody Ma 01960United States',1),('00:1F:E1','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:1F:E2','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:1F:E3','Lg Electronics','Lg Electronics60-39,kasan-dong,kumchon-ku,Seoul  153-801Korea, Republic Of',1),('00:1F:E4','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:1F:E5','In-circuit Gmbh','In-circuit GmbhKnigsbrcker Strasse 69Dresden  01099Germany',1),('00:1F:E6','Alphion Corporation','Alphion Corporation196 Princeton Hightstown RoadSuite 1aPrinceton Junction New Jersey 08550United States',1),('00:1F:E7','Simet','SimetStrada Del Portone 129Grugliasco Torino 10095Italy',1),('00:1F:E8','Kurusugawa Electronics Industry Inc,.','Kurusugawa Electronics Industry Inc,.2f, 52-5, Nogata 6chomeNakano-ku Tokyo 165-0027Japan',1),('00:1F:E9','Printrex, Inc.','Printrex, Inc.276 East Gish RoadSan Jose Ca 95112United States',1),('00:1F:EA','Applied Media Technologies Corporation','Applied Media Technologies Corporation4091 Amtc Center DriveClearwater Fl 33764United States',1),('00:1F:EB','Trio Datacom Pty Ltd','Trio Datacom Pty Ltd41 Aster AvenueCarrum Downs Victoria 3201Australia',1),('00:1F:EC','Synapse lectronique','Synapse lectronique1010, 7e AvenueGrand-mre Qubec G9t 2b8Canada',1),('00:1F:ED','Tecan Systems Inc.','Tecan Systems Inc.2450 Zanker RoadSan Jose Ca 95131United States',1),('00:1F:EE','Ubisys Technologies Gmbh','Ubisys Technologies GmbhAm Wehrhahn 45Dsseldorf Nrw 40211Germany',1),('00:1F:EF','Shinsei Industries Co.,ltd','Shinsei Industries Co.,ltd4-12-15,horifune, Kita-ku,Tokoyo  114-0004Japan',1),('00:1F:F0','Audio Partnership','Audio PartnershipGallery CourtHankey PlaceLondon  Se1 4bbUnited Kingdom',1),('00:1F:F1','Paradox Hellas S.a.','Paradox Hellas S.a.3 Korinthoy StMetamorfosiAthens Attiki 14451Greece',1),('00:1F:F2','Via Technologies, Inc.','Via Technologies, Inc.1f, 531, Chung-cheng RoadHsin-tien Taipei 231Taiwan, Republic Of China',1),('00:1F:F3','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 94086United States',1),('00:1F:F4','Power Monitors, Inc.','Power Monitors, Inc.800 North Main StreetMt. Crawford Virginia 22841United States',1),('00:1F:F5','Kongsberg Defence & Aerospace','Kongsberg Defence & AerospaceOlav Brunborgs Vei 6Billingstad  1396Norway',1),('00:1F:F6','Ps Audio International','Ps Audio International4826 Sterling DriveBoulder Co 80301United States',1),('00:1F:F7','Nakajima All Precision Co., Ltd.','Nakajima All Precision Co., Ltd.Kami-gomyo1480Sakaki-machiHanishina-gun Nagano-ken 389-0606Japan',1),('00:1F:F8','Siemens Ag, Sector Industry, Drive Technologies, Motion Control Systems','Siemens Ag, Sector Industry, Drive Technologies, Motion Control SystemsFrauenauracherstrasse 80Erlangen Bavaria 91056Germany',1),('00:1F:F9','Advanced Knowledge Associates','Advanced Knowledge Associates3350 Scott Blvd, Suite 40Santa Clara Ca 95054-3119United States',1),('00:1F:FA','Coretree, Co, Ltd','Coretree, Co, Ltd#502 It Venture Town, 694Taprib-dong, Yusung-guDaejeon  305-510Korea, Republic Of',1),('00:1F:FB','Green Packet Bhd','Green Packet BhdLot 1-4, Incubator 2, Technology Park MalaysiaLebuhraya Puchong - Sg Besi, Bukit JalilKuala Lumpur Wilayah Persekutuan 57000Malaysia',1),('00:1F:FC','Riccius+sohn Gmbh','Riccius+sohn GmbhHaynauer Str. 49Berlin  12249Germany',1),('00:1F:FD','Indigo Mobile Technologies Corp.','Indigo Mobile Technologies Corp.11f, No22, Lan407,tiding Blvd Section2, Neihu Technology ParkTaipei City  114Taiwan, Republic Of China',1),('00:1F:FE','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville Ca 95747United States',1),('00:1F:FF','Respironics, Inc.','Respironics, Inc.1740 Golden Mile HighwayMonroeville Pa 15146United States',1),('00:20:00','Lexmark International, Inc.','Lexmark International, Inc.740 New Circle RoadBldg. 35Lexington Ky 40550United States',1),('00:20:01','Dsp Solutions, Inc.','Dsp Solutions, Inc.2464 Embarcadero WayPalo Alto Ca 94303United States',1),('00:20:02','Seritech Enterprise Co., Ltd.','Seritech Enterprise Co., Ltd.Fl. 182, No. 531-1Chung Cheng Road Hsin Tien CityTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:20:03','Pixel Power Ltd.','Pixel Power Ltd.Unit 5 College Business ParkColdhams LaneCambridge  Cb1 3hdUnited Kingdom',1),('00:20:04','Yamatake-honeywell Co., Ltd.','Yamatake-honeywell Co., Ltd.54 Suzukawa, IseharaKanagawa 259-11Japan',1),('00:20:05','Simple Technology','Simple Technology3001 Daimler RoadSanta Ana Ca 92705United States',1),('00:20:06','Garrett Communications, Inc.','Garrett Communications, Inc.48531 Warmsprings Blvd.Fremont Ca 94539United States',1),('00:20:07','Sfa, Inc.','Sfa, Inc.1401 Mccormick DriveLandover Md 20785United States',1),('00:20:08','Cable & Computer Technology','Cable & Computer Technology1555 So. Sinclair StreetAnaheim Ca 92806United States',1),('00:20:09','Packard Bell Elec., Inc.','Packard Bell Elec., Inc.9425 Canoga AvenueChatsworth Ca 913211United States',1),('00:20:0A','Source-comm Corp.','Source-comm Corp.25020 W. Avenue StanfordUnit 180Valencia Ca 91355United States',1),('00:20:0B','Octagon Systems Corp.','Octagon Systems Corp.6510 W. 91st AvenueWestminster Co 80030United States',1),('00:20:0C','Adastra Systems Corp.','Adastra Systems Corp.28310 Industrial Blvd.-ste-kHayward Ca 94545United States',1),('00:20:0D','Carl Zeiss','Carl ZeissPostfach 1380Abt.  1-el 73444 OberkochenGermany',1),('00:20:0E','Satellite Technology Mgmt, Inc','Satellite Technology Mgmt, Inc3530 Hyland AvenueCosta Mesa Ca 92626United States',1),('00:20:0F','Tanbac Co., Ltd.','Tanbac Co., Ltd.Sakurai Dai 2 Bg27-4 Iriya 1-chome Taito-ku Tokyo 110Japan',1),('00:20:10','Jeol System Technology Co. Ltd','Jeol System Technology Co. Ltd3-1-2 MusashinoAkishima-shi Tokyo 196-8558Japan',1),('00:20:11','Canopus Co., Ltd.','Canopus Co., Ltd.Kobe Hi-tech Park1-2-2 Murotani Nishi-ku Kobe651-22 JapanJapan',1),('00:20:12','Camtronics Medical Systems','Camtronics Medical SystemsP.o. Box 950Hartland Wi 53029United States',1),('00:20:13','Diversified Technology, Inc.','Diversified Technology, Inc.112 E. State StreetRidgeland Ms 39157United States',1),('00:20:14','Global View Co., Ltd.','Global View Co., Ltd.4f, No. 23, Lane 306Fu-teh 1 Rd. Hsi-chih, Taipei, HsienTaiwan R.o.c.Taiwan, Republic Of China',1),('00:20:15','Actis Computer Sa','Actis Computer Sa16 Chemin Des Aulx1228 Plan Les OvatesSwitzerlandSwitzerland',1),('00:20:16','Showa Electric Wire & Cable Co','Showa Electric Wire & Cable CoNo. 20-25, Seishin 8-chomeSagamihara, Kanagawa229 JapanJapan',1),('00:20:17','Orbotech','OrbotechIndustrial ZoneP.o. Box 215 70651  YavneIsraelIsrael',1),('00:20:18','Cis Technology Inc.','Cis Technology Inc.Fl. 9-1, No. 94, Pao Chung Rd.Hsin Tien CityTaipei HsienTaiwan, Republic Of China',1),('00:20:19','Ohler Gmbh','Ohler GmbhMaybachstrase 3071332 WaiblingenGermany',1),('00:20:1A','Mrv Communications, Inc.','Mrv Communications, Inc.20415 Nordhoff St.Chatsworth Ca 91311United States',1),('00:20:1B','Northern Telecom/network','Northern Telecom/networkSystems Corporation250 Sidney Street Belleville, OntarioK8n 5b7Canada',1),('00:20:1C','Excel, Inc.','Excel, Inc.355 Old Plymouth RoadSagamore Beach Ma 02562United States',1),('00:20:1D','Katana Products','Katana ProductsThe Studio, Quarry Hill Box,Wiltshire Sn14 9htUnited Kingdom',1),('00:20:1E','Netquest Corporation','Netquest Corporation523 Fellowship Road-ste.#205Mt. Laurel Nj 08054United States',1),('00:20:1F','Best Power Technology, Inc.','Best Power Technology, Inc.P.o. Box 280Necedah Wi 54646United States',1),('00:20:20','Megatron Computer Industries Pty, Ltd.','Megatron Computer Industries Pty, Ltd.',1),('00:20:21','Algorithms Software Pvt. Ltd.','Algorithms Software Pvt. Ltd.83 Jolly Maker Chambers IiNariman Point Bombay  400021IndiaIndia',1),('00:20:22','Nms Communications','Nms Communications100 Crossing BoulevardFramingham Ma 01702United States',1),('00:20:23','T.c. Technologies Pty. Ltd','T.c. Technologies Pty. Ltd6/60 Fairford Rd.Padstow  Nsw2211Australia',1),('00:20:24','Pacific Communication Sciences','Pacific Communication Sciences9645 Scranton RoadSan Diego Ca 92121United States',1),('00:20:25','Control Technology, Inc.','Control Technology, Inc.5734 Middlebrook PikeKnoxville Tn 37921United States',1),('00:20:26','Amkly Systems, Inc.','Amkly Systems, Inc.15801 Rockfield Blvd., #pIrvine Ca 92718United States',1),('00:20:27','Ming Fortune Industry Co., Ltd','Ming Fortune Industry Co., Ltd4f, No. 800 Chung Cheng Rd,Chung Ho City, Taipei HsienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:20:28','West Egg Systems, Inc.','West Egg Systems, Inc.65 High Ridge Road-ste.#286Stamford Ct 06905United States',1),('00:20:29','Teleprocessing Products, Inc.','Teleprocessing Products, Inc.4565 E. Industrial StreetBuilding #7kSimi Valley Ca 93063United States',1),('00:20:2A','N.v. Dzine','N.v. DzineKoning Leopold Iii Laan 2B - 8500 KortrijkBelgiumBelgium',1),('00:20:2B','Advanced Telecommunications Modules, Ltd.','Advanced Telecommunications Modules, Ltd.',1),('00:20:2C','Welltronix Co., Ltd.','Welltronix Co., Ltd.3f, No. 36-1, Hwang Hsi StreetShin-lin TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:20:2D','Taiyo Corporation','Taiyo Corporation1-2-6 Sannoh, Ohta-kuTokyo143Japan',1),('00:20:2E','Daystar Digital','Daystar Digital5556 Atlanta HighwayFlowery Branch Ga 30542United States',1),('00:20:2F','Zeta Communications, Ltd.','Zeta Communications, Ltd.Zenith HouseGresford Industrial ParkWrexham, Clwyd, Ll12 8lxUnited Kingdom',1),('00:20:30','Analog & Digital Systems','Analog & Digital Systems1/2 Lavelle RoadBangalore - 560001IndiaIndia',1),('00:20:31','Ertec Gmbh','Ertec GmbhAm Pestalozziring 24D-91058 ErlangenGermany',1),('00:20:32','Alcatel Taisel','Alcatel Taisel4, Ming Sheng Street Tu-chengIndustrial District Taipei HsiehTaiwan RocTaiwan, Republic Of China',1),('00:20:33','Synapse Technologies, Inc.','Synapse Technologies, Inc.4822 Albemarle Road, #104Charlotte Nc 28205United States',1),('00:20:34','Rotec Industrieautomation Gmbh','Rotec Industrieautomation GmbhGutenbergstr. 1576437 RastattGermany',1),('00:20:35','Ibm Corporation','Ibm CorporationP.o. Box 12195Ce6a/664 3039 CornwallisRtp Nc 27709-2195United States',1),('00:20:36','Bmc Software','Bmc Software1600 City West Blvd., #1600Houston Tx 77042United States',1),('00:20:37','Seagate Technology','Seagate Technology8001 E. Bloomington FwyM/s - Mps043Bloomington Mn 55420United States',1),('00:20:38','Vme Microsystems International Corporation','Vme Microsystems International Corporation12090 S. Memorial ParkwayHuntsville Al 35803United States',1),('00:20:39','Scinets','Scinets1575 Tenaka - Ste# N8Sunnyvale Ca 94087United States',1),('00:20:3A','Digital Bi0metrics Inc.','Digital Bi0metrics Inc.5600 Rowland Road- Ste.#205Minnetonka Mn 55364United States',1),('00:20:3B','Wisdm Ltd.','Wisdm Ltd.St. Johns Innovation CentreCowley Road Cambridge  Cb4 4wsEnglandUnited Kingdom',1),('00:20:3C','Eurotime Ab','Eurotime AbBox 277S-53224 SkaraSwedenSweden',1),('00:20:3D','Honeywell Ecc','Honeywell Ecc1985 Douglas DriveMn10-121aGolden Valley Mn 55422United States',1),('00:20:3E','Logican Technologies, Inc.','Logican Technologies, Inc.150 Karl Clark RoadEdmonton, Alberta T6n 1e2Canada',1),('00:20:3F','Juki Corporation','Juki Corporation8-2-1 Kokuryo-choChofu-shi Tokyo  182JapanJapan',1),('00:20:40','Motorola Broadband Communications Sector','Motorola Broadband Communications Sector6450 Sequence DriveSan Diego Ca 92121United States',1),('00:20:41','Data Net','Data NetSuwon P.o. Box 106, SuwonKyunggi-doKorea 440-600Korea, Republic Of',1),('00:20:42','Datametrics Corp.','Datametrics Corp.8966 Comanche Ave.Chatsworth Ca 91311United States',1),('00:20:43','Neuron Company Limited','Neuron Company Limited15 Kwai Yi Road,  Block 2,21st Floor, Flat BKwai Chung,   N.t.Hong Kong',1),('00:20:44','Genitech Pty Ltd','Genitech Pty LtdP.o. Box 196Asquith Nsw 2077AustraliaAustralia',1),('00:20:45','Ion Networks, Inc.','Ion Networks, Inc.1551 South Washington Ave.Piscataway Nj 08854United States',1),('00:20:46','Ciprico, Inc.','Ciprico, Inc.2800 Campus Drive--suite #60Plymouth Mn 55441United States',1),('00:20:47','Steinbrecher Corp.','Steinbrecher Corp.30 North AvenueBurlington Ma 01803United States',1),('00:20:48','Marconi Communications','Marconi Communications1000 Fore DriveWarrendale Pa 15086-7502United States',1),('00:20:49','Comtron, Inc.','Comtron, Inc.Sancatherina Bldg.36-12 Shinjuku 1-chome Shinjuku-kuTokyo 160 JapanJapan',1),('00:20:4A','Pronet Gmbh','Pronet GmbhKarlstrasse 49D-7805 F Villingen-schwenningenGermanyGermany',1),('00:20:4B','Autocomputer Co., Ltd.','Autocomputer Co., Ltd.No. 18, Pei Yuan RoadChung-li City, Tao-yuan HsienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:20:4C','Mitron Computer Pte Ltd.','Mitron Computer Pte Ltd.1020 Hougang Avenue 1 #03-3504Singapore 1953Singapore',1),('00:20:4D','Inovis Gmbh','Inovis GmbhHanns-braun Strasse 5085375 NeufahrnGermanyGermany',1),('00:20:4E','Network Security Systems, Inc.','Network Security Systems, Inc.9401 Waples Street,ste. #100San Diego Ca 92121United States',1),('00:20:4F','Deutsche Aerospace Ag','Deutsche Aerospace AgGeschaeftsfeldVerteidigung Und Zivile System 81663 MueBundesrepublik DeutschlandGermany',1),('00:20:50','Korea Computer Inc.','Korea Computer Inc.469, Daeheung-dongMapo-gu, SeoulKoreaKorea, Republic Of',1),('00:20:51','Verilink Corporation','Verilink Corporation127 Jetplex CircleMadison Al 35758United States',1),('00:20:52','Ragula Systems','Ragula Systems4540 S. Jupiter DriveSalt Lake City Ut 84124United States',1),('00:20:53','Huntsville Microsystems, Inc.','Huntsville Microsystems, Inc.P.o. Box 12415Huntsville Al 35815United States',1),('00:20:54','Sycamore Networks','Sycamore Networks220 Mill RdChelmsford Ma 01824United States',1),('00:20:55','Altech Co., Ltd.','Altech Co., Ltd.Ohishi Bldg., 2-23-11Nishi-nippori, Arakawa-kuTokyo 116Japan',1),('00:20:56','Neoproducts','Neoproducts25 Chapman StreetBlackburn North Victoria 3130AustraliaAustralia',1),('00:20:57','Titze Datentechnik Gmbh','Titze Datentechnik GmbhDieselstrasse 10Ds-71272 Renningen-2Germany',1),('00:20:58','Allied Signal Inc.','Allied Signal Inc.Route 46Teterboro Nj 07608United States',1),('00:20:59','Miro Computer Products Ag','Miro Computer Products AgCarl Miele Str. 4D-38112 BraunschweigGermany',1),('00:20:5A','Computer Identics','Computer Identics5 Shawmut RoadCanton Ma 02021United States',1),('00:20:5B','Kentrox, Llc','Kentrox, Llc20010 Nw Tanasbourne Dr.Hillsboro Or 97124United States',1),('00:20:5C','Internet Systems Of Florida, Inc.','Internet Systems Of Florida, Inc.P.o. Box 578Crestview Fl 32536United States',1),('00:20:5D','Nanomatic Oy','Nanomatic OyPuistolan Raitti 400760 HelsinkiFinlandFinland',1),('00:20:5E','Castle Rock, Inc.','Castle Rock, Inc.20 South Santa Cruz Ave.Suite #310Los Gatos Ca 95030United States',1),('00:20:5F','Gammadata Computer Gmbh','Gammadata Computer GmbhGutenbergstr. 1382168 PuchheimGermanyGermany',1),('00:20:60','Alcatel Italia S.p.a.','Alcatel Italia S.p.a.Via Trento, 3020059 Vimercate (mi)Italy',1),('00:20:61','Garrettcom, Inc.','Garrettcom, Inc.991 Annapolis WayNorth Andover Ma 01845United States',1),('00:20:62','Scorpion Logic, Ltd.','Scorpion Logic, Ltd.19 Brookside RoadOxhey, WatfordHerts Wd1 4bwUnited Kingdom',1),('00:20:63','Wipro Infotech Ltd.','Wipro Infotech Ltd.Units 47-48, Sdf Block ViiMepz, Kadapperi Madras-600045India',1),('00:20:64','Protec Microsystems, Inc.','Protec Microsystems, Inc.297 LabrossePointe-claire, Quebec H9r 1a3Canada',1),('00:20:65','Supernet Networking Inc.','Supernet Networking Inc.16 Tozeret Haaretz St.Tel-aviv 67891Israel',1),('00:20:66','General Magic, Inc.','General Magic, Inc.2465 Latham StreetMountain View Ca 94040United States',1),('00:20:67','Private','',1),('00:20:68','Isdyne','Isdyne11 Roxbury AvenueNatick Ma 01760United States',1),('00:20:69','Isdn Systems Corporation','Isdn Systems Corporation8320 Old Courthouse Rd.Suite #203Vienna Va 22182United States',1),('00:20:6A','Osaka Computer Corp.','Osaka Computer Corp.2-8 Koyachou Neyagaw-shiOsaka 572JapanJapan',1),('00:20:6B','Konica Minolta Holdings, Inc.','Konica Minolta Holdings, Inc.1-6-1, Marunouchi,Chiyoda-kuTokyo  100-0005Japan',1),('00:20:6C','Evergreen Technology Corp.','Evergreen Technology Corp.231 Emerson StreetPalo Alto Ca 94301United States',1),('00:20:6D','Data Race, Inc.','Data Race, Inc.11550 Ih-10west  Ste#395San Antonio Tx 78230United States',1),('00:20:6E','Xact, Inc.','Xact, Inc.P.o. Box 55Argyle Tx 76226United States',1),('00:20:6F','Flowpoint Corporation','Flowpoint Corporation7291 Coronado Drive, Ste# 4San Jose Ca 95129United States',1),('00:20:70','Hynet, Ltd.','Hynet, Ltd.102 Jabotinsky St.Po Box 3638Petach Tikva 49130Israel',1),('00:20:71','Ibr Gmbh','Ibr GmbhKohlerstr. 45D-46286 DorstenGermany',1),('00:20:72','Worklink Innovations','Worklink Innovations2452 Armstrong StreetLivermore Ca 9455oUnited States',1),('00:20:73','Fusion Systems Corporation','Fusion Systems Corporation7600 Standish PlaceRockville Md 20855United States',1),('00:20:74','Sungwoon Systems','Sungwoon SystemsYusun Bldg.44-4Samsung-dong Kangnam-ku, Seoul 135-090KoreaKorea, Republic Of',1),('00:20:75','Motorola Communication Israel','Motorola Communication Israel3 Kremenetski StreetPob 25016Tel-aviv  61250Israel',1),('00:20:76','Reudo Corporation','Reudo Corporation4-1-10 ShinsanNagaoka City, Niigata 940-21JapanJapan',1),('00:20:77','Kardios Systems Corp.','Kardios Systems Corp.26 N Summit Ave.Gaithersburg Md 20877United States',1),('00:20:78','Runtop, Inc.','Runtop, Inc.5/f, No. 10, Alley 8, Lane 45Pao Shin Road, Hsintien Taipei HsienTaiwan R.o.c.Taiwan, Republic Of China',1),('00:20:79','Mikron Gmbh','Mikron GmbhBreslauerstr. 1-385386 EchingGermany',1),('00:20:7A','Wise Communications, Inc.','Wise Communications, Inc.130 Knowles DriveLos Gatos Ca 95030United States',1),('00:20:7B','Intel Corporation','Intel Corporation2111 Ne 25th AvenueJf3-420Hillsboro Or 97124United States',1),('00:20:7C','Autec Gmbh','Autec GmbhBahnhofstr. 5755234 FramersheimGermany',1),('00:20:7D','Advanced Computer Applications','Advanced Computer Applications107 Penns TrailNewtown Pa 18940United States',1),('00:20:7E','Finecom Co., Ltd.','Finecom Co., Ltd.1108 Hwakok-dong, Kangseo-kuSeoulKorea, Republic Of',1),('00:20:7F','Kyoei Sangyo Co., Ltd.','Kyoei Sangyo Co., Ltd.Dir. & Genl Mgr.ind. Systems20-4, Shoto 2-chome Shibuya-kuTokyoJapan',1),('00:20:80','Synergy (uk) Ltd.','Synergy (uk) Ltd.Hartcran HouseCarpenders Park,Watford Herts.  Wd1 5ezUnited Kingdom',1),('00:20:81','Titan Electronics','Titan Electronics3033 Science Park RoadSan Diego Ca 92121United States',1),('00:20:82','Oneac Corporation','Oneac Corporation27944 N. Bradley Rd.Libertyville Il 60048United States',1),('00:20:83','Presticom Incorporated','Presticom Incorporated3275, 1st Street, Ste. #1St-hubert (quebec)Canada J3y 8y6Canada',1),('00:20:84','Oce Printing Systems, Gmbh','Oce Printing Systems, GmbhSiemensallee 2D-85586 PoingGermany',1),('00:20:85','Exide Electronics','Exide ElectronicsP.o. Box  58189Raleigh Nc 27658United States',1),('00:20:86','Microtech Electronics Limited','Microtech Electronics LimitedLancaster RoadCressex Industrial Estate High Wycombe,KingdomUnited Kingdom',1),('00:20:87','Memotec Communications Corp.','Memotec Communications Corp.One High StreetNorth Andover Ma 01845United States',1),('00:20:88','Global Village Communication','Global Village Communication1144 East Arques AvenueSunnyvale Ca 94086United States',1),('00:20:89','T3plus Networking, Inc.','T3plus Networking, Inc.2840 San Tomas ExpresswaySanta Clara Ca 95051United States',1),('00:20:8A','Sonix Communications, Ltd.','Sonix Communications, Ltd.Wilkinson RoadCirencester, Glos. Gl7 1ytEnglandUnited Kingdom',1),('00:20:8B','Lapis Technologies, Inc.','Lapis Technologies, Inc.1100 Marina Village PkwySuite #100Alameda Ca 94501United States',1),('00:20:8C','Galaxy Networks, Inc.','Galaxy Networks, Inc.9348 De Soto AvenueChatsworth Ca 91311United States',1),('00:20:8D','Cmd Technology','Cmd Technology1 VanderbiltIrvine Ca 92718United States',1),('00:20:8E','Chevin Software Eng. Ltd.','Chevin Software Eng. Ltd.2 Boroughgate, Otley,Leeds, West, YorkshireLs21 3al United KingdomUnited Kingdom',1),('00:20:8F','Eci Telecom Ltd.','Eci Telecom Ltd.Hasivim St. 30,Petach-tikva 49133Israel',1),('00:20:90','Advanced Compression Technology, Inc.','Advanced Compression Technology, Inc.820 Flynn RoadCamarillo Ca 93012United States',1),('00:20:91','J125, National Security Agency','J125, National Security Agency9800 Savage RoadFt. Meade Md 20755-6000United States',1),('00:20:92','Chess Engineering B.v.','Chess Engineering B.v.Nieuwe Gracht 742011 Nj HaarlemNetherlands',1),('00:20:93','Landings Technology Corp.','Landings Technology Corp.163 Water StreetMerrill Block Unit A2Exeter Nh 03833United States',1),('00:20:94','Cubix Corporation','Cubix Corporation2800 Lockheed WayCarson City Nv 89706United States',1),('00:20:95','Riva Electronics','Riva ElectronicsUnit 17, Barrsfold Rd.Wingates Industrial Park Westhoughton, BLancashire England Bl5 3xwUnited Kingdom',1),('00:20:96','Invensys','Invensys1354 Clifford AvenueLoves Park Il 61111United States',1),('00:20:97','Applied Signal Technology','Applied Signal Technology160 Sobrante WaySunnyvale Ca 94086United States',1),('00:20:98','Hectronic Ab','Hectronic AbBox 3002S-75003 UppsalaSweden',1),('00:20:99','Bon Electric Co., Ltd.','Bon Electric Co., Ltd.4-4 28, Mizudo-choAmagasaki, 661Hyogo Hyogo JapanJapan',1),('00:20:9A','The 3do Company','The 3do Company600 Galveston DriveRedwood City Ca 94063United States',1),('00:20:9B','Ersat Electronic Gmbh','Ersat Electronic GmbhHaarbergstr. 61D-99097 ErfurtGermanyGermany',1),('00:20:9C','Primary Access Corp.','Primary Access Corp.10080 Carroll Canyon RdSan Diego Ca 92131United States',1),('00:20:9D','Lippert Automationstechnik','Lippert AutomationstechnikD-68165 MannheimKrappmuehlstr. 34GermanyGermany',1),('00:20:9E','Browns Operating System Services, Ltd.','Browns Operating System Services, Ltd.St. Agnes House, Cresswell Pk,Blackheath, London Se3 9rdUnited Kingdom',1),('00:20:9F','Mercury Computer Systems, Inc.','Mercury Computer Systems, Inc.199 Riverneck RoadChelmsford Ma 01824United States',1),('00:20:A0','Oa Laboratory Co., Ltd.','Oa Laboratory Co., Ltd.228 Kamimachiya KamakuraKanagawa 247Japan',1),('00:20:A1','Dovatron','DovatronProducts Division1198 Boston AvenueLongmont Co 80501United States',1),('00:20:A2','Galcom Networking Ltd.','Galcom Networking Ltd.P.o. Box 1568Ramat Hasharon 47113Israel',1),('00:20:A3','Divicom Inc.','Divicom Inc.580 Cottonwood DriveMilpitas Ca 95035United States',1),('00:20:A4','Multipoint Networks','Multipoint Networks19 Davis DriveBelmont Ca 94002-3001United States',1),('00:20:A5','Api Engineering','Api Engineering2689 Poplarwood WaySan Jose Ca 95132United States',1),('00:20:A6','Proxim, Inc.','Proxim, Inc.295 North Bernardo AvenueMountain View Ca 94043United States',1),('00:20:A7','Pairgain Technologies, Inc.','Pairgain Technologies, Inc.14402 Franklin AvenueTustin Ca 92680-7013United States',1),('00:20:A8','Sast Technology Corp.','Sast Technology Corp.225 Old New Brunswick Rd.Suite #101Piscataway Nj 08854United States',1),('00:20:A9','White Horse Industrial','White Horse Industrial4f. No.16, Alley 56, Lane 181Sec.4, Chung Hsiao East Road TaipeiTaiwan, Republic Of China',1),('00:20:AA','Digimedia Vision Ltd.','Digimedia Vision Ltd.Crawley CourtWinchester, HampshireSo21 2qa United KingdomUnited Kingdom',1),('00:20:AB','Micro Industries Corp.','Micro Industries Corp.8399 Green Meadows Dr. N.Westerville Oh 43081United States',1),('00:20:AC','Interflex Datensysteme Gmbh','Interflex Datensysteme GmbhGrobwiesenstrase 24W-7201 DurchhausenWestgermanyGermany',1),('00:20:AD','Linq Systems','Linq SystemsP.o. Box 11040Tucson Az 85734United States',1),('00:20:AE','Ornet Data Communication Tech.','Ornet Data Communication Tech.P.o. Box 323Carmiel  20100IsraelIsrael',1),('00:20:AF','3com Corporation','3com Corporation5400 Bayfront PlazaSanta Clara Ca 95052United States',1),('00:20:B0','Gateway Devices, Inc.','Gateway Devices, Inc.2440 Stanwell DriveConcord Ca 94520United States',1),('00:20:B1','Comtech Research Inc.','Comtech Research Inc.24271 TahoeLaguna Niguel Ca 92656United States',1),('00:20:B2','Gkd Gesellschaft Fur Kommunikation Und Datentechnik','Gkd Gesellschaft Fur Kommunikation Und Datentechnik',1),('00:20:B3','Scltec Communications Systems','Scltec Communications Systems3 Apollo PlaceLane Cove N.s.w. 2066AustraliaAustralia',1),('00:20:B4','Terma Elektronik As','Terma Elektronik AsHovmarken 4,Dk-8520 LystrupDenmark',1),('00:20:B5','Yaskawa Electric Corporation','Yaskawa Electric Corporation2-1 Kurosaki-shiroishiYahatanishi-ku Kitakyushu-cityJapan',1),('00:20:B6','Agile Networks, Inc.','Agile Networks, Inc.200 Baker AvenueConcord Ma 01742United States',1),('00:20:B7','Namaqua Computerware','Namaqua ComputerwareP.o. Box 7155Stellen Bosch 7599South Africa',1),('00:20:B8','Prime Option, Inc.','Prime Option, Inc.2341 W. 205th Street #116Torrance Ca 90501United States',1),('00:20:B9','Metricom, Inc.','Metricom, Inc.980 University AvenueLos Gatos Ca 95030United States',1),('00:20:BA','Center For High Performance','Center For High PerformanceComputing Of WpiSuite #170 293 Boston Post Road W.Marlboro Ma 01752United States',1),('00:20:BB','Zax Corporation','Zax Corporation20-12 Ogikubo 5-chomeSuginami-ku Tokyo167 JapanJapan',1),('00:20:BC','Long Reach Networks Pty Ltd','Long Reach Networks Pty LtdUnit 3, 118-122 Bowden StMeadowbank Nsw 2114Australia',1),('00:20:BD','Niobrara R & D Corporation','Niobrara R & D CorporationPo Box 3418Joplin Mo 64803-3418United States',1),('00:20:BE','Lan Access Corp.','Lan Access Corp.2730 Monterey Street, Ste.#102Torrance Ca 90503United States',1),('00:20:BF','Aehr Test Systems','Aehr Test Systems1667 Plymouth StreetMountain View Ca 94043United States',1),('00:20:C0','Pulse Electronics, Inc.','Pulse Electronics, Inc.5706 Frederick AvenueRockville Md 20852United States',1),('00:20:C1','Saxa, Inc.','Saxa, Inc.2-3 Shimomeguro 2-chomeMeguro-ku,TokyoJapan',1),('00:20:C2','Texas Memory Systems, Inc.','Texas Memory Systems, Inc.11200 Westheimer Rd-ste#1000Houston Tx 77042United States',1),('00:20:C3','Counter Solutions Ltd.','Counter Solutions Ltd.263 Heage RoadRipley, Derbys De5 3ghUnited Kingdom',1),('00:20:C4','Inet,inc.','Inet,inc.801 E. Campbell-ste.#330Richardson Tx 75081United States',1),('00:20:C5','Eagle Technology','Eagle Technology2865 Zanker RoadSan Jose Ca 95134United States',1),('00:20:C6','Nectec','NectecRama Vi RoadRajthevi Bangkok  10400ThailandThailand',1),('00:20:C7','Akai Professional M.i. Corp.','Akai Professional M.i. Corp.1-3, Hiranuma 1-chome,Nishi-ku, Yokohama,220-0023Japan',1),('00:20:C8','Larscom Incorporated','Larscom Incorporated4600 Patrick Henry DriveSanta Clara Ca 95054United States',1),('00:20:C9','Victron Bv','Victron BvPob 31Nl 9700 Aa GroningenThe NetherlandsNetherlands',1),('00:20:CA','Digital Ocean','Digital Ocean11206 Thompson AvenueLenexa Ks 66219-2303United States',1),('00:20:CB','Pretec Electronics Corp.','Pretec Electronics Corp.39899 Balentine Dr.Suite #305Newark Ca 94560United States',1),('00:20:CC','Digital Services, Ltd.','Digital Services, Ltd.9 Wayte StreetCosham HampshireEngland Po6 3bsUnited Kingdom',1),('00:20:CD','Hybrid Networks, Inc.','Hybrid Networks, Inc.10201 Bubb RoadCupertino Ca 95014-4167United States',1),('00:20:CE','Logical Design Group, Inc.','Logical Design Group, Inc.6301 Chapel Hill RoadRaleigh Nc 27607United States',1),('00:20:CF','Test & Measurement Systems Inc','Test & Measurement Systems Inc2045 Sitka CourtLoveland Co 80538United States',1),('00:20:D0','Versalynx Corporation','Versalynx Corporation8950 Carley CircleSan Diego Ca 92126United States',1),('00:20:D1','Microcomputer Systems (m) Sdn.','Microcomputer Systems (m) Sdn.23-25, Jalan Jejaka TujuhTaman Maluri, Cheras 55100 Kuala LumpurMalaysiaMalaysia',1),('00:20:D2','Rad Data Communications, Ltd.','Rad Data Communications, Ltd.8 Hanechoshet StreetTel-aviv  69710IsraelIsrael',1),('00:20:D3','Ost (ouest Standard Telematiqu','Ost (ouest Standard TelematiquRue Du Bas VillageBp 158, Z.i. Sud-est 35515 Cesson-sevignFranceFrance',1),('00:20:D4','Cabletron - Zeittnet Inc.','Cabletron - Zeittnet Inc.35 Industrial WayP.o. Box 5005Rohester Nh 03866-5005United States',1),('00:20:D5','Vipa Gmbh','Vipa GmbhWetterkreuz 27D-91058 ErlangenGermany',1),('00:20:D6','Breezecom','BreezecomAtidim Technological Pk-bldg.3Tel-aviv  61131IsraelIsrael',1),('00:20:D7','Japan Minicomputer Systems Co., Ltd.','Japan Minicomputer Systems Co., Ltd.3-33-18 TakaidohigashiSuginami-kuTokyo 168Japan',1),('00:20:D8','Nortel Networks','Nortel Networks4401 Great America Pkwy.Santa Clara Ca 94588United States',1),('00:20:D9','Panasonic Technologies, Inc./mieco-us','Panasonic Technologies, Inc./mieco-us1703 N. Randall Rd.Elgin Il 60123United States',1),('00:20:DA','Alcatel North America Esd','Alcatel North America Esd26801 West Agoura RoadCalabasas Ca 91301United States',1),('00:20:DB','Xnet Technology, Inc.','Xnet Technology, Inc.426 S. Hillview DriveMilpitas Ca 95035United States',1),('00:20:DC','Densitron Taiwan Ltd.','Densitron Taiwan Ltd.Kyowa Nanabankan 5f1-11-5 Omori-kita Ota-ku,  Tokyo 143JapanJapan',1),('00:20:DD','Cybertec Pty Ltd','Cybertec Pty LtdUnit 11, 41 Higginbotham RoadGladesville Nsw 2111Australia',1),('00:20:DE','Japan Digital Laboraty Co.ltd','Japan Digital Laboraty Co.ltdJdl Kawasaki R & D Center10-1 Minami-kurokawa Asao-ku, Kawaskaki-Kanagawa-ken  215Japan',1),('00:20:DF','Kyosan Electric Mfg. Co., Ltd.','Kyosan Electric Mfg. Co., Ltd.2-29, Heian-cho, Tsurumi-kuYokohama, 230Japan',1),('00:20:E0','Actiontec Electronics, Inc.','Actiontec Electronics, Inc.760 North Mary Ave.Sunnyvale. Ca 94085United States',1),('00:20:E1','Alamar Electronics','Alamar Electronics489 Division StreetCampbell Ca 95008United States',1),('00:20:E2','Information Resource Engineering','Information Resource Engineering8029 Corporate DriveBaltimore Md 21236United States',1),('00:20:E3','Mcd Kencom Corporation','Mcd Kencom Corporation20950 Castle Rock RoadLaguna Beach Ca 92651-1115United States',1),('00:20:E4','Hsing Tech Enterprise Co., Ltd','Hsing Tech Enterprise Co., LtdNo. 2, Lane 128, Sec. 2Chung Shan N. Rd.Teipei,Taiwan, Republic Of China',1),('00:20:E5','Apex Data, Inc.','Apex Data, Inc.6624 Owens DrivePleasanton Ca 94588United States',1),('00:20:E6','Lidkoping Machine Tools Ab','Lidkoping Machine Tools AbBox 910531 19 LidkopingSweden',1),('00:20:E7','B&w Nuclear Service Company','B&w Nuclear Service CompanySpecial Products & Integ.svcs.155 Mill Ridge RoadLynchburg Va 24502United States',1),('00:20:E8','Datatrek Corporation','Datatrek Corporation4505 Wyland DriveElkhart In 46516United States',1),('00:20:E9','Dantel','DantelP.o. Box 550132991 North Argyle Ave.Fresno Ca 93727-1388United States',1),('00:20:EA','Efficient Networks, Inc.','Efficient Networks, Inc.4201 Spring Valley RoadSuite #1200Dallas Tx 75244-3666United States',1),('00:20:EB','Cincinnati Microwave, Inc.','Cincinnati Microwave, Inc.One Microwave PlazaCincinnati Oh 45249United States',1),('00:20:EC','Techware Systems Corp.','Techware Systems Corp.#100 - 12051 Horseshoe WayRichmond, B.c. CanadaV7a 4v4Canada',1),('00:20:ED','Giga-byte Technology Co., Ltd.','Giga-byte Technology Co., Ltd.365 CloverleafBaldwin Park Ca 91706United States',1),('00:20:EE','Gtech Corporation','Gtech Corporation55 Technology WayWest Greenwich Ri 02817United States',1),('00:20:EF','Usc Corporation','Usc Corporation6-4, Osaki 1-chomeShinagawa-ku Tokyo,141 JapanJapan',1),('00:20:F0','Universal Microelectronics Co.','Universal Microelectronics Co.3, 27th Rd., Taichung Ind.parkTaichunTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:20:F1','Altos India Limited','Altos India LimitedD-60, Oklhla IndustrialArea, Phase 1 New Delhi -110020IndiaIndia',1),('00:20:F2','Sun Microsystems, Inc.','Sun Microsystems, Inc.4200 Network CircleSanta Clara Ca 95054United States',1),('00:20:F3','Raynet Corporation','Raynet Corporation155 Constitution DriveMenlo Park Ca 94025United States',1),('00:20:F4','Spectrix Corporation','Spectrix Corporation106 Wilmot Road, Suite 250Deerfield Il 60015-5150United States',1),('00:20:F5','Pandatel Ag','Pandatel AgFasanenweg 25D-22145  HamburgGermanyGermany',1),('00:20:F6','Net Tek  And Karlnet, Inc.','Net Tek  And Karlnet, Inc.Little StreamsThe Abbotsbrook, Bourne End Bucks, Sl8 5United KingdomUnited Kingdom',1),('00:20:F7','Cyberdata','Cyberdata2700 Garden RoadMonterey Ca 93940United States',1),('00:20:F8','Carrera Computers, Inc.','Carrera Computers, Inc.23181 Verdugo Drive-ste.#105aLaguna Hills Ca 92653United States',1),('00:20:F9','Paralink Networks, Inc.','Paralink Networks, Inc.4f, No. 27, Sec.3, Pateh Rd.TaipeiTaiwan, Republic Of China',1),('00:20:FA','Gde Systems, Inc.','Gde Systems, Inc.P.o. Box 85468 - Bldg.#61San Diego Ca 92186-5468United States',1),('00:20:FB','Octel Communications Corp.','Octel Communications Corp.1001 Murphy Ranch RdMilpitas Ca 95035United States',1),('00:20:FC','Matrox','Matrox1055 St. Regis,Dorval, Quebec  H9p-2t4Canada',1),('00:20:FD','Itv Technologies, Inc.','Itv Technologies, Inc.6800 Owensmouth Ave.  #230Canoga Park Ca 91303United States',1),('00:20:FE','Topware Inc. / Grand Computer','Topware Inc. / Grand ComputerCorporationB1, No. 9, Lane 50 Section 3, Nan Kang RTaipei  R.o.c.Taiwan, Republic Of China',1),('00:20:FF','Symmetrical Technologies','Symmetrical Technologies500 Huntmar Park DriveHerndon Va 22070United States',1),('00:21:00','Gemtek Technology Co., Ltd.','Gemtek Technology Co., Ltd.No.1 Jen Ai Road, Hsinchu Industrial Park,Hukou, Hsinchu 303Taiwan, Republic Of China',1),('00:21:01','Aplicaciones Electronicas Quasar (aeq)','Aplicaciones Electronicas Quasar (aeq)C/rey Pastor 40Poligono Industrial ButarqueLeganes Madrid 28914Spain',1),('00:21:02','Updatelogic Inc.','Updatelogic Inc.2 Willow Street, Suite 101Southborough Ma 01745United States',1),('00:21:03','Ghi Electronics, Llc','Ghi Electronics, Llc35555 Garfield Rd.Suite 4bClinton Township Mi 48035United States',1),('00:21:04','Gigaset Communications Gmbh','Gigaset Communications GmbhFrankenstrasse 246395 BocholtGermany',1),('00:21:05','Alcatel-lucent','Alcatel-lucent701 E. Middlefield Rd.Mountain View Ca 94043United States',1),('00:21:06','Rim Testing Services','Rim Testing Services440 Phillip StreetWaterloo On N2l 5r9Canada',1),('00:21:07','Seowonintech Co Ltd.','Seowonintech Co Ltd.689-47 GeumjeongdongGunposi Kyoungkido 436-862Korea, Republic Of',1),('00:21:08','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:21:09','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:21:0A','Byd:sign Corporation','Byd:sign Corporation2-10-6 TsukijiBps Square 2fChuo-ku Tokyo 104-0045Japan',1),('00:21:0B','Gemini Traze Rfid Pvt. Ltd.','Gemini Traze Rfid Pvt. Ltd.1, Dr. Ranga RoadAlwarpetChennai Tamilnadu 600018India',1),('00:21:0C','Cymtec Systems, Inc.','Cymtec Systems, Inc.10845 Olive BouleveardSuite 306St Louis Mo 63141United States',1),('00:21:0D','Samsin Innotec','Samsin InnotecSariyundong Ilsandong-gu252-23Goyang Kyunggi 411530Korea, Republic Of',1),('00:21:0E','Orpak Systems L.t.d.','Orpak Systems L.t.d.31 Lechi StBnei - Brak  51114Israel',1),('00:21:0F','Cernium Corp','Cernium Corp1943 Isaac Newton SqSuite 200Reston Va 20190United States',1),('00:21:10','Clearbox Systems','Clearbox SystemsUnit 11, 12-14 Beaumont RoadMt Kuring-gai Nsw 2080Australia',1),('00:21:11','Uniphone Inc.','Uniphone Inc.795 Main StreetHalf Moon Bay Ca 94019United States',1),('00:21:12','Wiscom System Co.,ltd','Wiscom System Co.,ltd100 Jiangjun Road,jiangning,Nanjing  211100China',1),('00:21:13','Padtec S/a','Padtec S/aRoad Campinas Mogi-mirim Km 118,5Campinas So Paulo 13086-902Brazil',1),('00:21:14','Hylab Technology Inc.','Hylab Technology Inc.15f-2.,no.872,jhongjheng Rd.Jhonghe City, Taipei 235Taiwan, Republic Of China',1),('00:21:15','Phywe Systeme Gmbh & Co. Kg','Phywe Systeme Gmbh & Co. KgRobert-bosch-breite 10Goettingen Niedersachsen 37079Germany',1),('00:21:16','Transcon Electronic Systems, Spol. S R. O.','Transcon Electronic Systems, Spol. S R. O.Kvapilova 2133Frydek-mistek  73802Czech Republic',1),('00:21:17','Tellord','TellordGurogu Gurodong 170-5 Woolim E-biz Center 709Seoul  152-050Korea, Republic Of',1),('00:21:18','Athena Tech, Inc.','Athena Tech, Inc.3721 Macintosh DrVint Hill Tech ParkWarrenton Va 20187United States',1),('00:21:19','Samsung Electro-mechanics','Samsung Electro-mechanics314, Metan 3 DongSuwon Kyung-gi Do 443-743Korea, Republic Of',1),('00:21:1A','Lintech Corporation','Lintech CorporationKrasnokazarmennaya St., 12Moscow  111250Russian Federation',1),('00:21:1B','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:1C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:1D','Dataline Ab','Dataline AbKatrinedalsgatan 53Bors  S-50451Sweden',1),('00:21:1E','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:21:1F','Shinsung Deltatech Co.,ltd.','Shinsung Deltatech Co.,ltd.44-10Ungnam-dongChangwon-city Kyungnam-do 641-290Korea, Republic Of',1),('00:21:20','Sequel Technologies, Llc','Sequel Technologies, Llc2958 Cleveland Ave. NRoseville Mn 55113United States',1),('00:21:21','Vrmagic Gmbh','Vrmagic GmbhAugustaanlage 32Mannheim Bw 68165Germany',1),('00:21:22','Chip-pro Ltd.','Chip-pro Ltd.5f.-4, No.63, Siwei Rd., North District,Hsinchu  300Taiwan, Republic Of China',1),('00:21:23','Aerosat Avionics','Aerosat Avionics62 State Rd.101a Suite 2bAmherst Nh 03031United States',1),('00:21:24','Optos Plc','Optos PlcQueensferry HouseCarnegie Business CampusDunfermline Fife Ky11 8grUnited Kingdom',1),('00:21:25','Kuk Je Tong Shin Co.,ltd','Kuk Je Tong Shin Co.,ltd476-3Jakjeon-dong,Incheon Kwangyouk-si 407-060Korea, Republic Of',1),('00:21:26','Shenzhen Torch Equipment Co., Ltd.','Shenzhen Torch Equipment Co., Ltd.Floor 5, Block 3, Liming Industrial District, Zhongshanyuan Road, Nanshan,Shenzhen Guangdong 518052China',1),('00:21:27','Tp-link Technology Co., Ltd.','Tp-link Technology Co., Ltd.South Building, No.5 Keyuan Road, Central Zone,Science & Technology Park,nanshanShenzhen Guangdong 518000China',1),('00:21:28','Sun Microsystems Inc','Sun Microsystems Inc4150 Network CircleSanta Clara Ca 95054United States',1),('00:21:29','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92617United States',1),('00:21:2A','Audiovox Corporation','Audiovox Corporation150 Marcus BlvdHauppauge Ny 11788United States',1),('00:21:2B','Msa Auer','Msa AuerThiemannstr. 1Berlin  12059Germany',1),('00:21:2C','Semindia System Private Limited','Semindia System Private LimitedNo. 1106/9, A.m Industrial Estate, Garvebhavipalya7th Mile, Hosur RoadBangalore Karnataka 560 068India',1),('00:21:2D','Scimolex Corporation','Scimolex Corporation2430, Saijou, Showa-choNakakoma-gun, Yamanashi  409-3866Japan',1),('00:21:2E','Dresden-elektronik','Dresden-elektronikGlasewaldtstrae 22Dresden Saxony D-01277Germany',1),('00:21:2F','Phoebe Micro Inc.','Phoebe Micro Inc.47606 Kato RdFremont Ca 94538United States',1),('00:21:30','Keico Hightech Inc.','Keico Hightech Inc.Ace Twin Tower I, 12th Fl.212-1, Guro-dong, Guro-guSeoul  152-050Korea, Republic Of',1),('00:21:31','Blynke Inc.','Blynke Inc.133 Richmond St. WestSuite 600Toronto Ontario M5h 2l3Canada',1),('00:21:32','Masterclock, Inc.','Masterclock, Inc.2484 West Clay St.St. Charles Mo 63301United States',1),('00:21:33','Building B, Inc','Building B, Inc1000 Nw 65th Street, Suite 300Ft. Lauderdale Fl 33309United States',1),('00:21:34','Brandywine Communications','Brandywine Communications1153 Warner AveTustin Ca 92780United States',1),('00:21:35','Alcatel-lucent','Alcatel-lucentRamirez De Prado 5Madrid  28045Spain',1),('00:21:36','Motorola Mobile Devices Business (mdb)','Motorola Mobile Devices Business (mdb)600 N. Us Highway 45Libertyville Il 60048United States',1),('00:21:37','Bay Controls, Llc','Bay Controls, Llc6528 Weatherfield CtMaumee Oh 43537United States',1),('00:21:38','Cepheid','Cepheid904 Caribbean DriveSunnyvale Ca 94089United States',1),('00:21:39','Escherlogic Inc.','Escherlogic Inc.1481 Rosebank Rd.Pickering Ontario L1v 1p3Canada',1),('00:21:3A','Winchester Systems Inc.','Winchester Systems Inc.101 Billerica AvenueBldg 5 Suite 101Billerica, Ma 01862United States',1),('00:21:3B','Berkshire Products, Inc','Berkshire Products, IncPo Box 2819Cumming Ga 30028United States',1),('00:21:3C','Aliphcom','Aliphcom150 Executive Park BlvdSuite 4550San Francisco Ca 94134United States',1),('00:21:3D','Cermetek Microelectronics, Inc.','Cermetek Microelectronics, Inc.374 Turquoise StreetMilpitas Ca 95035United States',1),('00:21:3E','Tomtom','TomtomOosterdoksstraat 114Amsterdam North Holland 1011 DkNetherlands',1),('00:21:3F','A-team Technology Ltd.','A-team Technology Ltd.Rm. 1608, 16/f., Metropole Square,2 On Yiu St., Shatin,New Territories,Hong Kong',1),('00:21:40','En Technologies Inc.','En Technologies Inc.Geumbok Bldg. 9f, Band-yi-dong 45-2, Songpa-guSeoul  138-828Korea, Republic Of',1),('00:21:41','Radlive','Radlive4 Hanechoshet St.Tel Aviv  69710Israel',1),('00:21:42','Abs Control Systems Doo','Abs Control Systems DooBulevar Zorana Djindjica 8aBelgrade Serbia 11070Yugoslavia',1),('00:21:43','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:21:44','Ss Telecoms','Ss Telecoms23 Botha AvenueLyttelton ManorCenturion Gauteng 0140South Africa',1),('00:21:45','Semptian Technologies Ltd.','Semptian Technologies Ltd.No. 809,  Tower B, Shi Ji Ke MaoNo. 66 Rd. Zhongguan Cun DongBeijing  100190China',1),('00:21:46','Sci Technology','Sci TechnologyPob 1000Huntsville Al 35807United States',1),('00:21:47','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:21:48','Kaco Solar Korea','Kaco Solar KoreaChung-won-ku Sang-dea-won-dong 333-1Songnam Kyung-kido 462-806Korea, Republic Of',1),('00:21:49','China Daheng Group ,inc.','China Daheng Group ,inc.12f Daheng Science & Technology Tower ,no.3 Suzhou Str.Beijing  100080China',1),('00:21:4A','Pixel Velocity, Inc','Pixel Velocity, Inc3917 Research Park Dr.Suite B7Ann Arbor Mi 48108United States',1),('00:21:4B','Shenzhen Hamp Science & Technology Co.,ltd','Shenzhen Hamp Science & Technology Co.,ltdNo.302-303,3 Floor,district A,tcl Tower,gaoxin Nan Yi Road,nanshan DistrictShenzhen Guangdong 518057China',1),('00:21:4C','Samsung Electronics Co., Ltd.','Samsung Electronics Co., Ltd.416, Metan-3dong,Youngtong-guSuwon Kyungki-do 442-742Korea, Republic Of',1),('00:21:4D','Guangzhou Skytone Transmission Technology Com. Ltd.','Guangzhou Skytone Transmission Technology Com. Ltd.3/f West, Block 4, HuangzhouIndustrial Park, Chebei Road.Guangzhou Guangdong 510660China',1),('00:21:4E','Gs Yuasa Power Supply Ltd.','Gs Yuasa Power Supply Ltd.1, Inobanba-cho, Nishinosho, Kisshoin, Minami-ku,Kyoto  601-8520Japan',1),('00:21:4F','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, OkinouchiSoma City Fukushima 976-8501Japan',1),('00:21:50','Eyeview Electronics','Eyeview Electronics3 Floor, No. 86, Kung Yeh 32 RoadTaichung  407Taiwan, Republic Of China',1),('00:21:51','Millinet Co., Ltd.','Millinet Co., Ltd.2f, West Building, It Venture Tower, 78, Garakbon-dongSongpa-gu Seoul 138-803Korea, Republic Of',1),('00:21:52','General Satellite Trading Limited','General Satellite Trading Limited21 Aylmer Parade, Aylmer RoadLondon  N2 0atUnited Kingdom',1),('00:21:53','Seamicro Inc.','Seamicro Inc.3250 Jay StreetSanta Clara Ca 95054United States',1),('00:21:54','D-tacq Solutions Ltd','D-tacq Solutions LtdJames Watt BuildingSetpEast Kilbride Lanarkshire G75 0qdUnited Kingdom',1),('00:21:55','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:56','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:57','National Datacast, Inc.','National Datacast, Inc.2100 Crystal Drive, Suite 750Arlington Va 22202United States',1),('00:21:58','Style Flying Technology Co.','Style Flying Technology Co.22/f,cyber Tower B,no.2 Zhong Guan Cun South Street,haidian District,Beijing  100086China',1),('00:21:59','Juniper Networks','Juniper Networks1194 N. Mathilda AveSunnyvale Ca 94089United States',1),('00:21:5A','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040802Houston Tx 77070United States',1),('00:21:5B','Inotive','InotiveDe Pinckart 54Nuenen Noord Brabant 5674 CcNetherlands',1),('00:21:5C','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:21:5D','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:21:5E','Ibm','Ibm3039 Cornwallis RdRtp Nc 27709United States',1),('00:21:5F','Ihse Gmbh','Ihse GmbhMaybachstrasse 11Oberteuringen Baden-wrttemberg 88094Germany',1),('00:21:60','Hidea Solutions Co. Ltd.','Hidea Solutions Co. Ltd.4f, Do&can House Dldg., #656-1683, Seongsu 1-ga 2-dong, Seongdong-guSeoul  656-1683Korea, Republic Of',1),('00:21:61','Yournet Inc.','Yournet Inc.Kt R&d Center17 Umyeon-dong, Seocho-guSeoul  137-792Korea, Republic Of',1),('00:21:62','Nortel','Nortel1830 Matheson BoulevardSuite 1Mississauga Ontario L4w 0b3Canada',1),('00:21:63','Askey Computer Corp','Askey Computer Corp10f,no.119.chienkang Rd,chung-ho,Taipei 235Taiwan, Republic Of China',1),('00:21:64','Special Design Bureau For Seismic Instrumentation','Special Design Bureau For Seismic Instrumentation129, Krainyaya Str.Saratov Saratov Region 410019Russian Federation',1),('00:21:65','Presstek Inc.','Presstek Inc.55 Executive DriveHudson New Hampshire 03051United States',1),('00:21:66','Novatel Inc.','Novatel Inc.1120 - 68 Ave NeCalgary Alberta T2e 8s5Canada',1),('00:21:67','Hwa Jin T&i Corp.','Hwa Jin T&i Corp.5f., Sehwa Bldg 164-24, Poi-dong, Gangnam-gu, Seoul, KoreaGangnam-gu Seoul 135-960Korea, Republic Of',1),('00:21:68','Iveia, Llc','Iveia, Llc51 Franklin StreetSuite 301Annapolis Md 21401United States',1),('00:21:69','Prologix, Llc.','Prologix, Llc.17217 Ne 133rd PlaceRedmond Washington 98052-2153United States',1),('00:21:6A','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:21:6B','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:21:6C','Odva','Odva4220 Varsity DriveSuite AAnn Arbor Mi 48108-5006United States',1),('00:21:6D','Soltech Co., Ltd.','Soltech Co., Ltd.#30-3,3fWonhyoro2-kaYongsan Ku Seoul 140837Korea, Republic Of',1),('00:21:6E','Function Ati (huizhou) Telecommunications Co., Ltd.','Function Ati (huizhou) Telecommunications Co., Ltd.No. 8, Huitai Road, Huitai Industrial ZoneHuizhou City Guangdong Province 516006China',1),('00:21:6F','Symcom, Inc.','Symcom, Inc.2880 North Plaza DriveRapid City Sd 57702United States',1),('00:21:70','Dell Inc','Dell IncOne Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:21:71','Wesung Tnc Co., Ltd.','Wesung Tnc Co., Ltd.102-1409, Bucheon Chunui Technopark 1st,200-1, Chunui-dong, Wonmi-guBucheon-city, Gyeongggi-do 420-857Korea, Republic Of',1),('00:21:72','Seoultek Valley','Seoultek ValleyBang-i Dong 51-5, SongpaSeoul  138-050Korea, Republic Of',1),('00:21:73','Ion Torrent Systems, Inc.','Ion Torrent Systems, Inc.37 Soundview RdSuite  2Guilford Ct 06437United States',1),('00:21:74','Avalan Wireless','Avalan Wireless958 San Leandro Ave, Suite 900Mountain View Ca 94043United States',1),('00:21:75','Pacific Satellite International Ltd.','Pacific Satellite International Ltd.20/f Tai Tung Building,8 Fleming Road,Wanchai  100000Hong Kong',1),('00:21:76','Ymax Telecom Ltd.','Ymax Telecom Ltd.11 Moshe Levi Str.Umi BuildingRishon Le Zion  75658Israel',1),('00:21:77','W. L. Gore & Associates','W. L. Gore & Associates402 Vieves WayElkton Md 21921United States',1),('00:21:78','Matuschek Messtechnik Gmbh','Matuschek Messtechnik GmbhWerner Heisenberg Strae 14Alsdorf Nrw 52477Germany',1),('00:21:79','Iogear, Inc.','Iogear, Inc.23 HubbleIrvine Ca 92618United States',1),('00:21:7A','Sejin Electron, Inc.','Sejin Electron, Inc.Sj Technoville4th Floor Room 412, 60-19 Kasan-dong, Keumchon-kuSeoul  153-801Korea, Republic Of',1),('00:21:7B','Bastec Ab','Bastec AbHstvgen 4aMalm M 212 35Sweden',1),('00:21:7C','2wire','2wire1764 Automation ParkwaySan Jose Ca 95131United States',1),('00:21:7D','Pyxis S.r.l.','Pyxis S.r.l.C/o Dip. Informatica E Sistemistica - University Of PaviaVia Ferrata 1Pavia  27100Italy',1),('00:21:7E','Telit Communication S.p.a','Telit Communication S.p.aVia Stazione Di Prosecco 5bSgonico Trieste 34010Italy',1),('00:21:7F','Intraco Technology Pte Ltd','Intraco Technology Pte Ltd750e Chai Chee Road #05-01Singapore  4690005Singapore',1),('00:21:80','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:21:81','Si2 Microsystems Limited','Si2 Microsystems LimitedNo 84, Sy No 150, Epip, Whitefield Industrial AreaBangalore Karnataka 560066India',1),('00:21:82','Sandlinks Systems, Ltd.','Sandlinks Systems, Ltd.P.o.box 4629Petah-tiqwa Israel 49277Israel',1),('00:21:83','Vatech Hydro','Vatech HydroWienerbergstrasse 41Object DVienna  A-1120Austria',1),('00:21:84','Powersoft Srl','Powersoft SrlVia Enrico Conti, 5Scandicci Fi 50018Italy',1),('00:21:85','Micro-star Intl Co.,ltd.','Micro-star Intl Co.,ltd.No.69,li-de St,jung-ho CityTaipei Hsien  235Taiwan, Republic Of China',1),('00:21:86','Usi','Usi141, Lane351, Sec.1, Taiping Road, TsaotuenNantou  54261Taiwan, Republic Of China',1),('00:21:87','Imacs Gmbh','Imacs GmbhMittelfeldstrasse 25Kornwestheim Germany D-70806Germany',1),('00:21:88','Data Domain, Inc.','Data Domain, Inc.2421 Mission College BlvdSanta Clara Ca 95050United States',1),('00:21:89','Apptech, Inc.','Apptech, Inc.363 Greyhound PassCarmel Indiana 46032United States',1),('00:21:8A','Electronic Design And Manufacturing Company','Electronic Design And Manufacturing Company31 Millrace DrLynchburg Va 24502United States',1),('00:21:8B','Wescon Technology, Inc.','Wescon Technology, Inc.4655-170 Old Ironsides DriveSanta Clara California 95054United States',1),('00:21:8C','Topcontrol Gmbh','Topcontrol GmbhEnzenbergweg 24/aTerlan (bz)  39018Italy',1),('00:21:8D','Ap Router Ind. Eletronica Ltda','Ap Router Ind. Eletronica LtdaAv. Lomanto Junior, 1000Bairro PontalIlheus Bahia 45654-000Brazil',1),('00:21:8E','Mekics Co., Ltd.','Mekics Co., Ltd.Industrial Zone 861-10, Taegye-dongChunchon Kangwon 200-944Korea, Republic Of',1),('00:21:8F','Avantgarde Acoustic Lautsprechersysteme Gmbh','Avantgarde Acoustic Lautsprechersysteme GmbhNibelungenstr. 349Lautertal - Reichenbach Hessen D-64686Germany',1),('00:21:90','Goliath Solutions','Goliath Solutions3082 Sterling CircleBoulder Colorado 80301United States',1),('00:21:91','D-link Corporation','D-link CorporationNo.289, Sinhu 3rd Rd.Neihu District Taipei City 114Taiwan, Republic Of China',1),('00:21:92','Baoding Galaxy Electronic Technology  Co.,ltd','Baoding Galaxy Electronic Technology  Co.,ltdNo.91 Fengfan Rd.,gaokai District,baoding City,hebei Prov.china 071051Baoding City Hebei Prov. 071051China',1),('00:21:93','Videofon Mv','Videofon Mv6 Blackoak MewsNewtown Pa 18940United States',1),('00:21:94','Ping Communication','Ping CommunicationSandakerveien 24cOslo  0473Norway',1),('00:21:95','Gwd Media Limited','Gwd Media Limited10 Leeds RoadSheffield South Yorkshire S9 3tyUnited Kingdom',1),('00:21:96','Telsey  S.p.a.','Telsey  S.p.a.Viale Dellindustria, 1Quinto Ditreviso 31055Italy',1),('00:21:97','Elitegroup Computer System','Elitegroup Computer SystemNo.239, Sec. 2, Ti Ding Blvd.,Taipei  11493Taiwan, Republic Of China',1),('00:21:98','Thai Radio Co, Ltd','Thai Radio Co, LtdHi-tech Industrial Estate787 M00 1 Baanlane Sub District Bang Pa-in DistrictAyutthaya  13160Thailand',1),('00:21:99','Vacon Plc','Vacon PlcP.o.box 25Vaasa  65380Finland',1),('00:21:9A','Cambridge Visual Networks Ltd','Cambridge Visual Networks Ltd61 Selwyn RoadCambridge Cambridgeshire Cb3 9eaUnited Kingdom',1),('00:21:9B','Dell Inc','Dell IncOne Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:21:9C','Honeywld Technology Corp.','Honeywld Technology Corp.No.40,hsueh-fu Rd.Hsinchu  300Taiwan, Republic Of China',1),('00:21:9D','Adesys Bv','Adesys BvMolenweer 4Wateringen Zuid Holland 2291 NrNetherlands',1),('00:21:9E','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:21:9F','Satel Oy','Satel OyMeriniitynkatu 17Salo Lansi-suomen Laani 24100Finland',1),('00:21:A0','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:A1','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:A2','Eke-electronics Ltd.','Eke-electronics Ltd.Piispanportti 7Espoo  02240Finland',1),('00:21:A3','Micromint','Micromint111 Commerce StLake Mary Fl 32746United States',1),('00:21:A4','Dbii Networks','Dbii Networks2217 Via BlancaOceanside Ca 92054United States',1),('00:21:A5','Erlphase Power Technologies Ltd.','Erlphase Power Technologies Ltd.74 Scurfield Blvd.Winnipeg Manitoba R3y 1g4Canada',1),('00:21:A6','Videotec Spa','Videotec SpaVia Friuli,6Schio Vicenza 36015Italy',1),('00:21:A7','Hantle System Co., Ltd.','Hantle System Co., Ltd.481-10 Byucksan Digital Vally Ii, Rm 1511Gasan-dong, Gumchon-guSeoul City Seoul 153-783Korea, Republic Of',1),('00:21:A8','Telephonics Corporation','Telephonics Corporation815 Broad Hollow RoadFarmingdale New York 11790United States',1),('00:21:A9','Mobilink Telecom Co.,ltd','Mobilink Telecom Co.,ltd292-3 Sindang-ri, Sandong-myunGumi Gyeongbuk 730-853Korea, Republic Of',1),('00:21:AA','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:21:AB','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790 VDenmark',1);
INSERT INTO `mac_track_oui_database` VALUES ('00:21:AC','Infrared Integrated Systems Ltd','Infrared Integrated Systems LtdPark Circle, Tithe Barn WaySwan ValleyNorthampton Northants Nn4 9bgUnited Kingdom',1),('00:21:AD','Nordic Id Oy','Nordic Id OyMyllyojankatu 2aSalo  Fin-24100Finland',1),('00:21:AE','Alcatel-lucent France - Wtd','Alcatel-lucent France - Wtd7-9, Avenue Morane SaulnierBp 57Velizy  78141France',1),('00:21:AF','Radio Frequency Systems','Radio Frequency SystemsKabelkamp 20Hannover  30179Germany',1),('00:21:B0','Tyco Telecommunications','Tyco Telecommunications1011 Pawtucket BlvdLowell Massachusetts 01853United States',1),('00:21:B1','Digital Solutions Ltd','Digital Solutions LtdTsarigradsko Shose 7km BlvdHi Tech Park Izot,Sofia Sofia 1784Bulgaria',1),('00:21:B2','Fiberblaze A/s','Fiberblaze A/sKildevangsvej 9GoederupRoskilde  4000Denmark',1),('00:21:B3','Ross Controls','Ross ControlsOne Ross WayLavonia Ga 30553United States',1),('00:21:B4','Apro Media Co., Ltd','Apro Media Co., Ltd#13-5,dodang-dong,wonmi-gu,Bucheon-city Kyunggi-do 420-801Korea, Republic Of',1),('00:21:B5','Vyro Games Limited','Vyro Games Limited14 St. Stephens GreenDublin  2Ireland',1),('00:21:B6','Triacta Power Technologies Inc.','Triacta Power Technologies Inc.Box 582, 7 Mill StreetAlmonte Ontario K0a 1a0Canada',1),('00:21:B7','Lexmark International Inc.','Lexmark International Inc.740 West New Circle RoadLexington Ky 40550United States',1),('00:21:B8','Inphi Corporation','Inphi Corporation2393 Townsgate Rd., Suite 101Westlake Village Ca 91361United States',1),('00:21:B9','Universal Devices Inc.','Universal Devices Inc.5353 Yarmouth Ave. #209Encino Ca 91316United States',1),('00:21:BA','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:21:BB','Riken Keiki Co., Ltd.','Riken Keiki Co., Ltd.2-7-6 AzusawaItabashi-ku Tokyo 174-8744Japan',1),('00:21:BC','Zala Computer','Zala ComputerEl BouniAnnaba  23000Algeria',1),('00:21:BD','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:21:BE','Cisco, Service Provider Video Technology Group','Cisco, Service Provider Video Technology Group5030 Sugarloaf ParkwayMail Stop 2.t.603Lawrenceville Ga 30044United States',1),('00:21:BF','Hitachi High-tech Control Systems Corporation','Hitachi High-tech Control Systems Corporation500,miyu-choMito-shi Ibaraki-ken 319-0316Japan',1),('00:21:C0','Mobile Appliance, Inc.','Mobile Appliance, Inc.#819 Kranz Techno,Sangdaewon-1 Dong, Jungwon-guSeong Nam Gyeonggi-do 462-729Korea, Republic Of',1),('00:21:C1','Abb Oy / Distribution Automation','Abb Oy / Distribution AutomationPo Box 699Vaasa  Fi-65101Finland',1),('00:21:C2','Gl Communications Inc','Gl Communications Inc818 West Diamond AveThird FloorGaithersburg Md 20878United States',1),('00:21:C3','Cornell Communications, Inc.','Cornell Communications, Inc.7915 N. 81st StreetMilwaukee Wisconsin 53223United States',1),('00:21:C4','Consilium Ab','Consilium AbVstra Finnbodavgen 2-4Nacka Stockholm 13131Sweden',1),('00:21:C5','3dsp Corp','3dsp Corp16271 Laguna Canyon RoadSuite 200Irvine, Ca 92618United States',1),('00:21:C6','Csj Global, Inc.','Csj Global, Inc.9th Fl. Samwhan Bldg. Annex, 17-26 Yeouido-dong,Youngdeungpo-guSeoul  150-874Korea, Republic Of',1),('00:21:C7','Russound','Russound5 Forbes RoadNewmarket Nh 03857United States',1),('00:21:C8','Lohuis Networks','Lohuis Networks2681 Tv MonsterVotlaan 408 Votlaan 31Netherlands',1),('00:21:C9','Wavecom Asia Pacific Limited','Wavecom Asia Pacific Limited201 Bio-informatics Centre,  No.2 Science Park West AveHong Kong Science Park, Shatin, NtHong Kong',1),('00:21:CA','Art System Co., Ltd.','Art System Co., Ltd.Mobile Techno Bldg Room 910573-13, Bokhyeon-dong, Buk-guDae-gu  702-020Korea, Republic Of',1),('00:21:CB','Sms Tecnologia Eletronica Ltda','Sms Tecnologia Eletronica LtdaAv. Pirmide, 661Diadema So Paulo 09970330Brazil',1),('00:21:CC','Flextronics International','Flextronics International2241 Lundy Ave.San Jose Ca 95131United States',1),('00:21:CD','Livetv','Livetv1333 Gateway Drive, Suite 1007Melbourne Florida 32901United States',1),('00:21:CE','Ntc-metrotek','Ntc-metrotek9, Nevzorovoy StreetSaint-petersburg  192148Russian Federation',1),('00:21:CF','The Crypto Group','The Crypto GroupZugerstrasse 42Steinhausen Zug 6312Switzerland',1),('00:21:D0','Global Display Solutions Spa','Global Display Solutions SpaVia Tezze, 20/aVat It02940180249Cornedo Vicentino Vicenza 36073Italy',1),('00:21:D1','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:21:D2','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:21:D3','Bocom Security(asia Pacific) Limited','Bocom Security(asia Pacific) LimitedFlr.3,no.29,#69 Guiqing RdChinaShanghai  200233China',1),('00:21:D4','Vollmer Werke Gmbh','Vollmer Werke GmbhMaschinenfabrikBiberach Baden-wrttemberg 88400Germany',1),('00:21:D5','X2e Gmbh','X2e GmbhRaiffeisenstrasse 9Winden Rheinland-pfalz 76872Germany',1),('00:21:D6','Lxi Consortium','Lxi ConsortiumP.o. Box 1016Niwot Co 80544-1016United States',1),('00:21:D7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:D8','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:21:D9','Sekonic Corporation','Sekonic Corporation7-24-14Oizumi-gakuen-choNerima-ku Tokyo 178-8686Japan',1),('00:21:DA','Automation Products Group Inc.','Automation Products Group Inc.1025 West 1700 NorthLogan Utah 84321United States',1),('00:21:DB','Santachi Video Technology (shenzhen) Co., Ltd.','Santachi Video Technology (shenzhen) Co., Ltd.Santachi Building,#14 Kaifeng Road,meilin,Shenzhen Guangdong 518049China',1),('00:21:DC','Tecnoalarm S.r.l.','Tecnoalarm S.r.l.Via CirieSan Mauro Torinese Torino 10099Italy',1),('00:21:DD','Northstar Systems Corp','Northstar Systems Corp5f, No.200 Gang Qian RdTaipei  114Taiwan, Republic Of China',1),('00:21:DE','Firepro Wireless','Firepro Wireless27, Zamrudpur Community Center,Kailash ColonyNew Delhi Haryana 110020India',1),('00:21:DF','Martin Christ Gmbh','Martin Christ GmbhAn Der Unteren Soese 50Osterode Niedersachsen 37520Germany',1),('00:21:E0','Commagility Ltd','Commagility LtdInnovation CentreEpinal WayLoughborough Leics Le11 3ehUnited Kingdom',1),('00:21:E1','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75082-4399United States',1),('00:21:E2','Creative Electronic Gmbh','Creative Electronic GmbhLorcher Strasse 52Birenbach Baden-wrttemberg 73102Germany',1),('00:21:E3','Serialtek Llc','Serialtek Llc1630 Oakland RdSuite A117San Jose Ca 95131United States',1),('00:21:E4','I-win','I-win27 Rue Des EcondeauxEpinay Sur Seine Seine Saint Denis 93800France',1),('00:21:E5','Display Solution Ag','Display Solution AgTalhofstr. 32aGilching D 82205Germany',1),('00:21:E6','Starlight Video Limited','Starlight Video Limited5/f., Shing Dao Industrial Building,232 Aberdeen Main Road,Hong Kong',1),('00:21:E7','Informatics Services Corporation','Informatics Services Corporation140, Negin Bldg.,Mirdamad BlvdTehran  1549534511Iran, Islamic Republic Of',1),('00:21:E8','Murata Manufacturing Co., Ltd.','Murata Manufacturing Co., Ltd.10-1, Higashikotari 1-chomeNagaokakyo-shi Kyoto 617-8555Japan',1),('00:21:E9','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:21:EA','Bystronic Laser Ag','Bystronic Laser AgIndustriestr. 213362 NiedernzSwitzerland',1),('00:21:EB','Esp Systems, Llc','Esp Systems, Llc1422 East Fourth StreetCharlotte Nc 28204United States',1),('00:21:EC','Solutronic Gmbh','Solutronic GmbhNuertinger Strasse 83Grossbettlingen  72663Germany',1),('00:21:ED','Telegesis','Telegesis84 Station RoadMarlow Bucks Sl7 1nxUnited Kingdom',1),('00:21:EE','Full Spectrum Inc.','Full Spectrum Inc.1149 Chestnut Street, Suite 100Menlo Park California 94025United States',1),('00:21:EF','Kapsys','Kapsys790 Av Du Docteur Maurice DonatLe Marco Polo A106250 Mougins Sophia AntipolisFrance',1),('00:21:F0','Ew3 Technologies Llc','Ew3 Technologies Llc20 Homestead Village DriveWarwick Ny 10990United States',1),('00:21:F1','Tutus Data Ab','Tutus Data AbSvardvagen 11Danderyd Stockholm 18233Sweden',1),('00:21:F2','Easy3call Technology Limited','Easy3call Technology LimitedRoom 1903-6, 19/f., Hing Yip Commercial Centre272-284 Des Voeux Road CentralHong Kong  999077China',1),('00:21:F3','M31 Spa','M31 SpaVia Tommaseo 77Padova Pd 35131Italy',1),('00:21:F4','Inrange Systems, Inc','Inrange Systems, Inc220 Lakemont Park BlvdAltoona Pa 16602United States',1),('00:21:F5','Western Engravers Supply, Inc.','Western Engravers Supply, Inc.17621 N Black Canyon HighwayPhoenix Az 85023United States',1),('00:21:F6','Virtual Iron Software','Virtual Iron Software900 Chelmsford StreetLowell Ma 01851United States',1),('00:21:F7','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville Ca 95747United States',1),('00:21:F8','Enseo, Inc.','Enseo, Inc.401 International ParkwaySuite 100Richardson Tx 75081United States',1),('00:21:F9','Wirecom Technologies','Wirecom Technologies135, Rue Jacques CharlesOlivet Loiret 45166France',1),('00:21:FA','A4sp Technologies Ltd.','A4sp Technologies Ltd.Keilaranta 19 DEspoo Uusimaa 02150Finland',1),('00:21:FB','Lg Electronics','Lg Electronics60-39,kasan-dong,kumchon-ku,Seoul  153-801Korea, Republic Of',1),('00:21:FC','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:21:FD','Dsta S.l.','Dsta S.l.Majada 4Tres Cantos Madrid 28760Spain',1),('00:21:FE','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:21:FF','Cyfrowy Polsat Sa','Cyfrowy Polsat Saubinowa 4aWarsaw Mazowieckie 03-878Poland',1),('00:22:00','Blade Network Technology','Blade Network Technology2350 Mission College Blvd, Suite 600Santa Clara Ca 95054United States',1),('00:22:01','Aksys Networks Inc','Aksys Networks Inc428, 3553 - 31 Street NwCalgary  T2l 2k7Canada',1),('00:22:02','Excito Elektronik I Skne Ab','Excito Elektronik I Skne AbBox 126Lddekpinge  246 22Sweden',1),('00:22:03','Glensound Electronics Ltd','Glensound Electronics Ltd1 - 6 Brooks PlaceMaidstone Kent Me17 1unUnited Kingdom',1),('00:22:04','Koratek','KoratekGeumjeong-dongGunpo-si Gyeonggi-do 435-825Korea, Republic Of',1),('00:22:05','Welink Solutions, Inc.','Welink Solutions, Inc.3f, No. 88, Sec. 1, Nei-hu Rd.Taipei  114Taiwan, Republic Of China',1),('00:22:06','Cyberdyne Inc.','Cyberdyne Inc.504@c49-2Tsukuba-shi Ibaraki-ken 305-0817Japan',1),('00:22:07','Inteno Broadband Technology Ab','Inteno Broadband Technology AbDrivhjulsvgen 22Stockholm Se 12630Sweden',1),('00:22:08','Certicom Corp','Certicom Corp5520 Explorer Drive, 4th FloorMississauga On L4w 5l1Canada',1),('00:22:09','Omron Healthcare Co., Ltd','Omron Healthcare Co., Ltd24 Yamanoshita-cho YamanouchiUkyokuKyoto  6150084Japan',1),('00:22:0A','Rearden Labs','Rearden Labs555 University AvenuePalo Alto California 94301United States',1),('00:22:0B','National Source Coding Center','National Source Coding CenterSuite 701,power Creative A,no.1Shangdi East Road,haidian DistrictBeijing  100085China',1),('00:22:0C','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:0D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:0E','Indigo Security Co., Ltd.','Indigo Security Co., Ltd.2nd Floor, 277-169 Sungsoo2-ga, Sungdong-guSeoul  133-832Korea, Republic Of',1),('00:22:0F','Moca (multimedia Over Coax Alliance)','Moca (multimedia Over Coax Alliance)90 Inverness Circle EastEnglewood Ca 94583United States',1),('00:22:10','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:22:11','Rohati Systems','Rohati Systems1192 Borregas AveSunnyvale Ca 94089United States',1),('00:22:12','Cai Networks, Inc.','Cai Networks, Inc.1715 E. Wilshire AvenueSte 719Santa Ana California 92705United States',1),('00:22:13','Pci Corporation','Pci CorporationNo.25, Lane 66, Hebei 1st St.,  Beitun DistrictTaichung  406Taiwan, Republic Of China',1),('00:22:14','Rinnai Korea','Rinnai Korea560-2, Shibjong-1dong, Pupyoung-gu5th Research TeamPupyoung-gu Incheon 403-847Korea, Republic Of',1),('00:22:15','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitou,Taipei  112Taiwan, Republic Of China',1),('00:22:16','Shibaura Vending Machine Corporation','Shibaura Vending Machine CorporationEkimae-cho13-10Obama-shi Fukui-ken 917-0077Japan',1),('00:22:17','Neat Electronics','Neat ElectronicsVaruvgen 2Lddekpinge Skne Se-24642Sweden',1),('00:22:18','Verivue Inc.','Verivue Inc.3 Carlisle RoadWestford Ma 01886United States',1),('00:22:19','Dell Inc','Dell IncOne Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:22:1A','Audio Precision','Audio Precision5750 Sw Arctic DriveBeaverton Or 97005United States',1),('00:22:1B','Morega Systems','Morega Systems5770 Hurontario StreetSuite 501Mississauga Ontario L5r 3g5Canada',1),('00:22:1C','Private','',1),('00:22:1D','Freegene Technology Ltd','Freegene Technology Ltd3/f ,c Bldg,weipengda Industrial ParkLongkou Industrial Area,bao-an DistrictShenzhen Gongdong 518109China',1),('00:22:1E','Media Devices Co., Ltd.','Media Devices Co., Ltd.Rm1002 Ace Technotower(9th) 345-30Kasan-dong, Kumchon-kuSeoul  153-802Korea, Republic Of',1),('00:22:1F','Esang Technologies Co., Ltd.','Esang Technologies Co., Ltd.#1-817, It Castle 550-1, Gasan-dong,Geumcheon-gu,Seoul  153-768Korea, Republic Of',1),('00:22:20','Mitac Technology Corp','Mitac Technology Corp9th Fl., #75, Min-sheng E. Road, Sec. 3,Taipei  104Taiwan, Republic Of China',1),('00:22:21','Itoh Denki Co,ltd.','Itoh Denki Co,ltd.1146-2, Asazuma-choKasai Hyogo 679-0180Japan',1),('00:22:22','Betec Engineering Gmbh','Betec Engineering GmbhAm Beutwang 4Nuertingen Bw 72622Germany',1),('00:22:23','Timekeeping Systems, Inc.','Timekeeping Systems, Inc.30700 Bainbridge RoadSuite HSolon Oh 44139United States',1),('00:22:24','Good Will Instrument Co., Ltd.','Good Will Instrument Co., Ltd.No. 7-1 Jhongsing Road,Tucheng CityTaipei  236Taiwan, Republic Of China',1),('00:22:25','Thales Avionics Ltd','Thales Avionics Ltd86 Bushey RoadRaynes ParkLondon  Sw20 0jwUnited Kingdom',1),('00:22:26','Avaak, Inc.','Avaak, Inc.9645 Scranton Rd., Suite 110San Diego Ca 92121United States',1),('00:22:27','Uv-electronic Gmbh','Uv-electronic GmbhGrosswiesenstrasse 20Durchhausen Baden-wrttemberg 78591Germany',1),('00:22:28','Breeze Innovations Ltd.','Breeze Innovations Ltd.Har Hotzvim, P.o. Box 45397Jerusalem Israel 91451Israel',1),('00:22:29','Compumedics Ltd','Compumedics Ltd30 - 40 Flockhart StreetAbbotsford Victoria 3067Australia',1),('00:22:2A','Soundear A/s','Soundear A/sRentemestervej 80Copenhagen Nv Denmark Dk-2400Denmark',1),('00:22:2B','Nucomm, Inc.','Nucomm, Inc.101 Bilby RoadHackettstown Nj 07840United States',1),('00:22:2C','Ceton Corp','Ceton Corp8259 122nd Ave Ne, Suite 275Kirkland Washington 98033United States',1),('00:22:2D','Smc Networks Inc.','Smc Networks Inc.20 MasonIrvine Ca 92618United States',1),('00:22:2E','Maintech Gmbh','Maintech GmbhSeeweg 60Hchberg Bavaria 97204Germany',1),('00:22:2F','Open Grid Computing, Inc.','Open Grid Computing, Inc.4030-1 West Braker Lane Ste130Austin Tx 78759United States',1),('00:22:30','Futurelogic Inc.','Futurelogic Inc.425 E. Colorado St., Ste. 100Glendale Ca 91205United States',1),('00:22:31','Smt&c Co., Ltd.','Smt&c Co., Ltd.2fr. Haksan Bldg. 110, Gwangjang-dong, Gwangjin-guSeoul  143-802Korea, Republic Of',1),('00:22:32','Design Design Technology Ltd','Design Design Technology LtdUnit 9, Ash Road SouthWrexham Industrial EstateWrexham North Wales Ll13 9ugUnited Kingdom',1),('00:22:33','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano  20126Italy',1),('00:22:34','Corventis Inc.','Corventis Inc.1410 Energy Park Dr. Suite #1St. Paul Minnesota 55108United States',1),('00:22:35','Strukton Systems Bv','Strukton Systems BvWestkanaaldijk 2Utrecht  3542 DaNetherlands',1),('00:22:36','Vector Sp. Z O.o.','Vector Sp. Z O.o.Krzemowa 6Gdynia  81-577Poland',1),('00:22:37','Shinhint Group','Shinhint GroupUnit 1506, 15/f, Nanyang Plaza,, 57 Hung To Road,Kwun Tong, KlnHong Kong',1),('00:22:38','Logiplus','Logiplus1, Rue Clement AderB-6041 GosseleiesGosselies Hainaut B-6041Belgium',1),('00:22:39','Indiana Life Sciences Incorporated','Indiana Life Sciences Incorporated8875 Bash StreetIndianapolis Indiana 46256United States',1),('00:22:3A','Scientific Atlanta, Cisco Spvt Group','Scientific Atlanta, Cisco Spvt Group5030 Sugarloaf ParkwayLawrenceville Ga 30044United States',1),('00:22:3B','Communication Networks, Llc','Communication Networks, Llc3 Corporate DriveDanbury Ct 06810United States',1),('00:22:3C','Ratio Entwicklungen Gmbh','Ratio Entwicklungen GmbhLudwig-erhard-strasse 22Hamburg  20459Germany',1),('00:22:3D','Jumpgen Systems, Llc','Jumpgen Systems, Llc2111 Palomar Airport Rd, Ste 140Carlsbad Ca 92011United States',1),('00:22:3E','Irtrans Gmbh','Irtrans GmbhEinsteinstrasse 14Unterschleissheim Bayern 85716Germany',1),('00:22:3F','Netgear Inc.','Netgear Inc.4500 Great America PkySanta Clara Ca 95054United States',1),('00:22:40','Universal Telecom S/a','Universal Telecom S/aAvenida Paulista, 2444 - 17 AndarSao Paulo  01310-300Brazil',1),('00:22:41','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:22:42','Alacron Inc.','Alacron Inc.71 Spit Brook Rd.Suite 204Nashua Nh 03060United States',1),('00:22:43','Azurewave Technologies, Inc.','Azurewave Technologies, Inc.8f., No. 94, Baozhong Rd., XindianTaipei  231Taiwan, Republic Of China',1),('00:22:44','Chengdu Linkon Communications Device Co., Ltd','Chengdu Linkon Communications Device Co., Ltd5f-02, Juntong Building, No. 53,shuangfeng Road, Wuhou District,Chengdu Sichuan 610041China',1),('00:22:45','Leine & Linde Ab','Leine & Linde AbBox 8Strngns Sdermanland Se-645 21Sweden',1),('00:22:46','Evoc Intelligent Technology Co.,ltd.','Evoc Intelligent Technology Co.,ltd.No.31 Gaoxin Centeral Avenue 4th Road,nanshan District Shenzhen CityShenzhen Guangdong 518057China',1),('00:22:47','Dac Engineering Co., Ltd.','Dac Engineering Co., Ltd.1-5 Oyanagi-choKamitoba, Minami-kuKyoto  601-8128Japan',1),('00:22:48','Microsoft Corporation','Microsoft CorporationOne Microsoft WayRedmond Washington 98052-6399United States',1),('00:22:49','Home Multienergy Sl','Home Multienergy SlCapitn Haya 1Edificio Eucocentro BajoMadrid  28020Spain',1),('00:22:4A','Raylase Ag','Raylase AgArgelsrieder Feld 2-4Wessling Bavaria 82234Germany',1),('00:22:4B','Airtech Technologies, Inc.','Airtech Technologies, Inc.19fl-4, No.77, Hsin Tai Wu Rd., Sec.1, Hsin-chihTaipei  221Taiwan, Republic Of China',1),('00:22:4C','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:22:4D','Mitac International Corp.','Mitac International Corp.6th Fl., No187, Tiding Blvd., Sec. 2Taipei  114Taiwan, Republic Of China',1),('00:22:4E','Seenergy Corp.','Seenergy Corp.4f, No.61, Dongsing Rd.Taipei  110Taiwan, Republic Of China',1),('00:22:4F','Byzoro Networks Ltd.','Byzoro Networks Ltd.Room 5a1,block A, Keshi Plaza,no. 28a Info. Road,Haidian District,Beijing 100085China',1),('00:22:50','Point Six Wireless, Llc','Point Six Wireless, Llc2333 Alumni Park PlazaSuite 305Lexington Ky 40517United States',1),('00:22:51','Lumasense Technologies','Lumasense Technologies3033 Scott Blvd.Santa Clara Ca 95054United States',1),('00:22:52','Zoll Lifecor Corporation','Zoll Lifecor Corporation121 Freeport RoadPittsburgh Pa 15238United States',1),('00:22:53','Entorian Technologies','Entorian Technologies8900 Shoal Creek BlvdAustin Tx 78757United States',1),('00:22:54','Bigelow Aerospace','Bigelow Aerospace1899 W. Brooks AveNorth Las Vegas Nv 89032United States',1),('00:22:55','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:56','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:57','3com Europe Ltd','3com Europe LtdPeoplebuilding 2Maylands AvenueHemel Hempstead Herts. Hp2 4nwUnited Kingdom',1),('00:22:58','Taiyo Yuden Co., Ltd.','Taiyo Yuden Co., Ltd.8-1, Sakae-choTakasaki-shi Gunma-ken 370-8522Japan',1),('00:22:59','Guangzhou New Postcom Equipment Co.,ltd.','Guangzhou New Postcom Equipment Co.,ltd.No.3guangpuxi Road,guangzhou Science City,Guangzhou Guangdong 510663China',1),('00:22:5A','Garde Security Ab','Garde Security AbBox 78Soderhamn  S-826 22Sweden',1),('00:22:5B','Teradici Corporation','Teradici Corporation#500 - 4400 Dominion St.Burnaby Bc V5g $g3Canada',1),('00:22:5C','Multimedia & Communication Technology','Multimedia & Communication TechnologyDigital Empire D-801 #980-3Yeongtong-dongSuwon-city Kyeonggi-do 443-813Korea, Republic Of',1),('00:22:5D','Digicable Network India Pvt. Ltd.','Digicable Network India Pvt. Ltd.7b, Shah Industrial EstateOff. Veera Desai Road,Andheri - West, Mumbai. Maharashtra 400 053India',1),('00:22:5E','Uwin Technologies Co.,ltd','Uwin Technologies Co.,ltd2f,no.22.r&d Rd Ii,sbipHsinchu  300Taiwan, Republic Of China',1),('00:22:5F','Liteon Technology Corporation','Liteon Technology Corporation4f,90,chien 1 Road,chungho,Taipei Hsien, 23585Taiwan, Republic Of China',1),('00:22:60','Afreey Inc.','Afreey Inc.6f, No.249, Chien I RoadChung Ho City Taipei County 235Taiwan, Republic Of China',1),('00:22:61','Frontier Silicon Ltd','Frontier Silicon LtdGleneagles, The BelfryColonial WayWatford Hertfordshire Wd24 4whUnited Kingdom',1),('00:22:62','Bep Marine','Bep Marine13 Tarndale Grove AlbanyNorth ShoreAuckland  0632New Zealand',1),('00:22:63','Koos Technical Services, Inc.','Koos Technical Services, Inc.1025 Greenwood Blvd.Suite 391Lake Mary Fl 32746United States',1),('00:22:64','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040802Houston Tx 77070United States',1),('00:22:65','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:22:66','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:22:67','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Texas 75082-4399United States',1),('00:22:68','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:22:69','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:22:6A','Honeywell','Honeywell8840 Evergreen Blvd.Minneapolis Mn 55433-6040United States',1),('00:22:6B','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92612United States',1),('00:22:6C','Linksprite Technologies, Inc.','Linksprite Technologies, Inc.1410 Cannon Mountain DrLongmont Co 80503United States',1),('00:22:6D','Shenzhen Giec Electronics Co., Ltd.','Shenzhen Giec Electronics Co., Ltd.24/f, Xinian Center, Shennan Road 6021#, Futian DistrictShenzhen Guangdong Province 518040China',1),('00:22:6E','Gowell Electronic Limited','Gowell Electronic LimitedRoom 3601 ,36 Floor,golden Central Tower,jintian Road,futian Central District,Shenzhen Guangdong 518048China',1),('00:22:6F','3onedata Technology Co. Ltd.','3onedata Technology Co. Ltd.3/f, B/2, Jiuxiangling Industrial District, Xili Town, Nanshan District,Shenzhen Guangdong 518055China',1),('00:22:70','Abk North America, Llc','Abk North America, Llc440 North Wolfe Rd.Sunnyvale Ca 94085United States',1),('00:22:71','Jger Computergesteuerte Messtechnik Gmbh','Jger Computergesteuerte Messtechnik GmbhRheinstrae 2-4Lorsch Hessen 64653Germany',1),('00:22:72','American Micro-fuel Device Corp.','American Micro-fuel Device Corp.2181 Buchanan LoopFerndale Wa 98248United States',1),('00:22:73','Techway','TechwayRm 1002, Daehyun Techno World Bd,174, Ojun-dong,Uiwang-si, Kyungki-do 437-820Korea, Republic Of',1),('00:22:74','Familyphone Ab','Familyphone AbAnckargripsgatan 3Malm  21119Sweden',1),('00:22:75','Belkin International, Inc.','Belkin International, Inc.501 W. Walnut St.Compton Ca. 90220United States',1),('00:22:76','Triple Eye B.v.','Triple Eye B.v.Vaassenseweg 71Emst  8166 AtNetherlands',1),('00:22:77','Nec Australia Pty Ltd','Nec Australia Pty Ltd649-655 Springvale RdMulgrave Victoria 3170Australia',1),('00:22:78','Shenzhen  Tongfang Multimedia  Technology Co.,ltd.','Shenzhen  Tongfang Multimedia  Technology Co.,ltd.9th Floor,building #d,tongfang Information Harbour,high-tech Industrial Park,langshan Rd, Nanshan District,Shenzheng Guangdong 518058China',1),('00:22:79','Nippon Conlux Co., Ltd.','Nippon Conlux Co., Ltd.5-3-8, ChiyodaSakado-shi Saitama 350-0214Japan',1),('00:22:7A','Telecom Design','Telecom DesignZa RemoraVoie Romaine33170 GradignanFrance',1),('00:22:7B','Apogee Labs, Inc.','Apogee Labs, Inc.210 S. 3rd St.North Wales Pa 19454United States',1),('00:22:7C','Woori Smt Co.,ltd','Woori Smt Co.,ltd649-2,suwolam-ri,seotan-myunPyongtaek Kyonggi-do 451-852Korea, Republic Of',1),('00:22:7D','Ye Data Inc.','Ye Data Inc.182 ShinkoIruma Saitama 358-0055Japan',1),('00:22:7E','Chengdu 30kaitian Communication Industry Co.ltd','Chengdu 30kaitian Communication Industry Co.ltdNo.6 Chuangye RoadChengdu Sichuan 610041China',1),('00:22:7F','Ruckus Wireless','Ruckus Wireless880 West Maude Ave.Suite 101Sunnyvale Ca 94085United States',1),('00:22:80','A2b Electronics Ab','A2b Electronics AbBox 14Motala  S-591 21Sweden',1),('00:22:81','Daintree Networks Inc','Daintree Networks Inc3340 Walnut AveSuite 275Fremont Ca 94538United States',1),('00:22:82','8086 Limited','8086 Limited17 Lowfield LaneBaldertonNewark Notts Ng24 3hjUnited Kingdom',1),('00:22:83','Juniper Networks','Juniper Networks1194 N Mathilda AvenueSunnyvale Ca 94089United States',1),('00:22:84','Desay A&v Science And Technology Co.,ltd','Desay A&v Science And Technology Co.,ltdDesay 3rd Zone,chenjiang,Huizhou Guangdong 516229China',1),('00:22:85','Nomus Comm Systems','Nomus Comm Systems601, Gunjan Tower,Off. Alembic Gorwa RoadBaroda Gujarat 390023India',1),('00:22:86','Astron','AstronOudehoogeveensedijk 4Dwingeloo Drenthe 7991pdNetherlands',1),('00:22:87','Titan Wireless Llc','Titan Wireless Llc1700 Bryant DrSuite 204Round Rock Texas 78664United States',1),('00:22:88','Sagrad, Inc.','Sagrad, Inc.4325 Woodland Park DriveSuite 101W. Melbourne Fl 32904United States',1),('00:22:89','Optosecurity Inc.','Optosecurity Inc.505, Boul. Du Parc TechnologiqueQuebec  G1p 4s9Canada',1),('00:22:8A','Teratronik Elektronische Systeme Gmbh','Teratronik Elektronische Systeme GmbhKarl-ulrich-strasse 1Gross-umstadt  D-64823Germany',1),('00:22:8B','Kensington Computer Products Group','Kensington Computer Products Group333 Twin Dolphin Dr.Sixth FloorRedwood Shores Ca 94065United States',1),('00:22:8C','Photon Europe Gmbh','Photon Europe GmbhJlicher Strae 376Aachen Nordrhein-westfalen 52070Germany',1),('00:22:8D','Gbs Laboratories Llc','Gbs Laboratories Llc2325 Dulles Corner BlvdHerndon Va 20171United States',1),('00:22:8E','Tv-numeric','Tv-numeric24-26 Rue Louis ArmandParis  75015France',1),('00:22:8F','Cnrs','CnrsMrct1 Place Aristide BriandMeudon Ile De France 92195France',1),('00:22:90','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:91','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:92','Cinetal','Cinetal8651 Castle ParkIndianapolis In 46256United States',1),('00:22:93','Zte Corporation','Zte Corporation12/f Zte Plaza,keji Road South,hi-tech Industrial Park,nanshan DistrictShenzhen Guangdong 518057China',1),('00:22:94','Kyocera Corporation','Kyocera Corporation2-1-1,kagaharaTsuzuki-kuYokohama-shi Kanagawa 224-8502Japan',1),('00:22:95','Sgm Technology For Lighting Spa','Sgm Technology For Lighting SpaVia Pio La Torre 1Tavullia Pu 61010Italy',1),('00:22:96','Linowave Corporation','Linowave Corporation1001-101 Champlain AvenueBurlington Onatario L7l 5z4Canada',1),('00:22:97','Xmos Semiconductor','Xmos SemiconductorVenturers HouseKing StreetBristol  Bs1 4pbUnited Kingdom',1),('00:22:98','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:22:99','Seamicro Inc.','Seamicro Inc.4677 Old Ironsides Dr.,Suite 310Santa Clara Ca 95054United States',1),('00:22:9A','Lastar, Inc.','Lastar, Inc.3555 Kettering Blvd.Moraine Ohio 45439United States',1),('00:22:9B','Averlogic Technologies, Inc.','Averlogic Technologies, Inc.7f-2, No.2, Lane 258, Rui Guang Rd., Nei-hu Dist.,Taipei Taiwan 114Taiwan, Republic Of China',1),('00:22:9C','Verismo Networks Inc','Verismo Networks Inc295 Bernando AvenueSte # 300Mountain View Ca 94043United States',1),('00:22:9D','Pyung-hwa Ind.co.,ltd','Pyung-hwa Ind.co.,ltd230-1Duckwoo-ri, Paltan-myunHwasung-si Kyunggi-do 445-912Korea, Republic Of',1),('00:22:9E','Social Aid Research Co., Ltd.','Social Aid Research Co., Ltd.South 3, West 10, Chuo-ku7f, Fukuyama-minami-3jyou Build.Sapporo Hokkaido 060-0063Japan',1),('00:22:9F','Sensys Traffic Ab','Sensys Traffic AbSlottsgatan 14Box 2174Jonkoping Smaland 55322Sweden',1),('00:22:A0','Delphi Corporation','Delphi CorporationM/c-480-405-2555820 Delphi DriveTroy Mi 48446United States',1),('00:22:A1','Huawei Symantec Technologies Co.,ltd.','Huawei Symantec Technologies Co.,ltd.Building 1,the West Zone Science Park Of Uestc,no.88,tianchen RoadChengdu Sichuan 611731China',1),('00:22:A2','Xtramus Technologies','Xtramus Technologies5th Fl., No. 102, Lide St.,Zhonghe City Taipei County 235Taiwan, Republic Of China',1),('00:22:A3','California Eastern Laboratories','California Eastern Laboratories4590 Patrick Henry Dr.Santa Clara Ca 95054United States',1),('00:22:A4','2wire','2wire1764 Automation ParkwaySan Jose Ca 95131United States',1),('00:22:A5','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:22:A6','Sony Computer Entertainment America','Sony Computer Entertainment America919 East Hillsdale BlvdFoster City California 94404-2175United States',1),('00:22:A7','Tyco Electronics Amp Gmbh','Tyco Electronics Amp GmbhAmperestr. 12-14Bensheim Hessen 64625Germany',1),('00:22:A8','Ouman Finland Oy','Ouman Finland OyVoimatie 6Kempele  Fin-90440Finland',1),('00:22:A9','Lg Electronics Inc','Lg Electronics Inc60-39,gasan-dongGumchon-guSeoul  153-023Korea, Republic Of',1),('00:22:AA','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:22:AB','Shenzhen Turbosight Technology Ltd','Shenzhen Turbosight Technology LtdUnit C-8a,shennan Garden Bldg,hightech Park,nanshan DistrictShenzhen Guangdong 518057China',1),('00:22:AC','Hangzhou Siyuan Tech. Co., Ltd','Hangzhou Siyuan Tech. Co., Ltd5 F, Tower B, No. 37, Xiang Yuan RoadHangzhou Zhejiang 310012China',1),('00:22:AD','Telesis Technologies, Inc.','Telesis Technologies, Inc.28181 River DriveCircleville Ohio 43113United States',1),('00:22:AE','Mattel Inc.','Mattel Inc.333 Continental Blvd.El Segundo Ca 90245United States',1),('00:22:AF','Safety Vision','Safety Vision6100 W. Sam Houston Pkwy. NorthHouston Texas 77041United States',1),('00:22:B0','D-link Corporation','D-link CorporationNo.289, Sinhu 3rd Rd.,Neihu District, Taipei City 114Taiwan, Republic Of China',1),('00:22:B1','Elbit Systems','Elbit SystemsPob 539Haifa  31053Israel',1),('00:22:B2','4rf Communications Ltd','4rf Communications Ltd26 Glover StreetNgauranga Wellington 6035New Zealand',1),('00:22:B3','Sei S.p.a.','Sei S.p.a.Via Ruffilli, 1Curno Bergamo 24035Italy',1),('00:22:B4','Motorola Mobile Devices','Motorola Mobile Devices600 N. U.s. Highway 45Libertyville Illinois 60048United States',1),('00:22:B5','Novita','Novita3f301,namsung B/d 340-30Gasan-dongGeumcheon-gu Seoul 153-782Korea, Republic Of',1),('00:22:B6','Superflow Technologies Group','Superflow Technologies Group4060 Dixon StreetDes Moines Ia 50266United States',1),('00:22:B7','Gss Grundig Sat-systems Gmbh','Gss Grundig Sat-systems GmbhBeutherner Strasse 43Nuernberg Bayern 90471Germany',1),('00:22:B8','Norcott','NorcottBrookfield HouseGrimsditch Lane Off Tarporley RoadNorcott Brook Cheshire Wa4 4eaUnited Kingdom',1),('00:22:B9','Analogix Seminconductor, Inc','Analogix Seminconductor, Inc3211 Scott Blvd., Suite 100Santa Clara Ca 95054United States',1),('00:22:BA','Huth Elektronik Systeme Gmbh','Huth Elektronik Systeme GmbhEchternacher Str. 10Troisdorf-spich Nrw 53842Germany',1),('00:22:BB','Beyerdynamic Gmbh & Co. Kg','Beyerdynamic Gmbh & Co. KgTheresienstr. 8Heilbronn  74072Germany',1),('00:22:BC','Jdsu France Sas','Jdsu France Sas34 Rue NeckerSaint Etienne Loire 42000France',1),('00:22:BD','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:BE','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:22:BF','Sieamp Group Of Companies','Sieamp Group Of Companies2 Ang Mo Kio Street 64Ang Mo Kio Industrial Park 3, Unit 02-01d Econ BuildingSingapore  569084Singapore',1),('00:22:C0','Shenzhen Forcelink Electronic Co, Ltd','Shenzhen Forcelink Electronic Co, Ltd2nd And 3rd Floor, Hasse Manufacture Building, Hasee Industrial ParkBanxuegang Industrial Area, Longgang DistrictShenzhen Guangdong 518112China',1),('00:22:C1','Active Storage Inc.','Active Storage Inc.2295 Jefferson StreetTorrance Ca 90501United States',1),('00:22:C2','Proview Eletronica Do Brasil Ltda','Proview Eletronica Do Brasil LtdaR. Acar, 203 - Distrito IndustrialManaus Amazonas 69075-030Brazil',1),('00:22:C3','Zeeport Technology Inc.','Zeeport Technology Inc.1f,no231,xianzheng 2nd Rd.Hsinchu Taiwan 300Taiwan, Republic Of China',1),('00:22:C4','Epro Gmbh','Epro GmbhJoebkesweg 3Gronau Nrw 48599Germany',1),('00:22:C5','Inforson Co,ltd.','Inforson Co,ltd.Room 704,tower B1, Changyuantiandi PlazaSuzhou Street, Haidian DistrictBeijing City  100080China',1),('00:22:C6','Sutus Inc','Sutus Inc301-3999 Henning DriveBurnaby British Columbia V5c 6p9Canada',1),('00:22:C7','Segger Microcontroller Gmbh & Co. Kg','Segger Microcontroller Gmbh & Co. KgIn Den Weiden 11Hilden Nrw 40721Germany',1),('00:22:C8','Applied Instruments','Applied InstrumentsEdisonweg 39dVlissingen Zeeland Nl-4382nvNetherlands',1),('00:22:C9','Lenord, Bauer & Co Gmbh','Lenord, Bauer & Co GmbhDohlenstr 32Oberhausen Nrw 46145Germany',1),('00:22:CA','Anviz Biometric Tech. Co., Ltd.','Anviz Biometric Tech. Co., Ltd.5th Floor, 4299 Jindu Road,Shanghai  201108China',1),('00:22:CB','Ionodes Inc.','Ionodes Inc.1555 AvenirSuite 103Laval Quebec H7s2n5Canada',1),('00:22:CC','Scilog, Inc.','Scilog, Inc.8845 South Greenview DriveSuite 4Middleton Wisconsin 53562United States',1),('00:22:CD','Ared Technology Co., Ltd.','Ared Technology Co., Ltd.6f-8 No.83 Sec.1, Nankan Rd. Luzhu ShiangTaoyuan County Taiwan 33859Taiwan, Republic Of China',1),('00:22:CE','Cisco, Service Provider Video Technology Group','Cisco, Service Provider Video Technology Group5030 Sugarloaf ParkwayLawrenceville Ga 30042United States',1),('00:22:CF','Planex Communications Inc','Planex Communications Inc2f Fenissay Ebisu Bldg3-16-3Shibuya-ku Tokyo 150-0011Japan',1),('00:22:D0','Polar Electro Oy','Polar Electro OyProfessorintie 5Kempele Oulu 90440Finland',1),('00:22:D1','Albrecht Jung Gmbh & Co. Kg','Albrecht Jung Gmbh & Co. KgVolmestrae 1Schalksmhle Nrw 58579Germany',1),('00:22:D2','All Earth Comrcio De Eletrnicos Ltda.','All Earth Comrcio De Eletrnicos Ltda.Rua Bento De Arruda Camargo270 - Jd. SantanaCampinas So Paulo 13088-650Brazil',1),('00:22:D3','Hub-tech','Hub-tech77, Imae-dongBundang-guSeongnam-si Gyeonggi-do 463-829Korea, Republic Of',1),('00:22:D4','Comworth Co., Ltd.','Comworth Co., Ltd.2-35-7 NishimagomeOhta-ku Tokyo 143-0026Japan',1),('00:22:D5','Eaton Corp. Electrical Group Data Center Solutions - Pulizzi','Eaton Corp. Electrical Group Data Center Solutions - Pulizzi3200 S. Susan St.Santa Ana Ca 92704United States',1),('00:22:D6','Cypak Ab','Cypak AbP.o. Box 2332Funckens Grnd 1Stockholm  103 18Sweden',1),('00:22:D7','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:22:D8','Shenzhen Gst Security And Safety Technology Limited','Shenzhen Gst Security And Safety Technology LimitedRoom 502,building 6 Of Kupai Infomation Harbour,No.2 Mengxi Road, Hntia(north Area),nanshan DistrictShenzhen Guangdong 518040China',1),('00:22:D9','Fortex Industrial Ltd.','Fortex Industrial Ltd.Flat 16, 12 /f.,pacific Trade Centre2 Kai Hing Road,kowloon Bay,Kowloon Hong Kong 852China',1),('00:22:DA','Anatek, Llc','Anatek, Llc3219 East Camelback RoadSuite 502Phoenix Az 85018United States',1),('00:22:DB','Translogic Corporation','Translogic Corporation10825 E. 47th AvenueDenver Colorado 80239United States',1),('00:22:DC','Vigil Health Solutions Inc.','Vigil Health Solutions Inc.2102-4464 Markham StVictoria Bc V8z 7x8Canada',1),('00:22:DD','Protecta Electronics Ltd','Protecta Electronics LtdKesmark Str 7/aBudapest Hungary 1158Hungary',1),('00:22:DE','Oppo Digital, Inc.','Oppo Digital, Inc.2629b Terminal BlvdMountain View Ca 94043United States',1),('00:22:DF','Tamuz Monitors','Tamuz MonitorsTiedenkamp 16Henstedt-ulzburg Sh 24558Germany',1),('00:22:E0','Atlantic Software Technologies S.r.l.','Atlantic Software Technologies S.r.l.Via Martino Bassi, 9Milano  20148Italy',1),('00:22:E1','Zort Labs, Llc.','Zort Labs, Llc.44h Dover Point RoadDover Nh 03820United States',1),('00:22:E2','Wabtec Transit Division','Wabtec Transit Division130 Ridgeview CircleDuncan Sc 29334United States',1),('00:22:E3','Amerigon','Amerigon21680 Haggerty RoadSuite 101Northville Michigan 48167United States',1),('00:22:E4','Apass Technology Co., Ltd.','Apass Technology Co., Ltd.2f, No. 267, Sec. 3, Chengde Rd.,Datong DistrictTeipei  113Taiwan, Republic Of China',1),('00:22:E5','Fisher-rosemount Systems Inc.','Fisher-rosemount Systems Inc.12301 Research BlvdBuilding 3Austin Texas 78759United States',1),('00:22:E6','Intelligent Data','Intelligent DataEdf. Inverinnova  Avda. Punto Mobi, 4. Parque Cientfico TecnolgicoTecnoalcal. Crta. Nacional Ii Madrid-barcelona Km. 31,600Alcal De Henares Madrid 28805Spain',1),('00:22:E7','Wps Parking Systems','Wps Parking SystemsHoevenweg 11Eindhoven Noord-brabant 5652 AwNetherlands',1),('00:22:E8','Applition Co., Ltd.','Applition Co., Ltd.509-1, Bundang Techno Park D-dong,151 Yatap-dong, Bundang-guSeongnam Kyunggi-do 463-760Korea, Republic Of',1),('00:22:E9','Provision Communications','Provision Communications1 Portland SquareBristol  Bs2 8rrUnited Kingdom',1),('00:22:EA','Rustelcom Inc.','Rustelcom Inc.Garagniy Proezd, 1St.-petersburg  192288Russian Federation',1),('00:22:EB','Data Respons A/s','Data Respons A/sEllekr 6Herlev  2730Denmark',1),('00:22:EC','Idealbt Technology Corporation','Idealbt Technology Corporation6f., No.8, Lane 345, Yangguang St., Neihu DistrictTaipei  114Taiwan, Republic Of China',1),('00:22:ED','Tsi Power Corporation','Tsi Power Corporation1103 West Pierce AvenueAntigo Wi 54409United States',1),('00:22:EE','Algo Communication Products Ltd','Algo Communication Products Ltd4500 Beedie StreetBurnaby Bc V5j 5l2Canada',1),('00:22:EF','Ibis Tek, Llc','Ibis Tek, Llc912 Pittsburgh RoadButler Pa 16002United States',1),('00:22:F0','3 Greens Aviation Limited','3 Greens Aviation Limited10 Hedingham CloseMacclesfield  Sk10 3lzUnited Kingdom',1),('00:22:F1','Private','',1),('00:22:F2','Sunpower Corp','Sunpower Corp1414 Harbour Way SouthRichmond Ca 94804United States',1),('00:22:F3','Sharp Corporation','Sharp Corporation22-22,nagaike-cho,Abeno-ku,Osaka, 545-8522,Japan',1),('00:22:F4','Ampak Technology, Inc.','Ampak Technology, Inc.No. 8-1, Nanyuan 2nd Rd.Jhongli Taoyuan 320Taiwan, Republic Of China',1),('00:22:F5','Advanced Realtime Tracking Gmbh','Advanced Realtime Tracking GmbhAm Oeferl 6Weilheim Bayern D-82362Germany',1),('00:22:F6','Syracuse Research Corporation','Syracuse Research Corporation6225 Running Ridge RoadNorth Syracuse Ny 13212United States',1),('00:22:F7','Conceptronic','ConceptronicDatabankweg 7Amersfoort Utrecht 3821 AlNetherlands',1),('00:22:F8','Pima Electronic Systems Ltd.','Pima Electronic Systems Ltd.5 Hatzoref St.Holon  58856Israel',1),('00:22:F9','Pollin Electronic Gmbh','Pollin Electronic GmbhMax-pollin-str. 1Pfoerring  85104Germany',1),('00:22:FA','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:22:FB','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:22:FC','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:22:FD','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:22:FE','Microprocessor Designs Inc','Microprocessor Designs Inc65 Longmeadow DrivePo Box 160Shelburne Vermont 05482United States',1),('00:22:FF','Nivis Llc','Nivis Llc1000 Circle 75Suite 300Atlanta Ga 30339United States',1),('00:23:00','Cayee Computer Ltd.','Cayee Computer Ltd.Units 1002-1003, 10/f, Join-in Hang Sing Centre71-75 Container Port RoadKwai Chung N.tHong Kong',1),('00:23:01','Witron Technology Limited','Witron Technology Limited6/f, Xin Rui Building, 32 Tao Hua Road, Futian Free Trade Zone,Shenzhen 86China',1),('00:23:02','Cobalt Digital, Inc.','Cobalt Digital, Inc.2406 East University AvenueUrbana Il 61802United States',1),('00:23:03','Lite-on It Corporation','Lite-on It Corporation14f, No. 392, Ruey Kuang Road, NeihuTaipei City  114Taiwan, Republic Of China',1),('00:23:04','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:05','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:06','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, OkinouchiSoma City Fukushima 976-8501Japan',1),('00:23:07','Future Innovation Tech Co.,ltd','Future Innovation Tech Co.,ltd312 3-dong, Gwangmyung Industrial Complex 201Haan-dongGwangmyung Gyunggi 423060Korea, Republic Of',1),('00:23:08','Arcadyan Technology Corporation','Arcadyan Technology Corporation4f., No. 9 , Park Avenue Ii,Science-based Industrial Park,Hsinchu Taiwan 300Taiwan, Republic Of China',1),('00:23:09','Janam Technologies Llc','Janam Technologies Llc100 Crossways Park WestSuite 105Woodbury Ny 11797United States',1),('00:23:0A','Arburg Gmbh & Co Kg','Arburg Gmbh & Co KgArthur Hehl StrasseLossburg  D-72290Germany',1),('00:23:0B','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:0C','Clover Electronics Co.,ltd.','Clover Electronics Co.,ltd.Akeno 306-1Obata ChyouIse City Mie Prefecture 519-0501Japan',1),('00:23:0D','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Texas 75082-4399United States',1),('00:23:0E','Gorba Ag','Gorba AgSandackerstrasseOberbren Sg Ch - 9245Switzerland',1),('00:23:0F','Hirsch Electronics Corporation','Hirsch Electronics Corporation1900 Carnegie, Bldg BSanta Ana Ca 92705United States',1),('00:23:10','Lnc Technology Co., Ltd.','Lnc Technology Co., Ltd.19f, No. 78-2, Sec. 3, Taichung Kang Rd.Taichung  40764Taiwan, Republic Of China',1),('00:23:11','Gloscom Co., Ltd.','Gloscom Co., Ltd.#507 Changhyun Bldg.960-1 Hogye-dongAnyang City Kyunggo-do 431-080Korea, Republic Of',1),('00:23:12','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:23:13','Qool Technologies Ltd.','Qool Technologies Ltd.Gotanda No.3 Hanatani Bldg 3f,5-28-9,higashi-gotandaShinagawa-ku Tokyo 141-0022Japan',1),('00:23:14','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:23:15','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:23:16','Kisan Electronics Co','Kisan Electronics Co317-15Sung Su 2ga 3dongSeoung-dong Gu Seoul 133-123Korea, Republic Of',1),('00:23:17','Lasercraft Inc','Lasercraft Inc1450 Oakbrook DriveSuite 900Norcross Ga 30093United States',1),('00:23:18','Toshiba','Toshiba2-9,suehiro-choOme Tokyo 1988710Japan',1),('00:23:19','Sielox Llc','Sielox Llc170 East Ninth Ave.Runnemede Nj 08078United States',1),('00:23:1A','Itf Co., Ltd.','Itf Co., Ltd.2-2-11 Nishiki-choTachikawa-shi Tokyo 190-0022Japan',1),('00:23:1B','Danaher Motion - Kollmorgen','Danaher Motion - Kollmorgen201 W. Rock RoadRadford Va 24141United States',1),('00:23:1C','Fourier Systems Ltd.','Fourier Systems Ltd.16 Hamelacha StRosh Haayin  48091Israel',1),('00:23:1D','Deltacom Electronics Ltd','Deltacom Electronics Ltd2f,zit,7km Tzarigradsko ShoseSofia Sofia-grad 1784Bulgaria',1),('00:23:1E','Cezzer Multimedia Technologies','Cezzer Multimedia TechnologiesPpinire Dentreprises Creatic115 Rue Claude ChappePlouzan  29280France',1),('00:23:1F','Guangda Electronic & Telecommunication Technology Development Co., Ltd.','Guangda Electronic & Telecommunication Technology Development Co., Ltd.#8 Gaopengdong Road, Gaoxin DistrictChengdu Sichuan 610041China',1),('00:23:20','Nicira Network','Nicira Network385 Sherman Ave. #14Palo Alto Ca 94306United States',1),('00:23:21','Avitech International Corp','Avitech International Corp15333 Ne 90th StreetRedmond Wa 98052United States',1),('00:23:22','Kiss Teknical Solutions, Inc.','Kiss Teknical Solutions, Inc.1583 S. Navajo WayChandler Arizona 85286United States',1),('00:23:23','Zylin As','Zylin AsAuglendsdalen 78Stavanger  4017Norway',1),('00:23:24','G-pro Computer','G-pro ComputerFirst Arrange C, Yinghu Industrial EstateQingxi CountryDongguan City Guangdong Province 523648China',1),('00:23:25','Iolan Holding','Iolan HoldingMon Plaisir 26Etten Leur  4879anNetherlands',1),('00:23:26','Fujitsu Limited','Fujitsu LimitedMusashi-kosugi Tower Place Bldg.,403, Kosugi-cho 1-chome,nakahara-kuKawasaki Kanagawa 211-0063Japan',1),('00:23:27','Shouyo Electronics Co., Ltd','Shouyo Electronics Co., Ltd4f., No.8, Lane 345, Yang Kung St.Taipei  11491Taiwan, Republic Of China',1),('00:23:28','Alcon Telecommunications Co., Ltd.','Alcon Telecommunications Co., Ltd.2nd Fl, No 480-5, Sec. 6, Yen-ping N. Rd.,Shih-linTaipei Taiwan 111Taiwan, Republic Of China',1),('00:23:29','Ddrdrive Llc','Ddrdrive Llc11076 Elati StNorthglenn Co 80234United States',1),('00:23:2A','Eonas It-beratung Und -entwicklung Gmbh','Eonas It-beratung Und -entwicklung GmbhGreifenhagener Str. 54Berlin  10437Germany',1),('00:23:2B','Ird A/s','Ird A/sKullinggade 31Svendborg Fyn 5700Denmark',1),('00:23:2C','Senticare','Senticare161 Worcester RdSuite 305Framingham Ma 01701United States',1),('00:23:2D','Sandforce','Sandforce12950 Saratoga Ave.Saratoga California 95070-4658United States',1),('00:23:2E','Kedah Electronics Engineering, Llc','Kedah Electronics Engineering, LlcZelenograd, 445Moscow  124498Russian Federation',1),('00:23:2F','Advanced Card Systems Ltd.','Advanced Card Systems Ltd.Unit 2010-13, Chevalier Commercial Centre,8 Wang Hoi Road,Kowloon Bay, SarHong Kong',1),('00:23:30','Dizipia, Inc.','Dizipia, Inc.15th Floor, East Wing, It Venture Tower78 Garak-dong, Songpa-gu,Seoul  138160Korea, Republic Of',1),('00:23:31','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:23:32','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:23:33','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:34','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:35','Linkflex Co.,ltd','Linkflex Co.,ltd5f. Min Young Bldg. 175-2Nonhyeon-dong, Gangnam-guSeoul  135-010Korea, Republic Of',1),('00:23:36','Metel S.r.o.','Metel S.r.o.Velka Jesenice 125Velka Jesenice Nachod 55224Czech Republic',1),('00:23:37','Global Star Solutions Ulc','Global Star Solutions Ulc4600 Jacombs RoadRichmond Bc V6v 3b1Canada',1),('00:23:38','Oj-electronics A/s','Oj-electronics A/sStenager 13bSnderborg  6400Denmark',1),('00:23:39','Samsung Electronics','Samsung Electronics#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:23:3A','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:23:3B','C-matic Systems Ltd','C-matic Systems LtdWarren CourtPark RoadCrowborough East Sussex Tn6 2qxUnited Kingdom',1),('00:23:3C','Alflex','AlflexBlauw-roodlaan 300Zoetermeer  2718 SkNetherlands',1),('00:23:3D','Novero Gmbh','Novero GmbhRensingstrasse 15Bochum  44807Germany',1),('00:23:3E','Alcatel-lucent-ipd','Alcatel-lucent-ipd701 E. Middlefield Rd.Mountain View Ca 94043United States',1),('00:23:3F','Purechoice Inc','Purechoice Inc11481 Rupp DriveBurnsville Mn 55337United States',1),('00:23:40','Mix Telematics','Mix TelematicsBlaauwklip Office Park 2Cnr Strand & Webersvallei RdStellenbosch Western Cape 7600South Africa',1),('00:23:41','Siemens Building Technologies Fire & Security Products Gmbh & Co. Ohg','Siemens Building Technologies Fire & Security Products Gmbh & Co. OhgSiemensallee 84Karlsruhe Baden-wrttemberg 76187Germany',1),('00:23:42','Coffee Equipment Company','Coffee Equipment Company4216 6th Ave NwSeattle Wa 98107United States',1),('00:23:43','Tem Ag','Tem AgTriststrasse 8Chur  7007Switzerland',1),('00:23:44','Objective Interface Systems','Objective Interface Systems13873 Park Center RdSuite 360Herndon Va 20171United States',1),('00:23:45','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:23:46','Vestac','VestacP.o. Box 7358Shrewsbury Nj 07702United States',1),('00:23:47','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville California 95747United States',1),('00:23:48','Sagem Communication','Sagem Communication14 Rue Paul DautierVelizy  78457France',1),('00:23:49','Helmholtz Centre Berlin For Material And Energy','Helmholtz Centre Berlin For Material And EnergyDepartment FmdGlienicker Strasse 100Berlin  14109Germany',1),('00:23:4A','Private','',1),('00:23:4B','Inyuan Technology Inc.','Inyuan Technology Inc.No. 3, Singye St.,Gueishan TownshipTaoyuan County  33341Taiwan, Republic Of China',1),('00:23:4C','Ktc Ab','Ktc AbF O Petersons Gata 6Vastra Frolunda Gothenburg Se-42131Sweden',1),('00:23:4D','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66, Chung Shan Rd.tu-chengTaipei Hsien Taiwan 236Taiwan, Republic Of China',1),('00:23:4E','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66,chung Shan Rd.tu-chengTaipei Hsien Taiwan 236Taiwan, Republic Of China',1),('00:23:4F','Luminous Power Technologies Pvt. Ltd.','Luminous Power Technologies Pvt. Ltd.C8-c9, Community Center,Behind Janak Cinema, Janakpuri,New Delhi  110058India',1),('00:23:50','Lyntec','Lyntec8401 Melrose DriveLenexa Ks 66214United States',1),('00:23:51','2wire','2wire1764 Automation ParkwaySan Jose Ca 95131United States',1),('00:23:52','Datasensor S.p.a.','Datasensor S.p.a.Via Lavino, 265Monte San Pietro (bo)  40050Italy',1),('00:23:53','F E T Elettronica Snc','F E T Elettronica SncVia A.manzoni 14/aCp303 Pptt Poggibonsi CentroPoggibonsi Siena 53036Italy',1),('00:23:54','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitou,Taipei Taiwan 112Taiwan, Republic Of China',1),('00:23:55','Kinco Electric (shanghai) Ltd.','Kinco Electric (shanghai) Ltd.Bldg1, No.1387, Zhangdong Road,Zhangjiang Hi-tech Park, Pudong.Shanghai 201203China',1),('00:23:56','Packet Forensics Llc','Packet Forensics Llc420 S Smith RdTempe Az 85281United States',1),('00:23:57','Pitronot Technologies And Engineering P.t.e. Ltd.','Pitronot Technologies And Engineering P.t.e. Ltd.8 Hatut StPardesiya  42815Israel',1),('00:23:58','Systel Sa','Systel SaZi De Belle AireBp 31Aytre  17440France',1),('00:23:59','Benchmark Electronics ( Thailand ) Public Company Limited','Benchmark Electronics ( Thailand ) Public Company Limited94 Moo 1, Hi-tech Industrial EstateBanlaneBang Pa-in Ayudhaya 13160Thailand',1),('00:23:5A','Compal Information (kunshan) Co., Ltd.','Compal Information (kunshan) Co., Ltd.No 25, The 3rd Street,Kuanshan Export Processing ZoneKuanshan Suzhou 215300China',1),('00:23:5B','Gulfstream','Gulfstream32 Lummus DriveRdc Lab R-08Savannah Ga 31407United States',1),('00:23:5C','Aprius, Inc.','Aprius, Inc.440 N. Wolfe RdSunnyvale Ca 94085United States',1),('00:23:5D','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:5E','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:5F','Silicon Micro Sensors Gmbh','Silicon Micro Sensors GmbhGrenzstrasse 28 / Gebude 32Dresden Saxony 01109Germany',1),('00:23:60','Lookit Co., Ltd','Lookit Co., LtdR413 Excellence Mansion, Fuhua 1st Road,Futian District,Shenzhen Guangdong 518048China',1),('00:23:61','Unigen Corporation','Unigen Corporation45388 Warm Springs BlvdFremont Ca 94539United States',1),('00:23:62','Goldline Controls','Goldline Controls61 Whitecap DrNorth Kingstown Ri 02852United States',1),('00:23:63','Zhuhai Raysharp Technology Co., Ltd.','Zhuhai Raysharp Technology Co., Ltd.No.119 Of Huawei Road, Qianshan Science & Technology Park,Zhuhai Guangdong 519070China',1),('00:23:64','Power Instruments Pte Ltd','Power Instruments Pte LtdBlk 40 Toh Guan Rd East, #01-62 Enterprise Hub608582Singapore',1),('00:23:65','Elka-elektronik Gmbh','Elka-elektronik GmbhTalstrasse 104Ldenscheid Nrw 58515Germany',1),('00:23:66','Beijing Siasun Electronic System Co.,ltd.','Beijing Siasun Electronic System Co.,ltd.Rm.1018 Huatian Bldg, No.6 Bei XiaomachangHaidian DistrictBeijing  100038China',1),('00:23:67','Unicontrols A.s.','Unicontrols A.s.Krenicka 2257Prague 10  100 00Czech Republic',1),('00:23:68','Motorola','Motorola1 Motorola PlazaHoltsville Ny 11742United States',1),('00:23:69','Cisco-linksys, Llc','Cisco-linksys, Llc121 Theory DriveIrvine California 92612United States',1),('00:23:6A','Clearaccess, Inc.','Clearaccess, Inc.1301 Ne 144th StreetSuite 119Vancouver Wa 98685United States',1),('00:23:6B','Xembedded, Inc.','Xembedded, Inc.1050 Highland DrSuite EAnn Arbor Mi 48108United States',1),('00:23:6C','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:23:6D','Resmed Ltd','Resmed Ltd1, Elizabeth Macarthur DriveBella Vista Nsw 2153Australia',1),('00:23:6E','Burster Gmbh & Co Kg','Burster Gmbh & Co KgTalstrasse 1-5Gernsbach Baden-wrttemberg 76593Germany',1),('00:23:6F','Daq System','Daq System709-1, Bundang Techno Park A-dong,Yatap-dong, Bundang-guSungnam-si Kyunggi-do, 463-760Korea, Republic Of',1),('00:23:70','Pro-bel Limited','Pro-bel LimitedHartman HouseDanehillReading Berks Rg6 4pbUnited Kingdom',1),('00:23:71','Soam Systel','Soam Systel182-13, Daerung Post Tower Ii, 1504Seoul Guro-dong, Guro-gu 152-847Korea, Republic Of',1),('00:23:72','More Star Industrial Group Limited','More Star Industrial Group LimitedRm1221-1225, F12 Sangda Science And Technology Building ,Keji Road , Hi-tech Industrial Park,Shenzhen Guangdong 518057China',1),('00:23:73','Gridiron Systems, Inc.','Gridiron Systems, Inc.726 Palomar AveSunnyvale Ca 94085United States',1),('00:23:74','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:75','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:76','Htc Corporation','Htc CorporationNo.23 Hsin Hua Rd.Taoyuan Taiwan 330Taiwan, Republic Of China',1),('00:23:77','Isotek Electronics Ltd','Isotek Electronics Ltd9 Clayton Wood BankWest Park Ring RoadLeeds  Ls16 6qzUnited Kingdom',1),('00:23:78','Gn Netcom A/s','Gn Netcom A/sLautrupbjerg 7P.o.box 99Ballerup  Dk - 2750Denmark',1),('00:23:79','Union Business Machines Co. Ltd.','Union Business Machines Co. Ltd.Unit 2, 2/f, Block A, Hong Kong Industrial Centre,489-491 Castle Peak Road,Lai Chi Kok KowloonHong Kong',1),('00:23:7A','Rim','Rim295 Phillip StreetWaterloo Ontario N2l 3w8Canada',1),('00:23:7B','Whdi Llc','Whdi Llc2350 Mission College Blvd.Suite 500Santa Clara Ca 95054United States',1),('00:23:7C','Neotion','NeotionZi Les Paluds165, Avenue Du Marin BlancAubagne  F-13400France',1),('00:23:7D','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040802Houston Tx 77070United States',1),('00:23:7E','Elster Gmbh','Elster GmbhKuhbrueckenstrasse 2-4Hameln  31785Germany',1),('00:23:7F','Plantronics','Plantronics345 Encinal StSanta Cruz Ca 95060United States',1),('00:23:80','Nanoteq','NanoteqPo Box 79911 Pieter Street, Highveld ParkCenturion Gauteng 0046South Africa',1),('00:23:81','Lengda Technology(xiamen) Co.,ltd.','Lengda Technology(xiamen) Co.,ltd.5/f, 47 Haijing South 2nd Road,xiamen Export Processing Zone, Haicang District,Xiamen Fujian 361026China',1),('00:23:82','Lih Rong Electronic Enterprise Co., Ltd.','Lih Rong Electronic Enterprise Co., Ltd.No. 2, Lane 387, Hsin Shu Rd.Hsin Chuang City, Taipei 242Taiwan, Republic Of China',1),('00:23:83','Inmage Systems Inc','Inmage Systems Inc3255-1 Scott Blvd, #104Santa Clara Ca 95054United States',1),('00:23:84','Ggh Engineering S.r.l.','Ggh Engineering S.r.l.Via Santo Stefano, 29Bologna Bo 40125Italy',1),('00:23:85','Antipode','Antipode5 Rue De DouaiParis Ile De France 75009France',1),('00:23:86','Tour & Andersson Ab','Tour & Andersson AbAnnelundLjung  524 80Sweden',1),('00:23:87','Thinkflood, Inc.','Thinkflood, Inc.138 Claflin StBelmont Ma 02478United States',1),('00:23:88','V.t. Telematica S.p.a.','V.t. Telematica S.p.a.Via Gorky, 21San Giuliano Milanese Milano 20098Italy',1),('00:23:89','Hangzhou H3c Technologies Co., Ltd.','Hangzhou H3c Technologies Co., Ltd.Oriental Electronics Bldg., #2, Chuangye Roadshangdi Information Industry Base,Haidian District, Beijing, P.r.chinaBeijing  100085China',1),('00:23:8A','Ciena Corporation','Ciena Corporation920 Elkridge LandingLinthicum Md 21090United States',1),('00:23:8B','Quanta Computer Inc.','Quanta Computer Inc.No. 211, Wen Hwa 2rd.,kuei Shan Hsiang, Tao Yuan Shien,Taipei Taiwan 333Taiwan, Republic Of China',1),('00:23:8C','Private','',1),('00:23:8D','Techno Design Co., Ltd.','Techno Design Co., Ltd.312-2Toriko, Nishihara-muraAso-gun Kumamoto-ken 861-2401Japan',1),('00:23:8E','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano  20126Italy',1),('00:23:8F','Nidec Copal Corporation','Nidec Copal Corporation2-18-10,shimuraItabashi-ku Tokyo 174-8550Japan',1),('00:23:90','Algolware Corporation','Algolware Corporation13f-5, No. 77, Sec. 1, Sintai 5th Rd.,Sijhih City,Taipei County Taiwan 221Taiwan, Republic Of China',1),('00:23:91','Maxian','Maxian21th Fl. Kins Tower, 25-1Jeonja-dong, Bundang-guSeongnam-city Gyeonggi-do 463-847Korea, Republic Of',1),('00:23:92','Proteus Industries Inc.','Proteus Industries Inc.340 Pioneer WayMountain View Ca 94041United States',1),('00:23:93','Ajinextek','Ajinextek9-3, Holimdong, DalseoguDaegu  704-240Korea, Republic Of',1),('00:23:94','Samjeon','Samjeon#1313-1 Joil-ri, Samdong-myeun,ulju-gunUlsan City South Korea 689-934Korea, Republic Of',1),('00:23:95','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:96','Andes Technology Corporation','Andes Technology Corporation2f,no. 1, Li-hsin First Road,Science-based Industrial ParkHsin-chu Taiwan 300Taiwan, Republic Of China',1),('00:23:97','Westell Technologies Inc.','Westell Technologies Inc.11852 Presley CrPlainfield Il 60585United States',1),('00:23:98','Sky Control','Sky ControlUl. Svornosti 41Bratislava Ba 82 107Slovakia',1),('00:23:99','Vd Division, Samsung Electronics Co.','Vd Division, Samsung Electronics Co.416, Maetan-3dong, Yeongtong-gu, Suwon-cityKoreaSuwon  443-742Korea, Republic Of',1),('00:23:9A','Easydata Software Gmbh','Easydata Software GmbhSteinbacher Strae 14-24Eschborn / Ts. Hessen D-65760Germany',1),('00:23:9B','Elster Integrated Solutions','Elster Integrated Solutions208 South Rogers LaneRaleigh North Carolina 27610United States',1),('00:23:9C','Juniper Networks','Juniper Networks1194 N Mathilda AvenueSunnyvale Ca 94089United States',1),('00:23:9D','Mapower Electronics Co., Ltd','Mapower Electronics Co., Ltd5f-2, No. 492-19, Sec 1,Wanshou Rd., Guishan ShiangTaoyuan  333Taiwan, Republic Of China',1),('00:23:9E','Jiangsu Lemote Technology Corporation Limited','Jiangsu Lemote Technology Corporation LimitedMenglan Industrial Park,yushanChangshu Jiangsu 215500China',1),('00:23:9F','Institut Fr Prftechnik','Institut Fr PrftechnikSchulstr. 3Todtenweis Bayern 86447Germany',1),('00:23:A0','Hana Cns Co., Ltd.','Hana Cns Co., Ltd.Taejang-dong 1720-52 Taejang-nonggong-danjiWonju Gangwon-do 220-962Korea, Republic Of',1),('00:23:A1','Trend Electronics Ltd','Trend Electronics LtdGut No. 350Village - BhalgaonAuranagabad Maharashtra 431210India',1),('00:23:A2','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:A3','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:A4','New Concepts Development Corp.','New Concepts Development Corp.2650 Bridge LaneWoodstock Il 60098United States',1),('00:23:A5','Sagetv, Llc','Sagetv, Llc9800 S. La Cienega BlvdSuite 905Inglewood Ca 90301United States',1),('00:23:A6','E-mon','E-monOne Oxford Valley, Suite 418Langhorne Pa 19047United States',1),('00:23:A7','Redpine Signals, Inc.','Redpine Signals, Inc.Plot 87, Sagar SocietyBanjara Hills Road No. 2Hyderabad Ap 500034India',1),('00:23:A8','Marshall Electronics','Marshall Electronics1910 E Maple AveEl Segundo Ca 90245United States',1),('00:23:A9','Beijing Detianquan Electromechanical Equipment Co., Ltd','Beijing Detianquan Electromechanical Equipment Co., LtdNo. 2 Chapeng Road, Haidian District,Beijing  100091China',1),('00:23:AA','Hfr, Inc.','Hfr, Inc.5f, Hana Ez Tower158, Gumi-dong, Bundang-guSungnam-si Kyunggi-do 463-870Korea, Republic Of',1),('00:23:AB','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:AC','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:AD','Xmark Corporation','Xmark Corporation309 Legget  DriveOttawa Ontario K2k 3a3Canada',1),('00:23:AE','Dell Inc.','Dell Inc.One Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:23:AF','Motorola Mobile Devices','Motorola Mobile Devices600 N. U.s. Highway 45Libertyville Illinois 60048United States',1),('00:23:B0','Comxion Technology Inc.','Comxion Technology Inc.11f, No. 111, Sec 2, Keelung Rd., Sinyi DistricTaipei Taiwan 110Taiwan, Republic Of China',1),('00:23:B1','Longcheer Technology (singapore) Pte Ltd','Longcheer Technology (singapore) Pte Ltd43 Kaki Bukit View,  #04-01  ,Kaki Bukit Tech Park Ii,415970Singapore',1),('00:23:B2','Intelligent Mechatronic Systems Inc','Intelligent Mechatronic Systems Inc161 Roger StreetWaterloo Ontario N2j 1b1Canada',1),('00:23:B3','Lyyn Ab','Lyyn AbIdeon Science ParkScheelevgen 17Lund  223 70Sweden',1),('00:23:B4','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:23:B5','Ortana Ltd','Ortana LtdOstim Kocasinan Sanayi Sitesi13. Sokak No:37-39 Y. MahalleAnkara  06370Turkey',1),('00:23:B6','Securite Communications / Honeywell','Securite Communications / HoneywellFont De Lorme1198 Av Du Docteur DonatMougins France 06250France',1),('00:23:B7','Q-light Co., Ltd.','Q-light Co., Ltd.178-1 Woogye-ri, Sangdong-myun,Gimhae-si Gyungsangnam-do 621-812Korea, Republic Of',1),('00:23:B8','Sichuan Jiuzhou Electronic Technology Co.,ltd','Sichuan Jiuzhou Electronic Technology Co.,ltdNo.259 Jiuzhou Road,Mianyang Sichuan 621000China',1),('00:23:B9','Eads Deutschland Gmbh','Eads Deutschland GmbhWilly Messerschmitt Str.Ottobrunn Bavaria 85521Germany',1),('00:23:BA','Chroma','Chroma68, Hwa-ya 1st Rd., Hwa-ya Technical Park,Kuei-shan Hsiang,Taoyuan Hsien Taiwan 333Taiwan, Republic Of China',1),('00:23:BB','Schmitt Industries','Schmitt Industries2765 Nw Nicolai StPortland Oregon 97210United States',1),('00:23:BC','Eq-sys Gmbh','Eq-sys GmbhHinter Den Grten 15bTreuenbrietzen Ot Feldheim Brandenburg 14929Germany',1),('00:23:BD','Digital Ally, Inc.','Digital Ally, Inc.1218 Valley Ridge DriveGrain Valley Mo 64029United States',1),('00:23:BE','Cisco Spvtg','Cisco Spvtg5030 Sugarloaf PkwyLawrenceville Ga 30044United States',1),('00:23:BF','Mainpine, Inc.','Mainpine, Inc.Po Box 241Wilsonville Oregon 97070-0241United States',1),('00:23:C0','Broadway Networks','Broadway Networks1754 Technology Drive, Suite 208San Jose California 95110United States',1),('00:23:C1','Securitas Direct Ab','Securitas Direct AbKalendegatan 26Malm  20320Sweden',1),('00:23:C2','Samsung Electronics. Co. Ltd','Samsung Electronics. Co. Ltd19th Fl., Korea Life Bldg. 1338-12Seocho 2 Dong Seocho-gu Domastic Sales& Marketing DivisionSeoul  137-860Korea, Republic Of',1),('00:23:C3','Logmein, Inc.','Logmein, Inc.500 Unicorn Park DriveWoburn Massachusetts 01801United States',1),('00:23:C4','Lux Lumen','Lux LumenKernenergiestraat 53aWilrijk Antwerp 2610Belgium',1),('00:23:C5','Radiation Safety And Control Services Inc','Radiation Safety And Control Services Inc91 Portsmouth AveStratham New Hampshire 03885United States',1),('00:23:C6','Smc Corporation','Smc Corporation4-2-2, KinunodaiTsukuba Mirai-shi Ibaraki-ken 300-2493Japan',1),('00:23:C7','Avsystem','AvsystemUl. Friedleina 4Krakw Maopolskie 30-009Poland',1),('00:23:C8','Team-r','Team-rGragdanski Str.111, A, 9-nSt. Petersburg  195265Russian Federation',1),('00:23:C9','Sichuan Tianyi Information Science & Technology Stock Co.,ltd','Sichuan Tianyi Information Science & Technology Stock Co.,ltdNo.1,hot Spring Highway,dayi CountyChengdu Sichuan 611330China',1),('00:23:CA','Behind The Set, Llc','Behind The Set, Llc2185 Knollwood Dr.Boulder Co 80302United States',1),('00:23:CB','Shenzhen Full-join Technology Co.,ltd','Shenzhen Full-join Technology Co.,ltd9/f,no.1,xinrui Road,hourui ,xixiang Town, Baoan DistrictShenzhen Guangdong 518000China',1),('00:23:CC','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:23:CD','Tp-link Technologies Co., Ltd.','Tp-link Technologies Co., Ltd.South Building, No.5 Keyuan Road, Central Zone,Science & Technology Park NanshanShenzhen Guangdong 518000China',1),('00:23:CE','Kita Denshi Corporation','Kita Denshi Corporation12f Tokyo-nishiikebukuro Bilg.,1-7-7, Nishi-ikebukuroToshima-ku, Tokyo 171-0021Japan',1),('00:23:CF','Cummins-allison Corp.','Cummins-allison Corp.891 Feehanville DriveMt. Prospect Il 60056United States',1),('00:23:D0','Uniloc Usa Inc.','Uniloc Usa Inc.3333 Michelson DriveSuite 600Irvine Ca 92612United States',1),('00:23:D1','Trg','TrgWisma Kosgoro 13th FloorJl. Mh. Thamrin 53Jakarta Pusat  10350Indonesia',1),('00:23:D2','Inhand Electronics, Inc.','Inhand Electronics, Inc.30 West Gude DriveSuite 550Rockville Maryland 20850United States',1),('00:23:D3','Airlink Wifi Networking Corp.','Airlink Wifi Networking Corp.19f-1 Room A , No.97, Sec 4, Chung Hsin Rd.,San Chung City, Taipei Hsien 241Taiwan, Republic Of China',1),('00:23:D4','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:23:D5','Warema Electronic Gmbh','Warema Electronic GmbhDillberg 33Marktheidenfeld Bavaria 97828Germany',1),('00:23:D6','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:23:D7','Samsung Electronics','Samsung Electronics#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:23:D8','Ball-it Oy','Ball-it OyUusikatu 24 G 76Oulu  90100Finland',1),('00:23:D9','Banner Engineering','Banner Engineering9714 10th Ave. N.Plymouth Mn 55441United States',1),('00:23:DA','Industrial Computer Source (deutschland)gmbh','Industrial Computer Source (deutschland)gmbhMarie-curie-strae 9Pulheim Nrw 50259Germany',1),('00:23:DB','Saxnet Gmbh','Saxnet GmbhWilly-brandt-ring 1Oelsnitz Sachsen 08606Germany',1),('00:23:DC','Benein, Inc','Benein, IncHyojachonjesangga228 B9, 297,Seohyun-dong, Bundang-guSengnam-si Kyunggi-do 463-818Korea, Republic Of',1),('00:23:DD','Elgin S.a.','Elgin S.a.Rua Barao De Campinas, 305Campos EliseosSao Paulo  01201-901Brazil',1),('00:23:DE','Ansync Inc.','Ansync Inc.4970 Robert J Matthews PkySuite 160El Dorado Hills Ca 95762United States',1),('00:23:DF','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:23:E0','Ino Therapeutics Llc','Ino Therapeutics Llc2902 Dairy DriveMadison Wi 53718United States',1),('00:23:E1','Cavena Image Products Ab','Cavena Image Products AbNytorpsvagen 26Tby Stockholm Se-183 53Sweden',1),('00:23:E2','Sea Signalisation','Sea Signalisation20-22 Rue Pierre Mends FranceBp 231Vaulx En Velin Cedex  69515France',1),('00:23:E3','Microtronic Ag','Microtronic AgDuennernstrasse 32Oensingen Solothurn 4702Switzerland',1),('00:23:E4','Ipnect Co. Ltd.','Ipnect Co. Ltd.808 Albatross B/d 237-18Gasan-dong, Geumcheon-guSeoul  153-801Korea, Republic Of',1),('00:23:E5','Ipaxiom Networks','Ipaxiom NetworksAston CourtKingsmead Business Park, Frederick PlaceHigh Wycombe Buckinghamshire Hp11 1laUnited Kingdom',1),('00:23:E6','Pirkus, Inc.','Pirkus, Inc.2f,1-1-2ShimuraItabashi-ku Tokyo 174-0056Japan',1),('00:23:E7','Hinke A/s','Hinke A/sTingbjergvej 2Bjaeverskov  Dk-4632Denmark',1),('00:23:E8','Demco Corp.','Demco Corp.#919, Doosan Venturedigm, 126-1Pyungchon-dong, Dongan-kuAnyang-si Kyungki-do 431-070Korea, Republic Of',1),('00:23:E9','F5 Networks, Inc.','F5 Networks, Inc.401 Elliott Ave. W.Seattle Wa 98119United States',1),('00:23:EA','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:EB','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:23:EC','Algorithmix Gmbh','Algorithmix GmbhKlettgaustrasse 21Waldshut-tiengen Bw 79761Germany',1),('00:23:ED','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:EE','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:23:EF','Zuend Systemtechnik Ag','Zuend Systemtechnik AgIndustriestrasse 8Altstaetten Sg 9450Switzerland',1),('00:23:F0','Shanghai Jinghan Weighing Apparatus Co. Ltd.','Shanghai Jinghan Weighing Apparatus Co. Ltd.Building 58, No.99 Chunguang Road, Xinzhuang Industrial Zone,minhang,Shanghai  201108China',1),('00:23:F1','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund Skne 22188Sweden',1),('00:23:F2','Tvlogic','TvlogicSuite 914 Ace Techno Tower-9thGasan-dongGeumcheon-gu Seoul 153-782Korea, Republic Of',1),('00:23:F3','Glocom, Inc.','Glocom, Inc.22 Firstfield RoadSuite 125Gaithersburg Maryland 20878United States',1),('00:23:F4','Masternaut','Masternaut4, Rue Charles CrosLouviers  27407France',1),('00:23:F5','Wilo Se','Wilo SeNortkirchenstr. 100D - 44263 Dortmund Nrw 44263Germany',1),('00:23:F6','Softwell Technology Co., Ltd.','Softwell Technology Co., Ltd.4f, No. 419, Jhonghe Rd., Yonghe City,Taipei County  234Taiwan, Republic Of China',1),('00:23:F7','Private','',1),('00:23:F8','Zyxel Communications Corporation','Zyxel Communications CorporationNo.6 Innovation Road Ii,Science Park,Hsin-chu, Taiwan 300Taiwan, Republic Of China',1),('00:23:F9','Double-take Software, Inc.','Double-take Software, Inc.8470 Allison Pointe BlvdSuite 300Indianapolis In 46250United States',1),('00:23:FA','Rg Nets, Inc.','Rg Nets, Inc.1000 E. William StreetSuite 204Carson City Nv 89701United States',1),('00:23:FB','Ip Datatel, Inc.','Ip Datatel, Inc.13110 Southwest FreewaySugar Land Texas 77478United States',1),('00:23:FC','Ultra Stereo Labs, Inc','Ultra Stereo Labs, Inc181 Bonetti DriveSan Luis Obispo Ca 93401United States',1),('00:23:FD','Aft Atlas Fahrzeugtechnik Gmbh','Aft Atlas Fahrzeugtechnik GmbhGewerbestr. 14Werdohl  58791Germany',1),('00:23:FE','Biodevices, Sa','Biodevices, SaRua 5 De Outubro 309Porto  4100-175Portugal',1),('00:23:FF','Beijing Httc Technology Ltd.','Beijing Httc Technology Ltd.B-13d-3 Keshi Building,jia No.28 Xinxi Road,shangdi It Industry BaseBeijing  100085China',1),('00:24:00','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75082United States',1),('00:24:01','D-link Corporation','D-link CorporationNo.289, Xinhu 3rd.Neihu District Taipei City 114Taiwan, Republic Of China',1),('00:24:02','Op-tection Gmbh','Op-tection GmbhBorsigstrae 80Heinsberg Germany 52525Germany',1),('00:24:03','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:24:04','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:24:05','Dilog Nordic Ab','Dilog Nordic AbFaktorvgen 9Kungsbacka Halland 439 34Sweden',1),('00:24:06','Pointmobile','Pointmobile301,world Meridian Verture Center-1 60-24Gasan-dongSeoul Geumcheon-gu 153781Korea, Republic Of',1),('00:24:07','Telem Sas','Telem Sas16, Rue De LetangGieres Rhone Alpes 38610France',1),('00:24:08','Pacific Biosciences','Pacific Biosciences1505 Adams DriveMenlo Park Ca 94025United States',1),('00:24:09','The Toro Company','The Toro Company5825 Jasmine StreetRiverside Ca 92504United States',1),('00:24:0A','Us Beverage Net','Us Beverage Net1001 W. Fayette Street3aSyracuse Ny 13204United States',1),('00:24:0B','Virtual Computer Inc.','Virtual Computer Inc.3 Lan DriveWestford Ma 01886United States',1),('00:24:0C','Delec Gmbh','Delec GmbhRuheweg 17-21Gllheim Rheinland-pfalz 67307Germany',1),('00:24:0D','Onepath Networks Ltd.','Onepath Networks Ltd.8 Hartom StJerusalem  91450Israel',1),('00:24:0E','Inventec Besta Co., Ltd.','Inventec Besta Co., Ltd.10fl, No.36, Lane 513, Rui Guang Road, Nei Hu Dist.Taipei  114Taiwan, Republic Of China',1),('00:24:0F','Ishii Tool & Engineering Corporation','Ishii Tool & Engineering Corporation2-5-60 Higashi-omichiOita  870-0823Japan',1),('00:24:10','Nueteq Technology,inc.','Nueteq Technology,inc.11f, No. 112, Sec. 1, Zhong-xiao E Rd.Taipei  100Taiwan, Republic Of China',1),('00:24:11','Pharmasmart Llc','Pharmasmart Llc3495 Winton PlaceBldg A, Suite 1Rochester Ny 14623United States',1),('00:24:12','Benign Technologies Co, Ltd.','Benign Technologies Co, Ltd.504 Room, 5f, South Building, Forsafe Tower,South One Street, Hi-tech Zone,Shenzhen Guangdong 518057China',1),('00:24:13','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:14','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:15','Magnetic Autocontrol Gmbh','Magnetic Autocontrol GmbhGrienmatt 20Schopfheim  D-79650Germany',1),('00:24:16','Any Use','Any UseLg Apt 211-1805,Shinbong-dong, Suji-gu,Yongin City Gyeong-gi Province 448-150Korea, Republic Of',1),('00:24:17','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47Edegem - Antwerp  B-2650Belgium',1),('00:24:18','Nextwave Semiconductor','Nextwave Semiconductor3611 Valley Centre DrSan Diego Ca 92130United States',1),('00:24:19','Private','',1),('00:24:1A','Red Beetle Inc.','Red Beetle Inc.898 Silas Deane HighwayWethersfield Ct 06109United States',1),('00:24:1B','Iwow Communications Pte Ltd','Iwow Communications Pte Ltd1 Lorong 2 Toa Payoh #04-01Yellow Pages Building319637Singapore',1),('00:24:1C','Fugang Electronic (dg) Co.,ltd','Fugang Electronic (dg) Co.,ltdIndustry Street, Dong-kengGuang Dong ProvinceDong Guan City  523448China',1),('00:24:1D','Giga-byte Technology Co.,ltd.','Giga-byte Technology Co.,ltd.No.215,nan-ping Road,Pin-jen Taoyuan 324Taiwan, Republic Of China',1),('00:24:1E','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto  601-8501Japan',1),('00:24:1F','Dct-delta Gmbh','Dct-delta GmbhBodanrueckstrasse 1Bodman - Ludwigshafen Baden - Wrttemberg 78351Germany',1),('00:24:20','Netup Inc.','Netup Inc.Olof Palme St., 1, Sect. 7Moscow  119311Russian Federation',1),('00:24:21','Micro-star Intl Co., Ltd.','Micro-star Intl Co., Ltd.No.69, Li-de StJung-ho CityTaipei Hsien  235Taiwan, Republic Of China',1),('00:24:22','Knapp Logistik Automation Gmbh','Knapp Logistik Automation GmbhGnter-knapp-strasse 5-7Hart Bei Graz Styria 8075Austria',1),('00:24:23','Azurewave Technologies (shanghai) Inc.','Azurewave Technologies (shanghai) Inc.No. 8, Lane 66, Chengbao Rd.Malu County, Jiading District,Shanghai  201801China',1),('00:24:24','Axis Network Technology','Axis Network TechnologyUnit 10, Midshires Bus ParkSmeaton CloseAylesbury Bucks Hp19 8hlUnited Kingdom',1),('00:24:25','Shenzhenshi Chuangzhicheng Technology Co.,ltd','Shenzhenshi Chuangzhicheng Technology Co.,ltd5th Floor,block2,25th Building,industrial Zone West Keyuan Sci-tech Garden Nanshan Districh,shenzhenShenzhen Guangdong 518057China',1),('00:24:26','Nohmi Bosai Ltd.','Nohmi Bosai Ltd.7-3,kudan-minami 4-chome,Chiyoda-kuTokyo  102-8277Japan',1),('00:24:27','Ssi Computer Corp','Ssi Computer Corp4f, No4, Lane 235, Bao Chiao RoadHsin Tien Taipei 231Taiwan, Republic Of China',1),('00:24:28','Energyict','EnergyictTheodoor Sevenslaan 104aKortrijk  8500Belgium',1),('00:24:29','Mk Master Inc.','Mk Master Inc.6f, -1, No. 110,sec. 3, Jhongshan Rd.,Jhong-he City, Taipei County 235Taiwan, Republic Of China',1),('00:24:2A','Hittite Microwave Corporation','Hittite Microwave Corporation20 Alpha RdChelmsford Ma 01824United States',1),('00:24:2B','Hon Hai Precision Ind.co.,ltd.','Hon Hai Precision Ind.co.,ltd.66,chung Shan Rd.tu-chengTaipei Hsien Taiwan 236Taiwan, Republic Of China',1),('00:24:2C','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.66,chung Shan Rd.tu-chengTaipei Hsien  236Taiwan, Republic Of China',1),('00:24:2D','Ronan Engineering','Ronan Engineering21200 OxnardWoodland Hills Ca 91367United States',1),('00:24:2E','Datastrip Inc.','Datastrip Inc.1 Waterview DriveSuite 103Shelton Ct 06484United States',1),('00:24:2F','Virtensys Inc','Virtensys Inc8705 Nimbus Ave Ste 100Beaverton Or 97008United States',1),('00:24:30','Ruby Tech Corp.','Ruby Tech Corp.3f, No. 1, Lane 50, Nan Kang Road, Sec. 3,Taipei  11510Taiwan, Republic Of China',1),('00:24:31','Uni-v Co.,ltd','Uni-v Co.,ltd5/f,cofco Property Tower,The 3rd Area, BaoanShenzhen Guangdong 518126China',1),('00:24:32','Neostar Technology Co.,ltd','Neostar Technology Co.,ltd8f., No.102, Sec. 1, Sintai 5th Rd.Sijhih City Taipei 22161Taiwan, Republic Of China',1),('00:24:33','Alps Electric Co., Ltd','Alps Electric Co., Ltd1-2-1, OkinouchiSoma City  976-8501Japan',1),('00:24:34','Lectrosonics, Inc.','Lectrosonics, Inc.581 Laser Rd.Rio Rancho Nm 87124United States',1),('00:24:35','Wide Corporation','Wide CorporationLeaders Tower 7th Fl., Gomae-dong, Giheung-guYongin Gyeonggi 446-901Korea, Republic Of',1),('00:24:36','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:24:37','Motorola - Bsg','Motorola - Bsg1101 Marina Village PkwySte 200Alameda Ca 94501United States',1),('00:24:38','Foundry Networks','Foundry Networks2100 Gold StreetPo Box 649100San Jose Ca 95164United States',1),('00:24:39','Essential Viewing Systems Limited','Essential Viewing Systems LimitedHillington Park Innovation Centre1 Ainslie RoadGlasgow Renfrewshire G52 4ruUnited Kingdom',1),('00:24:3A','Ludl Electronic Products','Ludl Electronic Products171 Brady AveHawthorne Ny 10532United States',1),('00:24:3B','Cssi (s) Pte Ltd','Cssi (s) Pte Ltd70 Bendemeer Road Unit 04-04339940Singapore',1),('00:24:3C','S.a.a.a.','S.a.a.a.Z.a. Croix Saint MathieuGallardon Eure Et Loir 28320France',1),('00:24:3D','Emerson Appliance Motors And Controls','Emerson Appliance Motors And Controls1901 South St.Elgin Il 60123United States',1),('00:24:3E','Private','',1),('00:24:3F','Storwize, Inc.','Storwize, Inc.11 Alatlef St.Yehud  56216Israel',1),('00:24:40','Halo Monitoring, Inc.','Halo Monitoring, Inc.515 Sparkman Dr.Huntsville Al 35816United States',1),('00:24:41','Wanzl Metallwarenfabrik Gmbh','Wanzl Metallwarenfabrik GmbhBubesheimer Strasse 4Leipheim Bavaria 89340Germany',1),('00:24:42','Axona Limited','Axona Limited148 Green LaneSt. Albans Herts Al3 6euUnited Kingdom',1),('00:24:43','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75082United States',1),('00:24:44','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:24:45','Liquidxstream Systems Inc.','Liquidxstream Systems Inc.8480 Boul. Du GolfMontreal Quebec H1j 3a1Canada',1),('00:24:46','Mmb Research Inc.','Mmb Research Inc.35 Prince Arthur Ave.Toronto Ontario M5r 1b2Canada',1),('00:24:47','Kaztek Systems','Kaztek Systems17 Bromfield RoadActon Ma 01720United States',1),('00:24:48','Spidercloud Wireless, Inc','Spidercloud Wireless, Inc3900 Freedom Circle, Suite 104Santa Clara Ca 95054United States',1),('00:24:49','Shen Zhen Lite Star Electronics Technology Co., Ltd','Shen Zhen Lite Star Electronics Technology Co., LtdXinghong Science Park,1st Ind.area,Fenghuangguang, Xixiang,baoan AreaShenzhen Guangdong 518102China',1),('00:24:4A','Voyant International','Voyant International444 Castro StMountain View Ca 94041United States',1),('00:24:4B','Perceptron Inc','Perceptron Inc47827 Halyard DrPo #cc67348Plymouth Mi 48170United States',1),('00:24:4C','Solartron Metrology Ltd','Solartron Metrology LtdSteyning WayBognor Regis West Sussex Po20 9stUnited Kingdom',1),('00:24:4D','Hokkaido Electronics Corporation','Hokkaido Electronics Corporation1-1 East 10 North 10Higashi-kuSapporo Hokkaido 065-0010Japan',1),('00:24:4E','Radchips, Inc.','Radchips, Inc.422 East Vermijo Ave.Suite 401Colorado Springs Co 80903United States',1),('00:24:4F','Asantron Technologies Ltd.','Asantron Technologies Ltd.3f-1, No.30 Jihe Rd., 111Shihlin DistrictTaipei  11166Taiwan, Republic Of China',1),('00:24:50','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:51','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:52','Silicon Software Gmbh','Silicon Software GmbhSteubenstr. 46Mannheim Baden-wrttemberg 68163Germany',1),('00:24:53','Initra D.o.o.','Initra D.o.o.Slomskova 33Ljubljana  1000Slovenia',1),('00:24:54','Samsung Electronics Co., Ltd','Samsung Electronics Co., Ltd416, Maetan 3dong, Yeongtong-gu,Suwon Gyeonggi-do 443742Korea, Republic Of',1),('00:24:55','Mulogic Bv','Mulogic BvOlivier Van Noortstraat 4Schiedam Zh 3124laNetherlands',1),('00:24:56','2wire','2wire1764 Automation ParkwaySan Jose Ca 95131United States',1),('00:24:57','Hammock Coporation','Hammock Coporation7-8-f 30sankyo-building1-30-4 TakadanobabaShinjuku-ward Tokyo 169-0075Japan',1),('00:24:58','Pa Bastion Cc','Pa Bastion Cc97, Liter K, Buddyonnovsky Ave.Rostov-on-don  344011Russian Federation',1),('00:24:59','Abb Stotz-kontakt Gmbh','Abb Stotz-kontakt GmbhEppelheimer Strae 82Sto/ke1Heidelberg  69123Germany',1),('00:24:5A','Nanjing Panda Electronics Company Limited','Nanjing Panda Electronics Company LimitedZhongshan Eastroad 301,Nanjing Jiangsu 210016China',1),('00:24:5B','Raidon Technology, Inc.','Raidon Technology, Inc.4f-8, No.16, Lane 609, Sec.5, Chung-hsin Rd.,San-chung City Taipei County, 24159Taiwan, Republic Of China',1),('00:24:5C','Design-com Technologies Pty. Ltd.','Design-com Technologies Pty. Ltd.14 Redland DriveMitcham Victoria 3132Australia',1),('00:24:5D','Terberg Besturingstechniek B.v.','Terberg Besturingstechniek B.v.Lage Dijk-noord 3Ijsselstein Utrecht 3401 VaNetherlands',1),('00:24:5E','Hivision Co.,ltd','Hivision Co.,ltd2201-2202, Cofco Property Tower,3rd Baoan DistrictShenzhen Guangdong 518101China',1),('00:24:5F','Vine Telecom Co.,ltd.','Vine Telecom Co.,ltd.191-4, 4f, Anyang-dong, Manan-guAnyang-si Gyeonggi-do 430-010Korea, Republic Of',1),('00:24:60','Giaval Science Development Co. Ltd.','Giaval Science Development Co. Ltd.58 Bei Si Huan Xi RdIdeal Plaza, Suite 413Beijing 100080China',1),('00:24:61','Shin Wang Tech.','Shin Wang Tech.632-62, Guro-dong, Guro-gu105-ho, C-dong, Guroculation Dept.Seoul  152-866Korea, Republic Of',1),('00:24:62','Rayzone Corporation','Rayzone Corporation#2008, B-dong, Samho BldgYangjae2-dong, Seocho-guSeoul  137-941Korea, Republic Of',1),('00:24:63','Phybridge Inc','Phybridge Inc1200 Speers RoadUnit 37Oakville Ontario L6l2x4Canada',1),('00:24:64','Bridge Technologies Co As','Bridge Technologies Co AsMlleparken 4Oslo  0459Norway',1),('00:24:65','Elentec','Elentec401-13 Chunggye-ri,dongtan-myunHwasung Kyunggi 445-811Korea, Republic Of',1),('00:24:66','Unitron Nv','Unitron NvFranrkijklaan 27Poperinge W-vl 8970Belgium',1),('00:24:67','Aoc International (europe) Gmbh','Aoc International (europe) GmbhLahnstrasse 86aBerlin  12055Germany',1),('00:24:68','Sumavision Technologies Co.,ltd','Sumavision Technologies Co.,ltd6f, Block A2, Power Creative Building,no.1 Shangdi East Road, Haidian DistrictBeijing  100085China',1),('00:24:69','Smart Doorphones','Smart DoorphonesSpieveldstraat 24Lokeren  9160Belgium',1),('00:24:6A','Solid Year Co., Ltd.','Solid Year Co., Ltd.2f-1, No. 94, Bao-chung Road,Hsin-tien City Taipei Hsien 23147Taiwan, Republic Of China',1),('00:24:6B','Coventive','CoventiveBenex S-3 Bldg., 3-20-8, Shinyokohama,kohoku-ku,Yokohama-city Kanagawa-pref. 222-0033Japan',1),('00:24:6C','Aruba Networks, Inc.','Aruba Networks, Inc.1344 Crossman AvenueSunnyvale Ca 94089United States',1),('00:24:6D','Weinzierl Engineering Gmbh','Weinzierl Engineering GmbhBahnhofstr. 6Tyrlaching Bavaria 84558Germany',1),('00:24:6E','Phihong Usa Corp.','Phihong Usa Corp.47800 Fremont Blvd.Fremont Ca 94538United States',1),('00:24:6F','Onda Communication Spa','Onda Communication SpaVia Del Lavoro 9Pordenone  33170Italy',1),('00:24:70','Aurotech Ultrasound As.','Aurotech Ultrasound As.Svingen 1Tydal Sr-tr N-7590Norway',1),('00:24:71','Fusion Multisystems Dba Fusion-io','Fusion Multisystems Dba Fusion-io6350 S. 3000 E., 6th FloorSalt Lake City Ut 84121United States',1),('00:24:72','Redriven Power Inc.','Redriven Power Inc.24a Bath Rd.Iroquois Ontario K0e 1k0Canada',1),('00:24:73','3com Europe Ltd','3com Europe LtdPeople Building 2Maylands AvenueHemel Hempstead Herts. Hp2 4nwUnited Kingdom',1),('00:24:74','Autronica Fire And Securirty','Autronica Fire And SecurirtyHaakon Viis G.4Trondheim N-7483Norway',1),('00:24:75','Compass System(embedded Dept.)','Compass System(embedded Dept.)1403 Ace Technotower 8th191-7, Guro-dong, Guro-guSeoul  152-050Korea, Republic Of',1),('00:24:76','Tap.tv','Tap.tv16w361 South Frontage RoadSuite 128Burr Ridge Il 60527United States',1),('00:24:77','Tibbo Technology','Tibbo Technology9f-3, No 31, Lane 169, Kang-ning St.,Hsi-chih Taipei Hsien 221Taiwan, Republic Of China',1),('00:24:78','Mag Tech Electronics Co Limited','Mag Tech Electronics Co LimitedFlat / Room T78 Gof Bangkok Building18 Bonham Strand WestSheung Wan HkHong Kong',1),('00:24:79','Optec Displays, Inc.','Optec Displays, Inc.528 S. 6th AvenueCity Of Industry California 91746United States',1),('00:24:7A','Fu Yi Cheng Technology Co., Ltd.','Fu Yi Cheng Technology Co., Ltd.13f, No. 105-1, Jilin Rd., Luju Shiang,Taoyuan  338Taiwan, Republic Of China',1),('00:24:7B','Actiontec Electronics, Inc','Actiontec Electronics, Inc760 North Mary AveSunnyvale Ca 94085United States',1),('00:24:7C','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790vDenmark',1),('00:24:7D','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:24:7E','Usi','Usi141, Lane 351, Taiping Rd.Sec.1, Tsao TuenNan-tou 542Tanzania, United Republic Of',1),('00:24:7F','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75082-4399United States',1),('00:24:80','Meteocontrol Gmbh','Meteocontrol GmbhSpichererstrasse 48Augsburg Bavaria 86152Germany',1),('00:24:81','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040802Houston Tx 77070United States',1),('00:24:82','Ruckus Wireless','Ruckus Wireless880 West Maude Ave.Suite 101Sunnyvale Ca 94085United States',1),('00:24:83','Lg Electronics','Lg Electronics60-39,kasan-dong,kumchon-ku,Seoul  153-801Korea, Republic Of',1),('00:24:84','Bang And Olufsen Medicom A/s','Bang And Olufsen Medicom A/sGimsinglundvej 20Struer Dk Dk7600Denmark',1),('00:24:85','Contextream Ltd','Contextream Ltd94 Em-hamoshavotPob 3246Petach-tikva  49527Israel',1),('00:24:86','Designart Networks','Designart Networks4 Haharoshet StP.o. Box 2278Raanana  43101Israel',1),('00:24:87','Blackboard Inc.','Blackboard Inc.22601 North 19th AvenueSuite 200Phoenix Az 85027United States',1),('00:24:88','Centre For Development Of Telematics','Centre For Development Of TelematicsB01, Electronic City, Phase 1Hosur RoadBangalore Karnataka 560100India',1),('00:24:89','Vodafone Omnitel N.v.','Vodafone Omnitel N.v.Via Jervis 1310015 Ivrea TorinoItaly',1),('00:24:8A','Kaga Electronics Co., Ltd.','Kaga Electronics Co., Ltd.Hongo 2-2-9Bunkyo-kuTokyo 113-8503Japan',1),('00:24:8B','Hybus Co., Ltd.','Hybus Co., Ltd.Rm# 701, Daerung Post Tower 1st212-8, Guro-3dong, Guro-guSeoul  152-790Korea, Republic Of',1),('00:24:8C','Asustek Computer Inc.','Asustek Computer Inc.15,li-te Rd.,peitou,Taipei  112Taiwan, Republic Of China',1),('00:24:8D','Sony Computer Entertainment Inc.','Sony Computer Entertainment Inc.2-6-21 Minami-aoyama,Minato-ku Tokyo 107-0062Japan',1),('00:24:8E','Infoware Zrt.','Infoware Zrt.Huseg U. 10/aBudapest  1223Hungary',1),('00:24:8F','Do-monix','Do-monix#501, Koreana B/d7-5, Sunae-dong, Bundang-guSeongnam-si Gyeonggi-do 82Korea, Democratic Peoples Republi',1),('00:24:90','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:24:91','Samsung Electronics','Samsung Electronics#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:24:92','Motorola, Broadband Solutions Group','Motorola, Broadband Solutions Group1101 Marina Village ParkwaySuite 200Alameda Ca 94501United States',1),('00:24:93','Motorola, Inc','Motorola, Inc1101 Marina Village ParkwaySuite 200Alameda Ca 94501United States',1),('00:24:94','Shenzhen Baoxin Tech Co., Ltd.','Shenzhen Baoxin Tech Co., Ltd.6f Huale Bldg., Zhonghangbei Rd.,Futian DistrictShenzhen Guangdong 518028China',1),('00:24:95','Motorola Mobile Devices','Motorola Mobile Devices600 N. U.s. Highway 45Libertyville Illinois 60048United States',1),('00:24:96','Ginzinger Electronic Systems','Ginzinger Electronic SystemsGewerbegebiet Pirath 16Weng Upper Austria 4952Austria',1),('00:24:97','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:98','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:99','Aquila Technologies','Aquila Technologies8429a Washington Place NeAlbuquerque Nm 87113United States',1),('00:24:9A','Beijing Zhongchuang Telecommunication Test Co., Ltd.','Beijing Zhongchuang Telecommunication Test Co., Ltd.12-14,block C,beijing International Building,#18,zhong Guan Cun Nan Road,Hai Dian DistrictBeijing  100081China',1),('00:24:9B','Action Star Enterprise Co., Ltd.','Action Star Enterprise Co., Ltd.10f, No.159, Ta-tung Rd., Sec.2Hsichih Taipei Hsien 221Taiwan, Republic Of China',1),('00:24:9C','Bimeng Comunication System Co. Ltd','Bimeng Comunication System Co. LtdLevel 16/f, Tower B,sinotrans Plaza,no.43, Xi Zhi Men Northern Road,hai Dian DistrictBeijing  100044China',1),('00:24:9D','Nes Technology Inc.','Nes Technology Inc.#205 Ace Technotower 10, 470-5 Gasan-dongGeumcheon-guSeoul  153-789Korea, Republic Of',1),('00:24:9E','Adc-elektronik Gmbh','Adc-elektronik Gmbhstingstrae 13bHamm Nrw D-59063Germany',1),('00:24:9F','Rim Testing Services','Rim Testing Services440 Phillip StreetWaterloo Ontario N2l 5r9Canada',1),('00:24:A0','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:24:A1','Motorola Chs','Motorola Chs6450 Sequence DriveSan Diego Ca 92121United States',1),('00:24:A2','Hong Kong Middleware Technology Limited','Hong Kong Middleware Technology LimitedRoom 1315 ,leighton Centre,77 Leighton RoadCauseway Bay  852Hong Kong',1),('00:24:A3','Sonim Technologies Inc','Sonim Technologies Inc1875 S.grant StreetSte#620Sanmateo Ca 94402United States',1),('00:24:A4','Siklu Communication','Siklu Communication7 Shoham St., , 3rd FloorPetah Tikva  49517Israel',1),('00:24:A5','Buffalo Inc.','Buffalo Inc.15, Shibata Hondori 4-chomeMinami-ku,nagoya Aichi Pref. 457-8520Japan',1),('00:24:A6','Telestar Digital Gmbh','Telestar Digital GmbhVulkanhhe / B410Dreis - Brck  54552Germany',1),('00:24:A7','Advanced Video Communications Inc.','Advanced Video Communications Inc.633 W 5th Street6800Los Angeles Ca 90017United States',1),('00:24:A8','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills BlvdRoseville California 95747United States',1),('00:24:A9','Ag Leader Technology','Ag Leader Technology2202 S Riverside Dr.Po Box 2348Ames Ia 50010United States',1),('00:24:AA','Dycor Technologies Ltd.','Dycor Technologies Ltd.1851 94 StreetEdmonton Alberta T6n 1e6Canada',1),('00:24:AB','A7 Engineering, Inc.','A7 Engineering, Inc.12127 Kirkham Road Suite 101Poway Ca 92064United States',1),('00:24:AC','Hangzhou Dptech Technologies Co., Ltd.','Hangzhou Dptech Technologies Co., Ltd.Huarong Shidai Bld., No.3880,jiang-nan Avenue, Binjiang DistrictHangzhou Zhejiang 310051China',1),('00:24:AD','Adolf Thies Gmbh & Co. Kg','Adolf Thies Gmbh & Co. KgHauptstr. 76Gttingen  37083Germany',1),('00:24:AE','Sagem Securite','Sagem Securite18 Chaussee Jules CesarOsny  95520France',1),('00:24:AF','Echostar Technologies','Echostar Technologies94 Inverness CircleEnglewood Co 80112United States',1),('00:24:B0','Esab Ab','Esab AbBox 8004Lindholmsalln 9Gothenburg  Se-402 77Sweden',1),('00:24:B1','Coulomb Technologies','Coulomb Technologies1692 Dell AveCampbell Ca 95008United States',1),('00:24:B2','Netgear','Netgear350 East Plumeria DriveSan Jose Ca 95134United States',1),('00:24:B3','Graf-syteco Gmbh & Co. Kg','Graf-syteco Gmbh & Co. KgKaiserstr. 18Tuningen Baden-wrttemberg 78609Germany',1),('00:24:B4','Escatronic Gmbh','Escatronic GmbhWuerzburger Str. 8Laatzen Lower Saxony 30880Germany',1),('00:24:B5','Nortel Networks','Nortel Networks2221 Lakeside BlvdRichardson Tx 75082-4399United States',1),('00:24:B6','Seagate Technology','Seagate Technology1280 Disc DriveShakopee Mn 55379United States',1),('00:24:B7','Gridpoint, Inc.','Gridpoint, Inc.2801 Clarendon Blvd.Suite 100Arlington Va 22201United States',1),('00:24:B8','Free Alliance Sdn Bhd','Free Alliance Sdn BhdB-3-2 Plaza DamasSri HartamasKuala Lumpur Wp 50480Malaysia',1),('00:24:B9','Wuhan Higheasy Electronic Technology Development Co.ltd','Wuhan Higheasy Electronic Technology Development Co.ltdBldg A2 Optics Valley Software Park,guanshan 1st Rd,Wuhan Hubei 430033China',1),('00:24:BA','Texas Instruments','Texas Instruments12500 Ti Boulevard, Ms 8723Dallas Tx 75243United States',1),('00:24:BB','Central Corporation','Central CorporationNisso 17 Bldg.7f 2-14-30Shinyokohama Kouhoku-kuYokohama Kanagawa 222-0033Japan',1),('00:24:BC','Hurob Co.,ltd','Hurob Co.,ltd2121, Jeongwang-dongSiheung-si Gyeonggi-do 429-793Korea, Republic Of',1),('00:24:BD','Hainzl Industriesysteme Gmbh','Hainzl Industriesysteme GmbhIndustriezeile 56Postfach 100Linz Upper Austria 4021Austria',1),('00:24:BE','Sony Corporation','Sony CorporationGotenyama Tec. 5-1-12KitashinagawaShinagawa-ku Tokyo 141-0001Japan',1),('00:24:BF','Ciat','Ciat30, Avenue Jean FalconnierCuloz  01350France',1),('00:24:C0','Nti Comodo Inc','Nti Comodo IncRm#502, Kangyong Bldg, Sungnam-dongCheungwon-guSungnam-si Kyunggi-do 462-827Korea, Republic Of',1),('00:24:C1','Hangzhou Motorola Technologies Ltd.','Hangzhou Motorola Technologies Ltd.No.1187 Binan Road, Binjiang District,Hangzhou Zhejiang 310053China',1),('00:24:C2','Asumo Co.,ltd.','Asumo Co.,ltd.Oya-kita 1-3-1Ebina-city Kanagawa-pref. 243-0419Japan',1),('00:24:C3','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:C4','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:C5','Meridian Audio Limited','Meridian Audio Limited11 Latham RoadHuntingdon Cambs Pe29 6yeUnited Kingdom',1),('00:24:C6','Hager Electro Sas','Hager Electro Sas132, Boulevard DeuropeObernai Bas-rhin 67215France',1),('00:24:C7','Mobilarm Ltd','Mobilarm Ltd768 Canning HighwayApplecrossPerth Western Australia 6153Australia',1),('00:24:C8','Broadband Solutions Group','Broadband Solutions Group1101 Marina Village ParkwayAlameda Ca 94501United States',1),('00:24:C9','Broadband Solutions Group','Broadband Solutions Group1101 Marina Village ParkwayAlameda Ca 94501United States',1),('00:24:CA','Tobii Technology Ab','Tobii Technology AbKarlsrovgen 2dDanderyd  18253Sweden',1),('00:24:CB','Autonet Mobile','Autonet Mobile2235 Mercury Way Ste. 145Santa Rosa Ca 95407United States',1),('00:24:CC','Fascinations Toys And Gifts, Inc.','Fascinations Toys And Gifts, Inc.19224 Des Moines Way SSte 100Seattle Washington 98148United States',1),('00:24:CD','Willow Garage, Inc.','Willow Garage, Inc.68 Willow Rd.Menlo Park Ca 94025United States',1),('00:24:CE','Exeltech Inc','Exeltech Inc7317 Jack Newell Blvd NorthFort Worth Tx 76118United States',1),('00:24:CF','Inscape Data Corporation','Inscape Data Corporation1611 South Main StreetMilpitas Ca 95035United States',1),('00:24:D0','Shenzhen Sogood Industry Co.,ltd.','Shenzhen Sogood Industry Co.,ltd.Sogood Science Park,aviation Road,xixiang Town,baoan District,Shenzhen Guangzhou 518102China',1),('00:24:D1','Thomson Inc.','Thomson Inc.101 West 103rd StreetIndianapolis In 46290United States',1),('00:24:D2','Askey Computer','Askey Computer10f,no.119,chienkang Rd,chung-ho,taipei,Taiwan Taipei 235Taiwan, Republic Of China',1),('00:24:D3','Qualica Inc.','Qualica Inc.5-29-15,toyo,Koto-ku,Tokyo  135-0016Japan',1),('00:24:D4','Freebox Sa','Freebox Sa8 Rue De La Ville LevequeParis Idf 75008France',1),('00:24:D5','Winward Industrial Limited','Winward Industrial LimitedRm.7, P Floor, Tower A,Hung Hom Commercial Centre,Hongkong  852China',1),('00:24:D6','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:24:D7','Intel Corporate','Intel CorporateLot 8, Jalan Hi-tech 2/3Kulim Hi-tech ParkKulim Kedah 09000Malaysia',1),('00:24:D8','Ilsung Precision','Ilsung Precision182-2, Jegi-ri, Jeongnam-myeonHwanseong-si Gyeonggi-do 445-964Korea, Republic Of',1),('00:24:D9','Bicom, Inc.','Bicom, Inc.755 Main StreetBuilding 3Monroe Ct 06468United States',1),('00:24:DA','Innovar Systems Limited','Innovar Systems Limited12155 Commissioner DrivePo Box 668North Jackson Ohio 44451United States',1),('00:24:DB','Alcohol Monitoring Systems','Alcohol Monitoring Systems1241 W. Mineral AvenueSuite 200Littleton Co 80120United States',1),('00:24:DC','Juniper Networks','Juniper Networks1194 N Mathilda AvenueSunnyvale Ca 94089United States',1),('00:24:DD','Centrak, Inc.','Centrak, Inc.207 Penns TrailNewtown Pa 18940United States',1),('00:24:DE','Global Technology Inc.','Global Technology Inc.No.168,shanshan Rd., Wangchun Industrial Park,Ningbo  315176China',1),('00:24:DF','Digitalbox Europe Gmbh','Digitalbox Europe GmbhSandstrae 65Ratingen  40878Germany',1),('00:24:E0','Ds Tech, Llc','Ds Tech, Llc2210 Hutton DriveSuite 100Carrollton Tx 75006United States',1),('00:24:E1','Convey Computer Corp.','Convey Computer Corp.1302 E. Collins Blvd.Richardson Tx 75081United States',1),('00:24:E2','Hasegawa Electric Co.,ltd.','Hasegawa Electric Co.,ltd.5-6-20 ShioeLightning Technology CenterAmagasaki Hyogo 661-0976Japan',1),('00:24:E3','Cao Group','Cao Group4628 West Skyhawk DriveWest Jordan Ut 84084United States',1),('00:24:E4','Withings','Withings37bis Rue Du General LeclercIssy Les Moulineaux  92442France',1),('00:24:E5','Seer Technology, Inc','Seer Technology, Inc2681 Parleys WaySuite 201Salt Lake City Utah 84109United States',1),('00:24:E6','In Motion Technology Inc.','In Motion Technology Inc.#350, 625 Agnes StreetNew Westminster Bc V3m 5y4Canada',1),('00:24:E7','Plaster Networks','Plaster Networks3723 Haven Ave. Ste. 119Menlo Park Ca 94025-1011United States',1),('00:24:E8','Dell Inc.','Dell Inc.One Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:24:E9','Samsung Electronics Co., Ltd., Storage System Division','Samsung Electronics Co., Ltd., Storage System Division416, Maetan 3dong, Yeongtong-guSuwon City Geyonggi Do 443-742Korea, Republic Of',1),('00:24:EA','Iris-gmbh Infrared & Intelligent Sensors','Iris-gmbh Infrared & Intelligent SensorsOstendstrasse 1-14Berlin  12459Germany',1),('00:24:EB','Clearpath Networks, Inc.','Clearpath Networks, Inc.1940 E. Mariposa Ave.Suite 150El Segundo Ca 90245United States',1),('00:24:EC','United Information Technology Co.,ltd.','United Information Technology Co.,ltd.5/f,9th Building,software Park,2nd Keji-zhong Road,high-tech Industrial ParkShenzhen Guangdong 518057China',1),('00:24:ED','Yt Elec. Co,.ltd.','Yt Elec. Co,.ltd.Block B,2 Floor ,bao Ying Industrial District,Long Gang Longxi,Wu Lian Lu Shenzhen 518116China',1),('00:24:EE','Aictek Co.,ltd.','Aictek Co.,ltd.18f., No. 75, Sec. 1, Sin Tai Wu Rd.,Sijhih City, Taipei County 221Taiwan, Republic Of China',1),('00:24:EF','Sony Ericsson Mobile Communications','Sony Ericsson Mobile CommunicationsNya VattentornetLund  22188Sweden',1),('00:24:F0','Seanodes','SeanodesBatiment Platon25 Bvd Victor HugoColomiers  31770France',1),('00:24:F1','Shenzhen Fanhai Sanjiang Electronics Co., Ltd.','Shenzhen Fanhai Sanjiang Electronics Co., Ltd.3fguangcai Xintiandi Building,nanshan Rd,nanshan,Shenzhen Guangdong 518054China',1),('00:24:F2','Uniphone Telecommunication Co., Ltd.','Uniphone Telecommunication Co., Ltd.No. 25, Chu-kung 3rd Lane, Chu-hou Tsung, Jen-wu Hsiang,Kaohsiung Hsien Taiwan 81448Taiwan, Republic Of China',1),('00:24:F3','Nintendo Co., Ltd.','Nintendo Co., Ltd.11-1 Hokotate-choKamitoba, Minami-kuKyoto Kyoto 601-8501Japan',1),('00:24:F4','Kaminario Technologies Ltd.','Kaminario Technologies Ltd.Yatam Industrial ParkCpc BuildingYokneam Israel 20692Israel',1),('00:24:F5','Nds Surgical Imaging','Nds Surgical Imaging5750 Hellyer Ave.San Jose Ca. 95138United States',1),('00:24:F6','Miyoshi Electronics Corporation','Miyoshi Electronics Corporation3-13-21 KushiroKawanishi-city Hyogo-pref. 666-0024Japan',1),('00:24:F7','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:F8','Technical Solutions Company Ltd.','Technical Solutions Company Ltd.Box 31750Whitehorse Yukon Y1a 6l3Canada',1),('00:24:F9','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:24:FA','Hilger U. Kern Gmbh','Hilger U. Kern GmbhKaefertaler Strasse 253-255Mannheim Baden-wuerttemberg 68167Germany',1),('00:24:FB','Private','',1),('00:24:FC','Quopin Co., Ltd.','Quopin Co., Ltd.#109, R&d Center For Advanced Technology 68 Yatap-dong Bundang-guSeongnam Kyungki-do 463-816Korea, Republic Of',1),('00:24:FD','Prosilient Technologies Ab','Prosilient Technologies Abrstangsvgen 25 (3rd Floor), (box 47231)Stockholm  Se-10074Sweden',1),('00:24:FE','Avm Gmbh','Avm GmbhAlt-moabit 95Berlin  10559Germany',1),('00:24:FF','Qlogic Corporation','Qlogic Corporation26650 Aliso Viejo ParkwayAliso Viejo Ca 92656United States',1),('00:25:00','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:25:01','Jsc supertel','Jsc supertel38a Petrogradskaya Emb.St.petersburg  197101Russian Federation',1),('00:25:02','Naruralpoint','NaruralpointPo Box 2317Corvallis Or 97339United States',1),('00:25:03','Blade Network Technology','Blade Network Technology2350 Mission College Blvd, Suite 600Santa Clara Ca 95054United States',1),('00:25:04','Valiant Communications Limited','Valiant Communications Limited71-1 Shivaji MargNew Delhi Delhi 110015India',1),('00:25:05','Eks Engel Gmbh & Co. Kg','Eks Engel Gmbh & Co. KgSchuetzenstrasse 2Wenden-hillmicke Nrw 57482Germany',1),('00:25:06','A.i. Antitaccheggio Italia Srl','A.i. Antitaccheggio Italia SrlVicolo Delle Dame 4Bologna  40124Italy',1),('00:25:07','Astak Inc.','Astak Inc.1911 Hartog DriveSan Jose Ca 95131United States',1),('00:25:08','Maquet Cardiopulmonary Ag','Maquet Cardiopulmonary AgHechinger Strasse 38Hirrlingen  72145Germany',1),('00:25:09','Sharetronic Group Ltd','Sharetronic Group LtdShajing,baoan Zone,Shenzhen Guangdong 518104China',1),('00:25:0A','Security Expert Co. Ltd','Security Expert Co. Ltd8f-3, No.2, Jian 8th Rd.,Jhonghe Taipei 235Taiwan, Republic Of China',1),('00:25:0B','Centrofactor  Inc','Centrofactor  IncRoad Town, Tortola, P.o.box 3161,Tortola  194295Virgin Islands, British',1),('00:25:0C','Enertrac','Enertrac94 River RdSuite 100Hudson Nh 03051United States',1),('00:25:0D','Gzt Telkom-telmor Sp. Z O.o.','Gzt Telkom-telmor Sp. Z O.o.Mickiewicza 5/7Gdansk Pomorskie 80-425Poland',1),('00:25:0E','Gt German Telematics Gmbh','Gt German Telematics GmbhRankestrasse 26Berlin  D-10789Germany',1),('00:25:0F','On-ramp Wireless, Inc.','On-ramp Wireless, Inc.16885 West Bernardo DriveSuite 255San Diego Ca 92127United States',1),('00:25:10','Pico-tesla Magnetic Therapies','Pico-tesla Magnetic Therapies7852 South Elati#202Littleton Co 80120United States',1),('00:25:11','Elitegroup Computer System Co., Ltd.','Elitegroup Computer System Co., Ltd.No. 239, Sec. 2, Ti Ding Blvd.Taipei Taiwan 11493Taiwan, Republic Of China',1),('00:25:12','Zte Corporation','Zte Corporation12f, R&d Building, Zte, Hi-tech Industrial ParkShenzhen Guangdong 518057China',1),('00:25:13','Cxp Digital Bv','Cxp Digital BvDe Reulver 97aEnschede  7544rtNetherlands',1),('00:25:14','Pc Worth Intl Co., Ltd.','Pc Worth Intl Co., Ltd.18f, No.100, Hsin-tai-wu Rd., Sec. 1,Hsi-chih, Taipei 22102Taiwan, Republic Of China',1),('00:25:15','Neuf Cegetel','Neuf Cegetel42 Quai Du Point Du JourBoulogne Billancourt . 92659France',1),('00:25:16','Integrated Design Tools, Inc.','Integrated Design Tools, Inc.1202 E Park AvenueTallahassee Fl 32301United States',1),('00:25:17','Venntis, Llc','Venntis, Llc11301 James StreetHolland Mi 49424United States',1),('00:25:18','Power Plus Communications Ag','Power Plus Communications AgAm Exerzierplatz 2Mannheim Baden Wuerttemberg 68167Germany',1),('00:25:19','Viaas Inc','Viaas Inc3175 South Winchester BlvdCampbell Ca 95008United States',1),('00:25:1A','Psiber Data Systems Inc.','Psiber Data Systems Inc.7075-k Mission Gorge RdSan Diego Ca 92120United States',1),('00:25:1B','Philips Careservant','Philips CareservantHigh Tech Campus 27Eindhoven Noord-brabant 5656 AeNetherlands',1),('00:25:1C','Edt','Edt1400 Sw ComptonSuite 315Beaverton Or 97008United States',1),('00:25:1D','Dsa Encore, Llc','Dsa Encore, Llc50 Pocono RdBrookfield Ct 06804United States',1),('00:25:1E','Rotel Technologies','Rotel TechnologiesCevizlidere 14.cd No:2/19 BalgatAnkara  06520Turkey',1),('00:25:1F','Zynus Vision Inc.','Zynus Vision Inc.1-1-7-1aSagamihara Kanagawa 229-0039Japan',1),('00:25:20','Sma Railway Technology Gmbh','Sma Railway Technology GmbhMiramstr. 87Kassel Hesse 34123Germany',1),('00:25:21','Logitek Electronic Systems, Inc.','Logitek Electronic Systems, Inc.5622 Edgemoor DriveHouston Texas 77081United States',1),('00:25:22','Asrock Incorporation','Asrock Incorporation2f., No. 37, Sec. 2, Jhongyang S. Rd., Beitou District,Taipei Taiwan 112Taiwan, Republic Of China',1),('00:25:23','Ocp Inc.','Ocp Inc.18495 S Dixie Hwy    Pmb 107Miami Florida 33157United States',1),('00:25:24','Lightcomm Technology Co., Ltd','Lightcomm Technology Co., Ltd9/f.,hi-tech Venture Park Tower A,Tian An Cyber Park,futianShenzhen Guangdong 518040China',1),('00:25:25','Ctera Networks Ltd.','Ctera Networks Ltd.24 Imber St.Petach-tikva  495111Israel',1),('00:25:26','Genuine Technologies Co., Ltd.','Genuine Technologies Co., Ltd.Klingelnberg Bldg.1-13-12 Shin-yokohama Kouhoku-kuYokohama Kanagawa 222-0033Japan',1),('00:25:27','Bitrode Corp.','Bitrode Corp.1642 Manufacturers Dr.Fenton Mo 63026United States',1),('00:25:28','Daido Signal Co., Ltd.','Daido Signal Co., Ltd.2-20-2NakaikegamiOhta-ku Tokyo 146-8678Japan',1),('00:25:29','Comelit Group S.p.a','Comelit Group S.p.aDon Arrigoni N. 5San Lorenzo, Rovetta Bergamo 24020Italy',1),('00:25:2A','Chengdu Geeya Technology Co.,ltd','Chengdu Geeya Technology Co.,ltd50 Shuxi Road,Chengdu Sichuan 610091China',1),('00:25:2B','Stirling Energy Systems','Stirling Energy SystemsSandia National Labs - NsttfPo Box 5800 Ms 1127Albuquerque Nm 87185-1127United States',1),('00:25:2C','Entourage Systems, Inc.','Entourage Systems, Inc.7901 Jones Branch DriveSuite 700Mclean Virginia 22102United States',1),('00:25:2D','Kiryung Electronics','Kiryung ElectronicsKiryung Bldg. 686-70, Sindaebang-dongDongjak-gu,Seoul  156-010Korea, Republic Of',1),('00:25:2E','Cisco Spvtg','Cisco Spvtg5030 Sugarloaf PkwyLawrenceville Ga 30044United States',1),('00:25:2F','Energy, Inc.','Energy, Inc.3297 Pacific StreetCharleston Sc 29418United States',1),('00:25:30','Aetas Systems Inc.','Aetas Systems Inc.3a3, No. 1, Lihsin Road IHsinchu Taiwan 30078Taiwan, Republic Of China',1),('00:25:31','Cloud Engines, Inc.','Cloud Engines, Inc.857 Montgomery StreetSan Francisco Ca 94133United States',1),('00:25:32','Digital Recorders','Digital Recorders4018 Patriot DriveSuite 100Durham Nc 27709United States',1),('00:25:33','Wittenstein Ag','Wittenstein AgWalter-wittenstein-str. 1Igersheim  97999Germany',1),('00:25:34','Private','',1),('00:25:35','Minimax Gmbh & Co Kg','Minimax Gmbh & Co KgIndustriestrasse 10/12Bad Oldesloe Sh 23840Germany',1),('00:25:36','Oki Electric Industry Co., Ltd.','Oki Electric Industry Co., Ltd.1-16-8 ChuouWarabi-shi Saitama 335-8510Japan',1),('00:25:37','Runcom Technologies Ltd.','Runcom Technologies Ltd.11 Moshe Levi Str. 11th Flr.Umi BuildingRishon Le Zion  75658Israel',1),('00:25:38','Samsung Electronics Co., Ltd., Memory Division','Samsung Electronics Co., Ltd., Memory DivisionSan #16 Banwol-dong, Taean-guHwasung City Gyeonggi Do 445-701Korea, Republic Of',1),('00:25:39','Ifta Gmbh','Ifta GmbhIndustriestrasse 33Groebenzell Bavaria 82194Germany',1),('00:25:3A','Ceva, Ltd.','Ceva, Ltd.2 Maskit Street.P.o. Box 2068Herzelia  46120Israel',1),('00:25:3B','Din Dietmar Nocker Facilitymanagement Gmbh','Din Dietmar Nocker Facilitymanagement GmbhKotzinastrasse 5Linz Upper Austria 4030Austria',1),('00:25:3C','2wire','2wire1764 Automation ParkwaySan Jose Ca 95131United States',1),('00:25:3D','Drs Consolidated Controls','Drs Consolidated Controls21 South StreetDanbury Ct 06810-8147United States',1),('00:25:3E','Telemetric Corporation','Telemetric Corporation9941 W. Emerald StreetBoise Idaho 83704United States',1),('00:25:3F','Private','',1),('00:25:40','Quasar Technologies, Inc.','Quasar Technologies, Inc.1701 Barrett Lakes BoulevardSuite 200Kennesaw Ga 30144United States',1),('00:25:41','Maquet Critical Care Ab','Maquet Critical Care AbRntgenvgen 2Solna  Se-171 95Sweden',1),('00:25:42','Pittasoft','Pittasoft#913 Daeryung Techno Town 8th 481-11gaGasan-dongGeumcheon-gu Seoul 153-775Korea, Republic Of',1),('00:25:43','Moneytech','MoneytechRua Guiratinga 931 Un. 103Chacara InglesaSao Paulo Sp 04141-001Brazil',1),('00:25:44','Lojack Corporation','Lojack Corporation780 Dedham StreetMa 02021United States',1),('00:25:45','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:25:46','Cisco Systems','Cisco Systems80 West Tasman Dr.Sjc-m/1San Jose Ca 95134United States',1),('00:25:47','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:25:48','Nokia Danmark A/s','Nokia Danmark A/sFrederikskajCopenhagen V  Dk-1790Denmark',1),('00:25:49','Jeorich Tech. Co.,ltd.','Jeorich Tech. Co.,ltd.4f., No.6, Ln. 70, Sec. 2, Academia Rd., Nangang District, Taipei City 115, Taiwan (r.o.c.)Taipei Taiwan 110Taiwan, Republic Of China',1),('00:25:4A','Ringcube Technologies, Inc.','Ringcube Technologies, Inc.100 West Evelyn Ave, Suite 210Mountain View Ca 94041United States',1),('00:25:4B','Apple, Inc','Apple, Inc1 Infinite LoopCupertino Ca 95014United States',1),('00:25:4C','Videon Central, Inc.','Videon Central, Inc.2171 Sandy DriveState College Pa 16803United States',1),('00:25:4D','Singapore Technologies Electronics Limited','Singapore Technologies Electronics Limited24 Ang Mo KioStreet 65569061Singapore',1),('00:25:4E','Vertex Wireless Co., Ltd.','Vertex Wireless Co., Ltd.5f, Seohyeon Plaza, 254-5, Seohyeon-dong, Bundang-guSeongnam-si Gyeonggi-do 463-824Korea, Republic Of',1),('00:25:4F','Elettrolab Srl','Elettrolab SrlVia Dellindustria 25San Vendemiano Treviso 31020Italy',1),('00:25:50','Mazu Networks','Mazu Networks125 Cambridge Park DriveCambridge Ma 02140United States',1),('00:25:51','Se-elektronic Gmbh','Se-elektronic GmbhEythstr. 16Goeppingen  73037Germany',1),('00:25:52','Vxi Corporation','Vxi CorporationOne Front SreetRollinsford Nh 03869United States',1),('00:25:53','Pirelli Broadband Solutions','Pirelli Broadband SolutionsViale Sarca 222Milano Italy 20126Italy',1),('00:25:54','Pixel8 Networks','Pixel8 Networks22 Great Oaks Blvd, Suite 150San Jose Ca 95119United States',1),('00:25:55','Visonic Technologies 1993 Ltd','Visonic Technologies 1993 Ltd23 Habarzel StTel - Aviv  69710Israel',1),('00:25:56','Hon Hai Precision Ind. Co., Ltd.','Hon Hai Precision Ind. Co., Ltd.No.1925, Nanle RoadSongjiang Export Processing ZoneShanghai  201613China',1),('00:25:57','Research In Motion','Research In Motion440 Phillip StreetWaterloo Ontario N2l 5w9Canada',1),('00:25:58','Mpedia','MpediaShinyoung Tower 12f 246-2Seohyeon-ding Bundang-guSeongnam Gyeonggi-do 463-824Korea, Republic Of',1),('00:25:59','Syphan Technologies Ltd','Syphan Technologies LtdThe WatermillBroughton HallSkipton North Yorkshire Bd23 3agUnited Kingdom',1),('00:25:5A','Tantalus Systems Corp.','Tantalus Systems Corp.301-3480 Gilmore WayBurnaby Bc V5g 4y1Canada',1),('00:25:5B','Coachcomm, Llc','Coachcomm, Llc205 Technology ParkwayAuburn Al 36830United States',1),('00:25:5C','Nec Corporation','Nec Corporation1753, Shimonumabe, Nakahara-ku, KawasakiKanagawa  211-8666Japan',1),('00:25:5D','Morningstar Corporation','Morningstar Corporation9055 Guilford Rd.Suite GColumbia Md 21046United States',1),('00:25:5E','Shanghai Dare Technologies Co.,ltd.','Shanghai Dare Technologies Co.,ltd.22f,info Tech Building, No.1555,kongjiang Road,Shanghai 200092China',1),('00:25:5F','Sentec Ag','Sentec AgRingstrasse 39Therwil  4106Switzerland',1),('00:25:60','Ibridge Networks & Communications Ltd.','Ibridge Networks & Communications Ltd.28,bedford Road East HamLondon  E6 2nnUnited Kingdom',1),('00:25:61','Procurve Networking By Hp','Procurve Networking By Hp8000 Foothills Blvd.Roseville California 95747United States',1),('00:25:62','Interbro Co. Ltd.','Interbro Co. Ltd.6f Joyang B/d, 113 Samseong-dong, Gangnam-guSeoul  135-090Korea, Republic Of',1),('00:25:63','Luxtera Inc','Luxtera Inc2320. Camino Vida RobleSuite 100Carlsbad Ca 92011United States',1),('00:25:64','Dell Inc.','Dell Inc.One Dell Way, Ms Rr5-45Round Rock Texas 78682United States',1),('00:25:65','Vizimax Inc.','Vizimax Inc.2284, Rue De La ProvinceLongueuil Qubec J4g 1g1Canada',1),('00:25:66','Samsung Electronics Co.,ltd','Samsung Electronics Co.,ltd#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:25:67','Samsung Electronics','Samsung Electronics#94-1, Imsoo-dongGumi Gyeongbuk 730-350Korea, Republic Of',1),('00:25:68','Shenzhen Huawei Communication Technologies Co., Ltd','Shenzhen Huawei Communication Technologies Co., LtdBuilding 17,nangang Industrial Park, Tangtou 3nd Industrial Estate,shiyan Baoan District,Shenzhen Guangdong 518108China',1),('00:25:69','Sagem Communication','Sagem Communication14 Rue Paul DautierVelizy  78457France',1),('00:25:6A','Init - Institut Industrial It','Init - Institut Industrial ItLiebigstrasse 87Lemgo Northrhine-westfalia 32657Germany',1),('00:25:6B','Atenix E.e. S.r.l.','Atenix E.e. S.r.l.Via Torricelli, 15/bVerona Vr 37135Italy',1),('00:25:6C','azimut Production Association Jsc','azimut Production Association Jsc2-b Ataeva StreetMakhachkala Dagestan 367005Russian Federation',1),('00:25:6D','Broadband Forum','Broadband Forum48377 Fremont BoulevardSuite 117Fremont Ca 94538United States',1),('00:25:6E','Van Breda B.v.','Van Breda B.v.Mercuriusweg 21Brummen Gelderland 6971 GvNetherlands',1),('00:25:6F','Dantherm Power','Dantherm PowerMarienlystvej 65Skive  7800Denmark',1),('00:25:70','Eastern Communications Company Limited','Eastern Communications Company LimitedNo.398 Wensan Road,No.66 Dongxin Road,r&d Building,b311Hangzhou Zhejiang 310013China',1),('00:25:71','Zhejiang Tianle Digital Electric Co.,ltd','Zhejiang Tianle Digital Electric Co.,ltdNo.8 Tianle Rd,economic Development ZoneShengzhou Zhejiang 312400China',1),('00:25:72','Nemo-q International Ab','Nemo-q International AbBox 210Sollentuna  19123Sweden',1),('00:25:73','St Electronics (info-security) Pte Ltd','St Electronics (info-security) Pte Ltd100, Jurong East Street 21, St Electronics Jurong East Bldg609602Singapore',1),('00:25:74','Kunimi Media Device Co., Ltd.','Kunimi Media Device Co., Ltd.3 Kitamachida YamazakiKunimi, Date Fukushima 969-1771Japan',1),('00:26:54','3com Corporation','3com Corporation5353 Betsy Ross DriveBldg 14, M/s 1425Santa Clara California 95054-1162United States',1),('00:30:00','Allwell Technology Corp.','Allwell Technology Corp.4f, #15, Lane3, Sec.2Chien Kwo N. Road TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:01','Smp','Smp22, Rue Des Cosmonautes31400 ToulouseFranceFrance',1),('00:30:02','Expand Networks','Expand NetworksAtidim Tech Park, Bldg. 4P.o. Box 58142Tel-aviv 61580Israel',1),('00:30:03','Phasys Ltd.','Phasys Ltd.#100-9404 41st AvenueEdmonton Alberta T6x 1r2Canada',1),('00:30:04','Leadtek Research Inc.','Leadtek Research Inc.18f, No.166, Chien-yi RoadChung-ho Taipei,HsienTaiwan, Republic Of China',1),('00:30:05','Fujitsu Siemens Computers','Fujitsu Siemens ComputersBuergermeister Ulrich 10086199 AugsburgGermany',1),('00:30:06','Superpower Computer','Superpower ComputerElectronics Co., Ltd.No. 20 Wu-gong 6th Road Wu-ku IndustrlTaipei 248Taiwan, Republic Of China',1),('00:30:07','Opti, Inc.','Opti, Inc.1440 Mccarthy Blvd.Milpitas Ca 95035United States',1),('00:30:08','Avio Digital, Inc.','Avio Digital, Inc.957 Industrial RoadSan Carlos Ca 94070United States',1),('00:30:09','Tachion Networks, Inc.','Tachion Networks, Inc.2 Meridian RoadEatontown Nj 07724United States',1),('00:30:0A','Aztech Systems Ltd.','Aztech Systems Ltd.31 Ubi Road 1, Aztech BuildingSingapore 408694Singapore',1),('00:30:0B','Mphase Technologies, Inc.','Mphase Technologies, Inc.250 14th StreetGcatt Bldg. - Room #248aAtlanta Ga 30318United States',1),('00:30:0C','Congruency, Ltd.','Congruency, Ltd.23 Hasivim StreetPob 7813Petah-tikva 49170Israel',1),('00:30:0D','Mmc Technology, Inc.','Mmc Technology, Inc.#1502, Seoul Venture Town, Aju Bldg679-5, Yeoksam-dong, Kangnam-guSeoul 135-080Korea, Republic Of',1),('00:30:0E','Klotz Digital Ag','Klotz Digital AgHans-stiessbergerstr. 2aD-85540 HaarGermany',1),('00:30:0F','Imt - Information Management T','Imt - Information Management TGewerbestrasse 8Ch-9470 BuchsSwitzerland',1),('00:30:10','Visionetics International','Visionetics International3f, No. 3, Prosperity Road 1Science-based Industrial Park HsinchuTaiwan R.o.c.Taiwan, Republic Of China',1),('00:30:11','Hms Fieldbus Systems Ab','Hms Fieldbus Systems AbPilefeltsgatan 93-9530250 HalmsstadSwedenSweden',1),('00:30:12','Digital Engineering Ltd.','Digital Engineering Ltd.2 Trench Road, MalluskBelfast Bt36 4tyNorthern IrelandIreland',1),('00:30:13','Nec Corporation','Nec Corporation1-10 Nisshincho, FuchuTokyo 183-8501Japan',1),('00:30:14','Divio, Inc.','Divio, Inc.997 E. Arques AvenueSunnyvale Ca 94086United States',1),('00:30:15','Cp Clare Corp.','Cp Clare Corp.78 Cherry Hill DriveBeverly Ma 01915United States',1),('00:30:16','Ishida Co., Ltd.','Ishida Co., Ltd.959-1 ShimomagariRitto-cho Kurita-gun Shiga  520-3026JapanJapan',1),('00:30:17','Bluearc Uk Ltd','Bluearc Uk LtdQueensgate HouseCookham RoadBracknell  Rg12 1rbUnited Kingdom',1),('00:30:18','Jetway Information Co., Ltd.','Jetway Information Co., Ltd.4f, No. 168, Li The St.Chung Ho City 235 TaipeiTaiwan, Republic Of China',1),('00:30:19','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:1A','Smartbridges Pte. Ltd.','Smartbridges Pte. Ltd.745 Toa Payoh Lorong 5#04-01319455Singapore',1),('00:30:1B','Shuttle, Inc.','Shuttle, Inc.5f, No. 34, Lane 60Wen-hu St., Nei-hu Dist.,TaipeiTaiwan, Republic Of China',1),('00:30:1C','Altvater Airdata Systems','Altvater Airdata SystemsGmbh & Co. KgRiemenstrasse 30 74906 Bad RappenauGermanyGermany',1),('00:30:1D','Skystream, Inc.','Skystream, Inc.455 Deguigne DriveSunnyvale Ca 94086-3835United States',1),('00:30:1E','3com Europe Ltd.','3com Europe Ltd.3com CentreBoundary Way, Hemel HempsteadHerts.  Hp2 7yuUnited Kingdom',1),('00:30:1F','Optical Networks, Inc.','Optical Networks, Inc.166 Baypointe ParkwaySan Jose Ca 95134United States',1),('00:30:20','Tsi, Inc..','Tsi, Inc..500 Cardigan RoadShoreview Mn 55126United States',1),('00:30:21','Hsing Tech. Enterprise Co.,ltd','Hsing Tech. Enterprise Co.,ltd2f, No. 22, Allley 38, Lane 91Sec. 1, Nei Hu RoadTaipeiTaiwan, Republic Of China',1),('00:30:22','Fong Kai Industrial Co., Ltd.','Fong Kai Industrial Co., Ltd.4f-3, No. 13, Wu Chuan 1st RoadHsin Chuang City, Taipei HsienTaiwan, Republic Of China',1),('00:30:23','Cogent Computer Systems, Inc.','Cogent Computer Systems, Inc.10 River Road - Ste. #205Uxbridge Ma 01569United States',1),('00:30:24','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive -sja-2San Jose Ca 95134United States',1),('00:30:25','Checkout Computer Systems, Ltd','Checkout Computer Systems, LtdTownsend Farm RoadHoughton Regis, Dunstable BedfordshireUnited KingdomUnited Kingdom',1),('00:30:26','Heitel Digital Video Gmbh','Heitel Digital Video GmbhStuthagen 2524113 MolfseeGermany',1),('00:30:27','Kerbango, Inc.','Kerbango, Inc.21771 Stevens Creek Blvd. #100Cupertino Ca 95014United States',1),('00:30:28','Fase Saldatura Srl','Fase Saldatura SrlV.r. Bernardi 510042 Stupiniqi-nichelinoTorinoItaly',1),('00:30:29','Opicom','OpicomRoom #302, Style Factory 151Yatab-dong, Bundang-gu Sungnam-si, KyungKoreaKorea, Republic Of',1),('00:30:2A','Southern Information','Southern InformationSystem, Inc.No.8, R&d Rd. Iv Science-based IndustriaHsinchu Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:30:2B','Inalp Networks, Inc.','Inalp Networks, Inc.Meriedweg 7Ch-3172 NiederwangenSwitzerlandSwitzerland',1),('00:30:2C','Sylantro Systems Corporation','Sylantro Systems Corporation1686 Dell AvenueCampbell Ca 95008United States',1),('00:30:2D','Quantum Bridge Communications','Quantum Bridge CommunicationsOne High StreetNorth Andover Ma 01845United States',1),('00:30:2E','Hoft & Wessel Ag','Hoft & Wessel AgRotenburger Strasse 2030659 HannoverGermany',1),('00:30:2F','Smiths Industries','Smiths Industries3290 Patterson Ave., S.e.Grand Rapids Mi 49512United States',1),('00:30:30','Harmonix Corporation','Harmonix Corporation1755 Osgood StreetNorth Andover Ma 01845United States',1),('00:30:31','Lightwave Communications, Inc.','Lightwave Communications, Inc.261 Pepes Farm RoadMilford Ct 06460United States',1),('00:30:32','Magicram, Inc.','Magicram, Inc.1850 Beverly Blvd.Los Angeles Ca 90057United States',1),('00:30:33','Orient Telecom Co., Ltd.','Orient Telecom Co., Ltd.Misung Bulding 115-7Nonhyun-dong, Kangman-ku SeoulKoreaKorea, Republic Of',1),('00:30:34','Set Engineering','Set Engineering15750 Vineyard Blvd. Ste. #100Morgan Hill Ca 95037United States',1),('00:30:35','Corning Incorporated','Corning IncorporatedData CenterM/s - Sp-ww-01Corning Ny 14831United States',1),('00:30:36','Rmp Elektroniksysteme Gmbh','Rmp Elektroniksysteme GmbhHanns-martin-schler-str.12-14D-47877 Willich-munchheideGermanyGermany',1),('00:30:37','Packard Bell Nec Services','Packard Bell Nec Services299 Avenue Patton, Bp 64549006 Angers Cedex 01France',1),('00:30:38','Xcp, Inc.','Xcp, Inc.40 Elm StreetDryden Ny 13053United States',1),('00:30:39','Softbook Press','Softbook Press7745 Herschel AvenueLa Jolla Ca 92037United States',1),('00:30:3A','Maatel','Maatel495 Rue De Pommarin38360 VoreppeFrance',1),('00:30:3B','Powercom Technology','Powercom Technology2f, No. 34, Industry E. Road IvHsinchu Science-based Industrial ParkHsinchu 300Taiwan, Republic Of China',1),('00:30:3C','Onnto Corp.','Onnto Corp.12f-2,  No. 161Sung Teh Rd., TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:3D','Iva Corporation','Iva Corporation29 Hudson RoadSudbury Ma 01776United States',1),('00:30:3E','Radcom Ltd.','Radcom Ltd.12 Hanechoshet StreetTel-aviv 69710Israel',1),('00:30:3F','Turbocomm Tech Inc.','Turbocomm Tech Inc.4f-2, No 171, Sung-tch RoadTaipeiTaiwan, Republic Of China',1),('00:30:40','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive -sja-2San Jose Ca 95134United States',1),('00:30:41','Saejin T & M Co., Ltd.','Saejin T & M Co., Ltd.2nd Fl., Saejin Bldg. 689Ilwon-dong, Kangnam-gu, Seoul135-230 KoreaKorea, Republic Of',1),('00:30:42','Detewe-deutsche Telephonwerke','Detewe-deutsche TelephonwerkeZeughofstrasse 1D-10997 BerlinGermany',1),('00:30:43','Idream Technologies, Pte. Ltd.','Idream Technologies, Pte. Ltd.54 Kallang Bahru, #02-14Singapore 339336SingaporeSingapore',1),('00:30:44','Portsmith Llc','Portsmith Llc1111 S. Orchard - Ste. #109Boise Id 83705United States',1),('00:30:45','Village Networks, Inc. (vni)','Village Networks, Inc. (vni)100 Village Court - Ste. #301Hazlet Nj 07730United States',1),('00:30:46','Controlled Electronic Manageme','Controlled Electronic ManagemeUnit 4 Ravenhill Business ParkRavenhill RoadBelfastIreland',1),('00:30:47','Nissei Electric Co., Ltd.','Nissei Electric Co., Ltd.32 Miyawake, Shimonoishiki-choNakagawa-ku, Nagoya 454-0945JapanJapan',1),('00:30:48','Supermicro Computer, Inc.','Supermicro Computer, Inc.2051 Junction AvenueSan Jose Ca 95131United States',1),('00:30:49','Bryant Technology, Ltd.','Bryant Technology, Ltd.P.o. Box 69557Bryanston, 2021South AfricaSouth Africa',1),('00:30:4A','Fraunhofer Ipms','Fraunhofer IpmsMaria-reiche-strasse 201109Germany',1),('00:30:4B','Orbacom Systems, Inc.','Orbacom Systems, Inc.1704 Taylors LaneCinnaminson Nj 08077United States',1),('00:30:4C','Appian Communications, Inc.','Appian Communications, Inc.80 Central StreetBoxborough Ma 01719United States',1),('00:30:4D','Esi','Esi2601 Summit AvenuePlano Tx 75074United States',1),('00:30:4E','Bustec Production Ltd.','Bustec Production Ltd.World Aviation ParkShannon County ClareIreland',1),('00:30:4F','Planet Technology Corporation','Planet Technology Corporation11f, No. 96, Min-chuan RoadHsin-tien TaipeiTaiwan, Republic Of China',1),('00:30:50','Versa Technology','Versa Technology4430 E. Miraloma Ave., - Ste.Anaheim Ca 92807United States',1),('00:30:51','Orbit Avionic & Communication','Orbit Avionic & CommunicationSystems, Ltd.P.o. Box 3171 Industrial Zone, Netanya 4IsraelIsrael',1),('00:30:52','Elastic Networks','Elastic Networks6120 Windward Parkway -ste#100Alpharetta Ga 30005United States',1),('00:30:53','Basler Ag','Basler AgAn Der Strusbek 60-6222926 AhrensburgGermany',1),('00:30:54','Castlenet Technology, Inc.','Castlenet Technology, Inc.No. 130 Wu-kung Rd.,Wu-ku Hsiang Taipei HsienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:55','Renesas Technology America, Inc.','Renesas Technology America, Inc.450 Holger WaySan Jose Ca 95134United States',1),('00:30:56','Beck Ipc Gmbh','Beck Ipc GmbhGrninger Weg 24D-35415 PohlheimGermany',1),('00:30:57','Qtelnet, Inc.','Qtelnet, Inc.400 - 3115 12th Street NeCalgary Alberta T2e 7j2Canada',1),('00:30:58','Api Motion','Api Motion45 Hazelwood DriveAmherst Ny 14228United States',1),('00:30:59','Digital-logic Ag','Digital-logic AgNordstr. 11/fCh-4542 LuterbachSwitzerland',1),('00:30:5A','Telgen Corporation','Telgen Corporation3101 Sovereign Dr. - Ste.Lansing Mi 48911United States',1),('00:30:5B','Toko Inc.','Toko Inc.18 Comigaya, Tsurugashima-shiSaitama-kenJapan 350-2281Japan',1),('00:30:5C','Smar Laboratories Corp.','Smar Laboratories Corp.10960 Millridge North - Ste. #107Houston Tx 77070United States',1),('00:30:5D','Digitra Systems, Inc.','Digitra Systems, Inc.8-61, Gawol-dongYongsan-ku SeoulKorea 140-150Korea, Republic Of',1),('00:30:5E','Abelko Innovation','Abelko InnovationBox 808S-97125 LuleaSweden',1),('00:30:5F','Hasselblad','HasselbladHejrevej 30Copenhagen Nv Dk-2400Denmark',1),('00:30:60','Powerfile, Inc.','Powerfile, Inc.3350 Thomas RoadSanta Clara Ca 95054-2062United States',1),('00:30:61','Mobytel','Mobytel4301 Connecticut Ave. NwSte. #454Washington Dc 20008United States',1),('00:30:62','Path 1 Network Technols Inc.','Path 1 Network Technols Inc.3636 Nobel Drive - Ste. #275San Diego Ca 92122United States',1),('00:30:63','Santera Systems, Inc.','Santera Systems, Inc.2901 Summit Avenue - Ste. #100Plano Tx 75074United States',1),('00:30:64','Adlink Technology, Inc.','Adlink Technology, Inc.9f, No. 166, Jien-yi R.d.Chung-ho City TaipeiTaiwan, Republic Of China',1),('00:30:65','Apple Computer, Inc.','Apple Computer, Inc.20650 Valley Green DriveCupertino Ca 95014United States',1),('00:30:66','Cirronet, Inc.','Cirronet, Inc.3079 Premiere PkwySuite 140Duluth Ga 30097United States',1),('00:30:67','Biostar Microtech Intl Corp.','Biostar Microtech Intl Corp.2fl. No. 108-2 Min Chuan RoadHsin Tien City, Taipei HsienTaiwan, Republic Of China',1),('00:30:68','Cybernetics Tech. Co., Ltd.','Cybernetics Tech. Co., Ltd.Daitoh Bldg. 4f 3-32-1Takada, Toshima-ku, TokyoJapan 171-0033Japan',1),('00:30:69','Impacct Technology Corp.','Impacct Technology Corp.2f, No. 12, R&d Rd. IiScience-based Industrial Park Hsin-chuTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:6A','Penta Media Co., Ltd.','Penta Media Co., Ltd.E-504 Bundang Technopark,151Yatop-dong Bundang-guSeongnam Gyeonggi-doKorea, Republic Of',1),('00:30:6B','Cmos Systems, Inc.','Cmos Systems, Inc.23440 Hawthorne Blvd-ste #290Torrance Ca 90505United States',1),('00:30:6C','Hitex Holding Gmbh','Hitex Holding GmbhGreschbachstr. 1276229 KarlsruheGermany',1),('00:30:6D','Lucent Technologies','Lucent Technologies300 Baker Avenue - Ste. #100Concord Ma 01742-2168United States',1),('00:30:6E','Hewlett Packard','Hewlett Packard11000 Wolfe RoadCupertino Ca 95014United States',1),('00:30:6F','Seyeon Tech. Co., Ltd.','Seyeon Tech. Co., Ltd.Namcheon Bldg. 6f,Daechi-dong, 957-013 Kangnam-gu, SeoulKorea 135-280Korea, Republic Of',1),('00:30:70','1net Corporation','1net Corporation347 Elizabeth Avenue - Ste. #100Somerset Nj 08873United States',1),('00:30:71','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Driv - Sja-2San Jose Ca 95134United States',1),('00:30:72','Intellibyte Inc.','Intellibyte Inc.Canada Trust Tower - Bce Place161 Bay St. 27th Floor,Toronto Ontario M5j 2s1Canada',1),('00:30:73','International Microsystems, In','International Microsystems, In521 Valley WayMilpitas Ca 95035United States',1),('00:30:74','Equiinet Ltd.','Equiinet Ltd.Edison HouseEdison RoadSwindon, Sn3 5jaUnited Kingdom',1),('00:30:75','Adtech','AdtechRue Du Val St Lambert 191 / ISeraing  4100Belgium',1),('00:30:76','Akamba Corporation','Akamba Corporation15595 Los Gatos Blvd.Los Gatos Ca 95032United States',1),('00:30:77','Onprem Networks','Onprem Networks42501 Albrae StreetFremont Ca 94538United States',1),('00:30:78','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:79','Cqos, Inc.','Cqos, Inc.25 Mauchly  - Ste. #329Irvine Ca 92618United States',1),('00:30:7A','Advanced Technology & Systems','Advanced Technology & SystemsYokohama Business Park East Tower 9f,134 Goudo-cho, Hodogaya-ku, Yokohama, Ka240-0005Japan',1),('00:30:7B','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:7C','Adid Sa','Adid Sa70 Ru Anatole France92 300 Levallois-perret CedexFrance',1),('00:30:7D','Gre America, Inc.','Gre America, Inc.425 Harbor Blvd.Belmont Ca 94002United States',1),('00:30:7E','Redflex Communication Systems','Redflex Communication Systems11-29 Eastern RoadSouth Melbourne Victoria 3205Australia',1),('00:30:7F','Irlan Ltd.','Irlan Ltd.1 Hatamar StreetP.o. Box 288 Yokneam 20692IsraelIsrael',1),('00:30:80','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:81','Altos C&c','Altos C&c150-010 Rm. 1012, 44-1Dae Young B/d, Yovido-dong Youngchungpo-KoreaKorea, Republic Of',1),('00:30:82','Taihan Electric Wire Co., Ltd.','Taihan Electric Wire Co., Ltd.Communication Engineering Team996 Siheung-dong Keym Cheon-kuSeoulKorea, Republic Of',1),('00:30:83','Ivron Systems','Ivron Systems19-20 York RoadDun Laoghaire County DublinIrelandIreland',1),('00:30:84','Allied Telesyn Internaional','Allied Telesyn InternaionalCorporation960 Stewart Drive,  Ste.Sunnyvale Ca 94086United States',1),('00:30:85','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:30:86','Transistor Devices, Inc.','Transistor Devices, Inc.36a Newburgh RoadHackettstown Nj 07840United States',1),('00:30:87','Vega Grieshaber Kg','Vega Grieshaber KgAm Hohenstein 11377761 SchultachGermanyGermany',1),('00:30:88','Siara Systems, Inc.','Siara Systems, Inc.300 Ferguson Drive - 2nd FloorMountain View Ca 94043United States',1),('00:30:89','Spectrapoint Wireless, Llc','Spectrapoint Wireless, Llc1125 E. Collins Blvd.Richardson Tx 75081United States',1),('00:30:8A','Nicotra Sistemi S.p.a','Nicotra Sistemi S.p.a41 Via Primo MaggioBaranzate (mi) 20021Italy',1),('00:30:8B','Brix Networks','Brix Networks300 Concord RoadBillerica Ma 01821United States',1),('00:30:8C','Quantum Corporation','Quantum Corporation10125 Federal DriveColorado Springs Co 80908United States',1),('00:30:8D','Pinnacle Systems, Inc.','Pinnacle Systems, Inc.Frankfurter Str. 3cD-38122 BraunschweigGermany',1),('00:30:8E','Cross Match Technologies, Inc.','Cross Match Technologies, Inc.3960 Rca Blvd., Suite 6001Palm Beach Fl 33410United States',1),('00:30:8F','Micrilor, Inc.','Micrilor, Inc.17 Lakeside Office Park607 North AvenueWakefield Ma 01880United States',1),('00:30:90','Cyra Technologies, Inc.','Cyra Technologies, Inc.8000 Capwell DriveOakland Ca 94621United States',1),('00:30:91','Taiwan First Line Elec. Corp.','Taiwan First Line Elec. Corp.40 Chung-shan RoadTu-cheng Industrial ParkTaipei CountyTaiwan, Republic Of China',1),('00:30:92','Modunorm Gmbh','Modunorm GmbhLangrutistrasse 33Ch-8840 EinsledelnSwitzerland',1),('00:30:93','Sonnet Technologies, Inc.','Sonnet Technologies, Inc.3390 Buford Drive - Ste. #7Buford Ga 30519United States',1),('00:30:94','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:95','Procomp Informatics, Ltd.','Procomp Informatics, Ltd.5f, 69-10, Sec. 2,Chung Cheng E. RoadTamshui, Taipei, Hsien  R.o.c.Taiwan, Republic Of China',1),('00:30:96','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:97','Ab Regin','Ab ReginBox 366Se-26123 LandskronaSweden',1),('00:30:98','Global Converging Technologies','Global Converging Technologies1800 Preston Park Blvd.Suite #250Plano Tx 75093United States',1),('00:30:99','Boenig Und Kallenbach Ohg','Boenig Und Kallenbach OhgAm Spoerkel 10044227 DortmundGermanyGermany',1),('00:30:9A','Astro Terra Corp.','Astro Terra Corp.11526 Sorrento Valley RoadSan Diego Ca 92121United States',1),('00:30:9B','Smartware','Smartware49 Av AristideBriand92160 AntonyFrance',1),('00:30:9C','Timing Applications, Inc.','Timing Applications, Inc.4775 Walnut St.Suite 1bBoulder Co 80301United States',1),('00:30:9D','Nimble Microsystems, Inc.','Nimble Microsystems, Inc.50 Church Street - 5th FloorCambridge Ma 02138United States',1),('00:30:9E','Workbit Corporation.','Workbit Corporation.1-2-2 Chuou, YamatoKanagawa  242-0021Japan',1),('00:30:9F','Amber Networks','Amber Networks2475 Augustine Dr.Santa Clara Ca 95054United States',1),('00:30:A0','Tyco Submarine Systems, Ltd.','Tyco Submarine Systems, Ltd.250 Industrial Way WestEatontown Nj 07724United States',1),('00:30:A1','Webgate Inc.','Webgate Inc.4f, Pika Bldg., 894-20, Hoyke 2-dongDongan-ku,Anyang-si Kyunggi-doKorea, Republic Of',1),('00:30:A2','Lightner Engineering','Lightner EngineeringP.o. Box 8308La Jolla Ca 92038-8308United States',1),('00:30:A3','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive -sja-2San Jose Ca 95134United States',1),('00:30:A4','Woodwind Communications System','Woodwind Communications System20300 Century Blvd., Suite 200bGermantown Md 20874United States',1),('00:30:A5','Active Power','Active Power11525 Stonehollow - Ste.#255Austin Tx 78758United States',1),('00:30:A6','Vianet Technologies, Ltd.','Vianet Technologies, Ltd.8 Hacharash StreetRamat Hasharon 47262IsraelIsrael',1),('00:30:A7','Schweitzer Engineering','Schweitzer EngineeringLaboratories, Inc.2350 Ne Hopkins CourtPullman Wa 99163United States',1),('00:30:A8','Ole Communications, Inc.','Ole Communications, Inc.1962 Zanker RoadSan Jose Ca 95112United States',1),('00:30:A9','Netiverse, Inc.','Netiverse, Inc.100 Century Center CourtSuite #600San Jose Ca 95112United States',1),('00:30:AA','Axus Microsystems, Inc.','Axus Microsystems, Inc.2f-4, No.18/n. 609, Sec. 5Chun-hsin Road, San Chung Taipei CountyTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:AB','Delta Networks, Inc.','Delta Networks, Inc.8, Kon Jan West RoadLiutu Industrial Zone KeelungTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:AC','Systeme Lauer Gmbh & Co., Ltd.','Systeme Lauer Gmbh & Co., Ltd.Kelterstrasse 5972669 UnterensingenGermany',1),('00:30:AD','Shanghai Communication','Shanghai CommunicationTechnologies Center15 Gui-qing Road Shanghai 200233P.r. ChinaChina',1),('00:30:AE','Times N System, Inc.','Times N System, Inc.1826 Kramer Lane - Ste.Austin Tx 78758United States',1),('00:30:AF','Honeywell Gmbh','Honeywell GmbhBoeblinger Str. 17P.o. Box 1164D-71098 SchoenaichGermany',1),('00:30:B0','Convergenet Technologies','Convergenet Technologies2222 Trade Zone BoulevardSan Jose Ca 95131United States',1),('00:30:B1','Axess-pro Networks Gmbh','Axess-pro Networks GmbhVor Der Pforte 19Dreieich  D-63303Germany',1),('00:30:B2','L-3 Sonoma Eo','L-3 Sonoma Eo428 Aviation BlvdSanta Rosa Ca 95403United States',1),('00:30:B3','San Valley Systems, Inc.','San Valley Systems, Inc.2105 S. Bascom Ave. - Ste. #390Campbell Ca 95008United States',1),('00:30:B4','Intersil Corp.','Intersil Corp.P.o. Box 8832401 Palm Bay RoadMelbourne Fl 32902United States',1),('00:30:B5','Tadiran Microwave Networks','Tadiran Microwave Networks4000 Greenbriar DriveStafford Tx 77477United States',1),('00:30:B6','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:30:B7','Teletrol Systems, Inc.','Teletrol Systems, Inc.Technology Center286 Commercial StreetManchester Nh 03101United States',1),('00:30:B8','Riverdelta Networks','Riverdelta NetworksThree Highwood Drive EastTewksbury Ma 01876United States',1),('00:30:B9','Ectel','Ectel22240 Comsat DriveClarksburg Md 20871United States',1),('00:30:BA','Ac&t System Co., Ltd.','Ac&t System Co., Ltd.Room 702, Keum-wha Plaza1142-5, Sanbon-dong Koonpo-shi, Kyongki-435-040 South KoreaKorea, Republic Of',1),('00:30:BB','Cacheflow, Inc.','Cacheflow, Inc.650 Almanor DriveSunnyvale Ca 94086United States',1),('00:30:BC','Optronic Ag','Optronic AgUntereggerstrasse 539403 GoldachSwitzerland',1),('00:30:BD','Belkin Components','Belkin Components501 West Walnut StreetCompton Ca 90220United States',1),('00:30:BE','City-net Technology, Inc.','City-net Technology, Inc.135 E. Chesnut Ave., Ste.Monrovia Ca 91016United States',1),('00:30:BF','Multidata Gmbh','Multidata GmbhAlsfelder Str. 3D-64289 DarmstadtGermanyGermany',1),('00:30:C0','Lara Technology, Inc.','Lara Technology, Inc.2345 North First StreetSan Jose Ca 95131United States',1),('00:30:C1','Hewlett-packard','Hewlett-packard11000 Wolfe RoadCupertino Ca 95014United States',1),('00:30:C2','Comone','ComoneParc De Marticot33610 CestasFrance',1),('00:30:C3','Flueckiger Elektronik Ag','Flueckiger Elektronik AgKirchbargstrasse 201Ch-3400 BurgdorfSwitzerlandSwitzerland',1),('00:30:C4','Canon Imaging Systems Inc.','Canon Imaging Systems Inc.1-24 Yoneyama, Chuo-kuNiigata-shi Niigata 950-0916Japan',1),('00:30:C5','Cadence Design Systems','Cadence Design SystemsCanada, Ltd.240-1130 Morrison Drive Ottawa, OntarioCanadaCanada',1),('00:30:C6','Control Solutions, Inc.','Control Solutions, Inc.201 85th Avenue NwMinneapolis Mn 55433United States',1),('00:30:C7','Macromate Corp.','Macromate Corp.8f,universal Center,number 179Sec.1,ta-tung Road, Hsi-chihTaipei HsienTaiwan, Republic Of China',1),('00:30:C8','Gad Line, Ltd.','Gad Line, Ltd.Beit Rokar Har HotzvimJerusalemIsrael',1),('00:30:C9','Luxn, N','Luxn, N570 Maude CourtSunnyvale Ca 94086United States',1),('00:30:CA','Discovery Com','Discovery Com4935 Century StreetHuntsville Al 35816United States',1),('00:30:CB','Omni Flow Computers, Inc.','Omni Flow Computers, Inc.10701 Corporate Drive-ste.#300Stafford Tx 77477United States',1),('00:30:CC','Tenor Networks, Inc.','Tenor Networks, Inc.50 Nagog ParkActon Ma 01720United States',1),('00:30:CD','Conexant Systems, Inc.','Conexant Systems, Inc.4311 Jamboree RoadNewport Beach Ca 92660United States',1),('00:30:CE','Zaffire','Zaffire2630 Orchard ParkwaySan Jose Ca 95134-2020United States',1),('00:30:CF','Two Technologies, Inc.','Two Technologies, Inc.419 Sargon WayHorsham Pa 19044United States',1),('00:30:D0','Tellabs','Tellabs1750 Founders ParkwaySuite 100Alpharetta Ga 30004United States',1),('00:30:D1','Inova Corporation','Inova Corporation110 Avon StreetCharlottesvile Va 22902United States',1),('00:30:D2','Win Technologies, Co., Ltd.','Win Technologies, Co., Ltd.4f-6, No. 81, Sec. 1Hsin Tai Wu Road, Hsi-chiTaipeiTaiwan, Republic Of China',1),('00:30:D3','Agilent Technologies','Agilent Technologies1501 Page Mill RoadPalo Alto Ca 94304-1126United States',1),('00:30:D4','Aae Systems, Inc','Aae Systems, Inc642 North Pastoria AvenueSunnyvale Ca 94085United States',1),('00:30:D5','Dresearch Gmbh','Dresearch GmbhOtto-schmirgal-str.310319 BerlinGermany',1),('00:30:D6','Msc Vertriebs Gmbh','Msc Vertriebs GmbhIndustriestr. 16D-76297 StutenseeGermanyGermany',1),('00:30:D7','Innovative Systems, L.l.c.','Innovative Systems, L.l.c.1000 Innovative DriveMitchell Sd 57301United States',1),('00:30:D8','Sitek','SitekVia Monte Fiorino 937057 - S. Giovanni Lup. VeronaItalyItaly',1),('00:30:D9','Datacore Software Corp.','Datacore Software Corp.Corporate Park6261 Nw 6th Way #110Fort Lauderdale Fl 33309United States',1),('00:30:DA','Comtrend Co.','Comtrend Co.3f-1 10 Lane 609 ChungHsin Road, Sec 5, San Chung City, TaipeiTaiwan 241Taiwan, Republic Of China',1),('00:30:DB','Mindready Solutions, Inc.','Mindready Solutions, Inc.2800 Marie-curie AvenueSaint-laurentQuebec  H4s 2c2Canada',1),('00:30:DC','Rightech Corporation','Rightech Corporation4f, No. 351, Chung-shun Rd.Sec. 2, Chung-ho City TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:30:DD','Indigita Corporation','Indigita Corporation30 Corporate Park DriveSuite 310Irvine Ca 92606United States',1),('00:30:DE','Wago Kontakttechnik Gmbh','Wago Kontakttechnik GmbhHansastrasse 2732423 MindenGermany',1),('00:30:DF','Kb/tel Telecomunicaciones','Kb/tel TelecomunicacionesS.a. De C.v.Torre Telmex 4  Piso, Plaza CuicuilcoMexico City 14060Mexico',1),('00:30:E0','Oxford Semiconductor Ltd.','Oxford Semiconductor Ltd.25 Milton ParkAbingdon Oxon Ox14 4shUnited Kingdom',1),('00:30:E1','Acrotron Systems, Inc.','Acrotron Systems, Inc.704 Ginesi Drive - Ste. #27Morganville Nj 07751United States',1),('00:30:E2','Garnet Systems Co., Ltd.','Garnet Systems Co., Ltd.Sungwon Bldg. 545-7Dogok-dong, Kangnam-guSeoulKorea, Republic Of',1),('00:30:E3','Sedona Networks Corp.','Sedona Networks Corp.10a Hearst WayKanata,  OntarioCanada K2l 2p4Canada',1),('00:30:E4','Chiyoda System Riken','Chiyoda System Riken2-7, Kanda-nishiki-choChiyoda-ku TokyoJapanJapan',1),('00:30:E5','Amper Datos S.a.','Amper Datos S.a.C/marconi N*3  (ptm)Tres Cantos28760 MadridSpain',1),('00:30:E6','Draeger Medical Systems, Inc.','Draeger Medical Systems, Inc.6 Tech DriveAndover Ma 01810United States',1),('00:30:E7','Cnf Mobile Solutions, Inc.','Cnf Mobile Solutions, Inc.7722 E. Gray RoadScottsdale Az 85260United States',1),('00:30:E8','Ensim Corp.','Ensim Corp.1215 Terra Bella Ave.Mountainview Ca 94043United States',1),('00:30:E9','Gma Communication Manufactg','Gma Communication ManufactgMarketing, (1991) Ltd.102 Jabutinski Street Kiryat Arie, PetacIsrael Israel 49130Israel',1),('00:30:EA','Teraforce Technology Corporation','Teraforce Technology Corporation1100 Executive DriveRichardson Tx 75081United States',1),('00:30:EB','Turbonet Communications, Inc.','Turbonet Communications, Inc.19f-1, No. 171, Sung-teh RoadTaipeiTaiwan, Republic Of China',1),('00:30:EC','Borgardt','BorgardtDieselstr. 15D71665 Vaihingen/enzGermanyGermany',1),('00:30:ED','Expert Magnetics Corp.','Expert Magnetics Corp.12/f., Unit D, Mtg Bldg., 1-3, NakaseMihama-ku, Chiba-city, 261-8501Japan',1),('00:30:EE','Dsg Technology, Inc.','Dsg Technology, Inc.6f-4 No. 270, Chwig HsiaoEast Road, Sec. 4TaipeiTaiwan, Republic Of China',1),('00:30:EF','Neon Technology, Inc.','Neon Technology, Inc.85 West Montague ExpresswayMilpitas Ca 95035United States',1),('00:30:F0','Uniform Industrial Corp.','Uniform Industrial Corp.18f, 171, Shung Teh RoadTaipeiTaiwan, Republic Of China',1),('00:30:F1','Accton Technology Corp.','Accton Technology Corp.No. 1, Creation Rd. IvS.g.z.pHsinchuTaiwan, Republic Of China',1),('00:30:F2','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 85134United States',1),('00:30:F3','At Work Computers','At Work ComputersP.o. Box 947Corvallis Or 97339United States',1),('00:30:F4','Stardot Technologies','Stardot Technologies6820-h Orange Thorpe Ave.Buena Park Ca 90620United States',1),('00:30:F5','Wild Lab. Ltd.','Wild Lab. Ltd.1-33-17-604 HarayamaUrawa City Saitama Prif. 336-0931Japan',1),('00:30:F6','Securelogix Corporation','Securelogix Corporation13750 San PedroSan Antonio Tx 78232United States',1),('00:30:F7','Ramix Inc.','Ramix Inc.1672 Donlon StreetVentura Ca 93003United States',1),('00:30:F8','Dynapro Systems, Inc.','Dynapro Systems, Inc.800 Carleton CourtAnnacis IslandNew Westminster British Columbia V3m 6l3Canada',1),('00:30:F9','Sollae Systems Co., Ltd.','Sollae Systems Co., Ltd.607 Incheo It Tower592-5, Dohwa-1-dongNam-gu IncheonKorea, Republic Of',1),('00:30:FA','Telica, Inc.','Telica, Inc.734 Forest Street, Bldg.Suite #100Marlboro Ma 01752United States',1),('00:30:FB','Azs Technology Ag','Azs Technology AgSteinbeisstrasse 2-472510 Stetten A.k.m.Germany',1),('00:30:FC','Terawave Communications, Inc.','Terawave Communications, Inc.30695 Huntwood AvenueHayward Ca 94544United States',1),('00:30:FD','Integrated Systems Design','Integrated Systems Design3650-g Centre Circle DriveFort Mill Sc 29715United States',1),('00:30:FE','Dsa Gmbh','Dsa GmbhPascalstr. 2852076 AachenGermany',1),('00:30:FF','Datafab Systems, Inc.','Datafab Systems, Inc.Room #1910, 19f, No. 333Keelung Road Sec. 1, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:40:00','Pci Componentes Da Amzonia Ltd','Pci Componentes Da Amzonia LtdRua Josef Kryss129 - Sao Paulo - Sp01140 BrasilBrazil',1),('00:40:01','Zyxel Communications, Inc.','Zyxel Communications, Inc.4f, 111, Chung Shan N. RoadSec 2,  TaipeiTaiwan R.o.c.Taiwan, Republic Of China',1),('00:40:02','Perle Systems Limited','Perle Systems Limited60 Renfrew DriveMarkham OntarioCanada L3r 0e1Canada',1),('00:40:03','Emerson Process Management Power & Water Solutions, Inc.','Emerson Process Management Power & Water Solutions, Inc.200 Beta DrivePittsburgh Pa 15238United States',1),('00:40:04','Icm Co. Ltd.','Icm Co. Ltd.4-2-9 Nihonbashi Naniwa-kuOsaka, (556)JapanJapan',1),('00:40:05','Ani Communications Inc.','Ani Communications Inc.8 AnzioIrvine Ca 92714United States',1),('00:40:06','Sampo Technology Corporation','Sampo Technology Corporation26-2 Ting-hu,Ta-kang Tsun Kuei-shan Hsiang, Taoyuan H33334 Taiwan 33334 Taiwan R.o.c.Taiwan, Republic Of China',1),('00:40:07','Telmat Informatique','Telmat Informatique6 Rue De LindustrieBp 12  68360 SoultzFranceFrance',1),('00:40:08','A Plus Info Corporation','A Plus Info Corporation5f, No.2, Lane 235Bao Chiao Road Hsin Tien, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:40:09','Tachibana Tectron Co., Ltd.','Tachibana Tectron Co., Ltd.Systematic Equipment Division2-2-5 Higashiyama, Meguroku Tokyo, 153JapanJapan',1),('00:40:0A','Pivotal Technologies, Inc.','Pivotal Technologies, Inc.100 W. Rincon Avenue-ste #211Campbell Ca 95008United States',1),('00:40:0B','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134-1706United States',1),('00:40:0C','General Micro Systems, Inc.','General Micro Systems, Inc.P.o. Box 3689Rancho Cucamonga Ca 91729United States',1),('00:40:0D','Lannet Data Communications,ltd','Lannet Data Communications,ltdAtidim Technologl Park, Bg.#3Tel Aviv 61131IsraelIsrael',1),('00:40:0E','Memotec Communications, Inc.','Memotec Communications, Inc.600 MccaffreyMontreal, Quebec H4t 1n1CanadaCanada',1),('00:40:0F','Datacom Technologies','Datacom Technologies11001 31st Place WestEverett Wa 98204United States',1),('00:40:10','Sonic Systems, Inc.','Sonic Systems, Inc.575 Pastoria North AvenueSunnyvale Ca 940867United States',1),('00:40:11','Andover Controls Corporation','Andover Controls Corporation300 Brickstone SquareAndover Ma 01810United States',1),('00:40:12','Windata, Inc.','Windata, Inc.10 Bearfoot RoadNorthboro Ma 01532United States',1),('00:40:13','Ntt Data Comm. Systems Corp.','Ntt Data Comm. Systems Corp.Development HeadquartersToyosu Center Bldg., 3-3-3 Toyosu, Koto-Tokyo 135 Tokyo 135 JapanJapan',1),('00:40:14','Comsoft Gmbh','Comsoft GmbhWachhausstr. 5a7500 Karlsruhe 41GermanyGermany',1),('00:40:15','Ascom Infrasys Ag','Ascom Infrasys AgDpt. Easo 3726Glutz-blotzheimstr. 1 Ch-4503  SolothurnSwitzerlandSwitzerland',1),('00:40:16','Adc - Global Connectivity Solutions Division','Adc - Global Connectivity Solutions DivisionP.o. Box 1101Minneapolis Mn 55440-1101United States',1),('00:40:17','Silex Technology America','Silex Technology America157 West 7065 SouthSalt Lake City Ut 84047United States',1),('00:40:18','Adobe Systems, Inc.','Adobe Systems, Inc.1585 Charleston RoadMountain View Ca 94043United States',1),('00:40:19','Aeon Systems, Inc.','Aeon Systems, Inc.8401 Washington Place NeAlbuquerque Nm 87113United States',1),('00:40:1A','Fuji Electric Co., Ltd.','Fuji Electric Co., Ltd.New Yurakucho Bldg12-1 Yurakucho 1-chome Chiyoda-ku, TokyoJapanJapan',1),('00:40:1B','Printer Systems Corp.','Printer Systems Corp.207 Perry ParkwayGaithersburg Md 20877-2142United States',1),('00:40:1C','Ast Research, Inc.','Ast Research, Inc.Ms 2-781615 Alton ParkwayIrvine Ca 92618United States',1),('00:40:1D','Invisible Software, Inc.','Invisible Software, Inc.1142 Chess DriveFoster City Ca 94404United States',1),('00:40:1E','Icc','Icc8230 Montgomery RoadCincinnati Oh 45236United States',1),('00:40:1F','Colorgraph Ltd','Colorgraph LtdUnit 2, Mars HouseCalleva Park, Aldermaston Nr. Reading, BRg7 4qw - United KingdomUnited Kingdom',1),('00:40:20','Tyco Electronics (uk) Ltd','Tyco Electronics (uk) LtdKinmel ParkBodelwyddan Rhyl Ll18 5tzUnited Kingdom',1),('00:40:21','Raster Graphics','Raster Graphics285 N. Wolfe RoadSunnyvale Ca 94086United States',1),('00:40:22','Klever Computers, Inc.','Klever Computers, Inc.1028 W. Maude AvenueSunnyvale Ca 94086United States',1),('00:40:23','Logic Corporation','Logic Corporation3-14-10 Meiji-seimei BuildingMita Minato-ku TokyoJapanJapan',1),('00:40:24','Compac Inc.','Compac Inc.16-7 Nihonbasi Hamacho 3-choChuo-ku, TokyoJapanJapan',1),('00:40:25','Molecular Dynamics','Molecular Dynamics880 East Arques AvenueSunnyvale Ca 94086-4536United States',1),('00:40:26','Melco, Inc.','Melco, Inc.Melco Hi-tech Center,Shibata Hondori 4-15 Minami-kuNagoya  457-8520Japan',1),('00:40:27','Smc Massachusetts, Inc.','Smc Massachusetts, Inc.25 Walkers Brook DriveReading Ma 01867United States',1),('00:40:28','Netcomm Limited','Netcomm Limited3 Olympic Business CentrePaycocke Road Basildon, Essex Ss14 3exUnited KingdomUnited Kingdom',1),('00:40:29','Compex','CompexB.p. 3574371 Pringy-franceFranceFrance',1),('00:40:2A','Canoga-perkins','Canoga-perkins21012 Lassen StreetChatsworth Ca 91311-4241United States',1),('00:40:2B','Trigem Computer, Inc.','Trigem Computer, Inc.Kisung B/d 4f, 784-6Yeoksam-dong, Kangnam-guSeoul Korea 135-080Korea, Republic Of',1),('00:40:2C','Isis Distributed Systems, Inc.','Isis Distributed Systems, Inc.111 South Cayuga StreetSuite #200Ithaca Ny 14850United States',1),('00:40:2D','Harris Adacom Corporation','Harris Adacom Corporation1100 Venture CourtCarrollton Tx 75006-5412United States',1),('00:40:2E','Precision Software, Inc.','Precision Software, Inc.600 S Federal Hwy SteDeerfield Beach Fl 33441-4193United States',1),('00:40:2F','Xlnt Designs Inc.','Xlnt Designs Inc.15050 Avenue Of ScienceSuite 200San Diego Ca 92128United States',1),('00:40:30','Gk Computer','Gk ComputerBasler Strasse 103D-7800 FreiburgGermanyGermany',1),('00:40:31','Kokusai Electric Co., Ltd','Kokusai Electric Co., Ltd2-1 YasuuchiYatsuo-machi NeigunToyama 939-23 JapanJapan',1),('00:40:32','Digital Communications','Digital CommunicationsAssociates, Inc.2010 Fortune Drive, #101San Jose Ca 95131United States',1),('00:40:33','Addtron Technology Co., Ltd.','Addtron Technology Co., Ltd.46560 Fremont Blvd. #303Fremont Ca 94538United States',1),('00:40:34','Bustek Corporation','Bustek Corporation4151 Burton DriveSanta Clara Ca 95054United States',1),('00:40:35','Opcom','Opcom1215 W. Crosby Rd.Carrollton Tx 75006United States',1),('00:40:36','Tribe Computer Works, Inc.','Tribe Computer Works, Inc.1195 Park Avenue-ste #211Emeryville Ca 94608United States',1),('00:40:37','Sea-ilan, Inc.','Sea-ilan, Inc.14602 North Us Highway #31Carmel In 46032United States',1),('00:40:38','Talent Electric Incorporated','Talent Electric Incorporated3rd Fl., No. 260, Pa Teh RoadSec. 2 TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:40:39','Optec Daiichi Denko Co., Ltd.','Optec Daiichi Denko Co., Ltd.Fiber Optics & Telecom. Div.3-1-1 Marunouchi Chiyodaku Tokyo 100Japan',1),('00:40:3A','Impact Technologies','Impact Technologies6 Rue De LacadieZ.a. Courtaboeuf 91953 Les Ulis CedexFranceFrance',1),('00:40:3B','Synerjet International Corp.','Synerjet International Corp.5f, No 35, Kuang Fu S. RoadTaipei,Taiwan R. O. C.Taiwan, Republic Of China',1),('00:40:3C','Forks, Inc.','Forks, Inc.1-27-4 Iriya,Iriya 1-27-4 Taito,110 JapanJapan',1),('00:40:3D','Teradata','Teradata100 N. Sepulveda Blvd.El Segundo Ca 90245United States',1),('00:40:3E','Raster Ops Corporation','Raster Ops Corporation2500 Walsh AvenueSanta Clara Ca 95051United States',1),('00:40:3F','Ssangyong Computer Systems','Ssangyong Computer SystemsCorporation60-1, 3ga, Chungmu-ro, Jung-gu SeoulKorea 100-705Korea, Republic Of',1),('00:40:40','Ring Access, Inc.','Ring Access, Inc.957-r Industrial RoadSan Carlos Ca 94070United States',1),('00:40:41','Fujikura Ltd.','Fujikura Ltd.1-5-1, Kiba, Koto-kuTokyo 135JapanJapan',1),('00:40:42','N.a.t. Gmbh','N.a.t. GmbhGoethestr. 25210 Troisdorf-sieglarGermanyGermany',1),('00:40:43','Nokia Siemens Networks Gmbh & Co. Kg.','Nokia Siemens Networks Gmbh & Co. Kg.Werner-von-siemens Str. 2-6Bruchsal Baden-wrtemberg 76646Finland',1),('00:40:44','Qnix Computer Co., Ltd.','Qnix Computer Co., Ltd.8,9f Korean Teachers Mut.bldg35-3, Yeouido_dong, Yeongdeungpo_guSeoul Korea 150-010Korea, Republic Of',1),('00:40:45','Twinhead Corporation','Twinhead Corporation1537 Centre Pointe DriveMilpitas Ca 95035United States',1),('00:40:46','Udc Research Limited','Udc Research Limited8a King Wan Industrial Bldg.54 Hung To Road, Kwun TongHong KongHong Kong',1),('00:40:47','Wind River Systems','Wind River Systems1010 Atlantic AvenueAlameda Ca 94501United States',1),('00:40:48','Smd Informatica S.a.','Smd Informatica S.a.Largo Movimento Das ForcasArmadas, 4 Alfragide,  2700 AmadoraPortugalPortugal',1),('00:40:49','Tegimenta Ag','Tegimenta AgForrenstrasseCh-6343 RotkreuzSwitzerlandSwitzerland',1),('00:40:4A','West Australian Department','West Australian DepartmentOf Employment (devet)Lever 2, 151 Royal St. East Perth  6001Western AustraliaAustralia',1),('00:40:4B','Maple Computer Systems','Maple Computer SystemsP.o. Box 10050St. Johns, NfCanada Ala 4l5Canada',1),('00:40:4C','Hypertec Pty Ltd.','Hypertec Pty Ltd.P.o. Box 1782Macquarie Centre Nsw, 2113AustraliaAustralia',1),('00:40:4D','Telecommunications Techniques','Telecommunications TechniquesM/s20400 Observation DriveGermantown Md 20876United States',1),('00:40:4E','Fluent, Inc.','Fluent, Inc.594 Worcester Road-ste.#308Natick Ma 01760United States',1),('00:40:4F','Space & Naval Warfare Systems','Space & Naval Warfare SystemsNuwcCode 2222,  Bldg 1171-3Newport Ri 02841-5047United States',1),('00:40:50','Ironics, Incorporated','Ironics, Incorporated767 Warren RdIthaca N.y. 14850United States',1),('00:40:51','Gracilis, Inc.','Gracilis, Inc.623 Palace StreetAurora Il 60506United States',1),('00:40:52','Star Technologies, Inc.','Star Technologies, Inc.515 Shaw RoadSterling Va 22075United States',1),('00:40:53','Ampro Computers','Ampro Computers990 Almondor AvenueSunnyvale Ca 94086United States',1),('00:40:54','Connection Machines Services','Connection Machines Services12 Henshaw StreetWoburn Ma 01801-466664United States',1),('00:40:55','Metronix Gmbh','Metronix GmbhNeue Knochenhauerstrabe 5D-3300 BraunschweigWest GermanyGermany',1),('00:40:56','Mcm Japan Ltd.','Mcm Japan Ltd.Syuukaen Bld. 2-11-1Komazawa Setagaya-ku Tokyo 154JapanJapan',1),('00:40:57','Lockheed - Sanders','Lockheed - SandersDaniel Webster Highway SouthP.o. Box 868Nashua Nh 03061-0868United States',1),('00:40:58','Kronos, Inc.','Kronos, Inc.400 Fifth AvenueWaltham Ma 02154United States',1),('00:40:59','Yoshida Kogyo K. K.','Yoshida Kogyo K. K.Technical Research Dept.200 Yoshida Kurobe City Toyama Pref.939 JapanJapan',1),('00:40:5A','Goldstar Information & Comm.','Goldstar Information & Comm.533, Hogae-dong, Anyang-shiKyongki-do 430-080KoreaKorea, Republic Of',1),('00:40:5B','Funasset Limited','Funasset LimitedOrchards, 14 TownsendSomerset Ta19 Oau IlminsterUnited KingdomUnited Kingdom',1),('00:40:5C','Future Systems, Inc.','Future Systems, Inc.Room 102 Dong Bang B/d,Yeog Sam-dong 740-5, Kang Nam-kuSeoul 130-080 Seoul 130-080 KoreaKorea, Republic Of',1),('00:40:5D','Star-tek, Inc.','Star-tek, Inc.71 Lyman StreetNorthboro Ma 01532United States',1),('00:40:5E','North Hills Israel','North Hills IsraelP.o. Box 1280Yokneam 20692IsraelIsrael',1),('00:40:5F','Afe Computers Ltd.','Afe Computers Ltd.62 Anchorage RoadSutton Coldfield West Midlands B74 2pgUnited KingdomUnited Kingdom',1),('00:40:60','Comendec Ltd','Comendec LtdEnterprise Way,Aston Science Park, Aston TriangleBirmingham Birmingham EnglandUnited Kingdom',1),('00:40:61','Datatech Enterprises Co., Ltd.','Datatech Enterprises Co., Ltd.(lin Kou Industrial Zone Sec,427, Hsi-shih Lake Road Kuei-shan HsiangTaoyuan County Taiwan R.o.c.Taiwan, Republic Of China',1),('00:40:62','E-systems, Inc./garland Div.','E-systems, Inc./garland Div.P.o. Box 660023Mail Stop 63000Dallas Tx 75266-0023United States',1),('00:40:63','Via Technologies, Inc.','Via Technologies, Inc.5020 Brandin CourtFremont Ca 94538United States',1),('00:40:64','Kla Instruments Corporation','Kla Instruments Corporation160 Rio RoblesSan Jose Ca 95161-9055United States',1),('00:40:65','Gte Spacenet','Gte Spacenet1700 Old Meadow RoadMclean Va 22102United States',1),('00:40:66','Hitachi Cable, Ltd.','Hitachi Cable, Ltd.Opto Electronic System Lab880 Isagozaw-cho, Hitachi-shi Ibaraki-ke319-14 JapanJapan',1),('00:40:67','Omnibyte Corporation','Omnibyte Corporation245 West Roosevelt RoadWest Chicago Il 60185United States',1),('00:40:68','Extended Systems','Extended Systems6123 North Meeker AvenueBoise Id 83704United States',1),('00:40:69','Lemcom Systems, Inc.','Lemcom Systems, Inc.2104 West Peoria AvenuePhoenix Az 85029United States',1),('00:40:6A','Kentek Information Systems,inc','Kentek Information Systems,inc2945 Wilderness PlaceBoulder Co 80301United States',1),('00:40:6B','Sysgen','Sysgen556 Gibraltar DriveMilpitas Ca 95035United States',1),('00:40:6C','Copernique','Copernique6, Mail De Leurope Bp 2578170 La Celle-saint-cloudFranceFrance',1),('00:40:6D','Lanco, Inc.','Lanco, Inc.800 West Airport FreewaySuite #1100Irving Tx 75062United States',1),('00:40:6E','Corollary, Inc.','Corollary, Inc.2802 KelvinIrvine Ca 92714United States',1),('00:40:6F','Sync Research Inc.','Sync Research Inc.7 StudebakerIrvine Ca 92718United States',1),('00:40:70','Interware Co., Ltd.','Interware Co., Ltd.7f Kudan New Central Bldg.,1-4-5 Kudan-kita, Chiyoda-kuTokyo 102 Tokyo 102 JapanJapan',1),('00:40:71','Atm Computer Gmbh','Atm Computer GmbhBucklestr. 1-5,postfach 101043D7750 KonstanzGermanyGermany',1),('00:40:72','Applied Innovation Inc.','Applied Innovation Inc.5800 Innovation DriveDublin Oh 43016-3271United States',1),('00:40:73','Bass Associates','Bass Associates435 Tasso Street, Ste. #325Palo Alto Ca 94301United States',1),('00:40:74','Cable And Wireless','Cable And WirelessCommunications, Inc.1919 Gallows RoadVienna Va 22182-3964United States',1),('00:40:75','M-trade (uk) Ltd','M-trade (uk) Ltd11-12 Northfield ProspectPutney Bridge Road London Sw18 1hrUnited KingdomUnited Kingdom',1),('00:40:76','Sun Conversion Technologies','Sun Conversion Technologies100 Commerce BoulevardQuakertown Pa 78951-2237United States',1),('00:40:77','Maxton Technology Corporation','Maxton Technology Corporation4fk, 249, Sec. 3,Chung Hsiao E. Rd., TaipeiTaiwanTaiwan, Republic Of China',1),('00:40:78','Wearnes Automation Pte Ltd','Wearnes Automation Pte Ltd801 Lorong 7, Toa PayohSingapore 1231Singapore',1),('00:40:79','Juko Manufacture Company, Ltd.','Juko Manufacture Company, Ltd.Flat C, 3rd Floor, Cdw Bldg.388 Castle Peak Road, Tsuen Wan, N.t.Hong KongHong Kong',1),('00:40:7A','Societe Dexploitation Du Cnit','Societe Dexploitation Du Cnit2 Glace De La Defense 92053Paris-la-defenseFranceFrance',1),('00:40:7B','Scientific Atlanta','Scientific AtlantaInformation Technology4311 Communications Drive Mail Code:  30Norcross Ga 30091-6850United States',1),('00:40:7C','Qume Corporation','Qume Corporation500 Yosemite Drive, M/s-29Milpitas Ca 95035-5426United States',1),('00:40:7D','Extension Technology Corp.','Extension Technology Corp.30 Hollis StreetFramingham Ma 01701United States',1),('00:40:7E','Evergreen Systems, Inc.','Evergreen Systems, Inc.120 Landing Court-suiteNovato Ca 94945United States',1),('00:40:7F','Flir Systems','Flir SystemsBox 3182-11  DanderydSwedenSweden',1),('00:40:80','Athenix Corporation','Athenix Corporation675 Almanor AvenueSunnyvale Ca 94086United States',1),('00:40:81','Mannesmann Scangraphic Gmbh','Mannesmann Scangraphic GmbhRissener Strasse 112-114W-2000 WedelGermanyGermany',1),('00:40:82','Laboratory Equipment Corp.','Laboratory Equipment Corp.1-7-3 MinatomachiTuchiura-city Ibaragi-ken,300 JapanJapan',1),('00:40:83','Tda Industria De Produtos','Tda Industria De ProdutosEletronicos S.a.Rue Agostino Togneri, 92 04690 - Sao PauBrazilBrazil',1),('00:40:84','Honeywell Inc.','Honeywell Inc.Honeywell Ssdc - M.s. 23003660 Technology DriveMinneapolis Mn 55418United States',1),('00:40:85','Saab Instruments Ab','Saab Instruments AbP.o. Box 1017S-551 11 JonkopingSweden',1),('00:40:86','Michels & Kleberhoff Computer','Michels & Kleberhoff ComputerGathe 1175600 Wuppertal 1GermanyGermany',1),('00:40:87','Ubitrex Corporation','Ubitrex Corporation19th Floor, 155 Carlton StreetWinnipeg, ManitobaCanada R3c 3h8Canada',1),('00:40:88','Mobius Technologies, Inc.','Mobius Technologies, Inc.5835 Doyle StreetEmeryville Ca 94608United States',1),('00:40:89','Meidensha Corporation','Meidensha CorporationFactory No.4, 515 KaminakamizoHigashi Makado Numazu-city Shizuoka-prefJapanJapan',1),('00:40:8A','Tps Teleprocessing Sys. Gmbh','Tps Teleprocessing Sys. GmbhSchwadermuchlstrasse 4-8W-8501 CadolzburgGermanyGermany',1),('00:40:8B','Raylan Corporation','Raylan Corporation120 Independence DriveMenlo Park Ca 94025United States',1),('00:40:8C','Axis Communications Ab','Axis Communications AbScheelevagen 16S-223 70 LundSwedenSweden',1),('00:40:8D','The Goodyear Tire & Rubber Co.','The Goodyear Tire & Rubber Co.1144 East Market StreetAkron Oh 44316United States',1),('00:40:8E','Digilog, Inc.','Digilog, Inc.2360 Maryland RoadWillow Grove Pa 19090United States',1),('00:40:8F','Wm-data Minfo Ab','Wm-data Minfo AbOlof Asklunds Gata 14Box 2065 421 02 GoteborgSwedenSweden',1),('00:40:90','Ansel Communications','Ansel Communications1701 Junction CourtSan Jose Ca 95112United States',1),('00:40:91','Procomp Industria Eletronica','Procomp Industria EletronicaAv. Kenkiti Simomoto, 76705347 - Sao Paulo / SpBrazilBrazil',1),('00:40:92','Asp Computer Products, Inc.','Asp Computer Products, Inc.160 San Gabriel DriveSunnyvale Ca 94086United States',1),('00:40:93','Paxdata Networks Ltd.','Paxdata Networks Ltd.Communications House,Frogmore Road Hemel Hempstead, Herts Hp3EnglandUnited Kingdom',1),('00:40:94','Shographics, Inc.','Shographics, Inc.1890 N. Shoreline Blvd.Mountain View Ca 94043United States',1),('00:40:95','R.p.t. Intergroups Intl Ltd.','R.p.t. Intergroups Intl Ltd.9f, 50 Min Chuan RdHsin Tien, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:40:96','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.San Jose Ca 95134United States',1),('00:40:97','Datex Division Of','Datex Division OfInstrumentarium Corp.P.o. Box 446, Sf-00101 HelsinkiFinlandFinland',1),('00:40:98','Dressler Gmbh & Co.','Dressler Gmbh & Co.Kackertstrasse 10D-52072 AachenGermanyGermany',1),('00:40:99','Newgen Systems Corp.','Newgen Systems Corp.17580 Newhope StreetFountain Valley Ca 92708United States',1),('00:40:9A','Network Express, Inc.','Network Express, Inc.2200 Green Road - SteAnn Arbor Mi 48170United States',1),('00:40:9B','Hal Computer Systems Inc.','Hal Computer Systems Inc.1315 Dell AvenueCampbell Ca 95008United States',1),('00:40:9C','Transware','Transware21, Rue Du 8 Mai 1945941107 ArcueilFranceFrance',1),('00:40:9D','Digiboard, Inc.','Digiboard, Inc.6400 Flying Cloud DriveEden Prairie Mn 55344United States',1),('00:40:9E','Concurrent Technologies  Ltd.','Concurrent Technologies  Ltd.654 The CrescentColchester Business Park Colchester, EssUnited KingdomUnited Kingdom',1),('00:40:9F','Lancast/casat Technology, Inc.','Lancast/casat Technology, Inc.10 Northern Blvd.-unit 5Amherst Nh 03031-2328United States',1),('00:40:A0','Goldstar Co., Ltd.','Goldstar Co., Ltd.6 Ga 3b Munlae YeongdeungpoSeoulKoreaKorea, Republic Of',1),('00:40:A1','Ergo Computing','Ergo ComputingOne Intercontinental WayPeabody Ma 01960United States',1),('00:40:A2','Kingstar Technology Inc.','Kingstar Technology Inc.1-3f, No. 185, Sec. 3,Cheng Teh RoadTaipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:40:A3','Microunity Systems Engineering','Microunity Systems Engineering255 Caspian DriveSunnyvale Ca 94089-1015United States',1),('00:40:A4','Rose Electronics','Rose ElectronicsP.o. Box 742571Houston Tx 77274-2571United States',1),('00:40:A5','Clinicomp Intl.','Clinicomp Intl.4510 Execcutive Drive-ste.#200San Diego Ca 92121United States',1),('00:40:A6','Cray, Inc.','Cray, Inc.655f Lone Oak DriveEagan Mn 55121United States',1),('00:40:A7','Itautec Philco S.a.','Itautec Philco S.a.Grupo Itautec PhilcoRua Santa Catarina, 1 03086-020 Sao PaulBrazilBrazil',1),('00:40:A8','Imf International Ltd.','Imf International Ltd.No.5 2/f Kingsford Ind. Centre13 Wang Hoi Road Kowloon Bay, KowloonHong KongHong Kong',1),('00:40:A9','Datacom Inc.','Datacom Inc.146 Highway Route 34 - Ste 250Holmdel Nj 07733United States',1),('00:40:AA','Valmet Automation Inc.','Valmet Automation Inc.P.o. Box 237Sf-33101 TampereFinlandFinland',1),('00:40:AB','Roland Dg Corporation','Roland Dg Corporation1227 Okubo-cho, Hamamatsu-shiShizuoka-ken432 JapanJapan',1),('00:40:AC','Super Workstation, Inc.','Super Workstation, Inc.2190 Paragon DriveSan Jose Ca 95131United States',1),('00:40:AD','Sma Regelsysteme Gmbh','Sma Regelsysteme GmbhHannoversche Str. 1-5D 3501 NiestetalGermanyGermany',1),('00:40:AE','Delta Controls, Inc.','Delta Controls, Inc.13520 78th AvenueSurrey, B.c.Canada V3w 8j6Canada',1),('00:40:AF','Digital Products, Inc.','Digital Products, Inc.411 Waverly Oaks RoadWaltham Ma 02154United States',1),('00:40:B0','Bytex Corporation, Engineering','Bytex Corporation, Engineering13873 Park Center RoadHerndon Va 22071United States',1),('00:40:B1','Codonics Inc.','Codonics Inc.17991 Englewood DriveMiddleburg Hts Oh 44130United States',1),('00:40:B2','Systemforschung','SystemforschungKonigstrasse 33a5300 Bonn 1GermanyGermany',1),('00:40:B3','Par Microsystems Corporation','Par Microsystems Corporation220 Seneca TurnpikeNew Hartford Ny 13413-1191United States',1),('00:40:B4','Nextcom K.k.','Nextcom K.k.1-12-1 ShibuyaShibuya-ku, Tokyo, 150JapanJapan',1),('00:40:B5','Video Technology Computers Ltd','Video Technology Computers Ltd33/f., Block #1,Tai Ping Industrial Center 57 Ting Kok RN.t. Hong KongHong Kong',1),('00:40:B6','Computerm  Corporation','Computerm  Corporation111 Wood StreetPittsburgh Pa 15222United States',1),('00:40:B7','Stealth Computer Systems','Stealth Computer Systems2341 Regina Ct.Santa Clara Ca 95054United States',1),('00:40:B8','Idea Associates','Idea Associates29 Dunham RoadBillerica Ma 01821United States',1),('00:40:B9','Macq Electronique Sa','Macq Electronique SaRue De Laeronef 2B - 1140 BrusselsBelgiumBelgium',1),('00:40:BA','Alliant Computer Systems Corp.','Alliant Computer Systems Corp.One Monarch DriveLittleton Ma 01460United States',1),('00:40:BB','Goldstar Cable Co., Ltd.','Goldstar Cable Co., Ltd.555, Hogye-dong, Anyang-shiKyungki-do, 430-080KoreaKorea, Republic Of',1),('00:40:BC','Algorithmics Ltd.','Algorithmics Ltd.3 Drayton ParkLondon N5 1nuEnglandUnited Kingdom',1),('00:40:BD','Starlight Networks, Inc.','Starlight Networks, Inc.444 Castro Street SteMountain View Ca 94041United States',1),('00:40:BE','Boeing Defense & Space','Boeing Defense & SpaceP.o. Box 3999Mail Stop 88-12Seattle Wa 98124-2499United States',1),('00:40:BF','Channel Systems Internl Inc.','Channel Systems Internl Inc.93 So. La Patera LaneSanta Barbara Ca 93117United States',1),('00:40:C0','Vista Controls Corporation','Vista Controls Corporation27825 Fremont CourtValencia Ca 91355United States',1),('00:40:C1','Bizerba-werke Wilheim Kraut','Bizerba-werke Wilheim KrautGmbh & Co. Kg,Wilhelm-kraut-str. 65 P.o. Box 100164D-7460 Balingen D-7460 Balingen GermanyGermany',1),('00:40:C2','Applied Computing Devices','Applied Computing DevicesAleph Park100 South Campus DriveTerre Haute In 47802United States',1),('00:40:C3','Fischer And Porter Co.','Fischer And Porter Co.125 E. County Line RoadWarminster Pa 18974United States',1),('00:40:C4','Kinkei System Corporation','Kinkei System Corporation1-22-17, Kamikita, HiranokuOsaka, 547JapanJapan',1),('00:40:C5','Micom Communications Inc.','Micom Communications Inc.4100 Los Angeles AvenueSimi Valley Ca 93063United States',1),('00:40:C6','Fibernet Research, Inc.','Fibernet Research, Inc.1 Tara Boulevard-#405Nashua Nh 03062United States',1),('00:40:C7','Ruby Tech Corporation','Ruby Tech Corporation6f-1, No.3, Lane 250,Sec. 5 Nanking E.roadTaipei Taiwan, R.o.c.Taiwan, Republic Of China',1),('00:40:C8','Milan Technology Corporation','Milan Technology Corporation894 Ross Drive--ste #105Sunnyvale Ca 94089United States',1),('00:40:C9','Ncube','Ncube919 East Hillsdale Blvd.Suite 200Foster City Ca 94404United States',1),('00:40:CA','First Internatl Computer, Inc','First Internatl Computer, IncFic BuildingNo 300 Yang Guang StreetNeihu Taipei 114 Taipei 114Taiwan, Republic Of China',1),('00:40:CB','Lanwan Technologies','Lanwan Technologies1566 La Pradera DriveCampbell Ca 95008United States',1),('00:40:CC','Silcom Manufg Technology Inc.','Silcom Manufg Technology Inc.5620 Timberlea BoulevardMississauga, OntarioCanada L4w 4m6Canada',1),('00:40:CD','Tera Microsystems, Inc.','Tera Microsystems, Inc.2500 Great America ParkwaySte. #250Santa Clara Ca 95054United States',1),('00:40:CE','Net-source, Inc.','Net-source, Inc.1265 El Camino RealSuite 101Santa Clara Ca 95050United States',1),('00:40:CF','Strawberry Tree, Inc.','Strawberry Tree, Inc.160 South Wolfe RoadSunnyvale Ca 94086United States',1),('00:40:D0','Mitac International Corp.','Mitac International Corp.8th Fl. 585 Ming Sheng E. Rd.TaipeiTaiwan, Republic Of China',1),('00:40:D1','Fukuda Denshi Co., Ltd.','Fukuda Denshi Co., Ltd.R & D Department No. 135-8, Hongo 2-chome, Bunkyo-ku Tokyo 113JapanJapan',1),('00:40:D2','Pagine Corporation','Pagine Corporation1961-a Concourse DriveSan Jose Ca 95131United States',1),('00:40:D3','Kimpsion International Corp.','Kimpsion International Corp.4701 Patrick Henry DriveSuite 401Santa Clara Ca 95054United States',1),('00:40:D4','Gage Talker Corp.','Gage Talker Corp.13680 Ne 16th StreetBellevue Wa 98005United States',1),('00:40:D5','Sartorius Ag','Sartorius AgWeender Landstr: 94 - 1083400 GottingenGermanyGermany',1),('00:40:D6','Locamation B.v.','Locamation B.v.Postbox 3607500 Aj EnschedeHollandNetherlands',1),('00:40:D7','Studio Gen Inc.','Studio Gen Inc.3-12-8 Takanawa #202Minatoku, Tokyo 108JapanJapan',1),('00:40:D8','Ocean Office Automation Ltd.','Ocean Office Automation Ltd.4th & 5th Floor, Kader Bldg.22 Kai Cheung Road Kowloon Bay, KowloonHong KongHong Kong',1),('00:40:D9','American Megatrends Inc.','American Megatrends Inc.6145f N Belt ParkwayNorcross Ga 30071United States',1),('00:40:DA','Telspec Ltd','Telspec LtdLancaster Parker RoadRochester Airport, Rochester Kent Me1 3qEnglandUnited Kingdom',1),('00:40:DB','Advanced Technical Solutions','Advanced Technical Solutions8050 Seminole Office CenterSuite 210Seminole Fl 34642United States',1),('00:40:DC','Tritec Electronic Gmbh','Tritec Electronic GmbhRobert Koch Str. 35D6500 Mainz 42GermanyGermany',1),('00:40:DD','Hong Technologies','Hong Technologies532 Weddell DriveSunnyvale Ca 94089United States',1),('00:40:DE','Elettronica San Giorgio','Elettronica San GiorgioElsag S.p.a.Via G. Puccini, 216154 Genova - ItalyItaly',1),('00:40:DF','Digalog Systems, Inc.','Digalog Systems, Inc.3180 South 166th StreetNew Berlin Wi 53151United States',1),('00:40:E0','Atomwide Ltd.','Atomwide Ltd.23 The GreenwayOrpington Br5 2ayUnited KingdomUnited Kingdom',1),('00:40:E1','Marner International, Inc.','Marner International, Inc.1617 93rd Lane NeBlaine Mn 55449United States',1),('00:40:E2','Mesa Ridge Technologies, Inc.','Mesa Ridge Technologies, Inc.6725 Mesa Ridge Road-ste#100San Diego Ca 92121United States',1),('00:40:E3','Quin Systems Ltd','Quin Systems LtdOaklands Business CentreOaklands Park, Wokingham Berks  Rg11 2fdUnited KingdomUnited Kingdom',1),('00:40:E4','E-m Technology, Inc.','E-m Technology, Inc.9245 Southwest Nimbus Ave.Beaverton Or 97005United States',1),('00:40:E5','Sybus Corporation','Sybus Corporation2300 Tall Pine Drive-ste. #100Largo Fl 34641United States',1),('00:40:E6','C.a.e.n.','C.a.e.n.2, Chemin LateralF94290 Villeneuve Le RoiFranceFrance',1),('00:40:E7','Arnos Instruments & Computer','Arnos Instruments & ComputerSystems (group) Co., Ltd.4/f., Eureka Ind. Bldg., 1-17 Sai Lau KoTsuen Wan N.t. Hong KongHong Kong',1),('00:40:E8','Charles River Data Systems,inc','Charles River Data Systems,inc983 Concord StreetFramingham Ma 01701United States',1),('00:40:E9','Accord Systems, Inc.','Accord Systems, Inc.572 Valley WayMilpitas Ca 95035United States',1),('00:40:EA','Plain Tree Systems Inc','Plain Tree Systems IncChief Exectuvie Officer59 Iber Road, Stittsville Ontario K2s 1eCanadaCanada',1),('00:40:EB','Martin Marietta Corporation','Martin Marietta Corporation12506 Lake UnderhillOrlando Fl 32825United States',1),('00:40:EC','Mikasa System Engineering','Mikasa System EngineeringCo., Ltd.1-3-10, Minami-shinmachi, Chuo-ku, OsakaJapanJapan',1),('00:40:ED','Network Controls Intnatl Inc.','Network Controls Intnatl Inc.9 Woodlawn GreenCharlotte Nc 28217United States',1),('00:40:EE','Optimem','Optimem297 N. Bernardo AvenueMountain View Ca 94043-5205United States',1),('00:40:EF','Hypercom, Inc.','Hypercom, Inc.2851 West Kathleen RoadPhoenix Az 85023United States',1),('00:40:F0','Micro Systems, Inc.','Micro Systems, Inc.69-52 Nagakude Kanihara,Nagakut. Ch. Aich-gun Aichi-ken 480-11JapanJapan',1),('00:40:F1','Chuo Electronics Co., Ltd.','Chuo Electronics Co., Ltd.1-9-9, Motohongo-choHachioji-shi Tokyo 192JapanJapan',1),('00:40:F2','Janich & Klass Computertechnik','Janich & Klass ComputertechnikZum Alten Zollhaus 20W-5600 Wuppertal 2GermanyGermany',1),('00:40:F3','Netcor','Netcor850 Auburn CourtFremont Ca 94538United States',1),('00:40:F4','Cameo Communications, Inc.','Cameo Communications, Inc.71 Spitbrook Road, Ste #410Nashua Nh 030603United States',1),('00:40:F5','Oem Engines','Oem Engines1190 Dell Avenue, Ste.Campbell Ca 95008United States',1),('00:40:F6','Katron Computers Inc.','Katron Computers Inc.4 Fl. No. 2, Alley 23Lane 91 Sec. 1 Nei Hu RoadTaipei Taipei TaiwanTaiwan, Republic Of China',1),('00:40:F7','Polaroid Corporation','Polaroid Corporation300 Baker AvenueConcord Ma 01742United States',1),('00:40:F8','Systemhaus Discom','Systemhaus DiscomDistributed Computing GmbhRoermonderstr. 615 D-5100 AachenGermanyGermany',1),('00:40:F9','Combinet','Combinet333 W. El Camino Real-ste#310Sunnyvale Ca 94087United States',1),('00:40:FA','Microboards, Inc.','Microboards, Inc.31-8, Takasecho,funabashi-cityChiba 273 Chiba 273 JapanJapan',1),('00:40:FB','Cascade Communications Corp.','Cascade Communications Corp.Production Quality Engineer239 Littleton Road-unit 4aWestford Ma 01886United States',1),('00:40:FC','Ibr Computer Technik Gmbh','Ibr Computer Technik GmbhFrankfurter Str. 114D 6056 HeusenstammWest GermanyGermany',1),('00:40:FD','Lxe','Lxe303 Research DriveNorcross Ga 30092United States',1),('00:40:FE','Symplex Communications','Symplex Communications5 Research DriveAnn Arbor Mi 48103United States',1),('00:40:FF','Telebit Corporation','Telebit Corporation1315 Chesapeake TerraceSunnyvale Ca 94089-1100United States',1),('00:42:52','Rlx Technologies','Rlx Technologies25231 Grograns Mill RdSuite 600The Woodlands Tx 77380United States',1),('00:45:01','Versus Technology, Inc.','Versus Technology, Inc.2600 Miller Creek RoadTraverse City Mi 49684United States',1),('00:50:00','Nexo Communications, Inc.','Nexo Communications, Inc.2nd Fl., 160, Mingchu RoadHsinchu CityTaiwan, Republic Of China',1),('00:50:01','Yamashita Systems Corp.','Yamashita Systems Corp.5-7-12 IkegamiOta-ku TokyoJapan',1),('00:50:02','Omnisec Ag','Omnisec AgRietstrasse 14Ch-8108 DaellikonSwitzerland',1),('00:50:03','Gretag Macbeth Ag','Gretag Macbeth AgAlthardstrasse 70Ch-8105 RegensdorfSwitzerland',1),('00:50:04','3com Corporation','3com Corporation5400 Bayfront PlazaSanta Clara Ca 95052United States',1),('00:50:06','Tac Ab','Tac AbJagershillgaton 1821375 MalmoSweden',1),('00:50:07','Siemens Telecommunication Systems Limited','Siemens Telecommunication Systems LimitedNo. 90, Sec. 1, Chien Kuo North RoadTaipeiTaiwan, Republic Of China',1),('00:50:08','Tiva Microcomputer Corp. (tmc)','Tiva Microcomputer Corp. (tmc)48550 Fremont Blvd.Fremont Ca 94538United States',1),('00:50:09','Philips Broadband Networks','Philips Broadband Networks64 Perimeter Centre EastAtlanta Ga 30346United States',1),('00:50:0A','Iris Technologies, Inc.','Iris Technologies, Inc.Westmoreland Indusrial ParkR.r. 12  Box 36Greensburg Pa 15601United States',1),('00:50:0B','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s Sja-2San Jose Ca 95134-1706United States',1),('00:50:0C','E-tek Labs, Inc.','E-tek Labs, Inc.1057 East Henrietta Rd.Rochester Ny 14623United States',1),('00:50:0D','Satori Electoric Co., Ltd.','Satori Electoric Co., Ltd.Tigusadai 38-8  Midori-kuYokohama, KanagawaJapan',1),('00:50:0E','Chromatis Networks, Inc.','Chromatis Networks, Inc.3 Bethesda Metro CenterBethesda Md 20814United States',1),('00:50:0F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive - Sja-2San Jose Ca 95134-1706United States',1),('00:50:10','Novanet Learning, Inc.','Novanet Learning, Inc.125 W. Church Street-ste. #300Champaign Il 61820United States',1),('00:50:12','Cbl - Gmbh','Cbl - GmbhDarmstaedter Str. 81D-64839 MuensterGermany',1),('00:50:13','Chaparral Network Storage','Chaparral Network Storage7420 E. Dry Creek ParkwayLongmont Co 80503United States',1),('00:50:14','Cisco Systems, Inc.','Cisco Systems, Inc.M/s/ Sja-2170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:50:15','Bright Star Engineering','Bright Star Engineering19 Enfield DriveAndover Ma 01810United States',1),('00:50:16','Sst/woodhead Industries','Sst/woodhead Industries50 Northland RoadWaterlooOntario N2v 1n3Canada',1),('00:50:17','Rsr S.r.l.','Rsr S.r.l.Via Sinigaglia, 38Lurate Caccivio (co)22075 ItalyItaly',1),('00:50:18','Amit, Inc.','Amit, Inc.No.32, Huangong Rd.,Yongkang City, Tainan County 71041Taiwan, Republic Of China',1),('00:50:19','Spring Tide Networks, Inc.','Spring Tide Networks, Inc.85 Swanson RoadBoxborough Ma 01719United States',1),('00:50:1A','Iqinvision','Iqinvision33122 Valle RoadSan Juan Capistrano Ca 92675-4853United States',1),('00:50:1B','Abl Canada, Inc.','Abl Canada, Inc.8550 Cote De LiesseSt-laurent (quebec) H4t 1h2Canada',1),('00:50:1C','Jatom Systems, Inc.','Jatom Systems, Inc.99 Michael Cowpland DriveKanataOntario, K2m 1x3Canada',1),('00:50:1E','Miranda Technologies, Inc.','Miranda Technologies, Inc.3499, Douglas B. FloreaniSanit-laurent, QcH4s 2c6Canada',1),('00:50:1F','Mrg Systems, Ltd.','Mrg Systems, Ltd.Willow House, Slad RoadStroudGlos.  Gl5 1qg EnglandUnited Kingdom',1),('00:50:20','Mediastar Co., Ltd.','Mediastar Co., Ltd.3fl, Sohun Bldg.951-33 Dogok-dong, Kangnam-ku SeoulKoreaKorea, Republic Of',1),('00:50:21','Eis International, Inc.','Eis International, Inc.1351 Washington Blvd.Stamford Ct 06902United States',1),('00:50:22','Zonet Technology, Inc.','Zonet Technology, Inc.830 Room, Bldg. 53, 195, Sec.4Chung Hsiung Rd, ChutungHsinchaTaiwan, Republic Of China',1),('00:50:23','Pg Design Electronics, Inc.','Pg Design Electronics, Inc.48700 Structural DriveChesterfield Mi 48051United States',1),('00:50:24','Navic Systems, Inc.','Navic Systems, Inc.74 Crescent StreetNeedham MaUnited States',1),('00:50:26','Cosystems, Inc.','Cosystems, Inc.1263 Oakmead ParkwaySunnyvale Ca 94086United States',1),('00:50:27','Genicom Corporation','Genicom Corporation900 Clopper Road - Ste. #110Gaithersburg Md 20878United States',1),('00:50:28','Aval Communications','Aval Communications1777 North California Blvd.Walnut Creek Ca 94596United States',1),('00:50:29','1394 Printer Working Group','1394 Printer Working GroupP.o. Box 23158San Jose Ca 95153United States',1),('00:50:2A','Cisco Systems, Inc.','Cisco Systems, Inc.M/s Sja-2170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:50:2B','Genrad Ltd.','Genrad Ltd.Orion Business ParkBirdhall Lane Stockport, CheshireUnited Kingdom Sk3 OxgUnited Kingdom',1),('00:50:2C','Soyo Computer, Inc.','Soyo Computer, Inc.No. 21 Wu-kung 5 Rd.Hsing Chuang City Taipei HsienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:50:2D','Accel, Inc.','Accel, Inc.1f, No. 7, R&d 1st RoadScience-based Industrial ParkHsinchuTaiwan, Republic Of China',1),('00:50:2E','Cambex Corporation','Cambex Corporation115 Flanders RoadWestborough Ma 01581United States',1),('00:50:2F','Tollbridge Technologies, Inc.','Tollbridge Technologies, Inc.872 Hermosa DriveSunnyvale Ca 94086United States',1),('00:50:30','Future Plus Systems','Future Plus Systems36 Olde English Rd.Bedford Nh 03110United States',1),('00:50:31','Aeroflex Laboratories, Inc.','Aeroflex Laboratories, Inc.35 South Service RoadPlainview Ny 11803United States',1),('00:50:32','Picazo Communications, Inc.','Picazo Communications, Inc.61 Daggett DriveSan Jose Ca 95134United States',1),('00:50:33','Mayan Networks','Mayan Networks3350 Scott Blvd. - Bldg. #9Santa Clara Ca 95054United States',1),('00:50:36','Netcam, Ltd.','Netcam, Ltd.6071 N. Paseo ZaldivarTucson Az 85750United States',1),('00:50:37','Koga Electronics Co.','Koga Electronics Co.5-8-10, Tehara, Ritto-choKurita GunShiga, 420-3047Japan',1),('00:50:38','Dain Telecom Co., Ltd.','Dain Telecom Co., Ltd.2nd Flr., Oh-sung Bldg. #2-28Yangjae-dong, Seocho-gu SeoulKorea, Republic Of',1),('00:50:39','Mariner Networks','Mariner Networks1585 S. Manchester Ave.Anaheim Ca 92802-2907United States',1),('00:50:3A','Datong Electronics Ltd.','Datong Electronics Ltd.Clayton Wood CloseWest ParkLeeds Ls16 6qeUnited Kingdom',1),('00:50:3B','Mediafire Corporation','Mediafire Corporation11317 Frederick AvenueBeltsville Md 20705United States',1),('00:50:3C','Tsinghua Novel Electronics','Tsinghua Novel ElectronicsCo., Ltd.Room 1205, Huaye Building Tsinghua Unive100084 100084 ChinaChina',1),('00:50:3E','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s/ Sja-2San Jose Ca 95134-1706United States',1),('00:50:3F','Anchor Games','Anchor Games815 Pilot Road, Suite GLas Vegas Nv 89119United States',1),('00:50:40','Panasonic Electric Works Co., Ltd.','Panasonic Electric Works Co., Ltd.Tsu-factory, 1668, FujikataTsu-shi Mie-ken 514-8555Japan',1),('00:50:41','Coretronic Corporation','Coretronic CorporationNo.11, Li Hsin Rd.Science-based Industrial Park HisnchuTaiwan, Republic Of China',1),('00:50:42','Sci Manufacturing Singapore Pte, Ltd.','Sci Manufacturing Singapore Pte, Ltd.3 Depot CloseSingapore 109840Singapore',1),('00:50:43','Marvell Semiconductor, Inc.','Marvell Semiconductor, Inc.645 Almanor AvenueSunnyvale Ca 94086United States',1),('00:50:44','Asaca Corporation','Asaca Corporation420 Corporate Circle, Unit HGolden Co 80401United States',1),('00:50:45','Rioworks Solutions, Inc.','Rioworks Solutions, Inc.4f, No.28, Lane 583Jui-kwang Road Taipei,  11457Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:50:46','Menicx International Co., Ltd.','Menicx International Co., Ltd.No.9, Ming Tsun RoadChutung, HsinchuTaiwan 310 Taiwan 310 R.o.c.Taiwan, Republic Of China',1),('00:50:47','Private','',1),('00:50:48','Infolibria','Infolibria411 Waverly Oaks Rd-ste #323Waltham Ma 02154-8414United States',1),('00:50:49','Arbor Networks Inc','Arbor Networks Inc7 Henry Clay DriveMerrimack Nh 03054United States',1),('00:50:4A','Elteco A.s.','Elteco A.s.Rosinska Cesta  P.o. Box C-901001 ZilinaSlovakiaSlovakia',1),('00:50:4B','Barconet N.v.','Barconet N.v.Luipaardstraat 128500 KortrijkBelgiumBelgium',1),('00:50:4C','Galil Motion Control','Galil Motion Control270 Technology WayRocklin Ca 95765United States',1),('00:50:4D','Tokyo Electron Device Limited','Tokyo Electron Device Limited1, Higashikata-machi, Tsuzuki-ku,Yokohama-shi Kanagawa-kenJapan',1),('00:50:4E','Sierra Monitor Corp.','Sierra Monitor Corp.1991 Tarob CourtMilpitas Ca 95035United States',1),('00:50:4F','Olencom Electronics','Olencom ElectronicsSoltam Industrial ParkP.o. Box 196Yokneam 20692Israel',1),('00:50:50','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive- Sja-2San Jose Ca 95134-1706United States',1),('00:50:51','Iwatsu Electric Co., Ltd.','Iwatsu Electric Co., Ltd.7-41, Kugayama 1-chomeSuginami-ku, Tokyo 168-8501Japan',1),('00:50:52','Tiara Networks, Inc.','Tiara Networks, Inc.113 Foorier AvenueFremont Ca 94539United States',1),('00:50:53','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive-sja-2San Jose Ca 95134-1706United States',1),('00:50:54','Cisco Systems, Inc.','Cisco Systems, Inc.M/s Sja-2170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:50:55','Doms A/s','Doms A/sFormervangen 28Dk-2600 GlostrupDenmarkDenmark',1),('00:50:56','Vmware, Inc.','Vmware, Inc.44 Encina AvenuePalo Alto Ca 94301United States',1),('00:50:57','Broadband Access Systems','Broadband Access Systems201 Forest StreetMarlborough Ma 01752United States',1),('00:50:58','Vegastream Group Limted','Vegastream Group Limted5 The Western CentreWestern RoadBracknell Berkshire Rg12 1rwUnited Kingdom',1),('00:50:59','Ibahn','Ibahn10757 S. River Front ParkwaySuite 300South Jordan Ut 84095United States',1),('00:50:5A','Network Alchemy, Inc.','Network Alchemy, Inc.1521.5 Pacific AvenueSanta Cruz Ca 95060United States',1),('00:50:5B','Kawasaki Lsi U.s.a., Inc.','Kawasaki Lsi U.s.a., Inc.2570 Northfirst StreetSuite #301San Jose Ca 95131United States',1),('00:50:5C','Tundo Corporation','Tundo Corporation7 Giborei Israel StreetNatanya 42504Israel',1),('00:50:5E','Digitek Micrologic S.a.','Digitek Micrologic S.a.Sant Joan De La Salle 6E08022 BarcelonaSpainSpain',1),('00:50:5F','Brand Innovators','Brand InnovatorsDe Pinck Art 545674 Cc NuenenNetherlands',1),('00:50:60','Tandberg Telecom As','Tandberg Telecom AsPhilip Pedersens Vei 201361 LysakerNorway',1),('00:50:62','Kouwell Electronics Corp.  **','Kouwell Electronics Corp.  **7f, No.99, Nan-kang RoadSec. 3, TaipeiTaiwan, Republic Of China',1),('00:50:63','Oy Comsel System Ab','Oy Comsel System AbTegelbruksgatan 5-7Fin-65100 VasaFinland',1),('00:50:64','Cae Electronics','Cae ElectronicsP.o. Box 1800St. Laurent, Quebec H4l 4x4Canada',1),('00:50:65','Tdk-lambda Corporation','Tdk-lambda Corporation36-1 KasuminosatoAmi-machi Inashiki-gun Ibaraki, 300-0396Japan',1),('00:50:66','Atecom Gmbh Advanced Telecomunication Modules','Atecom Gmbh Advanced Telecomunication ModulesKaiserstr. 100D-52134 HerzogenrathGermany',1),('00:50:67','Aerocomm, Inc.','Aerocomm, Inc.13256 W. 98th StreetLenexa Ks 66215United States',1),('00:50:68','Electronic Industries Association','Electronic Industries Association2500 Wilson Blvd.Arlington Va 22201United States',1),('00:50:69','Pixstream Incorporated','Pixstream Incorporated180 Columbia St. W.WaterlooOntario N2l 3l3Canada',1),('00:50:6A','Edeva, Inc.','Edeva, Inc.298 S. Sunnyvale Ave. - #208Sunnyvale Ca 94086United States',1),('00:50:6B','Spx-ateg','Spx-ateg802 S. Main StreetWayland Mi 49348United States',1),('00:50:6C','Beijer Electronics Products Ab','Beijer Electronics Products AbBox 426Se-201 24 MalmoeSweden',1),('00:50:6D','Videojet Systems','Videojet SystemsInternational Inc.1500 Mittel Blvd.Wooddale Il 60091-1073United States',1),('00:50:6E','Corder Engineering Corporation','Corder Engineering Corporation151 Kalmus Drive - Ste #a103Costa Mesa Ca 92626United States',1),('00:50:6F','G-connect','G-connectP.o. Box 2200Herzliya 46120Israel',1),('00:50:70','Chaintech Computer Co., Ltd.','Chaintech Computer Co., Ltd.5th F, Alley 2, Lane 222Lien-cheng Rd., Chung-ho Taipei-hsienTaiwan R.o.c.Taiwan, Republic Of China',1),('00:50:71','Aiwa Co., Ltd.','Aiwa Co., Ltd.1-11, Kamitomatsuri 4-chomeUtsunomiya-shi, Tochigi-ken 320-85Japan',1),('00:50:72','Corvis Corporation','Corvis Corporation8320 Guilford RoadColumbia Md 21046United States',1),('00:50:73','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s Sja-2San Jose Ca 95134-1706United States',1),('00:50:74','Advanced Hi-tech Corp.','Advanced Hi-tech Corp.1990 East Grand Ave.El Segundo Ca 90505United States',1),('00:50:75','Kestrel Solutions','Kestrel Solutions2370 Charleston RoadMt. View Ca 94043United States',1),('00:50:76','Ibm','IbmDept 29c 030-3 / C2193605 Highway 52 N.Rochester Mn 55901United States',1),('00:50:77','Prolific Technology, Inc.','Prolific Technology, Inc.6f 1, Lane 51, Sec 1Nan-chan Road Taipei100Taiwan, Republic Of China',1),('00:50:78','Megaton House, Ltd.','Megaton House, Ltd.Zip: 224 No.1-3-5 NakamachibaiTsuduki WardYokohamaJapan',1),('00:50:79','Private','',1),('00:50:7A','Xpeed, Inc.','Xpeed, Inc.4699 Old Ironsides DriveSuite #300Santa Clara Ca 95054United States',1),('00:50:7B','Merlot Communications','Merlot CommunicationsBerkshire Corporate Park4 Berkshire Blvd.Bethel Ct 06801United States',1),('00:50:7C','Videocon Ag','Videocon AgAlbert-schweitzer-str. 64D-81735 MunichGermanyGermany',1),('00:50:7D','Ifp','IfpLessingstr. 4D-78315 RadolfzellGermany',1),('00:50:7E','Newer Technology','Newer Technology4848 West Irving St.Wichita Ks 67209-2621United States',1),('00:50:7F','Draytek Corp.','Draytek Corp.26, Fushing Rd.Hsinchu Industrial ParkHsinchu Hukou 303Taiwan, Republic Of China',1),('00:50:80','Cisco Systems, Inc.','Cisco Systems, Inc.M/s Sja-2170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:50:81','Murata Machinery, Ltd.','Murata Machinery, Ltd.136, Takeda-mukaishiro-choFushimi-ku, Kyoto 612-8686Japan',1),('00:50:82','Foresson Corporation','Foresson Corporation3f, No.9 Sec.1Chang An East RoadTaipei 10404Taiwan, Republic Of China',1),('00:50:83','Gilbarco, Inc.','Gilbarco, Inc.Pob 22087Greensboro Nc 27420United States',1),('00:50:84','Atl Products','Atl Products2801 Kelvin AvenueIrvine Ca 92614-5872United States',1),('00:50:86','Telkom Sa, Ltd.','Telkom Sa, Ltd.Telkom LaboratoryP. Bag X74PretoriaSouth Africa',1),('00:50:87','Terasaki Electric Co., Ltd.','Terasaki Electric Co., Ltd.7-2-10 Hannan-cho Abeno-kuOsaka, 545-0021Japan',1),('00:50:88','Amano Corporation','Amano Corporation275, Mamedo-choKouhoku-ku, Yokohama222-8558Japan',1),('00:50:89','Safety Management Systems','Safety Management SystemsBranderijstraat 65223 As s-hertogenbosch  NetherlandsNetherlands',1),('00:50:8B','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:50:8C','Rsi Systems','Rsi Systems5555 W. 78th Street, Suite FEdina Mn 55439United States',1),('00:50:8D','Abit Computer Corporation','Abit Computer Corporation3f-7, No. 79, Sec.1Hsin Tai Wu Road, Hsi ChiTaipei HsienTaiwan, Republic Of China',1),('00:50:8E','Optimation, Inc.','Optimation, Inc.P.o. Box 14357Huntsville Al 35815United States',1),('00:50:8F','Asita Technologies Intl Ltd.','Asita Technologies Intl Ltd.Unit 2 Ballybrit Business ParkGalwayIreland',1),('00:50:90','Dctri','DctriNo.40 Xue Yuan RdHaidian District Beijing, 100083, P.r.ChinaChina',1),('00:50:91','Netaccess, Inc.','Netaccess, Inc.18 Keewaydin DriveSalem Nh 03079United States',1),('00:50:92','Rigaku Industrial Corporation','Rigaku Industrial Corporation14-8 Akaoji-choTakatsuki-shi, Osaka 569-1146Japan',1),('00:50:93','Boeing','Boeing3370 Miraloma AvenueAnaheim Ca 92803-3105United States',1),('00:50:94','Pace Micro Technology Plc','Pace Micro Technology PlcVictoria Rd, SaltaireShipley, W. Yorkshire Bradford  Bd28 3lfEnglandUnited Kingdom',1),('00:50:95','Peracom Networks','Peracom Networks13000 Weston ParkwaySuite #105Cary Nc 27513United States',1),('00:50:96','Salix Technologies, Inc.','Salix Technologies, Inc.904 Wind River Lane- Ste. #101Gaithersburg Md 20878United States',1),('00:50:97','Mmc-embedded Computertechnik Gmbh','Mmc-embedded Computertechnik GmbhUlrichsbergerstr. 17D-94469 DeggendorfGermany',1),('00:50:98','Globaloop, Ltd.','Globaloop, Ltd.12 Hasharon RoadKfar Saba 44269Israel',1),('00:50:99','3com Europe, Ltd.','3com Europe, Ltd.Boundary WayHemel HempsteadHerts. Hp2 7yuUnited Kingdom',1),('00:50:9A','Tag Electronic Systems','Tag Electronic SystemsGenesis Business ParkAlbert DriveWoking, Surrey Gu21 5rwUnited Kingdom',1),('00:50:9B','Switchcore Ab','Switchcore AbPositionen 153115 74 StockholmSwedenSweden',1),('00:50:9C','Beta Research','Beta ResearchBetastr. 185774 UnterfoehringGermany',1),('00:50:9D','The Industree B.v.','The Industree B.v.P.o. Box 4625600 Al EindhovenThe NetherlandsNetherlands',1),('00:50:9E','Les Technologies Softacoustik Inc.','Les Technologies Softacoustik Inc.',1),('00:50:9F','Horizon Computer','Horizon ComputerTrinity Bldg. 4-22-7Nishi-azabu, Minato-kuTokyo 106Japan',1),('00:50:A0','Delta Computer Systems, Inc.','Delta Computer Systems, Inc.11719 Ne 95th Street - Ste.Vancouver Wa 98682-2444United States',1),('00:50:A1','Carlo Gavazzi, Inc.','Carlo Gavazzi, Inc.222 Pennbright Dr. - Ste.#210Houston Tx 77090United States',1),('00:50:A2','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive - Sja-2San Jose Ca 95134-1706United States',1),('00:50:A3','Transmedia Communications, Inc.','Transmedia Communications, Inc.20 Great Oaks Blvd., #210San Jose Ca 95119United States',1),('00:50:A4','Io Tech, Inc.','Io Tech, Inc.25971 Cannon RoadCleveland Oh 44146United States',1),('00:50:A5','Capitol Business Systems, Ltd.','Capitol Business Systems, Ltd.43/44 RiversideSir Thomas Longley RoadRochester, Kent England Me2 4dpUnited Kingdom',1),('00:50:A6','Optronics','Optronics175 Cremona DriveGoleta Ca 93117United States',1),('00:50:A7','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s Sja-2San Jose Ca 95134-1706United States',1),('00:50:A8','Opencon Systems, Inc.','Opencon Systems, Inc.377 Hoes LanePiscataway Nj 08854United States',1),('00:50:A9','Moldat Wireless Technolgies','Moldat Wireless Technolgies3 Shimon Israeli StreetRishon Le Zion 75654IsraelIsrael',1),('00:50:AA','Konica Minolta Holdings, Inc.','Konica Minolta Holdings, Inc.1-6-1, Marunouchi,Chiyoda-kuTokyo  100-0005Japan',1),('00:50:AB','Naltec, Inc.','Naltec, Inc.1-1-15, Nakanogo, Shimizu-kuShizuoka-shi Shizuoka 424-0888Japan',1),('00:50:AC','Maple Computer Corporation','Maple Computer Corporation2f, No. 184, Sec. 2Chang-an E. Rd.TaipeiTajikistan',1),('00:50:AD','Communique Wireless Corp.','Communique Wireless Corp.1070 Marina Village ParkwaySuite #206Alameda Ca 94501United States',1),('00:50:AE','Iwaki Electronics Co., Ltd.','Iwaki Electronics Co., Ltd.1, KamanomaeJoban-kamiyunagaya-machiIwaki-city, Fukushima 972-8322 972-8322Japan',1),('00:50:AF','Intergon, Inc.','Intergon, Inc.5800 Ranchester DriveHouston Tx 77036United States',1),('00:50:B0','Technology Atlanta Corporation','Technology Atlanta Corporation500 Sugar Mill RoadSuite 202aAtlanta Ga 30350United States',1),('00:50:B1','Giddings & Lewis','Giddings & Lewis660 S. Military Rd.Fond Du Lac Wi 54935United States',1),('00:50:B2','Brodel Automation','Brodel AutomationDistelbusch 2442549 VelbertGermany',1),('00:50:B3','Voiceboard Corporation','Voiceboard Corporation3151 West Fifth StreetOxnard Ca 93030United States',1),('00:50:B4','Satchwell Control Systems, Ltd','Satchwell Control Systems, LtdP.o. Box 57,  94 Farnham RoadSlough,Berkshire Sl1 4uhUnited Kingdom',1),('00:50:B5','Fichet-bauche','Fichet-bauche15-17 Ave. Morane-saulnier78140 VelizyFranceFrance',1),('00:50:B6','Good Way Ind. Co., Ltd.','Good Way Ind. Co., Ltd.5f, No.8, Alley 6,Lane 45 Pao-hsin Rd.-hsin Tien Taipei HsTaiwan R.o.c.Taiwan, Republic Of China',1),('00:50:B7','Boser Technology Co., Ltd.','Boser Technology Co., Ltd.15f-6, 77 Hsin Tai Wu RoadSec. 1, Hsi-chiTaipei HsienTaiwan, Republic Of China',1),('00:50:B8','Inova Computers Gmbh & Co. Kg','Inova Computers Gmbh & Co. KgSudetenstrasse 587600 KaufbeurenGermany',1),('00:50:B9','Xitron Technologies, Inc.','Xitron Technologies, Inc.6295-d Ferris SquareSan Diego Ca 92121United States',1),('00:50:BA','D-link','D-link2f, No. 233l-2, Pao-chiao Rd.Hsin-tien 231TaipeiTaiwan, Republic Of China',1),('00:50:BB','Cms Technologies','Cms Technologies13955 Farmington RaodLivonia Mi 48154United States',1),('00:50:BC','Hammer Storage Solutions','Hammer Storage Solutions8450 Central AvenueNewark Ca 94560United States',1),('00:50:BD','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive - Sja-2San Jose Ca 95134-1706United States',1),('00:50:BE','Fast Multimedia Ag','Fast Multimedia AgRuedesheimerstr. 11-1380686 MunichGermany',1),('00:50:BF','Mototech Inc.','Mototech Inc.No.9, Park Avenue IiScience-base Industrial ParkHsin-chuTaiwan, Republic Of China',1),('00:50:C0','Gatan, Inc.','Gatan, Inc.5933 Coronado LanePleasanton Ca 94588United States',1),('00:50:C1','Gemflex Networks, Ltd.','Gemflex Networks, Ltd.230-6651 Fraserwood Pl.Richmond, B.c.Canada V6w 1j3Canada',1),('00:50:C2','Ieee Registration Authority','Ieee Registration Authority445 Hoes LanePiscataway Nj 08854United States',1),('00:50:C4','Imd','ImdHerbstrasse 8D-82178 PuchheimGermany',1),('00:50:C5','Ads Technologies, Inc','Ads Technologies, Inc12627 Hiddencreek WayCerritos Ca 90703United States',1),('00:50:C6','Loop Telecommunication International, Inc.','Loop Telecommunication International, Inc.2f, No. 22, Prosperity Rd. 2Science-based Industrial ParkHsinchuTaiwan, Republic Of China',1),('00:50:C8','Addonics Communications, Inc.','Addonics Communications, Inc.48434 Milmont DriveFremont Ca 94538United States',1),('00:50:C9','Maspro Denkoh Corp.','Maspro Denkoh Corp.Asada Nisshin Aichi470-0194Japan',1),('00:50:CA','Net To Net Technologies','Net To Net Technologies680 Central Avenue - Ste. #301Dover Nh 03820United States',1),('00:50:CB','Jetter','JetterGraeterstrasse 2D71642  LudwigsburgGermany',1),('00:50:CC','Xyratex','XyratexMail Point: 26/13; Dept:  Storage SystemLangstone RoadHavant Po9 1saUnited Kingdom',1),('00:50:CD','Digianswer A/s','Digianswer A/sSkalhuse 59240 NibeDenmark',1),('00:50:CE','Lg International Corp.','Lg International Corp.Lg Twin Towers20 Yoido-dong, Youngdungpo-guSeoul,  150-606Korea, Republic Of',1),('00:50:CF','Vanlink Communication Technology Research Institute','Vanlink Communication Technology Research Institute210 Yadi Office BuildingNo. 48 Bei San Huan Zhong LuBeijing 100088China',1),('00:50:D0','Minerva Systems','Minerva Systems1585 Charleston RoadMountain View Ca 84943United States',1),('00:50:D1','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s Sja-2San Jose Ca 95134-1706United States',1),('00:50:D2','Cmc Electronics Inc','Cmc Electronics Inc600 Dr.frederik-philips BlvdMontreal  Qc H4m 2s9Canada',1),('00:50:D3','Digital Audio Processing Pty. Ltd.','Digital Audio Processing Pty. Ltd.Po Box 40Concord WestNsw 2138Australia',1),('00:50:D4','Joohong Information &','Joohong Information &Communications, Ltd.Jungnam B/d, 721-39 Yeoksam-dong, KangnaSeoul Seoul KoreaKorea, Republic Of',1),('00:50:D5','Ad Systems Corp.','Ad Systems Corp.1-4-1, Nakacho, Musashino CityTokyo 180-0006Japan',1),('00:50:D6','Atlas Copco Tools Ab','Atlas Copco Tools Ab',1),('00:50:D7','Telstrat','Telstrat3600 AvenuePlano Tx 75074United States',1),('00:50:D8','Unicorn Computer Corp.','Unicorn Computer Corp.7 Fl.,  No. 96 Kwang Fu North RoadTaipeiTaiwan, Republic Of China',1),('00:50:D9','Engetron-engenharia Eletronica Ind. E Com. Ltda','Engetron-engenharia Eletronica Ind. E Com. LtdaVia Socrates M. Bittencourt, 109932010-010 Contagem MgBrazil',1),('00:50:DA','3com Corporation','3com Corporation5400 Bayfront PlazaMs: 4220Santa Clara Ca 95052United States',1),('00:50:DB','Contemporary Control','Contemporary ControlSystems, Inc.2431 Curtiss StreetDowners Grove Il 60515United States',1),('00:50:DC','Tas Telefonbau A. Schwabe Gmbh & Co. Kg','Tas Telefonbau A. Schwabe Gmbh & Co. Kg',1),('00:50:DD','Serra Soldadura, S.a.','Serra Soldadura, S.a.Pol. Ind. Zona Franca,Sector C, Calle D, N. 29 08040 BarcelonaSpainSpain',1),('00:50:DE','Signum Systems Corp.','Signum Systems Corp.1211 Flynn Rd,#104Camarillo Ca 93021United States',1),('00:50:DF','Airfiber, Inc.','Airfiber, Inc.P.o. Box 502148San Diego Ca 92150-2148United States',1),('00:50:E1','Ns Tech Electronics Sdn Bhd','Ns Tech Electronics Sdn BhdNo. 21 & 23 Jalan Canggih 10Taman Perindustrian Cemerlang81800 Ulu Tiram-johor BahruMalaysia',1),('00:50:E2','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive - Sja-2San Jose Ca 95134-1706United States',1),('00:50:E3','Motorola, Inc.','Motorola, Inc.2450 Walsh AveSanta Clara Ca 95051United States',1),('00:50:E4','Apple Computer, Inc.','Apple Computer, Inc.20650 Valley Green Dr.Cupertino Ca 95014United States',1),('00:50:E6','Hakusan Corporation','Hakusan CorporationJ Tower, 1-1, Nikkou-choFuchu-shi Tokyo 183-0044JapanJapan',1),('00:50:E7','Paradise Innovations (asia)','Paradise Innovations (asia)Pte. Ltd.25 Serangoon North Ave. 5 6th Floor UracSingapore 554914Singapore',1),('00:50:E8','Nomadix Inc.','Nomadix Inc.2701 Ocean Park Blvd.-ste.#231Santa Monica Ca 90405United States',1),('00:50:EA','Xel Communications, Inc.','Xel Communications, Inc.17101 E. Ohio DriveAurora Co 80017United States',1),('00:50:EB','Alpha-top Corporation','Alpha-top Corporation19f., No. 2, Lane 150Sec. 5, Hsin-yi RoadTaipeiTaiwan, Republic Of China',1),('00:50:EC','Olicom A/s','Olicom A/sNybrovej 114Dk-2800 LyngbyDenmark',1),('00:50:ED','Anda Networks','Anda Networks2921 Copper RoadSanta Clara Ca 95051United States',1),('00:50:EE','Tek Digitel Corporation','Tek Digitel Corporation20010 Century Blvd. #300Germantown Md 20874United States',1),('00:50:EF','Spe Systemhaus Gmbh','Spe Systemhaus GmbhWaldstrasse 763150 HeusenstammGermany',1),('00:50:F0','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s Sja-2San Jose Ca 95134-1706United States',1),('00:50:F1','Libit Signal Processing, Ltd.','Libit Signal Processing, Ltd.P.o. Box 126702 Shanker StreetHerzliya  46766Israel',1),('00:50:F2','Microsoft Corp.','Microsoft Corp.One Microsoft WayRedmond Wa 98052-6399United States',1),('00:50:F3','Global Net Information Co., Ltd.','Global Net Information Co., Ltd.North Tower- Rm 1305World Trade Centre Complex No.371-375, HGuang Zhou 510095China',1),('00:50:F4','Sigmatek Gmbh & Co. Kg','Sigmatek Gmbh & Co. KgA-5112 Lamprechtshausen,Burmooser Strasse 10AustriaAustria',1),('00:50:F6','Pan-international Industrial Corp.','Pan-international Industrial Corp.Gf, No. 176, Chang Chun Rd.TaipeiTaiwan, Republic Of China',1),('00:50:F7','Venture Manufacturing (singapore) Ltd.','Venture Manufacturing (singapore) Ltd.',1),('00:50:F8','Entrega Technologies, Inc.','Entrega Technologies, Inc.25691 Atlantic Ocean DriveSuite #18Lake Forest Ca 92630United States',1),('00:50:F9','Sensormatic Acd','Sensormatic Acd70 Westview StreetLexington Ma 02173United States',1),('00:50:FA','Oxtel, Ltd.','Oxtel, Ltd.The Market PlaceDidcot0x11 7le EnglandUnited Kingdom',1),('00:50:FB','Vsk Electronics','Vsk ElectronicsVenetielaan 398530 HarelbekeBelgiumBelgium',1),('00:50:FC','Edimax Technology Co., Ltd.','Edimax Technology Co., Ltd.3 Wu-chun 3rd RoadWu-ku Industrial ParkTaipei Hsien  248Taiwan, Republic Of China',1),('00:50:FD','Visioncomm Co., Ltd.','Visioncomm Co., Ltd.4, 5f, Daewon B/d198-8, Seobinggo-dongYongsan-gu, SeoulKorea, Republic Of',1),('00:50:FE','Pctvnet Asa','Pctvnet AsaStrandveilen 50N-1324 LysakerNorway',1),('00:50:FF','Hakko Electronics Co., Ltd.','Hakko Electronics Co., Ltd.238, Kamikashiwano-machiMatto-shi, Ishikawa 924-0035Japan',1),('00:60:00','Xycom Inc.','Xycom Inc.750 N. MapleSaline Mi 48176United States',1),('00:60:01','Innosys, Inc.','Innosys, Inc.3095 Richmond Pkwy #207Richmond Ca 94806United States',1),('00:60:02','Screen Subtitling Systems, Ltd','Screen Subtitling Systems, LtdThe Old RectoryChurch LaneClaydon Ipswich  Ip6 OeqUnited Kingdom',1),('00:60:03','Teraoka Weigh System Pte, Ltd.','Teraoka Weigh System Pte, Ltd.3a Tuas Avenue 8Singapore 639128Singapore',1),('00:60:04','Computadores Modulares Sa','Computadores Modulares SaAvda Montesierra S/nEdificio Congresos 31441020-sevillaSpain',1),('00:60:05','Feedback Data Ltd.','Feedback Data Ltd.Park RoadCrowboroughEast Sussex, Tn6 2qrUnited Kingdom',1),('00:60:06','Sotec Co., Ltd','Sotec Co., LtdYokohama Bashamichi Bldg.,4-55 Ohta-cho Naka-kuYokohama  231Japan',1),('00:60:07','Acres Gaming, Inc.','Acres Gaming, Inc.815 Nw 9th StreetCorvallis Or 97330United States',1),('00:60:08','3com Corporation','3com Corporation5400 Bayfront PlazaSanta Clara Ca 95052United States',1),('00:60:09','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:0A','Sord Computer Corporation','Sord Computer Corporation20-7, Masago 5-chomeMihama-ku, Chiba-shiChiba 261Japan',1),('00:60:0B','Logware Gmbh','Logware GmbhSchwedenstr. 9D-13359 BerlinGermany',1),('00:60:0C','Applied Data Systems, Inc.','Applied Data Systems, Inc.9140-a Guilford RoadColumbia Md 21046United States',1),('00:60:0D','Digital Logic Gmbh','Digital Logic GmbhStahlwerkstr. 25Mudersbach  57555Germany',1),('00:60:0E','Wavenet International, Inc.','Wavenet International, Inc.5825 Kennedy RoadMississauga, Ontario L4z 2g3Canada',1),('00:60:0F','Westell, Inc.','Westell, Inc.75 Executive DriveAurora Il 60504-4101United States',1),('00:60:10','Network Machines, Inc.','Network Machines, Inc.255 Old New Brunswick Rd., # N320Piscataway Nj 08854United States',1),('00:60:11','Crystal Semiconductor Corp.','Crystal Semiconductor Corp.P.o. Box 17847Austin Tx 78760United States',1),('00:60:12','Power Computing Corporation','Power Computing Corporation10261 Bubb RoadCupertino Ca 95014United States',1),('00:60:13','Netstal Maschinen Ag','Netstal Maschinen AgIndustriestrasseCh-8752 NaefelsSwitzerland',1),('00:60:14','Edec Co., Ltd.','Edec Co., Ltd.9f Of T.o.c. Building7-22-17 NishigotandaShinagawaku,  TokyoJapan',1),('00:60:15','Net2net Corporation','Net2net Corporation131 Coolidge StreetHudson Ma 01749United States',1),('00:60:16','Clariion','ClariionCoslin DriveMail Stop C25Southboro Ma 01772United States',1),('00:60:17','Tokimec Inc.','Tokimec Inc.2-16, Minami-kamata, Ohta-kuTokyo 144Japan',1),('00:60:18','Stellar One Corporation','Stellar One Corporation500 108th Ave. Ne--ste. #2200Bellevue Wa 98004United States',1),('00:60:19','Roche Diagnostics','Roche Diagnostics9115 Hague RoadIndianapolis In 46250-0457United States',1),('00:60:1A','Keithley Instruments','Keithley Instruments30500 Bainbridge Rd.Solon Oh 44139United States',1),('00:60:1B','Mesa Electronics','Mesa Electronics1323 61st StreetEmeryville Ca 94608-2117United States',1),('00:60:1C','Telxon Corporation','Telxon Corporation3330 W. Market StreetPo Box 5582Akron Oh 44334-0582United States',1),('00:60:1D','Lucent Technologies','Lucent Technologies101 Crawfords Corner Rd.Room  4k-321Holmdel Nj 07733United States',1),('00:60:1E','Softlab, Inc.','Softlab, Inc.P.o. Box 8Chimney Rock Co 81127United States',1),('00:60:1F','Stallion Technologies','Stallion Technologies33 Woodstock RoadToowong Q-l-d- 4066Australia',1),('00:60:20','Pivotal Networking, Inc.','Pivotal Networking, Inc.7246 Sharon Dr., SteSan Jose Ca 95129United States',1),('00:60:21','Dsc Corporation','Dsc CorporationRecruit-shinohtsuka Bldg.,2-25-15 Minamiohtsuka, Toshima-ku,Tokyo 170Japan',1),('00:60:22','Vicom Systems, Inc.','Vicom Systems, Inc.1961 Landings DriveMountain View Ca 94043United States',1),('00:60:23','Pericom Semiconductor Corp.','Pericom Semiconductor Corp.2380 Bering DriveSan Jose Ca 95131United States',1),('00:60:24','Gradient Technologies, Inc.','Gradient Technologies, Inc.2 Mount Royal AvenueMarlboro Ma 01752United States',1),('00:60:25','Active Imaging Plc','Active Imaging PlcHattori HouseVanwall Business ParkMaidenhead Berkshire Sl6 4ubUnited Kingdom',1),('00:60:26','Viking Components, Inc.','Viking Components, Inc.11 ColumbiaLaguna Hills Ca 92656United States',1),('00:60:27','Superior Modular Products','Superior Modular ProductsGeneral Technology Division415 Pineda CourtMelbourne Fl 32940United States',1),('00:60:28','Macrovision Corporation','Macrovision Corporation2830 De La Cruz BoulevardSanta Clara Ca 95050United States',1),('00:60:29','Cary Peripherals Inc.','Cary Peripherals Inc.190 Colonnade Road S, Unit 9Nepean, Ontario K2e 7j5Canada',1),('00:60:2A','Symicron Computer Communications, Ltd.','Symicron Computer Communications, Ltd.Unit 4 Green Lane Business Park238 Green LaneLondon Se9 3tlUnited States',1),('00:60:2B','Peak Audio','Peak Audio1790 30th Street Ste #414Boulder Co 80301United States',1),('00:60:2C','Linx Data Terminals, Inc.','Linx Data Terminals, Inc.625 Digital Drive-ste #100Plano Tx 75075United States',1),('00:60:2D','Alerton Technologies, Inc.','Alerton Technologies, Inc.6670 185th Ave. N.e.Redmond Wa 98052United States',1),('00:60:2E','Cyclades Corporation','Cyclades Corporation41934 Christy StreetFremont Ca 94538United States',1),('00:60:2F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:30','Village Tronic Entwicklung','Village Tronic EntwicklungWellweg 9531157 SarstedtGermany',1),('00:60:31','Hrk Systems','Hrk SystemsP.o. Box 514Westville 3630South Africa',1),('00:60:32','I-cube, Inc.','I-cube, Inc.2328-c Walsh AvenueSanta Clara Ca 95014United States',1),('00:60:33','Acuity Imaging, Inc.','Acuity Imaging, Inc.9 Townsend WestNashua Nh 03063United States',1),('00:60:34','Robert Bosch Gmbh','Robert Bosch GmbhPostbox 11 62D-64701 ErbachGermany',1),('00:60:35','Dallas Semiconductor, Inc.','Dallas Semiconductor, Inc.4401 South Beltwood ParkwayDallas Tx 75244-3292United States',1),('00:60:36','Austrian Research Center Seibersdorf','Austrian Research Center Seibersdorf',1),('00:60:37','Nxp Semiconductors','Nxp SemiconductorsMillbrook Technology CampusMillbrook Southampton So15 0djUnited Kingdom',1),('00:60:38','Nortel Networks','Nortel NetworksGlobal Operations EngineeringDep 6800 Program Manager 8200 Dixie RoadBrampton Ontario 16t 5p6Canada',1),('00:60:39','Sancom Technology, Inc.','Sancom Technology, Inc.7719 Wood Hollow DriveSuite #156Austin Tx 78731United States',1),('00:60:3A','Quick Controls Ltd.','Quick Controls Ltd.Durham House, Warwick CourtPark Road, MiddletonManchester  M24 1aeUnited Kingdom',1),('00:60:3B','Amtec Spa','Amtec SpaLoc. S. Martino53025 Piancastagnaio (siena)Italy',1),('00:60:3C','Hagiwara Sys-com Co., Ltd.','Hagiwara Sys-com Co., Ltd.2-4-3 Nishiki Naka-kuNagoyaAichi 460Japan',1),('00:60:3D','3cx','3cx2085 Hamilton Ave., -ste.#220San Jose Ca 95125United States',1),('00:60:3E','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:3F','Patapsco Designs','Patapsco Designs5350 Partners CourtFrederick Md 21703United States',1),('00:60:40','Netro Corp.','Netro Corp.3120 Scott Blvd.Santa Clara Ca 95054United States',1),('00:60:41','Yokogawa Electric Corporation','Yokogawa Electric Corporation2-9-31 Nakacho, Musashino-shiTokyo 180-8750Japan',1),('00:60:42','Tks (usa), Inc.','Tks (usa), Inc.1201 CommerceRichardson Tx 75081United States',1),('00:60:43','Idirect, Inc.','Idirect, Inc.13865 Sunrise Vally DriveSuite 100Herndon Va 20171United States',1),('00:60:44','Litton/poly-scientific','Litton/poly-scientific2200 South Main StreetBlacksburg Va 24060United States',1),('00:60:45','Pathlight Technologies','Pathlight Technologies767 Warren RoadIthaca Ny 14850United States',1),('00:60:46','Vmetro, Inc.','Vmetro, Inc.1880 Dairy Ashford- Ste #535Houston Tx 77077United States',1),('00:60:47','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:48','Emc Corporation','Emc Corporation171 South St.,Hopkinton Ma 01748United States',1),('00:60:49','Vina Technologies','Vina Technologies6 Union Square - Ste FUnion City Ca 94587United States',1),('00:60:4A','Saic Ideas Group','Saic Ideas Group7120 Columbia Gateway DriveColumbia Md 21046United States',1),('00:60:4B','Safe-com Gmbh & Co. Kg','Safe-com Gmbh & Co. KgBurg Lichtenfels35104 LichtenfelsGermany',1),('00:60:4C','Sagem Communication','Sagem Communication27 Rue LeblancCedex 15 Paris 75512France',1),('00:60:4D','Mmc Networks, Inc.','Mmc Networks, Inc.1134 East Arques AvenueSunnyvale Ca 94086-4602United States',1),('00:60:4E','Cycle Computer Corporation, Inc.','Cycle Computer Corporation, Inc.20245 Stevens Creek Blvd.Cupertino Ca 95014United States',1),('00:60:4F','Suzuki Mfg. Co., Ltd.','Suzuki Mfg. Co., Ltd.552-51 AjigauraHitachinakaIbaraki, 311-12Japan',1),('00:60:50','Internix Inc.','Internix Inc.59-10 Takakura-choHachiojiTokyo 192Japan',1),('00:60:51','Quality Semiconductor','Quality Semiconductor851 Martin AvenueSanta Clara Ca 95050United States',1),('00:60:52','Peripherals Enterprise Co., Ltd.','Peripherals Enterprise Co., Ltd.3f, No.10, Alley 6, Lane 45Pao Shin Road, Hsin Tien CityTaipeiTaiwan, Republic Of China',1),('00:60:53','Toyoda Machine Works, Ltd.','Toyoda Machine Works, Ltd.1-7 Kitajizoyama NodachouKariya City, AichiJapan',1),('00:60:54','Controlware Gmbh','Controlware GmbhWaldstrasse 9263128 DietzenbachGermany',1),('00:60:55','Cornell University','Cornell University110 Maple AvenueIthaca Ny 14850-4902United States',1),('00:60:56','Network Tools, Inc.','Network Tools, Inc.2975 Bowers Avenue, #202Santa Clara Ca 95051-0955United States',1),('00:60:57','Murata Manufacturing Co., Ltd.','Murata Manufacturing Co., Ltd.1-18-1 Hakusan Midori-kuYokohama  226Japan',1),('00:60:58','Copper Mountain Communications, Inc.','Copper Mountain Communications, Inc.6650 Lusk Blvd.-ste #b103San Diego Ca 92121United States',1),('00:60:59','Technical Communications Corp.','Technical Communications Corp.100 Domino DriveConcord Ma 01742United States',1),('00:60:5A','Celcore, Inc.','Celcore, Inc.8001 Centerview ParkwaySuite #201Memphis Tn 38018United States',1),('00:60:5B','Intraserver Technology, Inc.','Intraserver Technology, Inc.125 Hopping Brook ParkHolliston Ma 01746United States',1),('00:60:5C','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:5D','Scanivalve Corp.','Scanivalve Corp.1722 N. Madson StreetLiberty Lake Wa 99019United States',1),('00:60:5E','Liberty Technology Networking','Liberty Technology NetworkingP.o. Box 11566Hatfield, Pretoria 0028South Africa',1),('00:60:5F','Nippon Unisoft Corporation','Nippon Unisoft CorporationBr Ningyocho 1,2-13-9Nihonbashi-ningyocho, Chuo-kuTokyo 103Japan',1),('00:60:60','Dawning Technologies, Inc.','Dawning Technologies, Inc.409 Mason RoadFairport Ny 14450United States',1),('00:60:61','Whistle Communications Corp.','Whistle Communications Corp.110 Marsh Drive-ste #100Foster City Ca 94404United States',1),('00:60:62','Telesync, Inc.','Telesync, Inc.5555 Oakbrook Pkwy-ste #110Norcross Ga 30093United States',1),('00:60:63','Psion Dacom Plc.','Psion Dacom Plc.Psion Dacom HousePresley Way,Crownhill Milton Keynes  Mk8 0efUnited Kingdom',1),('00:60:64','Netcomm Limited','Netcomm LimitedPo Box 379North Ryde, Nsw, 2113Australia',1),('00:60:65','Bernecker & Rainer Industrie-elektronic Gmbh','Bernecker & Rainer Industrie-elektronic GmbhEggelsberg 1205142 EggelsbergAustria',1),('00:60:66','Lacroix Technolgie','Lacroix Technolgie1 Ere Avenue, 11 Eme Rue06516 CarrosFrance',1),('00:60:67','Acer Netxus Inc.','Acer Netxus Inc.5f-3, 5 Hsin Ann Road  SbipHsinchu 300Taiwan, Republic Of China',1),('00:60:68','Dialogic Corporation','Dialogic Corporation9800 Cavendish Blvd, 5th FloorMontreal Quebec H4m 2v9Canada',1),('00:60:69','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology DriveSan Jose Ca 95110United States',1),('00:60:6A','Mitsubishi Wireless Communications. Inc.','Mitsubishi Wireless Communications. Inc.2001 Cherry DriveBraselton Ga 30517United States',1),('00:60:6B','Synclayer Inc.','Synclayer Inc.1-20 HimegaokaKani-cityGifu 509-0249Japan',1),('00:60:6C','Arescom','Arescom2833 Junction Ave. - Ste #206San Jose Ca 95134United States',1),('00:60:6D','Digital Equipment Corp.','Digital Equipment Corp.550 King StreetM/s Lkg1-3/a10Littleton Ma 01460United States',1),('00:60:6E','Davicom Semiconductor, Inc.','Davicom Semiconductor, Inc.2457 Augustine DriveSanta Clara Ca 95054United States',1),('00:60:6F','Clarion Corporation Of America','Clarion Corporation Of America17 Lakeside Office Park607 North AvenueWakefield Ma 01880United States',1),('00:60:70','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:71','Midas Lab, Inc.','Midas Lab, Inc.4 Katamachi,Shinjuku-kuTokyo 160Japan',1),('00:60:72','Vxl Instruments, Limited','Vxl Instruments, LimitedPlot No. 17, Konappana AgraharaElectronic CityBangalore -  561 229India',1),('00:60:73','Redcreek Communications, Inc.','Redcreek Communications, Inc.3900 Newpark Mall RoadNewark Ca 94560United States',1),('00:60:74','Qsc Audio Products','Qsc Audio Products1675 Macarthur Blvd.Costa Mesa Ca 92626United States',1),('00:60:75','Pentek, Inc.','Pentek, Inc.1 Park WayUpper Saddle River Nj 07458United States',1),('00:60:76','Schlumberger Technologies Retail Petroleum Systems','Schlumberger Technologies Retail Petroleum Systems825-m Greenbrier CircleChesapeake Va 23320United States',1),('00:60:77','Prisa Networks','Prisa Networks6620 Mesa Ridge Road,Suite 200San Diego Ca 92121United States',1),('00:60:78','Power Measurement Ltd.','Power Measurement Ltd.2195 Keating Cross RoadSaanichton, B.c. V8m 2a5Canada',1),('00:60:79','Mainstream Data, Inc.','Mainstream Data, Inc.375 Chipeta Way, Suite BSalt Lake City Ut 84108United States',1),('00:60:7A','Dvs Gmbh','Dvs GmbhKrepenstrasse 8D-30165 HannoverGermany',1),('00:60:7B','Fore Systems, Inc.','Fore Systems, Inc.1000 Fore DriveWarrendale Pa 15086United States',1),('00:60:7C','Waveaccess, Ltd.','Waveaccess, Ltd.P.o. Box 247310 Hayezira StreetRaanana 43663Israel',1),('00:60:7D','Sentient Networks Inc.','Sentient Networks Inc.2201 Cantu Court-ste #205Sarasota Fl 34232United States',1),('00:60:7E','Gigalabs, Inc.','Gigalabs, Inc.290 Santa Ana CourtSunnyvale Ca 94086United States',1),('00:60:7F','Aurora Technologies, Inc.','Aurora Technologies, Inc.176 Second AvenueWaltham Ma 02154United States',1),('00:60:80','Microtronix Datacom Ltd.','Microtronix Datacom Ltd.200 Aberdeen DriveLondon, Ontario N5v 4n2Canada',1),('00:60:81','Tv/com International','Tv/com International16516 Via EsprilloSan Diego Ca 92127United States',1),('00:60:82','Novalink Technologies, Inc.','Novalink Technologies, Inc.48511 Warm Springs Blvd. #208Fremont Ca 94539United States',1),('00:60:83','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:60:84','Digital Video','Digital Video4920 Avalon Ridge PkwySuite #600Norcross Ga 30092United States',1),('00:60:85','Storage Concepts','Storage Concepts14352 Chamber RoadTustin Ca 92780United States',1),('00:60:86','Logic Replacement Tech. Ltd.','Logic Replacement Tech. Ltd.14 Arkwright RoadReading Berks Rg20lsUnited KingdomUnited Kingdom',1),('00:60:87','Kansai Electric Co., Ltd.','Kansai Electric Co., Ltd.6-14-9 Midorii, Asaminami-kuHiroshima 731-01Japan',1),('00:60:88','White Mountain Dsp, Inc.','White Mountain Dsp, Inc.410 Amherst Street-ste #325Nashua Nh 03063United States',1),('00:60:89','Xata','Xata151 East Cliff Road-ste.#10Burnsville Mn 55337United States',1),('00:60:8A','Citadel Computer','Citadel Computer29 Armory RdMilford Ma 03055United States',1),('00:60:8B','Confertech International','Confertech International12110 N. Pecos StreetWestminster Co 80234-2074United States',1),('00:60:8C','3com Corporation','3com Corporation5400 Bayfront PlazaSanta Clara Ca 95052-8145United States',1),('00:60:8D','Unipulse Corp.','Unipulse Corp.2-7, Sengendai-nishiKoshigaya-citySaitama 343Jordan',1),('00:60:8E','He Electronics, Technologie & Systemtechnik Gmbh','He Electronics, Technologie & Systemtechnik GmbhAm Gneisenauflot 8D-66538 NeunhirchenGermany',1),('00:60:8F','Tekram Technology Co., Ltd.','Tekram Technology Co., Ltd.B1, No. 17, Lane 159, Sec. 6Roosevelt Rd,TaipeiTaiwan, Republic Of China',1),('00:60:90','Able Communications, Inc.','Able Communications, Inc.Nakamura Lk Bldg.3-6-6, Nishiki-cho Tachikawa-shi,  TokyoJapanJapan',1),('00:60:91','First Pacific Networks, Inc.','First Pacific Networks, Inc.871 Fox LaneSan Jose Ca 95131United States',1),('00:60:92','Micro/sys, Inc.','Micro/sys, Inc.3447 Ocean View Blvd.Glendale Ca 91208United States',1),('00:60:93','Varian','Varian2700 Mitchell Dr.Walnut Greek Ca 94598United States',1),('00:60:94','Ibm Corp.','Ibm Corp.Po Box 12195Ce6a/664 3039 CornwallisRtp Nc 27709-2195United States',1),('00:60:95','Accu-time Systems, Inc.','Accu-time Systems, Inc.420 Somers RoadEllington Ct 06029United States',1),('00:60:96','T.s. Microtech Inc.','T.s. Microtech Inc.20818 Higgins CourtTorrance Ca 90501United States',1),('00:60:97','3com Corporation','3com Corporation5400 Bayfront PlazaSanta Clara Ca 95052United States',1),('00:60:98','Ht Communications','Ht Communications4480 Shopping LaneSimi Valley Ca 93063United States',1),('00:60:99','Sbe, Inc.','Sbe, Inc.2305 Camino RamonSuite 200San Ramon Ca 94583United States',1),('00:60:9A','Njk Techno Co.','Njk Techno Co.N1-25 KamiyasatoKomatsu  #923Japan',1),('00:60:9B','Astro-med, Inc.','Astro-med, Inc.600 East Greenwich Ave.West Warwick Ri 02893United States',1),('00:60:9C','Perkin-elmer Incorporated','Perkin-elmer Incorporated710 Bridgeport Ave.Shelton Ct 06484United States',1),('00:60:9D','Pmi Food Equipment Group','Pmi Food Equipment Group701 Ridge AvenueTroy Oh 45374United States',1),('00:60:9E','Asc X3 - Information Technology Standards Secretariats','Asc X3 - Information Technology Standards Secretariats1250 Eye Street Nw - Ste #200Washington Dc 20005United States',1),('00:60:9F','Phast Corporation','Phast Corporation79 West 4500 South - Bldg.#14Salt Lake City Ut 84107United States',1),('00:60:A0','Switched Network Technologies, Inc.','Switched Network Technologies, Inc.13805 1st Avenue NorthPlymouth Mn 55441-5455United States',1),('00:60:A1','Vpnet, Inc.','Vpnet, Inc.555 N. Mathilda Ave.,-ste #110Sunnyvale Ca 94086United States',1),('00:60:A2','Nihon Unisys Limited Co.','Nihon Unisys Limited Co.P.o. Box 135Tokyo-to,  Koutou-kuShinonome 1-10-9Japan',1),('00:60:A3','Continuum Technology Corp.','Continuum Technology Corp.220 Continuum DriveFletcher Nc 28732United States',1),('00:60:A4','Grinaker System Technologies','Grinaker System TechnologiesBox 912-561Silverton  0127South Africa',1),('00:60:A5','Performance Telecom Corp.','Performance Telecom Corp.10 Carlson RoadRochester Ny 14610-1021United States',1),('00:60:A6','Particle Measuring Systems','Particle Measuring Systems5475 Airport Blvd.Boulder Co 80301United States',1),('00:60:A7','Microsens Gmbh & Co. Kg','Microsens Gmbh & Co. KgKueferstrasse 16D-59067 HammGermany',1),('00:60:A8','Tidomat Ab','Tidomat Ab',1),('00:60:A9','Gesytec Mbh','Gesytec MbhPascalstrasse 6D 52076 AachenGermany',1),('00:60:AA','Intelligent Devices Inc. (idi)','Intelligent Devices Inc. (idi)1718-l Belmont AvenueBaltimore Md 21244United States',1),('00:60:AB','Larscom Incorporated','Larscom Incorporated1845 Mccandless DriveMilpitas Ca 95035United States',1),('00:60:AC','Resilience Corporation','Resilience Corporation1755 Embarcadero Road-ste #120Palo Alto Ca 94303United States',1),('00:60:AD','Megachips Corporation','Megachips Corporation4-1-6,miyaharaYodogawa-kuOsaka 532-0003Japan',1),('00:60:AE','Trio Information Systems Ab','Trio Information Systems AbFogdevagen 4bS-183 64 TabySweden',1),('00:60:AF','Pacific Micro Data, Inc.','Pacific Micro Data, Inc.16751 Millikan AvenueIrvine Ca 92714United States',1),('00:60:B0','Hewlett-packard Co.','Hewlett-packard Co.Ms 42le10000 Wolfe RoadCupertino Ca 95014United States',1),('00:60:B1','Input/output, Inc.','Input/output, Inc.12300 Parc Crest DriveStafford Tx 77477-2416United States',1),('00:60:B2','Process Control Corp.','Process Control Corp.6875 Mimms DriveAtlanta Ga 30340United States',1),('00:60:B3','Z-com, Inc.','Z-com, Inc.7f-2, No.9, Prosperity 1st Rd.Science-based Industrial ParkHsinchuTaiwan, Republic Of China',1),('00:60:B4','Glenayre R&d Inc.','Glenayre R&d Inc.1570 Kootenay StreetVancouver, Bc V5k 5b8Canada',1),('00:60:B5','Keba Gmbh','Keba GmbhGewerbepark UrfahrA-4041 LinzAustria',1),('00:60:B6','Land Computer Co., Ltd.','Land Computer Co., Ltd.7-4-17 NishinakajimaYodogawaku 532Japan',1),('00:60:B7','Channelmatic, Inc.','Channelmatic, Inc.1700 Gillespie WayEl Cajon Ca 92020-0901United States',1),('00:60:B8','Corelis Inc.','Corelis Inc.12607 Hiddencreek WayCerritos Ca 90703United States',1),('00:60:B9','Nec Infrontia Corporation','Nec Infrontia Corporation2-6-1,kitamikata,takatsu-kuKawasaki  213-8511Japan',1),('00:60:BA','Sahara Networks, Inc.','Sahara Networks, Inc.335 Highland Ave.Cheshire Ct 06410United States',1),('00:60:BB','Cabletron - Netlink, Inc.','Cabletron - Netlink, Inc.35 Industrial WayP.o. Box 5005Rochester Nh 03866-5005United States',1),('00:60:BC','Keunyoung Electronics & Communication Co., Ltd.','Keunyoung Electronics & Communication Co., Ltd.325-76, Daeheung-dong, Mapo-gu,SeoulKorea, Republic Of',1),('00:60:BD','Hubbell-pulsecom','Hubbell-pulsecom2900 Towerview RoadHerndon Va 21071United States',1),('00:60:BE','Webtronics','Webtronics3b-1  8-2-12Nishi-gotandaShinagawa-ku Tokyo 141Japan',1),('00:60:BF','Macraigor Systems, Inc.','Macraigor Systems, Inc.Po Box 1008Brookline Village Ma 02147United States',1),('00:60:C0','Nera Networks As','Nera Networks AsKokstadveien 23Bergen  5020Norway',1),('00:60:C1','Wavespan Corporation','Wavespan Corporation500 N. Bernardo Ave.Mountain View Ca 94043United States',1),('00:60:C2','Mpl Ag','Mpl AgTaefernstrasse 20Ch-5405 DaettwilSwitzerland',1),('00:60:C3','Netvision Corporation','Netvision CorporationMs# 1aOne Comac LoopRonkonkoma Ny 11779United States',1),('00:60:C4','Soliton Systems K.k.','Soliton Systems K.k.2-4-3 Shinjuku, Shinjuku-kuTokyo 160Japan',1),('00:60:C5','Ancot Corp.','Ancot Corp.115 Constitution Dr.Menlo Park Ca 94025United States',1),('00:60:C6','Dcs Ag','Dcs AgSalzachstrass 31D-14129  BerlinGermany',1),('00:60:C7','Amati Communications Corp.','Amati Communications Corp.2043 Samaritan DriveSan Jose Ca 95124United States',1),('00:60:C8','Kuka Welding Systems & Robots','Kuka Welding Systems & RobotsBluecherstrasse 144Dept. Re-shD-86165 AugsburgGermany',1),('00:60:C9','Controlnet, Inc.','Controlnet, Inc.747 Camden, Ste. ACampbell Ca 95008United States',1),('00:60:CA','Harmonic Systems Incorporated','Harmonic Systems Incorporated199 1st Street - Ste #302Los Altos Ca 94022United States',1),('00:60:CB','Hitachi Zosen Corporation','Hitachi Zosen Corporation3-4, Sakurajima 1-chomeKonohana-ku, Osaka 554Japan',1),('00:60:CC','Emtrak, Incorporated','Emtrak, Incorporated7150 Campus Drive, Ste #180Colorado Springs Co 80920United States',1),('00:60:CD','Videoserver, Inc.','Videoserver, Inc.5 Forbes RoadLexington Ma 02173United States',1),('00:60:CE','Acclaim Communications','Acclaim Communications5000 Old Ironsides DriveSanta Clara Ca 95054United States',1),('00:60:CF','Alteon Networks, Inc.','Alteon Networks, Inc.50 Great Oaks Blvd.San Jose Ca 95119United States',1),('00:60:D0','Snmp Research Incorporated','Snmp Research Incorporated3001 Kimberlin Heights RoadKnoxville Tn 37920-9716United States',1),('00:60:D1','Cascade Communications','Cascade Communications6 Technology Park DriveWestford Ma 01886United States',1),('00:60:D2','Lucent Technologies Taiwan Telecommunications Co., Ltd.','Lucent Technologies Taiwan Telecommunications Co., Ltd.#2, Innovation Road IiScience-based Industrial ParkHsin ChuTaiwan, Republic Of China',1),('00:60:D3','At&t','At&t101 Crawfords Corner Road, Rd. 1j321P.o. Box 3030Holmdel Nj 07733-3030United States',1),('00:60:D4','Eldat Communication Ltd.','Eldat Communication Ltd.10 Hakishon StreetBnei-brak  51203Israel',1),('00:60:D5','Miyachi Technos Corp.','Miyachi Technos Corp.95-3, FutasuzukaNoda City, Chiba, 278Japan',1),('00:60:D6','Novatel Wireless Technologies Ltd.','Novatel Wireless Technologies Ltd.Suite 200, 6715-8th Street NeCalgary, Alberta T2e 8m4Canada',1),('00:60:D7','Ecole Polytechnique Federale De Lausanne (epfl)','Ecole Polytechnique Federale De Lausanne (epfl)EcublensCh-1015 LausanneSwitzerland',1),('00:60:D8','Elmic Systems, Inc.','Elmic Systems, Inc.Dai-ichi Seimei Bldg.4-59 Benten-dori, Naka-kuYokohama 231Japan',1),('00:60:D9','Transys Networks Inc.','Transys Networks Inc.3403 GriffithSt. Laurent, Quebec H4t 1w5Canada',1),('00:60:DA','Jbm Electronics Co.','Jbm Electronics Co.4645 Laguardian DriveSt. Louis Mo 63134United States',1),('00:60:DB','Ntp Elektronik A/s','Ntp Elektronik A/sKnapholm 7Dk-2730 HerlevDenmark',1),('00:60:DC','Toyo Network Systems  & System Integration Co. Ltd','Toyo Network Systems  & System Integration Co. Ltd18 Nihon-odori,naka-kuYokohama, Kanagawa  231-0021Japan',1),('00:60:DD','Myricom, Inc.','Myricom, Inc.325b N. Santa Anita Ave.Arcadia Ca 91006United States',1),('00:60:DE','Kayser-threde Gmbh','Kayser-threde GmbhWolfratshauser Str. 48D-81379 MunichGermany',1),('00:60:DF','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology Dr.San Jose Ca 95110United States',1),('00:60:E0','Axiom Technology Co., Ltd.','Axiom Technology Co., Ltd.3f, 14, Lane 235Pao Chiao Road, Hsin TienTaipei HsienTaiwan, Republic Of China',1),('00:60:E1','Orckit Communications Ltd.','Orckit Communications Ltd.38 Nahalat Yizhak StreetTel-aviv  67448Israel',1),('00:60:E2','Quest Engineering & Development','Quest Engineering & Development1345 East Rock Wren RoadPhoenix Az 85048United States',1),('00:60:E3','Arbin Instruments','Arbin Instruments3206 Longmire DriveCollege Station Tx 77845United States',1),('00:60:E4','Compuserve, Inc.','Compuserve, Inc.5000 Arlington Centre Blvd.P.o. Box 20212Columbus Oh 43220United States',1),('00:60:E5','Fuji Automation Co., Ltd.','Fuji Automation Co., Ltd.3-23-10, NegishiUrawa-shi, 336 SaitamaJapan',1),('00:60:E6','Shomiti Systems Incorporated','Shomiti Systems Incorporated2099 Gateway Place - Ste.#220San Jose Ca 95110United States',1),('00:60:E7','Randata','RandataPo Box 209Hawthorn  Vic  3122Australia',1),('00:60:E8','Hitachi Computer Products (america), Inc.','Hitachi Computer Products (america), Inc.3101 Tasman DriveSanta Clara Ca 95054United States',1),('00:60:E9','Atop Technologies, Inc.','Atop Technologies, Inc.Suite 305, No. 47, Park Avenue Ii,Science-based Industrial ParkHsinchu 30047Taiwan, Republic Of China',1),('00:60:EA','Streamlogic','Streamlogic21329 Nordhoff StreetChatsworth Ca 91311United States',1),('00:60:EB','Fourthtrack Systems','Fourthtrack SystemsUnit 3 The Sycamores27 Mill RoadMarlow - Sl7 1qbUnited Kingdom',1),('00:60:EC','Hermary Opto Electronics Inc.','Hermary Opto Electronics Inc.201-4050 Graveley StBurnaby, Bc V5c-3t6Canada',1),('00:60:ED','Ricardo Test Automation Ltd.','Ricardo Test Automation Ltd.Lowesmoor WharfWorcester, Wr12rsUnited Kingdom',1),('00:60:EE','Apollo','Apollo3610 Birch Street--ste #100Newport Beach Ca 92660United States',1),('00:60:EF','Flytech Technology Co., Ltd.','Flytech Technology Co., Ltd.2fl. No. 8, Lane 50, Sec.3Nan Kang RoadTaipeiTaiwan, Republic Of China',1),('00:60:F0','Johnson & Johnson Medical, Inc','Johnson & Johnson Medical, Inc4110 George Rd.Tampa Fl 33634United States',1),('00:60:F1','Exp Computer, Inc.','Exp Computer, Inc.141 Eileen WaySyosset Ny 11791United States',1),('00:60:F2','Lasergraphics, Inc.','Lasergraphics, Inc.20 AdaIrvine Ca 92718United States',1),('00:60:F3','Performance Analysis Broadband, Spirent Plc','Performance Analysis Broadband, Spirent Plc27349 Agoura RoadCalabasas Hills Ca 91301United States',1),('00:60:F4','Advanced Computer Solutions, Inc.','Advanced Computer Solutions, Inc.12675 Danielson CourtSuite #407Poway Ca 92064United States',1),('00:60:F5','Icon West, Inc.','Icon West, Inc.3342 South 300 EastSalt Lake City Ut 84115United States',1),('00:60:F6','Nextest Communications Products, Inc.','Nextest Communications Products, Inc.Two Mid America Plaza, Ste.500Oakbrook Terrace Il 60181United States',1),('00:60:F7','Datafusion Systems','Datafusion SystemsP.o. Box 582Stellenbosch,  7599South Africa',1),('00:60:F8','Loran International Technologies Inc.','Loran International Technologies Inc.955 Green Valley CrescentSuite #165Ottawa, Ontario K2c 3v4Canada',1),('00:60:F9','Diamond Lane Communications','Diamond Lane Communications1310 Redwood Way - Ste.Petaluma Ca 94954United States',1),('00:60:FA','Educational Technology Resources, Inc.','Educational Technology Resources, Inc.1742 Church StreetHolbrook Ny 11741United States',1),('00:60:FB','Packeteer, Inc.','Packeteer, Inc.10201 N. De Anza BoulevardCupertino Ca 95014United States',1),('00:60:FC','Conservation Through Innovation Ltd.','Conservation Through Innovation Ltd.1040 Whipple St.- Ste. #225Prescott Az 86301United States',1),('00:60:FD','Netics, Inc.','Netics, Inc.42 Nagog ParkActon Ma 01720United States',1),('00:60:FE','Lynx System Developers, Inc.','Lynx System Developers, Inc.175n New Boston StreetWoburn Ma 01801United States',1),('00:60:FF','Quvis, Inc.','Quvis, Inc.2921 Sw Wanamaker DriveSuite #107Topeka Ks 66614United States',1),('00:70:B0','M/a-com Inc. Companies','M/a-com Inc. Companies11717 Exploration LaneGermantown Md 20767United States',1),('00:70:B3','Data Recall Ltd.','Data Recall Ltd.Sondes PlaceDorking Surrey Rh4 3efUnited KingdomUnited Kingdom',1),('00:80:00','Multitech Systems, Inc.','Multitech Systems, Inc.2205 Woodale DriveMounds View Mn 55112United States',1),('00:80:01','Periphonics Corporation','Periphonics Corporation4000 Veterans Memorial HighwayBohemia New York 11716United States',1),('00:80:02','Satelcom (uk) Ltd','Satelcom (uk) LtdTechnology Transfer CentreSilwood Park, Buckhurst Road Ascot, BerkEnglandUnited Kingdom',1),('00:80:03','Hytec Electronics Ltd.','Hytec Electronics Ltd.5 Cradock RoadReading Berks Rg5 4dxEnglandUnited Kingdom',1),('00:80:04','Antlow Communications, Ltd.','Antlow Communications, Ltd.4 Colthrop WayThatcham Rg19 4lwEnglandUnited Kingdom',1),('00:80:05','Cactus Computer Inc.','Cactus Computer Inc.1120 Metrocrest DriveSuite 103Carrollton Tx 75006United States',1),('00:80:06','Compuadd Corporation','Compuadd CorporationEngineering12303 Technology Blvd.Austin Tx 78727United States',1),('00:80:07','Dlog Nc-systeme','Dlog Nc-systemeWerner-von-siemens Strasse 13D-8037, OlchingGermany',1),('00:80:08','Dynatech Computer Systems','Dynatech Computer Systems280 Bernardo AvenueP.o. Box 7400Mountain View Ca 94039-7400United States',1),('00:80:09','Jupiter Systems, Inc.','Jupiter Systems, Inc.3073 Teagarden StreetSan Leandro Ca 94577-5720United States',1),('00:80:0A','Japan Computer Corp.','Japan Computer Corp.L. K. Bldg. Higashi Kanda2-6-9 Chiyoda-ku Tokyo 101JapanJapan',1),('00:80:0B','Csk Corporation','Csk Corporation18f Matsushita Imp Bldg,1-3-7 Shiromi Chuo-ku OsakaJapan 540Japan',1),('00:80:0C','Videcom Limited','Videcom LimitedNewtown EstateHenley-on-thames Oxon  Rg9 1hgEnglandUnited Kingdom',1),('00:80:0D','Vosswinkel F.u.','Vosswinkel F.u.Am Jostenhof 15D-4130 MoersGermanyGermany',1),('00:80:0E','Atlantix Corporation','Atlantix Corporation5401 Nw Brokensound Blvd.Boca Raton Fl 33431United States',1),('00:80:0F','Standard Microsystems','Standard Microsystems300 Kennedy DriveHauppauge Ny 11788United States',1),('00:80:10','Commodore International','Commodore International1200 Wilson DriveWest Chester Pa 19380United States',1),('00:80:11','Digital Systems Intl. Inc.','Digital Systems Intl. Inc.7659 178th Pl. NeP.o. Box 908Redmond Wa 98073-0908United States',1),('00:80:12','Integrated Measurement Systems','Integrated Measurement Systems9525 Sw Gemini DriveBeaverton Or 97005United States',1),('00:80:13','Thomas-conrad Corporation','Thomas-conrad Corporation1908-r Kramer LaneAustin Tx 78758United States',1),('00:80:14','Esprit Systems','Esprit Systems14f, No. 1, Sec. 4Nan King East Road 10569 TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:80:15','Seiko Systems, Inc.','Seiko Systems, Inc.Systems Development Division5-4 Hacchobori 4-choume Chuuou-ku TokoyoJapanJapan',1),('00:80:16','Wandel And Goltermann','Wandel And Goltermann1030 Swabia CourtResearch Triangle ParkNc 27709United States',1),('00:80:17','Pfu Limited','Pfu LimitedNetwork Sec.658-1, Tsuruma Machida-shi, Tokyo 194-00JapanJapan',1),('00:80:18','Kobe Steel, Ltd.','Kobe Steel, Ltd.Kobe Isuzu Recruit Bldg.7th Floor 2-2, 4-chome, Kumoi-dori, ChuoJapanJapan',1),('00:80:19','Dayna Communications, Inc.','Dayna Communications, Inc.50 South Main Street-#530Salt Lake City Utah 84144United States',1),('00:80:1A','Bell Atlantic','Bell AtlanticN92 W14612  Anthony AvenueMenomonee Falls Wi 53051United States',1),('00:80:1B','Kodiak Technology','Kodiak Technology2340 Harris WaySan Jose Ca 95131United States',1),('00:80:1C','Newport Systems Solutions','Newport Systems Solutions4019 Westerly AvenueSuite 103Newport Beach Ca 92660United States',1),('00:80:1D','Integrated Inference Machines','Integrated Inference Machines1468 East KatellaAnaheim Ca 92805United States',1),('00:80:1E','Xinetron, Inc.','Xinetron, Inc.2330 B. Walsh Ave.Santa Clara Ca 95051United States',1),('00:80:1F','Krupp Atlas Electronik Gmbh','Krupp Atlas Electronik GmbhP.o. Box 448545D-2800 Bremen 44Germany',1),('00:80:20','Network Products','Network ProductsDivision Of Andrew Corporation2771 Plaza Del Amo3Torrance Ca 90503United States',1),('00:80:21','Alcatel Canada Inc.','Alcatel Canada Inc.349 Terry Fox DriveKanata Ontario K2k 2v6Canada',1),('00:80:22','Scan-optics','Scan-optics201 Technology DriveIrvine Ca 92718United States',1),('00:80:23','Integrated Business Networks','Integrated Business Networks1bn The Systems Centre14, Bridgegate Business Park, GatehouseBucks Hp19 3xn - EnglandUnited Kingdom',1),('00:80:24','Kalpana, Inc.','Kalpana, Inc.1154 East Arques AvenueSunnyvale Ca 94086United States',1),('00:80:25','Stollmann Gmbh','Stollmann GmbhMax-brauer-allee 81D-2000 Hamburg 50GermanyGermany',1),('00:80:26','Network Products Corporation','Network Products Corporation1440 West Colorado Blvd.Pasadena Ca 91105United States',1),('00:80:27','Adaptive Systems, Inc.','Adaptive Systems, Inc.1400 N.w. Compton DriveSuite 340Beaverton Or 97006United States',1),('00:80:28','Tradpost (hk) Ltd','Tradpost (hk) Ltd5/f, Star Centre443-451 Castle Peak Road Kwai Chung, N.tHong KongHong Kong',1),('00:80:29','Eagle Technology, Inc.','Eagle Technology, Inc.6800 Orangethorpe Ave.unitBuena Park Ca 90620United States',1),('00:80:2A','Test Systems & Simulations Inc','Test Systems & Simulations Inc32429 Industrial DriveMadison Heights Mi 48071-1528United States',1),('00:80:2B','Integrated Marketing Co','Integrated Marketing Co1360 Bordeaux DriveBldg. #4Sunnyvale Ca 94089United States',1),('00:80:2C','The Sage Group Plc','The Sage Group PlcSage House, Benton Park RoadNewcastle Upon Tyne Ne7 7lzUnited KingdomUnited Kingdom',1),('00:80:2D','Xylogics Inc','Xylogics Inc53 Third AvenueBurlington Ma 01803United States',1),('00:80:2E','Castle Rock Computing','Castle Rock Computing20837 Boyce LaneSaratoga Ca 95070-4806United States',1),('00:80:2F','National Instruments Corp.','National Instruments Corp.11500 North Mopac ExpresswayAustin Tx 78759-3504United States',1),('00:80:30','Nexus Electronics','Nexus Electronics39 Springfield RoadCambridge Cb4 1adUnited KingdomUnited Kingdom',1),('00:80:31','Basys, Corp.','Basys, Corp.501 Macara AvenueSunnyvale Ca 94086United States',1),('00:80:32','Access Co., Ltd.','Access Co., Ltd.Hiei-kudan Bldg. B13-8-11 Kudan-minami, Chiyoda-ku, Tokyo 1JapanJapan',1),('00:80:33','Formation, Inc.','Formation, Inc.121 Whittendale DriveMoorestown Nj 08057United States',1),('00:80:34','Smt Goupil','Smt Goupil3 Rue Des Archives94000 CreteilFranceFrance',1),('00:80:35','Technology Works, Inc.','Technology Works, Inc.4030 Braker Lane #350Austin Tx 78759United States',1),('00:80:36','Reflex Manufacturing Systems','Reflex Manufacturing SystemsUnit D, The Fleming Centre,Fleming Way, Crawley West Sussex Rh10 2nEnglandUnited Kingdom',1),('00:80:37','Ericsson Group','Ericsson GroupTelefonaktiebolagetLm Ericsson Corp. 126 25 StockholmSwedenSweden',1),('00:80:38','Data Research & Applications','Data Research & Applications9041 Executive Park Dr.Suite 200Knoxville Tn 37923-4609United States',1),('00:80:39','Alcatel Stc Australia','Alcatel Stc Australia252-280 Botany RoadAlexandria, Nsw 2015AustraliaAustralia',1),('00:80:3A','Varityper, Inc.','Varityper, Inc.900 Middlesex TurnpikeBillerica Ma 01821United States',1),('00:80:3B','Apt Communications, Inc.','Apt Communications, Inc.9607 Dr. Perry RoadIjamsville Md 21754United States',1),('00:80:3C','Tvs Electronics Ltd','Tvs Electronics Ltd44, Miller RoadBangalore 560 052IndiaIndia',1),('00:80:3D','Surigiken Co.,  Ltd.','Surigiken Co.,  Ltd.Youth Bldg, 4-1-9 ShinjukuShinjuku-ku, TokyoJapanJapan',1),('00:80:3E','Synernetics','Synernetics85 Rangeway RoadNorth Billerica Ma 01862United States',1),('00:80:3F','Tatung Company','Tatung Company22 Chungshang N. Rd. 3rd Sec.Taipei Taiwan R.o.c.Taiwan, Republic Of China',1),('00:80:40','John Fluke Manufacturing Co.','John Fluke Manufacturing Co.P.o. Box C9090-m/s 244fEverett Wa 98206United States',1),('00:80:41','Veb Kombinat Robotron','Veb Kombinat RobotronGrunaer Strabe 2, Dresden 8010Gdr East GermanyGermany',1),('00:80:42','Emerson Network Power','Emerson Network Power2900 S. Diablo WayTempe Az 85282United States',1),('00:80:43','Networld, Inc.','Networld, Inc.Kanda 3 Amerex Bldg.3-10 Kandajinbocho Chiyoda-ku    Tokyo 1JapanJapan',1),('00:80:44','Systech Computer Corp.','Systech Computer Corp.6465 Nancy Ridge DriveSan Diego Ca 92121United States',1),('00:80:45','Matsushita Electric Ind. Co','Matsushita Electric Ind. CoComputer Division1006, Kadoma,Osaka 571 JapanJapan',1),('00:80:46','University Of Toronto','University Of TorontoDept. Of Electrical Engining10 Kings College Rd. Toronto, Ontario M5CanadaCanada',1),('00:80:47','In-net Corp.','In-net Corp.16720 West Bernardo DriveSan Diego Ca 92127-1904United States',1),('00:80:48','Compex Incorporated','Compex Incorporated4055 East La PalmaUnitAnaheim Ca 92807United States',1),('00:80:49','Nissin Electric Co., Ltd.','Nissin Electric Co., Ltd.47, Umezu - Takase - ChoUkyo-ku, Kyoto, 615JapanJapan',1),('00:80:4A','Pro-log','Pro-log12 Upper Ragsdale DriveMonterey Ca 93940United States',1),('00:80:4B','Eagle Technologies Pty.ltd.','Eagle Technologies Pty.ltd.70 Keys RoadMoorabbin  Vic. 3189AustraliaAustralia',1),('00:80:4C','Contec Co., Ltd.','Contec Co., Ltd.3-9-31, HimesatoNishiyodogawa-ku Osaka, 555JapanJapan',1),('00:80:4D','Cyclone Microsystems, Inc.','Cyclone Microsystems, Inc.25 Science ParkNew Haven Ct 06511United States',1),('00:80:4E','Apex Computer Company','Apex Computer Company4500 150th Avenue, NeRedmond Wa 98052United States',1),('00:80:4F','Daikin Industries, Ltd.','Daikin Industries, Ltd.Electronics DivisionShiga Plant 1000-2 Ohtani Okamoto-cho, KJapan 525Japan',1),('00:80:50','Ziatech Corporation','Ziatech Corporation3433 Roberto CourtSan Luis Obispo Ca 93401United States',1),('00:80:51','Fibermux','Fibermux9310 Topanga Canyon Blvd.Chatsworth Ca 91311United States',1),('00:80:52','Technically Elite Concepts','Technically Elite Concepts2615 Pacific Coast HighwayHermosa Beach Ca 90250United States',1),('00:80:53','Intellicom, Inc.','Intellicom, Inc.20415 Nordhoff StreetChatsworth Ca 91311United States',1),('00:80:54','Frontier Technologies Corp.','Frontier Technologies Corp.10201 No. Pt. Washington RoadMequon Wi 53092United States',1),('00:80:55','Fermilab','FermilabP.o. Box 500, Ms-234Batavia Il 60510United States',1),('00:80:56','Sphinx Elektronik Gmbh','Sphinx Elektronik GmbhWaldmattenstr, 137808 Waldkirch 3 Rappeneckstrabe 1West GermanyGermany',1),('00:80:57','Adsoft, Ltd.','Adsoft, Ltd.Landstrasse 27aCh-4313 MohlinSwitzerlandSwitzerland',1),('00:80:58','Printer Systems Corporation','Printer Systems Corporation207 Parry ParkwayGaithersburg Md 20877United States',1),('00:80:59','Stanley Electric Co., Ltd','Stanley Electric Co., LtdR&d Laboratory1-3-1 Eda-nishi, Midori-ku, Yokohama-shiJapanJapan',1),('00:80:5A','Tulip Computers Internatl B.v','Tulip Computers Internatl B.vP.o. Box 33335203 Dh s-hertogenboschThe NetherlandsNetherlands',1),('00:80:5B','Condor Systems, Inc.','Condor Systems, Inc.2133 Samariltan DriveSan Jose Ca 95124United States',1),('00:80:5C','Agilis Corporation','Agilis Corporation1101 San Antonio RoadSuite 101Mountain View Ca 94043-1008United States',1),('00:80:5D','Canstar','Canstar3900 Victoria Park AvenueNorth York Ontario, CanadaM2h 3h7Canada',1),('00:80:5E','Lsi Logic Corporation','Lsi Logic Corporation1551 Mccarthy BoulevardMs G813Milpitas Ca 95035United States',1),('00:80:5F','Hewlett Packard','Hewlett Packard20555 State Highway 249Ms040801Houston Tx 77070United States',1),('00:80:60','Network Interface Corporation','Network Interface Corporation15019 West 95 StreetLenexa Ks 66215United States',1),('00:80:61','Litton Systems, Inc.','Litton Systems, Inc.M/s 44-2029851 Agoura RoadAgoura Hills Ca 91301-0500United States',1),('00:80:62','Interface  Co.','Interface  Co.8-26 Ozu 5-chome Minami-kuHiroshima 732JapanJapan',1),('00:80:63','Richard Hirschmann Gmbh & Co.','Richard Hirschmann Gmbh & Co.GeschaftsbereichOptische Ubertragungstechnik Oberturkhei7300 Esslingen GermanyGermany',1),('00:80:64','Wyse Technology','Wyse Technology3471 North First Street M/sSan Jose Ca 95134United States',1),('00:80:65','Cybergraphic Systems Pty Ltd.','Cybergraphic Systems Pty Ltd.290 Burwood RoadHawthorn, Victoria 3122AustraliaAustralia',1),('00:80:66','Arcom Control Systems, Ltd.','Arcom Control Systems, Ltd.Unit 8, Clifton RoadCambridge Cbi 4whUnited KingdomUnited Kingdom',1),('00:80:67','Square D Company','Square D Company4041 North Richard StreetP.o. Box 472Milwaukee Wi 53201United States',1),('00:80:68','Yamatech Scientific Ltd.','Yamatech Scientific Ltd.1255 Laird, Suite 260Montreal, Quebec H3p 2t1CanadaCanada',1),('00:80:69','Computone Systems','Computone Systems1100 Northmeadow ParkwaySuite 150Roswell Ga 30076United States',1),('00:80:6A','Eri (empac Research Inc.)','Eri (empac Research Inc.)47560 Seabridge DriveFremont Ca 94538United States',1),('00:80:6B','Schmid Telecommunication','Schmid TelecommunicationBinzstrasse 35,Ch-8045 ZurichSwitzerlandSwitzerland',1),('00:80:6C','Cegelec Projects Ltd','Cegelec Projects LtdDept. Mdd,Boughton Rd,  Rugby Warks, Co21 1buEnglandUnited Kingdom',1),('00:80:6D','Century Systems Corp.','Century Systems Corp.2-8-12 Minami-choKokubunji-shi, Tokyo185 JapanJapan',1),('00:80:6E','Nippon Steel Corporation','Nippon Steel Corporation31-1 Shinkawa 2-choumeChuo-ku Tokyo 104JapanJapan',1),('00:80:6F','Onelan Ltd.','Onelan Ltd.P.o. Box 107Henley On Thames Oxfordshire Rg9 3noqUnited KingdomUnited Kingdom',1),('00:80:70','Computadoras Micron','Computadoras MicronGuerrero 2001 - 19Irapuato Gto  36660MexicoMexico',1),('00:80:71','Sai Technology','Sai Technology4224 Campus Point CourtSan Diego Ca 92121-1513United States',1),('00:80:72','Microplex Systems Ltd.','Microplex Systems Ltd.104-2071 KingswayPort Coquitlam,  Bc V3c 6n2Canada',1),('00:80:73','Dwb Associates','Dwb Associates9360 Sw Gemini DriveBeaverton Or 97005-7151United States',1),('00:80:74','Fisher Controls','Fisher Controls1712 Centre Creek DriveAustin Tx 78754United States',1),('00:80:75','Parsytec Gmbh','Parsytec GmbhJuelicher Str. 338D5100 AachenF.r. GermanyGermany',1),('00:80:76','Mcnc','McncP.o. Box 12889Rtp Nc 27709United States',1),('00:80:77','Brother Industries, Ltd.','Brother Industries, Ltd.Research Laboratory9-35 Horita-dori, Mizuho-ku Nagoya, 467Japan',1),('00:80:78','Practical Peripherals, Inc.','Practical Peripherals, Inc.375 Conejo Ridge AvenueThousand Oaks Ca 91361United States',1),('00:80:79','Microbus Designs Ltd.','Microbus Designs Ltd.Treadaway HillLoudwater High Wycombe Bucks Hp10 9qlUnited KingdomUnited Kingdom',1),('00:80:7A','Aitech Systems Ltd.','Aitech Systems Ltd.3080 Olcott StreetSuite 105aSanta Clara Ca 95054United States',1),('00:80:7B','Artel Communications Corp.','Artel Communications Corp.22 Kane Industrial DriveHudson Ma 01749United States',1),('00:80:7C','Fibercom, Inc.','Fibercom, Inc.3353 Orange Avenue NeRoanoke Va 24012United States',1),('00:80:7D','Equinox Systems Inc.','Equinox Systems Inc.14260 Sw 119th AvenueMiami Fl 33186United States',1),('00:80:7E','Southern Pacific Ltd.','Southern Pacific Ltd.Sanwa Bldg., 2-16-20Minamisaiwai Nishi YokohamaJapan Japan 220Japan',1),('00:80:7F','Dy-4 Incorporated','Dy-4 Incorporated333 Palladium Drive, Ms 312Kanata, Ontario, K2v 1a6CanadaCanada',1),('00:80:80','Datamedia Corporation','Datamedia Corporation7401 Central HighwayPennsauken Nj 08109United States',1),('00:80:81','Kendall Square Research Corp.','Kendall Square Research Corp.170 Tracer LaneWaltham Ma 02154-1379United States',1),('00:80:82','Pep Modular Computers Gmbh','Pep Modular Computers GmbhApfelstranger Str. 16D - 8950 KaufbeurenWest GermanyGermany',1),('00:80:83','Amdahl','Amdahl1250 East Arques AvenueM/s 286 P.o. Box 3470Sunnyvale Ca 94088-3470United States',1),('00:80:84','The Cloud Inc.','The Cloud Inc.Cloud Bldg.71-1, Cheong-dam Dong Kang-nam Ku, SeoulKoreaKorea, Republic Of',1),('00:80:85','H-three Systems Corporation','H-three Systems Corporation100 Park Drive, Suite 204Research Triangle ParkNc 27709United States',1),('00:80:86','Computer Generation Inc.','Computer Generation Inc.3855 Presidential ParkwayAtlanta Ga 30340United States',1),('00:80:87','Oki Electric Industry Co., Ltd','Oki Electric Industry Co., Ltd10-3 Shibaura 4-chomeMinato-ku, Tokyo 108Japan',1),('00:80:88','Victor Company Of Japan, Ltd.','Victor Company Of Japan, Ltd.58-7 Shinmei-cho, YokosukaKanagawa   239JapanJapan',1),('00:80:89','Tecnetics (pty) Ltd.','Tecnetics (pty) Ltd.P.o. Box/posbus 56412Pinegowrie, 2123South AfricaSouth Africa',1),('00:80:8A','Summit Microsystems Corp.','Summit Microsystems Corp.710 Lakeway-ste.#150Sunnyvale Ca 940867United States',1),('00:80:8B','Dacoll Limited','Dacoll LimitedDacoll House, Gardners LaneBathgate West LothianScotland Eh48 1tpUnited Kingdom',1),('00:80:8C','Netscout Systems, Inc.','Netscout Systems, Inc.1501 Main StreetSuite #40Tewksbury Ma 01876United States',1),('00:80:8D','Westcoast Technology B.v.','Westcoast Technology B.v.P.o. Box 33172601 Dh DelftNetherlandsNetherlands',1),('00:80:8E','Radstone Technology','Radstone TechnologyWater Lane, TowcesterNorthants Nn12 7jnEnglandUnited Kingdom',1),('00:80:8F','C. Itoh Electronics, Inc.','C. Itoh Electronics, Inc.2505 Mccabe WayIrvine Ca 92714United States',1),('00:80:90','Microtek International, Inc.','Microtek International, Inc.3300 Nw 211th TerraceHillsbor Or 97124-7136United States',1),('00:80:91','Tokyo Electric Co.,ltd','Tokyo Electric Co.,ltd10-14 Uchikanda1-chome Chiyoda-kuTokyo Japan 101Japan',1),('00:80:92','Silex Technology, Inc.','Silex Technology, Inc.2-3-1 Hikaridai,Seika-choKyoto  619-0237Japan',1),('00:80:93','Xyron Corporation','Xyron Corporation7864 Lily CourtCupertino Ca 95014United States',1),('00:80:94','Alfa Laval Automation Ab','Alfa Laval Automation AbAdnS-205 22 MalmoSwedenSweden',1),('00:80:95','Basic Merton Handelsges.m.b.h.','Basic Merton Handelsges.m.b.h.Durchlass-strasse 42A - 9020 KlagenfurtAustriaAustria',1),('00:80:96','Human Designed Systems, Inc.','Human Designed Systems, Inc.421 Feheley DriveKing Of Prussia Pa 19406United States',1),('00:80:97','Centralp Automatismes','Centralp Automatismes21, Rue Marcel Pagnol 69694Venissieux CedexFranceFrance',1),('00:80:98','Tdk Corporation','Tdk CorporationCorp. R&d Dept. Tech. Hdqters.2-15-7, Higashi-owada, Ichikawa-shiChiba-ken 272, JapanJapan',1),('00:80:99','Klockner Moeller Ipc','Klockner Moeller IpcFritz-kotz-str. 8P.o. Box 13 80 D-5276 Wiehl 1-bomigWest GermanyGermany',1),('00:80:9A','Novus Networks Ltd','Novus Networks LtdJohn Scott HouseMarket Street Bracknell, Berkw  Rg12 1jbEnglandUnited Kingdom',1),('00:80:9B','Justsystem Corporation','Justsystem Corporation3-46 OkinohamahigashiTokusimashi 770JapanJapan',1),('00:80:9C','Luxcom, Inc.','Luxcom, Inc.3249 Laurelview CourtFremont Ca 94538United States',1),('00:80:9D','Commscraft Ltd.','Commscraft Ltd.Po Box 160Bentley, W.a. 6102AustraliaAustralia',1),('00:80:9E','Datus Gmbh','Datus GmbhIndustriestr. 2D-5102 Wurselen/aachenWest GermanyGermany',1),('00:80:9F','Alcatel Business Systems','Alcatel Business Systems54, Avenue Jean Jaures92707 Colombes CedexFrance',1),('00:80:A0','Edisa Hewlett Packard S/a','Edisa Hewlett Packard S/aAlameda Rio Negro,750-alphaville 06454-000  Barueri SpBrazilBrazil',1),('00:80:A1','Microtest, Inc.','Microtest, Inc.4747 N. 22nd StreetPhoenix Az 85016-4708United States',1),('00:80:A2','Creative Electronic Systems','Creative Electronic Systems70 Route Du Pont - ButinCh-1213 Petit-lancy GenevaSwitzerlandSwitzerland',1),('00:80:A3','Lantronix','Lantronix15353 Barranca ParkwayIrvine Ca 92618United States',1),('00:80:A4','Liberty Electronics','Liberty Electronics332 Harbor WaySouth San Francisco Ca 94080United States',1),('00:80:A5','Speed International','Speed International1320 Arbolita Dr.La Habra Ca 90631United States',1),('00:80:A6','Republic Technology, Inc.','Republic Technology, Inc.P.o. Box 141006Austin Tx 78714United States',1),('00:80:A7','Measurex Corp.','Measurex Corp.1 Results WayCupertino Ca 95014-5991United States',1),('00:80:A8','Vitacom Corporation','Vitacom Corporation1330 Charleston RoadMountain View Ca 94043United States',1),('00:80:A9','Clearpoint Research','Clearpoint Research190 North Main StreetNatick MaUnited States',1),('00:80:AA','Maxpeed','Maxpeed1120 Chess DriveFoster City Ca 94404United States',1),('00:80:AB','Dukane Network Integration','Dukane Network Integration2900 Dukane DriveSt. Charles Il 60174United States',1),('00:80:AC','Imlogix, Division Of Genesys','Imlogix, Division Of Genesys1900 Summit Tower Blvd.ste#770Orlando Fl 32810United States',1),('00:80:AD','Cnet Technology, Inc.','Cnet Technology, Inc.2199 Zanker RoadSan Jose Ca 95131United States',1),('00:80:AE','Hughes Network Systems','Hughes Network Systems11717 Exploration LaneGermantown Md 20876United States',1),('00:80:AF','Allumer Co., Ltd.','Allumer Co., Ltd.2-8-8 Chuo-cho, Meguro-kuTokyo 152JapanJapan',1),('00:80:B0','Advanced Information','Advanced InformationTechnology, Inc.5f 1-2-6 Nihonbashi-honcho Chuo-ku,  TokJapanJapan',1),('00:80:B1','Softcom A/s','Softcom A/sStudiestraede 21Dk 1455 Copennhagen K.DenmarkDenmark',1),('00:80:B2','Network Equipment Technologies','Network Equipment Technologies6900 Paseo Padre ParkwayFremont Ca 94555United States',1),('00:80:B3','Aval Data Corporation','Aval Data CorporationMachida Engineering Center1757-1 Kanai-cho Machida City Tokyo JapaJapanJapan',1),('00:80:B4','Sophia Systems','Sophia Systems3337 Kifer RoadSanta Clara Ca 95051United States',1),('00:80:B5','United Networks Inc.','United Networks Inc.2178 Paragon DriveSan Jose Ca 95131United States',1),('00:80:B6','Themis Computer','Themis Computer6681 Owens DrivePleasonton Ca 94588United States',1),('00:80:B7','Stellar Computer','Stellar Computer95 Wells AvenueNewton Ma 02159United States',1),('00:80:B8','Bug, Incorporated','Bug, Incorporated1-14 Techno-park  1-chomeShimonopporo, Atsubetsu-ku Sapporo 004,JapanJapan',1),('00:80:B9','Arche Technoligies Inc.','Arche Technoligies Inc.48502 Kato RoadFremont Ca 94538United States Minor Outlying Islan',1),('00:80:BA','Specialix (asia) Pte, Ltd','Specialix (asia) Pte, Ltd3 Wintersells RoadByfleet Surrey  Kt147lfUnited KingdomUnited Kingdom',1),('00:80:BB','Hughes Lan Systems','Hughes Lan Systems1225 Charleston RoadMountain View Ca 94043United States',1),('00:80:BC','Hitachi Engineering Co., Ltd','Hitachi Engineering Co., Ltd4-8-26, OmikachoHitachi City Ibaraki Prefecture 319-12JapanJapan',1),('00:80:BD','The Furukawa Electric Co., Ltd','The Furukawa Electric Co., Ltd6-1, Marunouchi 2-chomeChiyoda-ku, Tokyo100 JapanJapan',1),('00:80:BE','Aries Research','Aries Research46791 Fremond Blvd.Fremont Ca 94538United States',1),('00:80:BF','Takaoka Electric Mfg. Co. Ltd.','Takaoka Electric Mfg. Co. Ltd.Kanda Branch Office Tonen2-1-11, Sarugaku-cho Chiyoda-ku, Tokyo,JapanJapan',1),('00:80:C0','Penril Datacomm','Penril Datacomm1300 Quince Orchard Blvd.Gaithersburg Md 20878United States',1),('00:80:C1','Lanex Corporation','Lanex Corporation10727 Tucker StreetBeltsville Md 20705United States',1),('00:80:C2','Ieee 802.1 Committee','Ieee 802.1 Committee802.1 Chair, C/o Ieee Standards Association445 Hoes LanePiscataway Nj 08854United States',1),('00:80:C3','Bicc Information Systems & Svc','Bicc Information Systems & Svc500 Capability Green, LutonBedfordshireEngland Lu1 3ltUnited Kingdom',1),('00:80:C4','Document Technologies, Inc.','Document Technologies, Inc.1300 Charleston RoadMountain View Ca 94043United States',1),('00:80:C5','Novellco De Mexico','Novellco De MexicoConstituyentes No. 907Col. Lomas Altas11950 Mexico 11950 Mexico D.f.Mexico',1),('00:80:C6','National Datacomm Corporation','National Datacomm Corporation2f, 28, Industry East 9th Rd.Science Park, Hsin-chuTaiwan  30077 Taiwan  30077 R.o.c.Taiwan, Republic Of China',1),('00:80:C7','Xircom','Xircom26025 Mureau RoadCalabasas Ca 91302United States',1),('00:80:C8','D-link Systems, Inc.','D-link Systems, Inc.53 Discover Dr.Irvine Ca 92618United States',1),('00:80:C9','Alberta Microelectronic Centre','Alberta Microelectronic Centre318, 11315 - 87 AvenueEdmonton, Ab T6g 2c2CanadaCanada',1),('00:80:CA','Netcom Research Incorporated','Netcom Research Incorporated201 Technology DriveIrvine Ca 92718United States',1),('00:80:CB','Falco Data Products','Falco Data Products440 Potrero AvenueSunnyvale Ca 94086-4196United States',1),('00:80:CC','Microwave Bypass Systems','Microwave Bypass Systems25 Braintree Hill Office ParkBraintree Ma 02184United States',1),('00:80:CD','Micronics Computer, Inc.','Micronics Computer, Inc.45365 Northport Loop WestFremont Ca 94538United States',1),('00:80:CE','Broadcast Television Systems','Broadcast Television SystemsP.o. Box 30816Salt Lake City, UtahUtah 84130-0816United States',1),('00:80:CF','Embedded Performance Inc.','Embedded Performance Inc.3385 Scott Blvd.Santa Clara Ca 95054-3115United States',1),('00:80:D0','Computer Peripherals, Inc.','Computer Peripherals, Inc.667 Rancho Conejo Blvd.Newbury Park Ca 91320United States',1),('00:80:D1','Kimtron Corporation','Kimtron Corporation1709 Junction CourtBuilding 380San Jose Ca 95112United States',1),('00:80:D2','Shinnihondenko Co., Ltd.','Shinnihondenko Co., Ltd.6-8 Nishitenma 2 ChomeKita-ku, Osaka 530JapanJapan',1),('00:80:D3','Shiva Corp.','Shiva Corp.205 Burlington RoadBedford Ma 01730United States',1),('00:80:D4','Chase Research Ltd.','Chase Research Ltd.7 Chineham Business ParkBasingstoke, Rg 24 OwdEnglandUnited Kingdom',1),('00:80:D5','Cadre Technologies','Cadre Technologies19545 Nw Von Neumann DriveBeaverton Or 97006United States',1),('00:80:D6','Nuvotech, Inc.','Nuvotech, Inc.2015 Bridgeway, Suite 204Sausalito Ca 94965United States',1),('00:80:D7','Fantum Engineering','Fantum Engineering',1),('00:80:D8','Network Peripherals Inc.','Network Peripherals Inc.2890 Zonker Road Suite 209San Jose Ca 95134United States',1),('00:80:D9','Emk Elektronik Gmbh & Co. Kg','Emk Elektronik Gmbh & Co. KgObere Bergstrasse 1675335 DobelGermany',1),('00:80:DA','Bruel & Kjaer','Bruel & Kjaer18, Naerum HovedgadeDk-2850 NaerumDenmarkDenmark',1),('00:80:DB','Graphon Corporation','Graphon Corporation1506 Dell Ave - #Campbell Ca 95008-6911United States',1),('00:80:DC','Picker International','Picker International595 Miner RoadCleveland Oh 44143United States',1),('00:80:DD','Gmx Inc/gimix','Gmx Inc/gimix3223 Arnold LaneNorthbrook Il 60062-2406United States',1),('00:80:DE','Gipsi S.a.','Gipsi S.a.2,bd Vauban - B.p. 26878053 St. Quentin En Yvelines CedexFranceFrance',1),('00:80:DF','Adc Codenoll Technology Corp.','Adc Codenoll Technology Corp.200 Corporate Blvd. So.Yonkers Ny 10701United States',1),('00:80:E0','Xtp Systems, Inc.','Xtp Systems, Inc.1900 State Street , SteSanta Barbara Ca 93101United States',1),('00:80:E1','Stmicroelectronics','Stmicroelectronics1000 Aztec WestAlmondsbury Bristol Bs32 4sqUnited Kingdom',1),('00:80:E2','T.d.i. Co., Ltd.','T.d.i. Co., Ltd.Development Div.  #3 Fuji Bldg1-3-13 Itachibori Nishi-ku Osaka 550JapanJapan',1),('00:80:E3','Coral Network Corporation','Coral Network Corporation(now Bay Networks)4401 Great American Pkwy M/s: Sc01-05Santa Clara Ca 95052-8185United States',1),('00:80:E4','Northwest Digital Systems, Inc','Northwest Digital Systems, IncP.o. Box 15288Seattle Wa 98115United States',1),('00:80:E5','Lsi Logic Corporation','Lsi Logic Corporation3718 N. Rock RoadWichita Ks 67226-1397United States',1),('00:80:E6','Peer Networks, Inc.','Peer Networks, Inc.3350 Scott Blvd. Bldg. 14Santa Clara Ca 95054United States',1),('00:80:E7','Lynwood Scientific Dev. Ltd.','Lynwood Scientific Dev. Ltd.Farnham Trading EstateFarnham, Surrey, Gu9 9nnUnited KingdomUnited Kingdom',1),('00:80:E8','Cumulus Corporatiion','Cumulus Corporatiion23500 Mercantile RoadCleveland Oh 44122United States',1),('00:80:E9','Madge Ltd.','Madge Ltd.Madge HousePriors WayMaindenhead Berkshire Sl6 2hpUnited Kingdom',1),('00:80:EA','Adva Optical Networking Ltd.','Adva Optical Networking Ltd.One Technology Parkway SouthNorcross Ga 30092United States',1),('00:80:EB','Compcontrol B.v.','Compcontrol B.v.Stratumsed K315611 Nb EindhovenThe NetherlandsNetherlands',1),('00:80:EC','Supercomputing Solutions, Inc.','Supercomputing Solutions, Inc.6175 Nancy Ridge Blvd.San Diego Ca 92121United States',1),('00:80:ED','Iq Technologies, Inc.','Iq Technologies, Inc.11811 Ne First StreetSuite 201Bellevue Wa 98005United States',1),('00:80:EE','Thomson Csf','Thomson Csf51 Esplanade Du GeneralDe Gaulle 92045 - Paris La  Defense - CeFranceFrance',1),('00:80:EF','Rational','Rational3320 Scott BoulevardSanta Clara Ca 95054United States',1),('00:80:F0','Panasonic Communications Co., Ltd.','Panasonic Communications Co., Ltd.4-1-62 Minoshima Hakata Fukuoka812-8531Japan',1),('00:80:F1','Opus Systems','Opus Systems3000 Coronado DriveSanta Clara Ca 95054United States',1),('00:80:F2','Raycom Systems Inc','Raycom Systems Inc16525 Sherman Way #c-8Van Nuys Ca 91406United States',1),('00:80:F3','Sun Electronics Corp.','Sun Electronics Corp.250 Asahi Kochino-choKonan-city Aichi483 JapanJapan',1),('00:80:F4','Telemecanique Electrique','Telemecanique Electrique33 Bis Avenue,Du Marechal Joffre 92002 Nanterre CedexFranceFrance',1),('00:80:F5','Quantel Ltd','Quantel LtdTurnpike RoadNewbury Berkshire Rg14 2nxUnited Kingdom',1),('00:80:F6','Synergy Microsystems','Synergy Microsystems9605 Scranton Road-ste #700San Diego Ca 92121-1773United States',1),('00:80:F7','Zenith Electronics','Zenith Electronics1000 Milwaukee AvenueGlenview Il 60025United States',1),('00:80:F8','Mizar, Inc.','Mizar, Inc.1419 Dunn DriveCarrollton Tx 75006United States',1),('00:80:F9','Heurikon Corporation','Heurikon Corporation8310 Excelsior DriveMadison Wi 53717United States',1),('00:80:FA','Rwt Gmbh','Rwt GmbhTalangerstr. 5-7D - 8033 KraillingWest GermanyGermany',1),('00:80:FB','Bvm Limited','Bvm LimitedHobb LaneHedge End SouthamptonEnglandUnited Kingdom',1),('00:80:FC','Avatar Corporation','Avatar Corporation65 South StreetHopkinton Ma 01748United States',1),('00:80:FD','Exsceed Corpration','Exsceed Corpration1-15-12, Kitakase, Saiwai-kuKawasaki-city, 211 KanagawaJapanJapan',1),('00:80:FE','Azure Technologies, Inc.','Azure Technologies, Inc.63 South StreetHopkinton Ma 01748-2212United States',1),('00:80:FF','Soc. De Teleinformatique Rtc','Soc. De Teleinformatique RtcP.o. Box 955 Place Du Parc300 Leo-paristau    Suite 725 Montreal (Canada H2w 2n1Canada',1),('00:90:00','Diamond Multimedia','Diamond Multimedia312 Se Stonemill DriveSuite #150Vancouver Wa 98684United States',1),('00:90:01','Nishimu Electronics Industries Co., Ltd.','Nishimu Electronics Industries Co., Ltd.700 Tateno Mitagawa-choKanzaki-gun Saga Pref.Japan',1),('00:90:02','Allgon Ab','Allgon AbGardatorget 1412 50 GoteborgSweden',1),('00:90:03','Aplio','Aplio18 Avenue Du 8 Mai 194595200 SarcellesFrance',1),('00:90:04','3com Europe Ltd.','3com Europe Ltd.3com Centre, Boundary WayHemel HempsteadHerts.  Hp2 7yuUnited Kingdom',1),('00:90:05','Protech Systems Co., Ltd.','Protech Systems Co., Ltd.5f, No. 34, Lane 80, Sec. 3Nankang RoadTaipeiTaiwan, Republic Of China',1),('00:90:06','Hamamatsu Photonics K.k.','Hamamatsu Photonics K.k.812 Joko-choHamamatsu  431-3196Japan',1),('00:90:07','Domex Technology Corp.','Domex Technology Corp.No. 2, Technology Rd. 1Science-based Industrial ParkHsinchuTaiwan, Republic Of China',1),('00:90:08','Hana Systems Inc.','Hana Systems Inc.Eaho B/d 740-1Yeok Sam-dong, Kangnam-kuSeoulKorea, Republic Of',1),('00:90:09','I Controls, Inc.','I Controls, Inc.12f Doosan Building, 105-7,Nonhyun-dong, Gangnam-guSeoul 135-714Korea, Republic Of',1),('00:90:0A','Proton Electronic Industrial Co., Ltd.','Proton Electronic Industrial Co., Ltd.',1),('00:90:0B','Lanner Electronics, Inc.','Lanner Electronics, Inc.8f-4, No. 77, Sec. 1Hsin Tai Wu Rd., HsichihTaipei HsienTaiwan, Republic Of China',1),('00:90:0C','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive - Sja-2San Jose Ca 95134-1706United States',1),('00:90:0D','Overland Storage Inc.','Overland Storage Inc.4820 Overland AvenueSan Diego Ca 92123United States',1),('00:90:0E','Handlink Technologies, Inc.','Handlink Technologies, Inc.5f, 24-2, Industry E. Road Iv,Science-based Industrial Park,Hsinchu 30077Taiwan, Republic Of China',1),('00:90:0F','Kawasaki Heavy Industries, Ltd','Kawasaki Heavy Industries, LtdElec. & Control Tech Center1-1 Kawasaki-cho Akashi 673-8666Japan',1),('00:90:10','Simulation Laboratories, Inc.','Simulation Laboratories, Inc.10078 Tyler Place #aIjamsville Md 21754United States',1),('00:90:11','Wavtrace, Inc.','Wavtrace, Inc.1555 132nd Ave. NeBellevue Wa 98005United States',1),('00:90:12','Globespan Semiconductor, Inc.','Globespan Semiconductor, Inc.100 Schulz DriveRed Bank Nj 07701United States',1),('00:90:13','Samsan Corp.','Samsan Corp.Electronics & Comm DivisionSamsan Bldg., 506-7, Amsa-dongKangdong-gu Seoul 134-050Korea, Republic Of',1),('00:90:14','Rotork Instruments, Ltd.','Rotork Instruments, Ltd.Chaul End LaneLuton BedfordshireLu4 8ez EnglandUnited Kingdom',1),('00:90:15','Centigram Communications Corp.','Centigram Communications Corp.91 East Tasman DriveSan Jose Ca 95134United States',1),('00:90:16','Zac','ZacTalstrasse 18D-71272 RenningenGermany',1),('00:90:17','Zypcom, Inc','Zypcom, Inc28400 Kohoutek WaySuite 170Union City Ca 94587-1212United States',1),('00:90:18','Ito Electric Industry Co, Ltd.','Ito Electric Industry Co, Ltd.4-26-12 Meieki Nakamura-kuNagoya-city Aichi 450-0002Japan',1),('00:90:19','Hermes Electronics Co., Ltd.','Hermes Electronics Co., Ltd.3-2-12 Yushima, Bunkyo-kuTokyo, 113-0034Japan',1),('00:90:1A','Unisphere Solutions','Unisphere Solutions5 Carlisle RoadWestford Ma 01886United States',1),('00:90:1B','Digital Controls','Digital Controls305 Pioneer Blvd.Springboro Oh 45066-1100United States',1),('00:90:1C','Mps Software Gmbh','Mps Software GmbhLudwigstr 3685551 KirchheimGermany',1),('00:90:1D','Pec (nz) Ltd.','Pec (nz) Ltd.2 Station RoadP.o. Box 308MartonNew Zealand',1),('00:90:1E','Selesta Ingegneria S.p.a.','Selesta Ingegneria S.p.a.Via Di Francia, 28Genova  16149Italy',1),('00:90:1F','Adtec Productions, Inc.','Adtec Productions, Inc.408 Russell StreetNashville Tn 37206United States',1),('00:90:20','Philips Analytical X-ray B.v.','Philips Analytical X-ray B.v.Lelyweg 17602 Ea AlmeloNetherlands',1),('00:90:21','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr. - Sja-2San Jose Ca 95134-1706United States',1),('00:90:22','Ivex','Ivex4295 International Blvd.SuiteNorcross Ga 30093United States',1),('00:90:23','Zilog Inc.','Zilog Inc.910 East Hamilton Ave.Campbell Ca 95008United States',1),('00:90:24','Pipelinks, Inc.','Pipelinks, Inc.2710 Walsh Ave., Ste #300Santa Clara Ca 95051United States',1),('00:90:25','Bae Systems Australia (electronic Systems) Pty Ltd','Bae Systems Australia (electronic Systems) Pty Ltd3 Second AveMawson Lakes South Australia 5095Australia',1),('00:90:26','Advanced Switching Communications, Inc.','Advanced Switching Communications, Inc.8330 Boone Boulevard--5th Fl.Vienna Va 22182United States',1),('00:90:27','Intel Corporation','Intel CorporationHf1-065200 N.e. Elam Young ParkwayHillsboro Or 97124United States',1),('00:90:28','Nippon Signal Co., Ltd.','Nippon Signal Co., Ltd.11 Hiraide-kogio-danchiUisunomiya Tochigi 321-8651Japan',1),('00:90:29','Crypto Ag','Crypto AgP.o. BoxCh-6301 ZugSwitzerland',1),('00:90:2A','Communication Devices, Inc.','Communication Devices, Inc.One Forstmann CourtClifton Nj 07011United States',1),('00:90:2B','Cisco Systems, Inc.','Cisco Systems, Inc.Sja-2170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:90:2C','Data & Control Equipment Ltd.','Data & Control Equipment Ltd.County Farm, Wendover Rd.Stoke MandevilleBucks. Hp22 StaUnited Kingdom',1),('00:90:2D','Data Electronics (aust.) Pty, Ltd.','Data Electronics (aust.) Pty, Ltd.7 Seismic CourtRowvilleVictoria 3178Australia',1),('00:90:2E','Namco Limited','Namco Limited1-1-32 Shin-urashima-choKanagawa-ku, YokohamaKanagawa 221-0031Japan',1),('00:90:2F','Netcore Systems, Inc.','Netcore Systems, Inc.187 Ballardvale StreetWilmington Ma 01887United States',1),('00:90:30','Honeywell-dating','Honeywell-datingVia Tintoretto, 1521012 Cassano Magnago (va)Italy',1),('00:90:31','Mysticom, Ltd.','Mysticom, Ltd.P.o. 8364Natania 42504Israel',1),('00:90:32','Pelcombe Group Ltd.','Pelcombe Group Ltd.Main RoadDovercourt, HarwichEssex C012 4lpUnited Kingdom',1),('00:90:33','Innovaphone Ag','Innovaphone AgBoeblinger Str. 76Sindelfingen  D71065Germany',1),('00:90:34','Imagic, Inc.','Imagic, Inc.235 West Road #7Portsmouth Nh 03801United States',1),('00:90:35','Alpha Telecom, Inc.','Alpha Telecom, Inc.2f, No.2, Li Hsin RoadScience-based Industrial ParkHsin-chuTaiwan, Republic Of China',1),('00:90:36','Ens, Inc.','Ens, Inc.P.o. Box 19207Raleigh Nc 27619United States',1),('00:90:37','Acucomm, Inc.','Acucomm, Inc.4633 Old Ironsides - Ste #310Santa Clara Ca 95054United States',1),('00:90:38','Fountain Technologies, Inc.','Fountain Technologies, Inc.50 Randolph RoadSomerset Nj 08873United States',1),('00:90:39','Shasta Networks','Shasta Networks249 Humboldt CourtSunnyvale Ca 94089-1300United States',1),('00:90:3A','Nihon Media Tool Inc.','Nihon Media Tool Inc.1875 Oyama-choYokkaichi-cityMie 512-1102Japan',1),('00:90:3B','Triems Research Lab, Inc.','Triems Research Lab, Inc.1275 N. Tustin AvenueAnaheim Ca 92807United States',1),('00:90:3C','Atlantic Network Systems','Atlantic Network SystemsImmeuble kennedyZiter Avenue Jf Kennedy33700 MerignacFrance',1),('00:90:3D','Biopac Systems, Inc.','Biopac Systems, Inc.42 Aero CaminoSanta Barbara Ca 93117United States',1),('00:90:3E','N.v. Philips Industrial Activities','N.v. Philips Industrial Activities',1),('00:90:3F','Aztec Radiomedia','Aztec Radiomedia31, Rue Du Chemindefer67200 StrasbourgFrance',1),('00:90:40','Siemens Network Convergence Llc','Siemens Network Convergence LlcTen Technology Park DriveWestford Ma 01886-3146United States',1),('00:90:41','Applied Digital Access','Applied Digital Access9855 Scranton RoadSan Diego Ca 92121United States',1),('00:90:42','Eccs, Inc.','Eccs, Inc.One Sheila DriveTinton Falls Nj 07724United States',1),('00:90:43','Nichibei Denshi Co., Ltd.','Nichibei Denshi Co., Ltd.1-13-10 Shirogane  Chuo-kuFukuoka-cityJapan',1),('00:90:44','Assured Digital, Inc.','Assured Digital, Inc.9-11 Goldsmith St.Littleton Ma 01460United States',1),('00:90:45','Marconi Communications','Marconi Communications1000 Fore DriveWarrendale Pa 15086-7502United States',1),('00:90:46','Dexdyne, Ltd.','Dexdyne, Ltd.15 Market Pl.CirencesterGlocestershire Gl7 2pbUnited Kingdom',1),('00:90:47','Giga Fast E. Ltd.','Giga Fast E. Ltd.14f, No.112, Sec. 1Hsin-tai Wu Rd.Hsi-chih Taipei HsienTaiwan, Republic Of China',1),('00:90:48','Zeal Corporation','Zeal Corporation301, HiraikeNagakute-cho, Aichi-pref. 480-1155Japan',1),('00:90:49','Entridia Corporation','Entridia Corporation101 Park Center PlazaSuite #500San Jose Ca 95113-2218United States',1),('00:90:4A','Concur System Technologies','Concur System Technologies2525 Wallingwood Dr.-ste. #804Austin Tx 78746United States',1),('00:90:4B','Gemtek Technology Co., Ltd.','Gemtek Technology Co., Ltd.No. 1 Jen Ai Road,Hsinchu Industrial Park,Hukou, Hsinchu, Taiwan 30352Taiwan, Republic Of China',1),('00:90:4C','Epigram, Inc.','Epigram, Inc.870 West Maude Ave.Sunnyvale Ca 94086United States',1),('00:90:4D','Spec S.a.','Spec S.a.Casp 172 3-b08013 BarcelonaSpain',1),('00:90:4E','Delem Bv','Delem BvLuchthaven Weg 425657 Eb EindhovenNetherlands',1),('00:90:4F','Abb Power T&d Company, Inc.','Abb Power T&d Company, Inc.7036 Snowdrift RoadAllentown Pa 18106United States',1),('00:90:50','Teleste Oy','Teleste OySeponkatu 1Littoinen  Fin-20660Finland',1),('00:90:51','Ultimate Technology Corp.','Ultimate Technology Corp.100 Rawson RoadVictor Ny 14564United States',1),('00:90:52','Selcom Elettronica S.r.l.','Selcom Elettronica S.r.l.Via Grandi, 540013 Castelmaggiore BoItaly',1),('00:90:53','Daewoo Electronics Co., Ltd.','Daewoo Electronics Co., Ltd.Dit Research CenterDaewoo Center 541 Namdaemunno 5-gaChung-gu Seoul 100-714Korea, Republic Of',1),('00:90:54','Innovative Semiconductors, Inc','Innovative Semiconductors, Inc2570 W. El Camino RealSuite #205Mountain View Ca 94040United States',1),('00:90:55','Parker Hannifin Corporation Compumotor Division','Parker Hannifin Corporation Compumotor Division5500 Business Park DriveRohnert Park Ca 94928United States',1),('00:90:56','Telestream, Inc.','Telestream, Inc.848 Gold Flat Rd., Suite 1Nevada City Ca 95959United States',1),('00:90:57','Aanetcom, Inc.','Aanetcom, Inc.4949 Liberty Lane - Ste. #200Allentown Pa 18106-9015United States',1),('00:90:58','Ultra Electronics Ltd., Command And Control Systems','Ultra Electronics Ltd., Command And Control SystemsKnaves Beech Business CentreLoudwater, High WycombeBuckinghamshire Hp10 9ut EnglandUnited Kingdom',1),('00:90:59','Telecom Device K.k.','Telecom Device K.k.Sanmiyanaga Bldg. 3f, 1-5-12Motoakasaka, Minato-kuTokyo 107Japan',1),('00:90:5A','Dearborn Group, Inc.','Dearborn Group, Inc.27007 Hills Tech Ct.Farmington Hills Mi 48331United States',1),('00:90:5B','Raymond And Lae Engineering','Raymond And Lae Engineering208 Commerce Dr.,  Unit #3cFort Collins Co 80524United States',1),('00:90:5C','Edmi','Edmi626 Old Gympie RoadNarangba Qld 4504Australia',1),('00:90:5D','Netcom Sicherheitstechnik Gmbh','Netcom Sicherheitstechnik GmbhBoppstrasse 3855118 MainzGermany',1),('00:90:5E','Rauland-borg Corporation','Rauland-borg Corporation3450 W. Oakton St.Skokie Il 60076United States',1),('00:90:5F','Cisco Systems, Inc.','Cisco Systems, Inc.Sja-2170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:90:60','System Create Corp.','System Create Corp.3-13-6 Yoshikawa Bld.Kimshi Sumida-kuTokyoJapan',1),('00:90:61','Pacific Research & Engineering Corporation','Pacific Research & Engineering Corporation2070 Las Palmas DriveCarlsbad Ca 92009United States',1),('00:90:62','Icp Vortex Computersysteme Gmbh','Icp Vortex Computersysteme GmbhFalterstrasse 51-53D 74223 FleinGermany',1),('00:90:63','Coherent Communications Systems Corporation','Coherent Communications Systems Corporation45085 University DriveAshburn Va 20147United States',1),('00:90:64','Thomson Inc.','Thomson Inc.101 West 103rd StreetIndianapolis In 46290-1102United States',1),('00:90:65','Finisar Corporation','Finisar Corporation1389 Moffett Park DrSunnyvale Ca 94089United States',1),('00:90:66','Troika Networks, Inc.','Troika Networks, Inc.2829 Townsgate Road,Suite 200Westlake Village Ca 91361United States',1),('00:90:67','Walkabout Computers, Inc.','Walkabout Computers, Inc.2655 N. Ocean Drive--ste. #510Singer Island Fl 33404United States',1),('00:90:68','Dvt Corp.','Dvt Corp.1670 Oakbrook Dr. - Ste. #330Norcross Ga 30093United States',1),('00:90:69','Juniper Networks, Inc.','Juniper Networks, Inc.1194 N. Mathilda AvenueSunnyvale Ca 94089-1206United States',1),('00:90:6A','Turnstone Systems, Inc.','Turnstone Systems, Inc.274 Ferguson DriveMountain View Ca 94043United States',1),('00:90:6B','Applied Resources, Inc.','Applied Resources, Inc.9821 Widmer RoadLenexa Ks 66215-1239United States',1),('00:90:6C','Sartorius Hamburg Gmbh','Sartorius Hamburg GmbhMeiendorferstr. 205Hamburg  D-22145Germany',1),('00:90:6D','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr. -  Sja-2San Jose Ca 95134-1706United States',1),('00:90:6E','Praxon, Inc.','Praxon, Inc.1700 Dell AvenueCampbell Ca 95008United States',1),('00:90:6F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr. - Sja-2San Jose Ca 95134-1706United States',1),('00:90:70','Neo Networks, Inc.','Neo Networks, Inc.10300 Bren Road EastMinnetonka Mn 55343United States',1),('00:90:71','Applied Innovation Inc.','Applied Innovation Inc.5800 Innovation DriveDublin Oh 43016-3271United States',1),('00:90:72','Simrad As','Simrad AsP.o. Box 1113191 HortenNorway',1),('00:90:73','Gaio Technology','Gaio TechnologyOak-yokohama Bldg.2-15-10 Kita-saiwai,Nishi-ku Yokohama-city KanagawaJapan',1),('00:90:74','Argon Networks, Inc.','Argon Networks, Inc.25 Porter RoadLittleton Ma 01460United States',1),('00:90:75','Nec Do Brasil S.a.','Nec Do Brasil S.a.Rodovia Presidente Dutra, Km 218Cumbica-guarulhosSao Paulo-sp Cep - 07210-902Brazil',1),('00:90:76','Fmt Aircraft Gate Support Systems Ab','Fmt Aircraft Gate Support Systems Ab',1),('00:90:77','Advanced Fibre Communications','Advanced Fibre CommunicationsPo Box #7512391 Willowbrook CtPetaluma Ca 94975United States',1),('00:90:78','Mer Telemanagement Solutions, Ltd.','Mer Telemanagement Solutions, Ltd.5 Hatsoref Str.Ind. AreaHolonIsrael',1),('00:90:79','Clearone, Inc.','Clearone, Inc.299 Washington StreetWoburn Ma 01801United States',1),('00:90:7A','Polycom, Inc.','Polycom, Inc.5755 Central AvenueBoulder Co 80301United States',1),('00:90:7B','E-tech, Inc.','E-tech, Inc.30, R&d Road 2Science ParkHsinchuTaiwan, Republic Of China',1),('00:90:7C','Digitalcast, Inc.','Digitalcast, Inc.503, Ilkwang Bldg., 1656-2Seocho-dongSeocho-ku  SeoulKorea, Republic Of',1),('00:90:7D','Lake Communications','Lake CommunicationsBeech House, Greenhills RoadDublin 24Ireland',1),('00:90:7E','Vetronix Corp.','Vetronix Corp.2030 Alamede Padre SerraSanta Barbara Ca 93103United States',1),('00:90:7F','Watchguard Technologies, Inc.','Watchguard Technologies, Inc.505 Fifth Ave SouthSuite 500Seattle Wa 98104United States',1),('00:90:80','Not Limited, Inc.','Not Limited, Inc.500 Allerton Street, Ste #102Redwood City Ca 94063United States',1),('00:90:81','Aloha Networks, Inc.','Aloha Networks, Inc.1001a Oreilly AvenueP.o. Box 29472San Francisco Ca 94129-0472United States',1),('00:90:82','Force Institute','Force InstitutePark Alle 345Dk-2605 BroendbyDenmark',1),('00:90:83','Turbo Communication, Inc.','Turbo Communication, Inc.4f-2, No. 171, Sung-teh RoadTaipeiTaiwan, Republic Of China',1),('00:90:84','Atech System','Atech System4f Daeboong Bldg. 1451-78Seocho-dong Seocho-kuSeoul  137-070Korea, Republic Of',1),('00:90:85','Golden Enterprises, Inc.','Golden Enterprises, Inc.4450 West Eau Gallie Blvd.250 Perimeter CenterMelbourne Fl 32934United States',1),('00:90:86','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr. - Sja-2San Jose Ca 95134-1706United States',1),('00:90:87','Itis','ItisCentre Espace PerformanceAlphasis-batiment C135769 Saint-gregoire CedexFrance',1),('00:90:88','Baxall Security Ltd.','Baxall Security Ltd.Unit 1 CastlehillHorsefield Way, Bredbury Park Ind. EstatStockport Great Britain Sk6 2svUnited Kingdom',1),('00:90:89','Softcom Microsystems, Inc.','Softcom Microsystems, Inc.47509 Seabridge DriveFremont Ca 94538United States',1),('00:90:8A','Bayly Communications, Inc.','Bayly Communications, Inc.105 Green CourtAjax Ontario  L1s 6w9Canada',1),('00:90:8B','Pfu Systems, Inc.','Pfu Systems, Inc.2600 Fernbrook LaneSuite 130Plymouth Mn 55447United States',1),('00:90:8C','Etrend Electronics, Inc.','Etrend Electronics, Inc.2f, 22 Industry E. 9th RoadHsinchu Science ParkTaiwan, Republic Of China',1),('00:90:8D','Vickers Electronics Systems','Vickers Electronics Systems1151 W. Mason-morrow Rd.Lebanon Oh 45036United States',1),('00:90:8E','Nortel Networks Broadband Access','Nortel Networks Broadband Access39660 Eureka DriveNewark Ca 94560United States',1),('00:90:8F','Audio Codes Ltd.','Audio Codes Ltd.3a Netanyahu StreetOr Yehuda 60256Israel',1),('00:90:90','I-bus','I-bus9174 Sky Park CourtSan Diego Ca 92123United States',1),('00:90:91','Digitalscape, Inc.','Digitalscape, Inc.6 Morgan  - Ste.#100Irvine Ca 92618United States',1),('00:90:92','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s Sja-2San Jose Ca 95134-1706United States',1),('00:90:93','Nanao Corporation','Nanao Corporation153 Shimokashiwano, MattoIshikawa 924-8566Japan',1),('00:90:94','Osprey Technologies, Inc.','Osprey Technologies, Inc.600 Airport Blvd. - Ste. #900Morrisville Nc 27560United States',1),('00:90:95','Universal Avionics','Universal Avionics11351 Willows Road NeRedmond Wa 98052-2552United States',1),('00:90:96','Askey Computer Corp.','Askey Computer Corp.2f, No. 2, Lane 497Chung-cheng Rd., Hsin-tienTaipei  23136Taiwan, Republic Of China',1),('00:90:97','Sycamore Networks','Sycamore Networks220 Mill RdChelmsford Ma 01824United States',1),('00:90:98','Sbc Designs, Inc.','Sbc Designs, Inc.3077-h Leeman Ferry RoadHuntsville Al 35801United States',1),('00:90:99','Allied Telesis, K.k.','Allied Telesis, K.k.No. 2  Toc Building, 7-21-11nishi-gotandShinagawa-ku Tokyo 141Japan',1),('00:90:9A','One World Systems, Inc.','One World Systems, Inc.1144 East Arques AvenueSunnyvale Ca 94086United States',1),('00:90:9B','Imaje','ImajeGtaverksgatan 6aGothenburg  417 55Sweden',1),('00:90:9C','Motorola, Inc.','Motorola, Inc.2450 Walsh AveSanta Clara Ca 95051United States',1),('00:90:9D','Novatech Process Solutions, Llc','Novatech Process Solutions, Llc11500 Cronridge DriveSuite 110Owings Mills Md 21117United States',1),('00:90:9E','Critical Io, Llc','Critical Io, Llc485 E. 17th StreetSuite 2010Costa Mesa Ca 92627United States',1),('00:90:9F','Digi-data Corporation','Digi-data Corporation8920-d Route 108Columbia Md 21045United States',1),('00:90:A0','8x8 Inc.','8x8 Inc.2445 Mission College Blvd.Santa Clara Ca 95054United States',1),('00:90:A1','Flying Pig Systems/high End Systems Inc.','Flying Pig Systems/high End Systems Inc.2105 Gracy Farms LaneAustin Tx 78758United States',1),('00:90:A2','Cybertan Technology, Inc.','Cybertan Technology, Inc.Bldg.53, 195-56 Sec. 4,Chung Hsing Road,Chutung HsinchuTaiwan, Republic Of China',1),('00:90:A3','Corecess Inc.','Corecess Inc.135-726, Keopyung B-town 1f, 203, NonhyuKangnam-gu,SeoulKorea, Republic Of',1),('00:90:A4','Altiga Networks','Altiga Networks124 Grove StreetFranklin Ma 02038-3206United States',1),('00:90:A5','Spectra Logic','Spectra Logic1700 N. 55th StreetBoulder Co 80301United States',1),('00:90:A6','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr. - Sja-2San Jose Ca 95134-1706United States',1),('00:90:A7','Clientec Corporation','Clientec Corporation8175 S. Virginia St.Suite #850-249Reno Nv 89511United States',1),('00:90:A8','Ninetiles Networks, Ltd.','Ninetiles Networks, Ltd.9 Station RoadWaterbeach Cambridge Cb5 9htUnited Kingdom',1),('00:90:A9','Western Digital','Western Digital1599 North BroadwayRochester Mn 55906United States',1),('00:90:AA','Indigo Active Vision Systems Limited','Indigo Active Vision Systems LimitedThe Edinburgh TechnopoleBash LoanEdinburgh Eh26 OpjUnited Kingdom',1),('00:90:AB','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive   Sja-2San Jose Ca 95134-1706United States',1),('00:90:AC','Optivision, Inc.','Optivision, Inc.3450 Hillview AvenuePalo Alto Ca 94304United States',1),('00:90:AD','Aspect Electronics, Inc.','Aspect Electronics, Inc.12740 Earhart Ave.Auburn Ca 95602United States',1),('00:90:AE','Italtel S.p.a.','Italtel S.p.a.Localita Boschetto67100 LaquilaItaly',1),('00:90:AF','J. Morita Mfg. Corp.','J. Morita Mfg. Corp.680 Higashihama Minami-choFushimi-ku, Kyoto 612-8213Japan',1),('00:90:B0','Vadem','Vadem1960 Zanker RdSan Jose Ca 95112United States',1),('00:90:B1','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Dr. - Sja-2San Jose Ca 95134-1706United States',1),('00:90:B2','Avici Systems Inc.','Avici Systems Inc.12 Elizabeth DriveChelmsford Ma 01824United States',1),('00:90:B3','Agranat Systems','Agranat Systems1345 Main StreetWaltham Ma 02154United States',1),('00:90:B4','Willowbrook Technologies','Willowbrook Technologies7120 Hayvenhurst Ave.-ste.#401Van Nuys Ca 91406United States',1),('00:90:B5','Nikon Corporation','Nikon CorporationElectronic Imaging Division, Designing D1-6-3, Nishi-ohi, Shinagawa-kuTokyo 140-8601Japan',1),('00:90:B6','Fibex Systems','Fibex Systems5350 Old Redwood HighwayPetaluma Ca 94954United States',1),('00:90:B7','Digital Lightwave, Inc.','Digital Lightwave, Inc.601 Cleveland Street- 5th Fl.Clearwater Fl 33755United States',1),('00:90:B8','Rohde & Schwarz Gmbh & Co. Kg','Rohde & Schwarz Gmbh & Co. KgPostfach: 80 14 69/abt.: 3ckD-81614 MunchenGermany',1),('00:90:B9','Beran Instruments Ltd.','Beran Instruments Ltd.Hatchmoor Industrial EstateTorringtonN Devon Ex38 7hpUnited Kingdom',1),('00:90:BA','Valid Networks, Inc.','Valid Networks, Inc.6 Cromwell #102Irvine Ca 92618United States',1),('00:90:BB','Tainet Communication System Corp.','Tainet Communication System Corp.3 Fl, No. 6, Alley 23, Lane 91 Sec. 1Nei-hu RoadTaipeiTaiwan, Republic Of China',1),('00:90:BC','Telemann Co., Ltd.','Telemann Co., Ltd.6f Dongsin Bldg.543, Dogok-dong, Kangnam-kuSeoul, 135-270Korea, Republic Of',1),('00:90:BD','Omnia Communications, Inc.','Omnia Communications, Inc.100 Nickerson RoadMarlborough Ma 01752United States',1),('00:90:BE','Ibc/integrated Business Computers','Ibc/integrated Business Computers2685 C Park Center DriveSimi Valley Ca 93065United States',1),('00:90:BF','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive   Sja-2San Jose Ca 95134-1706United States',1),('00:90:C0','K.j. Law Engineers, Inc.','K.j. Law Engineers, Inc.42300 W. Nine Mile RoadNovi Mi 48375United States',1),('00:90:C1','Peco Ii, Inc.','Peco Ii, Inc.7060 Huntley RoadColumbus Oh 43229United States',1),('00:90:C2','Jk Microsystems, Inc.','Jk Microsystems, Inc.1275 Yuba AvenueSan Pablo Ca 94806United States',1),('00:90:C3','Topic Semiconductor Corp.','Topic Semiconductor Corp.11f-1, No. 2, Wu-lin Rd.Hsin-chuTaiwan, Republic Of China',1),('00:90:C4','Javelin Systems, Inc.','Javelin Systems, Inc.1881 Langley Ave.Irvine Ca 92614United States',1),('00:90:C5','Internet Magic, Inc.','Internet Magic, Inc.6450 Lusk Blvd.-ste. #e-201San Diego Ca 92121United States',1),('00:90:C6','Optim Systems, Inc.','Optim Systems, Inc.8201 Greensboro Dr.-ste. #1000Mclean Va 22102United States',1),('00:90:C7','Icom Inc.','Icom Inc.6-9-16 KamihigashiHirano-ku, OsakaJapan',1),('00:90:C8','Waverider Communications (canada) Inc.','Waverider Communications (canada) Inc.',1),('00:90:C9','Dpac Technologies','Dpac Technologies7321 Lincoln WayGarden Grove Ca 92841United States',1),('00:90:CA','Accord Video Telecommunications, Ltd.','Accord Video Telecommunications, Ltd.10, Martin Gehl Str, Po Box 3564Petach-tikva 49130Israel',1),('00:90:CB','Wireless Online, Inc.','Wireless Online, Inc.4410 El Camino Real,  Ste #101Los Altos Ca 94022United States',1),('00:90:CC','Planex Communications','Planex Communications2f Fenissay Ebisu Bldg3-16-3 Higashi,Shibuya-ku, Tokyo 150-0011Japan',1),('00:90:CD','Ent-empresa Nacional De Telecommunicacoes, S.a.','Ent-empresa Nacional De Telecommunicacoes, S.a.R. Eng Frederico Ulrich -  Apartado 3081Guardeiras - 4470 Moreira MaiaPortugal',1),('00:90:CE','Tetra Gmbh','Tetra GmbhGewerbepark amwald 4D-98693 IlmenauGermany',1),('00:90:CF','Nortel','Nortel250 Sidney StreetBelleville Ontario K8n 5b7Canada',1),('00:90:D0','Thomson Telecom Belgium','Thomson Telecom BelgiumPrins Boudewijnlaan 47B-2650 EdegemBelgium',1),('00:90:D1','Leichu Enterprise Co., Ltd.','Leichu Enterprise Co., Ltd.8f, No. 203, Pa-teh Road, Sec.2Taipei CityTaiwanTaiwan, Republic Of China',1),('00:90:D2','Artel Video Systems','Artel Video Systems237 Cedar Hill St.Marlboro Ma 01752United States',1),('00:90:D3','Giesecke & Devrient Gmbh','Giesecke & Devrient GmbhPrinzregentenstrasse 159D-81677  MunchenGermany',1),('00:90:D4','Bindview Development Corp.','Bindview Development Corp.3355 West Alabama #1200Houston Tx 77098United States',1),('00:90:D5','Euphonix, Inc.','Euphonix, Inc.220 Portage Ave.Palo Alto Ca 94306United States',1),('00:90:D6','Crystal Group','Crystal Group850 Kacena Rd.Hiawatha Ia 52233United States',1),('00:90:D7','Netboost Corp.','Netboost Corp.390 Cambridge AvenuePalo Alto Ca 94306-1506United States',1),('00:90:D8','Whitecross Systems','Whitecross Systems3a Waterside Park, Cookham RdBracknellBerkshire Rg12 1rbUnited Kingdom',1),('00:90:D9','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveM/s/ Sja-2San Jose Ca 95134-1706United States',1),('00:90:DA','Dynarc, Inc.','Dynarc, Inc.1887 Landings DriveMountain View Ca 94043United States',1),('00:90:DB','Next Level Communications','Next Level Communications6085 State Farm DriveRohnert Park Ca 94928United States',1),('00:90:DC','Teco Information Systems','Teco Information SystemsCo., Ltd.2841 Junction Ave., Ste. #116San Jose Ca 95134United States',1),('00:90:DD','The Miharu Communications Co., Ltd.','The Miharu Communications Co., Ltd.',1),('00:90:DE','Cardkey Systems, Inc.','Cardkey Systems, Inc.1757 Tapo Canyon RoadSimi Valley Ca 93063United States',1),('00:90:DF','Mitsubishi Chemical America, Inc.','Mitsubishi Chemical America, Inc.445 Indio WaySunnyvale Ca 94086United States',1),('00:90:E0','Systran Corp.','Systran Corp.4126 Linden AvenueDayton Oh 45432United States',1),('00:90:E1','Telena S.p.a.','Telena S.p.a.Via Savona, 14620144 MilanoItaly',1),('00:90:E2','Distributed Processing Technology','Distributed Processing Technology140 Candace DriveOrlando Fl 32751United States',1),('00:90:E3','Avex Electronics Inc.','Avex Electronics Inc.4807 Bradford DriveHuntsville Al 35805United States',1),('00:90:E4','Nec America, Inc.','Nec America, Inc.3100 N.e. Shute RoadHillsboro Or 97124United States',1),('00:90:E5','Teknema, Inc.','Teknema, Inc.2656 E. Bayshore RoadPalo Alto Ca 94303United States',1),('00:90:E6','Ali Corporation','Ali Corporation6f, 246 Neihu Road, Sec. 1Taipei  114Taiwan, Republic Of China',1),('00:90:E7','Horsch Elektronik Ag','Horsch Elektronik AgHaagerstrassePostfachCh-9473 GamsSwitzerland',1),('00:90:E8','Moxa Technologies Corp., Ltd.','Moxa Technologies Corp., Ltd.7f, No. 2, Aly6, Ln 235Pao-chiao Rd,Shieng-tien City TaipeiTaiwan, Republic Of China',1),('00:90:E9','Janz Computer Ag','Janz Computer AgIm Drener Feld 8D-33100 PaderbornGermany',1),('00:90:EA','Alpha Technologies, Inc.','Alpha Technologies, Inc.3767 Alpha WayBellingham Wa 98226United States',1),('00:90:EB','Sentry Telecom Systems','Sentry Telecom Systems8664 Commerce CourtBurnaby Bc V5a 4n7Canada',1),('00:90:EC','Pyrescom','Pyrescom3 Allee Du Moulin66680 CanohesFrance',1),('00:90:ED','Central System Research Co., Ltd.','Central System Research Co., Ltd.4-13-2 HiyoshichoKokubunji-city Tokyo 18500032Japan',1),('00:90:EE','Personal Communications Technologies','Personal Communications Technologies50 Stiles RoadSalem Nh 03079United States',1),('00:90:EF','Integrix, Inc.','Integrix, Inc.2001 Corporate Center DriveNewbury Park Ca 91320United States',1),('00:90:F0','Harmonic Video Systems Ltd.','Harmonic Video Systems Ltd.19 Alon Hatavor StreetZone 3, Po Box 3600Caesarea  Industrial Park  38900Israel',1),('00:90:F1','Dot Hill Systems Corporation','Dot Hill Systems Corporation6305 El Camino RealCarlsbad Ca 92009United States',1),('00:90:F2','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman Drive - Sja-2San Jose Ca 95134-1706United States',1),('00:90:F3','Aspect Communications','Aspect Communications1310 Ridder Park DriveSan Jose Ca 95131-2313United States',1),('00:90:F4','Lightning Instrumentation','Lightning InstrumentationBoveresses 501010 LausanneSwitzerland',1),('00:90:F5','Clevo Co.','Clevo Co.35, Wu-gon 6th RoadWu-ku Industrial ParkTaipei HsienTaiwan, Republic Of China',1),('00:90:F6','Escalate Networks, Inc.','Escalate Networks, Inc.6 HughesIrvine Ca 92617United States',1),('00:90:F7','Nbase Communications Ltd.','Nbase Communications Ltd.Industrial ParkYoqneam Ilit P.o. Box 114Israel',1),('00:90:F8','Mediatrix Telecom','Mediatrix Telecom4229 GarlockSherbrookeQuebec J1l 2c8Canada',1),('00:90:F9','Leitch','Leitch10 Dyas RoadDon MillsOntario M3b 1v5Canada',1),('00:90:FA','Emulex Corp','Emulex Corp3333 Susan StreetCosta Mesa Ca 92626United States',1),('00:90:FB','Portwell, Inc.','Portwell, Inc.7f-4, No. 160, Sec. 6Ming-chuang E. Rd.TaipeiTaiwan, Republic Of China',1),('00:90:FC','Network Computing Devices','Network Computing Devices301 Ravendale DriveMountain View Ca 94043United States',1),('00:90:FD','Coppercom, Inc.','Coppercom, Inc.3255-1 Scott Blvd.,--ste.#103Santa Clara Ca 95054United States',1),('00:90:FE','Elecom Co., Ltd.  (laneed Div.)','Elecom Co., Ltd.  (laneed Div.)Sumitomo FudosanHigashi Ikebukuro Bldg. 6f, 3-13-2 HigasToshima-ku Tokyo 170-0013Japan',1),('00:90:FF','Tellus Technology Inc.','Tellus Technology Inc.40990 Encyclopedia Cir.Fremont Ca 94538-2470United States',1),('00:91:D6','Crystal Group, Inc.','Crystal Group, Inc.850 Kacena Rd.Hiawatha Ia 52233United States',1),('00:9D:8E','Cardiac Recorders, Inc.','Cardiac Recorders, Inc.34 Scarboro RoadLondon  N4 4l UUnited KingdomUnited Kingdom',1),('00:A0:00','Centillion Networks, Inc.','Centillion Networks, Inc.359 Ravendale DriveMountain View Ca 94043United States',1),('00:A0:01','Drs Signal Solutions','Drs Signal Solutions700 Quince Orchard RoadGaithersburg Md 20878-1794United States',1),('00:A0:02','Leeds & Northrup Australia Pty Ltd','Leeds & Northrup Australia Pty LtdPo Box 4009Eight Mile Plains  Qld 4113Australia',1),('00:A0:03','Staefa Control System','Staefa Control SystemLaubisrueti 508712 StaefaSwitzerland',1),('00:A0:04','Netpower, Inc.','Netpower, Inc.545 Oakmead ParkwaySunnyvale Ca 94086United States',1),('00:A0:05','Daniel Instruments, Ltd.','Daniel Instruments, Ltd.Trollstrasse 33Ch-8400 WinterthurSwitzerland',1),('00:A0:06','Image Data Processing System Group','Image Data Processing System GroupShintoyofuta 2-1Kashiwa-city, Chiba 277Japan',1),('00:A0:07','Apexx Technology, Inc.','Apexx Technology, Inc.506 S. 11thPo Box 9291Boise Id 83707United States',1),('00:A0:08','Netcorp','Netcorp8 Place Of Commerce--ste #200Brossard, QuebecCanada J4w 3h2Canada',1),('00:A0:09','Whitetree Network','Whitetree NetworkTechnologies, Inc.3200 Ash StreetPalo Alto Ca 94306United States',1),('00:A0:0A','Airspan','AirspanUnitronics Building, Arava Street, Airport CityPob 19970100Israel',1),('00:A0:0B','Computex Co., Ltd.','Computex Co., Ltd.432-13 Gojyobashi-higashi 4-chyomeHigashiyamaku, Kyoto-city 605Japan',1),('00:A0:0C','Kingmax Technology, Inc.','Kingmax Technology, Inc.2fl., No. 4, Lane 902, Sec.2Kuang Fu Rd., Hsin-chu CityTaiwan, Republic Of China',1),('00:A0:0D','The Panda Project','The Panda Project5201 Congress Ave. - C-100Boca Raton Fl 33487United States',1),('00:A0:0E','Visual Networks, Inc.','Visual Networks, Inc.2092 Gaither Road- Ste #220Rockville Md 20850United States',1),('00:A0:0F','Broadband Technologies','Broadband TechnologiesP.o. Box 13737Research Triangle Park, Nc 27709-3737United States',1),('00:A0:10','Syslogic Datentechnik Ag','Syslogic Datentechnik AgBruggerstrasse 69Ch-5400 BadenSwitzerland',1),('00:A0:11','Mutoh Industries Ltd.','Mutoh Industries Ltd.253 Kanagawa-ken,Chigasaki-shi Shimomachiya 1-3-1JapanJapan',1),('00:A0:12','B.a.t.m. Advanced Technologies','B.a.t.m. Advanced TechnologiesP.o. Box 203Yokneam Elit  20692Israel',1),('00:A0:13','Teltrend Ltd.','Teltrend Ltd.Ringway House, Bell RoadDaneshill,Basingstoke Hampshire Rg24 8fUnited Kingdom',1),('00:A0:14','Csir','CsirP.o. Box 395Pretoria 0001South AfricaSouth Africa',1),('00:A0:15','Wyle','Wyle3000 Bowers AvenueSanta Clara Ca 95051United States',1),('00:A0:16','Micropolis Corp.','Micropolis Corp.21211 Nordhoff StreetChatsworth Ca 91311United States',1),('00:A0:17','J B M Corporation','J B M Corporation10-1, Aramotoshin MachiHigashi Osaka577Japan',1),('00:A0:18','Creative Controllers, Inc.','Creative Controllers, Inc.128 Kendrick LanePicayune Ms 39466United States',1),('00:A0:19','Nebula Consultants, Inc.','Nebula Consultants, Inc.1449 Duncan DriveDelta, Bc V4l 1r5Canada',1),('00:A0:1A','Binar Elektronik Ab','Binar Elektronik AbMagnetuagen 18S-46138 TrollhattanSwedenSweden',1),('00:A0:1B','Premisys Communications, Inc.','Premisys Communications, Inc.48664 Milmont DriveFremont Ca 94538United States',1),('00:A0:1C','Nascent Networks Corporation','Nascent Networks Corporation277 Main Street,  3rd Flr.Marlboro Ma 01752United States',1),('00:A0:1D','Sixnet','SixnetP.o. Box 767Clifton Park Ny 12065United States',1),('00:A0:1E','Est Corporation','Est Corporation120 Royall StreetCanton Ma 02021United States',1),('00:A0:1F','Tricord Systems, Inc.','Tricord Systems, Inc.2800 Northwest BoulevardPlymouth Mn 55441-2625United States',1),('00:A0:20','Citicorp/tti','Citicorp/tti3100 Ocean Park Blvd.Santa Monica Ca 90405United States',1),('00:A0:21','General Dynamics','General DynamicsCommunication Systems77a StreetNeedham Heights Ma 02494-2892United States',1),('00:A0:22','Centre For Development Of Advanced Computing','Centre For Development Of Advanced ComputingUniversity Of Poona CampusGanesh Khind, Pune - 411 008India',1),('00:A0:23','Applied Creative Technology, Inc.','Applied Creative Technology, Inc.2626 Lombardy Lane--ste.#107Dallas Tx 75220United States',1),('00:A0:24','3com Corporation','3com Corporation5400 Bayfront PlazaSanta Clara Ca 95052United States',1),('00:A0:25','Redcom Labs Inc.','Redcom Labs Inc.One Redcom CenterVictor Ny 14564-0995United States',1),('00:A0:26','Teldat, S.a.','Teldat, S.a.Parque Tecnologico Madrid28760 Tacs Can Tos (madrid)Spain',1),('00:A0:27','Firepower Systems, Inc.','Firepower Systems, Inc.190 Independence DriveMenlo Park Ca 94025United States',1),('00:A0:28','Conner Peripherals','Conner Peripherals3061 Zanker RoadSan Jose Ca 95134-2128United States',1),('00:A0:29','Coulter Corporation','Coulter Corporation11800 S.w. 147th Ave.Miami Fl 33196United States',1),('00:A0:2A','Trancell Systems','Trancell Systems3180 De La Cruz Blvd.-ste#200Santa Clara Ca 95054-2402United States',1),('00:A0:2B','Transitions Research Corp.','Transitions Research Corp.Shelter Rock LaneDanbury Ct 06810United States',1),('00:A0:2C','Interwave Communications','Interwave Communications656 Bair Island Blvd.-ste.#108Redwood City Ca 94063-2704United States',1),('00:A0:2D','1394 Trade Association','1394 Trade Association3925 West Braker LaneAustin Tx 78759United States',1),('00:A0:2E','Brand Communications, Ltd.','Brand Communications, Ltd.Enterprise House, Chivers Way,Histon, Cambridge Cb4 4zrUnited Kingdom',1),('00:A0:2F','Pirelli Cavi','Pirelli CaviViale Sarca 22220126 MilanItaly',1),('00:A0:30','Captor Nv/sa','Captor Nv/saDe Hene 13B-1780 WemmelBelgium',1),('00:A0:31','Hazeltine Corporation, Ms 1-17','Hazeltine Corporation, Ms 1-17450 E. Pulaski RoadGreenlawn Ny 11740United States',1),('00:A0:32','Ges Singapore Pte. Ltd.','Ges Singapore Pte. Ltd.14 Sungei Kadut AvenueSingapore 2572Singapore',1),('00:A0:33','Imc Mebsysteme Gmbh','Imc Mebsysteme GmbhVoltastrasse 5D-13355 BerlinGermany',1),('00:A0:34','Axel','Axel16, Avenue Du QuebecZ.a. Courtaboeuf 91962 Les UlisFrance',1),('00:A0:35','Cylink Corporation','Cylink Corporation3131 Jay StreetSanta Clara Ca 95054United States',1),('00:A0:36','Applied Network Technology','Applied Network Technology319 Littleton Road--ste #101Westford Ma 01886-4133United States',1),('00:A0:37','Datascope Corporation','Datascope Corporation800 Macarthur Blvd.Mahwah Nj 07430-0619United States',1),('00:A0:38','Email Electronics','Email ElectronicsP.o. Box 154Mooroolbark, 3138Australia',1),('00:A0:39','Ross Technology, Inc.','Ross Technology, Inc.5316 Hwy 290 West - Ste. #500Austin Tx 78735United States',1),('00:A0:3A','Kubotek Corporation','Kubotek Corporation56 Nishiaketa-cho, HigashikujoMinami-ku, Kyoto 601Japan',1),('00:A0:3B','Toshin Electric Co., Ltd.','Toshin Electric Co., Ltd.3fl. River-stone 3rd. Blg.234Mizonokuchi, Takatsu-kv, Kawasaki-shi,213 JapanJapan',1),('00:A0:3C','Eg&g Nuclear Instruments','Eg&g Nuclear Instruments100 Midland RoadOak Ridge Tn 37830United States',1),('00:A0:3D','Opto-22','Opto-2243044 Business Park Dr.Temecula Ca 92590United States',1),('00:A0:3E','Atm Forum','Atm ForumWorldwide Headquarters303 Vintage Park DriveFoster City Ca 94404-1138United States',1),('00:A0:3F','Computer Society Microprocessor & Microprocessor Standards C','Computer Society Microprocessor & Microprocessor Standards C% Apple Computer, Inc.1 Infinite Loop,Cupertino Ca 95014United States',1),('00:A0:40','Apple Computer','Apple Computer20650 Valley Green DriveCupertino Ca 95014United States',1),('00:A0:41','Inficon','Inficon2 Technology PlaceE. Syracuse Ny 13057United States',1),('00:A0:42','Spur Products Corp.','Spur Products Corp.9288 W. Emerald StreetBoise Id 83704United States',1),('00:A0:43','American Technology Labs, Inc.','American Technology Labs, Inc.115 West 3rd StreetLower LevelStevensville Mt 59870United States',1),('00:A0:44','Ntt It Co., Ltd.','Ntt It Co., Ltd.',1),('00:A0:45','Phoenix Contact Gmbh & Co.','Phoenix Contact Gmbh & Co.Postfach 1341D-32819 BlombergGermanyGermany',1),('00:A0:46','Scitex Corp. Ltd.','Scitex Corp. Ltd.P.o.box 330Herzlia B 46103Israel',1),('00:A0:47','Integrated Fitness Corp.','Integrated Fitness Corp.26 6th StreetStamford Ct 06905United States',1),('00:A0:48','Questech, Ltd.','Questech, Ltd.Eastheath AvenueWokinghamBerks, Rg11 2ppUnited Kingdom',1),('00:A0:49','Digitech Industries, Inc.','Digitech Industries, Inc.Po Box 226755 Kenosia AvenueDanbury Ct 06810United States',1),('00:A0:4A','Nisshin Electric Co., Ltd.','Nisshin Electric Co., Ltd.5, Meotogoshi, Mutsushi,Shikatsu-cyo, Nishikasugai,Aichi 481Japan',1),('00:A0:4B','Tfl Lan Inc.','Tfl Lan Inc.9f, No. 499 Chung Cheng RoadShih-lin District, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:A0:4C','Innovative Systems & Technologies, Inc.','Innovative Systems & Technologies, Inc.48511 Warm Springs Blvd.Suite  # 211cFremont Ca 94539United States',1),('00:A0:4D','Eda Instruments, Inc.','Eda Instruments, Inc.4 Thorncliffe Park DriveToronto, OntarioM4h 1h1Canada',1),('00:A0:4E','Voelker Technologies, Inc.','Voelker Technologies, Inc.22 New Boston CourtDanville Ca 94526United States',1),('00:A0:4F','Ameritec Corp.','Ameritec Corp.760 Arrow Grand CircleCovina Ca 91722United States',1),('00:A0:50','Cypress Semiconductor','Cypress Semiconductor3901 North First StreetSan Jose Ca 95134United States',1),('00:A0:51','Angia Communications. Inc.','Angia Communications. Inc.441 East Bay Blvd.Provo Utah 84606United States',1),('00:A0:52','Stanilite Electronics Pty. Ltd','Stanilite Electronics Pty. Ltd424, Lane Cove RoadNorth Ryde Nsw 2113Australia',1),('00:A0:53','Compact Devices, Inc.','Compact Devices, Inc.16795 Lark AvenueLos Gatos Ca 95030United States',1),('00:A0:54','Private','',1),('00:A0:55','Data Device Corporation','Data Device Corporation105 Wilbur PlaceBohemia Ny 11716United States',1),('00:A0:56','Micropross','Micropross33, Rue Gantois59000 LilleFrance',1),('00:A0:57','Lancom Systems Gmbh','Lancom Systems GmbhAdenauer Str.20 /b2D-52070 AachenWrselen  52146Germany',1),('00:A0:58','Glory, Ltd.','Glory, Ltd.1-3-1 Shimoteno, HimejiHyogo Pref. 670Japan',1),('00:A0:59','Hamilton Hallmark','Hamilton Hallmark2105 Lundy AvenueSan Jose Ca 95131United States',1),('00:A0:5A','Kofax Image Products','Kofax Image Products3 Jenner StreetIrvine Ca 92718-3807United States',1),('00:A0:5B','Marquip, Inc.','Marquip, Inc.1245 E. Washington Ave.Madison Wi 53703United States',1),('00:A0:5C','Inventory Conversion, Inc./','Inventory Conversion, Inc./Nekotech Division102 Tide Mill Road -suite # 6Hampton Nh 03842United States',1),('00:A0:5D','Cs Computer Systeme Gmbh','Cs Computer Systeme GmbhIsarstrasse 3,82065 BaierbrunnGermany',1),('00:A0:5E','Myriad Logic Inc.','Myriad Logic Inc.1109 Spring StreetSilver Spring Md 20910United States',1),('00:A0:5F','Btg Electronics Design Bv','Btg Electronics Design BvP.o. Box 15433260Ba Oud BeijerlandNetherlands',1),('00:A0:60','Acer Peripherals, Inc.','Acer Peripherals, Inc.9f, 135 Chian Kuo N. Rd. Sec 2Taipei,  10479Taiwan, Republic Of China',1),('00:A0:61','Puritan Bennett','Puritan Bennett2200 Faraday AvenueCarlsbad Ca 92008United States',1),('00:A0:62','Aes Prodata','Aes Prodata249 Balcatta RoadBalcattaWestern Australia 6021Australia',1),('00:A0:63','Jrl Systems, Inc.','Jrl Systems, Inc.8305 Hwy 71 WestAustin Tx 78735United States',1),('00:A0:64','Kvb/analect','Kvb/analect9420 Jeronimo RoadIrvine Ca 92718United States',1),('00:A0:65','Symantec Corporation','Symantec Corporation20330 Stevens Creek Blvd.Cupertino Ca 95014United States',1),('00:A0:66','Isa Co., Ltd.','Isa Co., Ltd.Shinjuku Lambdax Bldg. 5f.,2-4-12 Okubo, Shinjuku-ku TokyoJapanJapan',1),('00:A0:67','Network Services Group','Network Services Group3421 Commission Court-ste #202Woodbridge Va 22192United States',1),('00:A0:68','Bhp Limited','Bhp LimitedGpo Box 86aMelbourne 3001 VictoriaAustralia',1),('00:A0:69','Symmetricom, Inc.','Symmetricom, Inc.3750 Westwind Blvd.Santa Rosa Ca 95403United States',1),('00:A0:6A','Verilink Corporation','Verilink Corporation127 Jetplex CircleMadison Al 35758United States',1),('00:A0:6B','Dms Dorsch Mikrosystem Gmbh','Dms Dorsch Mikrosystem GmbhHolmlueck 13-15D-24972 SteinberqkircheGermany',1),('00:A0:6C','Shindengen Electric Mfg. Co., Ltd.','Shindengen Electric Mfg. Co., Ltd.10-13, Minami-cho, Hannou-citySaitama 357Jordan',1),('00:A0:6D','Mannesmann Tally Corporation','Mannesmann Tally CorporationP.o. Box 97018Kent Wa 98064-9718United States',1),('00:A0:6E','Austron, Inc.','Austron, Inc.P.o. Box 14766Austin Tx 78761-4766United States',1),('00:A0:6F','The Appcon Group, Inc.','The Appcon Group, Inc.23 Richmond StreetRochester Ny 14607United States',1),('00:A0:70','Coastcom','Coastcom1151 Harbor Bay ParkwayAlameda Ca 94502-6511United States',1),('00:A0:71','Video Lottery Technologies,inc','Video Lottery Technologies,inc2311 South 7th AvenueBozeman Mt 59715United States',1),('00:A0:72','Ovation Systems Ltd.','Ovation Systems Ltd.Great Haseley Trad. Est.Great Haseley,  Oxfordshire Ox9 7pfEnglandUnited Kingdom',1),('00:A0:73','Com21, Inc.','Com21, Inc.2113 Landings DriveMountain View Ca 94043United States',1),('00:A0:74','Perception Technology','Perception Technology40 Shawmut RoadCanton Ma 02021-1409United States',1),('00:A0:75','Micron Technology, Inc.','Micron Technology, Inc.8000 S. Federal WayP.o. Box 6Boise Id 83707-0006United States',1),('00:A0:76','Cardware Lab, Inc.','Cardware Lab, Inc.285 Sobrante Way, Ste.Sunnyvale Ca 94086United States',1),('00:A0:77','Fujitsu Nexion, Inc.','Fujitsu Nexion, Inc.289 Great RoadActon Ma 01720-4739United States',1),('00:A0:78','Marconi Communications','Marconi Communications1000 Fore DriveWarrendale Pa 15086-7502United States',1),('00:A0:79','Alps Electric (usa), Inc.','Alps Electric (usa), Inc.3553 North 1st StreetSan Jose Ca 95134United States',1),('00:A0:7A','Advanced Peripherals Technologies, Inc.','Advanced Peripherals Technologies, Inc.',1),('00:A0:7B','Dawn Computer Incorporation','Dawn Computer Incorporation6 Kexueyuan South RoadZhong Guan Cun Beijing 100080China',1),('00:A0:7C','Tonyang Nylon Co., Ltd.','Tonyang Nylon Co., Ltd.Electronic Research Lab183, Hoge-dong, Dongan-guAnyang-city, Kyungki-do 430-080Korea, Republic Of',1),('00:A0:7D','Seeq Technology, Inc.','Seeq Technology, Inc.47131 Bayside ParkwayFremont Ca 94538United States',1),('00:A0:7E','Avid Technology, Inc.','Avid Technology, Inc.Metropolitan Technology ParkOne Park WestTewksbury Ma 01876United States',1),('00:A0:7F','Gsm-syntel, Ltd.','Gsm-syntel, Ltd.Victoria Works, Queens Mill RdHuddersfield West YorkshireHd1 3pg EnglandUnited Kingdom',1),('00:A0:80','Sbe, Inc.','Sbe, Inc.4000 Executive ParkwaySuite 200San Ramon Ca 94583United States',1),('00:A0:81','Alcatel Data Networks','Alcatel Data Networks12502 Sunrise Valley DriveReston Va 22096United States',1),('00:A0:82','Nkt Elektronik A/s','Nkt Elektronik A/sNkt Alle 85Dk-2605 BrondbyDenmark',1),('00:A0:83','Asimmphony Turkey','Asimmphony TurkeyElectronics, Ltd.#160.260 - 6651 Elmbridge Way Richmond BV7c 4n1Canada',1),('00:A0:84','Dataplex Pty Ltd','Dataplex Pty LtdLevel 2, 71 Epping Rd,North  Ryde Nsw 2113Australia',1),('00:A0:85','Private','',1),('00:A0:86','Amber Wave Systems, Inc.','Amber Wave Systems, Inc.403 Massachusetts AvenueSuite #202Acton Ma 01720United States',1),('00:A0:87','Zarlink Semiconductor Ltd.','Zarlink Semiconductor Ltd.Cheney Manor, SwindonWiltshire Sn2 2qwUnited Kingdom',1),('00:A0:88','Essential Communications','Essential Communications4374 Alexander Blvd. Ne-steAlbuquerque Nm 87107United States',1),('00:A0:89','Xpoint Technologies, Inc.','Xpoint Technologies, Inc.902 Clint Moore Rd.-ste#132Boca Raton Fl 33487United States',1),('00:A0:8A','Brooktrout Technology, Inc.','Brooktrout Technology, Inc.144 Gould Street- Suite #200Needham Ma 02194United States',1),('00:A0:8B','Aston Electronic Designs Ltd.','Aston Electronic Designs Ltd.123/127 Deepcut Bridge RoadDeepcut,  Camberley Surrey, Gu16 6sdEnglandUnited Kingdom',1),('00:A0:8C','Multimedia Lans, Inc.','Multimedia Lans, Inc.5600 Executive Center DriveSuite #312Charlotte Nc 28212United States',1),('00:A0:8D','Jacomo Corporation','Jacomo Corporation26900 E. Pink Hill RoadIndependence Mo 64057United States',1),('00:A0:8E','Nokia Internet Communications','Nokia Internet Communications313 Fairchild DriveMountain View Ca 94043United States',1),('00:A0:8F','Desknet Systems, Inc.','Desknet Systems, Inc.80 Business Park DriveArmonk Ny 10504United States',1),('00:A0:90','Timestep Corporation','Timestep Corporation359 Terry Fox DriveKanata, Ontario K2k 2e7Canada',1),('00:A0:91','Applicom International','Applicom International43, Rue Mazagran76320 Caudebec-les-elbeufFrance',1),('00:A0:92','H. Bollmann Manufacturers, Ltd','H. Bollmann Manufacturers, Ltd26 Victoria WayBurgess Hill W. Sussex Rh 15 9nfEnglandUnited Kingdom',1),('00:A0:93','B/e Aerospace, Inc.','B/e Aerospace, Inc.17481 Red HillIrvine Ca 92714-5630United States',1),('00:A0:94','Comsat Corporation','Comsat Corporation22300 Comsat DriveClarksburg Md 20871-9475United States',1),('00:A0:95','Acacia Networks, Inc.','Acacia Networks, Inc.831 Woburn StreetWilmington Ma 01887United States',1),('00:A0:96','Mitumi Electric Co., Ltd.','Mitumi Electric Co., Ltd.8-8-2,  Kokuryo-choChofu-shi Tokyo 182Japan',1),('00:A0:97','Jc Information Systems','Jc Information Systems4487 Technology DriveFremont Ca 94538-6343United States',1),('00:A0:98','Network Appliance Corp.','Network Appliance Corp.2770 San Tomas ExpresswaySanta Clara Ca 95051United States',1),('00:A0:99','K-net Ltd.','K-net Ltd.Saddlers House100 Reading Rd.Yateley, Surrey Gu17 7rxUnited Kingdom',1),('00:A0:9A','Nihon Kohden America','Nihon Kohden America2446 Dupont DriveIrvine Ca 92715United States',1),('00:A0:9B','Qpsx Communications, Ltd.','Qpsx Communications, Ltd.33 Richardson StreetWest Perth 6005Australia',1),('00:A0:9C','Xyplex, Inc.','Xyplex, Inc.25 Foster StreetLittleton Ma 01460United States',1),('00:A0:9D','Johnathon Freeman Technologies','Johnathon Freeman TechnologiesP.o. Box 880114San Francisco Ca 94188United States',1),('00:A0:9E','Ictv','Ictv14600 Winchester Blvd.Los Gatos Ca 95030United States',1),('00:A0:9F','Commvision Corp.','Commvision Corp.510 Logue Ave.Mountain View Ca 94043United States',1),('00:A0:A0','Compact Data, Ltd.','Compact Data, Ltd.58 Ditton WalkCambridge Cb5 8qeUnited Kingdom',1),('00:A0:A1','Epic Data Inc.','Epic Data Inc.7280 River RoadRichmond,  B.c.Canada V6x 1x5Canada',1),('00:A0:A2','Digicom S.p.a.','Digicom S.p.a.Via Volta 3921010 Cardano Al Campo (va)Italy',1),('00:A0:A3','Reliable Power Meters','Reliable Power Meters400 Blossom Hill RoadLos Gatos Ca 95032-4511United States',1),('00:A0:A4','Micros Systems, Inc.','Micros Systems, Inc.12000 Baltimore AvenueBeltsville Md 20705United States',1),('00:A0:A5','Teknor Microsysteme, Inc.','Teknor Microsysteme, Inc.616 Cure BoivinBoisbriand QuebecJ7g 2a7Canada',1),('00:A0:A6','M.i. Systems, K.k.','M.i. Systems, K.k.2-7-12-308 SatsukigaokaIkeda-shi Osaka 563-0029Japan',1),('00:A0:A7','Vorax Corporation','Vorax Corporation1031 East Duane Avenue, Ste HSunnyvale Ca 94086United States',1),('00:A0:A8','Renex Corporation','Renex Corporation2750 Killarney DriveWoodbridge Va 22192United States',1),('00:A0:A9','Navtel Communications Inc.','Navtel Communications Inc.55 Renfrew DriveMarkham, Ontario L3r 8h3Canada',1),('00:A0:AA','Spacelabs Medical','Spacelabs Medical5150 220 Ave SeIssaquah Wa 98027United States',1),('00:A0:AB','Netcs Informationstechnik Gmbh','Netcs Informationstechnik GmbhKatharinenstrasse 17-18D-10711 Berlin,GermanyGermany',1),('00:A0:AC','Gilat Satellite Networks, Ltd.','Gilat Satellite Networks, Ltd.24a Habarzel StreetTel Aviv  69710Israel',1),('00:A0:AD','Marconi Spa','Marconi SpaVia Negrone, 1a16153 Genova CorniglianoItaly',1),('00:A0:AE','Nucom Systems, Inc.','Nucom Systems, Inc.9f-6, No 4, Lane609 Chung Hsin Road, Sec. 5, San Chung CTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:A0:AF','Wms Industries','Wms Industries3401 N. CaliforniaChicago Il 60618United States',1),('00:A0:B0','I-o Data Device, Inc.','I-o Data Device, Inc.24-1, Sakurada-machiKanazawa, Ishikawa 920Japan',1),('00:A0:B1','First Virtual Corporation','First Virtual Corporation3393 Octavius Dr.-ste.# 102Santa Clara Ca 95054United States',1),('00:A0:B2','Shima Seiki','Shima Seiki85, Sakata Wakayama-cityWakayama 641Japan',1),('00:A0:B3','Zykronix','Zykronix7248 South Tucson WayEnglewood Co 80112United States',1),('00:A0:B4','Texas Microsystems, Inc.','Texas Microsystems, Inc.5959 Corporate DriveHouston Tx 77036United States',1),('00:A0:B5','3h Technology','3h Technology3375 Scott Blvd. #336Santa Clara Ca 95054United States',1),('00:A0:B6','Sanritz Automation Co., Ltd.','Sanritz Automation Co., Ltd.4-21 Minami NaruseMachida City Tokyo  194Japan',1),('00:A0:B7','Cordant, Inc.','Cordant, Inc.11400 Commerce Park Dr.Reston Va 22091-1506United States',1),('00:A0:B8','Symbios Logic Inc.','Symbios Logic Inc.2001 Danfield Ct.Fort Collins Co 80525United States',1),('00:A0:B9','Eagle Technology, Inc.','Eagle Technology, Inc.6800 Orangethorpe Ave., Unit ABuena Park Ca 90620United States',1),('00:A0:BA','Patton Electronics Co.','Patton Electronics Co.7622 Rickenbacker DriveGaithersburg Md 20879United States',1),('00:A0:BB','Hilan Gmbh','Hilan GmbhHaid-und-neu-strasse 7D-76131 KarlsruheGermany',1),('00:A0:BC','Viasat, Incorporated','Viasat, Incorporated6155 El Camino RealCarlsbad Ca 92009United States',1),('00:A0:BD','I-tech Corp.','I-tech Corp.10200 Valley View RoadEden Prairie Mn 55344United States',1),('00:A0:BE','Integrated Circuit Systems, Inc. Communications Group','Integrated Circuit Systems, Inc. Communications Group1271 Parkmoor AvenueSan Jose Ca 95126-3448United States',1),('00:A0:BF','Wireless Data Group Motorola','Wireless Data Group Motorola1201 E. Wiley RoadSchaumburg Il 60173United States',1),('00:A0:C0','Digital Link Corp.','Digital Link Corp.217 Humboldt CourtSunnyvale Ca 94089United States',1),('00:A0:C1','Ortivus Medical Ab','Ortivus Medical AbBox 513S-18325 TabySwedenSweden',1),('00:A0:C2','R.a. Systems Co., Ltd.','R.a. Systems Co., Ltd.1850-3 HirookanomuraShiojiri-shi, Nagamo 399-07JapanJapan',1),('00:A0:C3','Unicomputer Gmbh','Unicomputer GmbhLimburger Strasse 48D-61476 Kronberg I.t.s.GermanyGermany',1),('00:A0:C4','Cristie Electronics Ltd.','Cristie Electronics Ltd.Bonds MillStonehouseGloucestershire Gl10 3rgUnited Kingdom',1),('00:A0:C5','Zyxel Communication','Zyxel Communication2nd Flr.,  58 Park Avenue IiScience Based Industrial ParkHsinchu 30077Taiwan, Republic Of China',1),('00:A0:C6','Qualcomm Incorporated','Qualcomm Incorporated5775 Morehouse DrSan Diego Ca 92121United States',1),('00:A0:C7','Tadiran Telecommunications','Tadiran TelecommunicationsP.o. Box 500Petah-tikva 49104Israel',1),('00:A0:C8','Adtran Inc.','Adtran Inc.901 Explorer Blvd.Huntsville Al 35806-2807United States',1),('00:A0:C9','Intel Corporation - Hf1-06','Intel Corporation - Hf1-065200 Ne Elam Young ParkwayHillsboro Or 97124United States',1),('00:A0:CA','Fujitsu Denso Ltd.','Fujitsu Denso Ltd.3055 Orchard DriveSan Jose Ca 95134United States',1),('00:A0:CB','Ark Telecommunications, Inc.','Ark Telecommunications, Inc.124 Carmen Lane--suiteSanta Maria Ca 93454United States',1),('00:A0:CC','Lite-on Communications, Inc.','Lite-on Communications, Inc.720 S. Hillview DriveMilpitas Ca 95035United States',1),('00:A0:CD','Dr. Johannes Heidenhain Gmbh','Dr. Johannes Heidenhain GmbhDr.-johannes-heidenhain Str.83301 TraunreutGermany',1),('00:A0:CE','Astrocom Corporation','Astrocom Corporation2700 Summer St. N.e.Minneapolis Mn 55413United States',1),('00:A0:CF','Sotas, Inc.','Sotas, Inc.2 Research Place, Ste.Rockville Md 20850United States',1),('00:A0:D0','Ten X Technology, Inc.','Ten X Technology, Inc.13091 Pond Springs Road, Suite B-200Austin Tx 78729United States',1),('00:A0:D1','Inventec Corporation','Inventec CorporationInventec Building66 Hou-kang Street Shi-lin District, TaiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:A0:D2','Allied Telesis International Corporation','Allied Telesis International Corporation950 Kifer RoadSunnyvale Ca 94086United States',1),('00:A0:D3','Instem Computer Systems, Ltd.','Instem Computer Systems, Ltd.Walton Industrial EstateStone, Staffordshire St15 OltUnited Kingdom',1),('00:A0:D4','Radiolan,  Inc.','Radiolan,  Inc.454 Deguigne Drive - SteSunnyvale Ca 94086United States',1),('00:A0:D5','Sierra Wireless Inc.','Sierra Wireless Inc.#260 - 13151 Vanier PlaceRichmond B.c.V6v 2j2Canada',1),('00:A0:D6','Sbe, Inc.','Sbe, Inc.2305 Camino RamonSan Ramon Ca 94583United States',1),('00:A0:D7','Kasten Chase Applied Research','Kasten Chase Applied Research5100 Orbitor DriveMississauga, OntarioL4w 4z4Canada',1),('00:A0:D8','Spectra - Tek','Spectra - TekOutgang LanePickering North YorkshireEngland Y018 FjaUnited Kingdom',1),('00:A0:D9','Convex Computer Corporation','Convex Computer Corporation3000 Waterview ParkwayP.o. Box 833851Richardson Tx 75083-3851United States',1),('00:A0:DA','Integrated Systems Technology, Inc.','Integrated Systems Technology, Inc.4601 Presidents DriveSuite #210Lanham Md 20706United States',1),('00:A0:DB','Fisher & Paykel Production','Fisher & Paykel ProductionMachinery LimitedP.o. Box 58-223, Greenmount AucklandNew Zealand',1),('00:A0:DC','O.n. Electronic Co., Ltd.','O.n. Electronic Co., Ltd.3-20-27, TarumiSuita, Osaka 564Japan',1),('00:A0:DD','Azonix Corporation','Azonix Corporation900 Middlesex TurnpikeBldg.Billerica Ma 01821United States',1),('00:A0:DE','Yamaha Corporation','Yamaha CorporationElectronic Devices Division203 Matsunokijima Toyooka-mura Iwata-gun438-01Japan',1),('00:A0:DF','Sts Technologies, Inc.','Sts Technologies, Inc.13765 St. Charles Rock Rd.Suite #108Bridgeton Mo 63044United States',1),('00:A0:E0','Tennyson Technologies Pty Ltd','Tennyson Technologies Pty Ltd14 Business Park DriveNotting HillVictoria - 3168Australia',1),('00:A0:E1','Westport Research Associates, Inc.','Westport Research Associates, Inc.6102 ArlingtonRaytown Mo 64133United States',1),('00:A0:E2','Keisokugiken Corporation','Keisokugiken Corporation2021-5 HoushakujiTakanezawa-machiShioya-gun Tochigi 329-1233Japan',1),('00:A0:E3','Xkl Systems Corp.','Xkl Systems Corp.8420 154th Ave. NeRedmond Wa 98052United States',1),('00:A0:E4','Optiquest','Optiquest20490 Business ParkwayWalnut Ca 91789United States',1),('00:A0:E5','Nhc Communications','Nhc Communications5450 Cote De LiesseMontreal, Quebec H4p 1a5Canada',1),('00:A0:E6','Dialogic Corporation','Dialogic Corporation1515 Route 10Parsippany Nj 07054United States',1),('00:A0:E7','Central Data Corporation','Central Data Corporation1602 Newton DriveChampaign Il 61821United States',1),('00:A0:E8','Reuters Holdings Plc','Reuters Holdings Plc85, Fleet StreetLondon  Ec4p 4ajEnglandUnited Kingdom',1),('00:A0:E9','Electronic Retailing Systems International','Electronic Retailing Systems International372 Danbury RoadWilton Ct 06897-2523United States',1),('00:A0:EA','Ethercom Corp.','Ethercom Corp.45990 Hotchkiss St.Freemont Ca 94539United States',1),('00:A0:EB','Encore Networks','Encore Networks45472 Holiday DriveDulles Va 20166United States',1),('00:A0:EC','Transmitton Ltd.','Transmitton Ltd.Smisby RoadAshby De La ZouchLeicestershire Le65 2ugUnited Kingdom',1),('00:A0:ED','Brooks Automation, Inc.','Brooks Automation, Inc.15 Elizabeth DriveChelmsford Ma 01824United States',1),('00:A0:EE','Nashoba Networks','Nashoba Networks9-11 Goldsmith St.Littleton Ma 01460United States',1),('00:A0:EF','Lucidata Ltd.','Lucidata Ltd.Lucidata HouseSelwyn Close,Great Shelford Cambridge  Cb2 5haUnited Kingdom',1),('00:A0:F0','Toronto Microelectronics Inc.','Toronto Microelectronics Inc.5149 Bradco BoulevardMississauga, OntarioL4w 2a6Canada',1),('00:A0:F1','Mti','Mti4905 E. La Palma AvenueAnaheim Ca 92807United States',1),('00:A0:F2','Infotek Communications, Inc.','Infotek Communications, Inc.111 Anza Blvd., #203Burlingame Ca 94010United States',1),('00:A0:F3','Staubli','Staubli183 Rue Des UsinesBp 70 F74210 FavergesFranceFrance',1),('00:A0:F4','Ge','GeW-6573000 N. Grandview Blvd.Waukesha Wi 53188United States',1),('00:A0:F5','Radguard Ltd.','Radguard Ltd.8 Hanechoshet StreetTel-aviv  69710Israel',1),('00:A0:F6','Autogas Systems Inc.','Autogas Systems Inc.P.o. Box 6957Abiolene Tx 79608United States',1),('00:A0:F7','V.i Computer Corp.','V.i Computer Corp.531 Encinitas Blvd--#114Encinitas Ca 92024United States',1),('00:A0:F8','Symbol Technologies, Inc.','Symbol Technologies, Inc.1101 South Winchester Blvd.Suite  # B-110San Jose Ca 95128United States',1),('00:A0:F9','Bintec Communications Gmbh','Bintec Communications GmbhSuedwestpark 9490449 NuernbergGermany',1),('00:A0:FA','Marconi Communication Gmbh','Marconi Communication GmbhGerberstrasse 33D-71522 BacnknangGermanyGermany',1),('00:A0:FB','Toray Engineering Co., Ltd.','Toray Engineering Co., Ltd.1-45, Oe 1-chome, Otsu CityShiga,520-21 JapanJapan',1),('00:A0:FC','Image Sciences, Inc.','Image Sciences, Inc.7500 Innovation WayMason Oh 45040United States',1),('00:A0:FD','Scitex Digital Printing, Inc.','Scitex Digital Printing, Inc.3100 Research Blvd.Dayton Oh 45420United States',1),('00:A0:FE','Boston Technology, Inc.','Boston Technology, Inc.100 Quannapowitt ParkwayWakefield Ma 01880United States',1),('00:A0:FF','Tellabs Operations, Inc.','Tellabs Operations, Inc.1000 Remington Blvd.Bolingbrook  Il  6044060440United States',1),('00:AA:00','Intel Corporation','Intel Corporation5200 Ne Elam Young ParkwayHillsboro Or 97124United States',1),('00:AA:01','Intel Corporation','Intel Corporation',1),('00:AA:02','Intel Corporation','Intel Corporation',1),('00:AA:3C','Olivetti Telecom Spa (olteco)','Olivetti Telecom Spa (olteco)10062 Miller Ave.-ste.#204Cupertino Ca 95014United States',1),('00:B0:09','Grass Valley Group','Grass Valley GroupP.o. Box 599000Nevada City Ca 95959-7900United States',1),('00:B0:17','Infogear Technology Corp.','Infogear Technology Corp.2055 Woodside RoadRedwood City Ca 94061United States',1),('00:B0:19','Casi-rusco','Casi-rusco1155 Broken Sound PkwyBoca Raton Fl 33498United States',1),('00:B0:1C','Westport Technologies','Westport Technologies15 Capella Court, Unit 116Nepean OntarioCanada',1),('00:B0:1E','Rantic Labs, Inc.','Rantic Labs, Inc.702 Brazos,  Suite #500Austin Tx 78701United States',1),('00:B0:2A','Orsys Gmbh','Orsys GmbhAm Stadtgraben 25D-88677 MarkdorfGermany',1),('00:B0:2D','Viagate Technologies, Inc.','Viagate Technologies, Inc.745 Route 202/206Suite 5Bridgewater Nj 08807United States',1),('00:B0:3B','Hiq Networks','Hiq Networks2475 Augustine DriveSanta Clara Ca 95054United States',1),('00:B0:48','Marconi Communications Inc.','Marconi Communications Inc.8616 Freeport ParkwayMs A2Irving Tx 75063United States',1),('00:B0:4A','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:B0:52','Intellon Corporation','Intellon Corporation5100 West Silver Springs Blvd.Ocala Fl 34482United States',1),('00:B0:64','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:B0:69','Honewell Oy','Honewell OyP.o. Box 168, Fin-78201VarkausFinland',1),('00:B0:6D','Jones Futurex Inc.','Jones Futurex Inc.3715 Atherton RoadRocklin Ca 95765United States',1),('00:B0:80','Mannesmann Ipulsys B.v.','Mannesmann Ipulsys B.v.Bordewijklaan 182591 Xr The HagueNetherlands',1),('00:B0:86','Locsoft Limited','Locsoft Limited7 Bright StreetClitheroe Lancashire Bb7 1nwUnited Kingdom',1),('00:B0:8E','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive -sja-2San Jose Ca 95134United States',1),('00:B0:91','Transmeta Corp.','Transmeta Corp.3940 Freedom CircleSanta Clara Ca 95054United States',1),('00:B0:94','Alaris, Inc.','Alaris, Inc.47338 Fremont BoulevardFremont Ca 94538United States',1),('00:B0:9A','Morrow Technologies Corp.','Morrow Technologies Corp.2300 Tall Pines DriveLargo Fl 33771-5342United States',1),('00:B0:9D','Point Grey Research Inc.','Point Grey Research Inc.305-1847 West BroadwayVancouver British Columbia V6j 1y6Canada',1),('00:B0:AC','Siae-microelettronica S.p.a.','Siae-microelettronica S.p.a.Via Michelangelo Buonarroti, 2120093 Cologno M. (ml)Italy',1),('00:B0:AE','Symmetricom','Symmetricom2300 Orchard ParkwaySan Jose Ca 95131United States',1),('00:B0:B3','Xstreamis Plc','Xstreamis PlcMagdalen CentreOxford Science ParkOxford 0x4 4gaUnited Kingdom',1),('00:B0:C2','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive - Sja-2San Jose Ca 95134United States',1),('00:B0:C7','Tellabs Operations, Inc.','Tellabs Operations, Inc.One Tellabs Center1415 West Diehl RoadNaperville Il 60563United States',1),('00:B0:CE','Technology Rescue','Technology Rescue46 Avenue Des Speres Lumiere7819 TroppesFrance',1),('00:B0:D0','Dell Computer Corp.','Dell Computer Corp.One Dell WayRound Rock Tx 78682United States',1),('00:B0:DB','Nextcell, Inc.','Nextcell, Inc.651 East 18th StreetPlano Tx 75074United States',1),('00:B0:DF','Reldata Inc','Reldata Inc1719 Route 10  -  Suite #209Parsippany Nj 07054United States',1),('00:B0:E7','British Federal Ltd.','British Federal Ltd.Castle Mill WorksDudley Dy1 4da EnglandUnited Kingdom',1),('00:B0:EC','Eacem','EacemAvenue Louise 140, Bte 6B-1050 BrusselsBelgium',1),('00:B0:EE','Ajile Systems, Inc.','Ajile Systems, Inc.204 Collins Rd NeSuite 100Cedar Rapids Ia 52402United States',1),('00:B0:F0','Caly Networks','Caly Networks295 Santa Anna CourtSunnyvale Ca 94086United States',1),('00:B0:F5','Networth Technologies, Inc.','Networth Technologies, Inc.1000 Germantown PikeLdg. J-1Plymouth Metting Pa 19462United States',1),('00:BA:C0','Biometric Access Company','Biometric Access Company2555 North Ih 35Round Rock Texas 78664United States',1),('00:BB:01','Octothorpe Corp.','Octothorpe Corp.285 West Green StreetPasadena Ca 91105United States',1),('00:BB:F0','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:C0:00','Lanoptics, Ltd.','Lanoptics, Ltd.P.o. Box 184Migdal Ha-emekIsrael Israel 10551Israel',1),('00:C0:01','Diatek Patient Managment','Diatek Patient ManagmentSystems, Inc.5720 Oberlin DriveSan Diego Ca 92121-1723United States',1),('00:C0:02','Sercomm Corporation','Sercomm Corporation3f,no.81,yu-yih Road,chu-nan ChenMiao-lih Hsuan 350Taiwan, Republic Of China',1),('00:C0:03','Globalnet Communications','Globalnet Communications912, Place Trans CanadaLongueuil, QcCanada J4g 2m1Canada',1),('00:C0:04','Japan Business Computer Co.ltd','Japan Business Computer Co.ltd1368 Futoo-cho, Kohoku-kuYokohama-city222 JapanJapan',1),('00:C0:05','Livingston Enterprises, Inc.','Livingston Enterprises, Inc.6920 Koll Center Parkway #220Pleasanton Ca 94566United States',1),('00:C0:06','Nippon Avionics Co., Ltd.','Nippon Avionics Co., Ltd.Industrial System Division28-2, Hongoh 2-chome, Seya-ku YokohamaJapanJapan',1),('00:C0:07','Pinnacle Data Systems, Inc.','Pinnacle Data Systems, Inc.1350 West Fifth AvenueColumbus Oh 43212United States',1),('00:C0:08','Seco Srl','Seco SrlVia Calamandrei 9152100 ArezzoItalyItaly',1),('00:C0:09','Kt Technology (s) Pte Ltd','Kt Technology (s) Pte LtdKt Building100e Pasir Panjang RoadSingapore 0511Singapore',1),('00:C0:0A','Micro Craft','Micro Craft2-4-3 NishifurumatsuOkayama City Okayama Pref. 700JapanJapan',1),('00:C0:0B','Norcontrol A.s.','Norcontrol A.s.P.o. Box 1024N-3194 HortenNorwayNorway',1),('00:C0:0C','Relia Technolgies','Relia Technolgies1f., No. 24, Industry E. 9thRd., Science-based Industrial Park Hsin-Taiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:C0:0D','Advanced Logic Research, Inc.','Advanced Logic Research, Inc.9401 JeronimoIrvine Ca 92618United States',1),('00:C0:0E','Psitech, Inc.','Psitech, Inc.18368 Bandilier CircleFountain Valley Ca 92708United States',1),('00:C0:0F','Quantum Software Systems Ltd.','Quantum Software Systems Ltd.175 Terrence Matthews CrescentKanata, Ontario CanadaK2l 3t5Canada',1),('00:C0:10','Hirakawa Hewtech Corp.','Hirakawa Hewtech Corp.7f, Bldg.b, Omori Bellport6-26-2, Minami-oi,shinagawa-ku Tokyo 140JapanJapan',1),('00:C0:11','Interactive Computing Devices','Interactive Computing Devices1735 Technology Drive-ste #720San Jose Ca 95110United States',1),('00:C0:12','Netspan Corporation','Netspan Corporation1411 E. Campbell RdSuite #1000Richardson Tx 75081United States',1),('00:C0:13','Netrix','Netrix13595 Dulles Technology DriveHerndon Va 22071United States',1),('00:C0:14','Telematics Calabasas Intl,inc','Telematics Calabasas Intl,inc26630 Agoura RoadCalabasas Ca 91302-1988United States',1),('00:C0:15','New Media Corporation','New Media Corporation15375 Barranca ParkwayBuildingIrvine Ca 92718United States',1),('00:C0:16','Electronic Theatre Controls','Electronic Theatre Controls3030 Laura LaneMiddleton Wi 53562United States',1),('00:C0:17','Fluke Corporation','Fluke Corporation6920 Seaway Blvd.Everett Wa 98203United States',1),('00:C0:18','Lanart Corporation','Lanart Corporation145 Rosemary StreetNeedham Ma 02194United States',1),('00:C0:19','Leap Technology, Inc.','Leap Technology, Inc.20Burlington Ma 01803United States',1),('00:C0:1A','Corometrics Medical Systems','Corometrics Medical Systems61 Barnes Park Road NorthWallingford Ct 06492-0333United States',1),('00:C0:1B','Socket Communications, Inc.','Socket Communications, Inc.2823 Whipple Rd.Union City Ca 94587United States',1),('00:C0:1C','Interlink Communications Ltd.','Interlink Communications Ltd.Brunel Road,Gorse Lane Industrial Estate Clacton-on-EnglandUnited Kingdom',1),('00:C0:1D','Grand Junction Networks, Inc.','Grand Junction Networks, Inc.3101 Whipple Rd., #27Union City Ca 94587United States',1),('00:C0:1E','La Francaise Des Jeux','La Francaise Des JeuxCentre De Roussy/dti77230 Roussy-le-vieuxFranceFrance',1),('00:C0:1F','S.e.r.c.e.l.','S.e.r.c.e.l.B.p. 43944474 Carquefou CedexFranceFrance',1),('00:C0:20','Arco Electronic, Control Ltd.','Arco Electronic, Control Ltd.2750 North 29th Ave.-ste.#316Hollywood Fl 33020United States',1),('00:C0:21','Netexpress','Netexpress989 East Hillsdale Blvd.Suite #290Foster City Ca 94404-2113United States',1),('00:C0:22','Lasermaster Technologies, Inc.','Lasermaster Technologies, Inc.7156 Shady Oak RoadEden Prairie Mn 55344United States',1),('00:C0:23','Tutankhamon Electronics','Tutankhamon Electronics2446 Estand WayPleasant Hill Ca 94523United States',1),('00:C0:24','Eden Sistemas De Computacao Sa','Eden Sistemas De Computacao SaRua Do Ouvidor 121 5 AndarRio De JaneiroBrazilBrazil',1),('00:C0:25','Dataproducts Corporation','Dataproducts Corporation6219 Desoto AvenueWoodland Hills Ca 91365-0746United States',1),('00:C0:26','Lans Technology Co., Ltd.','Lans Technology Co., Ltd.153 Mintsu Rd. 2f, Taoyuan,Taiwan R. O. C.Taiwan, Republic Of China',1),('00:C0:27','Cipher Systems, Inc.','Cipher Systems, Inc.1800 Nw 169th PlaceSuite B-100Beaverton Or 97006United States',1),('00:C0:28','Jasco Corporation','Jasco Corporation2967-5 Ishikawa-cho,Hachioji-shi Tokyo 192JapanJapan',1),('00:C0:29','Nexans Deutschland Gmbh - Ans','Nexans Deutschland Gmbh - AnsBonnenbroicher Str. 10041238 MoenchengladbachGermany',1),('00:C0:2A','Ohkura Electric Co., Ltd.','Ohkura Electric Co., Ltd.2-90-20 Shirako Wako CitySaitama Pref.351-01 JapanJapan',1),('00:C0:2B','Gerloff Gesellschaft Fur','Gerloff Gesellschaft FurElekronische SystementwicklungFasanenweg 25 W-2000 Hamburg 73GermanyGermany',1),('00:C0:2C','Centrum Communications, Inc.','Centrum Communications, Inc.2880 Zanker Road-ste #108San Jose Ca 95134United States',1),('00:C0:2D','Fuji Photo Film Co., Ltd.','Fuji Photo Film Co., Ltd.798 Miyanodai Kaisei-machiAshigara-kami-gun KanagawaJapanJapan',1),('00:C0:2E','Netwiz','Netwiz26 Golomb StreetHaifa  33391IsraelIsrael',1),('00:C0:2F','Okuma Corporation','Okuma CorporationOguchi-cho, Niwa-gunAichi 480-01JapanJapan',1),('00:C0:30','Integrated Engineering B. V.','Integrated Engineering B. V.Ellermanstraat 151099 Bw AmsterdamThe NetherlandsNetherlands',1),('00:C0:31','Design Research Systems, Inc.','Design Research Systems, Inc.925 E. Executive Park Dr.SuiteSalt Lake City Ut 84117United States',1),('00:C0:32','I-cubed Limited','I-cubed LimitedUnit J1, The Poaddocks347 Cherry Hinton Road CambridgeCb1 4dh Cb1 4dh EnglandUnited Kingdom',1),('00:C0:33','Telebit Communications Aps','Telebit Communications ApsSkanderborgvej 234Dk-8260 VibyDenmarkDenmark',1),('00:C0:34','Transaction Network','Transaction NetworkServices, Inc.Omnilink Communications Div. 3101 TechnoLansing Mi 48910-8356United States',1),('00:C0:35','Quintar Company','Quintar Company370 Amapola Ave., Ste.#106Torrance Ca 90501United States',1),('00:C0:36','Raytech Electronic Corp.','Raytech Electronic Corp.2f, No.6, Lane 497Chung Cheng Rd, Hsin Tien City Taipei HsTaiwan R.o.c.Taiwan, Republic Of China',1),('00:C0:37','Dynatem','Dynatem15795 Rockfield Blvd.SuiteIrvine Ca 92718United States',1),('00:C0:38','Raster Image Processing System','Raster Image Processing System4665 Nautilus Court SouthBoulder Co 80301United States',1),('00:C0:39','Teridian Semiconductor Corporation','Teridian Semiconductor Corporation6440 Oak CanyonIrvine Ca 92618United States',1),('00:C0:3A','Men-mikro Elektronik Gmbh','Men-mikro Elektronik GmbhWiesentalstrasse 40W-8500 Nuernberg 90GermanyGermany',1),('00:C0:3B','Multiaccess Computing Corp.','Multiaccess Computing Corp.5350 Hollister Ave., Ste.Santa Barbara Ca 93111United States',1),('00:C0:3C','Tower Tech S.r.l.','Tower Tech S.r.l.Via Ridolfi 6,856124 PisaItalyItaly',1),('00:C0:3D','Wiesemann & Theis Gmbh','Wiesemann & Theis GmbhWittener Str. 3125600 Wuppertal 2GermanyGermany',1),('00:C0:3E','Fa. Gebr. Heller Gmbh','Fa. Gebr. Heller GmbhP.o. Box 1428, Dep. Ee77440 NurtingenGermanyGermany',1),('00:C0:3F','Stores Automated Systems, Inc.','Stores Automated Systems, Inc.1360 Adams RoadBensalem Pa 19020United States',1),('00:C0:40','Ecci','Ecci15070-b Avenue Of ScienceSan Diego Ca 92128United States',1),('00:C0:41','Digital Transmission Systems','Digital Transmission Systems4830 River Green ParkwayDuluth Ga 30136United States',1),('00:C0:42','Datalux Corp.','Datalux Corp.2836 Cessna DriveWinchester Va 22601United States',1),('00:C0:43','Stratacom','Stratacom1400 Parkmoor AvenueSan Jose Ca 95126United States',1),('00:C0:44','Emcom Corporation','Emcom Corporation840 AvenuePlano Tx 75074United States',1),('00:C0:45','Isolation Systems, Ltd.','Isolation Systems, Ltd.26 Six Point RoadToronto, OntarioCanada M8z 2w9Canada',1),('00:C0:46','Blue Chip Technology Ltd','Blue Chip Technology LtdChowley Oak LaneTattenhallChester Cheshire Ch3 9exUnited Kingdom',1),('00:C0:47','Unimicro Systems, Inc.','Unimicro Systems, Inc.44382 S. Grimmer Blvd.Fremont Ca 94538United States',1),('00:C0:48','Bay Technical Associates','Bay Technical Associates200 N. Second StreetP.o. Box 387Bay St. Louis Ms 39520United States',1),('00:C0:49','U.s. Robotics, Inc.','U.s. Robotics, Inc.8100 North Mccormick Blvd.Skokie Il 60076-2999United States',1),('00:C0:4A','Group 2000 Ag','Group 2000 AgP.o. Box 331Tannagertenstr. 9 Ch-8635 DurntenSwitzerlandSwitzerland',1),('00:C0:4B','Creative Microsystems','Creative Microsystems9, Avenue Du CanadaParc Hightec 6 Z.a. De Courtaboeuf91966 Les Ulis---francFrance',1),('00:C0:4C','Department Of Foreign Affairs','Department Of Foreign Affairs& TradeAdministrative Building Parkes Place,  PAustraliaAustralia',1),('00:C0:4D','Mitec, Inc.','Mitec, Inc.Br-kameido 1 BuildingZ-33-1, Kameido, Koutou-ku Tokyo, 136JapanJapan',1),('00:C0:4E','Comtrol Corporation','Comtrol Corporation2675 Patton RoadSt. Paul Mn 55113United States',1),('00:C0:4F','Dell Computer Corporation','Dell Computer Corporation1807 West Braker Lane-bldg.Austin Tx 78758-3610United States',1),('00:C0:50','Toyo Denki Seizo K.k.','Toyo Denki Seizo K.k.4-6-32 HigashikashiwagayaEbinashiKanagawa Japan 243-04Japan',1),('00:C0:51','Advanced Integration Research','Advanced Integration Research2188 Del Franco StreetSan Jose Ca 95131United States',1),('00:C0:52','Burr-brown','Burr-brownP.o. Box 11400Tucson Az 85734-1400United States',1),('00:C0:53','Aspect Software Inc.','Aspect Software Inc.6 Technology Park DriveWestford Ma 01886United States',1),('00:C0:54','Network Peripherals, Ltd.','Network Peripherals, Ltd.4th Floor, 17 Bowater Rd.Westminster Industrial Estate London SeEnglandUnited Kingdom',1),('00:C0:55','Modular Computing Technologies','Modular Computing Technologies2352 Main StreetConcord Ma 01742United States',1),('00:C0:56','Somelec','SomelecBp 7010 - 95050Cergy Pontoise CedexFranceFrance',1),('00:C0:57','Myco Electronics','Myco ElectronicsMusserongrand 1gS-756 UppsalaSwedenSweden',1),('00:C0:58','Dataexpert Corp.','Dataexpert Corp.1156 Sonopra Courtn-kang Rd.Sunnyvale Ca 94086United States',1),('00:C0:59','Denso Corporation','Denso Corporation1-1, Showa-cho,Kariya-shi, Aichi 448-8661Japan',1),('00:C0:5A','Semaphore Communications Corp.','Semaphore Communications Corp.217 Humboldt CourtSunnyvale Ca 94089-1300United States',1),('00:C0:5B','Networks Northwest, Inc.','Networks Northwest, Inc.P.o. Box 1188Issaquah Wa 98027United States',1),('00:C0:5C','Elonex Plc','Elonex Plc2 Apsley WayLondon, Nw2 7hfUnited KingdomUnited Kingdom',1),('00:C0:5D','L&n Technologies','L&n Technologies2899 Agoura Road #196Westlake Village Ca 91361-3200United States',1),('00:C0:5E','Vari-lite, Inc.','Vari-lite, Inc.201 Regal RowDallas Tx 75247United States',1),('00:C0:5F','Fine-pal Company Limited','Fine-pal Company LimitedRm. 9, 11f, Kingsford Ind. Ctr13, Wang Hoi Road Kowloon Bay, KlnHong KongHong Kong',1),('00:C0:60','Id Scandinavia As','Id Scandinavia AsP.o. Box 4227N-5028 BergenNorwayNorway',1),('00:C0:61','Solectek Corporation','Solectek Corporation6370 Nancy Ridge Dr.-ste.#109San Diego Ca 92121United States',1),('00:C0:62','Impulse Technology','Impulse Technology210 Dahlonega St.#204Cumming Ga 30130United States',1),('00:C0:63','Morning Star Technologies, Inc','Morning Star Technologies, Inc1760 Zollinger RoadColumbus Oh 43221United States',1),('00:C0:64','General Datacomm Ind. Inc.','General Datacomm Ind. Inc.Park Road ExtensionP.o. Box 1299Middlebury Ct 06762United States',1),('00:C0:65','Scope Communications, Inc.','Scope Communications, Inc.100 Otis StreetNorthboro Ma 01532United States',1),('00:C0:66','Docupoint, Inc.','Docupoint, Inc.2701 Bayview DriveFremont Ca 94538United States',1),('00:C0:67','United Barcode Industries','United Barcode Industries12240 Indian Creek CourtBeltsville Md 20705United States',1),('00:C0:68','Philip Drake Electronics Ltd.','Philip Drake Electronics Ltd.The HydewayWelwyn Garden City Herts. Al7 3uq,United Kingdom',1),('00:C0:69','Axxcelera Broadband Wireless','Axxcelera Broadband Wireless111 Castilian DriveSanta Barbara Ca 93117United States',1),('00:C0:6A','Zahner-elektrik Gmbh & Co. Kg','Zahner-elektrik Gmbh & Co. KgP.o. Box 1846Thueringer Strasse 12 Dw-8640 Kronach-guGermanyGermany',1),('00:C0:6B','Osi Plus Corporation','Osi Plus Corporation2-1-23 NakameguroMeguro-ku, Tokyo  153JapanJapan',1),('00:C0:6C','Svec Computer Corp.','Svec Computer Corp.3f, 531-1 Chung Cheng Rd.Hsin-tien City, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:C0:6D','Boca Research, Inc.','Boca Research, Inc.6401 Congress AvenueBoca Raton Fl 33487United States',1),('00:C0:6E','Haft Technology, Inc.','Haft Technology, Inc.Daini-doho Bldg.3-chome 24-7 Ninomiya Tsukuba Ibaragi305 JapanJapan',1),('00:C0:6F','Komatsu Ltd.','Komatsu Ltd.2597 Shinomiya Hiratsuka-shiKanagawa 254JapanJapan',1),('00:C0:70','Sectra Secure-transmission Ab','Sectra Secure-transmission AbTeknikringen 2S-583 30 LinkopingSwedenSweden',1),('00:C0:71','Areanex Communications, Inc.','Areanex Communications, Inc.3333 Octavius Drive Unit CSanta Clara Ca 95051United States',1),('00:C0:72','Knx Ltd.','Knx Ltd.Hollingwood HouseWest Chevin Road Otley, W. YorkshireLs21 3ha United KingdomUnited Kingdom',1),('00:C0:73','Xedia Corporation','Xedia Corporation301 Ballardvale StreetWilmington Ma 01887United States',1),('00:C0:74','Toyoda Automatic Loom','Toyoda Automatic LoomWorks, Ltd.2-1, Toyoda-cho, Kariya-shi Aichi-ken448 JapanJapan',1),('00:C0:75','Xante Corporation','Xante Corporation2559 Emogene StreetMobile Al 36606United States',1),('00:C0:76','I-data International A-s','I-data International A-s35-43 VadstrupvejDk-2880 BagsvaerdDenmarkDenmark',1),('00:C0:77','Daewoo Telecom Ltd.','Daewoo Telecom Ltd.Products Design Dept. 1Products Design Center Socho. P.o. Box 1Seoul Seoul KoreaKorea, Republic Of',1),('00:C0:78','Computer Systems Engineering','Computer Systems Engineering46791 Fremont Blvd.Fremont Ca 94538United States',1),('00:C0:79','Fonsys Co.,ltd.','Fonsys Co.,ltd.209-5, Yangjae, SeochoSeoul  A37130KoreaKorea, Republic Of',1),('00:C0:7A','Priva B.v.','Priva B.v.P.o. Box 182678  Zg De Lier (z-h)Netherlands',1),('00:C0:7B','Ascend Communications, Inc.','Ascend Communications, Inc.1701 Harbor Bay ParkwayAlameda Ca 94502United States',1),('00:C0:7C','Hightech Information','Hightech InformationSystem Ltd.Unit 7, 2/f, Po Lung Centre 11 Wang ChiuHong KongHong Kong',1),('00:C0:7D','Risc Developments Ltd.','Risc Developments Ltd.117 Hatfield RoadSt. Albans, Herts Al14j5EnglandUnited Kingdom',1),('00:C0:7E','Kubota Corporation Electronic','Kubota Corporation ElectronicDevice Dept.2-35, Jinmu-cho, Yao-city Osaka Pref.Japan #581Japan',1),('00:C0:7F','Nupon Computing Corp.','Nupon Computing Corp.1391 Warner Ave., -suiteTustin Ca 92680United States',1),('00:C0:80','Netstar, Inc.','Netstar, Inc.Cedar Business Center1801 E. 79th StreetMinneapolis Mn 55425-1235United States',1),('00:C0:81','Metrodata Ltd.','Metrodata Ltd.Blenheim HouseCrabtree Office Village Eversley Way, EgTw20 8ry Tw20 8ry EnglandUnited Kingdom',1),('00:C0:82','Moore Products Co.','Moore Products Co.Sumneytown PikeSpring House Pa 19477United States',1),('00:C0:83','Trace Mountain Products, Inc.','Trace Mountain Products, Inc.1040 East Brokaw RoadSan Jose Ca 95131United States',1),('00:C0:84','Data Link Corp. Ltd.','Data Link Corp. Ltd.3-15-3 MidorichoTokorozawa-city Saitama  359JapanJapan',1),('00:C0:85','Electronics For Imaging, Inc.','Electronics For Imaging, Inc.2855 Campus DriveSan Mateo Ca 94403United States',1),('00:C0:86','The Lynk Corporation','The Lynk Corporation101 Queens DriveKing Of Prussia Pa 19406United States',1),('00:C0:87','Uunet Technologies, Inc.','Uunet Technologies, Inc.3110 Fairview Park Dr. #570Falls Church Va 22042United States',1),('00:C0:88','Ekf Elektronik Gmbh','Ekf Elektronik GmbhPhilipp-reis-str. 44700 HammGermanyGermany',1),('00:C0:89','Telindus Distribution','Telindus DistributionGeldenaaksebaan 3353001 HeverleeBelgiumBelgium',1),('00:C0:8A','Lauterbach Datentechnik Gmbh','Lauterbach Datentechnik GmbhFichenstr. 27D-85649 HofoldingGermanyGermany',1),('00:C0:8B','Risq Modular Systems, Inc.','Risq Modular Systems, Inc.39899 Balentine Drive-ste #375Newark Ca 94560United States',1),('00:C0:8C','Performance Technologies, Inc.','Performance Technologies, Inc.315 Science ParkwayRochester Ny 14620United States',1),('00:C0:8D','Tronix Product Development','Tronix Product Development4908 E. Mcdowell Rd. Ste.#100Phoenix Az 85008United States',1),('00:C0:8E','Network Information Technology','Network Information Technology10430 S. De Anza Blvd.Cupertino Ca 95014United States',1),('00:C0:8F','Panasonic Electric Works Co., Ltd.','Panasonic Electric Works Co., Ltd.Tsu-factory1668 Fujikata Tsu-shiMie-ken 514-8555Japan',1),('00:C0:90','Praim S.r.l.','Praim S.r.l.Via Maccani, 16938100 Trento (tn)Italy',1),('00:C0:91','Jabil Circuit, Inc.','Jabil Circuit, Inc.32275 Mally RoadMadison Heights Mi 48071United States',1),('00:C0:92','Mennen Medical Inc.','Mennen Medical Inc.10123 Main StreetClarence Ny 14031-2095United States',1),('00:C0:93','Alta Research Corp.','Alta Research Corp.614 South Federal HighwayDeerfield Beach Fl 33441United States',1),('00:C0:94','Vmx Inc.','Vmx Inc.2115 Onel DriveSan Jose Ca 95131United States',1),('00:C0:95','Znyx','Znyx48421 Milmont DriveFremont Ca 94538United States',1),('00:C0:96','Tamura Corporation','Tamura CorporationCommunication Systems Div.19-43 Higashi Oizumi 1 Chome Nerima-ku,JapanJapan',1),('00:C0:97','Archipel Sa','Archipel Sa1 Rue Du BullozF 74940 Annecy-le-vieuxFranceFrance',1),('00:C0:98','Chuntex Electronic Co., Ltd.','Chuntex Electronic Co., Ltd.6f., No.2, Alley 6, Lane 235Pao Chiao Rd., Hsin Tien, Taipei HsienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:C0:99','Yoshiki Industrial Co.,ltd.','Yoshiki Industrial Co.,ltd.1-38 Matsugasaki 2-chomeYonezawa Yamagata992 JapanJapan',1),('00:C0:9A','Photonics Corporation','Photonics Corporation2940 North First StreetSan Jose Ca 95123-2021United States',1),('00:C0:9B','Reliance Comm/tec, R-tec','Reliance Comm/tec, R-tecSystems Inc.2100 Reliance Parkway,  Ms 22Bedford Tx 76021United States',1),('00:C0:9C','Hioki E.e. Corporation','Hioki E.e. Corporation81 Koizumi, Ueda, NaganoChiyoda-kuTokyo  386-1192Japan',1),('00:C0:9D','Distributed Systems Intl, Inc','Distributed Systems Intl, Inc531 West Roosevlet Rd, Ste #2Wheaton Il 60187United States',1),('00:C0:9E','Cache Computers, Inc.','Cache Computers, Inc.46600 Landing ParkwayFremont Ca 94538United States',1),('00:C0:9F','Quanta Computer, Inc.','Quanta Computer, Inc.7f., 116, Hou-kang St.,Shih-lin Dist. TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:C0:A0','Advance Micro Research, Inc.','Advance Micro Research, Inc.2045 Corporate CourtSan Jose Ca 95131United States',1),('00:C0:A1','Tokyo Denshi Sekei Co.','Tokyo Denshi Sekei Co.255-1 Renkoji, Tama-shiTokyoJapan 206Japan',1),('00:C0:A2','Intermedium A/s','Intermedium A/sOdinsvej 19Dk-2600 GlostrupDenmarkDenmark',1),('00:C0:A3','Dual Enterprises Corporation','Dual Enterprises Corporation9th Floor 48 Nan-kang RoadSec.3, TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:C0:A4','Unigraf Oy','Unigraf OyRuukintie 1802320 Esp00FinlandFinland',1),('00:C0:A5','Dickens Data Systems','Dickens Data Systems1175 Northmeadow Pkwy-ste #150Roswell Ga 30076United States',1),('00:C0:A6','Exicom Australia Pty. Ltd','Exicom Australia Pty. Ltd44-46 Mandarin StreetVillawood Nsw 2163AustraliaAustralia',1),('00:C0:A7','Seel Ltd.','Seel Ltd.3 Young SquareLivingston  Eh54  9bjScotlandUnited Kingdom',1),('00:C0:A8','Gvc Corporation','Gvc Corporation1961 Concourse Drive-steSan Jose Ca 95131United States',1),('00:C0:A9','Barron Mccann Ltd.','Barron Mccann Ltd.Bemac HouseFifth Avenue, Letchworth Herts., Sg6 2hfUnited KingdomUnited Kingdom',1),('00:C0:AA','Silicon Valley Computer','Silicon Valley Computer441 N. Whisman Rd., Bldg.#13Mt. View Ca 94043United States',1),('00:C0:AB','Telco Systems, Inc.','Telco Systems, Inc.63 Nathan StreetNorwood Ma 02072United States',1),('00:C0:AC','Gambit Computer Communications','Gambit Computer CommunicationsSoltam Industrial ParkP.o. Box 107 Yokneam 20692IsraelIsrael',1),('00:C0:AD','Marben Communication Systems','Marben Communication Systems1 Rue Du Bois ChalandLisses 91029 Evry CedexFranceFrance',1),('00:C0:AE','Towercom Co. Inc. Dba Pc House','Towercom Co. Inc. Dba Pc House841 E. Artesia Blvd.Carson Ca 90746United States',1),('00:C0:AF','Teklogix Inc.','Teklogix Inc.2100 Meadowvale BoulevardMississauga, Ontario,Canada L5n 7j9Canada',1),('00:C0:B0','Gcc Technologies,inc.','Gcc Technologies,inc.580 Winter StreetWaltham Ma 02154United States',1),('00:C0:B1','Genius Net Co.','Genius Net Co.4f, Hansoo B/d 210-5Yangjae-dong, Seocho-gu SeoulSouth KoreaKorea, Republic Of',1),('00:C0:B2','Norand Corporation','Norand Corporation550 2nd Street SeCedar Rapids Ia 52401United States',1),('00:C0:B3','Comstat Datacomm Corporation','Comstat Datacomm Corporation1720 Spectrum DriveLawrenceville Ga 30243United States',1),('00:C0:B4','Myson Technology, Inc.','Myson Technology, Inc.2f, No. 3, Industry E. Rd.ivScience-based Industrial Park Hsinchu, (TaiwanTaiwan, Republic Of China',1),('00:C0:B5','Corporate Network Systems,inc.','Corporate Network Systems,inc.5711 Six Forks Road--ste #306Raleigh Nc 27609United States',1),('00:C0:B6','Adaptec, Inc.','Adaptec, Inc.691 South Milpitas BoulevardMilpitas Ca 95035United States',1),('00:C0:B7','American Power Conversion Corp','American Power Conversion Corp267 Boston Road #2North Billerica Ma 01862United States',1),('00:C0:B8','Frasers Hill Ltd.','Frasers Hill Ltd.27502 W. Gill RoadP.o. Box 189Morristown Az 85342United States',1),('00:C0:B9','Funk Software, Inc.','Funk Software, Inc.222 Third StreetCambridge Ma 02142United States',1),('00:C0:BA','Netvantage','Netvantage201 Continental Blvd.-ste.#201El Secundo Ca 90245United States',1),('00:C0:BB','Forval Creative, Inc.','Forval Creative, Inc.3-27-12 HongoBunkyo-ku Tokyo  113JapanJapan',1),('00:C0:BC','Telecom Australia/cssc','Telecom Australia/csscLocked Bag 8812Southcoast Mail Centre 2521 N.s.w.AustraliaAustralia',1),('00:C0:BD','Inex Technologies, Inc.','Inex Technologies, Inc.3350 Scott Blvd.Bldg.#29Santa Clara Ca 95054United States',1),('00:C0:BE','Alcatel - Sel','Alcatel - SelLorenz Str.7000 Stuttgart 40GermanyGermany',1),('00:C0:BF','Technology Concepts, Ltd.','Technology Concepts, Ltd.Grange EstateCwmbran, Gwent, Np44 3xrUnited KingdomUnited Kingdom',1),('00:C0:C0','Shore Microsystems, Inc.','Shore Microsystems, Inc.23 Pocahontas AvenueOceanport Nj 07757United States',1),('00:C0:C1','Quad/graphics, Inc.','Quad/graphics, Inc.N63 W23075 Hwy 74Sussex Wi 53089United States',1),('00:C0:C2','Infinite Networks Ltd.','Infinite Networks Ltd.19 Brookside Road, OxheyWatford, Herts  Wd1 4bw EnglandUnited KingdomUnited Kingdom',1),('00:C0:C3','Acuson Computed Sonography','Acuson Computed Sonography1220 Charleston RoadP.o. Box 7393Mountain View Ca 94039-7393United States',1),('00:C0:C4','Computer Operational','Computer OperationalRequirement Analysts LtdCoral House, 274a High Street Aldershot,Gu12 4lz Gu12 4lz EnglandUnited Kingdom',1),('00:C0:C5','Sid Informatica','Sid InformaticaRua Dr. Geraldo Campos Moreira240 - 5 Andar Cep 04571-020 Sao Paulo -BrazilBrazil',1),('00:C0:C6','Personal Media Corp.','Personal Media Corp.1-7-7 My Bldg. HiratsukaShinagawa,  Tokyo 142JapanJapan',1),('00:C0:C7','Sparktrum Microsystems, Inc.','Sparktrum Microsystems, Inc.2860 Zanker Road,  Ste.#210San Jose Ca 95134United States',1),('00:C0:C8','Micro Byte Pty. Ltd.','Micro Byte Pty. Ltd.197 Sherbourne Rd.Montmorency Melbourne VicAustralia 3094Australia',1),('00:C0:C9','Elsag Bailey Process','Elsag Bailey ProcessAutomation29801 Euclid Avenue Ms-3s1Wickliffe Oh 44092United States',1),('00:C0:CA','Alfa, Inc.','Alfa, Inc.11-1, Industry East Road IvScience Based Industrial Park HsinchuTaiwanTaiwan, Republic Of China',1),('00:C0:CB','Control Technology Corporation','Control Technology Corporation25 South StreetHopkinton Ma 01748United States',1),('00:C0:CC','Telesciences Co Systems, Inc.','Telesciences Co Systems, Inc.351 New Albany Rd.Moorestown Nj 08057-1177United States',1),('00:C0:CD','Comelta, S.a.','Comelta, S.a.Avda. Parc Tecnologic, 408290 Cerdanyola Del Valles BarcelonaSpainSpain',1),('00:C0:CE','Cei Systems & Engineering Pte','Cei Systems & Engineering PteBlk 73 #02-18 Ayer Rajah CrescAyer Rajah Industrial EstateSingapore 0513Singapore',1),('00:C0:CF','Imatran Voima Oy','Imatran Voima OyIvoP.o. Box 340 02151 EspooFinlandFinland',1),('00:C0:D0','Ratoc System Inc.','Ratoc System Inc.Asahi Namba Bldg.1-6-14 Shikitsu Higashi Naniwaku Osaka C556 JapanJapan',1),('00:C0:D1','Comtree Technology Corporation','Comtree Technology Corporation5f-7, No. 1, Fu-hsing North RdTaipeiTaiwan R.o.c.China',1),('00:C0:D2','Syntellect, Inc.','Syntellect, Inc.15810 N. 28th AvenuePhoenix Az 85023United States',1),('00:C0:D3','Olympus Image Systems, Inc.','Olympus Image Systems, Inc.15271 Barranca ParkwayIrvine Ca 92718-2201United States',1),('00:C0:D4','Axon Networks, Inc.','Axon Networks, Inc.104 Spruce StreetWatertown Ma 02172United States',1),('00:C0:D5','Werbeagentur Jrgen Siebert','Werbeagentur Jrgen SiebertIm Klostergarten 8D-50321 BrhlGermany',1),('00:C0:D6','J1 Systems, Inc.','J1 Systems, Inc.3 Dunwoody Park-ste.#103Atlanta Ga 30338United States',1),('00:C0:D7','Taiwan Trading Center Dba','Taiwan Trading Center DbaTtc Computer Products3244 N. Skyway Circle #102Irving Tx 75038United States',1),('00:C0:D8','Universal Data Systems','Universal Data Systems5000 Bradford DriveHuntsville Al 35805-1993United States',1),('00:C0:D9','Quinte Network Confidentiality','Quinte Network ConfidentialityEquipment Inc.207 - 121 Dimdas Street East Belleville,Canada K8n 1c3Canada',1),('00:C0:DA','Nice Systems Ltd.','Nice Systems Ltd.3 Tevuot Haaretz StTel Aviv  69546IsraelIsrael',1),('00:C0:DB','Ipc Corporation (pte) Ltd.','Ipc Corporation (pte) Ltd.122 Eunos Ave., 7 #05-10Singapore 1440Singapore',1),('00:C0:DC','Eos Technologies, Inc.','Eos Technologies, Inc.3945 Freedom Circle, Ste.#770Santa Clara Ca 95054United States',1),('00:C0:DD','Qlogic Corporation','Qlogic Corporation6321 Bury Dr.Eden Prarie Mn 55346United States',1),('00:C0:DE','Zcomm, Inc.','Zcomm, Inc.1050 C East Duane AvenueSunnyvale Ca 94086United States',1),('00:C0:DF','Kye Systems Corp.','Kye Systems Corp.No. 492 Sec 5, Chung Hsin RoadTaipei Hsien 241Taiwan, Republic Of China',1),('00:C0:E0','Dsc Communication Corp.','Dsc Communication Corp.1000 Coit Road,  Ms#advp 3Plano Tx 75075United States',1),('00:C0:E1','Sonic Solutions','Sonic Solutions1891 E. Francisco Blvd.San Rafael Ca 94901United States',1),('00:C0:E2','Calcomp, Inc.','Calcomp, Inc.2411 W. Lapalma AvenueP.o. Box 3250, Ms22Anaheim Ca 92803-3250United States',1),('00:C0:E3','Ositech Communications, Inc.','Ositech Communications, Inc.679 Southgate DriveGuelph, OntarioCanada N1g 4s2Canada',1),('00:C0:E4','Siemens Building','Siemens BuildingTechnologies, Inc.1000 Deerfield ParkwayBuffalo Grove Il 60089United States',1),('00:C0:E5','Gespac, S.a.','Gespac, S.a.Chemin Des Aulx 18Ch-1228 GenevaSwitzerlandSwitzerland',1),('00:C0:E6','Verilink Corporation','Verilink Corporation127 Jetplex CircleMadison Al 35758United States',1),('00:C0:E7','Fiberdata Ab','Fiberdata AbP.o. Box 20095S-16102 BrommaSwedenSweden',1),('00:C0:E8','Plexcom, Inc.','Plexcom, Inc.65 Moreland RoadenuyeSimi Valley Ca 93065United States',1),('00:C0:E9','Oak Solutions, Ltd.','Oak Solutions, Ltd.Broadway House149-151 St Neots Rd, Hardwick CambridgeEnglandUnited Kingdom',1),('00:C0:EA','Array Technology Ltd.','Array Technology Ltd.145 Frimley RoadCamberley, SurreyEngland Gu15 2psUnited Kingdom',1),('00:C0:EB','Seh Computertechnik Gmbh','Seh Computertechnik GmbhSuedring 11P.o. Box 140829 D-33628 BielefeldGermanyGermany',1),('00:C0:EC','Dauphin Technology','Dauphin Technology450 Eisenhower Lane NorthLombard Il 60148United States',1),('00:C0:ED','Us Army Electronic','Us Army ElectronicProving Ground1838 Paseo San LuisSierra Vista Az 85635United States',1),('00:C0:EE','Kyocera Corporation','Kyocera Corporation2-14-9 TamagawadaiSetagaya-ku, Tokyo158 JapanJapan',1),('00:C0:EF','Abit Corporation','Abit Corporation29-11 Hiraoka-choHachiouji-shi Tokyo192 JapanJapan',1),('00:C0:F0','Kingston Technology Corp.','Kingston Technology Corp.17600 Newhope StreetFountain Valley Ca 92708United States',1),('00:C0:F1','Shinko Electric Co., Ltd.','Shinko Electric Co., Ltd.Computer System Division150 Motoyashiki, Sanya-cho Toyohashi-shiJapan 441-31Japan',1),('00:C0:F2','Transition Networks','Transition Networks6475 City West ParkwayMinneapolis Mn 55344United States',1),('00:C0:F3','Network Communications Corp.','Network Communications Corp.5501 Green Valley DriveBloomington Mn 55437-1085United States',1),('00:C0:F4','Interlink System Co., Ltd.','Interlink System Co., Ltd.Interlink B/d, 476-20Seogyo-dong, Mapo-ku SeoulKoreaKorea, Republic Of',1),('00:C0:F5','Metacomp, Inc.','Metacomp, Inc.10989 Via FronteraSan Diego Ca 92127United States',1),('00:C0:F6','Celan Technology Inc.','Celan Technology Inc.No. 101, Min-hsiang St.Hsin-chu CityTaiwan Taiwan R.o.c.China',1),('00:C0:F7','Engage Communication, Inc.','Engage Communication, Inc.9053 Soquel DriveAptos Ca 95003-4034United States',1),('00:C0:F8','About Computing Inc.','About Computing Inc.P.o. Box 172Belmont Ma 02178United States',1),('00:C0:F9','Motorola Embedded Computing Group','Motorola Embedded Computing Group120 Turnpike RoadSouthborough Ma 01772United States',1),('00:C0:FA','Canary Communications, Inc.','Canary Communications, Inc.1851 Zanker RoadSan Jose Ca 95112-4213United States',1),('00:C0:FB','Advanced Technology Labs','Advanced Technology Labs22100 Bothell Highway S.e.P.o. Box 3003Bothell Wa 98041-3003United States',1),('00:C0:FC','Elastic Reality, Inc.','Elastic Reality, Inc.925 Stewart StreetMadison Wi 53713United States',1),('00:C0:FD','Prosum','Prosum12 Rue Sadi-carnot94370  NoiseauFranceFrance',1),('00:C0:FE','Aptec Computer Systems, Inc.','Aptec Computer Systems, Inc.P.o. Box 6750Portland Or 97228-6750United States',1),('00:C0:FF','Dot Hill Systems Corporation','Dot Hill Systems Corporation6305 El Camino RealCarlsbad Ca 92009United States',1),('00:CB:BD','Cambridge Broadband Networks Ltd.','Cambridge Broadband Networks Ltd.Selwyn House Cambridge Business ParkCambridge Business ParkCambridge  Cb4 0wzUnited Kingdom',1),('00:CF:1C','Communication Machinery Corp.','Communication Machinery Corp.1226 AnacapaSanta Barbara Ca 93101United States',1),('00:D0:00','Ferran Scientific, Inc.','Ferran Scientific, Inc.11558 Sorrento Valley RoadSuite  #1San Diego Ca 92121United States',1),('00:D0:01','Vst Technologies, Inc.','Vst Technologies, Inc.125 Nagog ParkActon Ma 01720United States',1),('00:D0:02','Ditech Corporation','Ditech Corporation825 East Middlefield RdMountain View Ca 94043United States',1),('00:D0:03','Comda Enterprises Corp.','Comda Enterprises Corp.2f, No. 501-18, Chungchen RoadHsintien, TaipeiTaiwan Taiwan RocTaiwan, Republic Of China',1),('00:D0:04','Pentacom Ltd.','Pentacom Ltd.8 Hasadnaot StreetP.o. Box 12109 Herzlia 46733IsraelIsrael',1),('00:D0:05','Zhs Zeitmanagementsysteme','Zhs ZeitmanagementsystemeHard-und Software GmbhKreuzberger Ring 56 65205 WiesbadenGermanyGermany',1),('00:D0:06','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:D0:07','Mic Associates, Inc.','Mic Associates, Inc.1510-1, KaidokiTama, TokyoJapan Japan 206-0012Japan',1),('00:D0:08','Mactell Corporation','Mactell Corporation7000 Cameron RoadAustin Tx 78752United States',1),('00:D0:09','Hsing Tech. Enterprise Co. Ltd','Hsing Tech. Enterprise Co. LtdNo.2, Lane 128, Sec. 2Chung Shan N. Rd. TaipeiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:D0:0A','Lanaccess Telecom S.a.','Lanaccess Telecom S.a.Gran Via 8-10  4  108902- Lhospitalet De LlobregatSpainSpain',1),('00:D0:0B','Rhk Technology, Inc.','Rhk Technology, Inc.1050 East Maple RoadTroy Mi 48083United States',1),('00:D0:0C','Snijder Micro Systems','Snijder Micro SystemsP.o. Box 300Nl-5750 Ah DeurneThe NetherlandsNetherlands',1),('00:D0:0D','Micromeritics Instrument','Micromeritics InstrumentCorporationOne Micromeeritics DriveNorcross Ga 30093-1877United States',1),('00:D0:0E','Pluris, Inc.','Pluris, Inc.10455 Bandley DriveCupertino Ca 95014United States',1),('00:D0:0F','Speech Design Gmbh','Speech Design GmbhIndustriestr. 1D-82110 GermeringGermanyGermany',1),('00:D0:10','Convergent Networks, Inc.','Convergent Networks, Inc.2 Highwood DriveTewksbury Ma 01876United States',1),('00:D0:11','Prism Video, Inc.','Prism Video, Inc.15851 Dallas Parkway-ste.#1060Addison Tx 75001United States',1),('00:D0:12','Gateworks Corp.','Gateworks Corp.7631 Morro RoadAtascadero Ca 93422United States',1),('00:D0:13','Primex Aerospace Company','Primex Aerospace CompanyP.o. Box 9700911441 Willows Road NeRedmond Wa 98073-9709United States',1),('00:D0:14','Root, Inc.','Root, Inc.8f Toc2 Bldg, 7-21-11 Nishi-gotandaShinagawa-kuTokyo 141-0031Japan',1),('00:D0:15','Univex Microtechnology Corp.','Univex Microtechnology Corp.2, Tze-chiang 3rd RoadChung-li Industrial Park, Chung-liTaiwanTaiwan, Republic Of China',1),('00:D0:16','Scm Microsystems, Inc.','Scm Microsystems, Inc.160 Knowles DriveLos Gatos Ca 95032United States',1),('00:D0:17','Syntech Information Co., Ltd.','Syntech Information Co., Ltd.8f, 210, Ta-tung Rd., Sec. 3Hsi-chih, Taipei HsienTaiwan Taiwan RocTaiwan, Republic Of China',1),('00:D0:18','Qwes. Com, Inc.','Qwes. Com, Inc.14742 Newport Ave. - Ste. #203Tustin Ca 92780United States',1),('00:D0:19','Dainippon Screen Corporate','Dainippon Screen CorporateRepresentatives Of America,inc17942 Cowan AvenueIrvine Ca 92614United States',1),('00:D0:1A','Urmet  Tlc S.p.a.','Urmet  Tlc S.p.a.Via Di Castel Romano 16700128 - RomaItaly',1),('00:D0:1B','Mimaki Engineering Co., Ltd.','Mimaki Engineering Co., Ltd.5-9-41 Kita ShinagawaShinagawa-ku Tokyo 141-0001JapanJapan',1),('00:D0:1C','Sbs Technologies,','Sbs Technologies,Connectivity Products1284 Corporate Center DriveSt. Paul Mn 55121-1245United States',1),('00:D0:1D','Furuno Electric Co., Ltd.','Furuno Electric Co., Ltd.No. 9-52, Ashihara-choNishinomiya-city662-8580Japan',1),('00:D0:1E','Pingtel Corp.','Pingtel Corp.773 Winter StreetN. Andover Ma 01845United States',1),('00:D0:1F','Ctam Pty. Ltd.','Ctam Pty. Ltd.399 High StreetAshburton 3147 VictoriaAustraliaAustralia',1),('00:D0:20','Aim System, Inc.','Aim System, Inc.4th Floor Chungwoo B/d 219-1Poyee-dong, Gangnam-ku Seol, 135-200KoreaKorea, Republic Of',1),('00:D0:21','Regent Electronics Corp.','Regent Electronics Corp.200 Centennial Ave.-ste. #201Piscataway Nj 08854United States',1),('00:D0:22','Incredible Technologies, Inc.','Incredible Technologies, Inc.1600 Hicks RoadRolling Meadows Il 60008United States',1),('00:D0:23','Infortrend Technology, Inc.','Infortrend Technology, Inc.10f, No. 33 San-min Rd.Sec. 2 Panchiao City Taipei HsienTaiwanTaiwan, Republic Of China',1),('00:D0:24','Cognex Corporation','Cognex CorporationModular Vision Systems DivisionIn-sight Products Group 15865 Sw 74th AvPortland Or 97224United States',1),('00:D0:25','Xrosstech, Inc.','Xrosstech, Inc.Habdong B/d 5f 210-2Yangjae-dong, Seocho-ku SeoulKoreaKorea, Republic Of',1),('00:D0:26','Hirschmann Austria Gmbh','Hirschmann Austria GmbhOberer Paspelsweg 6 - 86830 Rankweil-brederisAustriaAustria',1),('00:D0:27','Applied Automation, Inc.','Applied Automation, Inc.P.o. Box 9999Bartlesville Ok 74005-9999United States',1),('00:D0:28','Omneon Video Networks','Omneon Video Networks965 Stewart DriveSunnyvale Ca 94086-3913United States',1),('00:D0:29','Wakefern Food Corporation','Wakefern Food Corporation230 Raritan Center ParkwayEdison Nj 08837United States',1),('00:D0:2A','Voxent Systems Ltd.','Voxent Systems Ltd.Unit 2, Rowan HouseSheldon Business ParkChippenham Wiltshire Sn14 0sqUnited Kingdom',1),('00:D0:2B','Jetcell, Inc.','Jetcell, Inc.173 Constitution DriveMenlo Park Ca 94025-1106United States',1),('00:D0:2C','Campbell Scientific, Inc.','Campbell Scientific, Inc.815 W. 1800 N.Logan Ut 84321-1784United States',1),('00:D0:2D','Ademco','Ademco165 Eileen WaySyosset Ny 11791United States',1),('00:D0:2E','Communication Automation Corp.','Communication Automation Corp.1180 Mcdermott DriveWest Chester Pa 19380United States',1),('00:D0:2F','Vlsi Technology Inc.','Vlsi Technology Inc.8375 S. River ParkwayTempe Az 85284United States',1),('00:D0:30','Safetran Systems Corp','Safetran Systems Corp10655 7th StreetRancho Cucamonga Ca 91730United States',1),('00:D0:31','Industrial Logic Corporation','Industrial Logic Corporation15 Piedmont Center-ste #700Atlanta Ga 30305United States',1),('00:D0:32','Yano Electric Co., Ltd.','Yano Electric Co., Ltd.7-3-1 IbukidaihigashimachiNishi-ku, Kobe, 651-2242JapanJapan',1),('00:D0:33','Dalian Daxian Network','Dalian Daxian NetworkSystem Co., Ltd.98 Shengli Rd Xigang District Dalian, P.ChinaChina',1),('00:D0:34','Ormec Systems Corp.','Ormec Systems Corp.19 Linden ParkRochester Ny 14625United States',1),('00:D0:35','Behavior Tech. Computer Corp.','Behavior Tech. Computer Corp.20f-b, No.98, Sec. 1,Sintai 5th Rd.Sijhih City Taipei County 22102Taiwan, Republic Of China',1),('00:D0:36','Technology Atlanta Corp.','Technology Atlanta Corp.141 W. Wieuca Rd. N.e.Suite #300Atlanta Ga 30342United States',1),('00:D0:37','Pace France','Pace France33 Rue De Verdun92150 SuresnesFrance',1),('00:D0:38','Fivemere, Ltd.','Fivemere, Ltd.Unit 1-heron Industrial EstateBasingstoke Road Spencers Wood,  ReadingRg7 1pj EnglandUnited Kingdom',1),('00:D0:39','Utilicom, Inc.','Utilicom, Inc.323 Love PlaceSanta Barbara Ca 93112-3289United States',1),('00:D0:3A','Zoneworx, Inc.','Zoneworx, Inc.40925 County Center DriveSuite #200Temecula Ca 92592United States',1),('00:D0:3B','Vision Products Pty. Ltd.','Vision Products Pty. Ltd.Second Avenue, Technology ParkMawson LakesAustralia 5095Australia',1),('00:D0:3C','Vieo, Inc.','Vieo, Inc.12416 Hymeadow Drive,Suite 200Austin Tx 78750United States',1),('00:D0:3D','Galileo Technology, Ltd.','Galileo Technology, Ltd.Moshav ManofD.n. Misgav 20184Israel',1),('00:D0:3E','Rocketchips, Inc.','Rocketchips, Inc.7901 Xerxes Ave. S.Minneapolis Mn 55431United States',1),('00:D0:3F','American Communication','American CommunicationTechnoligies International Inc320 Professional Center Dr. Suite #100Rohnert Park Ca 94928United States',1),('00:D0:40','Sysmate Co., Ltd.','Sysmate Co., Ltd.1091 Wolpyong-dongSeo-gu, Deajcon 302-280South KoreaKorea, Republic Of',1),('00:D0:41','Amigo Technology Co., Ltd.','Amigo Technology Co., Ltd.4f-1b, No.12, Lane 609, Sec.5,Chung Hsin Road, San Chung Taipei HsienTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:D0:42','Mahlo Gmbh & Co. Ug','Mahlo Gmbh & Co. UgDonaustrasse 12D-93342 Saal/donauGermanyGermany',1),('00:D0:43','Zonal Retail Data Systems','Zonal Retail Data Systems24 Forth StreetEdinburghScotlandUnited Kingdom',1),('00:D0:44','Alidian Networks, Inc.','Alidian Networks, Inc.1330 W. Middlefield RoadMountain View Ca 94043United States',1),('00:D0:45','Kvaser Ab','Kvaser AbBox 4076511 04 KinnahultSwedenSweden',1),('00:D0:46','Dolby Laboratories, Inc.','Dolby Laboratories, Inc.100 Potrero AvenueSan Francisco Ca 94103-4938United States',1),('00:D0:47','Xn Technologies','Xn TechnologiesP.o. Box 350Cheney Wa 99004United States',1),('00:D0:48','Ecton, Inc.','Ecton, Inc.5168 Campus DrivePlymouth Meeting Pa 19462United States',1),('00:D0:49','Impresstek Co., Ltd.','Impresstek Co., Ltd.6f, Specialty Construction Ctr1290, Sunsan-dong,so-gu302-120 Korea (rep.)Korea, Republic Of',1),('00:D0:4A','Presence Technology Gmbh','Presence Technology Gmbh+ Co. KgSendenhorster Str. 32 D-48317 DrensteinfGermanyGermany',1),('00:D0:4B','La Cie Group S.a.','La Cie Group S.a.17 Rue Ampere91349 Massy CedexFranceFrance',1),('00:D0:4C','Eurotel Telecom Ltd.','Eurotel Telecom Ltd.Canister HouseJewry Street Winchester B023 8saUnited KingdomUnited Kingdom',1),('00:D0:4D','Div Of Research & Statistics','Div Of Research & StatisticsBog Of The Federal Reserve SysMail Stop 96 20th &Washington Dc 20551United States',1),('00:D0:4E','Logibag','Logibag2, Rue De La Mandinire72300 Sable/sartheFrance',1),('00:D0:4F','Bitronics, Inc.','Bitronics, Inc.P.o. Box 22290Lehigh Valley Pa 18002-2290United States',1),('00:D0:50','Iskratel','IskratelLjubljanska C. 24a4000 KranjSloveniaSlovenia',1),('00:D0:51','O2 Micro, Inc.','O2 Micro, Inc.2901 Tasman Drive, Ste.#205Santa Clara Ca 95054United States',1),('00:D0:52','Ascend Communications, Inc.','Ascend Communications, Inc.One Ascend Plaza1701 Harbor Bay ParkwayAlameda Ca 94502-3002United States',1),('00:D0:53','Connected Systems','Connected Systems126 W. Figueroa StreetSanta Barbara Ca 93101United States',1),('00:D0:54','Sas Institute Inc.','Sas Institute Inc.Sas Campus Drive, R4Cary Nc 27511United States',1),('00:D0:55','Kathrein-werke Kg','Kathrein-werke KgAnton-kathrein-strass 1-3D-83004 RosenheimGermanyGermany',1),('00:D0:56','Somat Corporation','Somat Corporation702 Killarney StreetUrbana Il 61801United States',1),('00:D0:57','Ultrak, Inc.','Ultrak, Inc.1301 Waters Ridge DriveLewisville Tx 75057United States',1),('00:D0:58','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:D0:59','Ambit Microsystems Corp.','Ambit Microsystems Corp.5f-1, 5 Hsin-an RoadScience-based Industrial Park HsinchuTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:D0:5A','Symbionics, Ltd.','Symbionics, Ltd.St. Johns Innovation ParkCambridge  Cb4 0wsEnglandUnited Kingdom',1),('00:D0:5B','Acroloop Motion Control','Acroloop Motion ControlSystems3650 Chestnut St. N.Chaska Mn 55318United States',1),('00:D0:5C','Technotrend Systemtechnik Gmbh','Technotrend Systemtechnik GmbhWilhelm-wolff-strasse 6Ger-99099 ErfurtGermanyGermany',1),('00:D0:5D','Intelliworxx, Inc.','Intelliworxx, Inc.1819 Main Street,  Ste #1101Sarasota Fl 34236United States',1),('00:D0:5E','Stratabeam Technology, Inc.','Stratabeam Technology, Inc.1943 Landings DriveMountain View Ca 94043United States',1),('00:D0:5F','Valcom, Inc.','Valcom, Inc.1111 Industry AvenueRoanoke Va 24013United States',1),('00:D0:60','Panasonic Europe Ltd.','Panasonic Europe Ltd.Laboratories GmbhMonzastr. 4c D-63225 LangenGermanyGermany',1),('00:D0:61','Tremon Enterprises Co., Ltd.','Tremon Enterprises Co., Ltd.15f, No. 116, Sec. 1Hsin-tai 5th Road Hsichih, Taipei CountyTaiwan Taiwan RocTaiwan, Republic Of China',1),('00:D0:62','Digigram','DigigramParc De Pre Milliet38330 MontbonnotFranceFrance',1),('00:D0:63','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:D0:64','Multitel','Multitel2905 Rue De CellesQuebec City, Quebec ProvinceCanada Canada G2c-1w7Canada',1),('00:D0:65','Toko Electric','Toko Electric4008 Kurohama, Hasuda-shiSaitama 349-0192JapanJapan',1),('00:D0:66','Wintriss Engineering Corp.','Wintriss Engineering Corp.6344 Ferris SquareSan Diego Ca 92121United States',1),('00:D0:67','Campio Communications','Campio Communications2033 Gateway Pl, Suite #600San Jose Ca 95110United States',1),('00:D0:68','Iwill Corporation','Iwill CorporationNo.10, Wu-chuan 3 Rd,Hsin-chuan City TaipeiTaiwanTaiwan, Republic Of China',1),('00:D0:69','Technologic Systems','Technologic Systems16610 E. Laser Drive-ste. #10Fountain Hills Az 85268United States',1),('00:D0:6A','Linkup Systems Corporation','Linkup Systems Corporation1190 Coleman Ave.- Ste #2cSan Jose Ca 95110United States',1),('00:D0:6B','Sr Telecom Inc.','Sr Telecom Inc.8150 Trans Canada HighwayMontrealQuebec  H4s 1m5Canada',1),('00:D0:6C','Sharewave, Inc.','Sharewave, Inc.5175 Hillsdale CircleEl Dorado Hills Ca 95762United States',1),('00:D0:6D','Acrison, Inc.','Acrison, Inc.20 Empire Blvd.Moonachie Nj 07074United States',1),('00:D0:6E','Trendview Recorders Ltd.','Trendview Recorders Ltd.4 Airfield WayChristchurch Dorset Bh23 3tsUnited KingdomUnited Kingdom',1),('00:D0:6F','Kmc Controls','Kmc ControlsP.o. Box 49719476 New Paris Industrial Dr.New Paris In 46553United States',1),('00:D0:70','Long Well Electronics Corp.','Long Well Electronics Corp.4f, No. 59-1, Tsao Di WeiShengkeng Hsiang, Taipei HsienTaiwan 222 Taiwan 222 R.o.c.Taiwan, Republic Of China',1),('00:D0:71','Echelon Corp.','Echelon Corp.550 Meridian AvenueSan Jose Ca 95126United States',1),('00:D0:72','Broadlogic','Broadlogic463 S. Milpitas Blvd.Milpitas Ca 95035United States',1),('00:D0:73','Acn Advanced Communications','Acn Advanced CommunicationsNetworks SaRue Du Puits-godet Ba Ch-2000 NeuchatelSwitzerlandSwitzerland',1),('00:D0:74','Taqua Systems, Inc.','Taqua Systems, Inc.1600 Falmouth Rd. - SteCenterville Ma 02632United States',1),('00:D0:75','Alaris Medical Systems, Inc.','Alaris Medical Systems, Inc.P.o. Box 8533510221 Wateridge CircleSan Diego Ca 92121-2733United States',1),('00:D0:76','Merrill Lynch & Co., Inc.','Merrill Lynch & Co., Inc.1100 Merrill DrivePennington Nj 08534United States',1),('00:D0:77','Lucent Technologies','Lucent TechnologiesClient Access Business Unit101 Crawfords Corner Road Room #1e-437alHolmdel Nj 07733United States',1),('00:D0:78','Eltex Of Sweden Ab','Eltex Of Sweden AbBox 24283 21 OsbySweden',1),('00:D0:79','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:D0:7A','Amaquest Computer Corp.','Amaquest Computer Corp.8/f, 79 Hsin-tai5th Road, Sec. 1 Hs1-chih, TaipeiTaiwan R.o.c.Taiwan, Republic Of China',1),('00:D0:7B','Comcam International Ltd.','Comcam International Ltd.Park Valley Corporate Cntr#1071157 Phoenixville PikeWest Chester Pa 19380United States',1),('00:D0:7C','Koyo Electronics Inc. Co.,ltd.','Koyo Electronics Inc. Co.,ltd.1-171 Tenjin-cho KodairaTokyo  187-0004JapanJapan',1),('00:D0:7D','Cosine Communications','Cosine Communications1200 Bridge ParkwayRedwood City Ca 94065United States',1),('00:D0:7E','Keycorp Ltd.','Keycorp Ltd.P.o. Box 199Chatswood Nsw 2057AustraliaAustralia',1),('00:D0:7F','Strategy & Technology, Limited','Strategy & Technology, LimitedSuite 4.2, Clifton HeightsTriangle WestBristol Bs8 1ejUnited Kingdom',1),('00:D0:80','Exabyte Corporation','Exabyte Corporation1685 38th StreetBoulder Co 80301United States',1),('00:D0:81','Rtd Embedded Technologies, Inc.','Rtd Embedded Technologies, Inc.103 Innovation Blvd.State College Pa 16803United States',1),('00:D0:82','Iowave Inc.','Iowave Inc.1010 Wisconsin AvenueWashington Dc 20007United States',1),('00:D0:83','Invertex, Inc.','Invertex, Inc.1012 Morse Avenue- Ste.#9Sunnyvale Ca 94089United States',1),('00:D0:84','Nexcomm Systems, Inc.','Nexcomm Systems, Inc.Suit #nal-903,Sungnam Techno-park 148 Yatap-dong, BundSungnam-city Sungnam-city Kyunggi-do,kKorea, Republic Of',1),('00:D0:85','Otis Elevator Company','Otis Elevator Company5 Farm Springs Rd.Farmington Ct 06032United States',1),('00:D0:86','Foveon, Inc.','Foveon, Inc.2820 San Tomas ExpresswaySanta Clara Ca 95051United States',1),('00:D0:87','Microfirst Inc.','Microfirst Inc.11 East Oak StreetOakland Nj 07436United States',1),('00:D0:88','Motorola, Inc.','Motorola, Inc.2450 Walsh AveSanta Clara Ca 95051United States',1),('00:D0:89','Dynacolor, Inc.','Dynacolor, Inc.18f-1, No. 97, Section 4Chung Hsin Rd, San-chung City Taipei HsiTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:D0:8A','Photron Usa','Photron Usa1101 S. Winchester Blvd.Suite #d-144San Jose Ca 95128United States',1),('00:D0:8B','Adva Optical Networking Ltd','Adva Optical Networking LtdClifton Technology CentreClifton MoorYork North Yorkshire Yo30 4guUnited Kingdom',1),('00:D0:8C','Genoa Technology, Inc.','Genoa Technology, Inc.5401 Tech CircleMoorpark Ca 93021United States',1),('00:D0:8D','Phoenix Group, Inc.','Phoenix Group, Inc.123 Marcus Blvd.Hauppauge Ny 11788United States',1),('00:D0:8E','Nvision Inc.','Nvision Inc.125 Crown Point CourtGrass Valley Ca 95945United States',1),('00:D0:8F','Ardent Technologies, Inc.','Ardent Technologies, Inc.250 N. Wolfe RoadSunnyvale Ca 94086United States',1),('00:D0:90','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:D0:91','Smartsan Systems, Inc.','Smartsan Systems, Inc.4655 Old Ironsides Dr. #480Santa Clara Ca 95054United States',1),('00:D0:92','Glenayre Western Multiplex','Glenayre Western Multiplex1196 Borregas AvenueSunnyvale Ca 94089United States',1),('00:D0:93','Tq - Components Gmbh','Tq - Components GmbhGut Delling - Muhlstr 2D-82229 SeefeldGermanyGermany',1),('00:D0:94','Timeline Vista, Inc.','Timeline Vista, Inc.1755-b La Costa Meadows DriveSan Marcos Ca 92069United States',1),('00:D0:95','Alcatel-lucent, Enterprise Business Group','Alcatel-lucent, Enterprise Business Group26801 West Agoura RoadCalabasas Ca 91301United States',1),('00:D0:96','3com Europe Ltd.','3com Europe Ltd.Boundary WayHemel Hempstead Herts. Hp2 7yuUnited KingdomUnited Kingdom',1),('00:D0:97','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveM/s Sja-2San Jose Ca 95134United States',1),('00:D0:98','Photon Dynamics Canada Inc.','Photon Dynamics Canada Inc.221 Whitehall DriveMarkham, OntarioL3r 9t1Canada',1),('00:D0:99','Elcard Oy','Elcard OyP.o. Box 120/beckerintic 3851201 KangasniemiFinlandFinland',1),('00:D0:9A','Filanet Corporation','Filanet Corporation931 Benecia AvenueSunnyvale Ca 94085United States',1),('00:D0:9B','Spectel Ltd.','Spectel Ltd.21 Stillorgan Industrial ParkStillorgan, Co. DublinIrelandIreland',1),('00:D0:9C','Kapadia Communications','Kapadia Communications3925 West Broker LaneAustin Tx 78759United States',1),('00:D0:9D','Veris Industries','Veris Industries10831 Sw CascadePortland Or 97223United States',1),('00:D0:9E','2wire, Inc.','2wire, Inc.694 Tasman DriveMilpitas Ca 95035United States',1),('00:D0:9F','Novtek Test Systems','Novtek Test Systems2170 Paragon DriveSan Jose Ca 95131United States',1),('00:D0:A0','Mips Denmark','Mips DenmarkLautrupvang 2b2750 BallerupDk - DenmarkDenmark',1),('00:D0:A1','Oskar Vierling Gmbh + Co. Kg','Oskar Vierling Gmbh + Co. KgPretzfelder Str. 2191320 EbermannstadtGermanyGermany',1),('00:D0:A2','Integrated Device','Integrated DeviceTechnology, Inc.2975 Stender Way  M/s 0-318Santa Clara Ca 95054United States',1),('00:D0:A3','Vocal Data, Inc.','Vocal Data, Inc.1701 N Greenville #304Richardson Tx 75081United States',1),('00:D0:A4','Alantro Communications','Alantro Communications141 Stony Circle,  Ste. #210Santarosa Ca 95401United States',1),('00:D0:A5','American Arium','American Arium14281 Chambers RoadTustin Ca 92780United States',1),('00:D0:A6','Lanbird Technology Co., Ltd.','Lanbird Technology Co., Ltd.Room A-211, S.b.i.647-26, Deungchon-dong, Kangseo-gu,  SeoKorea 157-030Korea, Republic Of',1),('00:D0:A7','Tokyo Sokki Kenkyujo Co., Ltd.','Tokyo Sokki Kenkyujo Co., Ltd.8-2, Minami-ohi 6-chomeShinagawa-ku TokyoJapan 140-8560Japan',1),('00:D0:A8','Network Engines, Inc.','Network Engines, Inc.61 Pleasant StreetRandolph Ma 02368United States',1),('00:D0:A9','Shinano Kenshi Co., Ltd.','Shinano Kenshi Co., Ltd.Electronic Equipment Division6-15-26, Chuo, Ueda-shi Nagano-ken, 386-JapanJapan',1),('00:D0:AA','Chase Communications','Chase CommunicationsSt. Leonards RoadEast Sheen London Sw16 7lyUnited KingdomUnited Kingdom',1),('00:D0:AB','Deltakabel Telecom Cv','Deltakabel Telecom CvHanzeweg 142803 Mc GoudaThe NetherlandsNetherlands',1),('00:D0:AC','Grayson Wireless','Grayson Wireless140 Vista Centre DriveForest Va 24551United States',1),('00:D0:AD','Tl Industries','Tl Industries2541 Tracy RoadNorthwood Oh 43619United States',1),('00:D0:AE','Oresis Communications, Inc.','Oresis Communications, Inc.14670 Nw Greenbrier PkwyBeaverton Or 97006United States',1),('00:D0:AF','Cutler-hammer, Inc.','Cutler-hammer, Inc.Pmp Center240 Vista Park DrivePittsburgh Pa 15205United States',1),('00:D0:B0','Bitswitch Ltd.','Bitswitch Ltd.3 Meadow Court, Amos RoadMeadowhall, Sheffield S9 1bxUnited KingdomUnited Kingdom',1),('00:D0:B1','Omega Electronics Sa','Omega Electronics SaRoute De Soleure 68Ch-2500 Bienne 4SwitzerlandSwitzerland',1),('00:D0:B2','Xiotech Corporation','Xiotech Corporation6455 Flying Cloud DriveEden Prairie Mn 55344United States',1),('00:D0:B3','Drs Flight Safety And','Drs Flight Safety AndCommunications40 Concourse Gate NepeanCanada K2e 8a6Canada',1),('00:D0:B4','Katsujima Co., Ltd.','Katsujima Co., Ltd.1-6-1-, ShiratoriKatsushika-ku Tokyo 125-0063JapanJapan',1),('00:D0:B5','Ipricot Formerly Dotcom','Ipricot Formerly Dotcom10-12, Avenue De VerdunLa-garenne-colombes  F-92250France',1),('00:D0:B6','Crescent Networks, Inc.','Crescent Networks, Inc.201 Riverneck RoadChelmsford Ma 01842United States',1),('00:D0:B7','Intel Corporation','Intel Corporation5200 Ne Elam Young ParkwayHf1-08Hillsboro Or 97124United States',1),('00:D0:B8','Iomega Corporation','Iomega Corporation',1),('00:D0:B9','Microtek International, Inc.','Microtek International, Inc.No. 6 Industry East Road 3Science-based Industrial Park HsinchuTaiwan 30077 Taiwan 30077 R.o.c.Taiwan, Republic Of China',1),('00:D0:BA','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive- Sja-2San Jose Ca 95134United States',1),('00:D0:BB','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive  Sja-2San Jose Ca 95134United States',1),('00:D0:BC','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Drive-sja-2San Jose Ca 95134United States',1),('00:D0:BD','Silicon Image Gmbh','Silicon Image GmbhGarbsener Landstr. 10D-30419 HannoverGermany',1),('00:D0:BE','Emutec Inc.','Emutec Inc.P.o. Box 3035Everett Wa 98203United States',1),('00:D0:BF','Pivotal Technologies','Pivotal Technologies70 S. Lake Avenue - Ste. #900Pasadena Ca 91101United States',1),('00:D0:C0','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman Dr.  Sja-2San Jose Ca 95134United States',1),('00:D0:C1','Harmonic Data Systems, Ltd.','Harmonic Data Systems, Ltd.10 Beit Shamai StreetTel-avivIsrael 67018Israel',1),('00:D0:C2','Balthazar Technology Ab','Balthazar Technology AbAnkdammsgatan 24S-17143 SolnaSwedenSweden',1),('00:D0:C3','Vivid Technology Pte, Ltd.','Vivid Technology Pte, Ltd.1003 Bukit Merah Central#03-09, S159836SingaporeSingapore',1),('00:D0:C4','Teratech Corporation','Teratech Corporation223 Middlesex Trpk.Burlington Ma 01803-3308United States',1),('00:D0:C5','Computational Systems, Inc.','Computational Systems, Inc.835 Innovation DriveKnoxville Tn 37932United States',1),('00:D0:C6','Thomas & Betts Corp.','Thomas & Betts Corp.Thomas & Betts Aust. Pty. Ltd.23a Nyrang StreetLidcombe New South Wales 92618Australia',1),('00:D0:C7','Pathway, Inc.','Pathway, Inc.777 Beta DriveMayfield Village Oh 44143United States',1),('00:D0:C8','Prevas A/s','Prevas A/sFrederikskaj 6Dk-2450 Kbenhavn SvDenmark',1),('00:D0:C9','Advantech Co., Ltd.','Advantech Co., Ltd.Fl. 4, No.  108-3Ming-chuan Road Shing-tien CityTaipei Taipei TaiwanTaiwan, Republic Of China',1),('00:D0:CA','Intrinsyc Software International Inc.','Intrinsyc Software International Inc.700 West Pender Street10th FloorVancouver B.c. V6c 1g8Canada',1),('00:D0:CB','Dasan Co., Ltd.','Dasan Co., Ltd.6f, Kosmo Tower1002, Daechi-dong, Kangnam-ku SeoulKorea (zip 135-280)Korea, Republic Of',1),('00:D0:CC','Technologies Lyre Inc.','Technologies Lyre Inc.1200 St-jean-baptiste,Suite #120 Quebec, QuebecCanada G2e 5e8Canada',1),('00:D0:CD','Atan Technology Inc.','Atan Technology Inc.#5, Alley 18, Lane 81,Chien Kang, 2nd Road HinchuTaiwan Taiwan R.o.c.Taiwan, Republic Of China',1),('00:D0:CE','Asyst Electronic','Asyst ElectronicBrodisce 7, 10c Trzin1236 TrzinSloveniaSlovenia',1),('00:D0:CF','Moreton Bay','Moreton Bay12/97 Jijaws StreetSumner Park. 4074 Qld.AustraliaAustralia',1),('00:D0:D0','Zhongxing Telecom Ltd.','Zhongxing Telecom Ltd.8-9f Building 54,301#Zhong Shan Donglu, Nanjing Prc, Pc=21000ChinaChina',1),('00:D0:D1','Sycamore Networks','Sycamore Networks220 Mill RdChelmsford Ma 01824United States',1),('00:D0:D2','Epilog Corporation','Epilog Corporation500 Corporate Circle - Ste.Golden Co 80401United States',1),('00:D0:D3','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveM/s Sja-2San Jose Ca 95134United States',1),('00:D0:D4','V-bits, Inc.','V-bits, Inc.2150 Trade Zone Blvd.Suite #105San Jose Ca 95131United States',1),('00:D0:D5','Grundig Ag','Grundig AgKurgartensgtreet 37D-90762 Fuerth/bayernGermanyGermany',1),('00:D0:D6','Aethra Telecomunicazioni','Aethra TelecomunicazioniVia Matteo Ricci, 1060020 AnconaItalyItaly',1),('00:D0:D7','B2c2, Inc.','B2c2, Inc.2020 Challenger Drive-Suite #101Alameda Ca 94501United States',1),('00:D0:D8','3com Corporation','3com Corporation2133 Leghorn StreetMountain View Ca 94043United States',1),('00:D0:D9','Dedicated Microcomputers','Dedicated MicrocomputersGroup, Ltd.11 Oak Street, Pendlebury Swinton, ManchM274fl United KingdomUnited Kingdom',1),('00:D0:DA','Taicom Data Systems Co., Ltd.','Taicom Data Systems Co., Ltd.45, Wu-kung 5 RoadWu-ku Ind. Pavk Taipei-hsienTaiwanTaiwan, Republic Of China',1),('00:D0:DB','Mcquay International','Mcquay International13600 Industrial Park Blvd.Minneapolis Mn 55441United States',1),('00:D0:DC','Modular Mining Systems, Inc.','Modular Mining Systems, Inc.3289 E. Hemisphere LoopTucson Az 85706United States',1),('00:D0:DD','Sunrise Telecom, Inc.','Sunrise Telecom, Inc.22 Great Oaks Blvd.San Jose Ca 95119United States',1),('00:D0:DE','Philips Multimedia Network','Philips Multimedia NetworkSystems GmbhFichtestrasse 1a D-02601 BautzenGermanyGermany',1),('00:D0:DF','Kuzumi Electronics, Inc.','Kuzumi Electronics, Inc.28-6 Iijima-chyo, Sakae-kuYokohama-shi Kanagawa, 244-0842JapanJapan',1),('00:D0:E0','Dooin Electronics Co.','Dooin Electronics Co.Dooin Bldg. 16-6, Soonae-dongBundang-gu, Sungnam-si Kyunggi-doKorea 463-020Korea, Republic Of',1),('00:D0:E1','Avionitek Israel Inc.','Avionitek Israel Inc.1 Etgar StreetTirat  Carmel  39120IsraelIsrael',1),('00:D0:E2','Mrt Micro, Inc.','Mrt Micro, Inc.14000 S. Military TrailDelray Beach Fl 33484United States',1),('00:D0:E3','Ele-chem Engineering Co., Ltd.','Ele-chem Engineering Co., Ltd.Windstone Office1-803, 275-2 Yangjue-dong, Seocho-kuSeoul 137-130 Seoul 137-130 KoreaKorea, Republic Of',1),('00:D0:E4','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:D0:E5','Solidum Systems Corp.','Solidum Systems Corp.940 Belfast Road 1s.217Ottawa, Ontario K1g 4a2CanadaCanada',1),('00:D0:E6','Ibond Inc.','Ibond Inc.3160, De La Cruz Blvd.Suite #101Santa Clara Ca 95054United States',1),('00:D0:E7','Vcon Telecommunication Ltd.','Vcon Telecommunication Ltd.22 Maskit StreetHerzliya  46733IsraelIsrael',1),('00:D0:E8','Mac System Co., Ltd.','Mac System Co., Ltd.R&d InstituteMac System Co., Ltd. 219-2 Anang7-dong,Kyungki-do Korea, 430-017Korea, Republic Of',1),('00:D0:E9','Advantage Century Telecommunication Corp.','Advantage Century Telecommunication Corp.4f, 41, Tunghsin Rd.TaipeiTaiwan, Republic Of China',1),('00:D0:EA','Nextone Communications, Inc.','Nextone Communications, Inc.9700 Great Seneca HghwyRockville Md 20850United States',1),('00:D0:EB','Lightera Networks, Inc.','Lightera Networks, Inc.10201 Bubb RoadCupertino Ca 95014United States',1),('00:D0:EC','Nakayo Telecommunications, Inc','Nakayo Telecommunications, Inc1-3-2 Soujya-machiMaebashi-shi Gunma, 371-0853JapanJapan',1),('00:D0:ED','Xiox','Xiox150 Dow StreetManchester Nh 03101United States',1),('00:D0:EE','Dictaphone Corporation','Dictaphone Corporation3191 Broadbridge Ave.Stratford Ct 06614-2559United States',1),('00:D0:EF','Igt','Igt9295 Prototype DriveReno Nv 89511United States',1),('00:D0:F0','Convision Technology Gmbh','Convision Technology GmbhRebenring 33D-38106 BraunschweigGermanyGermany',1),('00:D0:F1','Sega Enterprises, Ltd.','Sega Enterprises, Ltd.12-14 Higashikoujiya 2-chomeOhta-ku Tokyo 144-8532JapanJapan',1),('00:D0:F2','Monterey Networks','Monterey Networks1909 N. Glenville DriveRichardson Tx 75081United States',1),('00:D0:F3','Solari Di Udine Spa','Solari Di Udine SpaVia Gino Pieri 2933100 UdineItalyItaly',1),('00:D0:F4','Carinthian Tech Institute','Carinthian Tech InstituteRichard-wagner Str. 199500 VillachAustriaAustria',1),('00:D0:F5','Orange Micro, Inc.','Orange Micro, Inc.1400 N. Lakeview Ave.Anaheim Ca 92807United States',1),('00:D0:F6','Alcatel Canada','Alcatel Canada600 March RoadKanata, OntarioK2k 2e6Canada',1),('00:D0:F7','Next Nets Corporation','Next Nets CorporationMita Kokusai Bldg. 17f1-4-28 Mita Minato-ku Tokyo 108-0073JapanJapan',1),('00:D0:F8','Fujian Star Terminal','Fujian Star TerminalDevice Co., Ltd.Fuer Industrial Zone Star Science & TechFuzhou Fujian, China 350002China',1),('00:D0:F9','Acute Communications Corp.','Acute Communications Corp.No. 1, Creation Road IiiScience Based Industrial Park Hsinchu 30TaiwanTaiwan, Republic Of China',1),('00:D0:FA','Thales E-security Ltd.','Thales E-security Ltd.Meadow View House, Crendon Industrial EstateLong CrendonAylesbury Buckinghamshire Hp18 9eqUnited Kingdom',1),('00:D0:FB','Tek Microsystems, Incorporated','Tek Microsystems, IncorporatedOne North AvenueBurlington Ma 01803United States',1),('00:D0:FC','Granite Microsystems','Granite Microsystems10202 N. Enterprise DriveMequon Wi 53092United States',1),('00:D0:FD','Optima Tele.com, Inc.','Optima Tele.com, Inc.200-90 Allstate ParkwayMarkham On L3r 6h3Canada',1),('00:D0:FE','Astral Point','Astral PointCommunications, Inc.27 Industrial Ave.,-ste. #3Chelmsford Ma 01824United States',1),('00:D0:FF','Cisco Systems, Inc.','Cisco Systems, Inc.170 West Tasman DriveSan Jose Ca 95134United States',1),('00:DD:00','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:01','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:02','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:03','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:04','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:05','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:06','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:07','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:08','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:09','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:0A','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:0B','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:0C','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:0D','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:0E','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:DD:0F','Ungermann-bass Inc.','Ungermann-bass Inc.3900 Freedom CircleSanta Clara Ca 95054United States',1),('00:E0:00','Fujitsu Limited','Fujitsu LimitedMusashi-kosugi Tower Place Bldg.,Kosugi-cho 1-chome,nakahara-kuKawasaki 211-88 KanagawaJapan',1),('00:E0:01','Strand Lighting Limited','Strand Lighting LimitedGrant WayIsleworthMiddlesex England Tw7 5qdUnited Kingdom',1),('00:E0:02','Crossroads Systems, Inc.','Crossroads Systems, Inc.9390 Research Blvd.Suite 2-300Austin Tx 78759United States',1),('00:E0:03','Nokia Wireless Business Commun','Nokia Wireless Business CommunAccess Point Products GroupUnit 6, Cambridge Bus Park Milton Rd, CaCb4 0wsUnited Kingdom',1),('00:E0:04','Pmc-sierra, Inc.','Pmc-sierra, Inc.105-8555 Baxter PlaceBurnaby, Bc V5a 4v7Canada',1),('00:E0:05','Technical Corp.','Technical Corp.22-6 Minami SengenchoNishiku Yokohama CityKanagawaJapan',1),('00:E0:06','Silicon Integrated Sys. Corp.','Silicon Integrated Sys. Corp.16, Creation Rd. IScience-based Industrial ParkHsin ChuTaiwan, Republic Of China',1),('00:E0:07','Avaya Ecs Ltd','Avaya Ecs LtdUnit 1 Sterling Court, MundellsWelwyn Garden City Hert Al7 1lzUnited Kingdom',1),('00:E0:08','Amazing Controls! Inc.','Amazing Controls! Inc.1615 Wyatt DriveSanta Clara Ca 95054United States',1),('00:E0:09','Marathon Technologies Corp.','Marathon Technologies Corp.1300 Massachusetts AvenueBoxborough Ma 01719United States',1),('00:E0:0A','Diba, Inc.','Diba, Inc.3355 Edison WayMenlo Park Ca 94025United States',1),('00:E0:0B','Rooftop Communications Corp.','Rooftop Communications Corp.468 Paco DriveLos Altos Ca 94024United States',1),('00:E0:0C','Motorola','Motorola5401 N. Beach St.  S243Ft. Worth Tx 76137United States',1),('00:E0:0D','Radiant Systems','Radiant Systems1000 Alderman Dr.Alpharetta Ga 30202United States',1),('00:E0:0E','Avalon Imaging Systems, Inc.','Avalon Imaging Systems, Inc.3133 Indian RoadBoulder Co 80301United States',1),('00:E0:0F','Shanghai Baud Data','Shanghai Baud DataCommunication Development Corp3f, Gold Luck Building 2507 Pudong RoadShanghaiChina',1),('00:E0:10','Hess Sb-automatenbau Gmbh','Hess Sb-automatenbau GmbhHindenburgstrasse 27-29D-71106 MagstadtGermany',1),('00:E0:11','Uniden Corporation','Uniden Corporation2-12-7 Hatchobori,Chuo-ku Tokyo 104-8512Japan',1),('00:E0:12','Pluto Technologies International Inc.','Pluto Technologies International Inc.2511 55th StreetBoulder Co 80301United States',1),('00:E0:13','Eastern Electronic Co., Ltd.','Eastern Electronic Co., Ltd.No. 4, Shin-long Road,Kwei-shan Industrial AreaTao-yuanTaiwan, Republic Of China',1),('00:E0:14','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:15','Heiwa Corporation','Heiwa Corporation2-3014-8, Hirosawa-choKiryu-shiGunma Pref. 376Japan',1),('00:E0:16','Rapid City Communications','Rapid City Communications555 Clyde Ave.Mountain View Ca 94043United States',1),('00:E0:17','Exxact Gmbh','Exxact GmbhRheinstrase 7D-41836 HuckelhovenGermany',1),('00:E0:18','Asustek Computer Inc.','Asustek Computer Inc.150 Li-te Rd.Peitou, TaipeiTaiwan, Republic Of China',1),('00:E0:19','Ing. Giordano Elettronica','Ing. Giordano ElettronicaVia Pietro Cossa  115/1210146-torinoItaly',1),('00:E0:1A','Comtec Systems. Co., Ltd.','Comtec Systems. Co., Ltd.404-9 Choungchen-dongBupyoung-ku, InchonKorea, Republic Of',1),('00:E0:1B','Sphere Communications, Inc.','Sphere Communications, Inc.2 Energy DriveLake Bluff Il 60044United States',1),('00:E0:1C','Cradlepoint, Inc','Cradlepoint, Inc1199 Shoreline LaneSuite 301Boise Id 83702United States',1),('00:E0:1D','Webtv Networks, Inc.','Webtv Networks, Inc.305 Lytton Ave.Palo Alto Ca 94301United States',1),('00:E0:1E','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:1F','Avidia Systems, Inc.','Avidia Systems, Inc.135 North Plains Industrial RdWallingford Ct 06492United States',1),('00:E0:20','Tecnomen Oy','Tecnomen OyP.o. Box 93Fin-02271 EspooFinland',1),('00:E0:21','Freegate Corp.','Freegate Corp.710 Lakeway  Ste.#230Sunnyvale Ca 94086United States',1),('00:E0:22','Analog Devices Inc.','Analog Devices Inc.777 Bay StreetSuite 2303Toronto Ontario M5g 2c8Canada',1),('00:E0:23','Telrad','TelradP.o. Box 50Lod 71100Israel',1),('00:E0:24','Gadzoox Networks','Gadzoox Networks5850 Hellyer AvenueSan Jose Ca 95138United States',1),('00:E0:25','Dit Co., Ltd.','Dit Co., Ltd.Premier Toyocho Building23-21 Toyo 3-chome,Koto-ku Tokyo 135-0056Japan',1),('00:E0:26','Redlake Masd Llc','Redlake Masd Llc3440 E. Pritannia Dr.Suite 124Tuscon Az 85706United States',1),('00:E0:27','Dux, Inc.','Dux, Inc.5-18-19, Nishikamata, Ota-kuTokyo-to, 144Japan',1),('00:E0:28','Aptix Corporation','Aptix Corporation2880 N. First StreetSan Jose Ca 95134United States',1),('00:E0:29','Standard Microsystems Corp.','Standard Microsystems Corp.6 HughesIrvine Ca 92718United States',1),('00:E0:2A','Tandberg Television As','Tandberg Television AsPhilip Pedersens V 20N-1324 LysakerNorway',1),('00:E0:2B','Extreme Networks','Extreme Networks10460 Bandley DriveCuperint0 Ca 95014United States',1),('00:E0:2C','Ast Computer','Ast Computer16215 Alton ParkwayIrvine Ca 92718United States',1),('00:E0:2D','Innomedialogic, Inc.','Innomedialogic, Inc.3653 Chemin ChamblyLongueuil, Quebec J4l J4l  In9Canada',1),('00:E0:2E','Spc Electronics Corporation','Spc Electronics Corporation2-1-3 Shibasaki, Chofu-shiTokyo, 182Japan',1),('00:E0:2F','Mcns Holdings, L.p.','Mcns Holdings, L.p.Tci, Inc.-technology VenturesP.o. Box 5630Denver Co 80217-5630United States',1),('00:E0:30','Melita International Corp.','Melita International Corp.5051 Peachtree Corners CircleNorcross Ga 30092United States',1),('00:E0:31','Hagiwara Electric Co., Ltd.','Hagiwara Electric Co., Ltd.7, Shimokofukada, Asada-choNisshin-shi, Aichi  470-01Japan',1),('00:E0:32','Misys Financial Systems, Ltd.','Misys Financial Systems, Ltd.Buckholt Drive,Warndon, Worcester Wr49srUnited Kingdom',1),('00:E0:33','E.e.p.d. Gmbh','E.e.p.d. GmbhRoemer-strasse 485229 Markt IndersdorfGermany',1),('00:E0:34','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:35','Emerson Network Power','Emerson Network Power2900 S. Diablo WayTempe Az 85282United States',1),('00:E0:36','Pioneer Corporation','Pioneer Corporation2610 Hanazono 4-chomeTokorozawa-shiSaitama Prefecture, 359-8Japan',1),('00:E0:37','Century Corporation','Century Corporation2-28-5, TaitoTaito-ku, Tokyo 101Japan',1),('00:E0:38','Proxima Corporation','Proxima Corporation9440 Carroll Park DriveSan Diego Ca 92121-2298United States',1),('00:E0:39','Paradyne Corp.','Paradyne Corp.8545 126th Avenue NorthLargo Fl 33773United States',1),('00:E0:3A','Cabletron Systems, Inc.','Cabletron Systems, Inc.35 Industrial Way - Bldg. #36Rochester Nh 03867United States',1),('00:E0:3B','Prominet Corporation','Prominet Corporation110 Turnpike Rd. - Ste. #208Westborough Ma 01581United States',1),('00:E0:3C','Advansys','Advansys1150 Ringwood CourtSan Jose Ca 95131United States',1),('00:E0:3D','Focon Electronic Systems A/s','Focon Electronic Systems A/sDamvang, Po Box 269Dk-6400 SonderborgDenmark',1),('00:E0:3E','Alfatech, Inc.','Alfatech, Inc.Shin-osaka Eito Bldg.4-15-18 Nishinakajima, Yodogawa-ku,OsakaJapan',1),('00:E0:3F','Jaton Corporation','Jaton Corporation556 South Milpitas Blvd.Milpitas Ca 95035United States',1),('00:E0:40','Deskstation Technology, Inc.','Deskstation Technology, Inc.15729 College Blvd.Lenexa Ks 66219United States',1),('00:E0:41','Cspi','Cspi43 Manning Rd.Billerica Ma 01821United States',1),('00:E0:42','Pacom Systems Ltd.','Pacom Systems Ltd.Unit 22 38/46 South St.Rydalmere 2116 NswAustralia',1),('00:E0:43','Vitalcom','Vitalcom15222 Del Amo Ave.Tustin Ca 92780United States',1),('00:E0:44','Lsics Corporation','Lsics Corporation3-8-3 Ninomiya, Tskukuba-shiIbaragi-ken, 305Japan',1),('00:E0:45','Touchwave, Inc.','Touchwave, Inc.994 San Antonio Rd.Palo Alto Ca 94303United States',1),('00:E0:46','Bently Nevada Corp.','Bently Nevada Corp.Po Box 157Minden Nv 89423United States',1),('00:E0:47','Infocus Corporation','Infocus Corporation27500 Sw Parkway AvenueWilsonville Or 97070-8238United States',1),('00:E0:48','Sdl Communications, Inc.','Sdl Communications, Inc.P.o. Box 1303Easton Ma 02334United States',1),('00:E0:49','Microwi Electronic Gmbh','Microwi Electronic GmbhZusamstrasse 8D 86165 AugsburgGermany',1),('00:E0:4A','Enhanced Messaging Systems, Inc','Enhanced Messaging Systems, Inc250 West Southlake Blvd.Southlake Tx 76092United States',1),('00:E0:4B','Jump Industrielle Computertechnik Gmbh','Jump Industrielle Computertechnik Gmbh',1),('00:E0:4C','Realtek Semiconductor Corp.','Realtek Semiconductor Corp.1f, No. 11, Industry E. Rd. IxScience-based Industrial ParkHsinchu 300Taiwan, Republic Of China',1),('00:E0:4D','Internet Initiative Japan, Inc','Internet Initiative Japan, Inc1-4, Sanban-cho, Chiyoda-kuTokyo 102Japan',1),('00:E0:4E','Sanyo Denki Co., Ltd.','Sanyo Denki Co., Ltd.812-3, Shimonogou, Ueda-shiNagano  386-1211Japan',1),('00:E0:4F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:50','Executone Information Systems, Inc.','Executone Information Systems, Inc.478 Wheelers Farms RoadMilford Ct 06460United States',1),('00:E0:51','Talx Corporation','Talx Corporation1850 Borman CourtSt. Louis Mo 63146United States',1),('00:E0:52','Foundry Networks, Inc.','Foundry Networks, Inc.680 W. Maude Ave. - Ste. #3Sunnyvale Ca 94086United States',1),('00:E0:53','Cellport Labs, Inc.','Cellport Labs, Inc.885 Arapahoe Ave.,Boulder Co 80302United States',1),('00:E0:54','Kodai Hitec Co., Ltd.','Kodai Hitec Co., Ltd.2-45 Onuma Hanyu CitySaitama.348Japan',1),('00:E0:55','Ingenieria Electronica Comercial Inelcom S.a.','Ingenieria Electronica Comercial Inelcom S.a.Cl. Piquer No.328033 MadridSpain',1),('00:E0:56','Holontech Corporation','Holontech Corporation2039 Samaritan DriveSan Jose Ca 95124United States',1),('00:E0:57','Han Microtelecom. Co., Ltd.','Han Microtelecom. Co., Ltd.Fashion Bd., 3rd Fr,1194, Doonsan 2Dong Seo-gu, Taejon Korea 302-173Korea, Republic Of',1),('00:E0:58','Phase One Denmark A/s','Phase One Denmark A/sRoskildevej 39Dk-2000 FrederiksbergDenmark',1),('00:E0:59','Controlled Environments, Ltd.','Controlled Environments, Ltd.590 Berry StreetWinnepeg R3h Or9Canada',1),('00:E0:5A','Galea Network Security','Galea Network Security2 Place Du Commerce - Ste #320Brossard, Quebec J4w 2t8Canada',1),('00:E0:5B','West End Systems Corp.','West End Systems Corp.39 Winners Circle Dr.,Arnprior, Ontario    K7s 3g9Canada',1),('00:E0:5C','Matsushita Kotobuki Electronics Industries, Ltd.','Matsushita Kotobuki Electronics Industries, Ltd.247, Fukutake SaijoEhime, 793Japan',1),('00:E0:5D','Unitec Co., Ltd.','Unitec Co., Ltd.Kisogawa-cho  Ichinotori 24Haguri-gun Aichi 493Japan',1),('00:E0:5E','Japan Aviation Electronics Industry, Ltd.','Japan Aviation Electronics Industry, Ltd.',1),('00:E0:5F','E-net, Inc.','E-net, Inc.12325 Hymeadow DriveSuite #2-200Austin Tx 78750United States',1),('00:E0:60','Sherwood','Sherwood21056 Forbes StreetHayward Ca 94545United States',1),('00:E0:61','Edgepoint Networks, Inc.','Edgepoint Networks, Inc.2238 Martin AvenueSanta Clara Ca 95050United States',1),('00:E0:62','Host Engineering','Host Engineering200 East Main Street -ste.#700Johnson City Tn 37604United States',1),('00:E0:63','Cabletron - Yago Systems, Inc.','Cabletron - Yago Systems, Inc.35 Industrial WayP.o. Box 5005Rochester Nh 03866-5005United States',1),('00:E0:64','Samsung Electronics','Samsung Electronics99 W. Tasman DriveSan Jose Ca 95134United States',1),('00:E0:65','Optical Access International','Optical Access International500 West Cummings Pl. #3400Woburn Ma 01801United States',1),('00:E0:66','Promax Systems, Inc.','Promax Systems, Inc.16 Technology Drive--bldg.#106Irvine Ca 92656United States',1),('00:E0:67','Eac Automation-consulting Gmbh','Eac Automation-consulting GmbhHermsdorfer Damm 22273467 BerlinGermany',1),('00:E0:68','Merrimac Systems Inc.','Merrimac Systems Inc.2144 Mc Coy RoadCarrollton Tx 75006United States',1),('00:E0:69','Jaycor','Jaycor9775 Towne Centre DriveSan Diego Ca 92121United States',1),('00:E0:6A','Kapsch Ag','Kapsch AgWagenseilgasse 11120-viennaAustria',1),('00:E0:6B','W&g Special Products','W&g Special ProductsSceince Park Eindhovin 50495692 Eb SonNetherlands',1),('00:E0:6C','Aep Systems International Ltd','Aep Systems International LtdFocus 31, West WingCleveland RoadHemel Hemstead Herts England Hp2 7bwUnited Kingdom',1),('00:E0:6D','Compuware Corporation','Compuware CorporationOne Campus MartiusDetroit Mi 48226United States',1),('00:E0:6E','Far Systems S.p.a.','Far Systems S.p.a.Via F. Zeni 83868 Rovereto (tn)Italy',1),('00:E0:6F','Motorola, Inc.','Motorola, Inc.2450 Walsh AveSanta Clara Ca 95051United States',1),('00:E0:70','Dh Technology','Dh Technology3003 Rollie Gates DrivePaso Robles Ca 93446United States',1),('00:E0:71','Epis Microcomputer','Epis Microcomputer72458 AlbstadtLautlinger Strasse 14772458 AlbstadtGermany',1),('00:E0:72','Lynk','LynkRabin BuildingTeradion Industrial ParkD.n. Misgav 201Israel',1),('00:E0:73','National Amusement Network, Inc.','National Amusement Network, Inc.401 N. Michigan AvenueChicago Il 60611United States',1),('00:E0:74','Tiernan Communications, Inc.','Tiernan Communications, Inc.11025 Roselle St.San Diego Ca 92121United States',1),('00:E0:75','Verilink Corporation','Verilink Corporation127 Jetplex CircleMadison Al 35758United States',1),('00:E0:76','Development Concepts, Inc.','Development Concepts, Inc.1000 N. Broad StreetLansdale Pa 19446United States',1),('00:E0:77','Webgear, Inc.','Webgear, Inc.1263 Oakmead PkwySunnyvale Ca 94080United States',1),('00:E0:78','Berkeley Networks','Berkeley Networks683 River Oaks ParkwaySan Jose Ca 95134United States',1),('00:E0:79','A.t.n.r.','A.t.n.r.Bp 96691976 CourtaboeufFrance',1),('00:E0:7A','Mikrodidakt Ab','Mikrodidakt AbSkiffervgen 48Lund  Se22478Sweden',1),('00:E0:7B','Bay Networks','Bay Networks125 Nagog ParkActon Ma 01720United States',1),('00:E0:7C','Mettler-toledo, Inc.','Mettler-toledo, Inc.1150 Dearborn DriveWorthington Oh 43085United States',1),('00:E0:7D','Netronix, Inc.','Netronix, Inc.340 Thor PlaceBrea Ca 92821United States',1),('00:E0:7E','Walt Disney Imagineering','Walt Disney Imagineering1401 Flower St.Glendale Ca 91221United States',1),('00:E0:7F','Logististem S.r.l.','Logististem S.r.l.Via Panciatichi 94/1850127 FirenzeItaly',1),('00:E0:80','Control Resources Corporation','Control Resources Corporation16-00 Pollitt DriveFair Lawn Nj 07410United States',1),('00:E0:81','Tyan Computer Corp.','Tyan Computer Corp.1753 S. Main StreetMilpitas Ca 95035United States',1),('00:E0:82','Anerma','AnermaSchaapsdries 252260 WesterloBelgium',1),('00:E0:83','Jato Technologies, Inc.','Jato Technologies, Inc.505 East Huntland Dr. Ste #550Austin Tx 78752United States',1),('00:E0:84','Compulite R&d','Compulite R&d3 Haroshet Str. New Ind. ZoneRamat-hasharon 47279Israel',1),('00:E0:85','Global Maintech, Inc.','Global Maintech, Inc.6468 City West ParkwayEden Prairie Mn 55344United States',1),('00:E0:86','Cybex Computer Products','Cybex Computer Products4912 Research DriveHuntsville Al 35805United States',1),('00:E0:87','Lecroy - Networking Productions Division','Lecroy - Networking Productions Division25 Burlington Mall RoadBurlington Ma 01803United States',1),('00:E0:88','Ltx Corporation','Ltx Corporation145 University AvenueWestwood Ma 02090-2306United States',1),('00:E0:89','Ion Networks, Inc.','Ion Networks, Inc.1551 South Washington Ave.Piscataway Nj 08854United States',1),('00:E0:8A','Gec Avery, Ltd.','Gec Avery, Ltd.Foundry LaneSmethwick, WarleyWest Midlands, B66 2lp EnglandUnited Kingdom',1),('00:E0:8B','Qlogic Corp.','Qlogic Corp.26600 Laguna Hills Dr.Aliso Viejo Ca 92656United States',1),('00:E0:8C','Neoparadigm Labs, Inc.','Neoparadigm Labs, Inc.1735 N. First St.,  Ste #108San Jose Ca 95112United States',1),('00:E0:8D','Pressure Systems, Inc.','Pressure Systems, Inc.34 Research DriveHampton Va 23666United States',1),('00:E0:8E','Utstarcom','Utstarcom33 Wood Ave. SouthIselin Nj 08830United States',1),('00:E0:8F','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:90','Beckman Lab. Automation Div.','Beckman Lab. Automation Div.90 Boroline RoadAllendale Nj 07401United States',1),('00:E0:91','Lg Electronics, Inc.','Lg Electronics, Inc.16, Woomyeon-dong,Seocho-gu, Seoul, 137-140,Korea, Republic Of',1),('00:E0:92','Admtek Incorporated','Admtek Incorporated1962 Zanker RoadSan Jose Ca 95112United States',1),('00:E0:93','Ackfin Networks','Ackfin Networks575 N. Pastoria Ave.Sunnyvale Ca 94086United States',1),('00:E0:94','Osai Srl','Osai SrlVia Torino603-ivrea (to)Italy',1),('00:E0:95','Advanced-vision Technolgies Corp.','Advanced-vision Technolgies Corp.8f-1, 87 Section 3, Chung Yang Rd,Tu Cheng TaipeiTaiwan, Republic Of China',1),('00:E0:96','Shimadzu Corporation','Shimadzu Corporation1, Nishinokyo-kuwabarachoNakagyo-ku, Kyoto 604Japan',1),('00:E0:97','Carrier Access Corporation','Carrier Access Corporation5395 Pearl ParkwayBoulder Co 80301United States',1),('00:E0:98','Abocom Systems, Inc.','Abocom Systems, Inc.12f-3, No. 333, Sec. 1Guan-fu RoadHsin-chuTaiwan, Republic Of China',1),('00:E0:99','Samson Ag','Samson AgWeismullerstr. 3D-60314 FrankfurtGermany',1),('00:E0:9A','Positron Inc.','Positron Inc.5101 Buchan StreetSuite 220Montreal, Quebec H4p 2r9Canada',1),('00:E0:9B','Engage Networks, Inc.','Engage Networks, Inc.316 N. Milwaukee St., Ste.#214Milwaukee Wi 53202United States',1),('00:E0:9C','Mii','MiiLe Parc Du Moulin2, Grande Rue ProlongeeF95650 Puiseux-potoiseFrance',1),('00:E0:9D','Sarnoff Corporation','Sarnoff CorporationCn 5300Princeton Nj 08543-5300United States',1),('00:E0:9E','Quantum Corporation','Quantum Corporation500 Mccarthy BoulevardMilpitas Ca 95035United States',1),('00:E0:9F','Pixel Vision','Pixel Vision43 Nagog ParkActon Ma 01720United States',1),('00:E0:A0','Wiltron Co.','Wiltron Co.490 Jarvis DriveMorgan Hill Ca 95037United States',1),('00:E0:A1','Hima Paul Hildebrandt Gmbh Co. Kg','Hima Paul Hildebrandt Gmbh Co. Kg',1),('00:E0:A2','Microslate Inc.','Microslate Inc.9625 Ignace - Ste. DBrossard  Qc J4y 2p3Canada',1),('00:E0:A3','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:A4','Esaote S.p.a.','Esaote S.p.a.Via Di Caciolle, 1550127 FlorenceItaly',1),('00:E0:A5','Comcore Semiconductor, Inc.','Comcore Semiconductor, Inc.4505 Las Virgenes, Suite 202Calabasas Ca 91302United States',1),('00:E0:A6','Telogy Networks, Inc.','Telogy Networks, Inc.20250 Century Blvd.Germantown Md 20874United States',1),('00:E0:A7','Ipc Information Systems, Inc.','Ipc Information Systems, Inc.Metro CenterOne Station PlaceStamford Ct 06907United States',1),('00:E0:A8','Sat Gmbh & Co.','Sat Gmbh & Co.Ruthnergasse 1Vienna A-1210Austria',1),('00:E0:A9','Funai Electric Co., Ltd.','Funai Electric Co., Ltd.7-1, Nakagaito 7-chome, DaitoOsaka  574Japan',1),('00:E0:AA','Electrosonic Ltd.','Electrosonic Ltd.Hawley Mill, Hawley Rd.Dartford, Kent Da2 7syUnited Kingdom',1),('00:E0:AB','Dimat S.a.','Dimat S.a.C/biscaia 383 308023  BarcelonaSpain',1),('00:E0:AC','Midsco, Inc.','Midsco, Inc.710 Route 46 EastFairfield Nj 07004United States',1),('00:E0:AD','Ees Technology, Ltd.','Ees Technology, Ltd.25 EastwaysWitham, Essex, Cm8 3alUnited Kingdom',1),('00:E0:AE','Xaqti Corporation','Xaqti Corporation1630 Oakland Rd. #a-214San Jose Ca 95131United States',1),('00:E0:AF','General Dynamics Information Systems','General Dynamics Information SystemsComputing Devices, Ltd.3190 Fairview PaFalls Church Va 22042-4523United States',1),('00:E0:B0','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:B1','Alcatel-lucent, Enterprise Business Group','Alcatel-lucent, Enterprise Business Group26801 West Agoura RoadCalabasas Ca 91301United States',1),('00:E0:B2','Telmax Communications Corp.','Telmax Communications Corp.46515 Landing ParkwayFremont Ca 94538United States',1),('00:E0:B3','Etherwan Systems, Inc.','Etherwan Systems, Inc.14 Hughes,  Ste.b-105Irvine Ca 92618United States',1),('00:E0:B4','Techno Scope Co., Ltd.','Techno Scope Co., Ltd.13-6-7 Kishimati UrawasiSaitama 336Japan',1),('00:E0:B5','Ardent Communications Corp.','Ardent Communications Corp.3801 Zanker Road,  Suite ASan Jose Ca 95134United States',1),('00:E0:B6','Entrada Networks','Entrada Networks9020 Junction DriveAnnapolis Junction Md 20701United States',1),('00:E0:B7','Pi Group, Ltd.','Pi Group, Ltd.Milton Hall, Church LaneMilton, Cambridge Cba 6abUnited Kingdom',1),('00:E0:B8','Gateway 2000','Gateway 2000610 Gateway DriveN. Sioux City Sd 57049United States',1),('00:E0:B9','Byas Systems','Byas Systems2250 Monroe Street,  #371Santa Clara Ca 95050United States',1),('00:E0:BA','Berghof Automationstechnik Gmbh','Berghof Automationstechnik GmbhHarret Strasse 1D 72800 EningenGermany',1),('00:E0:BB','Nbx Corporation','Nbx Corporation100 Brickstone SquareAndover Ma 01810United States',1),('00:E0:BC','Symon Communications, Inc.','Symon Communications, Inc.10701 Corporate Dr.-ste. #290Stafford Tx 77477United States',1),('00:E0:BD','Interface Systems, Inc.','Interface Systems, Inc.5855 Interface DriveAnn Arbor Mi 48103-9515United States',1),('00:E0:BE','Genroco International, Inc.','Genroco International, Inc.255 Enders CourtSlinger Wi 53086United States',1),('00:E0:BF','Torrent Networking Technologies Corp.','Torrent Networking Technologies Corp.8181 Professional PlaceSuite #160Landover Md 20785United States',1),('00:E0:C0','Seiwa Electric Mfg. Co., Ltd.','Seiwa Electric Mfg. Co., Ltd.86 Tarada Shin-ike,Joyo,Kyoto PrefectureJapan',1),('00:E0:C1','Memorex Telex Japan, Ltd.','Memorex Telex Japan, Ltd.Yaesuguchi Kaikan, 1-7-20Yaesu, Chuo-kuTokyo 103Japan',1),('00:E0:C2','Necsy S.p.a.','Necsy S.p.a.Via Lisbona 2835020 PadovaItaly',1),('00:E0:C3','Sakai System Development Corp.','Sakai System Development Corp.Portus Center Bld., 4-45-1Ebisujima-cho,  Sakai-cityOsaka-fu, 590Japan',1),('00:E0:C4','Horner Electric, Inc.','Horner Electric, Inc.1521 E. Washington St.Indianapolis In 46201United States',1),('00:E0:C5','Bcom Electronics Inc.','Bcom Electronics Inc.8 Fl, No. 64, An Ho Road, Sec. 2TaipeiTaiwan, Republic Of China',1),('00:E0:C6','Link2it, L.l.c.','Link2it, L.l.c.4256 Beck AvenueStudio City Ca 91604United States',1),('00:E0:C7','Eurotech Srl','Eurotech SrlVia Jacopo Linussio 133030 Amaroo (ud)Italy',1),('00:E0:C8','Virtual Access, Ltd.','Virtual Access, Ltd.Woodside House, Winkfield,Windsor, Berkshire Sl4 2dx EnglandUnited Kingdom',1),('00:E0:C9','Automatedlogic Corporation','Automatedlogic Corporation1150 Roberts BoulevardKennesaw Ga 30144-3618United States',1),('00:E0:CA','Best Data Products','Best Data Products21800 Nordhoff StreetChatsworth Ca 91311United States',1),('00:E0:CB','Reson, Inc.','Reson, Inc.300 Lopez RoadGoleta Ca 93117United States',1),('00:E0:CC','Hero Systems, Ltd.','Hero Systems, Ltd.The Barnes, Coombelands Lane,Addlestone, WeybridgeSurrey Kt15 1hy EnglandUnited Kingdom',1),('00:E0:CD','Sensis Corporation','Sensis Corporation5793 Widewaters ParkwayDewitt Ny 13214United States',1),('00:E0:CE','Arn','Arn51, Rue Gaston LauriauF-93512 Montreuil CedexFrance',1),('00:E0:CF','Integrated Device Technology, Inc.','Integrated Device Technology, Inc.',1),('00:E0:D0','Netspeed, Inc.','Netspeed, Inc.12303 Technology Blvd.Austin Tx 78727United States',1),('00:E0:D1','Telsis Limited','Telsis Limited16 Barnes Wallace RoadFareham, Hampshire Po15 5tt EnglandUnited Kingdom',1),('00:E0:D2','Versanet Communications, Inc.','Versanet Communications, Inc.628 N. Diamond Bar Blvd.Diamond Bar Ca 91765United States',1),('00:E0:D3','Datentechnik Gmbh','Datentechnik GmbhTheresianumgasse 11A-1040 WienAustria',1),('00:E0:D4','Excellent Computer','Excellent Computer551, M.k.n. RoadAlandur, Chennai 600016India',1),('00:E0:D5','Emulex Corporation','Emulex Corporation3333 Susan StreetCosta Mesa Ca 92626United States',1),('00:E0:D6','Computer & Communication Research Lab.','Computer & Communication Research Lab.',1),('00:E0:D7','Sunshine Electronics, Inc.','Sunshine Electronics, Inc.46560 Fremont Blvd. -ste. #113Fremont Ca 94538United States',1),('00:E0:D8','Lanbit Computer, Inc.','Lanbit Computer, Inc.12f, 552 Chung Hsiao E., Rd.Sec. 5, Taipei 110Taiwan, Republic Of China',1),('00:E0:D9','Tazmo Co., Ltd.','Tazmo Co., Ltd.6186 Kinoko, Ibara-shiOkayama 715Japan',1),('00:E0:DA','Alcatel North America Esd','Alcatel North America Esd26801 West Agoura RoadCalabasas Ca 91301United States',1),('00:E0:DB','Viavideo Communications, Inc.','Viavideo Communications, Inc.8900 Shoal Creek Blvd.Bldg. #300Austin Tx 78757United States',1),('00:E0:DC','Nexware Corp.','Nexware Corp.825 Stewart Dr.,  Ste #4Sunnyvale Ca 94086United States',1),('00:E0:DD','Zenith Electronics Corporation','Zenith Electronics Corporation1000 Milwaukee AvenueGlenview Il 60025United States',1),('00:E0:DE','Datax Nv','Datax NvRinglaan 51B-2600 BerchemBelgium',1),('00:E0:DF','Keymile Gmbh','Keymile GmbhWohlenbergstr. 330179 HannoverGermany',1),('00:E0:E0','Si Electronics, Ltd.','Si Electronics, Ltd.28-16, Shimomaruko 2-chome,Tokyo 146Japan',1),('00:E0:E1','G2 Networks, Inc.','G2 Networks, Inc.142 So. Santa Cruz Ave.Los Gatos Ca 95030-6702United States',1),('00:E0:E2','Innova Corp.','Innova Corp.3325 South 116th StreetSeattle Wa 98168United States',1),('00:E0:E3','Sk-elektronik Gmbh','Sk-elektronik GmbhHemmelratherweg 20151377 LeverkusenGermany',1),('00:E0:E4','Fanuc Robotics North America, Inc.','Fanuc Robotics North America, Inc.3900 W. Hamlin Rd.Rochester Hills Mi 48309-3253United States',1),('00:E0:E5','Cinco Networks, Inc.','Cinco Networks, Inc.6601 Koll Center Park WaySuite #140Pleasanton Ca 94566United States',1),('00:E0:E6','Incaa Datacom B.v.','Incaa Datacom B.v.P.o. Box 2117300 Ae ApeldoornNetherlands',1),('00:E0:E7','Raytheon E-systems, Inc.','Raytheon E-systems, Inc.1301 E. CollinsRichardson Tx 75081United States',1),('00:E0:E8','Gretacoder Data Systems Ag','Gretacoder Data Systems AgAlthardstrasse  150Ch-8105 RegensdorfSwitzerland',1),('00:E0:E9','Data Labs, Inc.','Data Labs, Inc.444 North Frederick Ave.Suite #240Gaithersburg Md 20877United States',1),('00:E0:EA','Innovat Communications, Inc.','Innovat Communications, Inc.1257 N. Plano RoadRichardson Tx 75081United States',1),('00:E0:EB','Digicom Systems, Incorporated','Digicom Systems, Incorporated188 Topaz StreetMilpitas Ca 95035United States',1),('00:E0:EC','Celestica Inc.','Celestica Inc.844 Don Mills RoadNorth York  Ontario M3c 1v7Canada',1),('00:E0:ED','Silicom, Ltd.','Silicom, Ltd.8 Hanager St.P.o. Box 2164Kfar-sava 44000Israel',1),('00:E0:EE','Marel Hf','Marel HfAusturhraun 9Gardabaer  210Iceland',1),('00:E0:EF','Dionex','DionexPo Box 3603Sunnyvale Ca 94088-3603United States',1),('00:E0:F0','Abler Technology, Inc.','Abler Technology, Inc.4f, No. 54  Sec. 4Min-sheng E. Rd.TaipeiTaiwan, Republic Of China',1),('00:E0:F1','That Corporation','That Corporation734 Forest StreetMarlborough Ma 01752United States',1),('00:E0:F2','Arlotto Comnet, Inc.','Arlotto Comnet, Inc.7f-4,55,tung-kuang RoadHsin-chu, 300Taiwan, Republic Of China',1),('00:E0:F3','Websprint Communications, Inc.','Websprint Communications, Inc.3026 Scott Blvd.Santa Clara Ca 95054United States',1),('00:E0:F4','Inside Technology A/s','Inside Technology A/sVenlighedsvej 6Dk-2970 HoersholmDenmark',1),('00:E0:F5','Teles Ag','Teles AgDovestr. 2-410587 BerlinGermany',1),('00:E0:F6','Decision Europe','Decision Europe3, Rue De Lattre De Tassigny85170 Saint Denis La ChevasseFrance',1),('00:E0:F7','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:F8','Dicna Control Ab','Dicna Control AbStenyxegatan 21 C213 76 MalmoeSweden',1),('00:E0:F9','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:FA','Trl Technology, Ltd.','Trl Technology, Ltd.Shannon Way, Ashchurch,Tewkesbury, Glos. Gl20 8ndUnited Kingdom',1),('00:E0:FB','Leightronix, Inc.','Leightronix, Inc.2330 Jarco Dr.Holt Mi 48842United States',1),('00:E0:FC','Huawei Technologies Co., Ltd.','Huawei Technologies Co., Ltd.Kefa Road, Science-based Industrial ParkNanshan District,Shenzhen 518057China',1),('00:E0:FD','A-trend Technology Co., Ltd.','A-trend Technology Co., Ltd.10f, No. 75, Hsin Tai Wu Rd.,Sec. 1, Hsi Chih,Taipei Hsien 221Taiwan, Republic Of China',1),('00:E0:FE','Cisco Systems, Inc.','Cisco Systems, Inc.170 W. Tasman DriveSan Jose Ca 95134-1706United States',1),('00:E0:FF','Security Dynamics Technologies, Inc.','Security Dynamics Technologies, Inc.20 Crosby DriveBedford Ma 01730United States',1),('00:E6:D3','Nixdorf Computer Corp.','Nixdorf Computer Corp.2520 Mission College RoadSanta Clara Ca 95054United States',1),('02:07:01','Racal-datacom','Racal-datacomLan Internetworking Division155 Swanson RoadBoxborough Ma 01719United States',1),('02:1C:7C','Perq Systems Corporation','Perq Systems Corporation2600 Liberty AvenueP.o. Box 2600Pittsburgh Pa 15230United States',1),('02:60:86','Logic Replacement Tech. Ltd.','Logic Replacement Tech. Ltd.14 Arkwright RoadReading Berks Rg2olsUnited KingdomUnited Kingdom',1),('02:60:8C','3com Corporation','3com Corporation2081 N. Shorline Blvd.Mountain View Ca 94043United States',1),('02:70:01','Racal-datacom','Racal-datacomLan Internetworking Division155 Swanson RoadBoxborough Ma 01719United States',1),('02:70:B0','M/a-com Inc. Companies','M/a-com Inc. Companies11717 Exploration LaneGermantown Md 20767United States',1),('02:70:B3','Data Recall Ltd','Data Recall LtdSondes PlaceDorking Surrey Rh4 3efUnited KingdomUnited Kingdom',1),('02:9D:8E','Cardiac Recorders Inc.','Cardiac Recorders Inc.34 Scarboro RdLondon N4 4l UUnited KingdomUnited Kingdom',1),('02:AA:3C','Olivetti Telecomm Spa (olteco)','Olivetti Telecomm Spa (olteco)20300 Stevens  Creek Blvd.Cupertino Ca 95014United States',1),('02:BB:01','Octothorpe Corp.','Octothorpe Corp.285 West Green StreetPasadena Ca 91105United States',1),('02:C0:8C','3com Corporation','3com Corporation5400 Bayfront PlazaP.o. Box 58145Santa Clara Ca 95052United States',1),('02:CF:1C','Communication Machinery Corp.','Communication Machinery Corp.1226 AnacapaSanta Barbara Ca 93101United States',1),('02:E6:D3','Nixdorf Computer Corporation','Nixdorf Computer CorporationNixdorf Technology Center2520 Mission College BlvdSanta Clara Ca 95054United States',1),('04:0A:E0','Xmit Ag Computer Networks','Xmit Ag Computer Networks11 Avenue De Baumettes1020 RenansSwitzerlandSwitzerland',1),('04:E0:C4','Triumph-adler Ag','Triumph-adler AgHundingstrabe 11b8500 Nurnburg 80GermanyGermany',1),('08:00:01','Computervision Corporation','Computervision Corporation14 Crosby Drive Ms 5-1Bedford Ma 01730United States',1),('08:00:02','Bridge Communications Inc.','Bridge Communications Inc.2081 Stierling RoadMountain View Ca 94043United States',1),('08:00:03','Advanced Computer Comm.','Advanced Computer Comm.720 Santa Barbara St.Santa Barbara Ca 93101United States',1),('08:00:04','Cromemco Incorporated','Cromemco Incorporated280 Bernardo AvenueMountain View Ca 94043United States',1),('08:00:05','Symbolics Inc.','Symbolics Inc.257 Vassar StreetCambridge Ma 02139United States',1),('08:00:06','Siemens Ag','Siemens AgSiemens It Solutions And Services, Sis Go Qm OSiemensstrasse 2-4Pob 2353 Fuerth 90713Germany',1),('08:00:07','Apple Computer Inc.','Apple Computer Inc.20650 Valley Green DriveCupertino Ca 95014United States',1),('08:00:08','Bolt Beranek And Newman Inc.','Bolt Beranek And Newman Inc.70 Fawcett StreetCambridge Ma 02138United States',1),('08:00:09','Hewlett Packard','Hewlett PackardEnterprise Systems Tech.center11000 Wolfe RoadCupertino Ca 95014United States',1),('08:00:0A','Nestar Systems Incorporated','Nestar Systems Incorporated2585 East Bayshore RoadPalo Alto Ca 94303United States',1),('08:00:0B','Unisys Corporation','Unisys CorporationTownship Line RoadBlue Bell Pa 19424United States',1),('08:00:0C','Miklyn Development Co.','Miklyn Development Co.3613 Andover DiveBedford Tx 76021United States',1),('08:00:0D','International Computers Ltd.','International Computers Ltd.Wenlock WayWest Gorton Manchester,  M12  5drUnited KingdomUnited Kingdom',1),('08:00:0E','Ncr Corporation','Ncr CorporationWorld HeadquartersDayton Oh 45479United States',1),('08:00:0F','Mitel Corporation','Mitel Corporation350 Legget DriveP.o. Box 13089 Kanata OntarioCanada K2k 1x3Canada',1),('08:00:11','Tektronix Inc.','Tektronix Inc.Technical Standards13975 Sw Karl Braun Drive Po Box 500,  MBeaverton Or 97077United States',1),('08:00:12','Bell Atlantic Integrated Syst.','Bell Atlantic Integrated Syst.40 Tall Pine DriveSudbury Ma 01776United States',1),('08:00:13','Exxon','Exxon',1),('08:00:14','Excelan','Excelan1599 Flickinger AvenueSan Jose Ca 95131United States',1),('08:00:15','Stc Business Systems','Stc Business SystemsHolbrook HouseCockfosters Road Cockfosters Herts En4 OUnited KingdomUnited Kingdom',1),('08:00:16','Barrister Info Sys Corp','Barrister Info Sys CorpOne Technology Center45 Oak StreetBuffalo Ny 14203United States',1),('08:00:17','National Semiconductor','National Semiconductor2900 Semiconductor DriveSanta Clara Ca 95051United States',1),('08:00:18','Pirelli Focom Networks','Pirelli Focom NetworksDenton DriveNorthwich Cheshire      Cw9 7luEnglandUnited Kingdom',1),('08:00:19','General Electric Corporation','General Electric Corporation1285 Boston AvenueBridgeport Ct 06602United States',1),('08:00:1A','Tiara/ 10net','Tiara/ 10net7777 Washington Village DriveSuite 200Dayton Ohio 45459-3957United States',1),('08:00:1B','Emc Corporation','Emc Corporation176 South StreetHopkinton Ma 01748United States',1),('08:00:1C','Kdd-kokusai Debnsin Denwa Co.','Kdd-kokusai Debnsin Denwa Co.Fuji Xerox Co., Ltd. TelegraphNo. 3-5, Akasaka 3-chome Minato-ku, Toky107 JapanJapan',1),('08:00:1D','Able Communications Inc.','Able Communications Inc.17891 Cartwright RoadIrvine Ca 92714-6216United States',1),('08:00:1E','Apollo Computer Inc.','Apollo Computer Inc.15 Elizabeth DriveChelmsford Ma 01824United States',1),('08:00:1F','Sharp Corporation','Sharp CorporationEngineering Department 6492 Minosho-cho Yamatokooriyma-shi,Nara 639-11 JapanJapan',1),('08:00:20','Sun Microsystems Inc.','Sun Microsystems Inc.4200 Network CircleSanta Clara Ca 95054United States',1),('08:00:21','3m Company','3m CompanyTelecom Division6801 River Place BoulevardAustin Tx 78726-9000United States',1),('08:00:22','Nbi Inc.','Nbi Inc.3450 Mitchell LaneP.o. Box 9001Boulder Co 80301United States',1),('08:00:23','Panasonic Communications Co., Ltd.','Panasonic Communications Co., Ltd.4-1-62 Minoshima Hakata Fukuoka812-8531Japan',1),('08:00:24','10net Communications/dca','10net Communications/dca7777 Washington Village Dr.Suite 200Dayton Oh 45459-3957United States',1),('08:00:25','Control Data','Control Data4201 Lexington Ave NorthArden Hills Mn 55112United States',1),('08:00:26','Norsk Data A.s.','Norsk Data A.s.P.o. Box 25 BogerudOslo 6NorwayNorway',1),('08:00:27','Cadmus Computer Systems','Cadmus Computer Systems600 Suffolk StLowell Ma 08154United States',1),('08:00:28','Texas Instruments','Texas Instruments12500 Ti BoulevardM/s 8723Dallas Tx 75243United States',1),('08:00:29','Megatek Corporation','Megatek Corporation9645 Scranton RoadSan Diego Ca 92121United States',1),('08:00:2A','Mosaic Technologies Inc.','Mosaic Technologies Inc.47 Manning RoadBillerica Ma 01821-3970United States',1),('08:00:2B','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King StreetLittleton Ma 01460-1289United States',1),('08:00:2C','Britton Lee Inc.','Britton Lee Inc.14600 Winchester BlvdLos Gatos Ca 95030United States',1),('08:00:2D','Lan-tec Inc.','Lan-tec Inc.2131 University AvenueBerkeley Ca 94704United States',1),('08:00:2E','Metaphor Computer Systems','Metaphor Computer Systems2500 Garcia AvenueMountain View Ca 94043United States',1),('08:00:2F','Prime Computer Inc.','Prime Computer Inc.100 Crosby DriveBedford Ma 01730-1402United States',1),('08:00:30','Royal Melbourne Inst Of Tech','Royal Melbourne Inst Of TechGpo Box 2476vMelbourne Vic 3001Australia',1),('08:00:31','Little Machines Inc.','Little Machines Inc.4141 Jutland DriveSan Diego Ca 92117United States',1),('08:00:32','Tigan Incorporated','Tigan Incorporated4020 Fabian WaySuite DPalo Alto Ca 94303United States',1),('08:00:33','Bausch & Lomb','Bausch & LombInteractive Graphics DivisionP.o. Box 14547Ausitn Tx 78671United States',1),('08:00:34','Filenet Corporation','Filenet Corporation1575 Corporate DriveCosta Mesa Ca 92626United States',1),('08:00:35','Microfive Corporation','Microfive Corporation3560 Hyland AvenueP.o. Box 5011Costa Mesa Ca 92626United States',1),('08:00:36','Intergraph Corporation','Intergraph CorporationOne Madison Industrial ParkHuntsville Al 35807United States',1),('08:00:37','Fuji-xerox Co. Ltd.','Fuji-xerox Co. Ltd.Advanced Tech & Engg Center9-50 Chuo 2-chome, Ebina-shi Kanagawa 24JapanJapan',1),('08:00:38','Cii Honeywell Bull','Cii Honeywell Bull68 Route De Versailles78430 LouveciennesFrance',1),('08:00:39','Spider Systems Limited','Spider Systems LimitedSpider ParkStanwell Street Edinburgh Eh6 5ngScotlandUnited Kingdom',1),('08:00:3A','Orcatech Inc.','Orcatech Inc.2680 Queensview DriveOttawa OntarioCanada K2b 8h6Canada',1),('08:00:3B','Torus Systems Limited','Torus Systems LimitedScience ParkMilton Road Cambridge Cb4 4bhUnited KingdomUnited Kingdom',1),('08:00:3C','Schlumberger Well Services','Schlumberger Well ServicesAustin Engineering ServicesP.o. Box 200015Austin Tx 78720-0015United States',1),('08:00:3D','Cadnetix Corporations','Cadnetix Corporations5797 Central AvenueBoulder Co 80301United States',1),('08:00:3E','Codex Corporation','Codex Corporation50 East Commerce DriveSuite  M1Schaumburg Il 60173United States',1),('08:00:3F','Fred Koschara Enterprises','Fred Koschara Enterprises',1),('08:00:40','Ferranti Computer Sys. Limited','Ferranti Computer Sys. LimitedWythenshawe DivisionWestern Road Bracknell Rg12 1raUnited KingdomUnited Kingdom',1),('08:00:41','Racal-milgo Information Sys..','Racal-milgo Information Sys..400 Embassy RowSuite 300Atlanta Ga 30328United States',1),('08:00:42','Japan Macnics Corp.','Japan Macnics Corp.',1),('08:00:43','Pixel Computer Inc.','Pixel Computer Inc.260 Fordham RoadWilmington Ma 01887United States',1),('08:00:44','David Systems Inc.','David Systems Inc.615 Tasman DriveSunnyvale Ca 94088United States',1),('08:00:45','Concurrent Computer Corp.','Concurrent Computer Corp.2 Crescent PlaceOceanport Nj 07757United States',1),('08:00:46','Sony Corporation','Sony Corporation5-1-2 KitashinagawaShinagawa-kuTokyo  141-0001Japan',1),('08:00:47','Sequent Computer Systems Inc.','Sequent Computer Systems Inc.15450 S.w. Koll Parkway   .Mailstop Col2-831Beaverton Or 97006United States',1),('08:00:48','Eurotherm Gauging Systems','Eurotherm Gauging Systems900 Middlesex Turnpike, Bdg. 6Billerica Ma 01821United States',1),('08:00:49','Univation','Univation1037 North Fair Oaks Ave.Sunnyvale Ca 94089United States',1),('08:00:4A','Banyan Systems Inc.','Banyan Systems Inc.135 Flanders RoadWestboro Ma 01581United States',1),('08:00:4B','Planning Research Corp.','Planning Research Corp.1dhs Systems1508 Kennedy Drive-ste#215Bellevue Ne 68--5United States',1),('08:00:4C','Hydra Computer Systems Inc.','Hydra Computer Systems Inc.12 Mercer RoadNatick Ma 01760United States',1),('08:00:4D','Corvus Systems Inc.','Corvus Systems Inc.2100 Corvus DriveSan Jose Ca 95124United States',1),('08:00:4E','3com Europe Ltd.','3com Europe Ltd.3com CentreBoundary Way, Hemel Hempstead HertforshiUnited KingdomUnited Kingdom',1),('08:00:4F','Cygnet Systems','Cygnet Systems2560 Junction AvenueSan Jose Ca 95134United States',1),('08:00:50','Daisy Systems Corp.','Daisy Systems Corp.139 Kifer CourtSunnyvale Ca 94086United States',1),('08:00:51','Experdata','Experdata88, Rue Brillat Savarin75013 ParisFranceFrance',1),('08:00:52','Insystec','Insystec450 Lakemont AvenueWinter Park Fl 32792United States',1),('08:00:53','Middle East Tech. University','Middle East Tech. UniversityDepartment OfComputer EngineeringAnkara TurkeyTurkey',1),('08:00:55','Stanford Telecomm. Inc.','Stanford Telecomm. Inc.1221 CrossmanSunnyvale Ca 94089United States',1),('08:00:56','Stanford Linear Accel. Center','Stanford Linear Accel. Center2575 Sandhill RoadMenlo Park Ca 94025United States',1),('08:00:57','Evans & Sutherland','Evans & SutherlandP.o. Box 8700580 Arapeen DriveSalt Lake City Ut 84108United States',1),('08:00:58','Systems Concepts','Systems Concepts520 Third StreetSan Francisco Ca 94107United States',1),('08:00:59','A/s Mycron','A/s MycronPo Box 6199N-0602 Oslo 6NorwayNorway',1),('08:00:5A','Ibm Corporation','Ibm CorporationP.o. Box 12195Ce6a/664 3039 CornwallisRtp Nc 27709-2195United States',1),('08:00:5B','Vta Technologies Inc.','Vta Technologies Inc.2040 Sherman StreetHollywood Fl 33020United States',1),('08:00:5C','Four Phase Systems','Four Phase Systems2001 Logic DriveSan Jose Ca 95124-3452United States',1),('08:00:5D','Gould Inc.','Gould Inc.6901 West Sunrise Blvd.P.o. Box 9148Ft. Lauderdale Fl 33310-9148United States',1),('08:00:5E','Counterpoint Computer Inc.','Counterpoint Computer Inc.2127 Ringwood AvenueSan Jose Ca 95131United States',1),('08:00:5F','Saber Technology Corp.','Saber Technology Corp.2381 Bering DriveSan Jose Ca 95131-1125United States',1),('08:00:60','Industrial Networking Inc.','Industrial Networking Inc.3990 Freedom CircleSanta Clara Ca 95050United States',1),('08:00:61','Jarogate Ltd.','Jarogate Ltd.197-213 Lyham RoadBriston London Sw2 5pyUnited KingdomUnited Kingdom',1),('08:00:62','General Dynamics','General DynamicsFort Worth DivisionP.o. Box 748Ft. Worth Tx 76101United States',1),('08:00:63','Plessey','PlesseyPlessey - Uk Limited167-55 148th AvenueJamaica Ny 11434United States',1),('08:00:64','Autophon Ag','Autophon AgAbt. Tzm 307Ziegelmattstrasse 1-15 4503 SolothurnSwitzerlandSwitzerland',1),('08:00:65','Genrad Inc.','Genrad Inc.300 Baker AvenueMail Stop 26Concord Ma 01742United States',1),('08:00:66','Agfa Corporation','Agfa Corporation200 Ballardvale StreetWilmington Ma 01887United States',1),('08:00:67','Comdesign','Comdesign751 South Kellog AvenueGoleta Ca 93117-3880United States',1),('08:00:68','Ridge Computers','Ridge Computers2451 Mission College Blvd.Santa Clara Ca 95054United States',1),('08:00:69','Silicon Graphics Inc.','Silicon Graphics Inc.2011 N. Shoreline Blvd.P.o. Box 7311 Ca 94043Mountain View Ca 94039-7311United States',1),('08:00:6A','Att Bell Laboratories','Att Bell Laboratories1100 East Warrenville RoadNaperville Il 60566United States',1),('08:00:6B','Accel Technologies Inc.','Accel Technologies Inc.7358 Trade StreetSan Diego Ca 92121United States',1),('08:00:6C','Suntek Technology Intl','Suntek Technology Intl586 No. First StreetSan Jose Ca 95112United States',1),('08:00:6D','Whitechapel Computer Works','Whitechapel Computer Works75 Whitechapel RoadLondon E1 1duUnited Kingdom',1),('08:00:6E','Masscomp','MasscompOne Technology ParkWestford Ma 01886United States',1),('08:00:6F','Philips Apeldoorn B.v.','Philips Apeldoorn B.v.P.o. Box 1057300 Ac ApeldoornThe NetherlandsNetherlands',1),('08:00:70','Mitsubishi Electric Corp.','Mitsubishi Electric Corp.325 KamimachiyaKamakura City Kanagwa Prefecture 247JapanJapan',1),('08:00:71','Matra (dsie)','Matra (dsie)Parc Daffaires - B.p. 26227100 Val De ReuilFranceFrance',1),('08:00:72','Xerox Corp Univ Grant Program','Xerox Corp Univ Grant ProgramZerox Systems InstituteM/s 105 50c 800 Phillips RoadWebster Ny 14580United States',1),('08:00:73','Tecmar Inc.','Tecmar Inc.6225 Cochran RoadSolon Oh 44139United States',1),('08:00:74','Casio Computer Co. Ltd.','Casio Computer Co. Ltd.3-2-1 Sakae-choHamuramachi, Nishitmagun Tokyo190-11 JapanJapan',1),('08:00:75','Dansk Data Electronik','Dansk Data ElectronikHerlev Hovedgade 199Dk 2730 HerlevDenmarkDenmark',1),('08:00:76','Pc Lan Technologies','Pc Lan Technologies5780 Lincoln Drive Suite 106Minneapolis Mn 55436United States',1),('08:00:77','Tsl Communications Ltd.','Tsl Communications Ltd.The Landsbury EstateLower Guildford Road Knaphil Woking SurrEnglandUnited Kingdom',1),('08:00:78','Accell Corporation','Accell Corporation50 Saginaw DriveRochester Ny 14623United States',1),('08:00:79','The Droid Works','The Droid WorksP.o. Box Cs 8180San Rafael Ca 94912United States',1),('08:00:7A','Indata','IndataGjerdrums Vei 12 CN-0486 Oslo 4NorwayNorway',1),('08:00:7B','Sanyo Electric Co. Ltd.','Sanyo Electric Co. Ltd.1-18-13 HashiridaniHirakata-shiOsaka 573 JapanJapan',1),('08:00:7C','Vitalink Communications Corp.','Vitalink Communications Corp.48761 Kato RoadFremont Ca 94538United States',1),('08:00:7E','Amalgamated Wireless(aus) Ltd','Amalgamated Wireless(aus) LtdNorth Ryde DivisionP.o. Box 96 North Ryde NswAustralia 2113Australia',1),('08:00:7F','Carnegie-mellon University','Carnegie-mellon UniversityInformation TechnologySchenley ParkPittsburge Pa 15213United States',1),('08:00:80','Aes Data Inc.','Aes Data Inc.1900 Minnesota CourtMissisauga OntarioCanada L5n L5n 3c9Canada',1),('08:00:81','Astech Inc.','Astech Inc.670 North Commercial StreetManchester Nh 03101United States',1),('08:00:82','Veritas Software','Veritas Software4800 Great America ParkwaySanta Clara Ca 95054United States',1),('08:00:83','Seiko Instruments Inc.','Seiko Instruments Inc.8, Nakase 1-chome Mihama-kuChiba-shi Chiba 261-8507Japan',1),('08:00:84','Tomen Electronics Corp.','Tomen Electronics Corp.1-1 Uchisaiwai-cho 2chomeChiyoda-ku Tokyo 100JapanJapan',1),('08:00:85','Elxsi','Elxsi2334 Lundy PlaceSan Jose Ca 95131United States',1),('08:00:86','Konica Minolta Holdings, Inc.','Konica Minolta Holdings, Inc.1-6-1, Marunouchi,Chiyoda-kuTokyo  100-0005Japan',1),('08:00:87','Xyplex','Xyplex295 Foster StreetLittleton Ma 01460United States',1),('08:00:88','Brocade Communications Systems, Inc.','Brocade Communications Systems, Inc.1745 Technology Dr.San Jose Ca 95110United States',1),('08:00:89','Kinetics','Kinetics3182 Old Tunnel RoadSuite HLafayette Ca 94549United States',1),('08:00:8A','Performance Technology','Performance Technology801 Lincoln Center7800 1h10 WestSan Antonio Tx 78230United States',1),('08:00:8B','Pyramid Technology Corp.','Pyramid Technology Corp.1295 Charleston RoadMountain View Ca 94043United States',1),('08:00:8C','Network Research Corporation','Network Research Corporation2380 N. Rose AvenueOxnard Ca 93010United States',1),('08:00:8D','Xyvision Inc.','Xyvision Inc.101 Edgewater DriveWakefield Ma 01880United States',1),('08:00:8E','Tandem Computers','Tandem Computers14321 Tandem Blvd.Austin Tx 78728-6610United States',1),('08:00:8F','Chipcom Corporation','Chipcom CorporationSouthborough Office118 Turnpike RoadSouthborough Ma 01772-1886United States',1),('08:00:90','Sonoma Systems','Sonoma Systems4640 Admiralty Way,  Ste. #600Marina Del Rey Ca 90292-6695United States',1),('08:14:43','Unibrain S.a.','Unibrain S.a.84, Ethnikis Antistaseos15231 AthensGreeceGreece',1),('08:BB:CC','Ak-nord Edv Vertriebsges. Mbh','Ak-nord Edv Vertriebsges. MbhFriedrichstrasse 1025436 TorneschGermany',1),('10:00:00','Private','',1),('10:00:5A','Ibm Corporation','Ibm CorporationP.o. Box 12195Ce6a/664 3039 CornwallisRtp Nc 27709-2195United States',1),('10:00:E8','National Semiconductor','National Semiconductor2900 Semiconductor DriveSanta Clara Ca 95051United States',1),('11:00:AA','Private','',1),('80:00:10','Att Bell Laboratories','Att Bell Laboratories1100 East Warrenville RoadNaperville Il 60566United States',1),('A0:6A:00','Verilink Corporation','Verilink Corporation127 Jetplex CircleMadison Al 35758United States',1),('AA:00:00','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King StreetLittleton Ma 01460-1289United States',1),('AA:00:01','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King StreetLittleton Ma 01460-1289United States',1),('AA:00:02','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King StreetLittleton Ma 01460-1289United States',1),('AA:00:03','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King StreetLittleton Ma 01460-1289United States',1),('AA:00:04','Digital Equipment Corporation','Digital Equipment CorporationLkg 1-2/a19550 King StreetLittleton Ma 01460-1289United States',1),('AC:DE:48','Private','',1);
/*!40000 ALTER TABLE `mac_track_oui_database` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mac_track_ports`
--

CREATE TABLE `mac_track_ports` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `hostname` varchar(40) NOT NULL default '',
  `device_name` varchar(100) NOT NULL default '',
  `vlan_id` varchar(5) NOT NULL default 'N/A',
  `vlan_name` varchar(50) NOT NULL default '',
  `mac_address` varchar(20) NOT NULL default '',
  `vendor_mac` varchar(8) default NULL,
  `ip_address` varchar(20) NOT NULL default '',
  `dns_hostname` varchar(200) default '',
  `port_number` varchar(10) NOT NULL default '',
  `port_name` varchar(50) NOT NULL default '',
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `authorized` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`port_number`,`scan_date`,`mac_address`,`device_id`),
  KEY `site_id` (`site_id`),
  KEY `description` (`device_name`),
  KEY `mac` (`mac_address`),
  KEY `hostname` (`hostname`),
  KEY `vlan_name` (`vlan_name`),
  KEY `vlan_id` (`vlan_id`),
  KEY `device_id` (`device_id`),
  KEY `ip_address` (`ip_address`),
  KEY `port_name` (`port_name`),
  KEY `dns_hostname` (`dns_hostname`),
  KEY `vendor_mac` (`vendor_mac`),
  KEY `authorized` (`authorized`)
) ENGINE=MyISAM COMMENT='Database for Tracking Device MACs';

--
-- Table structure for table `mac_track_processes`
--

CREATE TABLE `mac_track_processes` (
  `device_id` int(11) NOT NULL default '0',
  `process_id` int(10) unsigned default NULL,
  `status` varchar(20) NOT NULL default 'Queued',
  `start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`device_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_scan_dates`
--

CREATE TABLE `mac_track_scan_dates` (
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`scan_date`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_scanning_functions`
--

CREATE TABLE `mac_track_scanning_functions` (
  `scanning_function` varchar(100) NOT NULL default '',
  `type` int(10) unsigned NOT NULL default '0',
  `description` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`scanning_function`)
) ENGINE=MyISAM COMMENT='Registered Scanning Functions';

--
-- Table structure for table `mac_track_sites`
--

CREATE TABLE `mac_track_sites` (
  `site_id` int(10) unsigned NOT NULL auto_increment,
  `site_name` varchar(100) NOT NULL default '',
  `customer_contact` varchar(150) default '',
  `netops_contact` varchar(150) default '',
  `facilities_contact` varchar(150) default '',
  `site_info` text,
  `total_devices` int(10) unsigned NOT NULL default '0',
  `total_device_errors` int(10) unsigned NOT NULL default '0',
  `total_macs` int(10) unsigned NOT NULL default '0',
  `total_ips` int(10) unsigned NOT NULL default '0',
  `total_user_ports` int(11) NOT NULL default '0',
  `total_oper_ports` int(10) unsigned NOT NULL default '0',
  `total_trunk_ports` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`site_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_temp_ports`
--

CREATE TABLE `mac_track_temp_ports` (
  `site_id` int(10) unsigned NOT NULL default '0',
  `device_id` int(10) unsigned NOT NULL default '0',
  `hostname` varchar(40) NOT NULL default '',
  `device_name` varchar(100) NOT NULL default '',
  `vlan_id` varchar(5) NOT NULL default 'N/A',
  `vlan_name` varchar(50) NOT NULL default '',
  `mac_address` varchar(20) NOT NULL default '',
  `vendor_mac` varchar(8) default NULL,
  `ip_address` varchar(20) NOT NULL default '',
  `dns_hostname` varchar(200) default '',
  `port_number` varchar(10) NOT NULL default '',
  `port_name` varchar(50) NOT NULL default '',
  `scan_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `updated` tinyint(3) unsigned NOT NULL default '0',
  `authorized` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`port_number`,`scan_date`,`mac_address`,`device_id`),
  KEY `site_id` (`site_id`),
  KEY `description` (`device_name`),
  KEY `ip_address` (`ip_address`),
  KEY `hostname` (`hostname`),
  KEY `vlan_name` (`vlan_name`),
  KEY `vlan_id` (`vlan_id`),
  KEY `device_id` (`device_id`),
  KEY `mac` (`mac_address`),
  KEY `updated` (`updated`),
  KEY `vendor_mac` (`vendor_mac`),
  KEY `authorized` (`authorized`)
) ENGINE=MyISAM COMMENT='Database for Storing Temporary Results for Tracking Device MACS';

--
-- Table structure for table `mac_track_vlans`
--

CREATE TABLE `mac_track_vlans` (
  `vlan_id` int(10) unsigned NOT NULL,
  `site_id` int(10) unsigned NOT NULL,
  `device_id` int(10) unsigned NOT NULL,
  `vlan_name` varchar(128) NOT NULL,
  `present` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`vlan_id`,`site_id`,`device_id`),
  KEY `vlan_name` (`vlan_name`)
) ENGINE=MyISAM;

--
-- Table structure for table `mac_track_aggregated_ports`
--

CREATE TABLE `mac_track_aggregated_ports` (
  `row_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `site_id` int(10) unsigned NOT NULL DEFAULT '0',
  `device_id` int(10) unsigned NOT NULL DEFAULT '0',
  `hostname` varchar(40) NOT NULL DEFAULT '',
  `device_name` varchar(100) NOT NULL DEFAULT '',
  `vlan_id` varchar(5) NOT NULL DEFAULT 'N/A',
  `vlan_name` varchar(50) NOT NULL DEFAULT '',
  `mac_address` varchar(20) NOT NULL DEFAULT '',
  `vendor_mac` varchar(8) DEFAULT NULL,
  `ip_address` varchar(20) NOT NULL DEFAULT '',
  `dns_hostname` varchar(200) DEFAULT '',
  `port_number` varchar(10) NOT NULL DEFAULT '',
  `port_name` varchar(50) NOT NULL DEFAULT '',
  `date_last` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `first_scan_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `count_rec` int(10) unsigned NOT NULL DEFAULT '0',
  `active_last` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `authorized` tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`row_id`),
  UNIQUE KEY `port_number` (`port_number`,`mac_address`,`ip_address`,`device_id`,`site_id`,`vlan_id`,`authorized`) USING BTREE,
  KEY `site_id` (`site_id`),
  KEY `description` (`device_name`),
  KEY `mac` (`mac_address`),
  KEY `hostname` (`hostname`),
  KEY `vlan_name` (`vlan_name`),
  KEY `vlan_id` (`vlan_id`),
  KEY `device_id` (`device_id`),
  KEY `ip_address` (`ip_address`),
  KEY `port_name` (`port_name`),
  KEY `dns_hostname` (`dns_hostname`),
  KEY `vendor_mac` (`vendor_mac`),
  KEY `authorized` (`authorized`),
  KEY `site_id_device_id` (`site_id`,`device_id`)
) ENGINE=MyISAM COMMENT='Database for aggregated date for Tracking Device MAC''s';
